/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/nls","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/extpath","vs/base/common/uuid","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","fs","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/base/common/lazy","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","child_process","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/decorators","vs/base/common/hash","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","os","net","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/codiconsUtil","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/console","vs/amdX","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function($e){for(var e=[],r=0,h=$e.length;r<h;r++)e[r]=Se[$e[r]];return e};define(Se[174],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.LoaderEventType=e.$R=void 0,e.$R=!1;var r;(function(C){C[C.LoaderAvailable=1]="LoaderAvailable",C[C.BeginLoadingScript=10]="BeginLoadingScript",C[C.EndLoadingScriptOK=11]="EndLoadingScriptOK",C[C.EndLoadingScriptError=12]="EndLoadingScriptError",C[C.BeginInvokeFactory=21]="BeginInvokeFactory",C[C.EndInvokeFactory=22]="EndInvokeFactory",C[C.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",C[C.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",C[C.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",C[C.NodeEndNativeRequire=34]="NodeEndNativeRequire",C[C.CachedDataFound=60]="CachedDataFound",C[C.CachedDataMissed=61]="CachedDataMissed",C[C.CachedDataRejected=62]="CachedDataRejected",C[C.CachedDataCreated=63]="CachedDataCreated"})(r||(e.LoaderEventType=r={}));class h{static get(){const R=new Map,L=new Map,T=new Map,b=new Map;function c(w,a){w.has(a.detail)||w.set(a.detail,-a.timestamp)}function I(w,a){const m=w.get(a.detail);m&&(m>=0||w.set(a.detail,m+a.timestamp))}let S=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(S=$e.getStats().slice(0).sort((w,a)=>w.timestamp-a.timestamp));for(const w of S)switch(w.type){case r.BeginLoadingScript:c(R,w);break;case r.EndLoadingScriptOK:case r.EndLoadingScriptError:I(R,w);break;case r.BeginInvokeFactory:c(L,w);break;case r.EndInvokeFactory:I(L,w);break;case r.NodeBeginNativeRequire:c(T,w);break;case r.NodeEndNativeRequire:I(T,w);break;case r.NodeBeginEvaluatingScript:c(b,w);break;case r.NodeEndEvaluatingScript:I(b,w);break}let u=0;T.forEach(w=>u+=w);function P(w){const a=[];return w.forEach((m,$)=>a.push([$,m])),a}return{amdLoad:P(R),amdInvoke:P(L),nodeRequire:P(T),nodeEval:P(b),nodeRequireTotal:u}}static toMarkdownTable(R,L){let T="";const b=[];return R.forEach((c,I)=>{b[I]=c.length}),L.forEach(c=>{c.forEach((I,S)=>{typeof I>"u"&&(I=c[S]="-");const u=I.toString().length;b[S]=Math.max(u,b[S])})}),R.forEach((c,I)=>{T+=`| ${c+" ".repeat(b[I]-c.toString().length)} `}),T+=`|
`,R.forEach((c,I)=>{T+=`| ${"-".repeat(b[I])} `}),T+=`|
`,L.forEach(c=>{c.forEach((I,S)=>{typeof I<"u"&&(T+=`| ${I+" ".repeat(b[S]-I.toString().length)} `)}),T+=`|
`}),T}}e.$S=h}),define(Se[131],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=r,e.$fb=h,e.$gb=C,e.$hb=R,e.$ib=L,e.$jb=T,e.$kb=b,e.$mb=I,e.$nb=S,e.$ob=u,e.$pb=P,e.$qb=w;function r(a,m){const $=h(a,m);if($!==-1)return a[$]}function h(a,m,$=a.length-1){for(let f=$;f>=0;f--){const i=a[f];if(m(i))return f}return-1}function C(a,m){const $=R(a,m);return $===-1?void 0:a[$]}function R(a,m,$=0,f=a.length){let i=$,s=f;for(;i<s;){const t=Math.floor((i+s)/2);m(a[t])?i=t+1:s=t}return i-1}function L(a,m){const $=T(a,m);return $===a.length?void 0:a[$]}function T(a,m,$=0,f=a.length){let i=$,s=f;for(;i<s;){const t=Math.floor((i+s)/2);m(a[t])?s=t:i=t+1}return i}function b(a,m,$=0,f=a.length){const i=T(a,m,$,f);return i===a.length?-1:i}class c{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(c.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!m(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const $=R(this.e,m,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$lb=c;function I(a,m){if(a.length===0)return;let $=a[0];for(let f=1;f<a.length;f++){const i=a[f];m(i,$)>0&&($=i)}return $}function S(a,m){if(a.length===0)return;let $=a[0];for(let f=1;f<a.length;f++){const i=a[f];m(i,$)>=0&&($=i)}return $}function u(a,m){return I(a,($,f)=>-m($,f))}function P(a,m){if(a.length===0)return-1;let $=0;for(let f=1;f<a.length;f++){const i=a[f];m(i,a[$])>0&&($=f)}return $}function w(a,m){for(const $ of a){const f=m($);if(f!==void 0)return f}}}),define(Se[26],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var r;(function(h){h[h.Null=0]="Null",h[h.Backspace=8]="Backspace",h[h.Tab=9]="Tab",h[h.LineFeed=10]="LineFeed",h[h.CarriageReturn=13]="CarriageReturn",h[h.Space=32]="Space",h[h.ExclamationMark=33]="ExclamationMark",h[h.DoubleQuote=34]="DoubleQuote",h[h.Hash=35]="Hash",h[h.DollarSign=36]="DollarSign",h[h.PercentSign=37]="PercentSign",h[h.Ampersand=38]="Ampersand",h[h.SingleQuote=39]="SingleQuote",h[h.OpenParen=40]="OpenParen",h[h.CloseParen=41]="CloseParen",h[h.Asterisk=42]="Asterisk",h[h.Plus=43]="Plus",h[h.Comma=44]="Comma",h[h.Dash=45]="Dash",h[h.Period=46]="Period",h[h.Slash=47]="Slash",h[h.Digit0=48]="Digit0",h[h.Digit1=49]="Digit1",h[h.Digit2=50]="Digit2",h[h.Digit3=51]="Digit3",h[h.Digit4=52]="Digit4",h[h.Digit5=53]="Digit5",h[h.Digit6=54]="Digit6",h[h.Digit7=55]="Digit7",h[h.Digit8=56]="Digit8",h[h.Digit9=57]="Digit9",h[h.Colon=58]="Colon",h[h.Semicolon=59]="Semicolon",h[h.LessThan=60]="LessThan",h[h.Equals=61]="Equals",h[h.GreaterThan=62]="GreaterThan",h[h.QuestionMark=63]="QuestionMark",h[h.AtSign=64]="AtSign",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.OpenSquareBracket=91]="OpenSquareBracket",h[h.Backslash=92]="Backslash",h[h.CloseSquareBracket=93]="CloseSquareBracket",h[h.Caret=94]="Caret",h[h.Underline=95]="Underline",h[h.BackTick=96]="BackTick",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z",h[h.OpenCurlyBrace=123]="OpenCurlyBrace",h[h.Pipe=124]="Pipe",h[h.CloseCurlyBrace=125]="CloseCurlyBrace",h[h.Tilde=126]="Tilde",h[h.NoBreakSpace=160]="NoBreakSpace",h[h.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",h[h.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",h[h.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",h[h.U_Combining_Tilde=771]="U_Combining_Tilde",h[h.U_Combining_Macron=772]="U_Combining_Macron",h[h.U_Combining_Overline=773]="U_Combining_Overline",h[h.U_Combining_Breve=774]="U_Combining_Breve",h[h.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",h[h.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",h[h.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",h[h.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",h[h.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",h[h.U_Combining_Caron=780]="U_Combining_Caron",h[h.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",h[h.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",h[h.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",h[h.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",h[h.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",h[h.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",h[h.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",h[h.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",h[h.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",h[h.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",h[h.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",h[h.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",h[h.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",h[h.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",h[h.U_Combining_Horn=795]="U_Combining_Horn",h[h.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",h[h.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",h[h.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",h[h.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",h[h.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",h[h.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",h[h.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",h[h.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",h[h.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",h[h.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",h[h.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",h[h.U_Combining_Cedilla=807]="U_Combining_Cedilla",h[h.U_Combining_Ogonek=808]="U_Combining_Ogonek",h[h.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",h[h.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",h[h.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",h[h.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",h[h.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",h[h.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",h[h.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",h[h.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",h[h.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",h[h.U_Combining_Low_Line=818]="U_Combining_Low_Line",h[h.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",h[h.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",h[h.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",h[h.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",h[h.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",h[h.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",h[h.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",h[h.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",h[h.U_Combining_Square_Below=827]="U_Combining_Square_Below",h[h.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",h[h.U_Combining_X_Above=829]="U_Combining_X_Above",h[h.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",h[h.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",h[h.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",h[h.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",h[h.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",h[h.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",h[h.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",h[h.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",h[h.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",h[h.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",h[h.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",h[h.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",h[h.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",h[h.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",h[h.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",h[h.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",h[h.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",h[h.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",h[h.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",h[h.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",h[h.U_Combining_Fermata=850]="U_Combining_Fermata",h[h.U_Combining_X_Below=851]="U_Combining_X_Below",h[h.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",h[h.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",h[h.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",h[h.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",h[h.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",h[h.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",h[h.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",h[h.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",h[h.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",h[h.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",h[h.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",h[h.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",h[h.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",h[h.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",h[h.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",h[h.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",h[h.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",h[h.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",h[h.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",h[h.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",h[h.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",h[h.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",h[h.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",h[h.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",h[h.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",h[h.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",h[h.LINE_SEPARATOR=8232]="LINE_SEPARATOR",h[h.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",h[h.NEXT_LINE=133]="NEXT_LINE",h[h.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",h[h.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",h[h.U_DIAERESIS=168]="U_DIAERESIS",h[h.U_MACRON=175]="U_MACRON",h[h.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",h[h.U_CEDILLA=184]="U_CEDILLA",h[h.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",h[h.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",h[h.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",h[h.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",h[h.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",h[h.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",h[h.U_BREVE=728]="U_BREVE",h[h.U_DOT_ABOVE=729]="U_DOT_ABOVE",h[h.U_RING_ABOVE=730]="U_RING_ABOVE",h[h.U_OGONEK=731]="U_OGONEK",h[h.U_SMALL_TILDE=732]="U_SMALL_TILDE",h[h.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",h[h.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",h[h.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",h[h.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",h[h.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",h[h.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",h[h.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",h[h.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",h[h.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",h[h.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",h[h.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",h[h.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",h[h.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",h[h.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",h[h.U_GREEK_TONOS=900]="U_GREEK_TONOS",h[h.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",h[h.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",h[h.U_GREEK_PSILI=8127]="U_GREEK_PSILI",h[h.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",h[h.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",h[h.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",h[h.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",h[h.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",h[h.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",h[h.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",h[h.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",h[h.U_GREEK_VARIA=8175]="U_GREEK_VARIA",h[h.U_GREEK_OXIA=8189]="U_GREEK_OXIA",h[h.U_GREEK_DASIA=8190]="U_GREEK_DASIA",h[h.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",h[h.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",h[h.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",h[h.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",h[h.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",h[h.U_OVERLINE=8254]="U_OVERLINE",h[h.UTF8_BOM=65279]="UTF8_BOM",h[h.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",h[h.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(r||(e.CharCode=r={}))}),define(Se[78],De([1,0]),function($e,e){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=h,e.$d=C,e.$e=R,e.$f=L;function h(b,c){const I=Object.create(null);for(const S of b){const u=c(S);let P=I[u];P||(P=I[u]=[]),P.push(S)}return I}function C(b,c){const I=[],S=[];for(const u of b)c.has(u)||I.push(u);for(const u of c)b.has(u)||S.push(u);return{removed:I,added:S}}function R(b,c){const I=[],S=[];for(const[u,P]of b)c.has(u)||I.push(P);for(const[u,P]of c)b.has(u)||S.push(P);return{removed:I,added:S}}function L(b,c){const I=new Set;for(const S of c)b.has(S)&&I.add(S);return I}class T{static{r=Symbol.toStringTag}constructor(c,I){this.b=I,this.a=new Map,this[r]="SetWithKey";for(const S of c)this.add(S)}get size(){return this.a.size}add(c){const I=this.b(c);return this.a.set(I,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,I){this.a.forEach(S=>c.call(I,S,S,this))}[Symbol.iterator](){return this.values()}}e.$g=T}),define(Se[59],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=h,e.$8h=C,e.$9h=R;function r(L){return(T,b,c)=>{let I=null,S=null;if(typeof c.value=="function"?(I="value",S=c.value):typeof c.get=="function"&&(I="get",S=c.get),!S)throw new Error("not supported");c[I]=L(S,b)}}function h(L,T,b){let c=null,I=null;if(typeof b.value=="function"?(c="value",I=b.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(c="get",I=b.get),!I)throw new Error("not supported");const S=`$memoize$${T}`;b[c]=function(...u){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,u)}),this[S]}}function C(L,T,b){return r((c,I)=>{const S=`$debounce$${I}`,u=`$debounce$result$${I}`;return function(...P){this[u]||(this[u]=b?b():void 0),clearTimeout(this[S]),T&&(this[u]=T(this[u],...P),P=[this[u]]),this[S]=setTimeout(()=>{c.apply(this,P),this[u]=b?b():void 0},L)}})}function R(L,T,b){return r((c,I)=>{const S=`$throttle$timer$${I}`,u=`$throttle$result$${I}`,P=`$throttle$lastRun$${I}`,w=`$throttle$pending$${I}`;return function(...a){if(this[u]||(this[u]=b?b():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),T&&(this[u]=T(this[u],...a)),this[w])return;const m=this[P]+L;m<=Date.now()?(this[P]=Date.now(),c.apply(this,[this[u]]),this[u]=b?b():void 0):(this[w]=!0,this[S]=setTimeout(()=>{this[w]=!1,this[P]=Date.now(),c.apply(this,[this[u]]),this[u]=b?b():void 0},m-Date.now()))}})}}),define(Se[13],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=h,e.$X=C,e.$Y=R,e.$Z=L,e.$1=T,e.$2=b,e.$3=I,e.$5=u,e.$6=P,e.$7=w,e.$9=m;class r{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?s.isErrorNoTelemetry(n)?new s(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(d=>{d(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$U=r,e.$V=new r;function h(o){e.$V.setUnexpectedErrorHandler(o)}function C(o){if(!o||typeof o!="object")return!1;const n=o;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function R(o){I(o)||e.$V.onUnexpectedError(o)}function L(o){I(o)||e.$V.onUnexpectedExternalError(o)}function T(o){if(o instanceof Error){const{name:n,message:d}=o,l=o.stacktrace||o.stack;return{$isError:!0,name:n,message:d,stack:l,noTelemetry:s.isErrorNoTelemetry(o)}}return o}function b(o){let n;return o.noTelemetry?n=new s:(n=new Error,n.name=o.name),n.message=o.message,n.stack=o.stack,n}const c="Canceled";function I(o){return o instanceof S?!0:o instanceof Error&&o.name===c&&o.message===c}class S extends Error{constructor(){super(c),this.name=this.message}}e.$4=S;function u(){const o=new Error(c);return o.name=o.message,o}function P(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function w(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class a extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=a;function m(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class $ extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$0=$;class f extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$$=f;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=i;class s extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof s)return n;const d=new s;return d.message=n.message,d.stack=n.stack,d}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$ab=s;class t extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$bb=t}),define(Se[18],De([1,0,13,131]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=C,e.$sb=R,e.$tb=L,e.$ub=T,e.$vb=b,e.$wb=c,e.$xb=I,e.$yb=S,e.$zb=u,e.$Ab=P,e.$Bb=w,e.$Cb=a,e.$Db=m,e.top=$,e.$Fb=f,e.$Gb=s,e.$Hb=t,e.$Ib=o,e.$Jb=n,e.$Kb=d,e.$Lb=l,e.$Mb=g,e.$Nb=E,e.$Ob=D,e.$Pb=y,e.$Qb=k,e.$Rb=A,e.$Sb=p,e.$Tb=v,e.$Ub=F,e.$Vb=N,e.$Wb=O,e.$Xb=j,e.$Yb=z,e.$Zb=M,e.$1b=W,e.$2b=V,e.$3b=ne,e.$4b=B,e.$5b=ee,e.$6b=ue,e.$9b=me;function C(ae,te=0){return ae[ae.length-(1+te)]}function R(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}function L(ae,te,ce=(le,x)=>le===x){if(ae===te)return!0;if(!ae||!te||ae.length!==te.length)return!1;for(let le=0,x=ae.length;le<x;le++)if(!ce(ae[le],te[le]))return!1;return!0}function T(ae,te){const ce=ae.length-1;te<ce&&(ae[te]=ae[ce]),ae.pop()}function b(ae,te,ce){return c(ae.length,le=>ce(ae[le],te))}function c(ae,te){let ce=0,le=ae-1;for(;ce<=le;){const x=(ce+le)/2|0,oe=te(x);if(oe<0)ce=x+1;else if(oe>0)le=x-1;else return x}return-(ce+1)}function I(ae,te,ce){if(ae=ae|0,ae>=te.length)throw new TypeError("invalid index");const le=te[Math.floor(te.length*Math.random())],x=[],oe=[],pe=[];for(const we of te){const Fe=ce(we,le);Fe<0?x.push(we):Fe>0?oe.push(we):pe.push(we)}return ae<x.length?I(ae,x,ce):ae<x.length+pe.length?pe[0]:I(ae-(x.length+pe.length),oe,ce)}function S(ae,te){const ce=[];let le;for(const x of ae.slice(0).sort(te))!le||te(le[0],x)!==0?(le=[x],ce.push(le)):le.push(x);return ce}function*u(ae,te){let ce,le;for(const x of ae)le!==void 0&&te(le,x)?ce.push(x):(ce&&(yield ce),ce=[x]),le=x;ce&&(yield ce)}function P(ae,te){for(let ce=0;ce<=ae.length;ce++)te(ce===0?void 0:ae[ce-1],ce===ae.length?void 0:ae[ce])}function w(ae,te){for(let ce=0;ce<ae.length;ce++)te(ce===0?void 0:ae[ce-1],ae[ce],ce+1===ae.length?void 0:ae[ce+1])}function a(ae,te,ce){const le=[];function x(we,Fe,ze){if(Fe===0&&ze.length===0)return;const Ce=le[le.length-1];Ce&&Ce.start+Ce.deleteCount===we?(Ce.deleteCount+=Fe,Ce.toInsert.push(...ze)):le.push({start:we,deleteCount:Fe,toInsert:ze})}let oe=0,pe=0;for(;;){if(oe===ae.length){x(oe,0,te.slice(pe));break}if(pe===te.length){x(oe,ae.length-oe,[]);break}const we=ae[oe],Fe=te[pe],ze=ce(we,Fe);ze===0?(oe+=1,pe+=1):ze<0?(x(oe,1,[]),oe+=1):ze>0&&(x(oe,0,[Fe]),pe+=1)}return le}function m(ae,te,ce){const le=a(ae,te,ce),x=[],oe=[];for(const pe of le)x.push(...ae.slice(pe.start,pe.start+pe.deleteCount)),oe.push(...pe.toInsert);return{removed:x,added:oe}}function $(ae,te,ce){if(ce===0)return[];const le=ae.slice(0,ce).sort(te);return i(ae,te,le,ce,ae.length),le}function f(ae,te,ce,le,x){return ce===0?Promise.resolve([]):new Promise((oe,pe)=>{(async()=>{const we=ae.length,Fe=ae.slice(0,ce).sort(te);for(let ze=ce,Ce=Math.min(ce+le,we);ze<we;ze=Ce,Ce=Math.min(Ce+le,we)){if(ze>ce&&await new Promise(Ie=>setTimeout(Ie)),x&&x.isCancellationRequested)throw new r.$4;i(ae,te,Fe,ze,Ce)}return Fe})().then(oe,pe)})}function i(ae,te,ce,le,x){for(const oe=ce.length;le<x;le++){const pe=ae[le];if(te(pe,ce[oe-1])<0){ce.pop();const we=(0,h.$jb)(ce,Fe=>te(pe,Fe)<0);ce.splice(we,0,pe)}}}function s(ae){return ae.filter(te=>!!te)}function t(ae){let te=0;for(let ce=0;ce<ae.length;ce++)ae[ce]&&(ae[te]=ae[ce],te+=1);ae.length=te}function o(ae,te,ce){ae.splice(ce,0,ae.splice(te,1)[0])}function n(ae){return!Array.isArray(ae)||ae.length===0}function d(ae){return Array.isArray(ae)&&ae.length>0}function l(ae,te=ce=>ce){const ce=new Set;return ae.filter(le=>{const x=te(le);return ce.has(x)?!1:(ce.add(x),!0)})}function g(ae){const te=new Set;return ce=>{const le=ae(ce);return te.has(le)?!1:(te.add(le),!0)}}function E(ae,te){return ae.length>0?ae[0]:te}function D(ae,te){return ae.length>0?ae[ae.length-1]:te}function y(ae,te,ce=(le,x)=>le===x){let le=0;for(let x=0,oe=Math.min(ae.length,te.length);x<oe&&ce(ae[x],te[x]);x++)le++;return le}function k(ae,te){let ce=typeof te=="number"?ae:0;typeof te=="number"?ce=ae:(ce=0,te=ae);const le=[];if(ce<=te)for(let x=ce;x<te;x++)le.push(x);else for(let x=ce;x>te;x--)le.push(x);return le}function A(ae,te,ce){return ae.reduce((le,x)=>(le[te(x)]=ce?ce(x):x,le),Object.create(null))}function p(ae,te){return ae.push(te),()=>v(ae,te)}function v(ae,te){const ce=ae.indexOf(te);if(ce>-1)return ae.splice(ce,1),te}function F(ae,te,ce){const le=ae.slice(0,te),x=ae.slice(te);return le.concat(ce,x)}function N(ae,te){let ce;if(typeof te=="number"){let le=te;ce=()=>{const x=Math.sin(le++)*179426549;return x-Math.floor(x)}}else ce=Math.random;for(let le=ae.length-1;le>0;le-=1){const x=Math.floor(ce()*(le+1)),oe=ae[le];ae[le]=ae[x],ae[x]=oe}}function O(ae,te){const ce=ae.indexOf(te);ce>-1&&(ae.splice(ce,1),ae.unshift(te))}function j(ae,te){const ce=ae.indexOf(te);ce>-1&&(ae.splice(ce,1),ae.push(te))}function z(ae,te){for(const ce of te)ae.push(ce)}function M(ae,te){return Array.isArray(ae)?ae.map(te):te(ae)}function W(ae){return Array.isArray(ae)?ae:[ae]}function V(ae){return ae[Math.floor(Math.random()*ae.length)]}function ne(ae,te,ce){const le=K(ae,te),x=ae.length,oe=ce.length;ae.length=x+oe;for(let pe=x-1;pe>=le;pe--)ae[pe+oe]=ae[pe];for(let pe=0;pe<oe;pe++)ae[pe+le]=ce[pe]}function B(ae,te,ce,le){const x=K(ae,te);let oe=ae.splice(x,ce);return oe===void 0&&(oe=[]),ne(ae,x,le),oe}function K(ae,te){return te<0?Math.max(te+ae.length,0):Math.min(te,ae.length)}var Y;(function(ae){function te(oe){return oe<0}ae.isLessThan=te;function ce(oe){return oe<=0}ae.isLessThanOrEqual=ce;function le(oe){return oe>0}ae.isGreaterThan=le;function x(oe){return oe===0}ae.isNeitherLessOrGreaterThan=x,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(Y||(e.CompareResult=Y={}));function ee(ae,te){return(ce,le)=>te(ae(ce),ae(le))}function ue(...ae){return(te,ce)=>{for(const le of ae){const x=le(te,ce);if(!Y.isNeitherLessOrGreaterThan(x))return x}return Y.neitherLessOrGreaterThan}}const re=(ae,te)=>ae-te;e.$7b=re;const ye=(ae,te)=>(0,e.$7b)(ae?1:0,te?1:0);e.$8b=ye;function me(ae){return(te,ce)=>-ae(te,ce)}class J{constructor(te){this.g=te,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(te){let ce=this.c;for(;ce<this.g.length&&te(this.g[ce]);)ce++;const le=ce===this.c?null:this.g.slice(this.c,ce);return this.c=ce,le}takeFromEndWhile(te){let ce=this.d;for(;ce>=0&&te(this.g[ce]);)ce--;const le=ce===this.d?null:this.g.slice(ce+1,this.d+1);return this.d=ce,le}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const te=this.g[this.c];return this.c++,te}removeLast(){const te=this.g[this.d];return this.d--,te}takeCount(te){const ce=this.g.slice(this.c,this.c+te);return this.c+=te,ce}}e.$0b=J;class U{static{this.empty=new U(te=>{})}constructor(te){this.iterate=te}forEach(te){this.iterate(ce=>(te(ce),!0))}toArray(){const te=[];return this.iterate(ce=>(te.push(ce),!0)),te}filter(te){return new U(ce=>this.iterate(le=>te(le)?ce(le):!0))}map(te){return new U(ce=>this.iterate(le=>ce(te(le))))}some(te){let ce=!1;return this.iterate(le=>(ce=te(le),!ce)),ce}findFirst(te){let ce;return this.iterate(le=>te(le)?(ce=le,!1):!0),ce}findLast(te){let ce;return this.iterate(le=>(te(le)&&(ce=le),!0)),ce}findLastMaxBy(te){let ce,le=!0;return this.iterate(x=>((le||Y.isGreaterThan(te(x,ce)))&&(le=!1,ce=x),!0)),ce}}e.$$b=U;class se{constructor(te){this.c=te}static createSortPermutation(te,ce){const le=Array.from(te.keys()).sort((x,oe)=>ce(te[x],te[oe]));return new se(le)}apply(te){return te.map((ce,le)=>te[this.c[le]])}inverse(){const te=this.c.slice();for(let ce=0;ce<this.c.length;ce++)te[this.c[ce]]=ce;return new se(te)}}e.$_b=se}),define(Se[65],De([1,0,13]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=h,e.$dd=C,e.$ed=R,e.$fd=L,e.$gd=T,e.$hd=b;function h(c,I){if(!c)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function C(c,I="Unreachable"){throw new Error(I)}function R(c,I="unexpected state"){if(!c)throw new r.$bb(`Assertion Failed: ${I}`)}function L(c){c||(0,r.$Y)(new r.$bb("Soft Assertion Failed"))}function T(c){if(!c()){debugger;c(),(0,r.$Y)(new r.$bb("Assertion Failed"))}}function b(c,I){let S=0;for(;S<c.length-1;){const u=c[S],P=c[S+1];if(!I(u,P))return!1;S++}return!0}});var Hn=this&&this.__createBinding||(Object.create?function($e,e,r,h){h===void 0&&(h=r);var C=Object.getOwnPropertyDescriptor(e,r);(!C||("get"in C?!e.__esModule:C.writable||C.configurable))&&(C={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty($e,h,C)}:function($e,e,r,h){h===void 0&&(h=r),$e[h]=e[r]}),Gn=this&&this.__setModuleDefault||(Object.create?function($e,e){Object.defineProperty($e,"default",{enumerable:!0,value:e})}:function($e,e){$e.default=e}),Ue=this&&this.__importStar||function($e){if($e&&$e.__esModule)return $e;var e={};if($e!=null)for(var r in $e)r!=="default"&&Object.prototype.hasOwnProperty.call($e,r)&&Hn(e,$e,r);return Gn(e,$e),e};define(Se[175],De([1,0,18]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0,e.$6c=C,e.$7c=R,e.$8c=L,e.$9c=T,e.$0c=b,e.$$c=c,r=Ue(r);const h=(P,w)=>P===w;e.$5c=h;function C(P=e.$5c){return(w,a)=>r.$tb(w,a,P)}function R(){return(P,w)=>JSON.stringify(P)===JSON.stringify(w)}function L(){return(P,w)=>P.equals(w)}function T(P,w,a){if(a!==void 0){const m=P;return m==null||w===void 0||w===null?w===m:a(m,w)}else{const m=P;return($,f)=>$==null||f===void 0||f===null?f===$:m($,f)}}function b(P,w){if(P===w)return!0;if(Array.isArray(P)&&Array.isArray(w)){if(P.length!==w.length)return!1;for(let a=0;a<P.length;a++)if(!b(P[a],w[a]))return!1;return!0}if(P&&typeof P=="object"&&w&&typeof w=="object"&&Object.getPrototypeOf(P)===Object.prototype&&Object.getPrototypeOf(w)===Object.prototype){const a=P,m=w,$=Object.keys(a),f=Object.keys(m),i=new Set(f);if($.length!==f.length)return!1;for(const s of $)if(!i.has(s)||!b(a[s],m[s]))return!1;return!0}return!1}function c(P){return JSON.stringify(u(P))}let I=0;const S=new WeakMap;function u(P){if(Array.isArray(P))return P.map(u);if(P&&typeof P=="object")if(Object.getPrototypeOf(P)===Object.prototype){const w=P,a=Object.create(null);for(const m of Object.keys(w).sort())a[m]=u(w[m]);return a}else{let w=S.get(P);return w===void 0&&(w=I++,S.set(P,w)),w+"----2b76a038c20c4bcc"}return P}}),define(Se[79],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=r;function r(h,C){const R=this;let L=!1,T;return function(){if(L)return T;if(L=!0,C)try{T=h.apply(R,arguments)}finally{C()}else T=h.apply(R,arguments);return T}}}),define(Se[132],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$hQ=void 0;class r{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$hQ=r,e.$iQ=new r("id#")}),define(Se[39],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var r;(function(h){function C(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}h.is=C;const R=Object.freeze([]);function L(){return R}h.empty=L;function*T(n){yield n}h.single=T;function b(n){return C(n)?n:T(n)}h.wrap=b;function c(n){return n||R}h.from=c;function*I(n){for(let d=n.length-1;d>=0;d--)yield n[d]}h.reverse=I;function S(n){return!n||n[Symbol.iterator]().next().done===!0}h.isEmpty=S;function u(n){return n[Symbol.iterator]().next().value}h.first=u;function P(n,d){let l=0;for(const g of n)if(d(g,l++))return!0;return!1}h.some=P;function w(n,d){for(const l of n)if(d(l))return l}h.find=w;function*a(n,d){for(const l of n)d(l)&&(yield l)}h.filter=a;function*m(n,d){let l=0;for(const g of n)yield d(g,l++)}h.map=m;function*$(n,d){let l=0;for(const g of n)yield*d(g,l++)}h.flatMap=$;function*f(...n){for(const d of n)yield*d}h.concat=f;function i(n,d,l){let g=l;for(const E of n)g=d(g,E);return g}h.reduce=i;function*s(n,d,l=n.length){for(d<0&&(d+=n.length),l<0?l+=n.length:l>n.length&&(l=n.length);d<l;d++)yield n[d]}h.slice=s;function t(n,d=Number.POSITIVE_INFINITY){const l=[];if(d===0)return[l,n];const g=n[Symbol.iterator]();for(let E=0;E<d;E++){const D=g.next();if(D.done)return[l,h.empty()];l.push(D.value)}return[l,{[Symbol.iterator](){return g}}]}h.consume=t;async function o(n){const d=[];for await(const l of n)d.push(l);return Promise.resolve(d)}h.asyncToArray=o})(r||(e.Iterable=r={}))}),define(Se[176],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Tn=L,e.$Un=S,e.$Vn=u,e.$Wn=P,e.$Xn=w,e.$Yn=a,e.$Zn=m,e.$1n=$,e.$2n=f,e.$3n=i,e.$4n=s;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r||(e.ScanError=r={}));var h;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(h||(e.SyntaxKind=h={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function L(t,o=!1){let n=0;const d=t.length;let l="",g=0,E=h.Unknown,D=r.None;function y(O){let j=0,z=0;for(;j<O;){const M=t.charCodeAt(n);if(M>=I._0&&M<=I._9)z=z*16+M-I._0;else if(M>=I.A&&M<=I.F)z=z*16+M-I.A+10;else if(M>=I.a&&M<=I.f)z=z*16+M-I.a+10;else break;n++,j++}return j<O&&(z=-1),z}function k(O){n=O,l="",g=0,E=h.Unknown,D=r.None}function A(){const O=n;if(t.charCodeAt(n)===I._0)n++;else for(n++;n<t.length&&c(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===I.dot)if(n++,n<t.length&&c(t.charCodeAt(n)))for(n++;n<t.length&&c(t.charCodeAt(n));)n++;else return D=r.UnexpectedEndOfNumber,t.substring(O,n);let j=n;if(n<t.length&&(t.charCodeAt(n)===I.E||t.charCodeAt(n)===I.e))if(n++,(n<t.length&&t.charCodeAt(n)===I.plus||t.charCodeAt(n)===I.minus)&&n++,n<t.length&&c(t.charCodeAt(n))){for(n++;n<t.length&&c(t.charCodeAt(n));)n++;j=n}else D=r.UnexpectedEndOfNumber;return t.substring(O,j)}function p(){let O="",j=n;for(;;){if(n>=d){O+=t.substring(j,n),D=r.UnexpectedEndOfString;break}const z=t.charCodeAt(n);if(z===I.doubleQuote){O+=t.substring(j,n),n++;break}if(z===I.backslash){if(O+=t.substring(j,n),n++,n>=d){D=r.UnexpectedEndOfString;break}switch(t.charCodeAt(n++)){case I.doubleQuote:O+='"';break;case I.backslash:O+="\\";break;case I.slash:O+="/";break;case I.b:O+="\b";break;case I.f:O+="\f";break;case I.n:O+=`
`;break;case I.r:O+="\r";break;case I.t:O+="	";break;case I.u:{const W=y(4);W>=0?O+=String.fromCharCode(W):D=r.InvalidUnicode;break}default:D=r.InvalidEscapeCharacter}j=n;continue}if(z>=0&&z<=31)if(b(z)){O+=t.substring(j,n),D=r.UnexpectedEndOfString;break}else D=r.InvalidCharacter;n++}return O}function v(){if(l="",D=r.None,g=n,n>=d)return g=d,E=h.EOF;let O=t.charCodeAt(n);if(T(O)){do n++,l+=String.fromCharCode(O),O=t.charCodeAt(n);while(T(O));return E=h.Trivia}if(b(O))return n++,l+=String.fromCharCode(O),O===I.carriageReturn&&t.charCodeAt(n)===I.lineFeed&&(n++,l+=`
`),E=h.LineBreakTrivia;switch(O){case I.openBrace:return n++,E=h.OpenBraceToken;case I.closeBrace:return n++,E=h.CloseBraceToken;case I.openBracket:return n++,E=h.OpenBracketToken;case I.closeBracket:return n++,E=h.CloseBracketToken;case I.colon:return n++,E=h.ColonToken;case I.comma:return n++,E=h.CommaToken;case I.doubleQuote:return n++,l=p(),E=h.StringLiteral;case I.slash:{const j=n-1;if(t.charCodeAt(n+1)===I.slash){for(n+=2;n<d&&!b(t.charCodeAt(n));)n++;return l=t.substring(j,n),E=h.LineCommentTrivia}if(t.charCodeAt(n+1)===I.asterisk){n+=2;const z=d-1;let M=!1;for(;n<z;){if(t.charCodeAt(n)===I.asterisk&&t.charCodeAt(n+1)===I.slash){n+=2,M=!0;break}n++}return M||(n++,D=r.UnexpectedEndOfComment),l=t.substring(j,n),E=h.BlockCommentTrivia}return l+=String.fromCharCode(O),n++,E=h.Unknown}case I.minus:if(l+=String.fromCharCode(O),n++,n===d||!c(t.charCodeAt(n)))return E=h.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return l+=A(),E=h.NumericLiteral;default:for(;n<d&&F(O);)n++,O=t.charCodeAt(n);if(g!==n){switch(l=t.substring(g,n),l){case"true":return E=h.TrueKeyword;case"false":return E=h.FalseKeyword;case"null":return E=h.NullKeyword}return E=h.Unknown}return l+=String.fromCharCode(O),n++,E=h.Unknown}}function F(O){if(T(O)||b(O))return!1;switch(O){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function N(){let O;do O=v();while(O>=h.LineCommentTrivia&&O<=h.Trivia);return O}return{setPosition:k,getPosition:()=>n,scan:o?N:v,getToken:()=>E,getTokenValue:()=>l,getTokenOffset:()=>g,getTokenLength:()=>n-g,getTokenError:()=>D}}function T(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function b(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function c(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function S(t,o){const n=[],d=new Object;let l;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function D(y,k,A,p){g.value=y,g.offset=k,g.length=A,g.type=p,g.colonOffset=void 0,l=g}try{i(t,{onObjectBegin:(y,k)=>{if(o<=y)throw d;l=void 0,E=o>y,n.push("")},onObjectProperty:(y,k,A)=>{if(o<k||(D(y,k,A,"property"),n[n.length-1]=y,o<=k+A))throw d},onObjectEnd:(y,k)=>{if(o<=y)throw d;l=void 0,n.pop()},onArrayBegin:(y,k)=>{if(o<=y)throw d;l=void 0,n.push(0)},onArrayEnd:(y,k)=>{if(o<=y)throw d;l=void 0,n.pop()},onLiteralValue:(y,k,A)=>{if(o<k||(D(y,k,A,s(y)),o<=k+A))throw d},onSeparator:(y,k,A)=>{if(o<=k)throw d;if(y===":"&&l&&l.type==="property")l.colonOffset=k,E=!1,l=void 0;else if(y===","){const p=n[n.length-1];typeof p=="number"?n[n.length-1]=p+1:(E=!0,n[n.length-1]=""),l=void 0}}})}catch(y){if(y!==d)throw y}return{path:n,previousNode:l,isAtPropertyKey:E,matches:y=>{let k=0;for(let A=0;k<y.length&&A<n.length;A++)if(y[k]===n[A]||y[k]==="*")k++;else if(y[k]!=="**")return!1;return k===y.length}}}function u(t,o=[],n=R.DEFAULT){let d=null,l=[];const g=[];function E(y){Array.isArray(l)?l.push(y):d!==null&&(l[d]=y)}return i(t,{onObjectBegin:()=>{const y={};E(y),g.push(l),l=y,d=null},onObjectProperty:y=>{d=y},onObjectEnd:()=>{l=g.pop()},onArrayBegin:()=>{const y=[];E(y),g.push(l),l=y,d=null},onArrayEnd:()=>{l=g.pop()},onLiteralValue:E,onError:(y,k,A)=>{o.push({error:y,offset:k,length:A})}},n),l[0]}function P(t,o=[],n=R.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(y){d.type==="property"&&(d.length=y-d.offset,d=d.parent)}function g(y){return d.children.push(y),y}i(t,{onObjectBegin:y=>{d=g({type:"object",offset:y,length:-1,parent:d,children:[]})},onObjectProperty:(y,k,A)=>{d=g({type:"property",offset:k,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:y,offset:k,length:A,parent:d})},onObjectEnd:(y,k)=>{d.length=y+k-d.offset,d=d.parent,l(y+k)},onArrayBegin:(y,k)=>{d=g({type:"array",offset:y,length:-1,parent:d,children:[]})},onArrayEnd:(y,k)=>{d.length=y+k-d.offset,d=d.parent,l(y+k)},onLiteralValue:(y,k,A)=>{g({type:s(y),offset:k,length:A,parent:d,value:y}),l(k+A)},onSeparator:(y,k,A)=>{d.type==="property"&&(y===":"?d.colonOffset=k:y===","&&l(k))},onError:(y,k,A)=>{o.push({error:y,offset:k,length:A})}},n);const D=d.children[0];return D&&delete D.parent,D}function w(t,o){if(!t)return;let n=t;for(const d of o)if(typeof d=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const g of n.children)if(Array.isArray(g.children)&&g.children[0].value===d){n=g.children[1],l=!0;break}if(!l)return}else{const l=d;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}function a(t){if(!t.parent||!t.parent.children)return[];const o=a(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;o.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&o.push(n)}return o}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const o=Object.create(null);for(const n of t.children){const d=n.children[1];d&&(o[n.children[0].value]=m(d))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function $(t,o,n=!1){return o>=t.offset&&o<t.offset+t.length||n&&o===t.offset+t.length}function f(t,o,n=!1){if($(t,o,n)){const d=t.children;if(Array.isArray(d))for(let l=0;l<d.length&&d[l].offset<=o;l++){const g=f(d[l],o,n);if(g)return g}return t}}function i(t,o,n=R.DEFAULT){const d=L(t,!1);function l(ee){return ee?()=>ee(d.getTokenOffset(),d.getTokenLength()):()=>!0}function g(ee){return ee?ue=>ee(ue,d.getTokenOffset(),d.getTokenLength()):()=>!0}const E=l(o.onObjectBegin),D=g(o.onObjectProperty),y=l(o.onObjectEnd),k=l(o.onArrayBegin),A=l(o.onArrayEnd),p=g(o.onLiteralValue),v=g(o.onSeparator),F=l(o.onComment),N=g(o.onError),O=n&&n.disallowComments,j=n&&n.allowTrailingComma;function z(){for(;;){const ee=d.scan();switch(d.getTokenError()){case r.InvalidUnicode:M(C.InvalidUnicode);break;case r.InvalidEscapeCharacter:M(C.InvalidEscapeCharacter);break;case r.UnexpectedEndOfNumber:M(C.UnexpectedEndOfNumber);break;case r.UnexpectedEndOfComment:O||M(C.UnexpectedEndOfComment);break;case r.UnexpectedEndOfString:M(C.UnexpectedEndOfString);break;case r.InvalidCharacter:M(C.InvalidCharacter);break}switch(ee){case h.LineCommentTrivia:case h.BlockCommentTrivia:O?M(C.InvalidCommentToken):F();break;case h.Unknown:M(C.InvalidSymbol);break;case h.Trivia:case h.LineBreakTrivia:break;default:return ee}}}function M(ee,ue=[],re=[]){if(N(ee),ue.length+re.length>0){let ye=d.getToken();for(;ye!==h.EOF;){if(ue.indexOf(ye)!==-1){z();break}else if(re.indexOf(ye)!==-1)break;ye=z()}}}function W(ee){const ue=d.getTokenValue();return ee?p(ue):D(ue),z(),!0}function V(){switch(d.getToken()){case h.NumericLiteral:{let ee=0;try{ee=JSON.parse(d.getTokenValue()),typeof ee!="number"&&(M(C.InvalidNumberFormat),ee=0)}catch{M(C.InvalidNumberFormat)}p(ee);break}case h.NullKeyword:p(null);break;case h.TrueKeyword:p(!0);break;case h.FalseKeyword:p(!1);break;default:return!1}return z(),!0}function ne(){return d.getToken()!==h.StringLiteral?(M(C.PropertyNameExpected,[],[h.CloseBraceToken,h.CommaToken]),!1):(W(!1),d.getToken()===h.ColonToken?(v(":"),z(),Y()||M(C.ValueExpected,[],[h.CloseBraceToken,h.CommaToken])):M(C.ColonExpected,[],[h.CloseBraceToken,h.CommaToken]),!0)}function B(){E(),z();let ee=!1;for(;d.getToken()!==h.CloseBraceToken&&d.getToken()!==h.EOF;){if(d.getToken()===h.CommaToken){if(ee||M(C.ValueExpected,[],[]),v(","),z(),d.getToken()===h.CloseBraceToken&&j)break}else ee&&M(C.CommaExpected,[],[]);ne()||M(C.ValueExpected,[],[h.CloseBraceToken,h.CommaToken]),ee=!0}return y(),d.getToken()!==h.CloseBraceToken?M(C.CloseBraceExpected,[h.CloseBraceToken],[]):z(),!0}function K(){k(),z();let ee=!1;for(;d.getToken()!==h.CloseBracketToken&&d.getToken()!==h.EOF;){if(d.getToken()===h.CommaToken){if(ee||M(C.ValueExpected,[],[]),v(","),z(),d.getToken()===h.CloseBracketToken&&j)break}else ee&&M(C.CommaExpected,[],[]);Y()||M(C.ValueExpected,[],[h.CloseBracketToken,h.CommaToken]),ee=!0}return A(),d.getToken()!==h.CloseBracketToken?M(C.CloseBracketExpected,[h.CloseBracketToken],[]):z(),!0}function Y(){switch(d.getToken()){case h.OpenBracketToken:return K();case h.OpenBraceToken:return B();case h.StringLiteral:return W(!0);default:return V()}}return z(),d.getToken()===h.EOF?n.allowEmptyContent?!0:(M(C.ValueExpected,[],[]),!1):Y()?(d.getToken()!==h.EOF&&M(C.EndOfFileExpected,[],[]),!0):(M(C.ValueExpected,[],[]),!1)}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Se[177],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=r;function r(R){let L=!1;const T=new Map,b=new Map;if(C(R,a=>{if(R===a)return!0;const m=JSON.stringify(a);if(m.length<30)return!0;const $=T.get(m);if(!$){const f={schemas:[a]};return T.set(m,f),b.set(a,f),!0}return $.schemas.push(a),b.set(a,$),L=!0,!1}),T.clear(),!L)return JSON.stringify(R);let I="$defs";for(;R.hasOwnProperty(I);)I+="_";const S=[];function u(a){return JSON.stringify(a,(m,$)=>{if($!==a){const f=b.get($);if(f&&f.schemas.length>1)return f.id||(f.id=`_${S.length}`,S.push(f.schemas[0])),{$ref:`#/${I}/${f.id}`}}return $})}const P=u(R),w=[];for(let a=0;a<S.length;a++)w.push(`"_${a}":${u(S[a])}`);return w.length?`${P.substring(0,P.length-1)},"${I}":{${w.join(",")}}}`:P}function h(R){return typeof R=="object"&&R!==null}function C(R,L){if(!R||typeof R!="object")return;const T=(...P)=>{for(const w of P)h(w)&&S.push(w)},b=(...P)=>{for(const w of P)if(h(w))for(const a in w){const m=w[a];h(m)&&S.push(m)}},c=(...P)=>{for(const w of P)if(Array.isArray(w))for(const a of w)h(a)&&S.push(a)},I=P=>{if(Array.isArray(P))for(const w of P)h(w)&&S.push(w);else h(P)&&S.push(P)},S=[R];let u=S.pop();for(;u;)L(u)&&(T(u.additionalItems,u.additionalProperties,u.not,u.contains,u.propertyNames,u.if,u.then,u.else,u.unevaluatedItems,u.unevaluatedProperties),b(u.definitions,u.$defs,u.properties,u.patternProperties,u.dependencies,u.dependentSchemas),c(u.anyOf,u.allOf,u.oneOf,u.prefixItems),I(u.items)),u=S.pop()}}),define(Se[49],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class r{constructor(C){this.d=C,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=r}),define(Se[80],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class r{static{this.Undefined=new r(void 0)}constructor(R){this.element=R,this.next=r.Undefined,this.prev=r.Undefined}}class h{constructor(){this.a=r.Undefined,this.b=r.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===r.Undefined}clear(){let R=this.a;for(;R!==r.Undefined;){const L=R.next;R.prev=r.Undefined,R.next=r.Undefined,R=L}this.a=r.Undefined,this.b=r.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,L){const T=new r(R);if(this.a===r.Undefined)this.a=T,this.b=T;else if(L){const c=this.b;this.b=T,T.prev=c,c.next=T}else{const c=this.a;this.a=T,T.next=c,c.prev=T}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(T))}}shift(){if(this.a!==r.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==r.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==r.Undefined&&R.next!==r.Undefined){const L=R.prev;L.next=R.next,R.next.prev=L}else R.prev===r.Undefined&&R.next===r.Undefined?(this.a=r.Undefined,this.b=r.Undefined):R.next===r.Undefined?(this.b=this.b.prev,this.b.next=r.Undefined):R.prev===r.Undefined&&(this.a=this.a.next,this.a.prev=r.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==r.Undefined;)yield R.element,R=R.next}}e.$4c=h}),define(Se[28],De([1,0]),function($e,e){"use strict";var r,h,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=void 0,e.$wc=R,e.$xc=L,e.$yc=T,e.$Hc=s;function R(t,o,n){let d=t.get(o);return d===void 0&&(d=n,t.set(o,d)),d}function L(t){const o=[];return t.forEach((n,d)=>{o.push(`${d} => ${n}`)}),`Map(${t.size}) {${o.join(", ")}}`}function T(t){const o=[];return t.forEach(n=>{o.push(n)}),`Set(${t.size}) {${o.join(", ")}}`}class b{constructor(o,n){this.uri=o,this.value=n}}function c(t){return Array.isArray(t)}class I{static{this.c=o=>o.toString()}constructor(o,n){if(this[r]="ResourceMap",o instanceof I)this.d=new Map(o.d),this.e=n??I.c;else if(c(o)){this.d=new Map,this.e=n??I.c;for(const[d,l]of o)this.set(d,l)}else this.d=new Map,this.e=o??I.c}set(o,n){return this.d.set(this.e(o),new b(o,n)),this}get(o){return this.d.get(this.e(o))?.value}has(o){return this.d.has(this.e(o))}get size(){return this.d.size}clear(){this.d.clear()}delete(o){return this.d.delete(this.e(o))}forEach(o,n){typeof n<"u"&&(o=o.bind(n));for(const[d,l]of this.d)o(l.value,l.uri,this)}*values(){for(const o of this.d.values())yield o.value}*keys(){for(const o of this.d.values())yield o.uri}*entries(){for(const o of this.d.values())yield[o.uri,o.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.d)yield[o.uri,o.value]}}e.$zc=I;class S{constructor(o,n){this[h]="ResourceSet",!o||typeof o=="function"?this.c=new I(o):(this.c=new I(n),o.forEach(this.add,this))}get size(){return this.c.size}add(o){return this.c.set(o,o),this}clear(){this.c.clear()}delete(o){return this.c.delete(o)}forEach(o,n){this.c.forEach((d,l)=>o.call(n,l,l,this))}has(o){return this.c.has(o)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=S;var u;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class P{constructor(){this[C]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(o){return this.c.has(o)}get(o,n=u.None){const d=this.c.get(o);if(d)return n!==u.None&&this.m(d,n),d.value}set(o,n,d=u.None){let l=this.c.get(o);if(l)l.value=n,d!==u.None&&this.m(l,d);else{switch(l={key:o,value:n,next:void 0,previous:void 0},d){case u.None:this.k(l);break;case u.AsOld:this.j(l);break;case u.AsNew:this.k(l);break;default:this.k(l);break}this.c.set(o,l),this.f++}return this}delete(o){return!!this.remove(o)}remove(o){const n=this.c.get(o);if(n)return this.c.delete(o),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const o=this.d;return this.c.delete(o.key),this.l(o),this.f--,o.value}forEach(o,n){const d=this.g;let l=this.d;for(;l;){if(n?o.bind(n)(l.value,l.key,this):o(l.value,l.key,this),this.g!==d)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const o=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(o.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:d.key,done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return l}values(){const o=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(o.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:d.value,done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return l}entries(){const o=this,n=this.g;let d=this.d;const l={[Symbol.iterator](){return l},next(){if(o.g!==n)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:[d.key,d.value],done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return l}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(o){if(o>=this.size)return;if(o===0){this.clear();return}let n=this.d,d=this.size;for(;n&&d>o;)this.c.delete(n.key),n=n.next,d--;this.d=n,this.f=d,n&&(n.previous=void 0),this.g++}i(o){if(o>=this.size)return;if(o===0){this.clear();return}let n=this.e,d=this.size;for(;n&&d>o;)this.c.delete(n.key),n=n.previous,d--;this.e=n,this.f=d,n&&(n.next=void 0),this.g++}j(o){if(!this.d&&!this.e)this.e=o;else if(this.d)o.next=this.d,this.d.previous=o;else throw new Error("Invalid list");this.d=o,this.g++}k(o){if(!this.d&&!this.e)this.d=o;else if(this.e)o.previous=this.e,this.e.next=o;else throw new Error("Invalid list");this.e=o,this.g++}l(o){if(o===this.d&&o===this.e)this.d=void 0,this.e=void 0;else if(o===this.d){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.d=o.next}else if(o===this.e){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.e=o.previous}else{const n=o.next,d=o.previous;if(!n||!d)throw new Error("Invalid list");n.previous=d,d.next=n}o.next=void 0,o.previous=void 0,this.g++}m(o,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==u.AsOld&&n!==u.AsNew)){if(n===u.AsOld){if(o===this.d)return;const d=o.next,l=o.previous;o===this.e?(l.next=void 0,this.e=l):(d.previous=l,l.next=d),o.previous=void 0,o.next=this.d,this.d.previous=o,this.d=o,this.g++}else if(n===u.AsNew){if(o===this.e)return;const d=o.next,l=o.previous;o===this.d?(d.previous=void 0,this.d=d):(d.previous=l,l.next=d),o.next=void 0,o.previous=this.e,this.e.next=o,this.e=o,this.g++}}}toJSON(){const o=[];return this.forEach((n,d)=>{o.push([d,n])}),o}fromJSON(o){this.clear();for(const[n,d]of o)this.set(n,d)}}e.$Bc=P;class w extends P{constructor(o,n=1){super(),this.n=o,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(o){this.n=o,this.p()}get ratio(){return this.o}set ratio(o){this.o=Math.min(Math.max(0,o),1),this.p()}get(o,n=u.AsNew){return super.get(o,n)}peek(o){return super.get(o,u.None)}set(o,n){return super.set(o,n,u.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class a extends w{constructor(o,n=1){super(o,n)}q(o){this.h(o)}set(o,n){return super.set(o,n),this.p(),this}}e.$Cc=a;class m extends w{constructor(o,n=1){super(o,n)}q(o){this.i(o)}set(o,n){return this.n<=this.size&&!this.has(o)&&this.q(Math.round(this.n*this.o)-1),super.set(o,n),this}}e.$Dc=m;class ${constructor(){this.c=new Map}add(o){return this.c.set(o,(this.c.get(o)||0)+1),this}delete(o){let n=this.c.get(o)||0;return n===0?!1:(n--,n===0?this.c.delete(o):this.c.set(o,n),!0)}has(o){return this.c.has(o)}}e.$Ec=$;class f{constructor(o){if(this.c=new Map,this.d=new Map,o)for(const[n,d]of o)this.set(n,d)}clear(){this.c.clear(),this.d.clear()}set(o,n){this.c.set(o,n),this.d.set(n,o)}get(o){return this.c.get(o)}getKey(o){return this.d.get(o)}delete(o){const n=this.c.get(o);return n===void 0?!1:(this.c.delete(o),this.d.delete(n),!0)}forEach(o,n){this.c.forEach((d,l)=>{o.call(n,d,l,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=f;class i{constructor(){this.c=new Map}add(o,n){let d=this.c.get(o);d||(d=new Set,this.c.set(o,d)),d.add(n)}delete(o,n){const d=this.c.get(o);d&&(d.delete(n),d.size===0&&this.c.delete(o))}forEach(o,n){const d=this.c.get(o);d&&d.forEach(n)}get(o){const n=this.c.get(o);return n||new Set}}e.$Gc=i;function s(t,o){if(t===o)return!0;if(t.size!==o.size)return!1;for(const[n,d]of t)if(!o.has(n)||o.get(n)!==d)return!1;for(const[n]of o)if(!t.has(n))return!1;return!0}}),define(Se[3],De([1,0,18,78,28,79,39]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Ic=void 0,e.$Jc=I,e.$Kc=S,e.$Lc=u,e.$Mc=a,e.$Nc=m,e.$Oc=$,e.$Pc=f,e.$Qc=i,e.$Rc=s,e.$2c=k;const T=!1;let b=null;class c{constructor(){this.b=new Map}static{this.a=0}c(v){let F=this.b.get(v);return F||(F={parent:null,source:null,isSingleton:!1,value:v,idx:c.a++},this.b.set(v,F)),F}trackDisposable(v){const F=this.c(v);F.source||(F.source=new Error().stack)}setParent(v,F){const N=this.c(v);N.parent=F}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,F){const N=F.get(v);if(N)return N;const O=v.parent?this.f(this.c(v.parent),F):v;return F.set(v,O),O}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,v).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(v=10,F){let N;if(F)N=F;else{const W=new Map,V=[...this.b.values()].filter(B=>B.source!==null&&!this.f(B,W).isSingleton);if(V.length===0)return;const ne=new Set(V.map(B=>B.value));if(N=V.filter(B=>!(B.parent&&ne.has(B.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function O(W){function V(B,K){for(;B.length>0&&K.some(Y=>typeof Y=="string"?Y===B[0]:B[0].match(Y));)B.shift()}const ne=W.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return V(ne,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ne.reverse()}const j=new C.$Gc;for(const W of N){const V=O(W);for(let ne=0;ne<=V.length;ne++)j.add(V.slice(0,ne).join(`
`),W)}N.sort((0,r.$5b)(W=>W.idx,r.$7b));let z="",M=0;for(const W of N.slice(0,v)){M++;const V=O(W),ne=[];for(let B=0;B<V.length;B++){let K=V[B];K=`(shared with ${j.get(V.slice(0,B+1).join(`
`)).size}/${N.length} leaks) at ${K}`;const ee=j.get(V.slice(0,B).join(`
`)),ue=(0,h.$c)([...ee].map(re=>O(re)[B]),re=>re);delete ue[V[B]];for(const[re,ye]of Object.entries(ue))ne.unshift(`    - stacktraces of ${ye.length} other leaks continue with ${re}`);ne.unshift(K)}z+=`


==================== Leaking disposable ${M}/${N.length}: ${W.value.constructor.name} ====================
${ne.join(`
`)}
============================================================

`}return N.length>v&&(z+=`


... and ${N.length-v} more leaking disposables

`),{leaks:N,details:z}}}e.$Ic=c;function I(p){b=p}if(T){const p="__is_disposable_tracked__";I(new class{trackDisposable(v){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[p]||console.log(F)},3e3)}setParent(v,F){if(v&&v!==o.None)try{v[p]=!0}catch{}}markAsDisposed(v){if(v&&v!==o.None)try{v[p]=!0}catch{}}markAsSingleton(v){}})}function S(p){return b?.trackDisposable(p),p}function u(p){b?.markAsDisposed(p)}function P(p,v){b?.setParent(p,v)}function w(p,v){if(b)for(const F of p)b.setParent(F,v)}function a(p){return b?.markAsSingleton(p),p}function m(p){return typeof p=="object"&&p!==null&&typeof p.dispose=="function"&&p.dispose.length===0}function $(p){if(L.Iterable.is(p)){const v=[];for(const F of p)if(F)try{F.dispose()}catch(N){v.push(N)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(p)?[]:p}else if(p)return p.dispose(),p}function f(p){for(const v of p)m(v)&&v.dispose();return[]}function i(...p){const v=s(()=>$(p));return w(p,v),v}function s(p){const v=S({dispose:(0,R.$cb)(()=>{u(v),p()})});return v}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return P(v,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),P(v,null))}}e.$Sc=t;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,S(this),P(this.q,this)}dispose(){u(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Tc=o;class n{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&P(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&P(v,null),v}}e.$Uc=n;class d{constructor(v){this.a=new n,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=d;class l{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=l;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(v){let F=v;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,u(this))},this}}e.$Xc=g;class E{constructor(){this.a=new Map}acquire(v,...F){let N=this.a.get(v);N||(N={counter:0,object:this.b(v,...F)},this.a.set(v,N));const{object:O}=N,j=(0,R.$cb)(()=>{--N.counter===0&&(this.c(v,N.object),this.a.delete(v))});return N.counter++,{object:O,dispose:j}}}e.$Yc=E;class D{constructor(v){this.a=v}async acquire(v,...F){const N=this.a.acquire(v,...F);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(O){throw N.dispose(),O}}}e.$Zc=D;class y{constructor(v){this.object=v}dispose(){}}e.$1c=y;function k(p){const v=new t;try{p(v)}finally{v.dispose()}}class A{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,F,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(v)?.dispose(),this.a.set(v,F)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const F=this.a.get(v);return this.a.delete(v),F}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=A}),function($e,e){typeof define=="function"&&define.amd?define(Se[178],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(te,ce){for(var le=0;le<ce.length;le++){var x=ce[le];x.enumerable=x.enumerable||!1,x.configurable=!0,"value"in x&&(x.writable=!0),Object.defineProperty(te,x.key,x)}}function r(te,ce,le){return ce&&e(te.prototype,ce),le&&e(te,le),Object.defineProperty(te,"prototype",{writable:!1}),te}function h(te,ce){if(te){if(typeof te=="string")return C(te,ce);var le=Object.prototype.toString.call(te).slice(8,-1);if(le==="Object"&&te.constructor&&(le=te.constructor.name),le==="Map"||le==="Set")return Array.from(te);if(le==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(le))return C(te,ce)}}function C(te,ce){(ce==null||ce>te.length)&&(ce=te.length);for(var le=0,x=new Array(ce);le<ce;le++)x[le]=te[le];return x}function R(te,ce){var le=typeof Symbol<"u"&&te[Symbol.iterator]||te["@@iterator"];if(le)return(le=le.call(te)).next.bind(le);if(Array.isArray(te)||(le=h(te))||ce&&te&&typeof te.length=="number"){le&&(te=le);var x=0;return function(){return x>=te.length?{done:!0}:{done:!1,value:te[x++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=L();function T(te){$e.defaults=te}var b=/[&<>"']/,c=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},P=function(ce){return u[ce]};function w(te,ce){if(ce){if(b.test(te))return te.replace(c,P)}else if(I.test(te))return te.replace(S,P);return te}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(te){return te.replace(a,function(ce,le){return le=le.toLowerCase(),le==="colon"?":":le.charAt(0)==="#"?le.charAt(1)==="x"?String.fromCharCode(parseInt(le.substring(2),16)):String.fromCharCode(+le.substring(1)):""})}var $=/(^|[^\[])\^/g;function f(te,ce){te=typeof te=="string"?te:te.source,ce=ce||"";var le={replace:function(oe,pe){return pe=pe.source||pe,pe=pe.replace($,"$1"),te=te.replace(oe,pe),le},getRegex:function(){return new RegExp(te,ce)}};return le}var i=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(te,ce,le){if(te){var x;try{x=decodeURIComponent(m(le)).replace(i,"").toLowerCase()}catch{return null}if(x.indexOf("javascript:")===0||x.indexOf("vbscript:")===0||x.indexOf("data:")===0)return null}ce&&!s.test(le)&&(le=g(ce,le));try{le=encodeURI(le).replace(/%25/g,"%")}catch{return null}return le}var o={},n=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(te,ce){o[" "+te]||(n.test(te)?o[" "+te]=te+"/":o[" "+te]=k(te,"/",!0)),te=o[" "+te];var le=te.indexOf(":")===-1;return ce.substring(0,2)==="//"?le?ce:te.replace(d,"$1")+ce:ce.charAt(0)==="/"?le?ce:te.replace(l,"$1")+ce:te+ce}var E={exec:function(){}};function D(te){for(var ce=1,le,x;ce<arguments.length;ce++){le=arguments[ce];for(x in le)Object.prototype.hasOwnProperty.call(le,x)&&(te[x]=le[x])}return te}function y(te,ce){var le=te.replace(/\|/g,function(pe,we,Fe){for(var ze=!1,Ce=we;--Ce>=0&&Fe[Ce]==="\\";)ze=!ze;return ze?"|":" |"}),x=le.split(/ \|/),oe=0;if(x[0].trim()||x.shift(),x.length>0&&!x[x.length-1].trim()&&x.pop(),x.length>ce)x.splice(ce);else for(;x.length<ce;)x.push("");for(;oe<x.length;oe++)x[oe]=x[oe].trim().replace(/\\\|/g,"|");return x}function k(te,ce,le){var x=te.length;if(x===0)return"";for(var oe=0;oe<x;){var pe=te.charAt(x-oe-1);if(pe===ce&&!le)oe++;else if(pe!==ce&&le)oe++;else break}return te.slice(0,x-oe)}function A(te,ce){if(te.indexOf(ce[1])===-1)return-1;for(var le=te.length,x=0,oe=0;oe<le;oe++)if(te[oe]==="\\")oe++;else if(te[oe]===ce[0])x++;else if(te[oe]===ce[1]&&(x--,x<0))return oe;return-1}function p(te){te&&te.sanitize&&!te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function v(te,ce){if(ce<1)return"";for(var le="";ce>1;)ce&1&&(le+=te),ce>>=1,te+=te;return le+te}function F(te,ce,le,x){var oe=ce.href,pe=ce.title?w(ce.title):null,we=te[1].replace(/\\([\[\]])/g,"$1");if(te[0].charAt(0)!=="!"){x.state.inLink=!0;var Fe={type:"link",raw:le,href:oe,title:pe,text:we,tokens:x.inlineTokens(we)};return x.state.inLink=!1,Fe}return{type:"image",raw:le,href:oe,title:pe,text:w(we)}}function N(te,ce){var le=te.match(/^(\s+)(?:```)/);if(le===null)return ce;var x=le[1];return ce.split(`
`).map(function(oe){var pe=oe.match(/^\s+/);if(pe===null)return oe;var we=pe[0];return we.length>=x.length?oe.slice(x.length):oe}).join(`
`)}var O=function(){function te(le){this.options=le||$e.defaults}var ce=te.prototype;return ce.space=function(x){var oe=this.rules.block.newline.exec(x);if(oe&&oe[0].length>0)return{type:"space",raw:oe[0]}},ce.code=function(x){var oe=this.rules.block.code.exec(x);if(oe){var pe=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:k(pe,`
`)}}},ce.fences=function(x){var oe=this.rules.block.fences.exec(x);if(oe){var pe=oe[0],we=N(pe,oe[3]||"");return{type:"code",raw:pe,lang:oe[2]?oe[2].trim():oe[2],text:we}}},ce.heading=function(x){var oe=this.rules.block.heading.exec(x);if(oe){var pe=oe[2].trim();if(/#$/.test(pe)){var we=k(pe,"#");(this.options.pedantic||!we||/ $/.test(we))&&(pe=we.trim())}return{type:"heading",raw:oe[0],depth:oe[1].length,text:pe,tokens:this.lexer.inline(pe)}}},ce.hr=function(x){var oe=this.rules.block.hr.exec(x);if(oe)return{type:"hr",raw:oe[0]}},ce.blockquote=function(x){var oe=this.rules.block.blockquote.exec(x);if(oe){var pe=oe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},ce.list=function(x){var oe=this.rules.block.list.exec(x);if(oe){var pe,we,Fe,ze,Ce,Ie,Pe,q,H,X,Z,de,be=oe[1].trim(),Oe=be.length>1,He={type:"list",raw:"",ordered:Oe,start:Oe?+be.slice(0,-1):"",loose:!1,items:[]};be=Oe?"\\d{1,9}\\"+be.slice(-1):"\\"+be,this.options.pedantic&&(be=Oe?be:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+be+")((?:[	 ][^\\n]*)?(?:\\n|$))");x&&(de=!1,!(!(oe=Qe.exec(x))||this.rules.block.hr.test(x)));){if(pe=oe[0],x=x.substring(pe.length),q=oe[2].split(`
`,1)[0],H=x.split(`
`,1)[0],this.options.pedantic?(ze=2,Z=q.trimLeft()):(ze=oe[2].search(/[^ ]/),ze=ze>4?1:ze,Z=q.slice(ze),ze+=oe[1].length),Ie=!1,!q&&/^ *$/.test(H)&&(pe+=H+`
`,x=x.substring(H.length+1),de=!0),!de)for(var _e=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),st=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}#");x&&(X=x.split(`
`,1)[0],q=X,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(st.test(q)||rt.test(q)||_e.test(q)||nt.test(x)));){if(q.search(/[^ ]/)>=ze||!q.trim())Z+=`
`+q.slice(ze);else if(!Ie)Z+=`
`+q;else break;!Ie&&!q.trim()&&(Ie=!0),pe+=X+`
`,x=x.substring(X.length+1)}He.loose||(Pe?He.loose=!0:/\n *\n *$/.test(pe)&&(Pe=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(Z),we&&(Fe=we[0]!=="[ ] ",Z=Z.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:pe,task:!!we,checked:Fe,loose:!1,text:Z}),He.raw+=pe}He.items[He.items.length-1].raw=pe.trimRight(),He.items[He.items.length-1].text=Z.trimRight(),He.raw=He.raw.trimRight();var at=He.items.length;for(Ce=0;Ce<at;Ce++){this.lexer.state.top=!1,He.items[Ce].tokens=this.lexer.blockTokens(He.items[Ce].text,[]);var mt=He.items[Ce].tokens.filter(function(ct){return ct.type==="space"}),ht=mt.every(function(ct){for(var ke=ct.raw.split(""),Be=0,Ke=R(ke),Ne;!(Ne=Ke()).done;){var je=Ne.value;if(je===`
`&&(Be+=1),Be>1)return!0}return!1});!He.loose&&mt.length&&ht&&(He.loose=!0,He.items[Ce].loose=!0)}return He}},ce.html=function(x){var oe=this.rules.block.html.exec(x);if(oe){var pe={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(oe[0]):w(oe[0]);pe.type="paragraph",pe.text=we,pe.tokens=this.lexer.inline(we)}return pe}},ce.def=function(x){var oe=this.rules.block.def.exec(x);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var pe=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:oe[0],href:oe[2],title:oe[3]}}},ce.table=function(x){var oe=this.rules.block.table.exec(x);if(oe){var pe={type:"table",header:y(oe[1]).map(function(Pe){return{text:Pe}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]&&oe[3].trim()?oe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=oe[0];var we=pe.align.length,Fe,ze,Ce,Ie;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(pe.align[Fe])?pe.align[Fe]="right":/^ *:-+: *$/.test(pe.align[Fe])?pe.align[Fe]="center":/^ *:-+ *$/.test(pe.align[Fe])?pe.align[Fe]="left":pe.align[Fe]=null;for(we=pe.rows.length,Fe=0;Fe<we;Fe++)pe.rows[Fe]=y(pe.rows[Fe],pe.header.length).map(function(Pe){return{text:Pe}});for(we=pe.header.length,ze=0;ze<we;ze++)pe.header[ze].tokens=this.lexer.inline(pe.header[ze].text);for(we=pe.rows.length,ze=0;ze<we;ze++)for(Ie=pe.rows[ze],Ce=0;Ce<Ie.length;Ce++)Ie[Ce].tokens=this.lexer.inline(Ie[Ce].text);return pe}}},ce.lheading=function(x){var oe=this.rules.block.lheading.exec(x);if(oe)return{type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:this.lexer.inline(oe[1])}},ce.paragraph=function(x){var oe=this.rules.block.paragraph.exec(x);if(oe){var pe=oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1];return{type:"paragraph",raw:oe[0],text:pe,tokens:this.lexer.inline(pe)}}},ce.text=function(x){var oe=this.rules.block.text.exec(x);if(oe)return{type:"text",raw:oe[0],text:oe[0],tokens:this.lexer.inline(oe[0])}},ce.escape=function(x){var oe=this.rules.inline.escape.exec(x);if(oe)return{type:"escape",raw:oe[0],text:w(oe[1])}},ce.tag=function(x){var oe=this.rules.inline.tag.exec(x);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):w(oe[0]):oe[0]}},ce.link=function(x){var oe=this.rules.inline.link.exec(x);if(oe){var pe=oe[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var we=k(pe.slice(0,-1),"\\");if((pe.length-we.length)%2===0)return}else{var Fe=A(oe[2],"()");if(Fe>-1){var ze=oe[0].indexOf("!")===0?5:4,Ce=ze+oe[1].length+Fe;oe[2]=oe[2].substring(0,Fe),oe[0]=oe[0].substring(0,Ce).trim(),oe[3]=""}}var Ie=oe[2],Pe="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);q&&(Ie=q[1],Pe=q[3])}else Pe=oe[3]?oe[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(pe)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),F(oe,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Pe&&Pe.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},ce.reflink=function(x,oe){var pe;if((pe=this.rules.inline.reflink.exec(x))||(pe=this.rules.inline.nolink.exec(x))){var we=(pe[2]||pe[1]).replace(/\s+/g," ");if(we=oe[we.toLowerCase()],!we||!we.href){var Fe=pe[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return F(pe,we,pe[0],this.lexer)}},ce.emStrong=function(x,oe,pe){pe===void 0&&(pe="");var we=this.rules.inline.emStrong.lDelim.exec(x);if(we&&!(we[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(pe===""||this.rules.inline.punctuation.exec(pe))){var ze=we[0].length-1,Ce,Ie,Pe=ze,q=0,H=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,oe=oe.slice(-1*x.length+ze);(we=H.exec(oe))!=null;)if(Ce=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!Ce){if(Ie=Ce.length,we[3]||we[4]){Pe+=Ie;continue}else if((we[5]||we[6])&&ze%3&&!((ze+Ie)%3)){q+=Ie;continue}if(Pe-=Ie,!(Pe>0)){if(Ie=Math.min(Ie,Ie+Pe+q),Math.min(ze,Ie)%2){var X=x.slice(1,ze+we.index+Ie);return{type:"em",raw:x.slice(0,ze+we.index+Ie+1),text:X,tokens:this.lexer.inlineTokens(X)}}var Z=x.slice(2,ze+we.index+Ie-1);return{type:"strong",raw:x.slice(0,ze+we.index+Ie+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}}}}},ce.codespan=function(x){var oe=this.rules.inline.code.exec(x);if(oe){var pe=oe[2].replace(/\n/g," "),we=/[^ ]/.test(pe),Fe=/^ /.test(pe)&&/ $/.test(pe);return we&&Fe&&(pe=pe.substring(1,pe.length-1)),pe=w(pe,!0),{type:"codespan",raw:oe[0],text:pe}}},ce.br=function(x){var oe=this.rules.inline.br.exec(x);if(oe)return{type:"br",raw:oe[0]}},ce.del=function(x){var oe=this.rules.inline.del.exec(x);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2])}},ce.autolink=function(x,oe){var pe=this.rules.inline.autolink.exec(x);if(pe){var we,Fe;return pe[2]==="@"?(we=w(this.options.mangle?oe(pe[1]):pe[1]),Fe="mailto:"+we):(we=w(pe[1]),Fe=we),{type:"link",raw:pe[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ce.url=function(x,oe){var pe;if(pe=this.rules.inline.url.exec(x)){var we,Fe;if(pe[2]==="@")we=w(this.options.mangle?oe(pe[0]):pe[0]),Fe="mailto:"+we;else{var ze;do ze=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(ze!==pe[0]);we=w(pe[0]),pe[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:pe[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ce.inlineText=function(x,oe){var pe=this.rules.inline.text.exec(x);if(pe){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):w(pe[0]):pe[0]:we=w(this.options.smartypants?oe(pe[0]):pe[0]),{type:"text",raw:pe[0],text:we}}},te}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=f(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=f(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=f(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=f(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=f(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=f(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=D({},j),j.gfm=D({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=f(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=f(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=D({},j.normal,{html:f(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:f(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=f(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=f(j._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=f(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=f(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=f(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=f(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=f(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=f(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=f(z.reflink).replace("label",z._label).replace("ref",j._label).getRegex(),z.nolink=f(z.nolink).replace("ref",j._label).getRegex(),z.reflinkSearch=f(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=D({},z),z.pedantic=D({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:f(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:f(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=D({},z.normal,{escape:f(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=f(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=D({},z.gfm,{br:f(z.br).replace("{2,}","*").getRegex(),text:f(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(te){return te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(te){var ce="",le,x,oe=te.length;for(le=0;le<oe;le++)x=te.charCodeAt(le),Math.random()>.5&&(x="x"+x.toString(16)),ce+="&#"+x+";";return ce}var V=function(){function te(le){this.tokens=[],this.tokens.links=Object.create(null),this.options=le||$e.defaults,this.options.tokenizer=this.options.tokenizer||new O,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var x={block:j.normal,inline:z.normal};this.options.pedantic?(x.block=j.pedantic,x.inline=z.pedantic):this.options.gfm&&(x.block=j.gfm,this.options.breaks?x.inline=z.breaks:x.inline=z.gfm),this.tokenizer.rules=x}te.lex=function(x,oe){var pe=new te(oe);return pe.lex(x)},te.lexInline=function(x,oe){var pe=new te(oe);return pe.inlineTokens(x)};var ce=te.prototype;return ce.lex=function(x){x=x.replace(/\r\n|\r/g,`
`),this.blockTokens(x,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},ce.blockTokens=function(x,oe){var pe=this;oe===void 0&&(oe=[]),this.options.pedantic?x=x.replace(/\t/g,"    ").replace(/^ +$/gm,""):x=x.replace(/^( *)(\t+)/gm,function(Pe,q,H){return q+"    ".repeat(H.length)});for(var we,Fe,ze,Ce;x;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Pe){return(we=Pe.call({lexer:pe},x,oe))?(x=x.substring(we.raw.length),oe.push(we),!0):!1}))){if(we=this.tokenizer.space(x)){x=x.substring(we.raw.length),we.raw.length===1&&oe.length>0?oe[oe.length-1].raw+=`
`:oe.push(we);continue}if(we=this.tokenizer.code(x)){x=x.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):oe.push(we);continue}if(we=this.tokenizer.fences(x)){x=x.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.heading(x)){x=x.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.hr(x)){x=x.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.blockquote(x)){x=x.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.list(x)){x=x.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.html(x)){x=x.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.def(x)){x=x.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(x)){x=x.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.lheading(x)){x=x.substring(we.raw.length),oe.push(we);continue}if(ze=x,this.options.extensions&&this.options.extensions.startBlock&&function(){var Pe=1/0,q=x.slice(1),H=void 0;pe.options.extensions.startBlock.forEach(function(X){H=X.call({lexer:this},q),typeof H=="number"&&H>=0&&(Pe=Math.min(Pe,H))}),Pe<1/0&&Pe>=0&&(ze=x.substring(0,Pe+1))}(),this.state.top&&(we=this.tokenizer.paragraph(ze))){Fe=oe[oe.length-1],Ce&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):oe.push(we),Ce=ze.length!==x.length,x=x.substring(we.raw.length);continue}if(we=this.tokenizer.text(x)){x=x.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):oe.push(we);continue}if(x){var Ie="Infinite loop on byte: "+x.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,oe},ce.inline=function(x,oe){return oe===void 0&&(oe=[]),this.inlineQueue.push({src:x,tokens:oe}),oe},ce.inlineTokens=function(x,oe){var pe=this;oe===void 0&&(oe=[]);var we,Fe,ze,Ce=x,Ie,Pe,q;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)H.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Ie.index)+"["+v("a",Ie[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Ie.index)+"["+v("a",Ie[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Ie.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;x;)if(Pe||(q=""),Pe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Z){return(we=Z.call({lexer:pe},x,oe))?(x=x.substring(we.raw.length),oe.push(we),!0):!1}))){if(we=this.tokenizer.escape(x)){x=x.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.tag(x)){x=x.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):oe.push(we);continue}if(we=this.tokenizer.link(x)){x=x.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.reflink(x,this.tokens.links)){x=x.substring(we.raw.length),Fe=oe[oe.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):oe.push(we);continue}if(we=this.tokenizer.emStrong(x,Ce,q)){x=x.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.codespan(x)){x=x.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.br(x)){x=x.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.del(x)){x=x.substring(we.raw.length),oe.push(we);continue}if(we=this.tokenizer.autolink(x,W)){x=x.substring(we.raw.length),oe.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(x,W))){x=x.substring(we.raw.length),oe.push(we);continue}if(ze=x,this.options.extensions&&this.options.extensions.startInline&&function(){var Z=1/0,de=x.slice(1),be=void 0;pe.options.extensions.startInline.forEach(function(Oe){be=Oe.call({lexer:this},de),typeof be=="number"&&be>=0&&(Z=Math.min(Z,be))}),Z<1/0&&Z>=0&&(ze=x.substring(0,Z+1))}(),we=this.tokenizer.inlineText(ze,M)){x=x.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(q=we.raw.slice(-1)),Pe=!0,Fe=oe[oe.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):oe.push(we);continue}if(x){var X="Infinite loop on byte: "+x.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return oe},r(te,null,[{key:"rules",get:function(){return{block:j,inline:z}}}]),te}(),ne=function(){function te(le){this.options=le||$e.defaults}var ce=te.prototype;return ce.code=function(x,oe,pe){var we=(oe||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(x,we);Fe!=null&&Fe!==x&&(pe=!0,x=Fe)}return x=x.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+w(we,!0)+'">'+(pe?x:w(x,!0))+`</code></pre>
`:"<pre><code>"+(pe?x:w(x,!0))+`</code></pre>
`},ce.blockquote=function(x){return`<blockquote>
`+x+`</blockquote>
`},ce.html=function(x){return x},ce.heading=function(x,oe,pe,we){if(this.options.headerIds){var Fe=this.options.headerPrefix+we.slug(pe);return"<h"+oe+' id="'+Fe+'">'+x+"</h"+oe+`>
`}return"<h"+oe+">"+x+"</h"+oe+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(x,oe,pe){var we=oe?"ol":"ul",Fe=oe&&pe!==1?' start="'+pe+'"':"";return"<"+we+Fe+`>
`+x+"</"+we+`>
`},ce.listitem=function(x){return"<li>"+x+`</li>
`},ce.checkbox=function(x){return"<input "+(x?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(x){return"<p>"+x+`</p>
`},ce.table=function(x,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+x+`</thead>
`+oe+`</table>
`},ce.tablerow=function(x){return`<tr>
`+x+`</tr>
`},ce.tablecell=function(x,oe){var pe=oe.header?"th":"td",we=oe.align?"<"+pe+' align="'+oe.align+'">':"<"+pe+">";return we+x+("</"+pe+`>
`)},ce.strong=function(x){return"<strong>"+x+"</strong>"},ce.em=function(x){return"<em>"+x+"</em>"},ce.codespan=function(x){return"<code>"+x+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(x){return"<del>"+x+"</del>"},ce.link=function(x,oe,pe){if(x=t(this.options.sanitize,this.options.baseUrl,x),x===null)return pe;var we='<a href="'+w(x)+'"';return oe&&(we+=' title="'+oe+'"'),we+=">"+pe+"</a>",we},ce.image=function(x,oe,pe){if(x=t(this.options.sanitize,this.options.baseUrl,x),x===null)return pe;var we='<img src="'+x+'" alt="'+pe+'"';return oe&&(we+=' title="'+oe+'"'),we+=this.options.xhtml?"/>":">",we},ce.text=function(x){return x},te}(),B=function(){function te(){}var ce=te.prototype;return ce.strong=function(x){return x},ce.em=function(x){return x},ce.codespan=function(x){return x},ce.del=function(x){return x},ce.html=function(x){return x},ce.text=function(x){return x},ce.link=function(x,oe,pe){return""+pe},ce.image=function(x,oe,pe){return""+pe},ce.br=function(){return""},te}(),K=function(){function te(){this.seen={}}var ce=te.prototype;return ce.serialize=function(x){return x.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(x,oe){var pe=x,we=0;if(this.seen.hasOwnProperty(pe)){we=this.seen[x];do we++,pe=x+"-"+we;while(this.seen.hasOwnProperty(pe))}return oe||(this.seen[x]=we,this.seen[pe]=0),pe},ce.slug=function(x,oe){oe===void 0&&(oe={});var pe=this.serialize(x);return this.getNextSafeSlug(pe,oe.dryrun)},te}(),Y=function(){function te(le){this.options=le||$e.defaults,this.options.renderer=this.options.renderer||new ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new B,this.slugger=new K}te.parse=function(x,oe){var pe=new te(oe);return pe.parse(x)},te.parseInline=function(x,oe){var pe=new te(oe);return pe.parseInline(x)};var ce=te.prototype;return ce.parse=function(x,oe){oe===void 0&&(oe=!0);var pe="",we,Fe,ze,Ce,Ie,Pe,q,H,X,Z,de,be,Oe,He,Qe,_e,nt,st,rt,at=x.length;for(we=0;we<at;we++){if(Z=x[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Z.type]&&(rt=this.options.extensions.renderers[Z.type].call({parser:this},Z),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Z.type))){pe+=rt||"";continue}switch(Z.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(Z.tokens),Z.depth,m(this.parseInline(Z.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(Z.text,Z.lang,Z.escaped);continue}case"table":{for(H="",q="",Ce=Z.header.length,Fe=0;Fe<Ce;Fe++)q+=this.renderer.tablecell(this.parseInline(Z.header[Fe].tokens),{header:!0,align:Z.align[Fe]});for(H+=this.renderer.tablerow(q),X="",Ce=Z.rows.length,Fe=0;Fe<Ce;Fe++){for(Pe=Z.rows[Fe],q="",Ie=Pe.length,ze=0;ze<Ie;ze++)q+=this.renderer.tablecell(this.parseInline(Pe[ze].tokens),{header:!1,align:Z.align[ze]});X+=this.renderer.tablerow(q)}pe+=this.renderer.table(H,X);continue}case"blockquote":{X=this.parse(Z.tokens),pe+=this.renderer.blockquote(X);continue}case"list":{for(de=Z.ordered,be=Z.start,Oe=Z.loose,Ce=Z.items.length,X="",Fe=0;Fe<Ce;Fe++)Qe=Z.items[Fe],_e=Qe.checked,nt=Qe.task,He="",Qe.task&&(st=this.renderer.checkbox(_e),Oe?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=st+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=st+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:st}):He+=st),He+=this.parse(Qe.tokens,Oe),X+=this.renderer.listitem(He,nt,_e);pe+=this.renderer.list(X,de,be);continue}case"html":{pe+=this.renderer.html(Z.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(Z.tokens));continue}case"text":{for(X=Z.tokens?this.parseInline(Z.tokens):Z.text;we+1<at&&x[we+1].type==="text";)Z=x[++we],X+=`
`+(Z.tokens?this.parseInline(Z.tokens):Z.text);pe+=oe?this.renderer.paragraph(X):X;continue}default:{var mt='Token with "'+Z.type+'" type was not found.';if(this.options.silent){console.error(mt);return}else throw new Error(mt)}}}return pe},ce.parseInline=function(x,oe){oe=oe||this.renderer;var pe="",we,Fe,ze,Ce=x.length;for(we=0;we<Ce;we++){if(Fe=x[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(ze=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){pe+=ze||"";continue}switch(Fe.type){case"escape":{pe+=oe.text(Fe.text);break}case"html":{pe+=oe.html(Fe.text);break}case"link":{pe+=oe.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,oe));break}case"image":{pe+=oe.image(Fe.href,Fe.title,Fe.text);break}case"strong":{pe+=oe.strong(this.parseInline(Fe.tokens,oe));break}case"em":{pe+=oe.em(this.parseInline(Fe.tokens,oe));break}case"codespan":{pe+=oe.codespan(Fe.text);break}case"br":{pe+=oe.br();break}case"del":{pe+=oe.del(this.parseInline(Fe.tokens,oe));break}case"text":{pe+=oe.text(Fe.text);break}default:{var Ie='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return pe},te}();function ee(te,ce,le){if(typeof te>"u"||te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");if(typeof ce=="function"&&(le=ce,ce=null),ce=D({},ee.defaults,ce||{}),p(ce),le){var x=ce.highlight,oe;try{oe=V.lex(te,ce)}catch(Ce){return le(Ce)}var pe=function(Ie){var Pe;if(!Ie)try{ce.walkTokens&&ee.walkTokens(oe,ce.walkTokens),Pe=Y.parse(oe,ce)}catch(q){Ie=q}return ce.highlight=x,Ie?le(Ie):le(null,Pe)};if(!x||x.length<3||(delete ce.highlight,!oe.length))return pe();var we=0;ee.walkTokens(oe,function(Ce){Ce.type==="code"&&(we++,setTimeout(function(){x(Ce.text,Ce.lang,function(Ie,Pe){if(Ie)return pe(Ie);Pe!=null&&Pe!==Ce.text&&(Ce.text=Pe,Ce.escaped=!0),we--,we===0&&pe()})},0))}),we===0&&pe();return}function Fe(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(Ce.message+"",!0)+"</pre>";throw Ce}try{var ze=V.lex(te,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ee.walkTokens(ze,ce.walkTokens)).then(function(){return Y.parse(ze,ce)}).catch(Fe);ee.walkTokens(ze,ce.walkTokens)}return Y.parse(ze,ce)}catch(Ce){Fe(Ce)}}ee.options=ee.setOptions=function(te){return D(ee.defaults,te),T(ee.defaults),ee},ee.getDefaults=L,ee.defaults=$e.defaults,ee.use=function(){for(var te=arguments.length,ce=new Array(te),le=0;le<te;le++)ce[le]=arguments[le];var x=D.apply(void 0,[{}].concat(ce)),oe=ee.defaults.extensions||{renderers:{},childTokens:{}},pe;ce.forEach(function(we){if(we.extensions&&(pe=!0,we.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var Ce=oe.renderers?oe.renderers[ze.name]:null;Ce?oe.renderers[ze.name]=function(){for(var Ie=arguments.length,Pe=new Array(Ie),q=0;q<Ie;q++)Pe[q]=arguments[q];var H=ze.renderer.apply(this,Pe);return H===!1&&(H=Ce.apply(this,Pe)),H}:oe.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");oe[ze.level]?oe[ze.level].unshift(ze.tokenizer):oe[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?oe.startBlock?oe.startBlock.push(ze.start):oe.startBlock=[ze.start]:ze.level==="inline"&&(oe.startInline?oe.startInline.push(ze.start):oe.startInline=[ze.start]))}ze.childTokens&&(oe.childTokens[ze.name]=ze.childTokens)})),we.renderer&&function(){var ze=ee.defaults.renderer||new ne,Ce=function(q){var H=ze[q];ze[q]=function(){for(var X=arguments.length,Z=new Array(X),de=0;de<X;de++)Z[de]=arguments[de];var be=we.renderer[q].apply(ze,Z);return be===!1&&(be=H.apply(ze,Z)),be}};for(var Ie in we.renderer)Ce(Ie);x.renderer=ze}(),we.tokenizer&&function(){var ze=ee.defaults.tokenizer||new O,Ce=function(q){var H=ze[q];ze[q]=function(){for(var X=arguments.length,Z=new Array(X),de=0;de<X;de++)Z[de]=arguments[de];var be=we.tokenizer[q].apply(ze,Z);return be===!1&&(be=H.apply(ze,Z)),be}};for(var Ie in we.tokenizer)Ce(Ie);x.tokenizer=ze}(),we.walkTokens){var Fe=ee.defaults.walkTokens;x.walkTokens=function(ze){var Ce=[];return Ce.push(we.walkTokens.call(this,ze)),Fe&&(Ce=Ce.concat(Fe.call(this,ze))),Ce}}pe&&(x.extensions=oe),ee.setOptions(x)})},ee.walkTokens=function(te,ce){for(var le=[],x=function(){var Fe=pe.value;switch(le=le.concat(ce.call(ee,Fe)),Fe.type){case"table":{for(var ze=R(Fe.header),Ce;!(Ce=ze()).done;){var Ie=Ce.value;le=le.concat(ee.walkTokens(Ie.tokens,ce))}for(var Pe=R(Fe.rows),q;!(q=Pe()).done;)for(var H=q.value,X=R(H),Z;!(Z=X()).done;){var de=Z.value;le=le.concat(ee.walkTokens(de.tokens,ce))}break}case"list":{le=le.concat(ee.walkTokens(Fe.items,ce));break}default:ee.defaults.extensions&&ee.defaults.extensions.childTokens&&ee.defaults.extensions.childTokens[Fe.type]?ee.defaults.extensions.childTokens[Fe.type].forEach(function(be){le=le.concat(ee.walkTokens(Fe[be],ce))}):Fe.tokens&&(le=le.concat(ee.walkTokens(Fe.tokens,ce)))}},oe=R(te),pe;!(pe=oe()).done;)x();return le},ee.parseInline=function(te,ce){if(typeof te>"u"||te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");ce=D({},ee.defaults,ce||{}),p(ce);try{var le=V.lexInline(te,ce);return ce.walkTokens&&ee.walkTokens(le,ce.walkTokens),Y.parseInline(le,ce)}catch(x){if(x.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+w(x.message+"",!0)+"</pre>";throw x}},ee.Parser=Y,ee.parser=Y.parse,ee.Renderer=ne,ee.TextRenderer=B,ee.Lexer=V,ee.lexer=V.lex,ee.Tokenizer=O,ee.Slugger=K,ee.parse=ee;var ue=ee.options,re=ee.setOptions,ye=ee.use,me=ee.walkTokens,J=ee.parseInline,U=ee,se=Y.parse,ae=V.lex;$e.Lexer=V,$e.Parser=Y,$e.Renderer=ne,$e.Slugger=K,$e.TextRenderer=B,$e.Tokenizer=O,$e.getDefaults=L,$e.lexer=ae,$e.marked=ee,$e.options=ue,$e.parse=U,$e.parseInline=J,$e.parser=se,$e.setOptions=re,$e.use=ye,$e.walkTokens=me,Object.defineProperty($e,"__esModule",{value:!0})}),define(Se[40],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var r;(function(h){h[h.Uri=1]="Uri",h[h.Regexp=2]="Regexp",h[h.ScmResource=3]="ScmResource",h[h.ScmResourceGroup=4]="ScmResourceGroup",h[h.ScmProvider=5]="ScmProvider",h[h.CommentController=6]="CommentController",h[h.CommentThread=7]="CommentThread",h[h.CommentThreadInstance=8]="CommentThreadInstance",h[h.CommentThreadReply=9]="CommentThreadReply",h[h.CommentNode=10]="CommentNode",h[h.CommentThreadNode=11]="CommentThreadNode",h[h.TimelineActionContext=12]="TimelineActionContext",h[h.NotebookCellActionContext=13]="NotebookCellActionContext",h[h.NotebookActionContext=14]="NotebookActionContext",h[h.TerminalContext=15]="TerminalContext",h[h.TestItemContext=16]="TestItemContext",h[h.Date=17]="Date",h[h.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(r||(e.MarshalledId=r={}))}),define(Se[179],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=r;function r(a){const m=R(a);if(m&&m.length>0)return new Uint32Array(m)}let h=0;const C=new Uint32Array(10);function R(a){if(h=0,L(a,S,b.InitialConsonant),h>0||(L(a,u,b.Vowel),h>0)||(L(a,P,b.FinalConsonant),h>0)||(L(a,w,b.CompatibilityJamo),h))return C.subarray(0,h);if(a>=44032&&a<=55203){const m=a-44032,$=m%588,f=Math.floor(m/588),i=Math.floor($/28),s=$%28-1;if(f<S.length?L(f,S,0):b.InitialConsonant+f-b.CompatibilityJamo<w.length&&L(b.InitialConsonant+f,w,b.CompatibilityJamo),i<u.length?L(i,u,0):b.Vowel+i-b.CompatibilityJamo<w.length&&L(b.Vowel+i-b.CompatibilityJamo,w,b.CompatibilityJamo),s>=0&&(s<P.length?L(s,P,0):b.FinalConsonant+s-b.CompatibilityJamo<w.length&&L(b.FinalConsonant+s-b.CompatibilityJamo,w,b.CompatibilityJamo)),h>0)return C.subarray(0,h)}}function L(a,m,$){a>=$&&a<$+m.length&&T(m[a-$])}function T(a){a!==c.NUL&&(C[h++]=a&255,a>>8&&(C[h++]=a>>8&255),a>>16&&(C[h++]=a>>16&255))}var b;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var c;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(c||(c={}));var I;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(I||(I={}));const S=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),u=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l]),P=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,I.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),w=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.E,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,c.Q,I.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l])}),define(Se[81],De([1,0,28]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=void 0,e.$km=C,e.$lm=L;const h=new r.$Cc(1e4);function C(c){return b(c,"NFC",h)}const R=new r.$Cc(1e4);function L(c){return b(c,"NFD",R)}const T=/[^\u0000-\u0080]/;function b(c,I,S){if(!c)return c;const u=S.get(c);if(u)return u;let P;return T.test(c)?P=c.normalize(I):P=c,S.set(c,P),P}e.$mm=function(){const c=/[\u0300-\u036f]/g;return function(I){return L(I).replace(c,"")}}()}),define(Se[133],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=void 0,e.$Im=r,e.rot=h,e.$Nm=T;function r(b,c,I){return Math.min(Math.max(b,c),I)}function h(b,c){return(c+b%c)%c}class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Km=C;class R{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Lm=R;class L{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const I=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Mm=L;function T(b,c,I,S,u,P,w,a){const m=w-I,$=a-S,f=u-I,i=P-S,s=b-I,t=c-S,o=m*m+$*$,n=m*f+$*i,d=m*s+$*t,l=f*f+i*i,g=f*s+i*t,E=1/(o*l-n*n),D=(l*d-n*g)*E,y=(o*g-n*d)*E;return D>=0&&y>=0&&D+y<1}}),define(Se[180],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_c=void 0,e.$ad=R,e.$bd=u;class r{constructor(w,a,m){this.owner=w,this.debugNameSource=a,this.referenceFn=m}getDebugName(w){return R(w,this)}}e.$_c=r;const h=new Map,C=new WeakMap;function R(P,w){const a=C.get(P);if(a)return a;const m=L(P,w);if(m){let $=h.get(m)??0;$++,h.set(m,$);const f=$===1?m:`${m}#${$}`;return C.set(P,f),f}}function L(P,w){const a=C.get(P);if(a)return a;const m=w.owner?I(w.owner)+".":"";let $;const f=w.debugNameSource;if(f!==void 0)if(typeof f=="function"){if($=f(),$!==void 0)return m+$}else return m+f;const i=w.referenceFn;if(i!==void 0&&($=u(i),$!==void 0))return m+$;if(w.owner!==void 0){const s=T(w.owner,P);if(s!==void 0)return m+s}}function T(P,w){for(const a in P)if(P[a]===w)return a}const b=new Map,c=new WeakMap;function I(P){const w=c.get(P);if(w)return w;const a=S(P);let m=b.get(a)??0;m++,b.set(a,m);const $=m===1?a:`${a}#${m}`;return c.set(P,$),$}function S(P){const w=P.constructor;return w?w.name:"Object"}function u(P){const w=P.toString(),m=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(w);return(m?m[1]:void 0)?.trim()}}),define(Se[181],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Id=h,e.$Jd=C;let r;function h(a){r=a}function C(){return r}class R{constructor(){this.a=0,this.d=new WeakMap}b(m){return L([T(P("|  ",this.a)),m])}c(m){return m.hadValue?m.didChange?[T(" "),c(I(m.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),c(I(m.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),c(I(m.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(m,$){console.log(...this.b([b("observable value changed"),c(m.debugName,{color:"BlueViolet"}),...this.c($)]))}formatChanges(m){if(m.size!==0)return c(" (changed deps: "+[...m].map($=>$.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(m){const $=m.handleChange;this.d.set(m,new Set),m.handleChange=(f,i)=>(this.d.get(m).add(f),$.apply(m,[f,i]))}handleDerivedRecomputed(m,$){const f=this.d.get(m);console.log(...this.b([b("derived recomputed"),c(m.debugName,{color:"BlueViolet"}),...this.c($),this.formatChanges(f),{data:[{fn:m._debugNameData.referenceFn??m._computeFn}]}])),f.clear()}handleFromEventObservableTriggered(m,$){console.log(...this.b([b("observable from event triggered"),c(m.debugName,{color:"BlueViolet"}),...this.c($),{data:[{fn:m._getValue}]}]))}handleAutorunCreated(m){const $=m.handleChange;this.d.set(m,new Set),m.handleChange=(f,i)=>(this.d.get(m).add(f),$.apply(m,[f,i]))}handleAutorunTriggered(m){const $=this.d.get(m);console.log(...this.b([b("autorun"),c(m.debugName,{color:"BlueViolet"}),this.formatChanges($),{data:[{fn:m._debugNameData.referenceFn??m._runFn}]}])),$.clear(),this.a++}handleAutorunFinished(m){this.a--}handleBeginTransaction(m){let $=m.getDebugName();$===void 0&&($=""),console.log(...this.b([b("transaction"),c($,{color:"BlueViolet"}),{data:[{fn:m._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Kd=R;function L(a){const m=new Array,$=[];let f="";function i(t){if("length"in t)for(const o of t)o&&i(o);else"text"in t?(f+=`%c${t.text}`,m.push(t.style),t.data&&$.push(...t.data)):"data"in t&&$.push(...t.data)}i(a);const s=[f,...m];return s.push(...$),s}function T(a){return c(a,{color:"black"})}function b(a){return c(w(`${a}: `,10),{color:"black",bold:!0})}function c(a,m={color:"black"}){function $(i){return Object.entries(i).reduce((s,[t,o])=>`${s}${t}:${o};`,"")}const f={color:m.color};return m.strikeThrough&&(f["text-decoration"]="line-through"),m.bold&&(f["font-weight"]="bold"),{text:a,style:$(f)}}function I(a,m){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=m?`"${a}"`:`"${a.substr(0,m-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?S(a,m):u(a,m);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function S(a,m){let $="[ ",f=!0;for(const i of a){if(f||($+=", "),$.length-5>m){$+="...";break}f=!1,$+=`${I(i,m-$.length)}`}return $+=" ]",$}function u(a,m){let $="{ ",f=!0;for(const[i,s]of Object.entries(a)){if(f||($+=", "),$.length-5>m){$+="...";break}f=!1,$+=`${i}: ${I(s,m-$.length)}`}return $+=" }",$}function P(a,m){let $="";for(let f=1;f<=m;f++)$+=a;return $}function w(a,m){for(;a.length<m;)a+=" ";return a}}),define(Se[182],De([1,0,175,180,181]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$3d=e.$Xd=e.$Wd=void 0,e.$Td=L,e.$Ud=b,e.$Vd=I,e.$Yd=P,e.$Zd=a,e.$1d=m,e.$2d=$,e.$4d=i,e.$6d=t;let R;function L(n){R=n}let T;function b(n){T=n}let c;function I(n){c=n}class S{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,l){const g=l===void 0?void 0:d,E=l===void 0?d:l;return c({owner:g,debugName:()=>{const D=(0,h.$bd)(E);if(D!==void 0)return D;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(k)return`${this.debugName}.${k[2]}`;if(!g)return`${this.debugName} (mapped)`},debugReferenceFn:E},D=>E(this.read(D),D))}recomputeInitiallyAndOnChange(d,l){return d.add(R(this,l)),this}keepObserved(d){return d.add(T(this)),this}get a(){return this.get()}}e.$Wd=S;class u extends S{constructor(){super(...arguments),this.b=new Set}addObserver(d){const l=this.b.size;this.b.add(d),l===0&&this.c()}removeObserver(d){this.b.delete(d)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Xd=u;function P(n,d){const l=new f(n,d);try{n(l)}finally{l.finish()}}let w;function a(n){if(w)n(w);else{const d=new f(n,void 0);w=d;try{n(d)}finally{d.finish(),w=void 0}}}async function m(n,d){const l=new f(n,d);try{await n(l)}finally{l.finish()}}function $(n,d,l){n?d(n):P(d,l)}class f{constructor(d,l){this._fn=d,this.b=l,this.a=[],(0,C.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,h.$bd)(this._fn)}updateObserver(d,l){this.a.push({observer:d,observable:l}),d.beginUpdate(l)}finish(){const d=this.a;for(let l=0;l<d.length;l++){const{observer:g,observable:E}=d[l];g.endUpdate(E)}this.a=null,(0,C.$Jd)()?.handleEndTransaction()}}e.$3d=f;function i(n,d){let l;return typeof n=="string"?l=new h.$_c(void 0,n,void 0):l=new h.$_c(n,void 0,void 0),new s(l,d,r.$5c)}class s extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(d,l,g){super(),this.e=d,this.g=g,this.d=l}get(){return this.d}set(d,l,g){if(g===void 0&&this.g(this.d,d))return;let E;l||(l=E=new f(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(d),(0,C.$Jd)()?.handleObservableChanged(this,{oldValue:D,newValue:d,change:g,didChange:!0,hadValue:!0});for(const y of this.b)l.updateObserver(y,this),y.handleChange(this,g)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(d){this.d=d}}e.$5d=s;function t(n,d){let l;return typeof n=="string"?l=new h.$_c(void 0,n,void 0):l=new h.$_c(n,void 0,void 0),new o(l,d,r.$5c)}class o extends s{h(d){this.d!==d&&(this.d&&this.d.dispose(),this.d=d)}dispose(){this.d?.dispose()}}e.$7d=o}),function(){function $e(C){const R=[];typeof C=="number"&&R.push("code/timeOrigin",C);function L(b){R.push(b,Date.now())}function T(){const b=[];for(let c=0;c<R.length;c+=2)b.push({name:R[c],startTime:R[c+1]});return b}return{mark:L,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(C+L.startTime)});return R}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function r(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var h;typeof global=="object"?h=global:typeof self=="object"?h=self:h={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(h)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(h):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),h.perf=r(h))}(),define(Se[10],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=o,e.$E=D,e.$K=y,e.$h="en";let r=!1,h=!1,C=!1,R=!1,L=!1,T=!1,b=!1,c=!1,I=!1,S=!1,u,P=e.$h,w=e.$h,a,m;const $=globalThis;let f;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?f=$.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(f=process);const i=typeof f?.versions?.electron=="string",s=i&&f?.type==="renderer";if(typeof f=="object"){r=f.platform==="win32",h=f.platform==="darwin",C=f.platform==="linux",R=C&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,b=i,I=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.$h,P=e.$h;const k=f.env.VSCODE_NLS_CONFIG;if(k)try{const A=JSON.parse(k);u=A.userLocale,w=A.osLocale,P=A.resolvedLanguage||e.$h,a=A.languagePack?.translationsConfigFile}catch{}L=!0}else typeof navigator=="object"&&!s?(m=navigator.userAgent,r=m.indexOf("Windows")>=0,h=m.indexOf("Macintosh")>=0,c=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=m.indexOf("Linux")>=0,S=m?.indexOf("Mobi")>=0,T=!0,P=globalThis._VSCODE_NLS_LANGUAGE||e.$h,u=navigator.language.toLowerCase(),w=u):console.error("Unable to resolve platform.");var t;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(k){switch(k){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let n=t.Web;h?n=t.Mac:r?n=t.Windows:C&&(n=t.Linux),e.$j=r,e.$k=h,e.$l=C,e.$m=R,e.$n=L,e.$o=b,e.$p=T,e.$q=T&&typeof $.importScripts=="function",e.$r=e.$q?$.origin:void 0,e.$s=c,e.$t=S,e.$u=I,e.$v=n,e.$w=m,e.$x=P;var d;(function(k){function A(){return e.$x}k.value=A;function p(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}k.isDefaultVariant=p;function v(){return e.$x==="en"}k.isDefault=v})(d||(e.Language=d={})),e.$y=u,e.$z=w,e.$A=a,e.$B=typeof $.postMessage=="function"&&!$.importScripts,e.$C=(()=>{if(e.$B){const k=[];$.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let v=0,F=k.length;v<F;v++){const N=k[v];if(N.id===p.data.vscodeScheduleAsyncWork){k.splice(v,1),N.callback();return}}});let A=0;return p=>{const v=++A;k.push({id:v,callback:p}),$.postMessage({vscodeScheduleAsyncWork:v},"*")}}return k=>setTimeout(k)})();var l;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=h||c?l.Macintosh:r?l.Windows:l.Linux;let g=!0,E=!1;function D(){if(!E){E=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,g=new Uint16Array(k.buffer)[0]===513}return g}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function y(k){return parseFloat(k)>=20}}),define(Se[183],De([1,0,39]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2I=void 0;const h=Symbol("unset");class C{constructor(){this.a=new L,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||r.Iterable.empty()}get entries(){return this.a.children?.entries()||r.Iterable.empty()}insert(b,c,I){this.d(b,S=>S._value=c,I)}mutate(b,c){this.d(b,I=>I._value=c(I._value===h?void 0:I._value))}mutatePath(b,c){this.d(b,()=>{},I=>c(I))}delete(b){const c=this.c(b);if(!c)return;let I=c.length-1;const S=c[I].node._value;if(S!==h){for(this.b--,c[I].node._value=h;I>0;I--){const{node:u,part:P}=c[I];if(u.children?.size||u._value!==h)break;c[I-1].node.children.delete(P)}return S}}*deleteRecursive(b){const c=this.c(b);if(!c)return;const I=c[c.length-1].node;for(let S=c.length-1;S>0;S--){const u=c[S-1];if(u.node.children.delete(c[S].part),u.node.children.size>0||u.node._value!==h)break}for(const S of R(I))S._value!==h&&(this.b--,yield S._value)}find(b){let c=this.a;for(const I of b){const S=c.children?.get(I);if(!S)return;c=S}return c._value===h?void 0:c._value}hasKeyOrParent(b){let c=this.a;for(const I of b){const S=c.children?.get(I);if(!S)return!1;if(S._value!==h)return!0;c=S}return!1}hasKeyOrChildren(b){let c=this.a;for(const I of b){const S=c.children?.get(I);if(!S)return!1;c=S}return!0}hasKey(b){let c=this.a;for(const I of b){const S=c.children?.get(I);if(!S)return!1;c=S}return c._value!==h}c(b){const c=[{part:"",node:this.a}];let I=0;for(const S of b){const u=c[I].node.children?.get(S);if(!u)return;c.push({part:S,node:u}),I++}return c}d(b,c,I){let S=this.a;for(const w of b){if(S.children)if(S.children.has(w))S=S.children.get(w);else{const a=new L;S.children.set(w,a),S=a}else{const a=new L;S.children=new Map([[w,a]]),S=a}I?.(S)}const u=S._value===h?0:1;c(S);const P=S._value===h?0:1;this.b+=P-u}*values(){for(const{_value:b}of R(this.a))b!==h&&(yield b)}}e.$2I=C;function*R(T){const b=[T];for(;b.length>0;){const c=b.pop();if(yield c,c.children)for(const I of c.children.values())b.push(I)}}class L{constructor(){this._value=h}get value(){return this._value===h?void 0:this._value}set value(b){this._value=b===void 0?h:b}}}),define(Se[55],De([1,0,10]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let h;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.process<"u"){const R=C.process;h={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?h={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:h={get platform(){return r.$j?"win32":r.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=h.cwd,e.env=h.env,e.$cc=h.platform,e.$dc=h.arch}),define(Se[16],De([1,0,55]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0,r=Ue(r);const h=65,C=97,R=90,L=122,T=46,b=47,c=92,I=58,S=63;class u extends Error{constructor(d,l,g){let E;typeof l=="string"&&l.indexOf("not ")===0?(E="must not be",l=l.replace(/^not /,"")):E="must be";const D=d.indexOf(".")!==-1?"property":"argument";let y=`The "${d}" ${D} ${E} of type ${l}`;y+=`. Received type ${typeof g}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function P(n,d){if(n===null||typeof n!="object")throw new u(d,"Object",n)}function w(n,d){if(typeof n!="string")throw new u(d,"string",n)}const a=r.$cc==="win32";function m(n){return n===b||n===c}function $(n){return n===b}function f(n){return n>=h&&n<=R||n>=C&&n<=L}function i(n,d,l,g){let E="",D=0,y=-1,k=0,A=0;for(let p=0;p<=n.length;++p){if(p<n.length)A=n.charCodeAt(p);else{if(g(A))break;A=b}if(g(A)){if(!(y===p-1||k===1))if(k===2){if(E.length<2||D!==2||E.charCodeAt(E.length-1)!==T||E.charCodeAt(E.length-2)!==T){if(E.length>2){const v=E.lastIndexOf(l);v===-1?(E="",D=0):(E=E.slice(0,v),D=E.length-1-E.lastIndexOf(l)),y=p,k=0;continue}else if(E.length!==0){E="",D=0,y=p,k=0;continue}}d&&(E+=E.length>0?`${l}..`:"..",D=2)}else E.length>0?E+=`${l}${n.slice(y+1,p)}`:E=n.slice(y+1,p),D=p-y-1;y=p,k=0}else A===T&&k!==-1?++k:k=-1}return E}function s(n){return n?`${n[0]==="."?"":"."}${n}`:""}function t(n,d){P(d,"pathObject");const l=d.dir||d.root,g=d.base||`${d.name||""}${s(d.ext)}`;return l?l===d.root?`${l}${g}`:`${l}${n}${g}`:g}e.$ec={resolve(...n){let d="",l="",g=!1;for(let E=n.length-1;E>=-1;E--){let D;if(E>=0){if(D=n[E],w(D,`paths[${E}]`),D.length===0)continue}else d.length===0?D=r.cwd():(D=r.env[`=${d}`]||r.cwd(),(D===void 0||D.slice(0,2).toLowerCase()!==d.toLowerCase()&&D.charCodeAt(2)===c)&&(D=`${d}\\`));const y=D.length;let k=0,A="",p=!1;const v=D.charCodeAt(0);if(y===1)m(v)&&(k=1,p=!0);else if(m(v))if(p=!0,m(D.charCodeAt(1))){let F=2,N=F;for(;F<y&&!m(D.charCodeAt(F));)F++;if(F<y&&F!==N){const O=D.slice(N,F);for(N=F;F<y&&m(D.charCodeAt(F));)F++;if(F<y&&F!==N){for(N=F;F<y&&!m(D.charCodeAt(F));)F++;(F===y||F!==N)&&(A=`\\\\${O}\\${D.slice(N,F)}`,k=F)}}}else k=1;else f(v)&&D.charCodeAt(1)===I&&(A=D.slice(0,2),k=2,y>2&&m(D.charCodeAt(2))&&(p=!0,k=3));if(A.length>0)if(d.length>0){if(A.toLowerCase()!==d.toLowerCase())continue}else d=A;if(g){if(d.length>0)break}else if(l=`${D.slice(k)}\\${l}`,g=p,p&&d.length>0)break}return l=i(l,!g,"\\",m),g?`${d}\\${l}`:`${d}${l}`||"."},normalize(n){w(n,"path");const d=n.length;if(d===0)return".";let l=0,g,E=!1;const D=n.charCodeAt(0);if(d===1)return $(D)?"\\":n;if(m(D))if(E=!0,m(n.charCodeAt(1))){let k=2,A=k;for(;k<d&&!m(n.charCodeAt(k));)k++;if(k<d&&k!==A){const p=n.slice(A,k);for(A=k;k<d&&m(n.charCodeAt(k));)k++;if(k<d&&k!==A){for(A=k;k<d&&!m(n.charCodeAt(k));)k++;if(k===d)return`\\\\${p}\\${n.slice(A)}\\`;k!==A&&(g=`\\\\${p}\\${n.slice(A,k)}`,l=k)}}}else l=1;else f(D)&&n.charCodeAt(1)===I&&(g=n.slice(0,2),l=2,d>2&&m(n.charCodeAt(2))&&(E=!0,l=3));let y=l<d?i(n.slice(l),!E,"\\",m):"";return y.length===0&&!E&&(y="."),y.length>0&&m(n.charCodeAt(d-1))&&(y+="\\"),g===void 0?E?`\\${y}`:y:E?`${g}\\${y}`:`${g}${y}`},isAbsolute(n){w(n,"path");const d=n.length;if(d===0)return!1;const l=n.charCodeAt(0);return m(l)||d>2&&f(l)&&n.charCodeAt(1)===I&&m(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let d,l;for(let D=0;D<n.length;++D){const y=n[D];w(y,"path"),y.length>0&&(d===void 0?d=l=y:d+=`\\${y}`)}if(d===void 0)return".";let g=!0,E=0;if(typeof l=="string"&&m(l.charCodeAt(0))){++E;const D=l.length;D>1&&m(l.charCodeAt(1))&&(++E,D>2&&(m(l.charCodeAt(2))?++E:g=!1))}if(g){for(;E<d.length&&m(d.charCodeAt(E));)E++;E>=2&&(d=`\\${d.slice(E)}`)}return e.$ec.normalize(d)},relative(n,d){if(w(n,"from"),w(d,"to"),n===d)return"";const l=e.$ec.resolve(n),g=e.$ec.resolve(d);if(l===g||(n=l.toLowerCase(),d=g.toLowerCase(),n===d))return"";let E=0;for(;E<n.length&&n.charCodeAt(E)===c;)E++;let D=n.length;for(;D-1>E&&n.charCodeAt(D-1)===c;)D--;const y=D-E;let k=0;for(;k<d.length&&d.charCodeAt(k)===c;)k++;let A=d.length;for(;A-1>k&&d.charCodeAt(A-1)===c;)A--;const p=A-k,v=y<p?y:p;let F=-1,N=0;for(;N<v;N++){const j=n.charCodeAt(E+N);if(j!==d.charCodeAt(k+N))break;j===c&&(F=N)}if(N!==v){if(F===-1)return g}else{if(p>v){if(d.charCodeAt(k+N)===c)return g.slice(k+N+1);if(N===2)return g.slice(k+N)}y>v&&(n.charCodeAt(E+N)===c?F=N:N===2&&(F=3)),F===-1&&(F=0)}let O="";for(N=E+F+1;N<=D;++N)(N===D||n.charCodeAt(N)===c)&&(O+=O.length===0?"..":"\\..");return k+=F,O.length>0?`${O}${g.slice(k,A)}`:(g.charCodeAt(k)===c&&++k,g.slice(k,A))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const d=e.$ec.resolve(n);if(d.length<=2)return n;if(d.charCodeAt(0)===c){if(d.charCodeAt(1)===c){const l=d.charCodeAt(2);if(l!==S&&l!==T)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(f(d.charCodeAt(0))&&d.charCodeAt(1)===I&&d.charCodeAt(2)===c)return`\\\\?\\${d}`;return n},dirname(n){w(n,"path");const d=n.length;if(d===0)return".";let l=-1,g=0;const E=n.charCodeAt(0);if(d===1)return m(E)?n:".";if(m(E)){if(l=g=1,m(n.charCodeAt(1))){let k=2,A=k;for(;k<d&&!m(n.charCodeAt(k));)k++;if(k<d&&k!==A){for(A=k;k<d&&m(n.charCodeAt(k));)k++;if(k<d&&k!==A){for(A=k;k<d&&!m(n.charCodeAt(k));)k++;if(k===d)return n;k!==A&&(l=g=k+1)}}}}else f(E)&&n.charCodeAt(1)===I&&(l=d>2&&m(n.charCodeAt(2))?3:2,g=l);let D=-1,y=!0;for(let k=d-1;k>=g;--k)if(m(n.charCodeAt(k))){if(!y){D=k;break}}else y=!1;if(D===-1){if(l===-1)return".";D=l}return n.slice(0,D)},basename(n,d){d!==void 0&&w(d,"suffix"),w(n,"path");let l=0,g=-1,E=!0,D;if(n.length>=2&&f(n.charCodeAt(0))&&n.charCodeAt(1)===I&&(l=2),d!==void 0&&d.length>0&&d.length<=n.length){if(d===n)return"";let y=d.length-1,k=-1;for(D=n.length-1;D>=l;--D){const A=n.charCodeAt(D);if(m(A)){if(!E){l=D+1;break}}else k===-1&&(E=!1,k=D+1),y>=0&&(A===d.charCodeAt(y)?--y===-1&&(g=D):(y=-1,g=k))}return l===g?g=k:g===-1&&(g=n.length),n.slice(l,g)}for(D=n.length-1;D>=l;--D)if(m(n.charCodeAt(D))){if(!E){l=D+1;break}}else g===-1&&(E=!1,g=D+1);return g===-1?"":n.slice(l,g)},extname(n){w(n,"path");let d=0,l=-1,g=0,E=-1,D=!0,y=0;n.length>=2&&n.charCodeAt(1)===I&&f(n.charCodeAt(0))&&(d=g=2);for(let k=n.length-1;k>=d;--k){const A=n.charCodeAt(k);if(m(A)){if(!D){g=k+1;break}continue}E===-1&&(D=!1,E=k+1),A===T?l===-1?l=k:y!==1&&(y=1):l!==-1&&(y=-1)}return l===-1||E===-1||y===0||y===1&&l===E-1&&l===g+1?"":n.slice(l,E)},format:t.bind(null,"\\"),parse(n){w(n,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return d;const l=n.length;let g=0,E=n.charCodeAt(0);if(l===1)return m(E)?(d.root=d.dir=n,d):(d.base=d.name=n,d);if(m(E)){if(g=1,m(n.charCodeAt(1))){let F=2,N=F;for(;F<l&&!m(n.charCodeAt(F));)F++;if(F<l&&F!==N){for(N=F;F<l&&m(n.charCodeAt(F));)F++;if(F<l&&F!==N){for(N=F;F<l&&!m(n.charCodeAt(F));)F++;F===l?g=F:F!==N&&(g=F+1)}}}}else if(f(E)&&n.charCodeAt(1)===I){if(l<=2)return d.root=d.dir=n,d;if(g=2,m(n.charCodeAt(2))){if(l===3)return d.root=d.dir=n,d;g=3}}g>0&&(d.root=n.slice(0,g));let D=-1,y=g,k=-1,A=!0,p=n.length-1,v=0;for(;p>=g;--p){if(E=n.charCodeAt(p),m(E)){if(!A){y=p+1;break}continue}k===-1&&(A=!1,k=p+1),E===T?D===-1?D=p:v!==1&&(v=1):D!==-1&&(v=-1)}return k!==-1&&(D===-1||v===0||v===1&&D===k-1&&D===y+1?d.base=d.name=n.slice(y,k):(d.name=n.slice(y,D),d.base=n.slice(y,k),d.ext=n.slice(D,k))),y>0&&y!==g?d.dir=n.slice(0,y-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(a){const n=/\\/g;return()=>{const d=r.cwd().replace(n,"/");return d.slice(d.indexOf("/"))}}return()=>r.cwd()})();e.$fc={resolve(...n){let d="",l=!1;for(let g=n.length-1;g>=-1&&!l;g--){const E=g>=0?n[g]:o();w(E,`paths[${g}]`),E.length!==0&&(d=`${E}/${d}`,l=E.charCodeAt(0)===b)}return d=i(d,!l,"/",$),l?`/${d}`:d.length>0?d:"."},normalize(n){if(w(n,"path"),n.length===0)return".";const d=n.charCodeAt(0)===b,l=n.charCodeAt(n.length-1)===b;return n=i(n,!d,"/",$),n.length===0?d?"/":l?"./":".":(l&&(n+="/"),d?`/${n}`:n)},isAbsolute(n){return w(n,"path"),n.length>0&&n.charCodeAt(0)===b},join(...n){if(n.length===0)return".";let d;for(let l=0;l<n.length;++l){const g=n[l];w(g,"path"),g.length>0&&(d===void 0?d=g:d+=`/${g}`)}return d===void 0?".":e.$fc.normalize(d)},relative(n,d){if(w(n,"from"),w(d,"to"),n===d||(n=e.$fc.resolve(n),d=e.$fc.resolve(d),n===d))return"";const l=1,g=n.length,E=g-l,D=1,y=d.length-D,k=E<y?E:y;let A=-1,p=0;for(;p<k;p++){const F=n.charCodeAt(l+p);if(F!==d.charCodeAt(D+p))break;F===b&&(A=p)}if(p===k)if(y>k){if(d.charCodeAt(D+p)===b)return d.slice(D+p+1);if(p===0)return d.slice(D+p)}else E>k&&(n.charCodeAt(l+p)===b?A=p:p===0&&(A=0));let v="";for(p=l+A+1;p<=g;++p)(p===g||n.charCodeAt(p)===b)&&(v+=v.length===0?"..":"/..");return`${v}${d.slice(D+A)}`},toNamespacedPath(n){return n},dirname(n){if(w(n,"path"),n.length===0)return".";const d=n.charCodeAt(0)===b;let l=-1,g=!0;for(let E=n.length-1;E>=1;--E)if(n.charCodeAt(E)===b){if(!g){l=E;break}}else g=!1;return l===-1?d?"/":".":d&&l===1?"//":n.slice(0,l)},basename(n,d){d!==void 0&&w(d,"ext"),w(n,"path");let l=0,g=-1,E=!0,D;if(d!==void 0&&d.length>0&&d.length<=n.length){if(d===n)return"";let y=d.length-1,k=-1;for(D=n.length-1;D>=0;--D){const A=n.charCodeAt(D);if(A===b){if(!E){l=D+1;break}}else k===-1&&(E=!1,k=D+1),y>=0&&(A===d.charCodeAt(y)?--y===-1&&(g=D):(y=-1,g=k))}return l===g?g=k:g===-1&&(g=n.length),n.slice(l,g)}for(D=n.length-1;D>=0;--D)if(n.charCodeAt(D)===b){if(!E){l=D+1;break}}else g===-1&&(E=!1,g=D+1);return g===-1?"":n.slice(l,g)},extname(n){w(n,"path");let d=-1,l=0,g=-1,E=!0,D=0;for(let y=n.length-1;y>=0;--y){const k=n.charCodeAt(y);if(k===b){if(!E){l=y+1;break}continue}g===-1&&(E=!1,g=y+1),k===T?d===-1?d=y:D!==1&&(D=1):d!==-1&&(D=-1)}return d===-1||g===-1||D===0||D===1&&d===g-1&&d===l+1?"":n.slice(d,g)},format:t.bind(null,"/"),parse(n){w(n,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return d;const l=n.charCodeAt(0)===b;let g;l?(d.root="/",g=1):g=0;let E=-1,D=0,y=-1,k=!0,A=n.length-1,p=0;for(;A>=g;--A){const v=n.charCodeAt(A);if(v===b){if(!k){D=A+1;break}continue}y===-1&&(k=!1,y=A+1),v===T?E===-1?E=A:p!==1&&(p=1):E!==-1&&(p=-1)}if(y!==-1){const v=D===0&&l?1:D;E===-1||p===0||p===1&&E===y-1&&E===D+1?d.base=d.name=n.slice(v,y):(d.name=n.slice(v,E),d.base=n.slice(v,y),d.ext=n.slice(E,y))}return D>0?d.dir=n.slice(0,D-1):l&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=a?e.$ec.normalize:e.$fc.normalize,e.$hc=a?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=a?e.$ec.join:e.$fc.join,e.$jc=a?e.$ec.resolve:e.$fc.resolve,e.$kc=a?e.$ec.relative:e.$fc.relative,e.$lc=a?e.$ec.dirname:e.$fc.dirname,e.$mc=a?e.$ec.basename:e.$fc.basename,e.$nc=a?e.$ec.extname:e.$fc.extname,e.$oc=a?e.$ec.format:e.$fc.format,e.$pc=a?e.$ec.parse:e.$fc.parse,e.$qc=a?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=a?e.$ec.sep:e.$fc.sep,e.$sc=a?e.$ec.delimiter:e.$fc.delimiter}),define(Se[134],De([1,0,49,16]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=T,e.$yr=b,e.$zr=c,e.$Ar=I,e.$Br=S,e.$Cr=u,e.$Dr=P,e.$Er=w,e.$Fr=a,e.$Gr=m,e.$Hr=g,e.$Ir=E,e.$Jr=D;const C=new r.$T(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),R=new r.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new r.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(y,k,A=!1){const p=y||"",v=k||"",F=C.value.collator.compare(p,v);return C.value.collatorIsNumeric&&F===0&&p!==v?p<v?-1:1:F}function b(y,k){const A=R.value.collator;return y=y||"",k=k||"",s(A,y,k)}function c(y,k){const A=R.value.collator;return y=y||"",k=k||"",d(y,k)||s(A,y,k)}function I(y,k){const A=R.value.collator;return y=y||"",k=k||"",n(y,k)||s(A,y,k)}function S(y,k){return y=y||"",k=k||"",y===k?0:y<k?-1:1}function u(y,k){const[A,p]=f(y),[v,F]=f(k);let N=C.value.collator.compare(p,F);if(N===0){if(C.value.collatorIsNumeric&&p!==F)return p<F?-1:1;if(N=C.value.collator.compare(A,v),C.value.collatorIsNumeric&&N===0&&A!==v)return A<v?-1:1}return N}function P(y,k){y=y||"",k=k||"";const A=i(y),p=i(k),v=R.value.collator,F=L.value.collator;return s(F,A,p)||s(v,y,k)}function w(y,k){y=y||"",k=k||"";const A=i(y),p=i(k),v=R.value.collator,F=L.value.collator;return s(F,A,p)||d(y,k)||s(v,y,k)}function a(y,k){y=y||"",k=k||"";const A=i(y),p=i(k),v=R.value.collator,F=L.value.collator;return s(F,A,p)||n(y,k)||s(v,y,k)}function m(y,k){y=y||"",k=k||"";const A=i(y).toLowerCase(),p=i(k).toLowerCase();return A!==p?A<p?-1:1:y!==k?y<k?-1:1:0}const $=/^(.*?)(\.([^.]*))?$/;function f(y,k=!1){const A=y?$.exec(y):[];let p=[A&&A[1]||"",A&&A[3]||""];return k&&(!p[0]&&p[1]||p[0]&&p[0].charAt(0)===".")&&(p=[p[0]+"."+p[1],""]),p}function i(y){const k=y?$.exec(y):[];return k&&k[1]&&k[1].charAt(0)!=="."&&k[3]||""}function s(y,k,A){const p=y.compare(k,A);return p!==0?p:k.length!==A.length?k.length<A.length?-1:1:0}function t(y){const k=y.charAt(0);return k.toLocaleUpperCase()!==k}function o(y){const k=y.charAt(0);return k.toLocaleLowerCase()!==k}function n(y,k){return t(y)&&o(k)?-1:o(y)&&t(k)?1:0}function d(y,k){return o(y)&&t(k)?-1:t(y)&&o(k)?1:0}function l(y,k,A=!1){return A||(y=y&&y.toLowerCase(),k=k&&k.toLowerCase()),y===k?0:y<k?-1:1}function g(y,k,A=!1){const p=y.split(h.sep),v=k.split(h.sep),F=p.length-1,N=v.length-1;let O,j;for(let z=0;;z++){if(O=F===z,j=N===z,O&&j)return T(p[z],v[z],A);if(O)return-1;if(j)return 1;const M=l(p[z],v[z],A);if(M!==0)return M}}function E(y,k,A){const p=y.toLowerCase(),v=k.toLowerCase(),F=D(y,k,A);if(F)return F;const N=p.endsWith(A),O=v.endsWith(A);if(N!==O)return N?-1:1;const j=T(p,v);return j!==0?j:p.localeCompare(v)}function D(y,k,A){const p=y.toLowerCase(),v=k.toLowerCase(),F=p.startsWith(A),N=v.startsWith(A);if(F!==N)return F?-1:1;if(F&&N){if(p.length<v.length)return-1;if(p.length>v.length)return 1}return 0}}),define(Se[103],De([1,0,16]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0,e.$9s=R,e.$0s=L,e.$$s=T,e.$_s=c,e.$8s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const h={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(I){const S=(0,r.$nc)(I),u=h[S.toLowerCase()];return u!==void 0?u:L(I)}function L(I){const S=(0,r.$nc)(I);return C[S.toLowerCase()]}function T(I){for(const S in C)if(C[S]===I)return S}const b=/^(.+)\/(.+?)(;.+)?$/;function c(I,S){const u=b.exec(I);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:S?void 0:I}}),define(Se[104],De([1,0,10]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$im=R,e.$jm=L;var h;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(h||(e.Source=h={}));var C;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(C||(e.TerminateResponseCode=C={}));function R(T,...b){const c=b.reduce((u,P)=>(u[P]=!0,u),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(u=>!c[u]).forEach(u=>{for(let P=0;P<I.length;P++)if(u.search(I[P])!==-1){delete T[u];break}})}function L(T){T&&(delete T.DEBUG,r.$l&&delete T.LD_PRELOAD)}}),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var h in r)(typeof exports=="object"?exports:$e)[h]=r[h]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function r(h){if(e[h])return e[h].exports;var C=e[h]={i:h,l:!1,exports:{}};return $e[h].call(C.exports,C,C.exports,r),C.l=!0,C.exports}return r.m=$e,r.c=e,r.d=function(h,C,R){r.o(h,C)||Object.defineProperty(h,C,{enumerable:!0,get:R})},r.r=function(h){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(h,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(h,"__esModule",{value:!0})},r.t=function(h,C){if(1&C&&(h=r(h)),8&C||4&C&&typeof h=="object"&&h&&h.__esModule)return h;var R=Object.create(null);if(r.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:h}),2&C&&typeof h!="string")for(var L in h)r.d(R,L,function(T){return h[T]}.bind(null,L));return R},r.n=function(h){var C=h&&h.__esModule?function(){return h.default}:function(){return h};return r.d(C,"a",C),C},r.o=function(h,C){return Object.prototype.hasOwnProperty.call(h,C)},r.p="",r(r.s=0)}([function($e,e,r){(function(h){var C;e=$e.exports=ye,C=typeof h=="object"&&h.env&&h.env.NODE_DEBUG&&/\bsemver\b/i.test(h.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],b=e.src=[],c=0,I=c++;b[I]="0|[1-9]\\d*";var S=c++;b[S]="[0-9]+";var u=c++;b[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=c++;b[P]="("+b[I]+")\\.("+b[I]+")\\.("+b[I]+")";var w=c++;b[w]="("+b[S]+")\\.("+b[S]+")\\.("+b[S]+")";var a=c++;b[a]="(?:"+b[I]+"|"+b[u]+")";var m=c++;b[m]="(?:"+b[S]+"|"+b[u]+")";var $=c++;b[$]="(?:-("+b[a]+"(?:\\."+b[a]+")*))";var f=c++;b[f]="(?:-?("+b[m]+"(?:\\."+b[m]+")*))";var i=c++;b[i]="[0-9A-Za-z-]+";var s=c++;b[s]="(?:\\+("+b[i]+"(?:\\."+b[i]+")*))";var t=c++,o="v?"+b[P]+b[$]+"?"+b[s]+"?";b[t]="^"+o+"$";var n="[v=\\s]*"+b[w]+b[f]+"?"+b[s]+"?",d=c++;b[d]="^"+n+"$";var l=c++;b[l]="((?:<|>)?=?)";var g=c++;b[g]=b[S]+"|x|X|\\*";var E=c++;b[E]=b[I]+"|x|X|\\*";var D=c++;b[D]="[v=\\s]*("+b[E]+")(?:\\.("+b[E]+")(?:\\.("+b[E]+")(?:"+b[$]+")?"+b[s]+"?)?)?";var y=c++;b[y]="[v=\\s]*("+b[g]+")(?:\\.("+b[g]+")(?:\\.("+b[g]+")(?:"+b[f]+")?"+b[s]+"?)?)?";var k=c++;b[k]="^"+b[l]+"\\s*"+b[D]+"$";var A=c++;b[A]="^"+b[l]+"\\s*"+b[y]+"$";var p=c++;b[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=c++;b[v]="(?:~>?)";var F=c++;b[F]="(\\s*)"+b[v]+"\\s+",T[F]=new RegExp(b[F],"g");var N=c++;b[N]="^"+b[v]+b[D]+"$";var O=c++;b[O]="^"+b[v]+b[y]+"$";var j=c++;b[j]="(?:\\^)";var z=c++;b[z]="(\\s*)"+b[j]+"\\s+",T[z]=new RegExp(b[z],"g");var M=c++;b[M]="^"+b[j]+b[D]+"$";var W=c++;b[W]="^"+b[j]+b[y]+"$";var V=c++;b[V]="^"+b[l]+"\\s*("+n+")$|^$";var ne=c++;b[ne]="^"+b[l]+"\\s*("+o+")$|^$";var B=c++;b[B]="(\\s*)"+b[l]+"\\s*("+n+"|"+b[D]+")",T[B]=new RegExp(b[B],"g");var K=c++;b[K]="^\\s*("+b[D]+")\\s+-\\s+("+b[D]+")\\s*$";var Y=c++;b[Y]="^\\s*("+b[y]+")\\s+-\\s+("+b[y]+")\\s*$";var ee=c++;b[ee]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)C(ue,b[ue]),T[ue]||(T[ue]=new RegExp(b[ue]));function re(H,X){if(H instanceof ye)return H;if(typeof H!="string"||H.length>R||!(X?T[d]:T[t]).test(H))return null;try{return new ye(H,X)}catch{return null}}function ye(H,X){if(H instanceof ye){if(H.loose===X)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ye))return new ye(H,X);C("SemVer",H,X),this.loose=X;var Z=H.trim().match(X?T[d]:T[t]);if(!Z)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+Z[1],this.minor=+Z[2],this.patch=+Z[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");Z[4]?this.prerelease=Z[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var be=+de;if(be>=0&&be<L)return be}return de}):this.prerelease=[],this.build=Z[5]?Z[5].split("."):[],this.format()}e.parse=re,e.valid=function(H,X){var Z=re(H,X);return Z?Z.version:null},e.clean=function(H,X){var Z=re(H.trim().replace(/^[=v]+/,""),X);return Z?Z.version:null},e.SemVer=ye,ye.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ye.prototype.toString=function(){return this.version},ye.prototype.compare=function(H){return C("SemVer.compare",this.version,this.loose,H),H instanceof ye||(H=new ye(H,this.loose)),this.compareMain(H)||this.comparePre(H)},ye.prototype.compareMain=function(H){return H instanceof ye||(H=new ye(H,this.loose)),J(this.major,H.major)||J(this.minor,H.minor)||J(this.patch,H.patch)},ye.prototype.comparePre=function(H){if(H instanceof ye||(H=new ye(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var X=0;do{var Z=this.prerelease[X],de=H.prerelease[X];if(C("prerelease compare",X,Z,de),Z===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(Z===void 0)return-1;if(Z!==de)return J(Z,de)}while(++X)},ye.prototype.inc=function(H,X){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Z=this.prerelease.length;--Z>=0;)typeof this.prerelease[Z]=="number"&&(this.prerelease[Z]++,Z=-2);Z===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,X,Z,de){typeof Z=="string"&&(de=Z,Z=void 0);try{return new ye(H,Z).inc(X,de).version}catch{return null}},e.diff=function(H,X){if(te(H,X))return null;var Z=re(H),de=re(X);if(Z.prerelease.length||de.prerelease.length){for(var be in Z)if((be==="major"||be==="minor"||be==="patch")&&Z[be]!==de[be])return"pre"+be;return"prerelease"}for(var be in Z)if((be==="major"||be==="minor"||be==="patch")&&Z[be]!==de[be])return be},e.compareIdentifiers=J;var me=/^[0-9]+$/;function J(H,X){var Z=me.test(H),de=me.test(X);return Z&&de&&(H=+H,X=+X),Z&&!de?-1:de&&!Z?1:H<X?-1:H>X?1:0}function U(H,X,Z){return new ye(H,Z).compare(new ye(X,Z))}function se(H,X,Z){return U(H,X,Z)>0}function ae(H,X,Z){return U(H,X,Z)<0}function te(H,X,Z){return U(H,X,Z)===0}function ce(H,X,Z){return U(H,X,Z)!==0}function le(H,X,Z){return U(H,X,Z)>=0}function x(H,X,Z){return U(H,X,Z)<=0}function oe(H,X,Z,de){var be;switch(X){case"===":typeof H=="object"&&(H=H.version),typeof Z=="object"&&(Z=Z.version),be=H===Z;break;case"!==":typeof H=="object"&&(H=H.version),typeof Z=="object"&&(Z=Z.version),be=H!==Z;break;case"":case"=":case"==":be=te(H,Z,de);break;case"!=":be=ce(H,Z,de);break;case">":be=se(H,Z,de);break;case">=":be=le(H,Z,de);break;case"<":be=ae(H,Z,de);break;case"<=":be=x(H,Z,de);break;default:throw new TypeError("Invalid operator: "+X)}return be}function pe(H,X){if(H instanceof pe){if(H.loose===X)return H;H=H.value}if(!(this instanceof pe))return new pe(H,X);C("comparator",H,X),this.loose=X,this.parse(H),this.semver===we?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(H,X){return J(X,H)},e.major=function(H,X){return new ye(H,X).major},e.minor=function(H,X){return new ye(H,X).minor},e.patch=function(H,X){return new ye(H,X).patch},e.compare=U,e.compareLoose=function(H,X){return U(H,X,!0)},e.rcompare=function(H,X,Z){return U(X,H,Z)},e.sort=function(H,X){return H.sort(function(Z,de){return e.compare(Z,de,X)})},e.rsort=function(H,X){return H.sort(function(Z,de){return e.rcompare(Z,de,X)})},e.gt=se,e.lt=ae,e.eq=te,e.neq=ce,e.gte=le,e.lte=x,e.cmp=oe,e.Comparator=pe;var we={};function Fe(H,X){if(H instanceof Fe)return H.loose===X?H:new Fe(H.raw,X);if(H instanceof pe)return new Fe(H.value,X);if(!(this instanceof Fe))return new Fe(H,X);if(this.loose=X,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(Z){return this.parseRange(Z.trim())},this).filter(function(Z){return Z.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function ze(H){return!H||H.toLowerCase()==="x"||H==="*"}function Ce(H,X,Z,de,be,Oe,He,Qe,_e,nt,st,rt,at){return((X=ze(Z)?"":ze(de)?">="+Z+".0.0":ze(be)?">="+Z+"."+de+".0":">="+X)+" "+(Qe=ze(_e)?"":ze(nt)?"<"+(+_e+1)+".0.0":ze(st)?"<"+_e+"."+(+nt+1)+".0":rt?"<="+_e+"."+nt+"."+st+"-"+rt:"<="+Qe)).trim()}function Ie(H,X){for(var Z=0;Z<H.length;Z++)if(!H[Z].test(X))return!1;if(X.prerelease.length){for(Z=0;Z<H.length;Z++)if(C(H[Z].semver),H[Z].semver!==we&&H[Z].semver.prerelease.length>0){var de=H[Z].semver;if(de.major===X.major&&de.minor===X.minor&&de.patch===X.patch)return!0}return!1}return!0}function Pe(H,X,Z){try{X=new Fe(X,Z)}catch{return!1}return X.test(H)}function q(H,X,Z,de){var be,Oe,He,Qe,_e;switch(H=new ye(H,de),X=new Fe(X,de),Z){case">":be=se,Oe=x,He=ae,Qe=">",_e=">=";break;case"<":be=ae,Oe=le,He=se,Qe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Pe(H,X,de))return!1;for(var nt=0;nt<X.set.length;++nt){var st=X.set[nt],rt=null,at=null;if(st.forEach(function(mt){mt.semver===we&&(mt=new pe(">=0.0.0")),rt=rt||mt,at=at||mt,be(mt.semver,rt.semver,de)?rt=mt:He(mt.semver,at.semver,de)&&(at=mt)}),rt.operator===Qe||rt.operator===_e||(!at.operator||at.operator===Qe)&&Oe(H,at.semver)||at.operator===_e&&He(H,at.semver))return!1}return!0}pe.prototype.parse=function(H){var X=this.loose?T[V]:T[ne],Z=H.match(X);if(!Z)throw new TypeError("Invalid comparator: "+H);this.operator=Z[1],this.operator==="="&&(this.operator=""),Z[2]?this.semver=new ye(Z[2],this.loose):this.semver=we},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(H){return C("Comparator.test",H,this.loose),this.semver===we||(typeof H=="string"&&(H=new ye(H,this.loose)),oe(H,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(H,X){if(!(H instanceof pe))throw new TypeError("a Comparator is required");var Z;if(this.operator==="")return Z=new Fe(H.value,X),Pe(this.value,Z,X);if(H.operator==="")return Z=new Fe(this.value,X),Pe(H.semver,Z,X);var de=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),Oe=this.semver.version===H.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),Qe=oe(this.semver,"<",H.semver,X)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),_e=oe(this.semver,">",H.semver,X)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return de||be||Oe&&He||Qe||_e},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(H){var X=this.loose;H=H.trim(),C("range",H,X);var Z=X?T[Y]:T[K];H=H.replace(Z,Ce),C("hyphen replace",H),H=H.replace(T[B],"$1$2$3"),C("comparator trim",H,T[B]),H=(H=(H=H.replace(T[F],"$1~")).replace(T[z],"$1^")).split(/\s+/).join(" ");var de=X?T[V]:T[ne],be=H.split(" ").map(function(Oe){return function(He,Qe){return C("comp",He),He=function(_e,nt){return _e.trim().split(/\s+/).map(function(st){return function(rt,at){C("caret",rt,at);var mt=at?T[W]:T[M];return rt.replace(mt,function(ht,ct,ke,Be,Ke){var Ne;return C("caret",rt,ht,ct,ke,Be,Ke),ze(ct)?Ne="":ze(ke)?Ne=">="+ct+".0.0 <"+(+ct+1)+".0.0":ze(Be)?Ne=ct==="0"?">="+ct+"."+ke+".0 <"+ct+"."+(+ke+1)+".0":">="+ct+"."+ke+".0 <"+(+ct+1)+".0.0":Ke?(C("replaceCaret pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Ne=ct==="0"?ke==="0"?">="+ct+"."+ke+"."+Be+Ke+" <"+ct+"."+ke+"."+(+Be+1):">="+ct+"."+ke+"."+Be+Ke+" <"+ct+"."+(+ke+1)+".0":">="+ct+"."+ke+"."+Be+Ke+" <"+(+ct+1)+".0.0"):(C("no pr"),Ne=ct==="0"?ke==="0"?">="+ct+"."+ke+"."+Be+" <"+ct+"."+ke+"."+(+Be+1):">="+ct+"."+ke+"."+Be+" <"+ct+"."+(+ke+1)+".0":">="+ct+"."+ke+"."+Be+" <"+(+ct+1)+".0.0"),C("caret return",Ne),Ne})}(st,nt)}).join(" ")}(He,Qe),C("caret",He),He=function(_e,nt){return _e.trim().split(/\s+/).map(function(st){return function(rt,at){var mt=at?T[O]:T[N];return rt.replace(mt,function(ht,ct,ke,Be,Ke){var Ne;return C("tilde",rt,ht,ct,ke,Be,Ke),ze(ct)?Ne="":ze(ke)?Ne=">="+ct+".0.0 <"+(+ct+1)+".0.0":ze(Be)?Ne=">="+ct+"."+ke+".0 <"+ct+"."+(+ke+1)+".0":Ke?(C("replaceTilde pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Ne=">="+ct+"."+ke+"."+Be+Ke+" <"+ct+"."+(+ke+1)+".0"):Ne=">="+ct+"."+ke+"."+Be+" <"+ct+"."+(+ke+1)+".0",C("tilde return",Ne),Ne})}(st,nt)}).join(" ")}(He,Qe),C("tildes",He),He=function(_e,nt){return C("replaceXRanges",_e,nt),_e.split(/\s+/).map(function(st){return function(rt,at){rt=rt.trim();var mt=at?T[A]:T[k];return rt.replace(mt,function(ht,ct,ke,Be,Ke,Ne){C("xRange",rt,ht,ct,ke,Be,Ke,Ne);var je=ze(ke),he=je||ze(Be),_=he||ze(Ke);return ct==="="&&_&&(ct=""),je?ht=ct===">"||ct==="<"?"<0.0.0":"*":ct&&_?(he&&(Be=0),_&&(Ke=0),ct===">"?(ct=">=",he?(ke=+ke+1,Be=0,Ke=0):_&&(Be=+Be+1,Ke=0)):ct==="<="&&(ct="<",he?ke=+ke+1:Be=+Be+1),ht=ct+ke+"."+Be+"."+Ke):he?ht=">="+ke+".0.0 <"+(+ke+1)+".0.0":_&&(ht=">="+ke+"."+Be+".0 <"+ke+"."+(+Be+1)+".0"),C("xRange return",ht),ht})}(st,nt)}).join(" ")}(He,Qe),C("xrange",He),He=function(_e,nt){return C("replaceStars",_e,nt),_e.trim().replace(T[ee],"")}(He,Qe),C("stars",He),He}(Oe,X)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(Oe){return!!Oe.match(de)})),be=be.map(function(Oe){return new pe(Oe,X)})},Fe.prototype.intersects=function(H,X){if(!(H instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(Z){return Z.every(function(de){return H.set.some(function(be){return be.every(function(Oe){return de.intersects(Oe,X)})})})})},e.toComparators=function(H,X){return new Fe(H,X).set.map(function(Z){return Z.map(function(de){return de.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new ye(H,this.loose));for(var X=0;X<this.set.length;X++)if(Ie(this.set[X],H))return!0;return!1},e.satisfies=Pe,e.maxSatisfying=function(H,X,Z){var de=null,be=null;try{var Oe=new Fe(X,Z)}catch{return null}return H.forEach(function(He){Oe.test(He)&&(de&&be.compare(He)!==-1||(be=new ye(de=He,Z)))}),de},e.minSatisfying=function(H,X,Z){var de=null,be=null;try{var Oe=new Fe(X,Z)}catch{return null}return H.forEach(function(He){Oe.test(He)&&(de&&be.compare(He)!==1||(be=new ye(de=He,Z)))}),de},e.validRange=function(H,X){try{return new Fe(H,X).range||"*"}catch{return null}},e.ltr=function(H,X,Z){return q(H,X,"<",Z)},e.gtr=function(H,X,Z){return q(H,X,">",Z)},e.outside=q,e.prerelease=function(H,X){var Z=re(H,X);return Z&&Z.prerelease.length?Z.prerelease:null},e.intersects=function(H,X,Z){return H=new Fe(H,Z),X=new Fe(X,Z),H.intersects(X)},e.coerce=function(H){if(H instanceof ye)return H;if(typeof H!="string")return null;var X=H.match(T[p]);return X==null?null:re((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,r(1))},function($e,e){var r,h,C=$e.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function T(m){if(r===setTimeout)return setTimeout(m,0);if((r===R||!r)&&setTimeout)return r=setTimeout,setTimeout(m,0);try{return r(m,0)}catch{try{return r.call(null,m,0)}catch{return r.call(this,m,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:R}catch{r=R}try{h=typeof clearTimeout=="function"?clearTimeout:L}catch{h=L}})();var b,c=[],I=!1,S=-1;function u(){I&&b&&(I=!1,b.length?c=b.concat(c):S=-1,c.length&&P())}function P(){if(!I){var m=T(u);I=!0;for(var $=c.length;$;){for(b=c,c=[];++S<$;)b&&b[S].run();S=-1,$=c.length}b=null,I=!1,function(f){if(h===clearTimeout)return clearTimeout(f);if((h===L||!h)&&clearTimeout)return h=clearTimeout,clearTimeout(f);try{h(f)}catch{try{return h.call(null,f)}catch{return h.call(this,f)}}}(m)}}function w(m,$){this.fun=m,this.array=$}function a(){}C.nextTick=function(m){var $=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)$[f-1]=arguments[f];c.push(new w(m,$)),c.length!==1||I||T(P)},w.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=a,C.addListener=a,C.once=a,C.off=a,C.removeListener=a,C.removeAllListeners=a,C.emit=a,C.prependListener=a,C.prependOnceListener=a,C.listeners=function(m){return[]},C.binding=function(m){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(m){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Se[42],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class h{static create(R){return new h(R)}constructor(R){this.c=r&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$de=h}),define(Se[4],De([1,0,13,79,3,80,42]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$fe=e.Event=void 0,e.$ge=P;const T=!1,b=!1,c=!1;var I;(function(O){O.None=()=>C.$Tc.None;function j(Ie){if(c){const{onDidAddListener:Pe}=Ie,q=a.create();let H=0;Ie.onDidAddListener=()=>{++H===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),q.print()),Pe?.()}}}function z(Ie,Pe){return re(Ie,()=>{},0,void 0,!0,void 0,Pe)}O.defer=z;function M(Ie){return(Pe,q=null,H)=>{let X=!1,Z;return Z=Ie(de=>{if(!X)return Z?Z.dispose():X=!0,Pe.call(q,de)},null,H),X&&Z.dispose(),Z}}O.once=M;function W(Ie,Pe,q){return ee((H,X=null,Z)=>Ie(de=>H.call(X,Pe(de)),null,Z),q)}O.map=W;function V(Ie,Pe,q){return ee((H,X=null,Z)=>Ie(de=>{Pe(de),H.call(X,de)},null,Z),q)}O.forEach=V;function ne(Ie,Pe,q){return ee((H,X=null,Z)=>Ie(de=>Pe(de)&&H.call(X,de),null,Z),q)}O.filter=ne;function B(Ie){return Ie}O.signal=B;function K(...Ie){return(Pe,q=null,H)=>{const X=(0,C.$Qc)(...Ie.map(Z=>Z(de=>Pe.call(q,de))));return ue(X,H)}}O.any=K;function Y(Ie,Pe,q,H){let X=q;return W(Ie,Z=>(X=Pe(X,Z),X),H)}O.reduce=Y;function ee(Ie,Pe){let q;const H={onWillAddFirstListener(){q=Ie(X.fire,X)},onDidRemoveLastListener(){q?.dispose()}};Pe||j(H);const X=new n(H);return Pe?.add(X),X.event}function ue(Ie,Pe){return Pe instanceof Array?Pe.push(Ie):Pe&&Pe.add(Ie),Ie}function re(Ie,Pe,q=100,H=!1,X=!1,Z,de){let be,Oe,He,Qe=0,_e;const nt={leakWarningThreshold:Z,onWillAddFirstListener(){be=Ie(rt=>{Qe++,Oe=Pe(Oe,rt),H&&!He&&(st.fire(Oe),Oe=void 0),_e=()=>{const at=Oe;Oe=void 0,He=void 0,(!H||Qe>1)&&st.fire(at),Qe=0},typeof q=="number"?(clearTimeout(He),He=setTimeout(_e,q)):He===void 0&&(He=0,queueMicrotask(_e))})},onWillRemoveListener(){X&&Qe>0&&_e?.()},onDidRemoveLastListener(){_e=void 0,be.dispose()}};de||j(nt);const st=new n(nt);return de?.add(st),st.event}O.debounce=re;function ye(Ie,Pe=0,q){return O.debounce(Ie,(H,X)=>H?(H.push(X),H):[X],Pe,void 0,!0,void 0,q)}O.accumulate=ye;function me(Ie,Pe=(H,X)=>H===X,q){let H=!0,X;return ne(Ie,Z=>{const de=H||!Pe(Z,X);return H=!1,X=Z,de},q)}O.latch=me;function J(Ie,Pe,q){return[O.filter(Ie,Pe,q),O.filter(Ie,H=>!Pe(H),q)]}O.split=J;function U(Ie,Pe=!1,q=[],H){let X=q.slice(),Z=Ie(Oe=>{X?X.push(Oe):be.fire(Oe)});H&&H.add(Z);const de=()=>{X?.forEach(Oe=>be.fire(Oe)),X=null},be=new n({onWillAddFirstListener(){Z||(Z=Ie(Oe=>be.fire(Oe)),H&&H.add(Z))},onDidAddFirstListener(){X&&(Pe?setTimeout(de):de())},onDidRemoveLastListener(){Z&&Z.dispose(),Z=null}});return H&&H.add(be),be.event}O.buffer=U;function se(Ie,Pe){return(H,X,Z)=>{const de=Pe(new te);return Ie(function(be){const Oe=de.evaluate(be);Oe!==ae&&H.call(X,Oe)},void 0,Z)}}O.chain=se;const ae=Symbol("HaltChainable");class te{constructor(){this.f=[]}map(Pe){return this.f.push(Pe),this}forEach(Pe){return this.f.push(q=>(Pe(q),q)),this}filter(Pe){return this.f.push(q=>Pe(q)?q:ae),this}reduce(Pe,q){let H=q;return this.f.push(X=>(H=Pe(H,X),H)),this}latch(Pe=(q,H)=>q===H){let q=!0,H;return this.f.push(X=>{const Z=q||!Pe(X,H);return q=!1,H=X,Z?X:ae}),this}evaluate(Pe){for(const q of this.f)if(Pe=q(Pe),Pe===ae)break;return Pe}}function ce(Ie,Pe,q=H=>H){const H=(...be)=>de.fire(q(...be)),X=()=>Ie.on(Pe,H),Z=()=>Ie.removeListener(Pe,H),de=new n({onWillAddFirstListener:X,onDidRemoveLastListener:Z});return de.event}O.fromNodeEventEmitter=ce;function le(Ie,Pe,q=H=>H){const H=(...be)=>de.fire(q(...be)),X=()=>Ie.addEventListener(Pe,H),Z=()=>Ie.removeEventListener(Pe,H),de=new n({onWillAddFirstListener:X,onDidRemoveLastListener:Z});return de.event}O.fromDOMEventEmitter=le;function x(Ie){return new Promise(Pe=>M(Ie)(Pe))}O.toPromise=x;function oe(Ie){const Pe=new n;return Ie.then(q=>{Pe.fire(q)},()=>{Pe.fire(void 0)}).finally(()=>{Pe.dispose()}),Pe.event}O.fromPromise=oe;function pe(Ie,Pe){return Ie(q=>Pe.fire(q))}O.forward=pe;function we(Ie,Pe,q){return Pe(q),Ie(H=>Pe(H))}O.runAndSubscribe=we;class Fe{constructor(Pe,q){this._observable=Pe,this.f=0,this.g=!1;const H={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};q||j(H),this.emitter=new n(H),q&&q.add(this.emitter)}beginUpdate(Pe){this.f++}handlePossibleChange(Pe){}handleChange(Pe,q){this.g=!0}endUpdate(Pe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ze(Ie,Pe){return new Fe(Ie,Pe).emitter.event}O.fromObservable=ze;function Ce(Ie){return(Pe,q,H)=>{let X=0,Z=!1;const de={beginUpdate(){X++},endUpdate(){X--,X===0&&(Ie.reportChanges(),Z&&(Z=!1,Pe.call(q)))},handlePossibleChange(){},handleChange(){Z=!0}};Ie.addObserver(de),Ie.reportChanges();const be={dispose(){Ie.removeObserver(de)}};return H instanceof C.$Sc?H.add(be):Array.isArray(H)&&H.push(be),be}}O.fromObservableLight=Ce})(I||(e.Event=I={}));class S{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${S.f++}`,S.all.add(this)}start(j){this.g=new L.$de,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$fe=S;let u=-1;function P(O){const j=u;return u=O,{dispose(){u=j}}}class w{static{this.f=1}constructor(j,z,M=(w.f++).toString(16).padStart(3,"0")){this.j=j,this.threshold=z,this.name=M,this.h=0}dispose(){this.g?.clear()}check(j,z){const M=this.threshold;if(M<=0||z<M)return;this.g||(this.g=new Map);const W=this.g.get(j.value)||0;if(this.g.set(j.value,W+1),this.h-=1,this.h<=0){this.h=M*.5;const[V,ne]=this.getMostFrequentStack(),B=`[${this.name}] potential listener LEAK detected, having ${z} listeners already. MOST frequent listener (${ne}):`;console.warn(B),console.warn(V);const K=new m(B,V);this.j(K)}return()=>{const V=this.g.get(j.value)||0;this.g.set(j.value,V-1)}}getMostFrequentStack(){if(!this.g)return;let j,z=0;for(const[M,W]of this.g)(!j||z<W)&&(j=[M,W],z=W);return j}}class a{static create(){const j=new Error;return new a(j.stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(j,z){super(j),this.name="ListenerLeakError",this.stack=z}}e.$he=m;class $ extends Error{constructor(j,z){super(j),this.name="ListenerRefusalError",this.stack=z}}e.$ie=$;let f=0;class i{constructor(j){this.value=j,this.id=f++}}const s=2,t=(O,j)=>{if(O instanceof i)j(O);else for(let z=0;z<O.length;z++){const M=O[z];M&&j(M)}};let o;if(T){const O=[];setInterval(()=>{O.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(O.join(`
`)),O.length=0)},3e3),o=new FinalizationRegistry(j=>{typeof j=="string"&&O.push(j)})}class n{constructor(j){this.z=0,this.f=j,this.g=u>0||this.f?.leakWarningThreshold?new w(j?.onListenerError??r.$Y,this.f?.leakWarningThreshold??u):void 0,this.j=this.f?._profName?new S(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(b){const j=this.u;queueMicrotask(()=>{t(j,z=>z.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,z,M)=>{if(this.g&&this.z>this.g.threshold**2){const K=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(K);const Y=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new $(`${K}. HINT: Stack shows most frequent listener (${Y[1]}-times)`,Y[0]);return(this.f?.onListenerError||r.$Y)(ee),C.$Tc.None}if(this.m)return C.$Tc.None;z&&(j=j.bind(z));const W=new i(j);let V,ne;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(W.stack=a.create(),V=this.g.check(W.stack,this.z+1)),b&&(W.stack=ne??a.create()),this.u?this.u instanceof i?(this.w??=new l,this.u=[this.u,W]):this.u.push(W):(this.f?.onWillAddFirstListener?.(this),this.u=W,this.f?.onDidAddFirstListener?.(this)),this.z++;const B=(0,C.$Rc)(()=>{o?.unregister(B),V?.(),this.A(W)});if(M instanceof C.$Sc?M.add(B):Array.isArray(M)&&M.push(B),o){const K=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),Y=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(K);o.register(B,Y?.[2]??K,B)}return B},this.q}A(j){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const z=this.u,M=z.indexOf(j);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,z[M]=void 0;const W=this.w.current===this;if(this.z*s<=z.length){let V=0;for(let ne=0;ne<z.length;ne++)z[ne]?z[V++]=z[ne]:W&&(this.w.end--,V<this.w.i&&this.w.i--);z.length=V}}B(j,z){if(!j)return;const M=this.f?.onListenerError||r.$Y;if(!M){j.value(z);return}try{j.value(z)}catch(W){M(W)}}C(j){const z=j.current.u;for(;j.i<j.end;)this.B(z[j.i++],j.value);j.reset()}fire(j){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof i)this.B(this.u,j);else{const z=this.w;z.enqueue(this,j,this.u.length),this.C(z)}this.j?.stop()}hasListeners(){return this.z>0}}e.$je=n;const d=()=>new l;e.$ke=d;class l{constructor(){this.i=-1,this.end=0}enqueue(j,z,M){this.i=0,this.end=M,this.current=j,this.value=z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class g extends n{async fireAsync(j,z,M){if(this.u)for(this.h||(this.h=new R.$4c),t(this.u,W=>this.h.push([W.value,j]));this.h.size>0&&!z.isCancellationRequested;){const[W,V]=this.h.shift(),ne=[],B={...V,token:z,waitUntil:K=>{if(Object.isFrozen(ne))throw new Error("waitUntil can NOT be called asynchronous");M&&(K=M(K,W)),ne.push(K)}};try{W(B)}catch(K){(0,r.$Y)(K);continue}Object.freeze(ne),await Promise.allSettled(ne).then(K=>{for(const Y of K)Y.status==="rejected"&&(0,r.$Y)(Y.reason)})}}}e.$le=g;class E extends n{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new R.$4c,this.t=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.t(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.z&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$me=E;class D extends E{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$ne=D;class y extends n{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(z=>super.fire(z)),this.h=[]}))}}e.$oe=y;class k{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const z={event:j,listener:null};this.h.push(z),this.g&&this.m(z);const M=()=>{this.g&&this.o(z);const W=this.h.indexOf(z);this.h.splice(W,1)};return(0,C.$Rc)((0,h.$cb)(M))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(z=>this.f.fire(z))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$pe=k;class A{constructor(j,z,M,W){this.f=new C.$Sc;const V=this.f.add(new k),ne=this.f.add(new C.$3c);function B(K){ne.set(K,V.add(W(K)))}for(const K of j)B(K);this.f.add(z(K=>{B(K)})),this.f.add(M(K=>{ne.deleteAndDispose(K)})),this.event=V.event}dispose(){this.f.dispose()}}e.$qe=A;class p{constructor(){this.f=[]}wrapEvent(j,z,M){return(W,V,ne)=>j(B=>{const K=this.f[this.f.length-1];if(!z){K?K.buffers.push(()=>W.call(V,B)):W.call(V,B);return}const Y=K;if(!Y){W.call(V,z(M,B));return}Y.items??=[],Y.items.push(B),Y.buffers.length===0&&K.buffers.push(()=>{Y.reducedResult??=M?Y.items.reduce(z,M):Y.items.reduce(z),W.call(V,Y.reducedResult)})},void 0,ne)}bufferEvents(j){const z={buffers:new Array};this.f.push(z);const M=j();return this.f.pop(),z.buffers.forEach(W=>W()),M}}e.$re=p;class v{constructor(){this.f=!1,this.g=I.None,this.h=C.$Tc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$se=v;class F{static const(j){return new N(j)}constructor(j){this.g=j,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$te=F;class N{constructor(j){this.value=j,this.onDidChange=I.None}}}),define(Se[20],De([1,0,4]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.CancellationToken=void 0,e.$ve=T;const h=Object.freeze(function(b,c){const I=setTimeout(b.bind(c),0);return{dispose(){clearTimeout(I)}}});var C;(function(b){function c(I){return I===b.None||I===b.Cancelled||I instanceof R?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}b.isCancellationToken=c,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:h})})(C||(e.CancellationToken=C={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?h:(this.b||(this.b=new r.$je),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=C.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=C.None}}e.$ue=L;function T(b){const c=new L;return b.add({dispose(){c.cancel()}}),c.token}}),define(Se[184],De([1,0,20]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0e=e.$9e=e.$7e=void 0,e.$8e=C;class h{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new r.$ue,c=this.b(b.token);return this.a={promise:c,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$7e=h;function C(T){return T}class R{constructor(b,c){this.a=void 0,this.b=void 0,typeof b=="function"?(this.c=b,this.d=C):(this.c=c,this.d=b.getCacheKey)}get(b){const c=this.d(b);return this.b!==c&&(this.b=c,this.a=this.c(b)),this.a}}e.$9e=R;class L{get cachedValues(){return this.a}constructor(b,c){this.a=new Map,this.b=new Map,typeof b=="function"?(this.c=b,this.d=C):(this.c=c,this.d=b.getCacheKey)}get(b){const c=this.d(b);if(this.b.has(c))return this.b.get(c);const I=this.c(b);return this.a.set(b,I),this.b.set(c,I),I}}e.$0e=L}),define(Se[185],De([1,0,4,3]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.$ct=e.$bt=e.$at=e.ScrollbarVisibility=void 0;var C;(function(P){P[P.Auto=1]="Auto",P[P.Hidden=2]="Hidden",P[P.Visible=3]="Visible"})(C||(e.ScrollbarVisibility=C={}));class R{constructor(w,a,m,$,f,i,s){this.c=w,this._scrollStateBrand=void 0,this.c&&(a=a|0,m=m|0,$=$|0,f=f|0,i=i|0,s=s|0),this.rawScrollLeft=$,this.rawScrollTop=s,a<0&&(a=0),$+a>m&&($=m-a),$<0&&($=0),f<0&&(f=0),s+f>i&&(s=i-f),s<0&&(s=0),this.width=a,this.scrollWidth=m,this.scrollLeft=$,this.height=f,this.scrollHeight=i,this.scrollTop=s}equals(w){return this.rawScrollLeft===w.rawScrollLeft&&this.rawScrollTop===w.rawScrollTop&&this.width===w.width&&this.scrollWidth===w.scrollWidth&&this.scrollLeft===w.scrollLeft&&this.height===w.height&&this.scrollHeight===w.scrollHeight&&this.scrollTop===w.scrollTop}withScrollDimensions(w,a){return new R(this.c,typeof w.width<"u"?w.width:this.width,typeof w.scrollWidth<"u"?w.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof w.height<"u"?w.height:this.height,typeof w.scrollHeight<"u"?w.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(w){return new R(this.c,this.width,this.scrollWidth,typeof w.scrollLeft<"u"?w.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof w.scrollTop<"u"?w.scrollTop:this.rawScrollTop)}createScrollEvent(w,a){const m=this.width!==w.width,$=this.scrollWidth!==w.scrollWidth,f=this.scrollLeft!==w.scrollLeft,i=this.height!==w.height,s=this.scrollHeight!==w.scrollHeight,t=this.scrollTop!==w.scrollTop;return{inSmoothScrolling:a,oldWidth:w.width,oldScrollWidth:w.scrollWidth,oldScrollLeft:w.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:w.height,oldScrollHeight:w.scrollHeight,oldScrollTop:w.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:$,scrollLeftChanged:f,heightChanged:i,scrollHeightChanged:s,scrollTopChanged:t}}}e.$at=R;class L extends h.$Tc{constructor(w){super(),this._scrollableBrand=void 0,this.j=this.B(new r.$je),this.onScroll=this.j.event,this.c=w.smoothScrollDuration,this.f=w.scheduleAtNextAnimationFrame,this.g=new R(w.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(w){this.c=w}validateScrollPosition(w){return this.g.withScrollPosition(w)}getScrollDimensions(){return this.g}setScrollDimensions(w,a){const m=this.g.withScrollDimensions(w,a);this.n(m,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(w){const a=this.g.withScrollPosition(w);this.h&&(this.h.dispose(),this.h=null),this.n(a,!1)}setScrollPositionSmooth(w,a){if(this.c===0)return this.setScrollPositionNow(w);if(this.h){w={scrollLeft:typeof w.scrollLeft>"u"?this.h.to.scrollLeft:w.scrollLeft,scrollTop:typeof w.scrollTop>"u"?this.h.to.scrollTop:w.scrollTop};const m=this.g.withScrollPosition(w);if(this.h.to.scrollLeft===m.scrollLeft&&this.h.to.scrollTop===m.scrollTop)return;let $;a?$=new I(this.h.from,m,this.h.startTime,this.h.duration):$=this.h.combine(this.g,m,this.c),this.h.dispose(),this.h=$}else{const m=this.g.withScrollPosition(w);this.h=I.start(this.g,m,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const w=this.h.tick(),a=this.g.withScrollPosition(w);if(this.n(a,!0),!!this.h){if(w.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(w,a){const m=this.g;m.equals(w)||(this.g=w,this.j.fire(this.g.createScrollEvent(m,a)))}}e.$bt=L;class T{constructor(w,a,m){this.scrollLeft=w,this.scrollTop=a,this.isDone=m}}e.$ct=T;function b(P,w){const a=w-P;return function(m){return P+a*u(m)}}function c(P,w,a){return function(m){return m<a?P(m/a):w((m-a)/(1-a))}}class I{constructor(w,a,m,$){this.from=w,this.to=a,this.duration=$,this.startTime=m,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(w,a,m){if(Math.abs(w-a)>2.5*m){let f,i;return w<a?(f=w+.75*m,i=a-.75*m):(f=w-.75*m,i=a+.75*m),c(b(w,f),b(i,a),.33)}return b(w,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(w){this.to=w.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(w){const a=(w-this.startTime)/this.duration;if(a<1){const m=this.c(a),$=this.d(a);return new T(m,$,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(w,a,m){return I.start(w,a,m)}static start(w,a,m){m=m+10;const $=Date.now()-10;return new I(w,a,$,m)}}e.$dt=I;function S(P){return Math.pow(P,3)}function u(P){return 1-S(1-P)}}),define(Se[105],De([1,0,13,3]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=C,e.$xe=R,e.$ye=L,e.$ze=T,e.$Ae=c,e.$Be=I,e.$Ce=S,e.$De=u,e.$Ee=P,e.$Fe=w,e.$Ge=a,e.$He=m,e.$Ie=$,e.$Je=f,e.$Ke=i;function C(s){const t=s;return t?typeof t.read=="function":!1}function R(s){const t=s;return t?[t.on,t.pause,t.resume,t.destroy].every(o=>typeof o=="function"):!1}function L(s){const t=s;return t?R(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function T(s,t){return new b(s,t)}class b{constructor(t,o){this.e=t,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(o=>o(t))}h(t){this.c.error.length===0?(0,r.$Y)(t):this.c.error.slice(0).forEach(o=>o(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,o){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(t,o){if(this.a.destroyed)return;let n;switch(t){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const d=n.indexOf(o);d>=0&&n.splice(d,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(s,t){const o=[];let n;for(;(n=s.read())!==null;)o.push(n);return t(o)}function I(s,t,o){const n=[];let d;for(;(d=s.read())!==null&&n.length<o;)n.push(d);return d===null&&n.length>0?t(n):{read:()=>{if(n.length>0)return n.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return s.read()}}}function S(s,t){return new Promise((o,n)=>{const d=[];u(s,{onData:l=>{t&&d.push(l)},onError:l=>{t?n(l):o(void 0)},onEnd:()=>{o(t?t(d):void 0)}})})}function u(s,t,o){s.on("error",n=>{o?.isCancellationRequested||t.onError(n)}),s.on("end",()=>{o?.isCancellationRequested||t.onEnd()}),s.on("data",n=>{o?.isCancellationRequested||t.onData(n)})}function P(s,t){return new Promise((o,n)=>{const d=new h.$Sc,l=[],g=y=>{if(l.push(y),l.length>t)return d.dispose(),s.pause(),o({stream:s,buffer:l,ended:!1})},E=y=>(d.dispose(),n(y)),D=()=>(d.dispose(),o({stream:s,buffer:l,ended:!0}));d.add((0,h.$Rc)(()=>s.removeListener("error",E))),s.on("error",E),d.add((0,h.$Rc)(()=>s.removeListener("end",D))),s.on("end",D),d.add((0,h.$Rc)(()=>s.removeListener("data",g))),s.on("data",g)})}function w(s,t){const o=T(t);return o.end(s),o}function a(){const s=T(()=>{throw new Error("not supported")});return s.end(),s}function m(s){let t=!1;return{read:()=>t?null:(t=!0,s)}}function $(s,t,o){const n=T(o);return u(s,{onData:d=>n.write(t.data(d)),onError:d=>n.error(t.error?t.error(d):d),onEnd:()=>n.end()}),n}function f(s,t,o){let n=!1;return{read:()=>{const d=t.read();return n?d:(n=!0,d!==null?o([s,d]):s)}}}function i(s,t,o){let n=!1;const d=T(o);return u(t,{onData:l=>n?d.write(l):(n=!0,d.write(o([s,l]))),onError:l=>d.error(l),onEnd:()=>{n||(n=!0,d.write(s)),d.end()}}),d}}),define(Se[21],De([1,0,49,105]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=c,e.$Ne=I,e.$Oe=S,e.$Pe=u,e.$Qe=P,e.$Re=w,e.$Se=a,e.$Te=m,e.$Ue=$,e.$Ve=f,e.$We=i,e.$Xe=s,e.$Ye=t,e.$Ze=o,e.$1e=n,e.$2e=d,e.$3e=l,e.$4e=g,e.$5e=E,e.$6e=k,h=Ue(h);const C=typeof Buffer<"u",R=new r.$T(()=>new Uint8Array(256));let L,T;class b{static alloc(p){return C?new b(Buffer.allocUnsafe(p)):new b(new Uint8Array(p))}static wrap(p){return C&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new b(p)}static fromString(p,v){return!(v?.dontUseNodeBuffer||!1)&&C?new b(Buffer.from(p)):(L||(L=new TextEncoder),new b(L.encode(p)))}static fromByteArray(p){const v=b.alloc(p.length);for(let F=0,N=p.length;F<N;F++)v.buffer[F]=p[F];return v}static concat(p,v){if(typeof v>"u"){v=0;for(let O=0,j=p.length;O<j;O++)v+=p[O].byteLength}const F=b.alloc(v);let N=0;for(let O=0,j=p.length;O<j;O++){const z=p[O];F.set(z,N),N+=z.byteLength}return F}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=b.alloc(this.byteLength);return p.set(this),p}toString(){return C?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(p,v){return new b(this.buffer.subarray(p,v))}set(p,v){if(p instanceof b)this.buffer.set(p.buffer,v);else if(p instanceof Uint8Array)this.buffer.set(p,v);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),v);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return u(this.buffer,p)}writeUInt32BE(p,v){P(this.buffer,p,v)}readUInt32LE(p){return w(this.buffer,p)}writeUInt32LE(p,v){a(this.buffer,p,v)}readUInt8(p){return m(this.buffer,p)}writeUInt8(p,v){$(this.buffer,p,v)}indexOf(p,v=0){return c(this.buffer,p instanceof b?p.buffer:p,v)}}e.$Le=b;function c(A,p,v=0){const F=p.byteLength,N=A.byteLength;if(F===0)return 0;if(F===1)return A.indexOf(p[0]);if(F>N-v)return-1;const O=R.value;O.fill(p.length);for(let W=0;W<p.length;W++)O[p[W]]=p.length-W-1;let j=v+p.length-1,z=j,M=-1;for(;j<N;)if(A[j]===p[z]){if(z===0){M=j;break}j--,z--}else j+=Math.max(p.length-z,O[A[j]]),z=p.length-1;return M}function I(A,p){return A[p+0]<<0>>>0|A[p+1]<<8>>>0}function S(A,p,v){A[v+0]=p&255,p=p>>>8,A[v+1]=p&255}function u(A,p){return A[p]*2**24+A[p+1]*2**16+A[p+2]*2**8+A[p+3]}function P(A,p,v){A[v+3]=p,p=p>>>8,A[v+2]=p,p=p>>>8,A[v+1]=p,p=p>>>8,A[v]=p}function w(A,p){return A[p+0]<<0>>>0|A[p+1]<<8>>>0|A[p+2]<<16>>>0|A[p+3]<<24>>>0}function a(A,p,v){A[v+0]=p&255,p=p>>>8,A[v+1]=p&255,p=p>>>8,A[v+2]=p&255,p=p>>>8,A[v+3]=p&255}function m(A,p){return A[p]}function $(A,p,v){A[v]=p}function f(A){return h.$Ae(A,p=>b.concat(p))}function i(A){return h.$He(A)}function s(A){return h.$Ce(A,p=>b.concat(p))}async function t(A){return A.ended?b.concat(A.buffer):b.concat([...A.buffer,await s(A.stream)])}function o(A){return h.$Fe(A,p=>b.concat(p))}function n(A){return h.$Ie(A,{data:p=>typeof p=="string"?b.fromString(p):b.wrap(p)},p=>b.concat(p))}function d(A){return h.$ze(p=>b.concat(p),A)}function l(A,p){return h.$Je(A,p,v=>b.concat(v))}function g(A,p){return h.$Ke(A,p,v=>b.concat(v))}function E(A){let p=0,v=0,F=0;const N=new Uint8Array(Math.floor(A.length/4*3)),O=z=>{switch(v){case 3:N[F++]=p|z,v=0;break;case 2:N[F++]=p|z>>>2,p=z<<6,v=3;break;case 1:N[F++]=p|z>>>4,p=z<<4,v=2;break;default:p=z<<2,v=1}};for(let z=0;z<A.length;z++){const M=A.charCodeAt(z);if(M>=65&&M<=90)O(M-65);else if(M>=97&&M<=122)O(M-97+26);else if(M>=48&&M<=57)O(M-48+52);else if(M===43||M===45)O(62);else if(M===47||M===95)O(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${A[z]}`)}}const j=F;for(;v>0;)O(0);return b.wrap(N).slice(0,j)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:A},p=!0,v=!1){const F=v?y:D;let N="";const O=A.byteLength%3;let j=0;for(;j<A.byteLength-O;j+=3){const z=A[j+0],M=A[j+1],W=A[j+2];N+=F[z>>>2],N+=F[(z<<4|M>>>4)&63],N+=F[(M<<2|W>>>6)&63],N+=F[W&63]}if(O===1){const z=A[j+0];N+=F[z>>>2],N+=F[z<<4&63],p&&(N+="==")}else if(O===2){const z=A[j+0],M=A[j+1];N+=F[z>>>2],N+=F[(z<<4|M>>>4)&63],N+=F[M<<2&63],p&&(N+="=")}return N}}),define(Se[186],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0,e.$ee=Symbol("MicrotaskDelay")}),define(Se[17],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=r,e.$dg=h,e.$eg=C,e.$fg=R,e.$gg=L,e.$hg=T,e.$ig=b,e.$jg=c,e.$kg=I,e.$lg=S,e.$mg=u,e.$ng=P,e.$og=w,e.$pg=m,e.$qg=$,e.$rg=f,e.$sg=i,e.$tg=s;function r(t){return typeof t=="string"}function h(t){return Array.isArray(t)&&t.every(o=>r(o))}function C(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function R(t){const o=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof o}function L(t){return typeof t=="number"&&!isNaN(t)}function T(t){return!!t&&typeof t[Symbol.iterator]=="function"}function b(t){return t===!0||t===!1}function c(t){return typeof t>"u"}function I(t){return!S(t)}function S(t){return c(t)||t===null}function u(t,o){if(!t)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}function P(t){if(S(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function w(...t){const o=[];for(let n=0;n<t.length;n++){const d=t[n];if(S(d))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);o.push(d)}return o}const a=Object.prototype.hasOwnProperty;function m(t){if(!C(t))return!1;for(const o in t)if(a.call(t,o))return!1;return!0}function $(t){return typeof t=="function"}function f(...t){return t.length>0&&t.every($)}function i(t,o){const n=Math.min(t.length,o.length);for(let d=0;d<n;d++)s(t[d],o[d])}function s(t,o){if(r(o)){if(typeof t!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if($(o)){try{if(t instanceof o)return}catch{}if(!S(t)&&t.constructor===o||o.length===1&&o.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Se[106],De([1,0,17]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=C,e.$Xj=R;const h=Object.create(null);function C(L,T){if((0,r.$cg)(T)){const b=h[T];if(b===void 0)throw new Error(`${L} references an unknown codicon: ${T}`);T=b}return h[L]=T,{id:L}}function R(){return h}}),define(Se[187],De([1,0,106]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=void 0,e.$Yj={add:(0,r.$Wj)("add",6e4),plus:(0,r.$Wj)("plus",6e4),gistNew:(0,r.$Wj)("gist-new",6e4),repoCreate:(0,r.$Wj)("repo-create",6e4),lightbulb:(0,r.$Wj)("lightbulb",60001),lightBulb:(0,r.$Wj)("light-bulb",60001),repo:(0,r.$Wj)("repo",60002),repoDelete:(0,r.$Wj)("repo-delete",60002),gistFork:(0,r.$Wj)("gist-fork",60003),repoForked:(0,r.$Wj)("repo-forked",60003),gitPullRequest:(0,r.$Wj)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.$Wj)("git-pull-request-abandoned",60004),recordKeys:(0,r.$Wj)("record-keys",60005),keyboard:(0,r.$Wj)("keyboard",60005),tag:(0,r.$Wj)("tag",60006),gitPullRequestLabel:(0,r.$Wj)("git-pull-request-label",60006),tagAdd:(0,r.$Wj)("tag-add",60006),tagRemove:(0,r.$Wj)("tag-remove",60006),person:(0,r.$Wj)("person",60007),personFollow:(0,r.$Wj)("person-follow",60007),personOutline:(0,r.$Wj)("person-outline",60007),personFilled:(0,r.$Wj)("person-filled",60007),gitBranch:(0,r.$Wj)("git-branch",60008),gitBranchCreate:(0,r.$Wj)("git-branch-create",60008),gitBranchDelete:(0,r.$Wj)("git-branch-delete",60008),sourceControl:(0,r.$Wj)("source-control",60008),mirror:(0,r.$Wj)("mirror",60009),mirrorPublic:(0,r.$Wj)("mirror-public",60009),star:(0,r.$Wj)("star",60010),starAdd:(0,r.$Wj)("star-add",60010),starDelete:(0,r.$Wj)("star-delete",60010),starEmpty:(0,r.$Wj)("star-empty",60010),comment:(0,r.$Wj)("comment",60011),commentAdd:(0,r.$Wj)("comment-add",60011),alert:(0,r.$Wj)("alert",60012),warning:(0,r.$Wj)("warning",60012),search:(0,r.$Wj)("search",60013),searchSave:(0,r.$Wj)("search-save",60013),logOut:(0,r.$Wj)("log-out",60014),signOut:(0,r.$Wj)("sign-out",60014),logIn:(0,r.$Wj)("log-in",60015),signIn:(0,r.$Wj)("sign-in",60015),eye:(0,r.$Wj)("eye",60016),eyeUnwatch:(0,r.$Wj)("eye-unwatch",60016),eyeWatch:(0,r.$Wj)("eye-watch",60016),circleFilled:(0,r.$Wj)("circle-filled",60017),primitiveDot:(0,r.$Wj)("primitive-dot",60017),closeDirty:(0,r.$Wj)("close-dirty",60017),debugBreakpoint:(0,r.$Wj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.$Wj)("debug-breakpoint-disabled",60017),debugHint:(0,r.$Wj)("debug-hint",60017),terminalDecorationSuccess:(0,r.$Wj)("terminal-decoration-success",60017),primitiveSquare:(0,r.$Wj)("primitive-square",60018),edit:(0,r.$Wj)("edit",60019),pencil:(0,r.$Wj)("pencil",60019),info:(0,r.$Wj)("info",60020),issueOpened:(0,r.$Wj)("issue-opened",60020),gistPrivate:(0,r.$Wj)("gist-private",60021),gitForkPrivate:(0,r.$Wj)("git-fork-private",60021),lock:(0,r.$Wj)("lock",60021),mirrorPrivate:(0,r.$Wj)("mirror-private",60021),close:(0,r.$Wj)("close",60022),removeClose:(0,r.$Wj)("remove-close",60022),x:(0,r.$Wj)("x",60022),repoSync:(0,r.$Wj)("repo-sync",60023),sync:(0,r.$Wj)("sync",60023),clone:(0,r.$Wj)("clone",60024),desktopDownload:(0,r.$Wj)("desktop-download",60024),beaker:(0,r.$Wj)("beaker",60025),microscope:(0,r.$Wj)("microscope",60025),vm:(0,r.$Wj)("vm",60026),deviceDesktop:(0,r.$Wj)("device-desktop",60026),file:(0,r.$Wj)("file",60027),fileText:(0,r.$Wj)("file-text",60027),more:(0,r.$Wj)("more",60028),ellipsis:(0,r.$Wj)("ellipsis",60028),kebabHorizontal:(0,r.$Wj)("kebab-horizontal",60028),mailReply:(0,r.$Wj)("mail-reply",60029),reply:(0,r.$Wj)("reply",60029),organization:(0,r.$Wj)("organization",60030),organizationFilled:(0,r.$Wj)("organization-filled",60030),organizationOutline:(0,r.$Wj)("organization-outline",60030),newFile:(0,r.$Wj)("new-file",60031),fileAdd:(0,r.$Wj)("file-add",60031),newFolder:(0,r.$Wj)("new-folder",60032),fileDirectoryCreate:(0,r.$Wj)("file-directory-create",60032),trash:(0,r.$Wj)("trash",60033),trashcan:(0,r.$Wj)("trashcan",60033),history:(0,r.$Wj)("history",60034),clock:(0,r.$Wj)("clock",60034),folder:(0,r.$Wj)("folder",60035),fileDirectory:(0,r.$Wj)("file-directory",60035),symbolFolder:(0,r.$Wj)("symbol-folder",60035),logoGithub:(0,r.$Wj)("logo-github",60036),markGithub:(0,r.$Wj)("mark-github",60036),github:(0,r.$Wj)("github",60036),terminal:(0,r.$Wj)("terminal",60037),console:(0,r.$Wj)("console",60037),repl:(0,r.$Wj)("repl",60037),zap:(0,r.$Wj)("zap",60038),symbolEvent:(0,r.$Wj)("symbol-event",60038),error:(0,r.$Wj)("error",60039),stop:(0,r.$Wj)("stop",60039),variable:(0,r.$Wj)("variable",60040),symbolVariable:(0,r.$Wj)("symbol-variable",60040),array:(0,r.$Wj)("array",60042),symbolArray:(0,r.$Wj)("symbol-array",60042),symbolModule:(0,r.$Wj)("symbol-module",60043),symbolPackage:(0,r.$Wj)("symbol-package",60043),symbolNamespace:(0,r.$Wj)("symbol-namespace",60043),symbolObject:(0,r.$Wj)("symbol-object",60043),symbolMethod:(0,r.$Wj)("symbol-method",60044),symbolFunction:(0,r.$Wj)("symbol-function",60044),symbolConstructor:(0,r.$Wj)("symbol-constructor",60044),symbolBoolean:(0,r.$Wj)("symbol-boolean",60047),symbolNull:(0,r.$Wj)("symbol-null",60047),symbolNumeric:(0,r.$Wj)("symbol-numeric",60048),symbolNumber:(0,r.$Wj)("symbol-number",60048),symbolStructure:(0,r.$Wj)("symbol-structure",60049),symbolStruct:(0,r.$Wj)("symbol-struct",60049),symbolParameter:(0,r.$Wj)("symbol-parameter",60050),symbolTypeParameter:(0,r.$Wj)("symbol-type-parameter",60050),symbolKey:(0,r.$Wj)("symbol-key",60051),symbolText:(0,r.$Wj)("symbol-text",60051),symbolReference:(0,r.$Wj)("symbol-reference",60052),goToFile:(0,r.$Wj)("go-to-file",60052),symbolEnum:(0,r.$Wj)("symbol-enum",60053),symbolValue:(0,r.$Wj)("symbol-value",60053),symbolRuler:(0,r.$Wj)("symbol-ruler",60054),symbolUnit:(0,r.$Wj)("symbol-unit",60054),activateBreakpoints:(0,r.$Wj)("activate-breakpoints",60055),archive:(0,r.$Wj)("archive",60056),arrowBoth:(0,r.$Wj)("arrow-both",60057),arrowDown:(0,r.$Wj)("arrow-down",60058),arrowLeft:(0,r.$Wj)("arrow-left",60059),arrowRight:(0,r.$Wj)("arrow-right",60060),arrowSmallDown:(0,r.$Wj)("arrow-small-down",60061),arrowSmallLeft:(0,r.$Wj)("arrow-small-left",60062),arrowSmallRight:(0,r.$Wj)("arrow-small-right",60063),arrowSmallUp:(0,r.$Wj)("arrow-small-up",60064),arrowUp:(0,r.$Wj)("arrow-up",60065),bell:(0,r.$Wj)("bell",60066),bold:(0,r.$Wj)("bold",60067),book:(0,r.$Wj)("book",60068),bookmark:(0,r.$Wj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.$Wj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.$Wj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.$Wj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.$Wj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.$Wj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.$Wj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.$Wj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.$Wj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.$Wj)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.$Wj)("briefcase",60076),broadcast:(0,r.$Wj)("broadcast",60077),browser:(0,r.$Wj)("browser",60078),bug:(0,r.$Wj)("bug",60079),calendar:(0,r.$Wj)("calendar",60080),caseSensitive:(0,r.$Wj)("case-sensitive",60081),check:(0,r.$Wj)("check",60082),checklist:(0,r.$Wj)("checklist",60083),chevronDown:(0,r.$Wj)("chevron-down",60084),chevronLeft:(0,r.$Wj)("chevron-left",60085),chevronRight:(0,r.$Wj)("chevron-right",60086),chevronUp:(0,r.$Wj)("chevron-up",60087),chromeClose:(0,r.$Wj)("chrome-close",60088),chromeMaximize:(0,r.$Wj)("chrome-maximize",60089),chromeMinimize:(0,r.$Wj)("chrome-minimize",60090),chromeRestore:(0,r.$Wj)("chrome-restore",60091),circleOutline:(0,r.$Wj)("circle-outline",60092),circle:(0,r.$Wj)("circle",60092),debugBreakpointUnverified:(0,r.$Wj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.$Wj)("terminal-decoration-incomplete",60092),circleSlash:(0,r.$Wj)("circle-slash",60093),circuitBoard:(0,r.$Wj)("circuit-board",60094),clearAll:(0,r.$Wj)("clear-all",60095),clippy:(0,r.$Wj)("clippy",60096),closeAll:(0,r.$Wj)("close-all",60097),cloudDownload:(0,r.$Wj)("cloud-download",60098),cloudUpload:(0,r.$Wj)("cloud-upload",60099),code:(0,r.$Wj)("code",60100),collapseAll:(0,r.$Wj)("collapse-all",60101),colorMode:(0,r.$Wj)("color-mode",60102),commentDiscussion:(0,r.$Wj)("comment-discussion",60103),creditCard:(0,r.$Wj)("credit-card",60105),dash:(0,r.$Wj)("dash",60108),dashboard:(0,r.$Wj)("dashboard",60109),database:(0,r.$Wj)("database",60110),debugContinue:(0,r.$Wj)("debug-continue",60111),debugDisconnect:(0,r.$Wj)("debug-disconnect",60112),debugPause:(0,r.$Wj)("debug-pause",60113),debugRestart:(0,r.$Wj)("debug-restart",60114),debugStart:(0,r.$Wj)("debug-start",60115),debugStepInto:(0,r.$Wj)("debug-step-into",60116),debugStepOut:(0,r.$Wj)("debug-step-out",60117),debugStepOver:(0,r.$Wj)("debug-step-over",60118),debugStop:(0,r.$Wj)("debug-stop",60119),debug:(0,r.$Wj)("debug",60120),deviceCameraVideo:(0,r.$Wj)("device-camera-video",60121),deviceCamera:(0,r.$Wj)("device-camera",60122),deviceMobile:(0,r.$Wj)("device-mobile",60123),diffAdded:(0,r.$Wj)("diff-added",60124),diffIgnored:(0,r.$Wj)("diff-ignored",60125),diffModified:(0,r.$Wj)("diff-modified",60126),diffRemoved:(0,r.$Wj)("diff-removed",60127),diffRenamed:(0,r.$Wj)("diff-renamed",60128),diff:(0,r.$Wj)("diff",60129),diffSidebyside:(0,r.$Wj)("diff-sidebyside",60129),discard:(0,r.$Wj)("discard",60130),editorLayout:(0,r.$Wj)("editor-layout",60131),emptyWindow:(0,r.$Wj)("empty-window",60132),exclude:(0,r.$Wj)("exclude",60133),extensions:(0,r.$Wj)("extensions",60134),eyeClosed:(0,r.$Wj)("eye-closed",60135),fileBinary:(0,r.$Wj)("file-binary",60136),fileCode:(0,r.$Wj)("file-code",60137),fileMedia:(0,r.$Wj)("file-media",60138),filePdf:(0,r.$Wj)("file-pdf",60139),fileSubmodule:(0,r.$Wj)("file-submodule",60140),fileSymlinkDirectory:(0,r.$Wj)("file-symlink-directory",60141),fileSymlinkFile:(0,r.$Wj)("file-symlink-file",60142),fileZip:(0,r.$Wj)("file-zip",60143),files:(0,r.$Wj)("files",60144),filter:(0,r.$Wj)("filter",60145),flame:(0,r.$Wj)("flame",60146),foldDown:(0,r.$Wj)("fold-down",60147),foldUp:(0,r.$Wj)("fold-up",60148),fold:(0,r.$Wj)("fold",60149),folderActive:(0,r.$Wj)("folder-active",60150),folderOpened:(0,r.$Wj)("folder-opened",60151),gear:(0,r.$Wj)("gear",60152),gift:(0,r.$Wj)("gift",60153),gistSecret:(0,r.$Wj)("gist-secret",60154),gist:(0,r.$Wj)("gist",60155),gitCommit:(0,r.$Wj)("git-commit",60156),gitCompare:(0,r.$Wj)("git-compare",60157),compareChanges:(0,r.$Wj)("compare-changes",60157),gitMerge:(0,r.$Wj)("git-merge",60158),githubAction:(0,r.$Wj)("github-action",60159),githubAlt:(0,r.$Wj)("github-alt",60160),globe:(0,r.$Wj)("globe",60161),grabber:(0,r.$Wj)("grabber",60162),graph:(0,r.$Wj)("graph",60163),gripper:(0,r.$Wj)("gripper",60164),heart:(0,r.$Wj)("heart",60165),home:(0,r.$Wj)("home",60166),horizontalRule:(0,r.$Wj)("horizontal-rule",60167),hubot:(0,r.$Wj)("hubot",60168),inbox:(0,r.$Wj)("inbox",60169),issueReopened:(0,r.$Wj)("issue-reopened",60171),issues:(0,r.$Wj)("issues",60172),italic:(0,r.$Wj)("italic",60173),jersey:(0,r.$Wj)("jersey",60174),json:(0,r.$Wj)("json",60175),kebabVertical:(0,r.$Wj)("kebab-vertical",60176),key:(0,r.$Wj)("key",60177),law:(0,r.$Wj)("law",60178),lightbulbAutofix:(0,r.$Wj)("lightbulb-autofix",60179),linkExternal:(0,r.$Wj)("link-external",60180),link:(0,r.$Wj)("link",60181),listOrdered:(0,r.$Wj)("list-ordered",60182),listUnordered:(0,r.$Wj)("list-unordered",60183),liveShare:(0,r.$Wj)("live-share",60184),loading:(0,r.$Wj)("loading",60185),location:(0,r.$Wj)("location",60186),mailRead:(0,r.$Wj)("mail-read",60187),mail:(0,r.$Wj)("mail",60188),markdown:(0,r.$Wj)("markdown",60189),megaphone:(0,r.$Wj)("megaphone",60190),mention:(0,r.$Wj)("mention",60191),milestone:(0,r.$Wj)("milestone",60192),gitPullRequestMilestone:(0,r.$Wj)("git-pull-request-milestone",60192),mortarBoard:(0,r.$Wj)("mortar-board",60193),move:(0,r.$Wj)("move",60194),multipleWindows:(0,r.$Wj)("multiple-windows",60195),mute:(0,r.$Wj)("mute",60196),noNewline:(0,r.$Wj)("no-newline",60197),note:(0,r.$Wj)("note",60198),octoface:(0,r.$Wj)("octoface",60199),openPreview:(0,r.$Wj)("open-preview",60200),package:(0,r.$Wj)("package",60201),paintcan:(0,r.$Wj)("paintcan",60202),pin:(0,r.$Wj)("pin",60203),play:(0,r.$Wj)("play",60204),run:(0,r.$Wj)("run",60204),plug:(0,r.$Wj)("plug",60205),preserveCase:(0,r.$Wj)("preserve-case",60206),preview:(0,r.$Wj)("preview",60207),project:(0,r.$Wj)("project",60208),pulse:(0,r.$Wj)("pulse",60209),question:(0,r.$Wj)("question",60210),quote:(0,r.$Wj)("quote",60211),radioTower:(0,r.$Wj)("radio-tower",60212),reactions:(0,r.$Wj)("reactions",60213),references:(0,r.$Wj)("references",60214),refresh:(0,r.$Wj)("refresh",60215),regex:(0,r.$Wj)("regex",60216),remoteExplorer:(0,r.$Wj)("remote-explorer",60217),remote:(0,r.$Wj)("remote",60218),remove:(0,r.$Wj)("remove",60219),replaceAll:(0,r.$Wj)("replace-all",60220),replace:(0,r.$Wj)("replace",60221),repoClone:(0,r.$Wj)("repo-clone",60222),repoForcePush:(0,r.$Wj)("repo-force-push",60223),repoPull:(0,r.$Wj)("repo-pull",60224),repoPush:(0,r.$Wj)("repo-push",60225),report:(0,r.$Wj)("report",60226),requestChanges:(0,r.$Wj)("request-changes",60227),rocket:(0,r.$Wj)("rocket",60228),rootFolderOpened:(0,r.$Wj)("root-folder-opened",60229),rootFolder:(0,r.$Wj)("root-folder",60230),rss:(0,r.$Wj)("rss",60231),ruby:(0,r.$Wj)("ruby",60232),saveAll:(0,r.$Wj)("save-all",60233),saveAs:(0,r.$Wj)("save-as",60234),save:(0,r.$Wj)("save",60235),screenFull:(0,r.$Wj)("screen-full",60236),screenNormal:(0,r.$Wj)("screen-normal",60237),searchStop:(0,r.$Wj)("search-stop",60238),server:(0,r.$Wj)("server",60240),settingsGear:(0,r.$Wj)("settings-gear",60241),settings:(0,r.$Wj)("settings",60242),shield:(0,r.$Wj)("shield",60243),smiley:(0,r.$Wj)("smiley",60244),sortPrecedence:(0,r.$Wj)("sort-precedence",60245),splitHorizontal:(0,r.$Wj)("split-horizontal",60246),splitVertical:(0,r.$Wj)("split-vertical",60247),squirrel:(0,r.$Wj)("squirrel",60248),starFull:(0,r.$Wj)("star-full",60249),starHalf:(0,r.$Wj)("star-half",60250),symbolClass:(0,r.$Wj)("symbol-class",60251),symbolColor:(0,r.$Wj)("symbol-color",60252),symbolConstant:(0,r.$Wj)("symbol-constant",60253),symbolEnumMember:(0,r.$Wj)("symbol-enum-member",60254),symbolField:(0,r.$Wj)("symbol-field",60255),symbolFile:(0,r.$Wj)("symbol-file",60256),symbolInterface:(0,r.$Wj)("symbol-interface",60257),symbolKeyword:(0,r.$Wj)("symbol-keyword",60258),symbolMisc:(0,r.$Wj)("symbol-misc",60259),symbolOperator:(0,r.$Wj)("symbol-operator",60260),symbolProperty:(0,r.$Wj)("symbol-property",60261),wrench:(0,r.$Wj)("wrench",60261),wrenchSubaction:(0,r.$Wj)("wrench-subaction",60261),symbolSnippet:(0,r.$Wj)("symbol-snippet",60262),tasklist:(0,r.$Wj)("tasklist",60263),telescope:(0,r.$Wj)("telescope",60264),textSize:(0,r.$Wj)("text-size",60265),threeBars:(0,r.$Wj)("three-bars",60266),thumbsdown:(0,r.$Wj)("thumbsdown",60267),thumbsup:(0,r.$Wj)("thumbsup",60268),tools:(0,r.$Wj)("tools",60269),triangleDown:(0,r.$Wj)("triangle-down",60270),triangleLeft:(0,r.$Wj)("triangle-left",60271),triangleRight:(0,r.$Wj)("triangle-right",60272),triangleUp:(0,r.$Wj)("triangle-up",60273),twitter:(0,r.$Wj)("twitter",60274),unfold:(0,r.$Wj)("unfold",60275),unlock:(0,r.$Wj)("unlock",60276),unmute:(0,r.$Wj)("unmute",60277),unverified:(0,r.$Wj)("unverified",60278),verified:(0,r.$Wj)("verified",60279),versions:(0,r.$Wj)("versions",60280),vmActive:(0,r.$Wj)("vm-active",60281),vmOutline:(0,r.$Wj)("vm-outline",60282),vmRunning:(0,r.$Wj)("vm-running",60283),watch:(0,r.$Wj)("watch",60284),whitespace:(0,r.$Wj)("whitespace",60285),wholeWord:(0,r.$Wj)("whole-word",60286),window:(0,r.$Wj)("window",60287),wordWrap:(0,r.$Wj)("word-wrap",60288),zoomIn:(0,r.$Wj)("zoom-in",60289),zoomOut:(0,r.$Wj)("zoom-out",60290),listFilter:(0,r.$Wj)("list-filter",60291),listFlat:(0,r.$Wj)("list-flat",60292),listSelection:(0,r.$Wj)("list-selection",60293),selection:(0,r.$Wj)("selection",60293),listTree:(0,r.$Wj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.$Wj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.$Wj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.$Wj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.$Wj)("debug-stackframe-active",60297),circleSmallFilled:(0,r.$Wj)("circle-small-filled",60298),debugStackframeDot:(0,r.$Wj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.$Wj)("terminal-decoration-mark",60298),debugStackframe:(0,r.$Wj)("debug-stackframe",60299),debugStackframeFocused:(0,r.$Wj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.$Wj)("debug-breakpoint-unsupported",60300),symbolString:(0,r.$Wj)("symbol-string",60301),debugReverseContinue:(0,r.$Wj)("debug-reverse-continue",60302),debugStepBack:(0,r.$Wj)("debug-step-back",60303),debugRestartFrame:(0,r.$Wj)("debug-restart-frame",60304),debugAlt:(0,r.$Wj)("debug-alt",60305),callIncoming:(0,r.$Wj)("call-incoming",60306),callOutgoing:(0,r.$Wj)("call-outgoing",60307),menu:(0,r.$Wj)("menu",60308),expandAll:(0,r.$Wj)("expand-all",60309),feedback:(0,r.$Wj)("feedback",60310),gitPullRequestReviewer:(0,r.$Wj)("git-pull-request-reviewer",60310),groupByRefType:(0,r.$Wj)("group-by-ref-type",60311),ungroupByRefType:(0,r.$Wj)("ungroup-by-ref-type",60312),account:(0,r.$Wj)("account",60313),gitPullRequestAssignee:(0,r.$Wj)("git-pull-request-assignee",60313),bellDot:(0,r.$Wj)("bell-dot",60314),debugConsole:(0,r.$Wj)("debug-console",60315),library:(0,r.$Wj)("library",60316),output:(0,r.$Wj)("output",60317),runAll:(0,r.$Wj)("run-all",60318),syncIgnored:(0,r.$Wj)("sync-ignored",60319),pinned:(0,r.$Wj)("pinned",60320),githubInverted:(0,r.$Wj)("github-inverted",60321),serverProcess:(0,r.$Wj)("server-process",60322),serverEnvironment:(0,r.$Wj)("server-environment",60323),pass:(0,r.$Wj)("pass",60324),issueClosed:(0,r.$Wj)("issue-closed",60324),stopCircle:(0,r.$Wj)("stop-circle",60325),playCircle:(0,r.$Wj)("play-circle",60326),record:(0,r.$Wj)("record",60327),debugAltSmall:(0,r.$Wj)("debug-alt-small",60328),vmConnect:(0,r.$Wj)("vm-connect",60329),cloud:(0,r.$Wj)("cloud",60330),merge:(0,r.$Wj)("merge",60331),export:(0,r.$Wj)("export",60332),graphLeft:(0,r.$Wj)("graph-left",60333),magnet:(0,r.$Wj)("magnet",60334),notebook:(0,r.$Wj)("notebook",60335),redo:(0,r.$Wj)("redo",60336),checkAll:(0,r.$Wj)("check-all",60337),pinnedDirty:(0,r.$Wj)("pinned-dirty",60338),passFilled:(0,r.$Wj)("pass-filled",60339),circleLargeFilled:(0,r.$Wj)("circle-large-filled",60340),circleLarge:(0,r.$Wj)("circle-large",60341),circleLargeOutline:(0,r.$Wj)("circle-large-outline",60341),combine:(0,r.$Wj)("combine",60342),gather:(0,r.$Wj)("gather",60342),table:(0,r.$Wj)("table",60343),variableGroup:(0,r.$Wj)("variable-group",60344),typeHierarchy:(0,r.$Wj)("type-hierarchy",60345),typeHierarchySub:(0,r.$Wj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.$Wj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.$Wj)("git-pull-request-create",60348),runAbove:(0,r.$Wj)("run-above",60349),runBelow:(0,r.$Wj)("run-below",60350),notebookTemplate:(0,r.$Wj)("notebook-template",60351),debugRerun:(0,r.$Wj)("debug-rerun",60352),workspaceTrusted:(0,r.$Wj)("workspace-trusted",60353),workspaceUntrusted:(0,r.$Wj)("workspace-untrusted",60354),workspaceUnknown:(0,r.$Wj)("workspace-unknown",60355),terminalCmd:(0,r.$Wj)("terminal-cmd",60356),terminalDebian:(0,r.$Wj)("terminal-debian",60357),terminalLinux:(0,r.$Wj)("terminal-linux",60358),terminalPowershell:(0,r.$Wj)("terminal-powershell",60359),terminalTmux:(0,r.$Wj)("terminal-tmux",60360),terminalUbuntu:(0,r.$Wj)("terminal-ubuntu",60361),terminalBash:(0,r.$Wj)("terminal-bash",60362),arrowSwap:(0,r.$Wj)("arrow-swap",60363),copy:(0,r.$Wj)("copy",60364),personAdd:(0,r.$Wj)("person-add",60365),filterFilled:(0,r.$Wj)("filter-filled",60366),wand:(0,r.$Wj)("wand",60367),debugLineByLine:(0,r.$Wj)("debug-line-by-line",60368),inspect:(0,r.$Wj)("inspect",60369),layers:(0,r.$Wj)("layers",60370),layersDot:(0,r.$Wj)("layers-dot",60371),layersActive:(0,r.$Wj)("layers-active",60372),compass:(0,r.$Wj)("compass",60373),compassDot:(0,r.$Wj)("compass-dot",60374),compassActive:(0,r.$Wj)("compass-active",60375),azure:(0,r.$Wj)("azure",60376),issueDraft:(0,r.$Wj)("issue-draft",60377),gitPullRequestClosed:(0,r.$Wj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.$Wj)("git-pull-request-draft",60379),debugAll:(0,r.$Wj)("debug-all",60380),debugCoverage:(0,r.$Wj)("debug-coverage",60381),runErrors:(0,r.$Wj)("run-errors",60382),folderLibrary:(0,r.$Wj)("folder-library",60383),debugContinueSmall:(0,r.$Wj)("debug-continue-small",60384),beakerStop:(0,r.$Wj)("beaker-stop",60385),graphLine:(0,r.$Wj)("graph-line",60386),graphScatter:(0,r.$Wj)("graph-scatter",60387),pieChart:(0,r.$Wj)("pie-chart",60388),bracket:(0,r.$Wj)("bracket",60175),bracketDot:(0,r.$Wj)("bracket-dot",60389),bracketError:(0,r.$Wj)("bracket-error",60390),lockSmall:(0,r.$Wj)("lock-small",60391),azureDevops:(0,r.$Wj)("azure-devops",60392),verifiedFilled:(0,r.$Wj)("verified-filled",60393),newline:(0,r.$Wj)("newline",60394),layout:(0,r.$Wj)("layout",60395),layoutActivitybarLeft:(0,r.$Wj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.$Wj)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.$Wj)("layout-panel-left",60398),layoutPanelCenter:(0,r.$Wj)("layout-panel-center",60399),layoutPanelJustify:(0,r.$Wj)("layout-panel-justify",60400),layoutPanelRight:(0,r.$Wj)("layout-panel-right",60401),layoutPanel:(0,r.$Wj)("layout-panel",60402),layoutSidebarLeft:(0,r.$Wj)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.$Wj)("layout-sidebar-right",60404),layoutStatusbar:(0,r.$Wj)("layout-statusbar",60405),layoutMenubar:(0,r.$Wj)("layout-menubar",60406),layoutCentered:(0,r.$Wj)("layout-centered",60407),target:(0,r.$Wj)("target",60408),indent:(0,r.$Wj)("indent",60409),recordSmall:(0,r.$Wj)("record-small",60410),errorSmall:(0,r.$Wj)("error-small",60411),terminalDecorationError:(0,r.$Wj)("terminal-decoration-error",60411),arrowCircleDown:(0,r.$Wj)("arrow-circle-down",60412),arrowCircleLeft:(0,r.$Wj)("arrow-circle-left",60413),arrowCircleRight:(0,r.$Wj)("arrow-circle-right",60414),arrowCircleUp:(0,r.$Wj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.$Wj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.$Wj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.$Wj)("layout-sidebar-left-off",60418),blank:(0,r.$Wj)("blank",60419),heartFilled:(0,r.$Wj)("heart-filled",60420),map:(0,r.$Wj)("map",60421),mapHorizontal:(0,r.$Wj)("map-horizontal",60421),foldHorizontal:(0,r.$Wj)("fold-horizontal",60421),mapFilled:(0,r.$Wj)("map-filled",60422),mapHorizontalFilled:(0,r.$Wj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.$Wj)("fold-horizontal-filled",60422),circleSmall:(0,r.$Wj)("circle-small",60423),bellSlash:(0,r.$Wj)("bell-slash",60424),bellSlashDot:(0,r.$Wj)("bell-slash-dot",60425),commentUnresolved:(0,r.$Wj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.$Wj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.$Wj)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.$Wj)("search-fuzzy",60429),commentDraft:(0,r.$Wj)("comment-draft",60430),send:(0,r.$Wj)("send",60431),sparkle:(0,r.$Wj)("sparkle",60432),insert:(0,r.$Wj)("insert",60433),mic:(0,r.$Wj)("mic",60434),thumbsdownFilled:(0,r.$Wj)("thumbsdown-filled",60435),thumbsupFilled:(0,r.$Wj)("thumbsup-filled",60436),coffee:(0,r.$Wj)("coffee",60437),snake:(0,r.$Wj)("snake",60438),game:(0,r.$Wj)("game",60439),vr:(0,r.$Wj)("vr",60440),chip:(0,r.$Wj)("chip",60441),piano:(0,r.$Wj)("piano",60442),music:(0,r.$Wj)("music",60443),micFilled:(0,r.$Wj)("mic-filled",60444),repoFetch:(0,r.$Wj)("repo-fetch",60445),copilot:(0,r.$Wj)("copilot",60446),lightbulbSparkle:(0,r.$Wj)("lightbulb-sparkle",60447),robot:(0,r.$Wj)("robot",60448),sparkleFilled:(0,r.$Wj)("sparkle-filled",60449),diffSingle:(0,r.$Wj)("diff-single",60450),diffMultiple:(0,r.$Wj)("diff-multiple",60451),surroundWith:(0,r.$Wj)("surround-with",60452),share:(0,r.$Wj)("share",60453),gitStash:(0,r.$Wj)("git-stash",60454),gitStashApply:(0,r.$Wj)("git-stash-apply",60455),gitStashPop:(0,r.$Wj)("git-stash-pop",60456),vscode:(0,r.$Wj)("vscode",60457),vscodeInsiders:(0,r.$Wj)("vscode-insiders",60458),codeOss:(0,r.$Wj)("code-oss",60459),runCoverage:(0,r.$Wj)("run-coverage",60460),runAllCoverage:(0,r.$Wj)("run-all-coverage",60461),coverage:(0,r.$Wj)("coverage",60462),githubProject:(0,r.$Wj)("github-project",60463),mapVertical:(0,r.$Wj)("map-vertical",60464),foldVertical:(0,r.$Wj)("fold-vertical",60464),mapVerticalFilled:(0,r.$Wj)("map-vertical-filled",60465),foldVerticalFilled:(0,r.$Wj)("fold-vertical-filled",60465),goToSearch:(0,r.$Wj)("go-to-search",60466),percentage:(0,r.$Wj)("percentage",60467),sortPercentage:(0,r.$Wj)("sort-percentage",60467),attach:(0,r.$Wj)("attach",60468)}}),define(Se[82],De([1,0,106,187]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=void 0,e.$Zj=C;function C(){return Object.values(e.$2j)}e.$1j={dialogError:(0,r.$Wj)("dialog-error","error"),dialogWarning:(0,r.$Wj)("dialog-warning","warning"),dialogInfo:(0,r.$Wj)("dialog-info","info"),dialogClose:(0,r.$Wj)("dialog-close","close"),treeItemExpanded:(0,r.$Wj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.$Wj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.$Wj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.$Wj)("tree-filter-clear","close"),treeItemLoading:(0,r.$Wj)("tree-item-loading","loading"),menuSelection:(0,r.$Wj)("menu-selection","check"),menuSubmenu:(0,r.$Wj)("menu-submenu","chevron-right"),menuBarMore:(0,r.$Wj)("menubar-more","more"),scrollbarButtonLeft:(0,r.$Wj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.$Wj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.$Wj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.$Wj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.$Wj)("toolbar-more","more"),quickInputBack:(0,r.$Wj)("quick-input-back","arrow-left"),dropDownButton:(0,r.$Wj)("drop-down-button",60084),symbolCustomColor:(0,r.$Wj)("symbol-customcolor",60252),exportIcon:(0,r.$Wj)("export",60332),workspaceUnspecified:(0,r.$Wj)("workspace-unspecified",60355),newLine:(0,r.$Wj)("newline",60394),thumbsDownFilled:(0,r.$Wj)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.$Wj)("thumbsup-filled",60436),gitFetch:(0,r.$Wj)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.$Wj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.$Wj)("debug-breakpoint-pending",60377)},e.$2j={...h.$Yj,...e.$1j}}),define(Se[24],De([1,0,17]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=h,e.$co=C,e.$do=L,e.$eo=b,e.$fo=c,e.$go=I,e.$ho=S,e.$io=u,e.$jo=P,e.$ko=w,e.$lo=a,e.$mo=m,e.$no=$;function h(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const i=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([s,t])=>{i[s]=t&&typeof t=="object"?h(t):t}),i}function C(f){if(!f||typeof f!="object")return f;const i=[f];for(;i.length>0;){const s=i.shift();Object.freeze(s);for(const t in s)if(R.call(s,t)){const o=s[t];typeof o=="object"&&!Object.isFrozen(o)&&!(0,r.$fg)(o)&&i.push(o)}}return f}const R=Object.prototype.hasOwnProperty;function L(f,i){return T(f,i,new Set)}function T(f,i,s){if((0,r.$lg)(f))return f;const t=i(f);if(typeof t<"u")return t;if(Array.isArray(f)){const o=[];for(const n of f)o.push(T(n,i,s));return o}if((0,r.$eg)(f)){if(s.has(f))throw new Error("Cannot clone recursive data-structure");s.add(f);const o={};for(const n in f)R.call(f,n)&&(o[n]=T(f[n],i,s));return s.delete(f),o}return f}function b(f,i,s=!0){return(0,r.$eg)(f)?((0,r.$eg)(i)&&Object.keys(i).forEach(t=>{t in f?s&&((0,r.$eg)(f[t])&&(0,r.$eg)(i[t])?b(f[t],i[t],s):f[t]=i[t]):f[t]=i[t]}),f):i}function c(f,i){if(f===i)return!0;if(f==null||i===null||i===void 0||typeof f!=typeof i||typeof f!="object"||Array.isArray(f)!==Array.isArray(i))return!1;let s,t;if(Array.isArray(f)){if(f.length!==i.length)return!1;for(s=0;s<f.length;s++)if(!c(f[s],i[s]))return!1}else{const o=[];for(t in f)o.push(t);o.sort();const n=[];for(t in i)n.push(t);if(n.sort(),!c(o,n))return!1;for(s=0;s<o.length;s++)if(!c(f[o[s]],i[o[s]]))return!1}return!0}function I(f){const i=new Set;return JSON.stringify(f,(s,t)=>{if((0,r.$eg)(t)||Array.isArray(t)){if(i.has(t))return"[Circular]";i.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function S(f,i){const s=Object.create(null);return!f||!i||Object.keys(i).forEach(o=>{const n=f[o],d=i[o];c(n,d)||(s[o]=d)}),s}function u(f,i){const s=i.toLowerCase(),t=Object.keys(f).find(o=>o.toLowerCase()===s);return t?f[t]:f[i]}function P(f,i){const s=Object.create(null);for(const[t,o]of Object.entries(f))i(t,o)&&(s[t]=o);return s}function w(f){let i=[];for(;Object.prototype!==f;)i=i.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return i}function a(f){const i=[];for(const s of w(f))typeof f[s]=="function"&&i.push(s);return i}function m(f,i){const s=o=>function(){const n=Array.prototype.slice.call(arguments,0);return i(o,n)},t={};for(const o of f)t[o]=s(o);return t}function $(f,i){const s={};for(const[t,o]of Object.entries(f))s[t]=i(o,t);return s}}),define(Se[50],De([1,0,82]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$3j=C;var h;(function(L){function T(b){return b&&typeof b=="object"&&typeof b.id=="string"}L.isThemeColor=T})(h||(e.ThemeColor=h={}));function C(L){return{id:L}}var R;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function b(f){const i=T.exec(f.id);if(!i)return b(r.$2j.error);const[,s,t]=i,o=["codicon","codicon-"+s];return t&&o.push("codicon-modifier-"+t.substring(1)),o}L.asClassNameArray=b;function c(f){return b(f).join(" ")}L.asClassName=c;function I(f){return"."+b(f).join(".")}L.asCSSSelector=I;function S(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||h.isThemeColor(f.color))}L.isThemeIcon=S;const u=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function P(f){const i=u.exec(f);if(!i)return;const[,s]=i;return{id:s}}L.fromString=P;function w(f){return{id:f}}L.fromId=w;function a(f,i){let s=f.id;const t=s.lastIndexOf("~");return t!==-1&&(s=s.substring(0,t)),i&&(s=`${s}~${i}`),{id:s}}L.modify=a;function m(f){const i=f.id.lastIndexOf("~");if(i!==-1)return f.id.substring(i+1)}L.getModifier=m;function $(f,i){return f.id===i.id&&f.color?.id===i.color?.id}L.isEqual=$})(R||(e.ThemeIcon=R={}))}),define(Se[83],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$$e=h,e.$_e=C;var r;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(e.Constants=r={}));function h(R){return R<0?0:R>r.MAX_UINT_8?r.MAX_UINT_8:R|0}function C(R){return R<0?0:R>r.MAX_UINT_32?r.MAX_UINT_32:R|0}}),define(Se[12],De([1,0,184,26,49,83]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=e.$_f=e.GraphemeBreakType=e.$2f=e.$Tf=e.$Mf=e.$Lf=void 0,e.$af=L,e.$bf=b,e.$cf=I,e.$df=S,e.$ef=u,e.$ff=P,e.$gf=w,e.$hf=a,e.$if=m,e.$jf=$,e.$kf=f,e.$lf=i,e.$mf=s,e.$nf=t,e.$of=o,e.$pf=n,e.$qf=d,e.$rf=l,e.$sf=g,e.$tf=E,e.$uf=D,e.$vf=y,e.$wf=k,e.$xf=A,e.$yf=p,e.$zf=v,e.$Af=F,e.$Bf=N,e.$Cf=O,e.$Df=j,e.$Ef=z,e.$Ff=M,e.$Gf=W,e.$Hf=V,e.$If=ne,e.$Jf=B,e.$Kf=K,e.$Nf=re,e.$Of=ye,e.$Pf=me,e.$Qf=J,e.$Rf=ae,e.$Sf=ce,e.$Uf=le,e.$Vf=x,e.$Wf=oe,e.$Xf=pe,e.$Yf=Fe,e.$Zf=ze,e.$1f=Ie,e.$3f=Pe,e.$4f=q,e.$5f=H,e.$6f=X,e.$7f=Z,e.$8f=de,e.$9f=be,e.$0f=Oe,e.$$f=st;function L(ke){return!ke||typeof ke!="string"?!0:ke.trim().length===0}const T=/{(\d+)}/g;function b(ke,...Be){return Be.length===0?ke:ke.replace(T,function(Ke,Ne){const je=parseInt(Ne,10);return isNaN(je)||je<0||je>=Be.length?Ke:Be[je]})}const c=/{([^}]+)}/g;function I(ke,Be){return Object.keys(Be).length===0?ke:ke.replace(c,(Ke,Ne)=>Be[Ne]??Ke)}function S(ke){return ke.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function u(ke){return ke.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function P(ke){return ke.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function w(ke,Be){let Ke=0,Ne=ke.indexOf(Be);for(;Ne!==-1;)Ke++,Ne=ke.indexOf(Be,Ne+Be.length);return Ke}function a(ke,Be,Ke="\u2026"){return ke.length<=Be?ke:`${ke.substr(0,Be)}${Ke}`}function m(ke,Be,Ke="\u2026"){if(ke.length<=Be)return ke;const Ne=Math.ceil(Be/2)-Ke.length/2,je=Math.floor(Be/2)-Ke.length/2;return`${ke.substr(0,Ne)}${Ke}${ke.substr(ke.length-je)}`}function $(ke,Be=" "){const Ke=f(ke,Be);return i(Ke,Be)}function f(ke,Be){if(!ke||!Be)return ke;const Ke=Be.length;if(Ke===0||ke.length===0)return ke;let Ne=0;for(;ke.indexOf(Be,Ne)===Ne;)Ne=Ne+Ke;return ke.substring(Ne)}function i(ke,Be){if(!ke||!Be)return ke;const Ke=Be.length,Ne=ke.length;if(Ke===0||Ne===0)return ke;let je=Ne,he=-1;for(;he=ke.lastIndexOf(Be,je-1),!(he===-1||he+Ke!==je);){if(he===0)return"";je=he}return ke.substring(0,je)}function s(ke){return ke.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(ke){return ke.replace(/\*/g,"")}function o(ke,Be,Ke={}){if(!ke)throw new Error("Cannot create regex from empty string");Be||(ke=P(ke)),Ke.wholeWord&&(/\B/.test(ke.charAt(0))||(ke="\\b"+ke),/\B/.test(ke.charAt(ke.length-1))||(ke=ke+"\\b"));let Ne="";return Ke.global&&(Ne+="g"),Ke.matchCase||(Ne+="i"),Ke.multiline&&(Ne+="m"),Ke.unicode&&(Ne+="u"),new RegExp(ke,Ne)}function n(ke){return ke.source==="^"||ke.source==="^$"||ke.source==="$"||ke.source==="^\\s*$"?!1:!!(ke.exec("")&&ke.lastIndex===0)}function d(ke){return ke.split(/\r\n|\r|\n/)}function l(ke){const Be=[],Ke=ke.split(/(\r\n|\r|\n)/);for(let Ne=0;Ne<Math.ceil(Ke.length/2);Ne++)Be.push(Ke[2*Ne]+(Ke[2*Ne+1]??""));return Be}function g(ke){for(let Be=0,Ke=ke.length;Be<Ke;Be++){const Ne=ke.charCodeAt(Be);if(Ne!==h.CharCode.Space&&Ne!==h.CharCode.Tab)return Be}return-1}function E(ke,Be=0,Ke=ke.length){for(let Ne=Be;Ne<Ke;Ne++){const je=ke.charCodeAt(Ne);if(je!==h.CharCode.Space&&je!==h.CharCode.Tab)return ke.substring(Be,Ne)}return ke.substring(Be,Ke)}function D(ke,Be=ke.length-1){for(let Ke=Be;Ke>=0;Ke--){const Ne=ke.charCodeAt(Ke);if(Ne!==h.CharCode.Space&&Ne!==h.CharCode.Tab)return Ke}return-1}function y(ke,Be,Ke){const Ne=[];let je=0;for(const he of ke.matchAll(Be)){if(Ne.push(ke.slice(je,he.index)),he.index===void 0)throw new Error("match.index should be defined");je=he.index+he[0].length,Ne.push(Ke(he[0],...he.slice(1),he.index,ke,he.groups))}return Ne.push(ke.slice(je)),Promise.all(Ne).then(he=>he.join(""))}function k(ke,Be){return ke<Be?-1:ke>Be?1:0}function A(ke,Be,Ke=0,Ne=ke.length,je=0,he=Be.length){for(;Ke<Ne&&je<he;Ke++,je++){const Xe=ke.charCodeAt(Ke),tt=Be.charCodeAt(je);if(Xe<tt)return-1;if(Xe>tt)return 1}const _=Ne-Ke,Re=he-je;return _<Re?-1:_>Re?1:0}function p(ke,Be){return v(ke,Be,0,ke.length,0,Be.length)}function v(ke,Be,Ke=0,Ne=ke.length,je=0,he=Be.length){for(;Ke<Ne&&je<he;Ke++,je++){let Xe=ke.charCodeAt(Ke),tt=Be.charCodeAt(je);if(Xe===tt)continue;if(Xe>=128||tt>=128)return A(ke.toLowerCase(),Be.toLowerCase(),Ke,Ne,je,he);N(Xe)&&(Xe-=32),N(tt)&&(tt-=32);const ut=Xe-tt;if(ut!==0)return ut}const _=Ne-Ke,Re=he-je;return _<Re?-1:_>Re?1:0}function F(ke){return ke>=h.CharCode.Digit0&&ke<=h.CharCode.Digit9}function N(ke){return ke>=h.CharCode.a&&ke<=h.CharCode.z}function O(ke){return ke>=h.CharCode.A&&ke<=h.CharCode.Z}function j(ke,Be){return ke.length===Be.length&&v(ke,Be)===0}function z(ke,Be){const Ke=Be.length;return Be.length>ke.length?!1:v(ke,Be,0,Ke)===0}function M(ke,Be){const Ke=Math.min(ke.length,Be.length);let Ne;for(Ne=0;Ne<Ke;Ne++)if(ke.charCodeAt(Ne)!==Be.charCodeAt(Ne))return Ne;return Ke}function W(ke,Be){const Ke=Math.min(ke.length,Be.length);let Ne;const je=ke.length-1,he=Be.length-1;for(Ne=0;Ne<Ke;Ne++)if(ke.charCodeAt(je-Ne)!==Be.charCodeAt(he-Ne))return Ne;return Ke}function V(ke){return 55296<=ke&&ke<=56319}function ne(ke){return 56320<=ke&&ke<=57343}function B(ke,Be){return(ke-55296<<10)+(Be-56320)+65536}function K(ke,Be,Ke){const Ne=ke.charCodeAt(Ke);if(V(Ne)&&Ke+1<Be){const je=ke.charCodeAt(Ke+1);if(ne(je))return B(Ne,je)}return Ne}function Y(ke,Be){const Ke=ke.charCodeAt(Be-1);if(ne(Ke)&&Be>1){const Ne=ke.charCodeAt(Be-2);if(V(Ne))return B(Ne,Ke)}return Ke}class ee{get offset(){return this.e}constructor(Be,Ke=0){this.c=Be,this.d=Be.length,this.e=Ke}setOffset(Be){this.e=Be}prevCodePoint(){const Be=Y(this.c,this.e);return this.e-=Be>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Be}nextCodePoint(){const Be=K(this.c,this.d,this.e);return this.e+=Be>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Be}eol(){return this.e>=this.d}}e.$Lf=ee;class ue{get offset(){return this.c.offset}constructor(Be,Ke=0){this.c=new ee(Be,Ke)}nextGraphemeLength(){const Be=_e.getInstance(),Ke=this.c,Ne=Ke.offset;let je=Be.getGraphemeBreakType(Ke.nextCodePoint());for(;!Ke.eol();){const he=Ke.offset,_=Be.getGraphemeBreakType(Ke.nextCodePoint());if(He(je,_)){Ke.setOffset(he);break}je=_}return Ke.offset-Ne}prevGraphemeLength(){const Be=_e.getInstance(),Ke=this.c,Ne=Ke.offset;let je=Be.getGraphemeBreakType(Ke.prevCodePoint());for(;Ke.offset>0;){const he=Ke.offset,_=Be.getGraphemeBreakType(Ke.prevCodePoint());if(He(_,je)){Ke.setOffset(he);break}je=_}return Ne-Ke.offset}eol(){return this.c.eol()}}e.$Mf=ue;function re(ke,Be){return new ue(ke,Be).nextGraphemeLength()}function ye(ke,Be){return new ue(ke,Be).prevGraphemeLength()}function me(ke,Be){Be>0&&ne(ke.charCodeAt(Be))&&Be--;const Ke=Be+re(ke,Be);return[Ke-ye(ke,Ke),Ke]}function J(ke){const Be=new ue(ke);let Ke=0;for(;!Be.eol();)Ke++,Be.nextGraphemeLength();return Ke}let U;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ae(ke){return U||(U=se()),U.test(ke)}const te=/^[\t\n\r\x20-\x7E]*$/;function ce(ke){return te.test(ke)}e.$Tf=/[\u2028\u2029]/;function le(ke){return e.$Tf.test(ke)}function x(ke){return ke>=11904&&ke<=55215||ke>=63744&&ke<=64255||ke>=65281&&ke<=65374}function oe(ke){return ke>=127462&&ke<=127487||ke===8986||ke===8987||ke===9200||ke===9203||ke>=9728&&ke<=10175||ke===11088||ke===11093||ke>=127744&&ke<=128591||ke>=128640&&ke<=128764||ke>=128992&&ke<=129008||ke>=129280&&ke<=129535||ke>=129648&&ke<=129782}function pe(ke,Be,Ke=""){const Ne=ke.trimStart();if(Ne.length<Be)return Ne;const je=/\b/g;let he=0;for(;je.test(Ne)&&!(Ne.length-je.lastIndex<Be);)he=je.lastIndex,je.lastIndex+=1;return he===0?Ne:Ke+Ne.substring(he).trimStart()}const we=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Fe(ke){let Be=0;for(const Ke of ke.matchAll(we))Be!==Ke.index&&(yield{isCode:!1,str:ke.substring(Be,Ke.index)}),yield{isCode:!0,str:Ke[0]},Be=Ke.index+Ke[0].length;Be!==ke.length&&(yield{isCode:!1,str:ke.substring(Be)})}function ze(ke){return ke&&(ke=ke.replace(we,"")),ke}const Ce=/\\\[.*?\\\]/g;function Ie(ke){return ze(ke).replace(Ce,"")}e.$2f=String.fromCharCode(h.CharCode.UTF8_BOM);function Pe(ke){return!!(ke&&ke.length>0&&ke.charCodeAt(0)===h.CharCode.UTF8_BOM)}function q(ke){return Pe(ke)?ke.substr(1):ke}function H(ke,Be){if(!ke||!Be||ke.length<Be.length)return!1;const Ke=Be.length,Ne=ke.toLowerCase();let je=0,he=-1;for(;je<Ke;){const _=Ne.indexOf(Be[je],he+1);if(_<0)return!1;he=_,je++}return!0}function X(ke,Be=!1){return ke?(Be&&(ke=ke.replace(/\\./g,"")),ke.toLowerCase()!==ke):!1}function Z(ke){return ke.charAt(0).toUpperCase()+ke.slice(1)}function de(ke,Be=1){if(Be===0)return"";let Ke=-1;do Ke=ke.indexOf(`
`,Ke+1),Be--;while(Be>0&&Ke>=0);return Ke===-1?ke:(ke[Ke-1]==="\r"&&Ke--,ke.substr(0,Ke))}function be(ke){const Be=h.CharCode.Z-h.CharCode.A+1;return ke=ke%(2*Be),ke<Be?String.fromCharCode(h.CharCode.a+ke):String.fromCharCode(h.CharCode.A+ke-Be)}function Oe(ke){return _e.getInstance().getGraphemeBreakType(ke)}function He(ke,Be){return ke===Qe.Other?Be!==Qe.Extend&&Be!==Qe.SpacingMark:ke===Qe.CR&&Be===Qe.LF?!1:ke===Qe.Control||ke===Qe.CR||ke===Qe.LF||Be===Qe.Control||Be===Qe.CR||Be===Qe.LF?!0:!(ke===Qe.L&&(Be===Qe.L||Be===Qe.V||Be===Qe.LV||Be===Qe.LVT)||(ke===Qe.LV||ke===Qe.V)&&(Be===Qe.V||Be===Qe.T)||(ke===Qe.LVT||ke===Qe.T)&&Be===Qe.T||Be===Qe.Extend||Be===Qe.ZWJ||Be===Qe.SpacingMark||ke===Qe.Prepend||ke===Qe.ZWJ&&Be===Qe.Extended_Pictographic||ke===Qe.Regional_Indicator&&Be===Qe.Regional_Indicator)}var Qe;(function(ke){ke[ke.Other=0]="Other",ke[ke.Prepend=1]="Prepend",ke[ke.CR=2]="CR",ke[ke.LF=3]="LF",ke[ke.Control=4]="Control",ke[ke.Extend=5]="Extend",ke[ke.Regional_Indicator=6]="Regional_Indicator",ke[ke.SpacingMark=7]="SpacingMark",ke[ke.L=8]="L",ke[ke.V=9]="V",ke[ke.T=10]="T",ke[ke.LV=11]="LV",ke[ke.LVT=12]="LVT",ke[ke.ZWJ=13]="ZWJ",ke[ke.Extended_Pictographic=14]="Extended_Pictographic"})(Qe||(e.GraphemeBreakType=Qe={}));class _e{static{this.c=null}static getInstance(){return _e.c||(_e.c=new _e),_e.c}constructor(){this.d=nt()}getGraphemeBreakType(Be){if(Be<32)return Be===h.CharCode.LineFeed?Qe.LF:Be===h.CharCode.CarriageReturn?Qe.CR:Qe.Control;if(Be<127)return Qe.Other;const Ke=this.d,Ne=Ke.length/3;let je=1;for(;je<=Ne;)if(Be<Ke[3*je])je=2*je;else if(Be>Ke[3*je+1])je=2*je+1;else return Ke[3*je+2];return Qe.Other}}function nt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function st(ke,Be){if(ke===0)return 0;const Ke=rt(ke,Be);if(Ke!==void 0)return Ke;const Ne=new ee(Be,ke);return Ne.prevCodePoint(),Ne.offset}function rt(ke,Be){const Ke=new ee(Be,ke);let Ne=Ke.prevCodePoint();for(;at(Ne)||Ne===mt.emojiVariantSelector||Ne===mt.enclosingKeyCap;){if(Ke.offset===0)return;Ne=Ke.prevCodePoint()}if(!oe(Ne))return;let je=Ke.offset;return je>0&&Ke.prevCodePoint()===mt.zwj&&(je=Ke.offset),je}function at(ke){return 127995<=ke&&ke<=127999}var mt;(function(ke){ke[ke.zwj=8205]="zwj",ke[ke.emojiVariantSelector=65039]="emojiVariantSelector",ke[ke.enclosingKeyCap=8419]="enclosingKeyCap"})(mt||(mt={})),e.$_f="\xA0";class ht{static{this.c=new C.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new r.$9e({getCacheKey:JSON.stringify},Be=>{function Ke(ut){const gt=new Map;for(let Dt=0;Dt<ut.length;Dt+=2)gt.set(ut[Dt],ut[Dt+1]);return gt}function Ne(ut,gt){const Dt=new Map(ut);for(const[Nt,Ut]of gt)Dt.set(Nt,Ut);return Dt}function je(ut,gt){if(!ut)return gt;const Dt=new Map;for(const[Nt,Ut]of ut)gt.has(Nt)&&Dt.set(Nt,Ut);return Dt}const he=this.c.value;let _=Be.filter(ut=>!ut.startsWith("_")&&ut in he);_.length===0&&(_=["_default"]);let Re;for(const ut of _){const gt=Ke(he[ut]);Re=je(Re,gt)}const Xe=Ke(he._common),tt=Ne(Xe,Re);return new ht(tt)})}static getInstance(Be){return ht.d.get(Array.from(Be))}static{this.e=new C.$T(()=>Object.keys(ht.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return ht.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}containsAmbiguousCharacter(Be){for(let Ke=0;Ke<Be.length;Ke++){const Ne=Be.codePointAt(Ke);if(typeof Ne=="number"&&this.isAmbiguous(Ne))return!0}return!1}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ag=ht;class ct{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ct.c())),this.d}static isInvisibleCharacter(Be){return ct.e().has(Be)}static containsInvisibleCharacter(Be){for(let Ke=0;Ke<Be.length;Ke++){const Ne=Be.codePointAt(Ke);if(typeof Ne=="number"&&ct.isInvisibleCharacter(Ne))return!0}return!1}static get codePoints(){return ct.e()}}e.$bg=ct}),define(Se[31],De([1,0,26,16,10,12,17]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=T,e.$vg=b,e.$wg=c,e.$xg=I,e.$yg=S,e.$zg=a,e.$Ag=m,e.$Bg=$,e.$Cg=f,e.$Dg=i,e.$Eg=s,e.$Fg=t,e.$Gg=o,e.$Hg=n,e.$Ig=d,e.$Jg=l,e.$Kg=D;function T(y){return y===r.CharCode.Slash||y===r.CharCode.Backslash}function b(y){return y.replace(/[\\/]/g,h.$fc.sep)}function c(y){return y.indexOf("/")===-1&&(y=b(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function I(y,k=h.$fc.sep){if(!y)return"";const A=y.length,p=y.charCodeAt(0);if(T(p)){if(T(y.charCodeAt(1))&&!T(y.charCodeAt(2))){let F=3;const N=F;for(;F<A&&!T(y.charCodeAt(F));F++);if(N!==F&&!T(y.charCodeAt(F+1))){for(F+=1;F<A;F++)if(T(y.charCodeAt(F)))return y.slice(0,F+1).replace(/[\\/]/g,k)}}return k}else if(f(p)&&y.charCodeAt(1)===r.CharCode.Colon)return T(y.charCodeAt(2))?y.slice(0,2)+k:y.slice(0,2);let v=y.indexOf("://");if(v!==-1){for(v+=3;v<A;v++)if(T(y.charCodeAt(v)))return y.slice(0,v+1)}return""}function S(y){if(!C.$j||!y||y.length<5)return!1;let k=y.charCodeAt(0);if(k!==r.CharCode.Backslash||(k=y.charCodeAt(1),k!==r.CharCode.Backslash))return!1;let A=2;const p=A;for(;A<y.length&&(k=y.charCodeAt(A),k!==r.CharCode.Backslash);A++);return!(p===A||(k=y.charCodeAt(A+1),isNaN(k)||k===r.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,P=/[/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(y,k=C.$j){const A=k?u:P;return!(!y||y.length===0||/^\s+$/.test(y)||(A.lastIndex=0,A.test(y))||k&&w.test(y)||y==="."||y===".."||k&&y[y.length-1]==="."||k&&y.length!==y.trim().length||y.length>255)}function m(y,k,A){const p=y===k;return!A||p?p:!y||!k?!1:(0,R.$Df)(y,k)}function $(y,k,A,p=h.sep){if(y===k)return!0;if(!y||!k||k.length>y.length)return!1;if(A){if(!(0,R.$Ef)(y,k))return!1;if(k.length===y.length)return!0;let F=k.length;return k.charAt(k.length-1)===p&&F--,y.charAt(F)===p}return k.charAt(k.length-1)!==p&&(k+=p),y.indexOf(k)===0}function f(y){return y>=r.CharCode.A&&y<=r.CharCode.Z||y>=r.CharCode.a&&y<=r.CharCode.z}function i(y,k){return C.$j&&y.endsWith(":")&&(y+=h.sep),(0,h.$hc)(y)||(y=(0,h.$ic)(k,y)),y=(0,h.$gc)(y),s(y)}function s(y){return C.$j?(y=(0,R.$lf)(y,h.sep),y.endsWith(":")&&(y+=h.sep)):(y=(0,R.$lf)(y,h.sep),y||(y=h.sep)),y}function t(y){const k=(0,h.$gc)(y);return C.$j?y.length>3?!1:o(k)&&(y.length===2||k.charCodeAt(2)===r.CharCode.Backslash):k===h.$fc.sep}function o(y,k=C.$j){return k?f(y.charCodeAt(0))&&y.charCodeAt(1)===r.CharCode.Colon:!1}function n(y,k=C.$j){return o(y,k)?y[0]:void 0}function d(y,k,A){return k.length>y.length?-1:y===k?0:(A&&(y=y.toLowerCase(),k=k.toLowerCase()),y.indexOf(k))}function l(y){const k=y.split(":");let A,p,v;for(const F of k){const N=Number(F);(0,L.$gg)(N)?p===void 0?p=N:v===void 0&&(v=N):A=A?[A,F].join(":"):F}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:p!==void 0?p:void 0,column:v!==void 0?v:p!==void 0?1:void 0}}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(y,k,A=8){let p="";for(let F=0;F<A;F++){let N;F===0&&C.$j&&!k&&(A===3||A===4)?N=E:N=g,p+=N.charAt(Math.floor(Math.random()*N.length))}let v;return k?v=`${k}-${p}`:v=p,y?(0,h.$ic)(y,v):v}}),define(Se[135],De([1,0,26,28,179,12]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.FuzzyScore=e.$Fk=e.$Ek=void 0,e.or=L,e.$Gk=b,e.$Hk=c,e.$Ik=u,e.$Jk=D,e.$Kk=y,e.$Lk=N,e.$Mk=O,e.$Nk=j,e.$Ok=z,e.$Pk=se,e.$Rk=le,e.$Sk=pe,e.$Tk=we,R=Ue(R);function L(...Ce){return function(Ie,Pe){for(let q=0,H=Ce.length;q<H;q++){const X=Ce[q](Ie,Pe);if(X)return X}return null}}e.$Ek=T.bind(void 0,!1),e.$Fk=T.bind(void 0,!0);function T(Ce,Ie,Pe){if(!Pe||Pe.length<Ie.length)return null;let q;return Ce?q=R.$Ef(Pe,Ie):q=Pe.indexOf(Ie)===0,q?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function b(Ce,Ie){const Pe=Ie.toLowerCase().indexOf(Ce.toLowerCase());return Pe===-1?null:[{start:Pe,end:Pe+Ce.length}]}function c(Ce,Ie){return I(Ce.toLowerCase(),Ie.toLowerCase(),0,0)}function I(Ce,Ie,Pe,q){if(Pe===Ce.length)return[];if(q===Ie.length)return null;if(Ce[Pe]===Ie[q]){let H=null;return(H=I(Ce,Ie,Pe+1,q+1))?t({start:q,end:q+1},H):null}return I(Ce,Ie,Pe,q+1)}function S(Ce){return r.CharCode.a<=Ce&&Ce<=r.CharCode.z}function u(Ce){return r.CharCode.A<=Ce&&Ce<=r.CharCode.Z}function P(Ce){return r.CharCode.Digit0<=Ce&&Ce<=r.CharCode.Digit9}function w(Ce){return Ce===r.CharCode.Space||Ce===r.CharCode.Tab||Ce===r.CharCode.LineFeed||Ce===r.CharCode.CarriageReturn}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Ce=>a.add(Ce.charCodeAt(0)));function m(Ce){return w(Ce)||a.has(Ce)}function $(Ce,Ie){return Ce===Ie||m(Ce)&&m(Ie)}const f=new Map;function i(Ce){if(f.has(Ce))return f.get(Ce);let Ie;const Pe=(0,C.$Ck)(Ce);return Pe&&(Ie=Pe),f.set(Ce,Ie),Ie}function s(Ce){return S(Ce)||u(Ce)||P(Ce)}function t(Ce,Ie){return Ie.length===0?Ie=[Ce]:Ce.end===Ie[0].start?Ie[0].start=Ce.start:Ie.unshift(Ce),Ie}function o(Ce,Ie){for(let Pe=Ie;Pe<Ce.length;Pe++){const q=Ce.charCodeAt(Pe);if(u(q)||P(q)||Pe>0&&!s(Ce.charCodeAt(Pe-1)))return Pe}return Ce.length}function n(Ce,Ie,Pe,q){if(Pe===Ce.length)return[];if(q===Ie.length)return null;if(Ce[Pe]!==Ie[q].toLowerCase())return null;{let H=null,X=q+1;for(H=n(Ce,Ie,Pe+1,q+1);!H&&(X=o(Ie,X))<Ie.length;)H=n(Ce,Ie,Pe+1,X),X++;return H===null?null:t({start:q,end:q+1},H)}}function d(Ce){let Ie=0,Pe=0,q=0,H=0,X=0;for(let He=0;He<Ce.length;He++)X=Ce.charCodeAt(He),u(X)&&Ie++,S(X)&&Pe++,s(X)&&q++,P(X)&&H++;const Z=Ie/Ce.length,de=Pe/Ce.length,be=q/Ce.length,Oe=H/Ce.length;return{upperPercent:Z,lowerPercent:de,alphaPercent:be,numericPercent:Oe}}function l(Ce){const{upperPercent:Ie,lowerPercent:Pe}=Ce;return Pe===0&&Ie>.6}function g(Ce){const{upperPercent:Ie,lowerPercent:Pe,alphaPercent:q,numericPercent:H}=Ce;return Pe>.2&&Ie<.8&&q>.6&&H<.2}function E(Ce){let Ie=0,Pe=0,q=0,H=0;for(let X=0;X<Ce.length;X++)q=Ce.charCodeAt(X),u(q)&&Ie++,S(q)&&Pe++,w(q)&&H++;return(Ie===0||Pe===0)&&H===0?Ce.length<=30:Ie<=5}function D(Ce,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!E(Ce))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Pe=d(Ie);if(!g(Pe)){if(!l(Pe))return null;Ie=Ie.toLowerCase()}let q=null,H=0;for(Ce=Ce.toLowerCase();H<Ie.length&&(q=n(Ce,Ie,0,H))===null;)H=o(Ie,H+1);return q}function y(Ce,Ie,Pe=!1){if(!Ie||Ie.length===0)return null;let q=null,H=0;for(Ce=Ce.toLowerCase(),Ie=Ie.toLowerCase();H<Ie.length&&(q=k(Ce,Ie,0,H,Pe),q===null);)H=A(Ie,H+1);return q}function k(Ce,Ie,Pe,q,H){let X=0;if(Pe===Ce.length)return[];if(q===Ie.length)return null;if(!$(Ce.charCodeAt(Pe),Ie.charCodeAt(q))){const be=i(Ce.charCodeAt(Pe));if(!be)return null;for(let Oe=0;Oe<be.length;Oe++)if(!$(be[Oe],Ie.charCodeAt(q+Oe)))return null;X+=be.length-1}let Z=null,de=q+X+1;if(Z=k(Ce,Ie,Pe+1,de,H),!H)for(;!Z&&(de=A(Ie,de))<Ie.length;)Z=k(Ce,Ie,Pe+1,de,H),de++;if(!Z)return null;if(Ce.charCodeAt(Pe)!==Ie.charCodeAt(q)){const be=i(Ce.charCodeAt(Pe));if(!be)return Z;for(let Oe=0;Oe<be.length;Oe++)if(be[Oe]!==Ie.charCodeAt(q+Oe))return Z}return t({start:q,end:q+X+1},Z)}function A(Ce,Ie){for(let Pe=Ie;Pe<Ce.length;Pe++)if(m(Ce.charCodeAt(Pe))||Pe>0&&m(Ce.charCodeAt(Pe-1)))return Pe;return Ce.length}const p=L(e.$Fk,D,b),v=L(e.$Fk,D,c),F=new h.$Cc(1e4);function N(Ce,Ie,Pe=!1){if(typeof Ce!="string"||typeof Ie!="string")return null;let q=F.get(Ce);q||(q=new RegExp(R.$mf(Ce),"i"),F.set(Ce,q));const H=q.exec(Ie);return H?[{start:H.index,end:H.index+H[0].length}]:Pe?v(Ce,Ie):p(Ce,Ie)}function O(Ce,Ie){const Pe=le(Ce,Ce.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Pe?z(Pe):null}function j(Ce,Ie,Pe,q,H,X){const Z=Math.min(13,Ce.length);for(;Pe<Z;Pe++){const de=le(Ce,Ie,Pe,q,H,X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(de)return de}return[0,X]}function z(Ce){if(typeof Ce>"u")return[];const Ie=[],Pe=Ce[1];for(let q=Ce.length-1;q>1;q--){const H=Ce[q]+Pe,X=Ie[Ie.length-1];X&&X.end===H?X.end=H+1:Ie.push({start:H,end:H+1})}return Ie}const M=128;function W(){const Ce=[],Ie=[];for(let Pe=0;Pe<=M;Pe++)Ie[Pe]=0;for(let Pe=0;Pe<=M;Pe++)Ce.push(Ie.slice(0));return Ce}function V(Ce){const Ie=[];for(let Pe=0;Pe<=Ce;Pe++)Ie[Pe]=0;return Ie}const ne=V(2*M),B=V(2*M),K=W(),Y=W(),ee=W(),ue=!1;function re(Ce,Ie,Pe,q,H){function X(de,be,Oe=" "){for(;de.length<be;)de=Oe+de;return de}let Z=` |   |${q.split("").map(de=>X(de,3)).join("|")}
`;for(let de=0;de<=Pe;de++)de===0?Z+=" |":Z+=`${Ie[de-1]}|`,Z+=Ce[de].slice(0,H+1).map(be=>X(be.toString(),3)).join("|")+`
`;return Z}function ye(Ce,Ie,Pe,q){Ce=Ce.substr(Ie),Pe=Pe.substr(q),console.log(re(Y,Ce,Ce.length,Pe,Pe.length)),console.log(re(ee,Ce,Ce.length,Pe,Pe.length)),console.log(re(K,Ce,Ce.length,Pe,Pe.length))}function me(Ce,Ie){if(Ie<0||Ie>=Ce.length)return!1;const Pe=Ce.codePointAt(Ie);switch(Pe){case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.Slash:case r.CharCode.Backslash:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:case r.CharCode.DollarSign:case r.CharCode.LessThan:case r.CharCode.GreaterThan:case r.CharCode.OpenParen:case r.CharCode.CloseParen:case r.CharCode.OpenSquareBracket:case r.CharCode.CloseSquareBracket:case r.CharCode.OpenCurlyBrace:case r.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!R.$Wf(Pe)}}function J(Ce,Ie){if(Ie<0||Ie>=Ce.length)return!1;switch(Ce.charCodeAt(Ie)){case r.CharCode.Space:case r.CharCode.Tab:return!0;default:return!1}}function U(Ce,Ie,Pe){return Ie[Ce]!==Pe[Ce]}function se(Ce,Ie,Pe,q,H,X,Z=!1){for(;Ie<Pe&&H<X;)Ce[Ie]===q[H]&&(Z&&(ne[Ie]=H),Ie+=1),H+=1;return Ie===Pe}var ae;(function(Ce){Ce[Ce.Diag=1]="Diag",Ce[Ce.Left=2]="Left",Ce[Ce.LeftLeft=3]="LeftLeft"})(ae||(ae={}));var te;(function(Ce){Ce.Default=[-100,0];function Ie(Pe){return!Pe||Pe.length===2&&Pe[0]===-100&&Pe[1]===0}Ce.isDefault=Ie})(te||(e.FuzzyScore=te={}));class ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Pe){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Pe}}e.$Qk=ce;function le(Ce,Ie,Pe,q,H,X,Z=ce.default){const de=Ce.length>M?M:Ce.length,be=q.length>M?M:q.length;if(Pe>=de||X>=be||de-Pe>be-X||!se(Ie,Pe,de,H,X,be,!0))return;x(de,be,Pe,X,Ie,H);let Oe=1,He=1,Qe=Pe,_e=X;const nt=[!1];for(Oe=1,Qe=Pe;Qe<de;Oe++,Qe++){const ht=ne[Qe],ct=B[Qe],ke=Qe+1<de?B[Qe+1]:be;for(He=ht-X+1,_e=ht;_e<ke;He++,_e++){let Be=Number.MIN_SAFE_INTEGER,Ke=!1;_e<=ct&&(Be=oe(Ce,Ie,Qe,Pe,q,H,_e,be,X,K[Oe-1][He-1]===0,nt));let Ne=0;Be!==Number.MAX_SAFE_INTEGER&&(Ke=!0,Ne=Be+Y[Oe-1][He-1]);const je=_e>ht,he=je?Y[Oe][He-1]+(K[Oe][He-1]>0?-5:0):0,_=_e>ht+1&&K[Oe][He-1]>0,Re=_?Y[Oe][He-2]+(K[Oe][He-2]>0?-5:0):0;if(_&&(!je||Re>=he)&&(!Ke||Re>=Ne))Y[Oe][He]=Re,ee[Oe][He]=ae.LeftLeft,K[Oe][He]=0;else if(je&&(!Ke||he>=Ne))Y[Oe][He]=he,ee[Oe][He]=ae.Left,K[Oe][He]=0;else if(Ke)Y[Oe][He]=Ne,ee[Oe][He]=ae.Diag,K[Oe][He]=K[Oe-1][He-1]+1;else throw new Error("not possible")}}if(ue&&ye(Ce,Pe,q,X),!nt[0]&&!Z.firstMatchCanBeWeak)return;Oe--,He--;const st=[Y[Oe][He],X];let rt=0,at=0;for(;Oe>=1;){let ht=He;do{const ct=ee[Oe][ht];if(ct===ae.LeftLeft)ht=ht-2;else if(ct===ae.Left)ht=ht-1;else break}while(ht>=1);rt>1&&Ie[Pe+Oe-1]===H[X+He-1]&&!U(ht+X-1,q,H)&&rt+1>K[Oe][ht]&&(ht=He),ht===He?rt++:rt=1,at||(at=ht),Oe--,He=ht-1,st.push(He)}be-X===de&&Z.boostFullMatch&&(st[0]+=2);const mt=at-de;return st[0]-=mt,st}function x(Ce,Ie,Pe,q,H,X){let Z=Ce-1,de=Ie-1;for(;Z>=Pe&&de>=q;)H[Z]===X[de]&&(B[Z]=de,Z--),de--}function oe(Ce,Ie,Pe,q,H,X,Z,de,be,Oe,He){if(Ie[Pe]!==X[Z])return Number.MIN_SAFE_INTEGER;let Qe=1,_e=!1;return Z===Pe-q?Qe=Ce[Pe]===H[Z]?7:5:U(Z,H,X)&&(Z===0||!U(Z-1,H,X))?(Qe=Ce[Pe]===H[Z]?7:5,_e=!0):me(X,Z)&&(Z===0||!me(X,Z-1))?Qe=5:(me(X,Z-1)||J(X,Z-1))&&(Qe=5,_e=!0),Qe>1&&Pe===q&&(He[0]=!0),_e||(_e=U(Z,H,X)||me(X,Z-1)||J(X,Z-1)),Pe===q?Z>be&&(Qe-=_e?3:5):Oe?Qe+=_e?2:0:Qe+=_e?0:1,Z+1===de&&(Qe-=_e?3:5),Qe}function pe(Ce,Ie,Pe,q,H,X,Z){return Fe(Ce,Ie,Pe,q,H,X,!0,Z)}function we(Ce,Ie,Pe,q,H,X,Z){return Fe(Ce,Ie,Pe,q,H,X,!1,Z)}function Fe(Ce,Ie,Pe,q,H,X,Z,de){let be=le(Ce,Ie,Pe,q,H,X,de);if(be&&!Z)return be;if(Ce.length>=3){const Oe=Math.min(7,Ce.length-1);for(let He=Pe+1;He<Oe;He++){const Qe=ze(Ce,He);if(Qe){const _e=le(Qe,Qe.toLowerCase(),Pe,q,H,X,de);_e&&(_e[0]-=3,(!be||_e[0]>be[0])&&(be=_e))}}}return be}function ze(Ce,Ie){if(Ie+1>=Ce.length)return;const Pe=Ce[Ie],q=Ce[Ie+1];if(Pe!==q)return Ce.slice(0,Ie)+q+Pe+Ce.slice(Ie+2)}}),define(Se[60],De([1,0,12]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$uj=void 0,e.$qj=h,e.$rj=C,e.$sj=R,e.$tj=T,e.$vj=a,r=Ue(r);function h($){return C($,0)}function C($,f){switch(typeof $){case"object":return $===null?R(349,f):Array.isArray($)?b($,f):c($,f);case"string":return T($,f);case"boolean":return L($,f);case"number":return R($,f);case"undefined":return R(937,f);default:return R(617,f)}}function R($,f){return(f<<5)-f+$|0}function L($,f){return R($?433:863,f)}function T($,f){f=R(149417,f);for(let i=0,s=$.length;i<s;i++)f=R($.charCodeAt(i),f);return f}function b($,f){return f=R(104579,f),$.reduce((i,s)=>C(s,i),f)}function c($,f){return f=R(181387,f),Object.keys($).sort().reduce((i,s)=>(i=T(s,i),C($[s],i)),f)}class I{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=C(f,this.g),this.g}}e.$uj=I;var S;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function u($,f,i=32){const s=i-f,t=~((1<<s)-1);return($<<f|(t&$)>>>s)>>>0}function P($,f=0,i=$.byteLength,s=0){for(let t=0;t<i;t++)$[f+t]=s}function w($,f,i="0"){for(;$.length<f;)$=i+$;return $}function a($,f=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(i=>i.toString(16).padStart(2,"0")).join(""):w(($>>>0).toString(16),f/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(S.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const i=f.length;if(i===0)return;const s=this.p;let t=this.r,o=this.u,n,d;for(o!==0?(n=o,d=-1,o=0):(n=f.charCodeAt(0),d=0);;){let l=n;if(r.$Hf(n))if(d+1<i){const g=f.charCodeAt(d+1);r.$If(g)?(d++,l=r.$Jf(n,g)):l=S.UNICODE_REPLACEMENT}else{o=n;break}else r.$If(n)&&(l=S.UNICODE_REPLACEMENT);if(t=this.w(s,t,l),d++,d<i)n=f.charCodeAt(d);else break}this.r=t,this.u=o}w(f,i,s){return s<128?f[i++]=s:s<2048?(f[i++]=192|(s&1984)>>>6,f[i++]=128|(s&63)>>>0):s<65536?(f[i++]=224|(s&61440)>>>12,f[i++]=128|(s&4032)>>>6,f[i++]=128|(s&63)>>>0):(f[i++]=240|(s&1835008)>>>18,f[i++]=128|(s&258048)>>>12,f[i++]=128|(s&4032)>>>6,f[i++]=128|(s&63)>>>0),i>=S.BLOCK_SIZE&&(this.y(),i-=S.BLOCK_SIZE,this.t+=S.BLOCK_SIZE,f[0]=f[S.BLOCK_SIZE+0],f[1]=f[S.BLOCK_SIZE+1],f[2]=f[S.BLOCK_SIZE+2]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,S.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,P(this.p,this.r),this.r>56&&(this.y(),P(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=m.g,i=this.q;for(let D=0;D<64;D+=4)f.setUint32(D,i.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)f.setUint32(D,u(f.getUint32(D-12,!1)^f.getUint32(D-32,!1)^f.getUint32(D-56,!1)^f.getUint32(D-64,!1),1),!1);let s=this.h,t=this.l,o=this.m,n=this.n,d=this.o,l,g,E;for(let D=0;D<80;D++)D<20?(l=t&o|~t&n,g=1518500249):D<40?(l=t^o^n,g=1859775393):D<60?(l=t&o|t&n|o&n,g=2400959708):(l=t^o^n,g=3395469782),E=u(s,5)+l+d+g+f.getUint32(D*4,!1)&4294967295,d=n,n=o,o=u(t,30),t=s,s=E;this.h=this.h+s&4294967295,this.l=this.l+t&4294967295,this.m=this.m+o&4294967295,this.n=this.n+n&4294967295,this.o=this.o+d&4294967295}}e.$wj=m}),define(Se[136],De([1,0,26,134,135,60,16,10,12]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=S,e.$Lr=$,e.$Mr=l,e.$Nr=p,e.$Or=z,e.$Pr=W;const c=0,I=[c,[]];function S(V,ne,B,K){if(!V||!ne)return I;const Y=V.length,ee=ne.length;if(Y<ee)return I;const ue=V.toLowerCase();return u(ne,B,ee,V,ue,Y,K)}function u(V,ne,B,K,Y,ee,ue){const re=[],ye=[];for(let se=0;se<B;se++){const ae=se*ee,te=ae-ee,ce=se>0,le=V[se],x=ne[se];for(let oe=0;oe<ee;oe++){const pe=oe>0,we=ae+oe,Fe=we-1,ze=te+oe-1,Ce=pe?re[Fe]:0,Ie=ce&&pe?re[ze]:0,Pe=ce&&pe?ye[ze]:0;let q;!Ie&&ce?q=0:q=P(le,x,K,Y,oe,Pe),q&&Ie+q>=Ce&&(ue||ce||Y.startsWith(ne,oe))?(ye[we]=Pe+1,re[we]=Ie+q):(ye[we]=c,re[we]=Ce)}}const me=[];let J=B-1,U=ee-1;for(;J>=0&&U>=0;){const se=J*ee+U;ye[se]===c||(me.push(U),J--),U--}return[re[B*ee-1],me.reverse()]}function P(V,ne,B,K,Y,ee){let ue=0;if(!w(ne,K[Y]))return ue;if(ue+=1,ee>0&&(ue+=ee*5),V===B[Y]&&(ue+=1),Y===0)ue+=8;else{const re=a(B.charCodeAt(Y-1));re?ue+=re:(0,C.$Ik)(B.charCodeAt(Y))&&ee===0&&(ue+=2)}return ue}function w(V,ne){return V===ne?!0:V==="/"||V==="\\"?ne==="/"||ne==="\\":!1}function a(V){switch(V){case r.CharCode.Slash:case r.CharCode.Backslash:return 5;case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:return 4;default:return 0}}const m=[void 0,[]];function $(V,ne,B=0,K=0){const Y=ne;return Y.values&&Y.values.length>1?f(V,Y.values,B,K):i(V,ne,B,K)}function f(V,ne,B,K){let Y=0;const ee=[];for(const ue of ne){const[re,ye]=i(V,ue,B,K);if(typeof re!="number")return m;Y+=re,ee.push(...ye)}return[Y,k(ee)]}function i(V,ne,B,K){const Y=(0,C.$Rk)(ne.original,ne.originalLowercase,B,V,V.toLowerCase(),K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Y?[Y[0],(0,C.$Ok)(Y)]:m}const s=Object.freeze({score:0}),t=1<<18,o=1<<17,n=65536;function d(V,ne,B,K){const Y=K.values?K.values:[K];return(0,R.$qj)({[K.normalized]:{values:Y.map(ue=>({value:ue.normalized,expectContiguousMatch:ue.expectContiguousMatch})),label:V,description:ne,allowNonContiguousMatches:B}})}function l(V,ne,B,K,Y){if(!V||!ne.normalized)return s;const ee=K.getItemLabel(V);if(!ee)return s;const ue=K.getItemDescription(V),re=d(ee,ue,B,ne),ye=Y[re];if(ye)return ye;const me=g(ee,ue,K.getItemPath(V),ne,B);return Y[re]=me,me}function g(V,ne,B,K,Y){const ee=!B||!K.containsPathSeparator;return B&&(T.$l?K.pathNormalized===B:(0,b.$Df)(K.pathNormalized,B))?{score:t,labelMatch:[{start:0,end:V.length}],descriptionMatch:ne?[{start:0,end:ne.length}]:void 0}:K.values&&K.values.length>1?E(V,ne,B,K.values,ee,Y):D(V,ne,B,K,ee,Y)}function E(V,ne,B,K,Y,ee){let ue=0;const re=[],ye=[];for(const me of K){const{score:J,labelMatch:U,descriptionMatch:se}=D(V,ne,B,me,Y,ee);if(J===c)return s;ue+=J,U&&re.push(...U),se&&ye.push(...se)}return{score:ue,labelMatch:k(re),descriptionMatch:k(ye)}}function D(V,ne,B,K,Y,ee){if(Y||!ne){const[ue,re]=S(V,K.normalized,K.normalizedLowercase,ee&&!K.expectContiguousMatch);if(ue){const ye=(0,C.$Fk)(K.normalized,V);let me;if(ye){me=o;const J=Math.round(K.normalized.length/V.length*100);me+=J}else me=n;return{score:me+ue,labelMatch:ye||y(re)}}}if(ne){let ue=ne;B&&(ue=`${ne}${L.sep}`);const re=ue.length,ye=`${ue}${V}`,[me,J]=S(ye,K.normalized,K.normalizedLowercase,ee&&!K.expectContiguousMatch);if(me){const U=y(J),se=[],ae=[];return U.forEach(te=>{te.start<re&&te.end>re?(se.push({start:0,end:te.end-re}),ae.push({start:te.start,end:re})):te.start>=re?se.push({start:te.start-re,end:te.end-re}):ae.push(te)}),{score:me,labelMatch:se,descriptionMatch:ae}}}return s}function y(V){const ne=[];if(!V)return ne;let B;for(const K of V)B&&B.end===K?B.end+=1:(B={start:K,end:K+1},ne.push(B));return ne}function k(V){const ne=V.sort((Y,ee)=>Y.start-ee.start),B=[];let K;for(const Y of ne)!K||!A(K,Y)?(K=Y,B.push(Y)):(K.start=Math.min(K.start,Y.start),K.end=Math.max(K.end,Y.end));return B}function A(V,ne){return!(V.end<ne.start||ne.end<V.start)}function p(V,ne,B,K,Y,ee){const ue=l(V,B,K,Y,ee),re=l(ne,B,K,Y,ee),ye=ue.score,me=re.score;if((ye===t||me===t)&&ye!==me)return ye===t?-1:1;if(ye>n||me>n){if(ye!==me)return ye>me?-1:1;if(ye<o&&me<o){const le=F(ue.labelMatch,re.labelMatch);if(le!==0)return le}const te=Y.getItemLabel(V)||"",ce=Y.getItemLabel(ne)||"";if(te.length!==ce.length)return te.length-ce.length}if(ye!==me)return ye>me?-1:1;const J=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0,U=Array.isArray(re.labelMatch)&&re.labelMatch.length>0;if(J&&!U)return-1;if(U&&!J)return 1;const se=v(V,ue,Y),ae=v(ne,re,Y);return se&&ae&&se!==ae?ae>se?-1:1:N(V,ne,B,Y)}function v(V,ne,B){let K=-1,Y=-1;if(ne.descriptionMatch&&ne.descriptionMatch.length?K=ne.descriptionMatch[0].start:ne.labelMatch&&ne.labelMatch.length&&(K=ne.labelMatch[0].start),ne.labelMatch&&ne.labelMatch.length){if(Y=ne.labelMatch[ne.labelMatch.length-1].end,ne.descriptionMatch&&ne.descriptionMatch.length){const ee=B.getItemDescription(V);ee&&(Y+=ee.length)}}else ne.descriptionMatch&&ne.descriptionMatch.length&&(Y=ne.descriptionMatch[ne.descriptionMatch.length-1].end);return Y-K}function F(V,ne){if(!V&&!ne||(!V||!V.length)&&(!ne||!ne.length))return 0;if(!ne||!ne.length)return-1;if(!V||!V.length)return 1;const B=V[0].start,Y=V[V.length-1].end-B,ee=ne[0].start,re=ne[ne.length-1].end-ee;return Y===re?0:re<Y?1:-1}function N(V,ne,B,K){const Y=K.getItemLabel(V)||"",ee=K.getItemLabel(ne)||"",ue=K.getItemDescription(V),re=K.getItemDescription(ne),ye=Y.length+(ue?ue.length:0),me=ee.length+(re?re.length:0);if(ye!==me)return ye-me;const J=K.getItemPath(V),U=K.getItemPath(ne);return J&&U&&J.length!==U.length?J.length-U.length:Y!==ee?(0,h.$Ir)(Y,ee,B.normalized):ue&&re&&ue!==re?(0,h.$Ir)(ue,re,B.normalized):J&&U&&J!==U?(0,h.$Ir)(J,U,B.normalized):0}function O(V){return V.startsWith('"')&&V.endsWith('"')}const j=" ";function z(V){typeof V!="string"&&(V="");const ne=V.toLowerCase(),{pathNormalized:B,normalized:K,normalizedLowercase:Y}=M(V),ee=B.indexOf(L.sep)>=0,ue=O(V);let re;const ye=V.split(j);if(ye.length>1)for(const me of ye){const J=O(me),{pathNormalized:U,normalized:se,normalizedLowercase:ae}=M(me);se&&(re||(re=[]),re.push({original:me,originalLowercase:me.toLowerCase(),pathNormalized:U,normalized:se,normalizedLowercase:ae,expectContiguousMatch:J}))}return{original:V,originalLowercase:ne,pathNormalized:B,normalized:K,normalizedLowercase:Y,values:re,containsPathSeparator:ee,expectContiguousMatch:ue}}function M(V){let ne;T.$j?ne=V.replace(/\//g,L.sep):ne=V.replace(/\\/g,L.sep);const B=(0,b.$nf)(ne).replace(/\s|"/g,"");return{pathNormalized:ne,normalized:B,normalizedLowercase:B.toLowerCase()}}function W(V){return Array.isArray(V)?z(V.map(ne=>ne.original).join(j)):z(V.original)}}),define(Se[137],De([1,0,135,12,50]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=b,e.$Vk=I,e.$Wk=u,e.$Xk=P,e.$Yk=a,e.$Zk=m;const R="$(",L=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${L.source}`,"g");function b($){return $.replace(T,(f,i)=>i?f:`\\${f}`)}const c=new RegExp(`\\\\${L.source}`,"g");function I($){return $.replace(c,f=>`\\${f}`)}const S=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function u($){return $.indexOf(R)===-1?$:$.replace(S,(f,i,s,t)=>s?f:i||t||"")}function P($){return $?$.replace(/\$\((.*?)\)/g,(f,i)=>` ${i} `).trim():""}const w=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function a($){w.lastIndex=0;let f="";const i=[];let s=0;for(;;){const t=w.lastIndex,o=w.exec($),n=$.substring(t,o?.index);if(n.length>0){f+=n;for(let d=0;d<n.length;d++)i.push(s)}if(!o)break;s+=o[0].length}return{text:f,iconOffsets:i}}function m($,f,i=!1){const{text:s,iconOffsets:t}=f;if(!t||t.length===0)return(0,r.$Lk)($,s,i);const o=(0,h.$kf)(s," "),n=s.length-o.length,d=(0,r.$Lk)($,o,i);if(d)for(const l of d){const g=t[l.start+n]+n;l.start+=g,l.end+=g}return d}}),define(Se[43],De([1,0,12]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=Ue(r);var h;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(h||(h={})),function(C){const R="error",L="warning",T="warn",b="info",c="ignore";function I(u){return u?r.$Df(R,u)?C.Error:r.$Df(L,u)||r.$Df(T,u)?C.Warning:r.$Df(b,u)?C.Info:C.Ignore:C.Ignore}C.fromValue=I;function S(u){switch(u){case C.Error:return R;case C.Warning:return L;case C.Info:return b;default:return c}}C.toString=S}(h||(h={})),e.default=h}),define(Se[84],De([1,0,18,26,12]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class R{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const a=w.charCodeAt(0),m=this.b.charCodeAt(this.c);return a-m}value(){return this.b[this.c]}}e.$Ei=R;class L{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===h.CharCode.Period)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,C.$xf)(w,this.b,0,w.length,this.c,this.d):(0,C.$zf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Fi=L;class T{constructor(w=!0,a=!0){this.f=w,this.g=a}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let a=w.length-1;a>=0;a--,this.c--){const m=this.b.charCodeAt(a);if(!(m===h.CharCode.Slash||this.f&&m===h.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const a=this.b.charCodeAt(this.e);if(a===h.CharCode.Slash||this.f&&a===h.CharCode.Backslash)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,C.$xf)(w,this.b,0,w.length,this.d,this.e):(0,C.$zf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Gi=T;var b;(function(P){P[P.Scheme=1]="Scheme",P[P.Authority=2]="Authority",P[P.Path=3]="Path",P[P.Query=4]="Query",P[P.Fragment=5]="Fragment"})(b||(b={}));class c{constructor(w,a){this.f=w,this.g=a,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(b.Scheme),this.c.authority&&this.d.push(b.Authority),this.c.path&&(this.b=new T(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(b.Path)),this.g(w)||(this.c.query&&this.d.push(b.Query),this.c.fragment&&this.d.push(b.Fragment)),this.e=0,this}next(){return this.d[this.e]===b.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===b.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===b.Scheme)return(0,C.$yf)(w,this.c.scheme);if(this.d[this.e]===b.Authority)return(0,C.$yf)(w,this.c.authority);if(this.d[this.e]===b.Path)return this.b.cmp(w);if(this.d[this.e]===b.Query)return(0,C.$wf)(w,this.c.query);if(this.d[this.e]===b.Fragment)return(0,C.$wf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===b.Scheme)return this.c.scheme;if(this.d[this.e]===b.Authority)return this.c.authority;if(this.d[this.e]===b.Path)return this.b.value();if(this.d[this.e]===b.Query)return this.c.query;if(this.d[this.e]===b.Fragment)return this.c.fragment;throw new Error}}e.$Hi=c;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(P){P[P.Left=-1]="Left",P[P.Mid=0]="Mid",P[P.Right=1]="Right"})(S||(S={}));class u{static forUris(w=()=>!1,a=()=>!1){return new u(new c(w,a))}static forPaths(w=!1){return new u(new T(void 0,!w))}static forStrings(){return new u(new R)}static forConfigKeys(){return new u(new L)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,a){if(a){const m=a.slice(0);(0,r.$Vb)(m);for(const $ of m)this.set($,w)}else{const m=w.slice(0);(0,r.$Vb)(m);for(const $ of m)this.set($[0],$[1])}}set(w,a){const m=this.b.reset(w);let $;this.c||(this.c=new I,this.c.segment=m.value());const f=[];for($=this.c;;){const s=m.cmp($.segment);if(s>0)$.left||($.left=new I,$.left.segment=m.value()),f.push([S.Left,$]),$=$.left;else if(s<0)$.right||($.right=new I,$.right.segment=m.value()),f.push([S.Right,$]),$=$.right;else if(m.hasNext())m.next(),$.mid||($.mid=new I,$.mid.segment=m.value()),f.push([S.Mid,$]),$=$.mid;else break}const i=$.value;$.value=a,$.key=w;for(let s=f.length-1;s>=0;s--){const t=f[s][1];t.updateHeight();const o=t.balanceFactor();if(o<-1||o>1){const n=f[s][0],d=f[s+1][0];if(n===S.Right&&d===S.Right)f[s][1]=t.rotateLeft();else if(n===S.Left&&d===S.Left)f[s][1]=t.rotateRight();else if(n===S.Right&&d===S.Left)t.right=f[s+1][1]=f[s+1][1].rotateRight(),f[s][1]=t.rotateLeft();else if(n===S.Left&&d===S.Right)t.left=f[s+1][1]=f[s+1][1].rotateLeft(),f[s][1]=t.rotateRight();else throw new Error;if(s>0)switch(f[s-1][0]){case S.Left:f[s-1][1].left=f[s][1];break;case S.Right:f[s-1][1].right=f[s][1];break;case S.Mid:f[s-1][1].mid=f[s][1];break}else this.c=f[0][1]}}return i}get(w){return this.d(w)?.value}d(w){const a=this.b.reset(w);let m=this.c;for(;m;){const $=a.cmp(m.segment);if($>0)m=m.left;else if($<0)m=m.right;else if(a.hasNext())a.next(),m=m.mid;else break}return m}has(w){const a=this.d(w);return!(a?.value===void 0&&a?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,a){const m=this.b.reset(w),$=[];let f=this.c;for(;f;){const i=m.cmp(f.segment);if(i>0)$.push([S.Left,f]),f=f.left;else if(i<0)$.push([S.Right,f]),f=f.right;else if(m.hasNext())m.next(),$.push([S.Mid,f]),f=f.mid;else break}if(f){if(a?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const i=this.f(f.right);if(i.key){const{key:s,value:t,segment:o}=i;this.e(i.key,!1),f.key=s,f.value=t,f.segment=o}}else{const i=f.left??f.right;if($.length>0){const[s,t]=$[$.length-1];switch(s){case S.Left:t.left=i;break;case S.Mid:t.mid=i;break;case S.Right:t.right=i;break}}else this.c=i}for(let i=$.length-1;i>=0;i--){const s=$[i][1];s.updateHeight();const t=s.balanceFactor();if(t>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),$[i][1]=s.rotateLeft()):t<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),$[i][1]=s.rotateRight()),i>0)switch($[i-1][0]){case S.Left:$[i-1][1].left=$[i][1];break;case S.Right:$[i-1][1].right=$[i][1];break;case S.Mid:$[i-1][1].mid=$[i][1];break}else this.c=$[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const a=this.b.reset(w);let m=this.c,$;for(;m;){const f=a.cmp(m.segment);if(f>0)m=m.left;else if(f<0)m=m.right;else if(a.hasNext())a.next(),$=m.value||$,m=m.mid;else break}return m&&m.value||$}findSuperstr(w){return this.g(w,!1)}g(w,a){const m=this.b.reset(w);let $=this.c;for(;$;){const f=m.cmp($.segment);if(f>0)$=$.left;else if(f<0)$=$.right;else if(m.hasNext())m.next(),$=$.mid;else return $.mid?this.h($.mid):a?$.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[a,m]of this)w(m,a)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const a=[];return this.j(w,a),a[Symbol.iterator]()}j(w,a){w&&(w.left&&this.j(w.left,a),w.value&&a.push([w.key,w.value]),w.mid&&this.j(w.mid,a),w.right&&this.j(w.right,a))}_isBalanced(){const w=a=>{if(!a)return!0;const m=a.balanceFactor();return m<-1||m>1?!1:w(a.left)&&w(a.right)};return w(this.c)}}e.$Ii=u}),define(Se[2],De([1,0,26,40,16,10]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$uc=m,e.$vc=o,C=Ue(C);const L=/^\w[\w\d+.-]*$/,T=/^\//,b=/^\/\//;function c(E,D){if(!E.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${E.authority}", path: "${E.path}", query: "${E.query}", fragment: "${E.fragment}"}`);if(E.scheme&&!L.test(E.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(E.path){if(E.authority){if(!T.test(E.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(E.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(E,D){return!E&&!D?"file":E}function S(E,D){switch(E){case"https":case"http":case"file":D?D[0]!==P&&(D=P+D):D=P;break}return D}const u="",P="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(D){return D instanceof a?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,y,k,A,p,v=!1){typeof D=="object"?(this.scheme=D.scheme||u,this.authority=D.authority||u,this.path=D.path||u,this.query=D.query||u,this.fragment=D.fragment||u):(this.scheme=I(D,v),this.authority=y||u,this.path=S(this.scheme,k||u),this.query=A||u,this.fragment=p||u,c(this,v))}get fsPath(){return o(this,!1)}with(D){if(!D)return this;let{scheme:y,authority:k,path:A,query:p,fragment:v}=D;return y===void 0?y=this.scheme:y===null&&(y=u),k===void 0?k=this.authority:k===null&&(k=u),A===void 0?A=this.path:A===null&&(A=u),p===void 0?p=this.query:p===null&&(p=u),v===void 0?v=this.fragment:v===null&&(v=u),y===this.scheme&&k===this.authority&&A===this.path&&p===this.query&&v===this.fragment?this:new f(y,k,A,p,v)}static parse(D,y=!1){const k=w.exec(D);return k?new f(k[2]||u,g(k[4]||u),g(k[5]||u),g(k[7]||u),g(k[9]||u),y):new f(u,u,u,u,u)}static file(D){let y=u;if(R.$j&&(D=D.replace(/\\/g,P)),D[0]===P&&D[1]===P){const k=D.indexOf(P,2);k===-1?(y=D.substring(2),D=P):(y=D.substring(2,k),D=D.substring(k)||P)}return new f("file",y,D,u,u)}static from(D,y){return new f(D.scheme,D.authority,D.path,D.query,D.fragment,y)}static joinPath(D,...y){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return R.$j&&D.scheme==="file"?k=a.file(C.$ec.join(o(D,!0),...y)).path:k=C.$fc.join(D.path,...y),D.with({path:k})}toString(D=!1){return n(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof a)return D;{const y=new f(D);return y._formatted=D.external??null,y._fsPath=D._sep===$?D.fsPath??null:null,y}}else return D}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=a;function m(E){return!E||typeof E!="object"?!1:typeof E.scheme=="string"&&(typeof E.authority=="string"||typeof E.authority>"u")&&(typeof E.path=="string"||typeof E.path>"u")&&(typeof E.query=="string"||typeof E.query>"u")&&(typeof E.fragment=="string"||typeof E.fragment>"u")}const $=R.$j?1:void 0;class f extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(D=!1){return D?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const D={$mid:h.MarshalledId.Uri};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=$),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const i={[r.CharCode.Colon]:"%3A",[r.CharCode.Slash]:"%2F",[r.CharCode.QuestionMark]:"%3F",[r.CharCode.Hash]:"%23",[r.CharCode.OpenSquareBracket]:"%5B",[r.CharCode.CloseSquareBracket]:"%5D",[r.CharCode.AtSign]:"%40",[r.CharCode.ExclamationMark]:"%21",[r.CharCode.DollarSign]:"%24",[r.CharCode.Ampersand]:"%26",[r.CharCode.SingleQuote]:"%27",[r.CharCode.OpenParen]:"%28",[r.CharCode.CloseParen]:"%29",[r.CharCode.Asterisk]:"%2A",[r.CharCode.Plus]:"%2B",[r.CharCode.Comma]:"%2C",[r.CharCode.Semicolon]:"%3B",[r.CharCode.Equals]:"%3D",[r.CharCode.Space]:"%20"};function s(E,D,y){let k,A=-1;for(let p=0;p<E.length;p++){const v=E.charCodeAt(p);if(v>=r.CharCode.a&&v<=r.CharCode.z||v>=r.CharCode.A&&v<=r.CharCode.Z||v>=r.CharCode.Digit0&&v<=r.CharCode.Digit9||v===r.CharCode.Dash||v===r.CharCode.Period||v===r.CharCode.Underline||v===r.CharCode.Tilde||D&&v===r.CharCode.Slash||y&&v===r.CharCode.OpenSquareBracket||y&&v===r.CharCode.CloseSquareBracket||y&&v===r.CharCode.Colon)A!==-1&&(k+=encodeURIComponent(E.substring(A,p)),A=-1),k!==void 0&&(k+=E.charAt(p));else{k===void 0&&(k=E.substr(0,p));const F=i[v];F!==void 0?(A!==-1&&(k+=encodeURIComponent(E.substring(A,p)),A=-1),k+=F):A===-1&&(A=p)}}return A!==-1&&(k+=encodeURIComponent(E.substring(A))),k!==void 0?k:E}function t(E){let D;for(let y=0;y<E.length;y++){const k=E.charCodeAt(y);k===r.CharCode.Hash||k===r.CharCode.QuestionMark?(D===void 0&&(D=E.substr(0,y)),D+=i[k]):D!==void 0&&(D+=E[y])}return D!==void 0?D:E}function o(E,D){let y;return E.authority&&E.path.length>1&&E.scheme==="file"?y=`//${E.authority}${E.path}`:E.path.charCodeAt(0)===r.CharCode.Slash&&(E.path.charCodeAt(1)>=r.CharCode.A&&E.path.charCodeAt(1)<=r.CharCode.Z||E.path.charCodeAt(1)>=r.CharCode.a&&E.path.charCodeAt(1)<=r.CharCode.z)&&E.path.charCodeAt(2)===r.CharCode.Colon?D?y=E.path.substr(1):y=E.path[1].toLowerCase()+E.path.substr(2):y=E.path,R.$j&&(y=y.replace(/\//g,"\\")),y}function n(E,D){const y=D?t:s;let k="",{scheme:A,authority:p,path:v,query:F,fragment:N}=E;if(A&&(k+=A,k+=":"),(p||A==="file")&&(k+=P,k+=P),p){let O=p.indexOf("@");if(O!==-1){const j=p.substr(0,O);p=p.substr(O+1),O=j.lastIndexOf(":"),O===-1?k+=y(j,!1,!1):(k+=y(j.substr(0,O),!1,!1),k+=":",k+=y(j.substr(O+1),!1,!0)),k+="@"}p=p.toLowerCase(),O=p.lastIndexOf(":"),O===-1?k+=y(p,!1,!0):(k+=y(p.substr(0,O),!1,!0),k+=p.substr(O))}if(v){if(v.length>=3&&v.charCodeAt(0)===r.CharCode.Slash&&v.charCodeAt(2)===r.CharCode.Colon){const O=v.charCodeAt(1);O>=r.CharCode.A&&O<=r.CharCode.Z&&(v=`/${String.fromCharCode(O+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===r.CharCode.Colon){const O=v.charCodeAt(0);O>=r.CharCode.A&&O<=r.CharCode.Z&&(v=`${String.fromCharCode(O+32)}:${v.substr(2)}`)}k+=y(v,!0,!1)}return F&&(k+="?",k+=y(F,!1,!1)),N&&(k+="#",k+=D?N:s(N,!1,!1)),k}function d(E){try{return decodeURIComponent(E)}catch{return E.length>3?E.substr(0,3)+d(E.substr(3)):E}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function g(E){return E.match(l)?E.replace(l,D=>d(D)):E}}),define(Se[188],De([1,0,2]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=h,e.$br=C,e.$cr=R,e.log=T;function h(c){const I=c;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function C(c){const I=[];let S;try{const u=JSON.parse(c.arguments),P=u[u.length-1];P&&P.__$stack&&(u.pop(),S=P.__$stack),I.push(...u)}catch{I.push("Unable to log remote console arguments",c.arguments)}return{args:I,stack:S}}function R(c){if(typeof c!="string")return R(C(c).stack);const I=c;if(I){const S=L(I),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(u&&u.length===4)return{uri:r.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function L(c){if(!c)return c;const I=c.indexOf(`
`);return I===-1?c:c.substring(0,I)}function T(c,I){const{args:S,stack:u}=C(c),P=typeof S[0]=="string"&&S.length===1;let w=L(u);w&&(w=`(${w.trim()})`);let a=[];if(typeof S[0]=="string"?w&&P?a=[`%c[${I}] %c${S[0]} %c${w}`,b("blue"),b(""),b("grey")]:a=[`%c[${I}] %c${S[0]}`,b("blue"),b(""),...S.slice(1)]:a=[`%c[${I}]%`,b("blue"),...S],w&&!P&&a.push(w),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,a)}function b(c){return`color: ${c}`}}),define(Se[51],De([1,0,21,2,40]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=R,e.$$h=L,e.$_h=b;function R(c){return JSON.stringify(c,T)}function L(c){let I=JSON.parse(c);return I=b(I),I}function T(c,I){return I instanceof RegExp?{$mid:C.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function b(c,I=0){if(!c||I>200)return c;if(typeof c=="object"){switch(c.$mid){case C.MarshalledId.Uri:return h.URI.revive(c);case C.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case C.MarshalledId.Date:return new Date(c.source)}if(c instanceof r.$Le||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let S=0;S<c.length;++S)c[S]=b(c[S],I+1);else for(const S in c)Object.hasOwnProperty.call(c,S)&&(c[S]=b(c[S],I+1))}return c}}),define(Se[14],De([1,0,13,10,12,2,16]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Pg=e.$Og=e.$Ng=e.Schemas=void 0,e.$Lg=b,e.$Mg=c,e.$Qg=S,r=Ue(r),h=Ue(h),L=Ue(L);var T;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatCodeBlock="vscode-chat-code-block",w.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",w.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm",w.commentsInput="comment",w.codeSetting="code-setting"})(T||(e.Schemas=T={}));function b(w,a){return R.URI.isUri(w)?(0,C.$Df)(w.scheme,a):(0,C.$Ef)(w,a+":")}function c(w,...a){return a.some(m=>b(w,m))}e.$Ng="vscode-tkn",e.$Og="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,m){this.f=S(a,m)}getServerRootPath(){return this.f}get g(){return L.$fc.join(this.f,T.vscodeRemoteResource)}set(a,m,$){this.a[a]=m,this.b[a]=$}setConnectionToken(a,m){this.c[a]=m}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(t){return r.$Y(t),a}const m=a.authority;let $=this.a[m];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const f=this.b[m],i=this.c[m];let s=`path=${encodeURIComponent(a.path)}`;return typeof i=="string"&&(s+=`&${e.$Og}=${encodeURIComponent(i)}`),R.URI.from({scheme:h.$p?this.d:T.vscodeRemoteResource,authority:`${$}:${f}`,path:this.g,query:s})}}e.$Pg=new I;function S(w,a){return L.$fc.join(a??"/",`${w.quality??"oss"}-${w.commit??"dev"}`)}e.$Rg="vs/../../extensions",e.$Sg="vs/../../node_modules",e.$Tg="vs/../../node_modules.asar",e.$Ug="vs/../../node_modules.asar.unpacked",e.$Vg="vscode-app";class u{static{this.a=e.$Vg}asBrowserUri(a){const m=this.b(a,$e);return this.uriToBrowserUri(m)}uriToBrowserUri(a){return a.scheme===T.vscodeRemote?e.$Pg.rewrite(a):a.scheme===T.file&&(h.$n||h.$r===`${T.vscodeFileResource}://${u.a}`)?a.with({scheme:T.vscodeFileResource,authority:a.authority||u.a,query:null,fragment:null}):a}asFileUri(a){const m=this.b(a,$e);return this.uriToFileUri(m)}uriToFileUri(a){return a.scheme===T.vscodeFileResource?a.with({scheme:T.file,authority:a.authority!==u.a?a.authority:null,query:null,fragment:null}):a}b(a,m){return R.URI.isUri(a)?a:R.URI.parse(m.toUrl(a))}}e.$Wg=new u;var P;(function(w){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(a.get("3"));const m="vscode-coi";function $(i){let s;typeof i=="string"?s=new URL(i).searchParams:i instanceof URL?s=i.searchParams:R.URI.isUri(i)&&(s=new URL(i.toString(!0)).searchParams);const t=s?.get(m);if(t)return a.get(t)}w.getHeadersFromQuery=$;function f(i,s,t){if(!globalThis.crossOriginIsolated)return;const o=s&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(m,o):i[m]=o}w.addSearchParam=f})(P||(e.COI=P={}))}),define(Se[189],De([1,0,174,14,10,17,2]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zE=S,e.$AE=u,C=Ue(C);class T{constructor(w,a,m){this.id=w,this.dependencies=a,this.callback=m}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,a,m)=>{typeof w!="string"&&(m=a,a=w,w=null),(typeof a!="object"||!Array.isArray(a))&&(m=a,a=null),this.c.push(new T(w,a,m))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const a=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!a)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(a.dependencies)&&a.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${a.dependencies.join(", ")}`);return typeof a.callback=="function"?a.callback([]):a.callback}h(w){return new Promise((a,m)=>{const $=document.createElement("script");$.setAttribute("async","async"),$.setAttribute("type","text/javascript");const f=()=>{$.removeEventListener("load",i),$.removeEventListener("error",s)},i=t=>{f(),a(this.c.pop())},s=t=>{f(),m(t)};$.addEventListener("load",i),$.addEventListener("error",s),this.f&&(w=this.f.createScriptURL(w)),$.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild($)})}i(w){return new Promise((a,m)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),a(this.c.pop())}catch($){m($)}})}async j(w){try{const a=globalThis._VSCODE_NODE_MODULES.fs,m=globalThis._VSCODE_NODE_MODULES.vm,$=globalThis._VSCODE_NODE_MODULES.module,f=L.URI.parse(w).fsPath,i=a.readFileSync(f).toString(),s=$.wrap(i.replace(/^#!.*/,""));return new m.Script(s).runInThisContext().apply(),this.c.pop()}catch(a){throw a}}}const c=new Map;let I={};typeof globalThis.require=="object"&&(I=globalThis.require.paths??{});async function S(P,w,a){if(r.$R){a===void 0&&(a=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),I[P]&&(P=I[P]);const m=w?`${P}/${w}`:P;if(c.has(m))return c.get(m);let $;if(/^\w[\w\d+.-]*:\/\//.test(m))$=m;else{const t=`${a&&!C.$p?h.$Tg:h.$Sg}/${m}`;$=h.$Wg.asBrowserUri(t).toString(!0)}const f=b.INSTANCE.load($);return c.set(m,f),f}else return await new Promise((m,$)=>{$e([P],m,$)}).then(Ue)}function u(P,w){(0,R.$mg)(r.$R);const $=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit&&!C.$p,f=`${P}/${w}`,s=`${$?h.$Tg:h.$Sg}/${f}`;return h.$Wg.asBrowserUri(s).toString(!0)}}),define(Se[22],De([1,0,26,31,14,16,10,12,2]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0,e.$4g=c,e.$mh=S,e.$nh=P,h=Ue(h),R=Ue(R);function c(w){return(0,b.$vc)(w,!0)}class I{constructor(a){this.a=a}compare(a,m,$=!1){return a===m?0:(0,T.$wf)(this.getComparisonKey(a,$),this.getComparisonKey(m,$))}isEqual(a,m,$=!1){return a===m?!0:!a||!m?!1:this.getComparisonKey(a,$)===this.getComparisonKey(m,$)}getComparisonKey(a,m=!1){return a.with({path:this.a(a)?a.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(a){return this.a(a)}isEqualOrParent(a,m,$=!1){if(a.scheme===m.scheme){if(a.scheme===C.Schemas.file)return h.$Bg(c(a),c(m),this.a(a))&&a.query===m.query&&($||a.fragment===m.fragment);if((0,e.$ih)(a.authority,m.authority))return h.$Bg(a.path,m.path,this.a(a),"/")&&a.query===m.query&&($||a.fragment===m.fragment)}return!1}joinPath(a,...m){return b.URI.joinPath(a,...m)}basenameOrAuthority(a){return(0,e.$ah)(a)||a.authority}basename(a){return R.$fc.basename(a.path)}extname(a){return R.$fc.extname(a.path)}dirname(a){if(a.path.length===0)return a;let m;return a.scheme===C.Schemas.file?m=b.URI.file(R.$lc(c(a))).path:(m=R.$fc.dirname(a.path),a.authority&&m.length&&m.charCodeAt(0)!==r.CharCode.Slash&&(console.error(`dirname("${a.toString})) resulted in a relative path`),m="/")),a.with({path:m})}normalizePath(a){if(!a.path.length)return a;let m;return a.scheme===C.Schemas.file?m=b.URI.file(R.$gc(c(a))).path:m=R.$fc.normalize(a.path),a.with({path:m})}relativePath(a,m){if(a.scheme!==m.scheme||!(0,e.$ih)(a.authority,m.authority))return;if(a.scheme===C.Schemas.file){const i=R.$kc(c(a),c(m));return L.$j?h.$vg(i):i}let $=a.path||"/";const f=m.path||"/";if(this.a(a)){let i=0;for(const s=Math.min($.length,f.length);i<s&&!($.charCodeAt(i)!==f.charCodeAt(i)&&$.charAt(i).toLowerCase()!==f.charAt(i).toLowerCase());i++);$=f.substr(0,i)+$.substr(i)}return R.$fc.relative($,f)}resolvePath(a,m){if(a.scheme===C.Schemas.file){const $=b.URI.file(R.$jc(c(a),m));return a.with({authority:$.authority,path:$.path})}return m=h.$wg(m),a.with({path:R.$fc.resolve(a.path,m)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,m){return a===m||a!==void 0&&m!==void 0&&(0,T.$Df)(a,m)}hasTrailingPathSeparator(a,m=R.sep){if(a.scheme===C.Schemas.file){const $=c(a);return $.length>h.$xg($).length&&$[$.length-1]===m}else{const $=a.path;return $.length>1&&$.charCodeAt($.length-1)===r.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,m=R.sep){return(0,e.$jh)(a,m)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,m=R.sep){let $=!1;if(a.scheme===C.Schemas.file){const f=c(a);$=f!==void 0&&f.length===h.$xg(f).length&&f[f.length-1]===m}else{m="/";const f=a.path;$=f.length===1&&f.charCodeAt(f.length-1)===r.CharCode.Slash}return!$&&!(0,e.$jh)(a,m)?a.with({path:a.path+"/"}):a}}e.$5g=I,e.$6g=new I(()=>!1),e.$7g=new I(w=>w.scheme===C.Schemas.file?!L.$l:!0),e.$8g=new I(w=>!0),e.$9g=e.$6g.isEqual.bind(e.$6g),e.$0g=e.$6g.isEqualOrParent.bind(e.$6g),e.$$g=e.$6g.getComparisonKey.bind(e.$6g),e.$_g=e.$6g.basenameOrAuthority.bind(e.$6g),e.$ah=e.$6g.basename.bind(e.$6g),e.$bh=e.$6g.extname.bind(e.$6g),e.$ch=e.$6g.dirname.bind(e.$6g),e.$dh=e.$6g.joinPath.bind(e.$6g),e.$eh=e.$6g.normalizePath.bind(e.$6g),e.$fh=e.$6g.relativePath.bind(e.$6g),e.$gh=e.$6g.resolvePath.bind(e.$6g),e.$hh=e.$6g.isAbsolutePath.bind(e.$6g),e.$ih=e.$6g.isEqualAuthority.bind(e.$6g),e.$jh=e.$6g.hasTrailingPathSeparator.bind(e.$6g),e.$kh=e.$6g.removeTrailingPathSeparator.bind(e.$6g),e.$lh=e.$6g.addTrailingPathSeparator.bind(e.$6g);function S(w,a){const m=[];for(let $=0;$<w.length;$++){const f=a(w[$]);w.some((i,s)=>s===$?!1:(0,e.$0g)(f,a(i)))||m.push(w[$])}return m}var u;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function a(m){const $=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(s=>{const[t,o]=s.split(":");t&&o&&$.set(t,o)});const i=m.path.substring(0,m.path.indexOf(";"));return i&&$.set(w.META_DATA_MIME,i),$}w.parseMetaData=a})(u||(e.DataUri=u={}));function P(w,a,m){if(a){let $=w.path;return $&&$[0]!==R.$fc.sep&&($=R.$fc.sep+$),w.with({scheme:m,authority:a,path:$})}return w.with({scheme:m})}}),define(Se[7],De([1,0,20,13,4,3,22,10,186,49]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.Promises=e.$Zh=e.$Yh=e.$Xh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$oh=I,e.$ph=S,e.$qh=u,e.$rh=P,e.$sh=w,e.$th=a,e.$uh=m,e.$vh=$,e.$Dh=E,e.$Eh=D,e.$Fh=y,e.$Gh=k,e.$Hh=A,e.$Wh=K,e.$5h=te;function I(le){return!!le&&typeof le.then=="function"}function S(le){const x=new r.$ue,oe=le(x.token),pe=new Promise((we,Fe)=>{const ze=x.token.onCancellationRequested(()=>{ze.dispose(),Fe(new h.$4)});Promise.resolve(oe).then(Ce=>{ze.dispose(),x.dispose(),we(Ce)},Ce=>{ze.dispose(),x.dispose(),Fe(Ce)})});return new class{cancel(){x.cancel(),x.dispose()}then(we,Fe){return pe.then(we,Fe)}catch(we){return this.then(void 0,we)}finally(we){return pe.finally(we)}}}function u(le,x,oe){return new Promise((pe,we)=>{const Fe=x.onCancellationRequested(()=>{Fe.dispose(),pe(oe)});le.then(pe,we).finally(()=>Fe.dispose())})}function P(le,x){return new Promise((oe,pe)=>{const we=x.onCancellationRequested(()=>{we.dispose(),pe(new h.$4)});le.then(oe,pe).finally(()=>we.dispose())})}async function w(le){let x=-1;const oe=le.map((pe,we)=>pe.then(Fe=>(x=we,Fe)));try{return await Promise.race(oe)}finally{le.forEach((pe,we)=>{we!==x&&pe.cancel()})}}function a(le,x,oe){let pe;const we=setTimeout(()=>{pe?.(void 0),oe?.()},x);return Promise.race([le.finally(()=>clearTimeout(we)),new Promise(Fe=>pe=Fe)])}function m(le){return new Promise((x,oe)=>{const pe=le();I(pe)?pe.then(x,oe):x(pe)})}function $(){let le,x;return{promise:new Promise((pe,we)=>{le=pe,x=we}),resolve:le,reject:x}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(x){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=x,!this.b){const oe=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(oe,oe).then(pe)})}return new Promise((oe,pe)=>{this.b.then(oe,pe)})}return this.a=x(),new Promise((oe,pe)=>{this.a.then(we=>{this.a=null,oe(we)},we=>{this.a=null,pe(we)})})}dispose(){this.f=!0}}e.$wh=f;class i{constructor(){this.a=Promise.resolve(null)}queue(x){return this.a=this.a.then(()=>x(),()=>x())}}e.$xh=i;class s{constructor(){this.a=new Map}queue(x,oe){const we=(this.a.get(x)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.a.get(x)===we&&this.a.delete(x)});return this.a.set(x,we),we}}e.$yh=s;const t=(le,x)=>{let oe=!0;const pe=setTimeout(()=>{oe=!1,x()},le);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(pe),oe=!1}}},o=le=>{let x=!0;return queueMicrotask(()=>{x&&(x=!1,le())}),{isTriggered:()=>x,dispose:()=>{x=!1}}};class n{constructor(x){this.defaultDelay=x,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(x,oe=this.defaultDelay){this.g=x,this.h(),this.b||(this.b=new Promise((we,Fe)=>{this.d=we,this.f=Fe}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=oe===b.$ee?o(pe):t(oe,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new h.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$zh=n;class d{constructor(x){this.a=new n(x),this.b=new f}trigger(x,oe){return this.a.trigger(()=>this.b.queue(x),oe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ah=d;class l{constructor(){this.a=!1,this.b=new Promise((x,oe)=>{this.d=x})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Bh=l;class g extends l{constructor(x){super(),this.f=setTimeout(()=>this.open(),x)}open(){clearTimeout(this.f),super.open()}}e.$Ch=g;function E(le,x){return x?new Promise((oe,pe)=>{const we=setTimeout(()=>{Fe.dispose(),oe()},le),Fe=x.onCancellationRequested(()=>{clearTimeout(we),Fe.dispose(),pe(new h.$4)})}):S(oe=>E(le,oe))}function D(le,x=0,oe){const pe=setTimeout(()=>{le(),oe&&we.dispose()},x),we=(0,R.$Rc)(()=>{clearTimeout(pe),oe?.deleteAndLeak(we)});return oe?.add(we),we}function y(le){const x=[];let oe=0;const pe=le.length;function we(){return oe<pe?le[oe++]():null}function Fe(ze){ze!=null&&x.push(ze);const Ce=we();return Ce?Ce.then(Fe):Promise.resolve(x)}return Promise.resolve(null).then(Fe)}function k(le,x=pe=>!!pe,oe=null){let pe=0;const we=le.length,Fe=()=>{if(pe>=we)return Promise.resolve(oe);const ze=le[pe++];return Promise.resolve(ze()).then(Ie=>x(Ie)?Promise.resolve(Ie):Fe())};return Fe()}function A(le,x=pe=>!!pe,oe=null){if(le.length===0)return Promise.resolve(oe);let pe=le.length;const we=()=>{pe=-1;for(const Fe of le)Fe.cancel?.()};return new Promise((Fe,ze)=>{for(const Ce of le)Ce.then(Ie=>{--pe>=0&&x(Ie)?(we(),Fe(Ie)):pe===0&&Fe(oe)}).catch(Ie=>{--pe>=0&&(we(),ze(Ie))})})}class p{constructor(x){this.a=0,this.b=!1,this.f=x,this.g=[],this.d=0,this.h=new C.$je}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(x){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((oe,pe)=>{this.g.push({factory:x,c:oe,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const x=this.g.shift();this.d++;const oe=x.factory();oe.then(x.c,x.e),oe.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ih=p;class v extends p{constructor(){super(1)}}e.$Jh=v;class F{constructor(){this.a=new Y,this.b=0}queue(x){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,x())):this.a.run(this.b++,x())}}e.$Kh=F;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const x=new re;return this.b.add(x),x.p}g(){for(const[,x]of this.a)if(x.size>0)return!1;return!0}queueSize(x,oe=L.$6g){const pe=oe.getComparisonKey(x);return this.a.get(pe)?.size??0}queueFor(x,oe,pe=L.$6g){const we=pe.getComparisonKey(x);let Fe=this.a.get(we);if(!Fe){Fe=new v;const ze=this.f++,Ce=C.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(ze),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$3c),this.d.set(ze,Ce),this.a.set(we,Fe)}return Fe.queue(oe)}h(){this.g()&&this.j()}j(){for(const x of this.b)x.complete();this.b.clear()}dispose(){for(const[,x]of this.a)x.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Lh=N;class O{constructor(x,oe){this.b=!1,this.a=-1,typeof x=="function"&&typeof oe=="number"&&this.setIfNotSet(x,oe)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(x,oe){if(this.b)throw new h.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,x()},oe)}setIfNotSet(x,oe){if(this.b)throw new h.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,x()},oe))}}e.$Mh=O;class j{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(x,oe,pe=globalThis){if(this.f)throw new h.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const we=pe.setInterval(()=>{x()},oe);this.d=(0,R.$Rc)(()=>{pe.clearInterval(we),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Nh=j;class z{constructor(x,oe){this.b=-1,this.a=x,this.d=oe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(x=this.d){this.cancel(),this.b=setTimeout(this.f,x)}get delay(){return this.d}set delay(x){this.d=x}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Oh=z;class M{constructor(x,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.a=x,this.b=oe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(x=this.b){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(x/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ph=M;class W extends z{constructor(x,oe){super(x,oe),this.j=[]}work(x){this.j.push(x),this.isScheduled()||this.schedule()}h(){const x=this.j;this.j=[],this.a?.(x)}dispose(){this.j=[],super.dispose()}}e.$Qh=W;class V extends R.$Tc{constructor(x,oe){super(),this.g=x,this.h=oe,this.a=[],this.b=this.B(new R.$Uc),this.f=!1}get pending(){return this.a.length}work(x){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+x.length>this.g.maxBufferedWork)return!1}else if(this.pending+x.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const oe of x)this.a.push(oe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Rh=V,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Th=(le,x)=>{(0,T.$C)(()=>{if(oe)return;const pe=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let oe=!1;return{dispose(){oe||(oe=!0)}}}:e.$Th=(le,x,oe)=>{const pe=le.requestIdleCallback(x,typeof oe=="number"?{timeout:oe}:void 0);let we=!1;return{dispose(){we||(we=!0,le.cancelIdleCallback(pe))}}},e.$Sh=le=>(0,e.$Th)(globalThis,le)}();class ne{constructor(x,oe){this.g=!1,this.d=()=>{try{this.j=oe()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Th)(x,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Uh=ne;class B extends ne{constructor(x){super(globalThis,x)}}e.$Vh=B;async function K(le,x,oe){let pe;for(let we=0;we<oe;we++)try{return await le()}catch(Fe){pe=Fe,await E(x)}throw pe}class Y{isRunning(x){return typeof x=="number"?this.a?.taskId===x:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(x,oe,pe){return this.a={taskId:x,cancel:()=>pe?.(),promise:oe},oe.then(()=>this.d(x),()=>this.d(x)),oe}d(x){this.a&&x===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const x=this.b;this.b=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}queue(x){if(this.b)this.b.run=x;else{const{promise:oe,resolve:pe,reject:we}=$();this.b={run:x,promise:oe,promiseResolve:pe,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xh=Y;class ee{constructor(x,oe=()=>Date.now()){this.d=x,this.f=oe,this.a=0,this.b=0}increment(){const x=this.f();return x-this.a>this.d&&(this.a=x,this.b=0),this.b++,this.b}}e.$Yh=ee;var ue;(function(le){le[le.Resolved=0]="Resolved",le[le.Rejected=1]="Rejected"})(ue||(ue={}));class re{get isRejected(){return this.d?.outcome===ue.Rejected}get isResolved(){return this.d?.outcome===ue.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ue.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((x,oe)=>{this.a=x,this.b=oe})}complete(x){return new Promise(oe=>{this.a(x),this.d={outcome:ue.Resolved,value:x},oe()})}error(x){return new Promise(oe=>{this.b(x),this.d={outcome:ue.Rejected,value:x},oe()})}cancel(){return this.error(new h.$4)}}e.$Zh=re;var ye;(function(le){async function x(pe){let we;const Fe=await Promise.all(pe.map(ze=>ze.then(Ce=>Ce,Ce=>{we||(we=Ce)})));if(typeof we<"u")throw we;return Fe}le.settled=x;function oe(pe){return new Promise(async(we,Fe)=>{try{await pe(we,Fe)}catch(ze){Fe(ze)}})}le.withAsyncBody=oe})(ye||(e.Promises=ye={}));class me{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(x){this.a=void 0,this.b=void 0,this.d=!1,this.promise=x.then(oe=>(this.a=oe,this.d=!0,oe),oe=>{throw this.b=oe,this.d=!0,oe})}requireValue(){if(!this.d)throw new h.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$1h=me;class J{constructor(x){this.b=x,this.a=new c.$T(()=>new me(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$2h=J;var U;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(U||(U={}));class se{static fromArray(x){return new se(oe=>{oe.emitMany(x)})}static fromPromise(x){return new se(async oe=>{oe.emitMany(await x)})}static fromPromises(x){return new se(async oe=>{await Promise.all(x.map(async pe=>oe.emitOne(await pe)))})}static merge(x){return new se(async oe=>{await Promise.all(x.map(async pe=>{for await(const we of pe)oe.emitOne(we)}))})}static{this.EMPTY=se.fromArray([])}constructor(x,oe){this.a=U.Initial,this.b=[],this.d=null,this.f=oe,this.g=new C.$je,queueMicrotask(async()=>{const pe={emitOne:we=>this.h(we),emitMany:we=>this.j(we),reject:we=>this.l(we)};try{await Promise.resolve(x(pe)),this.k()}catch(we){this.l(we)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let x=0;return{next:async()=>{do{if(this.a===U.DoneError)throw this.d;if(x<this.b.length)return{done:!1,value:this.b[x++]};if(this.a===U.DoneOK)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(x,oe){return new se(async pe=>{for await(const we of x)pe.emitOne(oe(we))})}map(x){return se.map(this,x)}static filter(x,oe){return new se(async pe=>{for await(const we of x)oe(we)&&pe.emitOne(we)})}filter(x){return se.filter(this,x)}static coalesce(x){return se.filter(x,oe=>!!oe)}coalesce(){return se.coalesce(this)}static async toPromise(x){const oe=[];for await(const pe of x)oe.push(pe);return oe}toPromise(){return se.toPromise(this)}h(x){this.a===U.Initial&&(this.b.push(x),this.g.fire())}j(x){this.a===U.Initial&&(this.b=this.b.concat(x),this.g.fire())}k(){this.a===U.Initial&&(this.a=U.DoneOK,this.g.fire())}l(x){this.a===U.Initial&&(this.a=U.DoneError,this.d=x,this.g.fire())}}e.$3h=se;class ae extends se{constructor(x,oe){super(oe),this.m=x}cancel(){this.m.cancel()}}e.$4h=ae;function te(le){const x=new r.$ue,oe=le(x.token);return new ae(x,async pe=>{const we=x.token.onCancellationRequested(()=>{we.dispose(),x.dispose(),pe.reject(new h.$4)});try{for await(const Fe of oe){if(x.token.isCancellationRequested)return;pe.emitOne(Fe)}we.dispose(),x.dispose()}catch(Fe){we.dispose(),x.dispose(),pe.reject(Fe)}})}class ce{constructor(x){this.a=new re,this.b=new se(we=>{if(oe){we.reject(oe);return}return pe&&we.emitMany(pe),this.d=Fe=>we.reject(Fe),this.f=Fe=>we.emitOne(Fe),this.a.p},x);let oe,pe;this.f=we=>{pe||(pe=[]),pe.push(we)},this.d=we=>{oe||(oe=we)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(x){this.d(x),this.a.complete()}emitOne(x){this.f(x)}}e.$6h=ce}),define(Se[38],De([1,0,18,7,26,31,28,16,10,12]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$sk=I,e.$vk=a,e.$wk=F,e.$xk=N,e.$yk=O,e.$zk=j,e.$Ak=z,e.$Bk=ne;function I(){return Object.create(null)}e.$tk="**",e.$uk="/";const S="[/\\\\]",u="[^/\\\\]",P=/\//g;function w(B,K){switch(B){case 0:return"";case 1:return`${u}*?`;default:return`(?:${S}|${u}+${S}${K?`|${S}${u}+`:""})*?`}}function a(B,K){if(!B)return[];const Y=[];let ee=!1,ue=!1,re="";for(const ye of B){switch(ye){case K:if(!ee&&!ue){Y.push(re),re="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}re+=ye}return re&&Y.push(re),Y}function m(B){if(!B)return"";let K="";const Y=a(B,e.$uk);if(Y.every(ee=>ee===e.$tk))K=".*";else{let ee=!1;Y.forEach((ue,re)=>{if(ue===e.$tk){if(ee)return;K+=w(2,re===Y.length-1)}else{let ye=!1,me="",J=!1,U="";for(const se of ue){if(se!=="}"&&ye){me+=se;continue}if(J&&(se!=="]"||!U)){let ae;se==="-"?ae=se:(se==="^"||se==="!")&&!U?ae="^":se===e.$uk?ae="":ae=(0,c.$ff)(se),U+=ae;continue}switch(se){case"{":ye=!0;continue;case"[":J=!0;continue;case"}":{const te=`(?:${a(me,",").map(ce=>m(ce)).join("|")})`;K+=te,ye=!1,me="";break}case"]":{K+="["+U+"]",J=!1,U="";break}case"?":K+=u;continue;case"*":K+=w(1);continue;default:K+=(0,c.$ff)(se)}}re<Y.length-1&&(Y[re+1]!==e.$tk||re+2<Y.length)&&(K+=S)}ee=ue===e.$tk})}return K}const $=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.$Cc(1e4),d=function(){return!1},l=function(){return null};function g(B,K){if(!B)return l;let Y;typeof B!="string"?Y=B.pattern:Y=B,Y=Y.trim();const ee=`${Y}_${!!K.trimForExclusions}`;let ue=n.get(ee);if(ue)return E(ue,B);let re;return $.test(Y)?ue=y(Y.substr(4),Y):(re=f.exec(D(Y,K)))?ue=k(re[1],Y):(K.trimForExclusions?s:i).test(Y)?ue=A(Y,K):(re=t.exec(D(Y,K)))?ue=p(re[1].substr(1),Y,!0):(re=o.exec(D(Y,K)))?ue=p(re[1],Y,!1):ue=v(Y),n.set(ee,ue),E(ue,B)}function E(B,K){if(typeof K=="string")return B;const Y=function(ee,ue){return(0,R.$Bg)(ee,K.base,!b.$l)?B((0,c.$kf)(ee.substr(K.base.length),T.sep),ue):null};return Y.allBasenames=B.allBasenames,Y.allPaths=B.allPaths,Y.basenames=B.basenames,Y.patterns=B.patterns,Y}function D(B,K){return K.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function y(B,K){return function(Y,ee){return typeof Y=="string"&&Y.endsWith(B)?K:null}}function k(B,K){const Y=`/${B}`,ee=`\\${B}`,ue=function(ye,me){return typeof ye!="string"?null:me?me===B?K:null:ye===B||ye.endsWith(Y)||ye.endsWith(ee)?K:null},re=[B];return ue.basenames=re,ue.patterns=[K],ue.allBasenames=re,ue}function A(B,K){const Y=V(B.slice(1,-1).split(",").map(me=>g(me,K)).filter(me=>me!==l),B),ee=Y.length;if(!ee)return l;if(ee===1)return Y[0];const ue=function(me,J){for(let U=0,se=Y.length;U<se;U++)if(Y[U](me,J))return B;return null},re=Y.find(me=>!!me.allBasenames);re&&(ue.allBasenames=re.allBasenames);const ye=Y.reduce((me,J)=>J.allPaths?me.concat(J.allPaths):me,[]);return ye.length&&(ue.allPaths=ye),ue}function p(B,K,Y){const ee=T.sep===T.$fc.sep,ue=ee?B:B.replace(P,T.sep),re=T.sep+ue,ye=T.$fc.sep+B;let me;return Y?me=function(J,U){return typeof J=="string"&&(J===ue||J.endsWith(re)||!ee&&(J===B||J.endsWith(ye)))?K:null}:me=function(J,U){return typeof J=="string"&&(J===ue||!ee&&J===B)?K:null},me.allPaths=[(Y?"*/":"./")+B],me}function v(B){try{const K=new RegExp(`^${m(B)}$`);return function(Y){return K.lastIndex=0,typeof Y=="string"&&K.test(Y)?B:null}}catch{return l}}function F(B,K,Y){return!B||typeof K!="string"?!1:N(B)(K,void 0,Y)}function N(B,K={}){if(!B)return d;if(typeof B=="string"||O(B)){const Y=g(B,K);if(Y===l)return d;const ee=function(ue,re){return!!Y(ue,re)};return Y.allBasenames&&(ee.allBasenames=Y.allBasenames),Y.allPaths&&(ee.allPaths=Y.allPaths),ee}return M(B,K)}function O(B){const K=B;return K?typeof K.base=="string"&&typeof K.pattern=="string":!1}function j(B){return B.allBasenames||[]}function z(B){return B.allPaths||[]}function M(B,K){const Y=V(Object.getOwnPropertyNames(B).map(me=>W(me,B[me],K)).filter(me=>me!==l)),ee=Y.length;if(!ee)return l;if(!Y.some(me=>!!me.requiresSiblings)){if(ee===1)return Y[0];const me=function(se,ae){let te;for(let ce=0,le=Y.length;ce<le;ce++){const x=Y[ce](se,ae);if(typeof x=="string")return x;(0,h.$oh)(x)&&(te||(te=[]),te.push(x))}return te?(async()=>{for(const ce of te){const le=await ce;if(typeof le=="string")return le}return null})():null},J=Y.find(se=>!!se.allBasenames);J&&(me.allBasenames=J.allBasenames);const U=Y.reduce((se,ae)=>ae.allPaths?se.concat(ae.allPaths):se,[]);return U.length&&(me.allPaths=U),me}const ue=function(me,J,U){let se,ae;for(let te=0,ce=Y.length;te<ce;te++){const le=Y[te];le.requiresSiblings&&U&&(J||(J=(0,T.$mc)(me)),se||(se=J.substr(0,J.length-(0,T.$nc)(me).length)));const x=le(me,J,se,U);if(typeof x=="string")return x;(0,h.$oh)(x)&&(ae||(ae=[]),ae.push(x))}return ae?(async()=>{for(const te of ae){const ce=await te;if(typeof ce=="string")return ce}return null})():null},re=Y.find(me=>!!me.allBasenames);re&&(ue.allBasenames=re.allBasenames);const ye=Y.reduce((me,J)=>J.allPaths?me.concat(J.allPaths):me,[]);return ye.length&&(ue.allPaths=ye),ue}function W(B,K,Y){if(K===!1)return l;const ee=g(B,Y);if(ee===l)return l;if(typeof K=="boolean")return ee;if(K){const ue=K.when;if(typeof ue=="string"){const re=(ye,me,J,U)=>{if(!U||!ee(ye,me))return null;const se=ue.replace("$(basename)",()=>J),ae=U(se);return(0,h.$oh)(ae)?ae.then(te=>te?B:null):ae?B:null};return re.requiresSiblings=!0,re}}return ee}function V(B,K){const Y=B.filter(me=>!!me.basenames);if(Y.length<2)return B;const ee=Y.reduce((me,J)=>{const U=J.basenames;return U?me.concat(U):me},[]);let ue;if(K){ue=[];for(let me=0,J=ee.length;me<J;me++)ue.push(K)}else ue=Y.reduce((me,J)=>{const U=J.patterns;return U?me.concat(U):me},[]);const re=function(me,J){if(typeof me!="string")return null;if(!J){let se;for(se=me.length;se>0;se--){const ae=me.charCodeAt(se-1);if(ae===C.CharCode.Slash||ae===C.CharCode.Backslash)break}J=me.substr(se)}const U=ee.indexOf(J);return U!==-1?ue[U]:null};re.basenames=ee,re.patterns=ue,re.allBasenames=ee;const ye=B.filter(me=>!me.basenames);return ye.push(re),ye}function ne(B,K){return(0,r.$tb)(B,K,(Y,ee)=>typeof Y=="string"&&typeof ee=="string"?Y===ee:typeof Y!="string"&&typeof ee!="string"?Y.base===ee.base&&Y.pattern===ee.pattern:!1)}}),define(Se[85],De([1,0,13,137,22,12,2]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.MarkdownStringTextNewlineStyle=void 0,e.$2k=c,e.$3k=I,e.$4k=S,e.$5k=u,e.$6k=P,e.$7k=w,e.$8k=a,e.$9k=m;var T;(function($){$[$.Paragraph=0]="Paragraph",$[$.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class b{constructor(f="",i=!1){if(this.value=f,typeof this.value!="string")throw(0,r.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(f,i=T.Paragraph){return this.value+=u(this.supportThemeIcons?(0,h.$Uk)(f):f).replace(/([ \t]+)/g,(s,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===T.Break?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,i){return this.value+=`
${P(i,f)}
`,this}appendLink(f,i,s){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(f),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(f,i){const s=new RegExp((0,R.$ff)(i),"g");return f.replace(s,(t,o)=>f.charAt(o-1)!=="\\"?`\\${t}`:t)}}e.$1k=b;function c($){return I($)?!$.value:Array.isArray($)?$.every(c):!0}function I($){return $ instanceof b?!0:$&&typeof $=="object"?typeof $.value=="string"&&(typeof $.isTrusted=="boolean"||typeof $.isTrusted=="object"||$.isTrusted===void 0)&&(typeof $.supportThemeIcons=="boolean"||$.supportThemeIcons===void 0):!1}function S($,f){return $===f?!0:!$||!f?!1:$.value===f.value&&$.isTrusted===f.isTrusted&&$.supportThemeIcons===f.supportThemeIcons&&$.supportHtml===f.supportHtml&&($.baseUri===f.baseUri||!!$.baseUri&&!!f.baseUri&&(0,C.$9g)(L.URI.from($.baseUri),L.URI.from(f.baseUri)))}function u($){return $.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function P($,f){const i=$.match(/^`+/gm)?.reduce((t,o)=>t.length>o.length?t:o).length??0,s=i>=3?i+1:3;return[`${"`".repeat(s)}${f}`,$,`${"`".repeat(s)}`].join(`
`)}function w($){return $.replace(/"/g,"&quot;")}function a($){return $&&$.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m($){const f=[],i=$.split("|").map(t=>t.trim());$=i[0];const s=i[1];if(s){const t=/height=(\d+)/.exec(s),o=/width=(\d+)/.exec(s),n=t?t[1]:"",d=o?o[1]:"",l=isFinite(parseInt(d)),g=isFinite(parseInt(n));l&&f.push(`width="${d}"`),g&&f.push(`height="${n}"`)}return{href:$,dimensions:f}}}),define(Se[107],De([1,0,18,31,16,10,22,12]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ww=b,e.$Xw=I,e.$Yw=u,e.$Zw=P,e.$1w=$,e.$2w=i,e.$3w=s,e.$4w=t,e.$5w=o,e.$6w=n;function b(l,g){const{os:E,tildify:D,relative:y}=g;if(y){const p=c(l,y,E);if(typeof p=="string")return p}let k=l.fsPath;if(E===R.OperatingSystem.Windows&&!R.$j?k=k.replace(/\//g,"\\"):E!==R.OperatingSystem.Windows&&R.$j&&(k=k.replace(/\\/g,"/")),E!==R.OperatingSystem.Windows&&D?.userHome){const p=D.userHome.fsPath;let v;l.scheme!==D.userHome.scheme&&l.path[0]===C.$fc.sep&&l.path[1]!==C.$fc.sep?v=D.userHome.with({path:l.path}).fsPath:v=k,k=u(v,p,E)}return(E===R.OperatingSystem.Windows?C.$ec:C.$fc).normalize(I(k,E===R.OperatingSystem.Windows))}function c(l,g,E){const D=E===R.OperatingSystem.Windows?C.$ec:C.$fc,y=E===R.OperatingSystem.Linux?L.$6g:L.$8g,k=g.getWorkspace(),A=(0,r.$Nb)(k.folders);if(!A)return;l.scheme!==A.uri.scheme&&l.path[0]===C.$fc.sep&&l.path[1]!==C.$fc.sep&&(l=A.uri.with({path:l.path}));const p=g.getWorkspaceFolder(l);if(!p)return;let v;if(y.isEqual(p.uri,l)?v="":v=y.relativePath(p.uri,l)??"",v&&(v=D.normalize(v)),k.folders.length>1&&!g.noPrefix){const F=p.name?p.name:y.basenameOrAuthority(p.uri);v=v?`${F} \u2022 ${v}`:F}return v}function I(l,g=R.$j){return(0,h.$Gg)(l,g)?l.charAt(0).toUpperCase()+l.slice(1):l}let S=Object.create(null);function u(l,g,E=R.OS){if(E===R.OperatingSystem.Windows||!l||!g)return l;let D=S.original===g?S.normalized:void 0;D||(D=g,R.$j&&(D=(0,h.$vg)(D)),D=`${(0,T.$lf)(D,C.$fc.sep)}${C.$fc.sep}`,S={original:g,normalized:D});let y=l;return R.$j&&(y=(0,h.$vg)(y)),(E===R.OperatingSystem.Linux?y.startsWith(D):(0,T.$Ef)(y,D))?`~/${y.substr(D.length)}`:l}function P(l,g){return l.replace(/^~($|\/|\\)/,`${g}$1`)}const w="\u2026",a="\\\\",m="~";function $(l,g=C.sep){const E=new Array(l.length);let D=!1;for(let y=0;y<l.length;y++){const k=l[y];if(k===""){E[y]=`.${g}`;continue}if(!k){E[y]=k;continue}D=!0;let A="",p=k;p.indexOf(a)===0?(A=p.substr(0,p.indexOf(a)+a.length),p=p.substr(p.indexOf(a)+a.length)):p.indexOf(g)===0?(A=p.substr(0,p.indexOf(g)+g.length),p=p.substr(p.indexOf(g)+g.length)):p.indexOf(m)===0&&(A=p.substr(0,p.indexOf(m)+m.length),p=p.substr(p.indexOf(m)+m.length));const v=p.split(g);for(let F=1;D&&F<=v.length;F++)for(let N=v.length-F;D&&N>=0;N--){D=!1;let O=v.slice(N,N+F).join(g);for(let j=0;!D&&j<l.length;j++)if(j!==y&&l[j]&&l[j].indexOf(O)>-1){const z=N+F===v.length,M=N>0&&l[j].indexOf(g)>-1?g+O:O,W=l[j].endsWith(M);D=!z||W}if(!D){let j="";(v[0].endsWith(":")||A!=="")&&(N===1&&(N=0,F++,O=v[0]+g+O),N>0&&(j=v[0]+g),j=A+j),N>0&&(j=j+w+g),j=j+O,N+F<v.length&&(j=j+g+w),E[y]=j}}D&&(E[y]=k)}return E}var f;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function i(l,g=Object.create(null)){const E=[];let D=!1,y="";for(const k of l)if(k==="$"||D&&k==="{")y&&E.push({value:y,type:f.TEXT}),y="",D=!0;else if(k==="}"&&D){const A=g[y];if(typeof A=="string")A.length&&E.push({value:A,type:f.VARIABLE});else if(A){const p=E[E.length-1];(!p||p.type!==f.SEPARATOR)&&E.push({value:A.label,type:f.SEPARATOR})}y="",D=!1}else y+=k;return y&&!D&&E.push({value:y,type:f.TEXT}),E.filter((k,A)=>{if(k.type===f.SEPARATOR){const p=E[A-1],v=E[A+1];return[p,v].every(F=>F&&(F.type===f.VARIABLE||F.type===f.TEXT)&&F.value.length>0)}return!0}).map(k=>k.value).join("")}function s(l,g){return R.$k||g?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$k?"&":"&&"):l.replace(/&&|&/g,E=>E==="&"?"&&":"&")}function t(l,g){return R.$k||g?l.replace(/\(&&\w\)|&&/g,""):R.$j?l.replace(/&&|&/g,E=>E==="&"?"&&":"&"):l.replace(/&&/g,"_")}function o(l){return l.replace(/&/g,"&&")}function n(l){if(l.endsWith("]")){const g=l.lastIndexOf(" [",l.length-2);if(g!==-1){const E=d(l.substring(0,g)),D=l.substring(g);return{name:E.name+D,parentPath:E.parentPath}}}return d(l)}function d(l){const g=l.indexOf("/")!==-1?C.$fc:C.$ec,E=g.basename(l),D=g.dirname(l);return E.length?{name:E,parentPath:D}:{name:D,parentPath:""}}}),define(Se[138],De([1,0,21,40,2]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=void 0,e.$Ln=b,e.$Mn=I,e.$Nn=S;function R(u){return u.toJSON()}class L{constructor(P){this.a=P}transformIncoming(P){const w=this.a.transformIncoming(P);return w===P?P:R(C.URI.from(w))}transformOutgoing(P){const w=this.a.transformOutgoing(P);return w===P?P:R(C.URI.from(w))}transformOutgoingURI(P){const w=this.a.transformOutgoing(P);return w===P?P:C.URI.from(w)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.$Jn=L,e.$Kn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function T(u,P,w){if(!u||w>200)return null;if(typeof u=="object"){if(u instanceof C.URI)return P.transformOutgoing(u);for(const a in u)if(Object.hasOwnProperty.call(u,a)){const m=T(u[a],P,w+1);m!==null&&(u[a]=m)}}return null}function b(u,P){const w=T(u,P,0);return w===null?u:w}function c(u,P,w,a){if(!u||a>200)return null;if(typeof u=="object"){if(u.$mid===h.MarshalledId.Uri)return w?C.URI.revive(P.transformIncoming(u)):P.transformIncoming(u);if(u instanceof r.$Le)return null;for(const m in u)if(Object.hasOwnProperty.call(u,m)){const $=c(u[m],P,w,a+1);$!==null&&(u[m]=$)}}return null}function I(u,P){const w=c(u,P,!1,0);return w===null?u:w}function S(u,P){const w=c(u,P,!0,0);return w===null?u:w}}),define(Se[32],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=h;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function h(C){return r.test(C)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(T){for(let b=0;b<T.length;b++)T[b]=Math.floor(Math.random()*256);return T};const R=new Uint8Array(16),L=[];for(let T=0;T<256;T++)L.push(T.toString(16).padStart(2,"0"));return function(){C(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let b=0,c="";return c+=L[R[b++]],c+=L[R[b++]],c+=L[R[b++]],c+=L[R[b++]],c+="-",c+=L[R[b++]],c+=L[R[b++]],c+="-",c+=L[R[b++]],c+=L[R[b++]],c+="-",c+=L[R[b++]],c+=L[R[b++]],c+="-",c+=L[R[b++]],c+=L[R[b++]],c+=L[R[b++]],c+=L[R[b++]],c+=L[R[b++]],c+=L[R[b++]],c}}()}),define(Se[190],De([1,0,18,39,32]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qu=e.$ou=void 0,e.$mu=R,e.$nu=L,e.$pu=c;function R(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}function L(S,u,P){const w={id:(0,C.$Yg)(),name:S,uri:u,data:P};return{asString:async()=>"",asFile:()=>w,value:void 0}}class T{constructor(){this.a=new Map}get size(){let u=0;for(const P of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const P=[...this.a.keys()];return h.Iterable.some(this,([w,a])=>a.asFile())&&P.push("files"),I(b(u),P)}get(u){return this.a.get(this.b(u))?.[0]}append(u,P){const w=this.a.get(u);w?w.push(P):this.a.set(this.b(u),[P])}replace(u,P){this.a.set(this.b(u),[P])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,P]of this.a)for(const w of P)yield[u,w]}b(u){return b(u)}}e.$ou=T;function b(S){return S.toLowerCase()}function c(S,u){return I(b(S),u.map(b))}function I(S,u){if(S==="*/*")return u.length>0;if(u.includes(S))return!0;const P=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!P)return!1;const[w,a,m]=P;return m==="*"?u.some($=>$.startsWith(a+"/")):!1}e.$qu=Object.freeze({create:S=>(0,r.$Lb)(S.map(u=>u.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$qu.split(S).filter(u=>!u.startsWith("#"))})}),define(Se[33],De([1,0,44,66,360,7,31,81,16,10,22,2]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=i,e.whenDeleted=o,e.configureFlushOnWrite=E,e.writeFileSync=y,r=Ue(r);var u;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(u||(e.RimRafMode=u={}));async function P(M,W=u.UNLINK,V){if((0,L.$Fg)(M))throw new Error("rimraf - will refuse to recursively delete root");return W===u.UNLINK?a(M):w(M,V)}async function w(M,W=(0,L.$Kg)((0,h.tmpdir)())){try{try{await r.promises.rename(M,W)}catch(V){return V.code==="ENOENT"?void 0:a(M)}a(W).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function a(M){return r.promises.rm(M,{recursive:!0,force:!0,maxRetries:3})}function m(M){if((0,L.$Fg)(M))throw new Error("rimraf - will refuse to recursively delete root");r.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}async function $(M,W){return s(await(W?f(M):r.promises.readdir(M)))}async function f(M){try{return await r.promises.readdir(M,{withFileTypes:!0})}catch(ne){console.warn("[node.js fs] readdir with filetypes failed with error: ",ne)}const W=[],V=await $(M);for(const ne of V){let B=!1,K=!1,Y=!1;try{const ee=await r.promises.lstat((0,b.$ic)(M,ne));B=ee.isFile(),K=ee.isDirectory(),Y=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}W.push({name:ne,isFile:()=>B,isDirectory:()=>K,isSymbolicLink:()=>Y})}return W}function i(M){return s(r.readdirSync(M))}function s(M){return M.map(W=>typeof W=="string"?c.$k?(0,T.$km)(W):W:(W.name=c.$k?(0,T.$km)(W.name):W.name,W))}async function t(M){const W=await $(M),V=[];for(const ne of W)await n.existsDirectory((0,b.$ic)(M,ne))&&V.push(ne);return V}function o(M,W=1e3){return new Promise(V=>{let ne=!1;const B=setInterval(()=>{ne||(ne=!0,r.access(M,K=>{ne=!1,K&&(clearInterval(B),V(void 0))}))},W)})}var n;(function(M){async function W(B){let K;try{if(K=await r.promises.lstat(B),!K.isSymbolicLink())return{stat:K}}catch{}try{return{stat:await r.promises.stat(B),symbolicLink:K?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};if(c.$j&&Y.code==="EACCES")try{return{stat:await r.promises.stat(await r.promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};throw ee}throw Y}}M.stat=W;async function V(B){try{const{stat:K,symbolicLink:Y}=await M.stat(B);return K.isFile()&&Y?.dangling!==!0}catch{}return!1}M.existsFile=V;async function ne(B){try{const{stat:K,symbolicLink:Y}=await M.stat(B);return K.isDirectory()&&Y?.dangling!==!0}catch{}return!1}M.existsDirectory=ne})(n||(e.SymlinkSupport=n={}));const d=new R.$Lh;function l(M,W,V){return d.queueFor(S.URI.file(M),()=>{const ne=k(V);return new Promise((B,K)=>D(M,W,ne,Y=>Y?K(Y):B()))},I.$7g)}let g=!0;function E(M){g=M}function D(M,W,V,ne){if(!g)return r.writeFile(M,W,{mode:V.mode,flag:V.flag},ne);r.open(M,V.flag,V.mode,(B,K)=>{if(B)return ne(B);r.writeFile(K,W,Y=>{if(Y)return r.close(K,()=>ne(Y));r.fdatasync(K,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),E(!1)),r.close(K,ue=>ne(ue))))})})}function y(M,W,V){const ne=k(V);if(!g)return r.writeFileSync(M,W,{mode:ne.mode,flag:ne.flag});const B=r.openSync(M,ne.flag,ne.mode);try{r.writeFileSync(B,W);try{r.fdatasyncSync(B)}catch(K){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",K),E(!1)}}finally{r.closeSync(B)}}function k(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function A(M,W,V=6e4){if(M!==W)try{c.$j&&typeof V=="number"?await p(M,W,Date.now(),V):await r.promises.rename(M,W)}catch(ne){if(M.toLowerCase()!==W.toLowerCase()&&ne.code==="EXDEV"||M.endsWith("."))await v(M,W,{preserveSymlinks:!1}),await P(M,u.MOVE);else throw ne}}async function p(M,W,V,ne,B=0){try{return await r.promises.rename(M,W)}catch(K){if(K.code!=="EACCES"&&K.code!=="EPERM"&&K.code!=="EBUSY")throw K;if(Date.now()-V>=ne)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${K}`),K;if(B===0){let Y=!1;try{const{stat:ee}=await n.stat(W);ee.isFile()||(Y=!0)}catch{}if(Y)throw K}return await(0,R.$Dh)(Math.min(100,B*10)),p(M,W,V,ne,B+1)}}async function v(M,W,V){return N(M,W,{root:{source:M,target:W},options:V,handledSourcePaths:new Set})}const F=511;async function N(M,W,V){if(V.handledSourcePaths.has(M))return;V.handledSourcePaths.add(M);const{stat:ne,symbolicLink:B}=await n.stat(M);if(B){if(V.options.preserveSymlinks)try{return await z(M,W,V)}catch{}if(B.dangling)return}return ne.isDirectory()?O(M,W,ne.mode&F,V):j(M,W,ne.mode&F)}async function O(M,W,V,ne){await r.promises.mkdir(W,{recursive:!0,mode:V});const B=await $(M);for(const K of B)await N((0,b.$ic)(M,K),(0,b.$ic)(W,K),ne)}async function j(M,W,V){await r.promises.copyFile(M,W),await r.promises.chmod(W,V)}async function z(M,W,V){let ne=await r.promises.readlink(M);(0,L.$Bg)(ne,V.root.source,!c.$l)&&(ne=(0,b.$ic)(V.root.target,ne.substr(V.root.source.length+1))),await r.promises.symlink(ne,W)}e.Promises=new class{get read(){return(M,W,V,ne,B)=>new Promise((K,Y)=>{r.read(M,W,V,ne,B,(ee,ue,re)=>ee?Y(ee):K({bytesRead:ue,buffer:re}))})}get write(){return(M,W,V,ne,B)=>new Promise((K,Y)=>{r.write(M,W,V,ne,B,(ee,ue,re)=>ee?Y(ee):K({bytesWritten:ue,buffer:re}))})}get fdatasync(){return(0,C.promisify)(r.fdatasync)}get open(){return(0,C.promisify)(r.open)}get close(){return(0,C.promisify)(r.close)}get realpath(){return(0,C.promisify)(r.realpath)}async exists(M){try{return await r.promises.access(M),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return P}get rename(){return A}get copy(){return v}}}),define(Se[108],De([1,0,44,16,10,12,33]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=T,e.$jr=b,e.$kr=c,e.$lr=I,r=Ue(r);function T(u){if(C.$l)return u;const P=(0,h.$lc)(u);if(u===P)return u;const w=((0,h.$mc)(u)||u).toLowerCase();try{const m=(0,L.readdirSync)(P).filter($=>$.toLowerCase()===w);if(m.length===1){const $=T(P);if($)return(0,h.$ic)($,m[0])}else if(m.length>1){const $=m.indexOf(w);if($>=0){const f=T(P);if(f)return(0,h.$ic)(f,m[$])}}}catch{}return null}async function b(u,P){if(C.$l)return u;const w=(0,h.$lc)(u);if(u===w)return u;const a=((0,h.$mc)(u)||u).toLowerCase();try{if(P?.isCancellationRequested)return null;const $=(await L.Promises.readdir(w)).filter(f=>f.toLowerCase()===a);if($.length===1){const f=await b(w,P);if(f)return(0,h.$ic)(f,$[0])}else if($.length>1){const f=$.indexOf(a);if(f>=0){const i=await b(w,P);if(i)return(0,h.$ic)(i,$[f])}}}catch{}return null}async function c(u){try{return await L.Promises.realpath(u)}catch{const w=S(u);return await r.promises.access(w,r.constants.R_OK),w}}function I(u){try{return r.realpathSync(u)}catch{const w=S(u);return r.accessSync(w,r.constants.R_OK),w}}function S(u){return(0,R.$lf)((0,h.$gc)(u),h.sep)}}),define(Se[191],De([1,0,67]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=h,e.$3g=R,r=Ue(r);function h(T,b,c,I=1){let S=!1;return new Promise(u=>{const P=setTimeout(()=>{if(!S)return S=!0,u(0)},c);C(T,b,I,w=>{if(!S)return S=!0,clearTimeout(P),u(w)})})}function C(T,b,c,I){if(b===0)return I(0);const S=new r.Socket;S.once("connect",()=>(L(S),C(T+c,b-1,c,I))),S.once("data",()=>{}),S.once("error",u=>(L(S),u.code!=="ECONNREFUSED"?C(T+c,b-1,c,I):I(T))),S.connect(T,"127.0.0.1")}e.$2g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(T,b,c,I="127.0.0.1"){let S=!1,u,P=1;const w=r.createServer({pauseOnConnect:!0});function a(m,$){S||(S=!0,w.removeAllListeners(),w.close(),u&&clearTimeout(u),$(m))}return new Promise(m=>{u=setTimeout(()=>{a(0,m)},c),w.on("listening",()=>{a(T,m)}),w.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&P<b?(T++,P++,w.listen(T,I)):a(0,m)}),w.on("close",()=>{a(0,m)}),w.listen(T,I)})}function L(T){try{T.removeAllListeners("connect"),T.removeAllListeners("error"),T.end(),T.destroy(),T.unref()}catch(b){console.error(b)}}}),define(Se[109],De([1,0,44,16,10,55,104,17,33]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$vm=c,e.$wm=I,h=Ue(h),C=Ue(C),R=Ue(R),T=Ue(T),b=Ue(b),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function c(u=R.env){return u.comspec||"cmd.exe"}function I(u){let P=[],w=!1;const a=function(m){if(w){P.push(m);return}(!u.send(m,f=>{if(f&&console.error(f),w=!1,P.length>0){const i=P.slice(0);P=[],i.forEach(s=>a(s))}})||C.$j)&&(w=!0)};return{send:a}}var S;(function(u){async function P(w,a,m){if(h.$hc(w))return w;if(a===void 0&&(a=R.cwd()),h.$lc(w)!=="."||(m===void 0&&T.$cg(R.env.PATH)&&(m=R.env.PATH.split(h.$sc)),m===void 0||m.length===0))return h.$ic(a,w);async function f(i){if(await b.Promises.exists(i)){let s;try{s=await r.promises.stat(i)}catch(t){t.message.startsWith("EACCES")&&(s=await r.promises.lstat(i))}return s?!s.isDirectory():!1}return!1}for(const i of m){let s;if(h.$hc(i)?s=h.$ic(i,w):s=h.$ic(a,i,w),await f(s))return s;let t=s+".com";if(await f(t)||(t=s+".exe",await f(t)))return t}return h.$ic(a,w)}u.findExecutable=P})(S||(e.win32=S={}))});var Ye=this&&this.__decorate||function($e,e,r,h){var C=arguments.length,R=C<3?e:h===null?h=Object.getOwnPropertyDescriptor(e,r):h,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate($e,e,r,h);else for(var T=$e.length-1;T>=0;T--)(L=$e[T])&&(R=(C<3?L(R):C>3?L(e,r,R):L(e,r))||R);return C>3&&R&&Object.defineProperty(e,r,R),R};define(Se[86],De([1,0,18,7,21,20,59,13,4,3,51,12,17]),function($e,e,r,h,C,R,L,T,b,c,I,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.ProxyChannel=e.$ki=e.$hi=e.$gi=e.$fi=e.RequestInitiator=e.$ei=e.$bi=e.$ai=void 0,e.$ci=E,e.$di=D,e.$ii=F,e.$ji=N,S=Ue(S);var P;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(P||(P={}));function w(B){switch(B){case P.Promise:return"req";case P.PromiseCancel:return"cancel";case P.EventListen:return"subscribe";case P.EventDispose:return"unsubscribe"}}var a;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(a||(a={}));function m(B){switch(B){case a.Initialize:return"init";case a.PromiseSuccess:return"reply:";case a.PromiseError:case a.PromiseErrorObj:return"replyErr:";case a.EventFire:return"event:"}}var $;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})($||($={}));function f(B){let K=0;for(let Y=0;;Y+=7){const ee=B.read(1);if(K|=(ee.buffer[0]&127)<<Y,!(ee.buffer[0]&128))return K}}const i=d(0);function s(B,K){if(K===0){B.write(i);return}let Y=0;for(let ue=K;ue!==0;ue=ue>>>7)Y++;const ee=C.$Le.alloc(Y);for(let ue=0;K!==0;ue++)ee.buffer[ue]=K&127,K=K>>>7,K>0&&(ee.buffer[ue]|=128);B.write(ee)}class t{constructor(K){this.b=K,this.a=0}read(K){const Y=this.b.slice(this.a,this.a+K);return this.a+=Y.byteLength,Y}}e.$ai=t;class o{constructor(){this.a=[]}get buffer(){return C.$Le.concat(this.a)}write(K){this.a.push(K)}}e.$bi=o;var n;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(n||(n={}));function d(B){const K=C.$Le.alloc(1);return K.writeUInt8(B,0),K}const l={Undefined:d(n.Undefined),String:d(n.String),Buffer:d(n.Buffer),VSBuffer:d(n.VSBuffer),Array:d(n.Array),Object:d(n.Object),Uint:d(n.Int)},g=typeof Buffer<"u";function E(B,K){if(typeof K>"u")B.write(l.Undefined);else if(typeof K=="string"){const Y=C.$Le.fromString(K);B.write(l.String),s(B,Y.byteLength),B.write(Y)}else if(g&&Buffer.isBuffer(K)){const Y=C.$Le.wrap(K);B.write(l.Buffer),s(B,Y.byteLength),B.write(Y)}else if(K instanceof C.$Le)B.write(l.VSBuffer),s(B,K.byteLength),B.write(K);else if(Array.isArray(K)){B.write(l.Array),s(B,K.length);for(const Y of K)E(B,Y)}else if(typeof K=="number"&&(K|0)===K)B.write(l.Uint),s(B,K);else{const Y=C.$Le.fromString(JSON.stringify(K));B.write(l.Object),s(B,Y.byteLength),B.write(Y)}}function D(B){switch(B.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return B.read(f(B)).toString();case n.Buffer:return B.read(f(B)).buffer;case n.VSBuffer:return B.read(f(B));case n.Array:{const Y=f(B),ee=[];for(let ue=0;ue<Y;ue++)ee.push(D(B));return ee}case n.Object:return JSON.parse(B.read(f(B)).toString());case n.Int:return f(B)}}class y{constructor(K,Y,ee=null,ue=1e3){this.h=K,this.j=Y,this.k=ee,this.l=ue,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.q(re)),this.m({type:a.Initialize})}registerChannel(K,Y){this.b.set(K,Y),setTimeout(()=>this.w(K),0)}m(K){switch(K.type){case a.Initialize:{const Y=this.o([K.type]);this.k?.logOutgoing(Y,0,k.OtherSide,m(K.type));return}case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:{const Y=this.o([K.type,K.id],K.data);this.k?.logOutgoing(Y,K.id,k.OtherSide,m(K.type),K.data);return}}}o(K,Y=void 0){const ee=new o;return E(ee,K),E(ee,Y),this.p(ee.buffer)}p(K){try{return this.h.send(K),K.byteLength}catch{return 0}}q(K){const Y=new t(K),ee=D(Y),ue=D(Y),re=ee[0];switch(re){case P.Promise:return this.k?.logIncoming(K.byteLength,ee[1],k.OtherSide,`${w(re)}: ${ee[2]}.${ee[3]}`,ue),this.s({type:re,id:ee[1],channelName:ee[2],name:ee[3],arg:ue});case P.EventListen:return this.k?.logIncoming(K.byteLength,ee[1],k.OtherSide,`${w(re)}: ${ee[2]}.${ee[3]}`,ue),this.t({type:re,id:ee[1],channelName:ee[2],name:ee[3],arg:ue});case P.PromiseCancel:return this.k?.logIncoming(K.byteLength,ee[1],k.OtherSide,`${w(re)}`),this.u({type:re,id:ee[1]});case P.EventDispose:return this.k?.logIncoming(K.byteLength,ee[1],k.OtherSide,`${w(re)}`),this.u({type:re,id:ee[1]})}}s(K){const Y=this.b.get(K.channelName);if(!Y){this.v(K);return}const ee=new R.$ue;let ue;try{ue=Y.call(this.j,K.name,K.arg,ee.token)}catch(me){ue=Promise.reject(me)}const re=K.id;ue.then(me=>{this.m({id:re,data:me,type:a.PromiseSuccess})},me=>{me instanceof Error?this.m({id:re,data:{message:me.message,name:me.name,stack:me.stack?me.stack.split(`
`):void 0},type:a.PromiseError}):this.m({id:re,data:me,type:a.PromiseErrorObj})}).finally(()=>{ye.dispose(),this.d.delete(K.id)});const ye=(0,c.$Rc)(()=>ee.cancel());this.d.set(K.id,ye)}t(K){const Y=this.b.get(K.channelName);if(!Y){this.v(K);return}const ee=K.id,re=Y.listen(this.j,K.name,K.arg)(ye=>this.m({id:ee,data:ye,type:a.EventFire}));this.d.set(K.id,re)}u(K){const Y=this.d.get(K.id);Y&&(Y.dispose(),this.d.delete(K.id))}v(K){let Y=this.g.get(K.channelName);Y||(Y=[],this.g.set(K.channelName,Y));const ee=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===P.Promise&&this.m({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.l}ms`,stack:void 0},type:a.PromiseError})},this.l);Y.push({request:K,timeoutTimer:ee})}w(K){const Y=this.g.get(K);if(Y){for(const ee of Y)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case P.Promise:this.s(ee.request);break;case P.EventListen:this.t(ee.request);break}this.g.delete(K)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$ei=y;var k;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class A{constructor(K,Y=null){this.l=K,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$je,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=Y}getChannel(K){const Y=this;return{call(ee,ue,re){return Y.a?Promise.reject(new T.$4):Y.m(K,ee,ue,re)},listen(ee,ue){return Y.a?b.Event.None:Y.o(K,ee,ue)}}}m(K,Y,ee,ue=R.CancellationToken.None){const re=this.g++,ye=P.Promise,me={id:re,type:ye,channelName:K,name:Y,arg:ee};if(ue.isCancellationRequested)return Promise.reject(new T.$4);let J;return new Promise((se,ae)=>{if(ue.isCancellationRequested)return ae(new T.$4);const te=()=>{const oe=pe=>{switch(pe.type){case a.PromiseSuccess:this.f.delete(re),se(pe.data);break;case a.PromiseError:{this.f.delete(re);const we=new Error(pe.data.message);we.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,we.name=pe.data.name,ae(we);break}case a.PromiseErrorObj:this.f.delete(re),ae(pe.data);break}};this.f.set(re,oe),this.p(me)};let ce=null;this.b===$.Idle?te():(ce=(0,h.$ph)(oe=>this.u()),ce.then(()=>{ce=null,te()}));const le=()=>{ce?(ce.cancel(),ce=null):this.p({id:re,type:P.PromiseCancel}),ae(new T.$4)},x=ue.onCancellationRequested(le);J=(0,c.$Qc)((0,c.$Rc)(le),x),this.d.add(J)}).finally(()=>{J.dispose(),this.d.delete(J)})}o(K,Y,ee){const ue=this.g++,re=P.EventListen,ye={id:ue,type:re,channelName:K,name:Y,arg:ee};let me=null;const J=new b.$je({onWillAddFirstListener:()=>{me=(0,h.$ph)(se=>this.u()),me.then(()=>{me=null,this.d.add(J),this.p(ye)})},onDidRemoveLastListener:()=>{me?(me.cancel(),me=null):(this.d.delete(J),this.p({id:ue,type:P.EventDispose}))}}),U=se=>J.fire(se.data);return this.f.set(ue,U),J.event}p(K){switch(K.type){case P.Promise:case P.EventListen:{const Y=this.q([K.type,K.id,K.channelName,K.name],K.arg);this.j?.logOutgoing(Y,K.id,k.LocalSide,`${w(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case P.PromiseCancel:case P.EventDispose:{const Y=this.q([K.type,K.id]);this.j?.logOutgoing(Y,K.id,k.LocalSide,w(K.type));return}}}q(K,Y=void 0){const ee=new o;return E(ee,K),E(ee,Y),this.r(ee.buffer)}r(K){try{return this.l.send(K),K.byteLength}catch{return 0}}s(K){const Y=new t(K),ee=D(Y),ue=D(Y),re=ee[0];switch(re){case a.Initialize:return this.j?.logIncoming(K.byteLength,0,k.LocalSide,m(re)),this.t({type:ee[0]});case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:return this.j?.logIncoming(K.byteLength,ee[1],k.LocalSide,m(re),ue),this.t({type:ee[0],id:ee[1],data:ue})}}t(K){if(K.type===a.Initialize){this.b=$.Idle,this.k.fire();return}this.f.get(K.id)?.(K)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$fi=A,Ye([L.$7h],A.prototype,"onDidInitializePromise",null);class p{get connections(){const K=[];return this.f.forEach(Y=>K.push(Y)),K}constructor(K,Y,ee){this.a=new Map,this.f=new Set,this.g=new b.$je,this.onDidAddConnection=this.g.event,this.h=new b.$je,this.onDidRemoveConnection=this.h.event,this.j=new c.$Sc,this.j.add(K(({protocol:ue,onDidClientDisconnect:re})=>{const ye=b.Event.once(ue.onMessage);this.j.add(ye(me=>{const J=new t(me),U=D(J),se=new y(ue,U,Y,ee),ae=new A(ue,Y);this.a.forEach((ce,le)=>se.registerChannel(le,ce));const te={channelServer:se,channelClient:ae,ctx:U};this.f.add(te),this.g.fire(te),this.j.add(re(()=>{se.dispose(),ae.dispose(),this.f.delete(te),this.h.fire(te)}))}))}))}getChannel(K,Y){const ee=this;return{call(ue,re,ye){let me;if((0,u.$qg)(Y)){const U=(0,r.$2b)(ee.connections.filter(Y));me=U?Promise.resolve(U):b.Event.toPromise(b.Event.filter(ee.onDidAddConnection,Y))}else me=Y.routeCall(ee,ue,re);const J=me.then(U=>U.channelClient.getChannel(K));return F(J).call(ue,re,ye)},listen(ue,re){if((0,u.$qg)(Y))return ee.k(K,Y,ue,re);const ye=Y.routeEvent(ee,ue,re).then(me=>me.channelClient.getChannel(K));return F(ye).listen(ue,re)}}}k(K,Y,ee,ue){const re=this;let ye;const me=new b.$je({onWillAddFirstListener:()=>{ye=new c.$Sc;const J=new b.$pe,U=new Map,se=te=>{const le=te.channelClient.getChannel(K).listen(ee,ue),x=J.add(le);U.set(te,x)},ae=te=>{const ce=U.get(te);ce&&(ce.dispose(),U.delete(te))};re.connections.filter(Y).forEach(se),b.Event.filter(re.onDidAddConnection,Y)(se,void 0,ye),re.onDidRemoveConnection(ae,void 0,ye),J.event(me.fire,me,ye),ye.add(J)},onDidRemoveLastListener:()=>{ye?.dispose(),ye=void 0}});return me.event}registerChannel(K,Y){this.a.set(K,Y);for(const ee of this.f)ee.channelServer.registerChannel(K,Y)}dispose(){this.j.dispose();for(const K of this.f)K.channelClient.dispose(),K.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$gi=p;class v{constructor(K,Y,ee=null){const ue=new o;E(ue,Y),K.send(ue.buffer),this.a=new A(K,ee),this.d=new y(K,Y,ee)}getChannel(K){return this.a.getChannel(K)}registerChannel(K,Y){this.d.registerChannel(K,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.$hi=v;function F(B){return{call(K,Y,ee){return B.then(ue=>ue.call(K,Y,ee))},listen(K,Y){const ee=new b.$se;return B.then(ue=>ee.input=ue.listen(K,Y)),ee.event}}}function N(B){let K=!1;return{call(Y,ee,ue){return K?B.call(Y,ee,ue):(0,h.$Dh)(0).then(()=>K=!0).then(()=>B.call(Y,ee,ue))},listen(Y,ee){if(K)return B.listen(Y,ee);const ue=new b.$se;return(0,h.$Dh)(0).then(()=>K=!0).then(()=>ue.input=B.listen(Y,ee)),ue.event}}}class O{constructor(K){this.a=K}routeCall(K){return this.b(K)}routeEvent(K){return this.b(K)}async b(K){for(const Y of K.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await b.Event.toPromise(K.onDidAddConnection),await this.b(K)}}e.$ki=O;var j;(function(B){function K(re,ye,me){const J=re,U=me&&me.disableMarshalling,se=new Map;for(const ae in J)ee(ae)&&se.set(ae,b.Event.buffer(J[ae],!0,void 0,ye));return new class{listen(ae,te,ce){const le=se.get(te);if(le)return le;const x=J[te];if(typeof x=="function"){if(ue(te))return x.call(J,ce);if(ee(te))return se.set(te,b.Event.buffer(J[te],!0,void 0,ye)),se.get(te)}throw new T.$ab(`Event not found: ${te}`)}call(ae,te,ce){const le=J[te];if(typeof le=="function"){if(!U&&Array.isArray(ce))for(let oe=0;oe<ce.length;oe++)ce[oe]=(0,I.$_h)(ce[oe]);let x=le.apply(J,ce);return x instanceof Promise||(x=Promise.resolve(x)),x}throw new T.$ab(`Method not found: ${te}`)}}}B.fromService=K;function Y(re,ye){const me=ye&&ye.disableMarshalling;return new Proxy({},{get(J,U){if(typeof U=="string")return ye?.properties?.has(U)?ye.properties.get(U):ue(U)?function(se){return re.listen(U,se)}:ee(U)?re.listen(U):async function(...se){let ae;ye&&!(0,u.$lg)(ye.context)?ae=[ye.context,...se]:ae=se;const te=await re.call(U,ae);return me?te:(0,I.$_h)(te)};throw new T.$ab(`Property not found: ${String(U)}`)}})}B.toService=Y;function ee(re){return re[0]==="o"&&re[1]==="n"&&S.$Cf(re.charCodeAt(2))}function ue(re){return/^onDynamic/.test(re)&&S.$Cf(re.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const K=B.toString();if(K!=="[object Object]")return K}return B}function W(B){return Array.isArray(B)?B.map(M):M(B)}function V(B,K,Y,ee,ue,re,ye){ye=W(ye);const me=z[ue],J=me[ee%me.length];let U=[`%c[${B}]%c[${String(K).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${J}`];/\($/.test(re)?(U=U.concat(ye),U.push(")")):U.push(ye),console.log.apply(console,U)}class ne{constructor(K,Y){this.d=K,this.f=Y,this.a=0,this.b=0}logOutgoing(K,Y,ee,ue,re){this.b+=K,V(this.d,this.b,K,Y,ee,ue,re)}logIncoming(K,Y,ee,ue,re){this.a+=K,V(this.f,this.a,K,Y,ee,ue,re)}}e.$li=ne}),define(Se[68],De([1,0,21,4,3,86]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.ProtocolConstants=e.$mi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var T;(function(l){l.enableDiagnostics=!1,l.records=[];const g=new WeakMap;let E=0;function D(k,A){if(!g.has(k)){const p=String(++E);g.set(k,p)}return g.get(k)}function y(k,A,p,v){if(!l.enableDiagnostics)return;const F=D(k,A);if(v instanceof r.$Le||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const N=r.$Le.alloc(v.byteLength);N.set(v),l.records.push({timestamp:Date.now(),id:F,label:A,type:p,buff:N})}else l.records.push({timestamp:Date.now(),id:F,label:A,type:p,data:v})}l.traceSocketEvent=y})(T||(e.SocketDiagnostics=T={}));var b;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let c=null;function I(){return c||(c=r.$Le.alloc(0)),c}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(g){this.a.push(g),this.b+=g.byteLength}read(g){return this.c(g,!0)}peek(g){return this.c(g,!1)}c(g,E){if(g===0)return I();if(g>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===g){const A=this.a[0];return E&&(this.a.shift(),this.b-=g),A}if(this.a[0].byteLength>g){const A=this.a[0].slice(0,g);return E&&(this.a[0]=this.a[0].slice(g),this.b-=g),A}const D=r.$Le.alloc(g);let y=0,k=0;for(;g>0;){const A=this.a[k];if(A.byteLength>g){const p=A.slice(0,g);D.set(p,y),y+=g,E&&(this.a[k]=A.slice(g),this.b-=g),g-=g}else D.set(A,y),y+=A.byteLength,E?(this.a.shift(),this.b-=A.byteLength):k++,g-=A.byteLength}return D}}e.$mi=S;var u;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(u||(u={}));function P(l){switch(l){case u.None:return"None";case u.Regular:return"Regular";case u.Control:return"Control";case u.Ack:return"Ack";case u.Disconnect:return"Disconnect";case u.ReplayRequest:return"ReplayRequest";case u.Pause:return"PauseWriting";case u.Resume:return"ResumeWriting";case u.KeepAlive:return"KeepAlive"}}var w;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(w||(e.ProtocolConstants=w={}));class a{constructor(g,E,D,y){this.type=g,this.id=E,this.ack=D,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends C.$Tc{constructor(g){super(),this.f=this.B(new h.$je),this.onMessage=this.f.event,this.g={readHead:!0,readLen:w.HeaderLength,messageType:u.None,id:0,ack:0},this.a=g,this.b=!1,this.c=new S,this.B(this.a.onData(E=>this.acceptChunk(E))),this.lastReadTime=Date.now()}acceptChunk(g){if(!(!g||g.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(g);this.c.byteLength>=this.g.readLen;){const E=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=E.readUInt32BE(9),this.g.messageType=E.readUInt8(0),this.g.id=E.readUInt32BE(1),this.g.ack=E.readUInt32BE(5),this.a.traceSocketEvent(L.ProtocolHeaderRead,{messageType:P(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const D=this.g.messageType,y=this.g.id,k=this.g.ack;if(this.g.readHead=!0,this.g.readLen=w.HeaderLength,this.g.messageType=u.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(L.ProtocolMessageRead,E),this.f.fire(new a(D,y,k,E)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(g){this.k=null,this.a=!1,this.b=!1,this.c=g,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(g){if(this.a)return;g.writtenTime=Date.now(),this.lastWriteTime=Date.now();const E=r.$Le.alloc(w.HeaderLength);E.writeUInt8(g.type,0),E.writeUInt32BE(g.id,1),E.writeUInt32BE(g.ack,5),E.writeUInt32BE(g.data.byteLength,9),this.c.traceSocketEvent(L.ProtocolHeaderWrite,{messageType:P(g.type),id:g.id,ack:g.ack,messageSize:g.data.byteLength}),this.c.traceSocketEvent(L.ProtocolMessageWrite,g.data),this.j(E,g.data)}g(g,E){const D=this.f===0;return this.d.push(g,E),this.f+=g.byteLength+E.byteLength,D}h(){const g=r.$Le.concat(this.d,this.f);return this.d.length=0,this.f=0,g}j(g,E){this.g(g,E)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const g=this.h();this.c.traceSocketEvent(L.ProtocolWrite,{byteLength:g.byteLength}),this.c.write(g)}}class f extends C.$Tc{constructor(g){super(),this.f=new h.$je,this.onMessage=this.f.event,this.g=new h.$je,this.onDidDispose=this.g.event,this.a=g,this.b=this.B(new $(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(E=>{E.type===u.Regular&&this.f.fire(E.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(g){this.b.write(new a(u.Regular,0,0,g))}}e.$ni=f;class i extends R.$hi{static fromSocket(g,E){return new i(new f(g),E)}get onDidDispose(){return this.b.onDidDispose}constructor(g,E,D=null){super(g,E,D),this.b=g}dispose(){super.dispose();const g=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),g.end()}}e.$oi=i;class s{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new h.$je({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(g){this.b?this.d.length>0?this.d.push(g):this.a.fire(g):this.d.push(g)}flushBuffer(){this.d=[]}}e.$pi=s;class t{constructor(g){this.data=g,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let g=0,E=this.a;for(;E;)E=E.next,g++;return g}peek(){return this.a?this.a.data:null}toArray(){const g=[];let E=0,D=this.a;for(;D;)g[E++]=D.data,D=D.next;return g}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(g){const E=new t(g);if(!this.a){this.a=E,this.b=E;return}this.b.next=E,this.b=E}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const g=Date.now();for(let E=0;E<n.a;E++)this.c[E]=g-1e3*E;setInterval(()=>{for(let E=n.a;E>=1;E--)this.c[E]=this.c[E-1];this.c[0]=Date.now()},1e3)}d(){const g=Date.now(),E=(1+n.a)*1e3;let D=0;for(let y=0;y<n.a;y++)g-this.c[y]<=E&&D++;return 1-D/n.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.d-this.f}constructor(g){this.v=new s,this.onControlMessage=this.v.event,this.w=new s,this.onMessage=this.w.event,this.x=new s,this.onDidDispose=this.x.event,this.y=new s,this.onSocketClose=this.y.event,this.z=new s,this.onSocketTimeout=this.z.event,this.t=g.loadEstimator??n.getInstance(),this.u=g.sendKeepAlive??!0,this.a=!1,this.c=new o,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new C.$Sc,this.p=g.socket,this.q=this.s.add(new $(this.p)),this.r=this.s.add(new m(this.p)),this.s.add(this.r.onMessage(E=>this.A(E))),this.s.add(this.p.onClose(E=>this.y.fire(E))),g.initialChunk&&this.r.acceptChunk(g.initialChunk),this.u?this.m=setInterval(()=>{this.E()},w.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const g=new a(u.Disconnect,0,0,I());this.q.write(g),this.q.flush()}}sendPause(){const g=new a(u.Pause,0,0,I());this.q.write(g)}sendResume(){const g=new a(u.Resume,0,0,I());this.q.write(g)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(g,E){this.a=!0,this.s.dispose(),this.s=new C.$Sc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=g,this.q=this.s.add(new $(this.p)),this.r=this.s.add(new m(this.p)),this.s.add(this.r.onMessage(D=>this.A(D))),this.s.add(this.p.onClose(D=>this.y.fire(D))),this.r.acceptChunk(E)}endAcceptReconnection(){this.a=!1,this.j=this.h;const g=new a(u.Ack,0,this.j,I());this.q.write(g);const E=this.c.toArray();for(let D=0,y=E.length;D<y;D++)this.q.write(E[D]);this.C()}acceptDisconnect(){this.x.fire()}A(g){if(g.ack>this.f){this.f=g.ack;do{const E=this.c.peek();if(E&&E.id<=g.ack)this.c.pop();else break}while(!0)}switch(g.type){case u.None:break;case u.Regular:{if(g.id>this.h)if(g.id!==this.h+1){const E=Date.now();E-this.n>1e4&&(this.n=E,this.q.write(new a(u.ReplayRequest,0,0,I())))}else this.h=g.id,this.k=Date.now(),this.B(),this.w.fire(g.data);break}case u.Control:{this.v.fire(g.data);break}case u.Ack:break;case u.Disconnect:{this.x.fire();break}case u.ReplayRequest:{const E=this.c.toArray();for(let D=0,y=E.length;D<y;D++)this.q.write(E[D]);this.C();break}case u.Pause:{this.q.pause();break}case u.Resume:{this.q.resume();break}case u.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(g){const E=++this.d;this.j=this.h;const D=new a(u.Regular,E,this.j,g);this.c.push(D),this.a||(this.q.write(D),this.C())}sendControl(g){const E=new a(u.Control,0,0,g);this.q.write(E)}B(){if(this.h<=this.j||this.l)return;const g=Date.now()-this.k;if(g>=w.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},w.AcknowledgeTime-g+5)}C(){if(this.d<=this.f||this.g||this.a)return;const g=this.c.peek(),E=Date.now()-g.writtenTime,D=Date.now()-this.r.lastReadTime,y=Date.now()-this.o;if(E>=w.TimeoutTime&&D>=w.TimeoutTime&&y>=w.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:E,timeSinceLastReceivedSomeData:D});return}const k=Math.max(w.TimeoutTime-E,w.TimeoutTime-D,w.TimeoutTime-y,500);this.g=setTimeout(()=>{this.g=null,this.C()},k)}D(){if(this.h<=this.j)return;this.j=this.h;const g=new a(u.Ack,0,this.j,I());this.q.write(g)}E(){this.j=this.h;const g=new a(u.KeepAlive,0,this.j,I());this.q.write(g)}}e.$qi=d}),define(Se[192],De([1,0,56,7,21,20,188,13,4,3,24,109,104,86]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=void 0,T=Ue(T);class w extends P.$ei{constructor($){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",f=>C.$Le.wrap(Buffer.from(f,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$er=w;class a{constructor($,f){this.i=$,this.j=f,this.c=new Set,this.g=new Map,this.h=new b.$je,this.onDidProcessExit=this.h.event;const i=f&&f.timeout?f.timeout:6e4;this.b=new h.$zh(i),this.d=null,this.f=null}getChannel($){const f=this;return{call(i,s,t){return f.k($,i,s,t)},listen(i,s){return f.l($,i,s)}}}k($,f,i,s=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(T.$5());this.b.cancel();const t=this.n($),o=(0,h.$ph)(l=>t.call(f,i,l)),n=s.onCancellationRequested(()=>o.cancel()),d=(0,c.$Rc)(()=>o.cancel());return this.c.add(d),o.finally(()=>{n.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),o}l($,f,i){if(!this.b)return b.Event.None;this.b.cancel();let s;const t=new b.$je({onWillAddFirstListener:()=>{s=this.n($).listen(f,i)(t.fire,t),this.c.add(s)},onDidRemoveLastListener:()=>{this.c.delete(s),s.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,I.$bo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(E=>!/^--inspect(-brk)?=/.test(E)).filter(E=>!E.startsWith("--vscode-"))),(0,u.$jm)(f.env),this.d=(0,r.fork)(this.i,$,f);const i=new b.$je,t=b.Event.fromNodeEventEmitter(this.d,"message",E=>E)(E=>{if((0,L.$ar)(E)){(0,L.log)(E,`IPC Library: ${this.j.serverName}`);return}i.fire(C.$Le.wrap(Buffer.from(E,"base64")))}),o=this.j.useQueue?(0,S.$wm)(this.d):this.d,n=E=>this.d&&this.d.connected&&o.send(E.buffer.toString("base64")),d=i.event,l={send:n,onMessage:d};this.f=new P.$fi(l);const g=()=>this.o();process.once("exit",g),this.d.on("error",E=>console.warn('IPC "'+this.j.serverName+'" errored with '+E)),this.d.on("exit",(E,D)=>{process.removeListener("exit",g),t.dispose(),this.c.forEach(y=>(0,c.$Oc)(y)),this.c.clear(),E!==0&&D!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+E+" and signal "+D),this.b?.cancel(),this.o(),this.h.fire({code:E,signal:D})})}return this.f}n($){let f=this.g.get($);return f||(f=this.m.getChannel($),this.g.set($,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$fr=a}),define(Se[193],De([1,0,7,4,3,51,17]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.StorageState=e.StorageHint=void 0,e.$aq=b;var T;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function b(u){const P=u;return P?.changed instanceof Map||P?.deleted instanceof Set}var c;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(c||(e.StorageState=c={}));class I extends C.$Tc{static{this.a=100}constructor(P,w=Object.create(null)){super(),this.r=P,this.s=w,this.b=this.B(new h.$me),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new r.$Ah(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(P=>this.u(P)))}u(P){this.b.pause();try{P.changed?.forEach((w,a)=>this.w(a,w)),P.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w(P,w){if(this.c===c.Closed)return;let a=!1;(0,L.$lg)(w)?a=this.f.delete(P):this.f.get(P)!==w&&(this.f.set(P,w),a=!0),a&&this.b.fire({key:P,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(P,w){const a=this.f.get(P);return(0,L.$lg)(a)?w:a}getBoolean(P,w){const a=this.get(P);return(0,L.$lg)(a)?w:a==="true"}getNumber(P,w){const a=this.get(P);return(0,L.$lg)(a)?w:parseInt(a,10)}getObject(P,w){const a=this.get(P);return(0,L.$lg)(a)?w:(0,R.$$h)(a)}async set(P,w,a=!1){if(this.c===c.Closed)return;if((0,L.$lg)(w))return this.delete(P,a);const m=(0,L.$eg)(w)||Array.isArray(w)?(0,R.$0h)(w):String(w);if(this.f.get(P)!==m)return this.f.set(P,m),this.j.set(P,m),this.h.delete(P),this.b.fire({key:P,external:a}),this.D()}async delete(P,w=!1){if(!(this.c===c.Closed||!this.f.delete(P)))return this.h.has(P)||this.h.add(P),this.j.delete(P),this.b.fire({key:P,external:w}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const P={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(P).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(P){if(!(this.c===c.Closed||this.m))return this.D(P)}async D(P){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),P)}async whenFlushed(){if(this.z)return new Promise(P=>this.n.push(P))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$bq=I;class S{constructor(){this.onDidChangeItemsExternal=h.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(P){P.insert?.forEach((w,a)=>this.a.set(a,w)),P.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$cq=S}),define(Se[139],De([1,0,83]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fu=e.$eu=void 0;class h{constructor(T){const b=(0,r.$$e)(T);this.c=b,this.a=h.d(b),this.b=new Map}static d(T){const b=new Uint8Array(256);return b.fill(T),b}set(T,b){const c=(0,r.$$e)(b);T>=0&&T<256?this.a[T]=c:this.b.set(T,c)}get(T){return T>=0&&T<256?this.a[T]:this.b.get(T)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$eu=h;var C;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(C||(C={}));class R{constructor(){this.a=new h(C.False)}add(T){this.a.set(T,C.True)}has(T){return this.a.get(T)===C.True}clear(){return this.a.clear()}}e.$fu=R}),define(Se[194],De([1,0,26]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$wu=C;var h;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function C(R){let L=0,T=0,b=0,c=h.Unknown;for(let I=0,S=R.length;I<S;I++){const u=R.charCodeAt(I);u===r.CharCode.CarriageReturn?(L===0&&(T=I),L++,I+1<S&&R.charCodeAt(I+1)===r.CharCode.LineFeed?(c|=h.CRLF,I++):c|=h.Invalid,b=I+1):u===r.CharCode.LineFeed&&(c|=h.LF,L===0&&(T=I),L++,b=I+1)}return L===0&&(T=R.length),[L,T,R.length-b,c]}}),define(Se[57],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=void 0;class r{constructor(C,R){this.lineNumber=C,this.column=R}with(C=this.lineNumber,R=this.column){return C===this.lineNumber&&R===this.column?this:new r(C,R)}delta(C=0,R=0){return this.with(this.lineNumber+C,this.column+R)}equals(C){return r.equals(this,C)}static equals(C,R){return!C&&!R?!0:!!C&&!!R&&C.lineNumber===R.lineNumber&&C.column===R.column}isBefore(C){return r.isBefore(this,C)}static isBefore(C,R){return C.lineNumber<R.lineNumber?!0:R.lineNumber<C.lineNumber?!1:C.column<R.column}isBeforeOrEqual(C){return r.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,R){return C.lineNumber<R.lineNumber?!0:R.lineNumber<C.lineNumber?!1:C.column<=R.column}static compare(C,R){const L=C.lineNumber|0,T=R.lineNumber|0;if(L===T){const b=C.column|0,c=R.column|0;return b-c}return L-T}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new r(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Kt=r}),define(Se[30],De([1,0,57]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=void 0;class h{constructor(R,L,T,b){R>T||R===T&&L>b?(this.startLineNumber=T,this.startColumn=b,this.endLineNumber=R,this.endColumn=L):(this.startLineNumber=R,this.startColumn=L,this.endLineNumber=T,this.endColumn=b)}isEmpty(){return h.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return h.containsPosition(this,R)}static containsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<R.startColumn||L.lineNumber===R.endLineNumber&&L.column>R.endColumn)}static strictContainsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<=R.startColumn||L.lineNumber===R.endLineNumber&&L.column>=R.endColumn)}containsRange(R){return h.containsRange(this,R)}static containsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>R.endColumn)}strictContainsRange(R){return h.strictContainsRange(this,R)}static strictContainsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<=R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>=R.endColumn)}plusRange(R){return h.plusRange(this,R)}static plusRange(R,L){let T,b,c,I;return L.startLineNumber<R.startLineNumber?(T=L.startLineNumber,b=L.startColumn):L.startLineNumber===R.startLineNumber?(T=L.startLineNumber,b=Math.min(L.startColumn,R.startColumn)):(T=R.startLineNumber,b=R.startColumn),L.endLineNumber>R.endLineNumber?(c=L.endLineNumber,I=L.endColumn):L.endLineNumber===R.endLineNumber?(c=L.endLineNumber,I=Math.max(L.endColumn,R.endColumn)):(c=R.endLineNumber,I=R.endColumn),new h(T,b,c,I)}intersectRanges(R){return h.intersectRanges(this,R)}static intersectRanges(R,L){let T=R.startLineNumber,b=R.startColumn,c=R.endLineNumber,I=R.endColumn;const S=L.startLineNumber,u=L.startColumn,P=L.endLineNumber,w=L.endColumn;return T<S?(T=S,b=u):T===S&&(b=Math.max(b,u)),c>P?(c=P,I=w):c===P&&(I=Math.min(I,w)),T>c||T===c&&b>I?null:new h(T,b,c,I)}equalsRange(R){return h.equalsRange(this,R)}static equalsRange(R,L){return!R&&!L?!0:!!R&&!!L&&R.startLineNumber===L.startLineNumber&&R.startColumn===L.startColumn&&R.endLineNumber===L.endLineNumber&&R.endColumn===L.endColumn}getEndPosition(){return h.getEndPosition(this)}static getEndPosition(R){return new r.$Kt(R.endLineNumber,R.endColumn)}getStartPosition(){return h.getStartPosition(this)}static getStartPosition(R){return new r.$Kt(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,L){return new h(this.startLineNumber,this.startColumn,R,L)}setStartPosition(R,L){return new h(R,L,this.endLineNumber,this.endColumn)}collapseToStart(){return h.collapseToStart(this)}static collapseToStart(R){return new h(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return h.collapseToEnd(this)}static collapseToEnd(R){return new h(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new h(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,L=R){return new h(R.lineNumber,R.column,L.lineNumber,L.column)}static lift(R){return R?new h(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn)}static areIntersecting(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,L){if(R&&L){const c=R.startLineNumber|0,I=L.startLineNumber|0;if(c===I){const S=R.startColumn|0,u=L.startColumn|0;if(S===u){const P=R.endLineNumber|0,w=L.endLineNumber|0;if(P===w){const a=R.endColumn|0,m=L.endColumn|0;return a-m}return P-w}return S-u}return c-I}return(R?1:0)-(L?1:0)}static compareRangesUsingEnds(R,L){return R.endLineNumber===L.endLineNumber?R.endColumn===L.endColumn?R.startLineNumber===L.startLineNumber?R.startColumn-L.startColumn:R.startLineNumber-L.startLineNumber:R.endColumn-L.endColumn:R.endLineNumber-L.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$Lt=h}),define(Se[195],De([1,0,30]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=void 0;class h{static insert(R,L){return{range:new r.$Lt(R.lineNumber,R.column,R.lineNumber,R.column),text:L,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,L){return{range:R,text:L}}static replaceMove(R,L){return{range:R,text:L,forceMoveMarkers:!0}}}e.$Mt=h}),define(Se[196],De([1,0,57,30]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=e.SelectionDirection=void 0;var C;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(C||(e.SelectionDirection=C={}));class R extends h.$Lt{constructor(T,b,c,I){super(T,b,c,I),this.selectionStartLineNumber=T,this.selectionStartColumn=b,this.positionLineNumber=c,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return R.selectionsEqual(this,T)}static selectionsEqual(T,b){return T.selectionStartLineNumber===b.selectionStartLineNumber&&T.selectionStartColumn===b.selectionStartColumn&&T.positionLineNumber===b.positionLineNumber&&T.positionColumn===b.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?C.LTR:C.RTL}setEndPosition(T,b){return this.getDirection()===C.LTR?new R(this.startLineNumber,this.startColumn,T,b):new R(T,b,this.startLineNumber,this.startColumn)}getPosition(){return new r.$Kt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.$Kt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,b){return this.getDirection()===C.LTR?new R(T,b,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,T,b)}static fromPositions(T,b=T){return new R(T.lineNumber,T.column,b.lineNumber,b.column)}static fromRange(T,b){return b===C.LTR?new R(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new R(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new R(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,b){if(T&&!b||!T&&b)return!1;if(!T&&!b)return!0;if(T.length!==b.length)return!1;for(let c=0,I=T.length;c<I;c++)if(!this.selectionsEqual(T[c],b[c]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,b,c,I,S){return S===C.LTR?new R(T,b,c,I):new R(c,I,T,b)}}e.$Nt=R}),define(Se[197],De([1,0,12,10,21]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=void 0,e.$_t=I,e.$au=S,r=Ue(r),h=Ue(h),C=Ue(C);let R;function L(){return R||(R=new TextDecoder("UTF-16LE")),R}let T;function b(){return T||(T=new TextDecoder("UTF-16BE")),T}let c;function I(){return c||(c=h.$E()?L():b()),c}function S(w,a,m){const $=new Uint16Array(w.buffer,a,m);return m>0&&($[0]===65279||$[0]===65534)?u(w,a,m):L().decode($)}function u(w,a,m){const $=[];let f=0;for(let i=0;i<m;i++){const s=C.$Ne(w,a);a+=2,$[f++]=String.fromCharCode(s)}return $.join("")}class P{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return I().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const m=this.a-this.d;m<=1&&(m===0||r.$Hf(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const m=a.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=a;return}for(let $=0;$<m;$++)this.b[this.d++]=a.charCodeAt($)}}e.$bu=P}),define(Se[198],De([1,0,21,197]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cu=void 0,e.$du=L,r=Ue(r);function C(b){return b.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(c,I,S,u){this.oldPosition=c,this.oldText=I,this.newPosition=S,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(c){return 4+2*c.length}static c(c,I,S){const u=I.length;r.$Qe(c,u,S),S+=4;for(let P=0;P<u;P++)r.$Oe(c,I.charCodeAt(P),S),S+=2;return S}static d(c,I){const S=r.$Pe(c,I);return I+=4,(0,h.$au)(c,I,S)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(c,I){return r.$Qe(c,this.oldPosition,I),I+=4,r.$Qe(c,this.newPosition,I),I+=4,I=R.c(c,this.oldText,I),I=R.c(c,this.newText,I),I}static read(c,I,S){const u=r.$Pe(c,I);I+=4;const P=r.$Pe(c,I);I+=4;const w=R.d(c,I);I+=R.a(w);const a=R.d(c,I);return I+=R.a(a),S.push(new R(u,w,P,a)),I}}e.$cu=R;function L(b,c){return b===null||b.length===0?c:new T(b,c).compress()}class T{constructor(c,I){this.a=c,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let c=0,I=0,S=this.n(c),u=this.l(I);for(;c<this.f||I<this.h;){if(S===null){this.k(u),u=this.l(++I);continue}if(u===null){this.m(S),S=this.n(++c);continue}if(u.oldEnd<=S.newPosition){this.k(u),u=this.l(++I);continue}if(S.newEnd<=u.oldPosition){this.m(S),S=this.n(++c);continue}if(u.oldPosition<S.newPosition){const[$,f]=T.r(u,S.newPosition-u.oldPosition);this.k($),u=f;continue}if(S.newPosition<u.oldPosition){const[$,f]=T.q(S,u.oldPosition-S.newPosition);this.m($),S=f;continue}let a,m;if(u.oldEnd===S.newEnd)a=S,m=u,S=this.n(++c),u=this.l(++I);else if(u.oldEnd<S.newEnd){const[$,f]=T.q(S,u.oldLength);a=$,m=u,S=f,u=this.l(++I)}else{const[$,f]=T.r(u,S.newLength);a=S,m=$,S=this.n(++c),u=f}this.d[this.e++]=new R(a.oldPosition,a.oldText,m.newPosition,m.newText),this.g+=a.newLength-a.oldLength,this.j+=m.newLength-m.oldLength}const P=T.s(this.d);return T.t(P)}k(c){this.d[this.e++]=T.o(this.g,c),this.j+=c.newLength-c.oldLength}l(c){return c<this.h?this.c[c]:null}m(c){this.d[this.e++]=T.p(this.j,c),this.g+=c.newLength-c.oldLength}n(c){return c<this.f?this.a[c]:null}static o(c,I){return new R(I.oldPosition-c,I.oldText,I.newPosition,I.newText)}static p(c,I){return new R(I.oldPosition,I.oldText,I.newPosition+c,I.newText)}static q(c,I){const S=c.newText.substr(0,I),u=c.newText.substr(I);return[new R(c.oldPosition,c.oldText,c.newPosition,S),new R(c.oldEnd,"",c.newPosition+I,u)]}static r(c,I){const S=c.oldText.substr(0,I),u=c.oldText.substr(I);return[new R(c.oldPosition,S,c.newPosition,c.newText),new R(c.oldPosition+I,u,c.newEnd,"")]}static s(c){if(c.length===0)return c;const I=[];let S=0,u=c[0];for(let P=1;P<c.length;P++){const w=c[P];u.oldEnd===w.oldPosition?u=new R(u.oldPosition,u.oldText+w.oldText,u.newPosition,u.newText+w.newText):(I[S++]=u,u=w)}return I[S++]=u,I}static t(c){if(c.length===0)return c;const I=[];let S=0;for(let u=0;u<c.length;u++){const P=c[u];P.oldText!==P.newText&&(I[S++]=P)}return I}}}),define(Se[199],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=void 0,e.$it={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[200],De([1,0,26,28,139]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gu=e.WordCharacterClass=void 0,e.$hu=b;var R;(function(c){c[c.Regular=0]="Regular",c[c.Whitespace=1]="Whitespace",c[c.WordSeparator=2]="WordSeparator"})(R||(e.WordCharacterClass=R={}));class L extends C.$eu{constructor(I,S){super(R.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=S,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let u=0,P=I.length;u<P;u++)this.set(I.charCodeAt(u),R.WordSeparator);this.set(r.CharCode.Space,R.Whitespace),this.set(r.CharCode.Tab,R.Whitespace)}findPrevIntlWordBeforeOrAtOffset(I,S){let u=null;for(const P of this.h(I)){if(P.index>S)break;u=P}return u}findNextIntlWordAtOrAfterOffset(I,S){for(const u of this.h(I))if(!(u.index<S))return u;return null}h(I){return this.e?this.f===I?this.g:(this.f=I,this.g=this.j(this.e.segment(I)),this.g):[]}j(I){const S=[];for(const u of I)this.k(u)&&S.push(u);return S}k(I){return!!I.isWordLike}}e.$gu=L;const T=new h.$Cc(10);function b(c,I){const S=`${c}/${I.join(",")}`;let u=T.get(S);return u||(u=new L(c,I),T.set(S,u)),u}}),define(Se[140],De([1,0,39,3,80]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=e.$jt=void 0,e.$lt=L,e.$mt=b,e.$nt=c,e.$jt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(S=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.$jt)S.indexOf(P)>=0||(u+="\\"+P);return u+="\\s]+)",new RegExp(u,"g")}e.$kt=R();function L(S){let u=e.$kt;if(S&&S instanceof RegExp)if(S.global)u=S;else{let P="g";S.ignoreCase&&(P+="i"),S.multiline&&(P+="m"),S.unicode&&(P+="u"),u=new RegExp(S.source,P)}return u.lastIndex=0,u}const T=new C.$4c;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function b(S){const u=T.unshift(S);return(0,h.$Rc)(u)}function c(S,u,P,w,a){if(u=L(u),a||(a=r.Iterable.first(T)),P.length>a.maxLen){let s=S-a.maxLen/2;return s<0?s=0:w+=s,P=P.substring(s,S+a.maxLen/2),c(S,u,P,w,a)}const m=Date.now(),$=S-1-w;let f=-1,i=null;for(let s=1;!(Date.now()-m>=a.timeBudget);s++){const t=$-a.windowSize*s;u.lastIndex=Math.max(0,t);const o=I(u,P,$,f);if(!o&&i||(i=o,t<=0))break;f=t}if(i){const s={word:i[0],startColumn:w+1+i.index,endColumn:w+1+i.index+i[0].length};return u.lastIndex=0,s}return null}function I(S,u,P,w){let a;for(;a=S.exec(u);){const m=a.index||0;if(m<=P&&S.lastIndex>=P)return a;if(w>0&&m>w)return null}return null}}),define(Se[110],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$su=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var r;(function(b){b[b.Null=0]="Null",b[b.PlainText=1]="PlainText"})(r||(e.LanguageId=r={}));var h;(function(b){b[b.NotSet=-1]="NotSet",b[b.None=0]="None",b[b.Italic=1]="Italic",b[b.Bold=2]="Bold",b[b.Underline=4]="Underline",b[b.Strikethrough=8]="Strikethrough"})(h||(e.FontStyle=h={}));var C;(function(b){b[b.None=0]="None",b[b.DefaultForeground=1]="DefaultForeground",b[b.DefaultBackground=2]="DefaultBackground"})(C||(e.ColorId=C={}));var R;(function(b){b[b.Other=0]="Other",b[b.Comment=1]="Comment",b[b.String=2]="String",b[b.RegEx=3]="RegEx"})(R||(e.StandardTokenType=R={}));var L;(function(b){b[b.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",b[b.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",b[b.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",b[b.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",b[b.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",b[b.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",b[b.ITALIC_MASK=2048]="ITALIC_MASK",b[b.BOLD_MASK=4096]="BOLD_MASK",b[b.UNDERLINE_MASK=8192]="UNDERLINE_MASK",b[b.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",b[b.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",b[b.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",b[b.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",b[b.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",b[b.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",b[b.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",b[b.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",b[b.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",b[b.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",b[b.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",b[b.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",b[b.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(L||(e.MetadataConsts=L={}));class T{static getLanguageId(c){return(c&L.LANGUAGEID_MASK)>>>L.LANGUAGEID_OFFSET}static getTokenType(c){return(c&L.TOKEN_TYPE_MASK)>>>L.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(c){return(c&L.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(c){return(c&L.FONT_STYLE_MASK)>>>L.FONT_STYLE_OFFSET}static getForeground(c){return(c&L.FOREGROUND_MASK)>>>L.FOREGROUND_OFFSET}static getBackground(c){return(c&L.BACKGROUND_MASK)>>>L.BACKGROUND_OFFSET}static getClassNameFromMetadata(c){let S="mtk"+this.getForeground(c);const u=this.getFontStyle(c);return u&h.Italic&&(S+=" mtki"),u&h.Bold&&(S+=" mtkb"),u&h.Underline&&(S+=" mtku"),u&h.Strikethrough&&(S+=" mtks"),S}static getInlineStyleFromMetadata(c,I){const S=this.getForeground(c),u=this.getFontStyle(c);let P=`color: ${I[S]};`;u&h.Italic&&(P+="font-style: italic;"),u&h.Bold&&(P+="font-weight: bold;");let w="";return u&h.Underline&&(w+=" underline"),u&h.Strikethrough&&(w+=" line-through"),w&&(P+=`text-decoration:${w};`),P}static getPresentationFromMetadata(c){const I=this.getForeground(c),S=this.getFontStyle(c);return{foreground:I,italic:!!(S&h.Italic),bold:!!(S&h.Bold),underline:!!(S&h.Underline),strikethrough:!!(S&h.Strikethrough)}}}e.$su=T}),define(Se[201],De([1,0,38,16]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tu=C,e.$uu=R;function C(L,T,b,c,I,S){if(Array.isArray(L)){let u=0;for(const P of L){const w=C(P,T,b,c,I,S);if(w===10)return w;w>u&&(u=w)}return u}else{if(typeof L=="string")return c?L==="*"?5:L===b?10:0:0;if(L){const{language:u,pattern:P,scheme:w,hasAccessToAllModels:a,notebookType:m}=L;if(!c&&!a)return 0;m&&I&&(T=I);let $=0;if(w)if(w===T.scheme)$=10;else if(w==="*")$=5;else return 0;if(u)if(u===b)$=10;else if(u==="*")$=Math.max($,5);else return 0;if(m)if(m===S)$=10;else if(m==="*"&&S!==void 0)$=Math.max($,5);else return 0;if(P){let f;if(typeof P=="string"?f=P:f={...P,base:(0,h.$gc)(P.base)},f===T.fsPath||(0,r.$wk)(f,T.fsPath))$=10;else return 0}return $}else return 0}}function R(L){return typeof L=="string"?!1:Array.isArray(L)?L.some(R):!!L.notebookType}}),define(Se[202],De([1,0,26,110]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uu=e.$Tu=e.IndentAction=void 0;var C;(function(b){b[b.None=0]="None",b[b.Indent=1]="Indent",b[b.IndentOutdent=2]="IndentOutdent",b[b.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class R{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let I=0,S=c.notIn.length;I<S;I++)switch(c.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case h.StandardTokenType.Other:return!0;case h.StandardTokenType.Comment:return this.c;case h.StandardTokenType.String:return this.b;case h.StandardTokenType.RegEx:return this.d}}shouldAutoClose(c,I){if(c.getTokenCount()===0)return!0;const S=c.findTokenIndexAtOffset(I-2),u=c.getStandardTokenType(S);return this.isOK(u)}g(c,I){for(let S=c;S<=I;S++){const u=String.fromCharCode(S);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(r.CharCode.Digit0,r.CharCode.Digit9)),this.e||(this.e=this.g(r.CharCode.a,r.CharCode.z)),this.e||(this.e=this.g(r.CharCode.A,r.CharCode.Z))),this.e}}e.$Tu=R;class L{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of c)T(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),T(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),T(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),T(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&T(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$Uu=L;function T(b,c,I){b.has(c)?b.get(c).push(I):b.set(c,[I])}}),define(Se[203],De([1,0,26,139]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x4=e.$w4=e.State=void 0,e.$y4=P;var C;(function(w){w[w.Invalid=0]="Invalid",w[w.Start=1]="Start",w[w.H=2]="H",w[w.HT=3]="HT",w[w.HTT=4]="HTT",w[w.HTTP=5]="HTTP",w[w.F=6]="F",w[w.FI=7]="FI",w[w.FIL=8]="FIL",w[w.BeforeColon=9]="BeforeColon",w[w.AfterColon=10]="AfterColon",w[w.AlmostThere=11]="AlmostThere",w[w.End=12]="End",w[w.Accept=13]="Accept",w[w.LastKnownState=14]="LastKnownState"})(C||(e.State=C={}));class R{constructor(a,m,$){const f=new Uint8Array(a*m);for(let i=0,s=a*m;i<s;i++)f[i]=$;this.a=f,this.rows=a,this.cols=m}get(a,m){return this.a[a*this.cols+m]}set(a,m,$){this.a[a*this.cols+m]=$}}class L{constructor(a){let m=0,$=C.Invalid;for(let i=0,s=a.length;i<s;i++){const[t,o,n]=a[i];o>m&&(m=o),t>$&&($=t),n>$&&($=n)}m++,$++;const f=new R($,m,C.Invalid);for(let i=0,s=a.length;i<s;i++){const[t,o,n]=a[i];f.set(t,o,n)}this.a=f,this.b=m}nextState(a,m){return m<0||m>=this.b?C.Invalid:this.a.get(a,m)}}e.$w4=L;let T=null;function b(){return T===null&&(T=new L([[C.Start,r.CharCode.h,C.H],[C.Start,r.CharCode.H,C.H],[C.Start,r.CharCode.f,C.F],[C.Start,r.CharCode.F,C.F],[C.H,r.CharCode.t,C.HT],[C.H,r.CharCode.T,C.HT],[C.HT,r.CharCode.t,C.HTT],[C.HT,r.CharCode.T,C.HTT],[C.HTT,r.CharCode.p,C.HTTP],[C.HTT,r.CharCode.P,C.HTTP],[C.HTTP,r.CharCode.s,C.BeforeColon],[C.HTTP,r.CharCode.S,C.BeforeColon],[C.HTTP,r.CharCode.Colon,C.AfterColon],[C.F,r.CharCode.i,C.FI],[C.F,r.CharCode.I,C.FI],[C.FI,r.CharCode.l,C.FIL],[C.FI,r.CharCode.L,C.FIL],[C.FIL,r.CharCode.e,C.BeforeColon],[C.FIL,r.CharCode.E,C.BeforeColon],[C.BeforeColon,r.CharCode.Colon,C.AfterColon],[C.AfterColon,r.CharCode.Slash,C.AlmostThere],[C.AlmostThere,r.CharCode.Slash,C.End]])),T}var c;(function(w){w[w.None=0]="None",w[w.ForceTermination=1]="ForceTermination",w[w.CannotEndIn=2]="CannotEndIn"})(c||(c={}));let I=null;function S(){if(I===null){I=new h.$eu(c.None);const w=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<w.length;m++)I.set(w.charCodeAt(m),c.ForceTermination);const a=".,;:";for(let m=0;m<a.length;m++)I.set(a.charCodeAt(m),c.CannotEndIn)}return I}class u{static a(a,m,$,f,i){let s=i-1;do{const t=m.charCodeAt(s);if(a.get(t)!==c.CannotEndIn)break;s--}while(s>f);if(f>0){const t=m.charCodeAt(f-1),o=m.charCodeAt(s);(t===r.CharCode.OpenParen&&o===r.CharCode.CloseParen||t===r.CharCode.OpenSquareBracket&&o===r.CharCode.CloseSquareBracket||t===r.CharCode.OpenCurlyBrace&&o===r.CharCode.CloseCurlyBrace)&&s--}return{range:{startLineNumber:$,startColumn:f+1,endLineNumber:$,endColumn:s+2},url:m.substring(f,s+1)}}static computeLinks(a,m=b()){const $=S(),f=[];for(let i=1,s=a.getLineCount();i<=s;i++){const t=a.getLineContent(i),o=t.length;let n=0,d=0,l=0,g=C.Start,E=!1,D=!1,y=!1,k=!1;for(;n<o;){let A=!1;const p=t.charCodeAt(n);if(g===C.Accept){let v;switch(p){case r.CharCode.OpenParen:E=!0,v=c.None;break;case r.CharCode.CloseParen:v=E?c.None:c.ForceTermination;break;case r.CharCode.OpenSquareBracket:y=!0,D=!0,v=c.None;break;case r.CharCode.CloseSquareBracket:y=!1,v=D?c.None:c.ForceTermination;break;case r.CharCode.OpenCurlyBrace:k=!0,v=c.None;break;case r.CharCode.CloseCurlyBrace:v=k?c.None:c.ForceTermination;break;case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.BackTick:l===p?v=c.ForceTermination:l===r.CharCode.SingleQuote||l===r.CharCode.DoubleQuote||l===r.CharCode.BackTick?v=c.None:v=c.ForceTermination;break;case r.CharCode.Asterisk:v=l===r.CharCode.Asterisk?c.ForceTermination:c.None;break;case r.CharCode.Pipe:v=l===r.CharCode.Pipe?c.ForceTermination:c.None;break;case r.CharCode.Space:v=y?c.None:c.ForceTermination;break;default:v=$.get(p)}v===c.ForceTermination&&(f.push(u.a($,t,i,d,n)),A=!0)}else if(g===C.End){let v;p===r.CharCode.OpenSquareBracket?(D=!0,v=c.None):v=$.get(p),v===c.ForceTermination?A=!0:g=C.Accept}else g=m.nextState(g,p),g===C.Invalid&&(A=!0);A&&(g=C.Start,E=!1,D=!1,k=!1,d=n+1,l=p),n++}g===C.Accept&&f.push(u.a($,t,i,d,o))}return f}}e.$x4=u;function P(w){return!w||typeof w.getLineCount!="function"||typeof w.getLineContent!="function"?[]:u.computeLinks(w)}}),define(Se[58],De([1,0,24]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=e.$ew=e.$dw=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$bw=e.$aw=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$cw=w,e.$gw=s;var h;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(h||(e.OverviewRulerLane=h={}));var C;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(C||(e.GlyphMarginLane=C={}));var R;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var L;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(L||(e.MinimapSectionHeaderStyle=L={}));var T;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(T||(e.InjectedTextCursorStops=T={}));var b;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var c;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(c||(e.DefaultEndOfLine=c={}));var I;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class S{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),o.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,o.indentSize|0),this.a=!1),this.insertSpaces=!!o.insertSpaces,this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=!!o.trimAutoWhitespace,this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.a===o.a&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,r.$fo)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.$aw=S;class u{constructor(o,n){this._findMatchBrand=void 0,this.range=o,this.matches=n}}e.$bw=u;var P;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P||(e.TrackedRangeStickiness=P={}));function w(t){return t&&typeof t.read=="function"}var a;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var m;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class ${constructor(o,n,d,l,g,E){this.identifier=o,this.range=n,this.text=d,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=g,this._isTracked=E}}e.$dw=$;class f{constructor(o,n,d){this.regex=o,this.wordSeparators=n,this.simpleSearch=d}}e.$ew=f;class i{constructor(o,n,d){this.reverseEdits=o,this.changes=n,this.trimAutoWhitespaceLineNumbers=d}}e.$fw=i;function s(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(Se[204],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$C=e.NodeColor=e.$0C=void 0,e.$_C=C,e.$aD=R,e.$bD=c,e.$cD=I,e.$dD=S,e.$eD=u,e.$fD=P,e.$gD=w;class r{constructor(m,$){this.piece=m,this.color=$,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$$C)return C(this.right);let m=this;for(;m.parent!==e.$$C&&m.parent.left!==m;)m=m.parent;return m.parent===e.$$C?e.$$C:m.parent}prev(){if(this.left!==e.$$C)return R(this.left);let m=this;for(;m.parent!==e.$$C&&m.parent.right!==m;)m=m.parent;return m.parent===e.$$C?e.$$C:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$0C=r;var h;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(h||(e.NodeColor=h={})),e.$$C=new r(null,h.Black),e.$$C.parent=e.$$C,e.$$C.left=e.$$C,e.$$C.right=e.$$C,e.$$C.color=h.Black;function C(a){for(;a.left!==e.$$C;)a=a.left;return a}function R(a){for(;a.right!==e.$$C;)a=a.right;return a}function L(a){return a===e.$$C?0:a.size_left+a.piece.length+L(a.right)}function T(a){return a===e.$$C?0:a.lf_left+a.piece.lineFeedCnt+T(a.right)}function b(){e.$$C.parent=e.$$C}function c(a,m){const $=m.right;$.size_left+=m.size_left+(m.piece?m.piece.length:0),$.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=$.left,$.left!==e.$$C&&($.left.parent=m),$.parent=m.parent,m.parent===e.$$C?a.root=$:m.parent.left===m?m.parent.left=$:m.parent.right=$,$.left=m,m.parent=$}function I(a,m){const $=m.left;m.left=$.right,$.right!==e.$$C&&($.right.parent=m),$.parent=m.parent,m.size_left-=$.size_left+($.piece?$.piece.length:0),m.lf_left-=$.lf_left+($.piece?$.piece.lineFeedCnt:0),m.parent===e.$$C?a.root=$:m===m.parent.right?m.parent.right=$:m.parent.left=$,$.right=m,m.parent=$}function S(a,m){let $,f;if(m.left===e.$$C?(f=m,$=f.right):m.right===e.$$C?(f=m,$=f.left):(f=C(m.right),$=f.right),f===a.root){a.root=$,$.color=h.Black,m.detach(),b(),a.root.parent=e.$$C;return}const i=f.color===h.Red;if(f===f.parent.left?f.parent.left=$:f.parent.right=$,f===m?($.parent=f.parent,w(a,$)):(f.parent===m?$.parent=f:$.parent=f.parent,w(a,$),f.left=m.left,f.right=m.right,f.parent=m.parent,f.color=m.color,m===a.root?a.root=f:m===m.parent.left?m.parent.left=f:m.parent.right=f,f.left!==e.$$C&&(f.left.parent=f),f.right!==e.$$C&&(f.right.parent=f),f.size_left=m.size_left,f.lf_left=m.lf_left,w(a,f)),m.detach(),$.parent.left===$){const t=L($),o=T($);if(t!==$.parent.size_left||o!==$.parent.lf_left){const n=t-$.parent.size_left,d=o-$.parent.lf_left;$.parent.size_left=t,$.parent.lf_left=o,P(a,$.parent,n,d)}}if(w(a,$.parent),i){b();return}let s;for(;$!==a.root&&$.color===h.Black;)$===$.parent.left?(s=$.parent.right,s.color===h.Red&&(s.color=h.Black,$.parent.color=h.Red,c(a,$.parent),s=$.parent.right),s.left.color===h.Black&&s.right.color===h.Black?(s.color=h.Red,$=$.parent):(s.right.color===h.Black&&(s.left.color=h.Black,s.color=h.Red,I(a,s),s=$.parent.right),s.color=$.parent.color,$.parent.color=h.Black,s.right.color=h.Black,c(a,$.parent),$=a.root)):(s=$.parent.left,s.color===h.Red&&(s.color=h.Black,$.parent.color=h.Red,I(a,$.parent),s=$.parent.left),s.left.color===h.Black&&s.right.color===h.Black?(s.color=h.Red,$=$.parent):(s.left.color===h.Black&&(s.right.color=h.Black,s.color=h.Red,c(a,s),s=$.parent.left),s.color=$.parent.color,$.parent.color=h.Black,s.left.color=h.Black,I(a,$.parent),$=a.root));$.color=h.Black,b()}function u(a,m){for(w(a,m);m!==a.root&&m.parent.color===h.Red;)if(m.parent===m.parent.parent.left){const $=m.parent.parent.right;$.color===h.Red?(m.parent.color=h.Black,$.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,c(a,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,I(a,m.parent.parent))}else{const $=m.parent.parent.left;$.color===h.Red?(m.parent.color=h.Black,$.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,I(a,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,c(a,m.parent.parent))}a.root.color=h.Black}function P(a,m,$,f){for(;m!==a.root&&m!==e.$$C;)m.parent.left===m&&(m.parent.size_left+=$,m.parent.lf_left+=f),m=m.parent}function w(a,m){let $=0,f=0;if(m!==a.root){for(;m!==a.root&&m===m.parent.right;)m=m.parent;if(m!==a.root)for(m=m.parent,$=L(m.left)-m.size_left,f=T(m.left)-m.lf_left,m.size_left+=$,m.lf_left+=f;m!==a.root&&($!==0||f!==0);)m.parent.left===m&&(m.parent.size_left+=$,m.parent.lf_left+=f),m=m.parent}}}),define(Se[205],De([1,0,18,83]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lw=e.$kw=e.$jw=void 0;class C{constructor(b){this.a=b,this.b=new Uint32Array(b.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(b,c){b=(0,h.$_e)(b);const I=this.a,S=this.b,u=c.length;return u===0?!1:(this.a=new Uint32Array(I.length+u),this.a.set(I.subarray(0,b),0),this.a.set(I.subarray(b),b+u),this.a.set(c,b),b-1<this.c[0]&&(this.c[0]=b-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(S.subarray(0,this.c[0]+1)),!0)}setValue(b,c){return b=(0,h.$_e)(b),c=(0,h.$_e)(c),this.a[b]===c?!1:(this.a[b]=c,b-1<this.c[0]&&(this.c[0]=b-1),!0)}removeValues(b,c){b=(0,h.$_e)(b),c=(0,h.$_e)(c);const I=this.a,S=this.b;if(b>=I.length)return!1;const u=I.length-b;return c>=u&&(c=u),c===0?!1:(this.a=new Uint32Array(I.length-c),this.a.set(I.subarray(0,b),0),this.a.set(I.subarray(b+c),b),this.b=new Uint32Array(this.a.length),b-1<this.c[0]&&(this.c[0]=b-1),this.c[0]>=0&&this.b.set(S.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(b){return b<0?0:(b=(0,h.$_e)(b),this.d(b))}d(b){if(b<=this.c[0])return this.b[b];let c=this.c[0]+1;c===0&&(this.b[0]=this.a[0],c++),b>=this.a.length&&(b=this.a.length-1);for(let I=c;I<=b;I++)this.b[I]=this.b[I-1]+this.a[I];return this.c[0]=Math.max(this.c[0],b),this.b[b]}getIndexOf(b){b=Math.floor(b),this.getTotalSum();let c=0,I=this.a.length-1,S=0,u=0,P=0;for(;c<=I;)if(S=c+(I-c)/2|0,u=this.b[S],P=u-this.a[S],b<P)I=S-1;else if(b>=u)c=S+1;else break;return new L(S,b-P)}}e.$jw=C;class R{constructor(b){this.a=b,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(b){return this.g(),b===0?0:this.d[b-1]}getIndexOf(b){this.g();const c=this.e[b],I=c>0?this.d[c-1]:0;return new L(c,b-I)}removeValues(b,c){this.a.splice(b,c),this.f(b)}insertValues(b,c){this.a=(0,r.$Ub)(this.a,b,c),this.f(b)}f(b){this.b=!1,this.c=Math.min(this.c,b-1)}g(){if(!this.b){for(let b=this.c+1,c=this.a.length;b<c;b++){const I=this.a[b],S=b>0?this.d[b-1]:0;this.d[b]=S+I;for(let u=0;u<I;u++)this.e[S+u]=b}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(b,c){this.a[b]!==c&&(this.a[b]=c,this.f(b))}}e.$kw=R;class L{constructor(b,c){this.index=b,this.remainder=c,this._prefixSumIndexOfResultBrand=void 0,this.index=b,this.remainder=c}}e.$lw=L}),define(Se[206],De([1,0,12,57,205]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=void 0;class R{constructor(T,b,c,I){this.d=T,this.f=b,this.g=c,this.h=I,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(T){T.eol&&T.eol!==this.g&&(this.g=T.eol,this.j=null);const b=T.changes;for(const c of b)this.o(c.range),this.p(new h.$Kt(c.range.startLineNumber,c.range.startColumn),c.text);this.h=T.versionId,this.k=null}l(){if(!this.j){const T=this.g.length,b=this.f.length,c=new Uint32Array(b);for(let I=0;I<b;I++)c[I]=this.f[I].length+T;this.j=new C.$jw(c)}}n(T,b){this.f[T]=b,this.j&&this.j.setValue(T,this.f[T].length+this.g.length)}o(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this.n(T.startLineNumber-1,this.f[T.startLineNumber-1].substring(0,T.startColumn-1)+this.f[T.startLineNumber-1].substring(T.endColumn-1));return}this.n(T.startLineNumber-1,this.f[T.startLineNumber-1].substring(0,T.startColumn-1)+this.f[T.endLineNumber-1].substring(T.endColumn-1)),this.f.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this.j&&this.j.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}p(T,b){if(b.length===0)return;const c=(0,r.$qf)(b);if(c.length===1){this.n(T.lineNumber-1,this.f[T.lineNumber-1].substring(0,T.column-1)+c[0]+this.f[T.lineNumber-1].substring(T.column-1));return}c[c.length-1]+=this.f[T.lineNumber-1].substring(T.column-1),this.n(T.lineNumber-1,this.f[T.lineNumber-1].substring(0,T.column-1)+c[0]);const I=new Uint32Array(c.length-1);for(let S=1;S<c.length;S++)this.f.splice(T.lineNumber+S-1,0,c[S]),I[S-1]=c[S].length+this.g.length;this.j&&this.j.insertValues(T.lineNumber,I)}}e.$mw=R}),define(Se[111],De([1,0,26,12,200,57,30,58]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mD=e.$kD=e.$hD=void 0,e.$iD=I,e.$jD=S,e.$lD=m,h=Ue(h);const b=999;class c{constructor(i,s,t,o){this.searchString=i,this.isRegex=s,this.matchCase=t,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=I(this.searchString):i=this.searchString.indexOf(`
`)>=0;let s=null;try{s=h.$of(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!s)return null;let t=!this.isRegex&&!i;return t&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(t=this.matchCase),new T.$ew(s,this.wordSeparators?(0,C.$hu)(this.wordSeparators,[]):null,t?this.searchString:null)}}e.$hD=c;function I(f){if(!f||f.length===0)return!1;for(let i=0,s=f.length;i<s;i++){const t=f.charCodeAt(i);if(t===r.CharCode.LineFeed)return!0;if(t===r.CharCode.Backslash){if(i++,i>=s)break;const o=f.charCodeAt(i);if(o===r.CharCode.n||o===r.CharCode.r||o===r.CharCode.W)return!0}}return!1}function S(f,i,s){if(!s)return new T.$bw(f,null);const t=[];for(let o=0,n=i.length;o<n;o++)t[o]=i[o];return new T.$bw(f,t)}class u{constructor(i){const s=[];let t=0;for(let o=0,n=i.length;o<n;o++)i.charCodeAt(o)===r.CharCode.LineFeed&&(s[t++]=o);this.a=s}findLineFeedCountBeforeOffset(i){const s=this.a;let t=0,o=s.length-1;if(o===-1||i<=s[0])return 0;for(;t<o;){const n=t+((o-t)/2>>0);s[n]>=i?o=n-1:s[n+1]>=i?(t=n,o=n):t=n+1}return t+1}}class P{static findMatches(i,s,t,o,n){const d=s.parseSearchRequest();return d?d.regex.multiline?this.b(i,t,new $(d.wordSeparators,d.regex),o,n):this.c(i,t,d,o,n):[]}static a(i,s,t,o,n,d){let l,g=0;o?(g=o.findLineFeedCountBeforeOffset(n),l=s+n+g):l=s+n;let E;if(o){const A=o.findLineFeedCountBeforeOffset(n+d.length)-g;E=l+d.length+A}else E=l+d.length;const D=i.getPositionAt(l),y=i.getPositionAt(E);return new L.$Lt(D.lineNumber,D.column,y.lineNumber,y.column)}static b(i,s,t,o,n){const d=i.getOffsetAt(s.getStartPosition()),l=i.getValueInRange(s,T.EndOfLinePreference.LF),g=i.getEOL()===`\r
`?new u(l):null,E=[];let D=0,y;for(t.reset(0);y=t.next(l);)if(E[D++]=S(this.a(i,d,l,g,y.index,y[0]),y,o),D>=n)return E;return E}static c(i,s,t,o,n){const d=[];let l=0;if(s.startLineNumber===s.endLineNumber){const E=i.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return l=this.d(t,E,s.startLineNumber,s.startColumn-1,l,d,o,n),d}const g=i.getLineContent(s.startLineNumber).substring(s.startColumn-1);l=this.d(t,g,s.startLineNumber,s.startColumn-1,l,d,o,n);for(let E=s.startLineNumber+1;E<s.endLineNumber&&l<n;E++)l=this.d(t,i.getLineContent(E),E,0,l,d,o,n);if(l<n){const E=i.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);l=this.d(t,E,s.endLineNumber,0,l,d,o,n)}return d}static d(i,s,t,o,n,d,l,g){const E=i.wordSeparators;if(!l&&i.simpleSearch){const k=i.simpleSearch,A=k.length,p=s.length;let v=-A;for(;(v=s.indexOf(k,v+A))!==-1;)if((!E||m(E,s,p,v,A))&&(d[n++]=new T.$bw(new L.$Lt(t,v+1+o,t,v+1+A+o),null),n>=g))return n;return n}const D=new $(i.wordSeparators,i.regex);let y;D.reset(0);do if(y=D.next(s),y&&(d[n++]=S(new L.$Lt(t,y.index+1+o,t,y.index+1+y[0].length+o),y,l),n>=g))return n;while(y);return n}static findNextMatch(i,s,t,o){const n=s.parseSearchRequest();if(!n)return null;const d=new $(n.wordSeparators,n.regex);return n.regex.multiline?this.e(i,t,d,o):this.f(i,t,d,o)}static e(i,s,t,o){const n=new R.$Kt(s.lineNumber,1),d=i.getOffsetAt(n),l=i.getLineCount(),g=i.getValueInRange(new L.$Lt(n.lineNumber,n.column,l,i.getLineMaxColumn(l)),T.EndOfLinePreference.LF),E=i.getEOL()===`\r
`?new u(g):null;t.reset(s.column-1);const D=t.next(g);return D?S(this.a(i,d,g,E,D.index,D[0]),D,o):s.lineNumber!==1||s.column!==1?this.e(i,new R.$Kt(1,1),t,o):null}static f(i,s,t,o){const n=i.getLineCount(),d=s.lineNumber,l=i.getLineContent(d),g=this.g(t,l,d,s.column,o);if(g)return g;for(let E=1;E<=n;E++){const D=(d+E-1)%n,y=i.getLineContent(D+1),k=this.g(t,y,D+1,1,o);if(k)return k}return null}static g(i,s,t,o,n){i.reset(o-1);const d=i.next(s);return d?S(new L.$Lt(t,d.index+1,t,d.index+1+d[0].length),d,n):null}static findPreviousMatch(i,s,t,o){const n=s.parseSearchRequest();if(!n)return null;const d=new $(n.wordSeparators,n.regex);return n.regex.multiline?this.h(i,t,d,o):this.j(i,t,d,o)}static h(i,s,t,o){const n=this.b(i,new L.$Lt(1,1,s.lineNumber,s.column),t,o,10*b);if(n.length>0)return n[n.length-1];const d=i.getLineCount();return s.lineNumber!==d||s.column!==i.getLineMaxColumn(d)?this.h(i,new R.$Kt(d,i.getLineMaxColumn(d)),t,o):null}static j(i,s,t,o){const n=i.getLineCount(),d=s.lineNumber,l=i.getLineContent(d).substring(0,s.column-1),g=this.k(t,l,d,o);if(g)return g;for(let E=1;E<=n;E++){const D=(n+d-E-1)%n,y=i.getLineContent(D+1),k=this.k(t,y,D+1,o);if(k)return k}return null}static k(i,s,t,o){let n=null,d;for(i.reset(0);d=i.next(s);)n=S(new L.$Lt(t,d.index+1,t,d.index+1+d[0].length),d,o);return n}}e.$kD=P;function w(f,i,s,t,o){if(t===0)return!0;const n=i.charCodeAt(t-1);if(f.get(n)!==C.WordCharacterClass.Regular||n===r.CharCode.CarriageReturn||n===r.CharCode.LineFeed)return!0;if(o>0){const d=i.charCodeAt(t);if(f.get(d)!==C.WordCharacterClass.Regular)return!0}return!1}function a(f,i,s,t,o){if(t+o===s)return!0;const n=i.charCodeAt(t+o);if(f.get(n)!==C.WordCharacterClass.Regular||n===r.CharCode.CarriageReturn||n===r.CharCode.LineFeed)return!0;if(o>0){const d=i.charCodeAt(t+o-1);if(f.get(d)!==C.WordCharacterClass.Regular)return!0}return!1}function m(f,i,s,t,o){return w(f,i,s,t,o)&&a(f,i,s,t,o)}class ${constructor(i,s){this._wordSeparators=i,this.a=s,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const s=i.length;let t;do{if(this.b+this.c===s||(t=this.a.exec(i),!t))return null;const o=t.index,n=t[0].length;if(o===this.b&&n===this.c){if(n===0){h.$Kf(i,s,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=n,!this._wordSeparators||m(this._wordSeparators,i,s,o,n))return t}while(t);return null}}e.$mD=$}),define(Se[141],De([1,0,26,57,30,58,204,111]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rD=e.$qD=e.$pD=void 0,e.$nD=S,e.$oD=u;const b=65535;function c(f){let i;return f[f.length-1]<65536?i=new Uint16Array(f.length):i=new Uint32Array(f.length),i.set(f,0),i}class I{constructor(i,s,t,o,n){this.lineStarts=i,this.cr=s,this.lf=t,this.crlf=o,this.isBasicASCII=n}}function S(f,i=!0){const s=[0];let t=1;for(let o=0,n=f.length;o<n;o++){const d=f.charCodeAt(o);d===r.CharCode.CarriageReturn?o+1<n&&f.charCodeAt(o+1)===r.CharCode.LineFeed?(s[t++]=o+2,o++):s[t++]=o+1:d===r.CharCode.LineFeed&&(s[t++]=o+1)}return i?c(s):s}function u(f,i){f.length=0,f[0]=0;let s=1,t=0,o=0,n=0,d=!0;for(let g=0,E=i.length;g<E;g++){const D=i.charCodeAt(g);D===r.CharCode.CarriageReturn?g+1<E&&i.charCodeAt(g+1)===r.CharCode.LineFeed?(n++,f[s++]=g+2,g++):(t++,f[s++]=g+1):D===r.CharCode.LineFeed?(o++,f[s++]=g+1):d&&D!==r.CharCode.Tab&&(D<32||D>126)&&(d=!1)}const l=new I(c(f),t,o,n,d);return f.length=0,l}class P{constructor(i,s,t,o,n){this.bufferIndex=i,this.start=s,this.end=t,this.lineFeedCnt=o,this.length=n}}e.$pD=P;class w{constructor(i,s){this.buffer=i,this.lineStarts=s}}e.$qD=w;class a{constructor(i,s){this.a=[],this.c=i,this.d=s,this.b=0,i.root!==L.$$C&&i.iterate(i.root,t=>(t!==L.$$C&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class m{constructor(i){this.a=i,this.b=[]}get(i){for(let s=this.b.length-1;s>=0;s--){const t=this.b[s];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let s=this.b.length-1;s>=0;s--){const t=this.b[s];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let s=!1;const t=this.b;for(let o=0;o<t.length;o++){const n=t[o];if(n.node.parent===null||n.nodeStartOffset>=i){t[o]=null,s=!0;continue}}if(s){const o=[];for(const n of t)n!==null&&o.push(n);this.b=o}}}class ${constructor(i,s,t){this.create(i,s,t)}create(i,s,t){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=L.$$C,this.b=1,this.c=0,this.d=s,this.e=s.length,this.f=t;let o=null;for(let n=0,d=i.length;n<d;n++)if(i[n].buffer.length>0){i[n].lineStarts||(i[n].lineStarts=S(i[n].buffer));const l=new P(n+1,{line:0,column:0},{line:i[n].lineStarts.length-1,column:i[n].buffer.length-i[n].lineStarts[i[n].lineStarts.length-1]},i[n].lineStarts.length-1,i[n].buffer.length);this.a.push(i[n]),o=this.S(o,l)}this.h=new m(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const s=b,t=s-Math.floor(s/3),o=t*2;let n="",d=0;const l=[];if(this.iterate(this.root,g=>{const E=this.R(g),D=E.length;if(d<=t||d+D<o)return n+=E,d+=D,!0;const y=n.replace(/\r\n|\r|\n/g,i);return l.push(new w(y,S(y))),n=E,d=D,!0}),d>0){const g=n.replace(/\r\n|\r|\n/g,i);l.push(new w(g,S(g)))}this.create(l,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new a(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let s=0;return this.iterate(this.root,o=>{if(o===L.$$C)return!0;const n=this.R(o),d=n.length,l=i.G(s),g=i.G(s+d),E=i.getValueInRange2(l,g);return s+=d,n===E})}getOffsetAt(i,s){let t=0,o=this.root;for(;o!==L.$$C;)if(o.left!==L.$$C&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){t+=o.size_left;const n=this.B(o,i-o.lf_left-2);return t+=n+s-1}else i-=o.lf_left+o.piece.lineFeedCnt,t+=o.size_left+o.piece.length,o=o.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let s=this.root,t=0;const o=i;for(;s!==L.$$C;)if(s.size_left!==0&&s.size_left>=i)s=s.left;else if(s.size_left+s.piece.length>=i){const n=this.A(s,i-s.size_left);if(t+=s.lf_left+n.index,n.index===0){const d=this.getOffsetAt(t+1,1),l=o-d;return new h.$Kt(t+1,l+1)}return new h.$Kt(t+1,n.remainder+1)}else if(i-=s.size_left+s.piece.length,t+=s.lf_left+s.piece.lineFeedCnt,s.right===L.$$C){const n=this.getOffsetAt(t+1,1),d=o-i-n;return new h.$Kt(t+1,d+1)}else s=s.right;return new h.$Kt(1,1)}getValueInRange(i,s){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),o=this.H(i.endLineNumber,i.endColumn),n=this.getValueInRange2(t,o);return s?s!==this.d||!this.f?n.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this.f?n:n.replace(/\r\n|\r|\n/g,s):n}getValueInRange2(i,s){if(i.node===s.node){const l=i.node,g=this.a[l.piece.bufferIndex].buffer,E=this.u(l.piece.bufferIndex,l.piece.start);return g.substring(E+i.remainder,E+s.remainder)}let t=i.node;const o=this.a[t.piece.bufferIndex].buffer,n=this.u(t.piece.bufferIndex,t.piece.start);let d=o.substring(n+i.remainder,n+t.piece.length);for(t=t.next();t!==L.$$C;){const l=this.a[t.piece.bufferIndex].buffer,g=this.u(t.piece.bufferIndex,t.piece.start);if(t===s.node){d+=l.substring(g,g+s.remainder);break}else d+=l.substr(g,t.piece.length);t=t.next()}return d}getLinesContent(){const i=[];let s=0,t="",o=!1;return this.iterate(this.root,n=>{if(n===L.$$C)return!0;const d=n.piece;let l=d.length;if(l===0)return!0;const g=this.a[d.bufferIndex].buffer,E=this.a[d.bufferIndex].lineStarts,D=d.start.line,y=d.end.line;let k=E[D]+d.start.column;if(o&&(g.charCodeAt(k)===r.CharCode.LineFeed&&(k++,l--),i[s++]=t,t="",o=!1,l===0))return!0;if(D===y)return!this.f&&g.charCodeAt(k+l-1)===r.CharCode.CarriageReturn?(o=!0,t+=g.substr(k,l-1)):t+=g.substr(k,l),!0;t+=this.f?g.substring(k,Math.max(k,E[D+1]-this.e)):g.substring(k,E[D+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=t;for(let A=D+1;A<y;A++)t=this.f?g.substring(E[A],E[A+1]-this.e):g.substring(E[A],E[A+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=t;return!this.f&&g.charCodeAt(E[y]+d.end.column-1)===r.CharCode.CarriageReturn?(o=!0,d.end.column===0?s--:t=g.substr(E[y],d.end.column-1)):t=g.substr(E[y],d.end.column),!0}),o&&(i[s++]=t,t=""),i[s++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const s=i.node.next();if(!s)return 0;const t=this.a[s.piece.bufferIndex],o=this.u(s.piece.bufferIndex,s.piece.start);return t.buffer.charCodeAt(o)}else{const s=this.a[i.node.piece.bufferIndex],o=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return s.buffer.charCodeAt(o)}}getLineCharCode(i,s){const t=this.H(i,s+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const s=this.getOffsetAt(i,1);return this.getLength()-s}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const s=this.G(i);return this.l(s)}getNearestChunk(i){const s=this.G(i);if(s.remainder===s.node.piece.length){const t=s.node.next();if(!t||t===L.$$C)return"";const o=this.a[t.piece.bufferIndex],n=this.u(t.piece.bufferIndex,t.piece.start);return o.buffer.substring(n,n+t.piece.length)}else{const t=this.a[s.node.piece.bufferIndex],o=this.u(s.node.piece.bufferIndex,s.node.piece.start),n=o+s.remainder,d=o+s.node.piece.length;return t.buffer.substring(n,d)}}findMatchesInNode(i,s,t,o,n,d,l,g,E,D,y){const k=this.a[i.piece.bufferIndex],A=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,n),v=this.u(i.piece.bufferIndex,d);let F;const N={line:0,column:0};let O,j;s._wordSeparators?(O=k.buffer.substring(p,v),j=z=>z+p,s.reset(0)):(O=k.buffer,j=z=>z,s.reset(p));do if(F=s.next(O),F){if(j(F.index)>=v)return D;this.s(i,j(F.index)-A,N);const z=this.t(i.piece.bufferIndex,n,N),M=N.line===n.line?N.column-n.column+o:N.column+1,W=M+F[0].length;if(y[D++]=(0,T.$jD)(new C.$Lt(t+z,M,t+z,W),F,g),j(F.index)+F[0].length>=v||D>=E)return D}while(F);return D}findMatchesLineByLine(i,s,t,o){const n=[];let d=0;const l=new T.$mD(s.wordSeparators,s.regex);let g=this.H(i.startLineNumber,i.startColumn);if(g===null)return[];const E=this.H(i.endLineNumber,i.endColumn);if(E===null)return[];let D=this.s(g.node,g.remainder);const y=this.s(E.node,E.remainder);if(g.node===E.node)return this.findMatchesInNode(g.node,l,i.startLineNumber,i.startColumn,D,y,s,t,o,d,n),n;let k=i.startLineNumber,A=g.node;for(;A!==E.node;){const v=this.t(A.piece.bufferIndex,D,A.piece.end);if(v>=1){const N=this.a[A.piece.bufferIndex].lineStarts,O=this.u(A.piece.bufferIndex,A.piece.start),j=N[D.line+v],z=k===i.startLineNumber?i.startColumn:1;if(d=this.findMatchesInNode(A,l,k,z,D,this.s(A,j-O),s,t,o,d,n),d>=o)return n;k+=v}const F=k===i.startLineNumber?i.startColumn-1:0;if(k===i.endLineNumber){const N=this.getLineContent(k).substring(F,i.endColumn-1);return d=this.n(s,l,N,i.endLineNumber,F,d,n,t,o),n}if(d=this.n(s,l,this.getLineContent(k).substr(F),k,F,d,n,t,o),d>=o)return n;k++,g=this.H(k,1),A=g.node,D=this.s(g.node,g.remainder)}if(k===i.endLineNumber){const v=k===i.startLineNumber?i.startColumn-1:0,F=this.getLineContent(k).substring(v,i.endColumn-1);return d=this.n(s,l,F,i.endLineNumber,v,d,n,t,o),n}const p=k===i.startLineNumber?i.startColumn:1;return d=this.findMatchesInNode(E.node,l,k,p,D,y,s,t,o,d,n),n}n(i,s,t,o,n,d,l,g,E){const D=i.wordSeparators;if(!g&&i.simpleSearch){const k=i.simpleSearch,A=k.length,p=t.length;let v=-A;for(;(v=t.indexOf(k,v+A))!==-1;)if((!D||(0,T.$lD)(D,t,p,v,A))&&(l[d++]=new R.$bw(new C.$Lt(o,v+1+n,o,v+1+A+n),null),d>=E))return d;return d}let y;s.reset(0);do if(y=s.next(t),y&&(l[d++]=(0,T.$jD)(new C.$Lt(o,y.index+1+n,o,y.index+1+y[0].length+n),y,g),d>=E))return d;while(y);return d}insert(i,s,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==L.$$C){const{node:o,remainder:n,nodeStartOffset:d}=this.G(i),l=o.piece,g=l.bufferIndex,E=this.s(o,n);if(o.piece.bufferIndex===0&&l.end.line===this.g.line&&l.end.column===this.g.column&&d+l.length===i&&s.length<b){this.F(o,s),this.y();return}if(d===i)this.o(s,o),this.h.validate(i);else if(d+o.piece.length>i){const D=[];let y=new P(l.bufferIndex,E,l.end,this.t(l.bufferIndex,E,l.end),this.u(g,l.end)-this.u(g,E));if(this.K()&&this.M(s)&&this.I(o,n)===10){const v={line:y.start.line+1,column:0};y=new P(y.bufferIndex,v,y.end,this.t(y.bufferIndex,v,y.end),y.length-1),s+=`
`}if(this.K()&&this.L(s))if(this.I(o,n-1)===13){const v=this.s(o,n-1);this.C(o,v),s="\r"+s,o.piece.length===0&&D.push(o)}else this.C(o,E);else this.C(o,E);const k=this.w(s);y.length>0&&this.S(o,y);let A=o;for(let p=0;p<k.length;p++)A=this.S(A,k[p]);this.v(D)}else this.q(s,o)}else{const o=this.w(s);let n=this.T(null,o[0]);for(let d=1;d<o.length;d++)n=this.S(n,o[d])}this.y()}delete(i,s){if(this.j.lineNumber=0,this.j.value="",s<=0||this.root===L.$$C)return;const t=this.G(i),o=this.G(i+s),n=t.node,d=o.node;if(n===d){const k=this.s(n,t.remainder),A=this.s(n,o.remainder);if(t.nodeStartOffset===i){if(s===n.piece.length){const p=n.next();(0,L.$dD)(this,n),this.N(p),this.y();return}this.D(n,A),this.h.validate(i),this.N(n),this.y();return}if(t.nodeStartOffset+n.piece.length===i+s){this.C(n,k),this.O(n),this.y();return}this.E(n,k,A),this.y();return}const l=[],g=this.s(n,t.remainder);this.C(n,g),this.h.validate(i),n.piece.length===0&&l.push(n);const E=this.s(d,o.remainder);this.D(d,E),d.piece.length===0&&l.push(d);const D=n.next();for(let k=D;k!==L.$$C&&k!==d;k=k.next())l.push(k);const y=n.piece.length===0?n.prev():n;this.v(l),this.O(y),this.y()}o(i,s){const t=[];if(this.K()&&this.M(i)&&this.L(s)){const d=s.piece,l={line:d.start.line+1,column:0},g=new P(d.bufferIndex,l,d.end,this.t(d.bufferIndex,l,d.end),d.length-1);s.piece=g,i+=`
`,(0,L.$fD)(this,s,-1,-1),s.piece.length===0&&t.push(s)}const o=this.w(i);let n=this.T(s,o[o.length-1]);for(let d=o.length-2;d>=0;d--)n=this.T(n,o[d]);this.N(n),this.v(t)}q(i,s){this.Q(i,s)&&(i+=`
`);const t=this.w(i),o=this.S(s,t[0]);let n=o;for(let d=1;d<t.length;d++)n=this.S(n,t[d]);this.N(o)}s(i,s,t){const o=i.piece,n=i.piece.bufferIndex,d=this.a[n].lineStarts,g=d[o.start.line]+o.start.column+s;let E=o.start.line,D=o.end.line,y=0,k=0,A=0;for(;E<=D&&(y=E+(D-E)/2|0,A=d[y],y!==D);)if(k=d[y+1],g<A)D=y-1;else if(g>=k)E=y+1;else break;return t?(t.line=y,t.column=g-A,null):{line:y,column:g-A}}t(i,s,t){if(t.column===0)return t.line-s.line;const o=this.a[i].lineStarts;if(t.line===o.length-1)return t.line-s.line;const n=o[t.line+1],d=o[t.line]+t.column;if(n>d+1)return t.line-s.line;const l=d-1;return this.a[i].buffer.charCodeAt(l)===13?t.line-s.line+1:t.line-s.line}u(i,s){return this.a[i].lineStarts[s.line]+s.column}v(i){for(let s=0;s<i.length;s++)(0,L.$dD)(this,i[s])}w(i){if(i.length>b){const D=[];for(;i.length>b;){const k=i.charCodeAt(b-1);let A;k===r.CharCode.CarriageReturn||k>=55296&&k<=56319?(A=i.substring(0,b-1),i=i.substring(b-1)):(A=i.substring(0,b),i=i.substring(b));const p=S(A);D.push(new P(this.a.length,{line:0,column:0},{line:p.length-1,column:A.length-p[p.length-1]},p.length-1,A.length)),this.a.push(new w(A,p))}const y=S(i);return D.push(new P(this.a.length,{line:0,column:0},{line:y.length-1,column:i.length-y[y.length-1]},y.length-1,i.length)),this.a.push(new w(i,y)),D}let s=this.a[0].buffer.length;const t=S(i,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===s&&s!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let D=0;D<t.length;D++)t[D]+=s+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,s+=1}else{if(s!==0)for(let D=0;D<t.length;D++)t[D]+=s;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const n=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,l=n-this.a[0].lineStarts[d],g={line:d,column:l},E=new P(0,o,g,this.t(0,o,g),n-s);return this.g=g,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,s=0){let t=this.root,o="";const n=this.h.get2(i);if(n){t=n.node;const d=this.B(t,i-n.nodeStartLineNumber-1),l=this.a[t.piece.bufferIndex].buffer,g=this.u(t.piece.bufferIndex,t.piece.start);if(n.nodeStartLineNumber+t.piece.lineFeedCnt===i)o=l.substring(g+d,g+t.piece.length);else{const E=this.B(t,i-n.nodeStartLineNumber);return l.substring(g+d,g+E-s)}}else{let d=0;const l=i;for(;t!==L.$$C;)if(t.left!==L.$$C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const g=this.B(t,i-t.lf_left-2),E=this.B(t,i-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,y=this.u(t.piece.bufferIndex,t.piece.start);return d+=t.size_left,this.h.set({node:t,nodeStartOffset:d,nodeStartLineNumber:l-(i-1-t.lf_left)}),D.substring(y+g,y+E-s)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const g=this.B(t,i-t.lf_left-2),E=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);o=E.substring(D+g,D+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,d+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==L.$$C;){const d=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const l=this.B(t,0),g=this.u(t.piece.bufferIndex,t.piece.start);return o+=d.substring(g,g+l-s),o}else{const l=this.u(t.piece.bufferIndex,t.piece.start);o+=d.substr(l,t.piece.length)}t=t.next()}return o}y(){let i=this.root,s=1,t=0;for(;i!==L.$$C;)s+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=s,this.c=t,this.h.validate(this.c)}A(i,s){const t=i.piece,o=this.s(i,s),n=o.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===s){const d=this.t(i.piece.bufferIndex,t.start,o);if(d!==n)return{index:d,remainder:0}}return{index:n,remainder:o.column}}B(i,s){if(s<0)return 0;const t=i.piece,o=this.a[t.bufferIndex].lineStarts,n=t.start.line+s+1;return n>t.end.line?o[t.end.line]+t.end.column-o[t.start.line]-t.start.column:o[n]-o[t.start.line]-t.start.column}C(i,s){const t=i.piece,o=t.lineFeedCnt,n=this.u(t.bufferIndex,t.end),d=s,l=this.u(t.bufferIndex,d),g=this.t(t.bufferIndex,t.start,d),E=g-o,D=l-n,y=t.length+D;i.piece=new P(t.bufferIndex,t.start,d,g,y),(0,L.$fD)(this,i,D,E)}D(i,s){const t=i.piece,o=t.lineFeedCnt,n=this.u(t.bufferIndex,t.start),d=s,l=this.t(t.bufferIndex,d,t.end),g=this.u(t.bufferIndex,d),E=l-o,D=n-g,y=t.length+D;i.piece=new P(t.bufferIndex,d,t.end,l,y),(0,L.$fD)(this,i,D,E)}E(i,s,t){const o=i.piece,n=o.start,d=o.end,l=o.length,g=o.lineFeedCnt,E=s,D=this.t(o.bufferIndex,o.start,E),y=this.u(o.bufferIndex,s)-this.u(o.bufferIndex,n);i.piece=new P(o.bufferIndex,o.start,E,D,y),(0,L.$fD)(this,i,y-l,D-g);const k=new P(o.bufferIndex,t,d,this.t(o.bufferIndex,t,d),this.u(o.bufferIndex,d)-this.u(o.bufferIndex,t)),A=this.S(i,k);this.N(A)}F(i,s){this.Q(s,i)&&(s+=`
`);const t=this.K()&&this.L(s)&&this.M(i),o=this.a[0].buffer.length;this.a[0].buffer+=s;const n=S(s,!1);for(let A=0;A<n.length;A++)n[A]+=o;if(t){const A=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-A}}this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1));const d=this.a[0].lineStarts.length-1,l=this.a[0].buffer.length-this.a[0].lineStarts[d],g={line:d,column:l},E=i.piece.length+s.length,D=i.piece.lineFeedCnt,y=this.t(0,i.piece.start,g),k=y-D;i.piece=new P(i.piece.bufferIndex,i.piece.start,g,y,E),this.g=g,(0,L.$fD)(this,i,s.length,k)}G(i){let s=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let o=0;for(;s!==L.$$C;)if(s.size_left>i)s=s.left;else if(s.size_left+s.piece.length>=i){o+=s.size_left;const n={node:s,remainder:i-s.size_left,nodeStartOffset:o};return this.h.set(n),n}else i-=s.size_left+s.piece.length,o+=s.size_left+s.piece.length,s=s.right;return null}H(i,s){let t=this.root,o=0;for(;t!==L.$$C;)if(t.left!==L.$$C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const n=this.B(t,i-t.lf_left-2),d=this.B(t,i-t.lf_left-1);return o+=t.size_left,{node:t,remainder:Math.min(n+s-1,d),nodeStartOffset:o}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const n=this.B(t,i-t.lf_left-2);if(n+s-1<=t.piece.length)return{node:t,remainder:n+s-1,nodeStartOffset:o};s-=t.piece.length-n;break}else i-=t.lf_left+t.piece.lineFeedCnt,o+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==L.$$C;){if(t.piece.lineFeedCnt>0){const n=this.B(t,0),d=this.J(t);return{node:t,remainder:Math.min(s-1,n),nodeStartOffset:d}}else if(t.piece.length>=s-1){const n=this.J(t);return{node:t,remainder:s-1,nodeStartOffset:n}}else s-=t.piece.length;t=t.next()}return null}I(i,s){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start)+s;return t.buffer.charCodeAt(o)}J(i){if(!i)return 0;let s=i.size_left;for(;i!==this.root;)i.parent.right===i&&(s+=i.parent.size_left+i.parent.piece.length),i=i.parent;return s}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===L.$$C||i.piece.lineFeedCnt===0)return!1;const s=i.piece,t=this.a[s.bufferIndex].lineStarts,o=s.start.line,n=t[o]+s.start.column;return o===t.length-1||t[o+1]>n+1?!1:this.a[s.bufferIndex].buffer.charCodeAt(n)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===L.$$C||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const s=i.prev();this.M(s)&&this.P(s,i)}}O(i){if(this.K()&&this.M(i)){const s=i.next();this.L(s)&&this.P(i,s)}}P(i,s){const t=[],o=this.a[i.piece.bufferIndex].lineStarts;let n;i.piece.end.column===0?n={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:n={line:i.piece.end.line,column:i.piece.end.column-1};const d=i.piece.length-1,l=i.piece.lineFeedCnt-1;i.piece=new P(i.piece.bufferIndex,i.piece.start,n,l,d),(0,L.$fD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const g={line:s.piece.start.line+1,column:0},E=s.piece.length-1,D=this.t(s.piece.bufferIndex,g,s.piece.end);s.piece=new P(s.piece.bufferIndex,g,s.piece.end,D,E),(0,L.$fD)(this,s,-1,-1),s.piece.length===0&&t.push(s);const y=this.w(`\r
`);this.S(i,y[0]);for(let k=0;k<t.length;k++)(0,L.$dD)(this,t[k])}Q(i,s){if(this.K()&&this.M(i)){const t=s.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,L.$dD)(this,t);else{const o=t.piece,n={line:o.start.line+1,column:0},d=o.length-1,l=this.t(o.bufferIndex,n,o.end);t.piece=new P(o.bufferIndex,n,o.end,l,d),(0,L.$fD)(this,t,-1,-1)}return!0}}return!1}iterate(i,s){if(i===L.$$C)return s(L.$$C);const t=this.iterate(i.left,s);return t&&s(i)&&this.iterate(i.right,s)}R(i){if(i===L.$$C)return"";const s=this.a[i.piece.bufferIndex],t=i.piece,o=this.u(t.bufferIndex,t.start),n=this.u(t.bufferIndex,t.end);return s.buffer.substring(o,n)}getPieceContent(i){const s=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),o=this.u(i.bufferIndex,i.end);return s.buffer.substring(t,o)}S(i,s){const t=new L.$0C(s,L.NodeColor.Red);if(t.left=L.$$C,t.right=L.$$C,t.parent=L.$$C,t.size_left=0,t.lf_left=0,this.root===L.$$C)this.root=t,t.color=L.NodeColor.Black;else if(i.right===L.$$C)i.right=t,t.parent=i;else{const n=(0,L.$_C)(i.right);n.left=t,t.parent=n}return(0,L.$eD)(this,t),t}T(i,s){const t=new L.$0C(s,L.NodeColor.Red);if(t.left=L.$$C,t.right=L.$$C,t.parent=L.$$C,t.size_left=0,t.lf_left=0,this.root===L.$$C)this.root=t,t.color=L.NodeColor.Black;else if(i.left===L.$$C)i.left=t,t.parent=i;else{const o=(0,L.$aD)(i.left);o.right=t,t.parent=o}return(0,L.$eD)(this,t),t}U(i){let s="";return this.iterate(i,t=>(s+=this.R(t),!0)),s}}e.$rD=$}),define(Se[207],De([1,0,4,12,30,58,141,194,198,3]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sD=void 0,h=Ue(h);class I extends c.$Tc{constructor(u,P,w,a,m,$,f){super(),this.m=this.B(new r.$je),this.onDidChangeContent=this.m.event,this.f=P,this.j=!$,this.g=a,this.h=m,this.c=new L.$rD(u,w,f)}equals(u){return!(u instanceof I)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,P){return this.c.getOffsetAt(u,P)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,P){const w=u+P,a=this.getPositionAt(u),m=this.getPositionAt(w);return new C.$Lt(a.lineNumber,a.column,m.lineNumber,m.column)}getValueInRange(u,P=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const w=this.n(P);return this.c.getValueInRange(u,w)}getValueLengthInRange(u,P=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const w=this.getOffsetAt(u.startLineNumber,u.startColumn),a=this.getOffsetAt(u.endLineNumber,u.endColumn);let m=0;const $=this.n(P),f=this.getEOL();if($.length!==f.length){const i=$.length-f.length,s=u.endLineNumber-u.startLineNumber;m=i*s}return a-w+m}getCharacterCountInRange(u,P=R.EndOfLinePreference.TextDefined){if(this.j){let w=0;const a=u.startLineNumber,m=u.endLineNumber;for(let $=a;$<=m;$++){const f=this.getLineContent($),i=$===a?u.startColumn-1:0,s=$===m?u.endColumn-1:f.length;for(let t=i;t<s;t++)h.$Hf(f.charCodeAt(t))?(w=w+1,t=t+1):w=w+1}return w+=this.n(P).length*(m-a),w}return this.getValueLengthInRange(u,P)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,P){return this.c.getLineCharCode(u,P)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const P=h.$sf(this.getLineContent(u));return P===-1?0:P+1}getLineLastNonWhitespaceColumn(u){const P=h.$uf(this.getLineContent(u));return P===-1?0:P+2}n(u){switch(u){case R.EndOfLinePreference.LF:return`
`;case R.EndOfLinePreference.CRLF:return`\r
`;case R.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,P,w){let a=this.g,m=this.h,$=this.j,f=!0,i=[];for(let g=0;g<u.length;g++){const E=u[g];f&&E._isTracked&&(f=!1);const D=E.range;if(E.text){let v=!0;$||(v=!h.$Sf(E.text),$=v),!a&&v&&(a=h.$Rf(E.text)),!m&&v&&(m=h.$Uf(E.text))}let y="",k=0,A=0,p=0;if(E.text){let v;[k,A,p,v]=(0,T.$wu)(E.text);const F=this.getEOL(),N=F===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;v===T.StringEOL.Unknown||v===N?y=E.text:y=E.text.replace(/\r\n|\r|\n/g,F)}i[g]={sortIndex:g,identifier:E.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:y,eolCount:k,firstLineLength:A,lastLineLength:p,forceMoveMarkers:!!E.forceMoveMarkers,isAutoWhitespaceEdit:E.isAutoWhitespaceEdit||!1}}i.sort(I.u);let s=!1;for(let g=0,E=i.length-1;g<E;g++){const D=i[g].range.getEndPosition(),y=i[g+1].range.getStartPosition();if(y.isBeforeOrEqual(D)){if(y.isBefore(D))throw new Error("Overlapping ranges are not allowed!");s=!0}}f&&(i=this.s(i));const t=w||P?I._getInverseEditRanges(i):[],o=[];if(P)for(let g=0;g<i.length;g++){const E=i[g],D=t[g];if(E.isAutoWhitespaceEdit&&E.range.isEmpty())for(let y=D.startLineNumber;y<=D.endLineNumber;y++){let k="";y===D.startLineNumber&&(k=this.getLineContent(E.range.startLineNumber),h.$sf(k)!==-1)||o.push({lineNumber:y,oldContent:k})}}let n=null;if(w){let g=0;n=[];for(let E=0;E<i.length;E++){const D=i[E],y=t[E],k=this.getValueInRange(D.range),A=D.rangeOffset+g;g+=D.text.length-k.length,n[E]={sortIndex:D.sortIndex,identifier:D.identifier,range:y,text:k,textChange:new b.$cu(D.rangeOffset,k,A,D.text)}}s||n.sort((E,D)=>E.sortIndex-D.sortIndex)}this.g=a,this.h=m,this.j=$;const d=this.t(i);let l=null;if(P&&o.length>0){o.sort((g,E)=>E.lineNumber-g.lineNumber),l=[];for(let g=0,E=o.length;g<E;g++){const D=o[g].lineNumber;if(g>0&&o[g-1].lineNumber===D)continue;const y=o[g].oldContent,k=this.getLineContent(D);k.length===0||k===y||h.$sf(k)!==-1||l.push(D)}}return this.m.fire(),new R.$fw(n,d,l)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let P=!1;const w=u[0].range,a=u[u.length-1].range,m=new C.$Lt(w.startLineNumber,w.startColumn,a.endLineNumber,a.endColumn);let $=w.startLineNumber,f=w.startColumn;const i=[];for(let d=0,l=u.length;d<l;d++){const g=u[d],E=g.range;P=P||g.forceMoveMarkers,i.push(this.getValueInRange(new C.$Lt($,f,E.startLineNumber,E.startColumn))),g.text.length>0&&i.push(g.text),$=E.endLineNumber,f=E.endColumn}const s=i.join(""),[t,o,n]=(0,T.$wu)(s);return{sortIndex:0,identifier:u[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,R.EndOfLinePreference.TextDefined),text:s,eolCount:t,firstLineLength:o,lastLineLength:n,forceMoveMarkers:P,isAutoWhitespaceEdit:!1}}t(u){u.sort(I.w);const P=[];for(let w=0;w<u.length;w++){const a=u[w],m=a.range.startLineNumber,$=a.range.startColumn,f=a.range.endLineNumber,i=a.range.endColumn;if(m===f&&$===i&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const s=new C.$Lt(m,$,f,i);P.push({range:s,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return P}findMatchesLineByLine(u,P,w,a){return this.c.findMatchesLineByLine(u,P,w,a)}getPieceTree(){return this.c}static _getInverseEditRange(u,P){const w=u.startLineNumber,a=u.startColumn,[m,$,f]=(0,T.$wu)(P);let i;if(P.length>0){const s=m+1;s===1?i=new C.$Lt(w,a,w,a+$):i=new C.$Lt(w,a,w+s-1,f+1)}else i=new C.$Lt(w,a,w,a);return i}static _getInverseEditRanges(u){const P=[];let w=0,a=0,m=null;for(let $=0,f=u.length;$<f;$++){const i=u[$];let s,t;m?m.range.endLineNumber===i.range.startLineNumber?(s=w,t=a+(i.range.startColumn-m.range.endColumn)):(s=w+(i.range.startLineNumber-m.range.endLineNumber),t=i.range.startColumn):(s=i.range.startLineNumber,t=i.range.startColumn);let o;if(i.text.length>0){const n=i.eolCount+1;n===1?o=new C.$Lt(s,t,s,t+i.firstLineLength):o=new C.$Lt(s,t,s+n-1,i.lastLineLength+1)}else o=new C.$Lt(s,t,s,t);w=o.endLineNumber,a=o.endColumn,P.push(o),m=i}return P}static u(u,P){const w=C.$Lt.compareRangesUsingEnds(u.range,P.range);return w===0?u.sortIndex-P.sortIndex:w}static w(u,P){const w=C.$Lt.compareRangesUsingEnds(u.range,P.range);return w===0?P.sortIndex-u.sortIndex:-w}}e.$sD=I}),define(Se[208],De([1,0,26,12,58,141,207]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tD=void 0,h=Ue(h);class T{constructor(I,S,u,P,w,a,m,$,f){this.a=I,this.b=S,this.c=u,this.d=P,this.e=w,this.f=a,this.g=m,this.h=$,this.j=f}k(I){const S=this.c+this.d+this.e,u=this.c+this.e;return S===0?I===C.DefaultEndOfLine.LF?`
`:`\r
`:u>S/2?`\r
`:`
`}create(I){const S=this.k(I),u=this.a;if(this.j&&(S===`\r
`&&(this.c>0||this.d>0)||S===`
`&&(this.c>0||this.e>0)))for(let w=0,a=u.length;w<a;w++){const m=u[w].buffer.replace(/\r\n|\r|\n/g,S),$=(0,R.$nD)(m);u[w]=new R.$qD(m,$)}const P=new L.$sD(u,this.b,S,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class b{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&h.$3f(I)&&(this.b=h.$2f,I=I.substr(1));const S=I.charCodeAt(I.length-1);S===r.CharCode.CarriageReturn||S>=55296&&S<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=S):(this.m(I,!1),this.c=!1,this.d=S)}m(I,S){!S&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const S=(0,R.$oD)(this.e,I);this.a.push(new R.$qD(I,S.lineStarts)),this.f+=S.cr,this.g+=S.lf,this.h+=S.crlf,S.isBasicASCII||(this.l=!1,this.j||(this.j=h.$Rf(I)),this.k||(this.k=h.$Uf(I)))}finish(I=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const S=(0,R.$nD)(I.buffer);I.lineStarts=S,this.d===r.CharCode.CarriageReturn&&this.f++}}}e.$tD=b}),define(Se[142],De([1,0,21,10]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndb=b,e.$Odb=I,h=Ue(h);var C;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(C||(C={}));function R(S){for(let u=0,P=S.length;u<P;u+=4){const w=S[u+0],a=S[u+1],m=S[u+2],$=S[u+3];S[u+0]=$,S[u+1]=m,S[u+2]=a,S[u+3]=w}}function L(S){const u=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return h.$E()||R(u),r.$Le.wrap(u)}function T(S){const u=S.buffer;if(h.$E()||R(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const P=new Uint8Array(u.byteLength);return P.set(u),new Uint32Array(P.buffer,P.byteOffset,P.length/4)}}function b(S){const u=new Uint32Array(c(S));let P=0;if(u[P++]=S.id,S.type==="full")u[P++]=C.Full,u[P++]=S.data.length,u.set(S.data,P),P+=S.data.length;else{u[P++]=C.Delta,u[P++]=S.deltas.length;for(const w of S.deltas)u[P++]=w.start,u[P++]=w.deleteCount,w.data?(u[P++]=w.data.length,u.set(w.data,P),P+=w.data.length):u[P++]=0}return L(u)}function c(S){let u=0;if(u+=2,S.type==="full")u+=1+S.data.length;else{u+=1,u+=3*S.deltas.length;for(const P of S.deltas)P.data&&(u+=P.data.length)}return u}function I(S){const u=T(S);let P=0;const w=u[P++];if(u[P++]===C.Full){const f=u[P++],i=u.subarray(P,P+f);return P+=f,{id:w,type:"full",data:i}}const m=u[P++],$=[];for(let f=0;f<m;f++){const i=u[P++],s=u[P++],t=u[P++];let o;t>0&&(o=u.subarray(P,P+t),P+=t),$[f]={start:i,deleteCount:s,data:o}}return{id:w,type:"delta",deltas:$}}}),define(Se[209],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F_=e.$E_=void 0;class r{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const L=this.a.get(R);return this.a.delete(R),L}}addDragOperationTransfer(R,L){this.a.set(R,L)}}e.$E_=r;class h{constructor(R){this.identifier=R}}e.$F_=h}),define(Se[210],De([1,0,4,3,110]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vu=void 0;class R{constructor(){this.a=new Map,this.b=new Map,this.c=new r.$je,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,c){return this.a.set(b,c),this.handleChange([b]),(0,h.$Rc)(()=>{this.a.get(b)===c&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,c){this.b.get(b)?.dispose();const I=new L(this,b,c);return this.b.set(b,I),(0,h.$Rc)(()=>{const S=this.b.get(b);!S||S!==I||(this.b.delete(b),S.dispose())})}async getOrCreate(b){const c=this.get(b);if(c)return c;const I=this.b.get(b);return!I||I.isResolved?null:(await I.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const I=this.b.get(b);return!!(!I||I.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>C.ColorId.DefaultBackground?this.d[C.ColorId.DefaultBackground]:null}}e.$vu=R;class L extends h.$Tc{get isResolved(){return this.c}constructor(b,c,I){super(),this.f=b,this.g=c,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(Se[8],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=C,e.localize2=L;const r=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function h(T,b){let c;return b.length===0?c=T:c=T.replace(/\{(\d+)\}/g,(I,S)=>{const u=S[0],P=b[u];let w=I;return typeof P=="string"?w=P:(typeof P=="number"||typeof P=="boolean"||P===void 0||P===null)&&(w=String(P)),w}),r&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function C(T,b,...c){return h(typeof T=="number"?R(T,b):b,c)}function R(T,b){const c=globalThis._VSCODE_NLS_MESSAGES?.[T];if(typeof c!="string"){if(typeof b=="string")return b;throw new Error(`!!! NLS MISSING: ${T} !!!`)}return c}function L(T,b,...c){let I;typeof T=="number"?I=R(T,b):I=b;const S=h(I,c);return{value:S,original:b===I?S:h(b,c)}}}),define(Se[211],De([1,0,4,3,8]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=void 0,e.$mj=I,C=Ue(C);class R extends h.$Tc{constructor(u,P="",w="",a=!0,m){super(),this.j=this.B(new r.$je),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=P,this.w=w,this.z=a,this.D=m}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,P){this.D&&await this.D(u)}}e.$hj=R;class L extends h.$Tc{constructor(){super(...arguments),this.f=this.B(new r.$je),this.onWillRun=this.f.event,this.m=this.B(new r.$je),this.onDidRun=this.m.event}async run(u,P){if(!u.enabled)return;this.f.fire({action:u});let w;try{await this.u(u,P)}catch(a){w=a}this.m.fire({action:u,error:w})}async u(u,P){await u.run(P)}}e.$ij=L;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let P=[];for(const w of u)w.length&&(P.length?P=[...P,new T,...w]:P=w);return P}static{this.ID="vs.actions.separator"}async run(){}}e.$jj=T;class b{get actions(){return this.a}constructor(u,P,w,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=P,this.class=a,this.a=w}async run(){}}e.$kj=b;class c extends R{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,C.localize(12953,null),void 0,!1)}}e.$lj=c;function I(S){return{id:S.id,label:S.label,tooltip:S.tooltip??S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked,run:async(...u)=>S.run(...u)}}}),define(Se[212],De([1,0,8]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=c,e.$Zm=I,e.$1m=S;const h=60,C=h*60,R=C*24,L=R*7,T=R*30,b=R*365;function c(u,P,w,a){typeof u!="number"&&(u=u.getTime());const m=Math.round((new Date().getTime()-u)/1e3);if(m<-30)return(0,r.localize)(12890,null,c(new Date().getTime()+m*1e3,!1));if(!a&&m<30)return(0,r.localize)(12891,null);let $;return m<h?($=m,P?$===1?w?(0,r.localize)(12892,null,$):(0,r.localize)(12893,null,$):w?(0,r.localize)(12894,null,$):(0,r.localize)(12895,null,$):$===1?w?(0,r.localize)(12896,null,$):(0,r.localize)(12897,null,$):w?(0,r.localize)(12898,null,$):(0,r.localize)(12899,null,$)):m<C?($=Math.floor(m/h),P?$===1?w?(0,r.localize)(12900,null,$):(0,r.localize)(12901,null,$):w?(0,r.localize)(12902,null,$):(0,r.localize)(12903,null,$):$===1?w?(0,r.localize)(12904,null,$):(0,r.localize)(12905,null,$):w?(0,r.localize)(12906,null,$):(0,r.localize)(12907,null,$)):m<R?($=Math.floor(m/C),P?$===1?w?(0,r.localize)(12908,null,$):(0,r.localize)(12909,null,$):w?(0,r.localize)(12910,null,$):(0,r.localize)(12911,null,$):$===1?w?(0,r.localize)(12912,null,$):(0,r.localize)(12913,null,$):w?(0,r.localize)(12914,null,$):(0,r.localize)(12915,null,$)):m<L?($=Math.floor(m/R),P?$===1?(0,r.localize)(12916,null,$):(0,r.localize)(12917,null,$):$===1?(0,r.localize)(12918,null,$):(0,r.localize)(12919,null,$)):m<T?($=Math.floor(m/L),P?$===1?w?(0,r.localize)(12920,null,$):(0,r.localize)(12921,null,$):w?(0,r.localize)(12922,null,$):(0,r.localize)(12923,null,$):$===1?w?(0,r.localize)(12924,null,$):(0,r.localize)(12925,null,$):w?(0,r.localize)(12926,null,$):(0,r.localize)(12927,null,$)):m<b?($=Math.floor(m/T),P?$===1?w?(0,r.localize)(12928,null,$):(0,r.localize)(12929,null,$):w?(0,r.localize)(12930,null,$):(0,r.localize)(12931,null,$):$===1?w?(0,r.localize)(12932,null,$):(0,r.localize)(12933,null,$):w?(0,r.localize)(12934,null,$):(0,r.localize)(12935,null,$)):($=Math.floor(m/b),P?$===1?w?(0,r.localize)(12936,null,$):(0,r.localize)(12937,null,$):w?(0,r.localize)(12938,null,$):(0,r.localize)(12939,null,$):$===1?w?(0,r.localize)(12940,null,$):(0,r.localize)(12941,null,$):w?(0,r.localize)(12942,null,$):(0,r.localize)(12943,null,$))}function I(u,P){const w=Math.abs(u/1e3);return w<1?P?(0,r.localize)(12944,null,u):(0,r.localize)(12945,null,u):w<h?P?(0,r.localize)(12946,null,Math.round(u)/1e3):(0,r.localize)(12947,null,Math.round(u)/1e3):w<C?P?(0,r.localize)(12948,null,Math.round(u/(1e3*h))):(0,r.localize)(12949,null,Math.round(u/(1e3*h))):w<R?P?(0,r.localize)(12950,null,Math.round(u/(1e3*C))):(0,r.localize)(12951,null,Math.round(u/(1e3*C))):(0,r.localize)(12952,null,Math.round(u/(1e3*R)))}function S(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Se[52],De([1,0,18,17,8]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=b,e.$oj=c,e.$pj=I,r=Ue(r),h=Ue(h),C=Ue(C);function R(S,u){return u&&(S.stack||S.stacktrace)?C.localize(12884,null,T(S),L(S.stack)||L(S.stacktrace)):T(S)}function L(S){return Array.isArray(S)?S.join(`
`):S}function T(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?C.localize(12885,null,S.message):S.message||C.localize(12886,null)}function b(S=null,u=!1){if(!S)return C.localize(12887,null);if(Array.isArray(S)){const P=r.$Gb(S),w=b(P[0],u);return P.length>1?C.localize(12888,null,w,P.length):w}if(h.$cg(S))return S;if(S.detail){const P=S.detail;if(P.error)return R(P.error,u);if(P.exception)return R(P.exception,u)}return S.stack?R(S,u):S.message?S.message:C.localize(12889,null)}function c(S){const u=S;return u instanceof Error&&Array.isArray(u.actions)}function I(S,u){let P;return typeof S=="string"?P=new Error(S):P=S,P.actions=u,P}}),define(Se[87],De([1,0,82,2,195,30,210,8]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Ou=e.$Nu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Mu=e.$Lu=e.SymbolKinds=e.SymbolTag=e.$Ju=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Hu=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Gu=e.$Fu=e.$Eu=void 0,e.$Iu=d,e.$Ku=g;class b{constructor(K,Y,ee){this.offset=K,this.type=Y,this.language=ee,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Eu=b;class c{constructor(K,Y){this.tokens=K,this.endState=Y,this._tokenizationResultBrand=void 0}}e.$Fu=c;class I{constructor(K,Y){this.tokens=K,this.endState=Y,this._encodedTokenizationResultBrand=void 0}}e.$Gu=I;var S;(function(B){B[B.Increase=0]="Increase",B[B.Decrease=1]="Decrease"})(S||(e.HoverVerbosityAction=S={}));var u;(function(B){B[B.Method=0]="Method",B[B.Function=1]="Function",B[B.Constructor=2]="Constructor",B[B.Field=3]="Field",B[B.Variable=4]="Variable",B[B.Class=5]="Class",B[B.Struct=6]="Struct",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Event=10]="Event",B[B.Operator=11]="Operator",B[B.Unit=12]="Unit",B[B.Value=13]="Value",B[B.Constant=14]="Constant",B[B.Enum=15]="Enum",B[B.EnumMember=16]="EnumMember",B[B.Keyword=17]="Keyword",B[B.Text=18]="Text",B[B.Color=19]="Color",B[B.File=20]="File",B[B.Reference=21]="Reference",B[B.Customcolor=22]="Customcolor",B[B.Folder=23]="Folder",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue",B[B.Snippet=27]="Snippet"})(u||(e.CompletionItemKind=u={}));var P;(function(B){const K=new Map;K.set(u.Method,r.$2j.symbolMethod),K.set(u.Function,r.$2j.symbolFunction),K.set(u.Constructor,r.$2j.symbolConstructor),K.set(u.Field,r.$2j.symbolField),K.set(u.Variable,r.$2j.symbolVariable),K.set(u.Class,r.$2j.symbolClass),K.set(u.Struct,r.$2j.symbolStruct),K.set(u.Interface,r.$2j.symbolInterface),K.set(u.Module,r.$2j.symbolModule),K.set(u.Property,r.$2j.symbolProperty),K.set(u.Event,r.$2j.symbolEvent),K.set(u.Operator,r.$2j.symbolOperator),K.set(u.Unit,r.$2j.symbolUnit),K.set(u.Value,r.$2j.symbolValue),K.set(u.Enum,r.$2j.symbolEnum),K.set(u.Constant,r.$2j.symbolConstant),K.set(u.Enum,r.$2j.symbolEnum),K.set(u.EnumMember,r.$2j.symbolEnumMember),K.set(u.Keyword,r.$2j.symbolKeyword),K.set(u.Snippet,r.$2j.symbolSnippet),K.set(u.Text,r.$2j.symbolText),K.set(u.Color,r.$2j.symbolColor),K.set(u.File,r.$2j.symbolFile),K.set(u.Reference,r.$2j.symbolReference),K.set(u.Customcolor,r.$2j.symbolCustomColor),K.set(u.Folder,r.$2j.symbolFolder),K.set(u.TypeParameter,r.$2j.symbolTypeParameter),K.set(u.User,r.$2j.account),K.set(u.Issue,r.$2j.issues);function Y(re){let ye=K.get(re);return ye||(console.info("No codicon found for CompletionItemKind "+re),ye=r.$2j.symbolProperty),ye}B.toIcon=Y;const ee=new Map;ee.set("method",u.Method),ee.set("function",u.Function),ee.set("constructor",u.Constructor),ee.set("field",u.Field),ee.set("variable",u.Variable),ee.set("class",u.Class),ee.set("struct",u.Struct),ee.set("interface",u.Interface),ee.set("module",u.Module),ee.set("property",u.Property),ee.set("event",u.Event),ee.set("operator",u.Operator),ee.set("unit",u.Unit),ee.set("value",u.Value),ee.set("constant",u.Constant),ee.set("enum",u.Enum),ee.set("enum-member",u.EnumMember),ee.set("enumMember",u.EnumMember),ee.set("keyword",u.Keyword),ee.set("snippet",u.Snippet),ee.set("text",u.Text),ee.set("color",u.Color),ee.set("file",u.File),ee.set("reference",u.Reference),ee.set("customcolor",u.Customcolor),ee.set("folder",u.Folder),ee.set("type-parameter",u.TypeParameter),ee.set("typeParameter",u.TypeParameter),ee.set("account",u.User),ee.set("issue",u.Issue);function ue(re,ye){let me=ee.get(re);return typeof me>"u"&&!ye&&(me=u.Property),me}B.fromString=ue})(P||(e.CompletionItemKinds=P={}));var w;(function(B){B[B.Deprecated=1]="Deprecated"})(w||(e.CompletionItemTag=w={}));var a;(function(B){B[B.None=0]="None",B[B.KeepWhitespace=1]="KeepWhitespace",B[B.InsertAsSnippet=4]="InsertAsSnippet"})(a||(e.CompletionItemInsertTextRule=a={}));var m;(function(B){B[B.Word=0]="Word",B[B.Line=1]="Line",B[B.Suggest=2]="Suggest"})(m||(e.PartialAcceptTriggerKind=m={}));var $;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})($||(e.CompletionTriggerKind=$={}));var f;(function(B){B[B.Automatic=0]="Automatic",B[B.Explicit=1]="Explicit"})(f||(e.InlineCompletionTriggerKind=f={}));class i{constructor(K,Y,ee,ue){this.range=K,this.text=Y,this.completionKind=ee,this.isSnippetText=ue}equals(K){return R.$Lt.lift(this.range).equalsRange(K.range)&&this.text===K.text&&this.completionKind===K.completionKind&&this.isSnippetText===K.isSnippetText}}e.$Hu=i;var s;(function(B){B[B.Invoke=1]="Invoke",B[B.Auto=2]="Auto"})(s||(e.CodeActionTriggerType=s={}));var t;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var o;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(o||(e.SignatureHelpTriggerKind=o={}));var n;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function d(B){return B&&h.URI.isUri(B.uri)&&R.$Lt.isIRange(B.range)&&(R.$Lt.isIRange(B.originSelectionRange)||R.$Lt.isIRange(B.targetSelectionRange))}var l;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(l||(e.SymbolKind=l={})),e.$Ju={[l.Array]:(0,T.localize)(12754,null),[l.Boolean]:(0,T.localize)(12755,null),[l.Class]:(0,T.localize)(12756,null),[l.Constant]:(0,T.localize)(12757,null),[l.Constructor]:(0,T.localize)(12758,null),[l.Enum]:(0,T.localize)(12759,null),[l.EnumMember]:(0,T.localize)(12760,null),[l.Event]:(0,T.localize)(12761,null),[l.Field]:(0,T.localize)(12762,null),[l.File]:(0,T.localize)(12763,null),[l.Function]:(0,T.localize)(12764,null),[l.Interface]:(0,T.localize)(12765,null),[l.Key]:(0,T.localize)(12766,null),[l.Method]:(0,T.localize)(12767,null),[l.Module]:(0,T.localize)(12768,null),[l.Namespace]:(0,T.localize)(12769,null),[l.Null]:(0,T.localize)(12770,null),[l.Number]:(0,T.localize)(12771,null),[l.Object]:(0,T.localize)(12772,null),[l.Operator]:(0,T.localize)(12773,null),[l.Package]:(0,T.localize)(12774,null),[l.Property]:(0,T.localize)(12775,null),[l.String]:(0,T.localize)(12776,null),[l.Struct]:(0,T.localize)(12777,null),[l.TypeParameter]:(0,T.localize)(12778,null),[l.Variable]:(0,T.localize)(12779,null)};function g(B,K){return(0,T.localize)(12780,null,B,e.$Ju[K])}var E;(function(B){B[B.Deprecated=1]="Deprecated"})(E||(e.SymbolTag=E={}));var D;(function(B){const K=new Map;K.set(l.File,r.$2j.symbolFile),K.set(l.Module,r.$2j.symbolModule),K.set(l.Namespace,r.$2j.symbolNamespace),K.set(l.Package,r.$2j.symbolPackage),K.set(l.Class,r.$2j.symbolClass),K.set(l.Method,r.$2j.symbolMethod),K.set(l.Property,r.$2j.symbolProperty),K.set(l.Field,r.$2j.symbolField),K.set(l.Constructor,r.$2j.symbolConstructor),K.set(l.Enum,r.$2j.symbolEnum),K.set(l.Interface,r.$2j.symbolInterface),K.set(l.Function,r.$2j.symbolFunction),K.set(l.Variable,r.$2j.symbolVariable),K.set(l.Constant,r.$2j.symbolConstant),K.set(l.String,r.$2j.symbolString),K.set(l.Number,r.$2j.symbolNumber),K.set(l.Boolean,r.$2j.symbolBoolean),K.set(l.Array,r.$2j.symbolArray),K.set(l.Object,r.$2j.symbolObject),K.set(l.Key,r.$2j.symbolKey),K.set(l.Null,r.$2j.symbolNull),K.set(l.EnumMember,r.$2j.symbolEnumMember),K.set(l.Struct,r.$2j.symbolStruct),K.set(l.Event,r.$2j.symbolEvent),K.set(l.Operator,r.$2j.symbolOperator),K.set(l.TypeParameter,r.$2j.symbolTypeParameter);function Y(ee){let ue=K.get(ee);return ue||(console.info("No codicon found for SymbolKind "+ee),ue=r.$2j.symbolProperty),ue}B.toIcon=Y})(D||(e.SymbolKinds=D={}));class y{static asEditOperation(K){return C.$Mt.replace(R.$Lt.lift(K.range),K.text)}}e.$Lu=y;class k{static{this.Comment=new k("comment")}static{this.Imports=new k("imports")}static{this.Region=new k("region")}static fromValue(K){switch(K){case"comment":return k.Comment;case"imports":return k.Imports;case"region":return k.Region}return new k(K)}constructor(K){this.value=K}}e.$Mu=k;var A;(function(B){B[B.AIGenerated=1]="AIGenerated"})(A||(e.NewSymbolNameTag=A={}));var p;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(p||(e.NewSymbolNameTriggerKind=p={}));var v;(function(B){function K(Y){return!Y||typeof Y!="object"?!1:typeof Y.id=="string"&&typeof Y.title=="string"}B.is=K})(v||(e.Command=v={}));var F;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(F||(e.CommentThreadCollapsibleState=F={}));var N;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(N||(e.CommentThreadState=N={}));var O;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(O||(e.CommentThreadApplicability=O={}));var j;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(j||(e.CommentMode=j={}));var z;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(z||(e.CommentState=z={}));var M;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(M||(e.InlayHintKind=M={}));class W{constructor(K){this.b=K,this.a=null}dispose(){this.a&&this.a.then(K=>{K&&K.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Nu=W,e.$Ou=new L.$vu;var V;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(V||(e.ExternalUriOpenerPriority=V={}));var ne;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(ne||(e.InlineEditTriggerKind=ne={}))}),define(Se[213],De([1,0,26,13,8]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var R;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(R||(e.TokenType=R={}));function L(...I){switch(I.length){case 1:return(0,C.localize)(11492,null,I[0]);case 2:return(0,C.localize)(11493,null,I[0],I[1]);case 3:return(0,C.localize)(11494,null,I[0],I[1],I[2]);default:return}}const T=(0,C.localize)(11495,null),b=(0,C.localize)(11496,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(S){switch(S.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return S.isTripleEq?"===":"==";case R.NotEq:return S.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return S.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return S.lexeme;case R.QuotedStr:return S.lexeme;case R.Error:return S.lexeme;case R.EOF:return"EOF";default:throw(0,h.$7)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0)))}static{this.b=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this.g}reset(S){return this.c=S,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case r.CharCode.OpenParen:this.k(R.LParen);break;case r.CharCode.CloseParen:this.k(R.RParen);break;case r.CharCode.ExclamationMark:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.NotEq,offset:this.d,isTripleEq:u})}else this.k(R.Neg);break;case r.CharCode.SingleQuote:this.o();break;case r.CharCode.Slash:this.q();break;case r.CharCode.Equals:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.Eq,offset:this.d,isTripleEq:u})}else this.h(r.CharCode.Tilde)?this.k(R.RegexOp):this.l(L("==","=~"));break;case r.CharCode.LessThan:this.k(this.h(r.CharCode.Equals)?R.LtEq:R.Lt);break;case r.CharCode.GreaterThan:this.k(this.h(r.CharCode.Equals)?R.GtEq:R.Gt);break;case r.CharCode.Ampersand:this.h(r.CharCode.Ampersand)?this.k(R.And):this.l(L("&&"));break;case r.CharCode.Pipe:this.h(r.CharCode.Pipe)?this.k(R.Or):this.l(L("||"));break;case r.CharCode.Space:case r.CharCode.CarriageReturn:case r.CharCode.Tab:case r.CharCode.LineFeed:case r.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(R.EOF),Array.from(this.f)}h(S){return this.r()||this.c.charCodeAt(this.e)!==S?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?r.CharCode.Null:this.c.charCodeAt(this.e)}k(S){this.f.push({type:S,offset:this.d})}l(S){const u=this.d,P=this.c.substring(this.d,this.e),w={type:R.Error,offset:this.d,lexeme:P};this.g.push({offset:u,lexeme:P,additionalInfo:S}),this.f.push(w)}n(){this.m.lastIndex=this.d;const S=this.m.exec(this.c);if(S){this.e=this.d+S[0].length;const u=this.c.substring(this.d,this.e),P=c.b.get(u);P?this.k(P):this.f.push({type:R.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==r.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:R.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let S=this.e,u=!1,P=!1;for(;;){if(S>=this.c.length){this.e=S,this.l(b);return}const a=this.c.charCodeAt(S);if(u)u=!1;else if(a===r.CharCode.Slash&&!P){S++;break}else a===r.CharCode.OpenSquareBracket?P=!0:a===r.CharCode.Backslash?u=!0:a===r.CharCode.CloseSquareBracket&&(P=!1);S++}for(;S<this.c.length&&c.a.has(this.c.charCodeAt(S));)S++;this.e=S;const w=this.c.substring(this.d,this.e);this.f.push({type:R.RegexStr,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=c}),define(Se[143],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const r={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(r)}),define(Se[112],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class r{constructor(C,R=[],L=!1){this.ctor=C,this.staticArguments=R,this.supportsDelayedInstantiation=L}}e.$zi=r}),define(Se[88],De([1,0,112]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Os=R,e.$Ps=L;const h=[];var C;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function R(T,b,c){b instanceof r.$zi||(b=new r.$zi(b,[],!!c)),h.push([T,b])}function L(){return h}}),define(Se[214],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=void 0;class r{constructor(R,L){this.key=R,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$rr=r;class h{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const L of this.a.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const T=this.lookupOrInsertNode(R),b=this.lookupOrInsertNode(L);T.outgoing.set(b.key,b),b.incoming.set(T.key,T)}removeNode(R){const L=this.b(R);this.a.delete(L);for(const T of this.a.values())T.outgoing.delete(L),T.incoming.delete(L)}lookupOrInsertNode(R){const L=this.b(R);let T=this.a.get(L);return T||(T=new r(L,R),this.a.set(L,T)),T}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[L,T]of this.a)R.push(`${L}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,L]of this.a){const T=new Set([R]),b=this.c(L,T);if(b)return b}}c(R,L){for(const[T,b]of R.outgoing){if(L.has(T))return[...L,T].join(" -> ");L.add(T);const c=this.c(b,L);if(c)return c;L.delete(T)}}}e.$sr=h}),define(Se[5],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e._util=void 0,e.$Ci=C,e.$Di=R;var r;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function T(b){return b[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=T})(r||(e._util=r={})),e.$Bi=C("instantiationService");function h(L,T,b){T[r.DI_TARGET]===T?T[r.DI_DEPENDENCIES].push({id:L,index:b}):(T[r.DI_DEPENDENCIES]=[{id:L,index:b}],T[r.DI_TARGET]=T)}function C(L){if(r.serviceIds.has(L))return r.serviceIds.get(L);const T=function(b,c,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");h(T,b,I)};return T.toString=()=>L,r.serviceIds.set(L,T),T}function R(L){return L}}),define(Se[45],De([1,0,17,2,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=R,e.$$i=L,e.$_i=b,e.$aj=c,e.$bj=I,e.$cj=S,e.$dj=u,e.$ej=w,e.$fj=a,e.$gj=m,r=Ue(r),e.$9i=(0,C.$Ci)("configurationService");function R($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof h.URI)}function L($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof h.URI)}var T;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function b($){switch($){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function c($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}function I($,f){const i=Object.create(null);for(const s in $)S(i,s,$[s],f);return i}function S($,f,i,s){const t=f.split("."),o=t.pop();let n=$;for(let d=0;d<t.length;d++){const l=t[d];let g=n[l];switch(typeof g){case"undefined":g=n[l]=Object.create(null);break;case"object":if(g===null){s(`Ignoring ${f} as ${t.slice(0,d+1).join(".")} is null`);return}break;default:s(`Ignoring ${f} as ${t.slice(0,d+1).join(".")} is ${JSON.stringify(g)}`);return}n=g}if(typeof n=="object"&&n!==null)try{n[o]=i}catch{s(`Ignoring ${f} as ${t.join(".")} is ${JSON.stringify(n)}`)}else s(`Ignoring ${f} as ${t.join(".")} is ${JSON.stringify(n)}`)}function u($,f){const i=f.split(".");P($,i)}function P($,f){const i=f.shift();if(f.length===0){delete $[i];return}if(Object.keys($).indexOf(i)!==-1){const s=$[i];typeof s=="object"&&!Array.isArray(s)&&(P(s,f),Object.keys(s).length===0&&delete $[i])}}function w($,f,i){function s(n,d){let l=n;for(const g of d){if(typeof l!="object"||l===null)return;l=l[g]}return l}const t=f.split("."),o=s($,t);return typeof o>"u"?i:o}function a($,f,i){Object.keys(f).forEach(s=>{s!=="__proto__"&&(s in $?r.$eg($[s])&&r.$eg(f[s])?a($[s],f[s],i):i&&($[s]=f[s]):$[s]=f[s])})}function m($){return $.replace(/[\[\]]/g,"")}}),define(Se[35],De([1,0,26,10,12,213,5,8,13]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=I,e.$Bj=d,e.$Cj=l,e.$Vj=re;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",h.$k),c.set("isLinux",h.$l),c.set("isWindows",h.$j),c.set("isWeb",h.$p),c.set("isMacNative",h.$k&&!h.$p),c.set("isEdge",h.$I),c.set("isFirefox",h.$G),c.set("isChrome",h.$F),c.set("isSafari",h.$H);function I(J,U){if(c.get(J)!==void 0)throw(0,b.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(J,U)}const S=Object.prototype.hasOwnProperty;var u;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const P={regexParsingWithErrorRecovery:!0},w=(0,T.localize)(11506,null),a=(0,T.localize)(11507,null),m=(0,T.localize)(11508,null),$=(0,T.localize)(11509,null),f=(0,T.localize)(11510,null),i=(0,T.localize)(11511,null),s=(0,T.localize)(11512,null),t=(0,T.localize)(11513,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=P){this.k=U,this.d=new R.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:a});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const se=this.l();if(!this.E()){const ae=this.D(),te=ae.type===R.TokenType.Str?i:void 0;throw this.h.push({message:f,offset:ae.offset,lexeme:R.$xj.getLexeme(ae),additionalInfo:te}),o.c}return se}catch(se){if(se!==o.c)throw se;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(R.TokenType.Or);){const se=this.o();U.push(se)}return U.length===1?U[0]:n.or(...U)}o(){const U=[this.s()];for(;this.y(R.TokenType.And);){const se=this.s();U.push(se)}return U.length===1?U[0]:n.and(...U)}s(){if(this.y(R.TokenType.Neg)){const U=this.D();switch(U.type){case R.TokenType.True:return this.z(),E.INSTANCE;case R.TokenType.False:return this.z(),D.INSTANCE;case R.TokenType.LParen:{this.z();const se=this.l();return this.A(R.TokenType.RParen,$),se?.negate()}case R.TokenType.Str:return this.z(),F.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case R.TokenType.True:return this.z(),n.true();case R.TokenType.False:return this.z(),n.false();case R.TokenType.LParen:{this.z();const se=this.l();return this.A(R.TokenType.RParen,$),se}case R.TokenType.Str:{const se=U.lexeme;if(this.z(),this.y(R.TokenType.RegexOp)){const te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),te.type!==R.TokenType.RegexStr)throw this.B("REGEX",te);const ce=te.lexeme,le=ce.lastIndexOf("/"),x=le===ce.length-1?void 0:this.w(ce.substring(le+1));let oe;try{oe=new RegExp(ce.substring(1,le),x)}catch{throw this.B("REGEX",te)}return W.create(se,oe)}switch(te.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const ce=[te.lexeme];this.z();let le=this.D(),x=0;for(let ze=0;ze<te.lexeme.length;ze++)te.lexeme.charCodeAt(ze)===r.CharCode.OpenParen?x++:te.lexeme.charCodeAt(ze)===r.CharCode.CloseParen&&x--;for(;!this.E()&&le.type!==R.TokenType.And&&le.type!==R.TokenType.Or;){switch(le.type){case R.TokenType.LParen:x++;break;case R.TokenType.RParen:x--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let ze=0;ze<le.lexeme.length;ze++)le.lexeme.charCodeAt(ze)===r.CharCode.OpenParen?x++:te.lexeme.charCodeAt(ze)===r.CharCode.CloseParen&&x--}if(x<0)break;ce.push(R.$xj.getLexeme(le)),this.z(),le=this.D()}const oe=ce.join(""),pe=oe.lastIndexOf("/"),we=pe===oe.length-1?void 0:this.w(oe.substring(pe+1));let Fe;try{Fe=new RegExp(oe.substring(1,pe),we)}catch{throw this.B("REGEX",te)}return n.regex(se,Fe)}case R.TokenType.QuotedStr:{const ce=te.lexeme;this.z();let le=null;if(!(0,C.$af)(ce)){const x=ce.indexOf("/"),oe=ce.lastIndexOf("/");if(x!==oe&&x>=0){const pe=ce.slice(x+1,oe),we=ce[oe+1]==="i"?"i":"";try{le=new RegExp(pe,we)}catch{throw this.B("REGEX",te)}}}if(le===null)throw this.B("REGEX",te);return W.create(se,le)}default:throw this.B("REGEX",this.D())}}if(this.y(R.TokenType.Not)){this.A(R.TokenType.In,m);const te=this.u();return n.notIn(se,te)}switch(this.D().type){case R.TokenType.Eq:{this.z();const te=this.u();if(this.x().type===R.TokenType.QuotedStr)return n.equals(se,te);switch(te){case"true":return n.has(se);case"false":return n.not(se);default:return n.equals(se,te)}}case R.TokenType.NotEq:{this.z();const te=this.u();if(this.x().type===R.TokenType.QuotedStr)return n.notEquals(se,te);switch(te){case"true":return n.not(se);case"false":return n.has(se);default:return n.notEquals(se,te)}}case R.TokenType.Lt:return this.z(),z.create(se,this.u());case R.TokenType.LtEq:return this.z(),M.create(se,this.u());case R.TokenType.Gt:return this.z(),O.create(se,this.u());case R.TokenType.GtEq:return this.z(),j.create(se,this.u());case R.TokenType.In:return this.z(),n.in(se,this.u());default:return n.has(se)}}case R.TokenType.EOF:throw this.h.push({message:s,offset:U.offset,lexeme:"",additionalInfo:t}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this.z(),U.lexeme;case R.TokenType.True:return this.z(),"true";case R.TokenType.False:return this.z(),"false";case R.TokenType.In:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,se){if(this.C(U))return this.z();throw this.B(se,this.D())}B(U,se,ae){const te=(0,T.localize)(11514,null,U,R.$xj.getLexeme(se)),ce=se.offset,le=R.$xj.getLexeme(se);return this.h.push({message:te,offset:ce,lexeme:le,additionalInfo:ae}),o.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===R.TokenType.EOF}}e.$zj=o;class n{static false(){return E.INSTANCE}static true(){return D.INSTANCE}static has(U){return y.create(U)}static equals(U,se){return k.create(U,se)}static notEquals(U,se){return v.create(U,se)}static regex(U,se){return W.create(U,se)}static in(U,se){return A.create(U,se)}static notIn(U,se){return p.create(U,se)}static not(U){return F.create(U)}static and(...U){return B.create(U,null,!0)}static or(...U){return K.create(U,null,!0)}static greater(U,se){return O.create(U,se)}static greaterEquals(U,se){return j.create(U,se)}static smaller(U,se){return z.create(U,se)}static smallerEquals(U,se){return M.create(U,se)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Aj=n;function d(J){const U=new o({regexParsingWithErrorRecovery:!1});return J.map(se=>(U.parse(se),U.lexingErrors.length>0?U.lexingErrors.map(ae=>({errorMessage:ae.additionalInfo?(0,T.localize)(11515,null,ae.additionalInfo):(0,T.localize)(11516,null),offset:ae.offset,length:ae.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(ae=>({errorMessage:ae.additionalInfo?`${ae.message}. ${ae.additionalInfo}`:ae.message,offset:ae.offset,length:ae.lexeme.length})):[]))}function l(J,U){const se=J?J.substituteConstants():void 0,ae=U?U.substituteConstants():void 0;return!se&&!ae?!0:!se||!ae?!1:se.equals(ae)}function g(J,U){return J.cmp(U)}class E{static{this.INSTANCE=new E}constructor(){this.type=u.False}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return D.INSTANCE}}e.$Dj=E;class D{static{this.INSTANCE=new D}constructor(){this.type=u.True}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return E.INSTANCE}}e.$Ej=D;class y{static create(U,se=null){const ae=c.get(U);return typeof ae=="boolean"?ae?D.INSTANCE:E.INSTANCE:new y(U,se)}constructor(U,se){this.key=U,this.c=se,this.type=u.Defined}cmp(U){return U.type!==this.type?this.type-U.type:ee(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=c.get(this.key);return typeof U=="boolean"?U?D.INSTANCE:E.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Fj=y;class k{static create(U,se,ae=null){if(typeof se=="boolean")return se?y.create(U,ae):F.create(U,ae);const te=c.get(U);return typeof te=="boolean"?se===(te?"true":"false")?D.INSTANCE:E.INSTANCE:new k(U,se,ae)}constructor(U,se,ae){this.c=U,this.d=se,this.f=ae,this.type=u.Equals}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=c.get(this.c);if(typeof U=="boolean"){const se=U?"true":"false";return this.d===se?D.INSTANCE:E.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Gj=k;class A{static create(U,se){return new A(U,se)}constructor(U,se){this.d=U,this.f=se,this.type=u.In,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const se=U.getValue(this.f),ae=U.getValue(this.d);return Array.isArray(se)?se.includes(ae):typeof ae=="string"&&typeof se=="object"&&se!==null?S.call(se,ae):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$Hj=A;class p{static create(U,se){return new p(U,se)}constructor(U,se){this.d=U,this.f=se,this.type=u.NotIn,this.c=A.create(U,se)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=p;class v{static create(U,se,ae=null){if(typeof se=="boolean")return se?F.create(U,ae):y.create(U,ae);const te=c.get(U);return typeof te=="boolean"?se===(te?"true":"false")?E.INSTANCE:D.INSTANCE:new v(U,se,ae)}constructor(U,se,ae){this.c=U,this.d=se,this.f=ae,this.type=u.NotEquals}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=c.get(this.c);if(typeof U=="boolean"){const se=U?"true":"false";return this.d===se?E.INSTANCE:D.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Jj=v;class F{static create(U,se=null){const ae=c.get(U);return typeof ae=="boolean"?ae?E.INSTANCE:D.INSTANCE:new F(U,se)}constructor(U,se){this.c=U,this.d=se,this.type=u.Not}cmp(U){return U.type!==this.type?this.type-U.type:ee(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=c.get(this.c);return typeof U=="boolean"?U?E.INSTANCE:D.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Kj=F;function N(J,U){if(typeof J=="string"){const se=parseFloat(J);isNaN(se)||(J=se)}return typeof J=="string"||typeof J=="number"?U(J):E.INSTANCE}class O{static create(U,se,ae=null){return N(se,te=>new O(U,te,ae))}constructor(U,se,ae){this.c=U,this.d=se,this.f=ae,this.type=u.Greater}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Lj=O;class j{static create(U,se,ae=null){return N(se,te=>new j(U,te,ae))}constructor(U,se,ae){this.c=U,this.d=se,this.f=ae,this.type=u.GreaterEquals}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Mj=j;class z{static create(U,se,ae=null){return N(se,te=>new z(U,te,ae))}constructor(U,se,ae){this.c=U,this.d=se,this.f=ae,this.type=u.Smaller}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Nj=z;class M{static create(U,se,ae=null){return N(se,te=>new M(U,te,ae))}constructor(U,se,ae){this.c=U,this.d=se,this.f=ae,this.type=u.SmallerEquals}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Oj=M;class W{static create(U,se){return new W(U,se)}constructor(U,se){this.d=U,this.f=se,this.type=u.Regex,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const se=this.f?this.f.source:"",ae=U.f?U.f.source:"";return se<ae?-1:se>ae?1:0}equals(U){if(U.type===this.type){const se=this.f?this.f.source:"",ae=U.f?U.f.source:"";return this.d===U.d&&se===ae}return!1}substituteConstants(){return this}evaluate(U){const se=U.getValue(this.d);return this.f?this.f.test(se):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=V.create(this)),this.c}}e.$Pj=W;class V{static create(U){return new V(U)}constructor(U){this.c=U,this.type=u.NotRegex}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new V(this.c.map(U))}negate(){return this.c}}e.$Qj=V;function ne(J){let U=null;for(let se=0,ae=J.length;se<ae;se++){const te=J[se].substituteConstants();if(J[se]!==te&&U===null){U=[];for(let ce=0;ce<se;ce++)U[ce]=J[ce]}U!==null&&(U[se]=te)}return U===null?J:U}class B{static create(U,se,ae){return B.d(U,se,ae)}constructor(U,se){this.expr=U,this.c=se,this.type=u.And}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let se=0,ae=this.expr.length;se<ae;se++){const te=g(this.expr[se],U.expr[se]);if(te!==0)return te}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].equals(U.expr[se]))return!1;return!0}return!1}substituteConstants(){const U=ne(this.expr);return U===this.expr?this:B.create(U,this.c,!1)}evaluate(U){for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].evaluate(U))return!1;return!0}static d(U,se,ae){const te=[];let ce=!1;for(const le of U)if(le){if(le.type===u.True){ce=!0;continue}if(le.type===u.False)return E.INSTANCE;if(le.type===u.And){te.push(...le.expr);continue}te.push(le)}if(te.length===0&&ce)return D.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(g);for(let le=1;le<te.length;le++)te[le-1].equals(te[le])&&(te.splice(le,1),le--);if(te.length===1)return te[0];for(;te.length>1;){const le=te[te.length-1];if(le.type!==u.Or)break;te.pop();const x=te.pop(),oe=te.length===0,pe=K.create(le.expr.map(we=>B.create([we,x],null,ae)),null,oe);pe&&(te.push(pe),te.sort(g))}if(te.length===1)return te[0];if(ae){for(let le=0;le<te.length;le++)for(let x=le+1;x<te.length;x++)if(te[le].negate().equals(te[x]))return E.INSTANCE;if(te.length===1)return te[0]}return new B(te,se)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const se of this.expr)U.push(...se.keys());return U}map(U){return new B(this.expr.map(se=>se.map(U)),null)}negate(){if(!this.c){const U=[];for(const se of this.expr)U.push(se.negate());this.c=K.create(U,this,!0)}return this.c}}e.$Rj=B;class K{static create(U,se,ae){return K.d(U,se,ae)}constructor(U,se){this.expr=U,this.c=se,this.type=u.Or}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let se=0,ae=this.expr.length;se<ae;se++){const te=g(this.expr[se],U.expr[se]);if(te!==0)return te}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].equals(U.expr[se]))return!1;return!0}return!1}substituteConstants(){const U=ne(this.expr);return U===this.expr?this:K.create(U,this.c,!1)}evaluate(U){for(let se=0,ae=this.expr.length;se<ae;se++)if(this.expr[se].evaluate(U))return!0;return!1}static d(U,se,ae){let te=[],ce=!1;if(U){for(let le=0,x=U.length;le<x;le++){const oe=U[le];if(oe){if(oe.type===u.False){ce=!0;continue}if(oe.type===u.True)return D.INSTANCE;if(oe.type===u.Or){te=te.concat(oe.expr);continue}te.push(oe)}}if(te.length===0&&ce)return E.INSTANCE;te.sort(g)}if(te.length!==0){if(te.length===1)return te[0];for(let le=1;le<te.length;le++)te[le-1].equals(te[le])&&(te.splice(le,1),le--);if(te.length===1)return te[0];if(ae){for(let le=0;le<te.length;le++)for(let x=le+1;x<te.length;x++)if(te[le].negate().equals(te[x]))return D.INSTANCE;if(te.length===1)return te[0]}return new K(te,se)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const se of this.expr)U.push(...se.keys());return U}map(U){return new K(this.expr.map(se=>se.map(U)),null)}negate(){if(!this.c){const U=[];for(const se of this.expr)U.push(se.negate());for(;U.length>1;){const se=U.shift(),ae=U.shift(),te=[];for(const ce of me(se))for(const le of me(ae))te.push(B.create([ce,le],null,!1));U.unshift(K.create(te,null,!1))}this.c=K.create(U,this,!0)}return this.c}}e.$Sj=K;class Y extends y{static{this.d=[]}static all(){return Y.d.values()}constructor(U,se,ae){super(U,null),this.f=se,typeof ae=="object"?Y.d.push({...ae,key:U}):ae!==!0&&Y.d.push({key:U,description:ae,type:se!=null?typeof se:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return k.create(this.key,U)}notEqualsTo(U){return v.create(this.key,U)}}e.$Tj=Y,e.$Uj=(0,L.$Ci)("contextKeyService");function ee(J,U){return J<U?-1:J>U?1:0}function ue(J,U,se,ae){return J<se?-1:J>se?1:U<ae?-1:U>ae?1:0}function re(J,U){if(J.type===u.False||U.type===u.True)return!0;if(J.type===u.Or)return U.type===u.Or?ye(J.expr,U.expr):!1;if(U.type===u.Or){for(const se of U.expr)if(re(J,se))return!0;return!1}if(J.type===u.And){if(U.type===u.And)return ye(U.expr,J.expr);for(const se of J.expr)if(re(se,U))return!0;return!1}return J.equals(U)}function ye(J,U){let se=0,ae=0;for(;se<J.length&&ae<U.length;){const te=J[se].cmp(U[ae]);if(te<0)return!1;te===0&&se++,ae++}return se===J.length}function me(J){return J.type===u.Or?J.expr:[J]}}),define(Se[215],De([1,0,35,5]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$pt=e.AccessibilitySupport=e.$ot=void 0,e.$qt=R,e.$ot=(0,h.$Ci)("accessibilityService");var C;(function(L){L[L.Unknown=0]="Unknown",L[L.Disabled=1]="Disabled",L[L.Enabled=2]="Enabled"})(C||(e.AccessibilitySupport=C={})),e.$pt=new r.$Tj("accessibilityModeEnabled",!1);function R(L){return L&&typeof L=="object"&&typeof L.label=="string"&&(typeof L.role>"u"||typeof L.role=="string")}e.$rt="ACCESSIBLE_VIEW_SHOWN_"}),define(Se[113],De([1,0,18,24,10,185,83,199,140,8,215]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=n,e.stringSet=g,e.cursorStyleToString=N,e.filterValidationDecorations=Ie,r=Ue(r),h=Ue(h),C=Ue(C),c=Ue(c);var S;(function(he){he[he.None=0]="None",he[he.Keep=1]="Keep",he[he.Brackets=2]="Brackets",he[he.Advanced=3]="Advanced",he[he.Full=4]="Full"})(S||(e.EditorAutoIndentStrategy=S={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=u;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class w{constructor(_,Re,Xe,tt){this.id=_,this.name=Re,this.defaultValue=Xe,this.schema=tt}applyUpdate(_,Re){return m(_,Re)}compute(_,Re,Xe){return Xe}}class a{constructor(_,Re){this.newValue=_,this.didChange=Re}}e.ApplyUpdateResult=a;function m(he,_){if(typeof he!="object"||typeof _!="object"||!he||!_)return new a(_,he!==_);if(Array.isArray(he)||Array.isArray(_)){const Xe=Array.isArray(he)&&Array.isArray(_)&&r.$tb(he,_);return new a(_,!Xe)}let Re=!1;for(const Xe in _)if(_.hasOwnProperty(Xe)){const tt=m(he[Xe],_[Xe]);tt.didChange&&(he[Xe]=tt.newValue,Re=!0)}return new a(he,Re)}class ${constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,Re){return m(_,Re)}validate(_){return this.defaultValue}}class f{constructor(_,Re,Xe,tt){this.id=_,this.name=Re,this.defaultValue=Xe,this.schema=tt}applyUpdate(_,Re){return m(_,Re)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,Re,Xe){return Xe}}function i(he,_){return typeof he>"u"?_:he==="false"?!1:!!he}class s extends f{constructor(_,Re,Xe,tt=void 0){typeof tt<"u"&&(tt.type="boolean",tt.default=Xe),super(_,Re,Xe,tt)}validate(_){return i(_,this.defaultValue)}}function t(he,_,Re,Xe){if(typeof he>"u")return _;let tt=parseInt(he,10);return isNaN(tt)?_:(tt=Math.max(Re,tt),tt=Math.min(Xe,tt),tt|0)}class o extends f{static clampedInt(_,Re,Xe,tt){return t(_,Re,Xe,tt)}constructor(_,Re,Xe,tt,ut,gt=void 0){typeof gt<"u"&&(gt.type="integer",gt.default=Xe,gt.minimum=tt,gt.maximum=ut),super(_,Re,Xe,gt),this.minimum=tt,this.maximum=ut}validate(_){return o.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}function n(he,_,Re,Xe){if(typeof he>"u")return _;const tt=d.float(he,_);return d.clamp(tt,Re,Xe)}class d extends f{static clamp(_,Re,Xe){return _<Re?Re:_>Xe?Xe:_}static float(_,Re){if(typeof _=="number")return _;if(typeof _>"u")return Re;const Xe=parseFloat(_);return isNaN(Xe)?Re:Xe}constructor(_,Re,Xe,tt,ut){typeof ut<"u"&&(ut.type="number",ut.default=Xe),super(_,Re,Xe,ut),this.validationFn=tt}validate(_){return this.validationFn(d.float(_,this.defaultValue))}}class l extends f{static string(_,Re){return typeof _!="string"?Re:_}constructor(_,Re,Xe,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.default=Xe),super(_,Re,Xe,tt)}validate(_){return l.string(_,this.defaultValue)}}function g(he,_,Re,Xe){return typeof he!="string"?_:Xe&&he in Xe?Xe[he]:Re.indexOf(he)===-1?_:he}class E extends f{constructor(_,Re,Xe,tt,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=tt,ut.default=Xe),super(_,Re,Xe,ut),this.c=tt}validate(_){return g(_,this.defaultValue,this.c)}}class D extends w{constructor(_,Re,Xe,tt,ut,gt,Dt=void 0){typeof Dt<"u"&&(Dt.type="string",Dt.enum=ut,Dt.default=tt),super(_,Re,Xe,Dt),this.c=ut,this.d=gt}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function y(he){switch(he){case"none":return S.None;case"keep":return S.Keep;case"brackets":return S.Brackets;case"advanced":return S.Advanced;case"full":return S.Full}}class k extends w{constructor(){super(je.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(11682,null),c.localize(11683,null),c.localize(11684,null)],default:"auto",tags:["accessibility"],description:c.localize(11685,null)})}validate(_){switch(_){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(_,Re,Xe){return Xe===I.AccessibilitySupport.Unknown?_.accessibilitySupport:Xe}}class A extends w{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:c.localize(11686,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:c.localize(11687,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_;return{insertSpace:i(Re.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Re.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var p;(function(he){he[he.Hidden=0]="Hidden",he[he.Blink=1]="Blink",he[he.Smooth=2]="Smooth",he[he.Phase=3]="Phase",he[he.Expand=4]="Expand",he[he.Solid=5]="Solid"})(p||(e.TextEditorCursorBlinkingStyle=p={}));function v(he){switch(he){case"blink":return p.Blink;case"smooth":return p.Smooth;case"phase":return p.Phase;case"expand":return p.Expand;case"solid":return p.Solid}}var F;(function(he){he[he.Line=1]="Line",he[he.Block=2]="Block",he[he.Underline=3]="Underline",he[he.LineThin=4]="LineThin",he[he.BlockOutline=5]="BlockOutline",he[he.UnderlineThin=6]="UnderlineThin"})(F||(e.TextEditorCursorStyle=F={}));function N(he){switch(he){case F.Line:return"line";case F.Block:return"block";case F.Underline:return"underline";case F.LineThin:return"line-thin";case F.BlockOutline:return"block-outline";case F.UnderlineThin:return"underline-thin"}}function O(he){switch(he){case"line":return F.Line;case"block":return F.Block;case"underline":return F.Underline;case"line-thin":return F.LineThin;case"block-outline":return F.BlockOutline;case"underline-thin":return F.UnderlineThin}}class j extends ${constructor(){super(je.editorClassName)}compute(_,Re,Xe){const tt=["monaco-editor"];return Re.get(je.extraEditorClassName)&&tt.push(Re.get(je.extraEditorClassName)),_.extraEditorClassName&&tt.push(_.extraEditorClassName),Re.get(je.mouseStyle)==="default"?tt.push("mouse-default"):Re.get(je.mouseStyle)==="copy"&&tt.push("mouse-copy"),Re.get(je.showUnused)&&tt.push("showUnused"),Re.get(je.showDeprecated)&&tt.push("showDeprecated"),tt.join(" ")}}class z extends s{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:c.localize(11688,null)})}compute(_,Re,Xe){return Xe&&_.emptySelectionClipboard}}class M extends w{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:c.localize(11689,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[c.localize(11690,null),c.localize(11691,null),c.localize(11692,null)],description:c.localize(11693,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[c.localize(11694,null),c.localize(11695,null),c.localize(11696,null)],description:c.localize(11697,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:c.localize(11698,null),included:C.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:c.localize(11699,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:c.localize(11700,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_;return{cursorMoveOnType:i(Re.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":g(Re.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":g(Re.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Re.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Re.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Re.loop,this.defaultValue.loop)}}}class W extends w{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:c.localize(11701,null)},{type:"string",description:c.localize(11702,null)}],description:c.localize(11703,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"||_.length===0?W.OFF:_==="true"?W.ON:_:_?W.ON:W.OFF}}e.EditorFontLigatures=W;class V extends w{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",V.OFF,{anyOf:[{type:"boolean",description:c.localize(11704,null)},{type:"string",description:c.localize(11705,null)}],description:c.localize(11706,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?V.OFF:_==="true"?V.TRANSLATE:_:_?V.TRANSLATE:V.OFF}compute(_,Re,Xe){return _.fontInfo.fontVariationSettings}}e.EditorFontVariations=V;class ne extends ${constructor(){super(je.fontInfo)}compute(_,Re,Xe){return _.fontInfo}}class B extends f{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(11707,null)})}validate(_){const Re=d.float(_,this.defaultValue);return Re===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(Re,6,100)}compute(_,Re,Xe){return _.fontInfo.fontSize}}class K extends w{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.d,maximum:K.e,errorMessage:c.localize(11708,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(11709,null)})}validate(_){return _==="normal"||_==="bold"?_:String(o.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,K.d,K.e))}}class Y extends w{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Re={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[c.localize(11710,null),c.localize(11711,null),c.localize(11712,null)]},Xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(11713,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(11714,null),...Re},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(11715,null),...Re},"editor.gotoLocation.multipleDeclarations":{description:c.localize(11716,null),...Re},"editor.gotoLocation.multipleImplementations":{description:c.localize(11717,null),...Re},"editor.gotoLocation.multipleReferences":{description:c.localize(11718,null),...Re},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:Xe,description:c.localize(11719,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:Xe,description:c.localize(11720,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:Xe,description:c.localize(11721,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:Xe,description:c.localize(11722,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:Xe,description:c.localize(11723,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_;return{multiple:g(Re.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Re.multipleDefinitions??g(Re.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Re.multipleTypeDefinitions??g(Re.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Re.multipleDeclarations??g(Re.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Re.multipleImplementations??g(Re.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Re.multipleReferences??g(Re.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:l.string(Re.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:l.string(Re.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:l.string(Re.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:l.string(Re.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:l.string(Re.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends w{constructor(){const _={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:c.localize(11724,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:c.localize(11725,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:c.localize(11726,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:_.hidingDelay,description:c.localize(11727,null)},"editor.hover.above":{type:"boolean",default:_.above,description:c.localize(11728,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_;return{enabled:i(Re.enabled,this.defaultValue.enabled),delay:o.clampedInt(Re.delay,this.defaultValue.delay,0,1e4),sticky:i(Re.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(Re.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(Re.above,this.defaultValue.above)}}}var ue;(function(he){he[he.None=0]="None",he[he.Text=1]="Text",he[he.Blocks=2]="Blocks"})(ue||(e.RenderMinimap=ue={}));class re extends ${constructor(){super(je.layoutInfo)}compute(_,Re,Xe){return re.computeLayout(Re,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio,glyphMarginDecorationLaneCount:_.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(_){const Re=_.height/_.lineHeight,Xe=Math.floor(_.paddingTop/_.lineHeight);let tt=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&(tt=Math.max(tt,Re-1));const ut=(Xe+_.viewLineCount+tt)/(_.pixelRatio*_.height),gt=Math.floor(_.viewLineCount/ut);return{typicalViewportLineCount:Re,extraLinesBeforeFirstLine:Xe,extraLinesBeyondLastLine:tt,desiredRatio:ut,minimapLineCount:gt}}static c(_,Re){const Xe=_.outerWidth,tt=_.outerHeight,ut=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:ue.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ut*tt),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:tt};const gt=Re.stableMinimapLayoutInput,Dt=gt&&_.outerHeight===gt.outerHeight&&_.lineHeight===gt.lineHeight&&_.typicalHalfwidthCharacterWidth===gt.typicalHalfwidthCharacterWidth&&_.pixelRatio===gt.pixelRatio&&_.scrollBeyondLastLine===gt.scrollBeyondLastLine&&_.paddingTop===gt.paddingTop&&_.paddingBottom===gt.paddingBottom&&_.minimap.enabled===gt.minimap.enabled&&_.minimap.side===gt.minimap.side&&_.minimap.size===gt.minimap.size&&_.minimap.showSlider===gt.minimap.showSlider&&_.minimap.renderCharacters===gt.minimap.renderCharacters&&_.minimap.maxColumn===gt.minimap.maxColumn&&_.minimap.scale===gt.minimap.scale&&_.verticalScrollbarWidth===gt.verticalScrollbarWidth&&_.isViewportWrapping===gt.isViewportWrapping,Nt=_.lineHeight,Ut=_.typicalHalfwidthCharacterWidth,Zt=_.scrollBeyondLastLine,hi=_.minimap.renderCharacters;let et=ut>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const Gt=_.minimap.maxColumn,Kt=_.minimap.size,pt=_.minimap.side,kt=_.verticalScrollbarWidth,xt=_.viewLineCount,_t=_.remainingWidth,qt=_.isViewportWrapping,wt=hi?2:3;let Rt=Math.floor(ut*tt);const ci=Rt/ut;let Qt=!1,xe=!1,ei=wt*et,li=et/ut,di=1;if(Kt==="fill"||Kt==="fit"){const{typicalViewportLineCount:ii,extraLinesBeforeFirstLine:Vt,extraLinesBeyondLastLine:Ht,desiredRatio:ui,minimapLineCount:Lt}=re.computeContainedMinimapLineCount({viewLineCount:xt,scrollBeyondLastLine:Zt,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:tt,lineHeight:Nt,pixelRatio:ut});if(xt/Lt>1)Qt=!0,xe=!0,et=1,ei=1,li=et/ut;else{let bt=!1,Jt=et+1;if(Kt==="fit"){const Et=Math.ceil((Vt+xt+Ht)*ei);qt&&Dt&&_t<=Re.stableFitRemainingWidth?(bt=!0,Jt=Re.stableFitMaxMinimapScale):bt=Et>Rt}if(Kt==="fill"||bt){Qt=!0;const Et=et;ei=Math.min(Nt*ut,Math.max(1,Math.floor(1/ui))),qt&&Dt&&_t<=Re.stableFitRemainingWidth&&(Jt=Re.stableFitMaxMinimapScale),et=Math.min(Jt,Math.max(1,Math.floor(ei/wt))),et>Et&&(di=Math.min(2,et/Et)),li=et/ut/di,Rt=Math.ceil(Math.max(ii,Vt+xt+Ht)*ei),qt?(Re.stableMinimapLayoutInput=_,Re.stableFitRemainingWidth=_t,Re.stableFitMaxMinimapScale=et):(Re.stableMinimapLayoutInput=null,Re.stableFitRemainingWidth=0)}}}const It=Math.floor(Gt*li),Mt=Math.min(It,Math.max(0,Math.floor((_t-kt-2)*li/(Ut+li)))+e.MINIMAP_GUTTER_WIDTH);let Tt=Math.floor(ut*Mt);const jt=Tt/ut;Tt=Math.floor(Tt*di);const si=hi?ue.Text:ue.Blocks,ti=pt==="left"?0:Xe-Mt-kt;return{renderMinimap:si,minimapLeft:ti,minimapWidth:Mt,minimapHeightIsEditorHeight:Qt,minimapIsSampling:xe,minimapScale:et,minimapLineHeight:ei,minimapCanvasInnerWidth:Tt,minimapCanvasInnerHeight:Rt,minimapCanvasOuterWidth:jt,minimapCanvasOuterHeight:ci}}static computeLayout(_,Re){const Xe=Re.outerWidth|0,tt=Re.outerHeight|0,ut=Re.lineHeight|0,gt=Re.lineNumbersDigitCount|0,Dt=Re.typicalHalfwidthCharacterWidth,Nt=Re.maxDigitWidth,Ut=Re.pixelRatio,Zt=Re.viewLineCount,hi=_.get(je.wordWrapOverride2),et=hi==="inherit"?_.get(je.wordWrapOverride1):hi,Gt=et==="inherit"?_.get(je.wordWrap):et,Kt=_.get(je.wordWrapColumn),pt=Re.isDominatedByLongLines,kt=_.get(je.glyphMargin),xt=_.get(je.lineNumbers).renderType!==ze.Off,_t=_.get(je.lineNumbersMinChars),qt=_.get(je.scrollBeyondLastLine),wt=_.get(je.padding),Rt=_.get(je.minimap),ci=_.get(je.scrollbar),Qt=ci.verticalScrollbarSize,xe=ci.verticalHasArrows,ei=ci.arrowSize,li=ci.horizontalScrollbarSize,di=_.get(je.folding),It=_.get(je.showFoldingControls)!=="never";let Mt=_.get(je.lineDecorationsWidth);di&&It&&(Mt+=16);let Tt=0;if(xt){const Yt=Math.max(gt,_t);Tt=Math.round(Yt*Nt)}let jt=0;kt&&(jt=ut*Re.glyphMarginDecorationLaneCount);let si=0,ti=si+jt,ii=ti+Tt,Vt=ii+Mt;const Ht=Xe-jt-Tt-Mt;let ui=!1,Lt=!1,Pt=-1;et==="inherit"&&pt?(ui=!0,Lt=!0):Gt==="on"||Gt==="bounded"?Lt=!0:Gt==="wordWrapColumn"&&(Pt=Kt);const bt=re.c({outerWidth:Xe,outerHeight:tt,lineHeight:ut,typicalHalfwidthCharacterWidth:Dt,pixelRatio:Ut,scrollBeyondLastLine:qt,paddingTop:wt.top,paddingBottom:wt.bottom,minimap:Rt,verticalScrollbarWidth:Qt,viewLineCount:Zt,remainingWidth:Ht,isViewportWrapping:Lt},Re.memory||new P);bt.renderMinimap!==ue.None&&bt.minimapLeft===0&&(si+=bt.minimapWidth,ti+=bt.minimapWidth,ii+=bt.minimapWidth,Vt+=bt.minimapWidth);const Jt=Ht-bt.minimapWidth,Et=Math.max(1,Math.floor((Jt-Qt-2)/Dt)),oi=xe?ei:0;return Lt&&(Pt=Math.max(1,Et),Gt==="bounded"&&(Pt=Math.min(Pt,Kt))),{width:Xe,height:tt,glyphMarginLeft:si,glyphMarginWidth:jt,glyphMarginDecorationLaneCount:Re.glyphMarginDecorationLaneCount,lineNumbersLeft:ti,lineNumbersWidth:Tt,decorationsLeft:ii,decorationsWidth:Mt,contentLeft:Vt,contentWidth:Jt,minimap:bt,viewportColumn:Et,isWordWrapMinified:ui,isViewportWrapping:Lt,wrappingColumn:Pt,verticalScrollbarWidth:Qt,horizontalScrollbarHeight:li,overviewRuler:{top:oi,width:Qt,height:tt-2*oi,right:0}}}}e.EditorLayoutInfoComputer=re;class ye extends w{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(11729,null),c.localize(11730,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(11731,null)}})}validate(_){return g(_,"simple",["simple","advanced"])}compute(_,Re,Xe){return Re.get(je.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Xe}}var me;(function(he){he.Off="off",he.OnCode="onCode",he.On="on"})(me||(e.ShowLightbulbIconMode=me={}));class J extends w{constructor(){const _={enabled:me.On};super(je.lightbulb,"lightbulb",_,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[me.Off,me.OnCode,me.On],default:_.enabled,enumDescriptions:[c.localize(11732,null),c.localize(11733,null),c.localize(11734,null)],description:c.localize(11735,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:g(_.enabled,this.defaultValue.enabled,[me.Off,me.OnCode,me.On])}}}class U extends w{constructor(){const _={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:c.localize(11736,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:20,description:c.localize(11737,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:_.defaultModel,description:c.localize(11738,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:_.scrollWithEditor,description:c.localize(11739,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_;return{enabled:i(Re.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(Re.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:g(Re.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(Re.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends w{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:c.localize(11740,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(11741,null),c.localize(11742,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),c.localize(11743,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),c.localize(11744,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:c.localize(11745,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:c.localize(11746,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:c.localize(11747,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_;return typeof Re.enabled=="boolean"&&(Re.enabled=Re.enabled?"on":"off"),{enabled:g(Re.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(Re.fontSize,this.defaultValue.fontSize,0,100),fontFamily:l.string(Re.fontFamily,this.defaultValue.fontFamily),padding:i(Re.padding,this.defaultValue.padding)}}}class ae extends w{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):o.clampedInt(_,this.defaultValue,0,1e3)}compute(_,Re,Xe){return Xe<0?o.clampedInt(-Xe*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Xe}}class te extends d{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>d.clamp(_,0,150),{markdownDescription:c.localize(11748,null)})}compute(_,Re,Xe){return _.fontInfo.lineHeight}}class ce extends w{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:c.localize(11749,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:c.localize(11750,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(11751,null),c.localize(11752,null),c.localize(11753,null)],default:_.size,description:c.localize(11754,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:c.localize(11755,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:c.localize(11756,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(11757,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:c.localize(11758,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:c.localize(11759,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:_.showRegionSectionHeaders,description:c.localize(11760,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:_.showMarkSectionHeaders,description:c.localize(11761,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:_.sectionHeaderFontSize,description:c.localize(11762,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:_.sectionHeaderLetterSpacing,description:c.localize(11763,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_;return{enabled:i(Re.enabled,this.defaultValue.enabled),autohide:i(Re.autohide,this.defaultValue.autohide),size:g(Re.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(Re.side,this.defaultValue.side,["right","left"]),showSlider:g(Re.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Re.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(Re.scale,1,1,3),maxColumn:o.clampedInt(Re.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(Re.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(Re.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:d.clamp(Re.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:d.clamp(Re.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function le(he){return he==="ctrlCmd"?C.$k?"metaKey":"ctrlKey":"altKey"}class x extends w{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(11764,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(11765,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_;return{top:o.clampedInt(Re.top,0,0,1e3),bottom:o.clampedInt(Re.bottom,0,0,1e3)}}}class oe extends w{constructor(){const _={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:c.localize(11766,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:c.localize(11767,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_;return{enabled:i(Re.enabled,this.defaultValue.enabled),cycle:i(Re.cycle,this.defaultValue.cycle)}}}class pe extends ${constructor(){super(je.pixelRatio)}compute(_,Re,Xe){return _.pixelRatio}}class we extends w{constructor(){super(je.placeholder,"placeholder",void 0)}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_:this.defaultValue}}class Fe extends w{constructor(){const _={other:"on",comments:"off",strings:"off"},Re=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(11768,null),c.localize(11769,null),c.localize(11770,null)]}];super(je.quickSuggestions,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Re,default:_.strings,description:c.localize(11771,null)},comments:{anyOf:Re,default:_.comments,description:c.localize(11772,null)},other:{anyOf:Re,default:_.other,description:c.localize(11773,null)}},default:_,markdownDescription:c.localize(11774,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const Ut=_?"on":"off";return{comments:Ut,strings:Ut,other:Ut}}if(!_||typeof _!="object")return this.defaultValue;const{other:Re,comments:Xe,strings:tt}=_,ut=["on","inline","off"];let gt,Dt,Nt;return typeof Re=="boolean"?gt=Re?"on":"off":gt=g(Re,this.defaultValue.other,ut),typeof Xe=="boolean"?Dt=Xe?"on":"off":Dt=g(Xe,this.defaultValue.comments,ut),typeof tt=="boolean"?Nt=tt?"on":"off":Nt=g(tt,this.defaultValue.strings,ut),{other:gt,comments:Dt,strings:Nt}}}var ze;(function(he){he[he.Off=0]="Off",he[he.On=1]="On",he[he.Relative=2]="Relative",he[he.Interval=3]="Interval",he[he.Custom=4]="Custom"})(ze||(e.RenderLineNumbersType=ze={}));class Ce extends w{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:ze.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(11775,null),c.localize(11776,null),c.localize(11777,null),c.localize(11778,null)],default:"on",description:c.localize(11779,null)})}validate(_){let Re=this.defaultValue.renderType,Xe=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?(Re=ze.Custom,Xe=_):_==="interval"?Re=ze.Interval:_==="relative"?Re=ze.Relative:_==="on"?Re=ze.On:Re=ze.Off),{renderType:Re,renderFn:Xe}}}function Ie(he){const _=he.get(je.renderValidationDecorations);return _==="editable"?he.get(je.readOnly):_!=="on"}class Pe extends w{constructor(){const _=[],Re={type:"number",description:c.localize(11780,null)};super(je.rulers,"rulers",_,{type:"array",items:{anyOf:[Re,{type:["object"],properties:{column:Re,color:{type:"string",description:c.localize(11781,null),format:"color-hex"}}}]},default:_,description:c.localize(11782,null)})}validate(_){if(Array.isArray(_)){const Re=[];for(const Xe of _)if(typeof Xe=="number")Re.push({column:o.clampedInt(Xe,0,0,1e4),color:null});else if(Xe&&typeof Xe=="object"){const tt=Xe;Re.push({column:o.clampedInt(tt.column,0,0,1e4),color:tt.color})}return Re.sort((Xe,tt)=>Xe.column-tt.column),Re}return this.defaultValue}}class q extends w{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(_){return!_||typeof _!="object"?this.defaultValue:_}}function H(he,_){if(typeof he!="string")return _;switch(he){case"hidden":return R.ScrollbarVisibility.Hidden;case"visible":return R.ScrollbarVisibility.Visible;default:return R.ScrollbarVisibility.Auto}}class X extends w{constructor(){const _={vertical:R.ScrollbarVisibility.Auto,horizontal:R.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(11783,null),c.localize(11784,null),c.localize(11785,null)],default:"auto",description:c.localize(11786,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(11787,null),c.localize(11788,null),c.localize(11789,null)],default:"auto",description:c.localize(11790,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:c.localize(11791,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:c.localize(11792,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:c.localize(11793,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:_.ignoreHorizontalScrollbarInContentHeight,description:c.localize(11794,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_,Xe=o.clampedInt(Re.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),tt=o.clampedInt(Re.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(Re.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:H(Re.vertical,this.defaultValue.vertical),horizontal:H(Re.horizontal,this.defaultValue.horizontal),useShadows:i(Re.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Re.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Re.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Re.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Re.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Xe,horizontalSliderSize:o.clampedInt(Re.horizontalSliderSize,Xe,0,1e3),verticalScrollbarSize:tt,verticalSliderSize:o.clampedInt(Re.verticalSliderSize,tt,0,1e3),scrollByPage:i(Re.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(Re.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Z extends w{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:c.localize(11795,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:c.localize(11796,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:c.localize(11797,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:c.localize(11798,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:c.localize(11799,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:c.localize(11800,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:c.localize(11801,null)}})}applyUpdate(_,Re){let Xe=!1;Re.allowedCharacters&&_&&(h.$fo(_.allowedCharacters,Re.allowedCharacters)||(_={..._,allowedCharacters:Re.allowedCharacters},Xe=!0)),Re.allowedLocales&&_&&(h.$fo(_.allowedLocales,Re.allowedLocales)||(_={..._,allowedLocales:Re.allowedLocales},Xe=!0));const tt=super.applyUpdate(_,Re);return Xe?new a(tt.newValue,!0):tt}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_;return{nonBasicASCII:Qe(Re.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Re.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Re.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Qe(Re.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Qe(Re.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,Re){if(typeof _!="object"||!_)return Re;const Xe={};for(const[tt,ut]of Object.entries(_))ut===!0&&(Xe[tt]=!0);return Xe}}class de extends w{constructor(){const _={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:c.localize(11802,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(11803,null),c.localize(11804,null),c.localize(11805,null)],description:c.localize(11806,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:_.suppressSuggestions,description:c.localize(11807,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:_.fontFamily,description:c.localize(11808,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_;return{enabled:i(Re.enabled,this.defaultValue.enabled),mode:g(Re.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:g(Re.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(Re.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Re.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:l.string(Re.fontFamily,this.defaultValue.fontFamily)}}}class be extends w{constructor(){const _={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(je.inlineEdit,"experimentalInlineEdit",_,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:_.enabled,description:c.localize(11809,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(11810,null),c.localize(11811,null),c.localize(11812,null)],description:c.localize(11813,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:_.fontFamily,description:c.localize(11814,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_;return{enabled:i(Re.enabled,this.defaultValue.enabled),showToolbar:g(Re.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:l.string(Re.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(Re.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Oe extends w{constructor(){const _={enabled:T.$it.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$it.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:c.localize(11815,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:c.localize(11816,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_;return{enabled:i(Re.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Re.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class He extends w{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(11817,null),c.localize(11818,null),c.localize(11819,null)],default:_.bracketPairs,description:c.localize(11820,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(11821,null),c.localize(11822,null),c.localize(11823,null)],default:_.bracketPairsHorizontal,description:c.localize(11824,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:c.localize(11825,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:c.localize(11826,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(11827,null),c.localize(11828,null),c.localize(11829,null)],default:_.highlightActiveIndentation,description:c.localize(11830,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_;return{bracketPairs:Qe(Re.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Qe(Re.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Re.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Re.indentation,this.defaultValue.indentation),highlightActiveIndentation:Qe(Re.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Qe(he,_,Re){const Xe=Re.indexOf(he);return Xe===-1?_:Re[Xe]}class _e extends w{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(11831,null),c.localize(11832,null)],default:_.insertMode,description:c.localize(11833,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:c.localize(11834,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:c.localize(11835,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:c.localize(11836,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(11837,null),c.localize(11838,null),c.localize(11839,null),c.localize(11840,null)],default:_.selectionMode,markdownDescription:c.localize(11841,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:c.localize(11842,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:c.localize(11843,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:c.localize(11844,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:c.localize(11845,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:c.localize(11846,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(11847,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(11848,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(11849,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(11850,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(11851,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(11852,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(11853,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(11854,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(11855,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(11856,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(11857,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(11858,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(11859,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(11860,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(11861,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(11862,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(11863,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(11864,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(11865,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(11866,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(11867,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(11868,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(11869,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(11870,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(11871,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(11872,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(11873,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(11874,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(11875,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(11876,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(11877,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(11878,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_;return{insertMode:g(Re.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Re.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Re.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Re.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Re.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:g(Re.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Re.showIcons,this.defaultValue.showIcons),showStatusBar:i(Re.showStatusBar,this.defaultValue.showStatusBar),preview:i(Re.preview,this.defaultValue.preview),previewMode:g(Re.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Re.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Re.showMethods,this.defaultValue.showMethods),showFunctions:i(Re.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Re.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Re.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Re.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Re.showFields,this.defaultValue.showFields),showVariables:i(Re.showVariables,this.defaultValue.showVariables),showClasses:i(Re.showClasses,this.defaultValue.showClasses),showStructs:i(Re.showStructs,this.defaultValue.showStructs),showInterfaces:i(Re.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Re.showModules,this.defaultValue.showModules),showProperties:i(Re.showProperties,this.defaultValue.showProperties),showEvents:i(Re.showEvents,this.defaultValue.showEvents),showOperators:i(Re.showOperators,this.defaultValue.showOperators),showUnits:i(Re.showUnits,this.defaultValue.showUnits),showValues:i(Re.showValues,this.defaultValue.showValues),showConstants:i(Re.showConstants,this.defaultValue.showConstants),showEnums:i(Re.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Re.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Re.showKeywords,this.defaultValue.showKeywords),showWords:i(Re.showWords,this.defaultValue.showWords),showColors:i(Re.showColors,this.defaultValue.showColors),showFiles:i(Re.showFiles,this.defaultValue.showFiles),showReferences:i(Re.showReferences,this.defaultValue.showReferences),showFolders:i(Re.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Re.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Re.showSnippets,this.defaultValue.showSnippets),showUsers:i(Re.showUsers,this.defaultValue.showUsers),showIssues:i(Re.showIssues,this.defaultValue.showIssues)}}}class nt extends w{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(11879,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(11880,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(_.selectSubwords,this.defaultValue.selectSubwords)}}}class st extends w{constructor(){const _=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",_,{anyOf:[{description:c.localize(11881,null),type:"string"},{description:c.localize(11882,null),type:"array",items:{type:"string"}}]})}validate(_){if(typeof _=="string"&&(_=[_]),Array.isArray(_)){const Re=[];for(const Xe of _)if(typeof Xe=="string")try{Intl.Segmenter.supportedLocalesOf(Xe).length>0&&Re.push(Xe)}catch{}return Re}return this.defaultValue}}var rt;(function(he){he[he.None=0]="None",he[he.Same=1]="Same",he[he.Indent=2]="Indent",he[he.DeepIndent=3]="DeepIndent"})(rt||(e.WrappingIndent=rt={}));class at extends w{constructor(){super(je.wrappingIndent,"wrappingIndent",rt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(11883,null),c.localize(11884,null),c.localize(11885,null),c.localize(11886,null)],description:c.localize(11887,null),default:"same"}})}validate(_){switch(_){case"none":return rt.None;case"same":return rt.Same;case"indent":return rt.Indent;case"deepIndent":return rt.DeepIndent}return rt.Same}compute(_,Re,Xe){return Re.get(je.accessibilitySupport)===I.AccessibilitySupport.Enabled?rt.None:Xe}}class mt extends ${constructor(){super(je.wrappingInfo)}compute(_,Re,Xe){const tt=Re.get(je.layoutInfo);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:tt.isWordWrapMinified,isViewportWrapping:tt.isViewportWrapping,wrappingColumn:tt.wrappingColumn}}}class ht extends w{constructor(){const _={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:c.localize(11888,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(11889,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(11890,null),c.localize(11891,null)],default:"afterDrop"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_;return{enabled:i(Re.enabled,this.defaultValue.enabled),showDropSelector:g(Re.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ct extends w{constructor(){const _={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",_,{"editor.pasteAs.enabled":{type:"boolean",default:_.enabled,markdownDescription:c.localize(11892,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(11893,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(11894,null),c.localize(11895,null)],default:"afterPaste"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const Re=_;return{enabled:i(Re.enabled,this.defaultValue.enabled),showPasteSelector:g(Re.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ke="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",Ke="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$k?Be:C.$l?Ke:ke,fontWeight:"normal",fontSize:C.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(he){return e.editorOptionsRegistry[he.id]=he,he}var je;(function(he){he[he.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",he[he.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",he[he.accessibilitySupport=2]="accessibilitySupport",he[he.accessibilityPageSize=3]="accessibilityPageSize",he[he.ariaLabel=4]="ariaLabel",he[he.ariaRequired=5]="ariaRequired",he[he.autoClosingBrackets=6]="autoClosingBrackets",he[he.autoClosingComments=7]="autoClosingComments",he[he.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",he[he.autoClosingDelete=9]="autoClosingDelete",he[he.autoClosingOvertype=10]="autoClosingOvertype",he[he.autoClosingQuotes=11]="autoClosingQuotes",he[he.autoIndent=12]="autoIndent",he[he.automaticLayout=13]="automaticLayout",he[he.autoSurround=14]="autoSurround",he[he.bracketPairColorization=15]="bracketPairColorization",he[he.guides=16]="guides",he[he.codeLens=17]="codeLens",he[he.codeLensFontFamily=18]="codeLensFontFamily",he[he.codeLensFontSize=19]="codeLensFontSize",he[he.colorDecorators=20]="colorDecorators",he[he.colorDecoratorsLimit=21]="colorDecoratorsLimit",he[he.columnSelection=22]="columnSelection",he[he.comments=23]="comments",he[he.contextmenu=24]="contextmenu",he[he.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",he[he.cursorBlinking=26]="cursorBlinking",he[he.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",he[he.cursorStyle=28]="cursorStyle",he[he.cursorSurroundingLines=29]="cursorSurroundingLines",he[he.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",he[he.cursorWidth=31]="cursorWidth",he[he.disableLayerHinting=32]="disableLayerHinting",he[he.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",he[he.domReadOnly=34]="domReadOnly",he[he.dragAndDrop=35]="dragAndDrop",he[he.dropIntoEditor=36]="dropIntoEditor",he[he.emptySelectionClipboard=37]="emptySelectionClipboard",he[he.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",he[he.extraEditorClassName=39]="extraEditorClassName",he[he.fastScrollSensitivity=40]="fastScrollSensitivity",he[he.find=41]="find",he[he.fixedOverflowWidgets=42]="fixedOverflowWidgets",he[he.folding=43]="folding",he[he.foldingStrategy=44]="foldingStrategy",he[he.foldingHighlight=45]="foldingHighlight",he[he.foldingImportsByDefault=46]="foldingImportsByDefault",he[he.foldingMaximumRegions=47]="foldingMaximumRegions",he[he.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",he[he.fontFamily=49]="fontFamily",he[he.fontInfo=50]="fontInfo",he[he.fontLigatures=51]="fontLigatures",he[he.fontSize=52]="fontSize",he[he.fontWeight=53]="fontWeight",he[he.fontVariations=54]="fontVariations",he[he.formatOnPaste=55]="formatOnPaste",he[he.formatOnType=56]="formatOnType",he[he.glyphMargin=57]="glyphMargin",he[he.gotoLocation=58]="gotoLocation",he[he.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",he[he.hover=60]="hover",he[he.inDiffEditor=61]="inDiffEditor",he[he.inlineSuggest=62]="inlineSuggest",he[he.inlineEdit=63]="inlineEdit",he[he.letterSpacing=64]="letterSpacing",he[he.lightbulb=65]="lightbulb",he[he.lineDecorationsWidth=66]="lineDecorationsWidth",he[he.lineHeight=67]="lineHeight",he[he.lineNumbers=68]="lineNumbers",he[he.lineNumbersMinChars=69]="lineNumbersMinChars",he[he.linkedEditing=70]="linkedEditing",he[he.links=71]="links",he[he.matchBrackets=72]="matchBrackets",he[he.minimap=73]="minimap",he[he.mouseStyle=74]="mouseStyle",he[he.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",he[he.mouseWheelZoom=76]="mouseWheelZoom",he[he.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",he[he.multiCursorModifier=78]="multiCursorModifier",he[he.multiCursorPaste=79]="multiCursorPaste",he[he.multiCursorLimit=80]="multiCursorLimit",he[he.occurrencesHighlight=81]="occurrencesHighlight",he[he.overviewRulerBorder=82]="overviewRulerBorder",he[he.overviewRulerLanes=83]="overviewRulerLanes",he[he.padding=84]="padding",he[he.pasteAs=85]="pasteAs",he[he.parameterHints=86]="parameterHints",he[he.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",he[he.placeholder=88]="placeholder",he[he.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",he[he.quickSuggestions=90]="quickSuggestions",he[he.quickSuggestionsDelay=91]="quickSuggestionsDelay",he[he.readOnly=92]="readOnly",he[he.readOnlyMessage=93]="readOnlyMessage",he[he.renameOnType=94]="renameOnType",he[he.renderControlCharacters=95]="renderControlCharacters",he[he.renderFinalNewline=96]="renderFinalNewline",he[he.renderLineHighlight=97]="renderLineHighlight",he[he.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",he[he.renderValidationDecorations=99]="renderValidationDecorations",he[he.renderWhitespace=100]="renderWhitespace",he[he.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",he[he.roundedSelection=102]="roundedSelection",he[he.rulers=103]="rulers",he[he.scrollbar=104]="scrollbar",he[he.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",he[he.scrollBeyondLastLine=106]="scrollBeyondLastLine",he[he.scrollPredominantAxis=107]="scrollPredominantAxis",he[he.selectionClipboard=108]="selectionClipboard",he[he.selectionHighlight=109]="selectionHighlight",he[he.selectOnLineNumbers=110]="selectOnLineNumbers",he[he.showFoldingControls=111]="showFoldingControls",he[he.showUnused=112]="showUnused",he[he.snippetSuggestions=113]="snippetSuggestions",he[he.smartSelect=114]="smartSelect",he[he.smoothScrolling=115]="smoothScrolling",he[he.stickyScroll=116]="stickyScroll",he[he.stickyTabStops=117]="stickyTabStops",he[he.stopRenderingLineAfter=118]="stopRenderingLineAfter",he[he.suggest=119]="suggest",he[he.suggestFontSize=120]="suggestFontSize",he[he.suggestLineHeight=121]="suggestLineHeight",he[he.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",he[he.suggestSelection=123]="suggestSelection",he[he.tabCompletion=124]="tabCompletion",he[he.tabIndex=125]="tabIndex",he[he.unicodeHighlighting=126]="unicodeHighlighting",he[he.unusualLineTerminators=127]="unusualLineTerminators",he[he.useShadowDOM=128]="useShadowDOM",he[he.useTabStops=129]="useTabStops",he[he.wordBreak=130]="wordBreak",he[he.wordSegmenterLocales=131]="wordSegmenterLocales",he[he.wordSeparators=132]="wordSeparators",he[he.wordWrap=133]="wordWrap",he[he.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",he[he.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",he[he.wordWrapColumn=136]="wordWrapColumn",he[he.wordWrapOverride1=137]="wordWrapOverride1",he[he.wordWrapOverride2=138]="wordWrapOverride2",he[he.wrappingIndent=139]="wrappingIndent",he[he.wrappingStrategy=140]="wrappingStrategy",he[he.showDeprecated=141]="showDeprecated",he[he.inlayHints=142]="inlayHints",he[he.editorClassName=143]="editorClassName",he[he.pixelRatio=144]="pixelRatio",he[he.tabFocusMode=145]="tabFocusMode",he[he.layoutInfo=146]="layoutInfo",he[he.wrappingInfo=147]="wrappingInfo",he[he.defaultColorDecorators=148]="defaultColorDecorators",he[he.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",he[he.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new s(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(11896,null)})),acceptSuggestionOnEnter:Ne(new E(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(11897,null),""],markdownDescription:c.localize(11898,null)})),accessibilitySupport:Ne(new k),accessibilityPageSize:Ne(new o(je.accessibilityPageSize,"accessibilityPageSize",10,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(11899,null),tags:["accessibility"]})),ariaLabel:Ne(new l(je.ariaLabel,"ariaLabel",c.localize(11900,null))),ariaRequired:Ne(new s(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ne(new s(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(11901,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new E(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(11902,null),c.localize(11903,null),""],description:c.localize(11904,null)})),autoClosingComments:Ne(new E(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(11905,null),c.localize(11906,null),""],description:c.localize(11907,null)})),autoClosingDelete:Ne(new E(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(11908,null),""],description:c.localize(11909,null)})),autoClosingOvertype:Ne(new E(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(11910,null),""],description:c.localize(11911,null)})),autoClosingQuotes:Ne(new E(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(11912,null),c.localize(11913,null),""],description:c.localize(11914,null)})),autoIndent:Ne(new D(je.autoIndent,"autoIndent",S.Full,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[c.localize(11915,null),c.localize(11916,null),c.localize(11917,null),c.localize(11918,null),c.localize(11919,null)],description:c.localize(11920,null)})),automaticLayout:Ne(new s(je.automaticLayout,"automaticLayout",!1)),autoSurround:Ne(new E(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(11921,null),c.localize(11922,null),c.localize(11923,null),""],description:c.localize(11924,null)})),bracketPairColorization:Ne(new Oe),bracketPairGuides:Ne(new He),stickyTabStops:Ne(new s(je.stickyTabStops,"stickyTabStops",!1,{description:c.localize(11925,null)})),codeLens:Ne(new s(je.codeLens,"codeLens",!0,{description:c.localize(11926,null)})),codeLensFontFamily:Ne(new l(je.codeLensFontFamily,"codeLensFontFamily","",{description:c.localize(11927,null)})),codeLensFontSize:Ne(new o(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(11928,null)})),colorDecorators:Ne(new s(je.colorDecorators,"colorDecorators",!0,{description:c.localize(11929,null)})),colorDecoratorActivatedOn:Ne(new E(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(11930,null),c.localize(11931,null),c.localize(11932,null)],description:c.localize(11933,null)})),colorDecoratorsLimit:Ne(new o(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(11934,null)})),columnSelection:Ne(new s(je.columnSelection,"columnSelection",!1,{description:c.localize(11935,null)})),comments:Ne(new A),contextmenu:Ne(new s(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new s(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:c.localize(11936,null)})),cursorBlinking:Ne(new D(je.cursorBlinking,"cursorBlinking",p.Blink,"blink",["blink","smooth","phase","expand","solid"],v,{description:c.localize(11937,null)})),cursorSmoothCaretAnimation:Ne(new E(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(11938,null),c.localize(11939,null),c.localize(11940,null)],description:c.localize(11941,null)})),cursorStyle:Ne(new D(je.cursorStyle,"cursorStyle",F.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],O,{description:c.localize(11942,null)})),cursorSurroundingLines:Ne(new o(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(11943,null)})),cursorSurroundingLinesStyle:Ne(new E(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(11944,null),c.localize(11945,null)],markdownDescription:c.localize(11946,null)})),cursorWidth:Ne(new o(je.cursorWidth,"cursorWidth",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(11947,null)})),disableLayerHinting:Ne(new s(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new s(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new s(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:Ne(new s(je.dragAndDrop,"dragAndDrop",!0,{description:c.localize(11948,null)})),emptySelectionClipboard:Ne(new z),dropIntoEditor:Ne(new ht),stickyScroll:Ne(new U),experimentalWhitespaceRendering:Ne(new E(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(11949,null),c.localize(11950,null),c.localize(11951,null)],description:c.localize(11952,null)})),extraEditorClassName:Ne(new l(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Ne(new d(je.fastScrollSensitivity,"fastScrollSensitivity",5,he=>he<=0?5:he,{markdownDescription:c.localize(11953,null)})),find:Ne(new M),fixedOverflowWidgets:Ne(new s(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Ne(new s(je.folding,"folding",!0,{description:c.localize(11954,null)})),foldingStrategy:Ne(new E(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(11955,null),c.localize(11956,null)],description:c.localize(11957,null)})),foldingHighlight:Ne(new s(je.foldingHighlight,"foldingHighlight",!0,{description:c.localize(11958,null)})),foldingImportsByDefault:Ne(new s(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:c.localize(11959,null)})),foldingMaximumRegions:Ne(new o(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(11960,null)})),unfoldOnClickAfterEndOfLine:Ne(new s(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(11961,null)})),fontFamily:Ne(new l(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(11962,null)})),fontInfo:Ne(new ne),fontLigatures2:Ne(new W),fontSize:Ne(new B),fontWeight:Ne(new K),fontVariations:Ne(new V),formatOnPaste:Ne(new s(je.formatOnPaste,"formatOnPaste",!1,{description:c.localize(11963,null)})),formatOnType:Ne(new s(je.formatOnType,"formatOnType",!1,{description:c.localize(11964,null)})),glyphMargin:Ne(new s(je.glyphMargin,"glyphMargin",!0,{description:c.localize(11965,null)})),gotoLocation:Ne(new Y),hideCursorInOverviewRuler:Ne(new s(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:c.localize(11966,null)})),hover:Ne(new ee),inDiffEditor:Ne(new s(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Ne(new d(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,he=>d.clamp(he,-5,20),{description:c.localize(11967,null)})),lightbulb:Ne(new J),lineDecorationsWidth:Ne(new ae),lineHeight:Ne(new te),lineNumbers:Ne(new Ce),lineNumbersMinChars:Ne(new o(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new s(je.linkedEditing,"linkedEditing",!1,{description:c.localize(11968,null)})),links:Ne(new s(je.links,"links",!0,{description:c.localize(11969,null)})),matchBrackets:Ne(new E(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:c.localize(11970,null)})),minimap:Ne(new ce),mouseStyle:Ne(new E(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new d(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,he=>he===0?1:he,{markdownDescription:c.localize(11971,null)})),mouseWheelZoom:Ne(new s(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:C.$k?c.localize(11972,null):c.localize(11973,null)})),multiCursorMergeOverlapping:Ne(new s(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:c.localize(11974,null)})),multiCursorModifier:Ne(new D(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[c.localize(11975,null),c.localize(11976,null)],markdownDescription:c.localize(11977,null)})),multiCursorPaste:Ne(new E(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(11978,null),c.localize(11979,null)],markdownDescription:c.localize(11980,null)})),multiCursorLimit:Ne(new o(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(11981,null)})),occurrencesHighlight:Ne(new E(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[c.localize(11982,null),c.localize(11983,null),c.localize(11984,null)],markdownDescription:c.localize(11985,null)})),overviewRulerBorder:Ne(new s(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:c.localize(11986,null)})),overviewRulerLanes:Ne(new o(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Ne(new x),pasteAs:Ne(new ct),parameterHints:Ne(new oe),peekWidgetDefaultFocus:Ne(new E(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(11987,null),c.localize(11988,null)],description:c.localize(11989,null)})),placeholder:Ne(new we),definitionLinkOpensInPeek:Ne(new s(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:c.localize(11990,null)})),quickSuggestions:Ne(new Fe),quickSuggestionsDelay:Ne(new o(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(11991,null)})),readOnly:Ne(new s(je.readOnly,"readOnly",!1)),readOnlyMessage:Ne(new q),renameOnType:Ne(new s(je.renameOnType,"renameOnType",!1,{description:c.localize(11992,null),markdownDeprecationMessage:c.localize(11993,null)})),renderControlCharacters:Ne(new s(je.renderControlCharacters,"renderControlCharacters",!0,{description:c.localize(11994,null),restricted:!0})),renderFinalNewline:Ne(new E(je.renderFinalNewline,"renderFinalNewline",C.$l?"dimmed":"on",["off","on","dimmed"],{description:c.localize(11995,null)})),renderLineHighlight:Ne(new E(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(11996,null)],description:c.localize(11997,null)})),renderLineHighlightOnlyWhenFocus:Ne(new s(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(11998,null)})),renderValidationDecorations:Ne(new E(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new E(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(11999,null),c.localize(12e3,null),c.localize(12001,null),""],description:c.localize(12002,null)})),revealHorizontalRightPadding:Ne(new o(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new s(je.roundedSelection,"roundedSelection",!0,{description:c.localize(12003,null)})),rulers:Ne(new Pe),scrollbar:Ne(new X),scrollBeyondLastColumn:Ne(new o(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(12004,null)})),scrollBeyondLastLine:Ne(new s(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:c.localize(12005,null)})),scrollPredominantAxis:Ne(new s(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:c.localize(12006,null)})),selectionClipboard:Ne(new s(je.selectionClipboard,"selectionClipboard",!0,{description:c.localize(12007,null),included:C.$l})),selectionHighlight:Ne(new s(je.selectionHighlight,"selectionHighlight",!0,{description:c.localize(12008,null)})),selectOnLineNumbers:Ne(new s(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new E(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(12009,null),c.localize(12010,null),c.localize(12011,null)],description:c.localize(12012,null)})),showUnused:Ne(new s(je.showUnused,"showUnused",!0,{description:c.localize(12013,null)})),showDeprecated:Ne(new s(je.showDeprecated,"showDeprecated",!0,{description:c.localize(12014,null)})),inlayHints:Ne(new se),snippetSuggestions:Ne(new E(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(12015,null),c.localize(12016,null),c.localize(12017,null),c.localize(12018,null)],description:c.localize(12019,null)})),smartSelect:Ne(new nt),smoothScrolling:Ne(new s(je.smoothScrolling,"smoothScrolling",!1,{description:c.localize(12020,null)})),stopRenderingLineAfter:Ne(new o(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Ne(new _e),inlineSuggest:Ne(new de),inlineEdit:Ne(new be),inlineCompletionsAccessibilityVerbose:Ne(new s(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(12021,null)})),suggestFontSize:Ne(new o(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(12022,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new o(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(12023,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new s(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:c.localize(12024,null)})),suggestSelection:Ne(new E(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(12025,null),c.localize(12026,null),c.localize(12027,null)],description:c.localize(12028,null)})),tabCompletion:Ne(new E(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(12029,null),c.localize(12030,null),c.localize(12031,null)],description:c.localize(12032,null)})),tabIndex:Ne(new o(je.tabIndex,"tabIndex",0,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Ne(new Z),unusualLineTerminators:Ne(new E(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(12033,null),c.localize(12034,null),c.localize(12035,null)],description:c.localize(12036,null)})),useShadowDOM:Ne(new s(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:Ne(new s(je.useTabStops,"useTabStops",!0,{description:c.localize(12037,null)})),wordBreak:Ne(new E(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(12038,null),c.localize(12039,null)],description:c.localize(12040,null)})),wordSegmenterLocales:Ne(new st),wordSeparators:Ne(new l(je.wordSeparators,"wordSeparators",b.$jt,{description:c.localize(12041,null)})),wordWrap:Ne(new E(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(12042,null),c.localize(12043,null),c.localize(12044,null),c.localize(12045,null)],description:c.localize(12046,null)})),wordWrapBreakAfterCharacters:Ne(new l(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new l(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new o(je.wordWrapColumn,"wordWrapColumn",80,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(12047,null)})),wordWrapOverride1:Ne(new E(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new E(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new j),defaultColorDecorators:Ne(new s(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:c.localize(12048,null)})),pixelRatio:Ne(new pe),tabFocusMode:Ne(new s(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:c.localize(12049,null)})),layoutInfo:Ne(new re),wrappingInfo:Ne(new mt),wrappingIndent:Ne(new at),wrappingStrategy:Ne(new ye)}});var Wt=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Se[216],De([1,0,22,43,8,5,107,10,24]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$9w=e.$8w=e.$7w=void 0,e.$0w=P,e.$$w=w,h=Wt(h),e.$7w=(0,R.$Ci)("dialogService");var c;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(c||(c={}));class I{a(m){return this.d(m,c.Confirmation)}b(m){return this.d(m,c.Prompt)}c(m){return this.d(m,c.Input)}d(m,$){const f=[];switch($){case c.Confirmation:{const i=m;i.primaryButton?f.push(i.primaryButton):f.push((0,C.localize)(11483,null)),i.cancelButton?f.push(i.cancelButton):f.push((0,C.localize)(11484,null));break}case c.Prompt:{const i=m;Array.isArray(i.buttons)&&i.buttons.length>0&&f.push(...i.buttons.map(s=>s.label)),i.cancelButton&&(i.cancelButton===!0?f.push((0,C.localize)(11485,null)):typeof i.cancelButton=="string"?f.push(i.cancelButton):i.cancelButton.label?f.push(i.cancelButton.label):f.push((0,C.localize)(11486,null))),f.length===0&&f.push((0,C.localize)(11487,null));break}case c.Input:{const i=m;i.primaryButton?f.push(i.primaryButton):f.push((0,C.localize)(11488,null)),i.cancelButton?f.push(i.cancelButton):f.push((0,C.localize)(11489,null));break}}return f}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===h.default.Info?"info":m===h.default.Error?"error":m===h.default.Warning?"warning":"none"}f(m,$,f){const i=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&i.push(m.cancelButton);let s=i[$]?.run({checkboxChecked:f});return s instanceof Promise||(s=Promise.resolve(s)),{result:s,checkboxChecked:f}}}e.$8w=I,e.$9w=(0,R.$Ci)("fileDialogService");var S;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(S||(e.ConfirmResult=S={}));const u=10;function P(a){const m=[];return m.push(...a.slice(0,u).map($=>typeof $=="string"?$:(0,r.$ah)($))),a.length>u&&(a.length-u===1?m.push((0,C.localize)(11490,null)):m.push((0,C.localize)(11491,null,a.length-u))),m.push(""),m.join(`
`)}function w(a,m){const $=(0,b.$bo)(a);let f=($.buttons??[]).map(o=>(0,L.$4w)(o)),i=(a.buttons||[]).map((o,n)=>n),s=0,t=$.cancelId??f.length-1;if(f.length>1){const o=typeof t=="number"?f[t]:void 0;if(T.$l||T.$k){if(typeof o=="string"&&f.length>1&&t!==1){f.splice(t,1),f.splice(1,0,o);const n=i[t];i.splice(t,1),i.splice(1,0,n),t=1}T.$l&&f.length>1&&(f=f.reverse(),i=i.reverse(),s=f.length-1,typeof o=="string"&&(t=s-1))}else if(T.$j&&typeof o=="string"&&f.length>1&&t!==f.length-1){f.splice(t,1),f.push(o);const n=i[t];i.splice(t,1),i.push(n),t=f.length-1}}return $.buttons=f,$.defaultId=s,$.cancelId=t,$.noLink=!0,$.title=$.title||m.nameLong,{options:$,buttonIndeces:i}}}),define(Se[144],De([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,r.$Ci)("environmentService"),e.$Ki=(0,r.$Di)(e.$Ji)}),define(Se[217],De([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k0b=e.$j0b=void 0,e.$j0b=(0,r.$Ci)("externalTerminal"),e.$k0b="Terminal.app"}),define(Se[218],De([1,0,56,59,14,16,10,104,33,109,8,217]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=e.$_fc=e.$$fc=void 0,r=Ue(r),R=Ue(R),L=Ue(L),b=Ue(b),c=Ue(c),I=Ue(I);const u=I.localize(11333,null);class P{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends P{static{this.b="cmd.exe"}openTerminal(t,o){return this.spawnTerminal(r,t,c.$vm(),o)}spawnTerminal(t,o,n,d){const l=o.windowsExec||w.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const g=R.$mc(l,".exe").toLowerCase();if(g==="cmder")return t.spawn(l,d?[d]:void 0),Promise.resolve(void 0);const E=["/c","start","/wait"];return l.indexOf(" ")>=0&&E.push(l),E.push(l),g==="wt"&&E.push("-d ."),new Promise((D,y)=>{const k=$(process),A=t.spawn(n,E,{cwd:d,env:k,detached:!0});A.on("error",y),A.on("exit",()=>D())})}async runInTerminal(t,o,n,d,l){const g="windowsExec"in l&&l.windowsExec?l.windowsExec:w.getDefaultTerminalWindows(),E=await w.f();return new Promise((D,y)=>{const k=`"${o} - ${u}"`,A=`"${n.join('" "')}" & pause`,p=Object.assign({},$(process),d);Object.keys(p).filter(j=>p[j]===null).forEach(j=>delete p[j]);const v={cwd:o,env:p,windowsVerbatimArguments:!0};let F,N;R.$mc(g,".exe")==="wt"?(F=g,N=["-d",".",w.b,"/c",A]):E?(F=E,N=["-d",".",g,"/c",A]):(F=w.b,N=["/c","start",k,"/wait",g,"/c",`"${A}"`]),r.spawn(F,N,v).on("error",j=>{y(f(j))}),D(void 0)})}static getDefaultTerminalWindows(){if(!w.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return w.d}static async f(){try{const t=await c.win32.findExecutable("wt");return await b.Promises.exists(t)?t:void 0}catch{return}}}e.$$fc=w,Ye([h.$7h],w,"f",null);class a extends P{static{this.b="/usr/bin/osascript"}openTerminal(t,o){return this.spawnTerminal(r,t,o)}runInTerminal(t,o,n,d,l){const g=l.osxExec||S.$k0b;return new Promise((E,D)=>{if(g===S.$k0b||g==="iTerm.app"){const y=g===S.$k0b?"TerminalHelper":"iTermHelper",A=[C.$Wg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",t||u,"-w",o];for(const F of n)A.push("-a"),A.push(F);if(d){const F=Object.assign({},$(process),d);for(const N in F){const O=F[N];O===null?(A.push("-u"),A.push(N)):(A.push("-e"),A.push(`${N}=${O}`))}}let p="";const v=r.spawn(a.b,A);v.on("error",F=>{D(f(F))}),v.stderr.on("data",F=>{p+=F.toString()}),v.on("exit",F=>{if(F===0)E(void 0);else if(p){const N=p.split(`
`,1);D(new Error(N[0]))}else D(new Error(I.localize(11334,null,y,F)))})}else D(new Error(I.localize(11335,null,g)))})}spawnTerminal(t,o,n){const d=o.osxExec||S.$k0b;return new Promise((l,g)=>{const E=["-a",d];n&&E.push(n);const D=$(process),y=t.spawn("/usr/bin/open",E,{cwd:n,env:D});y.on("error",g),y.on("exit",()=>l())})}}e.$_fc=a;class m extends P{static{this.b=I.localize(11336,null)}openTerminal(t,o){return this.spawnTerminal(r,t,o)}runInTerminal(t,o,n,d,l){const g=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((E,D)=>{const y=[];g.then(k=>{k.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const A=`${i(n)}; echo; read -p "${m.b}" -n1;`;y.push(`''${A}''`);const p=Object.assign({},$(process),d);Object.keys(p).filter(O=>p[O]===null).forEach(O=>delete p[O]);const v={cwd:o,env:p};let F="";const N=r.spawn(k,y,v);N.on("error",O=>{D(f(O))}),N.stderr.on("data",O=>{F+=O.toString()}),N.on("exit",O=>{if(O===0)E(void 0);else if(F){const j=F.split(`
`,1);D(new Error(j[0]))}else D(new Error(I.localize(11337,null,k,O)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!L.$l)m.d=Promise.resolve("xterm");else{const t=await b.Promises.exists("/etc/debian_version");m.d=new Promise(o=>{t?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm")})}return m.d}spawnTerminal(t,o,n){const d=o.linuxExec?Promise.resolve(o.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((l,g)=>{d.then(E=>{const D=$(process),y=t.spawn(E,[],{cwd:n,env:D});y.on("error",g),y.on("exit",()=>l())})})}}e.$agc=m;function $(s){const t={...s.env};return(0,T.$im)(t),t}function f(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(I.localize(11338,null,s.path)):s}function i(s){let t="";for(const o of s)o.indexOf(" ")>=0?t+='"'+o+'"':t+=o,t+=" ";return t}}),define(Se[27],De([1,0,84,16,12,17,2,8,5,10,14,49]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$Cl=e.FileKind=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.FileOperationResult=e.$ul=e.$tl=e.$sl=e.$ql=e.FileChangeType=e.$pl=e.FileOperation=e.$jl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$0k=void 0,e.$$k=u,e.$_k=m,e.$al=f,e.$bl=i,e.$cl=s,e.$dl=t,e.$el=o,e.$fl=n,e.$gl=d,e.$hl=l,e.$il=g,e.$kl=y,e.$ll=k,e.$ml=A,e.$nl=p,e.$ol=v,e.$rl=z,e.$Dl=K,e.$El=Y,e.$Gl=ue,e.$0k=(0,b.$Ci)("fileService");function u(re){return re.create===!0}var P;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(P||(e.FileType=P={}));var w;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(w||(e.FilePermission=w={}));var a;(function(re){re[re.UPDATED=2]="UPDATED",re[re.ADDED=4]="ADDED",re[re.DELETED=8]="DELETED"})(a||(e.FileChangeFilter=a={}));function m(re){const ye=re;return!!ye&&typeof ye.onDidChange=="function"}var $;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function f(re){return!!(re.capabilities&$.FileReadWrite)}function i(re){return!!(re.capabilities&$.FileFolderCopy)}function s(re){return!!(re.capabilities&$.FileClone)}function t(re){return!!(re.capabilities&$.FileOpenReadWriteClose)}function o(re){return!!(re.capabilities&$.FileReadStream)}function n(re){return f(re)?!!(re.capabilities&$.FileAtomicRead):!1}function d(re){return f(re)?!!(re.capabilities&$.FileAtomicWrite):!1}function l(re){return!!(re.capabilities&$.FileAtomicDelete)}function g(re){return!!(re.capabilities&$.Readonly)}var E;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class D extends Error{static create(ye,me){const J=new D(ye.toString(),me);return A(J,me),J}constructor(ye,me){super(ye),this.code=me}}e.$jl=D;function y(re,ye){return D.create(re,ye)}function k(re){return re||y((0,T.localize)(11292,null),E.Unknown)}function A(re,ye){return re.name=ye?`${ye} (FileSystemError)`:"FileSystemError",re}function p(re){if(!re)return E.Unknown;if(re instanceof D)return re.code;const ye=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!ye)return E.Unknown;switch(ye[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function v(re){if(re instanceof M)return re.fileOperationResult;switch(p(re)){case E.FileNotFound:return ne.FILE_NOT_FOUND;case E.FileIsADirectory:return ne.FILE_IS_DIRECTORY;case E.FileNotADirectory:return ne.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return ne.FILE_WRITE_LOCKED;case E.NoPermissions:return ne.FILE_PERMISSION_DENIED;case E.FileExists:return ne.FILE_MOVE_CONFLICT;case E.FileTooLarge:return ne.FILE_TOO_LARGE;default:return ne.FILE_OTHER_ERROR}}var F;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class N{constructor(ye,me,J){this.resource=ye,this.operation=me,this.target=J}isOperation(ye){return this.operation===ye}}e.$pl=N;var O;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class j{static{this.a=null}constructor(ye,me){this.c=me,this.b=void 0,this.d=new S.$T(()=>{const J=r.$Ii.forUris(()=>this.c);return J.fill(this.rawAdded.map(U=>[U,!0])),J}),this.f=new S.$T(()=>{const J=r.$Ii.forUris(()=>this.c);return J.fill(this.rawUpdated.map(U=>[U,!0])),J}),this.g=new S.$T(()=>{const J=r.$Ii.forUris(()=>this.c);return J.fill(this.rawDeleted.map(U=>[U,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of ye){switch(J.type){case O.ADDED:this.rawAdded.push(J.resource);break;case O.UPDATED:this.rawUpdated.push(J.resource);break;case O.DELETED:this.rawDeleted.push(J.resource);break}this.b!==j.a&&(typeof J.cId=="number"?this.b===void 0?this.b=J.cId:this.b!==J.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(ye,...me){return this.h(ye,{includeChildren:!1},...me)}affects(ye,...me){return this.h(ye,{includeChildren:!0},...me)}h(ye,me,...J){if(!ye)return!1;const U=J.length>0;return!!((!U||J.includes(O.ADDED))&&(this.d.value.get(ye)||me.includeChildren&&this.d.value.findSuperstr(ye))||(!U||J.includes(O.UPDATED))&&(this.f.value.get(ye)||me.includeChildren&&this.f.value.findSuperstr(ye))||(!U||J.includes(O.DELETED))&&(this.g.value.findSubstr(ye)||me.includeChildren&&this.g.value.findSuperstr(ye)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ye){return this.b===ye}hasCorrelation(){return typeof this.b=="number"}}e.$ql=j;function z(re,ye,me){return!re||!ye||re===ye||ye.length>re.length?!1:(ye.charAt(ye.length-1)!==h.sep&&(ye+=h.sep),me?(0,C.$Ef)(re,ye):re.indexOf(ye)===0)}class M extends Error{constructor(ye,me,J){super(ye),this.fileOperationResult=me,this.options=J}}e.$sl=M;class W extends M{constructor(ye,me,J,U){super(ye,me,U),this.fileOperationResult=me,this.size=J}}e.$tl=W;class V extends M{constructor(ye,me,J){super(ye,ne.FILE_NOT_MODIFIED_SINCE,J),this.stat=me}}e.$ul=V;var ne;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.$vl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$wl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$xl="files.associations",e.$yl="files.exclude",e.$zl="files.readonlyInclude",e.$Al="files.readonlyExclude",e.$Bl="files.readonlyFromPermissions";var B;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.$Cl="";function K(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function Y(re,ye){if(!ye.hasProvider(L.URI.from({scheme:re.scheme})))return new Promise(me=>{const J=ye.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===re.scheme&&U.added&&(J.dispose(),me())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(ye){return(0,R.$gg)(ye)||(ye=0),ye<ee.KB?(0,T.localize)(11293,null,ye.toFixed(0)):ye<ee.MB?(0,T.localize)(11294,null,(ye/ee.KB).toFixed(2)):ye<ee.GB?(0,T.localize)(11295,null,(ye/ee.MB).toFixed(2)):ye<ee.TB?(0,T.localize)(11296,null,(ye/ee.GB).toFixed(2)):(0,T.localize)(11297,null,(ye/ee.TB).toFixed(2))}}e.$Fl=ee;function ue(re){const ye=typeof re=="string"||re?.scheme===I.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===I.Schemas.file?1024*ee.MB:ye?10*ee.MB:c.$p?50*ee.MB:1024*ee.MB}}),define(Se[219],De([1,0,21,13,8,27]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=L;async function L(I,S,u,P,w,a){let m;try{await T(I,S,u,P,w,a)}catch($){m=$}finally{m&&w.errorTransformer&&(m=w.errorTransformer(m)),typeof m<"u"&&u.error(m),u.end()}}async function T(I,S,u,P,w,a){b(a);const m=await I.open(S,{create:!1});try{b(a);let $=0,f=0,i=w&&typeof w.length=="number"?w.length:void 0,s=r.$Le.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),t=w&&typeof w.position=="number"?w.position:0,o=0;do f=await I.read(m,t,s.buffer,o,s.byteLength-o),t+=f,o+=f,$+=f,typeof i=="number"&&(i-=f),o===s.byteLength&&(await u.write(P(s)),s=r.$Le.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),o=0);while(f>0&&(typeof i!="number"||i>0)&&b(a)&&c($,w));if(o>0){let n=o;typeof i=="number"&&(n=Math.min(o,i)),u.write(P(s.slice(0,n)))}}catch($){throw(0,R.$ll)($)}finally{await I.close(m)}}function b(I){if(I.isCancellationRequested)throw(0,h.$5)();return!0}function c(I,S){if(typeof S?.limits?.size=="number"&&I>S.limits.size)throw(0,R.$kl)((0,C.localize)(11291,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[69],De([1,0,38,3,16,10,2,27]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=void 0,e.$1q=b,e.$2q=c,e.$6q=P,e.$7q=w,e.$8q=a,e.$9q=m,e.$0q=f,e.$$q=i;function b(s){return typeof s.correlationId=="number"}function c(s){return s.recursive===!0}class I extends h.$Tc{static{this.a=5}constructor(t,o,n,d){super(),this.h=t,this.j=o,this.m=n,this.n=d,this.c=this.B(new h.$Uc),this.f=void 0,this.g=0}s(){const t=new h.$Sc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(o=>this.h(o))),t.add(this.b.onDidLogMessage(o=>this.j(o))),t.add(this.b.onDidError(o=>this.t(o.error,o.request)))}t(t,o){this.u(t,o)?this.g<I.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,o){return!(!this.n.restartOnError||o||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$3q=I;class S extends I{constructor(t,o,n){super(t,o,n,{type:"node.js",restartOnError:!1})}}e.$4q=S;class u extends I{constructor(t,o,n){super(t,o,n,{type:"universal",restartOnError:!0})}}e.$5q=u;function P(s){return s.map(t=>({type:t.type,resource:L.URI.revive(t.resource),cId:t.cId}))}function w(s){const t=new $;for(const o of s)t.processEvent(o);return t.coalesce()}function a(s,t){return typeof t=="string"&&!t.startsWith(r.$tk)&&!(0,C.$hc)(t)?{base:s,pattern:t}:t}function m(s,t){const o=[];for(const n of t)o.push((0,r.$xk)(a(s,n)));return o}class ${constructor(){this.a=new Set,this.b=new Map}c(t){return R.$l?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const o=this.b.get(this.c(t));let n=!1;if(o){const d=o.type,l=t.type;o.resource.fsPath!==t.resource.fsPath&&(t.type===T.FileChangeType.DELETED||t.type===T.FileChangeType.ADDED)?n=!0:d===T.FileChangeType.ADDED&&l===T.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(o)):d===T.FileChangeType.DELETED&&l===T.FileChangeType.ADDED?o.type=T.FileChangeType.UPDATED:d===T.FileChangeType.ADDED&&l===T.FileChangeType.UPDATED||(o.type=l)}else n=!0;n&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],o=[];return Array.from(this.a).filter(n=>n.type!==T.FileChangeType.DELETED?(t.push(n),!1):!0).sort((n,d)=>n.resource.fsPath.length-d.resource.fsPath.length).filter(n=>o.some(d=>(0,T.$rl)(n.resource.fsPath,d,!R.$l))?!1:(o.push(n.resource.fsPath),!0)).concat(t)}}function f(s,t){if(typeof t=="number")switch(s.type){case T.FileChangeType.ADDED:return(t&T.FileChangeFilter.ADDED)===0;case T.FileChangeType.DELETED:return(t&T.FileChangeFilter.DELETED)===0;case T.FileChangeType.UPDATED:return(t&T.FileChangeFilter.UPDATED)===0}return!1}function i(s){if(typeof s=="number"){const t=[];return s&T.FileChangeFilter.ADDED&&t.push("Added"),s&T.FileChangeFilter.DELETED&&t.push("Deleted"),s&T.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(Se[220],De([1,0,44,3,69,4,27,2,7]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class c extends h.$Tc{constructor(){super(),this.a=this.B(new R.$je),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$je),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$je),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new h.$3c),this.m=new Set,this.n=this.B(new b.$Ah(this.y())),this.r=5007,this.s=new b.$Zh,this.R=!1,this.B(this.f(S=>this.t(S)))}t(S){this.u(S)&&this.z(S)}u(S){return(0,C.$1q)(S)}async watch(S){this.s.isSettled||this.s.complete(),this.s=new b.$Zh;try{this.h.clear(),this.g.clear();for(const u of S)this.u(u)?this.h.set(u.correlationId,u):this.g.add(u);for(const[u]of this.j)this.h.has(u)||(this.j.deleteAndDispose(u),this.m.delete(u));return await this.w(!1)}finally{this.s.complete()}}w(S){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(u=>!this.j.has(u.correlationId))]),S?this.y():0)}y(){return 800}isSuspended(S){return typeof S.correlationId!="number"?!1:this.m.has(S.correlationId)?"polling":this.j.has(S.correlationId)}async z(S){if(this.j.has(S.correlationId))return;const u=new h.$Sc;this.j.set(S.correlationId,u),await this.s.p,!u.isDisposed&&(this.D(S,u),this.w(!0))}C(S){this.j.deleteAndDispose(S.correlationId),this.m.delete(S.correlationId),this.w(!1)}D(S,u){this.F(S,u)?(this.P(`reusing an existing recursive watcher to monitor ${S.path}`),this.m.delete(S.correlationId)):(this.G(S,u),this.m.add(S.correlationId))}F(S,u){const P=this.O?.subscribe(S.path,(w,a)=>{u.isDisposed||(w?this.D(S,u):a?.type===L.FileChangeType.ADDED&&this.H(S))});return P?(u.add(P),!0):!1}G(S,u){let P=!1;const w=(a,m)=>{if(u.isDisposed)return;const $=this.I(a),f=this.I(m),i=P;P=$,!$&&(f||i)&&this.H(S)};this.P(`starting fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`);try{(0,r.watchFile)(S.path,{persistent:!1,interval:this.r},w)}catch(a){this.Q(`fs.watchFile() failed with error ${a} on path ${S.path} (correlationId: ${S.correlationId})`)}u.add((0,h.$Rc)(()=>{this.P(`stopping fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`);try{(0,r.unwatchFile)(S.path,w)}catch(a){this.Q(`fs.unwatchFile() failed with error ${a} on path ${S.path} (correlationId: ${S.correlationId})`)}}))}H(S){this.P(`detected ${S.path} exists again, resuming watcher (correlationId: ${S.correlationId})`);const u={resource:T.URI.file(S.path),type:L.FileChangeType.ADDED,cId:S.correlationId};this.a.fire([u]),this.J(u,S),this.C(S)}I(S){return S.ctimeMs===0&&S.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(S,u){if(this.R){const P=` >> normalized ${S.type===L.FileChangeType.ADDED?"[ADDED]":S.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${S.resource.fsPath}`;this.L(P,u)}}L(S,u){this.R&&this.P(`${S}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}M(S){return`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"}, filter: ${(0,C.$$q)(S.filter)}, correlationId: ${typeof S.correlationId=="number"?S.correlationId:"<none>"})`}async setVerboseLogging(S){this.R=S}}e.$hr=c}),define(Se[221],De([1,0,44,7,20,31,3,81,16,10,22,2,108,33,27,69]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0,e.$nr=$;class m extends L.$Tc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(i,s,t,o,n,d){super(),this.s=i,this.t=s,this.u=t,this.w=o,this.y=n,this.z=d,this.c=this.B(new h.$Rh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.u(l))),this.f=this.B(new h.$Qh(l=>this.M(l),m.b)),this.g=(0,a.$9q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,a.$9q)(this.s.path,this.s.includes):void 0,this.j=(0,a.$1q)(this.s)?this.s.filter:void 0,this.m=new C.$ue,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const i=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const s=await r.promises.stat(i);if(this.m.token.isCancellationRequested)return;this.B(await this.G(i,s.isDirectory()))}catch(i){i.code!=="ENOENT"?this.O(i):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${i})`),this.D()}}D(){this.r=!0,this.w?.()}async F(i){let s=i.path;try{s=await P.Promises.realpath(i.path),i.path===s&&(s=await(0,u.$jr)(i.path,this.m.token)??i.path),i.path!==s&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${s})`)}catch{}return s}async G(i,s){const t=new L.$Sc;return this.H(i,s,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(i,s,t)),t}H(i,s,t){if(s)return!1;const o=S.URI.file(this.s.path),n=this.t?.subscribe(this.s.path,async(d,l)=>{if(!t.isDisposed)if(d){const g=await this.G(i,s);t.isDisposed?g.dispose():t.add(g)}else l&&(typeof l.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:o,type:l.type,cId:this.s.correlationId},!0)});return n?(t.add(n),!0):!1}async I(i,s,t){if(c.$k&&(0,R.$Bg)(i,"/Volumes/",!0)){this.O(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const o=new C.$ue(this.m.token);t.add((0,L.$Rc)(()=>o.dispose(!0)));const n=new L.$Sc;t.add(n);try{const d=S.URI.file(this.s.path),l=(0,b.$mc)(i),g=(0,r.watch)(i);n.add((0,L.$Rc)(()=>{g.removeAllListeners(),g.close()})),this.Q(`Started watching: '${i}'`);const E=new Set;if(s)try{for(const y of await P.Promises.readdir(i))E.add(y)}catch(y){this.O(y)}if(o.token.isCancellationRequested)return;const D=new Map;n.add((0,L.$Rc)(()=>{for(const[,y]of D)y.dispose();D.clear()})),g.on("error",(y,k)=>{o.token.isCancellationRequested||(this.O(`Failed to watch ${i} for changes using fs.watch() (${y}, ${k})`),this.D())}),g.on("change",(y,k)=>{if(o.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${k}`);let A="";if(k&&(A=k.toString(),c.$k&&(A=(0,T.$km)(A))),!(!A||y!=="change"&&y!=="rename"))if(s)if(y==="rename"){D.get(A)?.dispose();const p=setTimeout(async()=>{if(D.delete(A),A===l&&!await P.Promises.exists(i)){this.J(d);return}if(o.token.isCancellationRequested)return;const v=await this.N((0,b.$ic)(i,A));if(o.token.isCancellationRequested)return;let F;v?E.has(A)?F=w.FileChangeType.UPDATED:(F=w.FileChangeType.ADDED,E.add(A)):(E.delete(A),F=w.FileChangeType.DELETED),this.L({resource:(0,I.$dh)(d,A),type:F,cId:this.s.correlationId})},m.a);D.set(A,(0,L.$Rc)(()=>clearTimeout(p)))}else{let p;E.has(A)?p=w.FileChangeType.UPDATED:(p=w.FileChangeType.ADDED,E.add(A)),this.L({resource:(0,I.$dh)(d,A),type:p,cId:this.s.correlationId})}else if(y==="rename"||A!==l){const p=setTimeout(async()=>{const v=await P.Promises.exists(i);o.token.isCancellationRequested||(v?(this.L({resource:d,type:w.FileChangeType.UPDATED,cId:this.s.correlationId},!0),n.add(await this.G(i,!1))):this.J(d))},m.a);n.clear(),n.add((0,L.$Rc)(()=>clearTimeout(p)))}else this.L({resource:d,type:w.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(d){o.token.isCancellationRequested||this.O(`Failed to watch ${i} for changes using fs.watch() (${d.toString()})`),this.D()}}J(i){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:i,type:w.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(i,s=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${i.type===w.FileChangeType.ADDED?"[ADDED]":i.type===w.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!s&&this.g.some(t=>t(i.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${i.resource.fsPath}`):!s&&this.h&&this.h.length>0&&!this.h.some(t=>t(i.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}M(i){const s=(0,a.$7q)(i),t=[];for(const n of s){if((0,a.$0q)(n,this.j)){this.z&&this.R(` >> ignored (filtered) ${n.resource.fsPath}`);continue}t.push(n)}if(t.length===0)return;if(this.z)for(const n of t)this.R(` >> normalized ${n.type===w.FileChangeType.ADDED?"[ADDED]":n.type===w.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(i){if(c.$l)return P.Promises.exists(i);try{const s=(0,b.$mc)(i);return(await P.Promises.readdir((0,b.$lc)(i))).some(o=>o===s)}catch(s){return this.Q(s),!1}}setVerboseLogging(i){this.z=i}O(i){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}P(i){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}Q(i){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}R(i){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${i}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$mr=m;async function $(f,i,s,t,o=512){const n=await P.Promises.open(f,"r"),d=Buffer.allocUnsafe(o),l=new C.$ue(t);let g,E=!1;const D={path:f,excludes:[],recursive:!1},y=new m(D,void 0,k=>{(async()=>{for(const{type:A}of k)if(A===w.FileChangeType.UPDATED){if(E)return;E=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:p}=await P.Promises.read(n,d,0,o,null);if(!p||l.token.isCancellationRequested)break;i(d.slice(0,p))}}catch(p){g=new Error(p),l.dispose(!0)}finally{E=!1}}})()});return await y.ready,s(),new Promise((k,A)=>{l.token.onCancellationRequested(async()=>{y.dispose();try{await P.Promises.close(n)}catch(p){g=new Error(p)}g?A(g):k()})})}}),define(Se[222],De([1,0,4,38,220,10,221,31]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class b extends C.$hr{constructor(I){super(),this.O=I,this.onDidError=r.Event.None,this.watchers=new Set}async N(I){I=this.Z(I);const S=[],u=new Set(Array.from(this.watchers));for(const P of I){const w=this.W(P);w&&(0,h.$Bk)(w.request.excludes,P.excludes)&&(0,h.$Bk)(w.request.includes,P.includes)?u.delete(w):S.push(P)}S.length&&this.P(`Request to start watching: ${S.map(P=>this.M(P)).join(",")}`),u.size&&this.P(`Request to stop watching: ${Array.from(u).map(P=>this.M(P.request)).join(",")}`);for(const P of u)this.Y(P);for(const P of S)this.X(P)}W(I){for(const S of this.watchers)if(typeof I.correlationId=="number"||typeof S.request.correlationId=="number"){if(S.request.correlationId===I.correlationId)return S}else if((0,T.$Ag)(S.request.path,I.path,!R.$l))return S}X(I){const S=new L.$mr(I,this.O,P=>this.a.fire(P),()=>this.c.fire(I),P=>this.b.fire(P),this.R),u={request:I,instance:S};this.watchers.add(u)}async stop(){await super.stop();for(const I of this.watchers)this.Y(I)}Y(I){this.P("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}Z(I){const S=new Map;for(const u of I){const P=R.$l?u.path:u.path.toLowerCase();let w=S.get(u.correlationId);w||(w=new Map,S.set(u.correlationId,w)),w.has(P)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),w.set(P,u)}return Array.from(S.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const S of this.watchers)S.instance.setVerboseLogging(I)}P(I,S){this.R&&this.b.fire({type:"trace",message:this.bb(I,S)})}Q(I){this.b.fire({type:"warn",message:this.bb(I)})}bb(I,S){return S?`[File Watcher (node.js)] ${I} (${this.M(S.request)})`:`[File Watcher (node.js)] ${I}`}}e.$or=b}),define(Se[223],De([1,0,69,222]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class C extends r.$4q{constructor(L,T,b){super(L,T,b),this.s()}r(L){return L.add(new h.$or(void 0))}}e.$pr=C}),define(Se[224],De([1,0,14,86,192,69]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class L extends R.$5q{constructor(b,c,I){super(b,c,I),this.s()}r(b){const c=b.add(new C.$fr(r.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(c.onDidProcessExit(({code:I,signal:S})=>this.t(`terminated by itself with code ${I}, signal: ${S} (ETERM)`))),h.ProxyChannel.toService((0,h.$ji)(c.getChannel("watcher")))}}e.$gr=L}),define(Se[114],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class r{constructor(...C){this.a=new Map;for(const[R,L]of C)this.set(R,L)}set(C,R){const L=this.a.get(C);return this.a.set(C,R),L}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Ai=r}),define(Se[225],De([1,0,7,13,3,112,214,5,114,80]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;const I=!1;class S extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class u{constructor(m=new b.$Ai,$=!1,f,i=I){this.i=m,this.j=$,this.k=f,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Bi,this),this._globalGraph=i?f?._globalGraph??new L.$sr(s=>s):void 0}dispose(){if(!this.f){this.f=!0,(0,C.$Oc)(this.h),this.h.clear();for(const m of this.g)(0,C.$Nc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m,$){this.m();const f=this,i=new class extends u{dispose(){f.h.delete(i),super.dispose()}}(m,this.j,this,this.l);return this.h.add(i),$?.add(i),i}invokeFunction(m,...$){this.m();const f=w.traceInvocation(this.l,m);let i=!1;try{return m({get:t=>{if(i)throw(0,h.$7)("service accessor is only valid during the invocation of its target method");const o=this.s(t,f);if(!o)throw new Error(`[invokeFunction] unknown service '${t}'`);return o}},...$)}finally{i=!0,f.stop()}}createInstance(m,...$){this.m();let f,i;return m instanceof R.$zi?(f=w.traceCreation(this.l,m.ctor),i=this.o(m.ctor,m.staticArguments.concat($),f)):(f=w.traceCreation(this.l,m),i=this.o(m,$,f)),f.stop(),i}o(m,$=[],f){const i=T._util.getServiceDependencies(m).sort((o,n)=>o.index-n.index),s=[];for(const o of i){const n=this.s(o.id,f);n||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${o.id}.`,!1),s.push(n)}const t=i.length>0?i[0].index:$.length;if($.length!==t){console.trace(`[createInstance] First service dependency of ${m.name} at position ${t+1} conflicts with ${$.length} static arguments`);const o=t-$.length;o>0?$=$.concat(new Array(o)):$=$.slice(0,t)}return Reflect.construct(m,$.concat(s))}q(m,$){if(this.i.get(m)instanceof R.$zi)this.i.set(m,$);else if(this.k)this.k.q(m,$);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const $=this.i.get(m);return!$&&this.k?this.k.r(m):$}s(m,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const f=this.r(m);return f instanceof R.$zi?this.u(m,f,$.branch(m,!0)):($.branch(m,!1),f)}u(m,$,f){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,$,f)}finally{this.t.delete(m)}}v(m,$,f){const i=new L.$sr(n=>n.id.toString());let s=0;const t=[{id:m,desc:$,_trace:f}],o=new Set;for(;t.length;){const n=t.pop();if(!o.has(String(n.id))){if(o.add(String(n.id)),i.lookupOrInsertNode(n),s++>1e3)throw new S(i);for(const d of T._util.getServiceDependencies(n.desc.ctor)){const l=this.r(d.id);if(l||this.y(`[createInstance] ${m} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(d.id)),l instanceof R.$zi){const g={id:d.id,desc:l,_trace:n._trace.branch(d.id,!0)};i.insertEdge(n,g),t.push(g)}}}}for(;;){const n=i.roots();if(n.length===0){if(!i.isEmpty())throw new S(i);break}for(const{data:d}of n){if(this.r(d.id)instanceof R.$zi){const g=this.w(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.q(d.id,g)}i.removeNode(d)}}return this.r(m)}w(m,$,f=[],i,s){if(this.i.get(m)instanceof R.$zi)return this.x(m,$,f,i,s,this.g);if(this.k)return this.k.w(m,$,f,i,s);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}x(m,$,f=[],i,s,t){if(i){const o=new u(void 0,this.j,this,this.l);o.c=String(m);const n=new Map,d=new r.$Vh(()=>{const l=o.o($,f,s);for(const[g,E]of n){const D=l[g];if(typeof D=="function")for(const y of E)y.disposable=D.apply(l,y.listener)}return n.clear(),t.add(l),l});return new Proxy(Object.create(null),{get(l,g){if(!d.isInitialized&&typeof g=="string"&&(g.startsWith("onDid")||g.startsWith("onWill"))){let y=n.get(g);return y||(y=new c.$4c,n.set(g,y)),(A,p,v)=>{if(d.isInitialized)return d.value[g](A,p,v);{const F={listener:[A,p,v],disposable:void 0},N=y.push(F);return(0,C.$Rc)(()=>{N(),F.disposable?.dispose()})}}}if(g in l)return l[g];const E=d.value;let D=E[g];return typeof D!="function"||(D=D.bind(E),l[g]=D),D},set(l,g,E){return d.value[g]=E,!0},getPrototypeOf(l){return $.prototype}})}else{const o=this.o($,f,s);return t.add(o),o}}y(m,$){if($&&console.warn(m),this.j)throw new Error(m)}}e.$tr=u;var P;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(P||(P={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(P.None,null)}stop(){}branch(){return this}}}static traceInvocation(m,$){return m?new w(P.Invocation,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(m,$){return m?new w(P.Creation,$.name):w.c}static{this.f=0}constructor(m,$){this.type=m,this.name=$,this.g=Date.now(),this.h=[]}branch(m,$){const f=new w(P.Branch,m.toString());return this.h.push([m,$,f]),f}stop(){const m=Date.now()-this.g;w.f+=m;let $=!1;function f(s,t){const o=[],n=new Array(s+1).join("	");for(const[d,l,g]of t.h)if(l&&g){$=!0,o.push(`${n}CREATES -> ${d}`);const E=f(s+1,g);E&&o.push(E)}else o.push(`${n}uses -> ${d}`);return o.join(`
`)}const i=[`${this.type===P.Creation?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(m>2||$)&&w.all.add(i.join(`
`))}}e.$ur=w}),define(Se[11],De([1,0,8,52,4,60,3,28,10,22,17,2,35,5]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$ak=e.LogLevel=e.$$j=e.$0j=void 0,e.$_j=a,e.log=$,e.$lk=D,e.$mk=y,e.$nk=k,e.$ok=A,r=Ue(r),e.$0j=(0,P.$Ci)("logService"),e.$$j=(0,P.$Ci)("loggerService");function w(){return new Date().toISOString()}function a(p){return(0,I.$gg)(p)}var m;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$ak=m.Info;function $(p,v,F){switch(v){case m.Trace:p.trace(F);break;case m.Debug:p.debug(F);break;case m.Info:p.info(F);break;case m.Warning:p.warn(F);break;case m.Error:p.error(F);break;case m.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function f(p,v=!1){let F="";for(let N=0;N<p.length;N++){let O=p[N];if(O instanceof Error&&(O=(0,h.$nj)(O,v)),typeof O=="object")try{O=JSON.stringify(O)}catch{}F+=(N>0?" ":"")+O}return F}class i extends L.$Tc{constructor(){super(...arguments),this.b=e.$ak,this.c=this.B(new C.$je),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==m.Off&&this.b<=v}}e.$ck=i;class s extends i{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...F){this.f(m.Trace)&&this.g(m.Trace,f([v,...F],!0))}debug(v,...F){this.f(m.Debug)&&this.g(m.Debug,f([v,...F]))}info(v,...F){this.f(m.Info)&&this.g(m.Info,f([v,...F]))}warn(v,...F){this.f(m.Warning)&&this.g(m.Warning,f([v,...F]))}error(v,...F){if(this.f(m.Error))if(v instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=v.stack,this.g(m.Error,f(N))}else this.g(m.Error,f([v,...F]))}flush(){}}e.$dk=s;class t extends i{constructor(v=e.$ak){super(),this.setLevel(v),this.g=!b.$j}trace(v,...F){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...F):console.log(`[main ${w()}]`,v,...F))}debug(v,...F){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...F):console.log(`[main ${w()}]`,v,...F))}info(v,...F){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,v,...F):console.log(`[main ${w()}]`,v,...F))}warn(v,...F){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,v,...F):console.warn(`[main ${w()}]`,v,...F))}error(v,...F){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,v,...F):console.error(`[main ${w()}]`,v,...F))}flush(){}}e.$ek=t;class o extends i{constructor(v=e.$ak,F=!0){super(),this.g=F,this.setLevel(v)}trace(v,...F){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...F):console.log(v,...F))}debug(v,...F){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...F):console.log(v,...F))}info(v,...F){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...F):console.log(v,...F))}warn(v,...F){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...F):console.log(v,...F))}error(v,...F){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...F):console.error(v,...F))}flush(){}}e.$fk=o;class n extends i{constructor(v,F=e.$ak){super(),this.g=v,this.setLevel(F)}trace(v,...F){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(v),...F])}debug(v,...F){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(v),...F])}info(v,...F){this.f(m.Info)&&this.g.log(m.Info,[this.h(v),...F])}warn(v,...F){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(v),...F])}error(v,...F){this.f(m.Error)&&this.g.log(m.Error,[this.h(v),...F])}h(v){return typeof v=="string"?v:(0,h.$nj)(v,this.f(m.Trace))}flush(){}}e.$gk=n;class d extends i{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const F of this.g)F.setLevel(v);super.setLevel(v)}trace(v,...F){for(const N of this.g)N.trace(v,...F)}debug(v,...F){for(const N of this.g)N.debug(v,...F)}info(v,...F){for(const N of this.g)N.info(v,...F)}warn(v,...F){for(const N of this.g)N.warn(v,...F)}error(v,...F){for(const N of this.g)N.error(v,...F)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$hk=d;class l extends L.$Tc{constructor(v,F,N){if(super(),this.h=v,this.j=F,this.b=new T.$zc,this.c=this.B(new C.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$je),this.onDidChangeVisibility=this.g.event,N)for(const O of N)this.b.set(O.resource,{logger:void 0,info:O})}m(v){return(0,I.$cg)(v)?[...this.b.values()].find(F=>F.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,F){const N=this.n(v),O=(0,I.$cg)(v)?v:F?.id??(0,R.$qj)(N.toString()).toString(16);let j=this.b.get(N)?.logger;const z=F?.logLevel==="always"?m.Trace:F?.logLevel;j||(j=this.s(N,z??this.getLogLevel(N)??this.h,{...F,id:O}));const M={logger:j,info:{resource:N,id:O,logLevel:z,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(M.info),this.b.set(N,M),j}n(v){return(0,I.$cg)(v)?(0,c.$dh)(this.j,`${v}.log`):v}setLogLevel(v,F){if(S.URI.isUri(v)){const N=v,O=F,j=this.b.get(N);j&&O!==j.info.logLevel&&(j.info.logLevel=O===this.h?void 0:O,j.logger?.setLevel(O),this.b.set(j.info.resource,j),this.f.fire([N,O]))}else{this.h=v;for(const[N,O]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,F){const N=this.m(v);N&&F!==!N.info.hidden&&(N.info.hidden=!F,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,F]))}getLogLevel(v){let F;return v&&(F=this.b.get(v)?.info.logLevel),F??this.h}registerLogger(v){const F=this.b.get(v.resource);F?F.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const F=this.b.get(v);F&&(F.logger&&F.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ik=l;class g{constructor(){this.onDidChangeLogLevel=new C.$je().event}setLevel(v){}getLevel(){return m.Info}trace(v,...F){}debug(v,...F){}info(v,...F){}warn(v,...F){}error(v,...F){}critical(v,...F){}dispose(){}flush(){}}e.$jk=g;class E extends g{}e.$kk=E;function D(p){if(p.verbose)return m.Trace;if(typeof p.logLevel=="string"){const v=A(p.logLevel.toLowerCase());if(v!==void 0)return v}return e.$ak}function y(p){switch(p){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function k(p){switch(p){case m.Trace:return{original:"Trace",value:r.localize(11225,null)};case m.Debug:return{original:"Debug",value:r.localize(11226,null)};case m.Info:return{original:"Info",value:r.localize(11227,null)};case m.Warning:return{original:"Warning",value:r.localize(11228,null)};case m.Error:return{original:"Error",value:r.localize(11229,null)};case m.Off:return{original:"Off",value:r.localize(11230,null)}}}function A(p){switch(p){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$pk=new u.$Tj("logLevel",y(m.Info))}),define(Se[226],De([1,0,18,7,13,4,31,3,16,69,11]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class S extends T.$Tc{constructor(P,w){super(),this.a=P,this.b=w,this.c=this.B(new R.$je),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$je),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new h.$Ah(0)),this.w=[],this.y=this.B(new h.$Ah(0))}watch(P,w){return w.recursive||this.b?.watcher?.forceUniversal?this.n(P,w):this.z(P,w)}n(P,w){const a={path:this.J(P),excludes:w.excludes,includes:w.includes,recursive:w.recursive,filter:w.filter,correlationId:w.correlationId},m=(0,r.$Sb)(this.j,a);return this.r(),(0,T.$Rc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(P=>(0,C.$Y)(P))}s(){this.h||(this.h=this.B(this.t(w=>this.c.fire((0,c.$6q)(w)),w=>this.G(w),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const P=this.b?.watcher?.recursive?.usePolling;if(P===!0)for(const w of this.j)(0,c.$2q)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(P))for(const w of this.j)(0,c.$2q)(w)&&P.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(P,w){const a={path:this.J(P),excludes:w.excludes,includes:w.includes,recursive:!1,filter:w.filter,correlationId:w.correlationId},m=(0,r.$Sb)(this.w,a);return this.C(),(0,T.$Rc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(P=>(0,C.$Y)(P))}D(){return this.u||(this.u=this.B(this.F(P=>this.c.fire((0,c.$6q)(P)),P=>this.G(P),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(P){P.type==="error"&&this.g.fire(P.message),this.H(P)}H(P){this.a[P.type](P.message)}I(P){return(0,b.$gc)(P.fsPath)}J(P){const w=this.I(P);return(0,L.$Eg)(w)}}e.$_q=S}),define(Se[227],De([1,0,44,7,28,21,4,31,3,16,10,22,105,33,8,27,219,226,224,223]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class s extends $.$_q{static{this.L=!1}constructor(o,n){super(o,n),this.onDidChangeCapabilities=L.Event.None,this.P=new C.$zc(d=>S.$7g.getComparisonKey(d)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=a.FileSystemProviderCapabilities.FileReadWrite|a.FileSystemProviderCapabilities.FileOpenReadWriteClose|a.FileSystemProviderCapabilities.FileReadStream|a.FileSystemProviderCapabilities.FileFolderCopy|a.FileSystemProviderCapabilities.FileWriteUnlock|a.FileSystemProviderCapabilities.FileAtomicRead|a.FileSystemProviderCapabilities.FileAtomicWrite|a.FileSystemProviderCapabilities.FileAtomicDelete|a.FileSystemProviderCapabilities.FileClone,I.$l&&(this.M|=a.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(o){try{const{stat:n,symbolicLink:d}=await P.SymlinkSupport.stat(this.I(o));return{type:this.O(n,d),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:a.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const n=await P.Promises.readdir(this.I(o),{withFileTypes:!0}),d=[];return await Promise.all(n.map(async l=>{try{let g;l.isSymbolicLink()?g=(await this.stat((0,S.$dh)(o,l.name))).type:g=this.O(l),d.push([l.name,g])}catch(g){this.a.trace(g)}})),d}catch(n){throw this.hb(n)}}O(o,n){let d;return n?.dangling?d=a.FileType.Unknown:o.isFile()?d=a.FileType.File:o.isDirectory()?d=a.FileType.Directory:d=a.FileType.Unknown,n&&(d|=a.FileType.SymbolicLink),d}async Q(o){const n=this.I(o);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let d;for(;d=this.P.get(o);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await d.wait();const l=new h.$Bh;return this.P.set(o,l),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,b.$Rc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(o)===l&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(o)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),l.open()})}async readFile(o,n){let d;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(o)})`),d=await this.Q(o));const l=this.I(o);return await r.promises.readFile(l)}catch(l){throw this.hb(l)}finally{d?.dispose()}}R(o){s.L&&this.a.trace(o)}readFileStream(o,n,d){const l=(0,u.$ze)(g=>R.$Le.concat(g.map(E=>R.$Le.wrap(E))).buffer);return(0,m.$Yq)(this,o,l,g=>g.buffer,{...n,bufferSize:256*1024},d),l}async writeFile(o,n,d){return d?.atomic!==!1&&d?.atomic?.postfix&&await this.S(o)?this.U(o,(0,S.$dh)((0,S.$ch)(o),`${(0,S.$ah)(o)}${d.atomic.postfix}`),n,d):this.W(o,n,d)}async S(o){try{const n=this.I(o),{symbolicLink:d}=await P.SymlinkSupport.stat(n);if(d)return!1}catch{}return!0}async U(o,n,d,l){const g=new b.$Sc;try{g.add(await this.Q(o)),g.add(await this.Q(n)),await this.W(n,d,l,!0);try{await this.rename(n,o,{overwrite:!0})}catch(E){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}finally{g.dispose()}}async W(o,n,d,l){let g;try{const E=this.I(o);if(!d.create||!d.overwrite){if(await P.Promises.exists(E)){if(!d.overwrite)throw(0,a.$kl)((0,w.localize)(11282,null),a.FileSystemProviderErrorCode.FileExists)}else if(!d.create)throw(0,a.$kl)((0,w.localize)(11283,null),a.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(o,{create:!0,unlock:d.unlock},l),await this.write(g,0,n,0,n.byteLength)}catch(E){throw await this.ib(o,E)}finally{typeof g=="number"&&await this.close(g)}}static{this.$=!0}static configureFlushOnWrite(o){s.$=o}async open(o,n,d){const l=this.I(o);let g;(0,a.$$k)(n)&&!d&&(g=await this.Q(o));let E;try{if((0,a.$$k)(n)&&n.unlock)try{const{stat:y}=await P.SymlinkSupport.stat(l);y.mode&128||await r.promises.chmod(l,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let D;if((0,a.$$k)(n)){if(I.$j)try{await r.promises.truncate(l,0),D="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}D||(D="w")}else D="r";E=await P.Promises.open(l,D)}catch(D){throw g?.dispose(),(0,a.$$k)(n)?await this.ib(o,D):this.hb(D)}if(this.X.set(E,0),(0,a.$$k)(n)&&this.Z.set(E,o),g){const D=this.Y.get(E);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${l})`),this.Y.set(E,g),D&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${l})`),D.dispose())}return E}async close(o){const n=this.Y.get(o);try{if(this.X.delete(o),this.Z.delete(o)&&s.$)try{await P.Promises.fdatasync(o)}catch(d){s.configureFlushOnWrite(!1),this.a.error(d)}return await P.Promises.close(o)}catch(d){throw this.hb(d)}finally{n&&(this.Y.get(o)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.Y.delete(o)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),n.dispose())}}async read(o,n,d,l,g){const E=this.ab(o,n);let D=null;try{D=(await P.Promises.read(o,d,l,g,E)).bytesRead}catch(y){throw this.hb(y)}finally{this.bb(o,E,D)}return D}ab(o,n){return n===this.X.get(o)?null:n}bb(o,n,d){const l=this.X.get(o);typeof l=="number"&&(typeof n=="number"||(typeof d=="number"?this.X.set(o,l+d):this.X.delete(o)))}async write(o,n,d,l,g){return(0,h.$Wh)(()=>this.cb(o,n,d,l,g),100,3)}async cb(o,n,d,l,g){const E=this.ab(o,n);let D=null;try{D=(await P.Promises.write(o,d,l,g,E)).bytesWritten}catch(y){throw await this.ib(this.Z.get(o),y)}finally{this.bb(o,E,D)}return D}async mkdir(o){try{await r.promises.mkdir(this.I(o))}catch(n){throw this.hb(n)}}async delete(o,n){try{const d=this.I(o);if(n.recursive){let l;n?.atomic!==!1&&n.atomic.postfix&&(l=(0,c.$ic)((0,c.$lc)(d),`${(0,c.$mc)(d)}${n.atomic.postfix}`)),await P.Promises.rm(d,P.RimRafMode.MOVE,l)}else try{await r.promises.unlink(d)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let g=!1;try{const{stat:E,symbolicLink:D}=await P.SymlinkSupport.stat(d);g=E.isDirectory()&&!D}catch{}if(g)await r.promises.rmdir(d);else throw l}else throw l}}catch(d){throw this.hb(d)}}async rename(o,n,d){const l=this.I(o),g=this.I(n);if(l!==g)try{await this.db(o,n,"move",d.overwrite),await P.Promises.rename(l,g)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,w.localize)(11284,null,(0,c.$mc)(l),(0,c.$mc)((0,c.$lc)(g)),E.toString()))),this.hb(E)}}async copy(o,n,d){const l=this.I(o),g=this.I(n);if(l!==g)try{await this.db(o,n,"copy",d.overwrite),await P.Promises.copy(l,g,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,w.localize)(11285,null,(0,c.$mc)(l),(0,c.$mc)((0,c.$lc)(g)),E.toString()))),this.hb(E)}}async db(o,n,d,l){const g=this.I(o),E=this.I(n);let D=!1;if(!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive)||(D=(0,T.$Ag)(g,E,!0)),D){if(d==="copy")throw(0,a.$kl)((0,w.localize)(11286,null),a.FileSystemProviderErrorCode.FileExists);if(d==="move")return}const k=await this.N(o);if(!k)throw(0,a.$kl)((0,w.localize)(11287,null),a.FileSystemProviderErrorCode.FileNotFound);const A=await this.N(n);if(A){if(!l)throw(0,a.$kl)((0,w.localize)(11288,null),a.FileSystemProviderErrorCode.FileExists);k.type&a.FileType.File&&A.type&a.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,n){return this.eb(o,n,!1)}async eb(o,n,d){const l=this.I(o),g=this.I(n),E=!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive);if((0,T.$Ag)(l,g,!E))return;const D=new b.$Sc;try{D.add(await this.Q(o)),D.add(await this.Q(n)),d&&await r.promises.mkdir((0,c.$lc)(g),{recursive:!0}),await r.promises.copyFile(l,g)}catch(y){if(y.code==="ENOENT"&&!d)return this.eb(o,n,!0);throw this.hb(y)}finally{D.dispose()}}t(o,n,d){return new f.$gr(l=>o(l),l=>n(l),d)}F(o,n,d){return new i.$pr(l=>o(l),l=>n(l),d)}hb(o){if(o instanceof a.$jl)return o;let n=o,d;switch(o.code){case"ENOENT":d=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":d=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":d=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":d=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":d=a.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,d=a.FileSystemProviderErrorCode.Unknown;break;default:d=a.FileSystemProviderErrorCode.Unknown}return(0,a.$kl)(n,d)}async ib(o,n){let d=this.hb(n);if(o&&d.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await P.SymlinkSupport.stat(this.I(o));l.mode&128||(d=(0,a.$kl)(n,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return d}}e.$qr=s}),define(Se[228],De([1,0,3,11]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CR=void 0;class C extends r.$Tc{constructor(L,T=[]){super(),this.a=new h.$hk([L,...T]),this.B(L.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...T){this.a.trace(L,...T)}debug(L,...T){this.a.debug(L,...T)}info(L,...T){this.a.info(L,...T)}warn(L,...T){this.a.warn(L,...T)}error(L,...T){this.a.error(L,...T)}flush(){this.a.flush()}}e.$CR=C}),define(Se[229],De([1,0,27,11]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rR=void 0;var C;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(C||(C={}));async function R(c,I,S,u,P){try{const w=await new Promise((m,$)=>{$e(["@vscode/spdlog"],m,$)}).then(Ue);w.setFlushOn(C.Trace);const a=await w.createAsyncRotatingLogger(c,I,S,u);return P?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(w){console.error(w)}return null}function L(c,I,S){switch(I){case h.LogLevel.Trace:c.trace(S);break;case h.LogLevel.Debug:c.debug(S);break;case h.LogLevel.Info:c.info(S);break;case h.LogLevel.Warning:c.warn(S);break;case h.LogLevel.Error:c.error(S);break;case h.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function T(c,I){switch(I){case h.LogLevel.Trace:c.setLevel(C.Trace);break;case h.LogLevel.Debug:c.setLevel(C.Debug);break;case h.LogLevel.Info:c.setLevel(C.Info);break;case h.LogLevel.Warning:c.setLevel(C.Warning);break;case h.LogLevel.Error:c.setLevel(C.Error);break;case h.LogLevel.Off:c.setLevel(C.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class b extends h.$dk{constructor(I,S,u,P,w){super(),this.m=[],this.setLevel(w),this.n=this.s(I,S,u,P),this.B(this.onDidChangeLogLevel(a=>{this.r&&T(this.r,a)}))}async s(I,S,u,P){const w=u?6:1,a=30/w*r.$Fl.MB,m=await R(I,S,a,w,P);if(m){this.r=m,T(this.r,this.getLevel());for(const{level:$,message:f}of this.m)L(this.r,$,f);this.m=[]}}g(I,S){this.r?L(this.r,I,S):this.getLevel()<=I&&this.m.push({level:I,message:S})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$rR=b});var Wt=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Se[145],De([1,0,43,8,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Du=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,r=Wt(r);var R;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var L;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(b){function c(w,a){return a-w}b.compare=c;const I=Object.create(null);I[b.Error]=(0,h.localize)(11222,null),I[b.Warning]=(0,h.localize)(11223,null),I[b.Info]=(0,h.localize)(11224,null);function S(w){return I[w]||""}b.toString=S;function u(w){switch(w){case r.default.Error:return b.Error;case r.default.Warning:return b.Warning;case r.default.Info:return b.Info;case r.default.Ignore:return b.Hint}}b.fromSeverity=u;function P(w){switch(w){case b.Error:return r.default.Error;case b.Warning:return r.default.Warning;case b.Info:return r.default.Info;case b.Hint:return r.default.Ignore}}b.toSeverity=P}(L||(e.MarkerSeverity=L={}));var T;(function(b){const c="";function I(u){return S(u,!0)}b.makeKey=I;function S(u,P){const w=[c];return u.source?w.push(u.source.replace("\xA6","\\\xA6")):w.push(c),u.code?typeof u.code=="string"?w.push(u.code.replace("\xA6","\\\xA6")):w.push(u.code.value.replace("\xA6","\\\xA6")):w.push(c),u.severity!==void 0&&u.severity!==null?w.push(L.toString(u.severity)):w.push(c),u.message&&P?w.push(u.message.replace("\xA6","\\\xA6")):w.push(c),u.startLineNumber!==void 0&&u.startLineNumber!==null?w.push(u.startLineNumber.toString()):w.push(c),u.startColumn!==void 0&&u.startColumn!==null?w.push(u.startColumn.toString()):w.push(c),u.endLineNumber!==void 0&&u.endLineNumber!==null?w.push(u.endLineNumber.toString()):w.push(c),u.endColumn!==void 0&&u.endColumn!==null?w.push(u.endColumn.toString()):w.push(c),w.push(c),w.join("\xA6")}b.makeKeyOptionalMessage=S})(T||(e.IMarkerData=T={})),e.$Du=(0,C.$Ci)("markerService")});var Wt=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Se[230],De([1,0,4,43,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$qw=e.Severity=void 0,e.$rw=T,h=Wt(h),e.Severity=h.default,e.$qw=(0,C.$Ci)("notificationService");var R;(function(S){S[S.DEFAULT=0]="DEFAULT",S[S.SILENT=1]="SILENT",S[S.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var L;(function(S){S[S.WORKSPACE=0]="WORKSPACE",S[S.PROFILE=1]="PROFILE",S[S.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function T(S){if(S){const u=S;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var b;(function(S){S[S.OFF=0]="OFF",S[S.ERROR=1]="ERROR"})(b||(e.NotificationsFilter=b={}));class c{constructor(){this.progress=new I,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$sw=c;class I{infinite(){}done(){}total(u){}worked(u){}}e.$tw=I}),define(Se[231],De([1,0,55]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.context<"u"){const R=C.context.configuration();if(R)h=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,r.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:R.version})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(Se[115],De([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$qk=(0,r.$Ci)("productService"),e.$rk="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function($e,e){return function(r,h){e(r,h,$e)}};define(Se[89],De([1,0,7,20,3,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aw=e.$zw=e.$yw=e.$xw=e.$ww=e.$vw=e.ProgressLocation=e.$uw=void 0,e.$uw=(0,R.$Ci)("progressService");var L;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$vw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$ww=T;class b{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const P=this.d;this.d=()=>{P?.(),u()}}):Promise.resolve()}}e.$xw=b;let c=class extends C.$Tc{constructor(u,P){super(),this.a=new r.$Zh,P.withProgress(u,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,C.$Rc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$yw=c,e.$yw=c=Ye([Ve(1,e.$uw)],c);class I extends C.$Tc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new C.$Sc)}start(u){this.stop();const P=++this.a,w=new h.$ue;return this.f=setTimeout(()=>{P===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,C.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Rc)(()=>w.cancel())),this.b.add((0,C.$Rc)(()=>this.c?this.c.done():void 0)),{id:P,token:w.token,stop:()=>this.h(P),isCurrent:()=>this.a===P}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$zw=I,e.$Aw=(0,R.$Ci)("editorProgressService")}),define(Se[36],De([1,0,65,17]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,r=Ue(r),h=Ue(h);class C{constructor(){this.a=new Map}add(L,T){r.ok(h.$cg(L)),r.ok(h.$eg(T)),r.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,T)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$oo=new C}),define(Se[116],De([1,0,4,177,36]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,C=Ue(C),e.$po={JSONContribution:"base.contributions.json"};function R(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class L{constructor(){this.b=new r.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,I){this.a[R(c)]=I,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(c){const I=this.a[c];return I?(0,h.$5j)(I):void 0}hasSchemaContent(c){return!!this.a[c]}}const T=new L;C.$oo.add(e.$po.JSONContribution,T)}),define(Se[70],De([1,0,18,4,17,8,45,116,36]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.ConfigurationScope=e.$to=e.EditPresentationTypes=void 0,e.$Eo=a,e.$Fo=m,e.$Go=$,e.$Ho=i,e.$Io=s,e.$Jo=t,e.$Ko=o,C=Ue(C),R=Ue(R);var c;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$to={Configuration:"base.contributions.configuration"};var I;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao="vscode://schemas/settings/resourceLanguage",e.$Bo="vscode://schemas/settings/configurationDefaults";const S=b.$oo.as(T.$po.JSONContribution);class u{constructor(){this.a=[],this.i=new Set,this.j=new h.$je,this.onDidSchemaChange=this.j.event,this.k=new h.$je,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:R.localize(11518,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},S.registerSchema(e.$Ao,this.h),this.z()}registerConfiguration(d,l=!0){this.registerConfigurations([d],l)}registerConfigurations(d,l=!0){const g=new Set;this.r(d,l,g),S.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:g})}deregisterConfigurations(d){const l=new Set;this.s(d,l),S.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:l})}updateConfigurations({add:d,remove:l}){const g=new Set;this.s(l,g),this.r(d,!1,g),S.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:g})}registerDefaultConfigurations(d){const l=new Set;this.l(d,l),this.j.fire(),this.k.fire({properties:l,defaultsOverrides:!0})}l(d,l){this.a.push(...d);const g=[];for(const{overrides:E,source:D}of d)for(const y in E){l.add(y);const k=this.b.get(y)??this.b.set(y,{configurationDefaultOverrides:[]}).get(y),A=E[y];if(k.configurationDefaultOverrides.push({value:A,source:D}),e.$Do.test(y)){const p=this.o(y,A,D,k.configurationDefaultOverrideValue);if(!p)continue;k.configurationDefaultOverrideValue=p,this.n(y,p,D),g.push(...a(y))}else{const p=this.p(y,A,D,k.configurationDefaultOverrideValue);if(!p)continue;k.configurationDefaultOverrideValue=p;const v=this.e[y];v&&(this.A(y,v),this.w(y,v))}}this.q(g)}deregisterDefaultConfigurations(d){const l=new Set;this.m(d,l),this.j.fire(),this.k.fire({properties:l,defaultsOverrides:!0})}m(d,l){for(const g of d){const E=this.a.indexOf(g);E!==-1&&this.a.splice(E,1)}for(const{overrides:g,source:E}of d)for(const D in g){const y=this.b.get(D);if(!y)continue;const k=y.configurationDefaultOverrides.findIndex(A=>E?A.source?.id===E.id:A.value===g[D]);if(k!==-1){if(y.configurationDefaultOverrides.splice(k,1),y.configurationDefaultOverrides.length===0&&this.b.delete(D),e.$Do.test(D)){let A;for(const p of y.configurationDefaultOverrides)A=this.o(D,p.value,p.source,A);A&&!C.$pg(A.value)?(y.configurationDefaultOverrideValue=A,this.n(D,A,E)):(this.b.delete(D),delete this.e[D],delete this.c.properties[D])}else{let A;for(const v of y.configurationDefaultOverrides)A=this.p(D,v.value,v.source,A);y.configurationDefaultOverrideValue=A;const p=this.e[D];p&&(this.A(D,p),this.w(D,p))}l.add(D)}}this.y()}n(d,l,g){const E={type:"object",default:l.value,description:R.localize(11519,null,(0,L.$gj)(d)),$ref:e.$Ao,defaultDefaultValue:l.value,source:g,defaultValueSource:g};this.e[d]=E,this.c.properties[d]=E}o(d,l,g,E){const D=E?.value||{},y=E?.source??new Map;if(!(y instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const k of Object.keys(l)){const A=l[k];if(C.$eg(A)&&(C.$jg(D[k])||C.$eg(D[k]))){if(D[k]={...D[k]??{},...A},g)for(const v in A)y.set(`${k}.${v}`,g)}else D[k]=A,g?y.set(k,g):y.delete(k)}return{value:D,source:y}}p(d,l,g,E){const D=this.e[d],y=E?.value??D?.defaultDefaultValue;let k=g;if(C.$eg(l)&&(D!==void 0&&D.type==="object"||D===void 0&&(C.$jg(y)||C.$eg(y)))){if(k=E?.source??new Map,!(k instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const p in l)g&&k.set(`${d}.${p}`,g);l={...C.$eg(y)?y:{},...l}}return{value:l,source:k}}deltaConfiguration(d){let l=!1;const g=new Set;d.removedDefaults&&(this.m(d.removedDefaults,g),l=!0),d.addedDefaults&&(this.l(d.addedDefaults,g),l=!0),d.removedConfigurations&&this.s(d.removedConfigurations,g),d.addedConfigurations&&this.r(d.addedConfigurations,!1,g),this.j.fire(),this.k.fire({properties:g,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...d){this.j.fire()}registerOverrideIdentifiers(d){this.q(d),this.j.fire()}q(d){for(const l of d)this.i.add(l);this.y()}r(d,l,g){d.forEach(E=>{this.u(E,l,E.extensionInfo,E.restrictedProperties,void 0,g),this.d.push(E),this.v(E)})}s(d,l){const g=E=>{if(E.properties)for(const D in E.properties){l.add(D);const y=this.e[D];y?.policy?.name&&this.f.delete(y.policy.name),delete this.e[D],this.x(D,E.properties[D])}E.allOf?.forEach(D=>g(D))};for(const E of d){g(E);const D=this.d.indexOf(E);D!==-1&&this.d.splice(D,1)}}u(d,l=!0,g,E,D=I.WINDOW,y){D=C.$lg(d.scope)?D:d.scope;const k=d.properties;if(k)for(const p in k){const v=k[p];if(l&&i(p,v)){delete k[p];continue}if(v.source=g,v.defaultDefaultValue=k[p].default,this.A(p,v),e.$Do.test(p)?v.scope=void 0:(v.scope=C.$lg(v.scope)?D:v.scope,v.restricted=C.$lg(v.restricted)?!!E?.includes(p):v.restricted),k[p].hasOwnProperty("included")&&!k[p].included){this.g[p]=k[p],delete k[p];continue}else this.e[p]=k[p],k[p].policy?.name&&this.f.set(k[p].policy.name,p);!k[p].deprecationMessage&&k[p].markdownDeprecationMessage&&(k[p].deprecationMessage=k[p].markdownDeprecationMessage),y.add(p)}const A=d.allOf;if(A)for(const p of A)this.u(p,l,g,E,D,y)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const d=new Map;for(const[l,g]of this.b)g.configurationDefaultOverrideValue&&d.set(l,g.configurationDefaultOverrideValue);return d}v(d){const l=g=>{const E=g.properties;if(E)for(const y in E)this.w(y,E[y]);g.allOf?.forEach(l)};l(d)}w(d,l){switch(e.$uo.properties[d]=l,l.scope){case I.APPLICATION:e.$vo.properties[d]=l;break;case I.MACHINE:e.$wo.properties[d]=l;break;case I.MACHINE_OVERRIDABLE:e.$xo.properties[d]=l;break;case I.WINDOW:e.$yo.properties[d]=l;break;case I.RESOURCE:e.$zo.properties[d]=l;break;case I.LANGUAGE_OVERRIDABLE:e.$zo.properties[d]=l,this.h.properties[d]=l;break}}x(d,l){switch(delete e.$uo.properties[d],l.scope){case I.APPLICATION:delete e.$vo.properties[d];break;case I.MACHINE:delete e.$wo.properties[d];break;case I.MACHINE_OVERRIDABLE:delete e.$xo.properties[d];break;case I.WINDOW:delete e.$yo.properties[d];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$zo.properties[d],delete this.h.properties[d];break}}y(){for(const d of this.i.values()){const l=`[${d}]`,g={type:"object",description:R.localize(11520,null),errorMessage:R.localize(11521,null),$ref:e.$Ao};this.A(l,g),e.$uo.properties[l]=g,e.$vo.properties[l]=g,e.$wo.properties[l]=g,e.$xo.properties[l]=g,e.$yo.properties[l]=g,e.$zo.properties[l]=g}}z(){const d={type:"object",description:R.localize(11522,null),errorMessage:R.localize(11523,null),$ref:e.$Ao};e.$uo.patternProperties[e.$Co]=d,e.$vo.patternProperties[e.$Co]=d,e.$wo.patternProperties[e.$Co]=d,e.$xo.patternProperties[e.$Co]=d,e.$yo.patternProperties[e.$Co]=d,e.$zo.patternProperties[e.$Co]=d,this.j.fire()}A(d,l){const g=this.b.get(d)?.configurationDefaultOverrideValue;let E,D;g&&(!l.disallowConfigurationDefault||!g.source)&&(E=g.value,D=g.source),C.$jg(E)&&(E=l.defaultDefaultValue,D=void 0),C.$jg(E)&&(E=$(l.type)),l.default=E,l.defaultValueSource=D}}const P="\\[([^\\]]+)\\]",w=new RegExp(P,"g");e.$Co=`^(${P})+$`,e.$Do=new RegExp(e.$Co);function a(n){const d=[];if(e.$Do.test(n)){let l=w.exec(n);for(;l?.length;){const g=l[1].trim();g&&d.push(g),l=w.exec(n)}}return(0,r.$Lb)(d)}function m(n){return n.reduce((d,l)=>`${d}[${l}]`,"")}function $(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const f=new u;b.$oo.add(e.$to.Configuration,f);function i(n,d){return n.trim()?e.$Do.test(n)?R.localize(11525,null,n):f.getConfigurationProperties()[n]!==void 0?R.localize(11526,null,n):d.policy?.name&&f.getPolicyConfigurations().get(d.policy?.name)!==void 0?R.localize(11527,null,n,d.policy?.name,f.getPolicyConfigurations().get(d.policy?.name)):null:R.localize(11524,null)}function s(){const n=[],d=f.getConfigurationProperties();for(const l of Object.keys(d))n.push([l,d[l].scope]);return n.push(["launch",I.RESOURCE]),n.push(["task",I.RESOURCE]),n}function t(n){const d={};for(const l of n){const g=l.properties;if(C.$eg(g))for(const E in g)d[E]=g[E];l.allOf&&Object.assign(d,t(l.allOf))}return d}function o(n){switch(n){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(Se[232],De([1,0,18,4,176,3,28,24,17,2,45,70,27,36]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0,e.$Po=s,r=Ue(r),C=Ue(C),T=Ue(T),b=Ue(b);function w(d){return Object.isFrozen(d)?d:T.$co(d)}class a{static createEmptyModel(l){return new a({},[],[],void 0,l)}constructor(l,g,E,D,y){this.b=l,this.c=g,this.d=E,this.raw=D,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const l=this.raw.map(g=>{if(g instanceof a)return g;const E=new m("",this.f);return E.parseRaw(g),E.configurationModel});this.g=l.reduce((g,E)=>E===g?E:g.merge(E),l[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(l){return l?(0,I.$ej)(this.contents,l):this.contents}inspect(l,g){const E=this;return{get value(){return w(E.rawConfiguration.getValue(l))},get override(){return g?w(E.rawConfiguration.getOverrideValue(l,g)):void 0},get merged(){return w(g?E.rawConfiguration.override(g).getValue(l):E.rawConfiguration.getValue(l))},get overrides(){const D=[];for(const{contents:y,identifiers:k,keys:A}of E.rawConfiguration.overrides){const p=new a(y,A,[],void 0,E.f).getValue(l);p!==void 0&&D.push({identifiers:k,value:p})}return D.length?w(D):void 0}}}getOverrideValue(l,g){const E=this.j(g);return E?l?(0,I.$ej)(E,l):E:void 0}getKeysForOverrideIdentifier(l){const g=[];for(const E of this.overrides)E.identifiers.includes(l)&&g.push(...E.keys);return r.$Lb(g)}getAllOverrideIdentifiers(){const l=[];for(const g of this.overrides)l.push(...g.identifiers);return r.$Lb(l)}override(l){let g=this.a.get(l);return g||(g=this.h(l),this.a.set(l,g)),g}merge(...l){const g=T.$bo(this.contents),E=T.$bo(this.overrides),D=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const k of l)if(y.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.i(g,k.contents);for(const A of k.overrides){const[p]=E.filter(v=>r.$tb(v.identifiers,A.identifiers));p?(this.i(p.contents,A.contents),p.keys.push(...A.keys),p.keys=r.$Lb(p.keys)):E.push(T.$bo(A))}for(const A of k.keys)D.indexOf(A)===-1&&D.push(A)}return new a(g,D,E,y.every(k=>k instanceof a)?void 0:y,this.f)}h(l){const g=this.j(l);if(!g||typeof g!="object"||!Object.keys(g).length)return this;const E={};for(const D of r.$Lb([...Object.keys(this.contents),...Object.keys(g)])){let y=this.contents[D];const k=g[D];k&&(typeof y=="object"&&typeof k=="object"?(y=T.$bo(y),this.i(y,k)):y=k),E[D]=y}return new a(E,this.keys,this.overrides,void 0,this.f)}i(l,g){for(const E of Object.keys(g)){if(E in l&&b.$eg(l[E])&&b.$eg(g[E])){this.i(l[E],g[E]);continue}l[E]=T.$bo(g[E])}}j(l){let g=null,E=null;const D=y=>{y&&(E?this.i(E,y):E=T.$bo(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===l?g=y.contents:y.identifiers.includes(l)&&D(y.contents);return D(g),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,g){this.k(l,g,!0)}setValue(l,g){this.k(l,g,!1)}removeValue(l){const g=this.keys.indexOf(l);g!==-1&&(this.keys.splice(g,1),(0,I.$dj)(this.contents,l),S.$Do.test(l)&&this.overrides.splice(this.overrides.findIndex(E=>r.$tb(E.identifiers,(0,S.$Eo)(l))),1))}k(l,g,E){if((0,I.$cj)(this.contents,l,g,D=>this.f.error(D)),E=E||this.keys.indexOf(l)===-1,E&&this.keys.push(l),S.$Do.test(l)){const D=(0,S.$Eo)(l),y={identifiers:D,keys:Object.keys(this.contents[l]),contents:(0,I.$bj)(this.contents[l],A=>this.f.error(A))},k=this.overrides.findIndex(A=>r.$tb(A.identifiers,D));k!==-1?this.overrides[k]=y:this.overrides.push(y)}}}e.$Lo=a;class m{constructor(l,g){this.f=l,this.g=g,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||a.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(l,g){if(!b.$lg(l)){const E=this.h(l);this.parseRaw(E,g)}}reparse(l){this.a&&this.parseRaw(this.a,l)}parseRaw(l,g){this.a=l;const{contents:E,keys:D,overrides:y,restricted:k,hasExcludedProperties:A}=this.i(l,g);this.b=new a(E,D,y,A?[l]:void 0,this.g),this.c=k||[]}h(l){let g={},E=null,D=[];const y=[],k=[];function A(v){Array.isArray(D)?D.push(v):E!==null&&(D[E]=v)}const p={onObjectBegin:()=>{const v={};A(v),y.push(D),D=v,E=null},onObjectProperty:v=>{E=v},onObjectEnd:()=>{D=y.pop()},onArrayBegin:()=>{const v=[];A(v),y.push(D),D=v,E=null},onArrayEnd:()=>{D=y.pop()},onLiteralValue:A,onError:(v,F,N)=>{k.push({error:v,offset:F,length:N})}};if(l)try{C.$3n(l,p),g=D[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return g}i(l,g){const E=P.$oo.as(S.$to.Configuration).getConfigurationProperties(),D=this.j(l,E,!0,g);l=D.raw;const y=(0,I.$bj)(l,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`)),k=Object.keys(l),A=this.l(l,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:y,keys:k,overrides:A,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(l,g,E,D){let y=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:y};const k={},A=[];for(const p in l)if(S.$Do.test(p)&&E){const v=this.j(l[p],g,!1,D);k[p]=v.raw,y=y||v.hasExcludedProperties,A.push(...v.restricted)}else{const v=g[p],F=v?typeof v.scope<"u"?v.scope:S.ConfigurationScope.WINDOW:void 0;v?.restricted&&A.push(p),!D.exclude?.includes(p)&&(D.include?.includes(p)||(F===void 0||D.scopes===void 0||D.scopes.includes(F))&&!(D.skipRestricted&&v?.restricted))?k[p]=l[p]:y=!0}return{raw:k,restricted:A,hasExcludedProperties:y}}l(l,g){const E=[];for(const D of Object.keys(l))if(S.$Do.test(D)){const y={};for(const k in l[D])y[k]=l[D][k];E.push({identifiers:(0,S.$Eo)(D),keys:Object.keys(y),contents:(0,I.$bj)(y,g)})}return E}}e.$Mo=m;class $ extends R.$Tc{constructor(l,g,E,D,y){super(),this.c=l,this.f=g,this.g=D,this.h=y,this.b=this.B(new h.$je),this.onDidChange=this.b.event,this.a=new m(this.c.toString(),y),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(h.Event.any(h.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),h.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(u.FileOperation.CREATE)||k.isOperation(u.FileOperation.COPY)||k.isOperation(u.FileOperation.DELETE)||k.isOperation(u.FileOperation.WRITE))&&E.isEqual(k.resource,l)))(()=>this.b.fire()))}async loadConfiguration(){try{const l=await this.g.readFile(this.c);return this.a.parse(l.value.toString()||"{}",this.f),this.a.configurationModel}catch{return a.createEmptyModel(this.h)}}reparse(l){return l&&(this.f=l),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$No=$;class f{constructor(l,g,E,D,y,k,A,p,v,F,N,O,j){this.a=l,this.b=g,this.c=E,this.overrideIdentifiers=D,this.d=y,this.f=k,this.g=A,this.h=p,this.i=v,this.j=F,this.k=N,this.l=O,this.m=j}get value(){return w(this.c)}n(l){return l?.value!==void 0||l?.override!==void 0||l?.overrides!==void 0?l:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(l,g,E,D,y,k,A,p,v,F){this.j=l,this.l=g,this.m=E,this.n=D,this.p=y,this.q=k,this.r=A,this.s=p,this.t=v,this.u=F,this.h=null,this.i=new L.$zc,this.v=null}getValue(l,g,E){return this.w(l,g,E).getValue(l)}updateValue(l,g,E={}){let D;E.resource?(D=this.t.get(E.resource),D||(D=a.createEmptyModel(this.u),this.t.set(E.resource,D))):D=this.s,g===void 0?D.removeValue(l):D.setValue(l,g),E.resource||(this.h=null)}inspect(l,g,E){const D=this.w(l,g,E),y=this.A(g.resource,E),k=g.resource?this.t.get(g.resource)||this.s:this.s,A=new Set;for(const p of D.overrides)for(const v of p.identifiers)D.getOverrideValue(l,v)!==void 0&&A.add(v);return new f(l,g,D.getValue(l),A.size?[...A]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.q:void 0,y||void 0,k)}keys(l){const g=this.A(void 0,l);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:g?g.keys.slice(0):[]}}updateDefaultConfiguration(l){this.j=l,this.h=null,this.i.clear()}updatePolicyConfiguration(l){this.l=l}updateApplicationConfiguration(l){this.m=l,this.h=null,this.i.clear()}updateLocalUserConfiguration(l){this.n=l,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(l){this.p=l,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(l){this.q=l,this.h=null,this.i.clear()}updateFolderConfiguration(l,g){this.r.set(l,g),this.i.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this.i.delete(l)}compareAndUpdateDefaultConfiguration(l,g){const E=[];if(!g){const{added:D,updated:y,removed:k}=o(this.j,l);g=[...D,...y,...k]}for(const D of g)for(const y of(0,S.$Eo)(D)){const k=this.j.getKeysForOverrideIdentifier(y),A=l.getKeysForOverrideIdentifier(y),p=[...A.filter(v=>k.indexOf(v)===-1),...k.filter(v=>A.indexOf(v)===-1),...k.filter(v=>!T.$fo(this.j.override(y).getValue(v),l.override(y).getValue(v)))];E.push([y,p])}return this.updateDefaultConfiguration(l),{keys:g,overrides:E}}compareAndUpdatePolicyConfiguration(l){const{added:g,updated:E,removed:D}=o(this.l,l),y=[...g,...E,...D];return y.length&&this.updatePolicyConfiguration(l),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:g,updated:E,removed:D,overrides:y}=o(this.applicationConfiguration,l),k=[...g,...E,...D];return k.length&&this.updateApplicationConfiguration(l),{keys:k,overrides:y}}compareAndUpdateLocalUserConfiguration(l){const{added:g,updated:E,removed:D,overrides:y}=o(this.localUserConfiguration,l),k=[...g,...E,...D];return k.length&&this.updateLocalUserConfiguration(l),{keys:k,overrides:y}}compareAndUpdateRemoteUserConfiguration(l){const{added:g,updated:E,removed:D,overrides:y}=o(this.remoteUserConfiguration,l),k=[...g,...E,...D];return k.length&&this.updateRemoteUserConfiguration(l),{keys:k,overrides:y}}compareAndUpdateWorkspaceConfiguration(l){const{added:g,updated:E,removed:D,overrides:y}=o(this.workspaceConfiguration,l),k=[...g,...E,...D];return k.length&&this.updateWorkspaceConfiguration(l),{keys:k,overrides:y}}compareAndUpdateFolderConfiguration(l,g){const E=this.folderConfigurations.get(l),{added:D,updated:y,removed:k,overrides:A}=o(E,g),p=[...D,...y,...k];return(p.length||!E)&&this.updateFolderConfiguration(l,g),{keys:p,overrides:A}}compareAndDeleteFolderConfiguration(l){const g=this.folderConfigurations.get(l);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:E,updated:D,removed:y,overrides:k}=o(g,void 0);return{keys:[...E,...D,...y],overrides:k}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(l,g,E){let D=this.x(g,E);return g.overrideIdentifier&&(D=D.override(g.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(l)!==void 0&&(D=D.merge(this.l)),D}x({resource:l},g){let E=this.y();if(g&&l){const D=g.getFolder(l);D&&(E=this.z(D.uri)||E);const y=this.t.get(l);y&&(E=E.merge(y))}return E}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(l){let g=this.i.get(l);if(!g){const E=this.y(),D=this.r.get(l);D?(g=E.merge(D),this.i.set(l,g)):g=E}return g}A(l,g){if(g&&l){const E=g.getFolder(l);if(E)return this.r.get(E.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((l,g)=>{const{contents:E,overrides:D,keys:y}=this.r.get(g);return l.push([g,{contents:E,overrides:D,keys:y}]),l},[])}}allKeys(){const l=new Set;return this.j.keys.forEach(g=>l.add(g)),this.userConfiguration.keys.forEach(g=>l.add(g)),this.q.keys.forEach(g=>l.add(g)),this.r.forEach(g=>g.keys.forEach(E=>l.add(E))),[...l.values()]}B(){const l=new Set;return this.j.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.userConfiguration.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.q.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.r.forEach(g=>g.getAllOverrideIdentifiers().forEach(E=>l.add(E))),[...l.values()]}D(l){const g=new Set;return this.j.getKeysForOverrideIdentifier(l).forEach(E=>g.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(E=>g.add(E)),this.q.getKeysForOverrideIdentifier(l).forEach(E=>g.add(E)),this.r.forEach(E=>E.getKeysForOverrideIdentifier(l).forEach(D=>g.add(D))),[...g.values()]}static parse(l,g){const E=this.E(l.defaults,g),D=this.E(l.policy,g),y=this.E(l.application,g),k=this.E(l.user,g),A=this.E(l.workspace,g),p=l.folders.reduce((v,F)=>(v.set(c.URI.revive(F[0]),this.E(F[1],g)),v),new L.$zc);return new i(E,D,y,k,a.createEmptyModel(g),A,p,a.createEmptyModel(g),new L.$zc,g)}static E(l,g){return new a(l.contents,l.keys,l.overrides,void 0,g)}}e.$Oo=i;function s(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const l=new Set,g=new Map;for(const D of d)D.keys.forEach(y=>l.add(y)),D.overrides.forEach(([y,k])=>{const A=(0,L.$wc)(g,y,new Set);k.forEach(p=>A.add(p))});const E=[];return g.forEach((D,y)=>E.push([y,[...D.values()]])),{keys:[...l.values()],overrides:E}}class t{constructor(l,g,E,D,y){this.change=l,this.f=g,this.g=E,this.h=D,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const k of l.keys)this.affectedKeys.add(k);for(const[,k]of l.overrides)for(const A of k)this.affectedKeys.add(A);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(l,g){const E=this.a+l,D=this.d.indexOf(E);if(D<0)return!1;const y=D+E.length;if(y>=this.d.length)return!1;const k=this.d.charCodeAt(y);if(k!==this.b&&k!==this.c)return!1;if(g){const A=this.previousConfiguration?this.previousConfiguration.getValue(l,g,this.f?.workspace):void 0,p=this.g.getValue(l,g,this.h);return!T.$fo(A,p)}return!0}}e.$Qo=t;function o(d,l){const{added:g,removed:E,updated:D}=n(l?.rawConfiguration,d?.rawConfiguration),y=[],k=d?.getAllOverrideIdentifiers()||[],A=l?.getAllOverrideIdentifiers()||[];if(l){const p=A.filter(v=>!k.includes(v));for(const v of p)y.push([v,l.getKeysForOverrideIdentifier(v)])}if(d){const p=k.filter(v=>!A.includes(v));for(const v of p)y.push([v,d.getKeysForOverrideIdentifier(v)])}if(l&&d){for(const p of k)if(A.includes(p)){const v=n({contents:d.getOverrideValue(void 0,p)||{},keys:d.getKeysForOverrideIdentifier(p)},{contents:l.getOverrideValue(void 0,p)||{},keys:l.getKeysForOverrideIdentifier(p)});y.push([p,[...v.added,...v.removed,...v.updated]])}}return{added:g,removed:E,updated:D,overrides:y}}function n(d,l){const g=d?l?d.keys.filter(y=>l.keys.indexOf(y)===-1):[...d.keys]:[],E=l?d?l.keys.filter(y=>d.keys.indexOf(y)===-1):[...l.keys]:[],D=[];if(d&&l){for(const y of l.keys)if(d.keys.indexOf(y)!==-1){const k=(0,I.$ej)(l.contents,y),A=(0,I.$ej)(d.contents,y);T.$fo(k,A)||D.push(y)}}return{added:g,removed:E,updated:D}}}),define(Se[233],De([1,0,21,4,3,68]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$txb=e.$rxb=e.$qxb=void 0,e.$sxb=T;const L=(c,I,S)=>{const u=new Uint8Array(16);for(let a=0;a<16;a++)u[a]=Math.round(Math.random()*256);const P=(0,r.$6e)(r.$Le.wrap(u));return[`GET ws://localhost${c}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`].join(`\r
`)+`\r
\r
`};e.$qxb=L,e.$rxb=r.$Le.fromString(`\r
\r
`);async function T(c,I,S,u,P){c.write(r.$Le.fromString((0,e.$qxb)(I,S,u)));const w=new C.$Sc;try{return await new Promise((a,m)=>{let $;w.add(c.onData(f=>{$?$=r.$Le.concat([$,f],$.byteLength+f.byteLength):$=f;const i=$.indexOf(e.$rxb);if(i===-1)return;a(c),c.pauseData();const s=$.slice(i+e.$rxb.byteLength);s.byteLength&&P.onData.fire(s)})),w.add(c.onClose(f=>m(f??new Error("socket closed")))),w.add(c.onEnd(()=>m(new Error("socket ended"))))})}catch(a){throw c.dispose(),a}finally{w.dispose()}}class b extends C.$Tc{constructor(I,S){super(),this.g=I,this.a=this.B(new h.$me),this.onData=(...u)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...u)),this.b=this.B(new h.$je),this.onDidDispose=this.b.event,this.f=!1,this.B(S.onData),this.B(S.onData.event(u=>this.a.fire(u))),this.onClose=this.B(S.onClose).event,this.onEnd=this.B(S.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,S){R.SocketDiagnostics.traceSocketEvent(this,this.g,I,S)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$txb=b}),define(Se[71],De([1,0,13,5]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.RemoteAuthorityResolverErrorCode=e.$Ql=e.$Pl=e.RemoteConnectionType=e.$Ol=void 0,e.$Sl=c,e.$Ol=(0,h.$Ci)("remoteAuthorityResolverService");var C;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class R{constructor(S){this.id=S,this.type=C.Managed}toString(){return`Managed(${this.id})`}}e.$Pl=R;class L{constructor(S,u){this.host=S,this.port=u,this.type=C.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ql=L;var T;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class b extends r.$ab{static isNotAvailable(S){return S instanceof b&&S._code===T.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof b&&S._code===T.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof b&&S._code===T.NoResolverFound}static isInvalidAuthority(S){return S instanceof b&&S._code===T.InvalidAuthority}static isHandled(S){return S instanceof b&&S.isHandled}constructor(S,u=T.Unknown,P){super(S),this._message=S,this._code=u,this._detail=P,this.isHandled=u===T.NotAvailable&&P===!0,Object.setPrototypeOf(this,b.prototype)}}e.$Rl=b;function c(I){const S=I.indexOf("+");return S===-1?I:I.substring(0,S)}}),define(Se[234],De([1,0,7,21,20,13,4,3,14,61,42,32,68,71]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Xl=y,e.$Yl=k,e.$Zl=p,c=Ue(c);const w=30*1e3;var a;(function(me){me[me.Management=1]="Management",me[me.ExtensionHost=2]="ExtensionHost",me[me.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function m(me){switch(me){case a.Management:return"Management";case a.ExtensionHost:return"ExtensionHost";case a.Tunnel:return"Tunnel"}}function $(me){const J=new C.$ue;return setTimeout(()=>J.cancel(),me),J.token}function f(me,J){if(me.isCancellationRequested||J.isCancellationRequested)return C.CancellationToken.Cancelled;const U=new C.$ue;return me.onCancellationRequested(()=>U.cancel()),J.onCancellationRequested(()=>U.cancel()),U.token}class i{get didTimeout(){return this.c==="timedout"}constructor(J){this.c="pending",this.d=new T.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,r.$vh)(),J.isCancellationRequested?this.h():this.d.add(J.onCancellationRequested(()=>this.h()))}registerDisposable(J){this.c==="pending"?this.d.add(J):J.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const J=new Error("Time limit reached");return J.code="ETIMEDOUT",J.syscall="connect",J}resolve(J){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(J))}reject(J){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(J))}}function s(me,J){const U=new i(J);return U.registerDisposable(me.onControlMessage(se=>{const ae=JSON.parse(se.toString()),te=K(ae);te?U.reject(te):U.resolve(ae)})),U.promise}function t(me,J,U,se,ae,te,ce,le){const x=new i(le),oe=I.$de.create(!1);return me.info(`Creating a socket (${ce})...`),c.mark(`code/willCreateSocket/${te}`),J.connect(U,se,ae,ce).then(pe=>{x.didTimeout?(c.mark(`code/didCreateSocketError/${te}`),me.info(`Creating a socket (${ce}) finished after ${oe.elapsed()} ms, but this is too late and has timed out already.`),pe?.dispose()):(c.mark(`code/didCreateSocketOK/${te}`),me.info(`Creating a socket (${ce}) was successful after ${oe.elapsed()} ms.`),x.resolve(pe))},pe=>{c.mark(`code/didCreateSocketError/${te}`),me.info(`Creating a socket (${ce}) returned an error after ${oe.elapsed()} ms.`),me.error(pe),x.reject(pe)}),x.promise}function o(me,J){const U=new i(J);return me.then(se=>{U.didTimeout||U.resolve(se)},se=>{U.didTimeout||U.reject(se)}),U.promise}async function n(me,J,U,se){const ae=re(me,J);me.logService.trace(`${ae} 1/6. invoking socketFactory.connect().`);let te;try{te=await t(me.logService,me.remoteSocketFactoryService,me.connectTo,b.$Pg.getServerRootPath(),`reconnectionToken=${me.reconnectionToken}&reconnection=${me.reconnectionProtocol?"true":"false"}`,m(J),`renderer-${m(J)}-${me.reconnectionToken}`,se)}catch(pe){throw me.logService.error(`${ae} socketFactory.connect() failed or timed out. Error:`),me.logService.error(pe),pe}me.logService.trace(`${ae} 2/6. socketFactory.connect() was successful.`);let ce,le;me.reconnectionProtocol?(me.reconnectionProtocol.beginAcceptReconnection(te,null),ce=me.reconnectionProtocol,le=!1):(ce=new u.$qi({socket:te}),le=!0),me.logService.trace(`${ae} 3/6. sending AuthRequest control message.`);const x=await o(me.signService.createNewMessage((0,S.$Yg)()),se),oe={type:"auth",auth:me.connectionToken||"00000000000000000000",data:x.data};ce.sendControl(h.$Le.fromString(JSON.stringify(oe)));try{const pe=await s(ce,f(se,$(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(me.logService.trace(`${ae} 4/6. received SignRequest control message.`),!await o(me.signService.validate(x,pe.signedData),se)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const Fe=await o(me.signService.sign(pe.data),se),ze={type:"connectionType",commit:me.commit,signedData:Fe,desiredConnectionType:J};return U&&(ze.args=U),me.logService.trace(`${ae} 5/6. sending ConnectionTypeRequest control message.`),ce.sendControl(h.$Le.fromString(JSON.stringify(ze))),{protocol:ce,ownsProtocol:le}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&(me.logService.error(`${ae} the handshake timed out. Error:`),me.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&(me.logService.error(`${ae} received error control message when negotiating connection. Error:`),me.logService.error(pe)),le&&B(ce),pe}}async function d(me,J,U,se){const ae=Date.now(),te=re(me,J),{protocol:ce,ownsProtocol:le}=await n(me,J,U,se),x=new i(se);return x.registerDisposable(ce.onControlMessage(oe=>{const pe=JSON.parse(oe.toString()),we=K(pe);we?(me.logService.error(`${te} received error control message when negotiating connection. Error:`),me.logService.error(we),le&&B(ce),x.reject(we)):(me.reconnectionProtocol?.endAcceptReconnection(),me.logService.trace(`${te} 6/6. handshake finished, connection is up and running after ${ye(ae)}!`),x.resolve({protocol:ce,firstMessage:pe}))})),x.promise}async function l(me,J){const{protocol:U}=await d(me,a.Management,void 0,J);return{protocol:U}}async function g(me,J,U){const{protocol:se,firstMessage:ae}=await d(me,a.ExtensionHost,J,U),te=ae&&ae.debugPort;return{protocol:se,debugPort:te}}async function E(me,J,U){const se=Date.now(),ae=re(me,a.Tunnel),{protocol:te}=await n(me,a.Tunnel,J,U);return me.logService.trace(`${ae} 6/6. handshake finished, connection is up and running after ${ye(se)}!`),te}async function D(me,J,U){const{connectTo:se,connectionToken:ae}=await me.addressProvider.getAddress();return{commit:me.commit,quality:me.quality,connectTo:se,connectionToken:ae,reconnectionToken:J,reconnectionProtocol:U,remoteSocketFactoryService:me.remoteSocketFactoryService,signService:me.signService,logService:me.logService}}async function y(me,J,U){return A(me,async se=>{const{protocol:ae}=await l(se,C.CancellationToken.None);return new V(me,J,U,se.reconnectionToken,ae)})}async function k(me,J){return A(me,async U=>{const{protocol:se,debugPort:ae}=await g(U,J,C.CancellationToken.None);return new ne(me,J,U.reconnectionToken,se,ae)})}async function A(me,J){for(let se=1;;se++)try{const ae=(0,S.$Yg)(),te=await D(me,ae,null);return await J(te)}catch(ae){if(se<5)me.logService.error(`[remote-connection][attempt ${se}] An error occurred in initial connection! Will retry... Error:`),me.logService.error(ae);else throw me.logService.error(`[remote-connection][attempt ${se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),me.logService.error(ae),W.triggerPermanentFailure(0,0,P.$Rl.isHandled(ae)),ae}}async function p(me,J,U){const se=await D(me,(0,S.$Yg)(),null);return await E(se,{host:J,port:U},C.CancellationToken.None)}function v(me){return(0,r.$ph)(J=>new Promise((U,se)=>{const ae=setTimeout(U,me*1e3);J.onCancellationRequested(()=>{clearTimeout(ae),U()})}))}var F;(function(me){me[me.ConnectionLost=0]="ConnectionLost",me[me.ReconnectionWait=1]="ReconnectionWait",me[me.ReconnectionRunning=2]="ReconnectionRunning",me[me.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",me[me.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class N{constructor(J,U){this.reconnectionToken=J,this.millisSinceLastIncomingData=U,this.type=F.ConnectionLost}}e.$1l=N;class O{constructor(J,U,se,ae){this.reconnectionToken=J,this.millisSinceLastIncomingData=U,this.durationSeconds=se,this.c=ae,this.type=F.ReconnectionWait}skipWait(){this.c.cancel()}}e.$2l=O;class j{constructor(J,U,se){this.reconnectionToken=J,this.millisSinceLastIncomingData=U,this.attempt=se,this.type=F.ReconnectionRunning}}e.$3l=j;class z{constructor(J,U,se){this.reconnectionToken=J,this.millisSinceLastIncomingData=U,this.attempt=se,this.type=F.ConnectionGain}}e.$4l=z;class M{constructor(J,U,se,ae){this.reconnectionToken=J,this.millisSinceLastIncomingData=U,this.attempt=se,this.handled=ae,this.type=F.ReconnectionPermanentFailure}}e.$5l=M;class W extends T.$Tc{static triggerPermanentFailure(J,U,se){this._permanentFailure=!0,this.f=J,this.g=U,this.h=se,this.j.forEach(ae=>ae.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(J=>J.y())}static debugPauseSocketWriting(){this.j.forEach(J=>J.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||W._permanentFailure}constructor(J,U,se,ae,te){super(),this.t=J,this.u=U,this.reconnectionToken=se,this.protocol=ae,this.w=te,this.m=this.B(new L.$je),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new z(this.reconnectionToken,0,0)),this.B(ae.onSocketClose(ce=>{const le=ue(this.t,this.reconnectionToken,!0);ce?ce.type===u.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${le} received socket close event (hadError: ${ce.hadError}).`),ce.error&&this.u.logService.error(ce.error)):(this.u.logService.info(`${le} received socket close event (wasClean: ${ce.wasClean}, code: ${ce.code}, reason: ${ce.reason}).`),ce.event&&this.u.logService.error(ce.event)):this.u.logService.info(`${le} received socket close event.`),this.y()})),this.B(ae.onSocketTimeout(ce=>{const le=ue(this.t,this.reconnectionToken,!0);this.u.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${ce.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ce.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ce.timeSinceLastReceivedSomeData}).`),this.y()})),W.j.push(this),this.B((0,T.$Rc)(()=>{const ce=W.j.indexOf(this);ce>=0&&W.j.splice(ce,1)})),this.n&&this.D(W.f,W.g,W.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const J=ue(this.t,this.reconnectionToken,!0);this.u.logService.info(`${J} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let se=-1;do{se++;const ae=se<U.length?U[se]:U[U.length-1];try{if(ae>0){const ce=v(ae);this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ae,ce)),this.u.logService.info(`${J} waiting for ${ae} seconds before reconnecting...`);try{await ce}catch{}}if(this.n){this.u.logService.error(`${J} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1)),this.u.logService.info(`${J} resolving connection...`);const te=await D(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${J} connecting to ${te.connectTo}...`),await this.G(te,$(w)),this.u.logService.info(`${J} reconnected!`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1));break}catch(te){if(te.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${J} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(se>360){this.u.logService.error(`${J} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(P.$Rl.isTemporarilyNotAvailable(te)){this.u.logService.info(`${J} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((te.code==="ETIMEDOUT"||te.code==="ENETUNREACH"||te.code==="ECONNREFUSED"||te.code==="ECONNRESET")&&te.syscall==="connect"){this.u.logService.info(`${J} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((0,R.$3)(te)){this.u.logService.info(`${J} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if(te instanceof P.$Rl){this.u.logService.error(`${J} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,P.$Rl.isHandled(te));break}this.u.logService.error(`${J} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}}while(!this.n&&!this.s)}C(J,U,se){this.w?W.triggerPermanentFailure(J,U,se):this.D(J,U,se)}D(J,U,se){this.m.fire(new M(this.reconnectionToken,J,U,se)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$6l=W;class V extends W{constructor(J,U,se,ae,te){super(a.Management,J,ae,te,!0),this.client=this.B(new u.$oi(te,{remoteAuthority:U,clientId:se},J.ipcLogger))}async G(J,U){await l(J,U)}}e.$7l=V;class ne extends W{constructor(J,U,se,ae,te){super(a.ExtensionHost,J,se,ae,!1),this.H=U,this.debugPort=te}async G(J,U){await g(J,this.H,U)}}e.$8l=ne;function B(me){try{me.acceptDisconnect();const J=me.getSocket();me.dispose(),J.dispose()}catch(J){(0,R.$Y)(J)}}function K(me){if(me&&me.type==="error"){const J=new Error(`Connection error: ${me.reason}`);return J.code="VSCODE_CONNECTION_ERROR",J}return null}function Y(me,J){for(;me.length<J;)me+=" ";return me}function ee(me,J){return`[remote-connection][${Y(m(me),13)}][${J.substr(0,5)}\u2026]`}function ue(me,J,U){return`${ee(me,J)}[${U?"reconnect":"initial"}]`}function re(me,J){return`${ue(J,me.reconnectionToken,!!me.reconnectionProtocol)}[${me.connectTo}]`}function ye(me){return`${Date.now()-me} ms`}}),define(Se[90],De([1,0,14]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=h,e.$fn=C,e.$gn=R,e.$hn=L;function h(b){return b.scheme===r.Schemas.vscodeRemote?b.authority:void 0}function C(b){if(!b)return;const c=b.indexOf("+");return c<0?b:b.substr(0,c)}function R(b){const{host:c,port:I}=T(b);if(typeof I>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:I}}function L(b,c){let{host:I,port:S}=T(b);return typeof S>"u"&&(S=c),{host:I,port:S}}function T(b){const c=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const I=b.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const S=b.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:b,port:void 0}}}),define(Se[23],De([1,0,12,5,90]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$qn=e.$pn=e.$on=e.TargetPlatform=e.ExtensionType=e.$nn=e.$ln=e.$kn=e.$jn=e.$in=void 0,e.$mn=R,e.$rn=S,e.$sn=u,e.$tn=P,e.$un=w,e.$vn=a,e.$wn=m,r=Ue(r),e.$in="extensions.user.cache",e.$jn="extensions.builtin.cache",e.$kn="undefined_publisher",e.$ln=["ui","workspace","web"];function R($){if(typeof $=="object"&&$!==null&&$.supported!==!0)return $.description}e.$nn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function($){$[$.System=0]="System",$[$.User=1]="User"})(L||(e.ExtensionType=L={}));var T;(function($){$.WIN32_X64="win32-x64",$.WIN32_ARM64="win32-arm64",$.LINUX_X64="linux-x64",$.LINUX_ARM64="linux-arm64",$.LINUX_ARMHF="linux-armhf",$.ALPINE_X64="alpine-x64",$.ALPINE_ARM64="alpine-arm64",$.DARWIN_X64="darwin-x64",$.DARWIN_ARM64="darwin-arm64",$.WEB="web",$.UNIVERSAL="universal",$.UNKNOWN="unknown",$.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class b{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,i){if(typeof f>"u"||f===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof f=="string"||typeof i=="string"){const s=typeof f=="string"?f:f.value,t=typeof i=="string"?i:i.value;return r.$Df(s,t)}return f._lower===i._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$on=b;class c{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const i of f)this.add(i)}add(f){this.c.add(b.toKey(f))}delete(f){return this.c.delete(b.toKey(f))}has(f){return this.c.has(b.toKey(f))}}e.$pn=c;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete(b.toKey(f))}get(f){return this.c.get(b.toKey(f))}has(f){return this.c.has(b.toKey(f))}set(f,i){this.c.set(b.toKey(f),i)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$qn=I;function S($){return u($)}function u($){return $.contributes&&$.contributes.localizations?$.contributes.localizations.length>0:!1}function P($){return $.contributes&&$.contributes.authentication?$.contributes.authentication.length>0:!1}function w($,f){if(f){const i=`onResolveRemoteAuthority:${(0,C.$fn)(f)}`;return!!$.activationEvents?.includes(i)}return!1}function a($){return $.map(f=>{const[i,s]=f.split("@");return{proposalName:i,version:s?parseInt(s):void 0}})}function m($){return $.map(f=>f.split("@")[0])}e.$xn=(0,h.$Ci)("IBuiltinExtensionsScannerService")}),define(Se[146],De([1,0,10,8,23,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.ExtensionManagementErrorCode=e.$jp=e.ExtensionGalleryErrorCode=e.$ip=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=void 0,e.$cp=T,e.$dp=b,e.$ep=c,e.$fp=I,e.$gp=S,e.$hp=u,e.$8o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9o=new RegExp(e.$8o),e.$0o="__web_extension",e.$$o="skipWalkthrough",e.$_o="extensionInstallSource",e.$ap="dependecyOrPackExtensionInstall",e.$bp="clientTargetPlatform";var L;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function T(t){switch(t){case C.TargetPlatform.WIN32_X64:return"Windows 64 bit";case C.TargetPlatform.WIN32_ARM64:return"Windows ARM";case C.TargetPlatform.LINUX_X64:return"Linux 64 bit";case C.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case C.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case C.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case C.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case C.TargetPlatform.DARWIN_X64:return"Mac";case C.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case C.TargetPlatform.WEB:return"Web";case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;case C.TargetPlatform.UNKNOWN:return C.TargetPlatform.UNKNOWN;case C.TargetPlatform.UNDEFINED:return C.TargetPlatform.UNDEFINED}}function b(t){switch(t){case C.TargetPlatform.WIN32_X64:return C.TargetPlatform.WIN32_X64;case C.TargetPlatform.WIN32_ARM64:return C.TargetPlatform.WIN32_ARM64;case C.TargetPlatform.LINUX_X64:return C.TargetPlatform.LINUX_X64;case C.TargetPlatform.LINUX_ARM64:return C.TargetPlatform.LINUX_ARM64;case C.TargetPlatform.LINUX_ARMHF:return C.TargetPlatform.LINUX_ARMHF;case C.TargetPlatform.ALPINE_X64:return C.TargetPlatform.ALPINE_X64;case C.TargetPlatform.ALPINE_ARM64:return C.TargetPlatform.ALPINE_ARM64;case C.TargetPlatform.DARWIN_X64:return C.TargetPlatform.DARWIN_X64;case C.TargetPlatform.DARWIN_ARM64:return C.TargetPlatform.DARWIN_ARM64;case C.TargetPlatform.WEB:return C.TargetPlatform.WEB;case C.TargetPlatform.UNIVERSAL:return C.TargetPlatform.UNIVERSAL;default:return C.TargetPlatform.UNKNOWN}}function c(t,o){switch(t){case r.Platform.Windows:return o==="x64"?C.TargetPlatform.WIN32_X64:o==="arm64"?C.TargetPlatform.WIN32_ARM64:C.TargetPlatform.UNKNOWN;case r.Platform.Linux:return o==="x64"?C.TargetPlatform.LINUX_X64:o==="arm64"?C.TargetPlatform.LINUX_ARM64:o==="arm"?C.TargetPlatform.LINUX_ARMHF:C.TargetPlatform.UNKNOWN;case"alpine":return o==="x64"?C.TargetPlatform.ALPINE_X64:o==="arm64"?C.TargetPlatform.ALPINE_ARM64:C.TargetPlatform.UNKNOWN;case r.Platform.Mac:return o==="x64"?C.TargetPlatform.DARWIN_X64:o==="arm64"?C.TargetPlatform.DARWIN_ARM64:C.TargetPlatform.UNKNOWN;case r.Platform.Web:return C.TargetPlatform.WEB}}function I(t,o){return o===C.TargetPlatform.WEB&&!t.includes(C.TargetPlatform.WEB)}function S(t,o,n){return I(o,n)?!1:t===C.TargetPlatform.UNDEFINED||t===C.TargetPlatform.UNIVERSAL?!0:t===C.TargetPlatform.UNKNOWN?!1:t===n}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var P;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var w;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var a;(function(t){t.Install="install",t.Uninstall="uninstall"})(a||(e.StatisticType=a={}));var m;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$ip=(0,R.$Ci)("extensionGalleryService");var $;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})($||(e.ExtensionGalleryErrorCode=$={}));class f extends Error{constructor(o,n){super(o),this.code=n,this.name=n}}e.$jp=f;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class s extends Error{constructor(o,n){super(o),this.code=n,this.name=n}}e.$kp=s,e.$lp=(0,R.$Ci)("extensionManagementService"),e.$mp="extensionsIdentifiers/disabled",e.$np="extensionsIdentifiers/enabled",e.$op=(0,R.$Ci)("IGlobalExtensionEnablementService"),e.$pp=(0,R.$Ci)("IExtensionTipsService"),e.$qp=(0,h.localize2)(11408,"Extensions"),e.$rp=(0,h.localize2)(11409,"Preferences")}),define(Se[147],De([1,0,13,23]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VG=e.$UG=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(L,T){this.a.set(L,T)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const T=Object.create(null);for(const b of L){const c=this.readActivationEvents(b);c.length>0&&(T[h.$on.toKey(b.identifier)]=c)}return T}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const T=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let b=0;b<T.length;b++)T[b]==="onUri"&&(T[b]=`onUri:${h.$on.toKey(L.identifier)}`);if(!L.contributes)return T;for(const b in L.contributes){const c=this.a.get(b);if(!c)continue;const I=L.contributes[b],S=Array.isArray(I)?I:[I];try{c(S,T)}catch(u){(0,r.$Y)(u)}}return T}}e.$UG=C,e.$VG=new C});var Wt=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Se[235],De([1,0,22,43,8,361,23,143]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=I,e.$Xp=S,e.$Yp=u,e.$Zp=P,e.$1p=w,e.$2p=a,e.$3p=m,e.$4p=$,h=Wt(h),C=Ue(C),R=Ue(R);const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function I(s){return s=s.trim(),s==="*"||b.test(s)}function S(s){if(!I(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=s.match(b);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function u(s){if(!s)return null;const t=s.majorBase,o=s.majorMustEqual,n=s.minorBase;let d=s.minorMustEqual;const l=s.patchBase;let g=s.patchMustEqual;s.hasCaret&&(t===0||(d=!1),g=!1);let E=0;if(s.preRelease){const D=c.exec(s.preRelease);if(D){const[,y,k,A]=D;E=Date.UTC(Number(y),Number(k)-1,Number(A))}}return{majorBase:t,majorMustEqual:o,minorBase:n,minorMustEqual:d,patchBase:l,patchMustEqual:g,isMinimum:s.hasGreaterEquals,notBefore:E}}function P(s,t,o){let n;typeof s=="string"?n=u(S(s)):n=s;let d;t instanceof Date?d=t.getTime():typeof t=="string"&&(d=new Date(t).getTime());let l;if(typeof o=="string"?l=u(S(o)):l=o,!n||!l)return!1;const g=n.majorBase,E=n.minorBase,D=n.patchBase;let y=l.majorBase,k=l.minorBase,A=l.patchBase;const p=l.notBefore;let v=l.majorMustEqual,F=l.minorMustEqual,N=l.patchMustEqual;return l.isMinimum?g>y?!0:g<y?!1:E>k?!0:E<k||d&&d<p?!1:D>=A:(g===1&&y===0&&(!v||!F||!N)&&(y=1,k=0,A=0,v=!0,F=!1,N=!1),g<y?!1:g>y?!v:E<k?!1:E>k?!F:D<A?!1:D>A?!N:!(d&&d<p))}function w(s,t,o,n,d,l){const g=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return g.push([h.default.Error,C.localize(11339,null)]),g;if(typeof n.name!="string")return g.push([h.default.Error,C.localize(11340,null,"name")]),g;if(typeof n.version!="string")return g.push([h.default.Error,C.localize(11341,null,"version")]),g;if(!n.engines)return g.push([h.default.Error,C.localize(11342,null,"engines")]),g;if(typeof n.engines.vscode!="string")return g.push([h.default.Error,C.localize(11343,null,"engines.vscode")]),g;if(typeof n.extensionDependencies<"u"&&!i(n.extensionDependencies))return g.push([h.default.Error,C.localize(11344,null,"extensionDependencies")]),g;if(typeof n.activationEvents<"u"){if(!i(n.activationEvents))return g.push([h.default.Error,C.localize(11345,null,"activationEvents")]),g;if(typeof n.main>"u"&&typeof n.browser>"u")return g.push([h.default.Error,C.localize(11346,null,"activationEvents","main","browser")]),g}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&g.push([h.default.Warning,C.localize(11347,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return g.push([h.default.Error,C.localize(11348,null,"main")]),g;{const y=(0,r.$dh)(o,n.main);(0,r.$0g)(y,o)||g.push([h.default.Warning,C.localize(11349,null,y.path,o.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return g.push([h.default.Error,C.localize(11350,null,"browser")]),g;{const y=(0,r.$dh)(o,n.browser);(0,r.$0g)(y,o)||g.push([h.default.Warning,C.localize(11351,null,y.path,o.path)])}}if(!R.valid(n.version))return g.push([h.default.Error,C.localize(11352,null)]),g;const E=[];if(!a(s,t,n,d,E))for(const y of E)g.push([h.default.Error,y]);if(l&&n.enabledApiProposals?.length){const y=[];if(!$([...n.enabledApiProposals],y))for(const k of y)g.push([h.default.Error,k])}return g}function a(s,t,o,n,d){return n||typeof o.main>"u"&&typeof o.browser>"u"?!0:f(s,t,o.engines.vscode,d)}function m(s,t,o){return s==="*"||f(t,o,s)}function $(s,t){if(s.length===0)return!0;const o=Array.isArray(t)?t:void 0,n=(o?void 0:t)??T.allApiProposals,d=[],l=(0,L.$vn)(s);for(const{proposalName:g,version:E}of l){const D=n[g];D&&E&&D.version!==E&&d.push(C.localize(11353,null,g))}return o?.push(...d),d.length===0}function f(s,t,o,n=[]){const d=u(S(o));if(!d)return n.push(C.localize(11354,null,o)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return n.push(C.localize(11355,null,o)),!1}else if(!d.majorMustEqual)return n.push(C.localize(11356,null,o)),!1;return P(s,t,d)?!0:(n.push(C.localize(11357,null,s,o)),!1)}function i(s){if(!Array.isArray(s))return!1;for(let t=0,o=s.length;t<o;t++)if(typeof s[t]!="string")return!1;return!0}}),define(Se[236],De([1,0,3,5]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=void 0,e.$Tl=(0,h.$Ci)("remoteSocketFactoryService");class C{constructor(){this.a={}}register(L,T){return this.a[L]??=[],this.a[L].push(T),(0,r.$Rc)(()=>{const b=this.a[L]?.indexOf(T);typeof b=="number"&&b>=0&&this.a[L]?.splice(b,1)})}b(L){return(this.a[L.type]||[]).find(b=>b.supports(L))}connect(L,T,b,c){const I=this.b(L);if(!I)throw new Error(`No socket factory found for ${L}`);return I.connect(L,T,b,c)}}e.$Ul=C}),define(Se[237],De([1,0,21,13,3,8,70,5,11,36]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0,e.$7p=u,e.$8p=P,e.$9p=w,e.$0p=a,e.$$p=m,e.$_p=$,e.$5p=(0,T.$Ci)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const o in this.b)o.toLowerCase()==="authorization"||o.toLowerCase()==="proxy-authorization"?t[o]="*****":t[o]=this.b[o];this.a=t}return this.a}}class S extends C.$Tc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,R.localize)(11126,null),when:b.$pk.isEqualTo((0,b.$mk)(b.LogLevel.Trace)).serialize()})}async c(t,o,n){const d=`${t} #${++this.b}: ${o.url}`;this.a.trace(`${d} - begin`,o.type,new I(o.headers??{}));try{const l=await n();return this.a.trace(`${d} - end`,o.type,l.res.statusCode,l.res.headers),l}catch(l){throw this.a.error(`${d} - error`,o.type,(0,h.$9)(l)),l}}}e.$6p=S;function u(s){return s.res.statusCode&&s.res.statusCode>=200&&s.res.statusCode<300||s.res.statusCode===1223}function P(s){return s.res.statusCode===204}async function w(s){return P(s)?null:(await(0,r.$Xe)(s.stream)).toString()}async function a(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);return w(s)}async function m(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);if(P(s))return null;const o=(await(0,r.$Xe)(s.stream)).toString();try{return JSON.parse(o)}catch(n){throw n.message+=`:
`+o,n}}function $(s){i(s)}let f;function i(s){const t=c.$oo.as(L.$to.Configuration),o=f;f={id:"http",order:15,title:(0,R.localize)(11127,null),type:"object",scope:s,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(11128,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(11129,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(11130,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,R.localize)(11131,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(11132,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(11133,null),(0,R.localize)(11134,null),(0,R.localize)(11135,null),(0,R.localize)(11136,null)],default:"override",description:(0,R.localize)(11137,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11138,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(11139,null),restricted:!0}}},t.updateConfigurations({add:[f],remove:o?[o]:[]})}i(L.ConfigurationScope.APPLICATION)}),define(Se[238],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=void 0;class r{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(C){try{const R=await this.c();if(R){const L=String(r.a++);return this.b.set(L,R),{id:L,data:R.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,R){if(!C.id)return!0;const L=this.b.get(C.id);if(!L)return!1;this.b.delete(C.id);try{return L.validate(R)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(C){try{return await this.d(C)}catch{}return C}}e.$jcc=r}),define(Se[117],De([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=void 0,e.$Vl="signService",e.$Wl=(0,r.$Ci)(e.$Vl)}),define(Se[148],De([1,0,238]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=void 0;class h extends r.$jcc{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(L=>new L.signer().sign(R))}h(){return new Promise((R,L)=>$e(["vsda"],R,L))}}e.$qhc=h}),define(Se[239],De([1,0,10,55,32]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=L,e.$tp=T;function R(b){if(r.$v===r.Platform.Linux&&/^penguin(\.|$)/i.test(b))return"chromebook"}function L(b,c,I,S,u,P,w,a,m,$){const f=Object.create(null);f["common.machineId"]=P,f["common.sqmId"]=w,f["common.devDeviceId"]=a,f.sessionID=(0,C.$Yg)()+Date.now(),f.commitHash=S,f.version=u,f["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,r.$i)(r.$v),f["common.nodePlatform"]=h.$cc,f["common.nodeArch"]=I,f["common.product"]=$||"desktop",m&&(f["common.msftInternal"]=m);let i=0;const s=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),r.$m&&(f["common.snap"]="true");const t=R(c);return t&&(f["common.platformDetail"]=t),f}function T(b){const c=h.env.USERDNSDOMAIN;if(!c)return!1;const I=c.toLowerCase();return b.some(S=>I===S)}}),define(Se[149],De([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=void 0,e.$9l=(0,r.$Ci)("telemetryService"),e.$0l=(0,r.$Ci)("customEndpointTelemetryService"),e.$$l="telemetry.currentSessionDate",e.$_l="telemetry.firstSessionDate",e.$am="telemetry.lastSessionDate",e.$bm="telemetry.machineId",e.$cm="telemetry.sqmId",e.$dm="telemetry.devDeviceId",e.$em="telemetry",e.$fm="telemetry.telemetryLevel",e.$gm="telemetry.enableCrashReporter",e.$hm="telemetry.enableTelemetry";var h;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(h||(e.TelemetryLevel=h={}));var C;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Se[91],De([1,0,24,17,90,239,149]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=void 0,e.$Bp=I,e.$Cp=S,e.$Dp=u,e.$Ep=P,e.$Fp=a,e.$Gp=$,e.$Hp=f,e.$Ip=t;class T{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$up=T;class b{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$vp=b,e.$wp=new b;class c{async publicLog(n,d,l){}async publicLogError(n,d,l){}}e.$xp=c,e.$yp="telemetry",e.$zp="extensionTelemetryLog",e.$Ap={log:()=>null,flush:()=>Promise.resolve(null)};function I(o,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!o.enableTelemetry)}function S(o,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}function u(o){const n=o.getValue(L.$fm),d=o.getValue(L.$gm);if(o.getValue(L.$hm)===!1||d===!1)return L.TelemetryLevel.NONE;switch(n??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function P(o){const n={},d={},l={};m(o,l);for(let g in l){g=g.length>150?g.substr(g.length-149):g;const E=l[g];typeof E=="number"?d[g]=E:typeof E=="boolean"?d[g]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${E.length}`),n[g]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(n[g]=E)}return{properties:n,measurements:d}}const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(o){if(!o)return"none";const n=(0,C.$fn)(o);return w.has(n)?n:"other"}function m(o,n,d=0,l){if(o)for(const g of Object.getOwnPropertyNames(o)){const E=o[g],D=l?l+g:g;Array.isArray(E)?n[D]=(0,r.$go)(E):E instanceof Date?n[D]=E.toISOString():(0,h.$eg)(E)?d<2?m(E,n,d+1,D+"."):n[D]=(0,r.$go)(E):n[D]=E}}function $(o,n){const d=o.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,R.$tp)(d)||l}function f(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}function i(o,n){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let d=o;const l=[];for(const y of n)for(;;){const k=y.exec(o);if(!k)break;l.push([k.index,y.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(d="";;){const y=E.exec(o);if(!y)break;const k=l.some(([A,p])=>y.index<p&&A<E.lastIndex);!g.test(y[0])&&!k&&(d+=o.substring(D,y.index)+"<REDACTED: user-file-path>",D=E.lastIndex)}return D<o.length&&(d+=o.substr(D)),d}function s(o){if(!o)return o;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of n)if(d.regex.test(o))return`<REDACTED: ${d.label}>`;return o}function t(o,n){return(0,r.$do)(o,d=>{if(d instanceof T||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let l=d.replaceAll("%20"," ");l=i(l,n);for(const g of n)l=l.replace(g,"");return l=s(l),l}})}}),define(Se[240],De([1,0,12,146,23,10,2,13,55,91]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Kp=void 0,e.$Jp=I,e.$Lp=w,e.$Mp=a,e.$Np=m,e.$Op=$,e.$Pp=f,e.$Qp=i,e.$Rp=s,e.$Tp=t,e.$Up=n;function I(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,r.$yf)(d.id,l.id)===0}const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(l){const g=l.manifest?l.manifest.version:l.version,E=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new u(l.identifier,g,E)}static parse(l){const g=S.exec(l);return g&&g[1]&&g[2]?new u({id:g[1]},g[2],g[4]||void 0):null}constructor(l,g,E=C.TargetPlatform.UNDEFINED){this.identifier=l,this.version=g,this.targetPlatform=E,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==C.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof u?I(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Kp=u;const P=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(d){const l=P.exec(d);return l&&l[1]?[m(l[1]),l[2]]:[m(d),void 0]}function a(d,l){return`${d}.${l}`}function m(d){return d.toLowerCase()}function $(d,l){return m(a(d??C.$kn,l))}function f(d,l){const g=[],E=D=>{for(const y of g)if(y.some(k=>I(l(k),l(D))))return y;return null};for(const D of d){const y=E(D);y?y.push(D):g.push([D])}return g}function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function s(d){return{id:new c.$up(d.identifier.id),name:new c.$up(d.name),version:d.version,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Sp=new C.$on("pprice.better-merge");function t(d,l){const g=[],E=l.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const D=E.shift();if(D&&g.every(y=>!I(y.identifier,{id:D}))){const y=d.filter(k=>I(k.identifier,{id:D}));y.length===1&&(g.push(y[0]),E.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}async function o(d,l){if(!R.$l)return!1;let g;try{g=(await d.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{g=(await d.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){l.debug("Error while getting the os-release file.",(0,T.$9)(D))}}return!!g&&(g.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(d,l){const g=await o(d,l),E=(0,h.$ep)(g?"alpine":R.$v,b.$dc);return l.debug("ComputeTargetPlatform:",E),E}}),define(Se[241],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=r,e.$Ds=h,e.$Es=C,e.$Fs=R,e.$Gs=L,e.$Hs=T;function r(b){return[...b.entries()]}function h(b){return b?[...b.entries()]:[]}function C(b){return new Map(b)}function R(b){return new Map(b??[])}function L(b){return Array.from(b.entries()).map(c=>[c[0],r(c[1].map),h(c[1].descriptionMap)])}function T(b){return new Map(b.map(c=>[c[0],{map:C(c[1]),descriptionMap:R(c[2])}]))}}),define(Se[242],De([1,0,5,35,36]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=e.$os=e.$ns=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ms=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ls=void 0,e.$ls=new h.$Tj("terminalTabFocusMode",!1,!0);var R;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var L;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(L||(e.TerminalSettingId=L={}));var T;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(T||(e.PosixShellType=T={}));var b;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(b||(e.WindowsShellType=b={}));var c;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var I;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var S;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(S||(e.ProcessPropertyType=S={})),e.$ms=(0,r.$Ci)("ptyService");var u;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var P;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(P||(e.TerminalLocation=P={}));var w;(function(t){t.TerminalView="view",t.Editor="editor"})(w||(e.TerminalLocationString=w={}));var a;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var m;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var $;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var f;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$ns={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(o){const n=this.b(o.remoteAuthority);if(this.a.has(n))throw new Error(`A terminal backend with remote authority '${n}' was already registered.`);this.a.set(n,o)}getTerminalBackend(o){return this.a.get(this.b(o))}b(o){return o?.toLowerCase()??""}}C.$oo.add(e.$ns.Backend,new s),e.$os=(0,r.$Ci)("localPtyService"),e.$ps=(0,r.$Ci)("terminalLogService")}),define(Se[243],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lxb=void 0;class r{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,R,L=5){const T=R(b=>{const c=typeof b=="string"?b:b.data;let I=this.a.get(C);if(I){I.data.push(c);return}const S=setTimeout(()=>this.flushBuffer(C),L);I={data:[c],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(C),T.dispose()}},this.a.set(C,I)});return T}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const R=this.a.get(C);R&&(this.a.delete(C),this.b(C,R.data.join("")))}}e.$Lxb=r}),define(Se[244],De([1,0,7,82,106,50,4,17,2,8,116,36]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fx=e.$Ex=e.$Dx=e.$Cx=e.$Bx=e.$Ax=e.IconFontDefinition=e.IconContribution=e.$xx=void 0,e.$yx=m,e.$zx=$,S=Ue(S),e.$xx={IconContribution:"base.contributions.icons"};var u;(function(t){function o(n,d){let l=n.defaults;for(;R.ThemeIcon.isThemeIcon(l);){const g=a.getIcon(l.id);if(!g)return;l=g.defaults}return l}t.getDefinition=o})(u||(e.IconContribution=u={}));var P;(function(t){function o(d){return{weight:d.weight,style:d.style,src:d.src.map(l=>({format:l.format,location:l.location.toString()}))}}t.toJSONObject=o;function n(d){const l=g=>(0,T.$cg)(g)?g:void 0;if(d&&Array.isArray(d.src)&&d.src.every(g=>(0,T.$cg)(g.format)&&(0,T.$cg)(g.location)))return{weight:l(d.weight),style:l(d.style),src:d.src.map(g=>({format:g.format,location:b.URI.parse(g.location)}))}}t.fromJSONObject=n})(P||(e.IconFontDefinition=P={}));class w{constructor(){this.a=new L.$je,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(11058,null)},fontCharacter:{type:"string",description:(0,c.localize)(11059,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(o,n,d,l){const g=this.b[o];if(g){if(d&&!g.description){g.description=d,this.d.properties[o].markdownDescription=`${d} $(${o})`;const y=this.e.enum.indexOf(o);y!==-1&&(this.e.enumDescriptions[y]=d),this.a.fire()}return g}const E={id:o,description:d,defaults:n,deprecationMessage:l};this.b[o]=E;const D={$ref:"#/definitions/icons"};return l&&(D.deprecationMessage=l),d&&(D.markdownDescription=`${d}: $(${o})`),this.d.properties[o]=D,this.e.enum.push(o),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:o}}deregisterIcon(o){delete this.b[o],delete this.d.properties[o];const n=this.e.enum.indexOf(o);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(o=>this.b[o])}getIcon(o){return this.b[o]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(o,n){const d=this.f[o];return d||(this.f[o]=n,this.a.fire(),n)}deregisterIconFont(o){delete this.f[o]}getIconFont(o){return this.f[o]}toString(){const o=(g,E)=>g.id.localeCompare(E.id),n=g=>{for(;R.ThemeIcon.isThemeIcon(g.defaults);)g=this.b[g.defaults.id];return`codicon codicon-${g?g.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(g=>this.b[g]);for(const g of l.filter(E=>!!E.description).sort(o))d.push(`|<i class="${n(g)}"></i>|${g.id}|${R.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const g of l.filter(E=>!R.ThemeIcon.isThemeIcon(E.defaults)).sort(o))d.push(`|<i class="${n(g)}"></i>|${g.id}|`);return d.join(`
`)}}const a=new w;S.$oo.add(e.$xx.IconContribution,a);function m(t,o,n,d){return a.registerIcon(t,o,n,d)}function $(){return a}function f(){const t=(0,C.$Xj)();for(const o in t){const n="\\"+t[o].toString(16);a.registerIcon(o,{fontCharacter:n})}}f(),e.$Ax="vscode://schemas/icons";const i=S.$oo.as(I.$po.JSONContribution);i.registerSchema(e.$Ax,a.getIconSchema());const s=new r.$Oh(()=>i.notifySchemaChanged(e.$Ax),200);a.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$Bx=m("widget-close",h.$2j.close,(0,c.localize)(11060,null)),e.$Cx=m("goto-previous-location",h.$2j.arrowUp,(0,c.localize)(11061,null)),e.$Dx=m("goto-next-location",h.$2j.arrowDown,(0,c.localize)(11062,null)),e.$Ex=R.ThemeIcon.modify(h.$2j.sync,"spin"),e.$Fx=R.ThemeIcon.modify(h.$2j.loading,"spin")}),define(Se[92],De([1,0,4,3,10,2,45,5,11]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=e.$Lw=e.$Iw=e.$Gw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Cw=e.$Bw=void 0,e.$Dw=S,e.$Ew=P,e.$Fw=w,e.$Hw=a,e.$Jw=m,e.$Kw=$,e.$Bw=(0,T.$Ci)("tunnelService"),e.$Cw=(0,T.$Ci)("sharedTunnelsService");var c;(function(s){s.Http="http",s.Https="https"})(c||(e.TunnelProtocol=c={}));var I;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(I||(e.TunnelPrivacyId=I={}));function S(s){return!!s.forwardPort}var u;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function P(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(t)return{address:t[1],port:+t[2]}}function w(s){if(s.scheme!=="http"&&s.scheme!=="https"||!s.query)return;const t=s.query.split("&");for(const o of t){const n=o.split("=")[1];if(/^https?:/.exec(n)){const d=P(R.URI.parse(n));if(d)return d}}}e.$Gw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function a(s){return e.$Gw.indexOf(s)>=0}e.$Iw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(s){return e.$Iw.indexOf(s)>=0}function $(s,t,o,n){if(o===C.OperatingSystem.Windows)return!1;if(o===C.OperatingSystem.Macintosh&&m(t)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(d?.length===4&&parseInt(d[1])>=18)return!1}return s<1024}class f{constructor(t,o,n){this.remoteAddress=t,this.localAddress=o,this.b=n,this.a=new r.$je,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lw=f;let i=class extends h.$Tc{constructor(t,o){super(),this.r=t,this.s=o,this.a=new r.$je,this.onTunnelOpened=this.a.event,this.b=new r.$je,this.onTunnelClosed=this.b.event,this.c=new r.$je,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],o=Array.from(this.f.values());for(const n of o){const d=Array.from(n.values());for(const l of d){const g=await l.value;g&&typeof g!="string"&&t.push(g)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:o}of t.values())await o.then(n=>typeof n!="string"?n?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,o,n,d,l){this.z(t,o,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:o,localAddress:n,privacy:d,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,o){(m(t)||a(t))&&(t=e.$Gw[0]);const n=this.D(t,o);if(n)return++n.refcount,n.value}openTunnel(t,o,n,d,l,g=!1,E,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${n} on local port ${l}.`);const y=this.g??t;if(!y)return;if(o||(o="localhost"),d||(d=this.t),this.g&&this.n.has(n)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const k=this.F(y,o,n,d,l,g,E,D);return k?k.then(A=>{if(A){if(typeof A=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(o,n),A}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(o,n);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.w(A);return(A.tunnelRemoteHost!==o||A.tunnelRemotePort!==n)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),E&&A.privacy!==E&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),k)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const o=this.f.get(t.tunnelRemoteHost);if(o){const n=o.get(t.tunnelRemotePort);n&&(n.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,n))}}}}async y(t,o,n){if(n.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${o}.`);const d=n.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(o),d}}async closeTunnel(t,o){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${o} `);const n=this.f.get(t);if(n&&n.has(o)){const d=n.get(o);d.refcount=0,await this.y(t,o,d)}}z(t,o,n){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(o,{refcount:1,value:n})}async C(t,o){const n=this.f.get(t);if(n){const d=n.get(o),l=d?await d.value:void 0;(!l||typeof l=="string")&&n.delete(o),n.size===0&&this.f.delete(t)}}D(t,o){const n=[t];a(t)?(n.push(...e.$Gw),n.push(...e.$Iw)):m(t)&&n.push(...e.$Iw);const d=n.map(l=>this.f.get(l));for(const l of d){const g=l?.get(o);if(g)return g}}canTunnel(t){return!!P(t)}G(t,o,n,d,l,g,E){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${n} on local port ${d}.`);const D=n;this.n.add(D);const y=d===void 0?n:d,k={elevationRequired:l?this.isPortPrivileged(y):!1},A={remoteAddress:{host:o,port:n},localAddressPort:d,privacy:g,public:g?g!==I.Private:void 0,protocol:E},p=t.forwardPort(A,k);return p?(this.z(o,n,p),p.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),p}};e.$Mw=i,e.$Mw=i=Ye([Ve(0,b.$0j),Ve(1,L.$9i)],i)}),define(Se[245],De([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=void 0,e.$Hl=(0,r.$Ci)("IUriIdentityService")}),define(Se[246],De([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Nw=void 0,e.$Nw=(0,r.$Ci)("editSessionIdentityService");var h;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(h||(e.EditSessionIdentityMatch=h={}))}),define(Se[247],De([1,0,14]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aN=h,e.$bN=C,e.$cN=R,e.$dN=L,e.$eN=T;function h(b){return b.scheme!==r.Schemas.file&&b.scheme!==r.Schemas.vscodeRemote}function C(b){if(b.folders.length)return b.folders.every(c=>h(c.uri))?b.folders[0].uri:void 0;if(b.configuration&&h(b.configuration))return b.configuration}function R(b){return C(b)?.scheme}function L(b){return C(b)?.authority}function T(b){return C(b)!==void 0}}),define(Se[46],De([1,0,8,16,84,22,2,5,14]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=c,e.$Ni=I,e.$Qi=S,e.$Ri=u,e.$Si=P,e.$Ti=a,e.$Ui=m,e.$Xi=i,e.$3i=s,e.$4i=t,e.$6i=o,e.$7i=n,e.$8i=d,e.$Li=(0,T.$Ci)("contextService");function c(l){const g=l;return typeof g?.id=="string"&&L.URI.isUri(g.uri)}function I(l){return typeof l?.id=="string"&&!c(l)&&!u(l)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function S(l,g){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,h.$mc)(l)}:g?e.$Oi:e.$Pi;const E=l;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}function u(l){const g=l;return typeof g?.id=="string"&&L.URI.isUri(g.configPath)}function P(l){const g=l;if(g?.uri)return{id:g.id,uri:L.URI.revive(g.uri)};const E=l;if(E?.configPath)return{id:E.id,configPath:L.URI.revive(E.configPath)};if(l?.id)return{id:l.id}}var w;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function a(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}function m(l){const g=l;return!!(g&&typeof g=="object"&&L.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}class ${constructor(g,E,D,y,k){this.h=g,this.j=D,this.k=y,this.l=k,this.c=C.$Ii.forUris(this.l,()=>!0),this.folders=E}update(g){this.h=g.id,this.k=g.configuration,this.j=g.transient,this.l=g.l,this.folders=g.folders}get folders(){return this.g}set folders(g){this.g=g,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(g){this.k=g}getFolder(g){return g&&this.c.findSubstr(g)||null}n(){this.c=C.$Ii.forUris(this.l,()=>!0);for(const g of this.folders)this.c.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=$;class f{constructor(g,E){this.raw=E,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,R.$dh)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=f;function i(l){return new f({uri:l,index:0,name:(0,R.$_g)(l)},{uri:l.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,r.localize)(10937,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function s(l,g){return R.$7g.isEqualOrParent(l,g.untitledWorkspacesHome)}function t(l){let g;return L.URI.isUri(l)?g=l:g=l.configuration,g?.scheme===b.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function o(l){return l.id===e.$5i}function n(l,g){return!s(l,g)&&!t(l)}function d(l){return(typeof l=="string"?(0,h.$nc)(l):(0,R.$bh)(l))===e.$Zi}}),define(Se[150],De([1,0,60,4,3,22,2,8,144,27,5,11,46,28,245,7,32,12,17]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Jl=e.ProfileResourceType=void 0,e.$Il=s,e.$Kl=t,e.$Ll=o;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function s(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&typeof g.isDefault=="boolean"&&typeof g.name=="string"&&L.URI.isUri(g.location)&&L.URI.isUri(g.globalStorageHome)&&L.URI.isUri(g.settingsResource)&&L.URI.isUri(g.keybindingsResource)&&L.URI.isUri(g.tasksResource)&&L.URI.isUri(g.snippetsHome)&&L.URI.isUri(g.extensionsResource))}e.$Jl=(0,I.$Ci)("IUserDataProfilesService");function t(l,g){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:L.URI.revive(l.location).with({scheme:g}),globalStorageHome:L.URI.revive(l.globalStorageHome).with({scheme:g}),settingsResource:L.URI.revive(l.settingsResource).with({scheme:g}),keybindingsResource:L.URI.revive(l.keybindingsResource).with({scheme:g}),tasksResource:L.URI.revive(l.tasksResource).with({scheme:g}),snippetsHome:L.URI.revive(l.snippetsHome).with({scheme:g}),extensionsResource:L.URI.revive(l.extensionsResource).with({scheme:g}),cacheHome:L.URI.revive(l.cacheHome).with({scheme:g}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function o(l,g,E,D,y,k){return{id:l,name:g,location:E,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:k&&y?.useDefaultFlags?.globalState?k.globalStorageHome:(0,R.$dh)(E,"globalStorage"),settingsResource:k&&y?.useDefaultFlags?.settings?k.settingsResource:(0,R.$dh)(E,"settings.json"),keybindingsResource:k&&y?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,R.$dh)(E,"keybindings.json"),tasksResource:k&&y?.useDefaultFlags?.tasks?k.tasksResource:(0,R.$dh)(E,"tasks.json"),snippetsHome:k&&y?.useDefaultFlags?.snippets?k.snippetsHome:(0,R.$dh)(E,"snippets"),extensionsResource:k&&y?.useDefaultFlags?.extensions?k.extensionsResource:(0,R.$dh)(E,"extensions.json"),cacheHome:(0,R.$dh)(D,l),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let n=class extends C.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(g,E,D,y){super(),this.t=g,this.u=E,this.w=D,this.y=y,this.f=!0,this.h=this.B(new h.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new h.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new h.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new h.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new P.$zc,workspaces:new P.$zc,emptyWindows:new Map},this.profilesHome=(0,R.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(g){this.f!==g&&(this.z=void 0,this.f=g)}isEnabled(){return this.f}get C(){if(!this.z){const g=this.D(),E=[g];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,f.$cg)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}E.push(o((0,R.$ah)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},g))}}catch(k){this.y.error(k)}const D=new P.$zc,y=new Map;if(E.length)try{const k=this.Q();if(k.workspaces)for(const[A,p]of Object.entries(k.workspaces)){const v=L.URI.parse(A),F=E.find(N=>N.id===p);F&&D.set(v,F)}if(k.emptyWindows)for(const[A,p]of Object.entries(k.emptyWindows)){const v=E.find(F=>F.id===p);v&&y.set(A,v)}}catch(k){this.y.error(k)}this.z={profiles:E,workspaces:D,emptyWindows:y}}return this.z}D(){const g=o("__default__profile__",(0,T.localize)(10984,null),this.t.userRoamingDataHome,this.g);return{...g,extensionsResource:this.S()??g.extensionsResource,isDefault:!0}}async createTransientProfile(g){const E="Temp",D=new RegExp(`${(0,$.$ff)(E)}\\s(\\d+)`);let y=0;for(const A of this.profiles){const p=D.exec(A.name),v=p?parseInt(p[1]):0;y=v>y?v:y}const k=`${E} ${y+1}`;return this.createProfile((0,r.$qj)((0,m.$Yg)()).toString(16),k,{transient:!0},g)}async createNamedProfile(g,E,D){return this.createProfile((0,r.$qj)((0,m.$Yg)()).toString(16),g,E,D)}async createProfile(g,E,D,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F(g,E,D);return y&&await this.setProfileForWorkspace(y,k),k}async F(g,E,D){if(!(0,f.$cg)(E)||!E)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(E);return y||(y=(async()=>{try{if(this.profiles.find(v=>v.name===E||v.id===g))throw new Error(`Profile with ${E} name already exists`);const A=o(g,E,(0,R.$dh)(this.profilesHome,g),this.g,D,this.defaultProfile);await this.u.createFolder(A.location);const p=[];return this.j.fire({profile:A,join(v){p.push(v)}}),await a.Promises.settled(p),this.I([A],[],[]),A}finally{this.r.delete(E)}})(),this.r.set(E,y)),y}async updateProfile(g,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(y=>y.id===g.id);if(!D)throw new Error(`Profile '${g.name}' does not exist`);return D=o(D.id,E.name??D.name,D.location,this.g,{shortName:E.shortName??D.shortName,icon:E.icon===null?void 0:E.icon??D.icon,transient:E.transient??D.isTransient,useDefaultFlags:E.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(g.isDefault)throw new Error("Cannot remove default profile");const E=this.profiles.find(y=>y.id===g.id);if(!E)throw new Error(`Profile '${g.name}' does not exist`);const D=[];this.m.fire({profile:E,join(y){D.push(y)}});try{await Promise.allSettled(D)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])E.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])E.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[E],[]);try{await this.u.del(E.cacheHome,{recursive:!0})}catch(y){(0,c.$ol)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(g,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(y=>y.id===E.id);if(!D)throw new Error(`Profile '${E.name}' does not exist`);this.L(g,D)}unsetWorkspace(g,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(g,void 0,E)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const g=await this.u.resolve(this.profilesHome);await Promise.all((g.children||[]).filter(E=>E.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,E.resource))).map(E=>this.u.del(E.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const g=this.s.profiles.filter(E=>!this.H(E));await Promise.allSettled(g.map(E=>this.removeProfile(E)))}getProfileForWorkspace(g){const E=this.G(g),D=L.URI.isUri(E)?this.C.workspaces.get(E):this.C.emptyWindows.get(E);return D||((0,u.$Mi)(g)?this.s.folders.get(g.uri):(0,u.$Ri)(g)?this.s.workspaces.get(g.configPath):this.s.emptyWindows.get(g.id))}G(g){return(0,u.$Mi)(g)?g.uri:(0,u.$Ri)(g)?g.configPath:g.id}H(g){return!!([...this.C.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.C.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.s.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.s.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,g.location))||[...this.s.folders.values()].some(E=>this.w.extUri.isEqual(E.location,g.location)))}I(g,E,D){const y=[...this.profiles,...g],k=[],A=this.s.profiles;this.s.profiles=[];for(let p of y){if(p.isDefault||E.some(F=>p.id===F.id))continue;p=D.find(F=>p.id===F.id)??p;const v=A.find(F=>p.id===F.id);if(p.isTransient)this.s.profiles.push(p);else{if(v){for(const[F,N]of this.s.emptyWindows.entries())if(p.id===N.id){this.L({id:F},p);break}for(const[F,N]of this.s.workspaces.entries())if(p.id===N.id){this.L({id:"",configPath:F},p);break}for(const[F,N]of this.s.folders.entries())if(p.id===N.id){this.L({id:"",uri:F},p);break}}k.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags})}}this.P(k),this.z=void 0,this.J(g,E,D)}J(g,E,D){this.h.fire({added:g,removed:E,updated:D,all:this.profiles})}L(g,E,D){if(D=E?.isTransient?!0:D,D)(0,u.$Mi)(g)?(this.s.folders.delete(g.uri),E&&this.s.folders.set(g.uri,E)):(0,u.$Ri)(g)?(this.s.workspaces.delete(g.configPath),E&&this.s.workspaces.set(g.configPath,E)):(this.s.emptyWindows.delete(g.id),E&&this.s.emptyWindows.set(g.id,E));else{this.L(g,void 0,!0);const y=this.G(g);L.URI.isUri(y)?(this.C.workspaces.delete(y),E&&this.C.workspaces.set(y,E)):(this.C.emptyWindows.delete(y),E&&this.C.emptyWindows.set(y,E)),this.M()}}M(){const g={};for(const[D,y]of this.C.workspaces.entries())g[D.toString()]=y.id;const E={};for(const[D,y]of this.C.emptyWindows.entries())E[D.toString()]=y.id;this.R({workspaces:g,emptyWindows:E}),this.z=void 0}N(g){const E={},D=this.D();if(g.workspaces)for(const[k,A]of Object.entries(g.workspaces)){const p=L.URI.parse(A);E[k]=this.w.extUri.isEqual(p,D.location)?D.id:this.w.extUri.basename(p)}const y={};if(g.emptyWindows)for(const[k,A]of Object.entries(g.emptyWindows)){const p=L.URI.parse(A);y[k]=this.w.extUri.isEqual(p,D.location)?D.id:this.w.extUri.basename(p)}return{workspaces:E,emptyWindows:y}}O(){return[]}P(g){throw new Error("not implemented")}Q(){return{}}R(g){throw new Error("not implemented")}S(){}};e.$Ml=n,e.$Ml=n=Ye([Ve(0,b.$Ji),Ve(1,c.$0k),Ve(2,w.$Hl),Ve(3,S.$0j)],n);class d extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(g){this.a=g}Q(){return this.X}R(g){this.X=g}}e.$Nl=d}),define(Se[151],De([1,0,7,4,3,61,17,193,5,150]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$fq=e.$eq=e.$dq=void 0,e.$gq=P,e.$iq=a,e.$kq=$,e.$dq="__$__isNewStorageMarker",e.$eq="__$__targetStorageMarker",e.$fq=(0,b.$Ci)("storageService");var I;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var S;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var u;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function P(f){const i=f.get(e.$eq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class w extends C.$Tc{static{this.a=60*1e3}constructor(i={flushInterval:w.a}){super(),this.m=i,this.b=this.B(new h.$me),this.c=this.B(new h.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new h.$je),this.onWillSaveState=this.f.event,this.h=this.B(new r.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new C.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,s,t){return h.Event.filter(this.b.event,o=>o.scope===i&&(s===void 0||o.key===s),t)}n(){this.j.value=(0,r.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,C.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,s){const{key:t,external:o}=s;if(t===e.$eq){switch(i){case S.APPLICATION:this.H=void 0;break;case S.PROFILE:this.F=void 0;break;case S.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:o})}w(i){this.f.fire({reason:i})}get(i,s,t){return this.P(s)?.get(i,t)}getBoolean(i,s,t){return this.P(s)?.getBoolean(i,t)}getNumber(i,s,t){return this.P(s)?.getNumber(i,t)}getObject(i,s,t){return this.P(s)?.getObject(i,t)}storeAll(i,s){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,s)})}store(i,s,t,o,n=!1){if((0,L.$lg)(s)){this.remove(i,t,n);return}this.y(()=>{this.z(i,t,o),this.P(t)?.set(i,s,n)})}remove(i,s,t=!1){this.y(()=>{this.z(i,s,void 0),this.P(s)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,s){const t=[],o=this.J(i);for(const n of Object.keys(o))o[n]===s&&t.push(n);return t}z(i,s,t,o=!1){const n=this.J(s);typeof t=="number"?n[i]!==t&&(n[i]=t,this.P(s)?.set(e.$eq,JSON.stringify(n),o)):typeof n[i]=="number"&&(delete n[i],this.P(s)?.set(e.$eq,JSON.stringify(n),o))}get D(){return this.C||(this.C=this.L(S.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(S.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(S.APPLICATION)),this.H}J(i){switch(i){case S.APPLICATION:return this.I;case S.PROFILE:return this.G;default:return this.D}}L(i){const s=this.P(i);return s?P(s):Object.create(null)}isNew(i){return this.getBoolean(e.$dq,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const s=this.P(S.APPLICATION),t=this.P(S.PROFILE),o=this.P(S.WORKSPACE);switch(i){case I.NONE:await r.Promises.settled([s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await r.Promises.settled([s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(S.APPLICATION)?.items??new Map,s=this.P(S.PROFILE)?.items??new Map,t=this.P(S.WORKSPACE)?.items??new Map;return $(i,s,t,this.Q(S.APPLICATION)??"",this.Q(S.PROFILE)??"",this.Q(S.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,s){return this.w(I.NONE),(0,c.$Il)(i)?this.R(i,s):this.S(i,s)}M(i,s){return!(i.id===s.id||a(s)&&a(i))}N(i,s,t){this.y(()=>{const o=new Set;for(const[n,d]of i)o.add(n),s.get(n)!==d&&this.u(t,{key:n,external:!0});for(const[n]of s.items)o.has(n)||this.u(t,{key:n,external:!0})})}}e.$hq=w;function a(f){return f.isDefault||!!f.useDefaultFlags?.globalState}class m extends w{constructor(){super(),this.U=this.B(new T.$bq(new T.$cq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$bq(new T.$cq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$bq(new T.$cq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(S.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(S.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(S.APPLICATION,i)))}P(i){switch(i){case S.APPLICATION:return this.U;case S.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case S.APPLICATION:return"inMemory (application)";case S.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$jq=m;async function $(f,i,s,t,o,n){const d=v=>{try{return JSON.parse(v)}catch{return v}},l=new Map,g=new Map;f.forEach((v,F)=>{l.set(F,v),g.set(F,d(v))});const E=new Map,D=new Map;i.forEach((v,F)=>{E.set(F,v),D.set(F,d(v))});const y=new Map,k=new Map;s.forEach((v,F)=>{y.set(F,v),k.set(F,d(v))}),console.group(t!==o?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const A=[];if(l.forEach((v,F)=>{A.push({key:F,value:v})}),console.table(A),console.groupEnd(),console.log(g),t!==o){console.group(`Storage: Profile (path: ${o}, profile specific)`);const v=[];E.forEach((F,N)=>{v.push({key:N,value:F})}),console.table(v),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${n})`);const p=[];y.forEach((v,F)=>{p.push({key:F,value:v})}),console.table(p),console.groupEnd(),console.log(k)}}),define(Se[118],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=void 0;class r{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const R=this.c++;return this.b.set(R,C),this.e(),R}get(C,R){return this.b.has(C)?this.b.get(C)[R]:void 0}delete(C){this.b.delete(C),this.e()}e(){r.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Voc=r}),define(Se[62],De([1,0,14,22,27,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2oc=e.$1oc=void 0;class L{constructor(){this.a=new Set(Object.keys(r.Schemas)),this.b=new Map,this.extUri=new h.$5g(b=>{const c=this.b.get(b.scheme);return!(c===void 0||c&C.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(b,c){c===null?this.b.delete(b.scheme):this.b.set(b.scheme,c)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$1oc=L,e.$2oc=(0,R.$Ci)("IExtHostFileSystemInfo")}),define(Se[29],De([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=void 0,e.$sQ=(0,r.$Ci)("IExtHostInitDataService")}),define(Se[248],De([1,0,8,11,228,29]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=void 0;let L=class extends C.$CR{constructor(b,c,I){const S=I.remote.isRemote?"remoteexthost":b?"workerexthost":"exthost",u=I.remote.isRemote?(0,r.localize)(10737,null):b?(0,r.localize)(10738,null):(0,r.localize)(10739,null);super(c.createLogger(S,{name:u}))}};e.$0qc=L,e.$0qc=L=Ye([Ve(1,h.$$j),Ve(2,R.$sQ)],L)}),define(Se[249],De([1,0,7]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hpc=e.$Gpc=void 0;class h{constructor(L,T,b){this.h=new Map,this.a=L,this.b=T,this.c=b,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(c=>(this.f=c,this)),this.g=this.c.onDidChangeStorage(c=>{c.shared===this.b&&c.key===this.a&&(this.f=c.value)}),this.i=new r.$Oh(()=>{const c=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of c.values())I.complete()}catch(I){for(const S of c.values())S.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,T){let b=this.f[L];return typeof b>"u"&&(b=T),b}update(L,T){this.f[L]=T;const b=this.h.get(L);if(b!==void 0)return b.p;const c=new r.$Zh;return this.h.set(L,c),this.i.isScheduled()||this.i.schedule(),c.p}dispose(){this.g.dispose()}}e.$Gpc=h;class C extends h{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,T){super(L.identifier.value,!0,T),this.j=L}}e.$Hpc=C}),define(Se[250],De([1,0,4,2]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=void 0;class C{constructor(L){this.c=L,this.a=new r.$je,this.onDidSaveNotebookDocument=this.a.event,this.b=new r.$je,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,T,b,c){const S=this.c.getNotebookDocument(h.URI.revive(L)).acceptModelChanged(T.value,b,c);this.b.fire(S)}$acceptDirtyStateChanged(L,T){this.c.getNotebookDocument(h.URI.revive(L)).acceptDirty(T)}$acceptModelSaved(L){const T=this.c.getNotebookDocument(h.URI.revive(L));this.a.fire(T.apiNotebook)}}e.$Bqc=C}),define(Se[19],De([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.$cQ=void 0,e.$cQ=(0,r.$Ci)("IExtHostRpcService");class h{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$dQ=h}),define(Se[251],De([1,0,23,4,3]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=void 0;class R{#e;constructor(T,b){this.disposables=new C.$Sc,this.a=r.$on.toKey(T.identifier),this.#e=b,this.onDidChange=h.Event.map(h.Event.filter(this.#e.onDidChangePassword,c=>c.extensionId===this.a),c=>({key:c.key}),this.disposables)}dispose(){this.disposables.dispose()}get(T){return this.#e.get(this.a,T)}store(T,b){return this.#e.store(this.a,T,b)}delete(T){return this.#e.delete(this.a,T)}}e.$Qpc=R}),define(Se[72],De([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=e.$epc=void 0,e.$epc=(0,r.$Ci)("IURITransformerService");class h{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$fpc=h}),define(Se[252],De([1,0,253,362,363,67,2,11,364]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Frc=I,r=Ue(r),h=Ue(h),C=Ue(C),R=Ue(R);const c=!1;function I(i,s,t,o,n,d){const l=d.environment.useHostProxy,g=typeof l=="boolean"?l:!d.remote.isRemote,E={resolveProxy:k=>i.resolveProxy(k),lookupProxyAuthorization:m.bind(void 0,i,o,n,s,{},{},d.remote.isRemote,g),getProxyURL:()=>s.getConfiguration("http").get("proxy"),getProxySupport:()=>s.getConfiguration("http").get("proxySupport")||"off",getNoProxyConfig:()=>s.getConfiguration("http").get("noProxy")||[],addCertificatesV1:()=>u(s),addCertificatesV2:()=>P(s),log:o,getLogLevel:()=>{const k=o.getLevel();switch(k){case T.LogLevel.Trace:return b.LogLevel.Trace;case T.LogLevel.Debug:return b.LogLevel.Debug;case T.LogLevel.Info:return b.LogLevel.Info;case T.LogLevel.Warning:return b.LogLevel.Warning;case T.LogLevel.Error:return b.LogLevel.Error;case T.LogLevel.Off:return b.LogLevel.Off;default:return A(k)}function A(p){return o.error("Unknown log level",p),b.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:g,loadAdditionalCertificates:async()=>{const k=[];if(d.remote.isRemote&&k.push((0,b.loadSystemCertificates)({log:o})),g){o.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const A=i.loadCertificates();A.then(p=>o.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",p.length)),k.push(A)}return d.environment.extensionTestsLocationURI&&h.globalAgent.testCertificates?.length&&(o.trace("ProxyResolver#loadAdditionalCertificates: Loading test certificates"),k.push(Promise.resolve(h.globalAgent.testCertificates))),(await Promise.all(k)).flat()},env:process.env},D=(0,b.createProxyResolver)(E),y=S(E,D);return a(t,y)}function S(i,s){function t(o,n){return Object.assign(o.default||o,n)}return{http:t(r,(0,b.createHttpPatch)(i,r,s)),https:t(h,(0,b.createHttpPatch)(i,h,s)),net:t(R,(0,b.createNetPatch)(i,R)),tls:t(C,(0,b.createTlsPatch)(i,C))}}function u(i){const s=i.getConfiguration("http");return!s.get("experimental.systemCertificatesV2",c)&&!!s.get("systemCertificates")}function P(i){const s=i.getConfiguration("http");return!!s.get("experimental.systemCertificatesV2",c)&&!!s.get("systemCertificates")}const w=new Map;function a(i,s){return i.getExtensionPathIndex().then(t=>{const o=globalThis._VSCODE_NODE_MODULES.module,n=o._load;o._load=function(l,g,E){if(l==="net")return s.net;if(l==="tls")return s.tls;if(l!=="http"&&l!=="https")return n.apply(this,arguments);const D=t.findSubstr(L.URI.file(g.filename));let y=w.get(D);if(y||w.set(D,y={}),!y[l]){const k=s[l];y[l]={...k}}return y[l]}})}async function m(i,s,t,o,n,d,l,g,E,D,y){const k=n[E];D&&(n[E]=D),s.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${E}`,`proxyAuthenticate:${D}`,`proxyAuthenticateCache:${k}`);const A=D||k,p=Array.isArray(A)?A:typeof A=="string"?[A]:[];if(f(t,p,l),p.some(F=>/^(Negotiate|Kerberos)( |$)/i.test(F))&&!y.kerberosRequested){y.kerberosRequested=!0;try{const F=await new Promise((M,W)=>{$e(["kerberos"],M,W)}).then(Ue),N=new URL(E),O=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${N.hostname}`:`HTTP@${N.hostname}`);return s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${E}`,`spn:${O}`),"Negotiate "+await(await F.initializeClient(O)).step("")}catch(F){s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",F)}if(l&&g){s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup on host",`proxyURL:${E}`);const F=await i.lookupKerberosAuthorization(E);if(F)return"Negotiate "+F}}const v=p.find(F=>/^Basic( |$)/i.test(F));if(v)try{const F=d[E];if(F)if(y.basicAuthCacheUsed)s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication deleting cached credentials",`proxyURL:${E}`),delete d[E];else return s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication using cached credentials",`proxyURL:${E}`),y.basicAuthCacheUsed=!0,F;y.basicAuthAttempt=(y.basicAuthAttempt||0)+1;const N=/ realm="([^"]+)"/i.exec(v)?.[1];s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication lookup",`proxyURL:${E}`,`realm:${N}`);const O=new URL(E),j={scheme:"basic",host:O.hostname,port:Number(O.port),realm:N||"",isProxy:!0,attempt:y.basicAuthAttempt},z=await i.lookupAuthorization(j);if(z){s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received credentials",`proxyURL:${E}`,`realm:${N}`);const M="Basic "+Buffer.from(`${z.username}:${z.password}`).toString("base64");return d[E]=M,M}else s.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received no credentials",`proxyURL:${E}`,`realm:${N}`)}catch(F){s.error("ProxyResolver#lookupProxyAuthorization Basic authentication failed",F)}}let $=!1;function f(i,s,t){$||!s.length||($=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:s.map(o=>o.split(" ")[0]).join(","),extensionHostType:t?"remote":"local"}))}}),define(Se[254],De([1,0,138]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=C;function h(R){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:R,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function C(R){return new r.$Jn(h(R))}});var Wt=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Se[152],De([1,0,8,17,2,3,5,36,27,14,52,211,43]),function($e,e,r,h,C,R,L,T,b,c,I,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$nG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$dG=e.EditorInputCapabilities=e.$cG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=void 0,e.$6F=a,e.$7F=m,e.$8F=$,e.$9F=f,e.$0F=i,e.$$F=s,e.$_F=t,e.$aG=o,e.$bG=n,e.$eG=y,e.$fG=A,e.$gG=p,e.$hG=v,e.$iG=F,e.$jG=N,e.$kG=O,e.$lG=j,e.$mG=B,e.$oG=ee,e.$pG=re,e.$qG=ye,e.$rG=me,u=Wt(u),e.$1F={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$2F={id:"default",displayName:(0,r.localize)(12379,null),providerDisplayName:(0,r.localize)(12380,null)},e.$3F="workbench.editor.sidebysideEditor",e.$4F="workbench.editors.textDiffEditor",e.$5F="workbench.editors.binaryResourceDiffEditor";var P;(function(J){J[J.PROGRAMMATIC=1]="PROGRAMMATIC",J[J.USER=2]="USER",J[J.EDIT=3]="EDIT",J[J.NAVIGATION=4]="NAVIGATION",J[J.JUMP=5]="JUMP"})(P||(e.EditorPaneSelectionChangeReason=P={}));var w;(function(J){J[J.IDENTICAL=1]="IDENTICAL",J[J.SIMILAR=2]="SIMILAR",J[J.DIFFERENT=3]="DIFFERENT"})(w||(e.EditorPaneSelectionCompareResult=w={}));function a(J){const U=J;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function m(J){const U=J;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function $(J,U,se){for(const ae of se.visibleEditorPanes)if(ae.group.id===U&&J.matches(ae.input))return ae.getViewState()}function f(J){if(y(J))return!1;const U=J;return C.URI.isUri(U?.resource)}function i(J){if(y(J))return!1;const U=J;return U?.original!==void 0&&U.modified!==void 0}function s(J){if(y(J))return!1;const U=J;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function t(J){if(y(J)||i(J))return!1;const U=J;return U?.primary!==void 0&&U.secondary!==void 0}function o(J){if(y(J))return!1;const U=J;return U?U.resource===void 0||U.resource.scheme===c.Schemas.untitled||U.forceUntitled===!0:!1}function n(J){if(y(J))return!1;const U=J;return C.URI.isUri(U?.base?.resource)&&C.URI.isUri(U?.input1?.resource)&&C.URI.isUri(U?.input2?.resource)&&C.URI.isUri(U?.result?.resource)}var d;(function(J){J[J.SHORT=0]="SHORT",J[J.MEDIUM=1]="MEDIUM",J[J.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var l;(function(J){J[J.EXPLICIT=1]="EXPLICIT",J[J.AUTO=2]="AUTO",J[J.FOCUS_CHANGE=3]="FOCUS_CHANGE",J[J.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class g{constructor(){this.a=new Map}registerSource(U,se){let ae=this.a.get(U);return ae||(ae={source:U,label:se},this.a.set(U,ae)),ae.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$cG=new g;var E;(function(J){J[J.None=0]="None",J[J.Readonly=2]="Readonly",J[J.Untitled=4]="Untitled",J[J.Singleton=8]="Singleton",J[J.RequiresTrust=16]="RequiresTrust",J[J.CanSplitInGroup=32]="CanSplitInGroup",J[J.ForceDescription=64]="ForceDescription",J[J.CanDropIntoEditor=128]="CanDropIntoEditor",J[J.MultipleEditors=256]="MultipleEditors",J[J.Scratchpad=512]="Scratchpad"})(E||(e.EditorInputCapabilities=E={}));class D extends R.$Tc{}e.$dG=D;function y(J){return J instanceof D}function k(J){const U=J;return C.URI.isUri(U?.preferredResource)}function A(J){const U=J;return y(U?.primary)&&y(U?.secondary)}function p(J){const U=J;return y(U?.modified)&&y(U?.original)}function v(J,U,se,ae,te){return me(ae,[(0,S.$mj)({id:"workbench.action.openLargeFile",label:(0,r.localize)(12381,null),run:()=>{const ce={...se,limits:{size:Number.MAX_VALUE}};J.openEditor(U,ce)}}),(0,S.$mj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(12382,null),run:()=>te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function F(J){return y(J?.editor)}function N(J){const U=J;return F(J)&&U?.group!==void 0}function O(J){const U=J;return typeof U?.groupId=="number"&&y(U.editor)}function j(J){return typeof J?.groupId=="number"}var z;(function(J){J[J.UNKNOWN=0]="UNKNOWN",J[J.REPLACE=1]="REPLACE",J[J.MOVE=2]="MOVE",J[J.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var M;(function(J){J[J.GROUP_ACTIVE=0]="GROUP_ACTIVE",J[J.GROUP_INDEX=1]="GROUP_INDEX",J[J.GROUP_LABEL=2]="GROUP_LABEL",J[J.GROUP_LOCKED=3]="GROUP_LOCKED",J[J.EDITORS_SELECTION=4]="EDITORS_SELECTION",J[J.EDITOR_OPEN=5]="EDITOR_OPEN",J[J.EDITOR_CLOSE=6]="EDITOR_CLOSE",J[J.EDITOR_MOVE=7]="EDITOR_MOVE",J[J.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",J[J.EDITOR_LABEL=9]="EDITOR_LABEL",J[J.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",J[J.EDITOR_PIN=11]="EDITOR_PIN",J[J.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",J[J.EDITOR_STICKY=13]="EDITOR_STICKY",J[J.EDITOR_DIRTY=14]="EDITOR_DIRTY",J[J.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var W;(function(J){J[J.PRIMARY=1]="PRIMARY",J[J.SECONDARY=2]="SECONDARY",J[J.BOTH=3]="BOTH",J[J.ANY=4]="ANY"})(W||(e.SideBySideEditor=W={}));class V{getOriginalUri(U,se){if(!U)return;if(n(U))return e.$nG.getOriginalUri(U.result,se);if(se?.supportSideBySide){const{primary:te,secondary:ce}=this.a(U);if(te&&ce){if(se?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(ce,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===W.ANY)return this.getOriginalUri(te,{filterByScheme:se.filterByScheme})??this.getOriginalUri(ce,{filterByScheme:se.filterByScheme});U=se.supportSideBySide===W.PRIMARY?te:ce}}if(i(U)||s(U)||t(U)||n(U))return;const ae=k(U)?U.preferredResource:U.resource;return!ae||!se||!se.filterByScheme?ae:this.b(ae,se.filterByScheme)}a(U){return A(U)||t(U)?{primary:U.primary,secondary:U.secondary}:p(U)||i(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,se){if(!U)return;if(n(U))return e.$nG.getCanonicalUri(U.result,se);if(se?.supportSideBySide){const{primary:te,secondary:ce}=this.a(U);if(te&&ce){if(se?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(ce,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===W.ANY)return this.getCanonicalUri(te,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(ce,{filterByScheme:se.filterByScheme});U=se.supportSideBySide===W.PRIMARY?te:ce}}if(i(U)||s(U)||t(U)||n(U))return;const ae=U.resource;return!ae||!se||!se.filterByScheme?ae:this.b(ae,se.filterByScheme)}b(U,se){if(Array.isArray(se)){if(se.some(ae=>U.scheme===ae))return U}else if(se===U.scheme)return U}}var ne;(function(J){J[J.UNKNOWN=0]="UNKNOWN",J[J.KEYBOARD=1]="KEYBOARD",J[J.MOUSE=2]="MOUSE"})(ne||(e.EditorCloseMethod=ne={}));function B(J,U,se,ae){if(!J.isSticky(U))return!1;switch(ae.preventPinnedEditorClose){case"keyboardAndMouse":return se===ne.MOUSE||se===ne.KEYBOARD;case"mouse":return se===ne.MOUSE;case"keyboard":return se===ne.KEYBOARD}return!1}e.$nG=new V;var K;(function(J){J[J.LEFT=0]="LEFT",J[J.RIGHT=1]="RIGHT"})(K||(e.CloseDirection=K={}));class Y{constructor(){this.c=new Map,this.d=new Map}start(U){const se=this.a=U.get(L.$Bi);for(const[ae,te]of this.c)this.e(ae,te,se);this.c.clear()}e(U,se,ae){const te=ae.createInstance(se);this.d.set(U,te)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,h.$ng)(this.b)}registerEditorSerializer(U,se){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,se,this.a):this.c.set(U,se),(0,R.$Rc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}T.$oo.add(e.$1F.EditorFactory,new Y);async function ee(J,U,se){return!J||!J.length?[]:await Promise.all(J.map(async ae=>{const te=C.URI.revive(ae.fileUri);if(!te){se.info("Cannot resolve the path because it is not valid.",ae);return}if(!await U.canHandleResource(te)){se.info("Cannot resolve the path because it cannot be handled",ae);return}let le=ae.exists,x=ae.type;if(typeof le!="boolean"||typeof x!="number")try{x=(await U.stat(te)).isDirectory?b.FileType.Directory:b.FileType.Unknown,le=!0}catch(pe){se.error(pe),le=!1}if(!le&&ae.openOnlyIfExists){se.info("Cannot resolve the path because it does not exist",ae);return}if(x===b.FileType.Directory){se.info("Cannot resolve the path because it is a directory",ae);return}const oe={...ae.options,pinned:!0};return le?{resource:te,options:oe}:{resource:te,options:oe,forceUntitled:!0}}))}var ue;(function(J){J[J.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",J[J.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function re(J){const U=J;if(!U)return!1;const se=U;if(se.modified)return re(se.modified);const ae=U;return!!(ae.contributionsState&&ae.viewState&&Array.isArray(ae.cursorState))}function ye(J){return(0,I.$oj)(J)}function me(J,U,se){const ae=(0,I.$pj)(J,U);return ae.forceMessage=se?.forceMessage,ae.forceSeverity=se?.forceSeverity,ae.allowDialog=se?.allowDialog,ae}}),define(Se[255],De([1,0,4,8,5,3,28,36,24,82,244]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zG=e.$yG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$xG=e.ViewContentGroups=e.$vG=e.ViewContainerLocation=e.Extensions=e.$uG=e.$tG=e.$sG=void 0,e.$wG=P,e.$sG="views",e.$tG=(0,h.localize)(12219,null),e.$uG=(0,I.$yx)("default-view-icon",c.$2j.window,(0,h.localize)(12220,null));var S;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(S||(e.Extensions=S={}));var u;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel",o[o.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$vG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function P(o){switch(o){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class w extends R.$Tc{constructor(){super(...arguments),this.c=this.B(new r.$je),this.onDidRegister=this.c.event,this.f=this.B(new r.$je),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(n,d,l){const g=this.get(n.id);if(g)return g;const E=n;return E.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,L.$wc)(this.g,d,[]).push(E),l?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:d}),E}deregisterViewContainer(n){for(const d of this.g.keys()){const l=this.g.get(d),g=l?.indexOf(n);if(g!==-1){l?.splice(g,1),l.length===0&&this.g.delete(d),this.f.fire({viewContainer:n,viewContainerLocation:d});return}}}get(n){return this.all.filter(d=>d.id===n)[0]}getViewContainers(n){return[...this.g.get(n)||[]]}getViewContainerLocation(n){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(l=>l?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.h.find(d=>this.getViewContainerLocation(d)===n)}}T.$oo.add(S.ViewContainersRegistry,new w);var a;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(a||(e.ViewContentGroups=a={}));function m(o,n){const d=o.group??a.More,l=n.group??a.More;return d!==l?d.localeCompare(l):(o.order??5)-(n.order??5)}class $ extends R.$Tc{constructor(){super(...arguments),this.c=this.B(new r.$je),this.onViewsRegistered=this.c.event,this.f=this.B(new r.$je),this.onViewsDeregistered=this.f.event,this.g=this.B(new r.$je),this.onDidChangeContainer=this.g.event,this.h=this.B(new r.$je),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Gc}registerViews(n,d){this.registerViews2([{views:n,viewContainer:d}])}registerViews2(n){n.forEach(({views:d,viewContainer:l})=>this.r(d,l)),this.c.fire(n)}deregisterViews(n,d){const l=this.s(n,d);l.length&&this.f.fire({views:l,viewContainer:d})}moveViews(n,d){for(const l of this.m.keys())if(l!==d){const g=this.s(n,l);g.length&&(this.r(g,d),this.g.fire({views:g,from:l,to:d}))}}getViews(n){return this.m.get(n)||[]}getView(n){for(const d of this.j){const l=(this.m.get(d)||[]).filter(g=>g.id===n)[0];if(l)return l}return null}getViewContainer(n){for(const d of this.j)if((this.m.get(d)||[]).filter(g=>g.id===n)[0])return d;return null}registerViewWelcomeContent(n,d){return this.n.add(n,d),this.h.fire(n),(0,R.$Rc)(()=>{this.n.delete(n,d),this.h.fire(n)})}registerViewWelcomeContent2(n,d){const l=new Map;for(const[g,E]of d)this.n.add(n,E),l.set(g,(0,R.$Rc)(()=>{this.n.delete(n,E),this.h.fire(n)}));return this.h.fire(n),l}getViewWelcomeContent(n){const d=[];return this.n.forEach(n,l=>d.push(l)),d.sort(m)}r(n,d){let l=this.m.get(d);l||(l=[],this.m.set(d,l),this.j.push(d));for(const g of n){if(this.getView(g.id)!==null)throw new Error((0,h.localize)(12221,null,g.id));l.push(g)}}s(n,d){const l=this.m.get(d);if(!l)return[];const g=[],E=[];for(const D of l)n.includes(D)?g.push(D):E.push(D);return g.length&&(E.length?this.m.set(d,E):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),g}}T.$oo.add(S.ViewsRegistry,new $),e.$xG=(0,C.$Ci)("viewDescriptorService");var f;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(f||(e.ViewVisibilityState=f={}));var i;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class s{constructor(n,d){this.c=!1,this.d=!1,(0,b.$eo)(this,n),this.d=!!d,this.resolve=async l=>{if(d&&!this.c){const g=await d(l);g&&(this.tooltip=this.tooltip??g.tooltip,this.command=this.command??g.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$yG=s;class t extends Error{constructor(n){super((0,h.localize)(12222,null,n)),this.name="NoTreeViewError"}static is(n){return n.name==="NoTreeViewError"}}e.$zG=t}),define(Se[256],De([1,0,8,35]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=void 0,e.$DG=new h.$Tj("chatSessionResponseVote","",{type:"string",description:(0,r.localize)(8342,null)}),e.$EG=new h.$Tj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,r.localize)(8343,null)}),e.$FG=new h.$Tj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,r.localize)(8344,null)}),e.$GG=new h.$Tj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,r.localize)(8345,null)}),e.$HG=new h.$Tj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,r.localize)(8346,null)}),e.$IG=new h.$Tj("chatResponse",!1,{type:"boolean",description:(0,r.localize)(8347,null)}),e.$JG=new h.$Tj("chatRequest",!1,{type:"boolean",description:(0,r.localize)(8348,null)}),e.$KG=new h.$Tj("chatEditApplied",!1,{type:"boolean",description:(0,r.localize)(8349,null)}),e.$LG=new h.$Tj("chatInputHasText",!1,{type:"boolean",description:(0,r.localize)(8350,null)}),e.$MG=new h.$Tj("chatInputHasFocus",!1,{type:"boolean",description:(0,r.localize)(8351,null)}),e.$NG=new h.$Tj("inChatInput",!1,{type:"boolean",description:(0,r.localize)(8352,null)}),e.$OG=new h.$Tj("inChat",!1,{type:"boolean",description:(0,r.localize)(8353,null)}),e.$PG=new h.$Tj("chatIsEnabled",!1,{type:"boolean",description:(0,r.localize)(8354,null)}),e.$QG=new h.$Tj("chatCursorAtTop",!1),e.$RG=new h.$Tj("chatInputHasAgent",!1),e.$SG=new h.$Tj("chatLocation",void 0),e.$TG=new h.$Tj("quickChatHasFocus",!1,{type:"boolean",description:(0,r.localize)(8355,null)})}),define(Se[153],De([1,0,131,7,20,4,39,3,51,182,12,35,23,5,11,115,237,151,256]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.ChatAgentLocation=void 0,e.$XH=d,e.$YH=l;var s;(function(g){g.Panel="panel",g.Terminal="terminal",g.Notebook="notebook",g.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function(g){function E(D){switch(D){case"panel":return g.Panel;case"terminal":return g.Terminal;case"notebook":return g.Notebook;case"editor":return g.Editor}return g.Panel}g.fromRaw=E}(s||(e.ChatAgentLocation=s={})),e.$SH=(0,P.$Ci)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(E){this.f=E,this.b=new Map,this.d=new R.$je,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=f.$PG.bindTo(this.f)}registerAgent(E,D){if(this.getAgent(E))throw new Error(`Agent already registered: ${JSON.stringify(E)}`);const k=this,A=D.slashCommands;D={...D,get slashCommands(){return A.filter(v=>!v.when||k.f.contextMatchesRules(S.$Aj.deserialize(v.when)))}};const p={data:D};return this.b.set(E,p),(0,T.$Rc)(()=>{this.b.delete(E),this.d.fire(void 0)})}registerAgentImplementation(E,D){const y=this.b.get(E);if(!y)throw new Error(`Unknown agent: ${JSON.stringify(E)}`);if(y.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(E)}`);return y.data.isDefault&&this.e.set(!0),y.impl=D,this.d.fire(new o(y.data,D)),(0,T.$Rc)(()=>{y.impl=void 0,this.d.fire(void 0),y.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(E,D){E.isDynamic=!0;const y={data:E,impl:D};return this.b.set(E.id,y),this.d.fire(new o(E,D)),(0,T.$Rc)(()=>{this.b.delete(E.id),this.d.fire(void 0)})}registerAgentCompletionProvider(E,D){return this.g.set(E,D),{dispose:()=>{this.g.delete(E)}}}async getAgentCompletionItems(E,D,y){return await this.g.get(E)?.(D,y)??[]}updateAgent(E,D){const y=this.b.get(E);if(!y?.impl)throw new Error(`No activated agent with id ${JSON.stringify(E)} registered`);y.data.metadata={...y.data.metadata,...D},this.d.fire(new o(y.data,y.impl))}getDefaultAgent(E){return(0,r.$eb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(E))}getContributedDefaultAgent(E){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(E))}getSecondaryAgent(){return L.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getAgent(E){if(this.h(E))return this.b.get(E)?.data}h(E){const D=this.b.get(E);return!D?.data.when||this.f.contextMatchesRules(S.$Aj.deserialize(D.data.when))}getAgentByFullyQualifiedId(E){const D=L.Iterable.find(this.b.values(),y=>d(y.data)===E)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(E=>E.data).filter(E=>this.h(E.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).filter(E=>this.h(E.data.id)).map(E=>new o(E.data,E.impl))}getAgentsByName(E){return this.getAgents().filter(D=>D.name===E)}agentHasDupeName(E){const D=this.getAgent(E);return D?this.getAgentsByName(D.name).filter(y=>y.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(E,D,y,k,A){const p=this.b.get(E);if(!p?.impl)throw new Error(`No activated agent with id "${E}"`);return await p.impl.invoke(D,y,k,A)}async getFollowups(E,D,y,k,A){const p=this.b.get(E);if(!p?.impl)throw new Error(`No activated agent with id "${E}"`);return p.impl?.provideFollowups?p.impl.provideFollowups(D,y,k,A):[]}};e.$TH=t,e.$TH=t=Ye([Ve(0,S.$Uj)],t);class o{constructor(E,D){this.b=E,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}async invoke(E,D,y,k){return this.d.invoke(E,D,y,k)}async provideFollowups(E,D,y,k){return this.d.provideFollowups?this.d.provideFollowups(E,D,y,k):[]}provideWelcomeMessage(E,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E,D)}provideSampleQuestions(E,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E,D)}}e.$UH=o,e.$VH=(0,P.$Ci)("chatAgentNameService");let n=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(E,D,y,k){if(this.g=D,this.h=y,this.i=k,this.e=(0,c.$4d)(this,Object.create(null)),this.f=!1,!E.chatParticipantRegistry)return;this.d=E.chatParticipantRegistry;const A=k.get(i.b,$.StorageScope.APPLICATION);try{this.e.set(JSON.parse(A??"{}"),void 0)}catch{k.remove(i.b,$.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(E=>this.h.warn("Failed to fetch chat participant registry",E)).then(()=>(0,h.$Dh)(5*60*1e3)).then(()=>this.j())}async k(){const E=await this.g.request({type:"GET",url:this.d},C.CancellationToken.None);if(E.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,m.$$p)(E);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const y=D.restrictedChatParticipants;this.e.set(y,void 0),this.i.store(i.b,JSON.stringify(y),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE)}getAgentNameRestriction(E){const D=this.l(E.name,E).get(),y=!E.fullName||this.l(E.fullName.replace(/\s/g,""),E).get();return D&&y}l(E,D){return this.e.map(k=>k[E.toLowerCase()]).map(k=>k?k.some(A=>(0,I.$Df)(A,A.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$WH=n,e.$WH=n=i=Ye([Ve(0,a.$qk),Ve(1,m.$5p),Ve(2,w.$0j),Ve(3,$.$fq)],n);function d(g){return`${g.extensionId.value}.${g.id}`}function l(g){const E="name"in g?g:{...g,name:g.id};return"extensionPublisherId"in E||(E.extensionPublisherId=E.extensionPublisher??""),"extensionDisplayName"in E||(E.extensionDisplayName=""),"extensionId"in E||(E.extensionId=new u.$on("")),(0,b.$_h)(E)}}),define(Se[257],De([1,0,2,30,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rH=e.$qH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$oH=R,e.$pH=L;function R(c){return!!c&&typeof c=="object"&&"uri"in c&&c.uri instanceof r.URI&&"version"in c&&typeof c.version=="number"&&"ranges"in c&&Array.isArray(c.ranges)&&c.ranges.every(h.$Lt.isIRange)}function L(c){return!!c&&typeof c=="object"&&"documents"in c&&Array.isArray(c.documents)&&c.documents.every(R)}var T;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(T||(e.ChatAgentVoteDirection=T={}));var b;(function(c){c[c.Action=1]="Action",c[c.Toolbar=2]="Toolbar"})(b||(e.ChatCopyKind=b={})),e.$qH=(0,C.$Ci)("IChatService"),e.$rH="accessibility.voice.keywordActivation"}),define(Se[154],De([1,0,4,7,8]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wtb=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new r.$je,this.o=new r.$je,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,b,c,I){const S={command:T};if(b&&Object.keys(b).length>0&&(S.arguments=b),this.u("request",S),typeof I=="number"){const u=setTimeout(()=>{clearTimeout(u);const P=this.f.get(S.seq);if(P){this.f.delete(S.seq);const w={type:"response",seq:0,request_seq:S.seq,success:!1,command:T,message:(0,C.localize)(7458,null,I,T)};P(w)}},I)}return c&&this.f.set(S.seq,c),S.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,b){return T.type!=="event"||b.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,h.$Dh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const b=T,c=this.f.get(b.request_seq);c&&(this.f.delete(b.request_seq),c(b));break}}}}u(T,b){b.type=T,b.seq=this.d++,this.sendMessage(b)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((b,c)=>T.set(c,b)),await(0,h.$Dh)(500),T.forEach((b,c)=>{b({type:"response",seq:0,request_seq:c,success:!1,command:"canceled",message:"canceled"}),this.f.delete(c)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Wtb=R}),define(Se[119],De([1,0,2,8,35,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$LK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$JK=e.MemoryRangeType=e.State=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=void 0,e.$IK=b,e.$KK=I,h=Ue(h),e.$wJ="workbench.view.debug",e.$xJ="workbench.debug.variablesView",e.$yJ="workbench.debug.watchExpressionsView",e.$zJ="workbench.debug.callStackView",e.$AJ="workbench.debug.loadedScriptsView",e.$BJ="workbench.debug.breakPointsView",e.$CJ="workbench.debug.disassemblyView",e.$DJ="workbench.panel.repl",e.$EJ="workbench.panel.repl.view",e.$FJ=new C.$Tj("debugType",void 0,{type:"string",description:h.localize(7395,null)}),e.$GJ=new C.$Tj("debugConfigurationType",void 0,{type:"string",description:h.localize(7396,null)}),e.$HJ=new C.$Tj("debugState","inactive",{type:"string",description:h.localize(7397,null)}),e.$IJ="debugUx",e.$JJ=new C.$Tj(e.$IJ,"default",{type:"string",description:h.localize(7398,null)}),e.$KJ=new C.$Tj("hasDebugged",!1,{type:"boolean",description:h.localize(7399,null)}),e.$LJ=new C.$Tj("inDebugMode",!1,{type:"boolean",description:h.localize(7400,null)}),e.$MJ=new C.$Tj("inDebugRepl",!1,{type:"boolean",description:h.localize(7401,null)}),e.$NJ=new C.$Tj("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(7402,null)}),e.$OJ=new C.$Tj("inBreakpointWidget",!1,{type:"boolean",description:h.localize(7403,null)}),e.$PJ=new C.$Tj("breakpointsFocused",!0,{type:"boolean",description:h.localize(7404,null)}),e.$QJ=new C.$Tj("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(7405,null)}),e.$RJ=new C.$Tj("watchExpressionsExist",!1,{type:"boolean",description:h.localize(7406,null)}),e.$SJ=new C.$Tj("variablesFocused",!0,{type:"boolean",description:h.localize(7407,null)}),e.$TJ=new C.$Tj("expressionSelected",!1,{type:"boolean",description:h.localize(7408,null)}),e.$UJ=new C.$Tj("breakpointInputFocused",!1,{type:"boolean",description:h.localize(7409,null)}),e.$VJ=new C.$Tj("callStackItemType",void 0,{type:"string",description:h.localize(7410,null)}),e.$WJ=new C.$Tj("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(7411,null)}),e.$XJ=new C.$Tj("callStackItemStopped",!1,{type:"boolean",description:h.localize(7412,null)}),e.$YJ=new C.$Tj("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(7413,null)}),e.$ZJ=new C.$Tj("watchItemType",void 0,{type:"string",description:h.localize(7414,null)}),e.$1J=new C.$Tj("canViewMemory",void 0,{type:"boolean",description:h.localize(7415,null)}),e.$2J=new C.$Tj("breakpointItemType",void 0,{type:"string",description:h.localize(7416,null)}),e.$3J=new C.$Tj("breakpointItemBytes",void 0,{type:"boolean",description:h.localize(7417,null)}),e.$4J=new C.$Tj("breakpointHasModes",!1,{type:"boolean",description:h.localize(7418,null)}),e.$5J=new C.$Tj("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(7419,null)}),e.$6J=new C.$Tj("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(7420,null)}),e.$7J=new C.$Tj("loadedScriptsItemType",void 0,{type:"string",description:h.localize(7421,null)}),e.$8J=new C.$Tj("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(7422,null)}),e.$9J=new C.$Tj("focusedSessionIsNoDebug",!1,{type:"boolean",description:h.localize(7423,null)}),e.$0J=new C.$Tj("stepBackSupported",!1,{type:"boolean",description:h.localize(7424,null)}),e.$$J=new C.$Tj("restartFrameSupported",!1,{type:"boolean",description:h.localize(7425,null)}),e.$_J=new C.$Tj("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(7426,null)}),e.$aK=new C.$Tj("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(7427,null)}),e.$bK=new C.$Tj("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(7428,null)}),e.$cK=new C.$Tj("breakpointsExist",!1,{type:"boolean",description:h.localize(7429,null)}),e.$dK=new C.$Tj("debuggersAvailable",!1,{type:"boolean",description:h.localize(7430,null)}),e.$eK=new C.$Tj("debugExtensionAvailable",!0,{type:"boolean",description:h.localize(7431,null)}),e.$fK=new C.$Tj("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(7432,null)}),e.$gK=new C.$Tj("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(7433,null)}),e.$hK=new C.$Tj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:h.localize(7434,null)}),e.$iK=new C.$Tj("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(7435,null)}),e.$jK=new C.$Tj("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(7436,null)}),e.$kK=new C.$Tj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(7437,null)}),e.$lK=new C.$Tj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(7438,null)}),e.$mK=new C.$Tj("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(7439,null)}),e.$nK=new C.$Tj("suspendDebuggeeSupported",!1,{type:"boolean",description:h.localize(7440,null)}),e.$oK=new C.$Tj("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(7441,null)}),e.$pK=new C.$Tj("variableIsReadonly",!1,{type:"boolean",description:h.localize(7442,null)}),e.$qK=new C.$Tj("variableValue",!1,{type:"string",description:h.localize(7443,null)}),e.$rK=new C.$Tj("variableType",!1,{type:"string",description:h.localize(7444,null)}),e.$sK=new C.$Tj("variableInterfaces",!1,{type:"array",description:h.localize(7445,null)}),e.$tK=new C.$Tj("variableName",!1,{type:"string",description:h.localize(7446,null)}),e.$uK=new C.$Tj("variableLanguage",!1,{type:"string",description:h.localize(7447,null)}),e.$vK=new C.$Tj("variableExtensionId",!1,{type:"string",description:h.localize(7448,null)}),e.$wK=new C.$Tj("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(7449,null)}),e.$xK=new C.$Tj("multiSessionRepl",!1,{type:"boolean",description:h.localize(7450,null)}),e.$yK=new C.$Tj("multiSessionDebug",!1,{type:"boolean",description:h.localize(7451,null)}),e.$zK=new C.$Tj("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(7452,null)}),e.$AK=new C.$Tj("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(7453,null)}),e.$BK=new C.$Tj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(7454,null)}),e.$CK=new C.$Tj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(7455,null)});const L=i=>h.localize(7456,null,i);e.$DK=L,e.$EK="editor.contrib.debug",e.$FK="editor.contrib.breakpoint",e.$GK="debug",e.$HK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(7457,null)};var T;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(T||(e.State=T={}));function b(i){switch(i){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var c;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(c||(e.MemoryRangeType=c={})),e.$JK="vscode-debug-memory";function I(i){const s=i.presentationHint??i.source.presentationHint;return s==="deemphasize"||s==="subtle"}var S;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(S||(e.DataBreakpointSetType=S={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var P;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$LK=(0,R.$Ci)("debugService");var w;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var a;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(a||(e.DebugVisualizationType=a={}));var m;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var $;(function(i){i.deserialize=s=>s,i.serialize=s=>s})($||(e.IDebugVisualizationTreeItem=$={}));var f;(function(i){i.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:r.URI.revive(s.iconPath.light),dark:r.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),i.serialize=s=>s})(f||(e.IDebugVisualization=f={}))}),define(Se[258],De([1,0,12,2,16,24,14,30,20,18]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dI=void 0,e.$4H=S,e.$5H=u,e.$6H=P,e.$7H=w,e.$8H=a,e.$9H=m,e.$0H=$,e.$$H=i,e.$_H=o,e.$aI=n,e.$bI=l,e.$cI=E;const I=/{([^}]+)}/g;function S(y,k,A){return y.replace(I,function(p,v){return k&&v.length>0&&v[0]!=="_"?p:A&&A.hasOwnProperty(v)?A[v]:p})}function u(y){const k={};for(const A of Object.keys(y))A.startsWith("!")||(k[A]=y[A]);return k}function P(y){return y.configuration.request==="attach"&&!w(y)&&(!y.parentSession||P(y.parentSession))}function w(y){let k=y.configuration.type;if(k)return k==="vslsShare"&&(k=y.configuration.adapterProxy.configuration.type),(0,r.$Df)(k,"extensionhost")||(0,r.$Df)(k,"pwa-extensionhost")?y:y.parentSession?w(y.parentSession):void 0}function a(y){return y.type&&(y.label||y.program||y.runtime)}function m(y,k,A){let p,v=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=F.exec(y);){const O=N.index+1,j=O+N[0].length;if(O<=k&&j>=A){p=N[0],v=O;break}}if(p){const O=/(\w|\p{L})+/gu;let j=null;for(;(j=O.exec(p))&&!(j.index+1+v+j[0].length>=A););j&&(p=p.substring(0,O.lastIndex))}return p?{start:v,end:v+p.length-1}:{start:0,end:0}}async function $(y,k,A,p){if(y.evaluatableExpressionProvider.has(k)){const v=y.evaluatableExpressionProvider.ordered(k),F=(0,c.$Gb)(await Promise.all(v.map(async N=>{try{return await N.provideEvaluatableExpression(k,A,p??b.CancellationToken.None)}catch{return}})));if(F.length>0){let N=F[0].expression;const O=F[0].range;return N||(N=k.getLineContent(A.lineNumber).substring(O.startColumn-1,O.endColumn-1)),{range:O,matchingExpression:N}}}else{const v=k.getLineContent(A.lineNumber),{start:F,end:N}=m(v,A.column,A.column),O=v.substring(F-1,N);return{matchingExpression:O,range:new T.$Lt(A.lineNumber,F,A.lineNumber,F+O.length)}}return null}const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(y){return!!(y&&y.match(f))}function s(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(i(y.path))return h.URI.parse(y.path);if((0,C.$hc)(y.path))return h.URI.file(y.path)}return y.path}function t(y){if(typeof y.path=="object"){const k=h.URI.revive(y.path);if(k)return k.scheme===L.Schemas.file?k.fsPath:k.toString()}return y.path}function o(y,k){const A=k?s:t,p=(0,R.$bo)(y);return d(p,(v,F)=>{v&&F&&(F.path=A(F))}),p}function n(y,k){const A=k?s:t,p=(0,R.$bo)(y);return d(p,(v,F)=>{!v&&F&&(F.path=A(F))}),p}function d(y,k){switch(y.type){case"event":{const A=y;switch(A.event){case"output":k(!1,A.body.source);break;case"loadedSource":k(!1,A.body.source);break;case"breakpoint":k(!1,A.body.breakpoint.source);break;default:break}break}case"request":{const A=y;switch(A.command){case"setBreakpoints":k(!0,A.arguments.source);break;case"breakpointLocations":k(!0,A.arguments.source);break;case"source":k(!0,A.arguments.source);break;case"gotoTargets":k(!0,A.arguments.source);break;case"launchVSCode":A.arguments.args.forEach(p=>k(!1,p));break;default:break}break}case"response":{const A=y;if(A.success&&A.body)switch(A.command){case"stackTrace":A.body.stackFrames.forEach(p=>k(!1,p.source));break;case"loadedSources":A.body.sources.forEach(p=>k(!1,p));break;case"scopes":A.body.scopes.forEach(p=>k(!1,p.source));break;case"setFunctionBreakpoints":A.body.breakpoints.forEach(p=>k(!1,p.source));break;case"setBreakpoints":A.body.breakpoints.forEach(p=>k(!1,p.source));break;case"disassemble":A.body?.instructions.forEach(v=>k(!1,v.location));break;default:break}break}}}function l(y){return y.filter(k=>!k.presentation?.hidden).sort((k,A)=>k.presentation?A.presentation?k.presentation.group?A.presentation.group?k.presentation.group!==A.presentation.group?k.presentation.group.localeCompare(A.presentation.group):g(k.presentation.order,A.presentation.order):-1:A.presentation.group?1:g(k.presentation.order,A.presentation.order):-1:A.presentation?1:0)}function g(y,k){return typeof y!="number"?typeof k!="number"?0:1:typeof k!="number"?-1:y-k}async function E(y,k){const A=y.getValue("debug.saveBeforeStart",{overrideIdentifier:k.activeTextEditorLanguageId});if(A!=="none"&&(await k.saveAll(),A==="allEditorsInActiveGroup")){const p=k.activeEditorPane;p&&p.input.resource?.scheme===L.Schemas.untitled&&await k.save({editor:p.input,groupId:p.group.id})}await y.reloadConfiguration()}const D=(y,k)=>!y||!k?y===k:y.name===k.name&&y.path===k.path&&y.sourceReference===k.sourceReference;e.$dI=D}),define(Se[259],De([1,0,56,67,24,16,10,12,33,8,154]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hrc=e.$grc=e.$frc=e.$erc=e.$drc=void 0,r=Ue(r),h=Ue(h),C=Ue(C),R=Ue(R),L=Ue(L),T=Ue(T),c=Ue(c);class S extends I.$Wtb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t($,f){this.l=f,this.p=Buffer.allocUnsafe(0),this.r=-1,$.on("data",i=>this.v(i))}sendMessage($){if(this.l){const f=JSON.stringify($);this.l.write(`Content-Length: ${Buffer.byteLength(f,"utf8")}${S.a}${f}`,"utf8")}}v($){for(this.p=Buffer.concat([this.p,$]);;){if(this.r>=0){if(this.p.length>=this.r){const f=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,f.length>0)try{this.acceptMessage(JSON.parse(f))}catch(i){this.n.fire(new Error((i.message||i)+`
`+f))}continue}}else{const f=this.p.indexOf(S.a);if(f!==-1){const s=this.p.toString("utf8",0,f).split(S.b);for(const t of s){const o=t.split(S.i);o[0]==="Content-Length"&&(this.r=Number(o[1]))}this.p=this.p.slice(f+S.a.length);continue}}break}}}e.$drc=S;class u extends S{startSession(){return new Promise(($,f)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),$(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):f(new Error("connection closed"))}),this.x.on("error",s=>{i?this.n.fire(s):f(s)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$erc=u;class P extends u{constructor($){super(),this.z=$}y($){return h.createConnection(this.z.port,this.z.host||"127.0.0.1",$)}}e.$frc=P;class w extends u{constructor($){super(),this.z=$}y($){return h.createConnection(this.z.path,$)}}e.$grc=w;class a extends S{constructor($,f){super(),this.y=$,this.z=f}async startSession(){const $=this.y.command,f=this.y.args,i=this.y.options||{};try{if($)if(R.$hc($)){if(!await b.Promises.exists($))throw new Error(c.localize(7318,null,$))}else $.indexOf("/")<0&&$.indexOf("\\")<0;else throw new Error(c.localize(7319,null,this.z));let s=process.env;if(i.env&&Object.keys(i.env).length>0&&(s=C.$eo(C.$bo(process.env),i.env)),$==="node")if(Array.isArray(f)&&f.length>0){const t=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:s,execArgv:t?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(o.cwd=i.cwd);const n=r.fork(f[0],f.slice(1),o);if(!n.pid)throw new Error(c.localize(7320,null,f[0]));this.x=n}else throw new Error(c.localize(7321,null));else{const t={env:s};i.cwd&&(t.cwd=i.cwd),this.x=r.spawn($,f,t)}this.x.on("error",t=>{this.n.fire(t)}),this.x.on("exit",(t,o)=>{this.o.fire(t)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",t=>{this.n.fire(t)}),this.x.stdin.on("error",t=>{this.n.fire(t)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(s){this.n.fire(s)}}async stopSession(){return this.x?(await this.w(),L.$j?new Promise(($,f)=>{const i=r.exec(`taskkill /F /T /PID ${this.x.pid}`,function(s,t,o){if(s)return f(s)});i.on("exit",$),i.on("error",f)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A($,f){if(!$)return;const i=Object.create(null);$.runtime&&($.runtime.indexOf("./")===0?i.runtime=R.$ic(f,$.runtime):i.runtime=$.runtime),$.runtimeArgs&&(i.runtimeArgs=$.runtimeArgs),$.program&&(R.$hc($.program)?i.program=$.program:i.program=R.$ic(f,$.program)),$.args&&(i.args=$.args);const s=$;return s.win&&(i.win=a.A(s.win,f)),s.winx86&&(i.winx86=a.A(s.winx86,f)),s.windows&&(i.windows=a.A(s.windows,f)),s.osx&&(i.osx=a.A(s.osx,f)),s.linux&&(i.linux=a.A(s.linux,f)),i}static platformAdapterExecutable($,f){let i=Object.create(null);f=f.toLowerCase();for(const l of $)if(l.contributes){const g=l.contributes.debuggers;g&&g.length>0&&g.filter(E=>typeof E.type=="string"&&T.$Df(E.type,f)).forEach(E=>{const D=a.A(E,l.extensionLocation.fsPath);i=C.$eo(i,D,l.isBuiltin)})}let s;L.$j&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?s=i.winx86||i.win||i.windows:L.$j?s=i.win||i.windows:L.$k?s=i.osx:L.$l&&(s=i.linux),s=s||i;const t=s.program||i.program,o=s.args||i.args,n=s.runtime||i.runtime,d=s.runtimeArgs||i.runtimeArgs;if(n)return{type:"executable",command:n,args:(d||[]).concat(typeof t=="string"?[t]:[]).concat(o||[])};if(t)return{type:"executable",command:t,args:o||[]}}}e.$hrc=a}),define(Se[260],De([1,0,56,31,10]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$irc=L,e.$jrc=b,r=Ue(r),C=Ue(C);function R(c,I){return new Promise((S,u)=>{let P="";const w=r.spawn(c,I);w.pid&&w.stdout.on("data",a=>{P+=a.toString()}),w.on("error",a=>{u(a)}),w.on("close",a=>{S(P)})})}async function L(c){if(c)if(C.$j){const I=await new Promise((S,u)=>{$e(["@vscode/windows-process-tree"],S,u)}).then(Ue);return new Promise(S=>{I.getProcessTree(c,u=>{S(!!u&&u.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(c)]).then(I=>{const S=I.trim();return!(S.length===0||S.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var T;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(T||(T={}));function b(c,I,S,u,P){c=c.trim().toLowerCase();let w;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?w=T.powershell:c.indexOf("cmd.exe")>=0?w=T.cmd:c.indexOf("bash")>=0?w=T.bash:C.$j?w=T.cmd:w=T.bash;let a,m=" ";switch(w){case T.powershell:if(a=$=>($=$.replace(/\'/g,"''"),$.length>0&&$.charAt($.length-1)==="\\"?`'${$}\\'`:`'${$}'`),u){const $=(0,h.$Hg)(u);$&&(m+=`${$}:; `),m+=`cd ${a(u)}; `}if(P)for(const $ in P){const f=P[$];f===null?m+=`Remove-Item env:${$}; `:m+=`\${env:${$}}='${f}'; `}if(I.length>0){const $=I.shift(),f=S?$:a($);m+=f[0]==="'"?`& ${f} `:`${f} `;for(const i of I)m+=i==="<"||i===">"||S?i:a(i),m+=" "}break;case T.cmd:if(a=$=>($=$.replace(/\"/g,'""'),$=$.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(f=>$.includes(f))||$.length===0?`"${$}"`:$),u){const $=(0,h.$Hg)(u);$&&(m+=`${$}: && `),m+=`cd ${a(u)} && `}if(P){m+='cmd /C "';for(const $ in P){let f=P[$];f===null?m+=`set "${$}=" && `:(f=f.replace(/[&^|<>]/g,i=>`^${i}`),m+=`set "${$}=${f}" && `)}}for(const $ of I)m+=$==="<"||$===">"||S?$:a($),m+=" ";P&&(m+='"');break;case T.bash:{a=f=>(f=f.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),f.length===0?'""':f);const $=f=>/[^\w@%\/+=,.:^-]/.test(f)?`'${f.replace(/'/g,"'\\''")}'`:f;if(u&&(m+=`cd ${a(u)} ; `),P){m+="/usr/bin/env";for(const f in P){const i=P[f];i===null?m+=` -u ${$(f)}`:m+=` ${$(`${f}=${i}`)}`}m+=" "}for(const f of I)m+=f==="<"||f===">"||S?f:a(f),m+=" ";break}}return m}}),define(Se[261],De([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TK=e.CellExecutionUpdateType=void 0;var h;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(h||(e.CellExecutionUpdateType=h={})),e.$TK=(0,r.$Ci)("INotebookExecutionService")}),define(Se[262],De([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XK=e.$WK=e.ProxyKernelState=e.$VK=void 0,e.$VK=100;var h;(function(C){C[C.Disconnected=1]="Disconnected",C[C.Connected=2]="Connected",C[C.Initializing=3]="Initializing"})(h||(e.ProxyKernelState=h={})),e.$WK=(0,r.$Ci)("INotebookKernelService"),e.$XK=(0,r.$Ci)("INotebookKernelHistoryService")}),define(Se[263],De([1,0,3,30,58,208,111]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Zb=void 0;class T extends r.$Tc{constructor(c,I,S){super(),this._source=c,this.b=I,this.c=S,this.a=void 0}f(c){const I=c.getLineCount();return new h.$Lt(1,1,I,this.g(c,I))}g(c,I){if(I<1||I>c.getLineCount())throw new Error("Illegal value for lineNumber");return c.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const c=new R.$tD;c.acceptChunk(this._source);const I=c.finish(!0),{textBuffer:S,disposable:u}=I.create(C.DefaultEndOfLine.LF);this.b=S,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(c=>{const I=new R.$tD;I.acceptChunk(c);const S=I.finish(!0),{textBuffer:u,disposable:P}=S.create(C.DefaultEndOfLine.LF);return this.B(P),u})),this.a}findInInputs(c){const S=new L.$hD(c,!1,!1,null).parseSearchRequest();if(!S)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,S,!0,5e3)}findInOutputs(c){const S=new L.$hD(c,!1,!1,null).parseSearchRequest();return S?this.outputTextBuffers.map(u=>{const P=u.findMatchesLineByLine(this.f(u),S,!0,5e3);if(P.length!==0)return{textBuffer:u,matches:P}}).filter(u=>!!u):[]}}e.$1Zb=T}),define(Se[73],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3I=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(R){R.Delimiter="\0"})(r||(e.TestIdPathParts=r={}));var h;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(h||(e.TestPosition=h={}));class C{static fromExtHostTestItem(L,T,b=L.parent){if(L._isRoot)return new C([T]);const c=[L.id];for(let I=b;I&&I.id!==T;I=I.parent)c.push(I.id);return c.push(T),new C(c.reverse())}static isRoot(L){return!L.includes(r.Delimiter)}static root(L){const T=L.indexOf(r.Delimiter);return T===-1?L:L.slice(0,T)}static fromString(L){return new C(L.split(r.Delimiter))}static join(L,T){return new C([...L.path,T])}static joinToString(L,T){return L.toString()+r.Delimiter+T}static parentId(L){const T=L.lastIndexOf(r.Delimiter);return T===-1?void 0:L.slice(0,T)}static localId(L){const T=L.lastIndexOf(r.Delimiter);return T===-1?L:L.slice(T+r.Delimiter.length)}static isChild(L,T){return T[L.length]===r.Delimiter&&T.startsWith(L)}static compare(L,T){return L===T?h.IsSame:C.isChild(L,T)?h.IsChild:C.isChild(T,L)?h.IsParent:h.Disconnected}static getLengthOfCommonPrefix(L,T){if(L===0)return 0;let b=0;for(;b<L-1;){for(let c=1;c<L;c++){const I=T(c-1),S=T(c);if(I.path[b]!==S.path[b])return b}b++}return b}constructor(L,T=L.length){if(this.path=L,this.d=T,L.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new C(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new C(this.path,L)}compare(L){if(typeof L=="string")return C.compare(this.toString(),L);for(let T=0;T<L.d&&T<this.d;T++)if(L.path[T]!==this.path[T])return h.Disconnected;return L.d>this.d?h.IsChild:L.d<this.d?h.IsParent:h.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+=r.Delimiter,this.c+=this.path[L]}return this.c}}e.$3I=C}),define(Se[74],De([1,0,2,57,30,73]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$$I=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$0I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$9I=e.$8I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$7I=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$6I=e.$5I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$4I=e.TestResultState=void 0;var L;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(L||(e.TestResultState=L={})),e.$4I={[L.Unset]:"unset",[L.Queued]:"queued",[L.Running]:"running",[L.Passed]:"passed",[L.Failed]:"failed",[L.Skipped]:"skipped",[L.Errored]:"errored"};var T;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var b;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.$5I=[b.Run,b.Debug,b.Coverage,b.HasNonDefaultProfile,b.HasConfigurable,b.SupportsContinuousRun];const c=M=>"runId"in M;e.$6I=c;var I;(function(M){M.serialize=W=>({range:W.range.toJSON(),uri:W.uri.toJSON()}),M.deserialize=(W,V)=>({range:C.$Lt.lift(V.range),uri:W.asCanonicalUri(r.URI.revive(V.uri))})})(I||(e.IRichLocation=I={}));var S;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(S||(e.TestMessageType=S={}));var u;(function(M){M.serialize=W=>({label:W.label,uri:W.uri?.toJSON(),position:W.position?.toJSON()}),M.deserialize=(W,V)=>({label:V.label,uri:V.uri?W.asCanonicalUri(r.URI.revive(V.uri)):void 0,position:V.position?h.$Kt.lift(V.position):void 0})})(u||(e.ITestMessageStackFrame=u={}));var P;(function(M){M.serialize=W=>({message:W.message,type:S.Error,expected:W.expected,actual:W.actual,contextValue:W.contextValue,location:W.location&&I.serialize(W.location),stackTrace:W.stackTrace?.map(u.serialize)}),M.deserialize=(W,V)=>({message:V.message,type:S.Error,expected:V.expected,actual:V.actual,contextValue:V.contextValue,location:V.location&&I.deserialize(W,V.location),stackTrace:V.stackTrace&&V.stackTrace.map(ne=>u.deserialize(W,ne))})})(P||(e.ITestErrorMessage=P={}));const w=(M,W)=>`${W?"s":"e"}${M}`;e.$7I=w;var a;(function(M){M.serialize=W=>({message:W.message,type:S.Output,offset:W.offset,length:W.length,location:W.location&&I.serialize(W.location)}),M.deserialize=(W,V)=>({message:V.message,type:S.Output,offset:V.offset,length:V.length,location:V.location&&I.deserialize(W,V.location)})})(a||(e.ITestOutputMessage=a={}));var m;(function(M){M.serialize=W=>W.type===S.Error?P.serialize(W):a.serialize(W),M.deserialize=(W,V)=>V.type===S.Error?P.deserialize(W,V):a.deserialize(W,V),M.isDiffable=W=>W.type===S.Error&&W.actual!==void 0&&W.expected!==void 0})(m||(e.ITestMessage=m={}));var $;(function(M){M.serializeWithoutMessages=W=>({state:W.state,duration:W.duration,messages:[]}),M.serialize=W=>({state:W.state,duration:W.duration,messages:W.messages.map(m.serialize)}),M.deserialize=(W,V)=>({state:V.state,duration:V.duration,messages:V.messages.map(ne=>m.deserialize(W,ne))})})($||(e.ITestTaskState=$={}));const f="\0",i=(M,W)=>M+f+W;e.$8I=i;const s=M=>{const W=M.indexOf(f);return{ctrlId:M.slice(0,W),tagId:M.slice(W+1)}};e.$9I=s;var t;(function(M){M.serialize=W=>({extId:W.extId,label:W.label,tags:W.tags,busy:W.busy,children:void 0,uri:W.uri?.toJSON(),range:W.range?.toJSON()||null,description:W.description,error:W.error,sortText:W.sortText}),M.deserialize=(W,V)=>({extId:V.extId,label:V.label,tags:V.tags,busy:V.busy,children:void 0,uri:V.uri?W.asCanonicalUri(r.URI.revive(V.uri)):void 0,range:V.range?C.$Lt.lift(V.range):null,description:V.description,error:V.error,sortText:V.sortText})})(t||(e.ITestItem=t={}));var o;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var n;(function(M){M.serialize=W=>({expand:W.expand,item:t.serialize(W.item)}),M.deserialize=(W,V)=>({controllerId:R.$3I.root(V.item.extId),expand:V.expand,item:t.deserialize(W,V.item)})})(n||(e.InternalTestItem=n={}));var d;(function(M){M.serialize=W=>{let V;return W.item&&(V={},W.item.label!==void 0&&(V.label=W.item.label),W.item.tags!==void 0&&(V.tags=W.item.tags),W.item.busy!==void 0&&(V.busy=W.item.busy),W.item.uri!==void 0&&(V.uri=W.item.uri?.toJSON()),W.item.range!==void 0&&(V.range=W.item.range?.toJSON()),W.item.description!==void 0&&(V.description=W.item.description),W.item.error!==void 0&&(V.error=W.item.error),W.item.sortText!==void 0&&(V.sortText=W.item.sortText)),{extId:W.extId,expand:W.expand,item:V}},M.deserialize=W=>{let V;return W.item&&(V={},W.item.label!==void 0&&(V.label=W.item.label),W.item.tags!==void 0&&(V.tags=W.item.tags),W.item.busy!==void 0&&(V.busy=W.item.busy),W.item.range!==void 0&&(V.range=W.item.range?C.$Lt.lift(W.item.range):null),W.item.description!==void 0&&(V.description=W.item.description),W.item.error!==void 0&&(V.error=W.item.error),W.item.sortText!==void 0&&(V.sortText=W.item.sortText)),{extId:W.extId,expand:W.expand,item:V}}})(d||(e.ITestItemUpdate=d={}));const l=(M,W)=>{W.expand!==void 0&&(M.expand=W.expand),W.item!==void 0&&(M.item=M.item?Object.assign(M.item,W.item):W.item)};e.$0I=l;var g;(function(M){M.serializeWithoutMessages=W=>({...n.serialize(W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map($.serializeWithoutMessages)}),M.serialize=W=>({...n.serialize(W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map($.serialize)}),M.deserialize=(W,V)=>({...n.deserialize(W,V),ownComputedState:V.ownComputedState,computedState:V.computedState,tasks:V.tasks.map(ne=>$.deserialize(W,ne)),retired:!0})})(g||(e.TestResultItem=g={}));var E;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(W,V)=>{W.covered+=V.covered,W.total+=V.total}})(E||(e.ICoverageCount=E={}));var D;(function(M){M.serialize=W=>({id:W.id,statement:W.statement,branch:W.branch,declaration:W.declaration,testIds:W.testIds,uri:W.uri.toJSON()}),M.deserialize=(W,V)=>({id:V.id,statement:V.statement,branch:V.branch,declaration:V.declaration,testIds:V.testIds,uri:W.asCanonicalUri(r.URI.revive(V.uri))}),M.empty=(W,V)=>({id:W,uri:V,statement:E.empty()})})(D||(e.IFileCoverage=D={}));function y(M){return{...M,location:M.location?.toJSON()}}function k(M){return M.location=M.location?h.$Kt.isIPosition(M.location)?h.$Kt.lift(M.location):C.$Lt.lift(M.location):void 0,M}e.$$I=3;var A;(function(M){M[M.Declaration=0]="Declaration",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})(A||(e.DetailType=A={}));var p;(function(M){M.serialize=W=>W.type===A.Declaration?F.serialize(W):N.serialize(W),M.deserialize=W=>W.type===A.Declaration?F.deserialize(W):N.deserialize(W)})(p||(e.CoverageDetails=p={}));var v;(function(M){M.serialize=y,M.deserialize=k})(v||(e.IBranchCoverage=v={}));var F;(function(M){M.serialize=y,M.deserialize=k})(F||(e.IDeclarationCoverage=F={}));var N;(function(M){M.serialize=W=>({...y(W),branches:W.branches?.map(v.serialize)}),M.deserialize=W=>({...k(W),branches:W.branches?.map(v.deserialize)})})(N||(e.IStatementCoverage=N={}));var O;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(O||(e.TestDiffOpType=O={}));var j;(function(M){M.deserialize=(W,V)=>V.op===O.Add?{op:V.op,item:n.deserialize(W,V.item)}:V.op===O.Update?{op:V.op,item:d.deserialize(V.item)}:V.op===O.DocumentSynced?{op:V.op,uri:W.asCanonicalUri(r.URI.revive(V.uri)),docv:V.docv}:V,M.serialize=W=>W.op===O.Add?{op:W.op,item:n.serialize(W.item)}:W.op===O.Update?{op:W.op,item:d.serialize(W.item)}:W})(j||(e.TestsDiffOp=j={}));class z{constructor(W){this.k=W,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(W){const V=this.w();for(const ne of W)switch(ne.op){case O.Add:this.l(n.deserialize(this.k,ne.item),V);break;case O.Update:this.p(d.deserialize(ne.item),V);break;case O.Remove:this.q(ne.itemId,V);break;case O.Retire:this.v(ne.itemId);break;case O.IncrementPendingExtHosts:this.updatePendingRoots(ne.amount);break;case O.AddTag:this.c.set(ne.tag.id,ne.tag);break;case O.RemoveTag:this.c.delete(ne.id);break}V.complete?.()}l(W,V){const ne=R.$3I.parentId(W.item.extId)?.toString();let B;if(!ne)B=this.x(W),this.g.add(B),this.f.set(W.item.extId,B);else if(this.f.has(ne)){const K=this.f.get(ne);K.children.add(W.item.extId),B=this.x(W,K),this.f.set(W.item.extId,B)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(W)}`);return}return V.add?.(B),W.expand===o.BusyExpanding&&this.h++,B}p(W,V){const ne=this.f.get(W.extId);if(ne)return W.expand!==void 0&&(ne.expand===o.BusyExpanding&&this.h--,W.expand===o.BusyExpanding&&this.h++),(0,e.$0I)(ne,W),V.update?.(ne),ne}q(W,V){const ne=this.f.get(W);if(!ne)return;const B=R.$3I.parentId(ne.item.extId)?.toString();B?this.f.get(B).children.delete(ne.item.extId):this.g.delete(ne);const K=[[W]];for(;K.length;)for(const Y of K.pop()){const ee=this.f.get(Y);ee&&(K.push(ee.children),this.f.delete(Y),V.remove?.(ee,ee!==ne),ee.expand===o.BusyExpanding&&this.h--)}}v(W){}updatePendingRoots(W){this.j+=W}w(){return{}}}e.$_I=z}),define(Se[264],De([1,0,137,8,74]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$BGb=e.$AGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var R;(function(S){S.ViewletId="workbench.view.extension.test",S.ExplorerViewId="workbench.view.testing",S.OutputPeekContributionId="editor.contrib.testingOutputPeek",S.DecorationsContributionId="editor.contrib.testingDecorations",S.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",S.CoverageViewId="workbench.view.testCoverage",S.ResultsPanelId="workbench.panel.testResults",S.ResultsViewId="workbench.panel.testResults.view",S.MessageLanguageId="vscodeInternalTestMessage"})(R||(e.Testing=R={}));var L;(function(S){S.List="list",S.Tree="true"})(L||(e.TestExplorerViewMode=L={}));var T;(function(S){S.ByLocation="location",S.ByStatus="status",S.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const b={[C.TestResultState.Errored]:(0,h.localize)(3158,null),[C.TestResultState.Failed]:(0,h.localize)(3159,null),[C.TestResultState.Passed]:(0,h.localize)(3160,null),[C.TestResultState.Queued]:(0,h.localize)(3161,null),[C.TestResultState.Running]:(0,h.localize)(3162,null),[C.TestResultState.Skipped]:(0,h.localize)(3163,null),[C.TestResultState.Unset]:(0,h.localize)(3164,null)},c=(S,u)=>(0,h.localize)(3165,null,(0,r.$Wk)(S),b[u]);e.$AGb=c,e.$BGb={[C.TestRunProfileBitset.Debug]:(0,h.localize)(3166,null),[C.TestRunProfileBitset.Run]:(0,h.localize)(3167,null),[C.TestRunProfileBitset.Coverage]:(0,h.localize)(3168,null)};var I;(function(S){S.CancelTestRefreshAction="testing.cancelTestRefresh",S.CancelTestRunAction="testing.cancelRun",S.ClearTestResultsAction="testing.clearTestResults",S.CollapseAllAction="testing.collapseAll",S.ConfigureTestProfilesAction="testing.configureProfile",S.ContinousRunUsingForTest="testing.continuousRunUsingForTest",S.CoverageAtCursor="testing.coverageAtCursor",S.CoverageByUri="testing.coverage.uri",S.CoverageClear="testing.coverage.close",S.CoverageCurrentFile="testing.coverageCurrentFile",S.CoverageFilterToTest="testing.coverageFilterToTest",S.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",S.CoverageLastRun="testing.coverageLastRun",S.CoverageSelectedAction="testing.coverageSelected",S.CoverageToggleToolbar="testing.coverageToggleToolbar",S.CoverageViewChangeSorting="testing.coverageViewChangeSorting",S.DebugAction="testing.debug",S.DebugAllAction="testing.debugAll",S.DebugAtCursor="testing.debugAtCursor",S.DebugByUri="testing.debug.uri",S.DebugCurrentFile="testing.debugCurrentFile",S.DebugFailedTests="testing.debugFailTests",S.DebugLastRun="testing.debugLastRun",S.DebugSelectedAction="testing.debugSelected",S.FilterAction="workbench.actions.treeView.testExplorer.filter",S.GetExplorerSelection="_testing.getExplorerSelection",S.GetSelectedProfiles="testing.getSelectedProfiles",S.GoToTest="testing.editFocusedTest",S.HideTestAction="testing.hideTest",S.OpenCoverage="testing.openCoverage",S.OpenOutputPeek="testing.openOutputPeek",S.RefreshTestsAction="testing.refreshTests",S.ReRunFailedTests="testing.reRunFailTests",S.ReRunLastRun="testing.reRunLastRun",S.RunAction="testing.run",S.RunAllAction="testing.runAll",S.RunAllWithCoverageAction="testing.coverageAll",S.RunAtCursor="testing.runAtCursor",S.RunByUri="testing.run.uri",S.RunCurrentFile="testing.runCurrentFile",S.RunSelectedAction="testing.runSelected",S.RunUsingProfileAction="testing.runUsing",S.RunWithCoverageAction="testing.coverage",S.SearchForTestExtension="testing.searchForTestExtension",S.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",S.ShowMostRecentOutputAction="testing.showMostRecentOutput",S.StartContinousRun="testing.startContinuousRun",S.StopContinousRun="testing.stopContinuousRun",S.TestingSortByDurationAction="testing.sortByDuration",S.TestingSortByLocationAction="testing.sortByLocation",S.TestingSortByStatusAction="testing.sortByStatus",S.TestingViewAsListAction="testing.viewAsList",S.TestingViewAsTreeAction="testing.viewAsTree",S.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",S.ToggleInlineTestOutput="testing.toggleInlineTestOutput",S.UnhideAllTestsAction="testing.unhideAllTests",S.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Se[120],De([1,0,7,4,3,65,74,73]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9P=e.$8P=e.$7P=e.$6P=e.$5P=e.TestItemEventOp=void 0;var b;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk",f[f.DocumentSynced=6]="DocumentSynced"})(b||(e.TestItemEventOp=b={}));const c=(f,i)=>f===i,S=Object.entries({range:(f,i)=>f===i?!0:!f||!i?!1:f.equalsRange(i),busy:c,label:c,description:c,error:c,sortText:c,tags:(f,i)=>!(f.length!==i.length||f.some(s=>!i.includes(s)))}),u=(f,i)=>{let s;for(const[t,o]of S)o(f[t],i[t])||(s?s[t]=i[t]:s={[t]:i[t]});return s};class P extends C.$Tc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new r.$Oh(()=>this.flushDiff(),200)),this.g=this.B(new h.$je),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case L.TestDiffOpType.DocumentSynced:{for(const s of this.m)if(s.op===L.TestDiffOpType.DocumentSynced&&s.uri===i.uri){s.docv=i.docv;return}break}case L.TestDiffOpType.Update:{const s=this.m[this.m.length-1];if(s){if(s.op===L.TestDiffOpType.Update&&s.item.extId===i.item.extId){(0,L.$0I)(s.item,i.item);return}if(s.op===L.TestDiffOpType.Add&&s.item.item.extId===i.item.extId){(0,L.$0I)(s.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,s){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||s>t.expandLevels)&&(t.expandLevels=s),t.expand===L.TestItemExpandState.Expandable){const o=this.M(t);return o.isOpen()?this.L(t,s-1):o.wait().then(()=>this.L(t,s-1))}else if(t.expand===L.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,s-1)):this.L(t,s-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,s){switch(s.op){case b.RemoveChild:this.O(T.$3I.joinToString(i.fullId,s.id));break;case b.Upsert:this.z(s.item,i);break;case b.Bulk:for(const t of s.ops)this.w(i,t);break;case b.SetTags:this.C(s.new,s.old,i.fullId.toString());break;case b.UpdateCanResolveChildren:this.J(i);break;case b.SetProp:this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:s.update}});break;case b.DocumentSynced:this.y(i.actual.uri);break;default:(0,R.$dd)(s)}}y(i){i&&this.pushDiff({op:L.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,s){const t=T.$3I.fromExtHostTestItem(i,this.root.id,s?.actual),o=this.s.getApiFor(i);o.parent&&o.parent!==s?.actual&&this.s.getChildren(o.parent).delete(i.id);let n=this.tree.get(t.toString());if(!n){n={fullId:t,actual:i,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:L.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(n.fullId.toString(),n),this.G(i,s),this.pushDiff({op:L.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(i)}}),this.I(i,n,s);return}if(n.actual===i){this.H(i,n,s);return}if(n.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,s);const d=this.s.getChildren(n.actual),l=n.actual,g=u(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,n.actual=i,n.resolveBarrier=void 0,n.expand=L.TestItemExpandState.NotExpandable,g&&(g.hasOwnProperty("tags")&&(this.C(i.tags,l.tags,t.toString()),delete g.tags),this.w(n,{op:b.SetProp,update:g})),this.I(i,n,s);for(const[D,y]of d)this.s.getChildren(i).get(y.id)||this.O(T.$3I.joinToString(t,y.id));const E=n.expandLevels;E!==void 0&&queueMicrotask(()=>{n.expand===L.TestItemExpandState.Expandable&&(n.expandLevels=void 0,this.expand(t.toString(),E))}),this.y(n.actual.uri)}C(i,s,t){const o=new Set(s.map(n=>n.id));for(const n of i)o.delete(n.id)||this.D(n);this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(n=>(0,L.$8I)(this.s.controllerId,n.id))}}}),o.forEach(this.F,this)}D(i){const s=this.j.get(i.id);s?s.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:L.TestDiffOpType.AddTag,tag:{id:(0,L.$8I)(this.s.controllerId,i.id)}}))}F(i){const s=this.j.get(i);s&&!--s.refCount&&(this.j.delete(i),this.pushDiff({op:L.TestDiffOpType.RemoveTag,id:(0,L.$8I)(this.s.controllerId,i)}))}G(i,s){this.s.getApiFor(i).parent=s&&s.actual!==this.root?s.actual:void 0}H(i,s,t){this.G(i,t);const o=this.s.getApiFor(i);o.parent=t?.actual,o.listener=n=>this.w(s,n),this.J(s)}I(i,s,t){this.H(i,s,t);for(const[o,n]of this.s.getChildren(i))this.z(n,s)}J(i){let s;this.h?i.resolveBarrier?s=i.resolveBarrier.isOpen()?L.TestItemExpandState.Expanded:L.TestItemExpandState.BusyExpanding:s=i.actual.canResolveChildren?L.TestItemExpandState.Expandable:L.TestItemExpandState.NotExpandable:s=L.TestItemExpandState.NotExpandable,s!==i.expand&&(i.expand=s,this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:s}}),s===L.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,s){if(s<0)return;const t=[];for(const[o,n]of this.s.getChildren(i.actual)){const d=this.expand(T.$3I.joinToString(i.fullId,n.id),s);(0,r.$oh)(d)&&t.push(d)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const n=new r.$Bh;return n.open(),n}i.expand=L.TestItemExpandState.BusyExpanding,this.N(i);const s=i.resolveBarrier=new r.$Bh,t=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let o;try{o=this.h(i.actual===this.root?void 0:i.actual)}catch(n){t(n)}return(0,r.$oh)(o)?o.catch(t).then(()=>{s.open(),this.J(i)}):(s.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const s=this.tree.get(i);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:L.TestDiffOpType.Remove,itemId:i});const t=[s];for(;t.length;){const o=t.pop();if(o){this.s.getApiFor(o.actual).listener=void 0;for(const n of o.actual.tags)this.F(n.id);this.tree.delete(o.fullId.toString());for(const[n,d]of this.s.getChildren(o.actual))t.push(this.tree.get(T.$3I.joinToString(o.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$5P=P;class w extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$6P=w;class a extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$7P=a;class m extends Error{constructor(i,s,t){super(`TestItem with ID "${i}" is from controller "${s}" and cannot be added as a child of an item from controller "${t}".`)}}e.$8P=m;const $=(f,i,s)=>{let t=new Map;return{get size(){return t.size},forEach(o,n){for(const d of t.values())o.call(n,d,this)},[Symbol.iterator](){return t.entries()},replace(o){const n=new Map,d=new Set(t.keys()),l={op:b.Bulk,ops:[]};for(const g of o){if(!(g instanceof s))throw new a(g.id);const E=i(g).controllerId;if(E!==f.controllerId)throw new m(g.id,E,f.controllerId);if(n.has(g.id))throw new w(g.id);n.set(g.id,g),d.delete(g.id),l.ops.push({op:b.Upsert,item:g})}for(const g of d.keys())l.ops.push({op:b.RemoveChild,id:g});f.listener?.(l),t=n},add(o){if(!(o instanceof s))throw new a(o.id);t.set(o.id,o),f.listener?.({op:b.Upsert,item:o})},delete(o){t.delete(o)&&f.listener?.({op:b.RemoveChild,id:o})},get(o){return t.get(o)},toJSON(){return Array.from(t.values())}}};e.$9P=$}),define(Se[155],De([1,0,120]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$P=e.$0P=void 0;const h=new WeakMap,C=(L,T)=>{const b={controllerId:T};return h.set(L,b),b};e.$0P=C;const R=L=>{const T=h.get(L);if(!T)throw new r.$7P(L?.id||"<unknown>");return T};e.$$P=R}),define(Se[121],De([1,0,26,14,2]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uDb=e.$tDb=e.$sDb=void 0,e.$vDb=R,e.$wDb=T,e.$sDb="vscode-cdn.net",e.$tDb=`vscode-resource.${e.$sDb}`,e.$uDb=`'self' https://*.${e.$sDb}`;function R(b,c){return b.scheme===h.Schemas.http||b.scheme===h.Schemas.https?b:(c&&c.authority&&c.isRemote&&b.scheme===h.Schemas.file&&(b=C.URI.from({scheme:h.Schemas.vscodeRemote,authority:c.authority,path:b.path})),C.URI.from({scheme:h.Schemas.https,authority:`${b.scheme}+${L(b.authority)}.${e.$tDb}`,path:b.path,fragment:b.fragment,query:b.query}))}function L(b){return b.replace(/./g,c=>{const I=c.charCodeAt(0);return I>=r.CharCode.a&&I<=r.CharCode.z||I>=r.CharCode.A&&I<=r.CharCode.Z||I>=r.CharCode.Digit0&&I<=r.CharCode.Digit9?c:"-"+I.toString(16).padStart(4,"0")})}function T(b){return b.replace(/-([0-9a-f]{4})/g,(c,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Se[265],De([1,0,4,3,121]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cpc=void 0;class R{constructor(T,b,c){this.d=T,this.e=b,this.f=c,this.a=0,this.b=new h.$Sc,this.c=new Map,this.b.add(b.onDidChangeVisibleTextEditors(()=>{const I=b.getVisibleTextEditors();for(const S of this.c.values())I.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,b,c,I,S){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===T){u=i;break}if(!u)throw new Error("not a visible editor");const P=this,w=this.a++,a=new r.$je,m=new r.$je,$=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,C.$vDb)(i,P.f)}get cspSource(){return C.$uDb}set options(i){this.b=i,P.d.$setOptions(w,i)}get options(){return this.b}set html(i){this.a=i,P.d.$setHtml(w,i)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(i){return P.d.$postMessage(w,i)}},f=new class{constructor(){this.editor=T,this.line=b,this.height=c,this.webview=$,this.onDidDispose=m.event}dispose(){P.c.has(w)&&(P.c.delete(w),P.d.$disposeEditorInset(w),m.fire(),m.dispose(),a.dispose())}};return this.d.$createEditorInset(w,u.id,u.value.document.uri,b+1,c,I||{},S.identifier,S.extensionLocation),this.c.set(w,{editor:T,inset:f,onDidReceiveMessage:a}),f}$onDidDispose(T){const b=this.c.get(T);b&&b.inset.dispose()}$onDidReceiveMessage(T,b){this.c.get(T)?.onDidReceiveMessage.fire(b)}}e.$cpc=R}),define(Se[156],De([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=e.$GM=e.$FM=void 0,e.$FM="__",e.$GM=(0,r.$Ci)("IAuthenticationService"),e.$HM=(0,r.$Ci)("IAuthenticationExtensionsService")}),define(Se[266],De([1,0,5]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Q=e.VariableKind=e.$3Q=void 0,e.$3Q=(0,r.$Ci)("configurationResolverService");var h;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(h||(e.VariableKind=h={}));class C extends Error{constructor(L,T){super(T),this.variable=L}}e.$4Q=C}),define(Se[267],De([1,0,16,55,17,24,10,107,8,266,12]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gR=void 0,r=Ue(r),h=Ue(h),C=Ue(C),R=Ue(R);class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(P,w,a,m){this.h=new Map,this.a=P,this.b=w,this.g=a,m&&(this.c=m.then($=>this.i($)))}i(P){if(L.$j){const w=Object.create(null);return Object.keys(P).forEach(a=>{w[a.toLowerCase()]=P[a]}),w}return P}resolveWithEnvironment(P,w,a){return this.l({env:this.i(P),userHome:void 0},w?w.uri:void 0,a)}async resolveAsync(P,w){const a={env:await this.c,userHome:await this.g};return this.l(a,P?P.uri:void 0,w)}async j(P,w,a,m){const $=R.$bo(w);L.$j&&$.windows?Object.keys($.windows).forEach(i=>$[i]=$.windows[i]):L.$k&&$.osx?Object.keys($.osx).forEach(i=>$[i]=$.osx[i]):L.$l&&$.linux&&Object.keys($.linux).forEach(i=>$[i]=$.linux[i]),delete $.windows,delete $.osx,delete $.linux;const f={env:await this.c,userHome:await this.g};return this.l(f,P?P.uri:void 0,$,a,m)}async resolveAnyAsync(P,w,a){return this.j(P,w,a)}async resolveAnyMap(P,w,a){const m=new Map;return{newConfig:await this.j(P,w,a,m),resolvedVariables:m}}resolveWithInteractionReplace(P,w,a,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,w,a,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,w){if(this.h.has(P))throw new Error("Variable "+P+" is contributed twice.");this.h.set(P,w)}async l(P,w,a,m,$){if(C.$cg(a))return this.m(P,w,a,m,$);if(Array.isArray(a))return Promise.all(a.map(f=>this.l(P,w,f,m,$)));if(C.$eg(a)){const f=Object.create(null),i=await Promise.all(Object.keys(a).map(async s=>[await this.m(P,w,s,m,$),await this.l(P,w,a[s],m,$)]));for(const[s,t]of i)f[s]=t;return f}return a}m(P,w,a,m,$){return(0,I.$vf)(a,S.VARIABLE_REGEXP,async(f,i)=>{if(i.includes(S.VARIABLE_LHS))return f;let s=await this.o(P,f,i,w,m);return $?.set(i,s),s!==f&&C.$cg(s)&&s.match(S.VARIABLE_REGEXP)&&(s=await this.m(P,w,s,m,$)),s})}n(P){return this.b?this.b.getUriLabel(P,{noPrefix:!0}):P.fsPath}async o(P,w,a,m,$){let f;const i=a.split(":");i.length>1&&(a=i[0],f=i[1]);const s=n=>{const d=this.a.getFilePath();if(d)return(0,T.$Xw)(d);throw new c.$4Q(n,(0,b.localize)(2058,null,w))},t=n=>{const d=s(n);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,T.$Xw)(l)}throw new c.$4Q(n,(0,b.localize)(2059,null,w,r.$mc(d)))},o=n=>{if(f){const d=this.a.getFolderUri(f);if(d)return d;throw new c.$4Q(n,(0,b.localize)(2060,null,w,f))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new c.$4Q(n,(0,b.localize)(2061,null,w)):new c.$4Q(n,(0,b.localize)(2062,null,w))};switch(a){case"env":if(f){if(P.env){const n=P.env[L.$j?f.toLowerCase():f];if(C.$cg(n))return n}return""}throw new c.$4Q(c.VariableKind.Env,(0,b.localize)(2063,null,w));case"config":if(f){const n=this.a.getConfigurationValue(m,f);if(C.$lg(n))throw new c.$4Q(c.VariableKind.Config,(0,b.localize)(2064,null,w,f));if(C.$eg(n))throw new c.$4Q(c.VariableKind.Config,(0,b.localize)(2065,null,w,f));return n}throw new c.$4Q(c.VariableKind.Config,(0,b.localize)(2066,null,w));case"command":return this.p(c.VariableKind.Command,w,f,$,"command");case"input":return this.p(c.VariableKind.Input,w,f,$,"input");case"extensionInstallFolder":if(f){const n=await this.a.getExtension(f);if(!n)throw new c.$4Q(c.VariableKind.ExtensionInstallFolder,(0,b.localize)(2067,null,w,f));return this.n(n.extensionLocation)}throw new c.$4Q(c.VariableKind.ExtensionInstallFolder,(0,b.localize)(2068,null,w));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,T.$Xw)(this.n(o(c.VariableKind.WorkspaceFolder)));case"cwd":return m||f?(0,T.$Xw)(this.n(o(c.VariableKind.Cwd))):h.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$Xw)(r.$mc(this.n(o(c.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(P.userHome)return P.userHome;throw new c.$4Q(c.VariableKind.UserHome,(0,b.localize)(2069,null,w))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new c.$4Q(c.VariableKind.LineNumber,(0,b.localize)(2070,null,w))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new c.$4Q(c.VariableKind.SelectedText,(0,b.localize)(2071,null,w))}case"file":return s(c.VariableKind.File);case"fileWorkspaceFolder":return t(c.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return r.$mc(t(c.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||f?r.$kc(this.n(o(c.VariableKind.RelativeFile)),s(c.VariableKind.RelativeFile)):s(c.VariableKind.RelativeFile);case"relativeFileDirname":{const n=r.$lc(s(c.VariableKind.RelativeFileDirname));if(m||f){const d=r.$kc(this.n(o(c.VariableKind.RelativeFileDirname)),n);return d.length===0?".":d}return n}case"fileDirname":return r.$lc(s(c.VariableKind.FileDirname));case"fileExtname":return r.$nc(s(c.VariableKind.FileExtname));case"fileBasename":return r.$mc(s(c.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=r.$mc(s(c.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-r.$nc(n).length)}case"fileDirnameBasename":return r.$mc(r.$lc(s(c.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||w}case"execInstallFolder":{const n=this.a.getAppRoot();return n||w}case"pathSeparator":case"/":return r.sep;default:try{const n=f?`${a}:${f}`:a;return this.p(c.VariableKind.Unknown,w,n,$,void 0)}catch{return w}}}}p(P,w,a,m,$){if(a&&m){const f=$===void 0?m[a]:m[$+":"+a];if(typeof f=="string")return f;throw new c.$4Q(P,(0,b.localize)(2072,null,w))}return w}}e.$gR=S}),define(Se[157],De([1,0,5,152]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$qE=void 0,e.$rE=c,e.$sE=u,e.$tE=P,e.$qE=(0,r.$Ci)("editorGroupsService");var C;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var R;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var L;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var T;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EXPAND=1]="EXPAND",w[w.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var b;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function c(w){const a=w;return(0,h.$eG)(a?.editor)&&(0,h.$eG)(a?.replacement)}var I;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var S;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function u(w){const a=w;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function P(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?C.DOWN:C.RIGHT}}),define(Se[268],De([1,0,5,157]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xE=e.$wE=e.$vE=e.$uE=void 0,e.$yE=C,e.$uE=(0,r.$Ci)("editorService"),e.$vE=-1,e.$wE=-2,e.$xE=-3;function C(R){const L=R;return typeof R=="number"||(0,h.$sE)(L)}}),define(Se[158],De([1,0,5,144]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=void 0,e.$1M=(0,r.$Di)(h.$Ji)}),define(Se[159],De([1,0,23,4,16,3,7]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=e.$ldc=e.$kdc=e.$jdc=e.$idc=void 0,C=Ue(C);class T{constructor(f,i){this.versionId=f,this.removedDueToLooping=i}}e.$idc=T;class b{static isHostExtension(f,i,s){if(i.getExtensionDescription(f))return!1;const t=s.getExtensionDescription(f);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(f,i){this.j=f,this.c=new h.$je,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(a),this.f=new r.$qn,this.g=[],this.h=new Map;for(const f of this.e){if(this.f.has(f.identifier)){console.error("Extension `"+f.identifier.value+"` is already registered");continue}this.f.set(f.identifier,f),this.g.push(f);const i=this.j.readActivationEvents(f);for(const s of i)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(f)}}set(f){return this.e=f,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(f,i){this.e=m(this.e,i),this.e=this.e.concat(f);const s=b.l(this.e);return this.e=m(this.e,s.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,s)}static l(f){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,l){this.addNode(d),this.addNode(l),this.c.has(d)?this.c.get(d).push(l):this.c.set(d,[l])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,l){const g=i.getArcs(d);for(let E=0;E<g.length;E++)if(!l.has(g[E]))return!1;return!0}getNodes(){return this.e}},s=new r.$qn;for(const d of f)if(s.set(d.identifier,d),d.extensionDependencies)for(const l of d.extensionDependencies)i.addArc(r.$on.toKey(d.identifier),r.$on.toKey(l));const t=new Set;i.getNodes().filter(d=>i.getArcs(d).length===0).forEach(d=>t.add(d));const o=i.getNodes().filter(d=>!t.has(d));let n;do{n=!1;for(let d=0;d<o.length;d++){const l=o[d];i.hasOnlyGoodArcs(l,t)&&(o.splice(d,1),d--,t.add(l),n=!0)}}while(n);return o.map(d=>s.get(d))}containsActivationEvent(f){return this.h.has(f)}containsExtension(f){return this.f.has(f)}getExtensionDescriptionsForActivationEvent(f){const i=this.h.get(f);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new c(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(f){const i=this.f.get(f);return i||void 0}getExtensionDescriptionByUUID(f){for(const i of this.g)if(i.uuid===f)return i}getExtensionDescriptionByIdOrUUID(f,i){return this.getExtensionDescription(f)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$jdc=b;class c{constructor(f,i){this.versionId=f,this.extensions=i}}e.$kdc=c;class I{constructor(f){this.d=new P,this.c=new b(f,[])}async acquireLock(f){const i=await this.d.acquire(f);return new S(this,i)}deltaExtensions(f,i,s){if(!f.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,s)}containsActivationEvent(f){return this.c.containsActivationEvent(f)}containsExtension(f){return this.c.containsExtension(f)}getExtensionDescriptionsForActivationEvent(f){return this.c.getExtensionDescriptionsForActivationEvent(f)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(f){return this.c.getExtensionDescription(f)}getExtensionDescriptionByUUID(f){return this.c.getExtensionDescriptionByUUID(f)}getExtensionDescriptionByIdOrUUID(f,i){return this.c.getExtensionDescriptionByIdOrUUID(f,i)}}e.$ldc=I;class S extends R.$Tc{constructor(f,i){super(),this.f=f,this.c=!1,this.B(i)}isAcquiredFor(f){return!this.c&&this.f===f}}e.$mdc=S;class u{constructor(f){this.name=f;const i=(0,L.$vh)();this.promise=i.promise,this.c=i.resolve}resolve(f){this.c(f)}}class P{constructor(){this.c=[],this.d=!1}async acquire(f){const i=new u(f);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const f=this.c.shift();this.d=!0;let i=!0;const s=setTimeout(()=>{i&&console.warn(`The customer named ${f.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(s),i=!1,this.d=!1,this.e())};f.resolve((0,R.$Rc)(t))}}var w;(function($){$[$.Builtin=0]="Builtin",$[$.User=1]="User",$[$.Dev=2]="Dev"})(w||(w={}));function a($,f){const i=$.isBuiltin?w.Builtin:$.isUnderDevelopment?w.Dev:w.User,s=f.isBuiltin?w.Builtin:f.isUnderDevelopment?w.Dev:w.User;if(i!==s)return i-s;const t=C.$fc.basename($.extensionLocation.path),o=C.$fc.basename(f.extensionLocation.path);return t<o?-1:t>o?1:0}function m($,f){const i=new r.$pn(f);return $.filter(s=>!i.has(s.identifier))}}),define(Se[269],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=e.ExtHostConnectionType=void 0,e.$cn=T,e.$dn=b;var r;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(r||(e.ExtHostConnectionType=r={}));class h{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(S){this.pipeName=S,this.type=r.IPC}serialize(S){S[h.ENV_KEY]=this.pipeName}}e.$_m=h;class C{constructor(){this.type=r.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(S){S[C.ENV_KEY]="1"}}e.$an=C;class R{constructor(){this.type=r.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(S){S[R.ENV_KEY]="1"}}e.$bn=R;function L(I){delete I[h.ENV_KEY],delete I[C.ENV_KEY],delete I[R.ENV_KEY]}function T(I,S){L(S),I.serialize(S)}function b(I){if(I[h.ENV_KEY])return c(I,new h(I[h.ENV_KEY]));if(I[C.ENV_KEY])return c(I,new C);if(I[R.ENV_KEY])return c(I,new R);throw new Error("No connection information defined in environment!")}function c(I,S){return L(I),S}}),define(Se[93],De([1,0,21]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$yn=L,e.$zn=T;var h;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(h||(e.UIKind=h={}));var C;(function(c){c[c.VersionMismatch=55]="VersionMismatch",c[c.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var R;(function(c){c[c.Initialized=0]="Initialized",c[c.Ready=1]="Ready",c[c.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function L(c){const I=r.$Le.alloc(1);switch(c){case R.Initialized:I.writeUInt8(1,0);break;case R.Ready:I.writeUInt8(2,0);break;case R.Terminate:I.writeUInt8(3,0);break}return I}function T(c,I){if(c.byteLength!==1)return!1;switch(c.readUInt8(0)){case 1:return I===R.Initialized;case 2:return I===R.Ready;case 3:return I===R.Terminate;default:return!1}}var b;(function(c){c.Start="START_NATIVE_LOG",c.End="END_NATIVE_LOG"})(b||(e.NativeLogMarkers=b={}))}),define(Se[94],De([1,0,5,4,149,11,29,93,90,91,24,2,3,8]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wQ=e.$uQ=e.$tQ=void 0,e.$vQ=m;let w=class extends u.$Tc{constructor(f,i){super(),this.s=f,this.t=i,this.a=this.B(new h.$je),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new h.$je),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=C.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=S.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:c.$zp,name:(0,P.localize)(10732,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(s=>{(0,R.$_j)(s)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===C.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=C.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=C.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=C.TelemetryLevel.USAGE:!1}}instantiateLogger(f,i,s){const t=this.getTelemetryDetails(),o=new a(i,s,f,this.n,this.j,this.getBuiltInCommonProperties(f),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),n=this.r.get(f.identifier.value)??[];return this.r.set(f.identifier.value,[...n,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(f,i,s){this.f=f,this.g=i,this.c=s??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(f){const i=Object.create(null);switch(i["common.extname"]=`${f.publisher}.${f.name}`,i["common.extversion"]=f.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=m(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:i["common.uikind"]="web";break;case T.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$fn)((0,c.$Fp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(f){this.h=this.getTelemetryConfiguration(),this.f=f;const i=this.getTelemetryDetails();this.r.forEach((s,t)=>{const o=s.filter(n=>!n.isDisposed);o.length===0?this.r.delete(t):this.r.set(t,o)}),this.r.forEach(s=>{for(const t of s)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(f,i){const t=this.r.get(f.value)?.filter(n=>!n.isDisposed);if(!t)return this.r.delete(f.value),!1;let o=!1;for(const n of t)n.ignoreUnhandledExtHostErrors||(n.logError(i),o=!0);return o}};e.$tQ=w,e.$tQ=w=Ye([Ve(0,L.$sQ),Ve(1,R.$$j)],w);class a{static validateSender(f){if(typeof f!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof f.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof f.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof f.flush<"u"&&typeof f.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(f,i,s,t,o,n,d){this.g=s,this.h=t,this.i=o,this.j=n,this.a=new h.$je,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=f,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(f,i){this.e&&(this.d={isUsageEnabled:f,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(f){let i="properties"in f?f.properties??{}:f;return i=(0,c.$Ip)(i,[]),this.c&&(i=(0,I.$eo)(i,this.c)),this.b||(i=(0,I.$eo)(i,this.j)),"properties"in f?f.properties=i:f=i,f}k(f,i){this.f&&(this.g.publisher==="vscode"?f=this.g.name+"/"+f:f=this.g.identifier.value+"/"+f,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(f,i),this.h.trace(f,i))}logUsage(f,i){this.d.isUsageEnabled&&this.k(f,i)}logError(f,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof f=="string")this.k(f,i);else{const s={name:f.name,message:f.message,stack:f.stack,cause:f.cause},t=(0,c.$Ip)(s,[]),o=new Error(t.message,{cause:t.cause});o.stack=t.stack,o.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(o,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const f=this,i={logUsage:f.logUsage.bind(f),get isUsageEnabled(){return f.d.isUsageEnabled},get isErrorsEnabled(){return f.d.isErrorsEnabled},logError:f.logError.bind(f),dispose:f.dispose.bind(f),onDidChangeEnableStates:f.a.event.bind(f)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let f=this.f;this.f=void 0,Promise.resolve(f.flush()).then(f=void 0),this.e=void 0}else this.f=void 0}}e.$uQ=a;function m($){const f=Date.now()-new Date($).getTime();return isNaN(f)?!1:f<1e3*60*60*24}e.$wQ=(0,r.$Ci)("IExtHostTelemetry")}),define(Se[25],De([1,0,4,2,240,147,23,5]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iH=e.ActivationKind=e.$fH=e.$eH=e.$bH=e.ExtensionHostStartup=e.$aH=e.$_G=e.$$G=e.$0G=void 0,e.$cH=u,e.$dH=P,e.$gH=$,e.$hH=f,e.$0G=Object.freeze({identifier:new L.$on("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:h.URI.parse("void:location"),isBuiltin:!1,targetPlatform:L.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$$G="extensions.webWorker",e.$_G=(0,T.$Ci)("extensionService");class b{constructor(t){this.dependency=t}}e.$aH=b;var c;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(c||(e.ExtensionHostStartup=c={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,o,n){this.c=t,this.d=o.slice(0),this.e=n.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$VG.createActivationEventsMap(this.d)}}set(t,o,n){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const d=[],l=[],g=[],E=[],D=S(this.d),y=S(o),k=(N,O)=>N.extensionLocation.toString()===O.extensionLocation.toString()||N.isBuiltin===O.isBuiltin||N.isUserBuiltin===O.isUserBuiltin||N.isUnderDevelopment===O.isUnderDevelopment;for(const N of this.d){const O=y.get(N.identifier);if(!O){d.push(N.identifier),D.delete(N.identifier);continue}if(!k(N,O)){d.push(N.identifier),D.delete(N.identifier);continue}}for(const N of o){const O=D.get(N.identifier);if(!O){l.push(N);continue}if(!k(O,N)){d.push(O.identifier),D.delete(O.identifier);continue}}const A=new L.$pn(this.e),p=new L.$pn(n);for(const N of this.e)p.has(N)||g.push(N);for(const N of n)A.has(N)||E.push(N);const v=R.$VG.createActivationEventsMap(l),F={versionId:t,toRemove:d,toAdd:l,addActivationEvents:v,myToRemove:g,myToAdd:E};return this.delta(F),F}delta(t){if(this.c>=t.versionId)return null;const{toRemove:o,toAdd:n,myToRemove:d,myToAdd:l}=t,g=new L.$pn(o),E=new L.$pn(d);for(let D=0;D<this.d.length;D++)g.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)E.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of n)this.d.push(D);for(const D of l)this.e.push(D);return this.f=null,t}containsExtension(t){for(const o of this.e)if(L.$on.equals(o,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const o of this.d){if(!this.containsExtension(o.identifier))continue;const n=R.$VG.readActivationEvents(o);for(const d of n)t.add(d)}return t}}e.$bH=I;function S(s){const t=new L.$qn;for(const o of s)t.set(o.identifier,o);return t}function u(s,t){return s.enabledApiProposals?s.enabledApiProposals.includes(t):!1}function P(s,t){if(!u(s,t))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class w{constructor(t,o,n,d){this.codeLoadingTime=t,this.activateCallTime=o,this.activateResolvedTime=n,this.activationReason=d}}e.$eH=w;class a{constructor(t,o){this.description=t,this.value=o}}e.$fH=a;var m;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function $(s){return{type:s.isBuiltin?L.ExtensionType.System:L.ExtensionType.User,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,C.$Op)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function f(s,t){const o=(0,C.$Mp)(s.manifest.publisher,s.manifest.name);return{id:o,identifier:new L.$on(o),isBuiltin:s.type===L.ExtensionType.System,isUserBuiltin:s.type===L.ExtensionType.User&&s.isBuiltin,isUnderDevelopment:!!t,extensionLocation:s.location,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName,...s.manifest}}class i{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.onWillStop=r.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,o){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,o){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$iH=i}),define(Se[270],De([1,0,13,3,159,23,25,11,7]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=e.$Cpc=e.$Bpc=e.$Apc=e.$zpc=e.$ypc=void 0,r=Ue(r);class c{static{this.NONE=new c(!1,-1,-1,-1)}constructor(f,i,s,t){this.startup=f,this.codeLoadingTime=i,this.activateCallTime=s,this.activateResolvedTime=t}}e.$ypc=c;class I{constructor(f){this.a=f,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(f,i){return f===-1||i===-1?-1:i-f}build(){return new c(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$zpc=I;class S{constructor(f,i,s,t,o,n){this.activationFailed=f,this.activationFailedError=i,this.activationTimes=s,this.module=t,this.exports=o,this.disposable=n}}e.$Apc=S;class u extends S{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,h.$Tc.None)}}e.$Bpc=u;class P extends S{constructor(){super(!1,null,c.NONE,{activate:void 0,deactivate:void 0},void 0,h.$Tc.None)}}e.$Cpc=P;class w extends S{constructor(f){super(!0,f,c.NONE,{activate:void 0,deactivate:void 0},void 0,h.$Tc.None)}}let a=class{constructor(f,i,s,t){this.g=t,this.a=f,this.b=i,this.c=s,this.d=new R.$qn,this.f=Object.create(null)}dispose(){for(const[f,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const f=[];for(const[i,s]of this.d)f.push(s.wait());await Promise.all(f)}isActivated(f){const i=this.d.get(f);return!!(i&&i.value)}getActivatedExtension(f){const i=this.d.get(f);if(!i||!i.value)throw new Error(`Extension '${f.value}' is not known or not activated`);return i.value}async activateByEvent(f,i){if(this.f[f])return;const s=this.a.getExtensionDescriptionsForActivationEvent(f);await this.h(s.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:f}}))),this.f[f]=!0}activateById(f,i){const s=this.a.getExtensionDescription(f);if(!s)throw new Error(`Extension '${f.value}' is not known`);return this.h([{id:s.identifier,reason:i}])}async h(f){const i=f.filter(s=>!this.isActivated(s.id)).map(s=>this.j(s));await Promise.all(i.map(s=>s.wait()))}j(f){if(this.d.has(f.id))return this.d.get(f.id);if(this.l(f.id))return this.k(f,null,[],null);const i=this.a.getExtensionDescription(f.id);if(!i){const o=new Error(`Cannot activate unknown extension '${f.id.value}'`),n=this.k(f,null,[],new w(o));return this.c.onExtensionActivationError(f.id,o,new L.$aH(f.id.value)),n}const s=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of t){if(this.m(o))continue;const n=this.d.get(o);if(n){s.push(n);continue}if(this.l(o)){s.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:f.reason}));continue}const d=this.a.getExtensionDescription(o);if(d){if(!d.main&&!d.browser)continue;s.push(this.j({id:d.identifier,reason:f.reason}));continue}const l=i.displayName||i.identifier.value,g=new Error(`Cannot activate the '${l}' extension because it depends on unknown extension '${o}'`),E=this.k(f,i.displayName,[],new w(g));return this.c.onExtensionActivationError(i.identifier,g,new L.$aH(o)),E}return this.k(f,i.displayName,s,null)}k(f,i,s,t){const o=new m(f.id,i,f.reason,s,t,this.c,this.g);return this.d.set(f.id,o),o}l(f){return C.$jdc.isHostExtension(f,this.a,this.b)}m(f){const i=this.b.getExtensionDescription(f);return i?!i.main&&!i.browser:!1}};e.$Dpc=a,e.$Dpc=a=Ye([Ve(3,T.$0j)],a);let m=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(f,i,s,t,o,n,d){this.c=f,this.d=i,this.f=s,this.g=t,this.h=o,this.j=n,this.k=d,this.a=new b.$Bh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let f=0;f<this.g.length;f++){const i=this.g[f];if(i.value&&!i.value.activationFailed){this.g.splice(f,1),f--;continue}if(i.value&&i.value.activationFailed){const s=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);s.detail=i.value.activationFailedError,this.h=new w(s),this.j.onExtensionActivationError(this.c,s,null);return}}this.g.length>0&&await Promise.race(this.g.map(f=>f.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(f){const i=new Error;if(f&&f.name&&(i.name=f.name),f&&f.message?i.message=`Activating extension '${this.c.value}' failed: ${f.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${f}.`,f&&f.stack&&(i.stack=f.stack),this.h=new w(i),this.b&&r.$3(f))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(f)}}};m=Ye([Ve(6,T.$0j)],m)});var Wt=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Se[160],De([1,0,8,13,43,146,116,36,23,115,147,143]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=void 0,r=Ue(r),C=Wt(C);const u=T.$oo.as(L.$po.JSONContribution);class P{constructor(t,o,n){this.a=t,this.b=o,this.c=n}d(t,o){this.a({type:t,message:o,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(C.default.Error,t)}warn(t){this.d(C.default.Warning,t)}info(t){this.d(C.default.Info,t)}}e.$4G=P;class w{static a(t){const o=new b.$pn;for(let n=0,d=t.length;n<d;n++)o.add(t[n].description.identifier);return o}static compute(t,o){if(!t||!t.length)return new w(o,[]);if(!o||!o.length)return new w([],t);const n=this.a(t),d=this.a(o),l=o.filter(E=>!n.has(E.description.identifier)),g=t.filter(E=>!d.has(E.description.identifier));return new w(l,g)}constructor(t,o){this.added=t,this.removed=o}}e.$5G=w;class a{constructor(t,o){this.name=t,this.defaultExtensionKind=o,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=w.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,h.$Y)(t)}}}e.$6G=a;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(1823,null),r.localize(1824,null)]},$="vscode://schemas/vscode-extensions";e.$7G={properties:{engines:{type:"object",description:r.localize(1825,null),properties:{vscode:{type:"string",description:r.localize(1826,null),default:"^1.22.0"}}},publisher:{description:r.localize(1827,null),type:"string"},displayName:{description:r.localize(1828,null),type:"string"},categories:{description:r.localize(1829,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.$nn},{type:"string",const:"Languages",deprecationMessage:r.localize(1830,null)}]}},galleryBanner:{type:"object",description:r.localize(1831,null),properties:{color:{description:r.localize(1832,null),type:"string"},theme:{description:r.localize(1833,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(1834,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(1835,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(1836,null)},enabledApiProposals:{markdownDescription:r.localize(1837,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals).map(s=>s),markdownEnumDescriptions:Object.values(S.allApiProposals).map(s=>s.proposal)}},api:{markdownDescription:r.localize(1838,null),type:"string",enum:["none"],enumDescriptions:[r.localize(1839,null)]},activationEvents:{description:r.localize(1840,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(1841,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(1842,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(1843,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(1844,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(1845,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(1846,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(1847,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(1848,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(1849,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(1850,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(1851,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(1852,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(1853,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(1854,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(1855,null)},{label:"onUri",body:"onUri",description:r.localize(1856,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(1857,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(1858,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(1859,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(1860,null)},{label:"onRenderer",description:r.localize(1861,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(1862,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(1863,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(1864,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:r.localize(1865,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:r.localize(1866,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:r.localize(1867,null)},{label:"*",description:r.localize(1868,null),body:"*"}]}},badges:{type:"array",description:r.localize(1869,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(1870,null)},href:{type:"string",description:r.localize(1871,null)},description:{type:"string",description:r.localize(1872,null)}}}},markdown:{type:"string",description:r.localize(1873,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(1874,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(1875,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$8o}},extensionPack:{description:r.localize(1876,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$8o}},extensionKind:{description:r.localize(1877,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(1878,null)},{body:["workspace"],description:r.localize(1879,null)},{body:["ui","workspace"],description:r.localize(1880,null)},{body:["workspace","ui"],description:r.localize(1881,null)},{body:[],description:r.localize(1882,null)}]},capabilities:{description:r.localize(1883,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(1884,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(1885,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(1886,null),r.localize(1887,null),r.localize(1888,null)]},description:{type:"string",markdownDescription:r.localize(1889,null)}}},untrustedWorkspaces:{description:r.localize(1890,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(1891,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(1892,null),r.localize(1893,null),r.localize(1894,null)]},restrictedConfigurations:{description:r.localize(1895,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(1896,null)}}}}},sponsor:{description:r.localize(1897,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(1898,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(1899,null),type:"string"},"vscode:uninstall":{description:r.localize(1900,null),type:"string"}}},icon:{type:"string",description:r.localize(1901,null)},l10n:{type:"string",description:r.localize(1902,null)},pricing:{type:"string",markdownDescription:r.localize(1903,null),enum:["Free","Trial"],default:"Free"}}};class f{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const o=new a(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,o),t.activationEventsGenerator&&I.$VG.register(t.extensionPoint,t.activationEventsGenerator),e.$7G.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema($,e.$7G),o}getExtensionPoints(){return Array.from(this.a.values())}}e.$8G=f;const i={ExtensionsRegistry:"ExtensionsRegistry"};T.$oo.add(i.ExtensionsRegistry,new f),e.$9G=T.$oo.as(i.ExtensionsRegistry),u.registerSchema($,e.$7G),u.registerSchema(c.$rk,{properties:{extensionEnabledApiProposals:{description:r.localize(1904,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals).map(s=>s.proposal)}}]}}}})}),define(Se[271],De([1,0,4,39,3,12,8,23,5,11,25,160]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lH=e.$kH=e.$jH=e.ChatMessageRole=void 0;var u;(function(a){a[a.System=0]="System",a[a.User=1]="User",a[a.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$jH=(0,b.$Ci)("ILanguageModelsService");const P={type:"object",properties:{vendor:{type:"string",description:(0,L.localize)(8332,null)}}};e.$kH=S.$9G.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,L.localize)(8333,null),oneOf:[P,{type:"array",items:P}]},activationEventsGenerator:(a,m)=>{for(const $ of a)m.push(`onLanguageModelChat:${$.vendor}`)}});let w=class{constructor(m,$){this.e=m,this.f=$,this.a=new C.$Sc,this.b=new Map,this.c=new Set,this.d=this.a.add(new r.$je),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$kH.setHandler(f=>{this.c.clear();for(const s of f){if(!(0,I.$cH)(s.description,"chatProvider")){s.collector.error((0,L.localize)(8334,null));continue}for(const t of h.Iterable.wrap(s.value)){if(this.c.has(t.vendor)){s.collector.error((0,L.localize)(8335,null,t.vendor));continue}if((0,R.$af)(t.vendor)){s.collector.error((0,L.localize)(8336,null));continue}if(t.vendor.trim()!==t.vendor){s.collector.error((0,L.localize)(8337,null));continue}this.c.add(t.vendor)}}const i=[];for(const[s,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(s),i.push(s));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(m){return this.b.get(m)?.metadata}async selectLanguageModels(m){if(m.vendor)await this.e.activateByEvent(`onLanguageModelChat:${m.vendor}}`);else{const f=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(f)}const $=[];for(const[f,i]of this.b)(m.vendor===void 0||i.metadata.vendor===m.vendor)&&(m.family===void 0||i.metadata.family===m.family)&&(m.version===void 0||i.metadata.version===m.version)&&(m.identifier===void 0||i.metadata.id===m.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(s=>T.$on.equals(s,m.extension)))&&$.push(f);return this.f.trace("[LM] selected language models",m,$),$}registerLanguageModelChat(m,$){if(this.f.trace("[LM] registering language model chat",m,$.metadata),!this.c.has($.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${$.metadata.vendor}.`);if(this.b.has(m))throw new Error(`Chat response provider with identifier ${m} is already registered.`);return this.b.set(m,$),this.d.fire({added:[{identifier:m,metadata:$.metadata}]}),(0,C.$Rc)(()=>{this.b.delete(m)&&(this.d.fire({removed:[m]}),this.f.trace("[LM] UNregistered language model chat",m,$.metadata))})}async sendChatRequest(m,$,f,i,s){const t=this.b.get(m);if(!t)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return t.sendChatRequest(f,$,i,s)}computeTokenLength(m,$,f){const i=this.b.get(m);if(!i)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return i.provideTokenCount($,f)}};e.$lH=w,e.$lH=w=Ye([Ve(0,I.$_G),Ve(1,c.$0j)],w)}),define(Se[272],De([1,0,8,17,24,160,35,4]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QI=void 0,r=Ue(r),h=Ue(h),C=Ue(C);const b={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(3890,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(3891,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(3892,null),default:""}}};var c;(function(u){function P(w,a,m){if(!w)return;const $=h.$cg(w.type)?w.type:void 0;if(!$||$.length===0){m.error(r.localize(3893,null));return}const f=[];if(Array.isArray(w.required))for(const i of w.required)h.$cg(i)&&f.push(i);return{extensionId:a.value,taskType:$,required:f,properties:w.properties?C.$bo(w.properties):{},when:w.when?L.$Aj.deserialize(w.when):void 0}}u.from=P})(c||(c={}));const I=R.$9G.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,P)=>{for(const w of u)w.type&&P.push(`onTaskType:${w.type}`)},jsonSchema:{description:r.localize(3894,null),type:"array",items:b}});class S{constructor(){this.d=new T.$je,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((P,w)=>{I.setHandler((a,m)=>{this.c=void 0;try{for(const $ of m.removed){const f=$.value;for(const i of f)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const $ of m.added){const f=$.value;for(const i of f){const s=c.from(i,$.description.identifier,$.collector);s&&(this.a[s.taskType]=s)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}P(void 0)})})}onReady(){return this.b}get(P){return this.a[P]}all(){return Object.keys(this.a).map(P=>this.a[P])}getJsonSchema(){if(this.c===void 0){const P=[];for(const w of this.all()){const a={type:"object",additionalProperties:!1};w.required.length>0&&(a.required=w.required.slice(0)),w.properties!==void 0?a.properties=C.$bo(w.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[w.taskType]},P.push(a)}this.c={oneOf:P}}return this.c}}e.$QI=new S}),define(Se[273],De([1,0,8,17,22,24,35,272,45]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$1I=e.JsonSchemaVersion=e.ExecutionEngine=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$UI=e.ShellQuoting=e.$TI=e.$SI=e.$RI=void 0,r=Ue(r),h=Ue(h),C=Ue(C),R=Ue(R),e.$RI="settings",e.$SI=new L.$Tj("taskRunning",!1,r.localize(3878,null)),e.$TI=r.localize2(3880,"Tasks");var c;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(c||(e.ShellQuoting=c={})),e.$UI="$customized",function(M){function W(V){if(!V)return M.Strong;switch(V.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=W}(c||(e.ShellQuoting=c={}));var I;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var S;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(S||(e.RevealKind=S={})),function(M){function W(V){switch(V.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=W}(S||(e.RevealKind=S={}));var u;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(M){function W(V){switch(V.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=W}(u||(e.RevealProblemKind=u={}));var P;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(P||(e.PanelKind=P={})),function(M){function W(V){switch(V.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=W}(P||(e.PanelKind=P={}));var w;(function(M){M.defaults={echo:!0,reveal:S.Always,revealProblems:u.Never,focus:!1,panel:P.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var a;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(a||(e.RuntimeType=a={})),function(M){function W(ne){switch(ne.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=W;function V(ne){switch(ne){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=V}(a||(e.RuntimeType=a={}));var m;(function(M){function W(V){return h.$cg(V)?V:V.value}M.value=W})(m||(e.CommandString=m={}));var $;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function W(ne){return ne===M.Clean._id||ne===M.Build._id||ne===M.Rebuild._id||ne===M.Test._id}M.is=W;function V(ne){if(ne!==void 0)return h.$cg(ne)?W(ne)?{_id:ne,isDefault:!1}:void 0:ne}M.from=V})($||(e.TaskGroup=$={}));var f;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(f||(e.TaskScope=f={}));var i;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function W(V){switch(V){case M.User:return b.ConfigurationTarget.USER;case M.WorkspaceFile:return b.ConfigurationTarget.WORKSPACE;default:return b.ConfigurationTarget.WORKSPACE_FOLDER}}M.toConfigurationTarget=W})(i||(e.TaskSourceKind=i={}));var s;(function(M){M.parallel="parallel",M.sequence="sequence"})(s||(e.DependsOrder=s={}));var t;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var o;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class n{constructor(W,V,ne,B,K,Y){this._label="",this._id=W,V&&(this._label=V),ne&&(this.type=ne),this.runOptions=B,this.configurationProperties=K,this._source=Y}getDefinition(W){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const W={folder:this.d(),id:this._id};return JSON.stringify(W)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(W,V=!1){if(W===void 0)return!1;if(h.$cg(W))return W===this._label||W===this.configurationProperties.identifier||V&&W===this._id;const ne=this.getDefinition(!0);return ne!==void 0&&ne._key===W._key}getQualifiedLabel(){const W=this.getWorkspaceFolder();return W?`${this._label} (${W.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(W){this.c===void 0&&(this.c=[]),W&&(this.c=this.c.concat(W))}get taskLoadMessages(){return this.c}}e.$VI=n;class d extends n{constructor(W,V,ne,B,K,Y,ee,ue){super(W,ne,void 0,ee,ue,V),this.command={},this._source=V,this.hasDefinedMatchers=Y,K&&(this.command=K)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(W=!1){if(W&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case a.Shell:V="shell";break;case a.Process:V="process";break;case a.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(W){return W instanceof d}getMapKey(){const W=this._source.config.workspaceFolder;return W?`${W.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$RI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const W=this.d();if(!W)return;let V=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(V+=this._source.kind);const ne={type:e.$UI,folder:W,id:V};return JSON.stringify(ne)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$ah(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(W){return new d(W._id,W._source,W._label,W.type,W.command,W.hasDefinedMatchers,W.runOptions,W.configurationProperties)}}e.$WI=d;class l extends n{constructor(W,V,ne,B,K,Y,ee){super(W,ne,B,Y,ee,V),this._source=V,this.configures=K}static is(W){return W instanceof l}f(W){return W}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$ah(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$RI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const W=this.d();if(!W)return;let V=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(V+=this._source.kind);const ne={type:e.$UI,folder:W,id:V};return JSON.stringify(ne)}}e.$XI=l;class g extends n{constructor(W,V,ne,B,K,Y,ee,ue,re){super(W,ne,B,ue,re,V),this.defines=K,this.hasDefinedMatchers=ee,this.command=Y,this.icon=re.icon,this.hide=re.hide}clone(){return new g(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(W){return W instanceof g}getMapKey(){const W=this._source.workspaceFolder;return W?`${this._source.scope.toString()}|${W.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===f.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const W={type:"contributed",scope:this._source.scope,id:this._id};return W.folder=this.d(),JSON.stringify(W)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(W){return new g(W._id,W._source,W._label,W.type,W.defines,W.command,W.hasDefinedMatchers,W.runOptions,W.configurationProperties)}}e.$YI=g;class E extends n{constructor(W,V,ne,B,K,Y){super(W,ne,B,K,Y,V),this._source=V}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(W){return W instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(W){return new E(W._id,W._source,W._label,W.type,W.runOptions,W.configurationProperties)}}e.$ZI=E;var D;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(M){M._default=M.Terminal}(D||(e.ExecutionEngine=D={}));var y;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class k{constructor(W){this.c=new Map;for(let V=0;V<W.length;V++)this.c.set(W[V].uri.toString(),V)}compare(W,V){const ne=W.getWorkspaceFolder(),B=V.getWorkspaceFolder();if(ne&&B){let K=this.c.get(ne.uri.toString());K=K===void 0?0:K+1;let Y=this.c.get(B.uri.toString());return Y=Y===void 0?0:Y+1,K===Y?W._label.localeCompare(V._label):K-Y}else return!ne&&B?-1:ne&&!B?1:0}}e.$1I=k;var A;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(A||(e.TaskEventKind=A={}));var p;(function(M){M.SingleRun="singleRun",M.Background="background"})(p||(e.TaskRunType=p={}));var v;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var F;(function(M){function W(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?p.Background:p.SingleRun,group:ue.configurationProperties.group,__task:ue}}function V(ue,re,ye){return{...W(ue),kind:A.Start,terminalId:re,resolvedVariables:ye}}M.start=V;function ne(ue,re,ye){return{...W(ue),kind:A.ProcessStarted,terminalId:re,processId:ye}}M.processStarted=ne;function B(ue,re,ye){return{...W(ue),kind:A.ProcessEnded,terminalId:re,exitCode:ye}}M.processEnded=B;function K(ue,re,ye){return{...W(ue),kind:A.Terminated,exitReason:ye,terminalId:re}}M.terminated=K;function Y(ue,re,ye){return{...W(re),kind:ue,terminalId:ye}}M.general=Y;function ee(){return{kind:A.Changed}}M.changed=ee})(F||(e.TaskEvent=F={}));var N;(function(M){function W(ne){const B=Object.keys(ne).sort();let K="";for(const Y of B){let ee=ne[Y];ee instanceof Object?ee=W(ee):typeof ee=="string"&&(ee=ee.replace(/,/g,",,")),K+=Y+","+ee+","}return K}function V(ne){const K={_key:W(ne),type:ne.taskType};return Object.assign(K,ne),K}M.create=V})(N||(e.KeyedTaskIdentifier=N={}));var O;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(O||(e.TaskSettingId=O={}));var j;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var z;(function(M){function W(V,ne){const B=T.$QI.get(V.type);if(B===void 0){const ue=R.$bo(V);return delete ue._key,N.create(ue)}const K=Object.create(null);K.type=B.taskType;const Y=new Set;B.required.forEach(ue=>Y.add(ue));const ee=B.properties;for(const ue of Object.keys(ee)){const re=V[ue];if(re!=null)K[ue]=re;else if(Y.has(ue)){const ye=ee[ue];if(ye.default!==void 0)K[ue]=R.$bo(ye.default);else switch(ye.type){case"boolean":K[ue]=!1;break;case"number":case"integer":K[ue]=0;break;case"string":K[ue]="";break;default:ne.error(r.localize(3879,null,JSON.stringify(V,void 0,0),ue));return}}}return N.create(K)}M.createTaskIdentifier=W})(z||(e.TaskDefinition=z={}))}),define(Se[274],De([1,0,13]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=e.$ndc=void 0;class h{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,T)=>{this.b=L,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,r.$Y)(L))}then(L,T){return this.j().then(L,T)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$ndc=h;class C extends h{constructor(){super(),this.h=!0,this.i=new r.$4}}e.$odc=C}),define(Se[53],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uw=e.$Rw=void 0,e.$Sw=C,e.$Tw=R;class r{static{this.count=0}constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++r.count}}e.$Rw=r;const h=[];function C(T){const b=new r(T);return h[b.nid]=b,b}function R(T){return h[T].sid}class L{constructor(b){this.value=b}}e.$Uw=L}),define(Se[6],De([1,0,53]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=e.$DN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$CN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var h;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(h||(e.TextEditorRevealType=h={}));var C;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(C||(e.TabInputKind=C={}));var R;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var L;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var T;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var b;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(b||(e.CellOutputKind=b={}));var c;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(c||(e.NotebookEditorRevealType=c={}));var I;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output",a[a.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class S{static{this.a=0}static mixin(m){return m._id=S.a++,m}}e.$CN=S;var u;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var P;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(P||(e.ISuggestResultDtoField=P={}));var w;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(w||(e.ExtHostTestingResource=w={})),e.$DN={MainThreadAuthentication:(0,r.$Sw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.$Sw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,r.$Sw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,r.$Sw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,r.$Sw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,r.$Sw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,r.$Sw)("MainThreadChatSkills"),MainThreadClipboard:(0,r.$Sw)("MainThreadClipboard"),MainThreadCommands:(0,r.$Sw)("MainThreadCommands"),MainThreadComments:(0,r.$Sw)("MainThreadComments"),MainThreadConfiguration:(0,r.$Sw)("MainThreadConfiguration"),MainThreadConsole:(0,r.$Sw)("MainThreadConsole"),MainThreadDebugService:(0,r.$Sw)("MainThreadDebugService"),MainThreadDecorations:(0,r.$Sw)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.$Sw)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.$Sw)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.$Sw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.$Sw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.$Sw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.$Sw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.$Sw)("MainThreadEditorTabs"),MainThreadErrors:(0,r.$Sw)("MainThreadErrors"),MainThreadTreeViews:(0,r.$Sw)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.$Sw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,r.$Sw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.$Sw)("MainThreadLanguages"),MainThreadLogger:(0,r.$Sw)("MainThreadLogger"),MainThreadMessageService:(0,r.$Sw)("MainThreadMessageService"),MainThreadOutputService:(0,r.$Sw)("MainThreadOutputService"),MainThreadProgress:(0,r.$Sw)("MainThreadProgress"),MainThreadQuickDiff:(0,r.$Sw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.$Sw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.$Sw)("MainThreadStatusBar"),MainThreadSecretState:(0,r.$Sw)("MainThreadSecretState"),MainThreadStorage:(0,r.$Sw)("MainThreadStorage"),MainThreadSpeech:(0,r.$Sw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,r.$Sw)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.$Sw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,r.$Sw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,r.$Sw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.$Sw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.$Sw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.$Sw)("MainThreadCustomEditors"),MainThreadUrls:(0,r.$Sw)("MainThreadUrls"),MainThreadUriOpeners:(0,r.$Sw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.$Sw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.$Sw)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.$Sw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,r.$Sw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,r.$Sw)("MainThreadExtensionService"),MainThreadSCM:(0,r.$Sw)("MainThreadSCM"),MainThreadSearch:(0,r.$Sw)("MainThreadSearch"),MainThreadShare:(0,r.$Sw)("MainThreadShare"),MainThreadTask:(0,r.$Sw)("MainThreadTask"),MainThreadWindow:(0,r.$Sw)("MainThreadWindow"),MainThreadLabelService:(0,r.$Sw)("MainThreadLabelService"),MainThreadNotebook:(0,r.$Sw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.$Sw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.$Sw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.$Sw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.$Sw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.$Sw)("MainThreadInteractive"),MainThreadTheming:(0,r.$Sw)("MainThreadTheming"),MainThreadTunnelService:(0,r.$Sw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,r.$Sw)("MainThreadManagedSockets"),MainThreadTimeline:(0,r.$Sw)("MainThreadTimeline"),MainThreadTesting:(0,r.$Sw)("MainThreadTesting"),MainThreadLocalization:(0,r.$Sw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,r.$Sw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,r.$Sw)("MainThreadAiEmbeddingVector")},e.$EN={ExtHostCommands:(0,r.$Sw)("ExtHostCommands"),ExtHostConfiguration:(0,r.$Sw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.$Sw)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.$Sw)("ExtHostDebugService"),ExtHostDecorations:(0,r.$Sw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.$Sw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.$Sw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.$Sw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.$Sw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.$Sw)("ExtHostEditors"),ExtHostTreeViews:(0,r.$Sw)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.$Sw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.$Sw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.$Sw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.$Sw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.$Sw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.$Sw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.$Sw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,r.$Sw)("ExtHostStatusBar"),ExtHostShare:(0,r.$Sw)("ExtHostShare"),ExtHostExtensionService:(0,r.$Sw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.$Sw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.$Sw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,r.$Sw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,r.$Sw)("ExtHostSCM"),ExtHostSearch:(0,r.$Sw)("ExtHostSearch"),ExtHostTask:(0,r.$Sw)("ExtHostTask"),ExtHostWorkspace:(0,r.$Sw)("ExtHostWorkspace"),ExtHostWindow:(0,r.$Sw)("ExtHostWindow"),ExtHostWebviews:(0,r.$Sw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.$Sw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.$Sw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.$Sw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.$Sw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.$Sw)("ExtHostEditorTabs"),ExtHostProgress:(0,r.$Sw)("ExtHostProgress"),ExtHostComments:(0,r.$Sw)("ExtHostComments"),ExtHostSecretState:(0,r.$Sw)("ExtHostSecretState"),ExtHostStorage:(0,r.$Sw)("ExtHostStorage"),ExtHostUrls:(0,r.$Sw)("ExtHostUrls"),ExtHostUriOpeners:(0,r.$Sw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.$Sw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.$Sw)("ExtHostOutputService"),ExtHostLabelService:(0,r.$Sw)("ExtHostLabelService"),ExtHostNotebook:(0,r.$Sw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.$Sw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.$Sw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.$Sw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.$Sw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,r.$Sw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,r.$Sw)("ExtHostInteractive"),ExtHostChatAgents2:(0,r.$Sw)("ExtHostChatAgents"),ExtHostChatVariables:(0,r.$Sw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,r.$Sw)("ExtHostChatSkills"),ExtHostChatProvider:(0,r.$Sw)("ExtHostChatProvider"),ExtHostSpeech:(0,r.$Sw)("ExtHostSpeech"),ExtHostEmbeddings:(0,r.$Sw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,r.$Sw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,r.$Sw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,r.$Sw)("ExtHostTheming"),ExtHostTunnelService:(0,r.$Sw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,r.$Sw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,r.$Sw)("ExtHostAuthentication"),ExtHostTimeline:(0,r.$Sw)("ExtHostTimeline"),ExtHostTesting:(0,r.$Sw)("ExtHostTesting"),ExtHostTelemetry:(0,r.$Sw)("ExtHostTelemetry"),ExtHostLocalization:(0,r.$Sw)("ExtHostLocalization")}}),define(Se[95],De([1,0,5,11,6,19]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zoc=e.$Yoc=e.$Xoc=void 0,C=Ue(C),e.$Xoc=(0,r.$Ci)("IExtHostApiDeprecationService");let L=class{constructor(b,c){this.c=c,this.a=new Set,this.b=b.getProxy(C.$DN.MainThreadTelemetry)}report(b,c,I){const S=this.d(b,c);this.a.has(S)||(this.a.add(S),c.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${b}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:c.identifier.value,apiId:b}))}d(b,c){return`${b}-${c.identifier.value}`}};e.$Yoc=L,e.$Yoc=L=Ye([Ve(0,R.$cQ),Ve(1,h.$0j)],L),e.$Zoc=Object.freeze(new class{report(T,b,c){}})}),define(Se[275],De([1,0,6]),function($e,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$apc=void 0;class h{constructor(R){const L=R.getProxy(r.$DN.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(T){return L.$writeText(T)}})}}e.$apc=h}),define(Se[276],De([1,0,24,6,29,19]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9qc=void 0;let L=class{constructor(I,S){this.a=I.getProxy(h.$DN.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,S){const u=this,P=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){u.e(I,S,P,arguments)}})}e(I,S,u,P){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:b(P,this.b)}),this.c&&this.f(I,u,P)}};e.$9qc=L,e.$9qc=L=Ye([Ve(0,R.$cQ),Ve(1,C.$sQ)],L);const T=1e5;function b(c,I){const S=[];if(c.length)for(let u=0;u<c.length;u++){let P=c[u];if(typeof P>"u")P="undefined";else if(P instanceof Error){const w=P;w.stack?P=w.stack:P=w.toString()}S.push(P)}if(I){const u=new Error().stack;u&&S.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,r.$go)(S);return u.length>T?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Se[277],De([1,0,2,6,25]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cqc=void 0;class R{constructor(T){this.a=T.getProxy(h.$DN.MainThreadDialogs)}showOpenDialog(T,b){return b?.allowUIResources&&(0,C.$dH)(T,"showLocal"),this.a.$showOpenDialog(b).then(c=>c?c.map(I=>r.URI.revive(I)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then(b=>b?r.URI.revive(b):void 0)}}e.$cqc=R}),define(Se[278],De([1,0,20,4,3,6]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fqc=void 0;class L{constructor(b){this.b=new Map,this.c=new h.$je,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=b.getProxy(R.$DN.MainThreadEmbeddings)}registerEmbeddingsProvider(b,c,I){if(this.d.has(c))throw new Error("An embeddings provider for this model is already registered");const S=this.e++;return this.a.$registerEmbeddingProvider(S,c),this.b.set(S,{id:c,provider:I}),(0,C.$Rc)(()=>{this.d.delete(c),this.a.$unregisterEmbeddingProvider(S),this.b.delete(S)})}async computeEmbeddings(b,c,I){I??=r.CancellationToken.None;let S=!1;typeof c=="string"&&(c=[c],S=!0);const u=await this.a.$computeEmbeddings(b,c,I);if(u.length!==c.length)throw new Error;if(S){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(b,c,I){const S=this.b.get(b);if(!S)return[];const u=await S.provider.provideEmbeddings(c,I);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(b){this.d=new Set(b),this.c.fire()}}e.$fqc=L}),define(Se[279],De([1,0,3,6]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=void 0;class C{constructor(L){this.b=0,this.a=L.getProxy(h.$DN.MainThreadLabelService)}$registerResourceLabelFormatter(L){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,L),(0,r.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$wqc=C}),define(Se[122],De([1,0,10,12,2,5,11,6,29,19]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=e.$Rpc=void 0;let I=class{constructor(u,P,w){this.f=w,this.d=new Map,this.a=P.getProxy(T.$DN.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===r.$h}getMessage(u,P){const{message:w,args:a,comment:m}=P;if(this.c)return(0,h.$cf)(w,a??{});let $=w;m&&m.length>0&&($+=`/${Array.isArray(m)?m.join(""):m}`);const f=this.d.get(u)?.contents[$];return f||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${$}`),(0,h.$cf)(f??w,a??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let P;const w=await this.g(u);if(!w){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(w),m=JSON.parse(a);P=u.isBuiltin?m.contents?.bundle:m}catch(a){this.f.error(`Failed to load translations for ${u.identifier.value} from ${w}: ${a.message}`);return}P&&this.d.set(u.identifier.value,{contents:P,uri:w})}async g(u){if(u.isBuiltin){const P=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return C.URI.revive(P)}return u.l10n?C.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Rpc=I,e.$Rpc=I=Ye([Ve(0,b.$sQ),Ve(1,c.$cQ),Ve(2,L.$0j)],I),e.$Spc=(0,R.$Ci)("IExtHostLocalizationService")}),define(Se[161],De([1,0,11,6,29,19,2,51]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8qc=void 0;let b=class extends r.$ik{constructor(S,u){super(u.logLevel,u.logsLocation,u.loggers.map(P=>(0,T.$_h)(P))),this.r=S.getProxy(h.$DN.MainThreadLogger)}$setLogLevel(S,u){u?this.setLogLevel(L.URI.revive(u),S):this.setLogLevel(S)}setVisibility(S,u){super.setVisibility(S,u),this.r.$setVisibility(S,u)}s(S,u,P){return new c(this.r,S,u,P)}};e.$8qc=b,e.$8qc=b=Ye([Ve(0,R.$cQ),Ve(1,C.$sQ)],b);class c extends r.$dk{constructor(S,u,P,w){super(w?.logLevel==="always"),this.r=S,this.s=u,this.m=!1,this.n=[],this.setLevel(P),this.r.$createLogger(u,w).then(()=>{this.u(this.n),this.m=!0})}g(S,u){const P=[[S,u]];this.m?this.u(P):this.n.push(...P)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Se[123],De([1,0,6,5,3,19,21]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=e.$Tpc=void 0,e.$Tpc=(0,h.$Ci)("IExtHostManagedSockets");let T=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(r.$DN.MainThreadManagedSockets)}setFactory(S,u){for(const P of this.d.values())P.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new b(S,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const u=++this.b,P=await this.c.makeConnection(),w=new C.$Sc;return this.d.set(u,new c(u,P,w)),w.add((0,C.$Rc)(()=>this.d.delete(u))),w.add(P.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),w.dispose()})),w.add(P.onDidClose(a=>{this.a.$onDidManagedSocketClose(u,a?.stack??a?.message),w.dispose()})),w.add(P.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(u,L.$Le.wrap(a)))),u}$remoteSocketWrite(S,u){this.d.get(S)?.actual.send(u.buffer)}$remoteSocketEnd(S){const u=this.d.get(S);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$Upc=T,e.$Upc=T=Ye([Ve(0,R.$cQ)],T);class b{constructor(S,u){this.socketFactoryId=S,this.makeConnection=u}}class c extends C.$Tc{constructor(S,u,P){super(),this.socketId=S,this.actual=u,this.B(P)}}}),define(Se[280],De([1,0,6,11,25]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zqc=void 0;function R(T){return T&&T.title}let L=class{constructor(b,c){this.b=c,this.a=b.getProxy(r.$DN.MainThreadMessageService)}showMessage(b,c,I,S,u){const P={source:{identifier:b.identifier,label:b.displayName||b.name}};let w;typeof S=="string"||R(S)?w=[S,...u]:(P.modal=S?.modal,P.useCustom=S?.useCustom,P.detail=S?.detail,w=u),P.useCustom&&(0,C.$dH)(b,"resolvers");const a=[];let m=!1;for(let $=0;$<w.length;$++){const f=w[$];if(typeof f=="string")a.push({title:f,handle:$,isCloseAffordance:!1});else if(typeof f=="object"){const{title:i,isCloseAffordance:s}=f;a.push({title:i,isCloseAffordance:!!s,handle:$}),s&&(m?this.b.warn(`[${b.identifier}] Only one message item can have 'isCloseAffordance':`,f):m=!0)}else this.b.warn(`[${b.identifier}] Invalid message item:`,f)}return this.a.$showMessage(c,I,P,a).then($=>{if(typeof $=="number")return w[$]})}};e.$zqc=L,e.$zqc=L=Ye([Ve(1,h.$0j)],L)}),define(Se[281],De([1,0,3,17,2,25,6]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iqc=void 0;class T{constructor(c){this.b=new Map,this.a=c.getProxy(L.$DN.MainThreadProfileContentHandlers)}registerProfileContentHandler(c,I,S){if((0,R.$dH)(c,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,S),this.a.$registerProfileContentHandler(I,S.name,S.description,c.identifier.value),(0,r.$Rc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(c,I,S,u){const P=this.b.get(c);if(!P)throw new Error(`Unknown handler with id: ${c}`);return P.saveProfile(I,S,u)}async $readProfile(c,I,S){const u=this.b.get(c);if(!u)throw new Error(`Unknown handler with id: ${c}`);return u.readProfile((0,h.$cg)(I)?I:C.URI.revive(I),S)}}e.$Iqc=T}),define(Se[124],De([1,0,6,4,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=e.$Opc=void 0;class R{constructor(T){this.b=new h.$je,this.onDidChangePassword=this.b.event,this.a=T.getProxy(r.$DN.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,b){return this.a.$getPassword(T,b)}store(T,b,c){return this.a.$setPassword(T,b,c)}delete(T,b){return this.a.$deletePassword(T,b)}}e.$Opc=R,e.$Ppc=(0,C.$Ci)("IExtHostSecretState")}),define(Se[282],De([1,0,20,3,6]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pqc=void 0;class R{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(C.$DN.MainThreadSpeech)}async $createSpeechToTextSession(T,b,c){const I=this.c.get(T);if(!I)return;const S=new h.$Sc,u=new r.$ue;this.d.set(b,u);const P=await I.provideSpeechToTextSession(u.token,c?{language:c}:void 0);P&&(S.add(P.onDidChange(w=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(b,w)})),S.add(u.token.onCancellationRequested(()=>S.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,b,c){const I=this.c.get(T);if(!I)return;const S=new h.$Sc,u=new r.$ue;this.d.set(b,u);const P=await I.provideTextToSpeechSession(u.token,c?{language:c}:void 0);P&&(this.f.set(b,P),S.add(P.onDidChange(w=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(b,w)})),S.add(u.token.onCancellationRequested(()=>S.dispose())))}async $synthesizeSpeech(T,b){this.f.get(T)?.synthesize(b)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,b){const c=this.c.get(T);if(!c)return;const I=new h.$Sc,S=new r.$ue;this.d.set(b,S);const u=await c.provideKeywordRecognitionSession(S.token);u&&(I.add(u.onDidChange(P=>{S.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(b,P)})),I.add(S.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,b,c){const I=R.a++;return this.c.set(I,c),this.b.$registerProvider(I,b,{extension:T,displayName:T.value}),(0,h.$Rc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$Pqc=R}),define(Se[125],De([1,0,6,4,5]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=e.$Epc=void 0;class R{constructor(T,b){this.c=b,this.b=new h.$je,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(r.$DN.MainThreadStorage)}registerExtensionStorageKeysToSync(T,b){this.a.$registerExtensionStorageKeysToSync(T,b)}async initializeExtensionStorage(T,b,c){const I=await this.a.$initializeExtensionStorage(T,b);let S;return I&&(S=this.d(T,b,I)),S||c}setValue(T,b,c){return this.a.$setValue(T,b,c)}$acceptValue(T,b,c){const I=this.d(T,b,c);I&&this.b.fire({shared:T,key:b,value:I})}d(T,b,c){try{return JSON.parse(c)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${b}, global: ${T}): ${I}`)}}}e.$Epc=R,e.$Fpc=(0,C.$Ci)("IExtHostStorage")}),define(Se[283],De([1,0,3,14,2,6]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2qc=void 0;class L{static{this.a=new Set([h.Schemas.http,h.Schemas.https])}constructor(b){this.c=new Map,this.b=b.getProxy(R.$DN.MainThreadUriOpeners)}registerExternalUriOpener(b,c,I,S){if(this.c.has(c))throw new Error(`Opener with id '${c}' already registered`);const u=S.schemes.find(P=>!L.a.has(P));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(c,I),this.b.$registerUriOpener(c,S.schemes,b,S.label),(0,r.$Rc)(()=>{this.c.delete(c),this.b.$unregisterUriOpener(c)})}async $canOpenUri(b,c,I){const S=this.c.get(b);if(!S)throw new Error(`Unknown opener with id: ${b}`);const u=C.URI.revive(c);return S.canOpenExternalUri(u,I)}async $openUri(b,c,I){const S=this.c.get(b);if(!S)throw new Error(`Unknown opener id: '${b}'`);return S.openExternalUri(C.URI.revive(c.resolvedUri),{sourceUri:C.URI.revive(c.sourceUri)},I)}}e.$2qc=L}),define(Se[284],De([1,0,6,2,3,13,23]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3qc=void 0;class T{static{this.a=0}constructor(c){this.c=new L.$pn,this.d=new Map,this.b=c.getProxy(r.$DN.MainThreadUrls)}registerUriHandler(c,I){const S=c.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const u=T.a++;return this.c.add(S),this.d.set(u,I),this.b.$registerUriHandler(u,S,c.displayName||c.name),(0,C.$Rc)(()=>{this.c.delete(S),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(c,I){const S=this.d.get(c);if(!S)return Promise.resolve(void 0);try{S.handleUri(h.URI.revive(I))}catch(u){(0,R.$Y)(u)}return Promise.resolve(void 0)}async createAppUri(c){return h.URI.revive(await this.b.$createAppUri(c))}}e.$3qc=T}),define(Se[285],De([1,0,21,6]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jtb=R,e.$Ktb=T,h=Ue(h);class C{constructor(){this.buffers=[]}add(c){let I=this.buffers.indexOf(c);return I<0&&(I=this.buffers.length,this.buffers.push(c)),I}}function R(b,c){if(c.serializeBuffersForPostMessage){const I=new C,u=JSON.stringify(b,(w,a)=>{if(a instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a)};if(ArrayBuffer.isView(a)){const m=L(a);if(m)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a.buffer),view:{type:m,byteLength:a.byteLength,byteOffset:a.byteOffset}}}return a}),P=I.buffers.map(w=>{const a=new Uint8Array(w);return r.$Le.wrap(a)});return{message:u,buffers:P}}else return{message:JSON.stringify(b),buffers:[]}}function L(b){switch(b.constructor.name){case"Int8Array":return h.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return h.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return h.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return h.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return h.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return h.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return h.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return h.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return h.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return h.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return h.WebviewMessageArrayBufferViewType.BigUint64Array}}function T(b,c){const I=c.map(P=>{const w=new ArrayBuffer(P.byteLength);return new Uint8Array(w).set(P.buffer),w}),S=c.length?(P,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const a=w,{index:m}=a,$=I[m];if(a.view)switch(a.view.type){case h.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array($,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array($,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray($,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array($,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array($,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array($,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array($,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array($,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array($,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array($,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array($,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return $}return w}:void 0;return{message:JSON.parse(b,S),arrayBuffers:I}}}),define(Se[96],De([1,0,4,3,14,24,2,235,285,121,6]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=e.$ppc=void 0,e.$qpc=u,e.$spc=a,e.$tpc=m,R=Ue(R),I=Ue(I);class S{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(s,t,o,n,d,l,g){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new r.$je,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new r.$je,this._onDidDispose=this.#h.event,this.#e=s,this.#t=t,this.#o=o,this.#n=n,this.#s=d,this.#r=l,this.#u=u(l),this.#d=P(l),this.#i=g}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#l=!0,(0,c.$vDb)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===C.Schemas.https||s.scheme===C.Schemas.http){let t=s.toString();return t.endsWith("/")||(t+="/"),t+" "+c.$uDb}return c.$uDb}get html(){return this.a(),this.#a}set html(s){this.a(),this.#a!==s&&(this.#a=s,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(s)))}get options(){return this.a(),this.#o}set options(s){this.a(),R.$fo(this.#o,s)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#c)return!1;const t=(0,b.$Jtb)(s,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(s){if(!this.#d)return s;const t=this.#r.extensionLocation?.scheme===C.Schemas.vscodeRemote,o=this.#r.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,d,l,g,E,D)=>{const y=L.URI.from({scheme:g||"file",path:decodeURIComponent(E)}),k=(0,c.$vDb)(y,{isRemote:t,authority:o}).toString();return`${d}${k}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,d,l,g,E,D)=>{const y=L.URI.from({scheme:g||"file",path:decodeURIComponent(E)}),k=(0,c.$vDb)(y,{isRemote:t,authority:o}).toString();return`${d}${k}${D}`})}}e.$ppc=S;function u(i){try{const s=(0,T.$Yp)((0,T.$Xp)(i.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function P(i){try{const s=(0,T.$Yp)((0,T.$Xp)(i.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class w extends h.$Tc{constructor(s,t,o,n,d){super(),this.c=t,this.f=o,this.g=n,this.h=d,this.b=new Map,this.a=s.getProxy(I.$DN.MainThreadWebviews)}dispose(){super.dispose();for(const s of this.b.values())s.dispose();this.b.clear()}$onMessage(s,t,o){const n=this.j(s);if(n){const{message:d}=(0,b.$Ktb)(t,o.value);n._onMessageEmitter.fire(d)}}$onMissingCsp(s,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,t,o){const n=new S(s,this.a,$(t),this.c,this.f,o,this.h);this.b.set(s,n);const d=n._onDidDispose(()=>{d.dispose(),this.deleteWebview(s)});return n}deleteWebview(s){this.b.delete(s)}j(s){return this.b.get(s)}}e.$rpc=w;function a(i){return{id:i.identifier,location:i.extensionLocation}}function m(i,s,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||f(i,s)}}function $(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(s=>L.URI.from(s))}}function f(i,s){return[...(s?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Se[162],De([1,0,4,14,12,2,5,19,6]),function($e,e,r,h,C,R,L,T,b){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=e.$5qc=void 0;let I=class{static{c=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new r.$je,this.onDidChangeWindowState=this.c.event,this.d=c.a,this.b=u.getProxy(b.$DN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:P,isActive:w})=>{this.onDidChangeWindowProperty("focused",P),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,P){P!==this.d[u]&&(this.d={...this.d,[u]:P},this.c.fire(this.d))}openUri(u,P){let w;if(typeof u=="string"){w=u;try{u=R.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,C.$af)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===h.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,w,P)}async asExternalUri(u,P){if((0,C.$af)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(u,P);return R.URI.from(w)}};e.$5qc=I,e.$5qc=I=c=Ye([Ve(0,T.$cQ)],I),e.$6qc=(0,L.$Ci)("IExtHostWindow")}),define(Se[286],De([1,0,276,29,19,93]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hrc=void 0;const L=1024*1024;let T=class extends r.$9qc{constructor(c,I){super(c,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(c,I,S){const u=c==="error"||c==="warn"?process.stderr:process.stdout;this.g=!0,u.write(`
${R.NativeLogMarkers.Start}
`),I.apply(console,S),u.write(`
${R.NativeLogMarkers.End}
`),this.g=!1}j(c,I){const S=process[c],u=S.write;let P="";Object.defineProperty(S,"write",{set:()=>{},get:()=>(w,a,m)=>{if(!this.g){P+=w.toString(a);const $=P.length>L?P.length:P.lastIndexOf(`
`);$!==-1&&(console[I](P.slice(0,$)),P=P.slice($+1))}u.call(S,w,a,m)}})}};e.$Hrc=T,e.$Hrc=T=Ye([Ve(0,C.$cQ),Ve(1,h.$sQ)],T)}),define(Se[287],De([1,0,161,14,229,32]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Trc=void 0;class L extends r.$8qc{s(b,c,I){return b.scheme===h.Schemas.file?new C.$rR(I?.name||(0,R.$Yg)(),b.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,c):super.s(b,c,I)}registerLogger(b){super.registerLogger(b),this.r.$registerLogger(b)}deregisterLogger(b){super.deregisterLogger(b),this.r.$deregisterLogger(b)}}e.$Trc=L}),define(Se[288],De([1,0,7,21,20,26,13,4,3,40,138,274,53]),function($e,e,r,h,C,R,L,T,b,c,I,S,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=e.ResponsiveState=e.RequestInitiator=void 0,e.$pdc=f,e.$qdc=i,L=Ue(L);function w(F,N){try{return JSON.stringify(F,N)}catch{return"null"}}const a="$$ref$$",m={[a]:-1};class ${constructor(N,O){this.jsonString=N,this.referencedBuffers=O}}function f(F,N=null,O=!1){const j=[];return{jsonString:(O?w:JSON.stringify)(F,(M,W)=>{if(typeof W>"u")return m;if(typeof W=="object"){if(W instanceof h.$Le){const V=j.push(W)-1;return{[a]:V}}if(N)return N(M,W)}return W}),referencedBuffers:j}}function i(F,N,O){return JSON.parse(F,(j,z)=>{if(z){const M=z[a];if(typeof M=="number")return N[M];if(O&&z.$mid===c.MarshalledId.Uri)return O.transformIncoming(z)}return z})}function s(F,N){return JSON.stringify(F,N)}function t(F){return F?(N,O)=>O&&O.$mid===c.MarshalledId.Uri?F.transformOutgoing(O):O:null}var o;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var n;(function(F){F[F.Responsive=0]="Responsive",F[F.Unresponsive=1]="Unresponsive"})(n||(e.ResponsiveState=n={}));const d=()=>{},l=Symbol.for("rpcProtocol"),g=Symbol.for("rpcProxy");class E extends b.$Tc{static{P=l}static{this.a=3*1e3}constructor(N,O=null,j=null){super(),this[P]=!0,this.b=this.B(new T.$je),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=O,this.g=j,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,M=u.$Rw.count;z<M;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=n.Responsive,this.z=0,this.C=0,this.D=this.B(new r.$Oh(()=>this.H(),1e3)),this.B(this.c.onMessage(z=>this.L(z)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const O=this.w[N];delete this.w[N],O.resolveErr(L.$5())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+E.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+E.a,this.z--,this.z===0&&this.D.cancel(),this.I(n.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(n.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,I.$Mn)(N,this.g):N}getProxy(N){const{nid:O,sid:j}=N;return this.s[O]||(this.s[O]=this.J(O,j)),this.s[O]}J(N,O){const j={get:(z,M)=>(typeof M=="string"&&!z[M]&&M.charCodeAt(0)===R.CharCode.DollarSign&&(z[M]=(...W)=>this.U(N,M,W)),M===g?O:z[M])};return new Proxy(Object.create(null),j)}set(N,O){return this.m[N.nid]=O,O}assertRegistered(N){for(let O=0,j=N.length;O<j;O++){const z=N[O];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(N){if(this.j)return;const O=N.byteLength,j=y.read(N,0),z=j.readUInt8(),M=j.readUInt32();switch(z){case p.RequestJSONArgs:case p.RequestJSONArgsWithCancellation:{let{rpcId:W,method:V,args:ne}=A.deserializeRequestJSONArgs(j);this.g&&(ne=(0,I.$Mn)(ne,this.g)),this.M(O,M,W,V,ne,z===p.RequestJSONArgsWithCancellation);break}case p.RequestMixedArgs:case p.RequestMixedArgsWithCancellation:{let{rpcId:W,method:V,args:ne}=A.deserializeRequestMixedArgs(j);this.g&&(ne=(0,I.$Mn)(ne,this.g)),this.M(O,M,W,V,ne,z===p.RequestMixedArgsWithCancellation);break}case p.Acknowledged:{this.f?.logIncoming(O,M,o.LocalSide,"ack"),this.G(M);break}case p.Cancel:{this.N(O,M);break}case p.ReplyOKEmpty:{this.O(O,M,void 0);break}case p.ReplyOKJSON:{let W=A.deserializeReplyOKJSON(j);this.g&&(W=(0,I.$Mn)(W,this.g)),this.O(O,M,W);break}case p.ReplyOKJSONWithBuffers:{const W=A.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(O,M,W);break}case p.ReplyOKVSBuffer:{const W=A.deserializeReplyOKVSBuffer(j);this.O(O,M,W);break}case p.ReplyErrError:{let W=A.deserializeReplyErrError(j);this.g&&(W=(0,I.$Mn)(W,this.g)),this.P(O,M,W);break}case p.ReplyErrEmpty:{this.P(O,M,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,O,j,z,M,W){this.f?.logIncoming(N,O,o.OtherSide,`receiveRequest ${(0,u.$Tw)(j)}.${z}(`,M);const V=String(O);let ne,B;if(W){const Y=new C.$ue;M.push(Y.token),ne=this.Q(j,z,M),B=()=>Y.cancel()}else ne=this.Q(j,z,M),B=d;this.u[V]=B;const K=A.serializeAcknowledged(O);this.f?.logOutgoing(K.byteLength,O,o.OtherSide,"ack"),this.c.send(K),ne.then(Y=>{delete this.u[V];const ee=A.serializeReplyOK(O,Y,this.h);this.f?.logOutgoing(ee.byteLength,O,o.OtherSide,"reply:",Y),this.c.send(ee)},Y=>{delete this.u[V];const ee=A.serializeReplyErr(O,Y);this.f?.logOutgoing(ee.byteLength,O,o.OtherSide,"replyErr:",Y),this.c.send(ee)})}N(N,O){this.f?.logIncoming(N,O,o.OtherSide,"receiveCancel");const j=String(O);this.u[j]?.()}O(N,O,j){this.f?.logIncoming(N,O,o.LocalSide,"receiveReply:",j);const z=String(O);if(!this.w.hasOwnProperty(z))return;const M=this.w[z];delete this.w[z],M.resolveOk(j)}P(N,O,j){this.f?.logIncoming(N,O,o.LocalSide,"receiveReplyErr:",j);const z=String(O);if(!this.w.hasOwnProperty(z))return;const M=this.w[z];delete this.w[z];let W;j&&(j.$isError?(W=new Error,W.name=j.name,W.message=j.message,W.stack=j.stack):W=j),M.resolveErr(W)}Q(N,O,j){try{return Promise.resolve(this.S(N,O,j))}catch(z){return Promise.reject(z)}}S(N,O,j){const z=this.m[N];if(!z)throw new Error("Unknown actor "+(0,u.$Tw)(N));const M=z[O];if(typeof M!="function")throw new Error("Unknown method "+O+" on actor "+(0,u.$Tw)(N));return M.apply(z,j)}U(N,O,j){if(this.j)return new S.$odc;let z=null;if(j.length>0&&C.CancellationToken.isCancellationToken(j[j.length-1])&&(z=j.pop()),z&&z.isCancellationRequested)return Promise.reject(L.$5());const M=A.serializeRequestArguments(j,this.h),W=++this.t,V=String(W),ne=new S.$ndc,B=new b.$Sc;z&&B.add(z.onCancellationRequested(()=>{const Y=A.serializeCancel(W);this.f?.logOutgoing(Y.byteLength,W,o.LocalSide,"cancel"),this.c.send(A.serializeCancel(W))})),this.w[V]=new D(ne,B),this.F(W);const K=A.serializeRequest(W,N,O,M,!!z);return this.f?.logOutgoing(K.byteLength,W,o.LocalSide,`request: ${(0,u.$Tw)(N)}.${O}(`,j),this.c.send(K),ne}}e.$rdc=E;class D{constructor(N,O){this.a=N,this.b=O}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class y{static alloc(N,O,j){const z=new y(h.$Le.alloc(j+1+4),0);return z.writeUInt8(N),z.writeUInt32(O),z}static read(N,O){return new y(N,O)}get buffer(){return this.a}constructor(N,O){this.a=N,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+N).toString();return this.b+=N,j}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+N).toString();return this.b+=N,j}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+N);return this.b+=N,O}static sizeMixedArray(N){let O=0;O+=1;for(let j=0,z=N.length;j<z;j++){const M=N[j];switch(O+=1,M.type){case v.String:O+=this.sizeLongString(M.value);break;case v.VSBuffer:O+=this.sizeVSBuffer(M.value);break;case v.SerializedObjectWithBuffers:O+=this.sizeUInt32,O+=this.sizeLongString(M.value);for(let W=0;W<M.buffers.length;++W)O+=this.sizeVSBuffer(M.buffers[W]);break;case v.Undefined:break}}return O}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let O=0,j=N.length;O<j;O++){const z=N[O];switch(z.type){case v.String:this.writeUInt8(v.String),this.writeLongString(z.value);break;case v.VSBuffer:this.writeUInt8(v.VSBuffer),this.writeVSBuffer(z.value);break;case v.SerializedObjectWithBuffers:this.writeUInt8(v.SerializedObjectWithBuffers),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let M=0;M<z.buffers.length;++M)this.writeBuffer(z.buffers[M]);break;case v.Undefined:this.writeUInt8(v.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const O=new Array(N);for(let j=0;j<N;j++)switch(this.readUInt8()){case v.String:O[j]=this.readLongString();break;case v.VSBuffer:O[j]=this.readVSBuffer();break;case v.SerializedObjectWithBuffers:{const M=this.readUInt32(),W=this.readLongString(),V=[];for(let ne=0;ne<M;++ne)V.push(this.readVSBuffer());O[j]=new u.$Uw(i(W,V,null));break}case v.Undefined:O[j]=void 0;break}return O}}var k;(function(F){F[F.Simple=0]="Simple",F[F.Mixed=1]="Mixed"})(k||(k={}));class A{static a(N){for(let O=0,j=N.length;O<j;O++)if(N[O]instanceof h.$Le||N[O]instanceof u.$Uw||typeof N[O]>"u")return!0;return!1}static serializeRequestArguments(N,O){if(this.a(N)){const j=[];for(let z=0,M=N.length;z<M;z++){const W=N[z];if(W instanceof h.$Le)j[z]={type:v.VSBuffer,value:W};else if(typeof W>"u")j[z]={type:v.Undefined};else if(W instanceof u.$Uw){const{jsonString:V,referencedBuffers:ne}=f(W.value,O);j[z]={type:v.SerializedObjectWithBuffers,value:h.$Le.fromString(V),buffers:ne}}else j[z]={type:v.String,value:h.$Le.fromString(s(W,O))}}return{type:k.Mixed,args:j}}return{type:k.Simple,args:s(N,O)}}static serializeRequest(N,O,j,z,M){switch(z.type){case k.Simple:return this.b(N,O,j,z.args,M);case k.Mixed:return this.c(N,O,j,z.args,M)}}static b(N,O,j,z,M){const W=h.$Le.fromString(j),V=h.$Le.fromString(z);let ne=0;ne+=y.sizeUInt8(),ne+=y.sizeShortString(W),ne+=y.sizeLongString(V);const B=y.alloc(M?p.RequestJSONArgsWithCancellation:p.RequestJSONArgs,N,ne);return B.writeUInt8(O),B.writeShortString(W),B.writeLongString(V),B.buffer}static deserializeRequestJSONArgs(N){const O=N.readUInt8(),j=N.readShortString(),z=N.readLongString();return{rpcId:O,method:j,args:JSON.parse(z)}}static c(N,O,j,z,M){const W=h.$Le.fromString(j);let V=0;V+=y.sizeUInt8(),V+=y.sizeShortString(W),V+=y.sizeMixedArray(z);const ne=y.alloc(M?p.RequestMixedArgsWithCancellation:p.RequestMixedArgs,N,V);return ne.writeUInt8(O),ne.writeShortString(W),ne.writeMixedArray(z),ne.buffer}static deserializeRequestMixedArgs(N){const O=N.readUInt8(),j=N.readShortString(),z=N.readMixedArray(),M=new Array(z.length);for(let W=0,V=z.length;W<V;W++){const ne=z[W];typeof ne=="string"?M[W]=JSON.parse(ne):M[W]=ne}return{rpcId:O,method:j,args:M}}static serializeAcknowledged(N){return y.alloc(p.Acknowledged,N,0).buffer}static serializeCancel(N){return y.alloc(p.Cancel,N,0).buffer}static serializeReplyOK(N,O,j){if(typeof O>"u")return this.d(N);if(O instanceof h.$Le)return this.e(N,O);if(O instanceof u.$Uw){const{jsonString:z,referencedBuffers:M}=f(O.value,j,!0);return this.g(N,z,M)}else return this.f(N,w(O,j))}static d(N){return y.alloc(p.ReplyOKEmpty,N,0).buffer}static e(N,O){let j=0;j+=y.sizeVSBuffer(O);const z=y.alloc(p.ReplyOKVSBuffer,N,j);return z.writeVSBuffer(O),z.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,O){const j=h.$Le.fromString(O);let z=0;z+=y.sizeLongString(j);const M=y.alloc(p.ReplyOKJSON,N,z);return M.writeLongString(j),M.buffer}static g(N,O,j){const z=h.$Le.fromString(O);let M=0;M+=y.sizeUInt32,M+=y.sizeLongString(z);for(const V of j)M+=y.sizeVSBuffer(V);const W=y.alloc(p.ReplyOKJSONWithBuffers,N,M);W.writeUInt32(j.length),W.writeLongString(z);for(const V of j)W.writeBuffer(V);return W.buffer}static deserializeReplyOKJSON(N){const O=N.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(N,O){const j=N.readUInt32(),z=N.readLongString(),M=[];for(let W=0;W<j;++W)M.push(N.readVSBuffer());return new u.$Uw(i(z,M,O))}static serializeReplyErr(N,O){const j=O?w(L.$1(O),null):void 0;if(typeof j!="string")return this.h(N);const z=h.$Le.fromString(j);let M=0;M+=y.sizeLongString(z);const W=y.alloc(p.ReplyErrError,N,M);return W.writeLongString(z),W.buffer}static deserializeReplyErrError(N){const O=N.readLongString();return JSON.parse(O)}static h(N){return y.alloc(p.ReplyErrEmpty,N,0).buffer}}var p;(function(F){F[F.RequestJSONArgs=1]="RequestJSONArgs",F[F.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",F[F.RequestMixedArgs=3]="RequestMixedArgs",F[F.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",F[F.Acknowledged=5]="Acknowledged",F[F.Cancel=6]="Cancel",F[F.ReplyOKEmpty=7]="ReplyOKEmpty",F[F.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",F[F.ReplyOKJSON=9]="ReplyOKJSON",F[F.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",F[F.ReplyErrError=11]="ReplyErrError",F[F.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var v;(function(F){F[F.String=1]="String",F[F.VSBuffer=2]="VSBuffer",F[F.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",F[F.Undefined=4]="Undefined"})(v||(v={}))}),define(Se[289],De([1,0,21,28,14,88,5]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qL=e.$nL=void 0,e.$oL=I,e.$pL=S,e.$nL=(0,L.$Ci)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],b=new RegExp(`^[${T.join("")}]+`),c=7;function I(P){if(P.scheme!==C.Schemas.vscodeNotebookCell)return;const w=P.fragment.indexOf("s");if(w<0)return;const a=parseInt(P.fragment.substring(0,w).replace(b,""),c),m=(0,r.$5e)(P.fragment.substring(w+1)).toString();if(!isNaN(a))return{handle:a,notebook:P.with({scheme:m,fragment:null})}}function S(P,w){const a=w.toString(c),$=`${a.length<T.length?T[a.length-1]:"z"}${a}s${(0,r.$6e)(r.$Le.fromString(P.scheme),!0,!0)}`;return P.with({scheme:C.Schemas.vscodeNotebookCell,fragment:$})}class u{constructor(){this.a=new h.$zc}getNotebook(w){if(w.scheme===C.Schemas.vscodeNotebookCell){const a=I(w);if(a){const m=this.a.get(a.notebook);if(m)return m}}return this.a.get(w)}addNotebookDocument(w){this.a.set(w.uri,w)}removeNotebookDocument(w){this.a.delete(w.uri)}}e.$qL=u,(0,R.$Os)(e.$nL,u,R.InstantiationType.Delayed)}),define(Se[126],De([1,0,21,38,39,103,14,16,10,35,289]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=e.$HL=e.CellStatusbarAlignment=e.$GL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$DL=e.$CL=e.$AL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$zL=e.$yL=e.$xL=e.$wL=e.CellKind=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=void 0,e.$BL=n,e.$EL=g,e.$FL=E,e.$IL=k,e.$JL=p,h=Ue(h),e.$rL="workbench.editor.notebook",e.$sL="workbench.editor.notebookTextDiffEditor",e.$tL="workbench.editor.interactive",e.$uL="workbench.editor.repl",e.$vL="replNotebook.input.execute";var S;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(S||(e.CellKind=S={})),e.$wL=["application/json","application/javascript","text/html","image/svg+xml",R.$8s.latex,R.$8s.markdown,"image/png","image/jpeg",R.$8s.text],e.$xL=[R.$8s.latex,R.$8s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$8s.text],e.$yL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$zL="_notAvailable";var u;(function(V){V[V.Running=1]="Running",V[V.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var P;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(P||(e.NotebookCellExecutionState=P={}));var w;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(w||(e.NotebookExecutionState=w={}));var a;(function(V){V[V.WithHardKernelDependency=0]="WithHardKernelDependency",V[V.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",V[V.Pure=2]="Pure",V[V.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var m;(function(V){V.Always="always",V.Never="never",V.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var $;(function(V){V[V.ModelChange=1]="ModelChange",V[V.Move=2]="Move",V[V.ChangeCellLanguage=5]="ChangeCellLanguage",V[V.Initialize=6]="Initialize",V[V.ChangeCellMetadata=7]="ChangeCellMetadata",V[V.Output=8]="Output",V[V.OutputItem=9]="OutputItem",V[V.ChangeCellContent=10]="ChangeCellContent",V[V.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",V[V.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",V[V.ChangeCellMime=13]="ChangeCellMime",V[V.Unknown=100]="Unknown"})($||(e.NotebookCellsChangeType=$={}));var f;(function(V){V[V.Handle=0]="Handle",V[V.Index=1]="Index"})(f||(e.SelectionStateType=f={}));var i;(function(V){V[V.Replace=1]="Replace",V[V.Output=2]="Output",V[V.Metadata=3]="Metadata",V[V.CellLanguage=4]="CellLanguage",V[V.DocumentMetadata=5]="DocumentMetadata",V[V.Move=6]="Move",V[V.OutputItems=7]="OutputItems",V[V.PartialMetadata=8]="PartialMetadata",V[V.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var s;(function(V){V.scheme=L.Schemas.vscodeNotebookCell;function ne(re,ye){return(0,I.$pL)(re,ye)}V.generate=ne;function B(re){return(0,I.$oL)(re)}V.parse=B;function K(re,ye){return re.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${ye??""},${re.scheme!==L.Schemas.file?re.scheme:""}`})}V.generateCellOutputUri=K;function Y(re){if(re.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const ye=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(re.fragment);if(!ye)return;const me=ye[1]&&ye[1]!==""?ye[1]:void 0,J=ye[2];return{outputId:me,notebook:re.with({scheme:J||L.Schemas.file,fragment:null})}}V.parseCellOutputUri=Y;function ee(re,ye,me){return V.generate(re,ye).with({scheme:me})}V.generateCellPropertyUri=ee;function ue(re,ye){if(re.scheme===ye)return V.parse(re.with({scheme:V.scheme}))}V.parseCellPropertyUri=ue})(s||(e.CellUri=s={}));const t=V=>b.$j?V.replace(/\//g,"\\"):V;class o{constructor(ne=[],B=e.$wL){this.e=B,this.d=[...new Set(ne)].map(K=>({pattern:K,matches:h.$xk(t(K))}))}sort(ne){const B=new Map(C.Iterable.map(ne,Y=>[Y,t(Y)]));let K=[];for(const{matches:Y}of this.d)for(const[ee,ue]of B)if(Y(ue)){K.push(ee),B.delete(ee);break}return B.size&&(K=K.concat([...B.keys()].sort((Y,ee)=>this.e.indexOf(Y)-this.e.indexOf(ee)))),K}prioritize(ne,B){const K=this.f(ne);if(K===-1){this.d.unshift({pattern:ne,matches:h.$xk(t(ne))});return}const Y=new Set(B.map(ue=>this.f(ue,K)));Y.delete(-1);const ee=Array.from(Y).sort();this.d.splice(K+1,0,...ee.map(ue=>this.d[ue]));for(let ue=ee.length-1;ue>=0;ue--)this.d.splice(ee[ue],1)}toArray(){return this.d.map(ne=>ne.pattern)}f(ne,B=this.d.length){const K=t(ne);for(let Y=0;Y<B;Y++)if(this.d[Y].matches(K))return Y;return-1}}e.$AL=o;function n(V,ne,B,K=(Y,ee)=>Y===ee){const Y=[];function ee(ye,me,J){if(me===0&&J.length===0)return;const U=Y[Y.length-1];U&&U.start+U.deleteCount===ye?(U.deleteCount+=me,U.toInsert.push(...J)):Y.push({start:ye,deleteCount:me,toInsert:J})}let ue=0,re=0;for(;;){if(ue===V.length){ee(ue,0,ne.slice(re));break}if(re===ne.length){ee(ue,V.length-ue,[]);break}const ye=V[ue],me=ne[re];if(K(ye,me)){ue+=1,re+=1;continue}B(me)?(ee(ue,1,[]),ue+=1):(ee(ue,0,[me]),re+=1)}return Y}e.$CL=new c.$Tj("notebookEditorCursorAtBoundary","none"),e.$DL=new c.$Tj("notebookEditorCursorAtLineBoundary","none");var d;(function(V){V.default="default",V.option="option"})(d||(e.NotebookEditorPriority=d={}));var l;(function(V){V.Cells="cells",V.Text="text",V.None="none"})(l||(e.NotebookFindScopeType=l={}));function g(V){const ne=V;return!!((typeof ne.include=="string"||h.$yk(ne.include))&&(typeof ne.exclude=="string"||h.$yk(ne.exclude)))}function E(V,ne,B){if(Array.isArray(V.viewType)&&V.viewType.indexOf(ne)>=0||V.viewType===ne)return!0;if(V.filenamePattern){const K=g(V.filenamePattern)?V.filenamePattern.include:V.filenamePattern,Y=g(V.filenamePattern)?V.filenamePattern.exclude:void 0;if(h.$wk(K,(0,T.$mc)(B.fsPath).toLowerCase()))return!(Y&&h.$wk(Y,(0,T.$mc)(B.fsPath).toLowerCase()))}return!1}e.$GL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class y{static{this.d="notebook/"}static create(ne){return`${y.d}${ne}`}static parse(ne){if(ne.startsWith(y.d))return ne.substring(y.d.length)}}e.$HL=y;function k(V){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(V)}const A=new TextDecoder;function p(V){const ne=[];let B=!1;for(const ue of V)(ne.length===0||B)&&(ne.push(ue),B=!0);let K=N(ne);const Y=r.$Le.concat(ne.map(ue=>r.$Le.wrap(ue))),ee=W(Y);return K=K||ee.byteLength!==Y.byteLength,{data:ee,didCompression:K}}e.$KL="\x1B[A";const v=e.$KL.split("").map(V=>V.charCodeAt(0)),F=10;function N(V){let ne=!1;return V.forEach((B,K)=>{if(K===0||B.length<e.$KL.length)return;const Y=V[K-1],ee=B.subarray(0,e.$KL.length);if(ee[0]===v[0]&&ee[1]===v[1]&&ee[2]===v[2]){const ue=Y.lastIndexOf(F);if(ue===-1)return;ne=!0,V[K-1]=Y.subarray(0,ue),V[K]=B.subarray(e.$KL.length)}}),ne}function O(V){let ne=V;do V=ne,ne=V.replace(/[^\n]\x08/gm,"");while(ne.length<V.length);return V}function j(V){for(V=V.replace(/\r+\n/gm,`
`);V.search(/\r[^$]/g)>-1;){const ne=V.match(/^(.*)\r+/m)[1];let B=V.match(/\r+(.*)$/m)[1];B=B+ne.slice(B.length,ne.length),V=V.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,B)}return V}const z=8,M=13;function W(V){return!V.buffer.includes(z)&&!V.buffer.includes(M)?V:r.$Le.fromString(j(O(A.decode(V.buffer))))}}),define(Se[9],De([1,0,18,13,85,28,103,12,17,2,32,23,27,71,126]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w){"use strict";var a,m,$,f,i,s,t,o,n,d,l,g,E,D,y,k,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$4P=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$3P=e.$2P=e.$1P=e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.LanguageModelChatMessageRole=e.$UP=e.$TP=e.ChatLocation=e.$SP=e.$RP=e.$QP=e.$PP=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.$GP=e.$FP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$EP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.$sP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$rP=e.$qP=e.$pP=e.$oP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.TestRunProfileKind=e.TestResultState=e.$hP=e.$gP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$fP=e.NotebookVariablesRequestKind=e.$eP=e.$dP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$cP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.ColorThemeKind=e.$9O=e.$8O=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$7O=e.QuickInputButtonLocation=e.$6O=e.DebugConsoleMode=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$ZO=e.$YO=e.FileChangeType=e.$XO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$WO=e.$VO=e.$UO=e.$TO=e.InlineCompletionTriggerKind=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.$LO=e.$KO=e.$JO=e.$IO=e.$GO=e.ConfigurationTarget=e.$FO=e.$EO=e.$DO=e.$CO=e.DocumentPasteTriggerKind=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$vO=e.ViewBadge=e.ProgressLocation=e.$uO=e.$tO=e.TaskScope=e.ShellQuoting=e.$sO=e.$rO=e.$qO=e.TaskPanelKind=e.TaskRevealKind=e.$pO=e.TerminalLocation=e.$oO=e.$nO=e.$mO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$lO=e.$kO=e.$jO=e.$iO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$gO=e.$fO=e.$eO=e.$dO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$cO=e.$bO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.LanguageStatusSeverity=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.CodeActionTriggerKind=e.$2N=e.$1N=e.SymbolTag=e.SymbolKind=e.$ZN=e.$YN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.DiagnosticSeverity=e.DiagnosticTag=e.$SN=e.$RN=e.FileEditType=e.$QN=e.$PN=e.$ON=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$NN=e.$MN=e.$LN=e.$IN=e.$HN=e.$GN=e.$FN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$JN=M,e.$KN=W,e.$hO=gt,e.$HO=Ni,e.$nP=Cn;function p(Q){return Object.assign(Q,{apply:function(...ge){if(ge.length===0)return Reflect.construct(Q,[]);{const Le=ge.length===1?[]:ge[1];return Reflect.construct(Q,Le,ge[0].constructor)}},call:function(...ge){if(ge.length===0)return Reflect.construct(Q,[]);{const[Le,...Ze]=ge;return Reflect.construct(Q,Ze,Le.constructor)}}})}var v;(function(Q){Q[Q.Top=0]="Top",Q[Q.Bottom=1]="Bottom"})(v||(e.TerminalOutputAnchor=v={}));var F;(function(Q){Q[Q.TerminalCommand=0]="TerminalCommand",Q[Q.Opener=1]="Opener",Q[Q.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let N=a=class{static from(...G){let ge=G;return new a(function(){if(ge){for(const Le of ge)Le&&typeof Le.dispose=="function"&&Le.dispose();ge=void 0}})}#e;constructor(G){this.#e=G}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$FN=N,e.$FN=N=a=Ye([p],N);let O=m=class{static Min(...G){if(G.length===0)throw new TypeError;let ge=G[0];for(let Le=1;Le<G.length;Le++){const Ze=G[Le];Ze.isBefore(ge)&&(ge=Ze)}return ge}static Max(...G){if(G.length===0)throw new TypeError;let ge=G[0];for(let Le=1;Le<G.length;Le++){const Ze=G[Le];Ze.isAfter(ge)&&(ge=Ze)}return ge}static isPosition(G){if(!G)return!1;if(G instanceof m)return!0;const{line:ge,character:Le}=G;return typeof ge=="number"&&typeof Le=="number"}static of(G){if(G instanceof m)return G;if(this.isPosition(G))return new m(G.line,G.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(G,ge){if(G<0)throw(0,h.$6)("line must be non-negative");if(ge<0)throw(0,h.$6)("character must be non-negative");this.c=G,this.e=ge}isBefore(G){return this.c<G.c?!0:G.c<this.c?!1:this.e<G.e}isBeforeOrEqual(G){return this.c<G.c?!0:G.c<this.c?!1:this.e<=G.e}isAfter(G){return!this.isBeforeOrEqual(G)}isAfterOrEqual(G){return!this.isBefore(G)}isEqual(G){return this.c===G.c&&this.e===G.e}compareTo(G){return this.c<G.c?-1:this.c>G.line?1:this.e<G.e?-1:this.e>G.e?1:0}translate(G,ge=0){if(G===null||ge===null)throw(0,h.$6)();let Le;return typeof G>"u"?Le=0:typeof G=="number"?Le=G:(Le=typeof G.lineDelta=="number"?G.lineDelta:0,ge=typeof G.characterDelta=="number"?G.characterDelta:0),Le===0&&ge===0?this:new m(this.line+Le,this.character+ge)}with(G,ge=this.character){if(G===null||ge===null)throw(0,h.$6)();let Le;return typeof G>"u"?Le=this.line:typeof G=="number"?Le=G:(Le=typeof G.line=="number"?G.line:this.line,ge=typeof G.character=="number"?G.character:this.character),Le===this.line&&ge===this.character?this:new m(Le,ge)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$GN=O,e.$GN=O=m=Ye([p],O);let j=$=class{static isRange(G){return G instanceof $?!0:G?O.isPosition(G.start)&&O.isPosition(G.end):!1}static of(G){if(G instanceof $)return G;if(this.isRange(G))return new $(G.start,G.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(G,ge,Le,Ze){let ot,$t;if(typeof G=="number"&&typeof ge=="number"&&typeof Le=="number"&&typeof Ze=="number"?(ot=new O(G,ge),$t=new O(Le,Ze)):O.isPosition(G)&&O.isPosition(ge)&&(ot=O.of(G),$t=O.of(ge)),!ot||!$t)throw new Error("Invalid arguments");ot.isBefore($t)?(this.c=ot,this.e=$t):(this.c=$t,this.e=ot)}contains(G){return $.isRange(G)?this.contains(G.start)&&this.contains(G.end):O.isPosition(G)?!(O.of(G).isBefore(this.c)||this.e.isBefore(G)):!1}isEqual(G){return this.c.isEqual(G.c)&&this.e.isEqual(G.e)}intersection(G){const ge=O.Max(G.start,this.c),Le=O.Min(G.end,this.e);if(!ge.isAfter(Le))return new $(ge,Le)}union(G){if(this.contains(G))return this;if(G.contains(this))return G;const ge=O.Min(G.start,this.c),Le=O.Max(G.end,this.end);return new $(ge,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(G,ge=this.end){if(G===null||ge===null)throw(0,h.$6)();let Le;return G?O.isPosition(G)?Le=G:(Le=G.start||this.start,ge=G.end||this.end):Le=this.start,Le.isEqual(this.c)&&ge.isEqual(this.end)?this:new $(Le,ge)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return M(this)}};e.$HN=j,e.$HN=j=$=Ye([p],j);let z=f=class extends j{static isSelection(G){return G instanceof f?!0:G?j.isRange(G)&&O.isPosition(G.anchor)&&O.isPosition(G.active)&&typeof G.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(G,ge,Le,Ze){let ot,$t;if(typeof G=="number"&&typeof ge=="number"&&typeof Le=="number"&&typeof Ze=="number"?(ot=new O(G,ge),$t=new O(Le,Ze)):O.isPosition(G)&&O.isPosition(ge)&&(ot=O.of(G),$t=O.of(ge)),!ot||!$t)throw new Error("Invalid arguments");super(ot,$t),this.f=ot,this.g=$t}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return W(this)}};e.$IN=z,e.$IN=z=f=Ye([p],z);function M(Q){return Q.isEmpty?`[${Q.start.line}:${Q.start.character})`:`[${Q.start.line}:${Q.start.character} -> ${Q.end.line}:${Q.end.character})`}function W(Q){let G=M(Q);return Q.isEmpty||(Q.active.isEqual(Q.start)?G=`|${G}`:G=`${G}|`),G}const V=Q=>{if(typeof Q!="string"||Q.length===0||!/^[0-9A-Za-z_\-]+$/.test(Q))throw(0,h.$6)("connectionToken")};class ne{static isResolvedAuthority(G){return G&&typeof G=="object"&&typeof G.host=="string"&&typeof G.port=="number"&&(G.connectionToken===void 0||typeof G.connectionToken=="string")}constructor(G,ge,Le){if(typeof G!="string"||G.length===0)throw(0,h.$6)("host");if(typeof ge!="number"||ge===0||Math.round(ge)!==ge)throw(0,h.$6)("port");typeof Le<"u"&&V(Le),this.host=G,this.port=Math.round(ge),this.connectionToken=Le}}e.$LN=ne;class B{static isManagedResolvedAuthority(G){return G&&typeof G=="object"&&typeof G.makeConnection=="function"&&(G.connectionToken===void 0||typeof G.connectionToken=="string")}constructor(G,ge){this.makeConnection=G,this.connectionToken=ge,typeof ge<"u"&&V(ge)}}e.$MN=B;class K extends Error{static NotAvailable(G,ge){return new K(G,P.RemoteAuthorityResolverErrorCode.NotAvailable,ge)}static TemporarilyNotAvailable(G){return new K(G,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(G,ge=P.RemoteAuthorityResolverErrorCode.Unknown,Le){super(G),this._message=G,this._code=ge,this._detail=Le,Object.setPrototypeOf(this,K.prototype)}}e.$NN=K;var Y;(function(Q){Q[Q.LF=1]="LF",Q[Q.CRLF=2]="CRLF"})(Y||(e.EndOfLine=Y={}));var ee;(function(Q){Q[Q.Replace=1]="Replace",Q[Q.Append=2]="Append",Q[Q.Prepend=3]="Prepend"})(ee||(e.EnvironmentVariableMutatorType=ee={}));let ue=i=class{static isTextEdit(G){return G instanceof i?!0:G?j.isRange(G)&&typeof G.newText=="string":!1}static replace(G,ge){return new i(G,ge)}static insert(G,ge){return i.replace(new j(G,G),ge)}static delete(G){return i.replace(G,"")}static setEndOfLine(G){const ge=new i(new j(new O(0,0),new O(0,0)),"");return ge.newEol=G,ge}get range(){return this.c}set range(G){if(G&&!j.isRange(G))throw(0,h.$6)("range");this.c=G}get newText(){return this.e||""}set newText(G){if(G&&typeof G!="string")throw(0,h.$6)("newText");this.e=G}get newEol(){return this.f}set newEol(G){if(G&&typeof G!="number")throw(0,h.$6)("newEol");this.f=G}constructor(G,ge){this.c=G,this.e=ge}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$ON=ue,e.$ON=ue=i=Ye([p],ue);let re=s=class{static isNotebookCellEdit(G){return G instanceof s?!0:G?Ei.isNotebookRange(G)&&Array.isArray(G.newCells):!1}static replaceCells(G,ge){return new s(G,ge)}static insertCells(G,ge){return new s(new Ei(G,G),ge)}static deleteCells(G){return new s(G,[])}static updateCellMetadata(G,ge){const Le=new s(new Ei(G,G),[]);return Le.newCellMetadata=ge,Le}static updateNotebookMetadata(G){const ge=new s(new Ei(0,0),[]);return ge.newNotebookMetadata=G,ge}constructor(G,ge){this.range=G,this.newCells=ge}};e.$PN=re,e.$PN=re=s=Ye([p],re);class ye{static isSnippetTextEdit(G){return G instanceof ye?!0:G?j.isRange(G.range)&&U.isSnippetString(G.snippet):!1}static replace(G,ge){return new ye(G,ge)}static insert(G,ge){return ye.replace(new j(G,G),ge)}constructor(G,ge){this.range=G,this.snippet=ge}}e.$QN=ye;var me;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text",Q[Q.Cell=3]="Cell",Q[Q.CellReplace=5]="CellReplace",Q[Q.Snippet=6]="Snippet"})(me||(e.FileEditType=me={}));let J=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(G,ge,Le,Ze){this.c.push({_type:me.File,from:G,to:ge,options:Le,metadata:Ze})}createFile(G,ge,Le){this.c.push({_type:me.File,from:void 0,to:G,options:ge,metadata:Le})}deleteFile(G,ge,Le){this.c.push({_type:me.File,from:G,to:void 0,options:ge,metadata:Le})}e(G,ge,Le){this.c.push({_type:me.Cell,metadata:Le,uri:G,edit:{editType:w.CellEditType.DocumentMetadata,metadata:ge},notebookMetadata:ge})}f(G,ge,Le,Ze){const ot=ge.start,$t=ge.end;(ot!==$t||Le.length>0)&&this.c.push({_type:me.CellReplace,uri:G,index:ot,count:$t-ot,cells:Le,metadata:Ze})}g(G,ge,Le,Ze){this.c.push({_type:me.Cell,metadata:Ze,uri:G,edit:{editType:w.CellEditType.Metadata,index:ge,metadata:Le}})}replace(G,ge,Le,Ze){this.c.push({_type:me.Text,uri:G,edit:new ue(ge,Le),metadata:Ze})}insert(G,ge,Le,Ze){this.replace(G,new j(ge,ge),Le,Ze)}delete(G,ge,Le){this.replace(G,ge,"",Le)}has(G){return this.c.some(ge=>ge._type===me.Text&&ge.uri.toString()===G.toString())}set(G,ge){if(ge)for(const Le of ge){if(!Le)continue;let Ze,ot;Array.isArray(Le)?(Ze=Le[0],ot=Le[1]):Ze=Le,re.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(G,Ze.range.start,Ze.newCellMetadata,ot):Ze.newNotebookMetadata?this.e(G,Ze.newNotebookMetadata,ot):this.f(G,Ze.range,Ze.newCells,ot):ye.isSnippetTextEdit(Ze)?this.c.push({_type:me.Snippet,uri:G,range:Ze.range,edit:Ze.snippet,metadata:ot}):this.c.push({_type:me.Text,uri:G,edit:Ze,metadata:ot})}else{for(let Le=0;Le<this.c.length;Le++){const Ze=this.c[Le];switch(Ze._type){case me.Text:case me.Snippet:case me.Cell:case me.CellReplace:Ze.uri.toString()===G.toString()&&(this.c[Le]=void 0);break}}(0,r.$Hb)(this.c)}}get(G){const ge=[];for(const Le of this.c)Le._type===me.Text&&Le.uri.toString()===G.toString()&&ge.push(Le.edit);return ge}entries(){const G=new R.$zc;for(const ge of this.c)if(ge._type===me.Text){let Le=G.get(ge.uri);Le||(Le=[ge.uri,[]],G.set(ge.uri,Le)),Le[1].push(ge.edit)}return[...G.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$RN=J,e.$RN=J=Ye([p],J);let U=t=class{static isSnippetString(G){return G instanceof t?!0:G?typeof G.value=="string":!1}static c(G){return G.replace(/\$|}|\\/g,"\\$&")}constructor(G){this.e=1,this.value=G||""}appendText(G){return this.value+=t.c(G),this}appendTabstop(G=this.e++){return this.value+="$",this.value+=G,this}appendPlaceholder(G,ge=this.e++){if(typeof G=="function"){const Le=new t;Le.e=this.e,G(Le),this.e=Le.e,G=Le.value}else G=t.c(G);return this.value+="${",this.value+=ge,this.value+=":",this.value+=G,this.value+="}",this}appendChoice(G,ge=this.e++){const Le=G.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ge,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(G,ge){if(typeof ge=="function"){const Le=new t;Le.e=this.e,ge(Le),this.e=Le.e,ge=Le.value}else typeof ge=="string"&&(ge=ge.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=G,ge&&(this.value+=":",this.value+=ge),this.value+="}",this}};e.$SN=U,e.$SN=U=t=Ye([p],U);var se;(function(Q){Q[Q.Unnecessary=1]="Unnecessary",Q[Q.Deprecated=2]="Deprecated"})(se||(e.DiagnosticTag=se={}));var ae;(function(Q){Q[Q.Hint=3]="Hint",Q[Q.Information=2]="Information",Q[Q.Warning=1]="Warning",Q[Q.Error=0]="Error"})(ae||(e.DiagnosticSeverity=ae={}));let te=o=class{static isLocation(G){return G instanceof o?!0:G?j.isRange(G.range)&&c.URI.isUri(G.uri):!1}constructor(G,ge){if(this.uri=G,ge)if(j.isRange(ge))this.range=j.of(ge);else if(O.isPosition(ge))this.range=new j(ge,ge);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$TN=te,e.$TN=te=o=Ye([p],te);let ce=class{static is(G){return G?typeof G.message=="string"&&G.location&&j.isRange(G.location.range)&&c.URI.isUri(G.location.uri):!1}constructor(G,ge){this.location=G,this.message=ge}static isEqual(G,ge){return G===ge?!0:!G||!ge?!1:G.message===ge.message&&G.location.range.isEqual(ge.location.range)&&G.location.uri.toString()===ge.location.uri.toString()}};e.$UN=ce,e.$UN=ce=Ye([p],ce);let le=class{constructor(G,ge,Le=ae.Error){if(!j.isRange(G))throw new TypeError("range must be set");if(!ge)throw new TypeError("message must be set");this.range=G,this.message=ge,this.severity=Le}toJSON(){return{severity:ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(G,ge){return G===ge?!0:!G||!ge?!1:G.message===ge.message&&G.severity===ge.severity&&G.code===ge.code&&G.severity===ge.severity&&G.source===ge.source&&G.range.isEqual(ge.range)&&(0,r.$tb)(G.tags,ge.tags)&&(0,r.$tb)(G.relatedInformation,ge.relatedInformation,ce.isEqual)}};e.$VN=le,e.$VN=le=Ye([p],le);let x=class{constructor(G,ge){if(!G)throw new Error("Illegal argument, contents must be defined");Array.isArray(G)?this.contents=G:this.contents=[G],this.range=ge}};e.$WN=x,e.$WN=x=Ye([p],x);let oe=class extends x{constructor(G,ge,Le,Ze){super(G,ge),this.canIncreaseVerbosity=Le,this.canDecreaseVerbosity=Ze}};e.$XN=oe,e.$XN=oe=Ye([p],oe);var pe;(function(Q){Q[Q.Increase=0]="Increase",Q[Q.Decrease=1]="Decrease"})(pe||(e.HoverVerbosityAction=pe={}));var we;(function(Q){Q[Q.Text=0]="Text",Q[Q.Read=1]="Read",Q[Q.Write=2]="Write"})(we||(e.DocumentHighlightKind=we={}));let Fe=class{constructor(G,ge=we.Text){this.range=G,this.kind=ge}toJSON(){return{range:this.range,kind:we[this.kind]}}};e.$YN=Fe,e.$YN=Fe=Ye([p],Fe);let ze=class{constructor(G,ge){this.uri=G,this.highlights=ge}toJSON(){return{uri:this.uri,highlights:this.highlights.map(G=>G.toJSON())}}};e.$ZN=ze,e.$ZN=ze=Ye([p],ze);var Ce;(function(Q){Q[Q.File=0]="File",Q[Q.Module=1]="Module",Q[Q.Namespace=2]="Namespace",Q[Q.Package=3]="Package",Q[Q.Class=4]="Class",Q[Q.Method=5]="Method",Q[Q.Property=6]="Property",Q[Q.Field=7]="Field",Q[Q.Constructor=8]="Constructor",Q[Q.Enum=9]="Enum",Q[Q.Interface=10]="Interface",Q[Q.Function=11]="Function",Q[Q.Variable=12]="Variable",Q[Q.Constant=13]="Constant",Q[Q.String=14]="String",Q[Q.Number=15]="Number",Q[Q.Boolean=16]="Boolean",Q[Q.Array=17]="Array",Q[Q.Object=18]="Object",Q[Q.Key=19]="Key",Q[Q.Null=20]="Null",Q[Q.EnumMember=21]="EnumMember",Q[Q.Struct=22]="Struct",Q[Q.Event=23]="Event",Q[Q.Operator=24]="Operator",Q[Q.TypeParameter=25]="TypeParameter"})(Ce||(e.SymbolKind=Ce={}));var Ie;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(Ie||(e.SymbolTag=Ie={}));let Pe=n=class{static validate(G){if(!G.name)throw new Error("name must not be falsy")}constructor(G,ge,Le,Ze,ot){this.name=G,this.kind=ge,this.containerName=ot,typeof Le=="string"&&(this.containerName=Le),Ze instanceof te?this.location=Ze:Le instanceof j&&(this.location=new te(Ze,Le)),n.validate(this)}toJSON(){return{name:this.name,kind:Ce[this.kind],location:this.location,containerName:this.containerName}}};e.$1N=Pe,e.$1N=Pe=n=Ye([p],Pe);let q=d=class{static validate(G){if(!G.name)throw new Error("name must not be falsy");if(!G.range.contains(G.selectionRange))throw new Error("selectionRange must be contained in fullRange");G.children?.forEach(d.validate)}constructor(G,ge,Le,Ze,ot){this.name=G,this.detail=ge,this.kind=Le,this.range=Ze,this.selectionRange=ot,this.children=[],d.validate(this)}};e.$2N=q,e.$2N=q=d=Ye([p],q);var H;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.Automatic=2]="Automatic"})(H||(e.CodeActionTriggerKind=H={}));let X=class{constructor(G,ge){this.title=G,this.kind=ge}};e.$3N=X,e.$3N=X=Ye([p],X);let Z=class{static{l=this}static{this.c="."}constructor(G){this.value=G}append(G){return new l(this.value?this.value+l.c+G:G)}intersects(G){return this.contains(G)||G.contains(this)}contains(G){return this.value===G.value||G.value.startsWith(this.value+l.c)}};e.$4N=Z,e.$4N=Z=l=Ye([p],Z),Z.Empty=new Z(""),Z.QuickFix=Z.Empty.append("quickfix"),Z.Refactor=Z.Empty.append("refactor"),Z.RefactorExtract=Z.Refactor.append("extract"),Z.RefactorInline=Z.Refactor.append("inline"),Z.RefactorMove=Z.Refactor.append("move"),Z.RefactorRewrite=Z.Refactor.append("rewrite"),Z.Source=Z.Empty.append("source"),Z.SourceOrganizeImports=Z.Source.append("organizeImports"),Z.SourceFixAll=Z.Source.append("fixAll"),Z.Notebook=Z.Empty.append("notebook");let de=class{constructor(G,ge){if(this.range=G,this.parent=ge,ge&&!ge.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$5N=de,e.$5N=de=Ye([p],de);class be{constructor(G,ge,Le,Ze,ot,$t){this.kind=G,this.name=ge,this.detail=Le,this.uri=Ze,this.range=ot,this.selectionRange=$t}}e.$6N=be;class Oe{constructor(G,ge){this.fromRanges=ge,this.from=G}}e.$7N=Oe;class He{constructor(G,ge){this.fromRanges=ge,this.to=G}}e.$8N=He;var Qe;(function(Q){Q[Q.Information=0]="Information",Q[Q.Warning=1]="Warning",Q[Q.Error=2]="Error"})(Qe||(e.LanguageStatusSeverity=Qe={}));let _e=class{constructor(G,ge){this.range=G,this.command=ge}get isResolved(){return!!this.command}};e.$9N=_e,e.$9N=_e=Ye([p],_e);let nt=g=class{#e;static isMarkdownString(G){return G instanceof g?!0:G&&G.appendCodeblock&&G.appendMarkdown&&G.appendText&&G.value!==void 0}constructor(G,ge=!1){this.#e=new C.$1k(G,{supportThemeIcons:ge})}get value(){return this.#e.value}set value(G){this.#e.value=G}get isTrusted(){return this.#e.isTrusted}set isTrusted(G){this.#e.isTrusted=G}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(G){this.#e.supportThemeIcons=G}get supportHtml(){return this.#e.supportHtml}set supportHtml(G){this.#e.supportHtml=G}get baseUri(){return this.#e.baseUri}set baseUri(G){this.#e.baseUri=G}appendText(G){return this.#e.appendText(G),this}appendMarkdown(G){return this.#e.appendMarkdown(G),this}appendCodeblock(G,ge){return this.#e.appendCodeblock(ge??"",G),this}};e.$0N=nt,e.$0N=nt=g=Ye([p],nt);let st=class{constructor(G,ge){this.label=G,this.documentation=ge}};e.$$N=st,e.$$N=st=Ye([p],st);let rt=class{constructor(G,ge){this.label=G,this.documentation=ge,this.parameters=[]}};e.$_N=rt,e.$_N=rt=Ye([p],rt);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$aO=at,e.$aO=at=Ye([p],at);var mt;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.TriggerCharacter=2]="TriggerCharacter",Q[Q.ContentChange=3]="ContentChange"})(mt||(e.SignatureHelpTriggerKind=mt={}));var ht;(function(Q){Q[Q.Type=1]="Type",Q[Q.Parameter=2]="Parameter"})(ht||(e.InlayHintKind=ht={}));let ct=class{constructor(G){this.value=G}};e.$bO=ct,e.$bO=ct=Ye([p],ct);let ke=class{constructor(G,ge,Le){this.position=G,this.label=ge,this.kind=Le}};e.$cO=ke,e.$cO=ke=Ye([p],ke);var Be;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.TriggerCharacter=1]="TriggerCharacter",Q[Q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var Ke;(function(Q){Q[Q.Text=0]="Text",Q[Q.Method=1]="Method",Q[Q.Function=2]="Function",Q[Q.Constructor=3]="Constructor",Q[Q.Field=4]="Field",Q[Q.Variable=5]="Variable",Q[Q.Class=6]="Class",Q[Q.Interface=7]="Interface",Q[Q.Module=8]="Module",Q[Q.Property=9]="Property",Q[Q.Unit=10]="Unit",Q[Q.Value=11]="Value",Q[Q.Enum=12]="Enum",Q[Q.Keyword=13]="Keyword",Q[Q.Snippet=14]="Snippet",Q[Q.Color=15]="Color",Q[Q.File=16]="File",Q[Q.Reference=17]="Reference",Q[Q.Folder=18]="Folder",Q[Q.EnumMember=19]="EnumMember",Q[Q.Constant=20]="Constant",Q[Q.Struct=21]="Struct",Q[Q.Event=22]="Event",Q[Q.Operator=23]="Operator",Q[Q.TypeParameter=24]="TypeParameter",Q[Q.User=25]="User",Q[Q.Issue=26]="Issue"})(Ke||(e.CompletionItemKind=Ke={}));var Ne;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(Ne||(e.CompletionItemTag=Ne={}));let je=class{constructor(G,ge){this.label=G,this.kind=ge}toJSON(){return{label:this.label,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$dO=je,e.$dO=je=Ye([p],je);let he=class{constructor(G=[],ge=!1){this.items=G,this.isIncomplete=ge}};e.$eO=he,e.$eO=he=Ye([p],he);let _=class{constructor(G,ge,Le){this.insertText=G,this.range=ge,this.command=Le}};e.$fO=_,e.$fO=_=Ye([p],_);let Re=class{constructor(G){this.commands=void 0,this.suppressSuggestions=void 0,this.items=G}};e.$gO=Re,e.$gO=Re=Ye([p],Re);var Xe;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.Word=1]="Word",Q[Q.Line=2]="Line",Q[Q.Suggest=3]="Suggest"})(Xe||(e.PartialAcceptTriggerKind=Xe={}));var tt;(function(Q){Q[Q.Active=-1]="Active",Q[Q.Beside=-2]="Beside",Q[Q.One=1]="One",Q[Q.Two=2]="Two",Q[Q.Three=3]="Three",Q[Q.Four=4]="Four",Q[Q.Five=5]="Five",Q[Q.Six=6]="Six",Q[Q.Seven=7]="Seven",Q[Q.Eight=8]="Eight",Q[Q.Nine=9]="Nine"})(tt||(e.ViewColumn=tt={}));var ut;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(ut||(e.StatusBarAlignment=ut={}));function gt(Q,G){return`${S.$on.toKey(Q)}.${G}`}var Dt;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval"})(Dt||(e.TextEditorLineNumbersStyle=Dt={}));var Nt;(function(Q){Q[Q.Manual=1]="Manual",Q[Q.AfterDelay=2]="AfterDelay",Q[Q.FocusOut=3]="FocusOut"})(Nt||(e.TextDocumentSaveReason=Nt={}));var Ut;(function(Q){Q[Q.Default=0]="Default",Q[Q.InCenter=1]="InCenter",Q[Q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Q[Q.AtTop=3]="AtTop"})(Ut||(e.TextEditorRevealType=Ut={}));var Zt;(function(Q){Q[Q.Keyboard=1]="Keyboard",Q[Q.Mouse=2]="Mouse",Q[Q.Command=3]="Command"})(Zt||(e.TextEditorSelectionChangeKind=Zt={}));var hi;(function(Q){Q[Q.Undo=1]="Undo",Q[Q.Redo=2]="Redo"})(hi||(e.TextDocumentChangeReason=hi={}));var et;(function(Q){Q[Q.OpenOpen=0]="OpenOpen",Q[Q.ClosedClosed=1]="ClosedClosed",Q[Q.OpenClosed=2]="OpenClosed",Q[Q.ClosedOpen=3]="ClosedOpen"})(et||(e.DecorationRangeBehavior=et={})),function(Q){function G(ge){switch(ge){case"keyboard":return Q.Keyboard;case"mouse":return Q.Mouse;case"api":return Q.Command}}Q.fromValue=G}(Zt||(e.TextEditorSelectionChangeKind=Zt={}));var Gt;(function(Q){Q[Q.Other=0]="Other",Q[Q.Comment=1]="Comment",Q[Q.String=2]="String",Q[Q.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(Q){function G(ge){switch(ge){case Q.Other:return"other";case Q.Comment:return"comment";case Q.String:return"string";case Q.RegEx:return"regex"}return"other"}Q.toString=G}(Gt||(e.SyntaxTokenType=Gt={}));let Kt=class{constructor(G,ge){if(ge&&!c.URI.isUri(ge))throw(0,h.$6)("target");if(!j.isRange(G)||G.isEmpty)throw(0,h.$6)("range");this.range=G,this.target=ge}};e.$iO=Kt,e.$iO=Kt=Ye([p],Kt);let pt=class{constructor(G,ge,Le,Ze){this.red=G,this.green=ge,this.blue=Le,this.alpha=Ze}};e.$jO=pt,e.$jO=pt=Ye([p],pt);let kt=class{constructor(G,ge){if(ge&&!(ge instanceof pt))throw(0,h.$6)("color");if(!j.isRange(G)||G.isEmpty)throw(0,h.$6)("range");this.range=G,this.color=ge}};e.$kO=kt,e.$kO=kt=Ye([p],kt);let xt=class{constructor(G){if(!G||typeof G!="string")throw(0,h.$6)("label");this.label=G}};e.$lO=xt,e.$lO=xt=Ye([p],xt);var _t;(function(Q){Q[Q.RGB=0]="RGB",Q[Q.HEX=1]="HEX",Q[Q.HSL=2]="HSL"})(_t||(e.ColorFormat=_t={}));var qt;(function(Q){Q[Q.Error=0]="Error",Q[Q.Warning=1]="Warning",Q[Q.Information=2]="Information"})(qt||(e.SourceControlInputBoxValidationType=qt={}));var wt;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.Shutdown=1]="Shutdown",Q[Q.Process=2]="Process",Q[Q.User=3]="User",Q[Q.Extension=4]="Extension"})(wt||(e.TerminalExitReason=wt={}));var Rt;(function(Q){Q[Q.Low=0]="Low",Q[Q.Medium=1]="Medium",Q[Q.High=2]="High"})(Rt||(e.TerminalShellExecutionCommandLineConfidence=Rt={}));class ci{constructor(G,ge,Le){if(this.startIndex=G,this.length=ge,this.tooltip=Le,typeof G!="number"||G<0)throw(0,h.$6)("startIndex");if(typeof ge!="number"||ge<1)throw(0,h.$6)("length");if(Le!==void 0&&typeof Le!="string")throw(0,h.$6)("tooltip")}}e.$mO=ci;class Qt{constructor(G){this.uri=G}}e.$nO=Qt;class xe{constructor(G){this.terminalCommand=G}}e.$oO=xe;var ei;(function(Q){Q[Q.Panel=1]="Panel",Q[Q.Editor=2]="Editor"})(ei||(e.TerminalLocation=ei={}));class li{constructor(G){if(this.options=G,typeof G!="object")throw(0,h.$6)("options")}}e.$pO=li;var di;(function(Q){Q[Q.Always=1]="Always",Q[Q.Silent=2]="Silent",Q[Q.Never=3]="Never"})(di||(e.TaskRevealKind=di={}));var It;(function(Q){Q[Q.Shared=1]="Shared",Q[Q.Dedicated=2]="Dedicated",Q[Q.New=3]="New"})(It||(e.TaskPanelKind=It={}));let Mt=class{static{E=this}static{this.Clean=new E("clean","Clean")}static{this.Build=new E("build","Build")}static{this.Rebuild=new E("rebuild","Rebuild")}static{this.Test=new E("test","Test")}static from(G){switch(G){case"clean":return E.Clean;case"build":return E.Build;case"rebuild":return E.Rebuild;case"test":return E.Test;default:return}}constructor(G,ge){if(this.label=ge,typeof G!="string"||typeof ge!="string")throw(0,h.$6)("name");this.c=G}get id(){return this.c}};e.$qO=Mt,e.$qO=Mt=E=Ye([p],Mt);function Tt(Q){let G="";for(let ge=0;ge<Q.length;ge++)G+=Q[ge].replace(/,/g,",,")+",";return G}let jt=class{constructor(G,ge,Le){if(typeof G!="string")throw(0,h.$6)("process");this.e=[],this.c=G,ge!==void 0&&(Array.isArray(ge)?(this.e=ge,this.f=Le):this.f=ge)}get process(){return this.c}set process(G){if(typeof G!="string")throw(0,h.$6)("process");this.c=G}get args(){return this.e}set args(G){Array.isArray(G)||(G=[]),this.e=G}get options(){return this.f}set options(G){this.f=G}computeId(){const G=[];if(G.push("process"),this.c!==void 0&&G.push(this.c),this.e&&this.e.length>0)for(const ge of this.e)G.push(ge);return Tt(G)}};e.$rO=jt,e.$rO=jt=Ye([p],jt);let si=class{constructor(G,ge,Le){if(this.f=[],Array.isArray(ge)){if(!G)throw(0,h.$6)("command can't be undefined or null");if(typeof G!="string"&&typeof G.value!="string")throw(0,h.$6)("command");this.e=G,this.f=ge,this.g=Le}else{if(typeof G!="string")throw(0,h.$6)("commandLine");this.c=G,this.g=ge}}get commandLine(){return this.c}set commandLine(G){if(typeof G!="string")throw(0,h.$6)("commandLine");this.c=G}get command(){return this.e?this.e:""}set command(G){if(typeof G!="string"&&typeof G.value!="string")throw(0,h.$6)("command");this.e=G}get args(){return this.f}set args(G){this.f=G||[]}get options(){return this.g}set options(G){this.g=G}computeId(){const G=[];if(G.push("shell"),this.c!==void 0&&G.push(this.c),this.e!==void 0&&G.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ge of this.f)G.push(typeof ge=="string"?ge:ge.value);return Tt(G)}};e.$sO=si,e.$sO=si=Ye([p],si);var ti;(function(Q){Q[Q.Escape=1]="Escape",Q[Q.Strong=2]="Strong",Q[Q.Weak=3]="Weak"})(ti||(e.ShellQuoting=ti={}));var ii;(function(Q){Q[Q.Global=1]="Global",Q[Q.Workspace=2]="Workspace"})(ii||(e.TaskScope=ii={}));class Vt{constructor(G){this.c=G}computeId(){return"customExecution"+(0,I.$Yg)()}set callback(G){this.c=G}get callback(){return this.c}}e.$tO=Vt;let Ht=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(G,ge,Le,Ze,ot,$t){this.k=!1,this.l=this.definition=G;let vt;typeof ge=="string"?(this.o=this.name=ge,this.w=this.source=Le,this.execution=Ze,vt=ot,this.k=!0):ge===ii.Global||ge===ii.Workspace?(this.target=ge,this.o=this.name=Le,this.w=this.source=Ze,this.execution=ot,vt=$t):(this.target=ge,this.o=this.name=Le,this.w=this.source=Ze,this.execution=ot,vt=$t),typeof vt=="string"?(this.r=[vt],this.t=!0):Array.isArray(vt)?(this.r=vt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(G){this.j=G}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof jt?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof si?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof Vt?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,I.$Yg)()}}get definition(){return this.l}set definition(G){if(G==null)throw(0,h.$6)("Kind can't be undefined or null");this.B(),this.l=G}get scope(){return this.m}set target(G){this.B(),this.m=G}get name(){return this.o}set name(G){if(typeof G!="string")throw(0,h.$6)("name");this.B(),this.o=G}get execution(){return this.q}set execution(G){G===null&&(G=void 0),this.B(),this.q=G;const ge=this.l.type;(D.g===ge||D.e===ge||D.f===ge||D.c===ge)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(G){if(Array.isArray(G))this.B(),this.r=G,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(G){G!==!0&&G!==!1&&(G=!1),this.B(),this.u=G}get source(){return this.w}set source(G){if(typeof G!="string"||G.length===0)throw(0,h.$6)("source must be a string of length > 0");this.B(),this.w=G}get group(){return this.x}set group(G){G===null&&(G=void 0),this.B(),this.x=G}get detail(){return this.A}set detail(G){G===null&&(G=void 0),this.A=G}get presentationOptions(){return this.y}set presentationOptions(G){G==null&&(G=Object.create(null)),this.B(),this.y=G}get runOptions(){return this.z}set runOptions(G){G==null&&(G=Object.create(null)),this.B(),this.z=G}};e.$uO=Ht,e.$uO=Ht=D=Ye([p],Ht);var ui;(function(Q){Q[Q.SourceControl=1]="SourceControl",Q[Q.Window=10]="Window",Q[Q.Notification=15]="Notification"})(ui||(e.ProgressLocation=ui={}));var Lt;(function(Q){function G(ge){const Le=ge;return(0,b.$gg)(Le.value)?Le.tooltip&&!(0,b.$cg)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}Q.isViewBadge=G})(Lt||(e.ViewBadge=Lt={}));let Pt=y=class{static isTreeItem(G,ge){const Le=G;if(Le.checkboxState!==void 0){const Ze=(0,b.$gg)(Le.checkboxState)?Le.checkboxState:(0,b.$eg)(Le.checkboxState)&&(0,b.$gg)(Le.checkboxState.state)?Le.checkboxState.state:void 0,ot=!(0,b.$gg)(Le.checkboxState)&&(0,b.$eg)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==Jt.Checked&&Ze!==Jt.Unchecked||ot!==void 0&&!(0,b.$cg)(ot))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(G instanceof y)return!0;if(Le.label!==void 0&&!(0,b.$cg)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,b.$cg)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,b.$cg)(Le.iconPath)&&!c.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,b.$cg)(Le.iconPath.id))){const Ze=Le.iconPath;if(!Ze||!(0,b.$cg)(Ze.light)&&!c.URI.isUri(Ze.light)&&!(0,b.$cg)(Ze.dark)&&!c.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,b.$cg)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!c.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,b.$cg)(Le.tooltip)&&!(Le.tooltip instanceof nt)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<bt.None&&Le.collapsibleState>bt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,b.$cg)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(G,ge=bt.None){this.collapsibleState=ge,c.URI.isUri(G)?this.resourceUri=G:this.label=G}};e.$vO=Pt,e.$vO=Pt=y=Ye([p],Pt);var bt;(function(Q){Q[Q.None=0]="None",Q[Q.Collapsed=1]="Collapsed",Q[Q.Expanded=2]="Expanded"})(bt||(e.TreeItemCollapsibleState=bt={}));var Jt;(function(Q){Q[Q.Unchecked=0]="Unchecked",Q[Q.Checked=1]="Checked"})(Jt||(e.TreeItemCheckboxState=Jt={}));let Et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(G){this.value=G}};e.$wO=Et,e.$wO=Et=Ye([p],Et);class oi extends Et{}e.$xO=oi;class Yt extends oi{#e;constructor(G){super(""),this.#e=G}asFile(){return this.#e}}e.$yO=Yt;class Ai{constructor(G,ge,Le,Ze){this.name=G,this.uri=ge,this._itemId=Le,this.c=Ze}data(){return this.c()}}e.$zO=Ai;let pi=class{#e=new Map;constructor(G){for(const[ge,Le]of G??[]){const Ze=this.#e.get(this.#t(ge));Ze?Ze.push(Le):this.#e.set(this.#t(ge),[Le])}}get(G){return this.#e.get(this.#t(G))?.[0]}set(G,ge){this.#e.set(this.#t(G),[ge])}forEach(G,ge){for(const[Le,Ze]of this.#e)for(const ot of Ze)G.call(ge,ot,Le,this)}*[Symbol.iterator](){for(const[G,ge]of this.#e)for(const Le of ge)yield[G,Le]}#t(G){return G.toLowerCase()}};e.$AO=pi,e.$AO=pi=Ye([p],pi);let Si=class{constructor(G,ge,Le){this.insertText=G,this.title=ge,this.kind=Le}};e.$BO=Si,e.$BO=Si=Ye([p],Si);var Bt;(function(Q){Q[Q.Automatic=0]="Automatic",Q[Q.PasteAs=1]="PasteAs"})(Bt||(e.DocumentPasteTriggerKind=Bt={}));class fi{static{this.c="."}constructor(G){this.value=G}append(...G){return new fi((this.value?[this.value,...G]:G).join(fi.c))}intersects(G){return this.contains(G)||G.contains(this)}contains(G){return this.value===G.value||G.value.startsWith(this.value+fi.c)}}e.$CO=fi,fi.Empty=new fi("");class Oi{constructor(G,ge,Le){this.title=ge,this.insertText=G,this.kind=Le}}e.$DO=Oi;let Ct=class{constructor(G,ge){this.id=G,this.color=ge}static isThemeIcon(G){return typeof G.id!="string"?(console.log("INVALID ThemeIcon, invalid id",G.id),!1):!0}};e.$EO=Ct,e.$EO=Ct=Ye([p],Ct),Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Di=class{constructor(G){this.id=G}};e.$FO=Di,e.$FO=Di=Ye([p],Di);var Ri;(function(Q){Q[Q.Global=1]="Global",Q[Q.Workspace=2]="Workspace",Q[Q.WorkspaceFolder=3]="WorkspaceFolder"})(Ri||(e.ConfigurationTarget=Ri={}));let bi=class{get base(){return this.c}set base(G){this.c=G,this.e=c.URI.file(G)}get baseUri(){return this.e}set baseUri(G){this.e=G,this.c=G.fsPath}constructor(G,ge){if(typeof G!="string"&&(!G||!c.URI.isUri(G)&&!c.URI.isUri(G.uri)))throw(0,h.$6)("base");if(typeof ge!="string")throw(0,h.$6)("pattern");typeof G=="string"?this.baseUri=c.URI.file(G):c.URI.isUri(G)?this.baseUri=G:this.baseUri=G.uri,this.pattern=ge}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$GO=bi,e.$GO=bi=Ye([p],bi);const Ti=new WeakMap;function Ni(Q,G){Ti.set(Q,G)}let Ft=class{constructor(G,ge,Le,Ze,ot){this.enabled=typeof G=="boolean"?G:!0,typeof ge=="string"&&(this.condition=ge),typeof Le=="string"&&(this.hitCondition=Le),typeof Ze=="string"&&(this.logMessage=Ze),typeof ot=="string"&&(this.mode=ot)}get id(){return this.c||(this.c=Ti.get(this)??(0,I.$Yg)()),this.c}};e.$IO=Ft,e.$IO=Ft=Ye([p],Ft);let Te=class extends Ft{constructor(G,ge,Le,Ze,ot,$t){if(super(ge,Le,Ze,ot,$t),G===null)throw(0,h.$6)("location");this.location=G}};e.$JO=Te,e.$JO=Te=Ye([p],Te);let Me=class extends Ft{constructor(G,ge,Le,Ze,ot,$t){super(ge,Le,Ze,ot,$t),this.functionName=G}};e.$KO=Me,e.$KO=Me=Ye([p],Me);let ve=class extends Ft{constructor(G,ge,Le,Ze,ot,$t,vt,Xt){if(super(Ze,ot,$t,vt,Xt),!ge)throw(0,h.$6)("dataId");this.label=G,this.dataId=ge,this.canPersist=Le}};e.$LO=ve,e.$LO=ve=Ye([p],ve);let ie=class{constructor(G,ge,Le){this.command=G,this.args=ge||[],this.options=Le}};e.$MO=ie,e.$MO=ie=Ye([p],ie);let Ae=class{constructor(G,ge){this.port=G,this.host=ge}};e.$NO=Ae,e.$NO=Ae=Ye([p],Ae);let Ge=class{constructor(G){this.path=G}};e.$OO=Ge,e.$OO=Ge=Ye([p],Ge);let it=class{constructor(G){this.implementation=G}};e.$PO=it,e.$PO=it=Ye([p],it);class Je{constructor(G,ge,Le){this.session=G,this.threadId=ge,this.frameId=Le}}e.$QO=Je;class ft{constructor(G,ge){this.session=G,this.threadId=ge}}e.$RO=ft;let At=class{constructor(G,ge){this.range=G,this.expression=ge}};e.$SO=At,e.$SO=At=Ye([p],At);var ni;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.Automatic=1]="Automatic"})(ni||(e.InlineCompletionTriggerKind=ni={}));let ai=class{constructor(G,ge){this.range=G,this.text=ge}};e.$TO=ai,e.$TO=ai=Ye([p],ai);let zt=class{constructor(G,ge,Le=!0){this.range=G,this.variableName=ge,this.caseSensitiveLookup=Le}};e.$UO=zt,e.$UO=zt=Ye([p],zt);let ri=class{constructor(G,ge){this.range=G,this.expression=ge}};e.$VO=ri,e.$VO=ri=Ye([p],ri);let Fi=class{constructor(G,ge){this.frameId=G,this.stoppedLocation=ge}};e.$WO=Fi,e.$WO=Fi=Ye([p],Fi);var _i;(function(Q){Q[Q.AIGenerated=1]="AIGenerated"})(_i||(e.NewSymbolNameTag=_i={}));var Mi;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.Automatic=1]="Automatic"})(Mi||(e.NewSymbolNameTriggerKind=Mi={}));class Ui{constructor(G,ge){this.newSymbolName=G,this.tags=ge}}e.$XO=Ui;var en;(function(Q){Q[Q.Changed=1]="Changed",Q[Q.Created=2]="Created",Q[Q.Deleted=3]="Deleted"})(en||(e.FileChangeType=en={}));let qi=k=class extends Error{static FileExists(G){return new k(G,u.FileSystemProviderErrorCode.FileExists,k.FileExists)}static FileNotFound(G){return new k(G,u.FileSystemProviderErrorCode.FileNotFound,k.FileNotFound)}static FileNotADirectory(G){return new k(G,u.FileSystemProviderErrorCode.FileNotADirectory,k.FileNotADirectory)}static FileIsADirectory(G){return new k(G,u.FileSystemProviderErrorCode.FileIsADirectory,k.FileIsADirectory)}static NoPermissions(G){return new k(G,u.FileSystemProviderErrorCode.NoPermissions,k.NoPermissions)}static Unavailable(G){return new k(G,u.FileSystemProviderErrorCode.Unavailable,k.Unavailable)}constructor(G,ge=u.FileSystemProviderErrorCode.Unknown,Le){super(c.URI.isUri(G)?G.toString(!0):G),this.code=Le?.name??"Unknown",(0,u.$ml)(this,ge),Object.setPrototypeOf(this,k.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$YO=qi,e.$YO=qi=k=Ye([p],qi);let vi=class{constructor(G,ge,Le){this.start=G,this.end=ge,this.kind=Le}};e.$ZO=vi,e.$ZO=vi=Ye([p],vi);var tn;(function(Q){Q[Q.Comment=1]="Comment",Q[Q.Imports=2]="Imports",Q[Q.Region=3]="Region"})(tn||(e.FoldingRangeKind=tn={}));var nn;(function(Q){Q[Q.Collapsed=0]="Collapsed",Q[Q.Expanded=1]="Expanded"})(nn||(e.CommentThreadCollapsibleState=nn={}));var ji;(function(Q){Q[Q.Editing=0]="Editing",Q[Q.Preview=1]="Preview"})(ji||(e.CommentMode=ji={}));var rn;(function(Q){Q[Q.Published=0]="Published",Q[Q.Draft=1]="Draft"})(rn||(e.CommentState=rn={}));var Bi;(function(Q){Q[Q.Unresolved=0]="Unresolved",Q[Q.Resolved=1]="Resolved"})(Bi||(e.CommentThreadState=Bi={}));var Vi;(function(Q){Q[Q.Current=0]="Current",Q[Q.Outdated=1]="Outdated"})(Vi||(e.CommentThreadApplicability=Vi={}));var sn;(function(Q){Q[Q.Reply=1]="Reply",Q[Q.Comment=2]="Comment"})(sn||(e.CommentThreadFocus=sn={}));class on{constructor(G,ge=[]){this.tokenTypes=G,this.tokenModifiers=ge}}e.$1O=on;function bn(Q){return typeof Q>"u"||(0,b.$dg)(Q)}class ki{constructor(G){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,G){this.m=!0;for(let ge=0,Le=G.tokenTypes.length;ge<Le;ge++)this.k.set(G.tokenTypes[ge],ge);for(let ge=0,Le=G.tokenModifiers.length;ge<Le;ge++)this.l.set(G.tokenModifiers[ge],ge)}}push(G,ge,Le,Ze,ot){if(typeof G=="number"&&typeof ge=="number"&&typeof Le=="number"&&typeof Ze=="number"&&(typeof ot=="number"||typeof ot>"u"))return typeof ot>"u"&&(ot=0),this.q(G,ge,Le,Ze,ot);if(j.isRange(G)&&typeof ge=="string"&&bn(Le))return this.o(G,ge,Le);throw(0,h.$6)()}o(G,ge,Le){if(!this.m)throw new Error("Legend must be provided in constructor");if(G.start.line!==G.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ge))throw new Error("`tokenType` is not in the provided legend");const Ze=G.start.line,ot=G.start.character,$t=G.end.character-G.start.character,vt=this.k.get(ge);let Xt=0;if(Le)for(const $i of Le){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const wi=this.l.get($i);Xt|=1<<wi>>>0}this.q(Ze,ot,$t,vt,Xt)}q(G,ge,Le,Ze,ot){if(this.f&&(G<this.c||G===this.c&&ge<this.e)){this.f=!1;const Xt=this.g.length/5|0;let $i=0,wi=0;for(let yi=0;yi<Xt;yi++){let Ci=this.g[5*yi],Zi=this.g[5*yi+1];Ci===0?(Ci=$i,Zi+=wi):Ci+=$i,this.g[5*yi]=Ci,this.g[5*yi+1]=Zi,$i=Ci,wi=Zi}}let $t=G,vt=ge;this.f&&this.j>0&&($t-=this.c,$t===0&&(vt-=this.e)),this.g[this.j++]=$t,this.g[this.j++]=vt,this.g[this.j++]=Le,this.g[this.j++]=Ze,this.g[this.j++]=ot,this.c=G,this.e=ge}static r(G){const ge=[],Le=G.length/5|0;for(let vt=0;vt<Le;vt++)ge[vt]=vt;ge.sort((vt,Xt)=>{const $i=G[5*vt],wi=G[5*Xt];if($i===wi){const yi=G[5*vt+1],Ci=G[5*Xt+1];return yi-Ci}return $i-wi});const Ze=new Uint32Array(G.length);let ot=0,$t=0;for(let vt=0;vt<Le;vt++){const Xt=5*ge[vt],$i=G[Xt+0],wi=G[Xt+1],yi=G[Xt+2],Ci=G[Xt+3],Zi=G[Xt+4],Vn=$i-ot,Lr=Vn===0?wi-$t:wi,xi=5*vt;Ze[xi+0]=Vn,Ze[xi+1]=Lr,Ze[xi+2]=yi,Ze[xi+3]=Ci,Ze[xi+4]=Zi,ot=$i,$t=wi}return Ze}build(G){return this.f?new Hi(new Uint32Array(this.g),G):new Hi(ki.r(this.g),G)}}e.$2O=ki;class Hi{constructor(G,ge){this.resultId=ge,this.data=G}}e.$3O=Hi;class wn{constructor(G,ge,Le){this.start=G,this.deleteCount=ge,this.data=Le}}e.$4O=wn;class vn{constructor(G,ge){this.resultId=ge,this.edits=G}}e.$5O=vn;var zi;(function(Q){Q[Q.Separate=0]="Separate",Q[Q.MergeWithParent=1]="MergeWithParent"})(zi||(e.DebugConsoleMode=zi={}));class an{constructor(G){this.name=G}}e.$6O=an;var qe;(function(Q){Q[Q.Title=1]="Title",Q[Q.Inline=2]="Inline"})(qe||(e.QuickInputButtonLocation=qe={}));let gi=class{static{this.Back={iconPath:new Ct("arrow-left")}}constructor(){}};e.$7O=gi,e.$7O=gi=Ye([p],gi);var Gi;(function(Q){Q[Q.Separator=-1]="Separator",Q[Q.Default=0]="Default"})(Gi||(e.QuickPickItemKind=Gi={}));var lt;(function(Q){Q[Q.Info=1]="Info",Q[Q.Warning=2]="Warning",Q[Q.Error=3]="Error"})(lt||(e.InputBoxValidationSeverity=lt={}));var yt;(function(Q){Q[Q.UI=1]="UI",Q[Q.Workspace=2]="Workspace"})(yt||(e.ExtensionKind=yt={}));class En{static validate(G){if(typeof G.badge=="string"){let ge=(0,T.$Nf)(G.badge,0);if(ge<G.badge.length&&(ge+=(0,T.$Nf)(G.badge,ge)),G.badge.length>ge)throw new Error("The 'badge'-property must be undefined or a short character")}else if(G.badge&&!Ct.isThemeIcon(G.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!G.color&&!G.badge&&!G.tooltip)throw new Error("The decoration is empty");return!0}constructor(G,ge,Le){this.badge=G,this.tooltip=ge,this.color=Le}}e.$8O=En;let Ki=class{constructor(G){this.kind=G}};e.$9O=Ki,e.$9O=Ki=Ye([p],Ki);var Qi;(function(Q){Q[Q.Light=1]="Light",Q[Q.Dark=2]="Dark",Q[Q.HighContrast=3]="HighContrast",Q[Q.HighContrastLight=4]="HighContrastLight"})(Qi||(e.ColorThemeKind=Qi={}));class Ei{static isNotebookRange(G){return G instanceof Ei?!0:G?typeof G.start=="number"&&typeof G.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(G,ge){if(G<0)throw(0,h.$6)("start must be positive");if(ge<0)throw(0,h.$6)("end must be positive");G<=ge?(this.c=G,this.e=ge):(this.c=ge,this.e=G)}with(G){let ge=this.c,Le=this.e;return G.start!==void 0&&(ge=G.start),G.end!==void 0&&(Le=G.end),ge===this.c&&Le===this.e?this:new Ei(ge,Le)}}e.$0O=Ei;class Ii{static validate(G){if(typeof G.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof G.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof G.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(G){return Array.isArray(G)&&G.every(ge=>Ii.isNotebookCellData(ge))}static isNotebookCellData(G){return!0}constructor(G,ge,Le,Ze,ot,$t,vt){this.kind=G,this.value=ge,this.languageId=Le,this.mime=Ze,this.outputs=ot??[],this.metadata=$t,this.executionSummary=vt,Ii.validate(this)}}e.$$O=Ii;class yn{constructor(G){this.cells=G}}e.$_O=yn;class mi{static isNotebookCellOutputItem(G){return G instanceof mi?!0:G?typeof G.mime=="string"&&G.data instanceof Uint8Array:!1}static error(G){const ge={name:G.name,message:G.message,stack:G.stack};return mi.json(ge,"application/vnd.code.notebook.error")}static stdout(G){return mi.text(G,"application/vnd.code.notebook.stdout")}static stderr(G){return mi.text(G,"application/vnd.code.notebook.stderr")}static bytes(G,ge="application/octet-stream"){return new mi(G,ge)}static#e=new TextEncoder;static text(G,ge=L.$8s.text){const Le=mi.#e.encode(String(G));return new mi(Le,ge)}static json(G,ge="text/x-json"){const Le=JSON.stringify(G,void 0,"	");return mi.text(Le,ge)}constructor(G,ge){this.data=G,this.mime=ge;const Le=(0,L.$_s)(ge,!0);if(!Le)throw new Error(`INVALID mime type: ${ge}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$aP=mi;class Wi{static isNotebookCellOutput(G){return G instanceof Wi?!0:!G||typeof G!="object"?!1:typeof G.id=="string"&&Array.isArray(G.items)}static ensureUniqueMimeTypes(G,ge=!1){const Le=new Set,Ze=new Set;for(let ot=0;ot<G.length;ot++){const $t=G[ot],vt=(0,L.$_s)($t.mime);if(!Le.has(vt)||(0,w.$IL)(vt)){Le.add(vt);continue}Ze.add(ot),ge&&console.warn(`DUPLICATED mime type '${$t.mime}' will be dropped`)}return Ze.size===0?G:G.filter((ot,$t)=>!Ze.has($t))}constructor(G,ge,Le){this.items=Wi.ensureUniqueMimeTypes(G,!0),typeof ge=="string"?(this.id=ge,this.metadata=Le):(this.id=(0,I.$Yg)(),this.metadata=ge??Le)}}e.$bP=Wi;var Ji;(function(Q){Q[Q.Markup=1]="Markup",Q[Q.Code=2]="Code"})(Ji||(e.NotebookCellKind=Ji={}));var cn;(function(Q){Q[Q.Idle=1]="Idle",Q[Q.Pending=2]="Pending",Q[Q.Executing=3]="Executing"})(cn||(e.NotebookCellExecutionState=cn={}));var ln;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(ln||(e.NotebookCellStatusBarAlignment=ln={}));var un;(function(Q){Q[Q.Default=0]="Default",Q[Q.InCenter=1]="InCenter",Q[Q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Q[Q.AtTop=3]="AtTop"})(un||(e.NotebookEditorRevealType=un={}));class Sn{constructor(G,ge){this.text=G,this.alignment=ge}}e.$cP=Sn;var hn;(function(Q){Q[Q.Default=1]="Default",Q[Q.Preferred=2]="Preferred"})(hn||(e.NotebookControllerAffinity=hn={}));var dn;(function(Q){Q[Q.Default=1]="Default",Q[Q.Preferred=2]="Preferred",Q[Q.Hidden=-1]="Hidden"})(dn||(e.NotebookControllerAffinity2=dn={}));class Dn{constructor(G,ge=[]){this.uri=G,this.provides=(0,r.$1b)(ge)}}e.$dP=Dn;class kn{constructor(G){this.label=G}}e.$eP=kn;var fn;(function(Q){Q[Q.Named=1]="Named",Q[Q.Indexed=2]="Indexed"})(fn||(e.NotebookVariablesRequestKind=fn={}));let Yi=class{constructor(G,ge){this.label=G,this.timestamp=ge}};e.$fP=Yi,e.$fP=Yi=Ye([p],Yi);var gn;(function(Q){Q[Q.Production=1]="Production",Q[Q.Development=2]="Development",Q[Q.Test=3]="Test"})(gn||(e.ExtensionMode=gn={}));var fe;(function(Q){Q[Q.Node=1]="Node",Q[Q.Webworker=2]="Webworker"})(fe||(e.ExtensionRuntime=fe={}));var Ee;(function(Q){Q[Q.Other=0]="Other",Q[Q.Comment=1]="Comment",Q[Q.String=2]="String",Q[Q.RegEx=3]="RegEx"})(Ee||(e.StandardTokenType=Ee={}));class We{constructor(G,ge){this.ranges=G,this.wordPattern=ge}}e.$gP=We;class dt{constructor(G){this.c=G}get autoForwardAction(){return this.c}}e.$hP=dt;var St;(function(Q){Q[Q.Queued=1]="Queued",Q[Q.Running=2]="Running",Q[Q.Passed=3]="Passed",Q[Q.Failed=4]="Failed",Q[Q.Skipped=5]="Skipped",Q[Q.Errored=6]="Errored"})(St||(e.TestResultState=St={}));var Ot;(function(Q){Q[Q.Run=1]="Run",Q[Q.Debug=2]="Debug",Q[Q.Coverage=3]="Coverage"})(Ot||(e.TestRunProfileKind=Ot={}));let Pi=class{constructor(G=void 0,ge=void 0,Le=void 0,Ze=!1,ot=!0){this.include=G,this.exclude=ge,this.profile=Le,this.continuous=Ze,this.preserveFocus=ot}};e.$iP=Pi,e.$iP=Pi=Ye([p],Pi);let Xi=A=class{static diff(G,ge,Le){const Ze=new A(G);return Ze.expectedOutput=ge,Ze.actualOutput=Le,Ze}constructor(G){this.message=G}};e.$jP=Xi,e.$jP=Xi=A=Ye([p],Xi);let In=class{constructor(G){this.id=G}};e.$kP=In,e.$kP=In=Ye([p],In);class Kn{constructor(G,ge,Le){this.label=G,this.file=ge,this.position=Le}}e.$lP=Kn;class mn{constructor(G,ge){this.covered=G,this.total=ge,Cn(this)}}e.$mP=mn;function Cn(Q){if(Q){if(Q.covered>Q.total)throw new Error(`The total number of covered items (${Q.covered}) cannot be greater than the total (${Q.total})`);if(Q.total<0)throw new Error(`The number of covered items (${Q.total}) cannot be negative`)}}class Pn{static fromDetails(G,ge){const Le=new mn(0,0),Ze=new mn(0,0),ot=new mn(0,0);for(const vt of ge)if("branches"in vt){Le.total+=1,Le.covered+=vt.executed?1:0;for(const Xt of vt.branches)Ze.total+=1,Ze.covered+=Xt.executed?1:0}else ot.total+=1,ot.covered+=vt.executed?1:0;const $t=new Pn(G,Le,Ze.total>0?Ze:void 0,ot.total>0?ot:void 0);return $t.detailedCoverage=ge,$t}constructor(G,ge,Le,Ze,ot=[]){this.uri=G,this.statementCoverage=ge,this.branchCoverage=Le,this.declarationCoverage=Ze,this.fromTests=ot}}e.$oP=Pn;class Qn{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,ge,Le=[]){this.executed=G,this.location=ge,this.branches=Le}}e.$pP=Qn;class Jn{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,ge,Le){this.executed=G,this.location=ge,this.label=Le}}e.$qP=Jn;class Yn{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,ge,Le){this.name=G,this.executed=ge,this.location=Le}}e.$rP=Yn;var An;(function(Q){Q[Q.None=0]="None",Q[Q.Option=1]="Option",Q[Q.Default=2]="Default",Q[Q.Preferred=3]="Preferred"})(An||(e.ExternalUriOpenerPriority=An={}));var Rn;(function(Q){Q[Q.Untrusted=0]="Untrusted",Q[Q.Trusted=1]="Trusted",Q[Q.Unspecified=2]="Unspecified"})(Rn||(e.WorkspaceTrustState=Rn={}));var Tn;(function(Q){Q[Q.Notify=1]="Notify",Q[Q.OpenBrowser=2]="OpenBrowser",Q[Q.OpenPreview=3]="OpenPreview",Q[Q.Silent=4]="Silent",Q[Q.Ignore=5]="Ignore",Q[Q.OpenBrowserOnce=6]="OpenBrowserOnce"})(Tn||(e.PortAutoForwardAction=Tn={}));class Xn{constructor(G,ge,Le,Ze,ot,$t){this.kind=G,this.name=ge,this.detail=Le,this.uri=Ze,this.range=ot,this.selectionRange=$t}}e.$sP=Xn;class Zn{constructor(G){this.uri=G}}e.$tP=Zn;class xn{constructor(G,ge){this.original=G,this.modified=ge}}e.$uP=xn;class _n{constructor(G,ge,Le,Ze){this.base=G,this.input1=ge,this.input2=Le,this.result=Ze}}e.$vP=_n;class er{constructor(G,ge){this.uri=G,this.viewType=ge}}e.$wP=er;class tr{constructor(G){this.viewType=G}}e.$xP=tr;class ir{constructor(G,ge){this.uri=G,this.notebookType=ge}}e.$yP=ir;class nr{constructor(G,ge,Le){this.original=G,this.modified=ge,this.notebookType=Le}}e.$zP=nr;class rr{constructor(){}}e.$AP=rr;class sr{constructor(G,ge){this.uri=G,this.inputBoxUri=ge}}e.$BP=sr;class or{constructor(){}}e.$CP=or;class ar{constructor(G){this.textDiffs=G}}e.$DP=ar;var Ln;(function(Q){Q[Q.Down=0]="Down",Q[Q.Up=1]="Up"})(Ln||(e.InteractiveSessionVoteDirection=Ln={}));var On;(function(Q){Q[Q.Action=1]="Action",Q[Q.Toolbar=2]="Toolbar"})(On||(e.ChatCopyKind=On={}));var Nn;(function(Q){Q[Q.Short=1]="Short",Q[Q.Medium=2]="Medium",Q[Q.Full=3]="Full"})(Nn||(e.ChatVariableLevel=Nn={}));class cr{constructor(G,ge,Le){this.id=G,this.label=ge,this.values=Le}}e.$EP=cr;var Fn;(function(Q){Q[Q.Unhelpful=0]="Unhelpful",Q[Q.Helpful=1]="Helpful",Q[Q.Undone=2]="Undone",Q[Q.Accepted=3]="Accepted",Q[Q.Bug=4]="Bug"})(Fn||(e.InteractiveEditorResponseFeedbackKind=Fn={}));var Mn;(function(Q){Q[Q.Unhelpful=0]="Unhelpful",Q[Q.Helpful=1]="Helpful"})(Mn||(e.ChatResultFeedbackKind=Mn={}));class lr{constructor(G){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new nt(G):G}}e.$FP=lr;class ur{constructor(G,ge){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new nt(G):G,this.vulnerabilities=ge}}e.$GP=ur;class hr{constructor(G,ge){this.participant=G,this.command=ge}}e.$HP=hr;class dr{constructor(G,ge,Le,Ze){this.title=G,this.message=ge,this.data=Le,this.buttons=Ze}}e.$IP=dr;class fr{constructor(G,ge){this.value=G,this.baseUri=ge}}e.$JP=fr;class gr{constructor(G,ge){this.value=G,this.title=ge}}e.$KP=gr;class mr{constructor(G){this.value=G}}e.$LP=mr;class $r{constructor(G,ge){this.value=G,this.task=ge}}e.$MP=$r;class pr{constructor(G){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new nt(G):G}}e.$NP=pr;class br{constructor(G){this.value=G}}e.$OP=br;class wr{constructor(G,ge){this.value=G,this.iconPath=ge}}e.$PP=wr;class vr{constructor(G,ge){this.uri=G,this.edits=Array.isArray(ge)?ge:[ge]}}e.$QP=vr;class Er{constructor(G,ge,Le,Ze){this.prompt=G,this.command=ge,this.references=Le,this.participant=Ze}}e.$RP=Er;class yr{constructor(G,ge,Le,Ze){this.response=G,this.result=ge,this.participant=Le,this.command=Ze}}e.$SP=yr;var jn;(function(Q){Q[Q.Panel=1]="Panel",Q[Q.Terminal=2]="Terminal",Q[Q.Notebook=3]="Notebook",Q[Q.Editor=4]="Editor"})(jn||(e.ChatLocation=jn={}));class Sr{constructor(G,ge,Le){this.document=G,this.selection=ge,this.wholeRange=Le}}e.$TP=Sr;class Dr{constructor(G){this.cell=G}}e.$UP=Dr;var $n;(function(Q){Q[Q.User=1]="User",Q[Q.Assistant=2]="Assistant",Q[Q.System=3]="System"})($n||(e.LanguageModelChatMessageRole=$n={}));class kr{constructor(G,ge,Le){this.name=G,this.content=ge,this.isError=Le??!1}}e.$VP=kr;class pn{static User(G,ge){const Le=new pn($n.User,typeof G=="string"?G:"",ge);return Le.content2=G,Le}static Assistant(G,ge){return new pn($n.Assistant,G,ge)}constructor(G,ge,Le){this.role=G,this.content=ge,this.content2=ge,this.name=Le}}e.$WP=pn;class Ir{constructor(G,ge){this.name=G,this.parameters=ge}}e.$XP=Ir;class Pr{constructor(G){this.value=G}}e.$YP=Pr;class Cr{constructor(G){this.content=G}}e.$ZP=Cr;class Ar{constructor(G,ge){this.content=G,this.name=ge}}e.$1P=Ar;class Rr{constructor(G,ge){this.content=G,this.name=ge}}e.$2P=Rr;class Li extends Error{static NotFound(G){return new Li(G,Li.NotFound.name)}static NoPermissions(G){return new Li(G,Li.NoPermissions.name)}static Blocked(G){return new Li(G,Li.Blocked.name)}constructor(G,ge,Le){super(G,{cause:Le}),this.name="LanguageModelError",this.code=ge??""}}e.$3P=Li;var Bn;(function(Q){Q[Q.SymbolInformation=1]="SymbolInformation",Q[Q.CommandInformation=2]="CommandInformation",Q[Q.SearchInformation=3]="SearchInformation",Q[Q.SettingInformation=4]="SettingInformation"})(Bn||(e.RelatedInformationType=Bn={}));var zn;(function(Q){Q[Q.Started=1]="Started",Q[Q.Recognizing=2]="Recognizing",Q[Q.Recognized=3]="Recognized",Q[Q.Stopped=4]="Stopped",Q[Q.Error=5]="Error"})(zn||(e.SpeechToTextStatus=zn={}));var Wn;(function(Q){Q[Q.Started=1]="Started",Q[Q.Stopped=2]="Stopped",Q[Q.Error=3]="Error"})(Wn||(e.TextToSpeechStatus=Wn={}));var Un;(function(Q){Q[Q.Recognized=1]="Recognized",Q[Q.Stopped=2]="Stopped"})(Un||(e.KeywordRecognitionStatus=Un={}));class Tr{constructor(G,ge){this.text=G,this.range=ge}}e.$4P=Tr;var qn;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.Automatic=1]="Automatic"})(qn||(e.InlineEditTriggerKind=qn={}))}),define(Se[290],De([1,0,6,9]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Woc=void 0;class C{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(r.$DN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,T,b){if(this.a.size===0)throw new Error("No related information providers registered");const c=this.a.get(L);if(!c)throw new Error("related information provider not found");return await c.provideRelatedInformation(T,b)??[]}getRelatedInformation(L,T,b){return this.c.$getAiRelatedInformation(T,b)}registerRelatedInformationProvider(L,T,b){const c=this.b;return this.b++,this.a.set(c,b),this.c.$registerAiRelatedInformationProvider(c,T),new h.$FN(()=>{this.c.$unregisterAiRelatedInformationProvider(c),this.a.delete(c)})}}e.$Woc=C}),define(Se[127],De([1,0,4,6,9,23,156,5,19]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9oc=e.$8oc=void 0,e.$8oc=(0,T.$Ci)("IExtHostAuthentication");let c=class{constructor(u){this.b=new Map,this.c=new r.$je,this.onDidChangeSessions=this.c.event,this.d=new I,this.a=u.getProxy(h.$DN.MainThreadAuthentication)}async getSession(u,P,w,a={}){const m=R.$on.toKey(u.identifier),$=[...w].sort().join(" ");return await this.d.getOrCreate(`${m} ${P} ${$}`,async()=>{await this.a.$ensureProvider(P);const f=u.displayName||u.name;return this.a.$getSession(P,w,m,f,a)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,P){const w=this.b.get(u);return w?w.provider.removeSession(P):this.a.$removeSession(u,P)}registerAuthenticationProvider(u,P,w,a){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:P,provider:w,options:a??{supportsMultipleAccounts:!1}});const m=w.onDidChangeSessions($=>this.a.$sendDidChangeSessions(u,$));return this.a.$registerAuthenticationProvider(u,P,a?.supportsMultipleAccounts??!1),new C.$FN(()=>{m.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,P,w){const a=this.b.get(u);if(a)return await a.provider.createSession(P,w);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,P){const w=this.b.get(u);if(w)return await w.provider.removeSession(P);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,P,w){const a=this.b.get(u);if(a)return await a.provider.getSessions(P,w);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,P){return u.startsWith(L.$FM)||this.c.fire({provider:{id:u,label:P}}),Promise.resolve()}};e.$9oc=c,e.$9oc=c=Ye([Ve(0,b.$cQ)],c);class I{constructor(){this.a=new Map}getOrCreate(u,P){const w=this.a.get(u);if(w)return w;const a=P().finally(()=>this.a.delete(u));return this.a.set(u,a),a}}}),define(Se[163],De([1,0,2,6,9,5,19,11,18,12,16,25]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$bqc=e.$aqc=void 0;let P=class{static{u=this}static{this.c=0}static{this.d=250}constructor(a,m){this.h=m,this.f=new Map,this.g=a.getProxy(h.$DN.MainThreadDecorations)}registerFileDecorationProvider(a,m){const $=u.c++;this.f.set($,{provider:a,extensionDescription:m}),this.g.$registerDecorationProvider($,m.identifier.value);const f=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange($,null);return}const s=(0,b.$1b)(i);if(s.length<=u.d){this.g.$onDidChange($,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,s.length);const t=s.map(d=>({uri:d,rank:(0,c.$gf)(d.path,"/")})),o=(0,b.$yb)(t,(d,l)=>d.rank-l.rank||(0,c.$wf)(d.uri.path,l.uri.path)),n=[];e:for(const d of o){let l;for(const g of d){const E=(0,I.$lc)(g.uri.path);if(l!==E&&(l=E,n.push(g.uri)>=u.d))break e}}this.g.$onDidChange($,n)});return new C.$FN(()=>{f?.dispose(),this.g.$unregisterDecorationProvider($),this.f.delete($)})}async $provideDecorations(a,m,$){if(!this.f.has(a))return Object.create(null);const f=Object.create(null),{provider:i,extensionDescription:s}=this.f.get(a);return await Promise.all(m.map(async t=>{try{const{uri:o,id:n}=t,d=await Promise.resolve(i.provideFileDecoration(r.URI.revive(o),$));if(!d)return;try{C.$8O.validate(d),d.badge&&typeof d.badge!="string"&&(0,S.$dH)(s,"codiconDecoration"),f[n]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${l}`)}}catch(o){this.h.error(o)}})),f}};e.$aqc=P,e.$aqc=P=u=Ye([Ve(0,L.$cQ),Ve(1,T.$0j)],P),e.$bqc=(0,R.$Ci)("IExtHostDecorations")}),define(Se[291],De([1,0,13,2,9,6,14,20,12]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dqc=void 0;class c{static{this.a=0}constructor(S,u,P){this.d=u,this.e=P,this.b=new Map,this.c=S.getProxy(R.$DN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,u){if(Object.keys(L.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const P=c.a++;this.b.set(P,u),this.c.$registerTextContentProvider(P,S);let w;if(typeof u.onDidChange=="function"){let a;w=u.onDidChange(async m=>{if(m.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;a&&await a;const $=this.$provideTextDocumentContent(P,m).then(async f=>{if(!f&&typeof f!="string")return;const i=this.d.getDocument(m);if(!i)return;const s=(0,b.$qf)(f);if(!i.equalLines(s))return this.c.$onVirtualDocumentChange(m,f)}).catch(r.$Y).finally(()=>{a===$&&(a=void 0)});a=$})}return new C.$FN(()=>{this.b.delete(P)&&this.c.$unregisterTextContentProvider(P),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(S,u){const P=this.b.get(S);return P?Promise.resolve(P.provideTextDocumentContent(h.URI.revive(u),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$dqc=c}),define(Se[164],De([1,0,65,14,12,206,140,9,18]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gQ=e.$fQ=void 0,e.$eQ=I;const c=new Map;function I(w,a){a?c.set(w,a):c.delete(w)}function S(w){return c.get(w)}class u extends R.$mw{constructor(a,m,$,f,i,s,t){super(m,$,f,i),this.c=a,this.m=s,this.q=t,this.b=!1}dispose(){(0,r.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,b.$tb)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===h.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(m){return m?a.s(m):a.getText()},get eol(){return a.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(m){return a.t(m)},offsetAt(m){return a.u(m)},positionAt(m){return a.v(m)},validateRange(m){return a.w(m)},validatePosition(m){return a.x(m)},getWordRangeAtPosition(m,$){return a.y(m,$)},[Symbol.for("debug.description")](){return`TextDocument(${a.d.toString()})`}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,r.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,r.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const m=this.w(a);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const $=this.g,f=m.start.line,i=m.end.line,s=[];s.push(this.f[f].substring(m.start.character));for(let t=f+1;t<i;t++)s.push(this.f[t]);return s.push(this.f[i].substring(0,m.end.character)),s.join($)}t(a){let m;if(a instanceof T.$GN?m=a.line:typeof a=="number"&&(m=a),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new P(m,this.f[m],m===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const m=this.j.getIndexOf(a),$=this.f[m.index].length;return new T.$GN(m.index,Math.min(m.remainder,$))}w(a){if(!(a instanceof T.$HN))throw new Error("Invalid argument");const m=this.x(a.start),$=this.x(a.end);return m===a.start&&$===a.end?a:new T.$HN(m.line,m.character,$.line,$.character)}x(a){if(!(a instanceof T.$GN))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:m,character:$}=a,f=!1;if(m<0)m=0,$=0,f=!0;else if(m>=this.f.length)m=this.f.length-1,$=this.f[m].length,f=!0;else{const i=this.f[m].length;$<0?($=0,f=!0):$>i&&($=i,f=!0)}return f?new T.$GN(m,$):a}y(a,m){const $=this.x(a);if(!m)m=S(this.m);else if((0,C.$pf)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const f=(0,L.$nt)($.character+1,(0,L.$lt)(m),this.f[$.line],0);if(f)return new T.$HN($.line,f.startColumn-1,$.line,f.endColumn-1)}}e.$fQ=u;class P{constructor(a,m,$){this.a=a,this.b=m,this.c=$}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$HN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$HN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$gQ=P}),define(Se[292],De([1,0,6,9]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gqc=void 0;class C{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(r.$DN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,T,b){if(this.a.size===0)throw new Error("No embedding vector providers registered");const c=this.a.get(L);if(!c)throw new Error("Embedding vector provider not found");const I=await c.provideEmbeddingVector(T,b);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(L,T,b){const c=this.b;return this.b++,this.a.set(c,b),this.c.$registerAiEmbeddingVectorProvider(T,c),new h.$FN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(c),this.a.delete(c)})}}e.$gqc=C}),define(Se[75],De([1,0,6,27,9,21,5,19,62,3,7,22,14]),function($e,e,r,h,C,R,L,T,b,c,I,S,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$mpc=e.$lpc=void 0,h=Ue(h);let w=P=class{constructor(m,$){this.b=new Map,this.c=new I.$Lh,this.a=m.getProxy(r.$DN.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(i){try{let s;const t=f.b.get(i.scheme);return t?(await f.a.$ensureActivation(i.scheme),s=await t.impl.stat(i)):s=await f.a.$stat(i),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===h.FilePermission.Readonly?1:void 0}}catch(s){P.e(s)}},async readDirectory(i){try{const s=f.b.get(i.scheme);return s?(await f.a.$ensureActivation(i.scheme),(await s.impl.readDirectory(i)).slice()):await f.a.$readdir(i)}catch(s){return P.e(s)}},async createDirectory(i){try{const s=f.b.get(i.scheme);return s&&!s.isReadonly?(await f.a.$ensureActivation(i.scheme),await f.d(s.impl,s.extUri,i)):await f.a.$mkdir(i)}catch(s){return P.e(s)}},async readFile(i){try{const s=f.b.get(i.scheme);return s?(await f.a.$ensureActivation(i.scheme),(await s.impl.readFile(i)).slice()):(await f.a.$readFile(i)).buffer}catch(s){return P.e(s)}},async writeFile(i,s){try{const t=f.b.get(i.scheme);return t&&!t.isReadonly?(await f.a.$ensureActivation(i.scheme),await f.d(t.impl,t.extUri,t.extUri.dirname(i)),await f.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,s,{create:!0,overwrite:!0})))):await f.a.$writeFile(i,R.$Le.wrap(s))}catch(t){return P.e(t)}},async delete(i,s){try{const t=f.b.get(i.scheme);return t&&!t.isReadonly&&!s?.useTrash?(await f.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...s})):await f.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(t){return P.e(t)}},async rename(i,s,t){try{return await f.a.$rename(i,s,{overwrite:!1,...t})}catch(o){return P.e(o)}},async copy(i,s,t){try{return await f.a.$copy(i,s,{overwrite:!1,...t})}catch(o){return P.e(o)}},isWritableFileSystem(i){const s=$.getCapabilities(i);if(typeof s=="number")return!(s&h.FileSystemProviderCapabilities.Readonly)}})}async d(m,$,f){const i=[];for(;!$.isEqual(f,$.dirname(f));)try{if(!((await m.stat(f)).type&h.FileType.Directory))throw C.$YO.FileExists(`Unable to create folder '${f.scheme===u.Schemas.file?f.fsPath:f.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(h.$nl(s)!==h.FileSystemProviderErrorCode.FileNotFound)throw s;i.push($.basename(f)),f=$.dirname(f)}for(let s=i.length-1;s>=0;s--){f=$.joinPath(f,i[s]);try{await m.createDirectory(f)}catch(t){if(h.$nl(t)!==h.FileSystemProviderErrorCode.FileExists)throw t}}}static e(m){if(m instanceof C.$YO)throw m;if(m instanceof h.$jl)switch(m.code){case h.FileSystemProviderErrorCode.FileExists:throw C.$YO.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw C.$YO.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw C.$YO.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw C.$YO.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw C.$YO.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw C.$YO.Unavailable(m.message);default:throw new C.$YO(m.message,m.name)}if(!(m instanceof Error))throw new C.$YO(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw C.$YO.Unavailable(m.message);switch(m.name){case h.FileSystemProviderErrorCode.FileExists:throw C.$YO.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw C.$YO.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw C.$YO.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw C.$YO.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw C.$YO.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw C.$YO.Unavailable(m.message);default:throw new C.$YO(m.message,m.name)}}addFileSystemProvider(m,$,f){return this.b.set(m,{impl:$,extUri:f?.isCaseSensitive?S.$6g:S.$8g,isReadonly:!!f?.isReadonly}),(0,c.$Rc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??S.$6g}};e.$lpc=w,e.$lpc=w=P=Ye([Ve(0,T.$cQ),Ve(1,b.$2oc)],w),e.$mpc=(0,L.$Ci)("IExtHostConsumerFileSystem")}),define(Se[97],De([1,0,5,29,11,75,2]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$opc=e.$npc=void 0,e.$npc=(0,r.$Ci)("IExtensionStoragePaths");let T=class{constructor(c,I,S){this.d=I,this.f=S,this.a=c.workspace??void 0,this.b=c.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(c){return L.URI.joinPath(this.b.workspaceStorageHome,c)}async h(){if(!this.a)return Promise.resolve(void 0);const c=this.a.id,I=await this.g(c);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(L.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(c){if(this.c)return L.URI.joinPath(this.c,c.identifier.value)}globalValue(c){return L.URI.joinPath(this.b.globalStorageHome,c.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$opc=T,e.$opc=T=Ye([Ve(0,h.$sQ),Ve(1,C.$0j),Ve(2,R.$mpc)],T)}),define(Se[293],De([1,0,9,19,4]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xqc=void 0;let R=class{constructor(T){this.a=new r.$9O(r.ColorThemeKind.Dark),this.b=new C.$je}get activeColorTheme(){return this.a}$onColorThemeChange(T){let b;switch(T){case"light":b=r.ColorThemeKind.Light;break;case"hcDark":b=r.ColorThemeKind.HighContrast;break;case"hcLight":b=r.ColorThemeKind.HighContrastLight;break;default:b=r.ColorThemeKind.Dark}this.a=new r.$9O(b),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Xqc=R,e.$Xqc=R=Ye([Ve(0,h.$cQ)],R)}),define(Se[76],De([1,0,20,4,3,8,5,11,92,6,29,19,9]),function($e,e,r,h,C,R,L,T,b,c,I,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Fb=e.$0Fb=e.TunnelDtoConverter=void 0,R=Ue(R),u=Ue(u);class P extends b.$Lw{}var w;(function(m){function $(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?b.TunnelPrivacyId.Public:b.TunnelPrivacyId.Private),protocol:i.protocol}}m.fromApiTunnel=$;function f(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==b.TunnelPrivacyId.ConstantPrivate&&i.privacy!==b.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}m.fromServiceTunnel=f})(w||(e.TunnelDtoConverter=w={})),e.$0Fb=(0,L.$Ci)("IExtHostTunnelService");let a=class extends C.$Tc{constructor($,f,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new h.$je,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=$.getProxy(c.$DN.MainThreadTunnelService)}async openTunnel($,f){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${$.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const i=await this.a.$openTunnel(f,$.displayName);if(i){const s=new P(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider($,f){$.portRange===void 0&&$.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:$,provider:f}),this.a.$registerPortsAttributesProvider($,i),new u.$FN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes($,f,i,s,t){const o=[];for(const d of $){const l=this.r.get(d);if(!l)return[];o.push(...await Promise.all(f.map(async g=>{let E;try{E=await l.provider.providePortAttributes({port:g,pid:i,commandLine:s},t)}catch{E=await l.provider.providePortAttributes(g,i,s,t)}return{providedAttributes:E,port:g}})))}const n=o.filter(d=>!!d.providedAttributes);return n.length>0?n.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder($){}registerTunnelProvider($,f){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,t)=>await $.provideTunnel(s,t,r.CancellationToken.None)??void 0;const i=f.tunnelFeatures?{elevation:!!f.tunnelFeatures?.elevation,privacyOptions:f.tunnelFeatures?.privacyOptions,protocol:f.tunnelFeatures.protocol===void 0?!0:f.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,C.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory($,f){if($){$.candidatePortSource!==void 0&&this.a.$setCandidatePortSource($.candidatePortSource),$.showCandidatePort&&(this.f=$.showCandidatePort,this.a.$setCandidateFilter());const i=$.tunnelFactory??(f?this.w(f):void 0);if(i){this.b=i;let s=$.tunnelFeatures?.privacyOptions??[];$.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:R.localize(10728,null),themeIcon:"lock"},{id:"public",label:R.localize(10729,null),themeIcon:"eye"}]);const t=$.tunnelFeatures?{elevation:!!$.tunnelFeatures?.elevation,public:!!$.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,C.$Rc)(()=>{this.b=void 0})}w($){}async $closeTunnel($,f){if(this.g.has($.host)){const i=this.g.get($.host);i.has($.port)&&(f&&i.get($.port).disposeListener.dispose(),await i.get($.port).tunnel.dispose(),i.delete($.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort($,f){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b($,f);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const s=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has($.remoteAddress.host)||this.g.set($.remoteAddress.host,new Map);const t=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get($.remoteAddress.host).set($.remoteAddress.port,{tunnel:s,disposeListener:t}),w.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter($){const f=await Promise.all($.map(s=>this.f(s.host,s.port,s.detail??""))),i=$.filter((s,t)=>f[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${$.map(s=>s.port).join(", ")} to ${i.map(s=>s.port).join(", ")}`),i}};e.$$Fb=a,e.$$Fb=a=Ye([Ve(0,S.$cQ),Ve(1,I.$sQ),Ve(2,T.$0j)],a)}),define(Se[15],De([1,0,18,21,190,79,85,28,178,51,103,24,183,22,50,17,2,113,30,110,87,58,145,89,155,152,153,271,119,126,73,74,268,9]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l,g,E,D,y,k,A,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$_P=ee,e.$aQ=re,e.$bQ=ye,L=Ue(L),f=Ue(f),i=Ue(i),s=Ue(s),E=Ue(E),y=Ue(y),v=Ue(v);var F;(function(Te){function Me(ie){const{selectionStartLineNumber:Ae,selectionStartColumn:Ge,positionLineNumber:it,positionColumn:Je}=ie,ft=new v.$GN(Ae-1,Ge-1),At=new v.$GN(it-1,Je-1);return new v.$IN(ft,At)}Te.to=Me;function ve(ie){const{anchor:Ae,active:Ge}=ie;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Ge.line+1,positionColumn:Ge.character+1}}Te.from=ve})(F||(e.Selection=F={}));var N;(function(Te){function Me(ie){if(!ie)return;const{start:Ae,end:Ge}=ie;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Ge.line+1,endColumn:Ge.character+1}}Te.from=Me;function ve(ie){if(!ie)return;const{startLineNumber:Ae,startColumn:Ge,endLineNumber:it,endColumn:Je}=ie;return new v.$HN(Ae-1,Ge-1,it-1,Je-1)}Te.to=ve})(N||(e.Range=N={}));var O;(function(Te){function Me(ie){return{uri:ie.uri,range:N.from(ie.range)}}Te.from=Me;function ve(ie){return new v.$TN(m.URI.revive(ie.uri),N.to(ie.range))}Te.to=ve})(O||(e.Location=O={}));var j;(function(Te){function Me(ve){switch(ve){case i.StandardTokenType.Comment:return v.StandardTokenType.Comment;case i.StandardTokenType.Other:return v.StandardTokenType.Other;case i.StandardTokenType.RegEx:return v.StandardTokenType.RegEx;case i.StandardTokenType.String:return v.StandardTokenType.String}}Te.to=Me})(j||(e.TokenType=j={}));var z;(function(Te){function Me(ie){return new v.$GN(ie.lineNumber-1,ie.column-1)}Te.to=Me;function ve(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Te.from=ve})(z||(e.Position=z={}));var M;(function(Te){function Me(Ae,Ge,it){return(0,r.$Gb)((0,r.$1b)(Ae).map(Je=>ve(Je,Ge,it)))}Te.from=Me;function ve(Ae,Ge,it){if(typeof Ae=="string")return{$serialized:!0,language:Ae,isBuiltin:it?.isBuiltin};if(Ae)return{$serialized:!0,language:Ae.language,scheme:ie(Ae.scheme,Ge),pattern:tt.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType,isBuiltin:it?.isBuiltin}}function ie(Ae,Ge){return Ge&&typeof Ae=="string"?Ge.transformOutgoingScheme(Ae):Ae}})(M||(e.DocumentSelector=M={}));var W;(function(Te){function Me(ie){switch(ie){case v.DiagnosticTag.Unnecessary:return o.MarkerTag.Unnecessary;case v.DiagnosticTag.Deprecated:return o.MarkerTag.Deprecated}}Te.from=Me;function ve(ie){switch(ie){case o.MarkerTag.Unnecessary:return v.DiagnosticTag.Unnecessary;case o.MarkerTag.Deprecated:return v.DiagnosticTag.Deprecated;default:return}}Te.to=ve})(W||(e.DiagnosticTag=W={}));var V;(function(Te){function Me(ie){let Ae;return ie.code&&((0,a.$cg)(ie.code)||(0,a.$gg)(ie.code)?Ae=String(ie.code):Ae={value:String(ie.code.value),target:ie.code.target}),{...N.from(ie.range),message:ie.message,source:ie.source,code:Ae,severity:B.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(ne.from),tags:Array.isArray(ie.tags)?(0,r.$Gb)(ie.tags.map(W.from)):void 0}}Te.from=Me;function ve(ie){const Ae=new v.$VN(N.to(ie),ie.message,B.to(ie.severity));return Ae.source=ie.source,Ae.code=(0,a.$cg)(ie.code)?ie.code:ie.code?.value,Ae.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(ne.to),Ae.tags=ie.tags&&(0,r.$Gb)(ie.tags.map(W.to)),Ae}Te.to=ve})(V||(e.Diagnostic=V={}));var ne;(function(Te){function Me(ie){return{...N.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Te.from=Me;function ve(ie){return new v.$UN(new v.$TN(ie.resource,N.to(ie)),ie.message)}Te.to=ve})(ne||(e.DiagnosticRelatedInformation=ne={}));var B;(function(Te){function Me(ie){switch(ie){case v.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Te.from=Me;function ve(ie){switch(ie){case o.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}Te.to=ve})(B||(e.DiagnosticSeverity=B={}));var K;(function(Te){function Me(ie){return typeof ie=="number"&&ie>=v.ViewColumn.One?ie-1:ie===v.ViewColumn.Beside?p.$wE:p.$vE}Te.from=Me;function ve(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Te.to=ve})(K||(e.ViewColumn=K={}));function Y(Te){return typeof Te.range<"u"}function ee(Te){return Te.length===0?!0:!!Y(Te[0])}var ue;(function(Te){function Me(Je){return Je.map(Te.from)}Te.fromMany=Me;function ve(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ie(Je){let ft;if(ve(Je)){const{language:zt,value:ri}=Je;ft={value:"```"+zt+`
`+ri+"\n```\n"}}else v.$0N.isMarkdownString(Je)?ft={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?ft={value:Je}:ft={value:""};const At=Object.create(null);ft.uris=At;const ni=zt=>{try{let ri=m.URI.parse(zt,!0);ri=ri.with({query:Ae(ri.query,At)}),At[zt]=ri}catch{}return""},ai=new b.marked.Renderer;return ai.link=ni,ai.image=zt=>typeof zt=="string"?ni(L.$9k(zt).href):"",(0,b.marked)(ft.value,{renderer:ai}),ft}Te.from=ie;function Ae(Je,ft){if(!Je)return Je;let At;try{At=(0,c.$$h)(Je)}catch{}if(!At)return Je;let ni=!1;return At=(0,S.$do)(At,ai=>{if(m.URI.isUri(ai)){const zt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[zt]=ai,ni=!0,zt}else return}),ni?JSON.stringify(At):Je}function Ge(Je){const ft=new v.$0N(Je.value,Je.supportThemeIcons);return ft.isTrusted=Je.isTrusted,ft.supportHtml=Je.supportHtml,ft.baseUri=Je.baseUri?m.URI.from(Je.baseUri):void 0,ft}Te.to=Ge;function it(Je){if(Je)return typeof Je=="string"?Je:Te.from(Je)}Te.fromStrict=it})(ue||(e.MarkdownString=ue={}));function re(Te){return ee(Te)?Te.map(Me=>({range:N.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?ue.fromMany(Me.hoverMessage):Me.hoverMessage?ue.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Te.map(Me=>({range:N.from(Me)}))}function ye(Te){return typeof Te>"u"?Te:typeof Te=="string"?m.URI.file(Te):Te}var me;(function(Te){function Me(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?ye(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Te.from=Me})(me||(e.ThemableDecorationAttachmentRenderOptions=me={}));var J;(function(Te){function Me(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?ye(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?me.from(ve.before):void 0,after:ve.after?me.from(ve.after):void 0}}Te.from=Me})(J||(e.ThemableDecorationRenderOptions=J={}));var U;(function(Te){function Me(ve){if(typeof ve>"u")return ve;switch(ve){case v.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case v.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Te.from=Me})(U||(e.DecorationRangeBehavior=U={}));var se;(function(Te){function Me(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?U.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?J.from(ve.light):void 0,dark:ve.dark?J.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?ye(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?me.from(ve.before):void 0,after:ve.after?me.from(ve.after):void 0}}Te.from=Me})(se||(e.DecorationRenderOptions=se={}));var ae;(function(Te){function Me(ie){return{text:ie.newText,eol:ie.newEol&&je.from(ie.newEol),range:N.from(ie.range)}}Te.from=Me;function ve(ie){const Ae=new v.$ON(N.to(ie.range),ie.text);return Ae.newEol=typeof ie.eol>"u"?void 0:je.to(ie.eol),Ae}Te.to=ve})(ae||(e.TextEdit=ae={}));var te;(function(Te){function Me(ie,Ae){const Ge={edits:[]};if(ie instanceof v.$RN){const it=new T.$Ac;for(const Je of ie._allEntries())Je._type===v.FileEditType.File&&m.URI.isUri(Je.to)&&Je.from===void 0&&it.add(Je.to);for(const Je of ie._allEntries())if(Je._type===v.FileEditType.File){let ft;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?ft={type:"base64",value:(0,h.$6e)(h.$Le.wrap(Je.options.contents))}:ft={type:"dataTransferItem",id:Je.options.contents._itemId}),Ge.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:ft},metadata:Je.metadata})}else Je._type===v.FileEditType.Text?Ge.edits.push({resource:Je.uri,textEdit:ae.from(Je.edit),versionId:it.has(Je.uri)?void 0:Ae?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===v.FileEditType.Snippet?Ge.edits.push({resource:Je.uri,textEdit:{range:N.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:it.has(Je.uri)?void 0:Ae?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===v.FileEditType.Cell?Ge.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(Je.uri)}):Je._type===v.FileEditType.CellReplace&&Ge.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:y.CellEditType.Replace,index:Je.index,count:Je.count,cells:Je.cells.map(et.from)}})}return Ge}Te.from=Me;function ve(ie){const Ae=new v.$RN,Ge=new T.$zc;for(const it of ie.edits)if(it.textEdit){const Je=it,ft=m.URI.revive(Je.resource),At=N.to(Je.textEdit.range),ni=Je.textEdit.text,ai=Je.textEdit.insertAsSnippet;let zt;ai?zt=v.$QN.replace(At,new v.$SN(ni)):zt=v.$ON.replace(At,ni);const ri=Ge.get(ft);ri?ri.push(zt):Ge.set(ft,[zt])}else Ae.renameFile(m.URI.revive(it.oldResource),m.URI.revive(it.newResource),it.options);for(const[it,Je]of Ge)Ae.set(it,Je);return Ae}Te.to=ve})(te||(e.WorkspaceEdit=te={}));var ce;(function(Te){const Me=Object.create(null);Me[v.SymbolKind.File]=s.SymbolKind.File,Me[v.SymbolKind.Module]=s.SymbolKind.Module,Me[v.SymbolKind.Namespace]=s.SymbolKind.Namespace,Me[v.SymbolKind.Package]=s.SymbolKind.Package,Me[v.SymbolKind.Class]=s.SymbolKind.Class,Me[v.SymbolKind.Method]=s.SymbolKind.Method,Me[v.SymbolKind.Property]=s.SymbolKind.Property,Me[v.SymbolKind.Field]=s.SymbolKind.Field,Me[v.SymbolKind.Constructor]=s.SymbolKind.Constructor,Me[v.SymbolKind.Enum]=s.SymbolKind.Enum,Me[v.SymbolKind.Interface]=s.SymbolKind.Interface,Me[v.SymbolKind.Function]=s.SymbolKind.Function,Me[v.SymbolKind.Variable]=s.SymbolKind.Variable,Me[v.SymbolKind.Constant]=s.SymbolKind.Constant,Me[v.SymbolKind.String]=s.SymbolKind.String,Me[v.SymbolKind.Number]=s.SymbolKind.Number,Me[v.SymbolKind.Boolean]=s.SymbolKind.Boolean,Me[v.SymbolKind.Array]=s.SymbolKind.Array,Me[v.SymbolKind.Object]=s.SymbolKind.Object,Me[v.SymbolKind.Key]=s.SymbolKind.Key,Me[v.SymbolKind.Null]=s.SymbolKind.Null,Me[v.SymbolKind.EnumMember]=s.SymbolKind.EnumMember,Me[v.SymbolKind.Struct]=s.SymbolKind.Struct,Me[v.SymbolKind.Event]=s.SymbolKind.Event,Me[v.SymbolKind.Operator]=s.SymbolKind.Operator,Me[v.SymbolKind.TypeParameter]=s.SymbolKind.TypeParameter;function ve(Ae){return typeof Me[Ae]=="number"?Me[Ae]:s.SymbolKind.Property}Te.from=ve;function ie(Ae){for(const Ge in Me)if(Me[Ge]===Ae)return Number(Ge);return v.SymbolKind.Property}Te.to=ie})(ce||(e.SymbolKind=ce={}));var le;(function(Te){function Me(ie){switch(ie){case v.SymbolTag.Deprecated:return s.SymbolTag.Deprecated}}Te.from=Me;function ve(ie){switch(ie){case s.SymbolTag.Deprecated:return v.SymbolTag.Deprecated}}Te.to=ve})(le||(e.SymbolTag=le={}));var x;(function(Te){function Me(ie){return{name:ie.name,kind:ce.from(ie.kind),tags:ie.tags&&ie.tags.map(le.from),containerName:ie.containerName,location:ze.from(ie.location)}}Te.from=Me;function ve(ie){const Ae=new v.$1N(ie.name,ce.to(ie.kind),ie.containerName,ze.to(ie.location));return Ae.tags=ie.tags&&ie.tags.map(le.to),Ae}Te.to=ve})(x||(e.WorkspaceSymbol=x={}));var oe;(function(Te){function Me(ie){const Ae={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),kind:ce.from(ie.kind),tags:ie.tags?.map(le.from)??[]};return ie.children&&(Ae.children=ie.children.map(Me)),Ae}Te.from=Me;function ve(ie){const Ae=new v.$2N(ie.name,ie.detail,ce.to(ie.kind),N.to(ie.range),N.to(ie.selectionRange));return(0,r.$Kb)(ie.tags)&&(Ae.tags=ie.tags.map(le.to)),ie.children&&(Ae.children=ie.children.map(ve)),Ae}Te.to=ve})(oe||(e.DocumentSymbol=oe={}));var pe;(function(Te){function Me(ie){const Ae=new v.$6N(ce.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),N.to(ie.range),N.to(ie.selectionRange));return Ae._sessionId=ie._sessionId,Ae._itemId=ie._itemId,Ae}Te.to=Me;function ve(ie,Ae,Ge){if(Ae=Ae??ie._sessionId,Ge=Ge??ie._itemId,Ae===void 0||Ge===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ge,name:ie.name,detail:ie.detail,kind:ce.from(ie.kind),uri:ie.uri,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),tags:ie.tags?.map(le.from)}}Te.from=ve})(pe||(e.CallHierarchyItem=pe={}));var we;(function(Te){function Me(ve){return new v.$7N(pe.to(ve.from),ve.fromRanges.map(ie=>N.to(ie)))}Te.to=Me})(we||(e.CallHierarchyIncomingCall=we={}));var Fe;(function(Te){function Me(ve){return new v.$8N(pe.to(ve.to),ve.fromRanges.map(ie=>N.to(ie)))}Te.to=Me})(Fe||(e.CallHierarchyOutgoingCall=Fe={}));var ze;(function(Te){function Me(ie){return{range:ie.range&&N.from(ie.range),uri:ie.uri}}Te.from=Me;function ve(ie){return new v.$TN(m.URI.revive(ie.uri),N.to(ie.range))}Te.to=ve})(ze||(e.location=ze={}));var Ce;(function(Te){function Me(ie){const Ae=ie,Ge=ie;return{originSelectionRange:Ae.originSelectionRange?N.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Ge.uri,range:N.from(Ae.targetRange?Ae.targetRange:Ge.range),targetSelectionRange:Ae.targetSelectionRange?N.from(Ae.targetSelectionRange):void 0}}Te.from=Me;function ve(ie){return{targetUri:m.URI.revive(ie.uri),targetRange:N.to(ie.range),targetSelectionRange:ie.targetSelectionRange?N.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?N.to(ie.originSelectionRange):void 0}}Te.to=ve})(Ce||(e.DefinitionLink=Ce={}));var Ie;(function(Te){function Me(ie){return{range:N.from(ie.range),contents:ue.fromMany(ie.contents),canIncreaseVerbosity:ie.canIncreaseVerbosity,canDecreaseVerbosity:ie.canDecreaseVerbosity}}Te.from=Me;function ve(ie){const Ae=ie.contents.map(ue.to),Ge=N.to(ie.range),it=ie.canIncreaseVerbosity,Je=ie.canDecreaseVerbosity;return new v.$XN(Ae,Ge,it,Je)}Te.to=ve})(Ie||(e.Hover=Ie={}));var Pe;(function(Te){function Me(ie){return{range:N.from(ie.range),expression:ie.expression}}Te.from=Me;function ve(ie){return new v.$SO(N.to(ie.range),ie.expression)}Te.to=ve})(Pe||(e.EvaluatableExpression=Pe={}));var q;(function(Te){function Me(ie){if(ie instanceof v.$TO)return{type:"text",range:N.from(ie.range),text:ie.text};if(ie instanceof v.$UO)return{type:"variable",range:N.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof v.$VO)return{type:"expression",range:N.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Te.from=Me;function ve(ie){switch(ie.type){case"text":return{range:N.to(ie.range),text:ie.text};case"variable":return{range:N.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:N.to(ie.range),expression:ie.expression}}}Te.to=ve})(q||(e.InlineValue=q={}));var H;(function(Te){function Me(ie){return{frameId:ie.frameId,stoppedLocation:N.from(ie.stoppedLocation)}}Te.from=Me;function ve(ie){return new v.$WO(ie.frameId,N.to(ie.stoppedLocation))}Te.to=ve})(H||(e.InlineValueContext=H={}));var X;(function(Te){function Me(ie){return{range:N.from(ie.range),kind:ie.kind}}Te.from=Me;function ve(ie){return new v.$YN(N.to(ie.range),ie.kind)}Te.to=ve})(X||(e.DocumentHighlight=X={}));var Z;(function(Te){function Me(ie){return{uri:ie.uri,highlights:ie.highlights.map(X.from)}}Te.from=Me;function ve(ie){return new v.$ZN(m.URI.revive(ie.uri),ie.highlights.map(X.to))}Te.to=ve})(Z||(e.MultiDocumentHighlight=Z={}));var de;(function(Te){function Me(ve){switch(ve){case s.CompletionTriggerKind.TriggerCharacter:return v.CompletionTriggerKind.TriggerCharacter;case s.CompletionTriggerKind.TriggerForIncompleteCompletions:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case s.CompletionTriggerKind.Invoke:default:return v.CompletionTriggerKind.Invoke}}Te.to=Me})(de||(e.CompletionTriggerKind=de={}));var be;(function(Te){function Me(ve){return{triggerKind:de.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Te.to=Me})(be||(e.CompletionContext=be={}));var Oe;(function(Te){function Me(ie){switch(ie){case v.CompletionItemTag.Deprecated:return s.CompletionItemTag.Deprecated}}Te.from=Me;function ve(ie){switch(ie){case s.CompletionItemTag.Deprecated:return v.CompletionItemTag.Deprecated}}Te.to=ve})(Oe||(e.CompletionItemTag=Oe={}));var He;(function(Te){const Me=new Map([[v.CompletionItemKind.Method,s.CompletionItemKind.Method],[v.CompletionItemKind.Function,s.CompletionItemKind.Function],[v.CompletionItemKind.Constructor,s.CompletionItemKind.Constructor],[v.CompletionItemKind.Field,s.CompletionItemKind.Field],[v.CompletionItemKind.Variable,s.CompletionItemKind.Variable],[v.CompletionItemKind.Class,s.CompletionItemKind.Class],[v.CompletionItemKind.Interface,s.CompletionItemKind.Interface],[v.CompletionItemKind.Struct,s.CompletionItemKind.Struct],[v.CompletionItemKind.Module,s.CompletionItemKind.Module],[v.CompletionItemKind.Property,s.CompletionItemKind.Property],[v.CompletionItemKind.Unit,s.CompletionItemKind.Unit],[v.CompletionItemKind.Value,s.CompletionItemKind.Value],[v.CompletionItemKind.Constant,s.CompletionItemKind.Constant],[v.CompletionItemKind.Enum,s.CompletionItemKind.Enum],[v.CompletionItemKind.EnumMember,s.CompletionItemKind.EnumMember],[v.CompletionItemKind.Keyword,s.CompletionItemKind.Keyword],[v.CompletionItemKind.Snippet,s.CompletionItemKind.Snippet],[v.CompletionItemKind.Text,s.CompletionItemKind.Text],[v.CompletionItemKind.Color,s.CompletionItemKind.Color],[v.CompletionItemKind.File,s.CompletionItemKind.File],[v.CompletionItemKind.Reference,s.CompletionItemKind.Reference],[v.CompletionItemKind.Folder,s.CompletionItemKind.Folder],[v.CompletionItemKind.Event,s.CompletionItemKind.Event],[v.CompletionItemKind.Operator,s.CompletionItemKind.Operator],[v.CompletionItemKind.TypeParameter,s.CompletionItemKind.TypeParameter],[v.CompletionItemKind.Issue,s.CompletionItemKind.Issue],[v.CompletionItemKind.User,s.CompletionItemKind.User]]);function ve(Ge){return Me.get(Ge)??s.CompletionItemKind.Property}Te.from=ve;const ie=new Map([[s.CompletionItemKind.Method,v.CompletionItemKind.Method],[s.CompletionItemKind.Function,v.CompletionItemKind.Function],[s.CompletionItemKind.Constructor,v.CompletionItemKind.Constructor],[s.CompletionItemKind.Field,v.CompletionItemKind.Field],[s.CompletionItemKind.Variable,v.CompletionItemKind.Variable],[s.CompletionItemKind.Class,v.CompletionItemKind.Class],[s.CompletionItemKind.Interface,v.CompletionItemKind.Interface],[s.CompletionItemKind.Struct,v.CompletionItemKind.Struct],[s.CompletionItemKind.Module,v.CompletionItemKind.Module],[s.CompletionItemKind.Property,v.CompletionItemKind.Property],[s.CompletionItemKind.Unit,v.CompletionItemKind.Unit],[s.CompletionItemKind.Value,v.CompletionItemKind.Value],[s.CompletionItemKind.Constant,v.CompletionItemKind.Constant],[s.CompletionItemKind.Enum,v.CompletionItemKind.Enum],[s.CompletionItemKind.EnumMember,v.CompletionItemKind.EnumMember],[s.CompletionItemKind.Keyword,v.CompletionItemKind.Keyword],[s.CompletionItemKind.Snippet,v.CompletionItemKind.Snippet],[s.CompletionItemKind.Text,v.CompletionItemKind.Text],[s.CompletionItemKind.Color,v.CompletionItemKind.Color],[s.CompletionItemKind.File,v.CompletionItemKind.File],[s.CompletionItemKind.Reference,v.CompletionItemKind.Reference],[s.CompletionItemKind.Folder,v.CompletionItemKind.Folder],[s.CompletionItemKind.Event,v.CompletionItemKind.Event],[s.CompletionItemKind.Operator,v.CompletionItemKind.Operator],[s.CompletionItemKind.TypeParameter,v.CompletionItemKind.TypeParameter],[s.CompletionItemKind.User,v.CompletionItemKind.User],[s.CompletionItemKind.Issue,v.CompletionItemKind.Issue]]);function Ae(Ge){return ie.get(Ge)??v.CompletionItemKind.Property}Te.to=Ae})(He||(e.CompletionItemKind=He={}));var Qe;(function(Te){function Me(ve,ie){const Ae=new v.$dO(ve.label);return Ae.insertText=ve.insertText,Ae.kind=He.to(ve.kind),Ae.tags=ve.tags?.map(Oe.to),Ae.detail=ve.detail,Ae.documentation=L.$3k(ve.documentation)?ue.to(ve.documentation):ve.documentation,Ae.sortText=ve.sortText,Ae.filterText=ve.filterText,Ae.preselect=ve.preselect,Ae.commitCharacters=ve.commitCharacters,f.$Lt.isIRange(ve.range)?Ae.range=N.to(ve.range):typeof ve.range=="object"&&(Ae.range={inserting:N.to(ve.range.insert),replacing:N.to(ve.range.replace)}),Ae.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&s.CompletionItemInsertTextRule.KeepWhitespace),typeof ve.insertTextRules<"u"&&ve.insertTextRules&s.CompletionItemInsertTextRule.InsertAsSnippet?Ae.insertText=new v.$SN(ve.insertText):(Ae.insertText=ve.insertText,Ae.textEdit=Ae.range instanceof v.$HN?new v.$ON(Ae.range,Ae.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ve.additionalTextEdits.map(Ge=>ae.to(Ge))),Ae.command=ie&&ve.command?ie.fromInternal(ve.command):void 0,Ae}Te.to=Me})(Qe||(e.CompletionItem=Qe={}));var _e;(function(Te){function Me(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:ue.fromStrict(ie.documentation)}}Te.from=Me;function ve(ie){return{label:ie.label,documentation:L.$3k(ie.documentation)?ue.to(ie.documentation):ie.documentation}}Te.to=ve})(_e||(e.ParameterInformation=_e={}));var nt;(function(Te){function Me(ie){return{label:ie.label,documentation:ue.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(_e.from):[],activeParameter:ie.activeParameter}}Te.from=Me;function ve(ie){return{label:ie.label,documentation:L.$3k(ie.documentation)?ue.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(_e.to):[],activeParameter:ie.activeParameter}}Te.to=ve})(nt||(e.SignatureInformation=nt={}));var st;(function(Te){function Me(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(nt.from):[]}}Te.from=Me;function ve(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(nt.to):[]}}Te.to=ve})(st||(e.SignatureHelp=st={}));var rt;(function(Te){function Me(ve,ie){const Ae=new v.$cO(z.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(at.to.bind(void 0,ve)),ie.kind&&mt.to(ie.kind));return Ae.textEdits=ie.textEdits&&ie.textEdits.map(ae.to),Ae.tooltip=L.$3k(ie.tooltip)?ue.to(ie.tooltip):ie.tooltip,Ae.paddingLeft=ie.paddingLeft,Ae.paddingRight=ie.paddingRight,Ae}Te.to=Me})(rt||(e.InlayHint=rt={}));var at;(function(Te){function Me(ve,ie){const Ae=new v.$bO(ie.label);return Ae.tooltip=L.$3k(ie.tooltip)?ue.to(ie.tooltip):ie.tooltip,s.Command.is(ie.command)&&(Ae.command=ve.fromInternal(ie.command)),ie.location&&(Ae.location=ze.to(ie.location)),Ae}Te.to=Me})(at||(e.InlayHintLabelPart=at={}));var mt;(function(Te){function Me(ie){return ie}Te.from=Me;function ve(ie){return ie}Te.to=ve})(mt||(e.InlayHintKind=mt={}));var ht;(function(Te){function Me(ie){return{range:N.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Te.from=Me;function ve(ie){let Ae;if(ie.url)try{Ae=typeof ie.url=="string"?m.URI.parse(ie.url,!0):m.URI.revive(ie.url)}catch{}const Ge=new v.$iO(N.to(ie.range),Ae);return Ge.tooltip=ie.tooltip,Ge}Te.to=ve})(ht||(e.DocumentLink=ht={}));var ct;(function(Te){function Me(ie){const Ae=new v.$lO(ie.label);return ie.textEdit&&(Ae.textEdit=ae.to(ie.textEdit)),ie.additionalTextEdits&&(Ae.additionalTextEdits=ie.additionalTextEdits.map(Ge=>ae.to(Ge))),Ae}Te.to=Me;function ve(ie){return{label:ie.label,textEdit:ie.textEdit?ae.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Ae=>ae.from(Ae)):void 0}}Te.from=ve})(ct||(e.ColorPresentation=ct={}));var ke;(function(Te){function Me(ie){return new v.$jO(ie[0],ie[1],ie[2],ie[3])}Te.to=Me;function ve(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Te.from=ve})(ke||(e.Color=ke={}));var Be;(function(Te){function Me(ie){return{range:N.from(ie.range)}}Te.from=Me;function ve(ie){return new v.$5N(N.to(ie.range))}Te.to=ve})(Be||(e.SelectionRange=Be={}));var Ke;(function(Te){function Me(ve){switch(ve){case l.SaveReason.AUTO:return v.TextDocumentSaveReason.AfterDelay;case l.SaveReason.EXPLICIT:return v.TextDocumentSaveReason.Manual;case l.SaveReason.FOCUS_CHANGE:case l.SaveReason.WINDOW_CHANGE:return v.TextDocumentSaveReason.FocusOut}}Te.to=Me})(Ke||(e.TextDocumentSaveReason=Ke={}));var Ne;(function(Te){function Me(ie){switch(ie){case v.TextEditorLineNumbersStyle.Off:return $.RenderLineNumbersType.Off;case v.TextEditorLineNumbersStyle.Relative:return $.RenderLineNumbersType.Relative;case v.TextEditorLineNumbersStyle.Interval:return $.RenderLineNumbersType.Interval;case v.TextEditorLineNumbersStyle.On:default:return $.RenderLineNumbersType.On}}Te.from=Me;function ve(ie){switch(ie){case $.RenderLineNumbersType.Off:return v.TextEditorLineNumbersStyle.Off;case $.RenderLineNumbersType.Relative:return v.TextEditorLineNumbersStyle.Relative;case $.RenderLineNumbersType.Interval:return v.TextEditorLineNumbersStyle.Interval;case $.RenderLineNumbersType.On:default:return v.TextEditorLineNumbersStyle.On}}Te.to=ve})(Ne||(e.TextEditorLineNumbersStyle=Ne={}));var je;(function(Te){function Me(ie){if(ie===v.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(ie===v.EndOfLine.LF)return t.EndOfLineSequence.LF}Te.from=Me;function ve(ie){if(ie===t.EndOfLineSequence.CRLF)return v.EndOfLine.CRLF;if(ie===t.EndOfLineSequence.LF)return v.EndOfLine.LF}Te.to=ve})(je||(e.EndOfLine=je={}));var he;(function(Te){function Me(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case v.ProgressLocation.SourceControl:return n.ProgressLocation.Scm;case v.ProgressLocation.Window:return n.ProgressLocation.Window;case v.ProgressLocation.Notification:return n.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Te.from=Me})(he||(e.ProgressLocation=he={}));var _;(function(Te){function Me(ie){const Ae={start:ie.start+1,end:ie.end+1};return ie.kind&&(Ae.kind=Re.from(ie.kind)),Ae}Te.from=Me;function ve(ie){const Ae={start:ie.start-1,end:ie.end-1};return ie.kind&&(Ae.kind=Re.to(ie.kind)),Ae}Te.to=ve})(_||(e.FoldingRange=_={}));var Re;(function(Te){function Me(ie){if(ie)switch(ie){case v.FoldingRangeKind.Comment:return s.$Mu.Comment;case v.FoldingRangeKind.Imports:return s.$Mu.Imports;case v.FoldingRangeKind.Region:return s.$Mu.Region}}Te.from=Me;function ve(ie){if(ie)switch(ie.value){case s.$Mu.Comment.value:return v.FoldingRangeKind.Comment;case s.$Mu.Imports.value:return v.FoldingRangeKind.Imports;case s.$Mu.Region.value:return v.FoldingRangeKind.Region}}Te.to=ve})(Re||(e.FoldingRangeKind=Re={}));var Xe;(function(Te){function Me(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?N.from(ve.selection):void 0,override:typeof ve.override=="boolean"?l.$2F.id:void 0}}Te.from=Me})(Xe||(e.TextEditorOpenOptions=Xe={}));var tt;(function(Te){function Me(Ge){return Ge instanceof v.$GO?Ge.toJSON():typeof Ge=="string"?Ge:ve(Ge)||ie(Ge)?new v.$GO(Ge.baseUri??Ge.base,Ge.pattern).toJSON():Ge}Te.from=Me;function ve(Ge){const it=Ge;return it?m.URI.isUri(it.baseUri)&&typeof it.pattern=="string":!1}function ie(Ge){const it=Ge;return it?typeof it.base=="string"&&typeof it.pattern=="string":!1}function Ae(Ge){return typeof Ge=="string"?Ge:new v.$GO(m.URI.revive(Ge.baseUri),Ge.pattern)}Te.to=Ae})(tt||(e.GlobPattern=tt={}));var ut;(function(Te){function Me(ve){if(ve){if(Array.isArray(ve))return ve.map(Me);if(typeof ve=="string")return ve;{const ie=ve;return{language:ie.language,scheme:ie.scheme,pattern:tt.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Te.from=Me})(ut||(e.LanguageSelector=ut={}));var gt;(function(Te){function Me(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Ae=>Array.isArray(Ae)&&Ae.every(Ge=>Ge&&typeof Ge=="object"&&"uri"in Ge&&m.URI.isUri(Ge.uri)&&"version"in Ge&&typeof Ge.version=="number"&&"ranges"in Ge&&Array.isArray(Ge.ranges)&&Ge.ranges.every(it=>it instanceof v.$HN)))}Te.is=Me;function ve(ie){return{documents:ie.documents.map(Ae=>Ae.map(Ge=>({uri:m.URI.from(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(it=>N.from(it))})))}}Te.from=ve})(gt||(e.MappedEditsContext=gt={}));var Dt;(function(Te){function Me(ie){return{start:ie.start,end:ie.end}}Te.from=Me;function ve(ie){return new v.$0O(ie.start,ie.end)}Te.to=ve})(Dt||(e.NotebookRange=Dt={}));var Nt;(function(Te){function Me(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Te.to=Me;function ve(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Te.from=ve})(Nt||(e.NotebookCellExecutionSummary=Nt={}));var Ut;(function(Te){function Me(ve){if(ve===y.NotebookCellExecutionState.Unconfirmed)return v.NotebookCellExecutionState.Pending;if(ve===y.NotebookCellExecutionState.Pending)return;if(ve===y.NotebookCellExecutionState.Executing)return v.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Te.to=Me})(Ut||(e.NotebookCellExecutionState=Ut={}));var Zt;(function(Te){function Me(ie){switch(ie){case v.NotebookCellKind.Markup:return y.CellKind.Markup;case v.NotebookCellKind.Code:default:return y.CellKind.Code}}Te.from=Me;function ve(ie){switch(ie){case y.CellKind.Markup:return v.NotebookCellKind.Markup;case y.CellKind.Code:default:return v.NotebookCellKind.Code}}Te.to=ve})(Zt||(e.NotebookCellKind=Zt={}));var hi;(function(Te){function Me(ie){const Ae={metadata:ie.metadata??Object.create(null),cells:[]};for(const Ge of ie.cells)v.$$O.validate(Ge),Ae.cells.push(et.from(Ge));return Ae}Te.from=Me;function ve(ie){const Ae=new v.$_O(ie.cells.map(et.to));return(0,a.$pg)(ie.metadata)||(Ae.metadata=ie.metadata),Ae}Te.to=ve})(hi||(e.NotebookData=hi={}));var et;(function(Te){function Me(ie){return{cellKind:Zt.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Nt.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(Kt.from):[]}}Te.from=Me;function ve(ie){return new v.$$O(Zt.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(Kt.to):void 0,ie.metadata,ie.internalMetadata?Nt.to(ie.internalMetadata):void 0)}Te.to=ve})(et||(e.NotebookCellData=et={}));var Gt;(function(Te){function Me(ie){return{mime:ie.mime,valueBytes:h.$Le.wrap(ie.data)}}Te.from=Me;function ve(ie){return new v.$aP(ie.valueBytes.buffer,ie.mime)}Te.to=ve})(Gt||(e.NotebookCellOutputItem=Gt={}));var Kt;(function(Te){function Me(ie){return{outputId:ie.id,items:ie.items.map(Gt.from),metadata:ie.metadata}}Te.from=Me;function ve(ie){const Ae=ie.items.map(Gt.to);return new v.$bP(Ae,ie.outputId,ie.metadata)}Te.to=ve})(Kt||(e.NotebookCellOutput=Kt={}));var pt;(function(Te){function Me(Ae){return ie(Ae)?{include:tt.from(Ae.include)??void 0,exclude:tt.from(Ae.exclude)??void 0}:tt.from(Ae)??void 0}Te.from=Me;function ve(Ae){return ie(Ae)?{include:tt.to(Ae.include),exclude:tt.to(Ae.exclude)}:tt.to(Ae)}Te.to=ve;function ie(Ae){const Ge=Ae;return Ge?!(0,a.$lg)(Ge.include)&&!(0,a.$lg)(Ge.exclude):!1}})(pt||(e.NotebookExclusiveDocumentPattern=pt={}));var kt;(function(Te){function Me(ve,ie,Ae){const Ge=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===v.NotebookCellStatusBarAlignment.Left?y.CellStatusbarAlignment.Left:y.CellStatusbarAlignment.Right,command:ie.toInternal(Ge,Ae),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Te.from=Me})(kt||(e.NotebookStatusBarItem=kt={}));var xt;(function(Te){function Me(ve,ie,Ae){const Ge=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:ie.toInternal(Ge,Ae),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Te.from=Me})(xt||(e.NotebookKernelSourceAction=xt={}));var _t;(function(Te){function Me(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Te.from=Me})(_t||(e.NotebookDocumentContentOptions=_t={}));var qt;(function(Te){function Me(ie){return{uri:ie.uri,provides:ie.provides}}Te.from=Me;function ve(ie){return new v.$dP(m.URI.revive(ie.uri),ie.provides)}Te.to=ve})(qt||(e.NotebookRendererScript=qt={}));var wt;(function(Te){function Me(ie){return{message:ue.fromStrict(ie.message)||"",type:A.TestMessageType.Error,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:N.from(ie.location.range),uri:ie.location.uri},stackTrace:ie.stackTrace?.map(Ae=>({label:Ae.label,position:Ae.position&&z.from(Ae.position),uri:Ae.file&&m.URI.revive(Ae.file).toJSON()}))}}Te.from=Me;function ve(ie){const Ae=new v.$jP(typeof ie.message=="string"?ie.message:ue.to(ie.message));return Ae.actualOutput=ie.actual,Ae.expectedOutput=ie.expected,Ae.contextValue=ie.contextValue,Ae.location=ie.location?ze.to(ie.location):void 0,Ae}Te.to=ve})(wt||(e.TestMessage=wt={}));var Rt;(function(Te){Te.namespace=A.$8I,Te.denamespace=A.$9I})(Rt||(e.TestTag=Rt={}));var ci;(function(Te){function Me(ie){const Ae=(0,d.$$P)(ie).controllerId;return{extId:k.$3I.fromExtHostTestItem(ie,Ae).toString(),label:ie.label,uri:m.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(Ge=>Rt.namespace(Ae,Ge.id)),range:f.$Lt.lift(N.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&ue.fromStrict(ie.error)||null}}Te.from=Me;function ve(ie){return{parent:void 0,error:void 0,id:k.$3I.fromString(ie.extId).localId,label:ie.label,uri:m.URI.revive(ie.uri),tags:(ie.tags||[]).map(Ae=>{const{tagId:Ge}=Rt.denamespace(Ae);return new v.$kP(Ge)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Te.toPlain=ve})(ci||(e.TestItem=ci={})),function(Te){function Me(ie){return{id:ie.id}}Te.from=Me;function ve(ie){return new v.$kP(ie.id)}Te.to=ve}(Rt||(e.TestTag=Rt={}));var Qt;(function(Te){const Me=(ie,Ae)=>{const Ge=ie.value;if(!Ge)return;const it={...ci.toPlain(Ge.item),parent:Ae,taskStates:Ge.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(ft=>ft.type===A.TestMessageType.Error).map(wt.to)})),children:[]};if(ie.children)for(const Je of ie.children.values()){const ft=Me(Je,it);ft&&it.children.push(ft)}return it};function ve(ie){const Ae=new u.$2I;for(const Je of ie.items)Ae.insert(k.$3I.fromString(Je.item.extId).path,Je);const Ge=[Ae.nodes],it=[];for(;Ge.length;)for(const Je of Ge.pop())Je.value?it.push(Je):Je.children&&Ge.push(Je.children.values());return{completedAt:ie.completedAt,results:it.map(Je=>Me(Je)).filter(a.$kg)}}Te.to=ve})(Qt||(e.TestResults=Qt={}));var xe;(function(Te){function Me(Ge){return{covered:Ge.covered,total:Ge.total}}function ve(Ge){return"line"in Ge?z.from(Ge):N.from(Ge)}function ie(Ge){if(typeof Ge.executed=="number"&&Ge.executed<0)throw new Error(`Invalid coverage count ${Ge.executed}`);return"branches"in Ge?{count:Ge.executed,location:ve(Ge.location),type:A.DetailType.Statement,branches:Ge.branches.length?Ge.branches.map(it=>({count:it.executed,location:it.location&&ve(it.location),label:it.label})):void 0}:{type:A.DetailType.Declaration,name:Ge.name,count:Ge.executed,location:ve(Ge.location)}}Te.fromDetails=ie;function Ae(Ge,it,Je){return v.$nP(Je.statementCoverage),v.$nP(Je.branchCoverage),v.$nP(Je.declarationCoverage),{id:it,uri:Je.uri,statement:Me(Je.statementCoverage),branch:Je.branchCoverage&&Me(Je.branchCoverage),declaration:Je.declarationCoverage&&Me(Je.declarationCoverage),testIds:Je instanceof v.$oP&&Je.fromTests.length?Je.fromTests.map(ft=>k.$3I.fromExtHostTestItem(ft,Ge).toString()):void 0}}Te.fromFile=Ae})(xe||(e.TestCoverage=xe={}));var ei;(function(Te){function Me(ve){switch(ve){case s.CodeActionTriggerType.Invoke:return v.CodeActionTriggerKind.Invoke;case s.CodeActionTriggerType.Auto:return v.CodeActionTriggerKind.Automatic}}Te.to=Me})(ei||(e.CodeActionTriggerKind=ei={}));var li;(function(Te){function Me(ie){const Ae=new v.$sP(ce.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),N.to(ie.range),N.to(ie.selectionRange));return Ae._sessionId=ie._sessionId,Ae._itemId=ie._itemId,Ae}Te.to=Me;function ve(ie,Ae,Ge){if(Ae=Ae??ie._sessionId,Ge=Ge??ie._itemId,Ae===void 0||Ge===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ge,kind:ce.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:N.from(ie.range),selectionRange:N.from(ie.selectionRange),tags:ie.tags?.map(le.from)}}Te.from=ve})(li||(e.TypeHierarchyItem=li={}));var di;(function(Te){function Me(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Te.from=Me})(di||(e.ViewBadge=di={}));var It;(function(Te){function Me(Ge,it,Je){const ft=it.fileData;return ft?new v.$yO(new v.$zO(ft.name,m.URI.revive(ft.uri),ft.id,(0,R.$cb)(()=>Je(ft.id)))):Ge===I.$8s.uriList&&it.uriListData?new v.$xO(Ae(it.uriListData)):new v.$xO(it.asString)}Te.to=Me;async function ve(Ge,it){const Je=await it.asString();if(Ge===I.$8s.uriList)return{asString:Je,fileData:void 0,uriListData:ie(Je)};const ft=it.asFile();return{asString:Je,fileData:ft?{name:ft.name,uri:ft.uri,id:ft._itemId??ft.id}:void 0}}Te.from=ve;function ie(Ge){return C.$qu.split(Ge).map(it=>{if(it.startsWith("#"))return it;try{return m.URI.parse(it)}catch{}return it})}function Ae(Ge){return C.$qu.create(Ge.map(it=>typeof it=="string"?it:m.URI.revive(it)))}})(It||(e.DataTransferItem=It={}));var Mt;(function(Te){function Me(ie,Ae){const Ge=ie.items.map(([it,Je])=>[it,It.to(it,Je,Ae)]);return new v.$AO(Ge)}Te.toDataTransfer=Me;async function ve(ie){const Ae={items:[]},Ge=[];for(const[it,Je]of ie)Ge.push((async()=>{Ae.items.push([it,await It.from(it,Je)])})());return await Promise.all(Ge),Ae}Te.from=ve})(Mt||(e.DataTransfer=Mt={}));var Tt;(function(Te){function Me(ie,Ae){return{kind:"reply",agentId:ie.participant??Ae?.agentId??"",subCommand:ie.command??Ae?.command,message:ie.prompt,title:ie.label}}Te.from=Me;function ve(ie){return{prompt:ie.message,label:ie.title,participant:ie.agentId,command:ie.subCommand}}Te.to=ve})(Tt||(e.ChatFollowup=Tt={}));var jt;(function(Te){function Me(ie){switch(ie){case E.ChatMessageRole.System:return v.LanguageModelChatMessageRole.System;case E.ChatMessageRole.User:return v.LanguageModelChatMessageRole.User;case E.ChatMessageRole.Assistant:return v.LanguageModelChatMessageRole.Assistant}}Te.to=Me;function ve(ie){switch(ie){case v.LanguageModelChatMessageRole.System:return E.ChatMessageRole.System;case v.LanguageModelChatMessageRole.User:return E.ChatMessageRole.User;case v.LanguageModelChatMessageRole.Assistant:return E.ChatMessageRole.Assistant}return E.ChatMessageRole.User}Te.from=ve})(jt||(e.LanguageModelChatMessageRole=jt={}));var si;(function(Te){function Me(ie){let Ae="",Ge;ie.content.type==="text"?Ae=ie.content.value:Ge=new v.$VP(ie.content.name,ie.content.value,ie.content.isError);const it=jt.to(ie.role),Je=new v.$WP(it,Ae,ie.name);return Ge!==void 0&&(Je.content2=Ge),Je}Te.to=Me;function ve(ie){const Ae=jt.from(ie.role),Ge=ie.name;let it;return ie.content2 instanceof v.$VP?it={type:"function_result",name:ie.content2.name,value:ie.content2.content,isError:ie.content2.isError}:it={type:"text",value:ie.content},{role:Ae,name:Ge,content:it}}Te.from=ve})(si||(e.LanguageModelChatMessage=si={}));var ti;(function(Te){function Me(ie){return{kind:"markdownContent",content:ue.from(ie.value)}}Te.from=Me;function ve(ie){return new v.$FP(ue.to(ie.content))}Te.to=ve})(ti||(e.ChatResponseMarkdownPart=ti={}));var ii;(function(Te){function Me(ie){return{kind:"markdownVuln",content:ue.from(ie.value),vulnerabilities:ie.vulnerabilities}}Te.from=Me;function ve(ie){return new v.$GP(ue.to(ie.content),ie.vulnerabilities)}Te.to=ve})(ii||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ii={}));var Vt;(function(Te){function Me(ie){return{kind:"agentDetection",agentId:ie.participant,command:ie.command}}Te.from=Me;function ve(ie){return new v.$HP(ie.agentId,ie.command)}Te.to=ve})(Vt||(e.ChatResponseDetectedParticipantPart=Vt={}));var Ht;(function(Te){function Me(ve){return{kind:"confirmation",title:ve.title,message:ve.message,data:ve.data,buttons:ve.buttons}}Te.from=Me})(Ht||(e.ChatResponseConfirmationPart=Ht={}));var ui;(function(Te){function Me(ie){const{value:Ae,baseUri:Ge}=ie;function it(Je,ft){return Je.map(At=>{const ni=m.URI.joinPath(ft,At.name);return{label:At.name,uri:ni,children:At.children&&it(At.children,ni)}})}return{kind:"treeData",treeData:{label:(0,P.$ah)(Ge),uri:Ge,children:it(Ae,Ge)}}}Te.from=Me;function ve(ie){const Ae=(0,c.$_h)(ie.treeData);function Ge(ft){return ft.map(At=>({name:At.label,children:At.children&&Ge(At.children)}))}const it=Ae.uri,Je=Ae.children?Ge(Ae.children):[];return new v.$JP(Je,it)}Te.to=ve})(ui||(e.ChatResponseFilesPart=ui={}));var Lt;(function(Te){function Me(ie){const Ae=Ge=>m.URI.isUri(Ge);return{kind:"inlineReference",name:ie.title,inlineReference:Ae(ie.value)?ie.value:O.from(ie.value)}}Te.from=Me;function ve(ie){const Ae=(0,c.$_h)(ie);return new v.$KP(m.URI.isUri(Ae.inlineReference)?Ae.inlineReference:O.to(Ae.inlineReference),ie.name)}Te.to=ve})(Lt||(e.ChatResponseAnchorPart=Lt={}));var Pt;(function(Te){function Me(ie){return{kind:"progressMessage",content:ue.from(ie.value)}}Te.from=Me;function ve(ie){return new v.$LP(ie.content.value)}Te.to=ve})(Pt||(e.ChatResponseProgressPart=Pt={}));var bt;(function(Te){function Me(ie){return{kind:"warning",content:ue.from(ie.value)}}Te.from=Me;function ve(ie){return new v.$NP(ie.content.value)}Te.to=ve})(bt||(e.ChatResponseWarningPart=bt={}));var Jt;(function(Te){function Me(ve){return{kind:"progressTask",content:ue.from(ve.value)}}Te.from=Me})(Jt||(e.ChatTask=Jt={}));var Et;(function(Te){function Me(ve){return{kind:"progressTaskResult",content:typeof ve=="string"?ue.from(ve):void 0}}Te.from=Me})(Et||(e.ChatTaskResult=Et={}));var oi;(function(Te){function Me(ie,Ae,Ge){return{kind:"command",command:Ae.toInternal(ie.value,Ge)??{command:ie.value.command,title:ie.value.title}}}Te.from=Me;function ve(ie,Ae){return new v.$OP(Ae.fromInternal(ie.command)??{command:ie.command.id,title:ie.command.title})}Te.to=ve})(oi||(e.ChatResponseCommandButtonPart=oi={}));var Yt;(function(Te){function Me(ie){return{kind:"textEdit",uri:ie.uri,edits:ie.edits.map(Ae=>ae.from(Ae))}}Te.from=Me;function ve(ie){return new v.$QP(m.URI.revive(ie.uri),ie.edits.map(Ae=>ae.to(Ae)))}Te.to=ve})(Yt||(e.ChatResponseTextEditPart=Yt={}));var Ai;(function(Te){function Me(ie){const Ae=w.ThemeIcon.isThemeIcon(ie.iconPath)?ie.iconPath:m.URI.isUri(ie.iconPath)?{light:m.URI.revive(ie.iconPath)}:ie.iconPath&&"light"in ie.iconPath&&"dark"in ie.iconPath&&m.URI.isUri(ie.iconPath.light)&&m.URI.isUri(ie.iconPath.dark)?{light:m.URI.revive(ie.iconPath.light),dark:m.URI.revive(ie.iconPath.dark)}:void 0;return"variableName"in ie.value?{kind:"reference",reference:{variableName:ie.value.variableName,value:m.URI.isUri(ie.value.value)||!ie.value.value?ie.value.value:O.from(ie.value.value)},iconPath:Ae}:{kind:"reference",reference:m.URI.isUri(ie.value)?ie.value:O.from(ie.value),iconPath:Ae}}Te.from=Me;function ve(ie){const Ae=(0,c.$_h)(ie),Ge=it=>m.URI.isUri(it)?it:O.to(it);return new v.$PP("variableName"in Ae.reference?{variableName:Ae.reference.variableName,value:Ae.reference.value&&Ge(Ae.reference.value)}:Ge(Ae.reference))}Te.to=ve})(Ai||(e.ChatResponseReferencePart=Ai={}));var pi;(function(Te){function Me(Ae,Ge,it){return Ae instanceof v.$FP?ti.from(Ae):Ae instanceof v.$KP?Lt.from(Ae):Ae instanceof v.$PP?Ai.from(Ae):Ae instanceof v.$LP?Pt.from(Ae):Ae instanceof v.$JP?ui.from(Ae):Ae instanceof v.$OP?oi.from(Ae,Ge,it):Ae instanceof v.$QP?Yt.from(Ae):Ae instanceof v.$GP?ii.from(Ae):Ae instanceof v.$HP?Vt.from(Ae):Ae instanceof v.$NP?bt.from(Ae):Ae instanceof v.$IP?Ht.from(Ae):{kind:"markdownContent",content:ue.from("")}}Te.from=Me;function ve(Ae,Ge){switch(Ae.kind){case"reference":return Ai.to(Ae);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ie(Ae,Ge)}}Te.to=ve;function ie(Ae,Ge){switch(Ae.kind){case"markdownContent":return ti.to(Ae);case"inlineReference":return Lt.to(Ae);case"progressMessage":return;case"treeData":return ui.to(Ae);case"command":return oi.to(Ae,Ge)}}Te.toContent=ie})(pi||(e.ChatResponsePart=pi={}));var Si;(function(Te){function Me(ve,ie){return{prompt:ve.message,command:ve.command,attempt:ve.attempt??0,enableCommandDetection:ve.enableCommandDetection??!0,references:ve.variables.variables.map(fi.to),location:Bt.to(ve.location),acceptedConfirmationData:ve.acceptedConfirmationData,rejectedConfirmationData:ve.rejectedConfirmationData,location2:ie}}Te.to=Me})(Si||(e.ChatAgentRequest=Si={}));var Bt;(function(Te){function Me(ie){switch(ie){case g.ChatAgentLocation.Notebook:return v.ChatLocation.Notebook;case g.ChatAgentLocation.Terminal:return v.ChatLocation.Terminal;case g.ChatAgentLocation.Panel:return v.ChatLocation.Panel;case g.ChatAgentLocation.Editor:return v.ChatLocation.Editor}}Te.to=Me;function ve(ie){switch(ie){case v.ChatLocation.Notebook:return g.ChatAgentLocation.Notebook;case v.ChatLocation.Terminal:return g.ChatAgentLocation.Terminal;case v.ChatLocation.Panel:return g.ChatAgentLocation.Panel;case v.ChatLocation.Editor:return g.ChatAgentLocation.Editor}}Te.from=ve})(Bt||(e.ChatLocation=Bt={}));var fi;(function(Te){function Me(ve){const ie=ve.value;if(!ie)throw new Error("Invalid value reference");return{id:ve.id,name:ve.name,range:ve.range&&[ve.range.start,ve.range.endExclusive],value:(0,m.$uc)(ie)?m.URI.revive(ie):ie&&typeof ie=="object"&&"uri"in ie&&"range"in ie&&(0,m.$uc)(ie.uri)?O.to((0,c.$_h)(ie)):ie,modelDescription:ve.modelDescription}}Te.to=Me})(fi||(e.ChatAgentValueReference=fi={}));var Oi;(function(Te){function Me(ve,ie,Ae){return{id:ve.id,label:ve.label,fullName:ve.fullName,icon:ve.icon?.id,value:ve.values[0].value,insertText:ve.insertText,detail:ve.detail,documentation:ve.documentation,command:ie.toInternal(ve.command,Ae)}}Te.from=Me})(Oi||(e.ChatAgentCompletionItem=Oi={}));var Ct;(function(Te){function Me(ve){return{errorDetails:ve.errorDetails,metadata:ve.metadata}}Te.to=Me})(Ct||(e.ChatAgentResult=Ct={}));var Di;(function(Te){function Me(ve,ie,Ae){if(ie.action.kind==="vote")return;const Ge=Ct.to(ve);if(ie.action.kind==="command"){const it=ie.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ae.fromInternal(it)??{command:it.id,title:it.title}}},result:Ge}}else return ie.action.kind==="followUp"?{action:{kind:"followUp",followup:Tt.to(ie.action.followup)},result:Ge}:ie.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ie.action.action==="accepted"},result:Ge}:{action:ie.action,result:Ge}}Te.to=Me})(Di||(e.ChatAgentUserActionEvent=Di={}));var Ri;(function(Te){function Me(ve,ie,Ae){return"terminalCommand"in ve?{terminalCommand:ve.terminalCommand,shouldExecute:ve.shouldExecute}:"uri"in ve?{uri:ve.uri}:ie.toInternal(ve,Ae)}Te.from=Me})(Ri||(e.TerminalQuickFix=Ri={}));var bi;(function(Te){function Me(ve){return{kind:Ti.to(ve.kind)}}Te.to=Me})(bi||(e.PartialAcceptInfo=bi={}));var Ti;(function(Te){function Me(ve){switch(ve){case s.PartialAcceptTriggerKind.Word:return v.PartialAcceptTriggerKind.Word;case s.PartialAcceptTriggerKind.Line:return v.PartialAcceptTriggerKind.Line;case s.PartialAcceptTriggerKind.Suggest:return v.PartialAcceptTriggerKind.Suggest;default:return v.PartialAcceptTriggerKind.Unknown}}Te.to=Me})(Ti||(e.PartialAcceptTriggerKind=Ti={}));var Ni;(function(Te){function Me(ve,ie){return{id:ie,label:ve.label,description:ve.description,canEdit:ve.canEdit,collapsibleState:ve.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:ve.contextValue}}Te.from=Me})(Ni||(e.DebugTreeItem=Ni={}));var Ft;(function(Te){function Me(ve){return{name:ve.name,description:ve.description,parametersSchema:ve.parametersSchema}}Te.to=Me})(Ft||(e.LanguageModelToolDescription=Ft={}))}),define(Se[294],De([1,0,6,19,15,53]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=void 0;let L=class{constructor(b,c){this.a=b.getProxy(r.$DN.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>c.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,c,I){const S=new R.$Uw(C.WorkspaceEdit.from(b,this.b));return this.a.$tryApplyWorkspaceEdit(S,void 0,I?.isRefactoring??!1)}};e.$0oc=L,e.$0oc=L=Ye([Ve(0,h.$cQ)],L)}),define(Se[295],De([1,0,18,7,52,4,39,3,51,42,17,2,23,6,15,9,153,257,25]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$oc=void 0,w=Ue(w),a=Ue(a);class i{constructor(n,d,l,g,E){this.j=n,this.k=d,this.l=l,this.m=g,this.n=E,this.b=c.$de.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let d=function(g){if(n.c){const E=new Error("Response stream has been closed");throw Error.captureStackTrace(E,g),E}};const n=this;this.b.reset();const l=(g,E)=>{if(typeof this.d>"u"&&"content"in g&&(this.d=this.b.elapsed()),E){const D=this.l.$handleProgressChunk(this.k.requestId,g),y={report:k=>{D?.then(A=>{A&&(a.$0N.isMarkdownString(k.value)?this.l.$handleProgressChunk(this.k.requestId,w.ChatResponseWarningPart.from(k),A):this.l.$handleProgressChunk(this.k.requestId,w.ChatResponseReferencePart.from(k),A))})}};Promise.all([D,E?.(y)]).then(([k,A])=>{k!==void 0&&A!==void 0&&this.l.$handleProgressChunk(this.k.requestId,w.ChatTaskResult.from(A),k)})}else this.l.$handleProgressChunk(this.k.requestId,g)};this.g={markdown(g){d(this.markdown);const E=new a.$FP(g),D=w.ChatResponseMarkdownPart.from(E);return l(D),this},markdownWithVulnerabilities(g,E){d(this.markdown),E&&(0,f.$dH)(n.j,"chatParticipantAdditions");const D=new a.$GP(g,E),y=w.ChatResponseMarkdownWithVulnerabilitiesPart.from(D);return l(y),this},filetree(g,E){d(this.filetree);const D=new a.$JP(g,E),y=w.ChatResponseFilesPart.from(D);return l(y),this},anchor(g,E){d(this.anchor);const D=new a.$KP(g,E),y=w.ChatResponseAnchorPart.from(D);return l(y),this},button(g){d(this.anchor);const E=new a.$OP(g),D=w.ChatResponseCommandButtonPart.from(E,n.m,n.n);return l(D),this},progress(g,E){d(this.progress);const D=new a.$MP(g,E),y=E?w.ChatTask.from(D):w.ChatResponseProgressPart.from(D);return l(y,E),this},warning(g){d(this.progress),(0,f.$dH)(n.j,"chatParticipantAdditions");const E=new a.$NP(g),D=w.ChatResponseWarningPart.from(E);return l(D),this},reference(g,E){if(d(this.reference),"variableName"in g&&(0,f.$dH)(n.j,"chatParticipantAdditions"),"variableName"in g&&!g.value){const D=n.k.variables.variables.find(y=>y.name===g.variableName);if(D){let y;if(D.references?.length)y=D.references.map(k=>({kind:"reference",reference:{variableName:g.variableName,value:k.reference}}));else{const k=new a.$PP(g,E);y=[w.ChatResponseReferencePart.from(k)]}return y.forEach(k=>l(k)),this}}else{const D=new a.$PP(g,E),y=w.ChatResponseReferencePart.from(D);l(y)}return this},textEdit(g,E){d(this.textEdit),(0,f.$dH)(n.j,"chatParticipantAdditions");const D=new a.$QP(g,E),y=w.ChatResponseTextEditPart.from(D);return l(y),this},detectedParticipant(g,E){d(this.detectedParticipant),(0,f.$dH)(n.j,"chatParticipantAdditions");const D=new a.$HP(g,E),y=w.ChatResponseDetectedParticipantPart.from(D);return l(y),this},confirmation(g,E,D,y){d(this.confirmation),(0,f.$dH)(n.j,"chatParticipantAdditions");const k=new a.$IP(g,E,D,y),A=w.ChatResponseConfirmationPart.from(k);return l(A),this},push(g){if(d(this.push),(g instanceof a.$QP||g instanceof a.$GP||g instanceof a.$HP||g instanceof a.$NP||g instanceof a.$IP)&&(0,f.$dH)(n.j,"chatParticipantAdditions"),g instanceof a.$PP)this.reference(g.value,g.iconPath);else{const E=w.ChatResponsePart.from(g,n.m,n.n);l(E)}return this}}}return this.g}}class s extends T.$Tc{static{this.b=0}constructor(n,d,l,g){super(),this.n=d,this.s=l,this.t=g,this.c=new Map,this.j=this.B(new T.$3c),this.m=this.B(new T.$3c),this.g=n.getProxy(P.$DN.MainThreadChatAgents2)}transferActiveChat(n){this.g.$transferActiveChatSession(n)}createChatAgent(n,d,l){const g=s.b++,E=new t(n,d,this.g,g,l);return this.c.set(g,E),this.g.$registerAgent(g,n.identifier,d,{},void 0),E.apiAgent}createDynamicChatAgent(n,d,l,g){const E=s.b++,D=new t(n,d,this.g,E,g);return this.c.set(E,D),this.g.$registerAgent(E,n.identifier,d,{isSticky:!0},l),D.apiAgent}async $invokeAgent(n,d,l,g){const E=this.c.get(n);if(!E)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);const D=(0,b.$_h)(d);let y=this.j.get(D.sessionId);y||(y=new T.$Sc,this.j.set(D.sessionId,y));const k=new i(E.extension,D,this.g,this.s.converter,y);try{const A=await this.u(D.agentId,l);let p;if(D.locationData?.type===m.ChatAgentLocation.Editor){const F=this.t.getDocument(D.locationData.document);p=new a.$TP(F,w.Selection.to(D.locationData.selection),w.Range.to(D.locationData.wholeRange))}else if(D.locationData?.type===m.ChatAgentLocation.Notebook){const F=this.t.getDocument(D.locationData.sessionInputUri);p=new a.$UP(F)}else D.locationData?.type,m.ChatAgentLocation.Terminal;const v=E.invoke(w.ChatAgentRequest.to(D,p),{history:A},k.apiObject,g);return await(0,h.$qh)(Promise.resolve(v).then(F=>{if(F?.metadata)try{JSON.stringify(F.metadata)}catch(O){const j=`result.metadata MUST be JSON.stringify-able. Got error: ${O.message}`;return this.n.error(`[${E.extension.identifier.value}] [@${E.id}] ${j}`,E.extension),{errorDetails:{message:j},timings:k.timings}}let N;return F?.errorDetails&&(N={...F.errorDetails,responseIsIncomplete:!0}),N?.responseIsRedacted&&(0,f.$dH)(E.extension,"chatParticipantPrivate"),{errorDetails:N,timings:k.timings,metadata:F?.metadata}}),g)}catch(A){return this.n.error(A,E.extension),A instanceof a.$3P&&A.cause&&(A=A.cause),{errorDetails:{message:(0,C.$nj)(A),responseIsIncomplete:!0}}}finally{k.close()}}async u(n,d){const l=[];for(const g of d.history){const E=w.ChatAgentResult.to(g.result),D=n===g.request.agentId?E:{...E,metadata:void 0};l.push(new a.$RP(g.request.message,g.request.command,g.request.variables.variables.map(w.ChatAgentValueReference.to),g.request.agentId));const y=(0,r.$Gb)(g.response.map(k=>w.ChatResponsePart.toContent(k,this.s.converter)));l.push(new a.$SP(y,D,g.request.agentId,g.request.command))}return l}$releaseSession(n){this.j.deleteAndDispose(n)}async $provideFollowups(n,d,l,g,E){const D=this.c.get(d);if(!D)return Promise.resolve([]);const y=(0,b.$_h)(n),k=await this.u(D.id,g),A=w.ChatAgentResult.to(l);return(await D.provideFollowups(A,{history:k},E)).filter(p=>{const v=!p.participant||L.Iterable.some(this.c.values(),F=>F.id===p.participant&&u.$on.equals(F.extension.identifier,D.extension.identifier));return v||this.n.warn(`[@${D.id}] ChatFollowup refers to an unknown participant: ${p.participant}`),v}).map(p=>w.ChatFollowup.from(p,y))}$acceptFeedback(n,d,l,g){const E=this.c.get(n);if(!E)return;const D=w.ChatAgentResult.to(d);let y;switch(l){case $.ChatAgentVoteDirection.Down:y=a.ChatResultFeedbackKind.Unhelpful;break;case $.ChatAgentVoteDirection.Up:y=a.ChatResultFeedbackKind.Helpful;break}E.acceptFeedback(Object.freeze(g?{result:D,kind:y,reportIssue:g}:{result:D,kind:y}))}$acceptAction(n,d,l){const g=this.c.get(n);if(!g||l.action.kind==="vote")return;const E=w.ChatAgentUserActionEvent.to(d,l,this.s.converter);E&&g.acceptAction(Object.freeze(E))}async $invokeCompletionProvider(n,d,l){const g=this.c.get(n);if(!g)return[];let E=this.m.get(n);return E?E.clear():(E=new T.$Sc,this.m.set(n,E)),(await g.invokeCompletionProvider(d,l)).map(y=>w.ChatAgentCompletionItem.from(y,this.s.converter,E))}async $provideWelcomeMessage(n,d,l){const g=this.c.get(n);if(g)return await g.provideWelcomeMessage(w.ChatLocation.to(d),l)}async $provideSampleQuestions(n,d,l){const g=this.c.get(n);if(g)return(await g.provideSampleQuestions(w.ChatLocation.to(d),l)).map(E=>w.ChatFollowup.from(E,void 0))}}e.$$oc=s;class t{constructor(n,d,l,g,E){this.extension=n,this.id=d,this.w=l,this.x=g,this.y=E,this.m=new R.$je,this.n=new R.$je}acceptFeedback(n){this.m.fire(n)}acceptAction(n){this.n.fire(n)}async invokeCompletionProvider(n,d){return this.q?await this.q.provider.provideCompletionItems(n,d)??[]:[]}async provideFollowups(n,d,l){if(!this.b)return[];const g=await this.b.provideFollowups(n,d,l);return g?g.filter(E=>!(E&&"commandId"in E)).filter(E=>!(E&&"message"in E)):[]}async provideWelcomeMessage(n,d){if(!this.s)return[];const l=await this.s.provideWelcomeMessage(n,d);return l?l.map(g=>typeof g=="string"?g:w.MarkdownString.from(g)):[]}async provideSampleQuestions(n,d){if(!this.s||!this.s.provideSampleQuestions)return[];const l=await this.s.provideSampleQuestions(n,d);return l||[]}get apiAgent(){let n=!1,d=!1;const l=()=>{n||d||(d=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof S.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof a.$EO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:w.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:w.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:w.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),d=!1}))},g=this;return{get id(){return g.id},get iconPath(){return g.c},set iconPath(E){g.c=E,l()},get requestHandler(){return g.y},set requestHandler(E){(0,I.$mg)(typeof E=="function","Invalid request handler"),g.y=E},get followupProvider(){return g.b},set followupProvider(E){g.b=E,l()},get isDefault(){return(0,f.$dH)(g.extension,"defaultChatParticipant"),g.d},set isDefault(E){(0,f.$dH)(g.extension,"defaultChatParticipant"),g.d=E,l()},get helpTextPrefix(){return(0,f.$dH)(g.extension,"defaultChatParticipant"),g.g},set helpTextPrefix(E){(0,f.$dH)(g.extension,"defaultChatParticipant"),g.g=E,l()},get helpTextVariablesPrefix(){return(0,f.$dH)(g.extension,"defaultChatParticipant"),g.j},set helpTextVariablesPrefix(E){(0,f.$dH)(g.extension,"defaultChatParticipant"),g.j=E,l()},get helpTextPostfix(){return(0,f.$dH)(g.extension,"defaultChatParticipant"),g.k},set helpTextPostfix(E){(0,f.$dH)(g.extension,"defaultChatParticipant"),g.k=E,l()},get isSecondary(){return(0,f.$dH)(g.extension,"defaultChatParticipant"),g.l},set isSecondary(E){(0,f.$dH)(g.extension,"defaultChatParticipant"),g.l=E,l()},get supportIssueReporting(){return(0,f.$dH)(g.extension,"chatParticipantPrivate"),g.o},set supportIssueReporting(E){(0,f.$dH)(g.extension,"chatParticipantPrivate"),g.o=E,l()},get onDidReceiveFeedback(){return g.m.event},set participantVariableProvider(E){if((0,f.$dH)(g.extension,"chatParticipantAdditions"),g.q=E,E){if(!E.triggerCharacters.length)throw new Error("triggerCharacters are required");g.w.$registerAgentCompletionsProvider(g.x,g.id,E.triggerCharacters)}else g.w.$unregisterAgentCompletionsProvider(g.x,g.id)},get participantVariableProvider(){return(0,f.$dH)(g.extension,"chatParticipantAdditions"),g.q},set welcomeMessageProvider(E){(0,f.$dH)(g.extension,"defaultChatParticipant"),g.s=E,l()},get welcomeMessageProvider(){return(0,f.$dH)(g.extension,"defaultChatParticipant"),g.s},onDidPerformAction:(0,f.$cH)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(E){g.t=E,l()},get requester(){return g.t},set supportsSlowReferences(E){(0,f.$dH)(g.extension,"chatParticipantPrivate"),g.u=E,l()},get supportsSlowReferences(){return(0,f.$dH)(g.extension,"chatParticipantPrivate"),g.u},dispose(){n=!0,g.b=void 0,g.m.dispose(),g.w.$unregisterAgent(g.x)}}}invoke(n,d,l,g){return this.y(n,d,l,g)}}}),define(Se[296],De([1,0,13,3,50,6,15,9,25]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=void 0,L=Ue(L),T=Ue(T);class c{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(R.$DN.MainThreadChatVariables)}async $resolveVariable(u,P,w,a){const m=this.b.get(u);if(m)try{if(m.resolver.resolve2){(0,b.$dH)(m.extension,"chatParticipantAdditions");const $=new I(P,this.c),f=await m.resolver.resolve2(m.data.name,{prompt:w},$.apiObject,a);if(f&&f[0])return f[0].value}else{const $=await m.resolver.resolve(m.data.name,{prompt:w},a);if($&&$[0])return $[0].value}}catch($){(0,r.$Z)($)}}registerVariableResolver(u,P,w,a,m,$,f,i,s){const t=c.a++,o=s?C.ThemeIcon.fromId(s):void 0;return this.b.set(t,{extension:u,data:{id:P,name:w,description:a,modelDescription:m,icon:o},resolver:f}),this.c.$registerVariable(t,{id:P,name:w,description:a,modelDescription:m,isSlow:$,fullName:i,icon:o}),(0,h.$Rc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$_oc=c;class I{constructor(u,P){this.c=u,this.d=P,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let P=function(a){if(u.a){const m=new Error("Response stream has been closed");throw Error.captureStackTrace(m,a),m}};const u=this,w=a=>{this.d.$handleProgressChunk(this.c,a)};this.b={progress(a){P(this.progress);const m=new T.$LP(a),$=L.ChatResponseProgressPart.from(m);return w($),this},reference(a){P(this.reference);const m=new T.$PP(a),$=L.ChatResponseReferencePart.from(m);return w($),this},push(a){return P(this.push),a instanceof T.$PP?w(L.ChatResponseReferencePart.from(a)):a instanceof T.$LP&&w(L.ChatResponseProgressPart.from(a)),this}}}return this.b}}}),define(Se[297],De([1,0,7,59,4,3,40,2,87,23,15,9,6,25]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=w,b=Ue(b),I=Ue(I),S=Ue(S);function w(a,m,$){const f=a.getProxy(u.$DN.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new c.$qn,m.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===L.MarshalledId.CommentController){const k=this.b.get(y.handle);return k?k.value:y}else if(y&&y.$mid===L.MarshalledId.CommentThread){const k=y,A=this.b.get(k.commentControlHandle);if(!A)return k;const p=A.getCommentThread(k.commentThreadHandle);return p?p.value:k}else if(y&&(y.$mid===L.MarshalledId.CommentThreadReply||y.$mid===L.MarshalledId.CommentThreadInstance)){const k=this.b.get(y.thread.commentControlHandle);if(!k)return y;const A=k.getCommentThread(y.thread.commentThreadHandle);return A?y.$mid===L.MarshalledId.CommentThreadInstance?A.value:{thread:A.value,text:y.text}:y}else if(y&&y.$mid===L.MarshalledId.CommentNode){const k=this.b.get(y.thread.commentControlHandle);if(!k)return y;const A=k.getCommentThread(y.thread.commentThreadHandle);if(!A)return y;const p=y.commentUniqueId,v=A.getCommentByUniqueId(p);return v||y}else if(y&&y.$mid===L.MarshalledId.CommentThreadNode){const k=this.b.get(y.thread.commentControlHandle);if(!k)return y;const A=k.getCommentThread(y.thread.commentThreadHandle);if(!A)return y;const p=y.text,v=y.commentUniqueId,F=A.getCommentByUniqueId(v);return F?(typeof F.body=="string"?F.body=p:F.body=new S.$0N(p),F):y}return y}})}createCommentController(y,k,A){const p=i.a++,v=new t(y,p,k,A);this.b.set(v.handle,v);const F=this.c.get(y.identifier)||[];return F.push(v),this.c.set(y.identifier,F),v.value}async $createCommentThreadTemplate(y,k,A,p){const v=this.b.get(y);v&&v.$createCommentThreadTemplate(k,A,p)}async $setActiveComment(y,k){const A=this.b.get(y);A&&A.$setActiveComment(k??void 0)}async $updateCommentThreadTemplate(y,k,A){const p=this.b.get(y);p&&p.$updateCommentThreadTemplate(k,A)}$deleteCommentThread(y,k){this.b.get(y)?.$deleteCommentThread(k)}async $provideCommentingRanges(y,k,A){const p=this.b.get(y);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const v=await $.ensureDocumentData(T.URI.revive(k));return(0,r.$uh)(async()=>{const F=await p.commentingRangeProvider.provideCommentingRanges(v.document,A);let N;return Array.isArray(F)?N={ranges:F,fileComments:!1}:F?N={ranges:F.ranges||[],fileComments:F.enableFileComments||!1}:N=F??void 0,N}).then(F=>{let N;return F&&(N={ranges:F.ranges.map(O=>I.Range.from(O)),fileComments:F.fileComments}),N})}$toggleReaction(y,k,A,p,v){const F=this.b.get(y);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,r.$uh)(()=>{const N=F.getCommentThread(k);if(N){const O=N.getCommentByUniqueId(p.uniqueIdInThread);if(F!==void 0&&O&&F.reactionHandler)return F.reactionHandler(O,d(v))}return Promise.resolve(void 0)})}}class s{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,typeof y=="object"?((0,P.$dH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=y.resolved,this.b.applicability=y.applicability):this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,k,A,p,v,F,N,O,j){this.m=k,this.n=A,this.o=p,this.p=v,this.q=F,this.extensionDescription=N,this.r=O,this.handle=s.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$je,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Uc,this.l.value=new R.$Sc,this.n===void 0&&(this.n=`${y}.${this.handle}`),f.$createCommentThread(k,this.handle,this.n,this.o,I.Range.from(this.p),this.q.map(M=>o(this,M,this.k,this.extensionDescription)),N.identifier,this.r,j),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{f.$deleteCommentThread(k,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(M){z.range=M},get comments(){return z.comments},set comments(M){z.comments=M},get collapsibleState(){return z.collapsibleState},set collapsibleState(M){z.collapsibleState=M},get canReply(){return z.canReply},set canReply(M){z.canReply=M},get contextValue(){return z.contextValue},set contextValue(M){z.contextValue=M},get label(){return z.label},set label(M){z.label=M},get state(){return z.state},set state(M){z.state=M},reveal:(M,W)=>z.reveal(M,W),hide:()=>z.hide(),dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Sc);const y=A=>Object.prototype.hasOwnProperty.call(this.b,A),k={};y("range")&&(k.range=I.Range.from(this.p)),y("label")&&(k.label=this.label),y("contextValue")&&(k.contextValue=this.contextValue??null),y("comments")&&(k.comments=this.q.map(A=>o(this,A,this.k,this.extensionDescription))),y("collapsibleState")&&(k.collapseState=l(this.g)),y("canReply")&&(k.canReply=this.canReply),y("state")&&(k.state=g(this.h)),y("applicability")&&(k.applicability=E(this.h)),y("isTemplate")&&(k.isTemplate=this.r),this.b={},f.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(y){for(const k of this.k){const A=k[0],p=k[1];if(y===p)return A}}async reveal(y,k){(0,P.$dH)(this.extensionDescription,"commentReveal");let A;y&&y.body!==void 0?A=y:k=k??y;let p=A?this.k.get(A):void 0;p??=this.k.get(this.q[0]);let v=!0,F=!1;return k?.focus===S.CommentThreadFocus.Reply?(F=!0,v=!1):k?.focus===S.CommentThreadFocus.Comment&&(v=!1),f.$revealCommentThread(this.m,this.handle,p,{preserveFocus:v,focusReply:F})}async hide(){return f.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}Ye([(0,h.$8h)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,y?.resourceHints&&(0,P.$dH)(this.h,"commentingRangeHint"),f.$updateCommentingRanges(this.handle,y?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,f.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,P.$dH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,P.$dH)(this.h,"activeComment"),this.f}constructor(y,k,A,p){this.h=y,this.i=k,this.j=A,this.k=p,this.a=new Map,f.$registerCommentController(this.handle,A,p,this.h.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(F){v.options=F},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(F){v.commentingRangeProvider=F},get reactionHandler(){return v.reactionHandler},set reactionHandler(F){v.reactionHandler=F},get activeCommentThread(){return v.activeCommentThread},createCommentThread(F,N,O){return v.createCommentThread(F,N,O).value},dispose:()=>{v.dispose()}}),this.g=[],this.g.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}createCommentThread(y,k,A){k===void 0&&(0,P.$dH)(this.h,"fileComments");const p=new s(this.id,this.handle,void 0,y,k,A,this.h,!1);return this.a.set(p.handle,p),p}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const k=this.a.get(y.commentThreadHandle);k&&(this.e=y.uniqueIdInThread?k.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=k)}$createCommentThreadTemplate(y,k,A){const p=new s(this.id,this.handle,void 0,T.URI.revive(y),I.Range.to(k),[],this.h,!0,A);return p.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(p.handle,p),p}$updateCommentThreadTemplate(y,k){const A=this.a.get(y);A&&(A.range=I.Range.to(k))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function o(D,y,k,A){let p=k.get(y);return p||(p=++D.commentHandle,k.set(y,p)),y.state!==void 0&&(0,P.$dH)(A,"commentsDraftState"),y.reactions?.some(v=>v.reactors!==void 0)&&(0,P.$dH)(A,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:p,body:typeof y.body=="string"?y.body:I.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(v=>n(v)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function n(D){return{label:D.label,iconPath:D.iconPath?I.$bQ(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(y=>y.name):D.reactors}}function d(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?T.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(y=>({name:y}))}}function l(D){if(D!==void 0)switch(D){case S.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case S.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function g(D){let y;if(typeof D=="object"?y=D.resolved:y=D,y!==void 0)switch(y){case S.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case S.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function E(D){let y;if(typeof D=="object"&&(y=D.applicability),y!==void 0)switch(y){case S.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case S.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new i}}),define(Se[298],De([1,0,20,60,3,14,22,2,15,96,118,6,9]),function($e,e,r,h,C,R,L,T,b,c,I,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vpc=void 0,b=Ue(b),S=Ue(S),u=Ue(u);class P{constructor(n,d){this.document=n,this.b=d,this.a=1,this.c=new I.$Voc("custom documents")}addEdit(n){return this.c.add([n])}async undo(n,d){await this.f(n).undo(),d||this.disposeBackup()}async redo(n,d){await this.f(n).redo(),d||this.disposeBackup()}disposeEdits(n){for(const d of n)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const n=t(this.document.uri)+this.a++;return(0,L.$dh)(this.b,n)}updateBackup(n){this.d?.delete(),this.d=n}disposeBackup(){this.d?.delete(),this.d=void 0}f(n){const d=this.c.get(n,0);if(!d)throw new Error("No edit found");return d}}class w{constructor(){this.a=new Map}get(n,d){return this.a.get(this.b(n,d))}add(n,d,l){const g=this.b(n,d.uri);if(this.a.has(g))throw new Error(`Document already exists for viewType:${n} resource:${d.uri}`);const E=new P(d,l);return this.a.set(g,E),E}delete(n,d){const l=this.b(n,d.uri);this.a.delete(l)}b(n,d){return`${n}@@@${d}`}}var a;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(a||(a={}));class m{constructor(){this.a=new Map}addTextProvider(n,d,l){return this.b(n,{type:a.Text,extension:d,provider:l})}addCustomProvider(n,d,l){return this.b(n,{type:a.Custom,extension:d,provider:l})}get(n){return this.a.get(n)}b(n,d){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,d),new u.$FN(()=>this.a.delete(n))}}class ${constructor(n,d,l,g,E){this.d=d,this.f=l,this.g=g,this.h=E,this.b=new m,this.c=new w,this.a=n.getProxy(S.$DN.MainThreadCustomEditors)}registerCustomEditorProvider(n,d,l,g){const E=new C.$Sc;return i(l)?(E.add(this.b.addTextProvider(d,n,l)),this.a.$registerTextEditorProvider((0,c.$spc)(n),d,g.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,c.$qpc)(n))):(E.add(this.b.addCustomProvider(d,n,l)),f(l)&&E.add(l.onDidChangeCustomDocument(D=>{const y=this.i(d,D.document.uri);if(s(D)){const k=y.addEdit(D);this.a.$onDidEdit(D.document.uri,d,k,D.label)}else this.a.$onContentChange(D.document.uri,d)})),this.a.$registerCustomEditorProvider((0,c.$spc)(n),d,g.webviewOptions||{},!!g.supportsMultipleEditorsPerDocument,(0,c.$qpc)(n))),u.$FN.from(E,new u.$FN(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(n,d,l,g,E){const D=this.b.get(d);if(!D)throw new Error(`No provider found for '${d}'`);if(D.type!==a.Custom)throw new Error(`Invalid provide type for '${d}'`);const y=T.URI.revive(n),k=await D.provider.openCustomDocument(y,{backupId:l,untitledDocumentData:g?.buffer},E);let A;return f(D.provider)&&this.f&&(A=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(d,k,A),{editable:f(D.provider)}}async $disposeCustomDocument(n,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==a.Custom)throw new Error(`Invalid provider type for '${d}'`);const g=T.URI.revive(n),{document:E}=this.i(d,g);this.c.delete(d,E),E.dispose()}async $resolveCustomEditor(n,d,l,g,E,D){const y=this.b.get(l);if(!y)throw new Error(`No provider found for '${l}'`);const k=b.ViewColumn.to(E),A=this.g.createNewWebview(d,g.contentOptions,y.extension),p=this.h.createNewWebviewPanel(d,l,g.title,k,g.options,A,g.active),v=T.URI.revive(n);switch(y.type){case a.Custom:{const{document:F}=this.i(l,v);return y.provider.resolveCustomEditor(F,p,D)}case a.Text:{const F=this.d.getDocument(v);return y.provider.resolveCustomTextEditor(F,p,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,d,l){this.i(d,n).disposeEdits(l)}async $onMoveCustomEditor(n,d,l){const g=this.b.get(l);if(!g)throw new Error(`No provider found for '${l}'`);if(!g.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const E=this.h.getWebviewPanel(n);if(!E)throw new Error("No webview found");const D=T.URI.revive(d),y=this.d.getDocument(D);await g.provider.moveCustomTextEditor(y,E,r.CancellationToken.None)}async $undo(n,d,l,g){return this.i(d,n).undo(l,g)}async $redo(n,d,l,g){return this.i(d,n).redo(l,g)}async $revert(n,d,l){const g=this.i(d,n);await this.j(d).revertCustomDocument(g.document,l),g.disposeBackup()}async $onSave(n,d,l){const g=this.i(d,n);await this.j(d).saveCustomDocument(g.document,l),g.disposeBackup()}async $onSaveAs(n,d,l,g){const E=this.i(d,n);return this.j(d).saveCustomDocumentAs(E.document,T.URI.revive(l),g)}async $backup(n,d,l){const g=this.i(d,n),D=await this.j(d).backupCustomDocument(g.document,{destination:g.getNewBackupUri()},l);return g.updateBackup(D),D.id}i(n,d){const l=this.c.get(n,T.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(n){const l=this.b.get(n)?.provider;if(!l||!f(l))throw new Error("Custom document is not editable");return l}}e.$vpc=$;function f(o){return!!o.onDidChangeCustomDocument}function i(o){return typeof o.resolveCustomTextEditor=="function"}function s(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function t(o){const n=o.scheme===R.Schemas.file||o.scheme===R.Schemas.untitled?o.fsPath:o.toString();return(0,h.$qj)(n)+""}}),define(Se[299],De([1,0,8,145,2,6,9,15,4,11,28,62]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$4oc=e.$3oc=void 0,T=Ue(T);class P{#e;#t;#i;constructor(m,$,f,i,s,t,o,n){this.d=m,this.e=$,this.f=f,this.g=i,this.h=s,this.c=!1,this.f=Math.max(i,f),this.#i=new I.$zc(d=>t.getComparisonKey(d)),this.#e=o,this.#t=n}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,$){if(!m){this.clear();return}this.j();let f=[];if(C.URI.isUri(m)){if(!$){this.delete(m);return}this.#i.set(m,$.slice()),f=[m]}else if(Array.isArray(m)){f=[];let t;m=[...m].sort(P.k);for(const o of m){const[n,d]=o;if((!t||n.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=n,f.push(n),this.#i.set(n,[])),d)this.#i.get(n)?.push(...d);else{const l=this.#i.get(n);l&&(l.length=0)}}}if(this.#t.fire(f),!this.#e)return;const i=[];let s=0;for(const t of f){let o=[];const n=this.#i.get(t);if(n)if(n.length>this.g){o=[];const d=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const g of n)if(g.severity===d[l]&&o.push({...T.Diagnostic.from(g),modelVersionId:this.h(t)})===this.g)break e;o.push({severity:h.MarkerSeverity.Info,message:(0,r.localize)(10745,null,n.length-this.g),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=n.map(d=>({...T.Diagnostic.from(d),modelVersionId:this.h(t)}));if(i.push([t,o]),s+=o.length,s>this.f)break}this.#e.$changeMany(this.e,i)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,$){this.j();for(const[f,i]of this)m.call($,f,i,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const $=this.#i.get(m);return Array.isArray($)?Object.freeze($.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,$){return m[0].toString()<$[0].toString()?-1:m[0].toString()>$[0].toString()?1:0}}e.$3oc=P;let w=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(m){const $=new I.$zc;for(const f of m)$.set(f,f);return{uris:Object.freeze(Array.from($.values()))}}constructor(m,$,f,i){this.j=$,this.k=f,this.l=i,this.g=new Map,this.h=new b.$ne({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this.h.event,u._mapper),this.f=m.getProxy(R.$DN.MainThreadDiagnostics)}createDiagnosticCollection(m,$){const{g:f,f:i,h:s,j:t,k:o,l:n}=this,d=new class{$changeMany(E,D){i.$changeMany(E,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,E,D.length===0?"CLEARING":D)}$clear(E){i.$clear(E),t.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,E)}dispose(){i.dispose()}};let l;if(!$)$="_generated_diagnostic_collection_name_#"+u.c++,l=$;else if(!f.has($))l=$;else{this.j.warn(`DiagnosticCollection with name '${$}' does already exist.`);do l=$+u.c++;while(f.has(l))}return new class extends P{constructor(){super($,l,u.e,u.d,E=>n.getDocument(E)?.version,o.extUri,d,s),f.set(l,this)}dispose(){super.dispose(),f.delete(l)}}}getDiagnostics(m){if(m)return this.m(m);{const $=new Map,f=[];for(const i of this.g.values())i.forEach((s,t)=>{let o=$.get(s.toString());typeof o>"u"&&(o=f.length,$.set(s.toString(),o),f.push([s,[]])),f[o][1]=f[o][1].concat(...t)});return f}}m(m){let $=[];for(const f of this.g.values())f.has(m)&&($=$.concat(f.get(m)));return $}$acceptMarkersChange(m){if(!this.n){const $="_generated_mirror",f=new P($,$,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set($,f),this.n=f}for(const[$,f]of m)this.n.set(C.URI.revive($),f.map(T.Diagnostic.to))}};e.$4oc=w,e.$4oc=w=u=Ye([Ve(1,c.$0j),Ve(2,S.$2oc)],w)}),define(Se[300],De([1,0,2,13,9,15,80,53]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eqc=void 0;class b{constructor(I,S,u,P={timeout:1500,errors:3}){this.c=I,this.d=S,this.f=u,this.g=P,this.a=new L.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(S,u,P)=>{const a={dispose:this.a.push([S,u,I])};return Array.isArray(P)&&P.push(a),a}}async $participateInSave(I,S){const u=r.URI.revive(I);let P=!1;const w=setTimeout(()=>P=!0,this.g.timeout),a=[];try{for(const m of[...this.a]){if(P)break;const $=this.d.getDocument(u),f=await this.h(m,{document:$,reason:R.TextDocumentSaveReason.to(S)});a.push(f)}}finally{clearTimeout(w)}return a}h([I,S,u],P){const w=this.b.get(I);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(u,I,S,P).then(()=>!0,a=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const m=this.b.get(I);this.b.set(I,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,S,u,P){const w=[],a=Date.now(),{document:m,reason:$}=P,{version:f}=m,i=Object.freeze({document:m,reason:$,waitUntil(s){if(Object.isFrozen(w))throw(0,h.$7)("waitUntil can not be called async");w.push(Promise.resolve(s))}});try{S.apply(u,[i])}catch(s){return Promise.reject(s)}return Object.freeze(w),new Promise((s,t)=>{const o=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(w).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(o),s(n)}).catch(n=>{clearTimeout(o),t(n)})}).then(s=>{const t={edits:[]};for(const o of s)if(Array.isArray(o)&&o.every(n=>n instanceof C.$ON))for(const{newText:n,newEol:d,range:l}of o)t.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:l&&R.Range.from(l),text:n,eol:d&&R.EndOfLine.from(d)}});if(t.edits.length!==0)return f===m.version?this.f.$tryApplyWorkspaceEdit(new T.$Uw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$eqc=b}),define(Se[301],De([1,0,4,3,2,6,164,15,17,24,9]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5oc=void 0,T=Ue(T);class S{constructor(P,w){this.a=new r.$je,this.b=new r.$je,this.c=new r.$je,this.d=new r.$je,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new h.$Sc,this.h=new Map,this.f=P.getProxy(R.$DN.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(a=>{for(const m of a)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const m of a)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(P){if(!P)return;const w=this.g.getDocument(P);if(w)return w}getDocument(P){const w=this.getDocumentData(P);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${P}'`);return w.document}ensureDocumentData(P){const w=this.g.getDocument(P);if(w)return Promise.resolve(w);let a=this.h.get(P.toString());return a||(a=this.f.$tryOpenDocument(P).then(m=>{this.h.delete(P.toString());const $=C.URI.revive(m);return(0,b.$ng)(this.g.getDocument($))},m=>(this.h.delete(P.toString()),Promise.reject(m))),this.h.set(P.toString(),a)),a}createDocumentData(P){return this.f.$tryCreateDocument(P).then(w=>C.URI.revive(w))}$acceptModelLanguageChanged(P,w){const a=C.URI.revive(P),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(w),this.a.fire(m.document)}$acceptModelSaved(P){const w=C.URI.revive(P),a=this.g.getDocument(w);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(P,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(P,w){const a=C.URI.revive(P),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");m._acceptIsDirty(w),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(P,w,a){const m=C.URI.revive(P),$=this.g.getDocument(m);if(!$)throw new Error("unknown document");$._acceptIsDirty(a),$.onEvents(w);let f;w.isUndoing?f=I.TextDocumentChangeReason.Undo:w.isRedoing&&(f=I.TextDocumentChangeReason.Redo),this.c.fire((0,c.$co)({document:$.document,contentChanges:w.changes.map(i=>({range:T.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:f}))}setWordDefinitionFor(P,w){(0,L.$eQ)(P,w)}}e.$5oc=S}),define(Se[77],De([1,0,78,4,17,2,5,6,19,15,9]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xpc=e.$wpc=void 0,c=Ue(c),e.$wpc=(0,L.$Ci)("IExtHostEditorTabs");class S{constructor(m,$,f){this.e=f,this.d=$,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,$={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze($)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new I.$tP(R.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new I.$uP(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new I.$vP(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new I.$wP(R.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new I.$xP(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new I.$yP(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new I.$zP(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new I.$AP;case T.TabInputKind.InteractiveEditorInput:return new I.$BP(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new I.$CP;case T.TabInputKind.MultiDiffEditorInput:return new I.$DP(this.b.input.diffEditors.map(m=>new I.$uP(R.URI.revive(m.original),R.URI.revive(m.modified))));default:return}}}class u{constructor(m,$){this.c=[],this.d="",this.b=m,this.e=$;for(const f of m.tabs)f.isActive&&(this.d=f.id),this.c.push(new S(f,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,$={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return c.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(f=>f.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(f=>f.apiObject))}};this.a=Object.freeze($)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===T.TabModelOperationKind.TAB_OPEN){const f=new S(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,f),m.tabDto.isActive&&(this.d=f.tabId),f}else if(m.kind===T.TabModelOperationKind.TAB_CLOSE){const f=this.c.splice(m.index,1)[0];if(!f)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return f.tabId===this.d&&(this.d=""),f}else if(m.kind===T.TabModelOperationKind.TAB_MOVE){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const f=this.c.splice(m.oldIndex,1)[0];if(!f)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,f),f}const $=this.c.find(f=>f.tabId===m.tabDto.id);if(!$)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),$.acceptDtoUpdate(m.tabDto),$}activeTabId(){return this.d}}let P=class{constructor(m){this.b=new h.$je,this.c=new h.$je,this.e=[],this.a=m.getProxy(T.$DN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,$={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(f=>f.apiObject))},get activeTabGroup(){const f=m.d;return(0,C.$ng)(m.e.find(s=>s.groupId===f)?.apiObject)},close:async(f,i)=>{const s=Array.isArray(f)?f:[f];return s.length?w(s[0])?this.j(s,i):this.i(s,i):!0}};this.f=Object.freeze($)}return this.f}$acceptEditorTabModel(m){const $=new Set(this.e.map(d=>d.groupId)),f=new Set(m.map(d=>d.groupId)),i=(0,r.$d)($,f),s=this.e.filter(d=>i.removed.includes(d.groupId)).map(d=>d.apiObject),t=[],o=[];this.e=m.map(d=>{const l=new u(d,()=>this.d);return i.added.includes(l.groupId)?t.push(l.apiObject):o.push(l.apiObject),l});const n=(0,C.$ng)(m.find(d=>d.isActive===!0)?.groupId);n!==void 0&&this.d!==n&&(this.d=n),this.c.fire(Object.freeze({opened:t,closed:s,changed:o}))}$acceptTabGroupUpdate(m){const $=this.e.find(f=>f.groupId===m.groupId);if(!$)throw new Error("Update Group IPC call received before group creation.");$.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[$.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const $=this.e.find(i=>i.groupId===m.groupId);if(!$)throw new Error("Update Tabs IPC call received before group creation.");const f=$.acceptTabOperation(m);switch(m.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[f.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[f.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[f.apiObject]}));return}}g(m){for(const $ of this.e)for(const f of $.tabs)if(f.apiObject===m)return f}h(m){return this.e.find($=>$.apiObject===m)}async i(m,$){const f=[];for(const i of m){const s=this.g(i);if(!s)throw new Error("Tab close: Invalid tab not found!");f.push(s.tabId)}return this.a.$closeTab(f,$)}async j(m,$){const f=[];for(const i of m){const s=this.h(i);if(!s)throw new Error("Group close: Invalid group not found!");f.push(s.groupId)}return this.a.$closeGroup(f,$)}};e.$xpc=P,e.$xpc=P=Ye([Ve(0,b.$cQ)],P);function w(a){return a.tabs!==void 0}}),define(Se[302],De([1,0,2,6,27,3,9,15,203,12,26,21,25,85]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hqc=void 0,C=Ue(C),T=Ue(T);class w{constructor(){this.a=[]}add($){this.b=void 0,this.a.push($)}delete($){const f=this.a.indexOf($);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const $=this.a.sort(),f=[];let i,s,t=b.State.LastKnownState,o=b.State.LastKnownState;for(const n of $){let d=i?(0,c.$Ff)(i,n):0;for(d===0?s=b.State.Start:s=o;d<n.length;d++)d+1===n.length?(t=o,o=b.State.BeforeColon):o+=1,f.push([s,n.toUpperCase().charCodeAt(d),o]),f.push([s,n.toLowerCase().charCodeAt(d),o]),s=o;i=n,o=t}f.push([b.State.BeforeColon,I.CharCode.Colon,b.State.AfterColon]),f.push([b.State.AfterColon,I.CharCode.Slash,b.State.End]),this.b=new b.$w4(f)}}provideDocumentLinks($){this.c();const f=[],i=b.$x4.computeLinks({getLineContent(s){return $.lineAt(s-1).text},getLineCount(){return $.lineCount}},this.b);for(const s of i){const t=T.DocumentLink.to(s);t.target&&f.push(t)}return f}}class a{constructor($,f){this.i=f,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=$.getProxy(h.$DN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider($,f,i,s={}){if(a.j(i),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider($,"*",this.b));const t=this.h++;this.b.add(f),this.d.add(f),this.c.set(t,i);let o=C.FileSystemProviderCapabilities.FileReadWrite;s.isCaseSensitive&&(o+=C.FileSystemProviderCapabilities.PathCaseSensitive),s.isReadonly&&(o+=C.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(o+=C.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.$dH)($,"fsChunks"),o+=C.FileSystemProviderCapabilities.FileOpenReadWriteClose);let n;s.isReadonly&&(0,P.$3k)(s.isReadonly)&&s.isReadonly.value!==""&&(n={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(t,f,o,n).catch(l=>{console.error(`FAILED to register filesystem provider of ${$.identifier.value}-extension for the scheme ${f}`),console.error(l)});const d=i.onDidChangeFile(l=>{const g=[];for(const E of l){const{uri:D,type:y}=E;if(D.scheme!==f)continue;let k;switch(y){case L.FileChangeType.Changed:k=C.FileChangeType.UPDATED;break;case L.FileChangeType.Created:k=C.FileChangeType.ADDED;break;case L.FileChangeType.Deleted:k=C.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}g.push({resource:D,type:k})}this.a.$onFileSystemChange(t,g)});return(0,R.$Rc)(()=>{d.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(t),this.a.$unregisterProvider(t)})}static j($){if(!$)throw new Error("MISSING provider");if(typeof $.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof $.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof $.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof $.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof $.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof $.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof $.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof $.rename!="function")throw new Error("Provider does NOT implement rename")}static k($){const{type:f,ctime:i,mtime:s,size:t,permissions:o}=$;return{type:f,ctime:i,mtime:s,size:t,permissions:o}}$stat($,f){return Promise.resolve(this.l($).stat(r.URI.revive(f))).then(i=>a.k(i))}$readdir($,f){return Promise.resolve(this.l($).readDirectory(r.URI.revive(f)))}$readFile($,f){return Promise.resolve(this.l($).readFile(r.URI.revive(f))).then(i=>S.$Le.wrap(i))}$writeFile($,f,i,s){return Promise.resolve(this.l($).writeFile(r.URI.revive(f),i.buffer,s))}$delete($,f,i){return Promise.resolve(this.l($).delete(r.URI.revive(f),i))}$rename($,f,i,s){return Promise.resolve(this.l($).rename(r.URI.revive(f),r.URI.revive(i),s))}$copy($,f,i,s){const t=this.l($);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(r.URI.revive(f),r.URI.revive(i),s))}$mkdir($,f){return Promise.resolve(this.l($).createDirectory(r.URI.revive(f)))}$watch($,f,i,s){const t=this.l($).watch(r.URI.revive(i),s);this.f.set(f,t)}$unwatch($,f){const i=this.f.get(f);i&&(i.dispose(),this.f.delete(f))}$open($,f,i){const s=this.l($);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(r.URI.revive(f),i))}$close($,f){const i=this.l($);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(f))}$read($,f,i,s){const t=this.l($);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const o=S.$Le.alloc(s);return Promise.resolve(t.read(f,i,o.buffer,0,s)).then(n=>o.slice(0,n))}$write($,f,i,s){const t=this.l($);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(f,i,s.buffer,0,s.byteLength))}l($){const f=this.c.get($);if(!f){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return f}}e.$hqc=a}),define(Se[303],De([1,0,4,38,2,6,15,9,27,49]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iqc=void 0,L=Ue(L);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,a,m,$,f,i){this.a=Math.random(),this.b=new r.$je,this.c=new r.$je,this.d=new r.$je,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const s=(0,h.$xk)(f),t=typeof f=="string",o=i?.correlate,n=$(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(o&&typeof d.session>"u")){if(!i?.ignoreCreateEvents)for(const l of d.created){const g=C.URI.revive(l);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this.b.fire(g)}if(!i?.ignoreChangeEvents)for(const l of d.changed){const g=C.URI.revive(l);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this.c.fire(g)}if(!i?.ignoreDeleteEvents)for(const l of d.deleted){const g=C.URI.revive(l);s(g.fsPath)&&(!t||a.getWorkspaceFolder(g))&&this.d.fire(g)}}});this.g=T.$FN.from(this.i(w,m,f,i,i?.correlate),this.b,this.c,this.d,n)}i(w,a,m,$,f){const i=T.$FN.from();if(typeof m=="string"||$?.ignoreChangeEvents&&$?.ignoreCreateEvents&&$?.ignoreDeleteEvents)return i;const s=w.getProxy(R.$DN.MainThreadFileSystemEventService);let t=!1;(m.pattern.includes(h.$tk)||m.pattern.includes(h.$uk))&&(t=!0);let o;return f&&($?.ignoreChangeEvents||$?.ignoreCreateEvents||$?.ignoreDeleteEvents)&&(o=b.FileChangeFilter.UPDATED|b.FileChangeFilter.ADDED|b.FileChangeFilter.DELETED,$?.ignoreChangeEvents&&(o&=~b.FileChangeFilter.UPDATED),$?.ignoreCreateEvents&&(o&=~b.FileChangeFilter.ADDED),$?.ignoreDeleteEvents&&(o&=~b.FileChangeFilter.DELETED)),s.$watch(a.identifier.value,this.a,m.baseUri,{recursive:t,excludes:$?.excludes??[],filter:o},!!f),T.$FN.from({dispose:()=>s.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class S{constructor(w){this.a=w,this.session=this.a.session,this.b=new c.$T(()=>this.a.created.map(C.URI.revive)),this.c=new c.$T(()=>this.a.changed.map(C.URI.revive)),this.d=new c.$T(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(w,a,m){this.j=w,this.k=a,this.l=m,this.a=new r.$je,this.b=new r.$je,this.c=new r.$je,this.d=new r.$je,this.g=new r.$le,this.h=new r.$le,this.i=new r.$le,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,a,m,$){return new I(this.j,w,a,this.a.event,L.GlobPattern.from(m),$)}$onFileEvent(w){this.a.fire(new S(w))}$onDidRunFileOperation(w,a){switch(w){case b.FileOperation.MOVE:this.b.fire(Object.freeze({files:a.map(m=>({oldUri:C.URI.revive(m.source),newUri:C.URI.revive(m.target)}))}));break;case b.FileOperation.DELETE:this.d.fire(Object.freeze({files:a.map(m=>C.URI.revive(m.target))}));break;case b.FileOperation.CREATE:case b.FileOperation.COPY:this.c.fire(Object.freeze({files:a.map(m=>C.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,a){return(m,$,f)=>{const i=function(t){m.call($,t)};return i.extension=w,a.event(i,void 0,f)}}async $onWillRunFileOperation(w,a,m,$){switch(w){case b.FileOperation.MOVE:return await this.n(this.g,{files:a.map(f=>({oldUri:C.URI.revive(f.source),newUri:C.URI.revive(f.target)}))},m,$);case b.FileOperation.DELETE:return await this.n(this.i,{files:a.map(f=>C.URI.revive(f.target))},m,$);case b.FileOperation.CREATE:case b.FileOperation.COPY:return await this.n(this.h,{files:a.map(f=>C.URI.revive(f.target))},m,$)}}async n(w,a,m,$){const f=new Set,i=[];if(await w.fireAsync(a,$,async(t,o)=>{const n=Date.now(),d=await Promise.resolve(t);d instanceof T.$RN&&(i.push([o.extension,d]),f.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-n>m&&this.k.warn("SLOW file-participant",o.extension.identifier)}),$.isCancellationRequested||i.length===0)return;const s={edits:[]};for(const[,t]of i){const{edits:o}=L.WorkspaceEdit.from(t,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(o)}return{edit:s,extensionNames:Array.from(f)}}}e.$iqc=u}),define(Se[304],De([1,0,18,7,20,13,132,3,24,42,12,17,2,30,196,87,142,8,23,15,9,25,118,6]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6oc=void 0,a=Ue(a),i=Ue(i),n=Ue(n);class d{constructor(q,H){this.d=q,this.e=H}async provideDocumentSymbols(q,H){const X=this.d.getDocument(q),Z=await this.e.provideDocumentSymbols(X,H);if(!(0,r.$Jb)(Z))return Z[0]instanceof s.$2N?Z.map(i.DocumentSymbol.from):d.f(Z)}static f(q){q=q.slice(0).sort((Z,de)=>{let be=Z.location.range.start.compareTo(de.location.range.start);return be===0&&(be=de.location.range.end.compareTo(Z.location.range.end)),be});const H=[],X=[];for(const Z of q){const de={name:Z.name||"!!MISSING: name!!",kind:i.SymbolKind.from(Z.kind),tags:Z.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:Z.containerName,range:i.Range.from(Z.location.range),selectionRange:i.Range.from(Z.location.range),children:[]};for(;;){if(X.length===0){X.push(de),H.push(de);break}const be=X[X.length-1];if(P.$Lt.containsRange(be.range,de.range)&&!P.$Lt.equalsRange(be.range,de.range)){be.children?.push(de),X.push(de);break}X.pop()}}return H}}class l{constructor(q,H,X,Z,de,be){this.f=q,this.g=H,this.h=X,this.j=Z,this.k=de,this.l=be,this.d=new o.$Voc("CodeLens"),this.e=new Map}async provideCodeLenses(q,H){const X=this.f.getDocument(q),Z=await this.h.provideCodeLenses(X,H);if(!Z||H.isCancellationRequested)return;const de=this.d.add(Z),be=new T.$Sc;this.e.set(de,be);const Oe={cacheId:de,lenses:[]};for(let He=0;He<Z.length;He++)Oe.lenses.push({cacheId:[de,He],range:i.Range.from(Z[He].range),command:this.g.toInternal(Z[He].command,be)});return Oe}async resolveCodeLens(q,H){const X=q.cacheId&&this.d.get(...q.cacheId);if(!X)return;let Z;if(typeof this.h.resolveCodeLens!="function"||X.isResolved?Z=X:Z=await this.h.resolveCodeLens(X,H),Z||(Z=X),H.isCancellationRequested)return;const de=q.cacheId&&this.e.get(q.cacheId[0]);if(de){if(!Z.command){const be=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,be),this.l.error(be);return}return q.command=this.g.toInternal(Z.command,de),q}}releaseCodeLenses(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}}function g(Pe){return Array.isArray(Pe)?Pe.map(i.DefinitionLink.from):Pe?[i.DefinitionLink.from(Pe)]:[]}class E{constructor(q,H){this.d=q,this.e=H}async provideDefinition(q,H,X){const Z=this.d.getDocument(q),de=i.Position.to(H),be=await this.e.provideDefinition(Z,de,X);return g(be)}}class D{constructor(q,H){this.d=q,this.e=H}async provideDeclaration(q,H,X){const Z=this.d.getDocument(q),de=i.Position.to(H),be=await this.e.provideDeclaration(Z,de,X);return g(be)}}class y{constructor(q,H){this.d=q,this.e=H}async provideImplementation(q,H,X){const Z=this.d.getDocument(q),de=i.Position.to(H),be=await this.e.provideImplementation(Z,de,X);return g(be)}}class k{constructor(q,H){this.d=q,this.e=H}async provideTypeDefinition(q,H,X){const Z=this.d.getDocument(q),de=i.Position.to(H),be=await this.e.provideTypeDefinition(Z,de,X);return g(be)}}class A{static{this.f=10}constructor(q,H){this.g=q,this.h=H,this.d=0,this.e=new Map}async provideHover(q,H,X,Z){const de=this.g.getDocument(q),be=i.Position.to(H);let Oe;if(X&&X.verbosityRequest){const nt=X.verbosityRequest.previousHover.id,st=this.e.get(nt);if(!st)throw new Error(`Hover with id ${nt} not found`);const rt={verbosityDelta:X.verbosityRequest.verbosityDelta,previousHover:st};Oe=await this.h.provideHover(de,be,Z,rt)}else Oe=await this.h.provideHover(de,be,Z);if(!Oe||(0,r.$Jb)(Oe.contents))return;Oe.range||(Oe.range=de.getWordRangeAtPosition(be)),Oe.range||(Oe.range=new s.$HN(be,be));const He=i.Hover.from(Oe),Qe=this.d;if(this.e.size===A.f){const nt=Math.min(...this.e.keys());this.e.delete(nt)}return this.e.set(Qe,Oe),this.d+=1,{...He,id:Qe}}releaseHover(q){this.e.delete(q)}}class p{constructor(q,H){this.d=q,this.e=H}async provideEvaluatableExpression(q,H,X){const Z=this.d.getDocument(q),de=i.Position.to(H),be=await this.e.provideEvaluatableExpression(Z,de,X);if(be)return i.EvaluatableExpression.from(be)}}class v{constructor(q,H){this.d=q,this.e=H}async provideInlineValues(q,H,X,Z){const de=this.d.getDocument(q),be=await this.e.provideInlineValues(de,i.Range.to(H),i.InlineValueContext.to(X),Z);if(Array.isArray(be))return be.map(Oe=>i.InlineValue.from(Oe))}}class F{constructor(q,H){this.d=q,this.e=H}async provideDocumentHighlights(q,H,X){const Z=this.d.getDocument(q),de=i.Position.to(H),be=await this.e.provideDocumentHighlights(Z,de,X);if(Array.isArray(be))return be.map(i.DocumentHighlight.from)}}class N{constructor(q,H){this.d=q,this.e=H}async provideMultiDocumentHighlights(q,H,X,Z){const de=this.d.getDocument(q),be=X.map(Qe=>this.d.getDocument(Qe)),Oe=i.Position.to(H),He=await this.e.provideMultiDocumentHighlights(de,Oe,be,Z);if(Array.isArray(He))return He.map(i.MultiDocumentHighlight.from)}}class O{constructor(q,H){this.d=q,this.e=H}async provideLinkedEditingRanges(q,H,X){const Z=this.d.getDocument(q),de=i.Position.to(H),be=await this.e.provideLinkedEditingRanges(Z,de,X);if(be&&Array.isArray(be.ranges))return{ranges:(0,r.$Gb)(be.ranges.map(i.Range.from)),wordPattern:be.wordPattern}}}class j{constructor(q,H){this.d=q,this.e=H}async provideReferences(q,H,X,Z){const de=this.d.getDocument(q),be=i.Position.to(H),Oe=await this.e.provideReferences(de,be,X,Z);if(Array.isArray(Oe))return Oe.map(i.location.from)}}class z{static{this.d=1e3}constructor(q,H,X,Z,de,be,Oe){this.g=q,this.h=H,this.j=X,this.k=Z,this.l=de,this.m=be,this.n=Oe,this.e=new o.$Voc("CodeAction"),this.f=new Map}async provideCodeActions(q,H,X,Z){const de=this.g.getDocument(q),be=w.$Nt.isISelection(H)?i.Selection.to(H):i.Range.to(H),Oe=[];for(const rt of this.j.getDiagnostics(q))if(be.intersection(rt.range)&&Oe.push(rt)>z.d)break;const He={diagnostics:Oe,only:X.only?new s.$4N(X.only):void 0,triggerKind:i.CodeActionTriggerKind.to(X.trigger)},Qe=await this.k.provideCodeActions(de,be,He,Z);if(!(0,r.$Kb)(Qe)||Z.isCancellationRequested)return;const _e=this.e.add(Qe),nt=new T.$Sc;this.f.set(_e,nt);const st=[];for(let rt=0;rt<Qe.length;rt++){const at=Qe[rt];if(at)if(z.o(at))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:at.title,command:this.h.toInternal(at,nt)});else{He.only&&(at.kind?He.only.contains(at.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value}' requested but returned code action is of kind '${at.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const mt=at.ranges??[];st.push({cacheId:[_e,rt],title:at.title,command:at.command&&this.h.toInternal(at.command,nt),diagnostics:at.diagnostics&&at.diagnostics.map(i.Diagnostic.from),edit:at.edit&&i.WorkspaceEdit.from(at.edit,void 0),kind:at.kind&&at.kind.value,isPreferred:at.isPreferred,isAI:(0,t.$cH)(this.m,"codeActionAI")?at.isAI:!1,ranges:(0,t.$cH)(this.m,"codeActionRanges")?(0,r.$Gb)(mt.map(i.Range.from)):void 0,disabled:at.disabled?.reason})}}return{cacheId:_e,actions:st}}async resolveCodeAction(q,H){const[X,Z]=q,de=this.e.get(X,Z);if(!de||z.o(de))return{};if(!this.k.resolveCodeAction)return{};const be=await this.k.resolveCodeAction(de,H)??de;let Oe;be.edit&&(Oe=i.WorkspaceEdit.from(be.edit,void 0));let He;if(be.command){const Qe=this.f.get(X);Qe&&(He=this.h.toInternal(be.command,Qe))}return{edit:Oe,command:He}}releaseCodeActions(q){this.f.get(q)?.dispose(),this.f.delete(q),this.e.delete(q)}static o(q){return typeof q.command=="string"&&typeof q.title=="string"}}class M{constructor(q,H,X,Z,de){this.e=q,this.f=H,this.g=X,this.h=Z,this.j=de,this.d=new o.$Voc("DocumentPasteEdit")}async prepareDocumentPaste(q,H,X,Z){if(!this.g.prepareDocumentPaste)return;const de=this.f.getDocument(q),be=H.map(Qe=>i.Range.to(Qe)),Oe=i.DataTransfer.toDataTransfer(X,()=>{throw new R.$0});if(await this.g.prepareDocumentPaste(de,be,Oe,Z),Z.isCancellationRequested)return;const He=Array.from(Oe).filter(([,Qe])=>!(Qe instanceof s.$xO));return i.DataTransfer.from(He)}async providePasteEdits(q,H,X,Z,de,be){if(!this.g.provideDocumentPasteEdits)return[];const Oe=this.f.getDocument(H),He=X.map(st=>i.Range.to(st)),Qe=i.DataTransfer.toDataTransfer(Z,async st=>(await this.e.$resolvePasteFileData(this.h,q,st)).buffer),_e=await this.g.provideDocumentPasteEdits(Oe,He,Qe,{only:de.only?new s.$CO(de.only):void 0,triggerKind:de.triggerKind},be);if(!_e||be.isCancellationRequested)return[];const nt=this.d.add(_e);return _e.map((st,rt)=>({_cacheId:[nt,rt],title:st.title??(0,$.localize)(10741,null,this.j.displayName||this.j.name),kind:st.kind,yieldTo:st.yieldTo?.map(at=>at.value),insertText:typeof st.insertText=="string"?st.insertText:{snippet:st.insertText.value},additionalEdit:st.additionalEdit?i.WorkspaceEdit.from(st.additionalEdit,void 0):void 0}))}async resolvePasteEdit(q,H){const[X,Z]=q,de=this.d.get(X,Z);if(!de||!this.g.resolveDocumentPasteEdit)return{};const be=await this.g.resolveDocumentPasteEdit(de,H)??de;return{additionalEdit:be.additionalEdit?i.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}releasePasteEdits(q){this.d.delete(q)}}class W{constructor(q,H){this.d=q,this.e=H}async provideDocumentFormattingEdits(q,H,X){const Z=this.d.getDocument(q),de=await this.e.provideDocumentFormattingEdits(Z,H,X);if(Array.isArray(de))return de.map(i.TextEdit.from)}}class V{constructor(q,H){this.d=q,this.e=H}async provideDocumentRangeFormattingEdits(q,H,X,Z){const de=this.d.getDocument(q),be=i.Range.to(H),Oe=await this.e.provideDocumentRangeFormattingEdits(de,be,X,Z);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(q,H,X,Z){(0,S.$mg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const de=this.d.getDocument(q),be=H.map(i.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(de,be,X,Z);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}}class ne{constructor(q,H){this.d=q,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,H,X,Z,de){const be=this.d.getDocument(q),Oe=i.Position.to(H),He=await this.e.provideOnTypeFormattingEdits(be,Oe,X,Z,de);if(Array.isArray(He))return He.map(i.TextEdit.from)}}class B{constructor(q,H){this.e=q,this.f=H,this.d=new o.$Voc("WorkspaceSymbols")}async provideWorkspaceSymbols(q,H){const X=await this.e.provideWorkspaceSymbols(q,H);if(!(0,r.$Kb)(X))return{symbols:[]};const Z=this.d.add(X),de={cacheId:Z,symbols:[]};for(let be=0;be<X.length;be++){const Oe=X[be];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}de.symbols.push({...i.WorkspaceSymbol.from(Oe),cacheId:[Z,be]})}return de}async resolveWorkspaceSymbol(q,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const X=this.d.get(...q.cacheId);if(X){const Z=await this.e.resolveWorkspaceSymbol(X,H);return Z&&(0,b.$eo)(q,i.WorkspaceSymbol.from(Z),!0)}}releaseWorkspaceSymbols(q){this.d.delete(q)}}class K{static supportsResolving(q){return typeof q.prepareRename=="function"}constructor(q,H,X){this.d=q,this.e=H,this.f=X}async provideRenameEdits(q,H,X,Z){const de=this.d.getDocument(q),be=i.Position.to(H);try{const Oe=await this.e.provideRenameEdits(de,be,X,Z);return Oe?i.WorkspaceEdit.from(Oe):void 0}catch(Oe){const He=K.g(Oe);return He?{rejectReason:He,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(q,H,X){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Z=this.d.getDocument(q),de=i.Position.to(H);try{const be=await this.e.prepareRename(Z,de,X);let Oe,He;if(s.$HN.isRange(be)?(Oe=be,He=Z.getText(be)):(0,S.$eg)(be)&&(Oe=be.range,He=be.placeholder),!Oe||!He)return;if(Oe.start.line>de.line||Oe.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Oe),text:He}}catch(be){const Oe=K.g(be);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(be)}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class Y{static{this.d={[a.NewSymbolNameTriggerKind.Invoke]:s.NewSymbolNameTriggerKind.Invoke,[a.NewSymbolNameTriggerKind.Automatic]:s.NewSymbolNameTriggerKind.Automatic}}constructor(q,H,X){this.e=q,this.f=H,this.g=X}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(q,H,X,Z){const de=this.e.getDocument(q),be=i.Range.to(H);try{const Oe=Y.d[X],He=await this.f.provideNewSymbolNames(de,be,Oe,Z);return He?He.map(Qe=>typeof Qe=="string"?{newSymbolName:Qe}:{newSymbolName:Qe.newSymbolName,tags:Qe.tags}):void 0}catch(Oe){this.g.error(Y.h(Oe)??JSON.stringify(Oe,null,"	"));return}}static h(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class ee{constructor(q,H){this.resultId=q,this.tokens=H}}class ue{constructor(q,H){this.f=q,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(q,H,X){const Z=this.f.getDocument(q),de=H!==0?this.d.get(H):null;let be=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Z,de.resultId,X):await this.g.provideDocumentSemanticTokens(Z,X);return de&&this.d.delete(H),be?(be=ue.h(be),this.o(ue.n(de,be),be)):null}async releaseDocumentSemanticColoring(q){this.d.delete(q)}static h(q){return ue.j(q)?ue.k(q)?q:new s.$3O(new Uint32Array(q.data),q.resultId):ue.l(q)?ue.m(q)?q:new s.$5O(q.edits.map(H=>new s.$4O(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),q.resultId):q}static j(q){return q&&!!q.data}static k(q){return q.data instanceof Uint32Array}static l(q){return q&&Array.isArray(q.edits)}static m(q){for(const H of q.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(q,H){if(!ue.j(H)||!q||!q.tokens)return H;const X=q.tokens,Z=X.length,de=H.data,be=de.length;let Oe=0;const He=Math.min(Z,be);for(;Oe<He&&X[Oe]===de[Oe];)Oe++;if(Oe===Z&&Oe===be)return new s.$5O([],H.resultId);let Qe=0;const _e=He-Oe;for(;Qe<_e&&X[Z-Qe-1]===de[be-Qe-1];)Qe++;return new s.$5O([{start:Oe,deleteCount:Z-Oe-Qe,data:de.subarray(Oe,be-Qe)}],H.resultId)}o(q,H){if(ue.j(q)){const X=this.e++;return this.d.set(X,new ee(q.resultId,q.data)),(0,m.$Ndb)({id:X,type:"full",data:q.data})}if(ue.l(q)){const X=this.e++;return ue.j(H)?this.d.set(X,new ee(H.resultId,H.data)):this.d.set(X,new ee(q.resultId)),(0,m.$Ndb)({id:X,type:"delta",deltas:(q.edits||[]).map(Z=>({start:Z.start,deleteCount:Z.deleteCount,data:Z.data}))})}return null}}class re{constructor(q,H){this.d=q,this.e=H}async provideDocumentRangeSemanticTokens(q,H,X){const Z=this.d.getDocument(q),de=await this.e.provideDocumentRangeSemanticTokens(Z,i.Range.to(H),X);return de?this.f(de):null}f(q){return(0,m.$Ndb)({id:0,type:"full",data:q.data})}}class ye{static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}constructor(q,H,X,Z,de){this.f=q,this.g=H,this.h=X,this.j=Z,this.k=de,this.d=new o.$Voc("CompletionItem"),this.e=new Map}async provideCompletionItems(q,H,X,Z){const de=this.f.getDocument(q),be=i.Position.to(H),Oe=de.getWordRangeAtPosition(be)||new s.$HN(be,be),He=Oe.with({end:be}),Qe=new c.$de,_e=await this.h.provideCompletionItems(de,be,Z,i.CompletionContext.to(X));if(!_e||Z.isCancellationRequested)return;const nt=Array.isArray(_e)?new s.$eO(_e):_e,st=ye.supportsResolving(this.h)?this.d.add(nt.items):this.d.add([]),rt=new T.$Sc;this.e.set(st,rt);const at=[],mt={x:st,[n.ISuggestResultDtoField.completions]:at,[n.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Oe),insert:i.Range.from(He)},[n.ISuggestResultDtoField.isIncomplete]:nt.isIncomplete||void 0,[n.ISuggestResultDtoField.duration]:Qe.elapsed()};for(let ht=0;ht<nt.items.length;ht++){const ct=nt.items[ht],ke=this.l(ct,[st,ht],He,Oe);at.push(ke)}return mt}async resolveCompletionItem(q,H){if(typeof this.h.resolveCompletionItem!="function")return;const X=this.d.get(...q);if(!X)return;const Z=this.l(X,q),de=await this.h.resolveCompletionItem(X,H);if(!de)return;const be=this.l(de,q);return(Z[n.ISuggestDataDtoField.insertText]!==be[n.ISuggestDataDtoField.insertText]||Z[n.ISuggestDataDtoField.insertTextRules]!==be[n.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Z[n.ISuggestDataDtoField.commandIdent]!==be[n.ISuggestDataDtoField.commandIdent]||Z[n.ISuggestDataDtoField.commandId]!==be[n.ISuggestDataDtoField.commandId]||!(0,b.$fo)(Z[n.ISuggestDataDtoField.commandArguments],be[n.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Z,[n.ISuggestDataDtoField.documentation]:be[n.ISuggestDataDtoField.documentation],[n.ISuggestDataDtoField.detail]:be[n.ISuggestDataDtoField.detail],[n.ISuggestDataDtoField.additionalTextEdits]:be[n.ISuggestDataDtoField.additionalTextEdits],[n.ISuggestDataDtoField.insertText]:be[n.ISuggestDataDtoField.insertText],[n.ISuggestDataDtoField.insertTextRules]:be[n.ISuggestDataDtoField.insertTextRules],[n.ISuggestDataDtoField.commandIdent]:be[n.ISuggestDataDtoField.commandIdent],[n.ISuggestDataDtoField.commandId]:be[n.ISuggestDataDtoField.commandId],[n.ISuggestDataDtoField.commandArguments]:be[n.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,H,X,Z){const de=this.e.get(H[0]);if(!de)throw Error("DisposableStore is missing...");const be=this.g.toInternal(q.command,de),Oe={x:H,[n.ISuggestDataDtoField.label]:q.label,[n.ISuggestDataDtoField.kind]:q.kind!==void 0?i.CompletionItemKind.from(q.kind):void 0,[n.ISuggestDataDtoField.kindModifier]:q.tags&&q.tags.map(i.CompletionItemTag.from),[n.ISuggestDataDtoField.detail]:q.detail,[n.ISuggestDataDtoField.documentation]:typeof q.documentation>"u"?void 0:i.MarkdownString.fromStrict(q.documentation),[n.ISuggestDataDtoField.sortText]:q.sortText!==q.label?q.sortText:void 0,[n.ISuggestDataDtoField.filterText]:q.filterText!==q.label?q.filterText:void 0,[n.ISuggestDataDtoField.preselect]:q.preselect||void 0,[n.ISuggestDataDtoField.insertTextRules]:q.keepWhitespace?a.CompletionItemInsertTextRule.KeepWhitespace:a.CompletionItemInsertTextRule.None,[n.ISuggestDataDtoField.commitCharacters]:q.commitCharacters?.join(""),[n.ISuggestDataDtoField.additionalTextEdits]:q.additionalTextEdits&&q.additionalTextEdits.map(i.TextEdit.from),[n.ISuggestDataDtoField.commandIdent]:be?.$ident,[n.ISuggestDataDtoField.commandId]:be?.id,[n.ISuggestDataDtoField.commandArguments]:be?.$ident?void 0:be?.arguments};q.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe[n.ISuggestDataDtoField.insertText]=q.textEdit.newText):typeof q.insertText=="string"?Oe[n.ISuggestDataDtoField.insertText]=q.insertText:q.insertText instanceof s.$SN&&(Oe[n.ISuggestDataDtoField.insertText]=q.insertText.value,Oe[n.ISuggestDataDtoField.insertTextRules]|=a.CompletionItemInsertTextRule.InsertAsSnippet);let He;return q.textEdit?He=q.textEdit.range:q.range&&(He=q.range),s.$HN.isRange(He)?Oe[n.ISuggestDataDtoField.range]=i.Range.from(He):He&&(!X?.isEqual(He.inserting)||!Z?.isEqual(He.replacing))&&(Oe[n.ISuggestDataDtoField.range]={insert:i.Range.from(He.inserting),replace:i.Range.from(He.replacing)}),Oe}}class me{async provideInlineCompletions(q,H,X,Z){}async provideInlineEdits(q,H,X,Z){}disposeCompletions(q){}handleDidShowCompletionItem(q,H,X){}handlePartialAccept(q,H,X,Z){}}class J extends me{constructor(q,H,X,Z){super(),this.f=q,this.g=H,this.h=X,this.j=Z,this.d=new se,this.e=(0,t.$cH)(this.f,"inlineCompletionsAdditions"),this.k={[a.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$cH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(q,H,X,Z){const de=this.g.getDocument(q),be=i.Position.to(H),Oe=await this.h.provideInlineCompletionItems(de,be,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:i.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind]},Z);if(!Oe||Z.isCancellationRequested)return;const He=Array.isArray(Oe)?Oe:Oe.items,Qe=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],_e=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let nt;return{pid:this.d.createReferenceId({dispose(){nt?.dispose()},items:He}),items:He.map((rt,at)=>{let mt;rt.command&&(nt||(nt=new T.$Sc),mt=this.j.toInternal(rt.command,nt));const ht=rt.insertText;return{insertText:typeof ht=="string"?ht:{snippet:ht.value},filterText:rt.filterText,range:rt.range?i.Range.from(rt.range):void 0,command:mt,idx:at,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Qe.map(rt=>(nt||(nt=new T.$Sc),this.j.toInternal(rt,nt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(q,H,X,Z){if(!this.h.provideInlineEdits)return;(0,t.$dH)(this.f,"inlineCompletionsAdditions");const de=this.g.getDocument(q),be=i.Range.to(H),Oe=await this.h.provideInlineEdits(de,be,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:i.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind],userPrompt:X.userPrompt},Z);if(!Oe||Z.isCancellationRequested)return;const He=Array.isArray(Oe)?Oe:Oe.items,Qe=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],_e=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let nt;return{pid:this.d.createReferenceId({dispose(){nt?.dispose()},items:He}),items:He.map((rt,at)=>{let mt;rt.command&&(nt||(nt=new T.$Sc),mt=this.j.toInternal(rt.command,nt));const ht=rt.insertText;return{insertText:typeof ht=="string"?ht:{snippet:ht.value},filterText:rt.filterText,range:rt.range?i.Range.from(rt.range):void 0,command:mt,idx:at,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Qe.map(rt=>(nt||(nt=new T.$Sc),this.j.toInternal(rt,nt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(q){this.d.disposeReferenceId(q)?.dispose()}handleDidShowCompletionItem(q,H,X){const Z=this.d.get(q)?.items[H];Z&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Z,X)}handlePartialAccept(q,H,X,Z){const de=this.d.get(q)?.items[H];de&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(de,X),this.h.handleDidPartiallyAcceptCompletionItem(de,i.PartialAcceptInfo.to(Z)))}}class U{async provideInlineEdits(q,H,X){const Z=this.f.getDocument(q),de=await this.g.provideInlineEdit(Z,{triggerKind:this.e[H.triggerKind]},X);if(!de||X.isCancellationRequested)return;let be;const Oe=this.d.createReferenceId({dispose(){be?.dispose()},item:de});let He;de.accepted&&(be||(be=new T.$Sc),He=this.h.toInternal(de.accepted,be));let Qe;return de.rejected&&(be||(be=new T.$Sc),Qe=this.h.toInternal(de.rejected,be)),{pid:Oe,text:de.text,range:i.Range.from(de.range),accepted:He,rejected:Qe}}disposeEdit(q){this.d.disposeReferenceId(q)?.dispose()}constructor(q,H,X,Z){this.f=H,this.g=X,this.h=Z,this.d=new se,this.e={[a.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class se{constructor(){this.d=new Map,this.e=1}createReferenceId(q){const H=this.e++;return this.d.set(H,q),H}disposeReferenceId(q){const H=this.d.get(q);return this.d.delete(q),H}get(q){return this.d.get(q)}}class ae{constructor(q,H){this.e=q,this.f=H,this.d=new o.$Voc("SignatureHelp")}async provideSignatureHelp(q,H,X,Z){const de=this.e.getDocument(q),be=i.Position.to(H),Oe=this.g(X),He=await this.f.provideSignatureHelp(de,be,Z,Oe);if(He){const Qe=this.d.add([He]);return{...i.SignatureHelp.from(He),id:Qe}}}g(q){let H;if(q.activeSignatureHelp){const X=i.SignatureHelp.to(q.activeSignatureHelp),Z=this.d.get(q.activeSignatureHelp.id,0);Z?(H=Z,H.activeSignature=X.activeSignature,H.activeParameter=X.activeParameter):H=X}return{...q,activeSignatureHelp:H}}releaseSignatureHelp(q){this.d.delete(q)}}class te{constructor(q,H,X,Z,de){this.f=q,this.g=H,this.h=X,this.j=Z,this.k=de,this.d=new o.$Voc("InlayHints"),this.e=new Map}async provideInlayHints(q,H,X){const Z=this.f.getDocument(q),de=i.Range.to(H),be=await this.h.provideInlayHints(Z,de,X);if(!Array.isArray(be)||be.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(H)}`);return}if(X.isCancellationRequested)return;const Oe=this.d.add(be);this.e.set(Oe,new T.$Sc);const He={hints:[],cacheId:Oe};for(let Qe=0;Qe<be.length;Qe++)this.l(be[Qe],de)&&He.hints.push(this.m(be[Qe],[Oe,Qe]));return this.j.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(H)}`),He}async resolveInlayHint(q,H){if(typeof this.h.resolveInlayHint!="function")return;const X=this.d.get(...q);if(!X)return;const Z=await this.h.resolveInlayHint(X,H);if(Z&&this.l(Z))return this.m(Z,q)}releaseHints(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,H){return q.label.length===0||Array.isArray(q.label)&&q.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(H&&!H.contains(q.position))}m(q,H){const X=this.e.get(H[0]);if(!X)throw Error("DisposableStore is missing...");const Z={label:"",cacheId:H,tooltip:i.MarkdownString.fromStrict(q.tooltip),position:i.Position.from(q.position),textEdits:q.textEdits&&q.textEdits.map(i.TextEdit.from),kind:q.kind&&i.InlayHintKind.from(q.kind),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};if(typeof q.label=="string")Z.label=q.label;else{const de=[];Z.label=de;for(const be of q.label){if(!be.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:be.value,tooltip:i.MarkdownString.fromStrict(be.tooltip)};s.$TN.isLocation(be.location)&&(Oe.location=i.location.from(be.location)),be.command&&(Oe.command=this.g.toInternal(be.command,X)),de.push(Oe)}}return Z}}class ce{constructor(q,H){this.e=q,this.f=H,this.d=new o.$Voc("DocumentLink")}async provideLinks(q,H){const X=this.e.getDocument(q),Z=await this.f.provideDocumentLinks(X,H);if(!(!Array.isArray(Z)||Z.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Z.filter(ce.g).map(i.DocumentLink.from)};{const de=this.d.add(Z),be={links:[],cacheId:de};for(let Oe=0;Oe<Z.length;Oe++){if(!ce.g(Z[Oe]))continue;const He=i.DocumentLink.from(Z[Oe]);He.cacheId=[de,Oe],be.links.push(He)}return be}}}static g(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,H){if(typeof this.f.resolveDocumentLink!="function")return;const X=this.d.get(...q);if(!X)return;const Z=await this.f.resolveDocumentLink(X,H);if(!(!Z||!ce.g(Z)))return i.DocumentLink.from(Z)}releaseLinks(q){this.d.delete(q)}}class le{constructor(q,H){this.d=q,this.e=H}async provideColors(q,H){const X=this.d.getDocument(q),Z=await this.e.provideDocumentColors(X,H);return Array.isArray(Z)?Z.map(be=>({color:i.Color.from(be.color),range:i.Range.from(be.range)})):[]}async provideColorPresentations(q,H,X){const Z=this.d.getDocument(q),de=i.Range.to(H.range),be=i.Color.to(H.color),Oe=await this.e.provideColorPresentations(be,{document:Z,range:de},X);if(Array.isArray(Oe))return Oe.map(i.ColorPresentation.from)}}class x{constructor(q,H){this.d=q,this.e=H}async provideFoldingRanges(q,H,X){const Z=this.d.getDocument(q),de=await this.e.provideFoldingRanges(Z,H,X);if(Array.isArray(de))return de.map(i.FoldingRange.from)}}class oe{constructor(q,H,X){this.d=q,this.e=H,this.f=X}async provideSelectionRanges(q,H,X){const Z=this.d.getDocument(q),de=H.map(i.Position.to),be=await this.e.provideSelectionRanges(Z,de,X);if(!(0,r.$Kb)(be))return[];if(be.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let He=0;He<de.length;He++){const Qe=[];Oe.push(Qe);let _e=de[He],nt=be[He];for(;;){if(!nt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(i.SelectionRange.from(nt)),!nt.parent)break;_e=nt.range,nt=nt.parent}}return Oe}}class pe{constructor(q,H){this.f=q,this.g=H,this.d=new L.$hQ(""),this.e=new Map}async prepareSession(q,H,X){const Z=this.f.getDocument(q),de=i.Position.to(H),be=await this.g.prepareCallHierarchy(Z,de,X);if(!be)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(be)?be.map(He=>this.h(Oe,He)):[this.h(Oe,be)]}async provideCallsTo(q,H,X){const Z=this.j(q,H);if(!Z)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(Z,X);if(de)return de.map(be=>({from:this.h(q,be.from),fromRanges:be.fromRanges.map(Oe=>i.Range.from(Oe))}))}async provideCallsFrom(q,H,X){const Z=this.j(q,H);if(!Z)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(Z,X);if(de)return de.map(be=>({to:this.h(q,be.to),fromRanges:be.fromRanges.map(Oe=>i.Range.from(Oe))}))}releaseSession(q){this.e.delete(q)}h(q,H){const X=this.e.get(q),Z=i.CallHierarchyItem.from(H,q,X.size.toString(36));return X.set(Z._itemId,H),Z}j(q,H){return this.e.get(q)?.get(H)}}class we{constructor(q,H){this.f=q,this.g=H,this.d=new L.$hQ(""),this.e=new Map}async prepareSession(q,H,X){const Z=this.f.getDocument(q),de=i.Position.to(H),be=await this.g.prepareTypeHierarchy(Z,de,X);if(!be)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(be)?be.map(He=>this.h(Oe,He)):[this.h(Oe,be)]}async provideSupertypes(q,H,X){const Z=this.j(q,H);if(!Z)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(Z,X);if(de)return de.map(be=>this.h(q,be))}async provideSubtypes(q,H,X){const Z=this.j(q,H);if(!Z)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(Z,X);if(de)return de.map(be=>this.h(q,be))}releaseSession(q){this.e.delete(q)}h(q,H){const X=this.e.get(q),Z=i.TypeHierarchyItem.from(H,q,X.size.toString(36));return X.set(Z._itemId,H),Z}j(q,H){return this.e.get(q)?.get(H)}}class Fe{constructor(q,H,X,Z,de){this.e=q,this.f=H,this.g=X,this.h=Z,this.j=de,this.d=new o.$Voc("DocumentDropEdit")}async provideDocumentOnDropEdits(q,H,X,Z,de){const be=this.f.getDocument(H),Oe=i.Position.to(X),He=i.DataTransfer.toDataTransfer(Z,async st=>(await this.e.$resolveDocumentOnDropFileData(this.h,q,st)).buffer),Qe=await this.g.provideDocumentDropEdits(be,Oe,He,de);if(!Qe)return;const _e=(0,r.$1b)(Qe),nt=this.d.add(_e);return _e.map((st,rt)=>({_cacheId:[nt,rt],title:st.title??(0,$.localize)(10742,null,this.j.displayName||this.j.name),kind:st.kind?.value,yieldTo:st.yieldTo?.map(at=>at.value),insertText:typeof st.insertText=="string"?st.insertText:{snippet:st.insertText.value},additionalEdit:st.additionalEdit?i.WorkspaceEdit.from(st.additionalEdit,void 0):void 0}))}async resolveDropEdit(q,H){const[X,Z]=q,de=this.d.get(X,Z);if(!de||!this.g.resolveDocumentDropEdit)return{};const be=await this.g.resolveDocumentDropEdit(de,H)??de;return{additionalEdit:be.additionalEdit?i.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}releaseDropEdits(q){this.d.delete(q)}}class ze{constructor(q,H){this.d=q,this.e=H}async provideMappedEdits(q,H,X,Z){const de=u.URI.revive(q),be=this.d.getDocument(de),Oe=X.documents.map(_e=>_e.map(nt=>({uri:u.URI.revive(nt.uri),version:nt.version,ranges:nt.ranges.map(st=>i.Range.to(st))}))),He={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(be,H,He,Z);return Qe?i.WorkspaceEdit.from(Qe):null}}class Ce{constructor(q,H){this.adapter=q,this.extension=H}}class Ie{static{this.d=0}constructor(q,H,X,Z,de,be,Oe,He){this.g=H,this.h=X,this.j=Z,this.k=de,this.l=be,this.m=Oe,this.n=He,this.f=new Map,this.e=q.getProxy(n.$DN.MainThreadLanguageFeatures)}o(q,H){return i.DocumentSelector.from(q,this.g,H)}p(q){return new s.$FN(()=>{this.f.delete(q),this.e.$unregister(q)})}q(){return Ie.d++}async s(q,H,X,Z,de,be=!1){const Oe=this.f.get(q);if(!Oe||!(Oe.adapter instanceof H))return Z;const He=Date.now();be||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const Qe=X(Oe.adapter,Oe.extension);return Promise.resolve(Qe).catch(_e=>{(0,R.$3)(_e)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Oe.extension.identifier,_e))}).finally(()=>{be||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),C.CancellationToken.isCancellationToken(de)?(0,h.$rh)(Qe,de):Qe}t(q,H){const X=this.q();return this.f.set(X,new Ce(q,H)),X}static u(q){return q.displayName||q.name}static w(q){return q.identifier.value}registerDocumentSymbolProvider(q,H,X,Z){const de=this.t(new d(this.h,X),q),be=Z&&Z.label||Ie.u(q);return this.e.$registerDocumentSymbolProvider(de,this.o(H,q),be),this.p(de)}$provideDocumentSymbols(q,H,X){return this.s(q,d,Z=>Z.provideDocumentSymbols(u.URI.revive(H),X),void 0,X)}registerCodeLensProvider(q,H,X){const Z=this.q(),de=typeof X.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Z,new Ce(new l(this.h,this.j.converter,X,q,this.n,this.l),q)),this.e.$registerCodeLensSupport(Z,this.o(H,q),de);let be=this.p(Z);if(de!==void 0){const Oe=X.onDidChangeCodeLenses(He=>this.e.$emitCodeLensEvent(de));be=s.$FN.from(be,Oe)}return be}$provideCodeLenses(q,H,X){return this.s(q,l,Z=>Z.provideCodeLenses(u.URI.revive(H),X),void 0,X)}$resolveCodeLens(q,H,X){return this.s(q,l,Z=>Z.resolveCodeLens(H,X),void 0,void 0)}$releaseCodeLenses(q,H){this.s(q,l,X=>Promise.resolve(X.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(q,H,X){const Z=this.t(new E(this.h,X),q);return this.e.$registerDefinitionSupport(Z,this.o(H,q)),this.p(Z)}$provideDefinition(q,H,X,Z){return this.s(q,E,de=>de.provideDefinition(u.URI.revive(H),X,Z),[],Z)}registerDeclarationProvider(q,H,X){const Z=this.t(new D(this.h,X),q);return this.e.$registerDeclarationSupport(Z,this.o(H,q)),this.p(Z)}$provideDeclaration(q,H,X,Z){return this.s(q,D,de=>de.provideDeclaration(u.URI.revive(H),X,Z),[],Z)}registerImplementationProvider(q,H,X){const Z=this.t(new y(this.h,X),q);return this.e.$registerImplementationSupport(Z,this.o(H,q)),this.p(Z)}$provideImplementation(q,H,X,Z){return this.s(q,y,de=>de.provideImplementation(u.URI.revive(H),X,Z),[],Z)}registerTypeDefinitionProvider(q,H,X){const Z=this.t(new k(this.h,X),q);return this.e.$registerTypeDefinitionSupport(Z,this.o(H,q)),this.p(Z)}$provideTypeDefinition(q,H,X,Z){return this.s(q,k,de=>de.provideTypeDefinition(u.URI.revive(H),X,Z),[],Z)}registerHoverProvider(q,H,X,Z){const de=this.t(new A(this.h,X),q);return this.e.$registerHoverProvider(de,this.o(H,q)),this.p(de)}$provideHover(q,H,X,Z,de){return this.s(q,A,be=>be.provideHover(u.URI.revive(H),X,Z,de),void 0,de)}$releaseHover(q,H){this.s(q,A,X=>Promise.resolve(X.releaseHover(H)),void 0,void 0)}registerEvaluatableExpressionProvider(q,H,X,Z){const de=this.t(new p(this.h,X),q);return this.e.$registerEvaluatableExpressionProvider(de,this.o(H,q)),this.p(de)}$provideEvaluatableExpression(q,H,X,Z){return this.s(q,p,de=>de.provideEvaluatableExpression(u.URI.revive(H),X,Z),void 0,Z)}registerInlineValuesProvider(q,H,X,Z){const de=typeof X.onDidChangeInlineValues=="function"?this.q():void 0,be=this.t(new v(this.h,X),q);this.e.$registerInlineValuesProvider(be,this.o(H,q),de);let Oe=this.p(be);if(de!==void 0){const He=X.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(de));Oe=s.$FN.from(Oe,He)}return Oe}$provideInlineValues(q,H,X,Z,de){return this.s(q,v,be=>be.provideInlineValues(u.URI.revive(H),X,Z,de),void 0,de)}registerDocumentHighlightProvider(q,H,X){const Z=this.t(new F(this.h,X),q);return this.e.$registerDocumentHighlightProvider(Z,this.o(H,q)),this.p(Z)}registerMultiDocumentHighlightProvider(q,H,X){const Z=this.t(new N(this.h,X),q);return this.e.$registerMultiDocumentHighlightProvider(Z,this.o(H,q)),this.p(Z)}$provideDocumentHighlights(q,H,X,Z){return this.s(q,F,de=>de.provideDocumentHighlights(u.URI.revive(H),X,Z),void 0,Z)}$provideMultiDocumentHighlights(q,H,X,Z,de){return this.s(q,N,be=>be.provideMultiDocumentHighlights(u.URI.revive(H),X,Z.map(Oe=>u.URI.revive(Oe)),de),void 0,de)}registerLinkedEditingRangeProvider(q,H,X){const Z=this.t(new O(this.h,X),q);return this.e.$registerLinkedEditingRangeProvider(Z,this.o(H,q)),this.p(Z)}$provideLinkedEditingRanges(q,H,X,Z){return this.s(q,O,async de=>{const be=await de.provideLinkedEditingRanges(u.URI.revive(H),X,Z);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?Ie.y(be.wordPattern):void 0}},void 0,Z)}registerReferenceProvider(q,H,X){const Z=this.t(new j(this.h,X),q);return this.e.$registerReferenceSupport(Z,this.o(H,q)),this.p(Z)}$provideReferences(q,H,X,Z,de){return this.s(q,j,be=>be.provideReferences(u.URI.revive(H),X,Z,de),void 0,de)}registerCodeActionProvider(q,H,X,Z){const de=new T.$Sc,be=this.t(new z(this.h,this.j.converter,this.k,X,this.l,q,this.m),q);return this.e.$registerCodeActionSupport(be,this.o(H,q),{providedKinds:Z?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:Z?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,de)}))},Ie.u(q),Ie.w(q),!!X.resolveCodeAction),de.add(this.p(be)),de}$provideCodeActions(q,H,X,Z,de){return this.s(q,z,be=>be.provideCodeActions(u.URI.revive(H),X,Z,de),void 0,de)}$resolveCodeAction(q,H,X){return this.s(q,z,Z=>Z.resolveCodeAction(H,X),{},void 0)}$releaseCodeActions(q,H){this.s(q,z,X=>Promise.resolve(X.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(q,H,X){const Z=this.t(new W(this.h,X),q);return this.e.$registerDocumentFormattingSupport(Z,this.o(H,q),q.identifier,q.displayName||q.name),this.p(Z)}$provideDocumentFormattingEdits(q,H,X,Z){return this.s(q,W,de=>de.provideDocumentFormattingEdits(u.URI.revive(H),X,Z),void 0,Z)}registerDocumentRangeFormattingEditProvider(q,H,X){const Z=typeof X.provideDocumentRangesFormattingEdits=="function",de=this.t(new V(this.h,X),q);return this.e.$registerRangeFormattingSupport(de,this.o(H,q),q.identifier,q.displayName||q.name,Z),this.p(de)}$provideDocumentRangeFormattingEdits(q,H,X,Z,de){return this.s(q,V,be=>be.provideDocumentRangeFormattingEdits(u.URI.revive(H),X,Z,de),void 0,de)}$provideDocumentRangesFormattingEdits(q,H,X,Z,de){return this.s(q,V,be=>be.provideDocumentRangesFormattingEdits(u.URI.revive(H),X,Z,de),void 0,de)}registerOnTypeFormattingEditProvider(q,H,X,Z){const de=this.t(new ne(this.h,X),q);return this.e.$registerOnTypeFormattingSupport(de,this.o(H,q),Z,q.identifier),this.p(de)}$provideOnTypeFormattingEdits(q,H,X,Z,de,be){return this.s(q,ne,Oe=>Oe.provideOnTypeFormattingEdits(u.URI.revive(H),X,Z,de,be),void 0,be)}registerWorkspaceSymbolProvider(q,H){const X=this.t(new B(H,this.l),q);return this.e.$registerNavigateTypeSupport(X,typeof H.resolveWorkspaceSymbol=="function"),this.p(X)}$provideWorkspaceSymbols(q,H,X){return this.s(q,B,Z=>Z.provideWorkspaceSymbols(H,X),{symbols:[]},X)}$resolveWorkspaceSymbol(q,H,X){return this.s(q,B,Z=>Z.resolveWorkspaceSymbol(H,X),void 0,void 0)}$releaseWorkspaceSymbols(q,H){this.s(q,B,X=>X.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(q,H,X){const Z=this.t(new K(this.h,X,this.l),q);return this.e.$registerRenameSupport(Z,this.o(H,q),K.supportsResolving(X)),this.p(Z)}$provideRenameEdits(q,H,X,Z,de){return this.s(q,K,be=>be.provideRenameEdits(u.URI.revive(H),X,Z,de),void 0,de)}$resolveRenameLocation(q,H,X,Z){return this.s(q,K,de=>de.resolveRenameLocation(u.URI.revive(H),X,Z),void 0,Z)}registerNewSymbolNamesProvider(q,H,X){const Z=this.t(new Y(this.h,X,this.l),q);return this.e.$registerNewSymbolNamesProvider(Z,this.o(H,q)),this.p(Z)}$supportsAutomaticNewSymbolNamesTriggerKind(q){return this.s(q,Y,H=>H.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(q,H,X,Z,de){return this.s(q,Y,be=>be.provideNewSymbolNames(u.URI.revive(H),X,Z,de),void 0,de)}registerDocumentSemanticTokensProvider(q,H,X,Z){const de=this.t(new ue(this.h,X),q),be=typeof X.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(H,q),Z,be);let Oe=this.p(de);if(be){const He=X.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(be));Oe=s.$FN.from(Oe,He)}return Oe}$provideDocumentSemanticTokens(q,H,X,Z){return this.s(q,ue,de=>de.provideDocumentSemanticTokens(u.URI.revive(H),X,Z),null,Z)}$releaseDocumentSemanticTokens(q,H){this.s(q,ue,X=>X.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,H,X,Z){const de=this.t(new re(this.h,X),q);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(H,q),Z),this.p(de)}$provideDocumentRangeSemanticTokens(q,H,X,Z){return this.s(q,re,de=>de.provideDocumentRangeSemanticTokens(u.URI.revive(H),X,Z),null,Z)}registerCompletionItemProvider(q,H,X,Z){const de=this.t(new ye(this.h,this.j.converter,X,this.m,q),q);return this.e.$registerCompletionsProvider(de,this.o(H,q),Z,ye.supportsResolving(X),q.identifier),this.p(de)}$provideCompletionItems(q,H,X,Z,de){return this.s(q,ye,be=>be.provideCompletionItems(u.URI.revive(H),X,Z,de),void 0,de)}$resolveCompletionItem(q,H,X){return this.s(q,ye,Z=>Z.resolveCompletionItem(H,X),void 0,X)}$releaseCompletionItems(q,H){this.s(q,ye,X=>X.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(q,H,X,Z){const de=new J(q,this.h,X,this.j.converter),be=this.t(de,q);return this.e.$registerInlineCompletionsSupport(be,this.o(H,q),de.supportsHandleEvents,f.$on.toKey(q.identifier.value),Z?.yieldTo?.map(Oe=>f.$on.toKey(Oe))||[]),this.p(be)}$provideInlineCompletions(q,H,X,Z,de){return this.s(q,me,be=>be.provideInlineCompletions(u.URI.revive(H),X,Z,de),void 0,de)}$provideInlineEdits(q,H,X,Z,de){return this.s(q,me,be=>be.provideInlineEdits(u.URI.revive(H),X,Z,de),void 0,de)}$handleInlineCompletionDidShow(q,H,X,Z){this.s(q,me,async de=>{de.handleDidShowCompletionItem(H,X,Z)},void 0,void 0)}$handleInlineCompletionPartialAccept(q,H,X,Z,de){this.s(q,me,async be=>{be.handlePartialAccept(H,X,Z,de)},void 0,void 0)}$freeInlineCompletionsList(q,H){this.s(q,me,async X=>{X.disposeCompletions(H)},void 0,void 0)}registerInlineEditProvider(q,H,X){const Z=new U(q,this.h,X,this.j.converter),de=this.t(Z,q);return this.e.$registerInlineEditProvider(de,this.o(H,q),q.identifier),this.p(de)}$provideInlineEdit(q,H,X,Z){return this.s(q,U,de=>de.provideInlineEdits(u.URI.revive(H),X,Z),void 0,Z)}$freeInlineEdit(q,H){this.s(q,U,async X=>{X.disposeEdit(H)},void 0,void 0)}registerSignatureHelpProvider(q,H,X,Z){const de=Array.isArray(Z)?{triggerCharacters:Z,retriggerCharacters:[]}:Z,be=this.t(new ae(this.h,X),q);return this.e.$registerSignatureHelpProvider(be,this.o(H,q),de),this.p(be)}$provideSignatureHelp(q,H,X,Z,de){return this.s(q,ae,be=>be.provideSignatureHelp(u.URI.revive(H),X,Z,de),void 0,de)}$releaseSignatureHelp(q,H){this.s(q,ae,X=>X.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(q,H,X){const Z=typeof X.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new te(this.h,this.j.converter,X,this.l,q),q);this.e.$registerInlayHintsProvider(de,this.o(H,q),typeof X.resolveInlayHint=="function",Z,Ie.u(q));let be=this.p(de);if(Z!==void 0){const Oe=X.onDidChangeInlayHints(He=>this.e.$emitInlayHintsEvent(Z));be=s.$FN.from(be,Oe)}return be}$provideInlayHints(q,H,X,Z){return this.s(q,te,de=>de.provideInlayHints(u.URI.revive(H),X,Z),void 0,Z)}$resolveInlayHint(q,H,X){return this.s(q,te,Z=>Z.resolveInlayHint(H,X),void 0,X)}$releaseInlayHints(q,H){this.s(q,te,X=>X.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(q,H,X){const Z=this.t(new ce(this.h,X),q);return this.e.$registerDocumentLinkProvider(Z,this.o(H,q),typeof X.resolveDocumentLink=="function"),this.p(Z)}$provideDocumentLinks(q,H,X){return this.s(q,ce,Z=>Z.provideLinks(u.URI.revive(H),X),void 0,X,H.scheme==="output")}$resolveDocumentLink(q,H,X){return this.s(q,ce,Z=>Z.resolveLink(H,X),void 0,void 0,!0)}$releaseDocumentLinks(q,H){this.s(q,ce,X=>X.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(q,H,X){const Z=this.t(new le(this.h,X),q);return this.e.$registerDocumentColorProvider(Z,this.o(H,q)),this.p(Z)}$provideDocumentColors(q,H,X){return this.s(q,le,Z=>Z.provideColors(u.URI.revive(H),X),[],X)}$provideColorPresentations(q,H,X,Z){return this.s(q,le,de=>de.provideColorPresentations(u.URI.revive(H),X,Z),void 0,Z)}registerFoldingRangeProvider(q,H,X){const Z=this.q(),de=typeof X.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Z,new Ce(new x(this.h,X),q)),this.e.$registerFoldingRangeProvider(Z,this.o(H,q),q.identifier,de);let be=this.p(Z);if(de!==void 0){const Oe=X.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));be=s.$FN.from(be,Oe)}return be}$provideFoldingRanges(q,H,X,Z){return this.s(q,x,de=>de.provideFoldingRanges(u.URI.revive(H),X,Z),void 0,Z)}registerSelectionRangeProvider(q,H,X){const Z=this.t(new oe(this.h,X,this.l),q);return this.e.$registerSelectionRangeProvider(Z,this.o(H,q)),this.p(Z)}$provideSelectionRanges(q,H,X,Z){return this.s(q,oe,de=>de.provideSelectionRanges(u.URI.revive(H),X,Z),[],Z)}registerCallHierarchyProvider(q,H,X){const Z=this.t(new pe(this.h,X),q);return this.e.$registerCallHierarchyProvider(Z,this.o(H,q)),this.p(Z)}$prepareCallHierarchy(q,H,X,Z){return this.s(q,pe,de=>Promise.resolve(de.prepareSession(u.URI.revive(H),X,Z)),void 0,Z)}$provideCallHierarchyIncomingCalls(q,H,X,Z){return this.s(q,pe,de=>de.provideCallsTo(H,X,Z),void 0,Z)}$provideCallHierarchyOutgoingCalls(q,H,X,Z){return this.s(q,pe,de=>de.provideCallsFrom(H,X,Z),void 0,Z)}$releaseCallHierarchy(q,H){this.s(q,pe,X=>Promise.resolve(X.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(q,H,X){const Z=this.t(new we(this.h,X),q);return this.e.$registerTypeHierarchyProvider(Z,this.o(H,q)),this.p(Z)}$prepareTypeHierarchy(q,H,X,Z){return this.s(q,we,de=>Promise.resolve(de.prepareSession(u.URI.revive(H),X,Z)),void 0,Z)}$provideTypeHierarchySupertypes(q,H,X,Z){return this.s(q,we,de=>de.provideSupertypes(H,X,Z),void 0,Z)}$provideTypeHierarchySubtypes(q,H,X,Z){return this.s(q,we,de=>de.provideSubtypes(H,X,Z),void 0,Z)}$releaseTypeHierarchy(q,H){this.s(q,we,X=>Promise.resolve(X.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(q,H,X,Z){const de=this.q();return this.f.set(de,new Ce(new Fe(this.e,this.h,X,de,q),q)),this.e.$registerDocumentOnDropEditProvider(de,this.o(H,q),(0,t.$cH)(q,"documentPaste")&&Z?{supportsResolve:!!X.resolveDocumentDropEdit,dropMimeTypes:Z.dropMimeTypes}:void 0),this.p(de)}$provideDocumentOnDropEdits(q,H,X,Z,de,be){return this.s(q,Fe,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(H,u.URI.revive(X),Z,de,be)),void 0,void 0)}$resolveDropEdit(q,H,X){return this.s(q,Fe,Z=>Z.resolveDropEdit(H,X),{},void 0)}$releaseDocumentOnDropEdits(q,H){this.s(q,Fe,X=>Promise.resolve(X.releaseDropEdits(H)),void 0,void 0)}registerMappedEditsProvider(q,H,X){const Z=this.t(new ze(this.h,X),q);return this.e.$registerMappedEditsProvider(Z,this.o(H,q),q.displayName??q.name),this.p(Z)}$provideMappedEdits(q,H,X,Z,de){return this.s(q,ze,be=>Promise.resolve(be.provideMappedEdits(H,X,Z,de)),null,de)}registerDocumentPasteEditProvider(q,H,X,Z){const de=this.q();return this.f.set(de,new Ce(new M(this.e,this.h,X,de,q),q)),this.e.$registerPasteEditProvider(de,this.o(H,q),{supportsCopy:!!X.prepareDocumentPaste,supportsPaste:!!X.provideDocumentPasteEdits,supportsResolve:!!X.resolveDocumentPasteEdit,providedPasteEditKinds:Z.providedPasteEditKinds?.map(be=>be.value),copyMimeTypes:Z.copyMimeTypes,pasteMimeTypes:Z.pasteMimeTypes}),this.p(de)}$prepareDocumentPaste(q,H,X,Z,de){return this.s(q,M,be=>be.prepareDocumentPaste(u.URI.revive(H),X,Z,de),void 0,de)}$providePasteEdits(q,H,X,Z,de,be,Oe){return this.s(q,M,He=>He.providePasteEdits(H,u.URI.revive(X),Z,de,be,Oe),void 0,Oe)}$resolvePasteEdit(q,H,X){return this.s(q,M,Z=>Z.resolvePasteEdit(H,X),{},void 0)}$releasePasteEdits(q,H){this.s(q,M,X=>Promise.resolve(X.releasePasteEdits(H)),void 0,void 0)}static y(q){return{pattern:q.source,flags:q.flags}}static z(q){return{decreaseIndentPattern:Ie.y(q.decreaseIndentPattern),increaseIndentPattern:Ie.y(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Ie.y(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Ie.y(q.unIndentedLinePattern):void 0}}static B(q){return{beforeText:Ie.y(q.beforeText),afterText:q.afterText?Ie.y(q.afterText):void 0,previousLineText:q.previousLineText?Ie.y(q.previousLineText):void 0,action:q.action}}static C(q){return q.map(Ie.B)}static D(q){return{open:q.open,close:q.close,notIn:q.notIn?q.notIn.map(H=>s.SyntaxTokenType.toString(H)):void 0}}static E(q){return q.map(Ie.D)}setLanguageConfiguration(q,H,X){const{wordPattern:Z}=X;if(Z&&(0,I.$pf)(Z))throw new Error(`Invalid language configuration: wordPattern '${Z}' is not allowed to match the empty string.`);Z?this.h.setWordDefinitionFor(H,Z):this.h.setWordDefinitionFor(H,void 0),X.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),X.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const de=this.q(),be={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Ie.y(X.wordPattern):void 0,indentationRules:X.indentationRules?Ie.z(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Ie.C(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport,autoClosingPairs:X.autoClosingPairs?Ie.E(X.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(de,H,be),this.p(de)}$setWordDefinitions(q){for(const H of q)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.$6oc=Ie}),define(Se[305],De([1,0,3,6,15]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=void 0,C=Ue(C);class R{constructor(T){this.a=new Map,this.c=new Map,this.b=T.getProxy(h.$DN.MainThreadLanguageModelTools),this.b.$getTools().then(b=>{for(const c of b)this.c.set(c.name,c)})}async invokeTool(T,b,c){return await this.b.$invokeTool(T,b,c)}async $acceptToolDelta(T){T.added&&this.c.set(T.added.name,T.added),T.removed&&this.c.delete(T.removed)}get tools(){return Array.from(this.c.values()).map(T=>C.LanguageModelToolDescription.to(T))}async $invokeTool(T,b,c){const I=this.a.get(T);if(!I)throw new Error(`Unknown tool ${T}`);return await I.tool.invoke(b,c)}registerTool(T,b,c){return this.a.set(b,{extension:T,tool:c}),this.b.$registerTool(b),(0,r.$Rc)(()=>{this.a.delete(b),this.b.$unregisterTool(b)})}}e.$xqc=R}),define(Se[128],De([1,0,7,20,52,13,4,39,3,8,23,5,11,89,6,127,19,15,9,156,25]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Npc=e.$Mpc=void 0,$=Ue($),f=Ue(f),e.$Mpc=(0,S.$Ci)("IExtHostLanguageModels");class o{constructor(g,E){this.option=g,this.stream=new r.$6h,this.stream=E??new r.$6h}}class n{constructor(){this.a=new Map,this.b=new r.$6h,this.c=!1;const g=this;this.apiObject={get stream(){return g.b.asyncIterable},get text(){return r.$3h.map(g.b.asyncIterable,E=>{if(E instanceof f.$YP)return E.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,g]of this.a)yield g.stream;else yield this.b}handleFragment(g){if(this.c)return;let E=this.a.get(g.index);E||(this.a.size===0?E=new o(g.index,this.b):E=new o(g.index),this.a.set(g.index,E));let D;g.part.type==="text"?D=new f.$YP(g.part.value):D=new f.$XP(g.part.name,g.part.parameters),E.stream.emitOne(D)}reject(g){this.c=!0;for(const E of this.d())E.reject(g)}resolve(){this.c=!0;for(const g of this.d())g.resolve()}}let d=class{static{t=this}static{this.a=1}constructor(g,E,D){this.j=E,this.k=D,this.c=new L.$je,this.d=new L.$je,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$qn,this.i=new Map,this.s=new Set,this.b=g.getProxy(w.$DN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(g,E,D,y){const k=t.a++;this.f.set(k,{extension:g.identifier,provider:D,languageModelId:E});let A;y.auth&&(A={providerLabel:g.displayName||g.name,accountLabel:typeof y.auth=="object"?y.auth.label:void 0}),this.b.$registerLanguageModelProvider(k,`${I.$on.toKey(g.identifier)}/${k}/${E}`,{extension:g.identifier,id:E,vendor:y.vendor??I.$on.toKey(g.identifier),name:y.name??"",family:y.family??"",version:y.version,maxInputTokens:y.maxInputTokens,maxOutputTokens:y.maxOutputTokens,auth:A,targetExtensions:y.extensions});const p=D.onDidReceiveLanguageModelResponse2?.(({extensionId:v,participant:F,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(E,new I.$on(v),F,N)});return(0,b.$Rc)(()=>{this.f.delete(k),this.b.$unregisterProvider(k),p?.dispose()})}async $startChatRequest(g,E,D,y,k,A){const p=this.f.get(g);if(!p)throw new Error("Provider not found");const v=new P.$ww(async N=>{if(A.isCancellationRequested){this.j.warn(`[CHAT](${p.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let O;if(N.part instanceof f.$XP?O={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof f.$YP&&(O={type:"text",value:N.part.value}),!O){this.j.warn(`[CHAT](${p.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this.b.$reportResponsePart(E,{index:N.index,part:O})});let F;if(p.provider.provideLanguageModelResponse2)F=Promise.resolve(p.provider.provideLanguageModelResponse2(y.map($.LanguageModelChatMessage.to),k,I.$on.toKey(D),v,A));else{const N=new P.$ww(async O=>{v.report({index:O.index,part:new f.$YP(O.part)})});F=Promise.resolve(p.provider.provideLanguageModelResponse(y.map($.LanguageModelChatMessage.to),k?.modelOptions??{},I.$on.toKey(D),N,A))}F.then(()=>{this.b.$reportResponseDone(E,void 0)},N=>{this.b.$reportResponseDone(E,(0,R.$1)(N))})}$provideTokenLength(g,E,D){const y=this.f.get(g);return y?Promise.resolve(y.provider.provideTokenCount(E,D)):Promise.resolve(0)}$acceptChatModelMetadata(g){if(g.added)for(const{identifier:E,metadata:D}of g.added)this.g.set(E,{metadata:D,apiObjects:new I.$qn});if(g.removed)for(const E of g.removed){this.g.delete(E);for(const[D,y]of this.i)y.languageModelId===E&&(y.res.reject(new R.$4),this.i.delete(D))}g.added?.forEach(E=>this.q(E.metadata)),this.d.fire(void 0)}async selectLanguageModels(g,E){const D=await this.b.$selectChatModels({...E,extension:g.identifier}),y=[],k=this;for(const A of D){const p=this.g.get(A);if(!p)continue;this.o(g.identifier,p.metadata)&&await this.q(p.metadata);let v=p.apiObjects.get(g.identifier);v||(v={id:A,vendor:p.metadata.vendor,family:p.metadata.family,version:p.metadata.version,name:p.metadata.name,maxInputTokens:p.metadata.maxInputTokens,countTokens(F,N){if(!k.g.has(A))throw f.$3P.NotFound(A);return k.r(A,F,N??h.CancellationToken.None)},sendRequest(F,N,O){if(!k.g.has(A))throw f.$3P.NotFound(A);return k.l(g,A,F,N??{},O??h.CancellationToken.None)}},Object.freeze(v),p.apiObjects.set(g.identifier,v)),y.push(v)}return y}async l(g,E,D,y,k){const A=this.m(g,D),p=g.identifier,v=this.g.get(E)?.metadata;if(!v||!this.g.has(E))throw f.$3P.NotFound(`Language model '${E}' is unknown.`);if(this.o(p,v)&&(!await this.n(g,{identifier:v.extension,displayName:v.auth.providerLabel},y.justification,!1)||!this.h.get(p)?.has(v.extension)))throw f.$3P.NoPermissions(`Language model '${E}' cannot be used by '${p.value}'.`);try{const F=Math.random()*1e6|0,N=new n;this.i.set(F,{languageModelId:E,res:N});try{await this.b.$tryStartChatRequest(p,E,F,A,y,k)}catch(O){throw this.i.delete(F),O}return N.apiObject}catch(F){throw F.name===f.$3P.name?F:new f.$3P(`Language model '${E}' errored: ${(0,C.$nj)(F)}`,"Unknown",F)}}m(g,E){const D=[];for(const y of E)y.role===f.LanguageModelChatMessageRole.System&&(0,s.$dH)(g,"languageModelSystem"),y.content2 instanceof f.$VP&&(0,s.$dH)(g,"lmTools"),D.push($.LanguageModelChatMessage.from(y));return D}async $acceptResponsePart(g,E){const D=this.i.get(g);D&&D.res.handleFragment(E)}async $acceptResponseDone(g,E){const D=this.i.get(g);D&&(this.i.delete(g),E?D.res.reject((0,R.$2)(E)):D.res.resolve())}async n(g,E,D,y){const k=i.$FM+E.identifier.value;if(await this.k.getSession(g,k,[],{silent:!0}))return this.$updateModelAccesslist([{from:g.identifier,to:E.identifier,enabled:!0}]),!0;if(y)return!1;try{const p=D?(0,c.localize)(10740,null,E.displayName,D):void 0;return await this.k.getSession(g,k,[],{forceNewSession:{detail:p}}),this.$updateModelAccesslist([{from:g.identifier,to:E.identifier,enabled:!0}]),!0}catch{return!1}}o(g,E){return!!E.auth&&!I.$on.equals(E.extension,g)}async q(g){if(g.auth)for(const E of this.s)try{await this.n(E,{identifier:g.extension,displayName:""},void 0,!0)}catch(D){this.j.error("Fake Auth request failed"),this.j.error(D)}}async r(g,E,D){if(!this.g.get(g))throw f.$3P.NotFound(`Language model '${g}' is unknown.`);const k=T.Iterable.find(this.f.values(),A=>A.languageModelId===g);return k?k.provider.provideTokenCount(E,D):this.b.$countTokens(g,typeof E=="string"?E:$.LanguageModelChatMessage.from(E),D)}$updateModelAccesslist(g){const E=new Array;for(const{from:D,to:y,enabled:k}of g){const A=this.h.get(D)??new I.$pn;if(A.has(y)!==k){k?A.add(y):A.delete(y),this.h.set(D,A);const v={from:D,to:y};E.push(v),this.c.fire(v)}}}createLanguageModelAccessInformation(g){this.s.add(g);const E=this,D=L.Event.signal(L.Event.filter(this.c.event,k=>I.$on.equals(k.from,g.identifier))),y=L.Event.signal(this.d.event);return{get onDidChange(){return L.Event.any(D,y)},canSendRequest(k){let A;e:for(const[v,F]of E.g)for(const N of F.apiObjects.values())if(N===k){A=F.metadata;break e}if(!A)return;if(!E.o(g.identifier,A))return!0;const p=E.h.get(g.identifier);if(p)return p.has(A.extension)}}}};e.$Npc=d,e.$Npc=d=t=Ye([Ve(0,m.$cQ),Ve(1,u.$0j),Ve(2,a.$8oc)],d)});var Wt=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Se[306],De([1,0,6,15,9,43,7,3,25]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=void 0,h=Ue(h),R=Wt(R);class c{constructor(S,u,P,w){this.c=u,this.d=P,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(r.$DN.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,u){await this.a.$changeLanguage(S,u);const P=this.c.getDocumentData(S);if(!P)throw new Error(`document '${S.toString()}' NOT found`);return P.document}async tokenAtPosition(S,u){const P=S.version,w=h.Position.from(u),a=await this.a.$tokensAtPosition(S.uri,w),m={type:C.StandardTokenType.Other,range:S.getWordRangeAtPosition(u)??new C.$HN(u.line,u.character,u.line,u.character)};if(!a)return m;const $={range:h.Range.to(a.range),type:h.TokenType.to(a.type)};return!$.range.contains(u)||P!==S.version?m:$}createLanguageStatusItem(S,u,P){const w=this.f++,a=this.a,m=this.g,$=`${S.identifier.value}/${u}`;if(m.has($))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);m.add($);const f={selector:P,id:u,name:S.displayName??S.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const s=new T.$Sc,t=()=>{if(i?.dispose(),!m.has($)){console.warn(`LanguageStatusItem (${u}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,L.$Eh)(()=>{s.clear(),this.a.$setLanguageStatus(w,{id:$,name:f.name??S.displayName??S.name,source:S.displayName??S.name,selector:h.DocumentSelector.from(f.selector,this.e),label:f.text,detail:f.detail??"",severity:f.severity===C.LanguageStatusSeverity.Error?R.default.Error:f.severity===C.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:f.command&&this.d.toInternal(f.command,s),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},o={dispose(){s.dispose(),i?.dispose(),a.$removeLanguageStatus(w),m.delete($)},get id(){return f.id},get name(){return f.name},set name(n){f.name=n,t()},get selector(){return f.selector},set selector(n){f.selector=n,t()},get text(){return f.text},set text(n){f.text=n,t()},set text2(n){(0,b.$dH)(S,"languageStatusText"),f.text=n,t()},get text2(){return(0,b.$dH)(S,"languageStatusText"),f.text},get detail(){return f.detail},set detail(n){f.detail=n,t()},get severity(){return f.severity},set severity(n){f.severity=n,t()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(n){f.accessibilityInformation=n,t()},get command(){return f.command},set command(n){f.command=n,t()},get busy(){return f.busy},set busy(n){f.busy=n,t()}};return t(),o}}e.$yqc=c}),define(Se[307],De([1,0,14,2,15,9,126]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=e.$jqc=void 0,C=Ue(C),L=Ue(L);class T{constructor(S,u,P,w){this.start=S,this.deletedCount=u,this.deletedItems=P,this.items=w}asApiEvent(){return{range:new R.$0O(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class b{static asModelAddData(S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1}}constructor(S,u,P){this.notebook=S,this.h=u,this.j=P,this.handle=P.handle,this.uri=h.URI.revive(P.uri),this.cellKind=P.cellKind,this.a=P.outputs.map(C.NotebookCellOutput.to),this.e=P.internalMetadata??{},this.b=Object.freeze(P.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(P.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const P={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return S.g},set mime(w){S.g=w},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(P)}return this.f}setOutputs(S){this.a=S.map(C.NotebookCellOutput.to)}setOutputItems(S,u,P){const w=P.map(C.NotebookCellOutputItem.to),a=this.a.find(m=>m.id===S);if(a&&(u||(a.items.length=0),a.items.push(...w),a.items.length>1&&a.items.every(m=>L.$IL(m.mime)))){const m=new Map,$=[];a.items.forEach(f=>{let i;m.has(f.mime)?i=m.get(f.mime):(i=[],m.set(f.mime,i),$.push(f.mime)),i.push(f.data)}),a.items.length=0,$.forEach(f=>{const i=L.$JL(m.get(f));a.items.push({mime:f,data:i.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$jqc=b;class c{static{this.a=0}constructor(S,u,P,w,a){this.k=S,this.l=u,this.m=P,this.uri=w,this.handle=c.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,u={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===r.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(P){return P=S.n(P),S.b[P].apiCell},getCells(P){return(P?S.p(P):S.b).map(a=>a.apiCell)},save(){return S.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,u,P){this.g=S.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:P});const w={notebook:this.apiNotebook,metadata:P,cellChanges:[],contentChanges:[]},a=[];for(const $ of S.rawEvents)$.kind===L.NotebookCellsChangeType.ModelChange?this.r($.changes,!1,w.contentChanges):$.kind===L.NotebookCellsChangeType.Move?this.s($.index,$.length,$.newIdx,w.contentChanges):$.kind===L.NotebookCellsChangeType.Output?(this.t($.index,$.outputs),a.push({cell:this.b[$.index].apiCell,outputs:this.b[$.index].apiCell.outputs})):$.kind===L.NotebookCellsChangeType.OutputItem?(this.u($.index,$.outputId,$.append,$.outputItems),a.push({cell:this.b[$.index].apiCell,outputs:this.b[$.index].apiCell.outputs})):$.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v($.index,$.language),a.push({cell:this.b[$.index].apiCell,document:this.b[$.index].apiCell.document})):$.kind===L.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[$.index].apiCell,document:this.b[$.index].apiCell.document}):$.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w($.index,$.mime):$.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x($.index,$.metadata),a.push({cell:this.b[$.index].apiCell,metadata:this.b[$.index].apiCell.metadata})):$.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y($.index,$.internalMetadata),a.push({cell:this.b[$.index].apiCell,executionSummary:this.b[$.index].apiCell.executionSummary}));const m=new Map;for(let $=0;$<a.length;$++){const f=a[$],i=m.get(f.cell);if(i===void 0){const s=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...f});m.set(f.cell,s-1)}else w.cellChanges[i]={...w.cellChanges[i],...f}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let u=S.start|0,P=S.end|0;return u<0&&(u=0),P>this.b.length&&(P=this.b.length),S.with({start:u,end:P})}p(S){S=this.o(S);const u=[];for(let P=S.start;P<S.end;P++)u.push(this.b[P]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,u,P){if(this.j)return;const w=[],a=[],m=[];if(S.reverse().forEach($=>{const i=$[2].map(o=>{const n=new b(this,this.l,o);return u||a.push(b.asModelAddData(o)),n}),s=new T($[0],$[1],[],i),t=this.b.splice($[0],$[1],...i);for(const o of t)m.push(o.uri),s.deletedItems.push(o.apiCell);w.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:m}),P)for(const $ of w)P.push($.asApiEvent())}s(S,u,P,w){const a=this.b.splice(S,u);this.b.splice(P,0,...a);const m=[new T(S,u,a.map($=>$.apiCell),[]),new T(P,0,[],a)];for(const $ of m)w.push($.asApiEvent())}t(S,u){this.b[S].setOutputs(u)}u(S,u,P,w){this.b[S].setOutputItems(u,P,w)}v(S,u){const P=this.b[S];P.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(P.uri,u)}w(S,u){const P=this.b[S];P.apiCell.mime=u}x(S,u){this.b[S].setMetadata(u)}y(S,u){this.b[S].setInternalMetadata(u)}getCellFromApiCell(S){return this.b.find(u=>u.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(u=>u.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$kqc=c}),define(Se[308],De([1,0,4,2,15,9,53]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aqc=void 0;class T{constructor(c,I,S,u={timeout:1500,errors:3}){this.b=c,this.c=I,this.d=S,this.f=u,this.a=new r.$le}dispose(){}getOnWillSaveNotebookDocumentEvent(c){return(I,S,u)=>{const P=function(a){I.call(S,a)};return P.extension=c,this.a.event(P,void 0,u)}}async $participateInSave(c,I,S){const u=h.URI.revive(c),P=this.c.getNotebookDocument(u);if(!P)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:P.apiNotebook,reason:C.TextDocumentSaveReason.to(I)},S,async(m,$)=>{const f=Date.now(),i=await await Promise.resolve(m);Date.now()-f>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",$.extension.identifier),!S.isCancellationRequested&&i&&(i instanceof R.$RN?w.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",$.extension.identifier,"ignored due to invalid data"))}),S.isCancellationRequested)return!1;if(w.length===0)return!0;const a={edits:[]};for(const m of w){const{edits:$}=C.WorkspaceEdit.from(m);a.edits=a.edits.concat($)}return this.d.$tryApplyWorkspaceEdit(new L.$Uw(a))}}e.$Aqc=T}),define(Se[165],De([1,0,13,15,9]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lqc=void 0,h=Ue(h),C=Ue(C);class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,b,c,I,S,u){this.id=T,this.f=b,this.notebookData=c,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=I,this.c=u}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(b){this.selections=[b]},get selections(){return T.a},set selections(b){if(!Array.isArray(b)||!b.every(C.$0O.isNotebookRange))throw(0,r.$6)("selections");T.a=b,T.g(b)},get visibleRanges(){return T.b},revealRange(b,c){T.f.$tryRevealRange(T.id,h.NotebookRange.from(b),c??C.NotebookEditorRevealType.Default)},get viewColumn(){return T.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(h.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$lqc=R}),define(Se[309],De([1,0,4,11,15]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cqc=void 0,C=Ue(C);let R=class{constructor(T,b){this.c=T,this.d=b,this.a=new r.$je,this.b=new r.$je,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,b){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,b);const c=this.d.getEditorById(T);b.visibleRanges&&c._acceptVisibleRanges(b.visibleRanges.ranges.map(C.NotebookRange.to)),b.selections&&c._acceptSelections(b.selections.selections.map(C.NotebookRange.to)),b.visibleRanges&&this.b.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),b.selections&&this.a.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const b in T)this.d.getEditorById(b)._acceptViewColumn(C.ViewColumn.to(T[b]))}};e.$Cqc=R,e.$Cqc=R=Ye([Ve(0,h.$0j)],R)}),define(Se[310],De([1,0,4,6,165]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fqc=void 0;class R{constructor(T,b){this.c=b,this.a=new Map,this.b=T.getProxy(h.$DN.MainThreadNotebookRenderers)}$postRendererMessage(T,b,c){const I=this.c.getEditorById(T);this.a.get(b)?.fire({editor:I.apiEditor,message:c})}createRendererMessaging(T,b){if(!T.contributes?.notebookRenderer?.some(I=>I.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);return{onDidReceiveMessage:(I,S,u)=>this.d(b).event(I,S,u),postMessage:(I,S)=>{C.$lqc.apiEditorsToExtHost.has(I)&&([I,S]=[S,I]);const u=S&&C.$lqc.apiEditorsToExtHost.get(S);return this.b.$postMessage(u?.id,b,I)}}}d(T){let b=this.a.get(T);return b||(b=new r.$je({onDidRemoveLastListener:()=>{b?.dispose(),this.a.delete(T)}}),this.a.set(T,b),b)}}e.$Fqc=R}),define(Se[311],De([1,0,15,89,20,59,13]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jqc=void 0;class T{constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,u,P){const w=this.b++,{title:a,location:m,cancellable:$}=u,f={label:S.displayName||S.name,id:S.identifier.value};return this.a.$startProgress(w,{location:r.ProgressLocation.from(m),title:a,source:f,cancellable:$},S.isUnderDevelopment?void 0:S.identifier.value).catch(L.$Z),this.d(w,P,!!$)}d(S,u,P){let w;P&&(w=new C.$ue,this.c.set(S,w));const a=$=>{this.a.$progressEnd($),this.c.delete($),w?.dispose()};let m;try{m=u(new c(this.a,S),P&&w?w.token:C.CancellationToken.None)}catch($){throw a(S),$}return m.then($=>a(S),$=>a(S)),m}$acceptProgressCanceled(S){const u=this.c.get(S);u&&(u.cancel(),this.c.delete(S))}}e.$Jqc=T;function b(I,S){return I.message=S.message,typeof S.increment=="number"&&(typeof I.increment=="number"?I.increment+=S.increment:I.increment=S.increment),I}class c extends h.$ww{constructor(S,u){super(P=>this.throttledReport(P)),this.c=S,this.d=u}throttledReport(S){this.c.$progressReport(this.d,S)}}Ye([(0,R.$9h)(100,(I,S)=>b(I,S),()=>Object.create(null))],c.prototype,"throttledReport",null)}),define(Se[312],De([1,0,2,6,7,15]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kqc=void 0;class L{static{this.a=0}constructor(b,c){this.d=c,this.c=new Map,this.b=b.getProxy(h.$DN.MainThreadQuickDiff)}$provideOriginalResource(b,c,I){const S=r.URI.revive(c),u=this.c.get(b);return u?(0,C.$uh)(()=>u.provideOriginalResource(S,I)).then(P=>P||null):Promise.resolve(null)}registerQuickDiffProvider(b,c,I,S){const u=L.a++;return this.c.set(u,c),this.b.$registerQuickDiffProvider(u,R.DocumentSelector.from(b,this.d),I,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Kqc=L});var Wt=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Se[313],De([1,0,20,4,3,6,2,9,13,18,43,50,25,15]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lqc=w,I=Wt(I);function w(a,m,$){const f=a.getProxy(R.$DN.MainThreadQuickOpen);class i{constructor(D,y){this.e=new Map,this.f=0,this.a=D,this.b=y}showQuickPick(D,y,k,A=r.CancellationToken.None){this.c=void 0;const p=Promise.resolve(y),v=++this.f,F=f.$show(v,{title:k?.title,placeHolder:k?.placeHolder,matchOnDescription:k?.matchOnDescription,matchOnDetail:k?.matchOnDetail,ignoreFocusLost:k?.ignoreFocusOut,canPickMany:k?.canPickMany},A),N={},O=F.then(()=>N);return Promise.race([O,p]).then(j=>{if(j===N)return;const z=(0,u.$cH)(D,"quickPickItemTooltip");return p.then(M=>{const W=[];for(let V=0;V<M.length;V++){const ne=M[V];if(typeof ne=="string")W.push({label:ne,handle:V});else if(ne.kind===T.QuickPickItemKind.Separator)W.push({type:"separator",label:ne.label});else{ne.tooltip&&!z&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const B=ne.iconPath?d(ne.iconPath):void 0;W.push({label:ne.label,iconPath:B?.iconPath,iconClass:B?.iconClass,description:ne.description,detail:ne.detail,picked:ne.picked,alwaysShow:ne.alwaysShow,tooltip:z?P.MarkdownString.fromStrict(ne.tooltip):void 0,handle:V})}}return k&&typeof k.onDidSelectItem=="function"&&(this.c=V=>{k.onDidSelectItem(M[V])}),f.$setItems(v,W),F.then(V=>{if(typeof V=="number")return M[V];if(Array.isArray(V))return V.map(ne=>M[ne])})})}).then(void 0,j=>{if(!(0,b.$3)(j))return f.$setError(v,j),Promise.reject(j)})}$onItemSelected(D){this.c?.(D)}showInput(D,y=r.CancellationToken.None){return this.d=D?.validateInput,f.$input(D,typeof this.d=="function",y).then(void 0,k=>{if(!(0,b.$3)(k))return Promise.reject(k)})}async $validateInput(D){if(!this.d)return;const y=await this.d(D);if(!y||typeof y=="string")return y;let k;switch(y.severity){case T.InputBoxValidationSeverity.Info:k=I.default.Info;break;case T.InputBoxValidationSeverity.Warning:k=I.default.Warning;break;case T.InputBoxValidationSeverity.Error:k=I.default.Error;break;default:k=y.message?I.default.Error:I.default.Ignore;break}return{content:y.message,severity:k}}async showWorkspaceFolderPick(D,y=r.CancellationToken.None){const k=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!k)return;const A=await this.a.getWorkspaceFolders2();if(A)return A.find(p=>p.uri.toString()===k.uri.toString())}createQuickPick(D){const y=new l(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(D){const y=new g(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(D,y){this.e.get(D)?._fireDidChangeValue(y)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,y){const k=this.e.get(D);k instanceof l&&k._fireDidChangeActive(y)}$onDidChangeSelection(D,y){const k=this.e.get(D);k instanceof l&&k._fireDidChangeSelection(y)}$onDidTriggerButton(D,y){this.e.get(D)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(D,y,k){const A=this.e.get(D);A instanceof l&&A._fireDidTriggerItemButton(y,k)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class s{static{this.a=1}constructor(D,y){this.x=D,this.y=y,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new h.$je,this.q=new h.$je,this.r=new h.$je,this.s=new h.$je,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){const y=(0,u.$cH)(this.x,"quickInputButtonLocation");!y&&D.some(k=>k.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=D.slice(),this.o.clear(),D.forEach((k,A)=>{const p=k===T.$7O.Back?-1:A;this.o.set(p,k)}),this.z({buttons:D.map((k,A)=>({...d(k.iconPath),tooltip:k.tooltip,handle:k===T.$7O.Back?-1:A,location:y?k.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const y=this.o.get(D);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),f.$dispose(this._id))}z(D){if(!this.v){for(const y of Object.keys(D)){const k=D[y];this.u[y]=k===void 0?null:k}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){f.$createOrUpdate(this.u),this.u={id:this._id}}}function t(E){if(E instanceof T.$EO)return{id:E.id};const D=n(E),y=o(E);return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof y=="string"?L.URI.file(y):y}}function o(E){return typeof E=="object"&&"light"in E?E.light:E}function n(E){return typeof E=="object"&&"dark"in E?E.dark:E}function d(E){const D=t(E);let y,k;return"id"in D?k=S.ThemeIcon.asClassName(D):y=D,{iconPath:y,iconClass:k}}class l extends s{constructor(D,y){super(D,y),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new h.$je,this.L=[],this.M=new h.$je,this.N=new h.$je,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((A,p)=>{this.C.set(p,A),this.D.set(A,p)});const y=(0,u.$cH)(this.x,"quickPickItemTooltip"),k=[];for(let A=0;A<D.length;A++){const p=D[A];if(p.kind===T.QuickPickItemKind.Separator)k.push({type:"separator",label:p.label});else{p.tooltip&&!y&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const v=p.iconPath?d(p.iconPath):void 0;k.push({handle:A,label:p.label,iconPath:v?.iconPath,iconClass:v?.iconClass,description:p.description,detail:p.detail,picked:p.picked,alwaysShow:p.alwaysShow,tooltip:y?P.MarkdownString.fromStrict(p.tooltip):void 0,buttons:p.buttons?.map((F,N)=>({...d(F.iconPath),tooltip:F.tooltip,handle:N}))})}}this.z({items:k})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(D){const y=(0,c.$Gb)(D.map(k=>this.C.get(k)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(D){const y=(0,c.$Gb)(D.map(k=>this.C.get(k)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(D,y){const k=this.C.get(D);if(!k||!k.buttons||!k.buttons.length)return;const A=k.buttons[y];A&&this.N.fire({button:A,item:k})}}class g extends s{constructor(D,y){super(D,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:I.default.Error}):this.z({validationMessage:D.message,severity:D.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i(m,$)}}),define(Se[314],De([1,0,2,4,59,3,7,6,18,134,11,23,40,50,15,25,14,10]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nqc=e.$Mqc=void 0;function i(N){return N instanceof r.URI}function s(N,O){return N.scheme===m.Schemas.file&&O.scheme===m.Schemas.file&&$.$l?N.toString()===O.toString():N.toString().toLowerCase()===O.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?r.URI.file(N.iconPath):r.URI.isUri(N.iconPath)||P.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function o(N){if(N){if(r.URI.isUri(N))return N;if(P.ThemeIcon.isThemeIcon(N))return N;{const O=N;return{light:O.light,dark:O.dark}}}else return}function n(N){const O=o(N.icon),j=N.labels?.map(z=>({title:z.title,icon:o(z.icon)}));return{...N,icon:O,labels:j}}function d(N,O){if(!N.iconPath&&!O.iconPath)return 0;if(N.iconPath){if(!O.iconPath)return 1}else return-1;const j=typeof N.iconPath=="string"?N.iconPath:r.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,z=typeof O.iconPath=="string"?O.iconPath:r.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,c.$Hr)(j,z)}function l(N,O){let j=0;if(N.strikeThrough!==O.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==O.faded)return N.faded?1:-1;if(N.tooltip!==O.tooltip)return(N.tooltip||"").localeCompare(O.tooltip||"");if(j=d(N,O),j!==0)return j;if(N.light&&O.light)j=d(N.light,O.light);else{if(N.light)return 1;if(O.light)return-1}if(j!==0)return j;if(N.dark&&O.dark)j=d(N.dark,O.dark);else{if(N.dark)return 1;if(O.dark)return-1}return j}function g(N,O){if(N.command!==O.command)return N.command<O.command?-1:1;if(N.title!==O.title)return N.title<O.title?-1:1;if(N.tooltip!==O.tooltip){if(N.tooltip!==void 0&&O.tooltip!==void 0)return N.tooltip<O.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(N.arguments===O.arguments)return 0;if(N.arguments)if(O.arguments){if(N.arguments.length!==O.arguments.length)return N.arguments.length-O.arguments.length}else return 1;else return-1;for(let j=0;j<N.arguments.length;j++){const z=N.arguments[j],M=O.arguments[j];if(z!==M&&!(i(z)&&i(M)&&s(z,M)))return z<M?-1:1}return 0}function E(N,O){let j=(0,c.$Hr)(N.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(j!==0)return j;if(N.command&&O.command)j=g(N.command,O.command);else{if(N.command)return 1;if(O.command)return-1}if(j!==0)return j;if(N.decorations&&O.decorations)j=l(N.decorations,O.decorations);else{if(N.decorations)return 1;if(O.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)j=(0,c.$Hr)(N.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)j=(0,c.$Hr)(N.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return j}function D(N,O){for(let j=0;j<N.length;j++)if(N[j]!==O[j])return!1;return!0}function y(N,O){return N.command===O.command&&N.title===O.title&&N.tooltip===O.tooltip&&(N.arguments&&O.arguments?D(N.arguments,O.arguments):N.arguments===O.arguments)}function k(N,O){return(0,b.$tb)(N,O,y)}class A{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.m,O),this.o(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.m,O),this.f=O}get validateInput(){return(0,a.$dH)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,a.$dH)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.m,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.m,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.m,O))}get document(){return(0,a.$dH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(O,j,z,M,W){this.k=O,this.m=M,this.n=W,this.d="",this.e=new h.$je,this.f="",this.h=!0,this.j=!0,this.#t=j,this.#e=z}showValidationMessage(O,j){(0,a.$dH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,O,j)}$onInputBoxValueChange(O){this.o(O)}o(O){this.d=O,this.e.fire(O)}}e.$Mqc=A;class p{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(O){this.w=O,this.s.$updateGroupLabel(this.u,this.handle,O)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(O){this.q=O,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,j,z,M,W,V,ne){this.s=O,this.t=j,this.u=z,this.v=M,this.w=W,this.multiDiffEditorEnableViewChanges=V,this.x=ne,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new h.$je,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new h.$je,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=p.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,j){const z=this.h.get(O);return z?(0,L.$uh)(()=>this.t.executeCommand(z.command,...z.arguments||[],j)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(E),z=(0,b.$Cb)(this.p,O,E).map(V=>{const ne=V.toInsert.map(B=>{const K=this.e++;this.g.set(K,B);const Y=B.resourceUri;let ee;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"||B.command.command==="vscode.changes"){const oe=new R.$Sc;ee=this.t.converter.toInternal(B.command,oe),this.j.set(K,oe)}else this.h.set(K,B.command);const ue=(0,a.$cH)(this.x,"scmMultiDiffEditor"),re=ue?B.multiDiffEditorOriginalUri:void 0,ye=ue?B.multiFileDiffEditorModifiedUri:void 0,me=t(B.decorations),J=B.decorations&&t(B.decorations.light)||me,U=B.decorations&&t(B.decorations.dark)||me,se=[J,U],ae=B.decorations&&B.decorations.tooltip||"",te=B.decorations&&!!B.decorations.strikeThrough,ce=B.decorations&&!!B.decorations.faded,le=B.contextValue||"";return{rawResource:[K,Y,se,ae,te,ce,le,ee,re,ye],handle:K}});return{start:V.start,deleteCount:V.deleteCount,toInsert:ne}}),M=z.map(({start:V,deleteCount:ne,toInsert:B})=>[V,ne,B.map(K=>K.rawResource)]),W=z.reverse();for(const{start:V,deleteCount:ne,toInsert:B}of W){const K=B.map(ee=>ee.handle),Y=this.o.splice(V,ne,...K);for(const ee of Y)this.g.delete(ee),this.h.delete(ee),this.j.get(ee)?.dispose(),this.j.delete(ee)}return this.p=O,M}dispose(){this.m=!0,this.n.fire()}}class v{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.x,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let j;(0,a.$cH)(this.y,"quickDiffProvider")&&(j=O?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!O,quickDiffLabel:j})}get historyProvider(){return(0,a.$dH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(O){(0,a.$dH)(this.y,"scmHistoryProvider"),this.j=O,this.k.value=new R.$Sc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.m=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(O){O!==this.n&&(this.n=O,this.#e.$updateSourceControl(this.x,{commitTemplate:O}))}get acceptInputCommand(){return this.p}set acceptInputCommand(O){this.o.value=new R.$Sc,this.p=O;const j=this.z.converter.toInternal(O,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:j})}get actionButton(){return(0,a.$dH)(this.y,"scmActionButton"),this.s}set actionButton(O){(0,a.$dH)(this.y,"scmActionButton"),this.q.value=new R.$Sc,this.s=O;const j=O!==void 0?{command:this.z.converter.toInternal(O.command,this.q.value),secondaryCommands:O.secondaryCommands?.map(z=>z.map(M=>this.z.converter.toInternal(M,this.q.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:j??null})}get statusBarCommands(){return this.u}set statusBarCommands(O){if(this.u&&O&&k(this.u,O))return;this.t.value=new R.$Sc,this.u=O;const j=(O||[]).map(z=>this.z.converter.toInternal(z,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:j})}get selected(){return this.v}constructor(O,j,z,M,W,V,ne){this.y=O,this.z=M,this.A=W,this.B=V,this.C=ne,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Uc,this.n=void 0,this.o=new R.$Uc,this.p=void 0,this.q=new R.$Uc,this.t=new R.$Uc,this.u=void 0,this.v=!1,this.w=new h.$je,this.onDidChangeSelection=this.w.event,this.x=v.d++,this.D=new Map,this.E=new Set,this.#e=z;const B=r.URI.from({scheme:m.Schemas.vscodeSourceControl,path:`${W}/scm${this.x}/input`,query:ne?`rootUri=${encodeURIComponent(ne.toString())}`:void 0});this.f=new A(O,j,this.#e,this.x,B),this.#e.$registerSourceControl(this.x,W,V,ne,B)}createResourceGroup(O,j,z){const M=(0,a.$cH)(this.y,"scmMultiDiffEditor")&&z?.multiDiffEditorEnableViewChanges===!0,W=new p(this.#e,this.z,this.x,O,j,M,this.y),V=h.Event.once(W.onDidDispose)(()=>this.D.delete(W));return this.D.set(W,V),this.eventuallyAddResourceGroups(),W}eventuallyAddResourceGroups(){const O=[],j=[];for(const[z,M]of this.D){M.dispose();const W=z.onDidUpdateResourceStates(()=>{this.E.add(z),this.eventuallyUpdateResourceStates()});h.Event.once(z.onDidDispose)(()=>{this.E.delete(z),W.dispose(),this.e.delete(z.handle),this.#e.$unregisterGroup(this.x,z.handle)}),O.push([z.handle,z.id,z.label,z.features,z.multiDiffEditorEnableViewChanges]);const V=z._takeResourceStateSnapshot();V.length>0&&j.push([z.handle,V]),this.e.set(z.handle,z)}this.#e.$registerGroups(this.x,O,j),this.D.clear()}eventuallyUpdateResourceStates(){const O=[];this.E.forEach(j=>{const z=j._takeResourceStateSnapshot();z.length!==0&&O.push([j.handle,z])}),O.length>0&&this.#e.$spliceResourceStates(this.x,O),this.E.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.v=O,this.w.fire(O)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ye([(0,C.$8h)(100)],v.prototype,"eventuallyAddResourceGroups",null),Ye([(0,C.$8h)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let F=class{static{f=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,j,z,M){this.m=j,this.n=z,this.o=M,this.g=new Map,this.h=new S.$qn,this.j=new h.$je,this.e=O.getProxy(T.$DN.MainThreadSCM),this.f=O.getProxy(T.$DN.MainThreadTelemetry),j.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===u.MarshalledId.ScmResource){const V=this.g.get(W.sourceControlHandle);if(!V)return W;const ne=V.getResourceGroup(W.groupHandle);return ne?ne.getResourceState(W.handle):W}else if(W&&W.$mid===u.MarshalledId.ScmResourceGroup){const V=this.g.get(W.sourceControlHandle);return V?V.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===u.MarshalledId.ScmProvider){const V=this.g.get(W.handle);return V||W}return W}})}createSourceControl(O,j,z,M){this.o.trace("ExtHostSCM#createSourceControl",O.identifier.value,j,z,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const W=f.d++,V=new v(O,this.n,this.e,this.m,j,z,M);this.g.set(W,V);const ne=this.h.get(O.identifier)||[];return ne.push(V),this.h.set(O.identifier,ne),V}getLastInputBox(O){this.o.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const j=this.h.get(O.identifier),z=j&&j[j.length-1];return z&&z.inputBox}$provideOriginalResource(O,j,z){const M=r.URI.revive(j);this.o.trace("ExtHostSCM#$provideOriginalResource",O,M.toString());const W=this.g.get(O);return!W||!W.quickDiffProvider||!W.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$uh)(()=>W.quickDiffProvider.provideOriginalResource(M,z)).then(V=>V||null)}$onInputBoxValueChange(O,j){this.o.trace("ExtHostSCM#$onInputBoxValueChange",O);const z=this.g.get(O);return z&&z.inputBox.$onInputBoxValueChange(j),Promise.resolve(void 0)}$executeResourceCommand(O,j,z,M){this.o.trace("ExtHostSCM#$executeResourceCommand",O,j,z);const W=this.g.get(O);if(!W)return Promise.resolve(void 0);const V=W.getResourceGroup(j);return V?V.$executeResourceCommand(z,M):Promise.resolve(void 0)}$validateInput(O,j,z){this.o.trace("ExtHostSCM#$validateInput",O);const M=this.g.get(O);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,L.$uh)(()=>M.inputBox.validateInput(j,z)).then(W=>{if(!W)return Promise.resolve(void 0);const V=w.MarkdownString.fromStrict(W.message);return V?Promise.resolve([V,W.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,j,z,M){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(j,z,M)??void 0}async $resolveHistoryItemGroupCommonAncestor2(O,j,z){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(j,z)??void 0}async $provideHistoryItems(O,j,z,M){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(j,z,M))?.map(ne=>n(ne))??void 0}async $provideHistoryItems2(O,j,z){return(await this.g.get(O)?.historyProvider?.provideHistoryItems2(j,z))?.map(V=>n(V))??void 0}async $provideHistoryItemSummary(O,j,z,M){const W=this.g.get(O)?.historyProvider;if(typeof W?.provideHistoryItemSummary!="function")return;const V=await W.provideHistoryItemSummary(j,z,M);return V?n(V):void 0}async $provideHistoryItemChanges(O,j,z,M){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(j,z,M)??void 0}};e.$Nqc=F,e.$Nqc=F=f=Ye([Ve(3,I.$0j)],F)}),define(Se[315],De([1,0,6,15,2]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oqc=void 0;class R{static{this.a=0}constructor(T,b){this.d=b,this.c=new Map,this.b=T.getProxy(r.$DN.MainThreadShare)}async $provideShare(T,b,c){return await this.c.get(T)?.provideShare({selection:h.Range.to(b.selection),resourceUri:C.URI.revive(b.resourceUri)},c)??void 0}registerShareProvider(T,b){const c=R.a++;return this.c.set(c,b),this.b.$registerShareProvider(c,h.DocumentSelector.from(T,this.d),b.id,b.label,b.priority),{dispose:()=>{this.b.$unregisterShareProvider(c),this.c.delete(c)}}}}e.$Oqc=R}),define(Se[316],De([1,0,9,6,8,3,15,17]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rqc=e.$Qqc=void 0;class b{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new r.$FO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.$FO("statusBarItem.warningForeground")]])}#e;#t;constructor(u,P,w,a,m,$=r.StatusBarAlignment.Left,f){if(this.i=!1,this.k="",this.q=new R.$Sc,this.#e=u,this.#t=P,m&&a){this.c=(0,r.$hO)(a.identifier,m);const i=w.get(this.c);i&&($=i.alignLeft?r.StatusBarAlignment.Left:r.StatusBarAlignment.Right,f=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(b.a++);this.e=a,this.f=m,this.g=$,this.h=this.u(f)}u(u){if((0,T.$gg)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!b.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new R.$Sc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let P;this.m?P=this.m:P=(0,C.localize)(10733,null,this.e.displayName||this.e.name);let w=this.n;this.o&&(w=b.b.get(this.o.id));const a=L.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,P,this.k,a,this.r?.internal,w,this.o,this.g===r.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Qqc=b;class c{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(10734,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const P={message:u};return this.b.unshift(P),this.c(),new r.$FN(()=>{const w=this.b.indexOf(P);w>=0&&(this.b.splice(w,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(u,P){this.e=new Map,this.a=u.getProxy(h.$DN.MainThreadStatusBar),this.b=P,this.c=new c(this)}$acceptStaticEntries(u){for(const P of u)this.e.set(P.entryId,P)}createStatusBarEntry(u,P,w,a){return new b(this.a,this.b,this.e,u,P,w,a)}setStatusBarMessage(u,P){const w=this.c.setMessage(u);let a;return typeof P=="number"?a=setTimeout(()=>w.dispose(),P):typeof P<"u"&&P.then(()=>w.dispose(),()=>w.dispose()),new r.$FN(()=>{w.dispose(),clearTimeout(a)})}}e.$Rqc=I}),define(Se[166],De([1,0,30,155,73,120,74,15,2]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rQ=e.$qQ=e.$pQ=e.$oQ=void 0,r=Ue(r),T=Ue(T);const c=(i,s,t,o)=>{let n=s;return{enumerable:!0,configurable:!1,get(){return n},set(d){if(!t(n,d)){const l=n;n=d,i.listener?.(o(d,l))}}}},I=(i,s)=>i===s,S={range:(i,s)=>i===s?!0:!i||!s?!1:i.isEqual(s),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,s)=>!(i.length!==s.length||i.some(t=>!s.find(o=>t.id===o.id)))},u=i=>s=>({op:R.TestItemEventOp.SetProp,update:i(s)}),P=(i,s)=>({range:(()=>{let t;const o=u(n=>({range:r.$Lt.lift(T.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return t},set(n){i.listener?.({op:R.TestItemEventOp.DocumentSynced}),S.range(t,n)||(t=n,i.listener?.(o(n)))}}})(),label:c(i,s,S.label,u(t=>({label:t}))),description:c(i,void 0,S.description,u(t=>({description:t}))),sortText:c(i,void 0,S.sortText,u(t=>({sortText:t}))),canResolveChildren:c(i,!1,S.canResolveChildren,t=>({op:R.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:c(i,!1,S.busy,u(t=>({busy:t}))),error:c(i,void 0,S.error,u(t=>({error:T.MarkdownString.fromStrict(t)||null}))),tags:c(i,[],S.tags,(t,o)=>({op:R.TestItemEventOp.SetTags,new:t.map(T.TestTag.from),old:o.map(T.TestTag.from)}))}),w=i=>{const s=C.$3I.fromString(i.extId),t=new m(s.controllerId,s.localId,i.label,b.URI.revive(i.uri)||void 0);return t.range=T.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(o=>T.TestTag.to({id:(0,L.$9I)(o).tagId})),t},a=i=>{let s;for(const t of i.tests){const o=w(t.item);(0,h.$$P)(o).parent=s,s=o}return s};e.$oQ=a;class m{constructor(s,t,o,n){if(t.includes(C.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const d=(0,h.$0P)(this,s);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof $?void 0:d.parent}},children:{value:(0,R.$9P)(d,h.$$P,m),enumerable:!0,writable:!1},...P(d,o)})}}e.$pQ=m;class $ extends m{constructor(s,t){super(s,s,t,void 0),this._isRoot=!0}}e.$qQ=$;class f extends R.$5P{constructor(s,t,o){super({controllerId:s,getDocumentVersion:n=>n&&o.getDocument(n)?.version,getApiFor:h.$$P,getChildren:n=>n.children,root:new $(s,t),toITestItem:T.TestItem.from})}}e.$rQ=f}),define(Se[34],De([1,0,17,9,15,24,6,18,11,51,30,57,2,3,5,19,166,21,53,52,42,91,94,32]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CQ=e.$BQ=e.$AQ=e.$zQ=e.$yQ=e.$xQ=void 0,h=Ue(h),C=Ue(C);let d=class{#e;#t;#i;constructor(k,A,p){this.b=new Map,this.c=new Map,this.#e=k.getProxy(L.$DN.MainThreadCommands),this.d=A,this.#i=p,this.#t=k.getProxy(L.$DN.MainThreadTelemetry),this.converter=new l(this,v=>{const F=this.c.get(v);return F?.result===E.Void?F:void 0},A),this.f=[{processArgument(v){return(0,c.$_h)(v)}},{processArgument(v){return(0,R.$do)(v,function(F){if(I.$Lt.isIRange(F))return C.Range.to(F);if(S.$Kt.isIPosition(F))return C.Position.to(F);if(I.$Lt.isIRange(F.range)&&u.URI.isUri(F.uri))return C.location.to(F);if(F instanceof $.$Le)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const A=this.registerCommand(!1,k.id,async(...p)=>{const v=k.args.map((N,O)=>{if(!N.validate(p[O]))throw new Error(`Invalid argument '${N.name}' when running '${k.id}', received: ${typeof p[O]=="object"?JSON.stringify(p[O],null,"	"):p[O]} `);return N.convert(p[O])}),F=await this.executeCommand(k.internalId,...v);return k.result.convert(F,p,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new h.$FN(()=>{A.dispose(),this.c.delete(k.id)})}registerCommand(k,A,p,v,F,N){if(this.d.trace("ExtHostCommands#registerCommand",A),!A.trim().length)throw new Error("invalid id");if(this.b.has(A))throw new Error(`command '${A}' already exists`);return this.b.set(A,{callback:p,thisArg:v,metadata:F,extension:N}),k&&this.#e.$registerCommand(A),new h.$FN(()=>{this.b.delete(A)&&k&&this.#e.$unregisterCommand(A)})}executeCommand(k,...A){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,A,!0)}async g(k,A,p){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,A,!1);{let v=!1;const F=(0,R.$do)(A,function(N){if(N instanceof h.$GN)return C.Position.from(N);if(N instanceof h.$HN)return C.Range.from(N);if(N instanceof h.$TN)return C.location.from(N);if(h.$0O.isNotebookRange(N))return C.NotebookRange.from(N);if(N instanceof ArrayBuffer)return v=!0,$.$Le.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return v=!0,$.$Le.wrap(N);if(N instanceof $.$Le)return v=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(k,v?new f.$Uw(F):F,p);return(0,c.$_h)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(k,A,!1);throw N}}}async h(k,A,p){const v=this.b.get(k);if(!v)throw new Error("Unknown command");const{callback:F,thisArg:N,metadata:O}=v;if(O?.args)for(let z=0;z<O.args.length;z++)try{(0,r.$tg)(A[z],O.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${O.args[z].name}' - ${O.args[z].description}`)}const j=s.$de.create();try{return await F.apply(N,A)}catch(z){if(k===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...A);M&&(k=M.command)}if(this.d.error(z,k,v.extension?.identifier),!p)throw z;if(v.extension?.identifier){const M=this.#i.onExtensionError(v.extension.identifier,z);this.d.trace("forwarded error to extension?",M,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$nj)(z)),this.id=k,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,k,j.elapsed())}}j(k,A,p){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new t.$up(A),duration:p})}$executeContributedCommand(k,...A){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const p=this.b.get(k);return p?(A=A.map(v=>this.f.reduce((F,N)=>N.processArgument(F,p.extension?.identifier),v)),this.h(k,A,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(A=>(k&&(A=A.filter(p=>p[0]!=="_")),A))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[A,p]of this.b){const{metadata:v}=p;v&&(k[A]=v)}return Promise.resolve(k)}};e.$xQ=d,e.$xQ=d=Ye([Ve(0,a.$cQ),Ve(1,b.$0j),Ve(2,o.$wQ)],d),e.$yQ=(0,w.$Ci)("IExtHostCommands");class l{constructor(k,A,p){this.d=k,this.f=A,this.g=p,this.delegatingCommandId=`__vsc${(0,n.$Yg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,A){if(!k)return;const p={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return p;const v=this.f(k.command);if(v)p.id=v.internalId,p.arguments=v.args.map((F,N)=>F.convert(k.arguments&&k.arguments[N]));else if((0,T.$Kb)(k.arguments)){const F=`${k.command} /${++this.c}`;this.b.set(F,k),A.add((0,P.$Rc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),p.$ident=F,p.id=this.delegatingCommandId,p.arguments=[F],this.g.trace("CommandsConverter#CREATE",k.command,F)}return p}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const A=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],A?A.command:"MISSING"),A?this.d.executeCommand(A.command,...A.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$zQ=l;class g{static{this.Uri=new g("uri","Uri of a text document",k=>u.URI.isUri(k),k=>k)}static{this.Position=new g("position","A position in a text document",k=>h.$GN.isPosition(k),C.Position.from)}static{this.Range=new g("range","A range in a text document",k=>h.$HN.isRange(k),C.Range.from)}static{this.Selection=new g("selection","A selection in a text document",k=>h.$IN.isSelection(k),C.Selection.from)}static{this.Number=new g("number","",k=>typeof k=="number",k=>k)}static{this.String=new g("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=g.Arr(g.String)}static Arr(k){return new g(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,A=>Array.isArray(A)&&A.every(p=>k.validate(p)),A=>A.map(p=>k.convert(p)))}static{this.CallHierarchyItem=new g("item","A call hierarchy item",k=>k instanceof h.$6N,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new g("item","A type hierarchy item",k=>k instanceof h.$sP,C.TypeHierarchyItem.from)}static{this.TestItem=new g("testItem","A VS Code TestItem",k=>k instanceof m.$pQ,C.TestItem.from)}constructor(k,A,p,v){this.name=k,this.description=A,this.validate=p,this.convert=v}optional(){return new g(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,A){return new g(k??this.name,A??this.description,this.validate,this.convert)}}e.$AQ=g;class E{static{this.Void=new E("no result",k=>k)}constructor(k,A){this.description=k,this.convert=A}}e.$BQ=E;class D{constructor(k,A,p,v,F){this.id=k,this.internalId=A,this.description=p,this.args=v,this.result=F}}e.$CQ=D}),define(Se[317],De([1,0,18,14,2,87,142,35,34,15,9]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7oc=void 0,R=Ue(R),c=Ue(c),I=Ue(I);const S=[new b.$CQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.$AQ.Uri,b.$AQ.Position],new b.$BQ("A promise that resolves to an array of DocumentHighlight-instances.",P(c.DocumentHighlight.to))),new b.$CQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.$AQ.Uri],new b.$BQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,m)=>{if((0,r.$Jb)(a))return;class $ extends I.$1N{static to(i){const s=new $(i.name,c.SymbolKind.to(i.kind),i.containerName||"",new I.$TN(m[0],c.Range.to(i.range)));return s.detail=i.detail,s.range=s.location.range,s.selectionRange=c.Range.to(i.selectionRange),s.children=i.children?i.children.map($.to):[],s}}return a.map($.to)})),new b.$CQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.$AQ.Uri,new b.$AQ("options","Formatting options",a=>!0,a=>a)],new b.$BQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new b.$CQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.$AQ.Uri,b.$AQ.Range,new b.$AQ("options","Formatting options",a=>!0,a=>a)],new b.$BQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new b.$CQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.$AQ.Uri,b.$AQ.Position,new b.$AQ("ch","Trigger character",a=>typeof a=="string",a=>a),new b.$AQ("options","Formatting options",a=>!0,a=>a)],new b.$BQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new b.$CQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.$AQ.Uri,b.$AQ.Position],new b.$BQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$CQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.$AQ.Uri,b.$AQ.Position],new b.$BQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$CQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.$AQ.Uri,b.$AQ.Position],new b.$BQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$CQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.$AQ.Uri,b.$AQ.Position],new b.$BQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new b.$CQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.$AQ.Uri,b.$AQ.Position],new b.$BQ("A promise that resolves to an array of Location-instances.",P(c.location.to))),new b.$CQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.$AQ.Uri,b.$AQ.Position],new b.$BQ("A promise that resolves to an array of Hover-instances.",P(c.Hover.to))),new b.$CQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.$AQ.Uri,new b.$AQ("position","A position in a text document",a=>Array.isArray(a)&&a.every(m=>I.$GN.isPosition(m)),a=>a.map(c.Position.from))],new b.$BQ("A promise that resolves to an array of ranges.",a=>a.map(m=>{let $;for(const f of m.reverse())$=new I.$5N(c.Range.to(f),$);return $}))),new b.$CQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.$AQ.String.with("query","Search string")],new b.$BQ("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(c.WorkspaceSymbol.to))),new b.$CQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.$AQ.Uri,b.$AQ.Position],new b.$BQ("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(c.CallHierarchyItem.to))),new b.$CQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.$AQ.CallHierarchyItem],new b.$BQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(c.CallHierarchyIncomingCall.to))),new b.$CQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.$AQ.CallHierarchyItem],new b.$BQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(c.CallHierarchyOutgoingCall.to))),new b.$CQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.$AQ.Uri,b.$AQ.Position],new b.$BQ("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:c.Range.to(a.range),placeholder:a.text}})),new b.$CQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.$AQ.Uri,b.$AQ.Position,b.$AQ.String.with("newName","The new symbol name")],new b.$BQ("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return c.WorkspaceEdit.to(a)}})),new b.$CQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.$AQ.Uri,b.$AQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.$BQ("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(c.DocumentLink.to))),new b.$CQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.$AQ.Uri],new b.$BQ("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.$1O(a.tokenTypes,a.tokenModifiers)})),new b.$CQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.$AQ.Uri],new b.$BQ("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,L.$Odb)(a);if(m.type==="full")return new I.$3O(m.data,void 0)})),new b.$CQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.$AQ.Uri,b.$AQ.Range.optional()],new b.$BQ("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.$1O(a.tokenTypes,a.tokenModifiers)})),new b.$CQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.$AQ.Uri,b.$AQ.Range],new b.$BQ("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,L.$Odb)(a);if(m.type==="full")return new I.$3O(m.data,void 0)})),new b.$CQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.$AQ.Uri,b.$AQ.Position,b.$AQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.$AQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.$BQ("A promise that resolves to a CompletionList-instance.",(a,m,$)=>{if(!a)return new I.$eO([]);const f=a.suggestions.map(i=>c.CompletionItem.to(i,$));return new I.$eO(f,a.incomplete)})),new b.$CQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.$AQ.Uri,b.$AQ.Position,b.$AQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.$BQ("A promise that resolves to SignatureHelp.",a=>{if(a)return c.SignatureHelp.to(a)})),new b.$CQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.$AQ.Uri,b.$AQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.$BQ("A promise that resolves to an array of CodeLens-instances.",(a,m,$)=>P(f=>new I.$9N(c.Range.to(f.range),f.command&&$.fromInternal(f.command)))(a))),new b.$CQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.$AQ.Uri,new b.$AQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>I.$HN.isRange(a),a=>I.$IN.isSelection(a)?c.Selection.from(a):c.Range.from(a)),b.$AQ.String.with("kind","Code action kind to return code actions for").optional(),b.$AQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.$BQ("A promise that resolves to an array of Command-instances.",(a,m,$)=>P(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return $.fromInternal(f.command)}else{const i=new I.$3N(f.title,f.kind?new I.$4N(f.kind):void 0);return f.edit&&(i.edit=c.WorkspaceEdit.to(f.edit)),f.command&&(i.command=$.fromInternal(f.command)),i.isPreferred=f.isPreferred,i}})(a))),new b.$CQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.$AQ.Uri],new b.$BQ("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(m=>new I.$kO(c.Range.to(m.range),c.Color.to(m.color))):[])),new b.$CQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.$AQ("color","The color to show and insert",a=>a instanceof I.$jO,c.Color.from),new b.$AQ("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:c.Range.from(a.range)}))],new b.$BQ("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(c.ColorPresentation.to):[])),new b.$CQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.$AQ.Uri,b.$AQ.Range],new b.$BQ("A promise that resolves to an array of Inlay objects",(a,m,$)=>a.map(c.InlayHint.to.bind(void 0,$)))),new b.$CQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.$AQ.Uri],new b.$BQ("A promise that resolves to an array of FoldingRange objects",(a,m)=>{if(a)return a.map(c.FoldingRange.to)})),new b.$CQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.$BQ("A promise that resolves to an array of NotebookContentProvider static info objects.",P(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(m=>c.NotebookExclusiveDocumentPattern.to(m))})))),new b.$CQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.$AQ.Uri,b.$AQ.Range,new b.$AQ("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof I.$HN,a=>c.InlineValueContext.from(a))],new b.$BQ("A promise that resolves to an array of InlineValue objects",a=>a.map(c.InlineValue.to))),new b.$CQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.$AQ("uriOrString","Uri-instance or string (only http/https)",a=>C.URI.isUri(a)||typeof a=="string"&&(0,h.$Mg)(a,h.Schemas.http,h.Schemas.https),a=>a),new b.$AQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional(),b.$AQ.String.with("label","").optional()],b.$BQ.Void),new b.$CQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.$AQ.Uri.with("resource","Resource to open"),b.$AQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new b.$AQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional()],b.$BQ.Void),new b.$CQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.$AQ.Uri.with("left","Left-hand side resource of the diff editor"),b.$AQ.Uri.with("right","Right-hand side resource of the diff editor"),b.$AQ.String.with("title","Human readable title for the diff editor").optional(),new b.$AQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)]).optional()],b.$BQ.Void),new b.$CQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[b.$AQ.String.with("title","Human readable title for the changes editor"),new b.$AQ("resourceList","List of resources to compare",a=>{for(const m of a){if(m.length!==3)return!1;const[$,f,i]=m;if(!C.URI.isUri($)||!C.URI.isUri(f)&&f!==void 0&&f!==null||!C.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},a=>a)],b.$BQ.Void),new b.$CQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.$AQ.Uri,b.$AQ.Position],new b.$BQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new b.$CQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.$AQ.TypeHierarchyItem],new b.$BQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new b.$CQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.$AQ.TypeHierarchyItem],new b.$BQ("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new b.$CQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.$AQ.TestItem],b.$BQ.Void),new b.$CQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.$AQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.$BQ.Void),new b.$CQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.$AQ.String.with("name","The context key name"),new b.$AQ("value","The context key value",()=>!0,a=>a)],b.$BQ.Void),new b.$CQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[b.$AQ.Uri,b.$AQ.StringArray,new b.$AQ("MappedEditsContext","Mapped Edits Context",a=>c.MappedEditsContext.is(a),a=>c.MappedEditsContext.from(a))],new b.$BQ("A promise that resolves to a workspace edit or null",a=>a?c.WorkspaceEdit.to(a):null)),new b.$CQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$AQ("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?c.Range.from(a.initialRange):void 0,initialSelection:I.$IN.isSelection(a.initialSelection)?c.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?c.Position.from(a.position):void 0}})],b.$BQ.Void)];class u{static register(m){S.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",T.$Bj)}}e.$7oc=u;function P(a){return m=>{if(Array.isArray(m))return m.map(a)}}function w(a){if(!Array.isArray(a))return;const m=[];for(const $ of a)R.$Iu($)?m.push(c.DefinitionLink.to($)):m.push(c.location.to($));return m}}),define(Se[318],De([1,0,2,34]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vqc=void 0;class C{constructor(L,T,b,c,I){this.a=T,this.b=b,this.c=c;const S=new h.$CQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new h.$AQ("showOptions","Show Options",u=>!0,u=>u),new h.$AQ("resource","Interactive resource Uri",u=>!0,u=>u),new h.$AQ("controllerId","Notebook controller Id",u=>!0,u=>u),new h.$AQ("title","Interactive editor title",u=>!0,u=>u)],new h.$BQ("Notebook and input URI",u=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const P=this.a.getEditorById(u.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",P.id),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri),notebookEditor:P.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(L,T,b,c){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:b,uri:L,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(L,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$vqc=C}),define(Se[319],De([1,0,18,7,20,4,3,28,2,23,11,6,34,15,9,121,261,25,53,262]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dqc=void 0,e.$Eqc=g,P=Ue(P);let s=class{constructor(D,y,k,A,p){this.m=y,this.n=k,this.o=A,this.q=p,this.b=new T.$zc,this.c=new T.$zc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$je,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(S.$DN.MainThreadNotebookKernels);const v=new u.$CQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$AQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const O=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:O}}else if(N&&"notebookEditor"in N){const O=this.n.getIdByEditor(N.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return N})],u.$BQ.Void),F=new u.$CQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$AQ.Uri],new u.$BQ("A promise that resolves to an array of variables",(N,O)=>N.map(j=>({variable:{name:j.name,value:j.value,expression:j.expression,type:j.type,language:j.language},hasNamedChildren:j.hasNamedChildren,indexedChildrenCount:j.indexedChildrenCount}))));this.o.registerApiCommand(v),this.o.registerApiCommand(F)}createNotebookController(D,y,k,A,p,v){for(const re of this.j.values())if(re.controller.id===y&&c.$on.equals(D.identifier,re.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const F=this.k++,N=this;this.q.trace(`NotebookController[${F}], CREATED by ${D.identifier.value}, ${y}`);const O=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${D.identifier}'`);let j=!1;const z=new R.$je,M=new R.$je,W={id:g(D.identifier,y),notebookType:k,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:A||D.identifier.value,preloads:v?v.map(P.NotebookRendererScript.from):[]};let V=p??O,ne,B;this.a.$addKernel(F,W).catch(re=>{console.log(re),j=!0});let K=0;const Y=()=>{if(j)return;const re=++K;Promise.resolve().then(()=>{re===K&&this.a.$updateKernel(F,W)})},ee=new T.$zc,ue={get id(){return y},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return W.label},set label(re){W.label=re??D.displayName??D.name,Y()},get detail(){return W.detail??""},set detail(re){W.detail=re,Y()},get description(){return W.description??""},set description(re){W.description=re,Y()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages(re){W.supportedLanguages=re,Y()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder(re){W.supportsExecutionOrder=re,Y()},get rendererScripts(){return W.preloads?W.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(re){V=re??O},get interruptHandler(){return ne},set interruptHandler(re){ne=re,W.supportsInterrupt=!!re,Y()},set variableProvider(re){(0,$.$dH)(D,"notebookVariableProvider"),B=re,W.hasVariableProvider=!!re,re?.onDidChangeVariables(ye=>N.a.$variablesUpdated(ye.uri)),Y()},get variableProvider(){return B},createNotebookCellExecution(re){if(j)throw new Error("notebook controller is DISPOSED");if(!ee.has(re.notebook.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return N._createNotebookCellExecution(re,g(D.identifier,this.id))},createNotebookExecution(re){if((0,$.$dH)(D,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!ee.has(re.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.uri.toString()}`);return N._createNotebookExecution(re,g(D.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${F}], DISPOSED`),j=!0,this.j.delete(F),z.dispose(),M.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(re,ye){ye===w.NotebookControllerAffinity2.Hidden&&(0,$.$dH)(D,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(F,re.uri,ye)},onDidReceiveMessage:M.event,postMessage(re,ye){return(0,$.$dH)(D,"notebookMessaging"),N.a.$postMessage(F,ye&&N.n.getIdByEditor(ye),re)},asWebviewUri(re){return(0,$.$dH)(D,"notebookMessaging"),(0,a.$vDb)(re,N.m.remote)}};return this.j.set(F,{extensionId:D.identifier,controller:ue,onDidReceiveMessage:M,onDidChangeSelection:z,associatedNotebooks:ee}),ue}getIdByController(D){for(const[y,k]of this.j)if(k.controller===D)return g(k.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,y){const k=this.g++,A=this;this.q.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(k,y);const p={dispose:()=>{this.f.delete(k),A.a.$removeKernelDetectionTask(k)}};return this.f.set(k,p),p}registerKernelSourceActionProvider(D,y,k){const A=this.i++,p=typeof k.onDidChangeNotebookKernelSourceActions=="function"?A:void 0,v=this;this.h.set(A,k),this.q.trace(`NotebookKernelSourceActionProvider[${A}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(A,A,y);let F;return p!==void 0&&(F=k.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(A),v.a.$removeKernelSourceActionProvider(A,A),F?.dispose()}}}async $provideKernelSourceActions(D,y){const k=this.h.get(D);if(k){const A=new L.$Sc;return(await k.provideNotebookKernelSourceActions(y)??[]).map(v=>P.NotebookKernelSourceAction.from(v,this.o.converter,A))}return[]}$acceptNotebookAssociation(D,y,k){const A=this.j.get(D);if(A){const p=this.n.getNotebookDocument(b.URI.revive(y));k?A.associatedNotebooks.set(p.uri,!0):A.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,p.uri.toString(),k),A.onDidChangeSelection.fire({selected:k,notebook:p.apiNotebook})}}async $executeCells(D,y,k){const A=this.j.get(D);if(!A)return;const p=this.n.getNotebookDocument(b.URI.revive(y)),v=[];for(const F of k){const N=p.getCell(F);N&&v.push(N.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,p.uri.toString(),v.length),await A.controller.executeHandler.call(A.controller,v,p.apiNotebook,A.controller)}catch(F){this.q.error(`NotebookController[${D}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(D,y,k){const A=this.j.get(D);if(!A)return;const p=this.n.getNotebookDocument(b.URI.revive(y));if(A.controller.interruptHandler)await A.controller.interruptHandler.call(A.controller,p.apiNotebook);else for(const v of k){const F=p.getCell(v);F&&this.b.get(F.uri)?.cancel()}if(A.controller.interruptHandler){const v=this.c.get(p.uri);this.c.delete(p.uri),k.length&&Array.isArray(v)&&v.length&&v.forEach(F=>F.dispose())}}async $provideVariables(D,y,k,A,p,v,F){const N=this.j.get(D);if(!N)return;const O=this.n.getNotebookDocument(b.URI.revive(k)),j=N.controller.variableProvider;if(!j)return;let z;if(A!==void 0){if(z=this.s[A],!z)return}else this.s={};const M=p==="named"?w.NotebookVariablesRequestKind.Named:w.NotebookVariablesRequestKind.Indexed,W=j.provideVariables(O.apiNotebook,z,M,v,F);let V=0;for await(const ne of W){if(F.isCancellationRequested)return;const B={id:this.r++,name:ne.variable.name,value:ne.variable.value,type:ne.variable.type,interfaces:ne.variable.interfaces,language:ne.variable.language,expression:ne.variable.expression,hasNamedChildren:ne.hasNamedChildren,indexedChildrenCount:ne.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[B.id]=ne.variable,this.a.$receiveVariable(y,B),V++>=i.$VK)return}}$acceptKernelMessageFromRenderer(D,y,k){const A=this.j.get(D);if(!A)return;const p=this.n.getEditorById(y);A.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:k}))}$cellExecutionChanged(D,y,k){const p=this.n.getNotebookDocument(b.URI.revive(D)).getCell(y);if(p){const v=k?P.NotebookCellExecutionState.to(k):w.NotebookCellExecutionState.Idle;v!==void 0&&this.l.fire({cell:p.apiCell,state:v})}}_createNotebookCellExecution(D,y){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const A=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!A)throw new Error("invalid cell");if(this.b.has(A.uri))throw new Error(`duplicate execution for ${A.uri}`);const p=new o(y,A,this.a);this.b.set(A.uri,p);const v=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),v.dispose(),this.b.delete(A.uri))});return p.asApiObject()}_createNotebookExecution(D,y){const k=this.n.getNotebookDocument(D.uri),A=D.getCells().find(F=>{const N=k.getCellFromApiCell(F);return N&&this.b.has(N.uri)});if(A)throw new Error(`duplicate cell execution for ${A.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const p=new d(y,k,this.a),v=p.onDidChangeState(()=>{p.state===n.Resolved&&(p.dispose(),v.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[p,v]),p.asApiObject()}};e.$Dqc=s,e.$Dqc=s=Ye([Ve(4,I.$0j)],s);var t;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(t||(t={}));class o extends L.$Tc{static{this.a=0}get state(){return this.f}constructor(D,y,k){super(),this.m=y,this.n=k,this.b=o.a++,this.c=new R.$je,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new C.$ue),this.h=new l(10,A=>this.s(A)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const y=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new f.$Uw(y))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let y=this.m;if(D&&(y=this.m.notebook.getCellFromApiCell(D)),!y)throw new Error("INVALID cell");return y.handle}y(D){return D.map(y=>{const k=w.$bP.ensureUniqueMimeTypes(y.items,!0);return k===y.items?P.NotebookCellOutput.from(y):P.NotebookCellOutput.from({items:k,id:y.id,metadata:y.metadata})})}async z(D,y,k){const A=this.w(y),p=this.y((0,r.$1b)(D));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:A,append:k,outputs:p})}async C(D,y,k){return D=w.$bP.ensureUniqueMimeTypes((0,r.$1b)(D),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:D.map(P.NotebookCellOutputItem.from),outputId:y.id,append:k})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(k){D.j=k,D.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(k){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,A,p){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const v=p?{message:p.message,stack:p.stack,location:p?.location?{startLineNumber:p.location.start.line,startColumn:p.location.start.character,endLineNumber:p.location.end.line,endColumn:p.location.end.character}:void 0,uri:p.uri}:void 0;D.n.$completeExecution(D.b,new f.$Uw({runEndTime:A,lastRunSuccess:k,error:v}))},clearOutput(k){return D.t(),D.z([],k,!1)},appendOutput(k,A){return D.t(),D.z(k,A,!0)},replaceOutput(k,A){return D.t(),D.z(k,A,!1)},appendOutputItems(k,A){return D.t(),D.C(k,A,!0)},replaceOutputItems(k,A){return D.t(),D.C(k,A,!1)}})}}var n;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(n||(n={}));class d extends L.$Tc{static{this.a=0}get state(){return this.f}constructor(D,y,k){super(),this.h=y,this.j=k,this.b=d.a++,this.c=new R.$je,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new C.$ue),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(D,y){this.f=D,this.g=y,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new h.$Zh,this.b=Date.now(),(0,h.$Dh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>D.complete())}}function g(E,D){return`${E.value}/${D}`}}),define(Se[47],De([1,0,4,6,5,2,19,3,9,8,13,241,20,32,242,243,50,7,15,34,40]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lpc=e.$Kpc=e.$Jpc=e.$Ipc=void 0,e.$Ipc=(0,C.$Ci)("IExtHostTerminalService");class t extends T.$Tc{constructor(p,v,F,N){super(),this.u=p,this._id=v,this.w=F,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new r.$je),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(j=>this.g=j);const O=this;this.value={get name(){return O.y||""},get processId(){return O.b},get creationOptions(){return O.w},get exitStatus(){return O.j},get state(){return O.m},get selection(){return O.n},get shellIntegration(){return O.shellIntegration},sendText(j,z=!0){O.C(),O.u.$sendText(O._id,j,z)},show(j){O.C(),O.u.$show(O._id,j)},hide(){O.C(),O.u.$hide(O._id)},dispose(){O.a||(O.a=!0,O.u.$dispose(O._id))},get dimensions(){if(!(O.f===void 0||O.h===void 0))return{columns:O.f,rows:O.h}}}}dispose(){this.s.fire(),super.dispose()}async create(p,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??v?.cwd??void 0,env:p.env??void 0,icon:D(p.iconPath)??void 0,color:m.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,forceShellIntegration:v?.forceShellIntegration??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this.z(p.location,v?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,v,F,N,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:m.ThemeColor.isThemeColor(O)?O.id:void 0,location:v?.location||this.z(p,F),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(p,v){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in p?{viewColumn:f.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.y=p}setExitStatus(p,v){this.j=Object.freeze({code:p,reason:v})}setDimensions(p,v){return p===this.f&&v===this.h||p===0||v===0?!1:(this.f=p,this.h=v,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(p){this.n=p}_setProcessId(p){this.g?(this.g(p),this.g=void 0):this.b.then(v=>{v!==p&&(this.b=Promise.resolve(p))})}}e.$Jpc=t;class o{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new r.$je,this.onProcessData=this.a.event,this.b=new r.$je,this.d=new r.$je,this.onDidChangeProperty=this.d.event,this.f=new r.$je,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${v}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,v){this.g.setDimensions?.({columns:p,rows:v})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(v=>this.a.fire(v)),this.g.onDidClose?.((v=void 0)=>{this.f.fire(v===void 0?void 0:v)}),this.g.onDidOverrideDimensions?.(v=>{v&&this.d.fire({type:w.ProcessPropertyType.OverrideDimensions,value:{cols:v.columns,rows:v.rows}})}),this.g.onDidChangeName?.(v=>{this.d.fire({type:w.ProcessPropertyType.Title,value:v})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let n=1,d=class extends T.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,v,F){super(),this.Q=v,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new r.$je,this.onDidCloseTerminal=this.H.event,this.I=new r.$je,this.onDidOpenTerminal=this.I.event,this.J=new r.$je,this.onDidChangeActiveTerminal=this.J.event,this.L=new r.$je,this.onDidChangeTerminalDimensions=this.L.event,this.M=new r.$je,this.onDidChangeTerminalState=this.M.event,this.N=new r.$je,this.onDidChangeShell=this.N.event,this.O=new r.$je({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new r.$je({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=F.getProxy(h.$DN.MainThreadTerminalService),this.y=new a.$Lxb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:N=>{const O=j=>{const z=j;return this.getTerminalById(z.instanceId)?.value};switch(N?.$mid){case s.MarshalledId.TerminalContext:return O(N);default:{if(Array.isArray(N))for(let j=0;j<N.length&&N[j].$mid===s.MarshalledId.TerminalContext;j++)N[j]=O(N[j]);return N}}}}),this.B({dispose:()=>{for(const[N,O]of this.g)O.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,v){const F=new t(this.a,(0,P.$Yg)(),p,p.name),N=new o(p.pty);return F.createExtensionTerminal(p.location,v,this.R(p,v).resolvedExtHostIdentifier,D(p.iconPath),y(p.color)).then(O=>{const j=this.S(O,N);this.h[O]=j}),this.f.push(F),F.value}R(p,v){if(v=v||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const F=p.location.parentTerminal;if(F){const N=this.f.find(O=>O.value===F);N&&(v.resolvedExtHostIdentifier=N._id)}}else p.location&&typeof p.location!="object"?v.location=p.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal(p,v){if(!this.getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const N=new o(v),O=this.S(p,N);this.h[p]=O}async $acceptActiveTerminalChanged(p){const v=this.b;if(p===null){this.b=void 0,v!==this.b&&this.J.fire(this.b);return}const F=this.getTerminalById(p);F&&(this.b=F,v!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,v){const F=this.getTerminalById(p);F&&this.O.fire({terminal:F.value,data:v})}async $acceptTerminalDimensions(p,v,F){const N=this.getTerminalById(p);N&&N.setDimensions(v,F)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(p,v){const F=this.getTerminalById(p);F&&this.P.fire({terminal:F.value,...v})}async $acceptTerminalMaximumDimensions(p,v,F){this.g.get(p)?.resize(v,F)}async $acceptTerminalTitleChange(p,v){const F=this.getTerminalById(p);F&&(F.name=v)}async $acceptTerminalClosed(p,v,F){const N=this.X(this.f,p);if(N!==null){const O=this.f.splice(N,1)[0];O.setExitStatus(v,F),this.H.fire(O.value)}}$acceptTerminalOpened(p,v,F,N){if(v){const z=this.X(this.f,v);if(z!==null){this.f[z]._id=p,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const O={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:R.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},j=new t(this.a,p,O,F);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(p,v){this.getTerminalById(p)?._setProcessId(v)}async $startExtensionTerminal(p,v){const F=this.getTerminalById(p);if(!F)return{message:(0,c.localize)(10731,null,p)};F.isOpen||await new Promise(O=>{const j=this.onDidOpenTerminal(async z=>{z===F.value&&(j.dispose(),O())})});const N=this.g.get(p);N?N.startSendingEvents(v):this.j[p]={initialDimensions:v}}S(p,v){const F=new T.$Sc;F.add(v.onProcessReady(O=>this.a.$sendProcessReady(p,O.pid,O.cwd,O.windowsPty))),F.add(v.onDidChangeProperty(O=>this.a.$sendProcessProperty(p,O))),this.y.startBuffering(p,v.onProcessData),F.add(v.onProcessExit(O=>this.U(p,O))),this.g.set(p,v);const N=this.j[p];return N&&v instanceof o&&(v.startSendingEvents(N.initialDimensions),delete this.j[p]),F}$acceptProcessAckDataEvent(p,v){this.g.get(p)?.acknowledgeDataEvent(v)}$acceptProcessInput(p,v){this.g.get(p)?.input(v)}$acceptTerminalInteraction(p){const v=this.getTerminalById(p);v?.setInteractedWith()&&this.M.fire(v.value)}$acceptTerminalSelection(p,v){this.getTerminalById(p)?.setSelection(v)}$acceptProcessResize(p,v,F){try{this.g.get(p)?.resize(v,F)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(p,v){this.g.get(p)?.shutdown(v)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(v=>this.a.$sendProcessProperty(p,{type:w.ProcessPropertyType.InitialCwd,value:v}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(v=>this.a.$sendProcessProperty(p,{type:w.ProcessPropertyType.Cwd,value:v}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new b.$FN(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,v,F){if(this.C.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this.C.set(v,F),this.a.$registerProfileProvider(v,p.identifier.value),new b.$FN(()=>{this.C.delete(v),this.a.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider(p,v,F){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,F),this.a.$registerQuickFixProvider(p,v),new b.$FN(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,v){const F=new u.$ue().token;if(F.isCancellationRequested)return;const N=this.D.get(p);if(!N)return;const O=await N.provideTerminalQuickFixes(v,F);if(O===null||Array.isArray(O)&&O.length===0)return;const j=new T.$Sc;if(this.w.value=j,!Array.isArray(O))return O?f.TerminalQuickFix.from(O,this.Q.converter,j):void 0;const z=[];for(const M of O){const W=f.TerminalQuickFix.from(M,this.Q.converter,j);W&&z.push(W)}return z}async $createContributedProfileTerminal(p,v){const F=new u.$ue().token;let N=await this.C.get(p)?.provideTerminalProfile(F);if(!F.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,v);return}this.createTerminalFromOptions(N.options,v)}}async $provideLinks(p,v){const F=this.getTerminalById(p);if(!F)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const O=new u.$ue;this.G.set(p,O);const j=[],z={terminal:F.value,line:v},M=[];for(const ne of this.z)M.push($.Promises.withAsyncBody(async B=>{O.token.onCancellationRequested(()=>B({provider:ne,links:[]}));const K=await ne.provideTerminalLinks(z,O.token)||[];O.token.isCancellationRequested||B({provider:ne,links:K})}));const W=await Promise.all(M);if(O.token.isCancellationRequested)return[];const V=new Map;for(const ne of W)ne&&ne.links.length>0&&j.push(...ne.links.map(B=>{const K={id:n++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return V.set(K.id,{provider:ne.provider,link:B}),K}));return this.F.set(p,V),j}$activateLink(p,v){const F=this.F.get(p)?.get(v);F&&F.provider.handleTerminalLink(F.link)}U(p,v){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const F=this.h[p];F&&(F.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,v)}getTerminalById(p){return this.W(this.f,p)}getTerminalIdByApiObject(p){const v=this.f.findIndex(F=>F.value===p);return v>=0?v:null}W(p,v){const F=this.X(p,v);return F!==null?p[F]:null}X(p,v){const F=p.findIndex(N=>N._id===v);return F>=0?F:null}getEnvironmentVariableCollection(p){let v=this.n.get(p.identifier.value);return v||(v=this.B(new l),this.Z(p.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}Y(p,v){const F=(0,S.$Cs)(v.map),N=(0,S.$Ds)(v.descriptionMap);this.a.$setEnvironmentVariableCollection(p,v.persistent,F.length===0?void 0:F,N)}$initEnvironmentVariableCollections(p){p.forEach(v=>{const F=v[0],N=this.B(new l(v[1]));this.Z(F,N)})}$acceptDefaultProfile(p,v){const F=this.s;this.s=p,this.u=v,F?.path!==p.path&&this.N.fire(p.path)}Z(p,v){this.n.set(p,v),this.B(v.onDidChangeCollection(()=>{this.Y(p,v)}))}};e.$Kpc=d,e.$Kpc=d=Ye([Ve(1,i.$yQ),Ve(2,L.$cQ)],d);class l extends T.$Tc{get persistent(){return this.b}set persistent(p){this.b=p,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(p){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new r.$je,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const v=this.j(p);let F=this.a.get(v);return F||(F=new g(this,p),this.a.set(v,F),this.B(F.onDidChangeCollection(()=>this.f.fire()))),F}replace(p,v,F,N){this.g(p,{value:v,type:b.EnvironmentVariableMutatorType.Replace,options:F??{applyAtProcessCreation:!0},scope:N})}append(p,v,F,N){this.g(p,{value:v,type:b.EnvironmentVariableMutatorType.Append,options:F??{applyAtProcessCreation:!0},scope:N})}prepend(p,v,F,N){this.g(p,{value:v,type:b.EnvironmentVariableMutatorType.Prepend,options:F??{applyAtProcessCreation:!0},scope:N})}g(p,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const F=this.h(p,v.scope),N=this.map.get(F),O=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==v.value||N.type!==v.type||N.options?.applyAtProcessCreation!==O.applyAtProcessCreation||N.options?.applyAtShellIntegration!==O.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const j=this.h(p,v.scope),z={variable:p,...v,options:O};this.map.set(j,z),this.f.fire()}}get(p,v){const F=this.h(p,v),N=this.map.get(F);return N?k(N):void 0}h(p,v){const F=this.j(v);return F.length?`${p}:::${F}`:p}j(p){return this.m(p?.workspaceFolder)??""}m(p){return p?p.uri.toString():void 0}getVariableMap(p){const v=new Map;for(const[F,N]of this.map)this.j(N.scope)===this.j(p)&&v.set(N.variable,k(N));return v}delete(p,v){const F=this.h(p,v);this.map.delete(F),this.f.fire()}clear(p){if(p?.workspaceFolder){for(const[v,F]of this.map)F.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(v);this.n(p)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(p,v){const F=this.j(v),N=this.descriptionMap.get(F);if(!N||N.description!==p){let O;typeof p=="string"?O=p:O=p?.value.split(`

`)[0];const j={description:O,scope:v};this.descriptionMap.set(F,j),this.f.fire()}}getDescription(p){const v=this.j(p);return this.descriptionMap.get(v)?.description}n(p){const v=this.j(p);this.descriptionMap.delete(v)}}class g{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,v){this.b=p,this.d=v,this.a=new r.$je}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,v,F){this.b.replace(p,v,F,this.d)}append(p,v,F){this.b.append(p,v,F,this.d)}prepend(p,v,F){this.b.prepend(p,v,F,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,v){this.b.getVariableMap(this.d).forEach((F,N)=>p.call(v,N,F,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let E=class extends d{constructor(p,v){super(!1,p,v)}createTerminal(p,v,F){throw new I.$$}createTerminalFromOptions(p,v){throw new I.$$}};e.$Lpc=E,e.$Lpc=E=Ye([Ve(0,i.$yQ),Ve(1,L.$cQ)],E);function D(A){if(!(!A||typeof A=="string"))return"id"in A?{id:A.id,color:A.color}:A}function y(A){return m.ThemeColor.isThemeColor(A)?A:void 0}function k(A){const p={...A};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(Se[167],De([1,0,9,3,5,6,19,47,4,2,7]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wqc=e.$Vqc=void 0,e.$Vqc=(0,C.$Ci)("IExtHostTerminalShellIntegration");let S=class extends h.$Tc{constructor(m,$){super(),this.h=$,this.b=new Map,this.c=new b.$je,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new b.$je,this.onDidStartTerminalShellExecution=this.f.event,this.g=new b.$je,this.onDidEndTerminalShellExecution=this.g.event,this.a=m.getProxy(R.$DN.MainThreadTerminalShellIntegration),this.B((0,h.$Rc)(()=>{for(const[f,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(m){const $=this.h.getTerminalById(m);if(!$)return;const f=$.value;let i=this.b.get(m);i||(i=new u($.value,this.f),this.b.set(m,i),i.store.add($.onWillDispose(()=>this.b.get(m)?.dispose())),i.store.add(i.onDidRequestShellExecution(s=>this.a.$executeCommand(m,s))),i.store.add(i.onDidRequestEndExecution(s=>this.g.fire(s))),i.store.add(i.onDidRequestChangeShellIntegration(s=>this.c.fire(s))),$.shellIntegration=i.value),this.c.fire({terminal:f,shellIntegration:i.value})}$shellExecutionStart(m,$,f,i,s){this.b.has(m)||this.$shellIntegrationChange(m);const t={value:$,confidence:f,isTrusted:i};this.b.get(m)?.startShellExecution(t,s)}$shellExecutionEnd(m,$,f,i,s){const t={value:$,confidence:f,isTrusted:i};this.b.get(m)?.endShellExecution(t,s)}$shellExecutionData(m,$){this.b.get(m)?.emitData($)}$cwdChange(m,$){this.b.get(m)?.setCwd((0,c.$uc)($)?c.URI.revive($):$)}$closeTerminal(m){this.b.get(m)?.dispose(),this.b.delete(m)}};e.$Wqc=S,e.$Wqc=S=Ye([Ve(0,L.$cQ),Ve(1,T.$Ipc)],S);class u extends h.$Tc{get currentExecution(){return this.a}constructor(m,$){super(),this.j=m,this.m=$,this.b=!1,this.store=this.B(new h.$Sc),this.f=this.B(new b.$je),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new b.$je),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new b.$je),this.onDidRequestEndExecution=this.h.event;const f=this;this.value={get cwd(){return f.c},executeCommand(i,s){let t=i;s&&(t+=` "${s.map(d=>`${d.replaceAll('"','\\"')}`).join('" "')}"`),f.g.fire(t);const o={value:t,confidence:r.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},n=f.startShellExecution(o,f.c,!0).value;return f.b=!0,n}}}startShellExecution(m,$,f){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new P(m,$);f?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(m){this.currentExecution?.emitData(m)}endShellExecution(m,$){this.a&&(this.a.endExecution(m),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:$}),this.a=void 0)}setCwd(m){let $=!1;c.URI.isUri(this.c)?$=!c.URI.isUri(m)||this.c.toString()!==m.toString():this.c!==m&&($=!0),$&&(this.c=m,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class P{constructor(m,$){this.c=m,this.cwd=$,this.b=!1;const f=this;this.value={get commandLine(){return f.c},get cwd(){return f.cwd},read(){return f.d()}}}d(){if(!this.a){if(this.b)return I.$3h.EMPTY;this.a=new w}return this.a.createIterable()}emitData(m){this.a?.emitData(m)}endExecution(m){m&&(this.c=m),this.a?.endExecution(),this.a=void 0,this.b=!0}}class w extends h.$Tc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Bh);const m=this.a;return new I.$3h(async f=>{this.b.push(f),await m.wait()})}emitData(m){for(const $ of this.b)$.emitOne(m)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Se[168],De([1,0,65,13,132,15,9]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lQ=e.$kQ=e.$jQ=void 0,R=Ue(R);class T{static{this.c=new C.$hQ("TextEditorDecorationType")}constructor(u,P,w){const a=T.c.nextId();u.$registerTextEditorDecorationType(P.identifier,a,R.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:a,dispose(){u.$removeTextEditorDecorationType(a)}})}}e.$jQ=T;class b{constructor(u,P){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=P.undoStopBefore,this.f=P.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,P){this.k();let w=null;if(u instanceof L.$GN)w=new L.$HN(u,u);else if(u instanceof L.$HN)w=u;else throw new Error("Unrecognized location");this.l(w,P,!1)}insert(u,P){this.k(),this.l(new L.$HN(u,u),P,!0)}delete(u){this.k();let P=null;if(u instanceof L.$HN)P=u;else throw new Error("Unrecognized location");this.l(P,null,!0)}l(u,P,w){const a=this.c.validateRange(u);this.g.push({range:a,text:P,forceMoveMarkers:w})}setEndOfLine(u){if(this.k(),u!==L.EndOfLine.LF&&u!==L.EndOfLine.CRLF)throw(0,h.$6)("endOfLine");this.h=u}}class c{constructor(u,P,w,a){this.c=u,this.d=P,this._accept(w),this.e=a;const m=this;this.value={get tabSize(){return m.f},set tabSize($){m.n($)},get indentSize(){return m.g},set indentSize($){m.p($)},get insertSpaces(){return m.j},set insertSpaces($){m.s($)},get cursorStyle(){return m.k},set cursorStyle($){m.t($)},get lineNumbers(){return m.l},set lineNumbers($){m.u($)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const P=Math.floor(u);return P>0?P:null}if(typeof u=="string"){const P=parseInt(u,10);return isNaN(P)?null:P>0?P:null}return null}n(u){const P=this.m(u);if(P!==null){if(typeof P=="number"){if(this.f===P)return;this.f=P}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:P}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const P=Math.floor(u);return P>0?P:null}if(typeof u=="string"){const P=parseInt(u,10);return isNaN(P)?null:P>0?P:null}return null}p(u){const P=this.o(u);if(P!==null){if(typeof P=="number"){if(this.h===P)return;this.g=P,this.h=P}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:P}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const P=this.q(u);if(typeof P=="boolean"){if(this.j===P)return;this.j=P}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:P}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(u)})))}assign(u){const P={};let w=!1;if(typeof u.tabSize<"u"){const a=this.m(u.tabSize);a==="auto"?(w=!0,P.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,w=!0,P.tabSize=a)}if(typeof u.indentSize<"u"){const a=this.o(u.indentSize);a==="tabSize"?(w=!0,P.indentSize=a):typeof a=="number"&&this.h!==a&&(this.g=a,this.h=a,w=!0,P.indentSize=a)}if(typeof u.insertSpaces<"u"){const a=this.q(u.insertSpaces);a==="auto"?(w=!0,P.insertSpaces=a):this.j!==a&&(this.j=a,w=!0,P.insertSpaces=a)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,w=!0,P.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,w=!0,P.lineNumbers=R.TextEditorLineNumbersStyle.from(u.lineNumbers)),w&&this.v("setOptions",this.c.$trySetOptions(this.d,P))}v(u,P){P.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(w)})}}e.$kQ=c;class I{constructor(u,P,w,a,m,$,f,i){this.id=u,this.j=P,this.k=w,this.g=!1,this.h=new Set,this.c=m,this.d=new c(this.j,this.id,$,w),this.e=f,this.f=i;const s=this;this.value=Object.freeze({get document(){return a.value},set document(t){throw new h.$8("document")},get selection(){return s.c&&s.c[0]},set selection(t){if(!(t instanceof L.$IN))throw(0,h.$6)("selection");s.c=[t],s.l()},get selections(){return s.c},set selections(t){if(!Array.isArray(t)||t.some(o=>!(o instanceof L.$IN)))throw(0,h.$6)("selections");s.c=t,s.l()},get visibleRanges(){return s.e},set visibleRanges(t){throw new h.$8("visibleRanges")},get options(){return s.d.value},set options(t){s.g||s.d.assign(t)},get viewColumn(){return s.f},set viewColumn(t){throw new h.$8("viewColumn")},edit(t,o={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new b(a.value,o);return t(n),s.m(n)},insertSnippet(t,o,n={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!o||Array.isArray(o)&&o.length===0)d=s.c.map(l=>R.Range.from(l));else if(o instanceof L.$GN){const{lineNumber:l,column:g}=R.Position.from(o);d=[{startLineNumber:l,startColumn:g,endLineNumber:l,endColumn:g}]}else if(o instanceof L.$HN)d=[R.Range.from(o)];else{d=[];for(const l of o)if(l instanceof L.$HN)d.push(R.Range.from(l));else{const{lineNumber:g,column:E}=R.Position.from(l);d.push({startLineNumber:g,startColumn:E,endLineNumber:g,endColumn:E})}}return P.$tryInsertSnippet(u,a.value.version,t.value,d,n)},setDecorations(t,o){const n=o.length===0;n&&!s.h.has(t.key)||(n?s.h.delete(t.key):s.h.add(t.key),s.n(()=>{if(R.$_P(o))return P.$trySetDecorations(u,t.key,R.$aQ(o));{const d=new Array(4*o.length);for(let l=0,g=o.length;l<g;l++){const E=o[l];d[4*l]=E.start.line+1,d[4*l+1]=E.start.character+1,d[4*l+2]=E.end.line+1,d[4*l+3]=E.end.character+1}return P.$trySetDecorationsFast(u,t.key,d)}}))},revealRange(t,o){s.n(()=>P.$tryRevealRange(u,R.Range.from(t),o||L.TextEditorRevealType.Default))},show(t){P.$tryShowEditor(u,R.ViewColumn.from(t))},hide(){P.$tryHideEditor(u)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,r.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,r.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,r.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,r.ok)(!this.g),this.f=u}_acceptSelections(u){(0,r.ok)(!this.g),this.c=u}async l(){const u=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const P=u.finalize();if(P.edits.length===0&&!P.setEndOfLine)return Promise.resolve(!0);const w=P.edits.map(m=>m.range);w.sort((m,$)=>m.end.line===$.end.line?m.end.character===$.end.character?m.start.line===$.start.line?m.start.character-$.start.character:m.start.line-$.start.line:m.end.character-$.end.character:m.end.line-$.end.line);for(let m=0,$=w.length-1;m<$;m++){const f=w[m].end;if(w[m+1].start.isBefore(f))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=P.edits.map(m=>({range:R.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,P.documentVersionId,a,{setEndOfLine:typeof P.setEndOfLine=="number"?R.EndOfLine.from(P.setEndOfLine):void 0,undoStopBefore:P.undoStopBefore,undoStopAfter:P.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,P=>(P instanceof Error&&P.name==="DISPOSED"||this.k.warn(P),null))}}e.$lQ=I}),define(Se[63],De([1,0,65,4,3,2,5,6,164,19,168,15,11,28,14,39,49]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=e.$mQ=void 0,r=Ue(r),S=Ue(S);class ${constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let f=class{constructor(s,t){this.h=s,this.i=t,this.a=null,this.b=new Map,this.c=new P.$zc,this.d=new h.$je,this.e=new h.$je,this.f=new h.$je,this.g=new h.$je,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const t=[],o=[],n=[];if(s.removedDocuments)for(const d of s.removedDocuments){const l=R.URI.revive(d),g=this.c.get(l);g?.unref()&&(this.c.delete(l),t.push(g.value))}if(s.addedDocuments)for(const d of s.addedDocuments){const l=R.URI.revive(d.uri);let g=this.c.get(l);if(g&&l.scheme!==w.Schemas.vscodeNotebookCell&&l.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);g||(g=new $(new b.$fQ(this.h.getProxy(T.$DN.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(l,g),o.push(g.value)),g.ref()}if(s.removedEditors)for(const d of s.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&n.push(l)}if(s.addedEditors)for(const d of s.addedEditors){const l=R.URI.revive(d.documentUri);r.ok(this.c.has(l),`document '${l}' does not exist`),r.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const g=this.c.get(l).value,E=new I.$lQ(d.id,this.h.getProxy(T.$DN.MainThreadTextEditors),this.i,new m.$T(()=>g.document),d.selections.map(S.Selection.to),d.options,d.visibleRanges.map(D=>S.Range.to(D)),typeof d.editorPosition=="number"?S.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,E)}s.newActiveEditor!==void 0&&(r.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,C.$Oc)(t),(0,C.$Oc)(n),s.removedDocuments&&this.e.fire(t),s.addedDocuments&&this.d.fire(o),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return a.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const t=this.b.get(this.a);return s?t:t?.value}allEditors(){return[...this.b.values()]}};e.$mQ=f,e.$mQ=f=Ye([Ve(0,c.$cQ),Ve(1,u.$0j)],f),e.$nQ=(0,L.$Ci)("IExtHostDocumentsAndEditors")}),define(Se[98],De([1,0,7,21,20,4,79,60,3,40,17,32,5,11,6,34,63,19,166,15,9,264,73,120,74,25]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=e.$6pc=e.$5pc=e.$4pc=e.$3pc=void 0,i=Ue(i);let g=0;const E=new WeakMap;e.$3pc=(0,u.$Ci)("IExtHostTesting");let D=class extends b.$Tc{constructor(B,K,Y,ee){super(),this.C=K,this.D=Y,this.F=ee,this.f=this.B(new R.$je),this.g=new Map,this.w=this.B(new R.$je),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=B.getProxy(w.$DN.MainThreadTesting),this.m=new j(this.h),this.j=new p(this.h,K),Y.registerArgumentProcessor({processArgument:ue=>{switch(ue?.$mid){case c.MarshalledId.TestItemContext:{const re=ue,ye=re.tests[re.tests.length-1].item.extId;return this.g.get(o.$3I.root(ye))?.collection.tree.get(ye)?.actual??(0,f.$oQ)(ue)}case c.MarshalledId.TestMessageMenuArgs:{const{test:re,message:ye}=ue,me=re.item.extId;return{test:this.g.get(o.$3I.root(me))?.collection.tree.get(me)?.actual??(0,f.$oQ)({$mid:c.MarshalledId.TestItemContext,tests:[re]}),message:i.TestMessage.to(ye)}}default:return ue}}}),Y.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ue=await Y.executeCommand(t.TestCommandId.GetExplorerSelection),re=ye=>{const me=this.g.get(o.$3I.root(ye));if(me)return o.$3I.isRoot(ye)?me.controller:me.collection.tree.get(ye)?.actual};return{include:ue?.include.map(re).filter(I.$kg)||[],exclude:ue?.exclude.map(re).filter(I.$kg)||[]}})}createTestController(B,K,Y,ee){if(this.g.has(K))throw new Error(`Attempt to insert a duplicate controller with ID "${K}"`);const ue=new b.$Sc,re=ue.add(new f.$rQ(K,Y,this.F));re.root.label=Y;const ye=new Map,me=new Set,J=this.h,U={items:re.root.children,get label(){return Y},set label(ae){Y=ae,re.root.label=ae,J.$updateController(K,{label:Y})},get refreshHandler(){return ee},set refreshHandler(ae){ee=ae,J.$updateController(K,{canRefresh:!!ae})},get id(){return K},createRunProfile:(ae,te,ce,le,x,oe)=>{let pe=(0,T.$qj)(ae);for(;ye.has(pe);)pe++;return new M(this.h,ye,me,this.w.event,K,pe,ae,te,ce,le,x,oe)},createTestItem(ae,te,ce){return new f.$pQ(K,ae,te,ce)},createTestRun:(ae,te,ce=!0)=>this.j.createTestRun(B,K,re,ae,te,ce),invalidateTestResults:ae=>{if(ae===void 0)this.h.$markTestRetired(void 0);else{const te=ae instanceof Array?ae:[ae];this.h.$markTestRetired(te.map(ce=>o.$3I.fromExtHostTestItem(ce,K).toString()))}},set resolveHandler(ae){re.resolveHandler=ae},get resolveHandler(){return re.resolveHandler},dispose:()=>{ue.dispose()}};J.$registerTestController(K,Y,!!ee),ue.add((0,b.$Rc)(()=>J.$unregisterTestController(K)));const se={controller:U,collection:re,profiles:ye,extension:B,activeProfiles:me};return this.g.set(K,se),ue.add((0,b.$Rc)(()=>this.g.delete(K))),ue.add(re.onDidGenerateDiff(ae=>J.$publishDiff(K,ae.map(d.TestsDiffOp.serialize)))),U}createTestObserver(){return this.m.checkout()}async runTests(B,K=C.CancellationToken.None){const Y=v(B);if(!Y)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ee=this.g.get(Y.controllerId);if(!ee)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:B.preserveFocus??!0,group:W[Y.kind],targets:[{testIds:B.include?.map(ue=>o.$3I.fromExtHostTestItem(ue,ee.collection.root.id).toString())??[ee.collection.root.id],profileId:Y.profileId,controllerId:Y.controllerId}],exclude:B.exclude?.map(ue=>ue.id)},K)}registerTestFollowupProvider(B){return this.y.add(B),{dispose:()=>{this.y.delete(B)}}}$syncTests(){for(const{collection:B}of this.g.values())B.flushDiff();return Promise.resolve()}async $getCoverageDetails(B,K,Y){return(await this.j.getCoverageDetails(B,K,Y))?.map(i.TestCoverage.fromDetails)}async $disposeRun(B){this.j.disposeTestRun(B)}$configureRunProfile(B,K){this.g.get(B)?.profiles.get(K)?.configureHandler?.()}$setDefaultRunProfiles(B){const K=new Map;for(const[Y,ee]of Object.entries(B)){const ue=this.g.get(Y);if(!ue)continue;const re=new Map,ye=ee.filter(J=>!ue.activeProfiles.has(J)),me=[...ue.activeProfiles].filter(J=>!ee.includes(J));for(const J of ye)re.set(J,!0),ue.activeProfiles.add(J);for(const J of me)re.set(J,!1),ue.activeProfiles.delete(J);re.size&&K.set(Y,re)}this.w.fire(K)}async $refreshTests(B,K){await this.g.get(B)?.controller.refreshHandler?.(K)}$publishTestResults(B){this.results=Object.freeze(B.map(K=>{const Y=i.TestResults.to(K);return E.set(Y,K.id),Y}).concat(this.results).sort((K,Y)=>Y.completedAt-K.completedAt).slice(0,32)),this.f.fire()}async $expandTest(B,K){const Y=this.g.get(o.$3I.fromString(B).controllerId)?.collection;Y&&(await Y.expand(B,K<0?1/0:K),Y.flushDiff())}$acceptDiff(B){this.m.applyDiff(B.map(K=>d.TestsDiffOp.deserialize({asCanonicalUri:Y=>Y},K)))}async $runControllerTests(B,K){return Promise.all(B.map(Y=>this.G(Y,!1,K)))}async $startContinuousRun(B,K){const Y=new C.$ue(K),ee=await Promise.all(B.map(ue=>this.G(ue,!0,Y.token)));return!K.isCancellationRequested&&!ee.some(ue=>ue.error)&&await new Promise(ue=>K.onCancellationRequested(ue)),Y.dispose(!0),ee}async $provideTestFollowups(B,K){const Y=this.results.find(re=>E.get(re)===B.resultId),ee=Y&&V(o.$3I.fromString(B.extId),Y?.results);if(!ee)return[];let ue=[];return await Promise.all([...this.y].map(async re=>{try{const ye=await re.provideFollowup(Y,ee,B.taskIndex,B.messageIndex,K);ye&&(ue=ue.concat(ye))}catch(ye){this.C.error("Error thrown while providing followup for test message",ye)}})),K.isCancellationRequested?[]:ue.map(re=>{const ye=g++;return this.z.set(ye,re),{title:re.title,id:ye}})}$disposeTestFollowups(B){for(const K of B)this.z.delete(K)}$executeTestFollowup(B){const K=this.z.get(B);return K?this.D.executeCommand(K.command,...K.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(B){B===void 0?this.j.cancelAllRuns():this.j.cancelRunById(B)}getMetadataForRun(B){for(const K of this.j.trackers){const Y=K.getTaskIdForRun(B);if(Y)return{taskId:Y,runId:K.id}}}async G(B,K,Y){const ee=this.g.get(B.controllerId);if(!ee)return{};const{collection:ue,profiles:re,extension:ye}=ee,me=re.get(B.profileId);if(!me)return{};const J=B.testIds.map(te=>ue.tree.get(te)).filter(I.$kg),U=B.excludeExtIds.map(te=>ee.collection.tree.get(te)).filter(I.$kg).filter(te=>J.some(ce=>ce.fullId.compare(te.fullId)===o.TestPosition.IsChild));if(!J.length)return{};const se=new s.$iP(J.some(te=>te.actual instanceof f.$qQ)?void 0:J.map(te=>te.actual),U.map(te=>te.actual),me,K),ae=(0,d.$6I)(B)&&this.j.prepareForMainThreadTestRun(ye,se,F.fromInternal(B,ee.collection),me,Y);try{return await me.runHandler(se,Y),{}}catch(te){return{error:String(te)}}finally{ae&&ae.hasRunningTasks&&!Y.isCancellationRequested&&await R.Event.toPromise(ae.onEnd)}}};e.$4pc=D,e.$4pc=D=Ye([Ve(0,$.$cQ),Ve(1,P.$0j),Ve(2,a.$yQ),Ve(3,m.$nQ)],D);const y=1e4;var k;(function(ne){ne[ne.Running=0]="Running",ne[ne.Cancelling=1]="Cancelling",ne[ne.Ended=2]="Ended"})(k||(k={}));class A extends b.$Tc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(B,K,Y,ee,ue,re){super(),this.z=B,this.C=K,this.D=Y,this.F=ee,this.G=ue,this.c=k.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$je),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new C.$ue(re));const ye=this.B(new r.$Oh(()=>this.H(),y));this.B(this.j.token.onCancellationRequested(()=>ye.schedule()));const me=new R.$je;this.w=me.event,this.B((0,b.$Rc)(()=>{me.fire(),me.dispose()}))}getTaskIdForRun(B){for(const[K,{run:Y}]of this.g)if(Y===B)return K}cancel(){this.c===k.Running?(this.j.cancel(),this.c=k.Cancelling):this.c===k.Cancelling&&this.H()}async getCoverageDetails(B,K,Y){const[,ee]=o.$3I.fromString(B).path,ue=this.y.get(B);if(!ue)return[];const{report:re,extIds:ye}=ue,me=this.g.get(ee);if(!me)throw new Error("unreachable: run task was not found");let J;if(K&&re instanceof s.$oP){const se=ye.indexOf(K);if(se===-1)return[];J=re.fromTests[se]}return await(J?this.F?.loadDetailedCoverageForTest?.(me.run,re,J,Y):this.F?.loadDetailedCoverage?.(me.run,re,Y))??[]}createRun(B){const K=this.z.id,Y=this.z.controllerId,ee=(0,S.$Yg)(),ue=J=>(U,...se)=>{if(ye){this.D.warn(`Setting the state of test "${U.id}" is a no-op after the run ends.`);return}this.J(U),J(U,...se)},re=(J,U)=>{const se=U instanceof Array?U.map(i.TestMessage.from):[i.TestMessage.from(U)];if(J.uri&&J.range){const ae={range:i.Range.from(J.range),uri:J.uri};for(const te of se)te.location=te.location||ae}this.C.$appendTestMessagesInRun(K,ee,o.$3I.fromExtHostTestItem(J,Y).toString(),se)};let ye=!1;const me={isPersisted:this.z.isPersisted,token:this.j.token,name:B,onDidDispose:this.w,addCoverage:J=>{if(ye)return;const U=J instanceof s.$oP?J.fromTests:[];if(U.length){(0,l.$dH)(this.G,"attributableCoverage");for(const te of U)this.J(te)}const se=J.uri.toString(),ae=new o.$3I([K,ee,se]).toString();this.y.set(ae,{report:J,extIds:U.map(te=>o.$3I.fromExtHostTestItem(te,Y).toString())}),this.C.$appendCoverage(K,ee,i.TestCoverage.fromFile(Y,ae,J))},enqueued:ue(J=>{this.C.$updateTestStateInRun(K,ee,o.$3I.fromExtHostTestItem(J,Y).toString(),d.TestResultState.Queued)}),skipped:ue(J=>{this.C.$updateTestStateInRun(K,ee,o.$3I.fromExtHostTestItem(J,Y).toString(),d.TestResultState.Skipped)}),started:ue(J=>{this.C.$updateTestStateInRun(K,ee,o.$3I.fromExtHostTestItem(J,Y).toString(),d.TestResultState.Running)}),errored:ue((J,U,se)=>{re(J,U),this.C.$updateTestStateInRun(K,ee,o.$3I.fromExtHostTestItem(J,Y).toString(),d.TestResultState.Errored,se)}),failed:ue((J,U,se)=>{re(J,U),this.C.$updateTestStateInRun(K,ee,o.$3I.fromExtHostTestItem(J,Y).toString(),d.TestResultState.Failed,se)}),passed:ue((J,U)=>{this.C.$updateTestStateInRun(K,ee,o.$3I.fromExtHostTestItem(J,this.z.controllerId).toString(),d.TestResultState.Passed,U)}),appendOutput:(J,U,se)=>{ye||(se&&this.J(se),this.C.$appendOutputToRun(K,ee,h.$Le.fromString(J),U&&i.location.from(U),se&&o.$3I.fromExtHostTestItem(se,Y).toString()))},end:()=>{ye||(ye=!0,this.C.$finishedTestRunTask(K,ee),--this.f||this.I())}};return this.f++,this.g.set(ee,{run:me}),this.C.$startedTestRunTask(K,{id:ee,name:B,running:!0}),me}H(){for(const{run:B}of this.g.values())B.end()}I(){this.c!==k.Ended&&(this.c=k.Ended,this.m.fire())}J(B){if(!(B instanceof f.$pQ))throw new n.$7P(B.id);if(this.h.has(o.$3I.fromExtHostTestItem(B,this.z.controllerId).toString()))return;const K=[],Y=this.z.colllection.root;for(;;){const ee=i.TestItem.from(B);if(K.unshift(ee),this.h.has(ee.extId)||(this.h.add(ee.extId),B===Y))break;B=B.parent||Y}this.C.$addTestsToRun(this.z.controllerId,this.z.id,K)}dispose(){this.I(),super.dispose()}}class p{get trackers(){return this.c.values()}constructor(B,K){this.g=B,this.h=K,this.c=new Map,this.f=new Map}getCoverageDetails(B,K,Y){const ee=o.$3I.root(B);return this.f.get(ee)?.getCoverageDetails(B,K,Y)||[]}disposeTestRun(B){this.f.get(B)?.dispose(),this.f.delete(B);for(const[K,{id:Y}]of this.c)Y===B&&this.c.delete(K)}prepareForMainThreadTestRun(B,K,Y,ee,ue){return this.j(K,Y,ee,B,ue)}cancelRunById(B){this.f.get(B)?.cancel()}cancelAllRuns(){for(const B of this.c.values())B.cancel()}createTestRun(B,K,Y,ee,ue,re){const ye=this.c.get(ee);if(ye)return ye.createRun(ue);const me=F.fromPublic(K,Y,ee,re),J=v(ee);this.g.$startedExtensionTestRun({controllerId:K,continuous:!!ee.continuous,profile:J&&{group:W[J.kind],id:J.profileId},exclude:ee.exclude?.map(se=>o.$3I.fromExtHostTestItem(se,Y.root.id).toString())??[],id:me.id,include:ee.include?.map(se=>o.$3I.fromExtHostTestItem(se,Y.root.id).toString())??[Y.root.id],preserveFocus:ee.preserveFocus??!0,persist:re});const U=this.j(ee,me,ee.profile,B);return R.Event.once(U.onEnd)(()=>{this.g.$finishedExtensionTestRun(me.id)}),U.createRun(ue)}j(B,K,Y,ee,ue){const re=new A(K,this.g,this.h,Y,ee,ue);return this.c.set(B,re),this.f.set(re.id,re),re}}e.$5pc=p;const v=ne=>{if(ne.profile){if(!(ne.profile instanceof M))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ne.profile}};class F{static fromPublic(B,K,Y,ee){return new F(B,(0,S.$Yg)(),ee,K)}static fromInternal(B,K){return new F(B.controllerId,B.runId,!0,K)}constructor(B,K,Y,ee){this.controllerId=B,this.id=K,this.isPersisted=Y,this.colllection=ee}}e.$6pc=F;class N{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(B){this.j=B,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(B){this.c.add(B)}update(B){Object.assign(B.revived,i.TestItem.toPlain(B.item)),this.c.has(B)||this.f.add(B)}remove(B){if(this.c.has(B)){this.c.delete(B);return}this.f.delete(B);const K=o.$3I.parentId(B.item.extId);if(K&&this.h.has(K.toString())){this.h.add(B.item.extId);return}this.g.add(B)}getChangeEvent(){const{c:B,f:K,g:Y}=this;return{get added(){return[...B].map(ee=>ee.revived)},get updated(){return[...K].map(ee=>ee.revived)},get removed(){return[...Y].map(ee=>ee.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class O extends d.$_I{constructor(){super(...arguments),this.y=new R.$je,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(B){return this.f.get(B)}getMirroredTestDataByReference(B){return this.f.get(B.id)}x(B,K){return{...B,revived:i.TestItem.toPlain(B.item),depth:K?K.depth+1:0,children:new Set}}w(){return new N(this.y)}}class j{constructor(B){this.f=B}checkout(){this.c||(this.c=this.g());const B=this.c;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(K=>K.revived)},dispose:(0,L.$cb)(()=>{--B.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(B){return this.c?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.c?.tests.apply(B)}g(){const B=new O({asCanonicalUri:K=>K});return this.f.$subscribeToDiffs(),{observers:0,tests:B}}}const z=(ne,B,K,Y)=>{K?Object.assign(K,Y):B.$updateTestRunConfig(ne.controllerId,ne.profileId,Y)};class M{#e;#t;#i;#n;#s;get label(){return this.f}set label(B){B!==this.f&&(this.f=B,z(this,this.#e,this.#n,{label:B}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(B){B!==this.g&&(this.g=B,z(this,this.#e,this.#n,{supportsContinuousRun:B}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(B){B!==this.isDefault&&(B?this.#t.add(this.profileId):this.#t.delete(this.profileId),z(this,this.#e,this.#n,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,z(this,this.#e,this.#n,{tag:B?i.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this.c}set configureHandler(B){B!==this.c&&(this.c=B,z(this,this.#e,this.#n,{hasConfigurationHandler:!!B}))}get onDidChangeDefault(){return R.Event.chain(this.#i,B=>B.map(K=>K.get(this.controllerId)?.get(this.profileId)).filter(I.$kg))}constructor(B,K,Y,ee,ue,re,ye,me,J,U=!1,se=void 0,ae=!1){this.controllerId=ue,this.profileId=re,this.f=ye,this.kind=me,this.runHandler=J,this._tag=se,this.g=ae,this.#e=B,this.#s=K,this.#t=Y,this.#i=ee,K.set(re,this);const te=W[me];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${me}`);U&&Y.add(re),this.#n={profileId:re,controllerId:ue,tag:se?i.TestTag.namespace(this.controllerId,se.id):null,label:ye,group:te,isDefault:U,hasConfigurationHandler:!1,supportsContinuousRun:ae},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$7pc=M;const W={[s.TestRunProfileKind.Coverage]:d.TestRunProfileBitset.Coverage,[s.TestRunProfileKind.Debug]:d.TestRunProfileBitset.Debug,[s.TestRunProfileKind.Run]:d.TestRunProfileBitset.Run};function V(ne,B){for(let K=0;K<ne.path.length;K++){const Y=B.find(ee=>ee.id===ne.path[K]);if(!Y)return;if(K===ne.path.length-1)return Y;B=Y.children}}}),define(Se[320],De([1,0,18,4,3,6,168,15,9]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=void 0,r=Ue(r),T=Ue(T);class c extends C.$Tc{constructor(S,u){super(),this.m=u,this.a=new h.$je,this.b=new h.$je,this.c=new h.$je,this.f=new h.$je,this.g=new h.$je,this.h=new h.$je,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=S.getProxy(R.$DN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(P=>this.h.fire(P))),this.B(this.m.onDidChangeActiveTextEditor(P=>this.g.fire(P)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(S){const u=this.m.allEditors();return S?u:u.map(P=>P.value)}async showTextDocument(S,u,P){let w;typeof u=="number"?w={position:T.ViewColumn.from(u),preserveFocus:P}:typeof u=="object"?w={position:T.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?T.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:w={preserveFocus:!1};const a=await this.j.$tryShowTextDocument(S.uri,w),m=a&&this.m.getEditor(a);if(m)return m.value;throw a?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}createTextEditorDecorationType(S,u){return new L.$jQ(this.j,S,u).value}$acceptEditorPropertiesChanged(S,u){const P=this.m.getEditor(S);if(!P)throw new Error("unknown text editor");if(u.options&&P._acceptOptions(u.options),u.selections){const w=u.selections.selections.map(T.Selection.to);P._acceptSelections(w)}if(u.visibleRanges){const w=r.$Gb(u.visibleRanges.map(T.Range.to));P._acceptVisibleRanges(w)}if(u.options&&this.b.fire({textEditor:P.value,options:{...u.options,lineNumbers:T.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const w=b.TextEditorSelectionChangeKind.fromValue(u.selections.source),a=u.selections.selections.map(T.Selection.to);this.a.fire({textEditor:P.value,selections:a,kind:w})}if(u.visibleRanges){const w=r.$Gb(u.visibleRanges.map(T.Range.to));this.c.fire({textEditor:P.value,visibleRanges:w})}}$acceptEditorPositionData(S){for(const u in S){const P=this.m.getEditor(u);if(!P)throw new Error("Unknown text editor");const w=T.ViewColumn.to(S[u]);P.value.viewColumn!==w&&(P._acceptViewColumn(w),this.f.fire({textEditor:P.value,viewColumn:w}))}}getDiffInformation(S){return Promise.resolve(this.j.$getDiffInformation(S))}}e.$bpc=c}),define(Se[321],De([1,0,2,5,6,3,9,15,23,40,17]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zqc=e.$Yqc=void 0,e.$Yqc=(0,h.$Ci)("IExtHostTimeline");class S{constructor(w,a){this.b=new Map,this.c=new Map,this.a=w.getProxy(C.$DN.MainThreadTimeline),a.registerArgumentProcessor({processArgument:(m,$)=>{if(m&&m.$mid===c.MarshalledId.TimelineActionContext)if(this.b.get(m.source)&&b.$on.equals($,this.b.get(m.source)?.extension)){const f=m.uri===void 0?void 0:r.URI.revive(m.uri);return this.c.get(m.source)?.get(u(f))?.get(m.handle)}else return;return m}})}async $getTimeline(w,a,m,$){return this.b.get(w)?.provider.provideTimeline(r.URI.revive(a),m,$)}registerTimelineProvider(w,a,m,$){const f=new R.$Sc,i=this.d(a.id,$,f).bind(this);let s;a.onDidChange&&(s=a.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:a.id}),this));const t=this.c;return this.f({...a,scheme:w,onDidChange:void 0,async provideTimeline(o,n,d){n?.resetCache&&(f.clear(),t.get(a.id)?.clear());const l=await a.provideTimeline(o,n,d);if(l==null)return;const g=i(o,n);return{...l,source:a.id,items:l.items.map(g)}},dispose(){for(const o of t.values())o.get(a.id)?.clear();s?.dispose(),f.dispose()}},m)}d(w,a,m){return($,f)=>{let i;if(f?.cacheResults){let s=this.c.get(w);s===void 0&&(s=new Map,this.c.set(w,s));const t=u($);i=s.get(t),i===void 0&&(i=new Map,s.set(t,i))}return s=>{const{iconPath:t,...o}=s,n=`${w}|${s.id??s.timestamp}`;i?.set(n,s);let d,l,g;s.iconPath&&(t instanceof L.$EO?g={id:t.id,color:t.color}:r.URI.isUri(t)?(d=t,l=t):{light:d,dark:l}=t);let E;return L.$0N.isMarkdownString(o.tooltip)?E=T.MarkdownString.from(o.tooltip):(0,I.$cg)(o.tooltip)?E=o.tooltip:L.$0N.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=T.MarkdownString.from(o.detail)):(0,I.$cg)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=o.detail),{...o,id:o.id??void 0,handle:n,source:w,command:s.command?a.toInternal(s.command,m):void 0,icon:d,iconDark:l,themeIcon:g,tooltip:E,accessibilityInformation:s.accessibilityInformation}}}}f(w,a){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:a}),(0,R.$Rc)(()=>{for(const $ of this.c.values())$.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$Zqc=S;function u(P){return P?.toString()}}),define(Se[322],De([1,0,8,22,2,4,3,255,7,9,17,18,15,85,20,209,25]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1qc=void 0,c=Ue(c);function $(s,t){if((0,I.$cg)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let o;return Array.isArray(s.highlights)&&(o=s.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),o=o.length?o:void 0),{label:s.label,highlights:o}}}class f extends L.$Tc{constructor(t,o,n){super(),this.f=t,this.g=o,this.h=n,this.a=new Map,this.b=new a.$E_;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}o.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(g=>d(g)?this.r(g):g):l})}registerTreeDataProvider(t,o,n){const d=this.createTreeView(t,{treeDataProvider:o},n);return{dispose:()=>d.dispose()}}createTreeView(t,o,n){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=o.dragAndDropController?.dropMimeTypes??[],l=o.dragAndDropController?.dragMimeTypes??[],g=!!o.dragAndDropController?.handleDrag,E=!!o.dragAndDropController?.handleDrop,D=this.m(t,o,n),y={showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:g,hasHandleDrop:E,manuallyManageCheckboxes:!!o.manageCheckboxStateManually},k=this.f.$registerTreeViewDataProvider(t,y),A={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,m.$dH)(n,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,m.$dH)(n,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(p){(0,P.$3k)(p)&&(0,m.$dH)(n,"treeViewMarkdownMessage"),D.message=p},get title(){return D.title},set title(p){D.title=p},get description(){return D.description},set description(p){D.description=p},get badge(){return D.badge},set badge(p){p!==void 0&&c.ViewBadge.isViewBadge(p)?D.badge={value:Math.floor(Math.abs(p.value)),tooltip:p.tooltip}:p===void 0&&(D.badge=void 0)},reveal:(p,v)=>D.reveal(p,v),dispose:async()=>{await k,this.a.delete(t),D.dispose()}};return this.B(A),A}$getChildren(t,o){const n=this.a.get(t);return n?n.getChildren(o):Promise.reject(new T.$zG(t))}async $handleDrop(t,o,n,d,l,g,E,D){const y=this.a.get(t);if(!y)return Promise.reject(new T.$zG(t));const k=u.DataTransfer.toDataTransfer(n,async A=>(await this.f.$resolveDropFileData(t,o,A)).buffer);return E===t&&D&&await this.j(k,y,D,l,g),y.onDrop(k,d,l)}async j(t,o,n,d,l){const g=this.b.removeDragOperationTransfer(l);if(g)(await g)?.forEach((E,D)=>{E&&t.set(D,E)});else if(l&&o.handleDrag){const E=o.handleDrag(n,t,d);this.b.addDragOperationTransfer(l,E),await E}return t}async $handleDrag(t,o,n,d){const l=this.a.get(t);if(!l)return Promise.reject(new T.$zG(t));const g=await this.j(new c.$AO,l,o,d,n);if(!(!g||d.isCancellationRequested))return u.DataTransfer.from(g)}async $hasResolve(t){const o=this.a.get(t);if(!o)throw new T.$zG(t);return o.hasResolve}$resolve(t,o,n){const d=this.a.get(t);if(!d)throw new T.$zG(t);return d.resolveTreeItem(o,n)}$setExpanded(t,o,n){const d=this.a.get(t);if(!d)throw new T.$zG(t);d.setExpanded(o,n)}$setSelectionAndFocus(t,o,n){const d=this.a.get(t);if(!d)throw new T.$zG(t);d.setSelectionAndFocus(o,n)}$setVisible(t,o){const n=this.a.get(t);if(!n){if(!o)return;throw new T.$zG(t)}n.setVisible(o)}$changeCheckboxState(t,o){const n=this.a.get(t);if(!n)throw new T.$zG(t);n.setCheckboxState(o)}m(t,o,n){const d=this.B(new i(t,o,this.f,this.g.converter,this.h,n));return this.a.set(t,d),d}r(t){const o=this.a.get(t.$treeViewId);return o&&"$treeItemHandle"in t?o.getExtensionElement(t.$treeItemHandle):o&&"$focusedTreeItem"in t&&t.$focusedTreeItem?o.focusedElement:null}}e.$1qc=f;class i extends L.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$lg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,o,n,d,l,g){if(super(),this.I=t,this.J=n,this.L=d,this.M=l,this.N=g,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$je),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$je),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$je),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$je),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$je),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$je),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$je),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new w.$ue,g.contributes&&g.contributes.views)for(const k in g.contributes.views)for(const A of g.contributes.views[k])A.id===t&&(this.P=A.name);this.f=o.treeDataProvider,this.g=o.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(k=>{Array.isArray(k)&&k.length===0||this.F.fire({message:!1,element:k})}));let E,D;const y=R.Event.debounce(this.F.event,(k,A)=>(k||(k={message:!1,elements:[]}),A.element!==!1&&(E||(E=new Promise(p=>D=p),this.G=this.G.then(()=>E)),Array.isArray(A.element)?k.elements.push(...A.element):k.elements.push(A.element)),A.message&&(k.message=!0),k),200,!0);this.B(y(({message:k,elements:A})=>{A.length&&(this.H=this.H.then(()=>{const p=D;return E=null,this.$(A).then(()=>p())})),k&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const o=t?this.getExtensionElement(t):void 0;if(t&&!o)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let n=this.X(t);return n||(n=await this.Y(o)),n?n.map(d=>d.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,o){o=o||{select:!0,focus:!1};const n=(0,I.$lg)(o.select)?!0:o.select,d=(0,I.$lg)(o.focus)?!1:o.focus,l=(0,I.$lg)(o.expand)?!1:o.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(g=>this.W(t,g[g.length-1]).then(E=>this.J.$reveal(this.I,{item:E.item,parentChain:g.map(D=>D.item)},{select:n,focus:d,expand:l})),g=>this.M.error(g)):this.J.$reveal(this.I,void 0,{select:n,focus:d,expand:l})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=u.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,o){const n=this.getExtensionElement(t);n&&(o?this.u.fire(Object.freeze({element:n})):this.w.fire(Object.freeze({element:n})))}setSelectionAndFocus(t,o){const n=!(0,S.$tb)(this.s,t);this.s=t;const d=this.t!==o;this.t=o,n&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const o=(await Promise.all(t.map(async n=>{const d=this.getExtensionElement(n.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:n.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);o.forEach(n=>{n.treeItem.checkboxState=n.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}),this.D.fire({items:o.map(n=>[n.extensionItem,n.newState])})}async handleDrag(t,o,n){const d=[];for(const l of t){const g=this.getExtensionElement(l);g&&d.push(g)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,o,n),o}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,o,n){const d=o?this.getExtensionElement(o):void 0;if(!(!d&&o||!this.g?.handleDrop))return(0,b.$uh)(()=>this.g?.handleDrop?this.g.handleDrop(d,t,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,o){if(!this.f.resolveTreeItem)return;const n=this.j.get(t);if(n){const d=this.m.get(n);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,n,o)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(t){return this.U(t).then(o=>o?this.S(o).then(n=>this.W(o,n[n.length-1]).then(d=>(n.push(d),n))):Promise.resolve([]))}U(t){const o=this.m.get(t);return o?Promise.resolve(o.parent?this.j.get(o.parent.item.handle):void 0):(0,b.$uh)(()=>this.f.getParent(t))}W(t,o){const n=this.m.get(t);return n?Promise.resolve(n):(0,b.$uh)(()=>this.f.getTreeItem(t)).then(d=>this.kb(t,d,o,!0)).then(d=>this.getChildren(o?o.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const g=this.m.get(l);if(g)return Promise.resolve(g)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let o;if(typeof t=="string"){const n=this.getExtensionElement(t);o=n?this.m.get(n):void 0}else o=t;return o&&o.children||void 0}return this.h}async Y(t){this.rb(t);const o=new w.$ue(this.Z.token);try{const n=t?this.m.get(t):void 0,d=await this.f.getChildren(t);if(o.token.isCancellationRequested)return;const l=(0,S.$Gb)(d||[]),g=await Promise.all((0,S.$Gb)(l).map(D=>this.f.getTreeItem(D)));if(o.token.isCancellationRequested)return;const E=g.map((D,y)=>D?this.db(l[y],D,n):null);return(0,S.$Gb)(E)}finally{o.dispose()}}$(t){if(t.some(n=>!n))return this.Z.dispose(!0),this.Z=new w.$ue,this.tb(),this.J.$refresh(this.I);{const n=this.ab(t);if(n.length)return this.bb(n)}return Promise.resolve(void 0)}ab(t){const o=new Set,n=t.map(l=>this.m.get(l));for(const l of n)if(l&&!o.has(l.item.handle)){let g=l;for(;g&&g.parent&&n.findIndex(E=>g&&g.parent&&E&&E.item.handle===g.parent.item.handle)===-1;){const E=this.j.get(g.parent.item.handle);g=E?this.m.get(E):void 0}g&&!g.parent&&o.add(l.item.handle)}const d=[];return o.forEach(l=>{const g=this.j.get(l);if(g){const E=this.m.get(g);E&&(!E.parent||!o.has(E.parent.item.handle))&&d.push(l)}}),d}bb(t){const o={};return Promise.all(t.map(n=>this.cb(n).then(d=>{d&&(o[n]=d.item)}))).then(()=>Object.keys(o).length?this.J.$refresh(this.I,o):void 0)}cb(t){const o=this.getExtensionElement(t);if(o){const n=this.m.get(o);if(n)return this.rb(o),(0,b.$uh)(()=>this.f.getTreeItem(o)).then(d=>{if(d){const l=this.ib(o,d,n.parent);return this.pb(o,l,n,n.parent),n.dispose(),l}return null})}return Promise.resolve(null)}db(t,o,n){const d=this.ib(t,o,n);if(o.id&&this.j.has(d.item.handle))throw new Error((0,r.localize)(10730,null,o.id));return this.ob(t,d),this.qb(d,n),d}eb(t){return c.$0N.isMarkdownString(t)?u.MarkdownString.from(t):t}fb(t,o){return o?{...this.L.toInternal(o,t),originalId:o.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let o,n,d;return typeof t.checkboxState=="number"?o=t.checkboxState:(o=t.checkboxState.state,n=t.checkboxState.tooltip,d=t.checkboxState.accessibilityInformation),{isChecked:o===c.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:d}}hb(t){if(!c.$vO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,o,n){this.hb(o);const d=this.B(new L.$Sc),l=this.kb(t,o,n),g=this.lb(o);return{item:{handle:l,parentHandle:n?n.item.handle:void 0,label:$(o.label,this.N),description:o.description,resourceUri:o.resourceUri,tooltip:this.eb(o.tooltip),command:this.fb(d,o.command),contextValue:o.contextValue,icon:g,iconDark:this.mb(o)||g,themeIcon:this.jb(o),collapsibleState:(0,I.$lg)(o.collapsibleState)?c.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation,checkbox:this.gb(o)},extensionItem:o,parent:n,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(t){return t.iconPath instanceof c.$EO?t.iconPath:void 0}kb(t,{id:o,label:n,resourceUri:d},l,g){if(o)return`${i.b}/${o}`;const E=$(n,this.N),D=l?l.item.handle:i.a;let y=E?E.label:d?(0,h.$ah)(d):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const k=this.m.has(t)?this.m.get(t).item.handle:void 0,A=this.X(l)||[];let p,v=0;do{if(p=`${D}/${v}:${y}`,g||!this.j.has(p)||k===p)break;v++}while(v<=A.length);return p}lb(t){if(t.iconPath&&!(t.iconPath instanceof c.$EO))return typeof t.iconPath=="string"||C.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof c.$EO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return C.URI.isUri(t)?t:C.URI.file(t)}ob(t,o){this.j.set(o.item.handle,t),this.m.set(t,o)}pb(t,o,n,d){this.j.delete(o.item.handle),this.m.delete(t),o.item.handle!==n.item.handle&&this.j.delete(n.item.handle),this.ob(t,o);const l=this.X(d)||[],g=l.filter(E=>E.item.handle===n.item.handle)[0];g&&l.splice(l.indexOf(g),1,o)}qb(t,o){o?(o.children||(o.children=[]),o.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const o=this.m.get(t);if(o){if(o.children)for(const n of o.children){const d=this.j.get(n.item.handle);d&&this.sb(d)}o.children=void 0}}else this.tb()}sb(t){const o=this.m.get(t);if(o){if(o.children)for(const n of o.children){const d=this.j.get(n.item.handle);d&&this.sb(d)}this.m.delete(t),this.j.delete(o.item.handle),o.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[323],De([1,0,4,3,2,32,15,96,6,9]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$upc=void 0,L=Ue(L),b=Ue(b),c=Ue(c);class I extends h.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(w,a,m,$){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new r.$je),this.onDidDispose=this.#d.event,this.#h=this.B(new r.$je),this.onDidChangeViewState=this.#h.event,this.#e=w,this.#t=a,this.#n=m,this.#i=$.viewType,this.#s=$.panelOptions,this.#o=$.viewColumn,this.#r=$.title,this.#l=$.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(w){this.c(),this.#r!==w&&(this.#r=w,this.#t.$setTitle(this.#e,w))}get iconPath(){return this.c(),this.#a}set iconPath(w){this.c(),this.#a!==w&&(this.#a=w,this.#t.$setIconPath(this.#e,C.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(w){this.#u||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(this.#l=w.active,this.#c=w.visible,this.#o=w.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(w,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof w>"u"?void 0:L.ViewColumn.from(w),preserveFocus:!!a})}c(){if(this.#u)throw new Error("Webview is disposed")}}class S extends h.$Tc{static c(){return(0,R.$Yg)()}constructor(w,a,m){super(),this.j=a,this.m=m,this.g=new Map,this.h=new Map,this.f=w.getProxy(b.$DN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(w=>w.dispose()),this.g.clear()}createWebviewPanel(w,a,m,$,f={}){const i=typeof $=="object"?$.viewColumn:$,s={viewColumn:L.ViewColumn.from(i),preserveFocus:typeof $=="object"&&!!$.preserveFocus},t=(0,T.$qpc)(w),o=S.c();this.f.$createWebviewPanel((0,T.$spc)(w),o,a,{title:m,panelOptions:u(f),webviewOptions:(0,T.$tpc)(w,this.m,f),serializeBuffersForPostMessage:t},s);const n=this.j.createNewWebview(o,f,w);return this.createNewWebviewPanel(o,a,m,i,f,n,!0)}$onDidChangeWebviewPanelViewStates(w){const a=Object.keys(w);a.sort((m,$)=>{const f=w[m],i=w[$];return f.active?1:i.active?-1:+f.visible-+i.visible});for(const m of a){const $=this.getWebviewPanel(m);if(!$)continue;const f=w[m];$._updateViewState({active:f.active,visible:f.visible,viewColumn:L.ViewColumn.to(f.position)})}}async $onDidDisposeWebviewPanel(w){this.getWebviewPanel(w)?.dispose(),this.g.delete(w),this.j.deleteWebview(w)}registerWebviewPanelSerializer(w,a,m){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:m,extension:w}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,T.$qpc)(w)}),new c.$FN(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(w,a,m,$){const f=this.h.get(a);if(!f)throw new Error(`No serializer found for '${a}'`);const{serializer:i,extension:s}=f,t=this.j.createNewWebview(w,m.webviewOptions,s),o=this.createNewWebviewPanel(w,a,m.title,$,m.panelOptions,t,m.active);await i.deserializeWebviewPanel(o,m.state)}createNewWebviewPanel(w,a,m,$,f,i,s){const t=new I(w,this.f,i,{viewType:a,title:m,viewColumn:$,panelOptions:f,active:s});return this.g.set(w,t),t}getWebviewPanel(w){return this.g.get(w)}}e.$upc=S;function u(P){return{enableFindWidget:P.enableFindWidget,retainContextWhenHidden:P.retainContextWhenHidden}}}),define(Se[324],De([1,0,4,3,96,15,6,9]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4qc=void 0,L=Ue(L),T=Ue(T);class b extends h.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(S,u,P,w,a,m){super(),this.#s=!1,this.#l=this.B(new r.$je),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new r.$je),this.onDidDispose=this.#u.event,this.#i=P,this.#a=w,this.#e=S,this.#t=u,this.#n=a,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#o}set description(S){this.a(),this.#o!==S&&(this.#o=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(S){S===this.#r||this.#s||(this.#r=S,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#s)throw new Error("Webview is disposed")}}class c{constructor(S,u){this.d=u,this.b=new Map,this.c=new Map,this.a=S.getProxy(L.$DN.MainThreadWebviewViews)}registerWebviewViewProvider(S,u,P,w){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:P,extension:S}),this.a.$registerWebviewViewProvider((0,C.$spc)(S),u,{retainContextWhenHidden:w?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$qpc)(S)}),new T.$FN(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(S,u,P,w,a){const m=this.b.get(u);if(!m)throw new Error(`No view provider found for '${u}'`);const{provider:$,extension:f}=m,i=this.d.createNewWebview(S,{},f),s=new b(S,this.a,u,P,i,!0);this.c.set(S,s),await $.resolveWebviewView(s,{state:w},a)}async $onDidChangeWebviewViewVisibility(S,u){this.e(S)._setVisible(u)}async $disposeWebviewView(S){const u=this.e(S);this.c.delete(S),u.dispose(),this.d.deleteWebview(S)}e(S){const u=this.c.get(S);if(!u)throw new Error("No webview found");return u}}e.$4qc=c}),define(Se[325],De([1,0,75,14,11,227,27,10]),function($e,e,r,h,C,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Irc=void 0;let b=class{constructor(S,u){S.addFileSystemProvider(h.Schemas.file,new c(u),{isCaseSensitive:T.$l})}};e.$Irc=b,e.$Irc=b=Ye([Ve(0,r.$mpc),Ve(1,C.$0j)],b);class c{constructor(S){this.b=S,this.a=new R.$qr(this.b)}async stat(S){const u=await this.a.stat(S);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(S){return this.a.readdir(S)}createDirectory(S){return this.a.mkdir(S)}readFile(S){return this.a.readFile(S)}writeFile(S,u,P){return this.a.writeFile(S,u,{...P,unlock:!1,atomic:!1})}delete(S,u){return this.a.delete(S,{...u,useTrash:!1,atomic:!1})}rename(S,u,P){return this.a.rename(S,u,P)}copy(S,u,P){return this.a.copy(S,u,P)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(S,u){throw new Error("Method not implemented.")}}}),define(Se[326],De([1,0,16,66,32,34,3,6,2,19]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Grc=void 0;let I=class extends L.$Tc{constructor(u,P){super();const w=u.getProxy(T.$DN.MainThreadDownloadService);P.registerCommand(!1,"_workbench.downloadResource",async a=>{const m=b.URI.file((0,r.$ic)((0,h.tmpdir)(),(0,C.$Yg)()));return await w.$download(a,m),m})}};e.$Grc=I,e.$Grc=I=Ye([Ve(0,c.$cQ),Ve(1,R.$yQ)],I)}),define(Se[327],De([1,0,44,16,2,97,3,14,7,33]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Src=void 0,r=Ue(r),h=Ue(h);class I extends R.$opc{constructor(){super(...arguments),this.i=null}async g(o){const n=await super.g(o);if(n.scheme!==T.Schemas.file)return n;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const d=n.fsPath;let l=0;do{let g;l===0?g=d:g=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await S(g);const E=h.$ic(g,"vscode.lock"),D=await a(this.d,E,!1);if(D)return this.i=D,process.on("exit",()=>{D.dispose()}),C.URI.file(g);l++}while(l<10);return n}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Src=I;async function S(t){try{await r.promises.stat(t);return}catch{}try{await r.promises.mkdir(t,{recursive:!0})}catch{}}const u=1e3,P=10*60*1e3;class w extends L.$Tc{constructor(o,n){super(),this.b=o,this.c=n,this.a=this.B(new b.$Nh),this.a.cancelAndSet(async()=>{const d=await m(o,n);(!d||d.pid!==process.pid)&&(o.info(`Lock '${n}': The lock was lost unexpectedly.`),this.a.cancel());try{await r.promises.utimes(n,new Date,new Date)}catch(l){o.error(l),o.info(`Lock '${n}': Could not update mtime.`)}},u)}dispose(){super.dispose();try{r.unlinkSync(this.c)}catch{}}async setWillRelease(o){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+o};await c.Promises.writeFile(this.c,JSON.stringify(n),{flag:"w"})}catch(n){this.b.error(n)}}}async function a(t,o,n){try{const l={pid:process.pid,willReleaseAt:0};await c.Promises.writeFile(o,JSON.stringify(l),{flag:"wx"})}catch(l){t.error(l)}const d=await m(t,o);return!d||d.pid!==process.pid?n?(t.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(t.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),i(t,o)):(t.info(`Lock '${o}': Lock acquired.`),new w(t,o))}async function m(t,o){let n;try{n=await r.promises.readFile(o)}catch(d){return t.error(d),null}try{return JSON.parse(String(n))}catch(d){return t.error(d),null}}async function $(t,o){let n;try{n=await r.promises.stat(o)}catch(d){return t.error(d),0}return n.mtime.getTime()}function f(t){try{return process.kill(t,0),!0}catch{return!1}}async function i(t,o){const n=await m(t,o);if(!n)return t.info(`Lock '${o}': Could not read pid of lock holder.`),s(t,o);if(n.willReleaseAt){let D=n.willReleaseAt-Date.now();if(D<5e3){for(D>0?t.info(`Lock '${o}': The lockfile is scheduled to be released in ${D} ms.`):t.info(`Lock '${o}': The lockfile is scheduled to have been released.`);D>0;){if(await(0,b.$Dh)(Math.min(100,D)),await $(t,o)===0)return s(t,o);D=n.willReleaseAt-Date.now()}return s(t,o)}}if(!f(n.pid))return t.info(`Lock '${o}': The pid ${n.pid} appears to be gone.`),s(t,o);const d=await $(t,o),l=Date.now()-d;if(l<=P)return t.info(`Lock '${o}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;t.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,b.$Dh)(2e3);const g=await $(t,o),E=Date.now()-g;return E<=P?(t.info(`Lock '${o}': The lock does not look stale, elapsed: ${E} ms, giving up.`),null):(t.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),s(t,o))}async function s(t,o){t.info(`Lock '${o}': Deleting a stale lock.`);try{await r.promises.unlink(o)}catch{}return a(t,o,!0)}}),define(Se[328],De([1,0,32,19,47,34]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$brc=void 0;let L=class extends C.$Kpc{constructor(b,c){super(!0,b,c)}createTerminal(b,c,I){return this.createTerminalFromOptions({name:b,shellPath:c,shellArgs:I})}createTerminalFromOptions(b,c){const I=new C.$Jpc(this.a,(0,r.$Yg)(),b,b.name);return this.f.push(I),I.create(b,this.R(b,c)),I.value}};e.$brc=L,e.$brc=L=Ye([Ve(0,R.$yQ),Ve(1,h.$cQ)],L)}),define(Se[329],De([1,0,4,36,35,5]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=e.$YM=e.OutputChannelUpdateMode=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=void 0,e.$LM="text/x-code-output",e.$MM="output",e.$NM="Log",e.$OM="text/x-code-log-output",e.$PM="log",e.$QM="workbench.panel.output",e.$RM=new C.$Tj("inOutput",!1),e.$SM=new C.$Tj("activeLogOutput",!1),e.$TM=new C.$Tj("activeLogOutput.levelSettable",!1),e.$UM=new C.$Tj("activeLogOutput.level",""),e.$VM=new C.$Tj("activeLogOutput.levelIsDefault",!1),e.$WM=new C.$Tj("outputView.scrollLock",!1),e.$XM=(0,R.$Ci)("outputService");var L;(function(b){b[b.Append=1]="Append",b[b.Replace=2]="Replace",b[b.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$YM={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new r.$je,this.onDidRegisterChannel=this.b.event,this.c=new r.$je,this.onDidRemoveChannel=this.c.event}registerChannel(c){this.a.has(c.id)||(this.a.set(c.id,c),this.b.fire(c.id))}getChannels(){const c=[];return this.a.forEach(I=>c.push(I)),c}getChannel(c){return this.a.get(c)}removeChannel(c){this.a.delete(c),this.c.fire(c)}}h.$oo.add(e.$YM.OutputChannels,new T),e.$ZM=new C.$Tj("activeOutputChannel","")}),define(Se[169],De([1,0,6,5,19,23,11,329,75,29,62,212,21,17,27,4,3]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hqc=e.$Gqc=void 0;class $ extends L.$dk{get disposed(){return this.n}constructor(t,o,n,d,l){super(),this.id=t,this.name=o,this.r=n,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(n.getLevel()),this.B(n.onDidChangeLogLevel(g=>this.setLevel(g)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,t)}replace(t){const o=this.m;this.info(t),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,o),this.visible&&this.r.flush()}show(t,o){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:o))}hide(){this.s.$close(this.id)}g(t,o){this.m+=u.$Le.fromString(o).byteLength,(0,L.log)(this.r,t,o),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class f extends ${appendLine(t){this.append(t)}}let i=class{constructor(t,o,n,d,l,g){this.i=o,this.j=n,this.k=d,this.l=l,this.m=g,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(r.$DN.MainThreadOutputService),this.b=this.k.extUri.joinPath(o.logsLocation,`output_logging_${(0,S.$1m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[o,n]of this.g)n.visible=o===this.h}createOutputChannel(t,o,n){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const d=typeof o=="object"&&o.log,l=(0,P.$cg)(o)?o:void 0;if((0,P.$cg)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let g;const E=this.i.environment.extensionLogLevel?.find(([y])=>R.$on.equals(n.identifier,y))?.[1];E&&(g=(0,L.$ok)(E));const D=d?this.o(t,g,n):this.n(t,l,n);return D.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),d?this.r(t,g??this.m.getLevel(),D):this.q(t,D)}async n(t,o,n){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),g=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.a.$register(t,l,o,n.identifier.value);return new $(E,t,g,this.a,n)}async o(t,o,n){const d=await this.p(n),l=t.replace(/[\\/:\*\?"<>\|]/g,""),g=this.k.extUri.joinPath(d,`${l}.log`),E=`${n.identifier.value}.${l}`,D=this.l.createLogger(g,{id:E,name:t,logLevel:o,extensionId:n.identifier.value});return new f(E,t,D,this.a,n)}p(t){let o=this.d.get(t.identifier.value);if(!o){const n=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,o=(async()=>{try{await this.j.value.createDirectory(n)}catch(d){if((0,w.$nl)(d)!==w.FileSystemProviderErrorCode.FileExists)throw d}return n})())}return o}q(t,o){let n=!1;const d=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return t},append(l){d(),o.then(g=>g.append(l))},appendLine(l){d(),o.then(g=>g.appendLine(l))},clear(){d(),o.then(l=>l.clear())},replace(l){d(),o.then(g=>g.replace(l))},show(l,g){d(),o.then(E=>E.show(l,g))},hide(){d(),o.then(l=>l.hide())},dispose(){n=!0,o.then(l=>l.dispose())}}}r(t,o,n){const d=new m.$Sc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},g=d.add(new a.$je);function E(D){o=D,g.fire(D)}return n.then(D=>{d.add(D),D.logLevel!==o&&E(D.logLevel),d.add(D.onDidChangeLogLevel(y=>E(y)))}),{...this.q(t,n),get logLevel(){return o},onDidChangeLogLevel:g.event,trace(D,...y){l(),n.then(k=>k.trace(D,...y))},debug(D,...y){l(),n.then(k=>k.debug(D,...y))},info(D,...y){l(),n.then(k=>k.info(D,...y))},warn(D,...y){l(),n.then(k=>k.warn(D,...y))},error(D,...y){l(),n.then(k=>k.error(D,...y))},dispose(){d.dispose()}}}};e.$Gqc=i,e.$Gqc=i=Ye([Ve(0,C.$cQ),Ve(1,c.$sQ),Ve(2,b.$mpc),Ve(3,I.$2oc),Ve(4,L.$$j),Ve(5,L.$0j)],i),e.$Hqc=(0,h.$Ci)("IExtHostOutputService")}),define(Se[170],De([1,0,5,7]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=void 0,e.$Tm=(0,r.$Ci)("remoteAgentService"),e.$Um=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let R=1/0;for(let T=0;T<this.maxSampleCount;T++){const b=await C.getRoundTripTime();if(b===void 0)return;R=Math.min(R,b/2),await(0,h.$Dh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(R):L=this.initial.reduce((T,b)=>T+b,0)/this.initial.length,this.lastMeasurement={initial:L,current:R,average:this.average.reduce((T,b)=>T+b,0)/this.average.length,high:typeof L>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(Se[330],De([1,0,8,70,36,46,45,3,4,170,10,24,7,150]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=void 0,e.$_K=Object.freeze({id:"application",order:100,title:(0,r.localize)(12453,null),type:"object"}),e.$aL=Object.freeze({id:"workbench",order:7,title:(0,r.localize)(12454,null),type:"object"}),e.$bL=Object.freeze({id:"security",scope:h.ConfigurationScope.APPLICATION,title:(0,r.localize)(12455,null),type:"object",order:7}),e.$cL=Object.freeze({id:"problems",title:(0,r.localize)(12456,null),type:"object",order:101}),e.$dL=Object.freeze({id:"window",order:8,title:(0,r.localize)(12457,null),type:"object"}),e.$eL={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new b.$je,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const a=new w;C.$oo.add(e.$eL.ConfigurationMigration,a);let m=class extends T.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(s,t){super(),this.a=s,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const n of o.added)await this.f(n,a.migrations)})),this.c(a.migrations),this.B(a.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(s){await this.f(void 0,s);for(const t of this.b.getWorkspace().folders)await this.f(t,s)}async f(s,t){await Promise.all([t.map(o=>this.g(o,s?.uri))])}async g(s,t){const o=this.a.inspect(s.key,{resource:t}),n=this.b.getWorkbenchState()===R.WorkbenchState.WORKSPACE?[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE],["workspaceFolder",L.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE]];for(const[d,l]of n){const g=o[d];if(!g)continue;const E=[];if(g.value!==void 0){const D=await this.h(s,d,g.value,t,void 0);for(const y of D??[])E.push([y,[]])}for(const{identifiers:D,value:y}of g.overrides??[])if(y!==void 0){const k=await this.h(s,d,y,t,D);for(const A of k??[])E.push([A,D])}E.length&&await Promise.allSettled(E.map(async([[D,y],k])=>this.a.updateValue(D,y.value,{resource:t,overrideIdentifiers:k},l)))}}async h(s,t,o,n,d){const l=E=>{const y=this.a.inspect(E,{resource:n})[t];if(y)return d?y.overrides?.find(({identifiers:k})=>(0,S.$fo)(k,d))?.value:y.value},g=await s.migrateFn(o,l);return Array.isArray(g)?g:[[s.key,g]]}};e.$fL=m,e.$fL=m=Ye([Ve(0,L.$9i),Ve(1,R.$Li)],m);let $=class extends T.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(s){super(),this.b=s,this.a=new u.$Zh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$j&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;C.$oo.as(h.$to.Configuration).registerConfiguration({...e.$bL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,r.localize)(12458,null)},default:[],markdownDescription:(0,r.localize)(12459,null),scope:h.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,r.localize)(12460,null),scope:h.ConfigurationScope.MACHINE}}})}};e.$gL=$,e.$gL=$=Ye([Ve(0,c.$Tm)],$),e.$hL="window.newWindowProfile";let f=class extends T.$Tc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(s,t){super(),this.c=s,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(o=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(o=>{o.source!==L.ConfigurationTarget.DEFAULT&&o.affectsConfiguration(e.$hL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const s=C.$oo.as(h.$to.Configuration),t={...e.$dL,properties:{[e.$hL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(o=>o.name),null],enumItemLabels:[...this.c.profiles.map(o=>""),(0,r.localize)(12461,null)],description:(0,r.localize)(12462,null),scope:h.ConfigurationScope.APPLICATION}}};this.a?s.updateConfigurations({add:[t],remove:[this.a]}):s.registerConfiguration(t),this.a=t}h(){const s=this.f.getValue(e.$hL);this.b=s?this.c.profiles.find(t=>t.name===s):void 0}j(){const s=this.f.getValue(e.$hL);if(!s)return;const t=this.b?this.c.profiles.find(o=>o.id===this.b.id):void 0;s!==t?.name&&this.f.updateValue(e.$hL,t?.name)}};e.$iL=f,e.$iL=f=Ye([Ve(0,P.$Jl),Ve(1,L.$9i)],f)}),define(Se[331],De([1,0,38,14,16,22,8,330,70,5,36]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$kL=e.$jL=void 0,e.$lL=a,e.$mL=m,r=Ue(r),e.$jL=(0,c.$Ci)("editorResolverService"),e.$kL="workbench.editorAssociations";const S=I.$oo.as(b.$to.Configuration),u={...T.$aL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(2005,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(u);var P;(function($){$.builtin="builtin",$.option="option",$.exclusive="exclusive",$.default="default"})(P||(e.RegisteredEditorPriority=P={}));var w;(function($){$[$.ABORT=1]="ABORT",$[$.NONE=2]="NONE"})(w||(e.ResolvedStatus=w={}));function a($){switch($){case P.exclusive:return 5;case P.default:return 4;case P.builtin:return 3;case P.option:default:return 1}}function m($,f){if(new Set([h.Schemas.extension,h.Schemas.webviewPanel,h.Schemas.vscodeWorkspaceTrust,h.Schemas.vscodeSettings]).has(f.scheme))return!1;const t=typeof $=="string"&&$.indexOf(C.$fc.sep)>=0?`${f.scheme}:${f.path}`:(0,R.$ah)(f);return r.$wk(typeof $=="string"?$.toLowerCase():$,t.toLowerCase())}}),define(Se[332],De([1,0,31,14,16,10,22,2,5,247,46,158,170]),function($e,e,r,h,C,R,L,T,b,c,I,S,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=void 0,e.$fN=(0,b.$Ci)("pathService");let w=P=class{constructor(m,$,f,i){this.d=m,this.e=$,this.f=f,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??m})()}hasValidBasename(m,$,f){return typeof $=="string"||typeof $>"u"?this.a.then(i=>this.h(m,i,$)):this.h(m,$,f)}h(m,$,f){return m.scheme===h.Schemas.file||m.scheme===h.Schemas.vscodeRemote?(0,r.$zg)(f??(0,L.$ah)(m),$===R.OperatingSystem.Windows):!0}get defaultUriScheme(){return P.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,$){if(m.remoteAuthority)return h.Schemas.vscodeRemote;const f=(0,c.$cN)($.getWorkspace());if(f)return f;const i=$.getWorkspace().folders[0];if(i)return i.uri.scheme;const s=$.getWorkspace().configuration;return s?s.scheme:h.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===R.OperatingSystem.Windows?C.$ec:C.$fc)}async fileURI(m){let $="";if(await this.a===R.OperatingSystem.Windows&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const i=m.indexOf("/",2);i===-1?($=m.substring(2),m="/"):($=m.substring(2,i),m=m.substring(i)||"/")}return T.URI.from({scheme:h.Schemas.file,authority:$,path:m,query:"",fragment:""})}};e.$gN=w,e.$gN=w=P=Ye([Ve(1,u.$Tm),Ve(2,S.$1M),Ve(3,I.$Li)],w)}),define(Se[333],De([1,0,8,59,4,60,3,2,45,216,11,71,151,92,46,158,25,20,17,24,35]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=e.$$M=e.OnPortForward=e.$6M=e.$5M=e.TunnelSource=e.TunnelCloseReason=e.$3M=e.$2M=void 0,e.$4M=l,e.$7M=D,e.$8M=y,e.$9M=k,e.$0M=p,r=Ue(r);const t=10*1e3,o="remote.tunnels.toRestore",n="remote.tunnels.toRestoreExpiration",d=1e3*60*60*24*14;e.$2M="onTunnel",e.$3M=new s.$Tj("forwardedPortsViewEnabled",!1,r.localize(1619,null));function l(N){const O=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(O)return{host:O[1]?.substring(0,O[1].length-1)||"localhost",port:Number(O[2])}}var g;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(g||(e.TunnelCloseReason=g={}));var E;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(E||(e.TunnelSource=E={})),e.$5M={source:E.User,description:r.localize(1620,null)},e.$6M={source:E.Auto,description:r.localize(1621,null)};function D(N,O,j){const z=N.get(k(O,j));if(z)return z;if((0,P.$Hw)(O))for(const M of P.$Gw){const W=k(M,j);if(N.has(W))return N.get(W)}else if((0,P.$Jw)(O))for(const M of P.$Iw){const W=k(M,j);if(N.has(W))return N.get(W)}}function y(N,O,j){const z=D(N,O,j);if(z)return z;const M=(0,P.$Jw)(O)?"localhost":(0,P.$Hw)(O)?"0.0.0.0":void 0;if(M)return D(N,M,j)}function k(N,O){return N+":"+O}var A;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(A||(e.OnPortForward=A={}));function p(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}class v extends L.$Tc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(O){super(),this.r=O,this.j=[],this.n=new C.$je,this.onDidChangeAttributes=this.n.event,this.B(O.onDidChangeConfiguration(j=>{(j.affectsConfiguration(v.c)||j.affectsConfiguration(v.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(O,j,z){let M=this.w(O,j,z,this.j,0);const W={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;M>=0;){const V=this.j[M];V.key===O?(W.onAutoForward=V.onAutoForward??W.onAutoForward,W.elevateIfNeeded=V.elevateIfNeeded!==void 0?V.elevateIfNeeded:W.elevateIfNeeded,W.label=V.label??W.label,W.requireLocalPort=V.requireLocalPort,W.protocol=V.protocol):(W.onAutoForward=W.onAutoForward??V.onAutoForward,W.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:V.elevateIfNeeded,W.label=W.label??V.label,W.requireLocalPort=W.requireLocalPort!==void 0?W.requireLocalPort:void 0,W.protocol=W.protocol??V.protocol),M=this.w(O,j,z,this.j,M+1)}return W.onAutoForward!==void 0||W.elevateIfNeeded!==void 0||W.label!==void 0||W.requireLocalPort!==void 0||W.protocol!==void 0?W:this.C()}t(O){return O.start!==void 0&&O.end!==void 0}u(O){return O.host!==void 0&&O.port!==void 0&&(0,f.$cg)(O.host)&&(0,f.$gg)(O.port)}w(O,j,z,M,W){if(W>=M.length)return-1;const V=!(0,P.$Hw)(j)&&!(0,P.$Jw)(j),B=M.slice(W).findIndex(K=>(0,f.$gg)(K.key)?V?!1:K.key===O:this.t(K.key)?V?!1:O>=K.key.start&&O<=K.key.end:this.u(K.key)?O===K.key.port&&j===K.key.host:z?K.key.test(z):!1);return B>=0?B+W:-1}y(){const O=this.r.getValue(v.c);if(!O||!(0,f.$eg)(O))return[];const j=[];for(const M in O){if(M===void 0)continue;const W=O[M];let V;if(Number(M))V=Number(M);else if((0,f.$cg)(M))if(v.g.test(M)){const ne=M.match(v.g);V={start:Number(ne[1]),end:Number(ne[2])}}else if(v.h.test(M)){const ne=M.match(v.h);V={host:ne[1],port:Number(ne[2])}}else{let ne;try{ne=RegExp(M)}catch{}ne&&(V=ne)}V&&j.push({key:V,elevateIfNeeded:W.elevateIfNeeded,onAutoForward:W.onAutoForward,label:W.label,requireLocalPort:W.requireLocalPort,protocol:W.protocol})}const z=this.r.getValue(v.f);return z&&(this.m={elevateIfNeeded:z.elevateIfNeeded,label:z.label,onAutoForward:z.onAutoForward,requireLocalPort:z.requireLocalPort,protocol:z.protocol}),this.z(j)}z(O){function j(z,M){return(0,f.$gg)(z.key)?z.key:M.t(z.key)?z.key.start:M.u(z.key)?z.key.port:Number.MAX_VALUE}return O.sort((z,M)=>j(z,this)-j(M,this))}C(){return this.m}static providedActionToAction(O){switch(O){case P.ProvidedOnAutoForward.Notify:return A.Notify;case P.ProvidedOnAutoForward.OpenBrowser:return A.OpenBrowser;case P.ProvidedOnAutoForward.OpenBrowserOnce:return A.OpenBrowserOnce;case P.ProvidedOnAutoForward.OpenPreview:return A.OpenPreview;case P.ProvidedOnAutoForward.Silent:return A.Silent;case P.ProvidedOnAutoForward.Ignore:return A.Ignore;default:return}}async addAttributes(O,j,z){const W=this.r.inspect(v.c).userRemoteValue;let V;!W||!(0,f.$eg)(W)?V={}:V=(0,i.$bo)(W),V[`${O}`]||(V[`${O}`]={});for(const ne in j)V[`${O}`][ne]=j[ne];return this.r.updateValue(v.c,V,z)}}e.$$M=v;let F=class extends L.$Tc{constructor(O,j,z,M,W,V,ne,B,K,Y){super(),this.H=O,this.I=j,this.J=z,this.L=M,this.M=W,this.N=V,this.O=ne,this.P=B,this.Q=K,this.R=Y,this.c=new Map,this.g=new C.$je,this.onForwardPort=this.g.event,this.h=new C.$je,this.onClosePort=this.h.event,this.j=new C.$je,this.onPortName=this.j.event,this.n=new C.$je,this.onCandidatesChanged=this.n.event,this.t=new C.$je,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new C.$je,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new v(z),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ee=>{const ue=await this.getAttributes(ee.map(re=>({port:re.tunnelRemotePort,host:re.tunnelRemoteHost})));for(const re of ee)if(re.localAddress){const ye=k(re.tunnelRemoteHost,re.tunnelRemotePort),me=y(this.m??new Map,re.tunnelRemoteHost,re.tunnelRemotePort);this.forwarded.set(ye,{remotePort:re.tunnelRemotePort,remoteHost:re.tunnelRemoteHost,localAddress:re.localAddress,protocol:ue?.get(re.tunnelRemotePort)?.protocol??P.TunnelProtocol.Http,localUri:await this.X(re.localAddress,ue?.get(re.tunnelRemotePort)),localPort:re.tunnelLocalPort,name:ue?.get(re.tunnelRemotePort)?.label,runningProcess:me?.detail,hasRunningProcess:!!me,pid:me?.pid,privacy:re.privacy,source:e.$5M}),this.f.set(ye,re)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ee=>{const ue=k(ee.tunnelRemoteHost,ee.tunnelRemotePort);if(!y(this.forwarded,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!y(this.detected,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!y(this.c,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&ee.localAddress){const re=y(this.m??new Map,ee.tunnelRemoteHost,ee.tunnelRemotePort),ye=(await this.getAttributes([{port:ee.tunnelRemotePort,host:ee.tunnelRemoteHost}]))?.get(ee.tunnelRemotePort);this.forwarded.set(ue,{remoteHost:ee.tunnelRemoteHost,remotePort:ee.tunnelRemotePort,localAddress:ee.localAddress,protocol:ye?.protocol??P.TunnelProtocol.Http,localUri:await this.X(ee.localAddress,ye),localPort:ee.tunnelLocalPort,name:ye?.label,closeable:!0,runningProcess:re?.detail,hasRunningProcess:!!re,pid:re?.pid,privacy:ee.privacy,source:e.$5M})}await this.cb(),this.f.set(ue,ee),this.g.fire(this.forwarded.get(ue))})),this.B(this.H.onTunnelClosed(ee=>this.W(ee,g.Other))),this.U()}S(){return this.Q.extensions.find(O=>O.activationEvents?.includes(e.$2M))?(this.R.createKey(e.$3M.key,!0),!0):!1}U(){if(this.S())return;const O=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&O.dispose()}))}async W(O,j){const z=k(O.host,O.port);this.forwarded.has(z)&&(this.forwarded.delete(z),await this.cb(),this.h.fire(O))}X(O,j){if(O.startsWith("http"))return T.URI.parse(O);const z=j?.protocol??"http";return T.URI.parse(`${z}://${O}`)}async Y(O){const j=this.N.getWorkspace(),z=j.configuration?(0,R.$qj)(j.configuration.path):j.folders.length>0?(0,R.$qj)(j.folders[0].uri.path):void 0;if(z===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${O}.${this.L.remoteAuthority}.${z}`}async Z(){return this.Y(o)}async $(){return this.Y(n)}async ab(){const O=this.I.get(o,u.StorageScope.WORKSPACE);if(O)return this.I.remove(o,u.StorageScope.WORKSPACE),await this.cb(),O;const j=await this.Z();if(j)return this.I.get(j,u.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const O=await this.s;if(O&&O!==this.y){const j=JSON.parse(O)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${j.map(z=>z.remotePort).join(", ")}`);for(const z of j){const M=y(this.detected,z.remoteHost,z.remotePort);z.source.source!==E.Extension&&!M||z.source.source===E.Extension&&M?await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,elevateIfNeeded:!0,source:z.source}):z.source.source===E.Extension&&!M&&this.D.set(k(z.remoteHost,z.remotePort),z)}}}if(this.z=!0,this.C.fire(),!this.w){const O=await this.Z();this.w=this.B(new L.$Sc),this.w.add(this.I.onDidChangeValue(u.StorageScope.PROFILE,void 0,this.w)(async j=>{j.key===O&&(this.s=Promise.resolve(this.I.get(O,u.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const O=this.I.keys(u.StorageScope.PROFILE,u.StorageTarget.USER).filter(j=>j.startsWith(n));for(const j of O){const z=this.I.getNumber(j,u.StorageScope.PROFILE);if(z&&z<Date.now()){this.s=Promise.resolve(void 0);const M=j.replace(n,o);this.I.remove(j,u.StorageScope.PROFILE),this.I.remove(M,u.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=Array.from(this.forwarded.values()),j=O.map(V=>({remoteHost:V.remoteHost,remotePort:V.remotePort,localPort:V.localPort,name:V.name,localAddress:V.localAddress,localUri:V.localUri,protocol:V.protocol,source:V.source}));let z;O.length>0&&(z=JSON.stringify(j));const M=await this.Z(),W=await this.$();!z&&M&&W?(this.I.remove(M,u.StorageScope.PROFILE),this.I.remove(W,u.StorageScope.PROFILE)):z!==this.y&&M&&W&&(this.I.store(M,z,u.StorageScope.PROFILE,u.StorageTarget.USER),this.I.store(W,Date.now()+d,u.StorageScope.PROFILE,u.StorageTarget.USER)),this.y=z}}async eb(O,j,z){if(!O.tunnelLocalPort||!z?.requireLocalPort||O.tunnelLocalPort===j)return;const M=new Date;if(this.db.getTime()+t>M.getTime())return;this.db=M;const W=r.localize(1622,null,j,O.tunnelRemotePort,O.tunnelLocalPort);return this.P.info(W)}async forward(O,j){return!this.z&&this.L.remoteAuthority&&await C.Event.toPromise(this.C.event),this.fb(O,j)}async fb(O,j){await this.Q.activateByEvent(e.$2M);const z=y(this.forwarded,O.remote.host,O.remote.port);j=j??(j!==null?(await this.getAttributes([O.remote]))?.get(O.remote.port):void 0);const M=O.local!==void 0?O.local:O.remote.port;let W;if(z)return this.hb(z,O,j);{const V=this.L.remoteAuthority,ne=V?{getAddress:async()=>(await this.M.resolveAuthority(V)).authority}:void 0,B=k(O.remote.host,O.remote.port);this.c.set(B,!0),O=this.gb(B,O);const K=await this.H.openTunnel(ne,O.remote.host,O.remote.port,void 0,M,O.elevateIfNeeded?O.elevateIfNeeded:j?.elevateIfNeeded,O.privacy,j?.protocol);if(typeof K=="string")W=K;else if(K&&K.localAddress){const Y=y(this.m??new Map,O.remote.host,O.remote.port),ee=K.protocol?K.protocol===P.TunnelProtocol.Https?P.TunnelProtocol.Https:P.TunnelProtocol.Http:j?.protocol??P.TunnelProtocol.Http,ue={remoteHost:K.tunnelRemoteHost,remotePort:K.tunnelRemotePort,localPort:K.tunnelLocalPort,name:j?.label??O.name,closeable:!0,localAddress:K.localAddress,protocol:ee,localUri:await this.X(K.localAddress,j),runningProcess:Y?.detail,hasRunningProcess:!!Y,pid:Y?.pid,source:O.source??e.$5M,privacy:K.privacy};return this.forwarded.set(B,ue),this.f.set(B,K),this.c.delete(B),await this.cb(),await this.eb(K,M,j),this.g.fire(ue),K}this.c.delete(B)}return W}gb(O,j){const z=this.D.has(O)?this.D:this.F.has(O)?this.F:void 0;if(z){const M=z.get(O);z.delete(O),M&&(j.name=M.name??j.name,j.local=("local"in M?M.local:"localPort"in M?M.localPort:void 0)??j.local,j.privacy=j.privacy)}return j}async hb(O,j,z){const M=z?.label??j.name;let W;(function(ne){ne[ne.None=0]="None",ne[ne.Fire=1]="Fire",ne[ne.Reopen=2]="Reopen"})(W||(W={}));let V=W.None;switch(M!==O.name&&(O.name=M,V=W.Fire),(z?.protocol||O.protocol!==P.TunnelProtocol.Http)&&z?.protocol!==O.protocol&&(j.source=O.source,V=W.Reopen),j.privacy&&O.privacy!==j.privacy&&(V=W.Reopen),V){case W.Fire:{this.g.fire();break}case W.Reopen:await this.close(O.remoteHost,O.remotePort,g.User),await this.fb(j,z)}return y(this.f,j.remote.host,j.remote.port)}async name(O,j,z){const M=y(this.forwarded,O,j),W=k(O,j);if(M){M.name=z,await this.cb(),this.j.fire({host:O,port:j});return}else this.detected.has(W)&&(this.detected.get(W).name=z,this.j.fire({host:O,port:j}))}async close(O,j,z){const M=k(O,j),W=this.forwarded.get(M);return z===g.AutoForwardEnd&&W&&W.source.source===E.Auto&&this.F.set(M,{local:W.localPort,name:W.name,privacy:W.privacy}),await this.H.closeTunnel(O,j),this.W({host:O,port:j},z)}address(O,j){const z=k(O,j);return(this.forwarded.get(z)||this.detected.get(z))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(O){if(O)for(const j of O){const z=y(this.m??new Map,j.remoteAddress.host,j.remoteAddress.port),M=typeof j.localAddress=="string"?j.localAddress:k(j.localAddress.host,j.localAddress.port);this.detected.set(k(j.remoteAddress.host,j.remoteAddress.port),{remoteHost:j.remoteAddress.host,remotePort:j.remoteAddress.port,localAddress:M,protocol:P.TunnelProtocol.Http,localUri:this.X(M),closeable:!1,runningProcess:z?.detail,hasRunningProcess:!!z,pid:z?.pid,privacy:P.TunnelPrivacyId.ConstantPrivate,source:{source:E.Extension,description:r.localize(1623,null)}}),this.H.setEnvironmentTunnel(j.remoteAddress.host,j.remoteAddress.port,M,P.TunnelPrivacyId.ConstantPrivate,P.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(O){this.r=O}async setCandidates(O){let j=O;this.r&&(j=await this.r(O));const z=this.ib(j);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(z.values()).map(M=>M.port).join(", ")}`),this.n.fire(z)}ib(O){const j=this.m??new Map,z=new Map;return this.m=z,O.forEach(M=>{const W=k(M.host,M.port);z.set(W,{host:M.host,port:M.port,detail:M.detail,pid:M.pid}),j.has(W)&&j.delete(W);const V=y(this.forwarded,M.host,M.port);V&&(V.runningProcess=M.detail,V.hasRunningProcess=!0,V.pid=M.pid)}),j.forEach((M,W)=>{const V=l(W);if(!V)return;const ne=y(this.forwarded,V.host,V.port);ne&&(ne.runningProcess=void 0,ne.hasRunningProcess=!1,ne.pid=void 0);const B=y(this.detected,V.host,V.port);B&&(B.runningProcess=void 0,B.hasRunningProcess=!1,B.pid=void 0)}),j}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const O=Array.from(this.forwarded.values()),j=await this.getAttributes(O.map(z=>({port:z.remotePort,host:z.remoteHost})),!1);if(j)for(const z of O){const M=j.get(z.remotePort);(M?.protocol||z.protocol!==P.TunnelProtocol.Http)&&M?.protocol!==z.protocol&&await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,source:z.source},M),M&&M.label&&M.label!==z.name&&await this.name(z.remoteHost,z.remotePort,M.label)}}async getAttributes(O,j=!0){const z=new Map,M=new Map;O.forEach(K=>{const Y=y(this.m??new Map,P.$Gw[0],K.port)??K;if(Y){z.set(K.port,Y);const ee=p(Y)?Y.pid:void 0;M.has(ee)||M.set(ee,[]),M.get(ee)?.push(K.port)}});const W=new Map;if(O.forEach(K=>{const Y=this.configPortsAttributes.getAttributes(K.port,K.host,z.get(K.port)?.detail);Y&&W.set(K.port,Y)}),this.G.length===0||!j)return W.size>0?W:void 0;const V=await Promise.all(this.G.flatMap(K=>Array.from(M.entries()).map(Y=>{const ee=Y[1],ue=z.get(ee[0]);return K.providePortAttributes(ee,ue?.pid,ue?.detail,$.CancellationToken.None)}))),ne=new Map;if(V.forEach(K=>K.forEach(Y=>{Y&&ne.set(Y.port,Y)})),!W&&!ne)return;const B=new Map;return O.forEach(K=>{const Y=W.get(K.port),ee=ne.get(K.port);B.set(K.port,{elevateIfNeeded:Y?.elevateIfNeeded,label:Y?.label,onAutoForward:Y?.onAutoForward??v.providedActionToAction(ee?.autoForwardAction),requireLocalPort:Y?.requireLocalPort,protocol:Y?.protocol})}),B}addAttributesProvider(O){this.G.push(O)}};e.$_M=F,Ye([(0,h.$8h)(1e3)],F.prototype,"cb",null),e.$_M=F=Ye([Ve(0,P.$Bw),Ve(1,u.$fq),Ve(2,b.$9i),Ve(3,a.$1M),Ve(4,S.$Ol),Ve(5,w.$Li),Ve(6,I.$0j),Ve(7,c.$7w),Ve(8,m.$_G),Ve(9,s.$Uj)],F)}),define(Se[99],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$TL=e.$SL=void 0;class r{constructor(L,T){this.line=L,this.character=T}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,T){return new r(0,0)}with(L){return new r(0,0)}}e.$SL=r;class h{constructor(L,T,b,c){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(L,T),this.end=new r(b,c)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new h(0,0,0,0)}with(L){return new h(0,0,0,0)}}e.$TL=h;var C;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Se[37],De([1,0,18,38,24,31,12,5,16,13,99,7]),function($e,e,r,h,C,R,L,T,b,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=e.$fM=e.$$L=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$8L=e.$7L=e.$6L=e.$5L=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.TextSearchCompleteMessageType=void 0,e.$2L=$,e.$3L=f,e.$4L=i,e.$9L=D,e.$0L=y,e.$_L=p,e.$aM=v,e.$bM=F,e.$cM=N,e.$dM=O,e.$eM=j,e.$gM=M,e.$iM=ne,e.$jM=B,h=Ue(h),C=Ue(C),R=Ue(R),b=Ue(b),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$UL="workbench.view.search",e.$VL="workbench.panel.search",e.$WL="workbench.view.search",e.$XL="search-result",e.$YL="search.exclude",e.$ZL=2e4;const u="\u27EA ",P=" characters skipped \u27EB",w=(u.length+P.length+5)*2;e.$1L=(0,T.$Ci)("searchService");var a;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text",Y[Y.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var m;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text",Y[Y.aiText=3]="aiText"})(m||(e.QueryType=m={}));function $(Y){return!!Y.preview}function f(Y){return!!Y.resource}function i(Y){return!!Y.message}var s;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class t{constructor(ee){this.resource=ee,this.results=[]}}e.$5L=t;class o{constructor(ee,ue,re,ye){this.ranges=ue,this.webviewIndex=ye;const me=Array.isArray(ue)?ue:[ue];if(re&&re.matchLines===1&&n(me)){ee=(0,L.$8f)(ee,re.matchLines);let J="",U=0,se=0;const ae=Math.floor(re.charsPerLine/5),te=[];for(const ce of me){const le=Math.max(ce.startColumn-ae,0),x=ce.startColumn+re.charsPerLine;if(le>se+ae+w){const oe=u+(le-se)+P;J+=oe+ee.slice(le,x),U+=le-(se+oe.length)}else J+=ee.slice(se,x);te.push(new l(0,ce.startColumn-U,ce.endColumn-U)),se=x}this.preview={text:J,matches:Array.isArray(this.ranges)?te:te[0]}}else{const J=Array.isArray(ue)?ue[0].startLineNumber:ue.startLineNumber;this.preview={text:ee,matches:(0,r.$Zb)(ue,U=>new d(U.startLineNumber-J,U.startColumn,U.endLineNumber-J,U.endColumn))}}}}e.$6L=o;function n(Y){const ee=Y[0].startLineNumber;for(const ue of Y)if(ue.startLineNumber!==ee||ue.endLineNumber!==ee)return!1;return!0}class d{constructor(ee,ue,re,ye){this.startLineNumber=ee,this.startColumn=ue,this.endLineNumber=re,this.endColumn=ye}}e.$7L=d;class l extends d{constructor(ee,ue,re){super(ee,ue,ee,re)}}e.$8L=l;var g;(function(Y){Y.List="list",Y.Tree="tree"})(g||(e.ViewMode=g={}));var E;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(E||(e.SearchSortOrder=E={}));function D(Y,ee=!0){const ue=Y&&Y.files&&Y.files.exclude,re=ee&&Y&&Y.search&&Y.search.exclude;if(!ue&&!re)return;if(!ue||!re)return ue||re||void 0;let ye=Object.create(null);return ye=C.$eo(ye,C.$bo(ue)),ye=C.$eo(ye,C.$bo(re),!0),ye}function y(Y,ee){return Y.excludePattern&&h.$wk(Y.excludePattern,ee)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&h.$wk(Y.includePattern,ee)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(ue=>{const re=ue.folder.fsPath;if(R.$Bg(ee,re)){const ye=b.$kc(re,ee);return!ue.includePattern||!!h.$wk(ue.includePattern,ye)}else return!1}):!1:!0}var k;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(k||(e.SearchErrorCode=k={}));class A extends Error{constructor(ee,ue){super(ee),this.code=ue}}e.$$L=A;function p(Y){const ee=Y.message;if((0,c.$3)(Y))return new A(ee,k.canceled);try{const ue=JSON.parse(ee);return new A(ue.message,ue.code)}catch{return new A(ee,k.other)}}function v(Y){const ee={message:Y.message,code:Y.code};return new Error(JSON.stringify(ee))}function F(Y){return Y.type==="error"?!0:Y.type==="success"}function N(Y){return Y.type==="success"}function O(Y){return!!Y.path}function j(Y,ee,ue=!0){const re=Y.searchPath?Y.searchPath:Y.relativePath;return ue?(0,L.$5f)(re,ee):h.$wk(ee,re)}class z{constructor(ee){this.path=ee,this.results=[]}addMatch(ee){this.results.push(ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$fM=z;function M(Y,ee){const ue={...Y||{},...ee||{}};return Object.keys(ue).filter(re=>{const ye=ue[re];return typeof ye=="boolean"&&ye})}class W{constructor(ee,ue){this.c=null,this.a={...ee.excludePattern||{},...ue.excludePattern||{}},this.b=h.$xk(this.a);let re=ee.includePattern;ue.includePattern&&(re?re={...re,...ue.includePattern}:re=ue.includePattern),re&&(this.c=h.$xk(re))}matchesExcludesSync(ee,ue,re){return!!(this.b&&this.b(ee,ue,re))}includedInQuerySync(ee,ue,re){return!(this.b&&this.b(ee,ue,re)||this.c&&!this.c(ee,ue,re))}includedInQuery(ee,ue,re){const ye=this.b(ee,ue,re),me=()=>this.c?!!this.c(ee,ue,re):!0;return(0,S.$oh)(ye)?ye.then(J=>J?!1:me()):me()}hasSiblingExcludeClauses(){return V(this.a)}}e.$hM=W;function V(Y){for(const ee in Y)if(typeof Y[ee]!="boolean")return!0;return!1}function ne(Y){if(!Y)return;let ee;return ue=>(ee||(ee=(Y()||Promise.resolve([])).then(re=>re?K(re):{})),ee.then(re=>!!re[ue]))}function B(Y){if(!Y)return;let ee;return ue=>{if(!ee){const re=Y();ee=re?K(re):{}}return!!ee[ue]}}function K(Y){const ee={};for(const ue of Y)ee[ue]=!0;return ee}}),define(Se[48],De([1,0,18,7,20,4,3,84,14,133,22,12,2,8,27,5,11,230,46,62,29,19,15,9,72,37,6,51]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hpc=e.$gpc=void 0;function D(O,j,z){return new I.$5g(M=>p(M,z)).isEqual(O,j)}function y(O,j,z){return D(O.uri,j.uri,z)?0:(0,S.$wf)(O.uri.toString(),j.uri.toString())}function k(O,j,z){return O.index!==j.index?O.index<j.index?-1:1:D(O.uri,j.uri,z)?(0,S.$wf)(O.name,j.name):(0,S.$wf)(O.uri.toString(),j.uri.toString())}function A(O,j,z,M){const W=O.slice(0).sort((ne,B)=>z(ne,B,M)),V=j.slice(0).sort((ne,B)=>z(ne,B,M));return(0,r.$Db)(W,V,(ne,B)=>z(ne,B,M))}function p(O,j){const z=j.getCapabilities(O.scheme);return!(z&&z&w.FileSystemProviderCapabilities.PathCaseSensitive)}class v extends f.$Vi{static toExtHostWorkspace(j,z,M,W){if(!j)return{workspace:null,added:[],removed:[]};const{id:V,name:ne,folders:B,configuration:K,transient:Y,isUntitled:ee}=j,ue=[],re=z;z?B.forEach((U,se)=>{const ae=u.URI.revive(U.uri),te=v.o(M||z,ae,W);te?(te.name=U.name,te.index=U.index,ue.push(te)):ue.push({uri:ae,name:U.name,index:se})}):ue.push(...B.map(({uri:U,name:se,index:ae})=>({uri:u.URI.revive(U),name:se,index:ae}))),ue.sort((U,se)=>U.index<se.index?-1:1);const ye=new v(V,ne,ue,!!Y,K?u.URI.revive(K):null,!!ee,U=>p(U,W)),{added:me,removed:J}=A(re?re.workspaceFolders:[],ye.workspaceFolders,y,W);return{workspace:ye,added:me,removed:J}}static o(j,z,M){for(let W=0;W<j.folders.length;W++){const V=j.workspaceFolders[W];if(D(V.uri,z,M))return V}}constructor(j,z,M,W,V,ne,B){super(j,M.map(K=>new f.$Wi(K)),W,V,B),this.t=z,this.u=ne,this.q=[],this.s=T.$Ii.forUris(B,()=>!0),M.forEach(K=>{this.q.push(K),this.s.set(K.uri,K)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,z){return z&&this.s.get(j)&&(j=(0,I.$ch)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let F=class{constructor(j,z,M,W,V){this.c=new R.$je,this.onDidChangeWorkspace=this.c.event,this.g=new R.$je,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$le,this.C=new Map,this.h=W,this.s=M,this.t=V,this.j=new c.$Km,this.k=new h.$Bh,this.o=j.getProxy(g.$DN.MainThreadWorkspace),this.q=j.getProxy(g.$DN.MainThreadMessageService);const ne=z.workspace;this.l=ne?new v(ne.id,ne.name,[],!!ne.transient,ne.configuration?u.URI.revive(ne.configuration):null,!!ne.isUntitled,B=>p(B,M)):void 0}$initializeWorkspace(j,z){this.v=z,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:b.Schemas.untitled,path:(0,I.$ah)((0,I.$ch)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,z,M,...W){const V=[];if(Array.isArray(W)&&W.forEach(ee=>{u.URI.isUri(ee.uri)&&!V.some(ue=>D(ue.uri,ee.uri,this.s))&&V.push({uri:ee.uri,name:ee.name||(0,I.$_g)(ee.uri)})}),this.n||[z,M].some(ee=>typeof ee!="number"||ee<0)||M===0&&V.length===0)return!1;const ne=this.x?this.x.workspaceFolders:[];if(z+M>ne.length)return!1;const B=ne.slice(0);B.splice(z,M,...V.map(ee=>({uri:ee.uri,name:ee.name||(0,I.$_g)(ee.uri),index:void 0})));for(let ee=0;ee<B.length;ee++){const ue=B[ee];if(B.some((re,ye)=>ye!==ee&&D(ue.uri,re.uri,this.s)))return!1}B.forEach((ee,ue)=>ee.index=ue);const{added:K,removed:Y}=A(ne,B,k,this.s);if(K.length===0&&Y.length===0)return!1;if(this.o){const ee=j.displayName||j.name;this.o.$updateWorkspaceFolders(ee,z,M,V).then(void 0,ue=>{this.n=void 0;const re={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage($.Severity.Error,(0,P.localize)(10727,null,ee,ue.toString()),re,[])})}return this.y(B),!0}getWorkspaceFolder(j,z){if(this.x)return this.x.getWorkspaceFolder(j,z)}async getWorkspaceFolder2(j,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,z)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,z){let M,W="";if(typeof j=="string"?(M=u.URI.file(j),W=j):typeof j<"u"&&(M=j,W=j.fsPath),!M)return W;const V=this.getWorkspaceFolder(M,!0);if(!V)return W;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let ne=(0,I.$fh)(V.uri,M);return z&&V.name&&(ne=`${V.name}/${ne}`),ne}y(j){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:z,added:M,removed:W}=v.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:W}))}findFiles(j,z,M,W,V=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${W.value}, entryPoint: findFiles`);let ne="",B=!0;return z===null?B=!1:z!==void 0&&(typeof z=="string"?ne=z:ne=z.pattern),this.z(j,void 0,{exclude:ne,maxResults:M,useDefaultExcludes:B,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},V)}findFiles2(j,z={},M,W=C.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,j,z,W)}async z(j,z,M,W=C.CancellationToken.None){if(W&&W.isCancellationRequested)return Promise.resolve([]);const V=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,ne={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:V,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let B;if(j){const{includePattern:K,folder:Y}=N(o.GlobPattern.from(j));B=Y,ne.includePattern=K}else{const{includePattern:K,folder:Y}=N(o.GlobPattern.from(z));B=Y,ne.filePattern=K}return this.o.$startFileSearch(B??null,ne,W).then(K=>Array.isArray(K)?K.map(Y=>u.URI.revive(Y)):[])}async findTextInFiles(j,z,M,W,V=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${W.value}, entryPoint: findTextInFiles`);const ne=this.j.getNext(),B=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:K,folder:Y}=N(o.GlobPattern.from(z.include)),ee=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ue={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:B,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:K,excludePattern:ee},re=!1;if(this.u[ne]=ye=>{if(re)return;const me=u.URI.revive(ye.resource);ye.results.forEach(J=>{const U=(0,E.$_h)(J);(0,l.$2L)(U)?M({uri:me,preview:{text:U.preview.text,matches:(0,r.$Zb)(U.preview.matches,se=>new n.$HN(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))},ranges:(0,r.$Zb)(U.ranges,se=>new n.$HN(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))}):M({uri:me,text:U.text,lineNumber:U.lineNumber})})},V.isCancellationRequested)return{};try{const ye=await this.o.$startTextSearch(j,Y??null,ue,ne,V);return delete this.u[ne],ye||{}}catch(ye){throw delete this.u[ne],ye}}$handleTextSearchResult(j,z){this.u[z]?.(j)}async save(j){const z=await this.o.$save(j,{saveAs:!1});return u.URI.revive(z)}async saveAs(j){const z=await this.o.$save(j,{saveAs:!0});return u.URI.revive(z)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}lookupAuthorization(j){return this.o.$lookupAuthorization(j)}lookupKerberosAuthorization(j){return this.o.$lookupKerberosAuthorization(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,z){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,z);const M=this.t.transformOutgoingScheme(j),W=this.A++;return this.o.$registerEditSessionIdentityProvider(W,M),(0,L.$Rc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(W)})}async $getEditSessionIdentifier(j,z){this.h.info("Getting edit session identifier for workspaceFolder",j);const M=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const W=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!W),!W)return;const V=await W.provideEditSessionIdentity(M,z);if(this.h.info("Provider returned edit session identifier: ",V),!!V)return V}async $provideEditSessionIdentityMatch(j,z,M,W){this.h.info("Getting edit session identifier for workspaceFolder",j);const V=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!V){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const ne=this.w.get(V.uri.scheme);if(this.h.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!ne),!ne)return;const B=await ne.provideEditSessionIdentityMatch?.(z,M,W);if(this.h.info("Provider returned edit session identifier match result: ",B),!!B)return B}getOnWillCreateEditSessionIdentityEvent(j){return(z,M,W)=>{const V=function(B){z.call(M,B)};return V.extension=j,this.B.event(V,void 0,W)}}async $onWillCreateEditSessionIdentity(j,z,M){const W=await this.resolveWorkspaceFolder(u.URI.revive(j));if(W===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:W},z,async(V,ne)=>{const B=Date.now();await Promise.resolve(V),Date.now()-B>M&&this.h.warn("SLOW edit session create-participant",ne.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(j,z){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,z);const M=this.t.transformOutgoingScheme(j),W=this.A++;return this.o.$registerCanonicalUriProvider(W,M),(0,L.$Rc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(W)})}async provideCanonicalUri(j,z,M){const W=this.C.get(j.scheme);if(!W)return;const V=await W.provideCanonicalUri?.(u.URI.revive(j),z,M);if(V)return V}async $provideCanonicalUri(j,z,M){return this.provideCanonicalUri(u.URI.revive(j),{targetScheme:z},M)}};e.$gpc=F,e.$gpc=F=Ye([Ve(0,t.$cQ),Ve(1,s.$sQ),Ve(2,i.$2oc),Ve(3,m.$0j),Ve(4,d.$epc)],F),e.$hpc=(0,a.$Ci)("IExtHostWorkspace");function N(O){let j,z;return O&&(typeof O=="string"?j=O:(j=O.pattern,z=u.URI.revive(O.baseUri))),{includePattern:j,folder:z}}}),define(Se[41],De([1,0,24,4,48,6,9,45,232,70,17,7,5,19,11,2]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kpc=e.$jpc=e.$ipc=void 0;function m(d,l){if(l){const g=l.split(".");let E=d;for(let D=0;E&&D<g.length;D++)E=E[g[D]];return E}}function $(d){return d instanceof a.URI}function f(d){return d&&d.uri instanceof a.URI&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function s(d){return d&&d.uri instanceof a.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function t(d){if($(d))return{resource:d};if(f(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(i(d))return{overrideIdentifier:d.languageId};if(s(d))return{resource:d.uri};if(d===null)return{resource:null}}let o=class{constructor(l,g,E){this.a=l.getProxy(R.$DN.MainThreadConfiguration),this.c=g,this.b=E,this.d=new S.$Bh,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new n(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,g){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(l,g))}};e.$ipc=o,e.$ipc=o=Ye([Ve(0,P.$cQ),Ve(1,C.$hpc),Ve(2,w.$0j)],o);class n{constructor(l,g,E,D){this.a=new h.$je,this.b=l,this.f=D,this.c=g,this.e=b.$Oo.parse(E,D),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,g){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$Oo.parse(l,this.f),this.d=this.k(l.configurationScopes),this.a.fire(this.j(g,E))}getConfiguration(l,g,E){const D=t(g)||{},y=this.g(l?m(this.e.getValue(void 0,D,this.c.workspace),l):this.e.getValue(void 0,D,this.c.workspace));l&&this.h(l,D,E?.identifier);function k(p){if(p==null)return null;if(typeof p=="boolean")return p?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(p){case L.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case L.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case L.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const A={has(p){return typeof m(y,p)<"u"},get:(p,v)=>{this.h(l?`${l}.${p}`:p,D,E?.identifier);let F=m(y,p);if(typeof F>"u")F=v;else{let N;const O=(j,z)=>{if((0,I.$eg)(j)){let M;const W=()=>{N=N||(0,r.$bo)(y),M=M||m(N,z)};return new Proxy(j,{get:(V,ne)=>{if(typeof ne=="string"&&ne.toLowerCase()==="tojson")return W(),()=>M;if(N)return M=M||m(N,z),M[ne];const B=V[ne];return typeof ne=="string"?O(B,`${z}.${ne}`):B},set:(V,ne,B)=>(W(),M&&(M[ne]=B),!0),deleteProperty:(V,ne)=>(W(),M&&delete M[ne],!0),defineProperty:(V,ne,B)=>(W(),M&&Object.defineProperty(M,ne,B),!0)})}return Array.isArray(j)?(0,r.$bo)(j):j};F=O(F,p)}return F},update:(p,v,F,N)=>{p=l?`${l}.${p}`:p;const O=k(F);return v!==void 0?this.b.$updateConfigurationOption(O,p,v,D,N):this.b.$removeConfigurationOption(O,p,D,N)},inspect:p=>{p=l?`${l}.${p}`:p;const v=this.e.inspect(p,D,this.c.workspace);if(v)return{key:p,defaultValue:(0,r.$bo)(v.policy?.value??v.default?.value),globalValue:(0,r.$bo)(v.user?.value??v.application?.value),workspaceValue:(0,r.$bo)(v.workspace?.value),workspaceFolderValue:(0,r.$bo)(v.workspaceFolder?.value),defaultLanguageValue:(0,r.$bo)(v.default?.override),globalLanguageValue:(0,r.$bo)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,r.$bo)(v.workspace?.override),workspaceFolderLanguageValue:(0,r.$bo)(v.workspaceFolder?.override),languageIds:(0,r.$bo)(v.overrideIdentifiers)}}};return typeof y=="object"&&(0,r.$eo)(A,y,!1),Object.freeze(A)}g(l){const g=E=>(0,I.$eg)(E)?new Proxy(E,{get:(D,y)=>g(D[y]),set:(D,y,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(D,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(D,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return g(l)}h(l,g,E){const D=c.$Do.test(l)?c.ConfigurationScope.RESOURCE:this.d.get(l),y=E?`[${E.value}] `:"";if(c.ConfigurationScope.RESOURCE===D){typeof g?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(c.ConfigurationScope.WINDOW===D){g?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,g){const E=new b.$Qo(l,g,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,y)=>E.affectsConfiguration(D,t(y))})}k(l){return l.reduce((g,E)=>(g.set(E[0],E[1]),g),new Map)}}e.$jpc=n,e.$kpc=(0,u.$Ci)("IExtHostConfiguration")}),define(Se[100],De([1,0,2,7,4,6,9,48,63,41,20,47,19,29,5,14,10,11,95,273,13]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uqc=e.$Tqc=e.$Sqc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,L=Ue(L),m=Ue(m);var t;(function(N){function O(z){if(z!=null)return z}N.from=O;function j(z){if(z!=null)return z}N.to=j})(t||(t={}));var o;(function(N){function O(z){if(z!=null)return z}N.from=O;function j(z){if(z!=null)return z}N.to=j})(o||(o={}));var n;(function(N){function O(z){if(z!=null)return z}N.from=O;function j(z){if(z!=null)return z}N.to=j})(n||(n={}));var d;(function(N){function O(M){if(M){const W=M;return W&&!!W.process}else return!1}N.is=O;function j(M){if(M==null)return;const W={process:M.process,args:M.args};return M.options&&(W.options=n.from(M.options)),W}N.from=j;function z(M){if(M!=null)return new L.$rO(M.process,M.args,M.options)}N.to=z})(d||(d={}));var l;(function(N){function O(z){if(z!=null)return z}N.from=O;function j(z){if(z!=null)return z}N.to=j})(l||(l={}));var g;(function(N){function O(M){if(M){const W=M;return W&&(!!W.commandLine||!!W.command)}else return!1}N.is=O;function j(M){if(M==null)return;const W={};return M.commandLine!==void 0?W.commandLine=M.commandLine:(W.command=M.command,W.args=M.args),M.options&&(W.options=l.from(M.options)),W}N.from=j;function z(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new L.$sO(M.commandLine,M.options):new L.$sO(M.command,M.args?M.args:[],M.options)}N.to=z})(g||(g={}));var E;(function(N){function O(M){if(M){const W=M;return W&&W.customExecution==="customExecution"}else return!1}N.is=O;function j(M){return{customExecution:"customExecution"}}N.from=j;function z(M,W){return W.get(M)}N.to=z})(E||(e.CustomExecutionDTO=E={}));var D;(function(N){function O(j,z){let M;return j.scope!==void 0&&typeof j.scope!="number"?M=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===L.TaskScope.Workspace&&z&&z.workspaceFile?M=z.workspaceFile:M=i.$RI),{id:j._id,workspaceFolder:M}}N.from=O})(D||(e.TaskHandleDTO=D={}));var y;(function(N){function O(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}N.from=O})(y||(y={}));var k;(function(N){function O(M,W){if(M==null)return[];const V=[];for(const ne of M){const B=j(ne,W);B&&V.push(B)}return V}N.fromMany=O;function j(M,W){if(M==null)return;let V;M.execution instanceof L.$rO?V=d.from(M.execution):M.execution instanceof L.$sO?V=g.from(M.execution):M.execution&&M.execution instanceof L.$tO&&(V=E.from(M.execution));const ne=t.from(M.definition);let B;return M.scope?typeof M.scope=="number"?B=M.scope:B=M.scope.uri:B=L.TaskScope.Workspace,!ne||!B?void 0:{_id:M._id,definition:ne,name:M.name,source:{extensionId:W.identifier.value,label:M.source,scope:B},execution:V,isBackground:M.isBackground,group:y.from(M.group),presentationOptions:o.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}N.from=j;async function z(M,W,V){if(M==null)return;let ne;d.is(M.execution)?ne=d.to(M.execution):g.is(M.execution)?ne=g.to(M.execution):E.is(M.execution)&&(ne=E.to(M._id,V));const B=t.to(M.definition);let K;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?K=M.source.scope:K=await W.resolveWorkspaceFolder(r.URI.revive(M.source.scope)):K=L.TaskScope.Workspace),!B||!K)return;const Y=new L.$uO(B,K,M.name,M.source.label,ne,M.problemMatchers);return M.isBackground!==void 0&&(Y.isBackground=M.isBackground),M.group!==void 0&&(Y.group=L.$qO.from(M.group._id),Y.group&&M.group.isDefault&&(Y.group=new L.$qO(Y.group.id,Y.group.label),M.group.isDefault===!0&&(Y.group.isDefault=M.group.isDefault))),M.presentationOptions&&(Y.presentationOptions=o.to(M.presentationOptions)),M._id&&(Y._id=M._id),M.detail&&(Y.detail=M.detail),Y}N.to=z})(k||(e.TaskDTO=k={}));var A;(function(N){function O(z){return z}N.from=O;function j(z){if(z)return Object.assign(Object.create(null),z)}N.to=j})(A||(A={}));class p{#e;constructor(O,j,z){this._id=j,this.a=z,this.#e=O}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(O){}fireDidEndProcess(O){}}let v=class{constructor(O,j,z,M,W,V,ne,B){this.q=new C.$je,this.r=new C.$je,this.s=new C.$je,this.u=new C.$je,this.a=O.getProxy(R.$DN.MainThreadTask),this.b=z,this.c=M,this.d=W,this.e=V,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ne,this.g=B,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(O,j,z){if(!z)return new L.$FN(()=>{});const M=this.x();return this.j.set(M,{type:j,provider:z,extension:O}),this.a.$registerTaskProvider(M,j),new L.$FN(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(O,j){this.a.$registerTaskSystem(O,j)}fetchTasks(O){return this.a.$fetchTasks(A.from(O)).then(async j=>{const z=[];for(const M of j){const W=await k.to(M,this.b,this.m);W&&z.push(W)}return z})}get taskExecutions(){const O=[];return this.k.forEach(j=>O.push(j)),O}terminateTask(O){if(!(O instanceof p))throw new Error("No valid task execution provided");return this.a.$terminateTask(O._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(O,j,z){const M=this.m.get(O.id);M&&(this.o.set(O.id,M),this.e.attachPtyToTerminal(j,await M.callback(z))),this.p=O.id,this.q.fire({execution:await this.z(O)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(O){if(!this.l.has(O.id))return;const j=await this.z(O);this.l.delete(O.id),this.k.delete(O.id),this.B(O),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(O){const j=await this.z(O.id);this.s.fire({execution:j,processId:O.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(O){const j=await this.z(O.id);this.u.fire({execution:j,exitCode:O.exitCode})}$provideTasks(O,j){const z=this.j.get(O);if(!z)return Promise.reject(new Error("no handler found"));const M=[],W=(0,h.$uh)(()=>z.provider.provideTasks(I.CancellationToken.None)).then(V=>this.v(j,M,z,V));return new Promise(V=>{W.then(ne=>{Promise.all(M).then(()=>{V(ne)})})})}async $resolveTask(O,j){const z=this.j.get(O);if(!z)return Promise.reject(new Error("no handler found"));if(j.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${z.type}].`);const M=await k.to(j,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const W=await z.provider.resolveTask(M,I.CancellationToken.None);if(!W)return;this.A(W,z);const V=k.from(W,z.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(V.execution)&&await this.y(V,W,!0),await this.w(V)}x(){return this.h++}async y(O,j,z){const M=await this.a.$createTaskId(O);!z&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,j.execution)),this.m.set(M,j.execution)}async z(O,j){if(typeof O=="string"){const W=this.l.get(O);if(!W)throw new s.$ab("Unexpected: The specified task is missing an execution");return W}const z=this.l.get(O.id);if(z)return z;let M;return j?M=Promise.resolve(new p(this,O.id,j)):M=k.to(O.task,this.b,this.m).then(W=>{if(!W)throw new s.$ab("Unexpected: Task does not exist.");return new p(this,O.id,W)}),this.l.set(O.id,M),M.then(W=>(this.k.set(O.id,W),W))}A(O,j){O._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}B(O){this.o.get(O.id)&&this.o.delete(O.id),this.n.has(O.id)&&this.p!==O.id&&(this.m.delete(O.id),this.n.delete(O.id));const z=this.n.values();let M=z.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=z.next()}};e.$Sqc=v,e.$Sqc=v=Ye([Ve(0,u.$cQ),Ve(1,P.$sQ),Ve(2,T.$hpc),Ve(3,b.$nQ),Ve(4,c.$kpc),Ve(5,S.$Ipc),Ve(6,$.$0j),Ve(7,f.$Xoc)],v);let F=class extends v{constructor(O,j,z,M,W,V,ne,B){super(O,j,z,M,W,V,ne,B),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:m.$i(m.Platform.Web)})}async executeTask(O,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const z=k.from(j,O);if(z===void 0)throw new Error("Task is not valid");if(E.is(z.execution))await this.y(z,j,!1);else throw new s.$$;const M=await this.z(await this.a.$getTaskExecution(z),j);return this.a.$executeTask(z).catch(W=>{throw new Error(W)}),M}v(O,j,z,M){const W=[];if(M)for(const V of M){if(this.A(V,z),!V.definition||!O[V.definition.type]){const B=V.source?V.source:"No task source";this.f.warn(`The task [${B}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`)}const ne=k.from(V,z.extension);ne&&E.is(ne.execution)?(W.push(ne),j.push(this.y(ne,V,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:z.extension}}async w(O){if(E.is(O.execution))return O;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(O,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(O,j,z){}};e.$Tqc=F,e.$Tqc=F=Ye([Ve(0,u.$cQ),Ve(1,P.$sQ),Ve(2,T.$hpc),Ve(3,b.$nQ),Ve(4,c.$kpc),Ve(5,S.$Ipc),Ve(6,$.$0j),Ve(7,f.$Xoc)],F),e.$Uqc=(0,w.$Ci)("IExtHostTask")}),define(Se[334],De([1,0,37,30]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=void 0,e.$pM=C,e.$rM=R;function C(L){return"cellResults"in L}e.$qM="rawCell#";function R(L,T){let b=-1;const c=[];let I=[];return L.forEach(u=>{u.range.startLineNumber!==b&&I.length>0&&(c.push([...I]),I=[]),I.push(u),b=u.range.endLineNumber}),I.length>0&&c.push([...I]),c.map(u=>{const P=[],w=u[0].range.startLineNumber,a=u[u.length-1].range.endLineNumber;for(let m=w;m<=a;m++)P.push(T.getLineContent(m));return new r.$6L(P.join(`
`)+`
`,u.map(m=>new h.$Lt(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(Se[335],De([1,0,8,21,4,3,28,40,12,17,2,27,118,6,34,15,9,53,307,165,24,14,37,263,334,331]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uqc=void 0,S=Ue(S),a=Ue(a),m=Ue(m);class g{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,y,k,A,p,v,F){this.q=k,this.r=A,this.s=p,this.t=v,this.u=F,this.f=new Map,this.g=new L.$zc,this.h=new Map,this.j=new C.$je,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$je,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$je,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$je,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$Voc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(P.$DN.MainThreadNotebook),this.c=D.getProxy(P.$DN.MainThreadNotebookDocuments),this.d=D.getProxy(P.$DN.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===T.MarshalledId.NotebookCellActionContext){const O=N.notebookEditor?.notebookUri,j=N.cell.handle,M=this.g.get(O)?.getCell(j);if(M)return M.apiCell}if(N&&N.$mid===T.MarshalledId.NotebookActionContext){const O=N.uri,j=this.g.get(O);if(j)return j.apiNotebook}return N}}),g.C(y)}getEditorById(D){const y=this.h.get(D);if(!y)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(D){for(const[y,k]of this.h)if(k.apiEditor===D)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,y){const k=this.g.get(D);if(!k&&!y)throw new Error(`NO notebook document for '${D}'`);return k}static w(D,y){if(!y)return;const k=y.filenamePattern.map(A=>a.NotebookExclusiveDocumentPattern.from(A)).filter(A=>A!==void 0);if(y.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:y.displayName,filenamePattern:k,priority:y.exclusive?l.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,y,k){const A=g.a++,p=typeof k.onDidChangeCellStatusBarItems=="function"?g.a++:void 0;this.f.set(A,k),this.b.$registerNotebookCellStatusBarItemProvider(A,p,y);let v;return p!==void 0&&(v=k.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(p))),new m.$FN(()=>{this.f.delete(A),this.b.$unregisterNotebookCellStatusBarItemProvider(A,p),v?.dispose()})}async createNotebookDocument(D){const y=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&a.NotebookData.from(D.content)});return I.URI.revive(y)}async openNotebookDocument(D){const y=this.g.get(D);if(y)return y.apiNotebook;const k=await this.c.$tryOpenNotebook(D),A=this.g.get(I.URI.revive(k));return(0,c.$ng)(A?.apiNotebook)}async showNotebookDocument(D,y){I.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let k;typeof y=="object"?k={position:a.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(a.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:k={preserveFocus:!1};const A=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,k),p=A&&this.h.get(A)?.apiEditor;if(p)return p;throw A?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,y,k,A){const p=this.f.get(D),v=I.URI.revive(y),F=this.g.get(v);if(!F||!p)return;const N=F.getCellFromIndex(k);if(!N)return;const O=await p.provideCellStatusBarItems(N.apiCell,A);if(!O)return;const j=new R.$Sc,z=this.p.add([j]),W=(Array.isArray(O)?O:[O]).map(V=>a.NotebookStatusBarItem.from(V,this.i,j));return{cacheId:z,items:W}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,y,k,A,p){if((0,b.$af)(y))throw new Error("viewType cannot be empty or just whitespace");const v=this.x++;return this.y.set(v,{viewType:y,serializer:k,options:A}),this.b.$registerNotebookSerializer(v,{id:D.identifier,location:D.extensionLocation},y,a.NotebookDocumentContentOptions.from(A),g.w(D,p)),(0,R.$Rc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(D,y,k){const A=this.y.get(D);if(!A)throw new Error("NO serializer found");const p=await A.serializer.deserializeNotebook(y.buffer,k);return new $.$Uw(a.NotebookData.from(p))}async $notebookToData(D,y,k){const A=this.y.get(D);if(!A)throw new Error("NO serializer found");const p=await A.serializer.serializeNotebook(a.NotebookData.to(y.value),k);return h.$Le.wrap(p)}async $saveNotebook(D,y,k,A,p){const v=I.URI.revive(y),F=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${k}, ${v.toString()})`),!F)throw new Error("NO serializer found");const N=this.g.get(v);if(!N)throw new Error("Document NOT found");if(N.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new S.$sl((0,r.localize)(10735,null,this.A(v)),S.FileOperationResult.FILE_PERMISSION_DENIED);const O={metadata:(0,s.$jo)(N.apiNotebook.metadata,V=>!(F.options?.transientDocumentMetadata??{})[V]),cells:[]};for(const V of N.apiNotebook.getCells()){const ne=new m.$$O(V.kind,V.document.getText(),V.document.languageId,V.mime,F.options?.transientOutputs?[]:[...V.outputs],V.metadata,V.executionSummary);ne.metadata=(0,s.$jo)(V.metadata,B=>!(F.options?.transientCellMetadata??{})[B]),O.cells.push(ne)}if(await this.z(v,A),p.isCancellationRequested)throw new Error("canceled");const j=await F.serializer.serializeNotebook(O,p);if(p.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${k} ${v.toString()}`),await this.s.value.writeFile(v,j),this.D(`Finished write versionId: ${k} ${v.toString()}`);const z=this.s.getFileSystemProviderExtUri(v.scheme),M=await this.s.value.stat(v),W={name:z.basename(v),isFile:(M.type&S.FileType.File)!==0,isDirectory:(M.type&S.FileType.Directory)!==0,isSymbolicLink:(M.type&S.FileType.SymbolicLink)!==0,mtime:M.mtime,ctime:M.ctime,size:M.size,readonly:!!((M.permissions??0)&S.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((M.permissions??0)&S.FilePermission.Locked),etag:S.$Dl({mtime:M.mtime,size:M.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${k}, ${v.toString()})`),W}async $searchInNotebooks(D,y,k,A,p){const v=this.y.get(D)?.serializer;if(!v)return{limitHit:!1,results:[]};const F=new L.$Ac;await(async(M,W,V)=>{await Promise.all(M.map(async ne=>await Promise.all(ne.filenamePatterns.map(B=>{const K={_reason:V._reason,folderQueries:V.folderQueries,includePattern:V.includePattern,excludePattern:V.excludePattern,maxResults:V.maxResults,type:o.QueryType.File,filePattern:B};return this.t.doInternalFileSearchWithCustomCallback(K,W,Y=>{Y.forEach(ee=>{F.has(ee)||A.some(re=>ne.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(ye=>(0,l.$mL)(ye,ee)))||F.add(ee)})}).catch(Y=>{if(Y.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Y})}))))})(k,p,y);const O=new L.$zc;let j=!1;const z=Array.from(F).map(async M=>{const W=[];try{if(p.isCancellationRequested)return;if(y.maxResults&&[...O.values()].reduce((K,Y)=>K+Y.cellResults.length,0)>y.maxResults){j=!0;return}const V=[],ne=this.g.get(M);if(ne)ne.apiNotebook.getCells().forEach(Y=>V.push({input:Y.document.getText(),outputs:Y.outputs.flatMap(ee=>ee.items.map(ue=>ue.data.toString()))}));else{const K=await this.s.value.readFile(M),Y=h.$Le.fromString(K.toString()),ee=await v.deserializeNotebook(Y.buffer,p);if(p.isCancellationRequested)return;a.NotebookData.from(ee).cells.forEach(re=>V.push({input:re.source,outputs:re.outputs.flatMap(ye=>ye.items.map(me=>me.valueBytes.toString()))}))}if(p.isCancellationRequested)return;V.forEach((K,Y)=>{const ee=y.contentPattern.pattern,ue=new n.$1Zb(K.input,void 0,K.outputs),re=ue.findInInputs(ee),ye=ue.findInOutputs(ee),me=ye.flatMap(J=>(0,d.$rM)(J.matches,J.textBuffer)).map((J,U)=>(J.webviewIndex=U,J));if(re.length>0||ye.length>0){const J={index:Y,contentResults:(0,d.$rM)(re,ue.inputTextBuffer),webviewResults:me};W.push(J)}});const B={resource:M,cellResults:W};O.set(M,B);return}catch{return}});return await Promise.all(z),{limitHit:j,results:[...O.values()]}}async z(D,y){const k=await this.s.value.stat(D);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==S.$Cl&&typeof k.mtime=="number"&&typeof k.size=="number"&&y.mtime<k.mtime&&y.etag!==S.$Dl({mtime:y.mtime,size:k.size}))throw new S.$sl((0,r.localize)(10736,null),S.FileOperationResult.FILE_MODIFIED_SINCE,y)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,y,k){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const A=new i.$lqc(y,this.d,D,k.visibleRanges.map(a.NotebookRange.to),k.selections.map(a.NotebookRange.to),typeof k.viewColumn=="number"?a.ViewColumn.to(k.viewColumn):void 0);this.h.set(y,A)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const k of D.value.removedDocuments){const A=I.URI.revive(k),p=this.g.get(A);p&&(p.dispose(),this.g.delete(A),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(p.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===A.toString()&&this.h.delete(v.id)}if(D.value.addedDocuments){const k=[];for(const A of D.value.addedDocuments){const p=I.URI.revive(A.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const v=new f.$kqc(this.c,this.q,this.r,p,A);k.push(...A.cells.map(F=>f.$jqc.asModelAddData(F))),this.g.get(p)?.dispose(),this.g.set(p,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(v.apiNotebook)}}if(D.value.addedEditors)for(const k of D.value.addedEditors){if(this.h.has(k.id))return;const A=I.URI.revive(k.documentUri),p=this.g.get(A);p&&this.B(p,k.id,k)}const y=[];if(D.value.removedEditors)for(const k of D.value.removedEditors){const A=this.h.get(k);A&&(this.h.delete(k),this.k?.id===A.id&&(this.k=void 0),y.push(A))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(A=>this.h.get(A)).filter(A=>!!A);const k=new Set;this.l.forEach(A=>k.add(A.id));for(const A of this.h.values()){const p=k.has(A.id);A._acceptVisibility(p)}this.l=[...this.h.values()].map(A=>A).filter(A=>A.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const y=w.$AQ.String.with("notebookType","A notebook type"),k=new w.$CQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new w.$AQ("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>h.$Le.wrap(p))],new w.$BQ("Notebook Data",p=>a.NotebookData.to(p.value))),A=new w.$CQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new w.$AQ("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new $.$Uw(a.NotebookData.from(p)))],new w.$BQ("Bytes",p=>p.buffer));D.registerApiCommand(k),D.registerApiCommand(A)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$uqc=g}),define(Se[336],De([1,0,16,20,52,38,22,42,37]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mqc=void 0,r=Ue(r),R=Ue(R),L=Ue(L);class c{constructor(u,P,w){this.k=u,this.l=P,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&R.$xk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&R.$xk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const P=this.k.folderQueries||[];return new Promise((w,a)=>{const m=$=>{this.f++,u($)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach($=>{const f=$.toString(),i=r.$mc(f);this.j&&this.j(f,i)||this.v(m,{base:$,basename:i})}),Promise.all(P.map($=>this.p($,m))).then($=>{w({limitHit:this.e,stats:$[0]||void 0})},$=>{a(new Error((0,C.$nj)($)))})})}async p(u,P){const w=new h.$ue,a=this.q(u),m=this.r(),$=new b.$hM(this.k,u),f=!$.hasSiblingExcludeClauses();let i;try{this.h.add(w),i=T.$de.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,w.token),t=i.elapsed(),o=T.$de.create();return this.g&&!this.e||(s&&s.forEach(n=>{const d=r.$fc.relative(u.folder.path,n.path);if(f){const l=r.$mc(n.path);this.v(P,{base:u.folder,relativePath:d,basename:l});return}this.s(m,u.folder,d,P)}),this.g&&!this.e)?null:(this.u(m,$,P),{providerTime:t,postProcessTime:o.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q(u){const P=(0,b.$gM)(this.k.includePattern,u.includePattern),w=(0,b.$gM)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:w,includes:P,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},P,w,a){if(w===this.a){const $=r.$mc(this.a);this.v(a,{base:P,relativePath:this.a,basename:$})}function m($){const f=r.$mc($),i=r.$lc($);let s=u[i];s||(s=u[i]=[],m(i)),s.push({base:P,relativePath:$,basename:f})}m(w)}u({rootEntries:u,pathToEntries:P},w,a){const m=this,$=this.a;function f(i){const s=(0,b.$jM)(()=>i.map(t=>t.basename));for(let t=0,o=i.length;t<o;t++){const n=i[t],{relativePath:d,basename:l}=n;if(w.matchesExcludesSync(d,l,$!==l?s:void 0))continue;const g=P[d];if(g)f(g);else{if(d===$)continue;m.v(a,n)}if(m.e)break}}f(u)}v(u,P){(!this.b||P.relativePath&&this.b(P.relativePath,P.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(P))}}class I{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,P,w,a){const m=this.c(u.cacheKey),$=new c(u,P,m&&m.token);let f=0;const i=s=>{f+=s.length,w(s.map(t=>this.d(t)))};return this.e($,I.a,i,a).then(s=>({limitHit:s.limitHit,stats:s.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:f,detailStats:s.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new h.$ue),this.b.get(u)}d(u){return u.relativePath?{resource:L.$dh(u.base,u.relativePath)}:{resource:u.base}}e(u,P,w,a){const m=a.onCancellationRequested(()=>{u.cancel()}),$=i=>{i&&(f.push(i),P>0&&f.length>=P&&(w(f),f=[]))};let f=[];return u.search($).then(i=>(f.length&&w(f),m.dispose(),i),i=>(f.length&&w(f),m.dispose(),Promise.reject(i)))}}e.$mqc=I}),define(Se[337],De([1,0,18,78,38,107,28,14,16,22,12,17,2,111,8,45,11,46,157,332,37]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=void 0,e.$iN=y,r=Ue(r),h=Ue(h),C=Ue(C),b=Ue(b),I=Ue(I),w=Ue(w);let t=class{constructor(A,p,v,F,N){this.a=A,this.b=p,this.c=v,this.d=F,this.e=N}text(A,p,v={}){A=this.f(A,v);const F=this.a.getValue(),N=p&&p.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(p?.map($.$Xi),v),type:s.QueryType.Text,contentPattern:A,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:F.search.usePCRE2||N||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}f(A,p){const v=this.a.getValue();A.isRegExp&&(A.pattern=A.pattern.replace(/\r?\n/g,"\\n"));const F={...A,wordSeparators:v.editor.wordSeparators};return this.j(A,p)&&(F.isCaseSensitive=!0),this.k(A)&&(F.isMultiline=!0),p.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=p.notebookSearchConfig.includeMarkupInput),p.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=p.notebookSearchConfig.includeMarkupPreview),p.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=p.notebookSearchConfig.includeCodeInput),p.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=p.notebookSearchConfig.includeOutput),F}file(A,p={}){return{...this.h(A,p),type:s.QueryType.File,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey,shouldGlobMatchFilePattern:p.shouldGlobSearch}}g(A,p){return A?(A=Array.isArray(A)?A.map(g):g(A),p?this.parseSearchPaths(A):{pattern:n(...Array.isArray(A)?A:[A])}):{}}h(A=[],p={}){const v=this.g(p.includePattern,p.expandPatterns),F=this.g(p.excludePattern,p.expandPatterns),N=A.length>1,O=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(M=>this.q(M,p,F)):A.map(M=>this.r(M,p,F,N))).filter(M=>!!M),j={_reason:p._reason,folderQueries:O,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:F.pattern,includePattern:v.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const M=r.$Gb(this.c.groups.flatMap(ne=>ne.editors.map(B=>B.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const W=M.filter(ne=>(0,s.$0L)(j,ne.fsPath)),V=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...j,...V}}const z=p.extraFileResources&&p.extraFileResources.filter(M=>(0,s.$0L)(j,M.fsPath));return j.extraFileResources=z&&z.length?z:void 0,j}i(A){const p=[],v=new L.$zc,F={};let N=!1;return A.forEach(O=>{if(O.scheme===T.Schemas.walkThrough)return;if((0,c.$hh)(O)){const z=this.b.getWorkspaceFolder(O)?.uri??O.with({path:b.$lc(O.fsPath)});let M=v.get(z);M||(N=!0,M={folder:z,includePattern:{}},p.push(M),v.set(z,M));const W=b.$kc(z.fsPath,O.fsPath);(0,S.$ng)(M.includePattern)[W.replace(/\\/g,"/")]=!0}else O.fsPath&&(N=!0,F[O.fsPath]=!0)}),{folderQueries:p,includePattern:F,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(A,p){if(p.isSmartCase){if(A.isRegExp){if(I.$6f(A.pattern,!0))return!0}else if(I.$6f(A.pattern))return!0}return!!A.isCaseSensitive}k(A){return A.isMultiline||A.isRegExp&&(0,P.$iD)(A.pattern)||A.pattern.indexOf(`
`)>=0?!0:!!A.isMultiline}parseSearchPaths(A){const p=V=>b.$hc(V)||/^\.\.?([\/\\]|$)/.test(V),F=(Array.isArray(A)?A:d(A)).map(V=>{const ne=this.e.resolvedUserHome;return ne?(0,R.$Zw)(V,ne.scheme===T.Schemas.file?ne.fsPath:ne.path):V}),N=h.$c(F,V=>p(V)?"searchPaths":"exprSegments"),O=(N.exprSegments||[]).map(V=>I.$lf(V,"/")).map(V=>I.$lf(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),l(V))),j={},z=this.m(N.searchPaths||[]);z&&z.length&&(j.searchPaths=z);const M=O.flat(),W=n(...M);return W&&(j.pattern=W),j}l(A,p){return p.disregardExcludeSettings?void 0:(0,s.$9L)(A,!p.disregardSearchExcludeSettings)}m(A){if(!A||!A.length)return[];const p=A.flatMap(F=>{let{pathPortion:N,globPortion:O}=o(F);return O&&(O=E(O)),this.n(N).flatMap(z=>this.o(z,O))}),v=new Map;return p.forEach(F=>{const N=F.searchPath.toString(),O=v.get(N);O?F.pattern&&(O.pattern=O.pattern||{},O.pattern[F.pattern]=!0):v.set(N,{searchPath:F.searchPath,pattern:F.pattern?n(F.pattern):void 0})}),Array.from(v.values())}n(A){if(b.$hc(A)){const p=this.b.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==T.Schemas.file?[{searchPath:p[0].uri.with({path:A})}]:[{searchPath:u.URI.file(b.$gc(A))}]}if(this.b.getWorkbenchState()===$.WorkbenchState.FOLDER){const p=this.b.getWorkspace().folders[0].uri;if(A=g(A),A.startsWith("../")||A===".."){const F=b.$fc.resolve(p.path,A);return[{searchPath:p.with({path:F})}]}const v=E(A);return[{searchPath:p,pattern:v}]}else{if(A==="./"||A===".\\")return[];{const p=A.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(N=>{const O=p.match(new RegExp(`^${I.$ff(N.name)}(?:/(.*)|$)`));return O?{match:O,folder:N}:null}).filter(S.$kg);if(F.length)return F.map(N=>{const O=N.match[1];return{searchPath:N.folder.uri,pattern:O&&E(O)}});{const N=A.match(/\.[\/\\](.+)[\/\\]?/),O=N?N[1]:A,j=w.localize(1613,null,O);throw new Error(j)}}}}o(A,p){const v=A.pattern&&p?`${A.pattern}/${p}`:A.pattern||p,F=[{searchPath:A.searchPath,pattern:v}];return v&&!v.endsWith("**")&&F.push({searchPath:A.searchPath,pattern:v+"/**"}),F}q(A,p,v){const F=this.r((0,$.$Xi)(A.searchPath),p,v,!1);return F?{...F,includePattern:A.pattern}:null}r(A,p,v,F){let N;const O=u.URI.isUri(A)?A:A.uri;if(v.searchPaths){const V=v.searchPaths.filter(ne=>(0,c.$9g)(ne.searchPath,O))[0];if(V&&!V.pattern)return null;V&&(N=V.pattern)}const j=this.a.getValue({resource:O}),M={...this.l(j,p)||{},...N||{}},W=u.URI.isUri(A)?(0,c.$ah)(A):A.name;return{folder:O,folderName:F?W:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof p.disregardParentIgnoreFiles=="boolean"?p.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!j.search.followSymlinks}}};e.$hN=t,e.$hN=t=Ye([Ve(0,a.$9i),Ve(1,$.$Li),Ve(2,f.$qE),Ve(3,m.$0j),Ve(4,i.$fN)],t);function o(k){const A=k.match(/[\*\{\}\(\)\[\]\?]/);if(A){const p=A.index,v=k.substr(0,p).match(/[/|\\][^/\\]*$/);if(v){let F=k.substr(0,v.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:k.substr((v.index||0)+1)}}}return{pathPortion:k}}function n(...k){return k.length?k.reduce((A,p)=>(A[p]=!0,A),Object.create(null)):void 0}function d(k){return C.$vk(k,",").map(A=>A.trim()).filter(A=>!!A.length)}function l(k){return[`**/${k}/**`,`**/${k}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function g(k){return k.replace(/\\/g,"/")}function E(k){return g(k).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(k){return k.replace(/([?*[\]])/g,"[$1]")}function y(k,A){k=r.$Lb(k,F=>F.toString());const p=[],v=A.getWorkspace();return k&&k.forEach(F=>{let N;if(A.getWorkbenchState()===$.WorkbenchState.FOLDER)N=(0,c.$fh)(v.folders[0].uri,F),N&&N!=="."&&(N="./"+N);else{const O=A.getWorkspaceFolder(F);if(O){const j=O.name;if(v.folders.filter(M=>M.name===j).length===1){const M=(0,c.$fh)(O.uri,F);M===""?N=`./${O.name}`:N=`./${O.name}/${M}`}else N=F.fsPath}}N&&p.push(D(N))}),p}}),define(Se[338],De([1,0,22,2,20,13,5,337,37,46,7]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ryb=u,e.$syb=a,r=Ue(r),R=Ue(R);const S=7e3;function u(m,$){const f=$.activationEvents;if(!f)return Promise.resolve(void 0);const i=[],s=[];for(const g of f)if(/^workspaceContains:/.test(g)){const E=g.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||m.forceUsingSearch?s.push(E):i.push(E)}if(i.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:t,resolve:o}=(0,I.$vh)(),n=g=>o({activationEvent:g}),d=Promise.all(i.map(g=>P(m,g,n))).then(()=>{}),l=w(m,$.identifier,s,n);return Promise.all([d,l]).then(()=>{o(void 0)}),t}async function P(m,$,f){for(const i of m.folders)if(await m.exists(r.$dh(h.URI.revive(i),$))){f(`workspaceContains:${$}`);return}}async function w(m,$,f,i){if(f.length===0)return Promise.resolve(void 0);const s=new C.$ue,t=m.checkExists(m.folders,f,s.token),o=setTimeout(async()=>{s.cancel(),m.logService.info(`Not activating extension '${$.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},S);let n=!1;try{n=await t}catch(d){R.$3(d)||R.$Y(d)}s.dispose(),clearTimeout(o),n&&i(`workspaceContains:${f.join(",")}`)}function a(m,$,f,i){const s=m.get(L.$Bi),t=m.get(b.$1L),n=s.createInstance(T.$hN).file($.map(d=>(0,c.$Xi)(h.URI.revive(d))),{_reason:"checkExists",includePattern:f,exists:!0});return t.fileSearch(n,i).then(d=>!!d.limitHit,d=>R.$3(d)?!1:Promise.reject(d))}}),define(Se[54],De([1,0,8,16,61,22,7,3,84,2,11,6,41,270,125,48,25,159,13,23,21,249,9,71,5,29,97,19,114,76,47,128,4,338,124,251,14,122,42,10,123]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l,g,E,D,y,k,A,p,v,F,N,O,j,z,M,W){"use strict";var V;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zpc=e.$Ypc=e.$Xpc=e.$Wpc=e.$Vpc=void 0,r=Ue(r),h=Ue(h),C=Ue(C),f=Ue(f),e.$Vpc=(0,d.$Ci)("IHostUtils");let ne=V=class extends T.$Tc{constructor(J,U,se,ae,te,ce,le,x,oe,pe,we,Fe,ze){super(),this.Y=Fe,this.Z=ze,this.a=this.B(new p.$je),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=U,this.g=se,this.f=le,this.j=ae,this.m=te,this.s=ce,this.t=oe,this.u=pe,this.w=we,this.y=this.g.getProxy(S.$DN.MainThreadWorkspace),this.z=this.g.getProxy(S.$DN.MainThreadTelemetry),this.C=this.g.getProxy(S.$DN.MainThreadExtensionService),this.D=new L.$Bh,this.F=new L.$Bh,this.G=new L.$Bh,this.H=new L.$Bh,this.I=new ye(this.f.extensions.activationEvents),this.L=new $.$jdc(this.I,this.f.extensions.allExtensions);const Ce=new i.$pn(this.f.extensions.myExtensions);this.J=new $.$jdc(this.I,ue(this.L,Ce)),M.$u&&(this.s.info(`Creating extension host with the following global extensions: ${Y(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Y(this.J)}`)),this.M=new w.$Epc(this.g,this.s),this.N=new F.$Opc(this.g),this.O=x,this.h=this.q.add(J.createChild(new D.$Ai([w.$Fpc,this.M],[F.$Ppc,this.N]))),this.P=this.B(new P.$Dpc(this.J,this.L,{onExtensionActivationError:(Ie,Pe,q)=>{this.C.$onExtensionActivationError(Ie,f.$1(Pe),q)},actualActivateExtension:async(Ie,Pe)=>{if($.$jdc.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,Pe),new P.$Cpc;const q=this.J.getExtensionDescription(Ie);return this.fb(q,Pe)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(J){f.$Y(J)}}async $(){this.O.onWillDeactivateAll();let J=[];try{J=this.J.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this.eb(te))}catch{}await Promise.all(J)}terminate(J,U=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${J}`),this.s.flush(),this.u.dispose(),this.P.dispose(),f.setUnexpectedErrorHandler(ae=>{this.s.error(ae)}),this.g.dispose();const se=this.$();Promise.race([(0,L.$Dh)(5e3),se]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(J){return this.G.isOpen()?this.P.isActivated(J):!1}async getExtension(J){const U=await this.C.$getExtension(J);return U&&{...U,identifier:new i.$on(U.identifier.value),extensionLocation:c.URI.revive(U.extensionLocation)}}ab(J,U){return this.P.activateByEvent(J,U)}bb(J,U){return this.P.activateById(J,U)}activateByIdWithErrors(J,U){return this.bb(J,U).then(()=>{const se=this.P.getActivatedExtension(J);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(J=>this.J)}getExtensionExports(J){if(this.G.isOpen())return this.P.getActivatedExtension(J).exports;try{return this.P.getActivatedExtension(J).exports}catch{return null}}async cb(J){if(J.scheme===O.Schemas.file&&this.c.fsRealpath){const U=J.fsPath;this.R.has(U)||this.R.set(U,this.c.fsRealpath(U));const se=await this.R.get(U);return c.URI.file(se)}return J}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(J=>new re(J))),this.Q}async db(J){const U=b.$Ii.forUris(se=>R.$7g.ignorePathCasing(se));return await Promise.all(J.map(async se=>{if(this.wb(se)){const ae=await this.cb(se.extensionLocation);U.set(ae,se)}})),U}eb(J){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(J))return U;const se=this.P.getActivatedExtension(J);if(!se)return U;try{typeof se.module.deactivate=="function"&&(U=Promise.resolve(se.module.deactivate()).then(void 0,ae=>(this.s.error(ae),Promise.resolve(void 0))))}catch(ae){this.s.error(`An error occurred when deactivating the extension '${J.value}':`),this.s.error(ae)}try{se.disposable.dispose()}catch(ae){this.s.error(`An error occurred when disposing the subscriptions for extension '${J.value}':`),this.s.error(ae)}return U}async fb(J,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(J.identifier):await this.C.$onWillActivateExtension(J.identifier),this.hb(J,U).then(se=>{const ae=se.activationTimes;return this.C.$onDidActivateExtension(J.identifier,ae.codeLoadingTime,ae.activateCallTime,ae.activateResolvedTime,U),this.gb(J,U,"success",ae),se},se=>{throw this.gb(J,U,"failure"),se})}gb(J,U,se,ae){const te=K(J,U);this.z.$publicLog2("extensionActivationTimes",{...te,...ae||{},outcome:se})}hb(J,U){const se=K(J,U);this.z.$publicLog2("activatePlugin",se);const ae=this.wb(J);if(!ae)return Promise.resolve(new P.$Bpc(P.$ypc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${J.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${J.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const te=new T.$Sc,ce=new P.$zpc(U.startup);return Promise.all([this.xb(J,(0,R.$dh)(J.extensionLocation,ae),ce),this.ib(J,te)]).then(le=>(C.mark(`code/extHost/willActivateExtension/${J.identifier.value}`),V.jb(this.s,J.identifier,le[0],le[1],te,ce))).then(le=>(C.mark(`code/extHost/didActivateExtension/${J.identifier.value}`),le))}ib(J,U){const se=this.Z.createLanguageModelAccessInformation(J),ae=U.add(new t.$Hpc(J,this.M)),te=U.add(new t.$Gpc(J.identifier.value,!1,this.M)),ce=U.add(new N.$Qpc(J,this.N)),le=J.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,x=this.f.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${J.identifier.value}`),Promise.all([ae.whenReady,te.whenReady,this.O.whenReady]).then(()=>{const oe=this;let pe,we;const Fe=(0,m.$cH)(J,"ipc")?this.f.messagePorts?.get(i.$on.toKey(J.identifier)):void 0;return Object.freeze({globalState:ae,workspaceState:te,secrets:ce,subscriptions:[],get languageModelAccessInformation(){return se},get extensionUri(){return J.extensionLocation},get extensionPath(){return J.extensionLocation.fsPath},asAbsolutePath(ze){return h.$ic(J.extensionLocation.fsPath,ze)},get storagePath(){return oe.O.workspaceValue(J)?.fsPath},get globalStoragePath(){return oe.O.globalValue(J).fsPath},get logPath(){return h.$ic(oe.f.logsLocation.fsPath,J.identifier.value)},get logUri(){return c.URI.joinPath(oe.f.logsLocation,J.identifier.value)},get storageUri(){return oe.O.workspaceValue(J)},get globalStorageUri(){return oe.O.globalValue(J)},get extensionMode(){return le},get extension(){return pe===void 0&&(pe=new ee(oe,J.identifier,J,x,!1)),pe},get extensionRuntime(){return(0,m.$dH)(J,"extensionRuntime"),oe.extensionRuntime},get environmentVariableCollection(){return oe.u.getEnvironmentVariableCollection(J)},get messagePassingProtocol(){if(!we){if(!Fe)return;const ze=p.Event.buffer(p.Event.fromDOMEventEmitter(Fe,"message",Ce=>Ce.data));Fe.start(),we={onDidReceiveMessage:ze,postMessage:Fe.postMessage.bind(Fe)}}return we}})})}static jb(J,U,se,ae,te,ce){return se=se||{activate:void 0,deactivate:void 0},this.kb(J,U,se,ae,ce).then(le=>new P.$Apc(!1,null,ce.build(),se,le,(0,T.$Rc)(()=>{te.dispose(),(0,T.$Oc)(ae.subscriptions)})))}static kb(J,U,se,ae,te){if(typeof se.activate=="function")try{te.activateCallStart(),J.trace(`ExtensionService#_callActivateOptional ${U.value}`);const ce=typeof global=="object"?global:self,le=se.activate.apply(ce,[ae]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(le).then(x=>(te.activateResolveStop(),x))}catch(ce){return Promise.reject(ce)}else return Promise.resolve(se)}lb(J,U){this.bb(J.identifier,{startup:!1,extensionId:J.identifier,activationEvent:U}).then(void 0,se=>{this.s.error(se)})}mb(J,U=0){const ae=Date.now();(0,M.$C)(()=>{for(let te=U;te<J.length;te+=1){const ce=J[te];for(const le of ce.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-ae>50){this.mb(J,te);break}else this.lb(ce,le)}})}nb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(J=>{const U=J.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this.J.getAllExtensionDescriptions();if(U)this.mb(se);else for(const ae of se)if(ae.activationEvents)for(const te of ae.activationEvents)te==="onStartupFinished"&&this.lb(ae,te)})}ob(){const J=this.ab("*",!0).then(void 0,ce=>{this.s.error(ce)});this.B(this.j.onDidChangeWorkspace(ce=>this.pb(ce.added)));const U=this.j.workspace?this.j.workspace.folders:[],se=this.pb(U),ae=this.rb(),te=Promise.all([ae,J,se]).then(()=>{});return Promise.race([te,(0,L.$Dh)(1e4)]).then(()=>{this.nb()}),te}pb(J){return J.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.qb(J,U))).then(()=>{})}async qb(J,U){if(this.isActivated(U.identifier))return;const se=!this.f.remote.isRemote&&!!this.f.remote.authority,ae={logService:this.s,folders:J.map(ce=>ce.uri),forceUsingSearch:se||!this.c.fsExists,exists:ce=>this.c.fsExists(ce.fsPath),checkExists:(ce,le,x)=>this.y.$checkExists(ce,le,x)},te=await(0,v.$ryb)(ae,U);if(te)return this.bb(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:te.activationEvent}).then(void 0,ce=>this.s.error(ce))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(J){throw console.error(J),J}}async sb(){const{extensionDevelopmentLocationURI:J,extensionTestsLocationURI:U}=this.f.environment;if(!J||!U)throw new Error(r.localize(10743,null));const se=await this.xb(null,U,new P.$zpc(!1));if(!se||typeof se.run!="function")throw new Error(r.localize(10744,null,U.toString()));return new Promise((ae,te)=>{const ce=(oe,pe)=>{oe?(M.$u&&this.s.error("Test runner called back with error",oe),te(oe)):(M.$u&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),ae(typeof pe=="number"&&pe>0?1:0))},le=(0,R.$4g)(U),x=se.run(le,ce);x&&x.then&&x.then(()=>{M.$u&&this.s.info("Test runner finished successfully."),ae(0)}).catch(oe=>{M.$u&&this.s.error("Test runner finished with error",oe),te(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$Dh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(J,U){return this.S[J]=U,(0,T.$Rc)(()=>{delete this.S[J]})}async getRemoteExecServer(J){const{resolver:U}=await this.ub(J);return U?.resolveExecServer?.(J,{resolveAttempt:0})}async ub(J){const U=J.indexOf("+");if(U===-1)throw new o.$NN("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=J.substr(0,U);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this.S[se]}}async $resolveAuthority(J,U){const se=z.$de.create(!1),ae=()=>`[resolveAuthority(${(0,n.$Sl)(J)},${U})][${se.elapsed()}ms] `,te=H=>this.s.info(`${ae()}${H}`),ce=H=>this.s.warn(`${ae()}${H}`),le=(H,X=void 0)=>this.s.error(`${ae()}${H}`,X),x=H=>{if(H instanceof o.$NN)return{type:"error",error:{code:H._code,message:H._message,detail:H._detail}};throw H},oe=async H=>{te(`activating resolver for ${H}...`);const{resolver:X,authorityPrefix:Z}=await this.ub(H);if(!X)throw le(`no resolver for ${Z}`),new o.$NN(`No remote extension installed to resolve ${Z}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:X,authorityPrefix:Z,remoteAuthority:H}},pe=J.split(/@|%40/g).reverse();te(`activating remote resolvers ${pe.join(" -> ")}`);let we;try{we=await Promise.all(pe.map(oe)).catch(async H=>{if(!(H instanceof o.$NN)||H._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw H;return ce(`resolving nested authorities failed: ${H.message}`),[await oe(J)]})}catch(H){return x(H)}const Fe=new L.$Nh;Fe.cancelAndSet(()=>te("waiting..."),1e3);let ze,Ce;for(const[H,{authorityPrefix:X,resolver:Z,remoteAuthority:de}]of we.entries())try{if(H===we.length-1)te("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${X}`),ze=await Z.resolve(de,{resolveAttempt:U,execServer:Ce}),C.mark(`code/extHost/didResolveAuthorityOK/${X}`),te("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Z,o.$MN.isManagedResolvedAuthority(ze)?ze:void 0));else{if(te(`invoking resolveExecServer() for ${de}`),C.mark(`code/extHost/willResolveExecServer/${X}`),Ce=await Z.resolveExecServer?.(de,{resolveAttempt:U,execServer:Ce}),!Ce)throw new o.$NN(`Exec server was not available for ${de}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${X}`)}}catch(be){return C.mark(`code/extHost/didResolveAuthorityError/${X}`),le("returned an error",be),Fe.dispose(),x(be)}Fe.dispose();const Ie={environmentTunnels:ze.environmentTunnels,features:ze.tunnelFeatures?{elevation:ze.tunnelFeatures.elevation,privacyOptions:ze.tunnelFeatures.privacyOptions,protocol:ze.tunnelFeatures.protocol===void 0?!0:ze.tunnelFeatures.protocol}:void 0},Pe={extensionHostEnv:ze.extensionHostEnv,isTrusted:ze.isTrusted,authenticationSession:ze.authenticationSessionForInitializingExtensions?{id:ze.authenticationSessionForInitializingExtensions.id,providerId:ze.authenticationSessionForInitializingExtensions.providerId}:void 0};te(`returned ${o.$MN.isManagedResolvedAuthority(ze)?"managed authority":`${ze.host}:${ze.port}`}`);let q;if(o.$MN.isManagedResolvedAuthority(ze)){const H=U;this.Y.setFactory(H,ze.makeConnection),q={authority:J,connectTo:new n.$Pl(H),connectionToken:ze.connectionToken}}else q={authority:J,connectTo:new n.$Ql(ze.host,ze.port),connectionToken:ze.connectionToken};return{type:"ok",value:{authority:q,options:Pe,tunnelInformation:Ie}}}async $getCanonicalURI(J,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,n.$Sl)(J)})`);const{resolver:se}=await this.ub(J);if(!se)return null;const ae=c.URI.revive(U);if(typeof se.getCanonicalURI>"u")return ae;const te=await(0,L.$uh)(()=>se.getCanonicalURI(ae));return te||ae}async $startExtensionHost(J){J.toAdd.forEach(ce=>ce.extensionLocation=c.URI.revive(ce.extensionLocation));const{globalRegistry:U,myExtensions:se}=B(this.I,this.L,this.J,J),ae=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(ae),this.L.set(U.getAllExtensionDescriptions()),this.J.set(se),M.$u&&(this.s.info(`$startExtensionHost: global extensions: ${Y(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Y(this.J)}`)),this.tb()}$activateByEvent(J,U){return U===m.ActivationKind.Immediate?this.D.wait().then(se=>this.ab(J,!1)):this.G.wait().then(se=>this.ab(J,!1))}async $activate(J,U){return await this.G.wait(),this.J.getExtensionDescription(J)?(await this.bb(J,U),!0):!1}async $deltaExtensions(J){J.toAdd.forEach(ce=>ce.extensionLocation=c.URI.revive(ce.extensionLocation));const{globalRegistry:U,myExtensions:se}=B(this.I,this.L,this.J,J),ae=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(ae),this.L.set(U.getAllExtensionDescriptions()),this.J.set(se),M.$u&&(this.s.info(`$deltaExtensions: global extensions: ${Y(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Y(this.J)}`)),Promise.resolve(void 0)}async $test_latency(J){return J}async $test_up(J){return J.byteLength}async $test_down(J){const U=s.$Le.alloc(J),se=Math.random()%256;for(let ae=0;ae<J;ae++)U.writeUInt8(se,ae);return U}async $updateRemoteConnectionData(J){this.X=J,this.a.fire()}};e.$Wpc=ne,e.$Wpc=ne=V=Ye([Ve(0,d.$Bi),Ve(1,e.$Vpc),Ve(2,E.$cQ),Ve(3,a.$hpc),Ve(4,u.$kpc),Ve(5,I.$0j),Ve(6,l.$sQ),Ve(7,g.$npc),Ve(8,y.$0Fb),Ve(9,k.$Ipc),Ve(10,j.$Spc),Ve(11,W.$Tpc),Ve(12,A.$Mpc)],ne);function B(me,J,U,se){me.addActivationEvents(se.addActivationEvents);const ae=new $.$jdc(me,J.getAllExtensionDescriptions());ae.deltaExtensions(se.toAdd,se.toRemove);const te=new i.$pn(U.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of se.myToRemove)te.delete(le);for(const le of se.myToAdd)te.add(le);const ce=ue(ae,te);return{globalRegistry:ae,myExtensions:ce}}function K(me,J){return{id:me.identifier.value,name:me.name,extensionVersion:me.version,publisherDisplayName:me.publisher,activationEvents:me.activationEvents?me.activationEvents.join(","):null,isBuiltin:me.isBuiltin,reason:J.activationEvent,reasonId:J.extensionId.value}}function Y(me){return me.getAllExtensionDescriptions().map(J=>J.identifier.value).join(",")}e.$Xpc=(0,d.$Ci)("IExtHostExtensionService");class ee{#e;#t;#i;constructor(J,U,se,ae,te){this.#e=J,this.#t=U,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=h.$gc((0,R.$4g)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=ae,this.isFromDifferentExtensionHost=te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Ypc=ee;function ue(me,J){return me.getAllExtensionDescriptions().filter(U=>J.has(U.identifier))}class re{constructor(J){this.a=J}setSearchTree(J){this.a=J}findSubstr(J){return this.a.findSubstr(J)}forEach(J){return this.a.forEach(J)}}e.$Zpc=re;class ye{constructor(J){this.a=new i.$qn,this.addActivationEvents(J)}readActivationEvents(J){return this.a.get(J.identifier)??[]}addActivationEvents(J){for(const U of Object.keys(J))this.a.set(U,J[U])}}}),define(Se[339],De([1,0,61,2,6,41,25,23,19,29,5,54,11,12]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$$qc=void 0,r=Ue(r);let a=class{constructor(s,t,o,n,d,l,g){this.c=s,this.d=t,this.e=o,this.f=n,this.g=d,this.h=l,this.i=g,this.a=new Map,this.b=[]}async install(){this.j(),r.mark("code/extHost/willWaitForConfig");const s=await this.f.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new $(this.c,t,this.d,s,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(f,t,this.h.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const t of s.nodeModuleName)this.a.set(t,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(t=>s.alternativeModuleName(t))}};e.$$qc=a,e.$$qc=a=Ye([Ve(2,I.$Bi),Ve(3,R.$kpc),Ve(4,S.$Xpc),Ve(5,c.$sQ),Ve(6,u.$0j)],a);let m=class{static{w=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&w.a.size){const t=(0,P.$ff)(this.c(s.environment.appRoot.fsPath)),o="[a-z0-9_.-]",n=`@${o}+\\/${o}+|${o}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${d}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const t=this.b.exec(this.c(s));if(!t)return;const[,o,n,d]=t,l=w.a.get(n);if(l!==void 0)return console.warn(`${n} as been renamed to ${l}, please update your imports`),o+l+d}c(s){return s.replace(/\\/g,"/")}};m=w=Ye([Ve(0,c.$sQ)],m);class ${constructor(s,t,o,n,d){this.c=s,this.d=t,this.e=o,this.f=n,this.g=d,this.nodeModuleName="vscode",this.a=new T.$qn}load(s,t){const o=this.d.findSubstr(t);if(o){let n=this.a.get(o.identifier);return n||(n=this.c(o,this.e,this.f),this.a.set(o.identifier,n)),n}if(!this.b){let n="";this.d.forEach((d,l)=>n+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${n}`),this.b=this.c(L.$0G,this.e,this.f)}return this.b}}let f=class{constructor(s,t,o){this.e=s,this.f=t,this.nodeModuleName=["open","opn"],this.d=o.getProxy(C.$DN.MainThreadTelemetry);const n=o.getProxy(C.$DN.MainThreadWindow);this.c=(d,l)=>{const g=h.URI.parse(d);return l?this.g(d,l):g.scheme==="http"||g.scheme==="https"?n.$openUri(g,d,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this.f?n.$openUri(g,d,{}):this.g(d,l)}}load(s,t,o){const n=this.e.findSubstr(t);return n&&(this.a=n.identifier.value,this.h()),this.b=o(s),this.c}g(s,t){return this.i(),this.b(s,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};f=Ye([Ve(2,b.$cQ)],f)}),define(Se[64],De([1,0,49,3,16,55,5,63,77,54,9,48,267,41]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2pc=e.$1pc=void 0,C=Ue(C),R=Ue(R),e.$1pc=(0,L.$Ci)("IExtHostVariableResolverProvider");class w extends u.$gR{constructor($,f,i,s,t,o,n){function d(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const g=s.tabGroups.all.find(E=>E.isActive)?.activeTab;if(g!==void 0){if(g.input instanceof I.$uP||g.input instanceof I.$zP)return g.input.modified;if(g.input instanceof I.$tP||g.input instanceof I.$yP||g.input instanceof I.$wP)return g.input.uri}}}super({getFolderUri:l=>{const g=o.folders.filter(E=>E.name===l);if(g&&g.length>0)return g[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(l,g)=>t.getConfiguration(void 0,l).get(g),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return C.$gc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(f){const l=d();if(l){const g=f.getWorkspaceFolder(l);if(g)return C.$gc(g.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>$.getExtension(l)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(R.env))}}let a=class extends h.$Tc{constructor($,f,i,s,t){super(),this.b=$,this.c=f,this.g=i,this.h=s,this.j=t,this.a=new r.$T(async()=>{const o=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.j,o,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$2pc=a,e.$2pc=a=Ye([Ve(0,c.$Xpc),Ve(1,S.$hpc),Ve(2,T.$nQ),Ve(3,P.$kpc),Ve(4,b.$wpc)],a)}),define(Se[101],De([1,0,7,4,2,3,23,5,6,77,54,19,9,48,154,119,258,41,64,50,34,15,18,98]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_pc=e.$$pc=e.$0pc=e.$9pc=e.$8pc=void 0,t=Ue(t),e.$8pc=(0,T.$Ci)("IExtHostDebugService");let d=class extends R.$Tc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(A,p,v,F,N,O,j,z){super(),this.Y=p,this.Z=v,this.$=F,this.ab=N,this.bb=O,this.cb=j,this.db=z,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new h.$je),this.z=this.B(new h.$je),this.C=this.B(new h.$je),this.F=this.B(new h.$je),this.u=A.getProxy(b.$DN.MainThreadDebugService),this.I=this.B(new h.$je),this.L=this.B(new h.$je),this.G=new g(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(M=>{this.B(M.onDidChange(W=>{this.fb(M)})),this.fb(M)})}async $getVisualizerTreeItem(A,p){const v=this.gb(p);if(!v)return;const F=await this.Q.get(A)?.getTreeItem?.(v);return F?this.eb(A,F):void 0}registerDebugVisualizationTree(A,p,v){const F=L.$on.toKey(A.identifier),N=this.ub(F,p);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.Q.set(N,v),this.u.$registerDebugVisualizerTree(N,!!v.editItem),(0,R.$Rc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete(p)})}async $getVisualizerTreeItemChildren(A,p){const v=this.S.get(p)?.item;return v?(await this.Q.get(A)?.getChildren?.(v))?.map(N=>this.eb(A,N))||[]:[]}async $editVisualizerTreeItem(A,p){const v=this.S.get(A);if(!v)return;const F=await this.Q.get(v.provider)?.editItem?.(v.item,p);return this.eb(v.provider,F||v.item)}$disposeVisualizedTree(A){const p=this.S.get(A);if(!p)return;const v=[p.children];for(const F of v)if(F)for(const N of F)v.push(this.S.get(N)?.children),this.S.delete(N)}eb(A,p){let v=this.R.get(p);return v||(v=this.O++,this.R.set(p,v),this.S.set(v,{provider:A,item:p})),t.DebugTreeItem.from(p,v)}asDebugSourceUri(A,p){const v=A;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let F=`debug:${encodeURIComponent(v.path||"")}`,N="?";return p&&(F+=`${N}session=${encodeURIComponent(p.id)}`,N="&"),F+=`${N}ref=${v.sourceReference}`,C.URI.parse(F)}else{if(v.path)return C.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(A){const p=[];for(const v of A.getAllExtensionDescriptions())if(v.contributes){const F=v.contributes.debuggers;if(F&&F.length>0)for(const N of F)(0,m.$8H)(N)&&p.push(N.type)}this.u.$registerDebugTypes(p)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const A=[];return this.H.forEach(p=>A.push(p)),A}async $resolveDebugVisualizer(A,p){const v=this.W.get(A);if(!v)throw new Error(`No debug visualizer found with id '${A}'`);let{v:F,provider:N,extensionId:O}=v;if(F.visualization||(F=await N.resolveDebugVisualization?.(F,p)||F,v.v=F),!F.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(O,F.visualization)}async $executeDebugVisualizerCommand(A){const p=this.W.get(A);if(!p)throw new Error(`No debug visualizer found with id '${A}'`);const v=p.v.visualization;v&&"command"in v&&this.cb.executeCommand(v.command,...v.arguments||[])}gb(A){const p=this.w.get(A.sessionId);return p&&{session:p.api,variable:A.variable,containerId:A.containerId,frameId:A.frameId,threadId:A.threadId}}async $provideDebugVisualizers(A,p,v,F){const N=this.gb(v),O=this.ub(A,p),j=this.P.get(O);if(!N||!j)return[];const z=await j.provideDebugVisualization(N,F);return z?z.map(M=>{const W=++this.X;this.W.set(W,{v:M,provider:j,extensionId:A});const V=M.iconPath?this.wb(M.iconPath):void 0;return{id:W,name:M.name,iconClass:V?.iconClass,iconPath:V?.iconPath,visualization:this.vb(A,M.visualization)}}):[]}$disposeDebugVisualizers(A){for(const p of A)this.W.delete(p)}registerDebugVisualizationProvider(A,p,v){if(!A.contributes?.debugVisualizers?.some(O=>O.id===p))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${p})`);const F=L.$on.toKey(A.identifier),N=this.ub(F,p);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.P.set(N,v),this.u.$registerDebugVisualizer(F,p),(0,R.$Rc)(()=>{this.u.$unregisterDebugVisualizer(F,p),this.P.delete(p)})}addBreakpoints(A){const p=A.filter(N=>{const O=N.id;return this.H.has(O)?!1:(this.H.set(O,N),!0)});this.rb(p,[],[]);const v=[],F=new Map;for(const N of p)if(N instanceof u.$JO){let O=F.get(N.location.uri.toString());O||(O={type:"sourceMulti",uri:N.location.uri,lines:[]},F.set(N.location.uri.toString(),O),v.push(O)),O.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof u.$KO&&v.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(v)}removeBreakpoints(A){const p=A.filter(O=>this.H.delete(O.id));this.rb([],p,[]);const v=p.filter(O=>O instanceof u.$JO).map(O=>O.id),F=p.filter(O=>O instanceof u.$KO).map(O=>O.id),N=p.filter(O=>O instanceof u.$LO).map(O=>O.id);return this.u.$unregisterBreakpoints(v,F,N)}startDebugging(A,p,v){const F=v.testRun&&this.db.getMetadataForRun(v.testRun);return this.u.$startDebugging(A?A.uri:void 0,p,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,testRun:F&&{runId:F.runId,taskId:F.taskId},suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(A){return this.u.$stopDebugging(A?A.id:void 0)}registerDebugConfigurationProvider(A,p,v){if(!p)return new u.$FN(()=>{});const F=this.f++;return this.g.push({type:A,handle:F,provider:p}),this.u.$registerDebugConfigurationProvider(A,v,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,F),new u.$FN(()=>{this.g=this.g.filter(N=>N.provider!==p),this.u.$unregisterDebugConfigurationProvider(F)})}registerDebugAdapterDescriptorFactory(A,p,v){if(!v)return new u.$FN(()=>{});if(!this.nb(A,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.kb(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const F=this.h++;return this.j.push({type:p,handle:F,factory:v}),this.u.$registerDebugAdapterDescriptorFactory(p,F),new u.$FN(()=>{this.j=this.j.filter(N=>N.factory!==v),this.u.$unregisterDebugAdapterDescriptorFactory(F)})}registerDebugAdapterTrackerFactory(A,p){if(!p)return new u.$FN(()=>{});const v=this.m++;return this.n.push({type:A,handle:v,factory:p}),new u.$FN(()=>{this.n=this.n.filter(F=>F.factory!==p)})}async $runInTerminal(A,p){return Promise.resolve(void 0)}async $substituteVariables(A,p){let v;const F=await this.tb(A);return F&&(v={uri:F.uri,name:F.name,index:F.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(v,p)}hb(A,p){if(A.type==="implementation")return new D(A.implementation)}ib(){}async $startDASession(A,p){const v=this,F=await this.sb(p);return this.pb(this.kb(F.type),F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}' (extension might have failed to activate)`);const O=this.jb(N),j=this.hb(O,F);if(!j)throw new Error(`Couldn't create a debug adapter for type '${F.type}'.`);const z=j;return this.M.set(A,z),this.ob(F).then(M=>(M&&this.N.set(A,M),z.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const V=W,ne={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const B=await this.U.sign(V.arguments.value);ne.body={signature:B},z.sendResponse(ne)}else throw new Error("no signer")}catch(B){ne.success=!1,ne.message=B.message,z.sendResponse(ne)}}else M&&M.onDidSendMessage&&M.onDidSendMessage(W),W=(0,m.$aI)(W,!0),v.u.$acceptDAMessage(A,W)}),z.onError(W=>{M&&M.onError&&M.onError(W),this.u.$acceptDAError(A,W.name,W.message,W.stack)}),z.onExit(W=>{M&&M.onExit&&M.onExit(W??void 0,void 0),this.u.$acceptDAExit(A,W??void 0,void 0)}),M&&M.onWillStartSession&&M.onWillStartSession(),z.startSession()))})}$sendDAMessage(A,p){p=(0,m.$_H)(p,!1);const v=this.N.get(A);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(p),this.M.get(A)?.sendMessage(p)}$stopDASession(A){const p=this.N.get(A);this.N.delete(A),p&&p.onWillStopSession&&p.onWillStopSession();const v=this.M.get(A);return this.M.delete(A),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(A){const p=[],v=[],F=[];if(A.added)for(const N of A.added){const O=N.id;if(O&&!this.H.has(O)){let j;if(N.type==="function")j=new u.$KO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")j=new u.$LO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const z=C.URI.revive(N.uri);j=new u.$JO(new u.$TN(z,new u.$GN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,u.$HO)(j,O),this.H.set(O,j),p.push(j)}}if(A.removed)for(const N of A.removed){const O=this.H.get(N);O&&(this.H.delete(N),v.push(O))}if(A.changed){for(const N of A.changed)if(N.id){const O=this.H.get(N.id);if(O){if(O instanceof u.$KO&&N.type==="function"){const j=O;j.enabled=N.enabled,j.condition=N.condition,j.hitCondition=N.hitCondition,j.logMessage=N.logMessage,j.functionName=N.functionName}else if(O instanceof u.$JO&&N.type==="source"){const j=O;j.enabled=N.enabled,j.condition=N.condition,j.hitCondition=N.hitCondition,j.logMessage=N.logMessage,j.location=new u.$TN(C.URI.revive(N.uri),new u.$GN(N.line,N.character))}F.push(O)}}}this.rb(p,v,F)}async $acceptStackFrameFocus(A){let p;if(A){const v=await this.sb(A.sessionId);A.kind==="thread"?p=new u.$RO(v.api,A.threadId):p=new u.$QO(v.api,A.threadId,A.frameId)}this.J=p,this.L.fire(this.J)}$provideDebugConfigurations(A,p,v){return(0,r.$uh)(async()=>{const F=this.mb(A);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb(p);return F.provideDebugConfigurations(N,v)}).then(F=>{if(!F)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return F})}$resolveDebugConfiguration(A,p,v,F){return(0,r.$uh)(async()=>{const N=this.mb(A);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.tb(p);return N.resolveDebugConfiguration(O,v,F)})}$resolveDebugConfigurationWithSubstitutedVariables(A,p,v,F){return(0,r.$uh)(async()=>{const N=this.mb(A);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.tb(p);return N.resolveDebugConfigurationWithSubstitutedVariables(O,v,F)})}async $provideDebugAdapter(A,p){const v=this.lb(A);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const F=await this.sb(p);return this.pb(v,F).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(A){const p=await this.sb(A);this.y.fire(p.api)}async $acceptDebugSessionTerminated(A){const p=await this.sb(A);p&&(this.z.fire(p.api),this.w.delete(p.id))}async $acceptDebugSessionActiveChanged(A){this.D=A?await this.sb(A):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(A,p){(await this.sb(A))?._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(A,p){const F={session:(await this.sb(A)).api,event:p.event,body:p.body};this.F.fire(F)}jb(A){if(A instanceof u.$MO)return{type:"executable",command:A.command,args:A.args,options:A.options};if(A instanceof u.$NO)return{type:"server",port:A.port,host:A.host};if(A instanceof u.$OO)return{type:"pipeServer",path:A.path};if(A instanceof u.$PO)return{type:"implementation",implementation:A.implementation};throw new Error("convertToDto unexpected type")}kb(A){const p=this.j.filter(v=>v.type===A);if(p.length>0)return p[0].factory}lb(A){const p=this.j.filter(v=>v.handle===A);if(p.length>0)return p[0].factory}mb(A){const p=this.g.filter(v=>v.handle===A);if(p.length>0)return p[0].provider}nb(A,p){if(A.contributes){const v=A.contributes.debuggers;if(v&&v.length>0){for(const F of v)if(F.label&&F.type&&F.type===p)return!0}}return!1}ob(A){const v=A.configuration.type,F=this.n.filter(N=>N.type===v||N.type==="*").map(N=>(0,r.$uh)(()=>N.factory.createDebugAdapterTracker(A.api)).then(O=>O,O=>null));return Promise.race([Promise.all(F).then(N=>{const O=(0,o.$Gb)(N);if(O.length>0)return new E(O)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(A,p){const v=p.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new u.$NO(v));if(A){const N=await this.Z.getExtensionRegistry();return(0,r.$uh)(()=>A.createDebugAdapterDescriptor(p.api,this.qb(p,N))).then(O=>{if(O)return O})}const F=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(p,F))}qb(A,p){}rb(A,p,v){(A.length>0||p.length>0||v.length>0)&&this.I.fire(Object.freeze({added:A,removed:p,changed:v}))}async sb(A){if(A)if(typeof A=="string"){const p=this.w.get(A);if(p)return p}else{let p=this.w.get(A.id);if(!p){const v=await this.tb(A.folderUri),F=A.parent?this.w.get(A.parent):void 0;p=new l(this.u,A.id,A.type,A.name,v,A.configuration,F?.api),this.w.set(p.id,p),this.u.$sessionCached(p.id)}return p}throw new Error("cannot find session")}tb(A){if(A){const p=C.URI.revive(A);return this.Y.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}ub(A,p){return`${A}\0${p}`}vb(A,p){if(p){if("title"in p&&"command"in p)return{type:a.DebugVisualizationType.Command};if("treeId"in p)return{type:a.DebugVisualizationType.Tree,id:`${A}\0${p.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(A){const p=this.xb(A);let v,F;return"id"in p?F=i.ThemeIcon.asClassName(p):v=p,{iconPath:v,iconClass:F}}xb(A){if(A instanceof u.$EO)return{id:A.id};const p=typeof A=="object"&&"dark"in A?A.dark:A,v=typeof A=="object"&&"light"in A?A.light:A;return{dark:typeof p=="string"?C.URI.file(p):p,light:typeof v=="string"?C.URI.file(v):v}}};e.$9pc=d,e.$9pc=d=Ye([Ve(0,S.$cQ),Ve(1,P.$hpc),Ve(2,I.$Xpc),Ve(3,$.$kpc),Ve(4,c.$wpc),Ve(5,f.$1pc),Ve(6,s.$yQ),Ve(7,n.$3pc)],d);class l{constructor(A,p,v,F,N,O,j){this.f=A,this.g=p,this.h=v,this.j=F,this.k=N,this.l=O,this.m=j}get api(){const A=this;return this.d??=Object.freeze({id:A.g,type:A.h,get name(){return A.j},set name(p){A.j=p,A.f.$setDebugSessionName(A.g,p)},parentSession:A.m,workspaceFolder:A.k,configuration:A.l,customRequest(p,v){return A.f.$customDebugAdapterRequest(A.g,p,v)},getDebugProtocolBreakpoint(p){return A.f.$getDebugProtocolBreakpoint(A.g,p.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(A){this.j=A}get configuration(){return this.l}}e.$0pc=l;class g{constructor(A){this.value=Object.freeze({append(p){A.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.$$pc=g;class E{constructor(A){this.d=A}onWillStartSession(){this.d.forEach(A=>A.onWillStartSession?A.onWillStartSession():void 0)}onWillReceiveMessage(A){this.d.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(A):void 0)}onDidSendMessage(A){this.d.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(A):void 0)}onWillStopSession(){this.d.forEach(A=>A.onWillStopSession?A.onWillStopSession():void 0)}onError(A){this.d.forEach(p=>p.onError?p.onError(A):void 0)}onExit(A,p){this.d.forEach(v=>v.onExit?v.onExit(A,p):void 0)}}class D extends w.$Wtb{constructor(A){super(),this.h=A,A.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(A){this.h.handleMessage(A)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let y=class extends d{constructor(A,p,v,F,N,O,j,z){super(A,p,v,F,N,O,j,z)}};e.$_pc=y,e.$_pc=y=Ye([Ve(0,S.$cQ),Ve(1,P.$hpc),Ve(2,I.$Xpc),Ve(3,$.$kpc),Ve(4,c.$wpc),Ve(5,f.$1pc),Ve(6,s.$yQ),Ve(7,n.$3pc)],y)}),define(Se[340],De([1,0,13,61,2,6,288,11,88,114,29,225,19,72,54,94]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$arc=e.$_qc=void 0,r=Ue(r),h=Ue(h);class m{static async installEarlyHandler(i){Error.stackTraceLimit=100;const s=i.get(T.$0j),o=i.get(u.$cQ).getProxy(R.$DN.MainThreadErrors);r.setUnexpectedErrorHandler(n=>{s.error(n);const d=r.$1(n);o.$onUnexpectedError(d)})}static async installFullHandler(i){const s=i.get(T.$0j),t=i.get(u.$cQ),o=i.get(w.$Xpc),n=i.get(a.$wQ),d=t.getProxy(R.$DN.MainThreadExtensionService),l=t.getProxy(R.$DN.MainThreadErrors),g=await o.getExtensionPathIndex(),E=new WeakMap;function D(A,p){if(E.has(A))return E.get(A).stack;let v="",F,N;for(const j of p)v+=`
	at ${j.toString()}`,N=j.getFileName(),!F&&N&&(F=g.findSubstr(C.URI.file(N)));const O=`${A.name||"Error"}: ${A.message||""}${v}`;return E.set(A,{extensionIdentifier:F?.identifier,stack:O}),O}const y=Symbol("prepareStackTrace wrapped");let k=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return k},set(A){if(A===D||!A||A[y]){k=A||D;return}k=function(p,v){return D(p,v),A.call(Error,p,v)},Object.assign(k,{[y]:!0})}}),r.setUnexpectedErrorHandler(A=>{s.error(A);const p=r.$1(A),v=E.get(A);if(!v?.extensionIdentifier){l.$onUnexpectedError(p);return}d.$onExtensionRuntimeError(v.extensionIdentifier,p);const F=n.onExtensionError(v.extensionIdentifier,A);s.trace("forwarded error to extension?",F,v)})}}e.$_qc=m;class ${constructor(i,s,t,o,n){this.a=t,this.b=new L.$rdc(i,null,o),s=$.e(s,this.b);const d=new c.$Ai(...(0,b.$Ps)());d.set(I.$sQ,{_serviceBrand:void 0,...s,messagePorts:n}),d.set(u.$cQ,new u.$dQ(this.b)),d.set(P.$epc,new P.$fpc(o)),d.set(w.$Vpc,t);const l=new S.$tr(d,!0);l.invokeFunction(m.installEarlyHandler),this.d=l.invokeFunction(g=>g.get(T.$0j)),h.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=l.invokeFunction(g=>g.get(w.$Xpc)),this.c.initialize(),l.invokeFunction(m.installFullHandler)}async asBrowserUri(i){const s=this.b.getProxy(R.$DN.MainThreadExtensionService);return C.URI.revive(await s.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,s){i.extensions.allExtensions.forEach(o=>{o.extensionLocation=C.URI.revive(s.transformIncomingURIs(o.extensionLocation))}),i.environment.appRoot=C.URI.revive(s.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(o=>C.URI.revive(s.transformIncomingURIs(o)))),i.environment.extensionTestsLocationURI=C.URI.revive(s.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=C.URI.revive(s.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=C.URI.revive(s.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=C.URI.revive(s.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=C.URI.revive(s.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=C.URI.revive(s.transformIncomingURIs(i.logsLocation)),i.workspace=s.transformIncomingURIs(i.workspace),i}}e.$arc=$}),define(Se[341],De([1,0,7,10,8,218,148,101,77,54,19,47,9,64,48,259,260,41,34,98]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$krc=void 0,h=Ue(h),C=Ue(C);let s=class extends T.$9pc{constructor(l,g,E,D,y,k,A,p,v){super(l,g,E,D,k,A,p,v),this.Ab=y,this.yb=new n}hb(l,g){switch(l.type){case"server":return new a.$frc(l);case"pipeServer":return new a.$grc(l);case"executable":return new a.$hrc(l,g.type)}return super.hb(l,g)}qb(l,g){const E=a.$hrc.platformAdapterExecutable(g.getAllExtensionDescriptions(),l.type);if(E)return new u.$MO(E.command,E.args,E.options)}ib(){return new L.$qhc}async $runInTerminal(l,g){if(l.kind==="integrated"){this.zb||(this.zb=this.B(this.Ab.onDidCloseTerminal(z=>{this.yb.onTerminalClosed(z)})));const E=await this.$.getConfigProvider(),D=this.Ab.getDefaultShell(!0),y=this.Ab.getDefaultShellArgs(!0),k=l.title||C.localize(10714,null),A=JSON.stringify({shell:D,shellArgs:y});let p=await this.yb.checkout(A,k),v,F=!1;if(p)v=l.cwd;else{const z={shellPath:D,shellArgs:y,cwd:l.cwd,name:k,iconPath:new u.$EO("debug")};F=!0,p=this.Ab.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.yb.insert(p,A)}p.show(!0);const N=await p.processId;F?await new Promise(z=>setTimeout(z,1e3)):(p.state.isInteractedWith&&(p.sendText(""),await(0,r.$Dh)(200)),E.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?p.sendText("cls"):D.indexOf("bash")>=0?p.sendText("clear"):h.$j?p.sendText("cls"):p.sendText("clear")));const O=(0,m.$jrc)(D,l.args,!!l.argsCanBeInterpretedByShell,v,l.env);p.sendText(O);const j=this.onDidTerminateDebugSession(z=>{z.id===g&&(this.yb.free(p),j.dispose())});return N}else if(l.kind==="external")return o(l,await this.$.getConfigProvider());return super.$runInTerminal(l,g)}};e.$krc=s,e.$krc=s=Ye([Ve(0,I.$cQ),Ve(1,w.$hpc),Ve(2,c.$Xpc),Ve(3,$.$kpc),Ve(4,S.$Ipc),Ve(5,b.$wpc),Ve(6,P.$1pc),Ve(7,f.$yQ),Ve(8,i.$3pc)],s);let t;function o(d,l){if(!t)if(h.$j)t=new R.$$fc;else if(h.$k)t=new R.$_fc;else if(h.$l)t=new R.$agc;else throw new Error("external terminals not supported on this platform");const g=l.getConfiguration("terminal");return t.runInTerminal(d.title,d.cwd,d.args,d.env||{},g.external||{})}class n{constructor(){this.b=new Map}static{this.a=1e3}async checkout(l,g,E=!1){const y=[...this.b.entries()].map(([k,A])=>(0,r.$ph)(async p=>{if(k.name!==g||A.lastUsedAt!==-1&&await(0,m.$irc)(await k.processId))return null;const v=Date.now();return A.lastUsedAt+n.a>v||p.isCancellationRequested?null:A.config!==l?(E&&k.dispose(),null):(A.lastUsedAt=v,k)}));return await(0,r.$Hh)(y,k=>!!k)}insert(l,g){this.b.set(l,{lastUsedAt:Date.now(),config:g})}free(l){const g=this.b.get(l);g&&(g.lastUsedAt=-1)}onTerminalClosed(l){this.b.delete(l)}}}),define(Se[342],De([1,0,16,2,109,48,63,41,46,47,19,29,100,14,11,95,22,66,64]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$crc=void 0,r=Ue(r),m=Ue(m);let i=class extends u.$Sqc{constructor(t,o,n,d,l,g,E,D,y){super(t,o,n,d,l,g,E,D),this.C=n,this.D=y,o.remote.isRemote&&o.remote.authority?this.registerTaskSystem(P.Schemas.vscodeRemote,{scheme:P.Schemas.vscodeRemote,authority:o.remote.authority,platform:process.platform}):this.registerTaskSystem(P.Schemas.file,{scheme:P.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,o){const n=o;if(!o.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const d=u.TaskHandleDTO.from(n,this.C),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const g=await this.z(l,o);return this.a.$executeTask(d).catch(()=>{}),g}else{const d=u.TaskDTO.from(o,t);if(d===void 0)return Promise.reject(new Error("Task is not valid"));u.CustomExecutionDTO.is(d.execution)&&await this.y(d,o,!1);const l=await this.z(await this.a.$getTaskExecution(d),o);return this.a.$executeTask(d).catch(()=>{}),l}}v(t,o,n,d){const l=[];if(d)for(const g of d){this.A(g,n),(!g.definition||!t[g.definition.type])&&this.f.warn(`The task [${g.source}, ${g.name}] uses an undefined task type. The task will be ignored in the future.`);const E=u.TaskDTO.from(g,n.extension);E&&(l.push(E),u.CustomExecutionDTO.is(E.execution)&&o.push(this.y(E,g,!0)))}return{tasks:l,extension:n.extension}}async w(t){return t}async G(t){let o=t&&t.length>0?t[0]:void 0;if(!o){const n=h.URI.file((0,$.homedir)());o=new b.$Wi({uri:n,name:m.$ah(n),index:0})}return{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,o){const n=h.URI.revive(t),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(n),g=await this.b.getWorkspaceFolders2()??[],E=await this.D.getResolver(),D=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(g);for(const y of o.variables)d.variables[y]=await E.resolveAsync(D,y);if(o.process!==void 0){let y;if(o.process.path!==void 0){y=o.process.path.split(r.$sc);for(let k=0;k<y.length;k++)y[k]=await E.resolveAsync(D,y[k])}d.process=await C.win32.findExecutable(await E.resolveAsync(D,o.process.name),o.process.cwd!==void 0?await E.resolveAsync(D,o.process.cwd):void 0,y)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(t,o,n){return C.win32.findExecutable(t,o,n)}};e.$crc=i,e.$crc=i=Ye([Ve(0,I.$cQ),Ve(1,S.$sQ),Ve(2,R.$hpc),Ve(3,L.$nQ),Ve(4,T.$kpc),Ve(5,c.$Ipc),Ve(6,w.$0j),Ve(7,a.$Xoc),Ve(8,f.$1pc)],i)}),define(Se[343],De([1,0,66,64]),function($e,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Urc=void 0;class C extends h.$2pc{m(){return(0,r.homedir)()}}e.$Urc=C}),define(Se[171],De([1,0,18,7,20,52,14,16,22,2,37]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qqc=e.$oqc=e.$nqc=void 0,e.$pqc=a,T=Ue(T),b=Ue(b);class S{constructor(f,i,s){this.d=f,this.e=i,this.f=s,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(f,i){const s=this.g.folderQueries||[],t=new C.$ue(i);return new Promise((o,n)=>{this.a=new P(f);let d=!1;const l=(g,E)=>{if(!d&&!this.b){const D=this.h(g);a(g)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,d=!0,t.cancel(),g=this.j(g,this.g.maxResults-this.c));const y=this.h(g);this.c+=y,(y>0||!a(g))&&this.a.add(g,E)}};Promise.all(s.map((g,E)=>this.k(g,D=>l(D,E),t.token))).then(g=>{t.dispose(),this.a.flush();const E=g.some(D=>!!D&&!!D.limitHit);o({limitHit:this.b||E,messages:g.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},g=>{t.dispose();const E=(0,R.$nj)(g);n(new Error(E))})})}h(f){return a(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}j(f,i){const s=Array.isArray(f.ranges)?f.ranges:[f.ranges],t=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:s.slice(0,i),preview:{matches:t.slice(0,i),text:f.preview.text},uri:f.uri}}async k(f,i,s){const t=new I.$hM(this.g,f),o=[],n={report:g=>{if(!this.l(g))return;const E=f.folder.scheme===L.Schemas.file?(0,I.$iM)(()=>this.e.readdir(b.$ch(g.uri))):void 0,D=b.$fh(f.folder,g.uri);if(D){const y=t.includedInQuery(D,T.$mc(D),E);(0,h.$oh)(y)?o.push(y.then(k=>{k&&i(g)})):y&&i(g)}}},d=this.n(f);let l;return this.d.query.type===I.QueryType.aiText?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,n,s):l=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),d,n,s),o.length&&await Promise.all(o),l}l(f){if(a(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(f){const i=(0,I.$gM)(this.g.includePattern,f.includePattern),s=(0,I.$gM)(this.g.excludePattern,f.excludePattern),t={folder:c.URI.from(f.folder),excludes:s,includes:i,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.e.toCanonicalName(f.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??I.$ZL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$nqc=S;function u($){return{isCaseSensitive:$.isCaseSensitive||!1,isRegExp:$.isRegExp||!1,isWordMatch:$.isWordMatch||!1,isMultiline:$.isMultiline||!1,pattern:$.pattern}}class P{constructor(f){this.e=f,this.b=-1,this.d=null,this.a=new m(512,i=>this.g(i))}add(f,i){this.d&&(this.b!==i||!b.$9g(this.c,f.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:f.uri,results:[]}),this.d.results.push(w(f))}f(){const f=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,f)}flush(){this.f(),this.a.flush()}g(f){this.e(f)}}e.$oqc=P;function w($){return a($)?{preview:{matches:(0,r.$Zb)($.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:$.preview.text},ranges:(0,r.$Zb)($.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:$.text,lineNumber:$.lineNumber}}function a($){return!!$.preview}class m{static{this.a=4e3}static{this.b=50}constructor(f,i){this.g=f,this.h=i,this.c=0,this.d=[],this.e=0}addItem(f,i){f&&this.j(f,i)}addItems(f,i){f&&this.k(f,i)}j(f,i){this.d.push(f),this.e+=i,this.l()}k(f,i){this.d=this.d.concat(f),this.e+=i,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$qqc=m}),define(Se[102],De([1,0,3,6,5,336,19,72,11,2,171]),function($e,e,r,h,C,R,L,T,b,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sqc=e.$rqc=void 0,e.$tqc=u,e.$rqc=(0,C.$Ci)("IExtHostSearch");let S=class{constructor(a,m,$){this.n=a,this.o=m,this.q=$,this.c=this.n.getProxy(h.$DN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$mqc}s(a){return this.o.transformOutgoingScheme(a)}registerTextSearchProvider(a,m){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const $=this.d++;return this.e.set($,m),this.c.$registerTextSearchProvider($,this.s(a)),(0,r.$Rc)(()=>{this.g.delete(a),this.e.delete($),this.c.$unregisterProvider($)})}registerAITextSearchProvider(a,m){if(this.i.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this.i.add(a);const $=this.d++;return this.h.set($,m),this.c.$registerAITextSearchProvider($,this.s(a)),(0,r.$Rc)(()=>{this.i.delete(a),this.h.delete($),this.c.$unregisterProvider($)})}registerFileSearchProvider(a,m){if(this.k.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.k.add(a);const $=this.d++;return this.j.set($,m),this.c.$registerFileSearchProvider($,this.s(a)),(0,r.$Rc)(()=>{this.k.delete(a),this.j.delete($),this.c.$unregisterProvider($)})}$provideFileSearchResults(a,m,$,f){const i=u($),s=this.j.get(a);if(s)return this.l.fileSearch(i,s,t=>{this.c.$handleFileMatch(a,m,t.map(o=>o.resource))},f);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,m,$){return{messages:[]}}$clearCache(a){return this.l.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,m,$,f){const i=this.e.get(a);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${a}`);const s=u($);return this.t(s,i).search(o=>this.c.$handleTextMatch(a,m,o),f)}$provideAITextSearchResults(a,m,$,f){const i=this.h.get(a);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${a}`);const s=u($);return this.v(s,i).search(o=>this.c.$handleTextMatch(a,m,o),f)}$enableExtensionHostSearch(){}t(a,m){return new I.$nqc({query:a,provider:m},{readdir:$=>Promise.resolve([]),toCanonicalName:$=>$},"textSearchProvider")}v(a,m){return new I.$nqc({query:a,provider:m},{readdir:$=>Promise.resolve([]),toCanonicalName:$=>$},"aiTextSearchProvider")}};e.$sqc=S,e.$sqc=S=Ye([Ve(0,L.$cQ),Ve(1,T.$epc),Ve(2,b.$0j)],S);function u(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(P),extraFileResources:w.extraFileResources&&w.extraFileResources.map(a=>c.URI.revive(a))}}function P(w){return{...w,folder:c.URI.revive(w.folder)}}});var Wt=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Se[344],De([1,0,20,13,4,3,14,43,2,113,201,202,58,23,27,11,90,91,246,6,290,317,95,127,294,295,296,275,265,34,297,41,298,101,163,299,277,291,300,301,63,77,278,292,54,302,75,303,62,29,318,279,304,305,128,306,122,123,280,335,308,250,309,319,310,169,281,311,312,313,19,314,102,124,315,282,316,125,97,100,94,47,167,98,320,293,321,322,76,15,9,283,72,284,96,323,324,162,48,119,93,25,99]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l,g,E,D,y,k,A,p,v,F,N,O,j,z,M,W,V,ne,B,K,Y,ee,ue,re,ye,me,J,U,se,ae,te,ce,le,x,oe,pe,we,Fe,ze,Ce,Ie,Pe,q,H,X,Z,de,be,Oe,He,Qe,_e,nt,st,rt,at,mt,ht,ct,ke,Be,Ke,Ne,je,he,_,Re,Xe,tt,ut,gt,Dt,Nt,Ut,Zt,hi,et,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qc=Kt,h=Ue(h),T=Wt(T),S=Ue(S),w=Ue(w),he=Ue(he),_=Ue(_);function Kt(pt){const kt=pt.get(ye.$sQ),xt=pt.get(re.$2oc),_t=pt.get(ee.$mpc),qt=pt.get(K.$Xpc),wt=pt.get(Ut.$hpc),Rt=pt.get(at.$wQ),ci=pt.get(A.$kpc),Qt=pt.get(Xe.$epc),xe=pt.get(Z.$cQ),ei=pt.get(nt.$Fpc),li=pt.get(st.$npc),di=pt.get(a.$$j),It=pt.get(a.$0j),Mt=pt.get(je.$0Fb),Tt=pt.get(o.$Xoc),jt=pt.get(Nt.$6qc),si=pt.get(Oe.$Ppc),ti=pt.get(V.$wpc),ii=pt.get(le.$Tpc),Vt=pt.get(n.$8oc),Ht=pt.get(ae.$Mpc);xe.set(i.$EN.ExtHostFileSystemInfo,xt),xe.set(i.$EN.ExtHostLogLevelServiceShape,di),xe.set(i.$EN.ExtHostWorkspace,wt),xe.set(i.$EN.ExtHostConfiguration,ci),xe.set(i.$EN.ExtHostExtensionService,qt),xe.set(i.$EN.ExtHostStorage,ei),xe.set(i.$EN.ExtHostTunnelService,Mt),xe.set(i.$EN.ExtHostWindow,jt),xe.set(i.$EN.ExtHostSecretState,si),xe.set(i.$EN.ExtHostTelemetry,Rt),xe.set(i.$EN.ExtHostEditorTabs,ti),xe.set(i.$EN.ExtHostManagedSockets,ii),xe.set(i.$EN.ExtHostAuthentication,Vt),xe.set(i.$EN.ExtHostChatProvider,Ht);const ui=xe.set(i.$EN.ExtHostDecorations,pt.get(F.$bqc)),Lt=xe.set(i.$EN.ExtHostDocumentsAndEditors,pt.get(W.$nQ)),Pt=xe.set(i.$EN.ExtHostCommands,pt.get(y.$yQ)),bt=xe.set(i.$EN.ExtHostTerminalService,pt.get(mt.$Ipc)),Jt=xe.set(i.$EN.ExtHostTerminalShellIntegration,pt.get(ht.$Vqc)),Et=xe.set(i.$EN.ExtHostDebugService,pt.get(v.$8pc)),oi=xe.set(i.$EN.ExtHostSearch,pt.get(be.$rqc)),Yt=xe.set(i.$EN.ExtHostTask,pt.get(rt.$Uqc)),Ai=xe.set(i.$EN.ExtHostOutputService,pt.get(Ie.$Hqc)),pi=xe.set(i.$EN.ExtHostLocalization,pt.get(ce.$Spc)),Si=xe.set(i.$EN.ExtHostUrls,new tt.$3qc(xe)),Bt=xe.set(i.$EN.ExtHostDocuments,new M.$5oc(xe,Lt)),fi=xe.set(i.$EN.ExtHostDocumentContentProviders,new j.$dqc(xe,Lt,It)),Oi=xe.set(i.$EN.ExtHostDocumentSaveParticipant,new z.$eqc(It,Bt,xe.getProxy(i.$DN.MainThreadBulkEdits))),Ct=xe.set(i.$EN.ExtHostNotebook,new oe.$uqc(xe,Pt,Lt,Bt,_t,oi,It)),Di=xe.set(i.$EN.ExtHostNotebookDocuments,new we.$Bqc(Ct)),Ri=xe.set(i.$EN.ExtHostNotebookEditors,new Fe.$Cqc(It,Ct)),bi=xe.set(i.$EN.ExtHostNotebookKernels,new ze.$Dqc(xe,kt,Ct,Pt,It)),Ti=xe.set(i.$EN.ExtHostNotebookRenderers,new Ce.$Fqc(xe,Ct)),Ni=xe.set(i.$EN.ExtHostNotebookDocumentSaveParticipant,new pe.$Aqc(It,Ct,xe.getProxy(i.$DN.MainThreadBulkEdits))),Ft=xe.set(i.$EN.ExtHostEditors,new ke.$bpc(xe,Lt)),Te=xe.set(i.$EN.ExtHostTreeViews,new Ne.$1qc(xe.getProxy(i.$DN.MainThreadTreeViews),Pt,It)),Me=xe.set(i.$EN.ExtHostEditorInsets,new D.$cpc(xe.getProxy(i.$DN.MainThreadEditorInsets),Ft,kt.remote)),ve=xe.set(i.$EN.ExtHostDiagnostics,new N.$4oc(xe,It,xt,Lt)),ie=xe.set(i.$EN.ExtHostLanguages,new te.$yqc(xe,Bt,Pt.converter,Qt)),Ae=xe.set(i.$EN.ExtHostLanguageFeatures,new U.$6oc(xe,Qt,Bt,Pt,ve,It,Tt,Rt)),Ge=xe.set(i.$EN.ExtHostFileSystem,new Y.$hqc(xe,Ae)),it=xe.set(i.$EN.ExtHostFileSystemEventService,new ue.$iqc(xe,It,Lt)),Je=xe.set(i.$EN.ExtHostQuickOpen,(0,X.$Lqc)(xe,wt,Pt)),ft=xe.set(i.$EN.ExtHostSCM,new de.$Nqc(xe,Pt,Bt,It)),At=xe.set(i.$EN.ExtHostQuickDiff,new H.$Kqc(xe,Qt)),ni=xe.set(i.$EN.ExtHostShare,new He.$Oqc(xe,Qt)),ai=xe.set(i.$EN.ExtHostComments,(0,k.$dpc)(xe,Pt,Bt)),zt=xe.set(i.$EN.ExtHostProgress,new q.$Jqc(xe.getProxy(i.$DN.MainThreadProgress))),ri=xe.set(i.$EN.ExtHostLabelService,new J.$wqc(xe)),Fi=xe.set(i.$EN.ExtHostTheming,new Be.$Xqc(xe)),_i=xe.set(i.$EN.ExtHostTimeline,new Ke.$Zqc(xe,Pt)),Mi=xe.set(i.$EN.ExtHostWebviews,new ut.$rpc(xe,kt.remote,wt,It,Tt)),Ui=xe.set(i.$EN.ExtHostWebviewPanels,new gt.$upc(xe,Mi,wt)),en=xe.set(i.$EN.ExtHostCustomEditors,new p.$vpc(xe,Bt,li,Mi,Ui)),qi=xe.set(i.$EN.ExtHostWebviewViews,new Dt.$4qc(xe,Mi)),vi=xe.set(i.$EN.ExtHostTesting,pt.get(ct.$3pc)),tn=xe.set(i.$EN.ExtHostUriOpeners,new Re.$2qc(xe)),nn=xe.set(i.$EN.ExtHostProfileContentHandlers,new Pe.$Iqc(xe));xe.set(i.$EN.ExtHostInteractive,new me.$vqc(xe,Ct,Lt,Pt,It));const ji=xe.set(i.$EN.ExtHostChatAgents2,new l.$$oc(xe,It,Pt,Bt)),rn=xe.set(i.$EN.ExtHostChatVariables,new g.$_oc(xe)),Bi=xe.set(i.$EN.ExtHostLanguageModelTools,new se.$xqc(xe)),Vi=xe.set(i.$EN.ExtHostAiRelatedInformation,new s.$Woc(xe)),sn=xe.set(i.$EN.ExtHostAiEmbeddingVector,new B.$gqc(xe)),on=xe.set(i.$EN.ExtHostStatusBar,new _e.$Rqc(xe,Pt.converter)),bn=xe.set(i.$EN.ExtHostSpeech,new Qe.$Pqc(xe)),ki=xe.set(i.$EN.ExtHostEmbeddings,new ne.$fqc(xe)),Hi=Object.values(i.$EN);xe.assertRegistered(Hi);const wn=new d.$0oc(xe,Lt),vn=new E.$apc(xe),zi=new x.$zqc(xe,It),an=new O.$cqc(xe);return t.$7oc.register(Pt),function(qe,gi,Gi){function lt(fe){return(Ee,We,dt)=>{const St=fe(Ot=>{try{Ee.call(We,Ot)}catch(Pi){h.$Z(new Error(`[ExtensionListenerError] Extension '${qe.identifier.value}' FAILED to handle event: ${Pi.toString()}`,{cause:Pi})),Rt.onExtensionError(qe.identifier,Pi)}});return dt?.push(St),St}}const yt=function(){let fe=!qe.isUnderDevelopment;function Ee(){fe||(It.info(`Extension '${qe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function We(dt){if(Array.isArray(dt))dt.forEach(We);else if(typeof dt=="string")Ee();else{const St=dt;typeof St.scheme>"u"&&Ee(),typeof St.exclusive=="boolean"&&(0,et.$dH)(qe,"documentFiltersExclusive")}return dt}}(),En={getSession(fe,Ee,We){return typeof We?.forceNewSession=="object"&&We.forceNewSession.learnMore&&(0,et.$dH)(qe,"authLearnMore"),We?.account&&(0,et.$dH)(qe,"authGetSessions"),Vt.getSession(qe,fe,Ee,We)},getAccounts(fe){return(0,et.$dH)(qe,"authGetSessions"),Vt.getAccounts(fe)},async hasSession(fe,Ee){return(0,et.$dH)(qe,"authSession"),!!await Vt.getSession(qe,fe,Ee,{silent:!0})},get onDidChangeSessions(){return lt(Vt.onDidChangeSessions)},registerAuthenticationProvider(fe,Ee,We,dt){return Vt.registerAuthenticationProvider(fe,Ee,We,dt)}},Ki={registerCommand(fe,Ee,We){return Pt.registerCommand(!0,fe,Ee,We,void 0,qe)},registerTextEditorCommand(fe,Ee,We){return Pt.registerCommand(!0,fe,(...dt)=>{const St=Ft.getActiveTextEditor();if(!St){It.warn("Cannot execute "+fe+" because there is no active text editor.");return}return St.edit(Ot=>{Ee.apply(We,[St,Ot,...dt])}).then(Ot=>{Ot||It.warn("Edits from command "+fe+" were not applied.")},Ot=>{It.warn("An error occurred while running command "+fe,Ot)})},void 0,void 0,qe)},registerDiffInformationCommand:(fe,Ee,We)=>((0,et.$dH)(qe,"diffCommand"),Pt.registerCommand(!0,fe,async(...dt)=>{const St=Lt.activeEditor(!0);if(!St){It.warn("Cannot execute "+fe+" because there is no active text editor.");return}const Ot=await Ft.getDiffInformation(St.id);Ee.apply(We,[Ot,...dt])},void 0,void 0,qe)),executeCommand(fe,...Ee){return Pt.executeCommand(fe,...Ee)},getCommands(fe=!1){return Pt.getCommands(fe)}},Qi={get machineId(){return kt.telemetryInfo.machineId},get sessionId(){return kt.telemetryInfo.sessionId},get language(){return kt.environment.appLanguage},get appName(){return kt.environment.appName},get appRoot(){return kt.environment.appRoot?.fsPath??""},get appHost(){return kt.environment.appHost},get uriScheme(){return kt.environment.appUriScheme},get clipboard(){return vn.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return lt(bt.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return lt(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$dH)(qe,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$dH)(qe,"telemetry"),lt(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,at.$vQ)(kt.telemetryInfo.firstSessionDate)},createTelemetryLogger(fe,Ee){return at.$uQ.validateSender(fe),Rt.instantiateLogger(qe,fe,Ee)},openExternal(fe,Ee){return jt.openUri(fe,{allowTunneling:!!kt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===kt.environment.appUriScheme)return Si.createAppUri(fe);try{return await jt.asExternalUri(fe,{allowTunneling:!!kt.remote.authority})}catch(Ee){if((0,L.$Lg)(fe,L.Schemas.http)||(0,L.$Lg)(fe,L.Schemas.https))return fe;throw Ee}},get remoteName(){return(0,m.$fn)(kt.remote.authority)},get remoteAuthority(){return(0,et.$dH)(qe,"resolvers"),kt.remote.authority},get uiKind(){return kt.uiKind},get logLevel(){return It.getLevel()},get onDidChangeLogLevel(){return lt(It.onDidChangeLogLevel)},get appQuality(){return(0,et.$dH)(qe,"resolvers"),kt.quality},get appCommit(){return(0,et.$dH)(qe,"resolvers"),kt.commit}};kt.environment.extensionTestsLocationURI||Object.freeze(Qi);const Ei={createTestController(fe,Ee,We){return vi.createTestController(qe,fe,Ee,We)},createTestObserver(){return(0,et.$dH)(qe,"testObserver"),vi.createTestObserver()},runTests(fe){return(0,et.$dH)(qe,"testObserver"),vi.runTests(fe)},registerTestFollowupProvider(fe){return(0,et.$dH)(qe,"testObserver"),vi.registerTestFollowupProvider(fe)},get onDidChangeTestResults(){return(0,et.$dH)(qe,"testObserver"),lt(vi.onResultsChanged)},get testResults(){return(0,et.$dH)(qe,"testObserver"),vi.results}},Ii=kt.remote.isRemote?_.ExtensionKind.Workspace:_.ExtensionKind.UI,yn={getExtension(fe,Ee){(0,et.$cH)(qe,"extensionsAny")||(Ee=!1);const We=gi.mine.getExtensionDescription(fe);if(We)return new K.$Ypc(qt,qe.identifier,We,Ii,!1);if(Ee){const dt=gi.all.getExtensionDescription(fe);if(dt)return new K.$Ypc(qt,qe.identifier,dt,Ii,!0)}},get all(){const fe=[];for(const Ee of gi.mine.getAllExtensionDescriptions())fe.push(new K.$Ypc(qt,qe.identifier,Ee,Ii,!1));return fe},get allAcrossExtensionHosts(){(0,et.$dH)(qe,"extensionsAny");const fe=new P.$pn(gi.mine.getAllExtensionDescriptions().map(We=>We.identifier)),Ee=[];for(const We of gi.all.getAllExtensionDescriptions()){const dt=!fe.has(We.identifier);Ee.push(new K.$Ypc(qt,qe.identifier,We,Ii,dt))}return Ee},get onDidChange(){return(0,et.$cH)(qe,"extensionsAny")?lt(C.Event.any(gi.mine.onDidChange,gi.all.onDidChange)):lt(gi.mine.onDidChange)}},mi={createDiagnosticCollection(fe){return ve.createDiagnosticCollection(qe.identifier,fe)},get onDidChangeDiagnostics(){return lt(ve.onDidChangeDiagnostics)},getDiagnostics:fe=>ve.getDiagnostics(fe),getLanguages(){return ie.getLanguages()},setTextDocumentLanguage(fe,Ee){return ie.changeLanguage(fe.uri,Ee)},match(fe,Ee){const We=he.LanguageSelector.from(fe);let dt;return(0,I.$uu)(We)&&(dt=Ct.notebookDocuments.find(St=>St.apiNotebook.getCells().find(Ot=>Ot.document===Ee))?.apiNotebook),(0,I.$tu)(We,Ee.uri,Ee.languageId,!0,dt?.uri,dt?.notebookType)},registerCodeActionsProvider(fe,Ee,We){return Ae.registerCodeActionProvider(qe,yt(fe),Ee,We)},registerDocumentPasteEditProvider(fe,Ee,We){return(0,et.$dH)(qe,"documentPaste"),Ae.registerDocumentPasteEditProvider(qe,yt(fe),Ee,We)},registerCodeLensProvider(fe,Ee){return Ae.registerCodeLensProvider(qe,yt(fe),Ee)},registerDefinitionProvider(fe,Ee){return Ae.registerDefinitionProvider(qe,yt(fe),Ee)},registerDeclarationProvider(fe,Ee){return Ae.registerDeclarationProvider(qe,yt(fe),Ee)},registerImplementationProvider(fe,Ee){return Ae.registerImplementationProvider(qe,yt(fe),Ee)},registerTypeDefinitionProvider(fe,Ee){return Ae.registerTypeDefinitionProvider(qe,yt(fe),Ee)},registerHoverProvider(fe,Ee){return Ae.registerHoverProvider(qe,yt(fe),Ee,qe.identifier)},registerEvaluatableExpressionProvider(fe,Ee){return Ae.registerEvaluatableExpressionProvider(qe,yt(fe),Ee,qe.identifier)},registerInlineValuesProvider(fe,Ee){return Ae.registerInlineValuesProvider(qe,yt(fe),Ee,qe.identifier)},registerDocumentHighlightProvider(fe,Ee){return Ae.registerDocumentHighlightProvider(qe,yt(fe),Ee)},registerMultiDocumentHighlightProvider(fe,Ee){return Ae.registerMultiDocumentHighlightProvider(qe,yt(fe),Ee)},registerLinkedEditingRangeProvider(fe,Ee){return Ae.registerLinkedEditingRangeProvider(qe,yt(fe),Ee)},registerReferenceProvider(fe,Ee){return Ae.registerReferenceProvider(qe,yt(fe),Ee)},registerRenameProvider(fe,Ee){return Ae.registerRenameProvider(qe,yt(fe),Ee)},registerNewSymbolNamesProvider(fe,Ee){return(0,et.$dH)(qe,"newSymbolNamesProvider"),Ae.registerNewSymbolNamesProvider(qe,yt(fe),Ee)},registerDocumentSymbolProvider(fe,Ee,We){return Ae.registerDocumentSymbolProvider(qe,yt(fe),Ee,We)},registerWorkspaceSymbolProvider(fe){return Ae.registerWorkspaceSymbolProvider(qe,fe)},registerDocumentFormattingEditProvider(fe,Ee){return Ae.registerDocumentFormattingEditProvider(qe,yt(fe),Ee)},registerDocumentRangeFormattingEditProvider(fe,Ee){return Ae.registerDocumentRangeFormattingEditProvider(qe,yt(fe),Ee)},registerOnTypeFormattingEditProvider(fe,Ee,We,...dt){return Ae.registerOnTypeFormattingEditProvider(qe,yt(fe),Ee,[We].concat(dt))},registerDocumentSemanticTokensProvider(fe,Ee,We){return Ae.registerDocumentSemanticTokensProvider(qe,yt(fe),Ee,We)},registerDocumentRangeSemanticTokensProvider(fe,Ee,We){return Ae.registerDocumentRangeSemanticTokensProvider(qe,yt(fe),Ee,We)},registerSignatureHelpProvider(fe,Ee,We,...dt){return typeof We=="object"?Ae.registerSignatureHelpProvider(qe,yt(fe),Ee,We):Ae.registerSignatureHelpProvider(qe,yt(fe),Ee,typeof We>"u"?[]:[We,...dt])},registerCompletionItemProvider(fe,Ee,...We){return Ae.registerCompletionItemProvider(qe,yt(fe),Ee,We)},registerInlineCompletionItemProvider(fe,Ee,We){return Ee.handleDidShowCompletionItem&&(0,et.$dH)(qe,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,et.$dH)(qe,"inlineCompletionsAdditions"),We&&(0,et.$dH)(qe,"inlineCompletionsAdditions"),Ae.registerInlineCompletionsProvider(qe,yt(fe),Ee,We)},registerInlineEditProvider(fe,Ee){return(0,et.$dH)(qe,"inlineEdit"),Ae.registerInlineEditProvider(qe,yt(fe),Ee)},registerDocumentLinkProvider(fe,Ee){return Ae.registerDocumentLinkProvider(qe,yt(fe),Ee)},registerColorProvider(fe,Ee){return Ae.registerColorProvider(qe,yt(fe),Ee)},registerFoldingRangeProvider(fe,Ee){return Ae.registerFoldingRangeProvider(qe,yt(fe),Ee)},registerSelectionRangeProvider(fe,Ee){return Ae.registerSelectionRangeProvider(qe,fe,Ee)},registerCallHierarchyProvider(fe,Ee){return Ae.registerCallHierarchyProvider(qe,fe,Ee)},registerTypeHierarchyProvider(fe,Ee){return Ae.registerTypeHierarchyProvider(qe,fe,Ee)},setLanguageConfiguration:(fe,Ee)=>Ae.setLanguageConfiguration(qe,fe,Ee),getTokenInformationAtPosition(fe,Ee){return(0,et.$dH)(qe,"tokenInformation"),ie.tokenAtPosition(fe,Ee)},registerInlayHintsProvider(fe,Ee){return Ae.registerInlayHintsProvider(qe,fe,Ee)},createLanguageStatusItem(fe,Ee){return ie.createLanguageStatusItem(qe,fe,Ee)},registerDocumentDropEditProvider(fe,Ee,We){return Ae.registerDocumentOnDropEditProvider(qe,fe,Ee,(0,et.$cH)(qe,"documentPaste")?We:void 0)}},Wi={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(fe,Ee,We){b.URI.isUri(fe)&&fe.scheme===L.Schemas.vscodeRemote&&!fe.authority&&Tt.report("workspace.showTextDocument",qe,"A URI of 'vscode-remote' scheme requires an authority.");const dt=await(b.URI.isUri(fe)?Promise.resolve(Ji.openTextDocument(fe)):Promise.resolve(fe));return Ft.showTextDocument(dt,Ee,We)},createTextEditorDecorationType(fe){return Ft.createTextEditorDecorationType(qe,fe)},onDidChangeActiveTextEditor(fe,Ee,We){return lt(Ft.onDidChangeActiveTextEditor)(fe,Ee,We)},onDidChangeVisibleTextEditors(fe,Ee,We){return lt(Ft.onDidChangeVisibleTextEditors)(fe,Ee,We)},onDidChangeTextEditorSelection(fe,Ee,We){return lt(Ft.onDidChangeTextEditorSelection)(fe,Ee,We)},onDidChangeTextEditorOptions(fe,Ee,We){return lt(Ft.onDidChangeTextEditorOptions)(fe,Ee,We)},onDidChangeTextEditorVisibleRanges(fe,Ee,We){return lt(Ft.onDidChangeTextEditorVisibleRanges)(fe,Ee,We)},onDidChangeTextEditorViewColumn(fe,Ee,We){return lt(Ft.onDidChangeTextEditorViewColumn)(fe,Ee,We)},onDidCloseTerminal(fe,Ee,We){return lt(bt.onDidCloseTerminal)(fe,Ee,We)},onDidOpenTerminal(fe,Ee,We){return lt(bt.onDidOpenTerminal)(fe,Ee,We)},onDidChangeActiveTerminal(fe,Ee,We){return lt(bt.onDidChangeActiveTerminal)(fe,Ee,We)},onDidChangeTerminalDimensions(fe,Ee,We){return(0,et.$dH)(qe,"terminalDimensions"),lt(bt.onDidChangeTerminalDimensions)(fe,Ee,We)},onDidChangeTerminalState(fe,Ee,We){return lt(bt.onDidChangeTerminalState)(fe,Ee,We)},onDidWriteTerminalData(fe,Ee,We){return(0,et.$dH)(qe,"terminalDataWriteEvent"),lt(bt.onDidWriteTerminalData)(fe,Ee,We)},onDidExecuteTerminalCommand(fe,Ee,We){return(0,et.$dH)(qe,"terminalExecuteCommandEvent"),lt(bt.onDidExecuteTerminalCommand)(fe,Ee,We)},onDidChangeTerminalShellIntegration(fe,Ee,We){return(0,et.$dH)(qe,"terminalShellIntegration"),lt(Jt.onDidChangeTerminalShellIntegration)(fe,Ee,We)},onDidStartTerminalShellExecution(fe,Ee,We){return(0,et.$dH)(qe,"terminalShellIntegration"),lt(Jt.onDidStartTerminalShellExecution)(fe,Ee,We)},onDidEndTerminalShellExecution(fe,Ee,We){return(0,et.$dH)(qe,"terminalShellIntegration"),lt(Jt.onDidEndTerminalShellExecution)(fe,Ee,We)},get state(){return jt.getState()},onDidChangeWindowState(fe,Ee,We){return lt(jt.onDidChangeWindowState)(fe,Ee,We)},showInformationMessage(fe,...Ee){return zi.showMessage(qe,T.default.Info,fe,Ee[0],Ee.slice(1))},showWarningMessage(fe,...Ee){return zi.showMessage(qe,T.default.Warning,fe,Ee[0],Ee.slice(1))},showErrorMessage(fe,...Ee){return zi.showMessage(qe,T.default.Error,fe,Ee[0],Ee.slice(1))},showQuickPick(fe,Ee,We){return Je.showQuickPick(qe,fe,Ee,We)},showWorkspaceFolderPick(fe){return Je.showWorkspaceFolderPick(fe)},showInputBox(fe,Ee){return Je.showInput(fe,Ee)},showOpenDialog(fe){return an.showOpenDialog(qe,fe)},showSaveDialog(fe){return an.showSaveDialog(fe)},createStatusBarItem(fe,Ee,We){let dt,St,Ot;return typeof fe=="string"?(dt=fe,St=Ee,Ot=We):(St=fe,Ot=Ee),on.createStatusBarEntry(qe,dt,St,Ot)},setStatusBarMessage(fe,Ee){return on.setStatusBarMessage(fe,Ee)},withScmProgress(fe){return Tt.report("window.withScmProgress",qe,"Use 'withProgress' instead."),zt.withProgress(qe,{location:_.ProgressLocation.SourceControl},(Ee,We)=>fe({report(dt){}}))},withProgress(fe,Ee){return zt.withProgress(qe,fe,Ee)},createOutputChannel(fe,Ee){return Ai.createOutputChannel(fe,Ee,qe)},createWebviewPanel(fe,Ee,We,dt){return Ui.createWebviewPanel(qe,fe,Ee,We,dt)},createWebviewTextEditorInset(fe,Ee,We,dt){return(0,et.$dH)(qe,"editorInsets"),Me.createWebviewEditorInset(fe,Ee,We,dt,qe)},createTerminal(fe,Ee,We){return typeof fe=="object"?"pty"in fe?bt.createExtensionTerminal(fe):bt.createTerminalFromOptions(fe):bt.createTerminal(fe,Ee,We)},registerTerminalLinkProvider(fe){return bt.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,Ee){return bt.registerProfileProvider(qe,fe,Ee)},registerTerminalQuickFixProvider(fe,Ee){return(0,et.$dH)(qe,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(fe,qe.identifier.value,Ee)},registerTreeDataProvider(fe,Ee){return Te.registerTreeDataProvider(fe,Ee,qe)},createTreeView(fe,Ee){return Te.createTreeView(fe,Ee,qe)},registerWebviewPanelSerializer:(fe,Ee)=>Ui.registerWebviewPanelSerializer(qe,fe,Ee),registerCustomEditorProvider:(fe,Ee,We={})=>en.registerCustomEditorProvider(qe,fe,Ee,We),registerFileDecorationProvider(fe){return ui.registerFileDecorationProvider(fe,qe)},registerUriHandler(fe){return Si.registerUriHandler(qe,fe)},createQuickPick(){return Je.createQuickPick(qe)},createInputBox(){return Je.createInputBox(qe)},get activeColorTheme(){return Fi.activeColorTheme},onDidChangeActiveColorTheme(fe,Ee,We){return lt(Fi.onDidChangeActiveColorTheme)(fe,Ee,We)},registerWebviewViewProvider(fe,Ee,We){return qi.registerWebviewViewProvider(qe,fe,Ee,We?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,Ee,We){return lt(Ct.onDidChangeActiveNotebookEditor)(fe,Ee,We)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return lt(Ct.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(fe,Ee,We){return lt(Ri.onDidChangeNotebookEditorSelection)(fe,Ee,We)},onDidChangeNotebookEditorVisibleRanges(fe,Ee,We){return lt(Ri.onDidChangeNotebookEditorVisibleRanges)(fe,Ee,We)},showNotebookDocument(fe,Ee){return Ct.showNotebookDocument(fe,Ee)},registerExternalUriOpener(fe,Ee,We){return(0,et.$dH)(qe,"externalUriOpener"),tn.registerExternalUriOpener(qe.identifier,fe,Ee,We)},registerProfileContentHandler(fe,Ee){return(0,et.$dH)(qe,"profileContentHandlers"),nn.registerProfileContentHandler(qe,fe,Ee)},registerQuickDiffProvider(fe,Ee,We,dt){return(0,et.$dH)(qe,"quickDiffProvider"),At.registerQuickDiffProvider(yt(fe),Ee,We,dt)},get tabGroups(){return ti.tabGroups},registerShareProvider(fe,Ee){return(0,et.$dH)(qe,"shareProvider"),ni.registerShareProvider(yt(fe),Ee)}},Ji={get rootPath(){return Tt.report("workspace.rootPath",qe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(fe){throw new h.$8("rootPath")},getWorkspaceFolder(fe){return wt.getWorkspaceFolder(fe)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(fe){throw new h.$8("name")},get workspaceFile(){return wt.workspaceFile},set workspaceFile(fe){throw new h.$8("workspaceFile")},updateWorkspaceFolders:(fe,Ee,...We)=>wt.updateWorkspaceFolders(qe,fe,Ee||0,...We),onDidChangeWorkspaceFolders:function(fe,Ee,We){return lt(wt.onDidChangeWorkspace)(fe,Ee,We)},asRelativePath:(fe,Ee)=>wt.getRelativePath(fe,Ee),findFiles:(fe,Ee,We,dt)=>wt.findFiles(fe,Ee,We,qe.identifier,dt),findFiles2:(fe,Ee,We)=>((0,et.$dH)(qe,"findFiles2"),wt.findFiles2(fe,Ee,qe.identifier,We)),findTextInFiles:(fe,Ee,We,dt)=>{(0,et.$dH)(qe,"findTextInFiles");let St,Ot;return typeof Ee=="object"?(St=Ee,Ot=We):(St={},Ot=Ee,dt=We),wt.findTextInFiles(fe,St||{},Ot,qe.identifier,dt)},save:fe=>wt.save(fe),saveAs:fe=>wt.saveAs(fe),saveAll:fe=>wt.saveAll(fe),applyEdit(fe,Ee){return wn.applyWorkspaceEdit(fe,qe,Ee)},createFileSystemWatcher:(fe,Ee,We,dt)=>{let St;return typeof Ee=="boolean"?St={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!We,ignoreDeleteEvents:!!dt,correlate:!1}:Ee&&((0,et.$dH)(qe,"createFileSystemWatcher"),St={...Ee,correlate:!0}),it.createFileSystemWatcher(wt,qe,fe,St)},get textDocuments(){return Bt.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw new h.$8("textDocuments")},openTextDocument(fe){let Ee;const We=fe;if(typeof fe=="string")Ee=Promise.resolve(b.URI.file(fe));else if(b.URI.isUri(fe))Ee=Promise.resolve(fe);else if(!We||typeof We=="object")Ee=Bt.createDocumentData(We);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(dt=>(dt.scheme===L.Schemas.vscodeRemote&&!dt.authority&&Tt.report("workspace.openTextDocument",qe,"A URI of 'vscode-remote' scheme requires an authority."),Bt.ensureDocumentData(dt).then(St=>St.document)))},onDidOpenTextDocument:(fe,Ee,We)=>lt(Bt.onDidAddDocument)(fe,Ee,We),onDidCloseTextDocument:(fe,Ee,We)=>lt(Bt.onDidRemoveDocument)(fe,Ee,We),onDidChangeTextDocument:(fe,Ee,We)=>lt(Bt.onDidChangeDocument)(fe,Ee,We),onDidSaveTextDocument:(fe,Ee,We)=>lt(Bt.onDidSaveDocument)(fe,Ee,We),onWillSaveTextDocument:(fe,Ee,We)=>lt(Oi.getOnWillSaveTextDocumentEvent(qe))(fe,Ee,We),get notebookDocuments(){return Ct.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,Ee){let We;if(b.URI.isUri(fe))We=fe,await Ct.openNotebookDocument(fe);else if(typeof fe=="string")We=b.URI.revive(await Ct.createNotebookDocument({viewType:fe,content:Ee}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(We).apiNotebook},onDidSaveNotebookDocument(fe,Ee,We){return lt(Di.onDidSaveNotebookDocument)(fe,Ee,We)},onDidChangeNotebookDocument(fe,Ee,We){return lt(Di.onDidChangeNotebookDocument)(fe,Ee,We)},onWillSaveNotebookDocument(fe,Ee,We){return lt(Ni.getOnWillSaveNotebookDocumentEvent(qe))(fe,Ee,We)},get onDidOpenNotebookDocument(){return lt(Ct.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return lt(Ct.onDidCloseNotebookDocument)},registerNotebookSerializer(fe,Ee,We,dt){return Ct.registerNotebookSerializer(qe,fe,Ee,We,(0,et.$cH)(qe,"notebookLiveShare")?dt:void 0)},onDidChangeConfiguration:(fe,Ee,We)=>lt(Gi.onDidChangeConfiguration)(fe,Ee,We),getConfiguration(fe,Ee){return Ee=arguments.length===1?void 0:Ee,Gi.getConfiguration(fe,Ee,qe)},registerTextDocumentContentProvider(fe,Ee){return fi.registerTextDocumentContentProvider(fe,Ee)},registerTaskProvider:(fe,Ee)=>(Tt.report("window.registerTaskProvider",qe,"Use the corresponding function on the 'tasks' namespace instead"),Yt.registerTaskProvider(qe,fe,Ee)),registerFileSystemProvider(fe,Ee,We){return(0,R.$Qc)(Ge.registerFileSystemProvider(qe,fe,Ee,We),_t.addFileSystemProvider(fe,Ee,We))},get fs(){return _t.value},registerFileSearchProvider:(fe,Ee)=>((0,et.$dH)(qe,"fileSearchProvider"),oi.registerFileSearchProvider(fe,Ee)),registerTextSearchProvider:(fe,Ee)=>((0,et.$dH)(qe,"textSearchProvider"),oi.registerTextSearchProvider(fe,Ee)),registerAITextSearchProvider:(fe,Ee)=>((0,et.$dH)(qe,"aiTextSearchProvider"),(0,et.$dH)(qe,"textSearchProvider"),oi.registerAITextSearchProvider(fe,Ee)),registerRemoteAuthorityResolver:(fe,Ee)=>((0,et.$dH)(qe,"resolvers"),qt.registerRemoteAuthorityResolver(fe,Ee)),registerResourceLabelFormatter:fe=>((0,et.$dH)(qe,"resolvers"),ri.$registerResourceLabelFormatter(fe)),getRemoteExecServer:fe=>((0,et.$dH)(qe,"resolvers"),qt.getRemoteExecServer(fe)),onDidCreateFiles:(fe,Ee,We)=>lt(it.onDidCreateFile)(fe,Ee,We),onDidDeleteFiles:(fe,Ee,We)=>lt(it.onDidDeleteFile)(fe,Ee,We),onDidRenameFiles:(fe,Ee,We)=>lt(it.onDidRenameFile)(fe,Ee,We),onWillCreateFiles:(fe,Ee,We)=>lt(it.getOnWillCreateFileEvent(qe))(fe,Ee,We),onWillDeleteFiles:(fe,Ee,We)=>lt(it.getOnWillDeleteFileEvent(qe))(fe,Ee,We),onWillRenameFiles:(fe,Ee,We)=>lt(it.getOnWillRenameFileEvent(qe))(fe,Ee,We),openTunnel:fe=>((0,et.$dH)(qe,"tunnels"),Mt.openTunnel(qe,fe).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,et.$dH)(qe,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(fe,Ee,We)=>((0,et.$dH)(qe,"tunnels"),lt(Mt.onDidChangeTunnels)(fe,Ee,We)),registerPortAttributesProvider:(fe,Ee)=>((0,et.$dH)(qe,"portsAttributes"),Mt.registerPortsAttributesProvider(fe,Ee)),registerTunnelProvider:(fe,Ee)=>((0,et.$dH)(qe,"tunnelFactory"),Mt.registerTunnelProvider(fe,Ee)),registerTimelineProvider:(fe,Ee)=>((0,et.$dH)(qe,"timeline"),_i.registerTimelineProvider(fe,Ee,qe.identifier,Pt.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:fe=>((0,et.$dH)(qe,"workspaceTrust"),wt.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,Ee,We)=>lt(wt.onDidGrantWorkspaceTrust)(fe,Ee,We),registerEditSessionIdentityProvider:(fe,Ee)=>((0,et.$dH)(qe,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(fe,Ee)),onWillCreateEditSessionIdentity:(fe,Ee,We)=>((0,et.$dH)(qe,"editSessionIdentityProvider"),lt(wt.getOnWillCreateEditSessionIdentityEvent(qe))(fe,Ee,We)),registerCanonicalUriProvider:(fe,Ee)=>((0,et.$dH)(qe,"canonicalUriProvider"),wt.registerCanonicalUriProvider(fe,Ee)),getCanonicalUri:(fe,Ee,We)=>((0,et.$dH)(qe,"canonicalUriProvider"),wt.provideCanonicalUri(fe,Ee,We))},cn={get inputBox(){return Tt.report("scm.inputBox",qe,"Use 'SourceControl.inputBox' instead"),ft.getLastInputBox(qe)},createSourceControl(fe,Ee,We){return ft.createSourceControl(qe,fe,Ee,We)}},ln={createCommentController(fe,Ee){return ai.createCommentController(qe,fe,Ee)}},un={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get activeStackItem(){return Et.activeStackItem},registerDebugVisualizationProvider(fe,Ee){return(0,et.$dH)(qe,"debugVisualization"),Et.registerDebugVisualizationProvider(qe,fe,Ee)},registerDebugVisualizationTreeProvider(fe,Ee){return(0,et.$dH)(qe,"debugVisualization"),Et.registerDebugVisualizationTree(qe,fe,Ee)},onDidStartDebugSession(fe,Ee,We){return lt(Et.onDidStartDebugSession)(fe,Ee,We)},onDidTerminateDebugSession(fe,Ee,We){return lt(Et.onDidTerminateDebugSession)(fe,Ee,We)},onDidChangeActiveDebugSession(fe,Ee,We){return lt(Et.onDidChangeActiveDebugSession)(fe,Ee,We)},onDidReceiveDebugSessionCustomEvent(fe,Ee,We){return lt(Et.onDidReceiveDebugSessionCustomEvent)(fe,Ee,We)},onDidChangeBreakpoints(fe,Ee,We){return lt(Et.onDidChangeBreakpoints)(fe,Ee,We)},onDidChangeActiveStackItem(fe,Ee,We){return lt(Et.onDidChangeActiveStackItem)(fe,Ee,We)},registerDebugConfigurationProvider(fe,Ee,We){return Et.registerDebugConfigurationProvider(fe,Ee,We||Zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,Ee){return Et.registerDebugAdapterDescriptorFactory(qe,fe,Ee)},registerDebugAdapterTrackerFactory(fe,Ee){return Et.registerDebugAdapterTrackerFactory(fe,Ee)},startDebugging(fe,Ee,We){return!We||typeof We=="object"&&"configuration"in We?Et.startDebugging(fe,Ee,{parentSession:We}):Et.startDebugging(fe,Ee,We||{})},stopDebugging(fe){return Et.stopDebugging(fe)},addBreakpoints(fe){return Et.addBreakpoints(fe)},removeBreakpoints(fe){return Et.removeBreakpoints(fe)},asDebugSourceUri(fe,Ee){return Et.asDebugSourceUri(fe,Ee)}},Sn={registerTaskProvider:(fe,Ee)=>Yt.registerTaskProvider(qe,fe,Ee),fetchTasks:fe=>Yt.fetchTasks(fe),executeTask:fe=>Yt.executeTask(qe,fe),get taskExecutions(){return Yt.taskExecutions},onDidStartTask:(fe,Ee,We)=>lt(Yt.onDidStartTask)(fe,Ee,We),onDidEndTask:(fe,Ee,We)=>lt(Yt.onDidEndTask)(fe,Ee,We),onDidStartTaskProcess:(fe,Ee,We)=>lt(Yt.onDidStartTaskProcess)(fe,Ee,We),onDidEndTaskProcess:(fe,Ee,We)=>lt(Yt.onDidEndTaskProcess)(fe,Ee,We)},hn={createNotebookController(fe,Ee,We,dt,St){return bi.createNotebookController(qe,fe,Ee,We,dt,(0,et.$cH)(qe,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(fe,Ee)=>Ct.registerNotebookCellStatusBarItemProvider(qe,fe,Ee),createRendererMessaging(fe){return Ti.createRendererMessaging(qe,fe)},createNotebookControllerDetectionTask(fe){return(0,et.$dH)(qe,"notebookKernelSource"),bi.createNotebookControllerDetectionTask(qe,fe)},registerKernelSourceActionProvider(fe,Ee){return(0,et.$dH)(qe,"notebookKernelSource"),bi.registerKernelSourceActionProvider(qe,fe,Ee)},onDidChangeNotebookCellExecutionState(fe,Ee,We){return(0,et.$dH)(qe,"notebookCellExecutionState"),lt(bi.onDidChangeNotebookCellExecutionState)(fe,Ee,We)}},dn={t(...fe){if(typeof fe[0]=="string"){const Ee=fe.shift(),We=!fe||typeof fe[0]!="object"?fe:fe[0];return pi.getMessage(qe.identifier.value,{message:Ee,args:We})}return pi.getMessage(qe.identifier.value,fe[0])},get bundle(){return pi.getBundle(qe.identifier.value)},get uri(){return pi.getBundleUri(qe.identifier.value)}},Dn={_version:1,transferActiveChat(fe){return(0,et.$dH)(qe,"interactive"),ji.transferActiveChat(fe)}},kn={getRelatedInformation(fe,Ee){return(0,et.$dH)(qe,"aiRelatedInformation"),Vi.getRelatedInformation(qe,fe,Ee)},registerRelatedInformationProvider(fe,Ee){return(0,et.$dH)(qe,"aiRelatedInformation"),Vi.registerRelatedInformationProvider(qe,fe,Ee)},registerEmbeddingVectorProvider(fe,Ee){return(0,et.$dH)(qe,"aiRelatedInformation"),sn.registerEmbeddingVectorProvider(qe,fe,Ee)}},fn={_version:1,registerChatResponseProvider(fe,Ee,We){return(0,et.$dH)(qe,"chatProvider"),Ht.registerLanguageModel(qe,fe,Ee,We)},registerChatVariableResolver(fe,Ee,We,dt,St,Ot,Pi,Xi){return(0,et.$dH)(qe,"chatVariableResolver"),rn.registerVariableResolver(qe,fe,Ee,We,dt,St,Ot,Pi,Xi?.id)},registerMappedEditsProvider(fe,Ee){return(0,et.$dH)(qe,"mappedEditsProvider"),Ae.registerMappedEditsProvider(qe,fe,Ee)},createChatParticipant(fe,Ee){return ji.createChatAgent(qe,fe,Ee)},createDynamicChatParticipant(fe,Ee,We){return(0,et.$dH)(qe,"chatParticipantPrivate"),ji.createDynamicChatAgent(qe,fe,Ee,We)}},Yi={selectChatModels:fe=>Ht.selectLanguageModels(qe,fe??{}),onDidChangeChatModels:(fe,Ee,We)=>Ht.onDidChangeProviders(fe,Ee,We),registerChatModelProvider:(fe,Ee,We)=>((0,et.$dH)(qe,"chatProvider"),Ht.registerLanguageModel(qe,fe,Ee,We)),get embeddingModels(){return(0,et.$dH)(qe,"embeddings"),ki.embeddingsModels},onDidChangeEmbeddingModels:(fe,Ee,We)=>((0,et.$dH)(qe,"embeddings"),ki.onDidChange(fe,Ee,We)),registerEmbeddingsProvider(fe,Ee){return(0,et.$dH)(qe,"embeddings"),ki.registerEmbeddingsProvider(qe,fe,Ee)},async computeEmbeddings(fe,Ee,We){return(0,et.$dH)(qe,"embeddings"),ki.computeEmbeddings(fe,Ee,We)},registerTool(fe,Ee){return(0,et.$dH)(qe,"lmTools"),Bi.registerTool(qe,fe,Ee)},invokeTool(fe,Ee,We){return(0,et.$dH)(qe,"lmTools"),Bi.invokeTool(fe,Ee,We)},get tools(){return(0,et.$dH)(qe,"lmTools"),Bi.tools}},gn={registerSpeechProvider(fe,Ee){return(0,et.$dH)(qe,"speech"),bn.registerProvider(qe.identifier,fe,Ee)}};return{version:kt.version,ai:kn,authentication:En,commands:Ki,comments:ln,chat:fn,debug:un,env:Qi,extensions:yn,interactive:Dn,l10n:dn,languages:mi,lm:Yi,notebooks:hn,scm:cn,speech:gn,tasks:Sn,tests:Ei,window:Wi,workspace:Ji,Breakpoint:_.$IO,TerminalOutputAnchor:_.TerminalOutputAnchor,ChatResultFeedbackKind:_.ChatResultFeedbackKind,ChatVariableLevel:_.ChatVariableLevel,ChatCompletionItem:_.$EP,CallHierarchyIncomingCall:_.$7N,CallHierarchyItem:_.$6N,CallHierarchyOutgoingCall:_.$8N,CancellationError:h.$4,CancellationTokenSource:r.$ue,CandidatePortSource:i.CandidatePortSource,CodeAction:_.$3N,CodeActionKind:_.$4N,CodeActionTriggerKind:_.CodeActionTriggerKind,CodeLens:_.$9N,Color:_.$jO,ColorInformation:_.$kO,ColorPresentation:_.$lO,ColorThemeKind:_.ColorThemeKind,CommentMode:_.CommentMode,CommentState:_.CommentState,CommentThreadCollapsibleState:_.CommentThreadCollapsibleState,CommentThreadState:_.CommentThreadState,CommentThreadApplicability:_.CommentThreadApplicability,CommentThreadFocus:_.CommentThreadFocus,CompletionItem:_.$dO,CompletionItemKind:_.CompletionItemKind,CompletionItemTag:_.CompletionItemTag,CompletionList:_.$eO,CompletionTriggerKind:_.CompletionTriggerKind,ConfigurationTarget:_.ConfigurationTarget,CustomExecution:_.$tO,DebugAdapterExecutable:_.$MO,DebugAdapterInlineImplementation:_.$PO,DebugAdapterNamedPipeServer:_.$OO,DebugAdapterServer:_.$NO,DebugConfigurationProviderTriggerKind:Zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:_.DebugConsoleMode,DebugVisualization:_.$6O,DecorationRangeBehavior:_.DecorationRangeBehavior,Diagnostic:_.$VN,DiagnosticRelatedInformation:_.$UN,DiagnosticSeverity:_.DiagnosticSeverity,DiagnosticTag:_.DiagnosticTag,Disposable:_.$FN,DocumentHighlight:_.$YN,DocumentHighlightKind:_.DocumentHighlightKind,MultiDocumentHighlight:_.$ZN,DocumentLink:_.$iO,DocumentSymbol:_.$2N,EndOfLine:_.EndOfLine,EnvironmentVariableMutatorType:_.EnvironmentVariableMutatorType,EvaluatableExpression:_.$SO,InlineValueText:_.$TO,InlineValueVariableLookup:_.$UO,InlineValueEvaluatableExpression:_.$VO,InlineCompletionTriggerKind:_.InlineCompletionTriggerKind,EventEmitter:C.$je,ExtensionKind:_.ExtensionKind,ExtensionMode:_.ExtensionMode,ExternalUriOpenerPriority:_.ExternalUriOpenerPriority,FileChangeType:_.FileChangeType,FileDecoration:_.$8O,FileDecoration2:_.$8O,FileSystemError:_.$YO,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:_.$ZO,FoldingRangeKind:_.FoldingRangeKind,FunctionBreakpoint:_.$KO,InlineCompletionItem:_.$fO,InlineCompletionList:_.$gO,Hover:_.$WN,VerboseHover:_.$XN,HoverVerbosityAction:_.HoverVerbosityAction,IndentAction:S.IndentAction,Location:_.$TN,MarkdownString:_.$0N,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:_.$$N,PortAutoForwardAction:_.PortAutoForwardAction,Position:_.$GN,ProcessExecution:_.$rO,ProgressLocation:_.ProgressLocation,QuickInputButtonLocation:_.QuickInputButtonLocation,QuickInputButtons:_.$7O,Range:_.$HN,RelativePattern:_.$GO,Selection:_.$IN,SelectionRange:_.$5N,SemanticTokens:_.$3O,SemanticTokensBuilder:_.$2O,SemanticTokensEdit:_.$4O,SemanticTokensEdits:_.$5O,SemanticTokensLegend:_.$1O,ShellExecution:_.$sO,ShellQuoting:_.ShellQuoting,SignatureHelp:_.$aO,SignatureHelpTriggerKind:_.SignatureHelpTriggerKind,SignatureInformation:_.$_N,SnippetString:_.$SN,SourceBreakpoint:_.$JO,StandardTokenType:_.StandardTokenType,StatusBarAlignment:_.StatusBarAlignment,SymbolInformation:_.$1N,SymbolKind:_.SymbolKind,SymbolTag:_.SymbolTag,Task:_.$uO,TaskGroup:_.$qO,TaskPanelKind:_.TaskPanelKind,TaskRevealKind:_.TaskRevealKind,TaskScope:_.TaskScope,TerminalLink:_.$mO,TerminalQuickFixTerminalCommand:_.$oO,TerminalQuickFixOpener:_.$nO,TerminalLocation:_.TerminalLocation,TerminalProfile:_.$pO,TerminalExitReason:_.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:_.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:_.TextDocumentSaveReason,TextEdit:_.$ON,SnippetTextEdit:_.$QN,TextEditorCursorStyle:c.TextEditorCursorStyle,TextEditorLineNumbersStyle:_.TextEditorLineNumbersStyle,TextEditorRevealType:_.TextEditorRevealType,TextEditorSelectionChangeKind:_.TextEditorSelectionChangeKind,SyntaxTokenType:_.SyntaxTokenType,TextDocumentChangeReason:_.TextDocumentChangeReason,ThemeColor:_.$FO,ThemeIcon:_.$EO,TreeItem:_.$vO,TreeItemCheckboxState:_.TreeItemCheckboxState,TreeItemCollapsibleState:_.TreeItemCollapsibleState,TypeHierarchyItem:_.$sP,UIKind:hi.UIKind,Uri:b.URI,ViewColumn:_.ViewColumn,WorkspaceEdit:_.$RN,DocumentPasteTriggerKind:_.DocumentPasteTriggerKind,DocumentDropEdit:_.$BO,DocumentDropOrPasteEditKind:_.$CO,DocumentPasteEdit:_.$DO,InlayHint:_.$cO,InlayHintLabelPart:_.$bO,InlayHintKind:_.InlayHintKind,RemoteAuthorityResolverError:_.$NN,ResolvedAuthority:_.$LN,ManagedResolvedAuthority:_.$MN,SourceControlInputBoxValidationType:_.SourceControlInputBoxValidationType,ExtensionRuntime:_.ExtensionRuntime,TimelineItem:_.$fP,NotebookRange:_.$0O,NotebookCellKind:_.NotebookCellKind,NotebookCellExecutionState:_.NotebookCellExecutionState,NotebookCellData:_.$$O,NotebookData:_.$_O,NotebookRendererScript:_.$dP,NotebookCellStatusBarAlignment:_.NotebookCellStatusBarAlignment,NotebookEditorRevealType:_.NotebookEditorRevealType,NotebookCellOutput:_.$bP,NotebookCellOutputItem:_.$aP,NotebookCellStatusBarItem:_.$cP,NotebookControllerAffinity:_.NotebookControllerAffinity,NotebookControllerAffinity2:_.NotebookControllerAffinity2,NotebookEdit:_.$PN,NotebookKernelSourceAction:_.$eP,NotebookVariablesRequestKind:_.NotebookVariablesRequestKind,PortAttributes:_.$hP,LinkedEditingRanges:_.$gP,TestResultState:_.TestResultState,TestRunRequest:_.$iP,TestMessage:_.$jP,TestMessage2:_.$jP,TestMessageStackFrame:_.$lP,TestTag:_.$kP,TestRunProfileKind:_.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:_.$AO,DataTransferItem:_.$wO,TestCoverageCount:_.$mP,FileCoverage:_.$oP,FileCoverage2:_.$oP,StatementCoverage:_.$pP,BranchCoverage:_.$qP,DeclarationCoverage:_.$rP,WorkspaceTrustState:_.WorkspaceTrustState,LanguageStatusSeverity:_.LanguageStatusSeverity,QuickPickItemKind:_.QuickPickItemKind,InputBoxValidationSeverity:_.InputBoxValidationSeverity,TabInputText:_.$tP,TabInputTextDiff:_.$uP,TabInputTextMerge:_.$vP,TabInputCustom:_.$wP,TabInputNotebook:_.$yP,TabInputNotebookDiff:_.$zP,TabInputWebview:_.$xP,TabInputTerminal:_.$AP,TabInputInteractiveWindow:_.$BP,TabInputChat:_.$CP,TabInputTextMultiDiff:_.$DP,TelemetryTrustedValue:$.$up,LogLevel:a.LogLevel,EditSessionIdentityMatch:f.EditSessionIdentityMatch,InteractiveSessionVoteDirection:_.InteractiveSessionVoteDirection,ChatCopyKind:_.ChatCopyKind,InteractiveEditorResponseFeedbackKind:_.InteractiveEditorResponseFeedbackKind,DebugStackFrame:_.$QO,DebugThread:_.$RO,RelatedInformationType:_.RelatedInformationType,SpeechToTextStatus:_.SpeechToTextStatus,TextToSpeechStatus:_.TextToSpeechStatus,PartialAcceptTriggerKind:_.PartialAcceptTriggerKind,KeywordRecognitionStatus:_.KeywordRecognitionStatus,ChatResponseMarkdownPart:_.$FP,ChatResponseFileTreePart:_.$JP,ChatResponseAnchorPart:_.$KP,ChatResponseProgressPart:_.$LP,ChatResponseProgressPart2:_.$MP,ChatResponseReferencePart:_.$PP,ChatResponseWarningPart:_.$NP,ChatResponseTextEditPart:_.$QP,ChatResponseMarkdownWithVulnerabilitiesPart:_.$GP,ChatResponseCommandButtonPart:_.$OP,ChatResponseDetectedParticipantPart:_.$HP,ChatResponseConfirmationPart:_.$IP,ChatRequestTurn:_.$RP,ChatResponseTurn:_.$SP,ChatLocation:_.ChatLocation,ChatRequestEditorData:_.$TP,ChatRequestNotebookData:_.$UP,LanguageModelChatMessageRole:_.LanguageModelChatMessageRole,LanguageModelChatMessage:_.$WP,LanguageModelChatMessageFunctionResultPart:_.$VP,LanguageModelChatResponseTextPart:_.$YP,LanguageModelChatResponseFunctionUsePart:_.$XP,LanguageModelError:_.$3P,NewSymbolName:_.$XO,NewSymbolNameTag:_.NewSymbolNameTag,NewSymbolNameTriggerKind:_.NewSymbolNameTriggerKind,InlineEdit:_.$4P,InlineEditTriggerKind:_.InlineEditTriggerKind}}}}),define(Se[345],De([1,0,88,169,48,163,41,34,63,47,100,101,102,125,76,95,162,75,62,124,94,77,161,11,64,122,123,127,128,167,98]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d,l,g,E,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Os)(l.$Spc,l.$Rpc,r.InstantiationType.Delayed),(0,r.$Os)(n.$$j,o.$8qc,r.InstantiationType.Delayed),(0,r.$Os)(a.$Xoc,a.$Yoc,r.InstantiationType.Delayed),(0,r.$Os)(T.$yQ,T.$xQ,r.InstantiationType.Eager),(0,r.$Os)(E.$8oc,E.$9oc,r.InstantiationType.Eager),(0,r.$Os)(D.$Mpc,D.$Npc,r.InstantiationType.Eager),(0,r.$Os)(L.$kpc,L.$ipc,r.InstantiationType.Eager),(0,r.$Os)($.$mpc,$.$lpc,r.InstantiationType.Eager),(0,r.$Os)(k.$3pc,k.$4pc,r.InstantiationType.Eager),(0,r.$Os)(S.$8pc,S.$_pc,r.InstantiationType.Eager),(0,r.$Os)(R.$bqc,R.$aqc,r.InstantiationType.Eager),(0,r.$Os)(b.$nQ,b.$mQ,r.InstantiationType.Eager),(0,r.$Os)(g.$Tpc,g.$Upc,r.InstantiationType.Eager),(0,r.$Os)(f.$2oc,f.$1oc,r.InstantiationType.Eager),(0,r.$Os)(h.$Hqc,h.$Gqc,r.InstantiationType.Delayed),(0,r.$Os)(u.$rqc,u.$sqc,r.InstantiationType.Eager),(0,r.$Os)(P.$Fpc,P.$Epc,r.InstantiationType.Eager),(0,r.$Os)(I.$Uqc,I.$Tqc,r.InstantiationType.Eager),(0,r.$Os)(c.$Ipc,c.$Lpc,r.InstantiationType.Eager),(0,r.$Os)(y.$Vqc,y.$Wqc,r.InstantiationType.Eager),(0,r.$Os)(w.$0Fb,w.$$Fb,r.InstantiationType.Eager),(0,r.$Os)(m.$6qc,m.$5qc,r.InstantiationType.Eager),(0,r.$Os)(C.$hpc,C.$gpc,r.InstantiationType.Eager),(0,r.$Os)(i.$Ppc,i.$Opc,r.InstantiationType.Eager),(0,r.$Os)(s.$wQ,s.$tQ,r.InstantiationType.Eager),(0,r.$Os)(t.$wpc,t.$xpc,r.InstantiationType.Eager),(0,r.$Os)(d.$1pc,d.$2pc,r.InstantiationType.Eager)}),define(Se[129],De([1,0,18,11,37,99]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nrc=void 0,e.$lrc=L,e.$mrc=T,R=Ue(R);function L(S){return S.startsWith("**")||S.startsWith("/")?S:`/${S}`}function T(S,u,P,w){const a=(0,r.$Zb)(P,b),m=new C.$6L(u,a,w),$=m.preview.matches;return{ranges:(0,r.$Zb)(a,c),uri:S,preview:{text:m.preview.text,matches:(0,r.$Zb)($,c)}}}function b(S){return new C.$7L(S.start.line,S.start.character,S.end.line,S.end.character)}function c(S){return new R.$TL(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn)}let I=class{constructor(u,P){this.a=u,this.b=P}appendLine(u){this.b.debug(`${this.a}#search`,u)}};e.$nrc=I,e.$nrc=I=Ye([Ve(1,h.$0j)],I)}),define(Se[346],De([1,0,56,16,81,31,10,12,129,347]),function($e,e,r,h,C,R,L,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$orc=S,e.$prc=m,e.$qrc=f,r=Ue(r),h=Ue(h),R=Ue(R),T=Ue(T);const I=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function S(i,s,t,o,n){const d=u(i,s,t,o,n),l=s.folder.fsPath;return{cmd:r.spawn(I,d.args,{cwd:l}),rgDiskPath:I,siblingClauses:d.siblingClauses,rgArgs:d,cwd:l}}function u(i,s,t,o,n){const d=["--files","--hidden","--case-sensitive","--no-require-git"];w([s],t,!1).forEach(g=>{const E=(0,b.$lrc)(g);if(d.push("-g",E),L.$k){const D=(0,C.$lm)(E);D!==E&&d.push("-g",D)}});const l=P([s],o,void 0,!1);return l.globArgs.forEach(g=>{const E=`!${(0,b.$lrc)(g)}`;if(d.push("-g",E),L.$k){const D=(0,C.$lm)(E);D!==E&&d.push("-g",D)}}),s.disregardIgnoreFiles!==!1?d.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),s.ignoreSymlinks||d.push("--follow"),i.exists&&d.push("--quiet"),n&&d.push("--threads",`${n}`),d.push("--no-config"),s.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:l.siblingClauses}}function P(i,s,t,o=!0){const n=[];let d={};return i.forEach(l=>{const g=Object.assign({},l.excludePattern||{},s||{}),E=a(g,o?l.folder.fsPath:void 0,t);n.push(...E.globArgs),E.siblingClauses&&(d=Object.assign(d,E.siblingClauses))}),{globArgs:n,siblingClauses:d}}function w(i,s,t=!0){const o=[];return i.forEach(n=>{const d=Object.assign({},s||{},n.includePattern||{}),l=a(d,t?n.folder.fsPath:void 0);o.push(...l.globArgs)}),o}function a(i,s,t){const o=[],n={};return Object.keys(i).forEach(d=>{if(t&&t.has(d)||!d)return;const l=i[d];d=$(s?m(s,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),o.push(f(d))):l&&l.when&&(n[d]=l)}),{globArgs:o,siblingClauses:n}}function m(i,s){return h.$hc(s)?s:h.$ic(i,s)}function $(i){return i=T.$lf(i,"\\"),T.$lf(i,"/")}function f(i){return R.$xg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(Se[348],De([1,0,56,44,16,349,18,52,38,81,31,10,42,12,17,33,37,346,136]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$src=e.$rrc=void 0,r=Ue(r),h=Ue(h),C=Ue(C),L=Ue(L),b=Ue(b),c=Ue(c),S=Ue(S),P=Ue(P),w=Ue(w);const i=new Set;process.on("exit",()=>{i.forEach(d=>d())});class s{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&b.$xk(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=l.shouldGlobMatchFilePattern?null:(0,f.$Or)(this.b).normalizedLowercase),this.u=l.excludePattern&&b.$xk(l.excludePattern),this.t=new Map,l.folderQueries.forEach(g=>{const E=Object.assign({},g.excludePattern||{},this.a.excludePattern||{}),D=g.folder.fsPath;l.folderQueries.map(y=>y.folder.fsPath).filter(y=>y!==D).forEach(y=>{(0,I.$Bg)(y,D)&&(E[C.$kc(D,y)]=!0)}),this.t.set(D,new o(E,D))})}cancel(){this.l=!0,i.forEach(l=>l())}walk(l,g,E,D,y,k){if(this.m=u.$de.create(!1),this.l)return k(null,this.j);g.forEach(A=>{const p=C.$mc(A.fsPath);this.u&&this.u(A.fsPath,p)||this.J(D,{relativePath:A.fsPath,searchPath:void 0})}),this.r=u.$de.create(!1),this.w(l,(A,p)=>{this.x(this.y,this,A,E,D,y,v=>{if(v){const F=(0,T.$nj)(v);console.error(F),this.q.push(F),p(v,void 0)}else p(null,void 0)})},(A,p)=>{this.m.stop();const v=A?L.$Gb(A)[0]:null;k(v,this.j)})}w(l,g,E){const D=new Array(l.length),y=new Array(l.length);let k=!1,A=0;if(l.length===0)return E(null,[]);l.forEach((p,v)=>{g(p,(F,N)=>{if(F?(k=!0,D[v]=null,y[v]=F):(D[v]=N,y[v]=null),++A===l.length)return E(k?y:null,D)})})}x(l,g,...E){try{l.apply(g,E)}catch(D){E[E.length-1](D)}}y(l,g,E,D,y){const k=l.folder.fsPath,A=S.$k,p=()=>j&&j.kill();i.add(p);let v=V=>{i.delete(p),v=()=>{},y(V)},F="";const N=this.D(),O=(0,$.$orc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression,g),j=O.cmd,z=!Object.keys(O.siblingClauses).length,M=O.rgArgs.args.map(V=>V.match(/^-/)?V:`'${V}'`).join(" ");let W=`${O.rgDiskPath} ${M}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(W+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),D({message:W}),this.s=0,this.z(j,"utf8",D,(V,ne,B)=>{if(V){v(V);return}if(this.j){v();return}const Y=(F+(A?c.$km(ne||""):ne)).split(`
`);if(B){const ee=Y.length;Y[ee-1]=Y[ee-1].trim(),Y[ee-1]||Y.pop()}else F=Y.pop()||"";if(Y.length&&Y[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=Y.length,z){for(const ee of Y)if(this.J(E,{base:k,relativePath:ee,searchPath:this.N(l,ee)}),this.j){p();break}(B||this.j)&&v();return}this.G(l,N,k,Y,E),B&&(this.H(N,k,E),v())})}spawnFindCmd(l){const g=this.t.get(l.folder.fsPath),E=g.getBasenameTerms(),D=g.getPathTerms(),y=["-L","."];if(E.length||D.length){y.push("-not","(","(");for(const k of E)y.push("-name",k),y.push("-o");for(const k of D)y.push("-path",k),y.push("-o");y.pop(),y.push(")","-prune",")")}return y.push("-type","f"),r.spawn("find",y,{cwd:l.folder.fsPath})}readStdout(l,g,E){let D="";this.z(l,g,()=>{},(y,k,A)=>{if(y){E(y);return}D+=k,A&&E(null,D)})}z(l,g,E,D){let y=(p,v,F)=>{(p||F)&&(y=()=>{},this.r?.stop()),D(p,v,F)},k=!1;l.stdout?(this.A(l.stdout,g,y),l.stdout.once("data",()=>k=!0)):E({message:"stdout is null"});let A;l.stderr?A=this.B(l.stderr):E({message:"stderr is null"}),l.on("error",p=>{y(p)}),l.on("close",p=>{let v;!k&&(v=this.C(A,g))&&n(v)?y(new Error(`command failed with error code ${p}: ${this.C(A,g)}`)):(this.g&&p===0&&(this.j=!0),y(null,"",!0))})}A(l,g,E){const D=new R.StringDecoder(g);return l.on("data",y=>{E(null,D.write(y))}),D}B(l){const g=[];return l.on("data",E=>{g.push(E)}),g}C(l,g){const E=new R.StringDecoder(g);return l.map(D=>E.write(D)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:g},E,D,y){D.indexOf(this.b)!==-1&&this.J(y,{base:E,relativePath:this.b,searchPath:this.N(l,this.b)});const k=A=>{const p=C.$mc(A),v=C.$lc(A);let F=g[v];F||(F=g[v]=[],k(v)),F.push({base:E,relativePath:A,basename:p,searchPath:this.N(l,A)})};D.forEach(k)}H({rootEntries:l,pathToEntries:g},E,D){const y=this,k=this.t.get(E),A=this.b;function p(v){y.o++;const F=(0,m.$jM)(()=>v.map(N=>N.basename));for(let N=0,O=v.length;N<O;N++){const j=v[N],{relativePath:z,basename:M}=j;if(k.test(z,M,A!==M?F:void 0))continue;const W=g[z];if(W)p(W);else{if(y.p++,z===A)continue;y.J(D,j)}if(y.j)break}}p(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,g,E,D,y){const k=l.folder,A=(0,m.$jM)(()=>E);this.w(E,(p,v)=>{if(this.l||this.j)return v(null);const F=g?[g,p].join(C.sep):p;if(this.t.get(l.folder.fsPath).test(F,p,this.a.filePattern!==p?A:void 0))return v(null);const N=[k.fsPath,F].join(C.sep);h.lstat(N,(O,j)=>{if(O||this.l||this.j)return v(null);this.L(N,j,(z,M)=>z||this.l||this.j?v(null):M.isDirectory()?(this.o++,this.M(N,j,(W,V)=>W||this.l||this.j||(V=V||"",this.v[V])?v(null):(this.v[V]=!0,a.Promises.readdir(N).then(ne=>{if(this.l||this.j)return v(null);this.I(l,F,ne,D,B=>v(B||null))},ne=>{v(null)})))):(this.p++,F===this.b||this.h&&w.$gg(M.size)&&M.size>this.h||this.J(D,{base:k.fsPath,relativePath:F,searchPath:this.N(l,F)}),v(null,void 0)))})},p=>{const v=p&&L.$Gb(p);return y(v&&v.length>0?v[0]:void 0)})}J(l,g){this.K(g)&&(!this.d||this.d(g.relativePath,C.$mc(g.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(g))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$eM)(l,this.c);if(this.b)return(0,m.$eM)(l,this.b,!1)}return!0}L(l,g,E){return g.isSymbolicLink()?h.stat(l,E):E(null,g)}M(l,g,E){return g.isSymbolicLink()?h.realpath(l,(D,y)=>D?E(D):E(null,y)):E(null,l)}N(l,g){return l.folderName?C.$ic(l.folderName,g):g}}e.$rrc=s;class t{constructor(l,g){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.d=g,this.c=new s(l)}search(l,g,E){this.c.walk(this.a,this.b,this.d,l,g,(D,y)=>{E(D,{limitHit:y,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$src=t;class o{constructor(l,g){this.expression=l,this.c=g,this.d(l)}d(l){let g,E;Object.keys(l).filter(D=>l[D]).forEach(D=>{C.$hc(D)?(g=g||b.$sk(),g[D]=l[D]):(E=E||b.$sk(),E[D]=l[D])}),this.a=g&&b.$xk(g,{trimForExclusions:!0}),this.b=E&&b.$xk(E,{trimForExclusions:!0})}test(l,g,E){return this.b&&this.b(l,g,E)||this.a&&this.a(C.$ic(this.c,l),g,E)}getBasenameTerms(){const l=[];return this.a&&l.push(...b.$zk(this.a)),this.b&&l.push(...b.$zk(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...b.$Ak(this.a)),this.b&&l.push(...b.$Ak(this.b)),l}}function n(d){const l=d.trim().split(`
`),g=l[0].trim();if(g.startsWith("Error parsing regex"))return g;if(g.startsWith("regex parse error"))return P.$7f(l[l.length-1].trim());if(g.startsWith("error parsing glob")||g.startsWith("unsupported encoding"))return g.charAt(0).toUpperCase()+g.substr(1);if(g==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(g.startsWith("Literal "))return g}}),define(Se[350],De([1,0,105,21,189,20,18]),function($e,e,r,h,C,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SE=e.$RE=e.$JE=e.DecodeStreamErrorKind=e.$IE=e.$HE=e.$GE=e.$EE=e.$DE=e.$CE=e.$BE=void 0,e.$FE=T,e.$KE=a,e.$LE=m,e.$ME=$,e.$NE=f,e.$OE=i,e.$PE=E,e.$QE=D,e.$BE="utf8",e.$CE="utf8bom",e.$DE="utf16be",e.$EE="utf16le";function T(y){return[e.$BE,e.$CE,e.$DE,e.$EE].some(k=>k===y)}e.$GE=[254,255],e.$HE=[255,254],e.$IE=[239,187,191];const b=512,c=512,I=512*8,S=512*128;var u;(function(y){y[y.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(u||(e.DecodeStreamErrorKind=u={}));class P extends Error{constructor(k,A){super(k),this.decodeStreamErrorKind=A}}e.$JE=P;class w{static async create(k){let A;if(k!==e.$BE)A=(await(0,C.$zE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(f(k));else{const p=new TextDecoder;A={write(v){return p.decode(v,{stream:!0})},end(){return p.decode()}}}return new w(A)}constructor(k){this.a=k}write(k){return this.a.write(k)}end(){return this.a.end()}}function a(y,k){const A=k.minBytesRequiredForDetection??k.guessEncoding?I:c;return new Promise((p,v)=>{const F=(0,r.$ze)(W=>W.join("")),N=[];let O=0,j;const z=new R.$ue,M=async()=>{try{const W=await D({buffer:h.$Le.concat(N),bytesRead:O},k.guessEncoding,k.candidateGuessEncodings);if(W.seemsBinary&&k.acceptTextOnly)throw new P("Stream is binary but only text is accepted for decoding",u.STREAM_IS_BINARY);W.encoding=await k.overwriteEncoding(W.encoding),j=await w.create(W.encoding);const V=j.write(h.$Le.concat(N).buffer);F.write(V),N.length=0,O=0,p({stream:F,detected:W})}catch(W){z.cancel(),F.destroy(),v(W)}};(0,r.$De)(y,{onData:async W=>{j?F.write(j.write(W.buffer)):(N.push(W),O+=W.byteLength,O>=A&&(y.pause(),await M(),setTimeout(()=>y.resume())))},onError:W=>F.error(W),onEnd:async()=>{j||await M(),F.end(j?.end())}},z.token)})}async function m(y,k,A){const v=(await(0,C.$zE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(f(k),A);let F=!1,N=!1;return{read(){if(N)return null;const O=y.read();if(typeof O!="string"){if(N=!0,!F&&A?.addBOM)switch(k){case e.$BE:case e.$CE:return h.$Le.wrap(Uint8Array.from(e.$IE));case e.$DE:return h.$Le.wrap(Uint8Array.from(e.$GE));case e.$EE:return h.$Le.wrap(Uint8Array.from(e.$HE))}const j=v.end();return j&&j.length>0?(F=!0,h.$Le.wrap(j)):null}return F=!0,h.$Le.wrap(v.write(O))}}}async function $(y){return(await(0,C.$zE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(f(y))}function f(y){return y===e.$CE||y===null?e.$BE:y}function i(y,k){if(!y||k<e.$GE.length)return null;const A=y.readUInt8(0),p=y.readUInt8(1);if(A===e.$GE[0]&&p===e.$GE[1])return e.$DE;if(A===e.$HE[0]&&p===e.$HE[1])return e.$EE;if(k<e.$IE.length)return null;const v=y.readUInt8(2);return A===e.$IE[0]&&p===e.$IE[1]&&v===e.$IE[2]?e.$CE:null}const s=["ascii","utf-16","utf-32"];async function t(y,k){const A=await(0,C.$zE)("jschardet","dist/jschardet.min.js"),p=y.slice(0,S),v=g(p.buffer);k&&(k=(0,L.$Gb)(k.map(O=>l(O))),k.length===0&&(k=void 0));const F=A.detect(v,k?{detectEncodings:k}:void 0);if(!F||!F.encoding)return null;const N=F.encoding.toLowerCase();return 0<=s.indexOf(N)?null:d(F.encoding)}const o={ibm866:"cp866",big5:"cp950"};function n(y){return y.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function d(y){const k=n(y);return o[k]||k}function l(y){const k=n(y);return e.$SE[k].guessableName}function g(y){let k="";for(let A=0;A<y.length;A++)k+=String.fromCharCode(y[A]);return k}function E(y){switch(y){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const k=y.match(/windows(\d+)/);return k?"windows-"+k[1]:y}}}function D({buffer:y,bytesRead:k},A,p){let v=i(y,k),F=!1;if(v!==e.$DE&&v!==e.$EE&&y){let N=!0,O=!0,j=!1;for(let z=0;z<k&&z<b;z++){const M=z%2===1,W=y.readUInt8(z)===0;if(W&&(j=!0),N&&(M&&!W||!M&&W)&&(N=!1),O&&(M&&W||!M&&!W)&&(O=!1),W&&!N&&!O)break}j&&(N?v=e.$EE:O?v=e.$DE:F=!0)}return A&&!F&&!v&&y?t(y.slice(0,k),p).then(N=>({seemsBinary:!1,encoding:N})):{seemsBinary:F,encoding:v}}e.$RE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.$SE=(()=>{const y={};for(const k in e.$RE)e.$RE[k].guessableName&&(y[k]=e.$RE[k]);return y})()}),define(Se[172],De([1,0,350,33,171]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Arc=void 0,h=Ue(h);class R extends C.$nqc{constructor(T,b,c=h,I="searchProcess"){super({query:T,provider:b},{readdir:S=>c.Promises.readdir(S.fsPath),toCanonicalName:S=>(0,r.$PE)(S)},I)}}e.$Arc=R}),define(Se[173],De([1,0,56,365,349,18,78,38,12,2,37,99,366,347,129]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$urc=e.$trc=void 0,e.$vrc=o,e.$wrc=d,e.$xrc=g,e.$yrc=E,e.$zrc=y,r=Ue(r);const a=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(A,p){this.a=A,this.b=p}provideTextSearchResults(A,p,v,F){return this.a.appendLine(`provideTextSearchResults ${A.pattern}, ${JSON.stringify({...p,folder:p.folder.toString()})}`),new Promise((N,O)=>{F.onCancellationRequested(()=>Y());const j={...p,numThreads:this.b},z=o(A,j),M=p.folder.fsPath,W=z.map(me=>me.match(/^-/)?me:`'${me}'`).join(" ");this.a.appendLine(`${a} ${W}
 - cwd: ${M}`);let V=r.spawn(a,z,{cwd:M});V.on("error",me=>{console.error(me),this.a.appendLine("Error: "+(me&&me.message)),O((0,I.$aM)(new I.$$L(me&&me.message,I.SearchErrorCode.rgProcessError)))});let ne=!1;const B=new i(p.maxResults,p.folder,p.previewOptions);B.on("result",me=>{ne=!0,ue="",v.report(me)});let K=!1;const Y=()=>{K=!0,V?.kill(),B?.cancel()};let ee=!1;B.on("hitLimit",()=>{ee=!0,Y()});let ue="";V.stdout.on("data",me=>{B.handleData(me),ne||(ue+=me)});let re=!1;V.stdout.once("data",()=>re=!0);let ye="";V.stderr.on("data",me=>{const J=me.toString();this.a.appendLine(J),ye.length+J.length<1e6&&(ye+=J)}),V.on("close",()=>{if(this.a.appendLine(re?"Got data from stdout":"No data from stdout"),this.a.appendLine(ne?"Got result from parser":"No result from parser"),ue&&this.a.appendLine(`Got data without result: ${ue}`),this.a.appendLine(""),K)N({limitHit:ee});else{B.flush(),V=null;let me;ye&&!re&&(me=$(ye))?O((0,I.$aM)(new I.$$L(me.message,me.code))):N({limitHit:ee})}})})}}e.$trc=m;function $(k){const A=k.split(`
`),p=A[0].trim();if(A.some(F=>F.startsWith("regex parse error")))return new I.$$L(f(A),I.SearchErrorCode.regexParseError);const v=p.match(/grep config error: unknown encoding: (.*)/);if(v)return new I.$$L(`Unknown encoding: ${v[1]}`,I.SearchErrorCode.unknownEncoding);if(p.startsWith("error parsing glob"))return new I.$$L(p.charAt(0).toUpperCase()+p.substr(1),I.SearchErrorCode.globParseError);if(p.startsWith("the literal"))return new I.$$L(p.charAt(0).toUpperCase()+p.substr(1),I.SearchErrorCode.invalidLiteral);if(p.startsWith("PCRE2: error compiling pattern"))return new I.$$L(p,I.SearchErrorCode.regexParseError)}function f(k){const A=["Regex parse error"],p=k.filter(v=>v.startsWith("PCRE2:"));if(p.length>=1){const v=p[0].replace("PCRE2:","");if(v.indexOf(":")!==-1&&v.split(":").length>=2){const F=v.split(":")[1];A.push(":"+F)}}return A.join("")}class i extends h.EventEmitter{constructor(A,p,v){super(),this.g=A,this.h=p,this.j=v,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new C.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(A,p){return super.on(A,p),this}handleData(A){if(this.b)return;const p=typeof A=="string"?A:this.d.write(A);this.k(p)}k(A){let p=A.indexOf(`
`);const v=this.a+A;if(p>=0)p+=this.a.length;else{this.a=v;return}let F=0;for(;p>=0;)this.m(v.substring(F,p).trim()),F=p+1,p=v.indexOf(`
`,F);this.a=v.substring(F)}m(A){if(this.b||!A)return;let p;try{p=JSON.parse(A)}catch{throw new Error(`malformed line from rg: ${A}`)}if(p.type==="match"){const v=s(p.data.path),F=c.URI.joinPath(this.h,v),N=this.n(p.data,F);this.p(N),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(p.type==="context"){const v=s(p.data.path),F=c.URI.joinPath(this.h,v);this.o(p.data,F).forEach(O=>this.p(O))}}n(A,p){const v=A.line_number-1,F=s(A.lines),N=Buffer.from(F);let O=0,j=0,z=v;A.submatches.length===0&&A.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const M=(0,R.$Gb)(A.submatches.map((W,V)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ne=s(W.match),B=N.slice(O,W.start).toString(),K=t(B),Y=K.numLines>0?K.lastLineLength:K.lastLineLength+j,ee=t(ne),ue=K.numLines+z,re=ee.numLines+ue,ye=ee.numLines>0?ee.lastLineLength:ee.lastLineLength+Y;return O=W.end,j=ye,z=re,new S.$TL(ue,Y,re,ye)}));return(0,w.$mrc)(p,F,M,this.j)}o(A,p){const v=s(A.lines),F=A.line_number;return v.replace(/\r?\n$/,"").split(`
`).map((N,O)=>({text:N,uri:p,lineNumber:F+O}))}p(A){this.emit("result",A)}}e.$urc=i;function s(k){return k.bytes?Buffer.from(k.bytes,"base64").toString():k.text}function t(k){const A=/\n/g;let p=0,v=-1,F;for(;F=A.exec(k);)p++,v=F.index;const N=v>=0?k.length-v-1:k.length;return{numLines:p,lastLineLength:N}}function o(k,A){const p=["--hidden","--no-require-git"];p.push(k.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:v,otherIncludes:F}=(0,L.$c)(A.includes,O=>O.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const O=new Set;F.forEach(j=>{O.add(j)}),p.push("-g","!*"),O.forEach(j=>{n(j).map(w.$lrc).forEach(z=>{p.push("-g",z)})})}v&&v.length&&v.forEach(O=>{p.push("-g",O)}),A.excludes.map(w.$lrc).forEach(O=>p.push("-g",`!${O}`)),A.maxFileSize&&p.push("--max-filesize",A.maxFileSize+""),A.useIgnoreFiles?A.useParentIgnoreFiles||p.push("--no-ignore-parent"):p.push("--no-ignore"),A.followSymlinks&&p.push("--follow"),A.encoding&&A.encoding!=="utf8"&&p.push("--encoding",A.encoding),A.numThreads&&p.push("--threads",`${A.numThreads}`),k.pattern==="--"&&(k.isRegExp=!0,k.pattern="\\-\\-"),k.isMultiline&&!k.isRegExp&&(k.pattern=(0,b.$ff)(k.pattern),k.isRegExp=!0),A.usePCRE2&&p.push("--pcre2"),p.push("--crlf"),k.isRegExp&&(k.pattern=d(k.pattern),p.push("--engine","auto"));let N;if(k.isWordMatch){const j=(0,b.$of)(k.pattern,!!k.isRegExp,{wholeWord:k.isWordMatch}).source.replace(/\\\//g,"/");p.push("--regexp",j)}else if(k.isRegExp){let O=g(k.pattern);O=E(O),p.push("--regexp",O)}else N=k.pattern,p.push("--fixed-strings");return p.push("--no-config"),A.useGlobalIgnoreFiles||p.push("--no-ignore-global"),p.push("--json"),k.isMultiline&&p.push("--multiline"),A.beforeContext&&p.push("--before-context",A.beforeContext+""),A.afterContext&&p.push("--after-context",A.afterContext+""),p.push("--"),N&&p.push(N),p.push("."),p}function n(k){return y(k).flatMap(p=>{const v=(0,T.$vk)(p,"/");return v.map((F,N)=>v.slice(0,N+1).join("/"))})}function d(k){const A=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;k.match(A);)k=k.replace(A,"$1\\x{$2}");const p=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;k.match(p);)k=k.replace(p,"$1\\x{$2}");return k}const l=k=>k.type==="Assertion"&&k.kind==="lookbehind";function g(k){let A;try{A=new u.RegExpParser().parsePattern(k)}catch{return k}let p="",v=0;const F=(j,z,M)=>{p+=k.slice(v,j)+M,v=z},N=[];return new u.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const z=N[0];if(!z)F(j.start,j.end,"\\r?\\n");else if(!N.some(l))if(z.type==="CharacterClass")if(z.negate){const M=k.slice(z.start+2,j.start)+k.slice(j.end,z.end-1);z.parent?.type==="Quantifier"?F(z.start,z.end,M?`[^${M}]`:"."):F(z.start,z.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=k.slice(z.start+1,j.start)+k.slice(j.end,z.end-1);F(z.start,z.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else z.type==="Quantifier"&&F(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){N.unshift(j)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(j){N.unshift(j)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(j){N.unshift(j)},onCharacterClassLeave(){N.shift()},onAssertionEnter(j){l(j)&&N.push(j)},onAssertionLeave(j){N[0]===j&&N.shift()}}).visit(A),p+=k.slice(v),p}function E(k){return k.replace(/\n/g,"\\r?\\n")}function D(k){let A=!1,p=!1,v="",F="";for(let N=0;N<k.length;N++){const O=k[N];switch(O){case"\\":p?(A?F+="\\"+O:v+="\\"+O,p=!1):p=!0;break;case"{":if(p)A?F+=O:v+=O,p=!1;else{if(A)return{strInBraces:v+"{"+F+"{"+k.substring(N+1)};A=!0}break;case"}":if(p)A?F+=O:v+=O,p=!1;else{if(A)return{fixedStart:v,strInBraces:F,fixedEnd:k.substring(N+1)};v+=O}break;default:A?F+=(p?"\\":"")+O:v+=(p?"\\":"")+O,p=!1;break}}return{strInBraces:v+(A?"{"+F:"")}}function y(k){const{fixedStart:A,strInBraces:p,fixedEnd:v}=D(k);if(A===void 0||v===void 0)return[p];let F=(0,T.$vk)(p,",");F.length||(F=[""]);const N=y(v);return F.flatMap(O=>{const j=A+O;return N.map(z=>j+z)})}}),define(Se[351],De([1,0,20,173,89,14]),function($e,e,r,h,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Drc=void 0;class L{constructor(c,I){this.b=c,this.c=I,this.a=new Set,process.once("exit",()=>this.e())}async provideTextSearchResults(c,I,S,u){const P=await this.c(),w=new h.$trc(this.b,P),a={...I,numThreads:P};if(I.folder.scheme===R.Schemas.vscodeUserData){const m={...a,folder:I.folder.with({scheme:R.Schemas.file})},$=new C.$ww(f=>S.report({...f,uri:f.uri.with({scheme:I.folder.scheme})}));return this.d(u,f=>w.provideTextSearchResults(c,m,$,f))}else return this.d(u,m=>w.provideTextSearchResults(c,a,S,m))}async d(c,I){const S=T(c);this.a.add(S);const u=await I(S.token);return this.a.delete(S),u}e(){this.a.forEach(c=>c.cancel())}}e.$Drc=L;function T(b){const c=new r.$ue;return b.onCancellationRequested(()=>c.cancel()),c}}),define(Se[352],De([1,0,33,173,172]),function($e,e,r,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Brc=void 0,r=Ue(r);class R{constructor(b,c){this.a=b,this.b=c}search(b,c,I){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const S={appendLine(P){I({message:P})}},u=new C.$Arc(this.a,new h.$trc(S,this.b),r);return new Promise((P,w)=>u.search(a=>{c(a.map(L))},b).then(a=>P({limitHit:a.limitHit??!1,type:"success",stats:a.stats,messages:[]}),w))}}e.$Brc=R;function L(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((b,c)=>{if(c.ranges){const I=c;return b+(Array.isArray(I.ranges)?I.ranges.length:1)}else return b+1},0)}}}),define(Se[353],De([1,0,18,7,13,4,136,16,42,2,27,37,348,352]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Crc=void 0,r=Ue(r);class w{static{this.a=512}constructor(s="searchProcess",t){this.d=s,this.f=t,this.b=Object.create(null)}fileSearch(s){let t;const o=$(s),n=new R.$je({onDidAddFirstListener:()=>{t=(0,h.$ph)(async d=>{const l=await this.f?.();return this.doFileSearchWithEngine(u.$src,o,g=>n.fire(g),d,w.a,l)}),t.then(d=>n.fire(d),d=>n.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return n.event}textSearch(s){let t;const o=$(s),n=new R.$je({onDidAddFirstListener:()=>{t=(0,h.$ph)(d=>this.g(o,l=>n.fire(l),d)),t.then(d=>n.fire(d),d=>n.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return n.event}async g(s,t,o){s.maxFileSize=this.h().maxFileSize;const n=await this.f?.();return new P.$Brc(s,n).search(o,t,t)}h(){return{maxFileSize:16*I.$Fl.GB}}doFileSearch(s,t,o,n){return this.doFileSearchWithEngine(u.$src,s,o,n,w.a,t)}doFileSearchWithEngine(s,t,o,n,d=w.a,l){let g=0;const E=y=>{Array.isArray(y)?(g+=y.length,o(y.map(k=>this.j(k)))):y.relativePath?(g++,o(this.j(y))):o(y)};if(t.sortByScore){let y=this.n(t,E,n);if(!y){const k=t.maxResults?Object.assign({},t,{maxResults:null}):t,A=new s(k,l);y=this.k(A,t,o,E,n)}return new Promise((k,A)=>{y.then(([p,v])=>{const F=v.map(N=>this.j(N));this.q(F,o,d),k(p)},A)})}const D=new s(t,l);return this.s(D,E,d,n).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:this.d,fromCache:!1,resultCount:g,sortingTime:void 0},messages:[]}))}j(s){return{path:s.base?(0,T.$ic)(s.base,s.relativePath):s.relativePath}}k(s,t,o,n,d){const l=new R.$je;let g=(0,h.$ph)(D=>{let y=[];const k=A=>{Array.isArray(A)?y=A:(n(A),l.fire(A))};return this.s(s,k,-1,D).then(A=>[A,y])}),E;if(t.cacheKey){E=this.l(t.cacheKey);const D={promise:g,event:l.event,resolved:!1};E.resultsToSearchCache[t.filePattern||""]=D,g.then(()=>{D.resolved=!0},y=>{delete E.resultsToSearchCache[t.filePattern||""]}),g=this.t(g)}return g.then(([D,y])=>{const k=E?E.scorerCache:Object.create(null),A=(typeof t.maxResults!="number"||t.maxResults>0)&&b.$de.create(!1);return this.o(t,y,k,d).then(p=>{const v=A?A.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:v,fromCache:!1,type:this.d,resultCount:p.length},messages:D.messages,limitHit:D.limitHit||typeof t.maxResults=="number"&&y.length>t.maxResults},p]})})}l(s){const t=this.b[s];return t||(this.b[s]=new a)}n(s,t,o){const n=s.cacheKey&&this.b[s.cacheKey];if(!n)return;const d=this.r(n,s.filePattern||"",t,o);if(d)return d.then(([l,g,E])=>{const D=b.$de.create(!1);return this.o(s,g,n.scorerCache,o).then(y=>{const k=D.elapsed(),A={fromCache:!0,detailStats:E,type:this.d,resultCount:g.length,sortingTime:k};return[{type:"success",limitHit:l.limitHit||typeof s.maxResults=="number"&&g.length>s.maxResults,stats:A,messages:[]},y]})})}o(s,t,o,n){const d=(0,L.$Or)(s.filePattern||""),l=(E,D)=>(0,L.$Nr)(E,D,d,!0,m,o),g=typeof s.maxResults=="number"?s.maxResults:S.$ZL;return r.$Fb(t,l,g,1e4,n)}q(s,t,o){if(o&&o>0)for(let n=0;n<s.length;n+=o)t(s.slice(n,n+o));else t(s)}r(s,t,o,n){const d=b.$de.create(!1),l=t.indexOf(T.sep)>=0;let g;for(const k in s.resultsToSearchCache)if(t.startsWith(k)){if(l&&k.indexOf(T.sep)<0&&k!=="")continue;const A=s.resultsToSearchCache[k];g={promise:this.t(A.promise),event:A.event,resolved:A.resolved};break}if(!g)return null;const E=d.elapsed(),D=b.$de.create(!1),y=g.event(o);return n&&n.onCancellationRequested(()=>{y.dispose()}),g.promise.then(([k,A])=>{if(n&&n.isCancellationRequested)throw(0,C.$5)();const p=[],v=(0,L.$Or)(t).normalizedLowercase;for(const F of A)(0,S.$eM)(F,v)&&p.push(F);return[k,p,{cacheWasResolved:g.resolved,cacheLookupTime:E,cacheFilterTime:D.elapsed(),cacheEntryCount:A.length}]})}s(s,t,o,n){return new Promise((d,l)=>{let g=[];n?.onCancellationRequested(()=>s.cancel()),s.search(E=>{E&&(o?(g.push(E),o>0&&g.length>=o&&(t(g),g=[])):t(E))},E=>{t(E)},(E,D)=>{g.length&&t(g),E?(t({message:"Search finished. Error: "+E.message}),l(E)):(t({message:"Search finished. Stats: "+JSON.stringify(D.stats)}),d(D))})})}clearCache(s){return delete this.b[s],Promise.resolve(void 0)}t(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(t,o){return s.then(t,o)}catch(t){return this.then(void 0,t)}finally(t){return s.finally(t)}}}}e.$Crc=w;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(i){return(0,T.$mc)(i.relativePath)}getItemDescription(i){return(0,T.$lc)(i.relativePath)}getItemPath(i){return i.relativePath}};function $(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(f),extraFileResources:i.extraFileResources&&i.extraFileResources.map(s=>c.URI.revive(s))}}function f(i){return{...i,folder:c.URI.revive(i.folder)}}}),define(Se[354],De([1,0,3,14,2,33,11,41,29,19,102,72,37,353,351,129,172]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Erc=void 0,R=Ue(R);let $=class extends I.$sqc{constructor(i,s,t,o,n){super(i,t,n),this.D=o,this.w=R,this.x=-1,this.y=null,this.z=!1,this.B=new r.$Sc,this.C=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.E=this.E.bind(this);const d=new a.$nrc("RipgrepSearchUD",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.vscodeUserData,new w.$Drc(d,this.getNumThreadsCached))),s.remote.isRemote&&s.remote.authority&&this.F(),o.getConfigProvider().then(l=>{this.C||this.B.add(l.onDidChangeConfiguration(this.E))})}E(i){i.affectsConfiguration("search")&&(this.A=void 0)}async getNumThreads(){return(await this.D.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this.A||(this.A=this.getNumThreads()),this.A}dispose(){this.C=!0,this.B.dispose()}$enableExtensionHostSearch(){this.F()}F(){if(this.z)return;this.z=!0;const i=new a.$nrc("RipgrepSearchEH",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.file,new w.$Drc(i,this.getNumThreadsCached))),this.B.add(this.G(h.Schemas.file,new P.$Crc("fileSearchProvider",this.getNumThreadsCached)))}G(i,s){const t=this.d++;return this.y=s,this.x=t,this.c.$registerFileSearchProvider(t,this.s(i)),(0,r.$Rc)(()=>{this.y=null,this.c.$unregisterProvider(t)})}$provideFileSearchResults(i,s,t,o){const n=(0,I.$tqc)(t);if(i===this.x){const d=Date.now();return this.H(i,s,n,o).then(l=>{const g=Date.now()-d;return this.q.debug(`Ext host file search time: ${g}ms`),l})}return super.$provideFileSearchResults(i,s,t,o)}async doInternalFileSearchWithCustomCallback(i,s,t){const o=d=>{if((0,u.$dM)(d)&&(d=[d]),Array.isArray(d)){t(d.map(l=>C.URI.file(l.path)));return}d.message&&this.q.debug("ExtHostSearch",d.message)};if(!this.y)throw new Error("No internal file search handler");const n=await this.getNumThreadsCached();return this.y.doFileSearch(i,n,o,s)}async H(i,s,t,o){return this.doInternalFileSearchWithCustomCallback(t,o,n=>{this.c.$handleFileMatch(i,s,n)})}$clearCache(i){return this.y?.clearCache(i),super.$clearCache(i)}t(i,s){return new m.$Arc(i,s,void 0,"textSearchProvider")}};e.$Erc=$,e.$Erc=$=Ye([Ve(0,c.$cQ),Ve(1,b.$sQ),Ve(2,S.$epc),Ve(3,T.$kpc),Ve(4,L.$0j)],$)}),define(Se[130],De([1,0,367,67,66,368,21,13,4,3,16,10,32,86,68]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$ti=e.$si=e.$ri=void 0,e.$ui=l,e.$vi=g,e.$xi=y,e.$yi=k;const a=3e4;class m{traceSocketEvent(p,v){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,v)}constructor(p,v=""){this.f=!0,this.debugLabel=v,this.socket=p,this.traceSocketEvent(w.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=N=>{if(this.traceSocketEvent(w.SocketDiagnosticsEventType.Error,{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,T.$Y)(N)}},this.socket.on("error",this.a);let F;this.b=N=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.Close,{hadError:N}),this.f=!1,F&&clearTimeout(F)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,F=setTimeout(()=>p.destroy(),a)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const v=F=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.Read,F),p(L.$Le.wrap(F))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(p){const v=F=>{p({type:w.SocketCloseEventType.NodeSocketCloseEvent,hadError:F,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(p){const v=()=>{p()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(w.SocketDiagnosticsEventType.Write,p),this.socket.write(p.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,T.$Y)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,T.$Y)(v)}}end(){this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((p,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainEnd),p();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainEnd),p()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.$ri=m;var $;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var f;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(f||(f={}));class i extends c.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,v){this.socket.traceSocketEvent(p,v)}constructor(p,v,F,N){super(),this.f=this.B(new b.$je),this.g=this.B(new b.$je),this.h=!1,this.j={state:f.PeekHeader,readLen:$.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent(w.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:F?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new s(this,v,F,N,this.f,(O,j)=>this.m(O,j))),this.B(this.a.onError(O=>{console.error(O),(0,T.$Y)(O),this.g.fire({type:w.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:O})})),this.b=new w.$mi,this.B(this.socket.onData(O=>this.n(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let v=0;for(;v<p.byteLength;)this.a.writeMessage(p.slice(v,Math.min(v+$.MaxWebSocketMessageLength,p.byteLength)),{compressed:!0,opcode:2}),v+=$.MaxWebSocketMessageLength}m(p,{compressed:v,opcode:F}){if(this.h)return;this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,p);let N=$.MinHeaderByteSize;p.byteLength<126?N+=0:p.byteLength<2**16?N+=2:N+=8;const O=L.$Le.alloc(N),j=v?64:0,z=F&15;if(O.writeUInt8(128|j|z,0),p.byteLength<126)O.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){O.writeUInt8(126,1);let M=1;O.writeUInt8(p.byteLength>>>8&255,++M),O.writeUInt8(p.byteLength>>>0&255,++M)}else{O.writeUInt8(127,1);let M=1;O.writeUInt8(0,++M),O.writeUInt8(0,++M),O.writeUInt8(0,++M),O.writeUInt8(0,++M),O.writeUInt8(p.byteLength>>>24&255,++M),O.writeUInt8(p.byteLength>>>16&255,++M),O.writeUInt8(p.byteLength>>>8&255,++M),O.writeUInt8(p.byteLength>>>0&255,++M)}this.socket.write(L.$Le.concat([O,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===f.PeekHeader){const v=this.b.peek(this.j.readLen),F=v.readUInt8(0),N=(F&128)>>>7,O=(F&64)>>>6,j=F&15,z=v.readUInt8(1),M=(z&128)>>>7,W=z&127;this.j.state=f.ReadHeader,this.j.readLen=$.MinHeaderByteSize+(M?4:0)+(W===126?2:0)+(W===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!O),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===f.ReadHeader){const v=this.b.read(this.j.readLen),F=v.readUInt8(1),N=(F&128)>>>7;let O=F&127,j=1;O===126?O=v.readUInt8(++j)*2**8+v.readUInt8(++j):O===127&&(O=v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j));let z=0;N&&(z=v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j)),this.j.state=f.ReadBody,this.j.readLen=O,this.j.mask=z,this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===f.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),n(v,this.j.mask),this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=f.PeekHeader,this.j.readLen=$.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$si=i;class s extends c.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$Le.alloc(0)}constructor(p,v,F,N,O,j){super(),this.n=p,this.r=O,this.s=j,this.a=this.B(new b.$je),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$je),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$je),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new t(this.n,N,F,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(p,v){this.g.push({data:p,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:v}=this.g.shift();if(this.f&&v.compressed){const F=await this.w(this.f,p);this.s(F,v)}else this.s(p,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,v){return new Promise((F,N)=>{p.write(v),p.flush(O=>F(O))})}acceptFrame(p,v,F){this.h.push({data:p,isCompressed:v,isLastFrameOfMessage:F}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const v=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,v,F){return new Promise((N,O)=>{p.write(v),F&&p.write(L.$Le.fromByteArray([0,0,255,255])),p.flush(j=>N(j))})}}class t extends c.$Tc{get recordedInflateBytes(){return this.j?L.$Le.concat(this.f):L.$Le.alloc(0)}constructor(p,v,F,N){super(),this.h=p,this.j=v,this.a=this.B(new b.$je),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(N),this.b.on("error",O=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateError,{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateData,O),this.g.push(L.$Le.wrap(O))}),F&&(this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateInitialWrite,F.buffer),this.b.write(F.buffer),this.b.flush(()=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateWrite,p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=L.$Le.concat(this.g);this.g.length=0,p(v)})}}class o extends c.$Tc{constructor(p,v){super(),this.g=p,this.a=this.B(new b.$je),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",F=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateError,{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateData,F),this.f.push(L.$Le.wrap(F))})}write(p){this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateWrite,p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=L.$Le.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),p(v)})}}function n(A,p){if(p===0)return;const v=A.byteLength>>>2;for(let M=0;M<v;M++){const W=A.readUInt32BE(M*4);A.writeUInt32BE(W^p,M*4)}const F=v*4,N=A.byteLength-F,O=p>>>24&255,j=p>>>16&255,z=p>>>8&255;N>=1&&A.writeUInt8(A.readUInt8(F)^O,F),N>=2&&A.writeUInt8(A.readUInt8(F+1)^j,F+1),N>=3&&A.writeUInt8(A.readUInt8(F+2)^z,F+2)}e.$ti=process.env.XDG_RUNTIME_DIR;const d={[S.Platform.Linux]:107,[S.Platform.Mac]:103};function l(){const A=(0,u.$Yg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const p=process.platform!=="darwin"&&e.$ti?e.$ti:(0,C.tmpdir)(),v=(0,I.$ic)(p,`vscode-ipc-${A}.sock`);return E(v),v}function g(A,p,v){const N=(0,r.createHash)("sha256").update(A).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${v}-${p}-sock`;const O=v.substr(0,4),j=p.substr(0,6);let z;return process.platform!=="darwin"&&e.$ti&&!process.env.VSCODE_PORTABLE?z=(0,I.$ic)(e.$ti,`vscode-${N}-${O}-${j}.sock`):z=(0,I.$ic)(A,`${O}-${j}.sock`),E(z),z}function E(A){const p=d[S.$v];typeof p=="number"&&A.length>=p&&console.warn(`WARNING: IPC handle "${A}" is longer than ${p} chars, try a shorter --user-data-dir`)}class D extends P.$gi{static b(p){const v=b.Event.fromNodeEventEmitter(p,"connection");return b.Event.map(v,F=>({protocol:new w.$ni(new m(F,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(F,"close"))}))}constructor(p){super(D.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$wi=D;function y(A){return new Promise((p,v)=>{const F=(0,h.createServer)();F.on("error",v),F.listen(A,()=>{F.removeListener("error",v),p(new D(F))})})}function k(A,p){return new Promise((v,F)=>{const N=(0,h.createConnection)(A,()=>{N.removeListener("error",F),v(w.$oi.fromSocket(new m(N,`ipc-client${p}`),p))});N.once("error",F)})}}),define(Se[355],De([1,0,67,66,191,130,7,3,10,45,11,115,234,236,117,92,21]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=e.$nhc=e.$mhc=e.$lhc=void 0,r=Ue(r),h=Ue(h);async function $(o,n,d,l,g){let E;for(let D=3;D&&(E?.dispose(),E=await new f(o,n,d,l,g).waitForReady(),!(g&&C.$2g[g]||!C.$2g[E.tunnelLocalPort]));D--);return E}class f extends T.$Tc{constructor(n,d,l,g,E){super(),this.m=d,this.n=E,this.privacy=a.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=r.createServer(),this.c=new L.$Bh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=D=>this.r(D),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=g,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,d=(0,a.$Jw)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,C.$3g)(n,2,1e3,d),g=null;return this.b.listen(l,this.m),await this.c.wait(),g=this.b.address(),g||(l=0,this.b.listen(l,this.m),await this.c.wait(),g=this.b.address()),this.tunnelLocalPort=g.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${g.port}`,this}async r(n){n.pause();const d=(0,a.$Hw)(this.tunnelRemoteHost)||(0,a.$Jw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,u.$Zl)(this.a,d,this.tunnelRemotePort),g=l.getSocket(),E=l.readEntireBuffer();l.dispose(),E.byteLength>0&&n.write(E.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),g.end()}),n.on("close",()=>g.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),g instanceof R.$ri?g.socket.destroy():g.end()}),g instanceof R.$ri?this.t(n,g):this.s(n,g),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),g.end()})}s(n,d){d.onClose(()=>n.destroy()),d.onEnd(()=>n.end()),d.onData(l=>n.write(l.buffer)),n.on("data",l=>d.write(m.$Le.wrap(l))),n.resume()}t(n,d){const l=d.socket;l.on("end",()=>n.end()),l.on("close",()=>n.end()),l.on("error",()=>{n.destroy()}),l.pipe(n),n.pipe(l)}}e.$lhc=f;let i=class extends a.$Mw{constructor(n,d,l,g,E){super(d,E),this.H=n,this.I=l,this.J=g}isPortPrivileged(n){return(0,a.$Kw)(n,this.t,b.OS,h.release())}F(n,d,l,g,E,D,y,k){const A=this.D(d,l);if(A)return++A.refcount,A.value;if((0,a.$Dw)(n))return this.G(n,d,l,E,D,y,k);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${E}.`);const p={commit:this.J.commit,quality:this.J.quality,addressProvider:n,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=$(p,g,d,l,E);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(d,l,v),v}}};e.$mhc=i,e.$mhc=i=Ye([Ve(0,P.$Tl),Ve(1,I.$0j),Ve(2,w.$Wl),Ve(3,S.$qk),Ve(4,c.$9i)],i);let s=class extends i{constructor(n,d,l,g,E){super(n,d,l,g,E)}};e.$nhc=s,e.$nhc=s=Ye([Ve(0,P.$Tl),Ve(1,I.$0j),Ve(2,w.$Wl),Ve(3,S.$qk),Ve(4,c.$9i)],s);let t=class extends T.$Tc{constructor(n,d,l,g,E){super(),this.b=n,this.c=d,this.f=l,this.g=g,this.h=E,this.a=new Map}async openTunnel(n,d,l,g,E,D,y,k,A){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${g} on local port ${D}.`),!this.a.has(n)){const p=new s(this.b,this.c,this.g,this.f,this.h);this.B(p),this.a.set(n,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(d,l,g,E,D,y,k,A)}};e.$ohc=t,e.$ohc=t=Ye([Ve(0,P.$Tl),Ve(1,I.$0j),Ve(2,S.$qk),Ve(3,w.$Wl),Ve(4,c.$9i)],t)}),define(Se[356],De([1,0,130,253,44,34,2,11,46]),function($e,e,r,h,C,R,L,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=e.$DQ=void 0,h=Ue(h),C=Ue(C);class c{constructor(u,P,w){this.b=u,this.c=P,this.f=w,this.a=h.createServer((a,m)=>this.h(a,m)),this.g().catch(a=>(P.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",u=>this.c.error(u))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(u,P){const w=(m,$)=>{P.writeHead(m,{"content-type":"application/json"}),P.end(JSON.stringify($||null),f=>f&&this.c.error(f))},a=[];u.setEncoding("utf8"),u.on("data",m=>a.push(m)),u.on("end",async()=>{try{const m=JSON.parse(a.join(""));let $;switch(m.type){case"open":$=await this.i(m);break;case"openExternal":$=await this.j(m);break;case"status":$=await this.l(m);break;case"extensionManagement":$=await this.k(m);break;default:w(404,`Unknown message type: ${m.type}`);break}w(200,$)}catch(m){const $=m instanceof Error?m.message:JSON.stringify(m);w(500,$),this.c.error("Error while processing pipe request",m)}})}async i(u){const{fileURIs:P,folderURIs:w,forceNewWindow:a,diffMode:m,mergeMode:$,addMode:f,forceReuseWindow:i,gotoLineMode:s,waitMarkerFilePath:t,remoteAuthority:o}=u,n=[];if(Array.isArray(w))for(const E of w)try{n.push({folderUri:L.URI.parse(E)})}catch{}if(Array.isArray(P))for(const E of P)try{(0,b.$8i)(E)?n.push({workspaceUri:L.URI.parse(E)}):n.push({fileUri:L.URI.parse(E)})}catch{}const d=t?L.URI.file(t):void 0,g={forceNewWindow:a,diffMode:m,mergeMode:$,addMode:f,gotoLineMode:s,forceReuseWindow:i,preferNewWindow:!i&&!d&&!f,waitMarkerFileURI:d,remoteAuthority:o};this.b.executeCommand("_remoteCLI.windowOpen",n,g)}async j(u){for(const P of u.uris){const w=L.URI.parse(P),a=w.scheme==="file"?w:P;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k(u){const P=a=>a?.map(m=>/\.vsix$/i.test(m)?L.URI.parse(m):m),w={list:u.list,install:P(u.install),uninstall:P(u.uninstall),force:u.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",w)}async l(u){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&C.existsSync(this.f)&&C.unlinkSync(this.f)}}e.$DQ=c;let I=class extends c{constructor(u,P){super(u,P,(0,r.$ui)())}};e.$EQ=I,e.$EQ=I=Ye([Ve(0,R.$yQ),Ve(1,T.$0j)],I)}),define(Se[357],De([1,0,61,344,339,252,54,326,2,14,9,356,108,286,325]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jrc=void 0,r=Ue(r);class a extends C.$$qc{j(){const f=this,i=globalThis._VSCODE_NODE_MODULES.module,s=i._load;i._load=function(d,l,g){return d=o(d),f.a.has(d)?f.a.get(d).load(d,b.URI.file((0,u.$lr)(l.filename)),E=>s.apply(this,[E,l,g])):s.apply(this,arguments)};const t=i._resolveLookupPaths;i._resolveLookupPaths=(n,d)=>t.call(this,o(n),d);const o=n=>{for(const d of f.b){const l=d(n);if(l){n=l;break}}return n}}}class m extends L.$Wpc{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async vb(){this.h.createInstance(P.$Hrc);const f=this.h.invokeFunction(h.$7qc);if(this.h.createInstance(T.$Grc),this.f.remote.isRemote&&this.f.remote.authority){const t=this.h.createInstance(S.$EQ);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}this.h.createInstance(w.$Irc),await this.h.createInstance(a,f,{mine:this.J,all:this.L}).install(),r.mark("code/extHost/didInitAPI");const s=await this.m.getConfigProvider();await(0,R.$Frc)(this.j,s,this,this.s,this.z,this.f),r.mark("code/extHost/didInitProxyResolver")}wb(f){return f.main}async xb(f,i,s){if(i.scheme!==c.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let t=null;s.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const o=f?.identifier.value;f&&await this.w.initializeLocalizedMessages(f);try{o&&r.mark(`code/extHost/willLoadExtensionCode/${o}`),t=$e.__$__nodeRequire(i.fsPath)}finally{o&&r.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}return t}async $setRemoteEnvironment(f){if(this.f.remote.isRemote)for(const i in f){const s=f[i];s===null?delete process.env[i]:process.env[i]=s}}}e.$Jrc=m}),define(Se[358],De([1,0,44,56,21,4,3,133,10,22,2,33,68,11,233,71,117,92,355,29,19,76,333]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rrc=void 0,e.$Krc=n,e.$Lrc=d,e.$Mrc=l,e.$Nrc=g,e.$Orc=D,e.$Prc=y,e.$Qrc=k,r=Ue(r),c=Ue(c),S=Ue(S);function n(v){const F=v.trim().split(`
`),N=[];return F.forEach(j=>{const z=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(j);z&&z.length>=3&&N.push({pid:parseInt(z[1],10),socket:parseInt(z[2],10)})}),N.reduce((j,z)=>(j[z.socket]=z,j),{})}function d(...v){const F=[].concat(...v.map(g));return[...new Map(F.filter(N=>N.st==="0A").map(N=>{const O=N.local_address.split(":");return{socket:parseInt(N.inode,10),ip:l(O[0]),port:parseInt(O[1],16)}}).map(N=>[N.ip+":"+N.port,N])).values()]}function l(v){let F="";if(v.length===8)for(let N=v.length-2;N>=0;N-=2)F+=parseInt(v.substr(N,2),16),N!==0&&(F+=".");else for(let N=0;N<v.length;N+=8){const O=v.substring(N,N+8);let j="";for(let z=8;z>=2;z-=2)j+=O.substring(z-2,z),(z===6||z===2)&&(j=parseInt(j,16).toString(16),F+=`${j}`,j="",N+z!==v.length-6&&(F+=":"))}return F}function g(v){const F=v.trim().split(`
`),N=F.shift().trim().split(/\s+/).filter(j=>j!=="rx_queue"&&j!=="tm->when");return F.map(j=>j.trim().split(/\s+/).reduce((z,M,W)=>(z[N[W]||W]=M,z),{}))}function E(v){return!!v.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||v.indexOf("out/server-main.js")!==-1||v.indexOf("_productName=VSCode")!==-1}function D(v){const F=v.trim().split(`
`),N=[];return F.forEach(O=>{const j=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);j&&j.length>=4&&N.push({pid:parseInt(j[1],10),ppid:parseInt(j[2]),cmd:j[3]})}),N}async function y(v,F,N){const O=N.reduce((z,M)=>(z[M.pid]=M,z),{}),j=[];return v.forEach(({socket:z,ip:M,port:W})=>{const V=F[z]?F[z].pid:void 0,ne=V?O[V]?.cmd:void 0;V&&ne&&!E(ne)&&j.push({host:M,port:W,detail:ne,pid:V})}),j}function k(v,F,N){const O=new Map,j=D(F);for(const z of v){const M=N.get(z.port);if(M){O.set(z.port,M);continue}const W=j.find(V=>V.cmd.includes(`${z.port}`));if(W){let V=W,ne;do ne=j.find(B=>B.ppid===V.pid),ne&&(V=ne);while(ne);O.set(z.port,{host:z.ip,port:z.port,pid:V.pid,detail:V.cmd,ppid:V.ppid})}else O.set(z.port,{host:z.ip,port:z.port,ppid:Number.MAX_VALUE})}return O}let A=class extends t.$$Fb{constructor(F,N,O,j){super(F,N,O),this.D=N,this.F=j,this.y=void 0,this.z=new Map,this.C=!1,b.$l&&N.remote.isRemote&&N.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(F){if(F&&this.C)return;this.C=F;let N;this.y&&(N=this.y,await this.a.$onFoundNewCandidates(this.y));const O=new T.$Lm;let j=0;for(;this.C;){const z=new Date().getTime(),M=(await this.I()).filter(ne=>(0,$.$Hw)(ne.host)||(0,$.$Jw)(ne.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(ne=>ne.port).join(", ")}`);const W=new Date().getTime()-z;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${W} ms.`),j++>3&&O.update(W),(!N||JSON.stringify(N)!==JSON.stringify(M))&&(N=M,await this.a.$onFoundNewCandidates(N));const V=this.G(O.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${V} ms.`),await new Promise(ne=>setTimeout(()=>ne(),V))}}G(F){return Math.max(F*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(F=>F.port).join(", ")}`)}async I(){let F="",N="";try{F=await r.promises.readFile("/proc/net/tcp","utf8"),N=await r.promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=d(F,N),j=await new Promise(Y=>{(0,h.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(ee,ue,re)=>{Y(ue)})}),z=n(j),M=await S.Promises.readdir("/proc"),W=[];for(const Y of M)try{const ee=Number(Y),ue=c.$dh(I.URI.file("/proc"),Y);if((await r.promises.stat(ue.fsPath)).isDirectory()&&!isNaN(ee)){const ye=await r.promises.readlink(c.$dh(ue,"cwd").fsPath),me=await r.promises.readFile(c.$dh(ue,"cmdline").fsPath,"utf8");W.push({pid:ee,cwd:ye,cmd:me})}}catch{}const V=[],ne=O.filter(Y=>{const ee=z[Y.socket];return ee||V.push(Y),ee}),B=y(ne,z,W);let K;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${V.length}`),V.length>0){const Y=await new Promise(ee=>{(0,h.exec)("ps -F -A -l | grep root",(ue,re,ye)=>{ee(re)})});this.z=k(V,Y,this.z),K=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${K.map(ee=>ee.port).join(", ")}`)}return B.then(Y=>K?Y.concat(K):Y)}w(F){return async N=>{const O=new f.$lhc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(z,M,W,V){const ne=await F.makeConnection();return p.connect(ne,M,W,V)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new a.$Pl(0),connectionToken:F.connectionToken})}},signService:this.F},"localhost",N.remoteAddress.host||"localhost",N.remoteAddress.port,N.localAddressPort);await O.waitForReady();const j=new R.$je;return{localAddress:(0,o.$4M)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:j.event,dispose:()=>{O.dispose(),j.fire(),j.dispose()}}}}};e.$Rrc=A,e.$Rrc=A=Ye([Ve(0,s.$cQ),Ve(1,i.$sQ),Ve(2,P.$0j),Ve(3,m.$Wl)],A);class p extends w.$txb{static connect(F,N,O,j){const z=new L.$Sc,M={onClose:z.add(new R.$je),onData:z.add(new R.$je),onEnd:z.add(new R.$je)};z.add(F.onDidReceiveMessage(V=>M.onData.fire(C.$Le.wrap(V)))),z.add(F.onDidEnd(()=>M.onEnd.fire())),z.add(F.onDidClose(V=>M.onClose.fire({type:u.SocketCloseEventType.NodeSocketCloseEvent,error:V,hadError:!!V})));const W=new p(F,j,M);return W.B(z),(0,w.$sxb)(W,N,O,j,M)}constructor(F,N,O){super(N,O),this.n=F}write(F){this.n.send(F.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[359],De([1,0,88,328,342,341,354,357,358,101,54,102,100,47,76,97,327,287,11,343,64,248,112,117,148]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$,f,i,s,t,o,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Os)(I.$Xpc,T.$Jrc,r.InstantiationType.Eager),(0,r.$Os)(f.$$j,$.$Trc,r.InstantiationType.Delayed),(0,r.$Os)(f.$0j,new o.$zi(t.$0qc,[!1],!0)),(0,r.$Os)(n.$Wl,d.$qhc,r.InstantiationType.Delayed),(0,r.$Os)(a.$npc,m.$Src,r.InstantiationType.Eager),(0,r.$Os)(c.$8pc,R.$krc,r.InstantiationType.Eager),(0,r.$Os)(S.$rqc,L.$Erc,r.InstantiationType.Eager),(0,r.$Os)(u.$Uqc,C.$crc,r.InstantiationType.Eager),(0,r.$Os)(P.$Ipc,h.$brc,r.InstantiationType.Eager),(0,r.$Os)(w.$0Fb,b.$Rrc,r.InstantiationType.Eager),(0,r.$Os)(s.$1pc,i.$Urc,r.InstantiationType.Eager)});var Wt=this&&this.__importDefault||function($e){return $e&&$e.__esModule?$e:{default:$e}};define(Se[369],De([1,0,370,67,7,21,13,61,108,33,68,130,113,231,340,254,269,93,345,359]),function($e,e,r,h,C,R,L,T,b,c,I,S,u,P,w,a,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=Wt(r),h=Ue(h),T=Ue(T),P=Wt(P),function(){for(let D=0;D<process.execArgv.length;D++)process.execArgv[D]==="--inspect-port=0"&&(process.execArgv.splice(D,1),D--)}();const f=(0,r.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const E=globalThis._VSCODE_NODE_MODULES.module,D=E._load;E._load=function(y){if(y==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return D.apply(this,arguments)}})();const i=process.exit.bind(process),s=process.on.bind(process);function t(E){process.exit=function(D){if(E)i(D);else{const y=new Error("An extension called process.exit() and this was prevented.");console.warn(y.stack)}},process.crash=function(){const D=new Error("An extension called process.crash() and this was prevented.");console.warn(D.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(D,y){D==="uncaughtException"&&(y=function(){try{return y.call(void 0,arguments)}catch{}}),s(D,y)}}let o=function(E){i()};function n(){const E=(0,m.$dn)(process.env);if(E.type===m.ExtHostConnectionType.MessagePort)return new Promise((D,y)=>{const k=A=>{const p=A[0],v=new I.$pi;p.on("message",F=>v.fire(R.$Le.wrap(F.data))),p.on("close",()=>{o("renderer closed the MessagePort")}),p.start(),D({onMessage:v.event,send:F=>p.postMessage(F.buffer)})};process.parentPort.on("message",A=>k(A.ports))});if(E.type===m.ExtHostConnectionType.Socket)return new Promise((D,y)=>{let k=null;const A=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),p=I.ProtocolConstants.ReconnectionGraceTime,v=I.ProtocolConstants.ReconnectionShortGraceTime,F=new C.$Ph(()=>o("renderer disconnected for too long (1)"),p),N=new C.$Ph(()=>o("renderer disconnected for too long (2)"),v);process.on("message",(j,z)=>{if(j&&j.type==="VSCODE_EXTHOST_IPC_SOCKET"){z.setNoDelay(!0);const M=R.$Le.wrap(Buffer.from(j.initialDataChunk,"base64"));let W;if(j.skipWebSocketFrames)W=new S.$ri(z,"extHost-socket");else{const V=R.$Le.wrap(Buffer.from(j.inflateBytes,"base64"));W=new S.$si(new S.$ri(z,"extHost-socket"),j.permessageDeflate,V,!1)}k?(F.cancel(),N.cancel(),k.beginAcceptReconnection(W,M),k.endAcceptReconnection(),k.sendResume()):(clearTimeout(A),k=new I.$qi({socket:W,initialChunk:M}),k.sendResume(),k.onDidDispose(()=>o("renderer disconnected")),D(k),k.onSocketClose(()=>{F.schedule()}))}if(j&&j.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;F.isScheduled()&&N.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(O)});{const D=E.pipeName;return new Promise((y,k)=>{const A=h.createConnection(D,()=>{A.removeListener("error",k);const p=new I.$qi({socket:new S.$ri(A,"extHost-renderer")});p.sendResume(),y(p)});A.once("error",k),A.on("close",()=>{o("renderer closed the socket")})})}}async function d(){const E=await n();return new class{constructor(){this.a=new I.$pi,this.onMessage=this.a.event,this.b=!1,this.d=E.onMessage(D=>{(0,$.$zn)(D,$.MessageType.Terminate)?(this.b=!0,this.d.dispose(),o("received terminate message from renderer")):this.a.fire(D)})}send(D){this.b||E.send(D)}async drain(){if(E.drain)return E.drain()}}}function l(E){return new Promise(D=>{const y=E.onMessage(k=>{y.dispose();const A=JSON.parse(k.toString()),p=A.commit,v=P.default.commit;if(p&&v&&p!==v&&i($.ExtensionHostExitCode.VersionMismatch),A.parentPid){let F=0;setInterval(function(){try{process.kill(A.parentPid,0),F=0}catch(O){O&&O.code==="EPERM"?(F++,F>=3&&o(`parent process ${A.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):o(`parent process ${A.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(A.parentPid)}catch(O){(0,L.$Y)(O)}}E.send((0,$.$yn)($.MessageType.Initialized)),D({protocol:E,initData:A})});E.send((0,$.$yn)($.MessageType.Ready))})}async function g(){const E=[];process.on("unhandledRejection",(F,N)=>{E.push(N),setTimeout(()=>{const O=E.indexOf(N);O>=0&&N.catch(j=>{E.splice(O,1),(0,L.$3)(j)||(console.warn(`rejected promise not handled within 1 second: ${j}`),j&&j.stack&&console.warn(`stack trace: ${j.stack}`),F&&(0,L.$Y)(F))})},1e3)}),process.on("rejectionHandled",F=>{const N=E.indexOf(F);N>=0&&E.splice(N,1)}),process.on("uncaughtException",function(F){(0,L.$X)(F)||(0,L.$Y)(F)}),T.mark("code/extHost/willConnectToRenderer");const D=await d();T.mark("code/extHost/didConnectToRenderer");const y=await l(D);T.mark("code/extHost/didWaitForInitData");const{initData:k}=y;t(!!k.environment.extensionTestsLocationURI),k.environment.useHostProxy=f.useHostProxy!==void 0?f.useHostProxy!=="false":void 0,k.environment.skipWorkspaceStorageLock=(0,u.boolean)(f.skipWorkspaceStorageLock,!1);const A=new class{constructor(){this.pid=process.pid}exit(N){i(N)}fsExists(N){return c.Promises.exists(N)}fsRealpath(N){return(0,b.$kr)(N)}};let p=null;k.remote.authority&&f.transformURIs&&(p=(0,a.$Ss)(k.remote.authority));const v=new w.$arc(y.protocol,k,A,p);o=F=>v.terminate(F)}g().catch(E=>console.log(E))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/4a103b0eea7de96d12fc2cbada846ca7ef4f1298/core/vs/workbench/api/node/extensionHostProcess.js.map
