/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Oe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshallingIds","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/extpath","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/comparers","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ne=function(be){for(var e=[],v=0,I=be.length;v<I;v++)e[v]=Oe[be[v]];return e};define(Oe[71],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=I,e.$8h=P,e.$9h=O;function v(R){return(T,$,s)=>{let A=null,y=null;if(typeof s.value=="function"?(A="value",y=s.value):typeof s.get=="function"&&(A="get",y=s.get),!y)throw new Error("not supported");s[A]=R(y,$)}}function I(R,T,$){let s=null,A=null;if(typeof $.value=="function"?(s="value",A=$.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(s="get",A=$.get),!A)throw new Error("not supported");const y=`$memoize$${T}`;$[s]=function(...a){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,a)}),this[y]}}function P(R,T,$){return v((s,A)=>{const y=`$debounce$${A}`,a=`$debounce$result$${A}`;return function(...S){this[a]||(this[a]=$?$():void 0),clearTimeout(this[y]),T&&(this[a]=T(this[a],...S),S=[this[a]]),this[y]=setTimeout(()=>{s.apply(this,S),this[a]=$?$():void 0},R)}})}function O(R,T,$){return v((s,A)=>{const y=`$throttle$timer$${A}`,a=`$throttle$result$${A}`,S=`$throttle$lastRun$${A}`,d=`$throttle$pending$${A}`;return function(...n){if(this[a]||(this[a]=$?$():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),T&&(this[a]=T(this[a],...n)),this[d])return;const o=this[S]+R;o<=Date.now()?(this[S]=Date.now(),s.apply(this,[this[a]]),this[a]=$?$():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[S]=Date.now(),s.apply(this,[this[a]]),this[a]=$?$():void 0},o-Date.now()))}})}});var Hn=this&&this.__createBinding||(Object.create?function(be,e,v,I){I===void 0&&(I=v);var P=Object.getOwnPropertyDescriptor(e,v);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[v]}}),Object.defineProperty(be,I,P)}:function(be,e,v,I){I===void 0&&(I=v),be[I]=e[v]}),Qn=this&&this.__setModuleDefault||(Object.create?function(be,e){Object.defineProperty(be,"default",{enumerable:!0,value:e})}:function(be,e){be.default=e}),We=this&&this.__importStar||function(be){if(be&&be.__esModule)return be;var e={};if(be!=null)for(var v in be)v!=="default"&&Object.prototype.hasOwnProperty.call(be,v)&&Hn(e,be,v);return Qn(e,be),e};define(Oe[135],Ne([1,0,17]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0,e.$6c=P,e.$7c=O,e.$8c=R,e.$9c=T,e.$0c=$,e.$$c=s,v=We(v);const I=(S,d)=>S===d;e.$5c=I;function P(S=e.$5c){return(d,n)=>v.$tb(d,n,S)}function O(){return(S,d)=>JSON.stringify(S)===JSON.stringify(d)}function R(){return(S,d)=>S.equals(d)}function T(S,d,n){if(n!==void 0){const o=S;return o==null||d===void 0||d===null?d===o:n(o,d)}else{const o=S;return(c,l)=>c==null||l===void 0||l===null?l===c:o(c,l)}}function $(S,d){if(S===d)return!0;if(Array.isArray(S)&&Array.isArray(d)){if(S.length!==d.length)return!1;for(let n=0;n<S.length;n++)if(!$(S[n],d[n]))return!1;return!0}if(S&&typeof S=="object"&&d&&typeof d=="object"&&Object.getPrototypeOf(S)===Object.prototype&&Object.getPrototypeOf(d)===Object.prototype){const n=S,o=d,c=Object.keys(n),l=Object.keys(o),i=new Set(l);if(c.length!==l.length)return!1;for(const r of c)if(!i.has(r)||!$(n[r],o[r]))return!1;return!0}return!1}function s(S){return JSON.stringify(a(S))}let A=0;const y=new WeakMap;function a(S){if(Array.isArray(S))return S.map(a);if(S&&typeof S=="object")if(Object.getPrototypeOf(S)===Object.prototype){const d=S,n=Object.create(null);for(const o of Object.keys(d).sort())n[o]=a(d[o]);return n}else{let d=y.get(S);return d===void 0&&(d=A++,y.set(S,d)),d+"----2b76a038c20c4bcc"}return S}}),define(Oe[96],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$hQ=void 0;class v{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$hQ=v,e.$iQ=new v("id#")}),define(Oe[136],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Tn=R,e.$Un=y,e.$Vn=a,e.$Wn=S,e.$Xn=d,e.$Yn=n,e.$Zn=o,e.$1n=c,e.$2n=l,e.$3n=i,e.$4n=r;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I||(e.SyntaxKind=I={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function R(t,g=!1){let u=0;const m=t.length;let p="",h=0,E=I.Unknown,D=v.None;function b(L){let W=0,G=0;for(;W<L;){const F=t.charCodeAt(u);if(F>=A._0&&F<=A._9)G=G*16+F-A._0;else if(F>=A.A&&F<=A.F)G=G*16+F-A.A+10;else if(F>=A.a&&F<=A.f)G=G*16+F-A.a+10;else break;u++,W++}return W<L&&(G=-1),G}function k(L){u=L,p="",h=0,E=I.Unknown,D=v.None}function C(){const L=u;if(t.charCodeAt(u)===A._0)u++;else for(u++;u<t.length&&s(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===A.dot)if(u++,u<t.length&&s(t.charCodeAt(u)))for(u++;u<t.length&&s(t.charCodeAt(u));)u++;else return D=v.UnexpectedEndOfNumber,t.substring(L,u);let W=u;if(u<t.length&&(t.charCodeAt(u)===A.E||t.charCodeAt(u)===A.e))if(u++,(u<t.length&&t.charCodeAt(u)===A.plus||t.charCodeAt(u)===A.minus)&&u++,u<t.length&&s(t.charCodeAt(u))){for(u++;u<t.length&&s(t.charCodeAt(u));)u++;W=u}else D=v.UnexpectedEndOfNumber;return t.substring(L,W)}function f(){let L="",W=u;for(;;){if(u>=m){L+=t.substring(W,u),D=v.UnexpectedEndOfString;break}const G=t.charCodeAt(u);if(G===A.doubleQuote){L+=t.substring(W,u),u++;break}if(G===A.backslash){if(L+=t.substring(W,u),u++,u>=m){D=v.UnexpectedEndOfString;break}switch(t.charCodeAt(u++)){case A.doubleQuote:L+='"';break;case A.backslash:L+="\\";break;case A.slash:L+="/";break;case A.b:L+="\b";break;case A.f:L+="\f";break;case A.n:L+=`
`;break;case A.r:L+="\r";break;case A.t:L+="	";break;case A.u:{const K=b(4);K>=0?L+=String.fromCharCode(K):D=v.InvalidUnicode;break}default:D=v.InvalidEscapeCharacter}W=u;continue}if(G>=0&&G<=31)if($(G)){L+=t.substring(W,u),D=v.UnexpectedEndOfString;break}else D=v.InvalidCharacter;u++}return L}function w(){if(p="",D=v.None,h=u,u>=m)return h=m,E=I.EOF;let L=t.charCodeAt(u);if(T(L)){do u++,p+=String.fromCharCode(L),L=t.charCodeAt(u);while(T(L));return E=I.Trivia}if($(L))return u++,p+=String.fromCharCode(L),L===A.carriageReturn&&t.charCodeAt(u)===A.lineFeed&&(u++,p+=`
`),E=I.LineBreakTrivia;switch(L){case A.openBrace:return u++,E=I.OpenBraceToken;case A.closeBrace:return u++,E=I.CloseBraceToken;case A.openBracket:return u++,E=I.OpenBracketToken;case A.closeBracket:return u++,E=I.CloseBracketToken;case A.colon:return u++,E=I.ColonToken;case A.comma:return u++,E=I.CommaToken;case A.doubleQuote:return u++,p=f(),E=I.StringLiteral;case A.slash:{const W=u-1;if(t.charCodeAt(u+1)===A.slash){for(u+=2;u<m&&!$(t.charCodeAt(u));)u++;return p=t.substring(W,u),E=I.LineCommentTrivia}if(t.charCodeAt(u+1)===A.asterisk){u+=2;const G=m-1;let F=!1;for(;u<G;){if(t.charCodeAt(u)===A.asterisk&&t.charCodeAt(u+1)===A.slash){u+=2,F=!0;break}u++}return F||(u++,D=v.UnexpectedEndOfComment),p=t.substring(W,u),E=I.BlockCommentTrivia}return p+=String.fromCharCode(L),u++,E=I.Unknown}case A.minus:if(p+=String.fromCharCode(L),u++,u===m||!s(t.charCodeAt(u)))return E=I.Unknown;case A._0:case A._1:case A._2:case A._3:case A._4:case A._5:case A._6:case A._7:case A._8:case A._9:return p+=C(),E=I.NumericLiteral;default:for(;u<m&&M(L);)u++,L=t.charCodeAt(u);if(h!==u){switch(p=t.substring(h,u),p){case"true":return E=I.TrueKeyword;case"false":return E=I.FalseKeyword;case"null":return E=I.NullKeyword}return E=I.Unknown}return p+=String.fromCharCode(L),u++,E=I.Unknown}}function M(L){if(T(L)||$(L))return!1;switch(L){case A.closeBrace:case A.closeBracket:case A.openBrace:case A.openBracket:case A.doubleQuote:case A.colon:case A.comma:case A.slash:return!1}return!0}function N(){let L;do L=w();while(L>=I.LineCommentTrivia&&L<=I.Trivia);return L}return{setPosition:k,getPosition:()=>u,scan:g?N:w,getToken:()=>E,getTokenValue:()=>p,getTokenOffset:()=>h,getTokenLength:()=>u-h,getTokenError:()=>D}}function T(t){return t===A.space||t===A.tab||t===A.verticalTab||t===A.formFeed||t===A.nonBreakingSpace||t===A.ogham||t>=A.enQuad&&t<=A.zeroWidthSpace||t===A.narrowNoBreakSpace||t===A.mathematicalSpace||t===A.ideographicSpace||t===A.byteOrderMark}function $(t){return t===A.lineFeed||t===A.carriageReturn||t===A.lineSeparator||t===A.paragraphSeparator}function s(t){return t>=A._0&&t<=A._9}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function y(t,g){const u=[],m=new Object;let p;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function D(b,k,C,f){h.value=b,h.offset=k,h.length=C,h.type=f,h.colonOffset=void 0,p=h}try{i(t,{onObjectBegin:(b,k)=>{if(g<=b)throw m;p=void 0,E=g>b,u.push("")},onObjectProperty:(b,k,C)=>{if(g<k||(D(b,k,C,"property"),u[u.length-1]=b,g<=k+C))throw m},onObjectEnd:(b,k)=>{if(g<=b)throw m;p=void 0,u.pop()},onArrayBegin:(b,k)=>{if(g<=b)throw m;p=void 0,u.push(0)},onArrayEnd:(b,k)=>{if(g<=b)throw m;p=void 0,u.pop()},onLiteralValue:(b,k,C)=>{if(g<k||(D(b,k,C,r(b)),g<=k+C))throw m},onSeparator:(b,k,C)=>{if(g<=k)throw m;if(b===":"&&p&&p.type==="property")p.colonOffset=k,E=!1,p=void 0;else if(b===","){const f=u[u.length-1];typeof f=="number"?u[u.length-1]=f+1:(E=!0,u[u.length-1]=""),p=void 0}}})}catch(b){if(b!==m)throw b}return{path:u,previousNode:p,isAtPropertyKey:E,matches:b=>{let k=0;for(let C=0;k<b.length&&C<u.length;C++)if(b[k]===u[C]||b[k]==="*")k++;else if(b[k]!=="**")return!1;return k===b.length}}}function a(t,g=[],u=O.DEFAULT){let m=null,p=[];const h=[];function E(b){Array.isArray(p)?p.push(b):m!==null&&(p[m]=b)}return i(t,{onObjectBegin:()=>{const b={};E(b),h.push(p),p=b,m=null},onObjectProperty:b=>{m=b},onObjectEnd:()=>{p=h.pop()},onArrayBegin:()=>{const b=[];E(b),h.push(p),p=b,m=null},onArrayEnd:()=>{p=h.pop()},onLiteralValue:E,onError:(b,k,C)=>{g.push({error:b,offset:k,length:C})}},u),p[0]}function S(t,g=[],u=O.DEFAULT){let m={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(b){m.type==="property"&&(m.length=b-m.offset,m=m.parent)}function h(b){return m.children.push(b),b}i(t,{onObjectBegin:b=>{m=h({type:"object",offset:b,length:-1,parent:m,children:[]})},onObjectProperty:(b,k,C)=>{m=h({type:"property",offset:k,length:-1,parent:m,children:[]}),m.children.push({type:"string",value:b,offset:k,length:C,parent:m})},onObjectEnd:(b,k)=>{m.length=b+k-m.offset,m=m.parent,p(b+k)},onArrayBegin:(b,k)=>{m=h({type:"array",offset:b,length:-1,parent:m,children:[]})},onArrayEnd:(b,k)=>{m.length=b+k-m.offset,m=m.parent,p(b+k)},onLiteralValue:(b,k,C)=>{h({type:r(b),offset:k,length:C,parent:m,value:b}),p(k+C)},onSeparator:(b,k,C)=>{m.type==="property"&&(b===":"?m.colonOffset=k:b===","&&p(k))},onError:(b,k,C)=>{g.push({error:b,offset:k,length:C})}},u);const D=m.children[0];return D&&delete D.parent,D}function d(t,g){if(!t)return;let u=t;for(const m of g)if(typeof m=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let p=!1;for(const h of u.children)if(Array.isArray(h.children)&&h.children[0].value===m){u=h.children[1],p=!0;break}if(!p)return}else{const p=m;if(u.type!=="array"||p<0||!Array.isArray(u.children)||p>=u.children.length)return;u=u.children[p]}return u}function n(t){if(!t.parent||!t.parent.children)return[];const g=n(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;g.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&g.push(u)}return g}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const g=Object.create(null);for(const u of t.children){const m=u.children[1];m&&(g[u.children[0].value]=o(m))}return g}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function c(t,g,u=!1){return g>=t.offset&&g<t.offset+t.length||u&&g===t.offset+t.length}function l(t,g,u=!1){if(c(t,g,u)){const m=t.children;if(Array.isArray(m))for(let p=0;p<m.length&&m[p].offset<=g;p++){const h=l(m[p],g,u);if(h)return h}return t}}function i(t,g,u=O.DEFAULT){const m=R(t,!1);function p(ae){return ae?()=>ae(m.getTokenOffset(),m.getTokenLength()):()=>!0}function h(ae){return ae?$e=>ae($e,m.getTokenOffset(),m.getTokenLength()):()=>!0}const E=p(g.onObjectBegin),D=h(g.onObjectProperty),b=p(g.onObjectEnd),k=p(g.onArrayBegin),C=p(g.onArrayEnd),f=h(g.onLiteralValue),w=h(g.onSeparator),M=p(g.onComment),N=h(g.onError),L=u&&u.disallowComments,W=u&&u.allowTrailingComma;function G(){for(;;){const ae=m.scan();switch(m.getTokenError()){case v.InvalidUnicode:F(P.InvalidUnicode);break;case v.InvalidEscapeCharacter:F(P.InvalidEscapeCharacter);break;case v.UnexpectedEndOfNumber:F(P.UnexpectedEndOfNumber);break;case v.UnexpectedEndOfComment:L||F(P.UnexpectedEndOfComment);break;case v.UnexpectedEndOfString:F(P.UnexpectedEndOfString);break;case v.InvalidCharacter:F(P.InvalidCharacter);break}switch(ae){case I.LineCommentTrivia:case I.BlockCommentTrivia:L?F(P.InvalidCommentToken):M();break;case I.Unknown:F(P.InvalidSymbol);break;case I.Trivia:case I.LineBreakTrivia:break;default:return ae}}}function F(ae,$e=[],oe=[]){if(N(ae),$e.length+oe.length>0){let Ce=m.getToken();for(;Ce!==I.EOF;){if($e.indexOf(Ce)!==-1){G();break}else if(oe.indexOf(Ce)!==-1)break;Ce=G()}}}function K(ae){const $e=m.getTokenValue();return ae?f($e):D($e),G(),!0}function Y(){switch(m.getToken()){case I.NumericLiteral:{let ae=0;try{ae=JSON.parse(m.getTokenValue()),typeof ae!="number"&&(F(P.InvalidNumberFormat),ae=0)}catch{F(P.InvalidNumberFormat)}f(ae);break}case I.NullKeyword:f(null);break;case I.TrueKeyword:f(!0);break;case I.FalseKeyword:f(!1);break;default:return!1}return G(),!0}function le(){return m.getToken()!==I.StringLiteral?(F(P.PropertyNameExpected,[],[I.CloseBraceToken,I.CommaToken]),!1):(K(!1),m.getToken()===I.ColonToken?(w(":"),G(),se()||F(P.ValueExpected,[],[I.CloseBraceToken,I.CommaToken])):F(P.ColonExpected,[],[I.CloseBraceToken,I.CommaToken]),!0)}function _(){E(),G();let ae=!1;for(;m.getToken()!==I.CloseBraceToken&&m.getToken()!==I.EOF;){if(m.getToken()===I.CommaToken){if(ae||F(P.ValueExpected,[],[]),w(","),G(),m.getToken()===I.CloseBraceToken&&W)break}else ae&&F(P.CommaExpected,[],[]);le()||F(P.ValueExpected,[],[I.CloseBraceToken,I.CommaToken]),ae=!0}return b(),m.getToken()!==I.CloseBraceToken?F(P.CloseBraceExpected,[I.CloseBraceToken],[]):G(),!0}function ge(){k(),G();let ae=!1;for(;m.getToken()!==I.CloseBracketToken&&m.getToken()!==I.EOF;){if(m.getToken()===I.CommaToken){if(ae||F(P.ValueExpected,[],[]),w(","),G(),m.getToken()===I.CloseBracketToken&&W)break}else ae&&F(P.CommaExpected,[],[]);se()||F(P.ValueExpected,[],[I.CloseBracketToken,I.CommaToken]),ae=!0}return C(),m.getToken()!==I.CloseBracketToken?F(P.CloseBracketExpected,[I.CloseBracketToken],[]):G(),!0}function se(){switch(m.getToken()){case I.OpenBracketToken:return ge();case I.OpenBraceToken:return _();case I.StringLiteral:return K(!0);default:return Y()}}return G(),m.getToken()===I.EOF?u.allowEmptyContent?!0:(F(P.ValueExpected,[],[]),!1):se()?(m.getToken()!==I.EOF&&F(P.EndOfFileExpected,[],[]),!0):(F(P.ValueExpected,[],[]),!1)}function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Oe[137],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=v;function v(O){let R=!1;const T=new Map,$=new Map;if(P(O,n=>{if(O===n)return!0;const o=JSON.stringify(n);if(o.length<30)return!0;const c=T.get(o);if(!c){const l={schemas:[n]};return T.set(o,l),$.set(n,l),!0}return c.schemas.push(n),$.set(n,c),R=!0,!1}),T.clear(),!R)return JSON.stringify(O);let A="$defs";for(;O.hasOwnProperty(A);)A+="_";const y=[];function a(n){return JSON.stringify(n,(o,c)=>{if(c!==n){const l=$.get(c);if(l&&l.schemas.length>1)return l.id||(l.id=`_${y.length}`,y.push(l.schemas[0])),{$ref:`#/${A}/${l.id}`}}return c})}const S=a(O),d=[];for(let n=0;n<y.length;n++)d.push(`"_${n}":${a(y[n])}`);return d.length?`${S.substring(0,S.length-1)},"${A}":{${d.join(",")}}}`:S}function I(O){return typeof O=="object"&&O!==null}function P(O,R){if(!O||typeof O!="object")return;const T=(...S)=>{for(const d of S)I(d)&&y.push(d)},$=(...S)=>{for(const d of S)if(I(d))for(const n in d){const o=d[n];I(o)&&y.push(o)}},s=(...S)=>{for(const d of S)if(Array.isArray(d))for(const n of d)I(n)&&y.push(n)},A=S=>{if(Array.isArray(S))for(const d of S)I(d)&&y.push(d);else I(S)&&y.push(S)},y=[O];let a=y.pop();for(;a;)R(a)&&(T(a.additionalItems,a.additionalProperties,a.not,a.contains,a.propertyNames,a.if,a.then,a.else,a.unevaluatedItems,a.unevaluatedProperties),$(a.definitions,a.$defs,a.properties,a.patternProperties,a.dependencies,a.dependentSchemas),s(a.anyOf,a.allOf,a.oneOf,a.prefixItems),A(a.items)),a=y.pop()}}),function(be,e){typeof define=="function"&&define.amd?define(Oe[138],Ne([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(ce,we){for(var ue=0;ue<we.length;ue++){var X=we[ue];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(ce,X.key,X)}}function v(ce,we,ue){return we&&e(ce.prototype,we),ue&&e(ce,ue),Object.defineProperty(ce,"prototype",{writable:!1}),ce}function I(ce,we){if(ce){if(typeof ce=="string")return P(ce,we);var ue=Object.prototype.toString.call(ce).slice(8,-1);if(ue==="Object"&&ce.constructor&&(ue=ce.constructor.name),ue==="Map"||ue==="Set")return Array.from(ce);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return P(ce,we)}}function P(ce,we){(we==null||we>ce.length)&&(we=ce.length);for(var ue=0,X=new Array(we);ue<we;ue++)X[ue]=ce[ue];return X}function O(ce,we){var ue=typeof Symbol<"u"&&ce[Symbol.iterator]||ce["@@iterator"];if(ue)return(ue=ue.call(ce)).next.bind(ue);if(Array.isArray(ce)||(ue=I(ce))||we&&ce&&typeof ce.length=="number"){ue&&(ce=ue);var X=0;return function(){return X>=ce.length?{done:!0}:{done:!1,value:ce[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=R();function T(ce){be.defaults=ce}var $=/[&<>"']/,s=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(we){return a[we]};function d(ce,we){if(we){if($.test(ce))return ce.replace(s,S)}else if(A.test(ce))return ce.replace(y,S);return ce}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ce){return ce.replace(n,function(we,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var c=/(^|[^\[])\^/g;function l(ce,we){ce=typeof ce=="string"?ce:ce.source,we=we||"";var ue={replace:function(x,me){return me=me.source||me,me=me.replace(c,"$1"),ce=ce.replace(x,me),ue},getRegex:function(){return new RegExp(ce,we)}};return ue}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(ce,we,ue){if(ce){var X;try{X=decodeURIComponent(o(ue)).replace(i,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}we&&!r.test(ue)&&(ue=h(we,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var g={},u=/^[^:]+:\/*[^/]*$/,m=/^([^:]+:)[\s\S]*$/,p=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(ce,we){g[" "+ce]||(u.test(ce)?g[" "+ce]=ce+"/":g[" "+ce]=k(ce,"/",!0)),ce=g[" "+ce];var ue=ce.indexOf(":")===-1;return we.substring(0,2)==="//"?ue?we:ce.replace(m,"$1")+we:we.charAt(0)==="/"?ue?we:ce.replace(p,"$1")+we:ce+we}var E={exec:function(){}};function D(ce){for(var we=1,ue,X;we<arguments.length;we++){ue=arguments[we];for(X in ue)Object.prototype.hasOwnProperty.call(ue,X)&&(ce[X]=ue[X])}return ce}function b(ce,we){var ue=ce.replace(/\|/g,function(me,pe,Re){for(var ze=!1,ke=pe;--ke>=0&&Re[ke]==="\\";)ze=!ze;return ze?"|":" |"}),X=ue.split(/ \|/),x=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>we)X.splice(we);else for(;X.length<we;)X.push("");for(;x<X.length;x++)X[x]=X[x].trim().replace(/\\\|/g,"|");return X}function k(ce,we,ue){var X=ce.length;if(X===0)return"";for(var x=0;x<X;){var me=ce.charAt(X-x-1);if(me===we&&!ue)x++;else if(me!==we&&ue)x++;else break}return ce.slice(0,X-x)}function C(ce,we){if(ce.indexOf(we[1])===-1)return-1;for(var ue=ce.length,X=0,x=0;x<ue;x++)if(ce[x]==="\\")x++;else if(ce[x]===we[0])X++;else if(ce[x]===we[1]&&(X--,X<0))return x;return-1}function f(ce){ce&&ce.sanitize&&!ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function w(ce,we){if(we<1)return"";for(var ue="";we>1;)we&1&&(ue+=ce),we>>=1,ce+=ce;return ue+ce}function M(ce,we,ue,X){var x=we.href,me=we.title?d(we.title):null,pe=ce[1].replace(/\\([\[\]])/g,"$1");if(ce[0].charAt(0)!=="!"){X.state.inLink=!0;var Re={type:"link",raw:ue,href:x,title:me,text:pe,tokens:X.inlineTokens(pe)};return X.state.inLink=!1,Re}return{type:"image",raw:ue,href:x,title:me,text:d(pe)}}function N(ce,we){var ue=ce.match(/^(\s+)(?:```)/);if(ue===null)return we;var X=ue[1];return we.split(`
`).map(function(x){var me=x.match(/^\s+/);if(me===null)return x;var pe=me[0];return pe.length>=X.length?x.slice(X.length):x}).join(`
`)}var L=function(){function ce(ue){this.options=ue||be.defaults}var we=ce.prototype;return we.space=function(X){var x=this.rules.block.newline.exec(X);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},we.code=function(X){var x=this.rules.block.code.exec(X);if(x){var me=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?me:k(me,`
`)}}},we.fences=function(X){var x=this.rules.block.fences.exec(X);if(x){var me=x[0],pe=N(me,x[3]||"");return{type:"code",raw:me,lang:x[2]?x[2].trim():x[2],text:pe}}},we.heading=function(X){var x=this.rules.block.heading.exec(X);if(x){var me=x[2].trim();if(/#$/.test(me)){var pe=k(me,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(me=pe.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:me,tokens:this.lexer.inline(me)}}},we.hr=function(X){var x=this.rules.block.hr.exec(X);if(x)return{type:"hr",raw:x[0]}},we.blockquote=function(X){var x=this.rules.block.blockquote.exec(X);if(x){var me=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},we.list=function(X){var x=this.rules.block.list.exec(X);if(x){var me,pe,Re,ze,ke,Pe,Te,U,B,H,V,ne,fe=x[1].trim(),Ie=fe.length>1,je={type:"list",raw:"",ordered:Ie,start:Ie?+fe.slice(0,-1):"",loose:!1,items:[]};fe=Ie?"\\d{1,9}\\"+fe.slice(-1):"\\"+fe,this.options.pedantic&&(fe=Ie?fe:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(ne=!1,!(!(x=Qe.exec(X))||this.rules.block.hr.test(X)));){if(me=x[0],X=X.substring(me.length),U=x[2].split(`
`,1)[0],B=X.split(`
`,1)[0],this.options.pedantic?(ze=2,V=U.trimLeft()):(ze=x[2].search(/[^ ]/),ze=ze>4?1:ze,V=U.slice(ze),ze+=x[1].length),Pe=!1,!U&&/^ *$/.test(B)&&(me+=B+`
`,X=X.substring(B.length+1),ne=!0),!ne)for(var _e=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,ze-1)+"}#");X&&(H=X.split(`
`,1)[0],U=H,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(U)||et.test(U)||_e.test(U)||tt.test(X)));){if(U.search(/[^ ]/)>=ze||!U.trim())V+=`
`+U.slice(ze);else if(!Pe)V+=`
`+U;else break;!Pe&&!U.trim()&&(Pe=!0),me+=H+`
`,X=X.substring(H.length+1)}je.loose||(Te?je.loose=!0:/\n *\n *$/.test(me)&&(Te=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(V),pe&&(Re=pe[0]!=="[ ] ",V=V.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:me,task:!!pe,checked:Re,loose:!1,text:V}),je.raw+=me}je.items[je.items.length-1].raw=me.trimRight(),je.items[je.items.length-1].text=V.trimRight(),je.raw=je.raw.trimRight();var rt=je.items.length;for(ke=0;ke<rt;ke++){this.lexer.state.top=!1,je.items[ke].tokens=this.lexer.blockTokens(je.items[ke].text,[]);var mt=je.items[ke].tokens.filter(function(st){return st.type==="space"}),lt=mt.every(function(st){for(var ct=st.raw.split(""),ft=0,pt=O(ct),qe;!(qe=pt()).done;){var Ue=qe.value;if(Ue===`
`&&(ft+=1),ft>1)return!0}return!1});!je.loose&&mt.length&&lt&&(je.loose=!0,je.items[ke].loose=!0)}return je}},we.html=function(X){var x=this.rules.block.html.exec(X);if(x){var me={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]);me.type="paragraph",me.text=pe,me.tokens=this.lexer.inline(pe)}return me}},we.def=function(X){var x=this.rules.block.def.exec(X);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var me=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:x[0],href:x[2],title:x[3]}}},we.table=function(X){var x=this.rules.block.table.exec(X);if(x){var me={type:"table",header:b(x[1]).map(function(Te){return{text:Te}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=x[0];var pe=me.align.length,Re,ze,ke,Pe;for(Re=0;Re<pe;Re++)/^ *-+: *$/.test(me.align[Re])?me.align[Re]="right":/^ *:-+: *$/.test(me.align[Re])?me.align[Re]="center":/^ *:-+ *$/.test(me.align[Re])?me.align[Re]="left":me.align[Re]=null;for(pe=me.rows.length,Re=0;Re<pe;Re++)me.rows[Re]=b(me.rows[Re],me.header.length).map(function(Te){return{text:Te}});for(pe=me.header.length,ze=0;ze<pe;ze++)me.header[ze].tokens=this.lexer.inline(me.header[ze].text);for(pe=me.rows.length,ze=0;ze<pe;ze++)for(Pe=me.rows[ze],ke=0;ke<Pe.length;ke++)Pe[ke].tokens=this.lexer.inline(Pe[ke].text);return me}}},we.lheading=function(X){var x=this.rules.block.lheading.exec(X);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},we.paragraph=function(X){var x=this.rules.block.paragraph.exec(X);if(x){var me=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:me,tokens:this.lexer.inline(me)}}},we.text=function(X){var x=this.rules.block.text.exec(X);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},we.escape=function(X){var x=this.rules.inline.escape.exec(X);if(x)return{type:"escape",raw:x[0],text:d(x[1])}},we.tag=function(X){var x=this.rules.inline.tag.exec(X);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]):x[0]}},we.link=function(X){var x=this.rules.inline.link.exec(X);if(x){var me=x[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var pe=k(me.slice(0,-1),"\\");if((me.length-pe.length)%2===0)return}else{var Re=C(x[2],"()");if(Re>-1){var ze=x[0].indexOf("!")===0?5:4,ke=ze+x[1].length+Re;x[2]=x[2].substring(0,Re),x[0]=x[0].substring(0,ke).trim(),x[3]=""}}var Pe=x[2],Te="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);U&&(Pe=U[1],Te=U[3])}else Te=x[3]?x[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test(me)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),M(x,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Te&&Te.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},we.reflink=function(X,x){var me;if((me=this.rules.inline.reflink.exec(X))||(me=this.rules.inline.nolink.exec(X))){var pe=(me[2]||me[1]).replace(/\s+/g," ");if(pe=x[pe.toLowerCase()],!pe||!pe.href){var Re=me[0].charAt(0);return{type:"text",raw:Re,text:Re}}return M(me,pe,me[0],this.lexer)}},we.emStrong=function(X,x,me){me===void 0&&(me="");var pe=this.rules.inline.emStrong.lDelim.exec(X);if(pe&&!(pe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Re=pe[1]||pe[2]||"";if(!Re||Re&&(me===""||this.rules.inline.punctuation.exec(me))){var ze=pe[0].length-1,ke,Pe,Te=ze,U=0,B=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(B.lastIndex=0,x=x.slice(-1*X.length+ze);(pe=B.exec(x))!=null;)if(ke=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!ke){if(Pe=ke.length,pe[3]||pe[4]){Te+=Pe;continue}else if((pe[5]||pe[6])&&ze%3&&!((ze+Pe)%3)){U+=Pe;continue}if(Te-=Pe,!(Te>0)){if(Pe=Math.min(Pe,Pe+Te+U),Math.min(ze,Pe)%2){var H=X.slice(1,ze+pe.index+Pe);return{type:"em",raw:X.slice(0,ze+pe.index+Pe+1),text:H,tokens:this.lexer.inlineTokens(H)}}var V=X.slice(2,ze+pe.index+Pe-1);return{type:"strong",raw:X.slice(0,ze+pe.index+Pe+1),text:V,tokens:this.lexer.inlineTokens(V)}}}}}},we.codespan=function(X){var x=this.rules.inline.code.exec(X);if(x){var me=x[2].replace(/\n/g," "),pe=/[^ ]/.test(me),Re=/^ /.test(me)&&/ $/.test(me);return pe&&Re&&(me=me.substring(1,me.length-1)),me=d(me,!0),{type:"codespan",raw:x[0],text:me}}},we.br=function(X){var x=this.rules.inline.br.exec(X);if(x)return{type:"br",raw:x[0]}},we.del=function(X){var x=this.rules.inline.del.exec(X);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},we.autolink=function(X,x){var me=this.rules.inline.autolink.exec(X);if(me){var pe,Re;return me[2]==="@"?(pe=d(this.options.mangle?x(me[1]):me[1]),Re="mailto:"+pe):(pe=d(me[1]),Re=pe),{type:"link",raw:me[0],text:pe,href:Re,tokens:[{type:"text",raw:pe,text:pe}]}}},we.url=function(X,x){var me;if(me=this.rules.inline.url.exec(X)){var pe,Re;if(me[2]==="@")pe=d(this.options.mangle?x(me[0]):me[0]),Re="mailto:"+pe;else{var ze;do ze=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(ze!==me[0]);pe=d(me[0]),me[1]==="www."?Re="http://"+pe:Re=pe}return{type:"link",raw:me[0],text:pe,href:Re,tokens:[{type:"text",raw:pe,text:pe}]}}},we.inlineText=function(X,x){var me=this.rules.inline.text.exec(X);if(me){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):d(me[0]):me[0]:pe=d(this.options.smartypants?x(me[0]):me[0]),{type:"text",raw:me[0],text:pe}}},ce}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=l(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=l(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=l(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=l(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=l(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=l(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=D({},W),W.gfm=D({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=l(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=l(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=D({},W.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:l(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var G={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};G._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",G.punctuation=l(G.punctuation).replace(/punctuation/g,G._punctuation).getRegex(),G.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,G.escapedEmSt=/\\\*|\\_/g,G._comment=l(W._comment).replace("(?:-->|$)","-->").getRegex(),G.emStrong.lDelim=l(G.emStrong.lDelim).replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimAst=l(G.emStrong.rDelimAst,"g").replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimUnd=l(G.emStrong.rDelimUnd,"g").replace(/punct/g,G._punctuation).getRegex(),G._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,G._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,G._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,G.autolink=l(G.autolink).replace("scheme",G._scheme).replace("email",G._email).getRegex(),G._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,G.tag=l(G.tag).replace("comment",G._comment).replace("attribute",G._attribute).getRegex(),G._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,G._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,G._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,G.link=l(G.link).replace("label",G._label).replace("href",G._href).replace("title",G._title).getRegex(),G.reflink=l(G.reflink).replace("label",G._label).replace("ref",W._label).getRegex(),G.nolink=l(G.nolink).replace("ref",W._label).getRegex(),G.reflinkSearch=l(G.reflinkSearch,"g").replace("reflink",G.reflink).replace("nolink",G.nolink).getRegex(),G.normal=D({},G),G.pedantic=D({},G.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",G._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",G._label).getRegex()}),G.gfm=D({},G.normal,{escape:l(G.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),G.gfm.url=l(G.gfm.url,"i").replace("email",G.gfm._extended_email).getRegex(),G.breaks=D({},G.gfm,{br:l(G.br).replace("{2,}","*").getRegex(),text:l(G.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(ce){return ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(ce){var we="",ue,X,x=ce.length;for(ue=0;ue<x;ue++)X=ce.charCodeAt(ue),Math.random()>.5&&(X="x"+X.toString(16)),we+="&#"+X+";";return we}var Y=function(){function ce(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||be.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:W.normal,inline:G.normal};this.options.pedantic?(X.block=W.pedantic,X.inline=G.pedantic):this.options.gfm&&(X.block=W.gfm,this.options.breaks?X.inline=G.breaks:X.inline=G.gfm),this.tokenizer.rules=X}ce.lex=function(X,x){var me=new ce(x);return me.lex(X)},ce.lexInline=function(X,x){var me=new ce(x);return me.inlineTokens(X)};var we=ce.prototype;return we.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},we.blockTokens=function(X,x){var me=this;x===void 0&&(x=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Te,U,B){return U+"    ".repeat(B.length)});for(var pe,Re,ze,ke;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Te){return(pe=Te.call({lexer:me},X,x))?(X=X.substring(pe.raw.length),x.push(pe),!0):!1}))){if(pe=this.tokenizer.space(X)){X=X.substring(pe.raw.length),pe.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(pe);continue}if(pe=this.tokenizer.code(X)){X=X.substring(pe.raw.length),Re=x[x.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+pe.raw,Re.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):x.push(pe);continue}if(pe=this.tokenizer.fences(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.heading(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.hr(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.blockquote(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.list(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.html(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.def(X)){X=X.substring(pe.raw.length),Re=x[x.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+pe.raw,Re.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.lheading(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(ze=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Te=1/0,U=X.slice(1),B=void 0;me.options.extensions.startBlock.forEach(function(H){B=H.call({lexer:this},U),typeof B=="number"&&B>=0&&(Te=Math.min(Te,B))}),Te<1/0&&Te>=0&&(ze=X.substring(0,Te+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(ze))){Re=x[x.length-1],ke&&Re.type==="paragraph"?(Re.raw+=`
`+pe.raw,Re.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):x.push(pe),ke=ze.length!==X.length,X=X.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(X)){X=X.substring(pe.raw.length),Re=x[x.length-1],Re&&Re.type==="text"?(Re.raw+=`
`+pe.raw,Re.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):x.push(pe);continue}if(X){var Pe="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return this.state.top=!0,x},we.inline=function(X,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:X,tokens:x}),x},we.inlineTokens=function(X,x){var me=this;x===void 0&&(x=[]);var pe,Re,ze,ke=X,Pe,Te,U;if(this.tokens.links){var B=Object.keys(this.tokens.links);if(B.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)B.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Pe.index)+"["+w("a",Pe[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Pe.index)+"["+w("a",Pe[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Pe.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Te||(U=""),Te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(V){return(pe=V.call({lexer:me},X,x))?(X=X.substring(pe.raw.length),x.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.tag(X)){X=X.substring(pe.raw.length),Re=x[x.length-1],Re&&pe.type==="text"&&Re.type==="text"?(Re.raw+=pe.raw,Re.text+=pe.text):x.push(pe);continue}if(pe=this.tokenizer.link(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(pe.raw.length),Re=x[x.length-1],Re&&pe.type==="text"&&Re.type==="text"?(Re.raw+=pe.raw,Re.text+=pe.text):x.push(pe);continue}if(pe=this.tokenizer.emStrong(X,ke,U)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.codespan(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.br(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.del(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.autolink(X,K)){X=X.substring(pe.raw.length),x.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(X,K))){X=X.substring(pe.raw.length),x.push(pe);continue}if(ze=X,this.options.extensions&&this.options.extensions.startInline&&function(){var V=1/0,ne=X.slice(1),fe=void 0;me.options.extensions.startInline.forEach(function(Ie){fe=Ie.call({lexer:this},ne),typeof fe=="number"&&fe>=0&&(V=Math.min(V,fe))}),V<1/0&&V>=0&&(ze=X.substring(0,V+1))}(),pe=this.tokenizer.inlineText(ze,F)){X=X.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(U=pe.raw.slice(-1)),Te=!0,Re=x[x.length-1],Re&&Re.type==="text"?(Re.raw+=pe.raw,Re.text+=pe.text):x.push(pe);continue}if(X){var H="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return x},v(ce,null,[{key:"rules",get:function(){return{block:W,inline:G}}}]),ce}(),le=function(){function ce(ue){this.options=ue||be.defaults}var we=ce.prototype;return we.code=function(X,x,me){var pe=(x||"").match(/\S*/)[0];if(this.options.highlight){var Re=this.options.highlight(X,pe);Re!=null&&Re!==X&&(me=!0,X=Re)}return X=X.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+d(pe,!0)+'">'+(me?X:d(X,!0))+`</code></pre>
`:"<pre><code>"+(me?X:d(X,!0))+`</code></pre>
`},we.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},we.html=function(X){return X},we.heading=function(X,x,me,pe){if(this.options.headerIds){var Re=this.options.headerPrefix+pe.slug(me);return"<h"+x+' id="'+Re+'">'+X+"</h"+x+`>
`}return"<h"+x+">"+X+"</h"+x+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(X,x,me){var pe=x?"ol":"ul",Re=x&&me!==1?' start="'+me+'"':"";return"<"+pe+Re+`>
`+X+"</"+pe+`>
`},we.listitem=function(X){return"<li>"+X+`</li>
`},we.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(X){return"<p>"+X+`</p>
`},we.table=function(X,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+x+`</table>
`},we.tablerow=function(X){return`<tr>
`+X+`</tr>
`},we.tablecell=function(X,x){var me=x.header?"th":"td",pe=x.align?"<"+me+' align="'+x.align+'">':"<"+me+">";return pe+X+("</"+me+`>
`)},we.strong=function(X){return"<strong>"+X+"</strong>"},we.em=function(X){return"<em>"+X+"</em>"},we.codespan=function(X){return"<code>"+X+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(X){return"<del>"+X+"</del>"},we.link=function(X,x,me){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return me;var pe='<a href="'+d(X)+'"';return x&&(pe+=' title="'+x+'"'),pe+=">"+me+"</a>",pe},we.image=function(X,x,me){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return me;var pe='<img src="'+X+'" alt="'+me+'"';return x&&(pe+=' title="'+x+'"'),pe+=this.options.xhtml?"/>":">",pe},we.text=function(X){return X},ce}(),_=function(){function ce(){}var we=ce.prototype;return we.strong=function(X){return X},we.em=function(X){return X},we.codespan=function(X){return X},we.del=function(X){return X},we.html=function(X){return X},we.text=function(X){return X},we.link=function(X,x,me){return""+me},we.image=function(X,x,me){return""+me},we.br=function(){return""},ce}(),ge=function(){function ce(){this.seen={}}var we=ce.prototype;return we.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(X,x){var me=X,pe=0;if(this.seen.hasOwnProperty(me)){pe=this.seen[X];do pe++,me=X+"-"+pe;while(this.seen.hasOwnProperty(me))}return x||(this.seen[X]=pe,this.seen[me]=0),me},we.slug=function(X,x){x===void 0&&(x={});var me=this.serialize(X);return this.getNextSafeSlug(me,x.dryrun)},ce}(),se=function(){function ce(ue){this.options=ue||be.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new ge}ce.parse=function(X,x){var me=new ce(x);return me.parse(X)},ce.parseInline=function(X,x){var me=new ce(x);return me.parseInline(X)};var we=ce.prototype;return we.parse=function(X,x){x===void 0&&(x=!0);var me="",pe,Re,ze,ke,Pe,Te,U,B,H,V,ne,fe,Ie,je,Qe,_e,tt,nt,et,rt=X.length;for(pe=0;pe<rt;pe++){if(V=X[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[V.type]&&(et=this.options.extensions.renderers[V.type].call({parser:this},V),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(V.type))){me+=et||"";continue}switch(V.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(V.tokens),V.depth,o(this.parseInline(V.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(V.text,V.lang,V.escaped);continue}case"table":{for(B="",U="",ke=V.header.length,Re=0;Re<ke;Re++)U+=this.renderer.tablecell(this.parseInline(V.header[Re].tokens),{header:!0,align:V.align[Re]});for(B+=this.renderer.tablerow(U),H="",ke=V.rows.length,Re=0;Re<ke;Re++){for(Te=V.rows[Re],U="",Pe=Te.length,ze=0;ze<Pe;ze++)U+=this.renderer.tablecell(this.parseInline(Te[ze].tokens),{header:!1,align:V.align[ze]});H+=this.renderer.tablerow(U)}me+=this.renderer.table(B,H);continue}case"blockquote":{H=this.parse(V.tokens),me+=this.renderer.blockquote(H);continue}case"list":{for(ne=V.ordered,fe=V.start,Ie=V.loose,ke=V.items.length,H="",Re=0;Re<ke;Re++)Qe=V.items[Re],_e=Qe.checked,tt=Qe.task,je="",Qe.task&&(nt=this.renderer.checkbox(_e),Ie?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=nt+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=nt+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:nt}):je+=nt),je+=this.parse(Qe.tokens,Ie),H+=this.renderer.listitem(je,tt,_e);me+=this.renderer.list(H,ne,fe);continue}case"html":{me+=this.renderer.html(V.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(V.tokens));continue}case"text":{for(H=V.tokens?this.parseInline(V.tokens):V.text;pe+1<rt&&X[pe+1].type==="text";)V=X[++pe],H+=`
`+(V.tokens?this.parseInline(V.tokens):V.text);me+=x?this.renderer.paragraph(H):H;continue}default:{var mt='Token with "'+V.type+'" type was not found.';if(this.options.silent){console.error(mt);return}else throw new Error(mt)}}}return me},we.parseInline=function(X,x){x=x||this.renderer;var me="",pe,Re,ze,ke=X.length;for(pe=0;pe<ke;pe++){if(Re=X[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Re.type]&&(ze=this.options.extensions.renderers[Re.type].call({parser:this},Re),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Re.type))){me+=ze||"";continue}switch(Re.type){case"escape":{me+=x.text(Re.text);break}case"html":{me+=x.html(Re.text);break}case"link":{me+=x.link(Re.href,Re.title,this.parseInline(Re.tokens,x));break}case"image":{me+=x.image(Re.href,Re.title,Re.text);break}case"strong":{me+=x.strong(this.parseInline(Re.tokens,x));break}case"em":{me+=x.em(this.parseInline(Re.tokens,x));break}case"codespan":{me+=x.codespan(Re.text);break}case"br":{me+=x.br();break}case"del":{me+=x.del(this.parseInline(Re.tokens,x));break}case"text":{me+=x.text(Re.text);break}default:{var Pe='Token with "'+Re.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return me},ce}();function ae(ce,we,ue){if(typeof ce>"u"||ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");if(typeof we=="function"&&(ue=we,we=null),we=D({},ae.defaults,we||{}),f(we),ue){var X=we.highlight,x;try{x=Y.lex(ce,we)}catch(ke){return ue(ke)}var me=function(Pe){var Te;if(!Pe)try{we.walkTokens&&ae.walkTokens(x,we.walkTokens),Te=se.parse(x,we)}catch(U){Pe=U}return we.highlight=X,Pe?ue(Pe):ue(null,Te)};if(!X||X.length<3||(delete we.highlight,!x.length))return me();var pe=0;ae.walkTokens(x,function(ke){ke.type==="code"&&(pe++,setTimeout(function(){X(ke.text,ke.lang,function(Pe,Te){if(Pe)return me(Pe);Te!=null&&Te!==ke.text&&(ke.text=Te,ke.escaped=!0),pe--,pe===0&&me()})},0))}),pe===0&&me();return}function Re(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+d(ke.message+"",!0)+"</pre>";throw ke}try{var ze=Y.lex(ce,we);if(we.walkTokens){if(we.async)return Promise.all(ae.walkTokens(ze,we.walkTokens)).then(function(){return se.parse(ze,we)}).catch(Re);ae.walkTokens(ze,we.walkTokens)}return se.parse(ze,we)}catch(ke){Re(ke)}}ae.options=ae.setOptions=function(ce){return D(ae.defaults,ce),T(ae.defaults),ae},ae.getDefaults=R,ae.defaults=be.defaults,ae.use=function(){for(var ce=arguments.length,we=new Array(ce),ue=0;ue<ce;ue++)we[ue]=arguments[ue];var X=D.apply(void 0,[{}].concat(we)),x=ae.defaults.extensions||{renderers:{},childTokens:{}},me;we.forEach(function(pe){if(pe.extensions&&(me=!0,pe.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var ke=x.renderers?x.renderers[ze.name]:null;ke?x.renderers[ze.name]=function(){for(var Pe=arguments.length,Te=new Array(Pe),U=0;U<Pe;U++)Te[U]=arguments[U];var B=ze.renderer.apply(this,Te);return B===!1&&(B=ke.apply(this,Te)),B}:x.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[ze.level]?x[ze.level].unshift(ze.tokenizer):x[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?x.startBlock?x.startBlock.push(ze.start):x.startBlock=[ze.start]:ze.level==="inline"&&(x.startInline?x.startInline.push(ze.start):x.startInline=[ze.start]))}ze.childTokens&&(x.childTokens[ze.name]=ze.childTokens)})),pe.renderer&&function(){var ze=ae.defaults.renderer||new le,ke=function(U){var B=ze[U];ze[U]=function(){for(var H=arguments.length,V=new Array(H),ne=0;ne<H;ne++)V[ne]=arguments[ne];var fe=pe.renderer[U].apply(ze,V);return fe===!1&&(fe=B.apply(ze,V)),fe}};for(var Pe in pe.renderer)ke(Pe);X.renderer=ze}(),pe.tokenizer&&function(){var ze=ae.defaults.tokenizer||new L,ke=function(U){var B=ze[U];ze[U]=function(){for(var H=arguments.length,V=new Array(H),ne=0;ne<H;ne++)V[ne]=arguments[ne];var fe=pe.tokenizer[U].apply(ze,V);return fe===!1&&(fe=B.apply(ze,V)),fe}};for(var Pe in pe.tokenizer)ke(Pe);X.tokenizer=ze}(),pe.walkTokens){var Re=ae.defaults.walkTokens;X.walkTokens=function(ze){var ke=[];return ke.push(pe.walkTokens.call(this,ze)),Re&&(ke=ke.concat(Re.call(this,ze))),ke}}me&&(X.extensions=x),ae.setOptions(X)})},ae.walkTokens=function(ce,we){for(var ue=[],X=function(){var Re=me.value;switch(ue=ue.concat(we.call(ae,Re)),Re.type){case"table":{for(var ze=O(Re.header),ke;!(ke=ze()).done;){var Pe=ke.value;ue=ue.concat(ae.walkTokens(Pe.tokens,we))}for(var Te=O(Re.rows),U;!(U=Te()).done;)for(var B=U.value,H=O(B),V;!(V=H()).done;){var ne=V.value;ue=ue.concat(ae.walkTokens(ne.tokens,we))}break}case"list":{ue=ue.concat(ae.walkTokens(Re.items,we));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[Re.type]?ae.defaults.extensions.childTokens[Re.type].forEach(function(fe){ue=ue.concat(ae.walkTokens(Re[fe],we))}):Re.tokens&&(ue=ue.concat(ae.walkTokens(Re.tokens,we)))}},x=O(ce),me;!(me=x()).done;)X();return ue},ae.parseInline=function(ce,we){if(typeof ce>"u"||ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");we=D({},ae.defaults,we||{}),f(we);try{var ue=Y.lexInline(ce,we);return we.walkTokens&&ae.walkTokens(ue,we.walkTokens),se.parseInline(ue,we)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+d(X.message+"",!0)+"</pre>";throw X}},ae.Parser=se,ae.parser=se.parse,ae.Renderer=le,ae.TextRenderer=_,ae.Lexer=Y,ae.lexer=Y.lex,ae.Tokenizer=L,ae.Slugger=ge,ae.parse=ae;var $e=ae.options,oe=ae.setOptions,Ce=ae.use,Le=ae.walkTokens,Z=ae.parseInline,q=ae,te=se.parse,ve=Y.lex;be.Lexer=Y,be.Parser=se,be.Renderer=le,be.Slugger=ge,be.TextRenderer=_,be.Tokenizer=L,be.getDefaults=R,be.lexer=ve,be.marked=ae,be.options=$e,be.parse=q,be.parseInline=Z,be.parser=te,be.setOptions=oe,be.use=Ce,be.walkTokens=Le,Object.defineProperty(be,"__esModule",{value:!0})}),define(Oe[139],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=v;function v(n){const o=O(n);if(o&&o.length>0)return new Uint32Array(o)}let I=0;const P=new Uint32Array(10);function O(n){if(I=0,R(n,y,$.InitialConsonant),I>0||(R(n,a,$.Vowel),I>0)||(R(n,S,$.FinalConsonant),I>0)||(R(n,d,$.CompatibilityJamo),I))return P.subarray(0,I);if(n>=44032&&n<=55203){const o=n-44032,c=o%588,l=Math.floor(o/588),i=Math.floor(c/28),r=c%28-1;if(l<y.length?R(l,y,0):$.InitialConsonant+l-$.CompatibilityJamo<d.length&&R($.InitialConsonant+l,d,$.CompatibilityJamo),i<a.length?R(i,a,0):$.Vowel+i-$.CompatibilityJamo<d.length&&R($.Vowel+i-$.CompatibilityJamo,d,$.CompatibilityJamo),r>=0&&(r<S.length?R(r,S,0):$.FinalConsonant+r-$.CompatibilityJamo<d.length&&R($.FinalConsonant+r-$.CompatibilityJamo,d,$.CompatibilityJamo)),I>0)return P.subarray(0,I)}}function R(n,o,c){n>=c&&n<c+o.length&&T(o[n-c])}function T(n){n!==s.NUL&&(P[I++]=n&255,n>>8&&(P[I++]=n>>8&255),n>>16&&(P[I++]=n>>16&255))}var $;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var s;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(s||(s={}));var A;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(A||(A={}));const y=new Uint8Array([s.r,s.R,s.s,s.e,s.E,s.f,s.a,s.q,s.Q,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g]),a=new Uint16Array([s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,A.hk,A.ho,A.hl,s.y,s.n,A.nj,A.np,A.nl,s.b,s.m,A.ml,s.l]),S=new Uint16Array([s.r,s.R,A.rt,s.s,A.sw,A.sg,s.e,s.f,A.fr,A.fa,A.fq,A.ft,A.fx,A.fv,A.fg,s.a,s.q,A.qt,s.t,s.T,s.d,s.w,s.c,s.z,s.x,s.v,s.g]),d=new Uint16Array([s.r,s.R,A.rt,s.s,A.sw,A.sg,s.e,s.E,s.f,A.fr,A.fa,A.fq,A.ft,A.fx,A.fv,A.fg,s.a,s.q,s.Q,A.qt,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g,s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,A.hk,A.ho,A.hl,s.y,s.n,A.nj,A.np,A.nl,s.b,s.m,A.ml,s.l])}),define(Oe[140],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=void 0,e.$Im=v,e.rot=I,e.$Nm=T;function v($,s,A){return Math.min(Math.max($,s),A)}function I($,s){return(s+$%s)%s}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Km=P;class O{constructor(){this.a=1,this.b=0}update(s){return this.b=this.b+(s-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Lm=O;class R{constructor(s){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(s),this.c.fill(0,0,s)}update(s){const A=this.c[this.d];return this.c[this.d]=s,this.d=(this.d+1)%this.c.length,this.e-=A,this.e+=s,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Mm=R;function T($,s,A,y,a,S,d,n){const o=d-A,c=n-y,l=a-A,i=S-y,r=$-A,t=s-y,g=o*o+c*c,u=o*l+c*i,m=o*r+c*t,p=l*l+i*i,h=l*r+i*t,E=1/(g*p-u*u),D=(p*m-u*h)*E,b=(g*h-u*m)*E;return D>=0&&b>=0&&D+b<1}}),define(Oe[141],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_c=void 0,e.$ad=O,e.$bd=a;class v{constructor(d,n,o){this.owner=d,this.debugNameSource=n,this.referenceFn=o}getDebugName(d){return O(d,this)}}e.$_c=v;const I=new Map,P=new WeakMap;function O(S,d){const n=P.get(S);if(n)return n;const o=R(S,d);if(o){let c=I.get(o)??0;c++,I.set(o,c);const l=c===1?o:`${o}#${c}`;return P.set(S,l),l}}function R(S,d){const n=P.get(S);if(n)return n;const o=d.owner?A(d.owner)+".":"";let c;const l=d.debugNameSource;if(l!==void 0)if(typeof l=="function"){if(c=l(),c!==void 0)return o+c}else return o+l;const i=d.referenceFn;if(i!==void 0&&(c=a(i),c!==void 0))return o+c;if(d.owner!==void 0){const r=T(d.owner,S);if(r!==void 0)return o+r}}function T(S,d){for(const n in S)if(S[n]===d)return n}const $=new Map,s=new WeakMap;function A(S){const d=s.get(S);if(d)return d;const n=y(S);let o=$.get(n)??0;o++,$.set(n,o);const c=o===1?n:`${n}#${o}`;return s.set(S,c),c}function y(S){const d=S.constructor;return d?d.name:"Object"}function a(S){const d=S.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(o?o[1]:void 0)?.trim()}}),define(Oe[142],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Id=I,e.$Jd=P;let v;function I(n){v=n}function P(){return v}class O{constructor(){this.a=0,this.d=new WeakMap}b(o){return R([T(S("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[T(" "),s(A(o.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),s(A(o.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),s(A(o.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(o,c){console.log(...this.b([$("observable value changed"),s(o.debugName,{color:"BlueViolet"}),...this.c(c)]))}formatChanges(o){if(o.size!==0)return s(" (changed deps: "+[...o].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const c=o.handleChange;this.d.set(o,new Set),o.handleChange=(l,i)=>(this.d.get(o).add(l),c.apply(o,[l,i]))}handleDerivedRecomputed(o,c){const l=this.d.get(o);console.log(...this.b([$("derived recomputed"),s(o.debugName,{color:"BlueViolet"}),...this.c(c),this.formatChanges(l),{data:[{fn:o._debugNameData.referenceFn??o._computeFn}]}])),l.clear()}handleFromEventObservableTriggered(o,c){console.log(...this.b([$("observable from event triggered"),s(o.debugName,{color:"BlueViolet"}),...this.c(c),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const c=o.handleChange;this.d.set(o,new Set),o.handleChange=(l,i)=>(this.d.get(o).add(l),c.apply(o,[l,i]))}handleAutorunTriggered(o){const c=this.d.get(o);console.log(...this.b([$("autorun"),s(o.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:o._debugNameData.referenceFn??o._runFn}]}])),c.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let c=o.getDebugName();c===void 0&&(c=""),console.log(...this.b([$("transaction"),s(c,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Kd=O;function R(n){const o=new Array,c=[];let l="";function i(t){if("length"in t)for(const g of t)g&&i(g);else"text"in t?(l+=`%c${t.text}`,o.push(t.style),t.data&&c.push(...t.data)):"data"in t&&c.push(...t.data)}i(n);const r=[l,...o];return r.push(...c),r}function T(n){return s(n,{color:"black"})}function $(n){return s(d(`${n}: `,10),{color:"black",bold:!0})}function s(n,o={color:"black"}){function c(i){return Object.entries(i).reduce((r,[t,g])=>`${r}${t}:${g};`,"")}const l={color:o.color};return o.strikeThrough&&(l["text-decoration"]="line-through"),o.bold&&(l["font-weight"]="bold"),{text:n,style:c(l)}}function A(n,o){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=o?`"${n}"`:`"${n.substr(0,o-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?y(n,o):a(n,o);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function y(n,o){let c="[ ",l=!0;for(const i of n){if(l||(c+=", "),c.length-5>o){c+="...";break}l=!1,c+=`${A(i,o-c.length)}`}return c+=" ]",c}function a(n,o){let c="{ ",l=!0;for(const[i,r]of Object.entries(n)){if(l||(c+=", "),c.length-5>o){c+="...";break}l=!1,c+=`${i}: ${A(r,o-c.length)}`}return c+=" }",c}function S(n,o){let c="";for(let l=1;l<=o;l++)c+=n;return c}function d(n,o){for(;n.length<o;)n+=" ";return n}}),define(Oe[143],Ne([1,0,135,141,142]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$3d=e.$Xd=e.$Wd=void 0,e.$Td=R,e.$Ud=$,e.$Vd=A,e.$Yd=S,e.$Zd=n,e.$1d=o,e.$2d=c,e.$4d=i,e.$6d=t;let O;function R(u){O=u}let T;function $(u){T=u}let s;function A(u){s=u}class y{get TChange(){return null}reportChanges(){this.get()}read(m){return m?m.readObservable(this):this.get()}map(m,p){const h=p===void 0?void 0:m,E=p===void 0?m:p;return s({owner:h,debugName:()=>{const D=(0,I.$bd)(E);if(D!==void 0)return D;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(k)return`${this.debugName}.${k[2]}`;if(!h)return`${this.debugName} (mapped)`},debugReferenceFn:E},D=>E(this.read(D),D))}recomputeInitiallyAndOnChange(m,p){return m.add(O(this,p)),this}keepObserved(m){return m.add(T(this)),this}get a(){return this.get()}}e.$Wd=y;class a extends y{constructor(){super(...arguments),this.b=new Set}addObserver(m){const p=this.b.size;this.b.add(m),p===0&&this.c()}removeObserver(m){this.b.delete(m)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Xd=a;function S(u,m){const p=new l(u,m);try{u(p)}finally{p.finish()}}let d;function n(u){if(d)u(d);else{const m=new l(u,void 0);d=m;try{u(m)}finally{m.finish(),d=void 0}}}async function o(u,m){const p=new l(u,m);try{await u(p)}finally{p.finish()}}function c(u,m,p){u?m(u):S(m,p)}class l{constructor(m,p){this._fn=m,this.b=p,this.a=[],(0,P.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,I.$bd)(this._fn)}updateObserver(m,p){this.a.push({observer:m,observable:p}),m.beginUpdate(p)}finish(){const m=this.a;for(let p=0;p<m.length;p++){const{observer:h,observable:E}=m[p];h.endUpdate(E)}this.a=null,(0,P.$Jd)()?.handleEndTransaction()}}e.$3d=l;function i(u,m){let p;return typeof u=="string"?p=new I.$_c(void 0,u,void 0):p=new I.$_c(u,void 0,void 0),new r(p,m,v.$5c)}class r extends a{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(m,p,h){super(),this.e=m,this.g=h,this.d=p}get(){return this.d}set(m,p,h){if(h===void 0&&this.g(this.d,m))return;let E;p||(p=E=new l(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(m),(0,P.$Jd)()?.handleObservableChanged(this,{oldValue:D,newValue:m,change:h,didChange:!0,hadValue:!0});for(const b of this.b)p.updateObserver(b,this),b.handleChange(this,h)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(m){this.d=m}}e.$5d=r;function t(u,m){let p;return typeof u=="string"?p=new I.$_c(void 0,u,void 0):p=new I.$_c(u,void 0,void 0),new g(p,m,v.$5c)}class g extends r{h(m){this.d!==m&&(this.d&&this.d.dispose(),this.d=m)}dispose(){this.d?.dispose()}}e.$7d=g}),function(){function be(P){const O=[];typeof P=="number"&&O.push("code/timeOrigin",P);function R($){O.push($,Date.now())}function T(){const $=[];for(let s=0;s<O.length;s+=2)$.push({name:O[s],startTime:O[s+1]});return $}return{mark:R,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))O.push({name:R.name,startTime:Math.round(P+R.startTime)});return O}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function v(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=v(I))}(),define(Oe[144],Ne([1,0,39]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2I=void 0;const I=Symbol("unset");class P{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||v.Iterable.empty()}get entries(){return this.a.children?.entries()||v.Iterable.empty()}insert($,s,A){this.d($,y=>y._value=s,A)}mutate($,s){this.d($,A=>A._value=s(A._value===I?void 0:A._value))}mutatePath($,s){this.d($,()=>{},A=>s(A))}delete($){const s=this.c($);if(!s)return;let A=s.length-1;const y=s[A].node._value;if(y!==I){for(this.b--,s[A].node._value=I;A>0;A--){const{node:a,part:S}=s[A];if(a.children?.size||a._value!==I)break;s[A-1].node.children.delete(S)}return y}}*deleteRecursive($){const s=this.c($);if(!s)return;const A=s[s.length-1].node;for(let y=s.length-1;y>0;y--){const a=s[y-1];if(a.node.children.delete(s[y].part),a.node.children.size>0||a.node._value!==I)break}for(const y of O(A))y._value!==I&&(this.b--,yield y._value)}find($){let s=this.a;for(const A of $){const y=s.children?.get(A);if(!y)return;s=y}return s._value===I?void 0:s._value}hasKeyOrParent($){let s=this.a;for(const A of $){const y=s.children?.get(A);if(!y)return!1;if(y._value!==I)return!0;s=y}return!1}hasKeyOrChildren($){let s=this.a;for(const A of $){const y=s.children?.get(A);if(!y)return!1;s=y}return!0}hasKey($){let s=this.a;for(const A of $){const y=s.children?.get(A);if(!y)return!1;s=y}return s._value!==I}c($){const s=[{part:"",node:this.a}];let A=0;for(const y of $){const a=s[A].node.children?.get(y);if(!a)return;s.push({part:y,node:a}),A++}return s}d($,s,A){let y=this.a;for(const d of $){if(y.children)if(y.children.has(d))y=y.children.get(d);else{const n=new R;y.children.set(d,n),y=n}else{const n=new R;y.children=new Map([[d,n]]),y=n}A?.(y)}const a=y._value===I?0:1;s(y);const S=y._value===I?0:1;this.b+=S-a}*values(){for(const{_value:$}of O(this.a))$!==I&&(yield $)}}e.$2I=P;function*O(T){const $=[T];for(;$.length>0;){const s=$.pop();if(yield s,s.children)for(const A of s.children.values())$.push(A)}}class R{constructor(){this._value=I}get value(){return this._value===I?void 0:this._value}set value($){this._value=$===void 0?I:$}}}),define(Oe[145],Ne([1,0,48,19]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=T,e.$yr=$,e.$zr=s,e.$Ar=A,e.$Br=y,e.$Cr=a,e.$Dr=S,e.$Er=d,e.$Fr=n,e.$Gr=o,e.$Hr=h,e.$Ir=E,e.$Jr=D;const P=new v.$T(()=>{const b=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:b,collatorIsNumeric:b.resolvedOptions().numeric}}),O=new v.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new v.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(b,k,C=!1){const f=b||"",w=k||"",M=P.value.collator.compare(f,w);return P.value.collatorIsNumeric&&M===0&&f!==w?f<w?-1:1:M}function $(b,k){const C=O.value.collator;return b=b||"",k=k||"",r(C,b,k)}function s(b,k){const C=O.value.collator;return b=b||"",k=k||"",m(b,k)||r(C,b,k)}function A(b,k){const C=O.value.collator;return b=b||"",k=k||"",u(b,k)||r(C,b,k)}function y(b,k){return b=b||"",k=k||"",b===k?0:b<k?-1:1}function a(b,k){const[C,f]=l(b),[w,M]=l(k);let N=P.value.collator.compare(f,M);if(N===0){if(P.value.collatorIsNumeric&&f!==M)return f<M?-1:1;if(N=P.value.collator.compare(C,w),P.value.collatorIsNumeric&&N===0&&C!==w)return C<w?-1:1}return N}function S(b,k){b=b||"",k=k||"";const C=i(b),f=i(k),w=O.value.collator,M=R.value.collator;return r(M,C,f)||r(w,b,k)}function d(b,k){b=b||"",k=k||"";const C=i(b),f=i(k),w=O.value.collator,M=R.value.collator;return r(M,C,f)||m(b,k)||r(w,b,k)}function n(b,k){b=b||"",k=k||"";const C=i(b),f=i(k),w=O.value.collator,M=R.value.collator;return r(M,C,f)||u(b,k)||r(w,b,k)}function o(b,k){b=b||"",k=k||"";const C=i(b).toLowerCase(),f=i(k).toLowerCase();return C!==f?C<f?-1:1:b!==k?b<k?-1:1:0}const c=/^(.*?)(\.([^.]*))?$/;function l(b,k=!1){const C=b?c.exec(b):[];let f=[C&&C[1]||"",C&&C[3]||""];return k&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function i(b){const k=b?c.exec(b):[];return k&&k[1]&&k[1].charAt(0)!=="."&&k[3]||""}function r(b,k,C){const f=b.compare(k,C);return f!==0?f:k.length!==C.length?k.length<C.length?-1:1:0}function t(b){const k=b.charAt(0);return k.toLocaleUpperCase()!==k}function g(b){const k=b.charAt(0);return k.toLocaleLowerCase()!==k}function u(b,k){return t(b)&&g(k)?-1:g(b)&&t(k)?1:0}function m(b,k){return g(b)&&t(k)?-1:t(b)&&g(k)?1:0}function p(b,k,C=!1){return C||(b=b&&b.toLowerCase(),k=k&&k.toLowerCase()),b===k?0:b<k?-1:1}function h(b,k,C=!1){const f=b.split(I.sep),w=k.split(I.sep),M=f.length-1,N=w.length-1;let L,W;for(let G=0;;G++){if(L=M===G,W=N===G,L&&W)return T(f[G],w[G],C);if(L)return-1;if(W)return 1;const F=p(f[G],w[G],C);if(F!==0)return F}}function E(b,k,C){const f=b.toLowerCase(),w=k.toLowerCase(),M=D(b,k,C);if(M)return M;const N=f.endsWith(C),L=w.endsWith(C);if(N!==L)return N?-1:1;const W=T(f,w);return W!==0?W:f.localeCompare(w)}function D(b,k,C){const f=b.toLowerCase(),w=k.toLowerCase(),M=f.startsWith(C),N=w.startsWith(C);if(M!==N)return M?-1:1;if(M&&N){if(f.length<w.length)return-1;if(f.length>w.length)return 1}return 0}}),define(Oe[72],Ne([1,0,19]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0,e.$9s=O,e.$0s=R,e.$$s=T,e.$_s=s,e.$8s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(A){const y=(0,v.$nc)(A),a=I[y.toLowerCase()];return a!==void 0?a:R(A)}function R(A){const y=(0,v.$nc)(A);return P[y.toLowerCase()]}function T(A){for(const y in P)if(P[y]===A)return y}const $=/^(.+)\/(.+?)(;.+)?$/;function s(A,y){const a=$.exec(A);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:y?void 0:A}}),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var I in v)(typeof exports=="object"?exports:be)[I]=v[I]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function v(I){if(e[I])return e[I].exports;var P=e[I]={i:I,l:!1,exports:{}};return be[I].call(P.exports,P,P.exports,v),P.l=!0,P.exports}return v.m=be,v.c=e,v.d=function(I,P,O){v.o(I,P)||Object.defineProperty(I,P,{enumerable:!0,get:O})},v.r=function(I){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},v.t=function(I,P){if(1&P&&(I=v(I)),8&P||4&P&&typeof I=="object"&&I&&I.__esModule)return I;var O=Object.create(null);if(v.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:I}),2&P&&typeof I!="string")for(var R in I)v.d(O,R,function(T){return I[T]}.bind(null,R));return O},v.n=function(I){var P=I&&I.__esModule?function(){return I.default}:function(){return I};return v.d(P,"a",P),P},v.o=function(I,P){return Object.prototype.hasOwnProperty.call(I,P)},v.p="",v(v.s=0)}([function(be,e,v){(function(I){var P;e=be.exports=Ce,P=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],$=e.src=[],s=0,A=s++;$[A]="0|[1-9]\\d*";var y=s++;$[y]="[0-9]+";var a=s++;$[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=s++;$[S]="("+$[A]+")\\.("+$[A]+")\\.("+$[A]+")";var d=s++;$[d]="("+$[y]+")\\.("+$[y]+")\\.("+$[y]+")";var n=s++;$[n]="(?:"+$[A]+"|"+$[a]+")";var o=s++;$[o]="(?:"+$[y]+"|"+$[a]+")";var c=s++;$[c]="(?:-("+$[n]+"(?:\\."+$[n]+")*))";var l=s++;$[l]="(?:-?("+$[o]+"(?:\\."+$[o]+")*))";var i=s++;$[i]="[0-9A-Za-z-]+";var r=s++;$[r]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var t=s++,g="v?"+$[S]+$[c]+"?"+$[r]+"?";$[t]="^"+g+"$";var u="[v=\\s]*"+$[d]+$[l]+"?"+$[r]+"?",m=s++;$[m]="^"+u+"$";var p=s++;$[p]="((?:<|>)?=?)";var h=s++;$[h]=$[y]+"|x|X|\\*";var E=s++;$[E]=$[A]+"|x|X|\\*";var D=s++;$[D]="[v=\\s]*("+$[E]+")(?:\\.("+$[E]+")(?:\\.("+$[E]+")(?:"+$[c]+")?"+$[r]+"?)?)?";var b=s++;$[b]="[v=\\s]*("+$[h]+")(?:\\.("+$[h]+")(?:\\.("+$[h]+")(?:"+$[l]+")?"+$[r]+"?)?)?";var k=s++;$[k]="^"+$[p]+"\\s*"+$[D]+"$";var C=s++;$[C]="^"+$[p]+"\\s*"+$[b]+"$";var f=s++;$[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=s++;$[w]="(?:~>?)";var M=s++;$[M]="(\\s*)"+$[w]+"\\s+",T[M]=new RegExp($[M],"g");var N=s++;$[N]="^"+$[w]+$[D]+"$";var L=s++;$[L]="^"+$[w]+$[b]+"$";var W=s++;$[W]="(?:\\^)";var G=s++;$[G]="(\\s*)"+$[W]+"\\s+",T[G]=new RegExp($[G],"g");var F=s++;$[F]="^"+$[W]+$[D]+"$";var K=s++;$[K]="^"+$[W]+$[b]+"$";var Y=s++;$[Y]="^"+$[p]+"\\s*("+u+")$|^$";var le=s++;$[le]="^"+$[p]+"\\s*("+g+")$|^$";var _=s++;$[_]="(\\s*)"+$[p]+"\\s*("+u+"|"+$[D]+")",T[_]=new RegExp($[_],"g");var ge=s++;$[ge]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var se=s++;$[se]="^\\s*("+$[b]+")\\s+-\\s+("+$[b]+")\\s*$";var ae=s++;$[ae]="(<|>)?=?\\s*\\*";for(var $e=0;$e<35;$e++)P($e,$[$e]),T[$e]||(T[$e]=new RegExp($[$e]));function oe(B,H){if(B instanceof Ce)return B;if(typeof B!="string"||B.length>O||!(H?T[m]:T[t]).test(B))return null;try{return new Ce(B,H)}catch{return null}}function Ce(B,H){if(B instanceof Ce){if(B.loose===H)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Ce))return new Ce(B,H);P("SemVer",B,H),this.loose=H;var V=B.trim().match(H?T[m]:T[t]);if(!V)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+V[1],this.minor=+V[2],this.patch=+V[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");V[4]?this.prerelease=V[4].split(".").map(function(ne){if(/^[0-9]+$/.test(ne)){var fe=+ne;if(fe>=0&&fe<R)return fe}return ne}):this.prerelease=[],this.build=V[5]?V[5].split("."):[],this.format()}e.parse=oe,e.valid=function(B,H){var V=oe(B,H);return V?V.version:null},e.clean=function(B,H){var V=oe(B.trim().replace(/^[=v]+/,""),H);return V?V.version:null},e.SemVer=Ce,Ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ce.prototype.toString=function(){return this.version},Ce.prototype.compare=function(B){return P("SemVer.compare",this.version,this.loose,B),B instanceof Ce||(B=new Ce(B,this.loose)),this.compareMain(B)||this.comparePre(B)},Ce.prototype.compareMain=function(B){return B instanceof Ce||(B=new Ce(B,this.loose)),Z(this.major,B.major)||Z(this.minor,B.minor)||Z(this.patch,B.patch)},Ce.prototype.comparePre=function(B){if(B instanceof Ce||(B=new Ce(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var H=0;do{var V=this.prerelease[H],ne=B.prerelease[H];if(P("prerelease compare",H,V,ne),V===void 0&&ne===void 0)return 0;if(ne===void 0)return 1;if(V===void 0)return-1;if(V!==ne)return Z(V,ne)}while(++H)},Ce.prototype.inc=function(B,H){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var V=this.prerelease.length;--V>=0;)typeof this.prerelease[V]=="number"&&(this.prerelease[V]++,V=-2);V===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,H,V,ne){typeof V=="string"&&(ne=V,V=void 0);try{return new Ce(B,V).inc(H,ne).version}catch{return null}},e.diff=function(B,H){if(ce(B,H))return null;var V=oe(B),ne=oe(H);if(V.prerelease.length||ne.prerelease.length){for(var fe in V)if((fe==="major"||fe==="minor"||fe==="patch")&&V[fe]!==ne[fe])return"pre"+fe;return"prerelease"}for(var fe in V)if((fe==="major"||fe==="minor"||fe==="patch")&&V[fe]!==ne[fe])return fe},e.compareIdentifiers=Z;var Le=/^[0-9]+$/;function Z(B,H){var V=Le.test(B),ne=Le.test(H);return V&&ne&&(B=+B,H=+H),V&&!ne?-1:ne&&!V?1:B<H?-1:B>H?1:0}function q(B,H,V){return new Ce(B,V).compare(new Ce(H,V))}function te(B,H,V){return q(B,H,V)>0}function ve(B,H,V){return q(B,H,V)<0}function ce(B,H,V){return q(B,H,V)===0}function we(B,H,V){return q(B,H,V)!==0}function ue(B,H,V){return q(B,H,V)>=0}function X(B,H,V){return q(B,H,V)<=0}function x(B,H,V,ne){var fe;switch(H){case"===":typeof B=="object"&&(B=B.version),typeof V=="object"&&(V=V.version),fe=B===V;break;case"!==":typeof B=="object"&&(B=B.version),typeof V=="object"&&(V=V.version),fe=B!==V;break;case"":case"=":case"==":fe=ce(B,V,ne);break;case"!=":fe=we(B,V,ne);break;case">":fe=te(B,V,ne);break;case">=":fe=ue(B,V,ne);break;case"<":fe=ve(B,V,ne);break;case"<=":fe=X(B,V,ne);break;default:throw new TypeError("Invalid operator: "+H)}return fe}function me(B,H){if(B instanceof me){if(B.loose===H)return B;B=B.value}if(!(this instanceof me))return new me(B,H);P("comparator",B,H),this.loose=H,this.parse(B),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(B,H){return Z(H,B)},e.major=function(B,H){return new Ce(B,H).major},e.minor=function(B,H){return new Ce(B,H).minor},e.patch=function(B,H){return new Ce(B,H).patch},e.compare=q,e.compareLoose=function(B,H){return q(B,H,!0)},e.rcompare=function(B,H,V){return q(H,B,V)},e.sort=function(B,H){return B.sort(function(V,ne){return e.compare(V,ne,H)})},e.rsort=function(B,H){return B.sort(function(V,ne){return e.rcompare(V,ne,H)})},e.gt=te,e.lt=ve,e.eq=ce,e.neq=we,e.gte=ue,e.lte=X,e.cmp=x,e.Comparator=me;var pe={};function Re(B,H){if(B instanceof Re)return B.loose===H?B:new Re(B.raw,H);if(B instanceof me)return new Re(B.value,H);if(!(this instanceof Re))return new Re(B,H);if(this.loose=H,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(V){return this.parseRange(V.trim())},this).filter(function(V){return V.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function ze(B){return!B||B.toLowerCase()==="x"||B==="*"}function ke(B,H,V,ne,fe,Ie,je,Qe,_e,tt,nt,et,rt){return((H=ze(V)?"":ze(ne)?">="+V+".0.0":ze(fe)?">="+V+"."+ne+".0":">="+H)+" "+(Qe=ze(_e)?"":ze(tt)?"<"+(+_e+1)+".0.0":ze(nt)?"<"+_e+"."+(+tt+1)+".0":et?"<="+_e+"."+tt+"."+nt+"-"+et:"<="+Qe)).trim()}function Pe(B,H){for(var V=0;V<B.length;V++)if(!B[V].test(H))return!1;if(H.prerelease.length){for(V=0;V<B.length;V++)if(P(B[V].semver),B[V].semver!==pe&&B[V].semver.prerelease.length>0){var ne=B[V].semver;if(ne.major===H.major&&ne.minor===H.minor&&ne.patch===H.patch)return!0}return!1}return!0}function Te(B,H,V){try{H=new Re(H,V)}catch{return!1}return H.test(B)}function U(B,H,V,ne){var fe,Ie,je,Qe,_e;switch(B=new Ce(B,ne),H=new Re(H,ne),V){case">":fe=te,Ie=X,je=ve,Qe=">",_e=">=";break;case"<":fe=ve,Ie=ue,je=te,Qe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(B,H,ne))return!1;for(var tt=0;tt<H.set.length;++tt){var nt=H.set[tt],et=null,rt=null;if(nt.forEach(function(mt){mt.semver===pe&&(mt=new me(">=0.0.0")),et=et||mt,rt=rt||mt,fe(mt.semver,et.semver,ne)?et=mt:je(mt.semver,rt.semver,ne)&&(rt=mt)}),et.operator===Qe||et.operator===_e||(!rt.operator||rt.operator===Qe)&&Ie(B,rt.semver)||rt.operator===_e&&je(B,rt.semver))return!1}return!0}me.prototype.parse=function(B){var H=this.loose?T[Y]:T[le],V=B.match(H);if(!V)throw new TypeError("Invalid comparator: "+B);this.operator=V[1],this.operator==="="&&(this.operator=""),V[2]?this.semver=new Ce(V[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(B){return P("Comparator.test",B,this.loose),this.semver===pe||(typeof B=="string"&&(B=new Ce(B,this.loose)),x(B,this.operator,this.semver,this.loose))},me.prototype.intersects=function(B,H){if(!(B instanceof me))throw new TypeError("a Comparator is required");var V;if(this.operator==="")return V=new Re(B.value,H),Te(this.value,V,H);if(B.operator==="")return V=new Re(this.value,H),Te(B.semver,V,H);var ne=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),fe=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Ie=this.semver.version===B.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Qe=x(this.semver,"<",B.semver,H)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),_e=x(this.semver,">",B.semver,H)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return ne||fe||Ie&&je||Qe||_e},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(B){var H=this.loose;B=B.trim(),P("range",B,H);var V=H?T[se]:T[ge];B=B.replace(V,ke),P("hyphen replace",B),B=B.replace(T[_],"$1$2$3"),P("comparator trim",B,T[_]),B=(B=(B=B.replace(T[M],"$1~")).replace(T[G],"$1^")).split(/\s+/).join(" ");var ne=H?T[Y]:T[le],fe=B.split(" ").map(function(Ie){return function(je,Qe){return P("comp",je),je=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){P("caret",et,rt);var mt=rt?T[K]:T[F];return et.replace(mt,function(lt,st,ct,ft,pt){var qe;return P("caret",et,lt,st,ct,ft,pt),ze(st)?qe="":ze(ct)?qe=">="+st+".0.0 <"+(+st+1)+".0.0":ze(ft)?qe=st==="0"?">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+".0 <"+(+st+1)+".0.0":pt?(P("replaceCaret pr",pt),pt.charAt(0)!=="-"&&(pt="-"+pt),qe=st==="0"?ct==="0"?">="+st+"."+ct+"."+ft+pt+" <"+st+"."+ct+"."+(+ft+1):">="+st+"."+ct+"."+ft+pt+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+ft+pt+" <"+(+st+1)+".0.0"):(P("no pr"),qe=st==="0"?ct==="0"?">="+st+"."+ct+"."+ft+" <"+st+"."+ct+"."+(+ft+1):">="+st+"."+ct+"."+ft+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+ft+" <"+(+st+1)+".0.0"),P("caret return",qe),qe})}(nt,tt)}).join(" ")}(je,Qe),P("caret",je),je=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){var mt=rt?T[L]:T[N];return et.replace(mt,function(lt,st,ct,ft,pt){var qe;return P("tilde",et,lt,st,ct,ft,pt),ze(st)?qe="":ze(ct)?qe=">="+st+".0.0 <"+(+st+1)+".0.0":ze(ft)?qe=">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":pt?(P("replaceTilde pr",pt),pt.charAt(0)!=="-"&&(pt="-"+pt),qe=">="+st+"."+ct+"."+ft+pt+" <"+st+"."+(+ct+1)+".0"):qe=">="+st+"."+ct+"."+ft+" <"+st+"."+(+ct+1)+".0",P("tilde return",qe),qe})}(nt,tt)}).join(" ")}(je,Qe),P("tildes",je),je=function(_e,tt){return P("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(nt){return function(et,rt){et=et.trim();var mt=rt?T[C]:T[k];return et.replace(mt,function(lt,st,ct,ft,pt,qe){P("xRange",et,lt,st,ct,ft,pt,qe);var Ue=ze(ct),ee=Ue||ze(ft),Q=ee||ze(pt);return st==="="&&Q&&(st=""),Ue?lt=st===">"||st==="<"?"<0.0.0":"*":st&&Q?(ee&&(ft=0),Q&&(pt=0),st===">"?(st=">=",ee?(ct=+ct+1,ft=0,pt=0):Q&&(ft=+ft+1,pt=0)):st==="<="&&(st="<",ee?ct=+ct+1:ft=+ft+1),lt=st+ct+"."+ft+"."+pt):ee?lt=">="+ct+".0.0 <"+(+ct+1)+".0.0":Q&&(lt=">="+ct+"."+ft+".0 <"+ct+"."+(+ft+1)+".0"),P("xRange return",lt),lt})}(nt,tt)}).join(" ")}(je,Qe),P("xrange",je),je=function(_e,tt){return P("replaceStars",_e,tt),_e.trim().replace(T[ae],"")}(je,Qe),P("stars",je),je}(Ie,H)}).join(" ").split(/\s+/);return this.loose&&(fe=fe.filter(function(Ie){return!!Ie.match(ne)})),fe=fe.map(function(Ie){return new me(Ie,H)})},Re.prototype.intersects=function(B,H){if(!(B instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(V){return V.every(function(ne){return B.set.some(function(fe){return fe.every(function(Ie){return ne.intersects(Ie,H)})})})})},e.toComparators=function(B,H){return new Re(B,H).set.map(function(V){return V.map(function(ne){return ne.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new Ce(B,this.loose));for(var H=0;H<this.set.length;H++)if(Pe(this.set[H],B))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(B,H,V){var ne=null,fe=null;try{var Ie=new Re(H,V)}catch{return null}return B.forEach(function(je){Ie.test(je)&&(ne&&fe.compare(je)!==-1||(fe=new Ce(ne=je,V)))}),ne},e.minSatisfying=function(B,H,V){var ne=null,fe=null;try{var Ie=new Re(H,V)}catch{return null}return B.forEach(function(je){Ie.test(je)&&(ne&&fe.compare(je)!==1||(fe=new Ce(ne=je,V)))}),ne},e.validRange=function(B,H){try{return new Re(B,H).range||"*"}catch{return null}},e.ltr=function(B,H,V){return U(B,H,"<",V)},e.gtr=function(B,H,V){return U(B,H,">",V)},e.outside=U,e.prerelease=function(B,H){var V=oe(B,H);return V&&V.prerelease.length?V.prerelease:null},e.intersects=function(B,H,V){return B=new Re(B,V),H=new Re(H,V),B.intersects(H)},e.coerce=function(B){if(B instanceof Ce)return B;if(typeof B!="string")return null;var H=B.match(T[f]);return H==null?null:oe((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,v(1))},function(be,e){var v,I,P=be.exports={};function O(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function T(o){if(v===setTimeout)return setTimeout(o,0);if((v===O||!v)&&setTimeout)return v=setTimeout,setTimeout(o,0);try{return v(o,0)}catch{try{return v.call(null,o,0)}catch{return v.call(this,o,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:O}catch{v=O}try{I=typeof clearTimeout=="function"?clearTimeout:R}catch{I=R}})();var $,s=[],A=!1,y=-1;function a(){A&&$&&(A=!1,$.length?s=$.concat(s):y=-1,s.length&&S())}function S(){if(!A){var o=T(a);A=!0;for(var c=s.length;c;){for($=s,s=[];++y<c;)$&&$[y].run();y=-1,c=s.length}$=null,A=!1,function(l){if(I===clearTimeout)return clearTimeout(l);if((I===R||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(l);try{I(l)}catch{try{return I.call(null,l)}catch{return I.call(this,l)}}}(o)}}function d(o,c){this.fun=o,this.array=c}function n(){}P.nextTick=function(o){var c=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)c[l-1]=arguments[l];s.push(new d(o,c)),s.length!==1||A||T(S)},d.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=n,P.addListener=n,P.once=n,P.off=n,P.removeListener=n,P.removeAllListeners=n,P.emit=n,P.prependListener=n,P.prependOnceListener=n,P.listeners=function(o){return[]},P.binding=function(o){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(o){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Oe[146],Ne([1,0,6,4]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.$ct=e.$bt=e.$at=e.ScrollbarVisibility=void 0;var P;(function(S){S[S.Auto=1]="Auto",S[S.Hidden=2]="Hidden",S[S.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class O{constructor(d,n,o,c,l,i,r){this.c=d,this._scrollStateBrand=void 0,this.c&&(n=n|0,o=o|0,c=c|0,l=l|0,i=i|0,r=r|0),this.rawScrollLeft=c,this.rawScrollTop=r,n<0&&(n=0),c+n>o&&(c=o-n),c<0&&(c=0),l<0&&(l=0),r+l>i&&(r=i-l),r<0&&(r=0),this.width=n,this.scrollWidth=o,this.scrollLeft=c,this.height=l,this.scrollHeight=i,this.scrollTop=r}equals(d){return this.rawScrollLeft===d.rawScrollLeft&&this.rawScrollTop===d.rawScrollTop&&this.width===d.width&&this.scrollWidth===d.scrollWidth&&this.scrollLeft===d.scrollLeft&&this.height===d.height&&this.scrollHeight===d.scrollHeight&&this.scrollTop===d.scrollTop}withScrollDimensions(d,n){return new O(this.c,typeof d.width<"u"?d.width:this.width,typeof d.scrollWidth<"u"?d.scrollWidth:this.scrollWidth,n?this.rawScrollLeft:this.scrollLeft,typeof d.height<"u"?d.height:this.height,typeof d.scrollHeight<"u"?d.scrollHeight:this.scrollHeight,n?this.rawScrollTop:this.scrollTop)}withScrollPosition(d){return new O(this.c,this.width,this.scrollWidth,typeof d.scrollLeft<"u"?d.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof d.scrollTop<"u"?d.scrollTop:this.rawScrollTop)}createScrollEvent(d,n){const o=this.width!==d.width,c=this.scrollWidth!==d.scrollWidth,l=this.scrollLeft!==d.scrollLeft,i=this.height!==d.height,r=this.scrollHeight!==d.scrollHeight,t=this.scrollTop!==d.scrollTop;return{inSmoothScrolling:n,oldWidth:d.width,oldScrollWidth:d.scrollWidth,oldScrollLeft:d.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:d.height,oldScrollHeight:d.scrollHeight,oldScrollTop:d.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:c,scrollLeftChanged:l,heightChanged:i,scrollHeightChanged:r,scrollTopChanged:t}}}e.$at=O;class R extends I.$Tc{constructor(d){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$je),this.onScroll=this.j.event,this.c=d.smoothScrollDuration,this.f=d.scheduleAtNextAnimationFrame,this.g=new O(d.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(d){this.c=d}validateScrollPosition(d){return this.g.withScrollPosition(d)}getScrollDimensions(){return this.g}setScrollDimensions(d,n){const o=this.g.withScrollDimensions(d,n);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(d){const n=this.g.withScrollPosition(d);this.h&&(this.h.dispose(),this.h=null),this.n(n,!1)}setScrollPositionSmooth(d,n){if(this.c===0)return this.setScrollPositionNow(d);if(this.h){d={scrollLeft:typeof d.scrollLeft>"u"?this.h.to.scrollLeft:d.scrollLeft,scrollTop:typeof d.scrollTop>"u"?this.h.to.scrollTop:d.scrollTop};const o=this.g.withScrollPosition(d);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let c;n?c=new A(this.h.from,o,this.h.startTime,this.h.duration):c=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=c}else{const o=this.g.withScrollPosition(d);this.h=A.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const d=this.h.tick(),n=this.g.withScrollPosition(d);if(this.n(n,!0),!!this.h){if(d.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(d,n){const o=this.g;o.equals(d)||(this.g=d,this.j.fire(this.g.createScrollEvent(o,n)))}}e.$bt=R;class T{constructor(d,n,o){this.scrollLeft=d,this.scrollTop=n,this.isDone=o}}e.$ct=T;function $(S,d){const n=d-S;return function(o){return S+n*a(o)}}function s(S,d,n){return function(o){return o<n?S(o/n):d((o-n)/(1-n))}}class A{constructor(d,n,o,c){this.from=d,this.to=n,this.duration=c,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(d,n,o){if(Math.abs(d-n)>2.5*o){let l,i;return d<n?(l=d+.75*o,i=n-.75*o):(l=d-.75*o,i=n+.75*o),s($(d,l),$(i,n),.33)}return $(d,n)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(d){this.to=d.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(d){const n=(d-this.startTime)/this.duration;if(n<1){const o=this.c(n),c=this.d(n);return new T(o,c,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(d,n,o){return A.start(d,n,o)}static start(d,n,o){o=o+10;const c=Date.now()-10;return new A(d,n,c,o)}}e.$dt=A;function y(S){return Math.pow(S,3)}function a(S){return 1-y(1-S)}}),define(Oe[147],Ne([1,0,13,4]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=P,e.$xe=O,e.$ye=R,e.$ze=T,e.$Ae=s,e.$Be=A,e.$Ce=y,e.$De=a,e.$Ee=S,e.$Fe=d,e.$Ge=n,e.$He=o,e.$Ie=c,e.$Je=l,e.$Ke=i;function P(r){const t=r;return t?typeof t.read=="function":!1}function O(r){const t=r;return t?[t.on,t.pause,t.resume,t.destroy].every(g=>typeof g=="function"):!1}function R(r){const t=r;return t?O(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function T(r,t){return new $(r,t)}class ${constructor(t,g){this.e=t,this.f=g,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(g=>this.d.push(g))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(g=>g(t))}h(t){this.c.error.length===0?(0,v.$Y)(t):this.c.error.slice(0).forEach(g=>g(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,g){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(g),this.resume();break;case"end":this.c.end.push(g),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(g),this.a.flowing&&this.k();break}}removeListener(t,g){if(this.a.destroyed)return;let u;switch(t){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const m=u.indexOf(g);m>=0&&u.splice(m,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const g=[...this.d];this.d.length=0,g.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function s(r,t){const g=[];let u;for(;(u=r.read())!==null;)g.push(u);return t(g)}function A(r,t,g){const u=[];let m;for(;(m=r.read())!==null&&u.length<g;)u.push(m);return m===null&&u.length>0?t(u):{read:()=>{if(u.length>0)return u.shift();if(typeof m<"u"){const p=m;return m=void 0,p}return r.read()}}}function y(r,t){return new Promise((g,u)=>{const m=[];a(r,{onData:p=>{t&&m.push(p)},onError:p=>{t?u(p):g(void 0)},onEnd:()=>{g(t?t(m):void 0)}})})}function a(r,t,g){r.on("error",u=>{g?.isCancellationRequested||t.onError(u)}),r.on("end",()=>{g?.isCancellationRequested||t.onEnd()}),r.on("data",u=>{g?.isCancellationRequested||t.onData(u)})}function S(r,t){return new Promise((g,u)=>{const m=new I.$Sc,p=[],h=b=>{if(p.push(b),p.length>t)return m.dispose(),r.pause(),g({stream:r,buffer:p,ended:!1})},E=b=>(m.dispose(),u(b)),D=()=>(m.dispose(),g({stream:r,buffer:p,ended:!0}));m.add((0,I.$Rc)(()=>r.removeListener("error",E))),r.on("error",E),m.add((0,I.$Rc)(()=>r.removeListener("end",D))),r.on("end",D),m.add((0,I.$Rc)(()=>r.removeListener("data",h))),r.on("data",h)})}function d(r,t){const g=T(t);return g.end(r),g}function n(){const r=T(()=>{throw new Error("not supported")});return r.end(),r}function o(r){let t=!1;return{read:()=>t?null:(t=!0,r)}}function c(r,t,g){const u=T(g);return a(r,{onData:m=>u.write(t.data(m)),onError:m=>u.error(t.error?t.error(m):m),onEnd:()=>u.end()}),u}function l(r,t,g){let u=!1;return{read:()=>{const m=t.read();return u?m:(u=!0,m!==null?g([r,m]):r)}}}function i(r,t,g){let u=!1;const m=T(g);return a(t,{onData:p=>u?m.write(p):(u=!0,m.write(g([r,p]))),onError:p=>m.error(p),onEnd:()=>{u||(u=!0,m.write(r)),m.end()}}),m}}),define(Oe[22],Ne([1,0,48,147]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=s,e.$Ne=A,e.$Oe=y,e.$Pe=a,e.$Qe=S,e.$Re=d,e.$Se=n,e.$Te=o,e.$Ue=c,e.$Ve=l,e.$We=i,e.$Xe=r,e.$Ye=t,e.$Ze=g,e.$1e=u,e.$2e=m,e.$3e=p,e.$4e=h,e.$5e=E,e.$6e=k,I=We(I);const P=typeof Buffer<"u",O=new v.$T(()=>new Uint8Array(256));let R,T;class ${static alloc(f){return P?new $(Buffer.allocUnsafe(f)):new $(new Uint8Array(f))}static wrap(f){return P&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new $(f)}static fromString(f,w){return!(w?.dontUseNodeBuffer||!1)&&P?new $(Buffer.from(f)):(R||(R=new TextEncoder),new $(R.encode(f)))}static fromByteArray(f){const w=$.alloc(f.length);for(let M=0,N=f.length;M<N;M++)w.buffer[M]=f[M];return w}static concat(f,w){if(typeof w>"u"){w=0;for(let L=0,W=f.length;L<W;L++)w+=f[L].byteLength}const M=$.alloc(w);let N=0;for(let L=0,W=f.length;L<W;L++){const G=f[L];M.set(G,N),N+=G.byteLength}return M}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=$.alloc(this.byteLength);return f.set(this),f}toString(){return P?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(f,w){return new $(this.buffer.subarray(f,w))}set(f,w){if(f instanceof $)this.buffer.set(f.buffer,w);else if(f instanceof Uint8Array)this.buffer.set(f,w);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),w);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return a(this.buffer,f)}writeUInt32BE(f,w){S(this.buffer,f,w)}readUInt32LE(f){return d(this.buffer,f)}writeUInt32LE(f,w){n(this.buffer,f,w)}readUInt8(f){return o(this.buffer,f)}writeUInt8(f,w){c(this.buffer,f,w)}indexOf(f,w=0){return s(this.buffer,f instanceof $?f.buffer:f,w)}}e.$Le=$;function s(C,f,w=0){const M=f.byteLength,N=C.byteLength;if(M===0)return 0;if(M===1)return C.indexOf(f[0]);if(M>N-w)return-1;const L=O.value;L.fill(f.length);for(let K=0;K<f.length;K++)L[f[K]]=f.length-K-1;let W=w+f.length-1,G=W,F=-1;for(;W<N;)if(C[W]===f[G]){if(G===0){F=W;break}W--,G--}else W+=Math.max(f.length-G,L[C[W]]),G=f.length-1;return F}function A(C,f){return C[f+0]<<0>>>0|C[f+1]<<8>>>0}function y(C,f,w){C[w+0]=f&255,f=f>>>8,C[w+1]=f&255}function a(C,f){return C[f]*2**24+C[f+1]*2**16+C[f+2]*2**8+C[f+3]}function S(C,f,w){C[w+3]=f,f=f>>>8,C[w+2]=f,f=f>>>8,C[w+1]=f,f=f>>>8,C[w]=f}function d(C,f){return C[f+0]<<0>>>0|C[f+1]<<8>>>0|C[f+2]<<16>>>0|C[f+3]<<24>>>0}function n(C,f,w){C[w+0]=f&255,f=f>>>8,C[w+1]=f&255,f=f>>>8,C[w+2]=f&255,f=f>>>8,C[w+3]=f&255}function o(C,f){return C[f]}function c(C,f,w){C[w]=f}function l(C){return I.$Ae(C,f=>$.concat(f))}function i(C){return I.$He(C)}function r(C){return I.$Ce(C,f=>$.concat(f))}async function t(C){return C.ended?$.concat(C.buffer):$.concat([...C.buffer,await r(C.stream)])}function g(C){return I.$Fe(C,f=>$.concat(f))}function u(C){return I.$Ie(C,{data:f=>typeof f=="string"?$.fromString(f):$.wrap(f)},f=>$.concat(f))}function m(C){return I.$ze(f=>$.concat(f),C)}function p(C,f){return I.$Je(C,f,w=>$.concat(w))}function h(C,f){return I.$Ke(C,f,w=>$.concat(w))}function E(C){let f=0,w=0,M=0;const N=new Uint8Array(Math.floor(C.length/4*3)),L=G=>{switch(w){case 3:N[M++]=f|G,w=0;break;case 2:N[M++]=f|G>>>2,f=G<<6,w=3;break;case 1:N[M++]=f|G>>>4,f=G<<4,w=2;break;default:f=G<<2,w=1}};for(let G=0;G<C.length;G++){const F=C.charCodeAt(G);if(F>=65&&F<=90)L(F-65);else if(F>=97&&F<=122)L(F-97+26);else if(F>=48&&F<=57)L(F-48+52);else if(F===43||F===45)L(62);else if(F===47||F===95)L(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${C[G]}`)}}const W=M;for(;w>0;)L(0);return $.wrap(N).slice(0,W)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:C},f=!0,w=!1){const M=w?b:D;let N="";const L=C.byteLength%3;let W=0;for(;W<C.byteLength-L;W+=3){const G=C[W+0],F=C[W+1],K=C[W+2];N+=M[G>>>2],N+=M[(G<<4|F>>>4)&63],N+=M[(F<<2|K>>>6)&63],N+=M[K&63]}if(L===1){const G=C[W+0];N+=M[G>>>2],N+=M[G<<4&63],f&&(N+="==")}else if(L===2){const G=C[W+0],F=C[W+1];N+=M[G>>>2],N+=M[(G<<4|F>>>4)&63],N+=M[F<<2&63],f&&(N+="=")}return N}}),define(Oe[148],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0,e.$ee=Symbol("MicrotaskDelay")}),define(Oe[34],Ne([1,0,97]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$3j=P;var I;(function(R){function T($){return $&&typeof $=="object"&&typeof $.id=="string"}R.isThemeColor=T})(I||(e.ThemeColor=I={}));function P(R){return{id:R}}var O;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function $(l){const i=T.exec(l.id);if(!i)return $(v.$2j.error);const[,r,t]=i,g=["codicon","codicon-"+r];return t&&g.push("codicon-modifier-"+t.substring(1)),g}R.asClassNameArray=$;function s(l){return $(l).join(" ")}R.asClassName=s;function A(l){return"."+$(l).join(".")}R.asCSSSelector=A;function y(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||I.isThemeColor(l.color))}R.isThemeIcon=y;const a=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function S(l){const i=a.exec(l);if(!i)return;const[,r]=i;return{id:r}}R.fromString=S;function d(l){return{id:l}}R.fromId=d;function n(l,i){let r=l.id;const t=r.lastIndexOf("~");return t!==-1&&(r=r.substring(0,t)),i&&(r=`${r}~${i}`),{id:r}}R.modify=n;function o(l){const i=l.id.lastIndexOf("~");if(i!==-1)return l.id.substring(i+1)}R.getModifier=o;function c(l,i){return l.id===i.id&&l.color?.id===i.color?.id}R.isEqual=c})(O||(e.ThemeIcon=O={}))}),define(Oe[51],Ne([1,0,27,19,20,12,14]),function(be,e,v,I,P,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=T,e.$vg=$,e.$wg=s,e.$xg=A,e.$yg=y,e.$zg=n,e.$Ag=o,e.$Bg=c,e.$Cg=l,e.$Dg=i,e.$Eg=r,e.$Fg=t,e.$Gg=g,e.$Hg=u,e.$Ig=m,e.$Jg=p,e.$Kg=D;function T(b){return b===v.CharCode.Slash||b===v.CharCode.Backslash}function $(b){return b.replace(/[\\/]/g,I.$fc.sep)}function s(b){return b.indexOf("/")===-1&&(b=$(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}function A(b,k=I.$fc.sep){if(!b)return"";const C=b.length,f=b.charCodeAt(0);if(T(f)){if(T(b.charCodeAt(1))&&!T(b.charCodeAt(2))){let M=3;const N=M;for(;M<C&&!T(b.charCodeAt(M));M++);if(N!==M&&!T(b.charCodeAt(M+1))){for(M+=1;M<C;M++)if(T(b.charCodeAt(M)))return b.slice(0,M+1).replace(/[\\/]/g,k)}}return k}else if(l(f)&&b.charCodeAt(1)===v.CharCode.Colon)return T(b.charCodeAt(2))?b.slice(0,2)+k:b.slice(0,2);let w=b.indexOf("://");if(w!==-1){for(w+=3;w<C;w++)if(T(b.charCodeAt(w)))return b.slice(0,w+1)}return""}function y(b){if(!P.$j||!b||b.length<5)return!1;let k=b.charCodeAt(0);if(k!==v.CharCode.Backslash||(k=b.charCodeAt(1),k!==v.CharCode.Backslash))return!1;let C=2;const f=C;for(;C<b.length&&(k=b.charCodeAt(C),k!==v.CharCode.Backslash);C++);return!(f===C||(k=b.charCodeAt(C+1),isNaN(k)||k===v.CharCode.Backslash))}const a=/[\\/:\*\?"<>\|]/g,S=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(b,k=P.$j){const C=k?a:S;return!(!b||b.length===0||/^\s+$/.test(b)||(C.lastIndex=0,C.test(b))||k&&d.test(b)||b==="."||b===".."||k&&b[b.length-1]==="."||k&&b.length!==b.trim().length||b.length>255)}function o(b,k,C){const f=b===k;return!C||f?f:!b||!k?!1:(0,O.$Df)(b,k)}function c(b,k,C,f=I.sep){if(b===k)return!0;if(!b||!k||k.length>b.length)return!1;if(C){if(!(0,O.$Ef)(b,k))return!1;if(k.length===b.length)return!0;let M=k.length;return k.charAt(k.length-1)===f&&M--,b.charAt(M)===f}return k.charAt(k.length-1)!==f&&(k+=f),b.indexOf(k)===0}function l(b){return b>=v.CharCode.A&&b<=v.CharCode.Z||b>=v.CharCode.a&&b<=v.CharCode.z}function i(b,k){return P.$j&&b.endsWith(":")&&(b+=I.sep),(0,I.$hc)(b)||(b=(0,I.$ic)(k,b)),b=(0,I.$gc)(b),r(b)}function r(b){return P.$j?(b=(0,O.$lf)(b,I.sep),b.endsWith(":")&&(b+=I.sep)):(b=(0,O.$lf)(b,I.sep),b||(b=I.sep)),b}function t(b){const k=(0,I.$gc)(b);return P.$j?b.length>3?!1:g(k)&&(b.length===2||k.charCodeAt(2)===v.CharCode.Backslash):k===I.$fc.sep}function g(b,k=P.$j){return k?l(b.charCodeAt(0))&&b.charCodeAt(1)===v.CharCode.Colon:!1}function u(b,k=P.$j){return g(b,k)?b[0]:void 0}function m(b,k,C){return k.length>b.length?-1:b===k?0:(C&&(b=b.toLowerCase(),k=k.toLowerCase()),b.indexOf(k))}function p(b){const k=b.split(":");let C,f,w;for(const M of k){const N=Number(M);(0,R.$gg)(N)?f===void 0?f=N:w===void 0&&(w=N):C=C?[C,M].join(":"):M}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:f!==void 0?f:void 0,column:w!==void 0?w:f!==void 0?1:void 0}}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(b,k,C=8){let f="";for(let M=0;M<C;M++){let N;M===0&&P.$j&&!k&&(C===3||C===4)?N=E:N=h,f+=N.charAt(Math.floor(Math.random()*N.length))}let w;return k?w=`${k}-${f}`:w=f,b?(0,I.$ic)(b,w):w}}),define(Oe[149],Ne([1,0,27,28,139,12]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.FuzzyScore=e.$Fk=e.$Ek=void 0,e.or=R,e.$Gk=$,e.$Hk=s,e.$Ik=a,e.$Jk=D,e.$Kk=b,e.$Lk=N,e.$Mk=L,e.$Nk=W,e.$Ok=G,e.$Pk=te,e.$Rk=ue,e.$Sk=me,e.$Tk=pe,O=We(O);function R(...ke){return function(Pe,Te){for(let U=0,B=ke.length;U<B;U++){const H=ke[U](Pe,Te);if(H)return H}return null}}e.$Ek=T.bind(void 0,!1),e.$Fk=T.bind(void 0,!0);function T(ke,Pe,Te){if(!Te||Te.length<Pe.length)return null;let U;return ke?U=O.$Ef(Te,Pe):U=Te.indexOf(Pe)===0,U?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function $(ke,Pe){const Te=Pe.toLowerCase().indexOf(ke.toLowerCase());return Te===-1?null:[{start:Te,end:Te+ke.length}]}function s(ke,Pe){return A(ke.toLowerCase(),Pe.toLowerCase(),0,0)}function A(ke,Pe,Te,U){if(Te===ke.length)return[];if(U===Pe.length)return null;if(ke[Te]===Pe[U]){let B=null;return(B=A(ke,Pe,Te+1,U+1))?t({start:U,end:U+1},B):null}return A(ke,Pe,Te,U+1)}function y(ke){return v.CharCode.a<=ke&&ke<=v.CharCode.z}function a(ke){return v.CharCode.A<=ke&&ke<=v.CharCode.Z}function S(ke){return v.CharCode.Digit0<=ke&&ke<=v.CharCode.Digit9}function d(ke){return ke===v.CharCode.Space||ke===v.CharCode.Tab||ke===v.CharCode.LineFeed||ke===v.CharCode.CarriageReturn}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>n.add(ke.charCodeAt(0)));function o(ke){return d(ke)||n.has(ke)}function c(ke,Pe){return ke===Pe||o(ke)&&o(Pe)}const l=new Map;function i(ke){if(l.has(ke))return l.get(ke);let Pe;const Te=(0,P.$Ck)(ke);return Te&&(Pe=Te),l.set(ke,Pe),Pe}function r(ke){return y(ke)||a(ke)||S(ke)}function t(ke,Pe){return Pe.length===0?Pe=[ke]:ke.end===Pe[0].start?Pe[0].start=ke.start:Pe.unshift(ke),Pe}function g(ke,Pe){for(let Te=Pe;Te<ke.length;Te++){const U=ke.charCodeAt(Te);if(a(U)||S(U)||Te>0&&!r(ke.charCodeAt(Te-1)))return Te}return ke.length}function u(ke,Pe,Te,U){if(Te===ke.length)return[];if(U===Pe.length)return null;if(ke[Te]!==Pe[U].toLowerCase())return null;{let B=null,H=U+1;for(B=u(ke,Pe,Te+1,U+1);!B&&(H=g(Pe,H))<Pe.length;)B=u(ke,Pe,Te+1,H),H++;return B===null?null:t({start:U,end:U+1},B)}}function m(ke){let Pe=0,Te=0,U=0,B=0,H=0;for(let je=0;je<ke.length;je++)H=ke.charCodeAt(je),a(H)&&Pe++,y(H)&&Te++,r(H)&&U++,S(H)&&B++;const V=Pe/ke.length,ne=Te/ke.length,fe=U/ke.length,Ie=B/ke.length;return{upperPercent:V,lowerPercent:ne,alphaPercent:fe,numericPercent:Ie}}function p(ke){const{upperPercent:Pe,lowerPercent:Te}=ke;return Te===0&&Pe>.6}function h(ke){const{upperPercent:Pe,lowerPercent:Te,alphaPercent:U,numericPercent:B}=ke;return Te>.2&&Pe<.8&&U>.6&&B<.2}function E(ke){let Pe=0,Te=0,U=0,B=0;for(let H=0;H<ke.length;H++)U=ke.charCodeAt(H),a(U)&&Pe++,y(U)&&Te++,d(U)&&B++;return(Pe===0||Te===0)&&B===0?ke.length<=30:Pe<=5}function D(ke,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!E(ke))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Te=m(Pe);if(!h(Te)){if(!p(Te))return null;Pe=Pe.toLowerCase()}let U=null,B=0;for(ke=ke.toLowerCase();B<Pe.length&&(U=u(ke,Pe,0,B))===null;)B=g(Pe,B+1);return U}function b(ke,Pe,Te=!1){if(!Pe||Pe.length===0)return null;let U=null,B=0;for(ke=ke.toLowerCase(),Pe=Pe.toLowerCase();B<Pe.length&&(U=k(ke,Pe,0,B,Te),U===null);)B=C(Pe,B+1);return U}function k(ke,Pe,Te,U,B){let H=0;if(Te===ke.length)return[];if(U===Pe.length)return null;if(!c(ke.charCodeAt(Te),Pe.charCodeAt(U))){const fe=i(ke.charCodeAt(Te));if(!fe)return null;for(let Ie=0;Ie<fe.length;Ie++)if(!c(fe[Ie],Pe.charCodeAt(U+Ie)))return null;H+=fe.length-1}let V=null,ne=U+H+1;if(V=k(ke,Pe,Te+1,ne,B),!B)for(;!V&&(ne=C(Pe,ne))<Pe.length;)V=k(ke,Pe,Te+1,ne,B),ne++;if(!V)return null;if(ke.charCodeAt(Te)!==Pe.charCodeAt(U)){const fe=i(ke.charCodeAt(Te));if(!fe)return V;for(let Ie=0;Ie<fe.length;Ie++)if(fe[Ie]!==Pe.charCodeAt(U+Ie))return V}return t({start:U,end:U+H+1},V)}function C(ke,Pe){for(let Te=Pe;Te<ke.length;Te++)if(o(ke.charCodeAt(Te))||Te>0&&o(ke.charCodeAt(Te-1)))return Te;return ke.length}const f=R(e.$Fk,D,$),w=R(e.$Fk,D,s),M=new I.$Cc(1e4);function N(ke,Pe,Te=!1){if(typeof ke!="string"||typeof Pe!="string")return null;let U=M.get(ke);U||(U=new RegExp(O.$mf(ke),"i"),M.set(ke,U));const B=U.exec(Pe);return B?[{start:B.index,end:B.index+B[0].length}]:Te?w(ke,Pe):f(ke,Pe)}function L(ke,Pe){const Te=ue(ke,ke.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Te?G(Te):null}function W(ke,Pe,Te,U,B,H){const V=Math.min(13,ke.length);for(;Te<V;Te++){const ne=ue(ke,Pe,Te,U,B,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ne)return ne}return[0,H]}function G(ke){if(typeof ke>"u")return[];const Pe=[],Te=ke[1];for(let U=ke.length-1;U>1;U--){const B=ke[U]+Te,H=Pe[Pe.length-1];H&&H.end===B?H.end=B+1:Pe.push({start:B,end:B+1})}return Pe}const F=128;function K(){const ke=[],Pe=[];for(let Te=0;Te<=F;Te++)Pe[Te]=0;for(let Te=0;Te<=F;Te++)ke.push(Pe.slice(0));return ke}function Y(ke){const Pe=[];for(let Te=0;Te<=ke;Te++)Pe[Te]=0;return Pe}const le=Y(2*F),_=Y(2*F),ge=K(),se=K(),ae=K(),$e=!1;function oe(ke,Pe,Te,U,B){function H(ne,fe,Ie=" "){for(;ne.length<fe;)ne=Ie+ne;return ne}let V=` |   |${U.split("").map(ne=>H(ne,3)).join("|")}
`;for(let ne=0;ne<=Te;ne++)ne===0?V+=" |":V+=`${Pe[ne-1]}|`,V+=ke[ne].slice(0,B+1).map(fe=>H(fe.toString(),3)).join("|")+`
`;return V}function Ce(ke,Pe,Te,U){ke=ke.substr(Pe),Te=Te.substr(U),console.log(oe(se,ke,ke.length,Te,Te.length)),console.log(oe(ae,ke,ke.length,Te,Te.length)),console.log(oe(ge,ke,ke.length,Te,Te.length))}function Le(ke,Pe){if(Pe<0||Pe>=ke.length)return!1;const Te=ke.codePointAt(Pe);switch(Te){case v.CharCode.Underline:case v.CharCode.Dash:case v.CharCode.Period:case v.CharCode.Space:case v.CharCode.Slash:case v.CharCode.Backslash:case v.CharCode.SingleQuote:case v.CharCode.DoubleQuote:case v.CharCode.Colon:case v.CharCode.DollarSign:case v.CharCode.LessThan:case v.CharCode.GreaterThan:case v.CharCode.OpenParen:case v.CharCode.CloseParen:case v.CharCode.OpenSquareBracket:case v.CharCode.CloseSquareBracket:case v.CharCode.OpenCurlyBrace:case v.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.$Wf(Te)}}function Z(ke,Pe){if(Pe<0||Pe>=ke.length)return!1;switch(ke.charCodeAt(Pe)){case v.CharCode.Space:case v.CharCode.Tab:return!0;default:return!1}}function q(ke,Pe,Te){return Pe[ke]!==Te[ke]}function te(ke,Pe,Te,U,B,H,V=!1){for(;Pe<Te&&B<H;)ke[Pe]===U[B]&&(V&&(le[Pe]=B),Pe+=1),B+=1;return Pe===Te}var ve;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var ce;(function(ke){ke.Default=[-100,0];function Pe(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}ke.isDefault=Pe})(ce||(e.FuzzyScore=ce={}));class we{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Te){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Te}}e.$Qk=we;function ue(ke,Pe,Te,U,B,H,V=we.default){const ne=ke.length>F?F:ke.length,fe=U.length>F?F:U.length;if(Te>=ne||H>=fe||ne-Te>fe-H||!te(Pe,Te,ne,B,H,fe,!0))return;X(ne,fe,Te,H,Pe,B);let Ie=1,je=1,Qe=Te,_e=H;const tt=[!1];for(Ie=1,Qe=Te;Qe<ne;Ie++,Qe++){const lt=le[Qe],st=_[Qe],ct=Qe+1<ne?_[Qe+1]:fe;for(je=lt-H+1,_e=lt;_e<ct;je++,_e++){let ft=Number.MIN_SAFE_INTEGER,pt=!1;_e<=st&&(ft=x(ke,Pe,Qe,Te,U,B,_e,fe,H,ge[Ie-1][je-1]===0,tt));let qe=0;ft!==Number.MAX_SAFE_INTEGER&&(pt=!0,qe=ft+se[Ie-1][je-1]);const Ue=_e>lt,ee=Ue?se[Ie][je-1]+(ge[Ie][je-1]>0?-5:0):0,Q=_e>lt+1&&ge[Ie][je-1]>0,De=Q?se[Ie][je-2]+(ge[Ie][je-2]>0?-5:0):0;if(Q&&(!Ue||De>=ee)&&(!pt||De>=qe))se[Ie][je]=De,ae[Ie][je]=ve.LeftLeft,ge[Ie][je]=0;else if(Ue&&(!pt||ee>=qe))se[Ie][je]=ee,ae[Ie][je]=ve.Left,ge[Ie][je]=0;else if(pt)se[Ie][je]=qe,ae[Ie][je]=ve.Diag,ge[Ie][je]=ge[Ie-1][je-1]+1;else throw new Error("not possible")}}if($e&&Ce(ke,Te,U,H),!tt[0]&&!V.firstMatchCanBeWeak)return;Ie--,je--;const nt=[se[Ie][je],H];let et=0,rt=0;for(;Ie>=1;){let lt=je;do{const st=ae[Ie][lt];if(st===ve.LeftLeft)lt=lt-2;else if(st===ve.Left)lt=lt-1;else break}while(lt>=1);et>1&&Pe[Te+Ie-1]===B[H+je-1]&&!q(lt+H-1,U,B)&&et+1>ge[Ie][lt]&&(lt=je),lt===je?et++:et=1,rt||(rt=lt),Ie--,je=lt-1,nt.push(je)}fe-H===ne&&V.boostFullMatch&&(nt[0]+=2);const mt=rt-ne;return nt[0]-=mt,nt}function X(ke,Pe,Te,U,B,H){let V=ke-1,ne=Pe-1;for(;V>=Te&&ne>=U;)B[V]===H[ne]&&(_[V]=ne,V--),ne--}function x(ke,Pe,Te,U,B,H,V,ne,fe,Ie,je){if(Pe[Te]!==H[V])return Number.MIN_SAFE_INTEGER;let Qe=1,_e=!1;return V===Te-U?Qe=ke[Te]===B[V]?7:5:q(V,B,H)&&(V===0||!q(V-1,B,H))?(Qe=ke[Te]===B[V]?7:5,_e=!0):Le(H,V)&&(V===0||!Le(H,V-1))?Qe=5:(Le(H,V-1)||Z(H,V-1))&&(Qe=5,_e=!0),Qe>1&&Te===U&&(je[0]=!0),_e||(_e=q(V,B,H)||Le(H,V-1)||Z(H,V-1)),Te===U?V>fe&&(Qe-=_e?3:5):Ie?Qe+=_e?2:0:Qe+=_e?0:1,V+1===ne&&(Qe-=_e?3:5),Qe}function me(ke,Pe,Te,U,B,H,V){return Re(ke,Pe,Te,U,B,H,!0,V)}function pe(ke,Pe,Te,U,B,H,V){return Re(ke,Pe,Te,U,B,H,!1,V)}function Re(ke,Pe,Te,U,B,H,V,ne){let fe=ue(ke,Pe,Te,U,B,H,ne);if(fe&&!V)return fe;if(ke.length>=3){const Ie=Math.min(7,ke.length-1);for(let je=Te+1;je<Ie;je++){const Qe=ze(ke,je);if(Qe){const _e=ue(Qe,Qe.toLowerCase(),Te,U,B,H,ne);_e&&(_e[0]-=3,(!fe||_e[0]>fe[0])&&(fe=_e))}}}return fe}function ze(ke,Pe){if(Pe+1>=ke.length)return;const Te=ke[Pe],U=ke[Pe+1];if(Te!==U)return ke.slice(0,Pe)+U+Te+ke.slice(Pe+2)}}),define(Oe[98],Ne([1,0,149,12,34]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=$,e.$Vk=A,e.$Wk=a,e.$Xk=S,e.$Yk=n,e.$Zk=o;const O="$(",R=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${R.source}`,"g");function $(c){return c.replace(T,(l,i)=>i?l:`\\${l}`)}const s=new RegExp(`\\\\${R.source}`,"g");function A(c){return c.replace(s,l=>`\\${l}`)}const y=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function a(c){return c.indexOf(O)===-1?c:c.replace(y,(l,i,r,t)=>r?l:i||t||"")}function S(c){return c?c.replace(/\$\((.*?)\)/g,(l,i)=>` ${i} `).trim():""}const d=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(c){d.lastIndex=0;let l="";const i=[];let r=0;for(;;){const t=d.lastIndex,g=d.exec(c),u=c.substring(t,g?.index);if(u.length>0){l+=u;for(let m=0;m<u.length;m++)i.push(r)}if(!g)break;r+=g[0].length}return{text:l,iconOffsets:i}}function o(c,l,i=!1){const{text:r,iconOffsets:t}=l;if(!t||t.length===0)return(0,v.$Lk)(c,r,i);const g=(0,I.$kf)(r," "),u=r.length-g.length,m=(0,v.$Lk)(c,g,i);if(m)for(const p of m){const h=t[p.start+u]+u;p.start+=h,p.end+=h}return m}}),define(Oe[35],Ne([1,0,12]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v=We(v);var I;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(I||(I={})),function(P){const O="error",R="warning",T="warn",$="info",s="ignore";function A(a){return a?v.$Df(O,a)?P.Error:v.$Df(R,a)||v.$Df(T,a)?P.Warning:v.$Df($,a)?P.Info:P.Ignore:P.Ignore}P.fromValue=A;function y(a){switch(a){case P.Error:return O;case P.Warning:return R;case P.Info:return $;default:return s}}P.toString=y}(I||(I={})),e.default=I}),define(Oe[58],Ne([1,0,17,27,12]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class O{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const n=d.charCodeAt(0),o=this.b.charCodeAt(this.c);return n-o}value(){return this.b[this.c]}}e.$Ei=O;class R{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===I.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,P.$xf)(d,this.b,0,d.length,this.c,this.d):(0,P.$zf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Fi=R;class T{constructor(d=!0,n=!0){this.f=d,this.g=n}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let n=d.length-1;n>=0;n--,this.c--){const o=this.b.charCodeAt(n);if(!(o===I.CharCode.Slash||this.f&&o===I.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const n=this.b.charCodeAt(this.e);if(n===I.CharCode.Slash||this.f&&n===I.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,P.$xf)(d,this.b,0,d.length,this.d,this.e):(0,P.$zf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Gi=T;var $;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})($||($={}));class s{constructor(d,n){this.f=d,this.g=n,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new T(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push($.Path)),this.g(d)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===$.Scheme)return(0,P.$yf)(d,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,P.$yf)(d,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(d);if(this.d[this.e]===$.Query)return(0,P.$wf)(d,this.c.query);if(this.d[this.e]===$.Fragment)return(0,P.$wf)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Hi=s;class A{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(y||(y={}));class a{static forUris(d=()=>!1,n=()=>!1){return new a(new s(d,n))}static forPaths(d=!1){return new a(new T(void 0,!d))}static forStrings(){return new a(new O)}static forConfigKeys(){return new a(new R)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,n){if(n){const o=n.slice(0);(0,v.$Vb)(o);for(const c of o)this.set(c,d)}else{const o=d.slice(0);(0,v.$Vb)(o);for(const c of o)this.set(c[0],c[1])}}set(d,n){const o=this.b.reset(d);let c;this.c||(this.c=new A,this.c.segment=o.value());const l=[];for(c=this.c;;){const r=o.cmp(c.segment);if(r>0)c.left||(c.left=new A,c.left.segment=o.value()),l.push([y.Left,c]),c=c.left;else if(r<0)c.right||(c.right=new A,c.right.segment=o.value()),l.push([y.Right,c]),c=c.right;else if(o.hasNext())o.next(),c.mid||(c.mid=new A,c.mid.segment=o.value()),l.push([y.Mid,c]),c=c.mid;else break}const i=c.value;c.value=n,c.key=d;for(let r=l.length-1;r>=0;r--){const t=l[r][1];t.updateHeight();const g=t.balanceFactor();if(g<-1||g>1){const u=l[r][0],m=l[r+1][0];if(u===y.Right&&m===y.Right)l[r][1]=t.rotateLeft();else if(u===y.Left&&m===y.Left)l[r][1]=t.rotateRight();else if(u===y.Right&&m===y.Left)t.right=l[r+1][1]=l[r+1][1].rotateRight(),l[r][1]=t.rotateLeft();else if(u===y.Left&&m===y.Right)t.left=l[r+1][1]=l[r+1][1].rotateLeft(),l[r][1]=t.rotateRight();else throw new Error;if(r>0)switch(l[r-1][0]){case y.Left:l[r-1][1].left=l[r][1];break;case y.Right:l[r-1][1].right=l[r][1];break;case y.Mid:l[r-1][1].mid=l[r][1];break}else this.c=l[0][1]}}return i}get(d){return this.d(d)?.value}d(d){const n=this.b.reset(d);let o=this.c;for(;o;){const c=n.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else break}return o}has(d){const n=this.d(d);return!(n?.value===void 0&&n?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,n){const o=this.b.reset(d),c=[];let l=this.c;for(;l;){const i=o.cmp(l.segment);if(i>0)c.push([y.Left,l]),l=l.left;else if(i<0)c.push([y.Right,l]),l=l.right;else if(o.hasNext())o.next(),c.push([y.Mid,l]),l=l.mid;else break}if(l){if(n?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const i=this.f(l.right);if(i.key){const{key:r,value:t,segment:g}=i;this.e(i.key,!1),l.key=r,l.value=t,l.segment=g}}else{const i=l.left??l.right;if(c.length>0){const[r,t]=c[c.length-1];switch(r){case y.Left:t.left=i;break;case y.Mid:t.mid=i;break;case y.Right:t.right=i;break}}else this.c=i}for(let i=c.length-1;i>=0;i--){const r=c[i][1];r.updateHeight();const t=r.balanceFactor();if(t>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),c[i][1]=r.rotateLeft()):t<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),c[i][1]=r.rotateRight()),i>0)switch(c[i-1][0]){case y.Left:c[i-1][1].left=c[i][1];break;case y.Right:c[i-1][1].right=c[i][1];break;case y.Mid:c[i-1][1].mid=c[i][1];break}else this.c=c[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const n=this.b.reset(d);let o=this.c,c;for(;o;){const l=n.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(n.hasNext())n.next(),c=o.value||c,o=o.mid;else break}return o&&o.value||c}findSuperstr(d){return this.g(d,!1)}g(d,n){const o=this.b.reset(d);let c=this.c;for(;c;){const l=o.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(o.hasNext())o.next(),c=c.mid;else return c.mid?this.h(c.mid):n?c.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[n,o]of this)d(o,n)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const n=[];return this.j(d,n),n[Symbol.iterator]()}j(d,n){d&&(d.left&&this.j(d.left,n),d.value&&n.push([d.key,d.value]),d.mid&&this.j(d.mid,n),d.right&&this.j(d.right,n))}_isBalanced(){const d=n=>{if(!n)return!0;const o=n.balanceFactor();return o<-1||o>1?!1:d(n.left)&&d(n.right)};return d(this.c)}}e.$Ii=a}),define(Oe[40],Ne([1,0,22,2,36]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=O,e.$$h=R,e.$_h=$;function O(s){return JSON.stringify(s,T)}function R(s){let A=JSON.parse(s);return A=$(A),A}function T(s,A){return A instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:A.source,flags:A.flags}:A}function $(s,A=0){if(!s||A>200)return s;if(typeof s=="object"){switch(s.$mid){case P.MarshalledId.Uri:return I.URI.revive(s);case P.MarshalledId.Regexp:return new RegExp(s.source,s.flags);case P.MarshalledId.Date:return new Date(s.source)}if(s instanceof v.$Le||s instanceof Uint8Array)return s;if(Array.isArray(s))for(let y=0;y<s.length;++y)s[y]=$(s[y],A+1);else for(const y in s)Object.hasOwnProperty.call(s,y)&&(s[y]=$(s[y],A+1))}return s}}),define(Oe[15],Ne([1,0,13,20,12,2,19]),function(be,e,v,I,P,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Pg=e.$Og=e.$Ng=e.Schemas=void 0,e.$Lg=$,e.$Mg=s,e.$Qg=y,v=We(v),I=We(I),R=We(R);var T;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(T||(e.Schemas=T={}));function $(d,n){return O.URI.isUri(d)?(0,P.$Df)(d.scheme,n):(0,P.$Ef)(d,n+":")}function s(d,...n){return n.some(o=>$(d,o))}e.$Ng="vscode-tkn",e.$Og="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,o){this.f=y(n,o)}getServerRootPath(){return this.f}get g(){return R.$fc.join(this.f,T.vscodeRemoteResource)}set(n,o,c){this.a[n]=o,this.b[n]=c}setConnectionToken(n,o){this.c[n]=o}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(t){return v.$Y(t),n}const o=n.authority;let c=this.a[o];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const l=this.b[o],i=this.c[o];let r=`path=${encodeURIComponent(n.path)}`;return typeof i=="string"&&(r+=`&${e.$Og}=${encodeURIComponent(i)}`),O.URI.from({scheme:I.$p?this.d:T.vscodeRemoteResource,authority:`${c}:${l}`,path:this.g,query:r})}}e.$Pg=new A;function y(d,n){return R.$fc.join(n??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Rg="vs/../../extensions",e.$Sg="vs/../../node_modules",e.$Tg="vs/../../node_modules.asar",e.$Ug="vs/../../node_modules.asar.unpacked",e.$Vg="vscode-app";class a{static{this.a=e.$Vg}asBrowserUri(n){const o=this.b(n,be);return this.uriToBrowserUri(o)}uriToBrowserUri(n){return n.scheme===T.vscodeRemote?e.$Pg.rewrite(n):n.scheme===T.file&&(I.$n||I.$r===`${T.vscodeFileResource}://${a.a}`)?n.with({scheme:T.vscodeFileResource,authority:n.authority||a.a,query:null,fragment:null}):n}asFileUri(n){const o=this.b(n,be);return this.uriToFileUri(o)}uriToFileUri(n){return n.scheme===T.vscodeFileResource?n.with({scheme:T.file,authority:n.authority!==a.a?n.authority:null,query:null,fragment:null}):n}b(n,o){return O.URI.isUri(n)?n:O.URI.parse(o.toUrl(n))}}e.$Wg=new a;var S;(function(d){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(n.get("3"));const o="vscode-coi";function c(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:O.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const t=r?.get(o);if(t)return n.get(t)}d.getHeadersFromQuery=c;function l(i,r,t){if(!globalThis.crossOriginIsolated)return;const g=r&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(o,g):i[o]=g}d.addSearchParam=l})(S||(e.COI=S={}))}),define(Oe[23],Ne([1,0,27,51,15,19,20,12,2]),function(be,e,v,I,P,O,R,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0,e.$4g=s,e.$mh=y,e.$nh=S,I=We(I),O=We(O);function s(d){return(0,$.$vc)(d,!0)}class A{constructor(n){this.a=n}compare(n,o,c=!1){return n===o?0:(0,T.$wf)(this.getComparisonKey(n,c),this.getComparisonKey(o,c))}isEqual(n,o,c=!1){return n===o?!0:!n||!o?!1:this.getComparisonKey(n,c)===this.getComparisonKey(o,c)}getComparisonKey(n,o=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,o,c=!1){if(n.scheme===o.scheme){if(n.scheme===P.Schemas.file)return I.$Bg(s(n),s(o),this.a(n))&&n.query===o.query&&(c||n.fragment===o.fragment);if((0,e.$ih)(n.authority,o.authority))return I.$Bg(n.path,o.path,this.a(n),"/")&&n.query===o.query&&(c||n.fragment===o.fragment)}return!1}joinPath(n,...o){return $.URI.joinPath(n,...o)}basenameOrAuthority(n){return(0,e.$ah)(n)||n.authority}basename(n){return O.$fc.basename(n.path)}extname(n){return O.$fc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let o;return n.scheme===P.Schemas.file?o=$.URI.file(O.$lc(s(n))).path:(o=O.$fc.dirname(n.path),n.authority&&o.length&&o.charCodeAt(0)!==v.CharCode.Slash&&(console.error(`dirname("${n.toString})) resulted in a relative path`),o="/")),n.with({path:o})}normalizePath(n){if(!n.path.length)return n;let o;return n.scheme===P.Schemas.file?o=$.URI.file(O.$gc(s(n))).path:o=O.$fc.normalize(n.path),n.with({path:o})}relativePath(n,o){if(n.scheme!==o.scheme||!(0,e.$ih)(n.authority,o.authority))return;if(n.scheme===P.Schemas.file){const i=O.$kc(s(n),s(o));return R.$j?I.$vg(i):i}let c=n.path||"/";const l=o.path||"/";if(this.a(n)){let i=0;for(const r=Math.min(c.length,l.length);i<r&&!(c.charCodeAt(i)!==l.charCodeAt(i)&&c.charAt(i).toLowerCase()!==l.charAt(i).toLowerCase());i++);c=l.substr(0,i)+c.substr(i)}return O.$fc.relative(c,l)}resolvePath(n,o){if(n.scheme===P.Schemas.file){const c=$.URI.file(O.$jc(s(n),o));return n.with({authority:c.authority,path:c.path})}return o=I.$wg(o),n.with({path:O.$fc.resolve(n.path,o)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,o){return n===o||n!==void 0&&o!==void 0&&(0,T.$Df)(n,o)}hasTrailingPathSeparator(n,o=O.sep){if(n.scheme===P.Schemas.file){const c=s(n);return c.length>I.$xg(c).length&&c[c.length-1]===o}else{const c=n.path;return c.length>1&&c.charCodeAt(c.length-1)===v.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,o=O.sep){return(0,e.$jh)(n,o)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,o=O.sep){let c=!1;if(n.scheme===P.Schemas.file){const l=s(n);c=l!==void 0&&l.length===I.$xg(l).length&&l[l.length-1]===o}else{o="/";const l=n.path;c=l.length===1&&l.charCodeAt(l.length-1)===v.CharCode.Slash}return!c&&!(0,e.$jh)(n,o)?n.with({path:n.path+"/"}):n}}e.$5g=A,e.$6g=new A(()=>!1),e.$7g=new A(d=>d.scheme===P.Schemas.file?!R.$l:!0),e.$8g=new A(d=>!0),e.$9g=e.$6g.isEqual.bind(e.$6g),e.$0g=e.$6g.isEqualOrParent.bind(e.$6g),e.$$g=e.$6g.getComparisonKey.bind(e.$6g),e.$_g=e.$6g.basenameOrAuthority.bind(e.$6g),e.$ah=e.$6g.basename.bind(e.$6g),e.$bh=e.$6g.extname.bind(e.$6g),e.$ch=e.$6g.dirname.bind(e.$6g),e.$dh=e.$6g.joinPath.bind(e.$6g),e.$eh=e.$6g.normalizePath.bind(e.$6g),e.$fh=e.$6g.relativePath.bind(e.$6g),e.$gh=e.$6g.resolvePath.bind(e.$6g),e.$hh=e.$6g.isAbsolutePath.bind(e.$6g),e.$ih=e.$6g.isEqualAuthority.bind(e.$6g),e.$jh=e.$6g.hasTrailingPathSeparator.bind(e.$6g),e.$kh=e.$6g.removeTrailingPathSeparator.bind(e.$6g),e.$lh=e.$6g.addTrailingPathSeparator.bind(e.$6g);function y(d,n){const o=[];for(let c=0;c<d.length;c++){const l=n(d[c]);d.some((i,r)=>r===c?!1:(0,e.$0g)(l,n(i)))||o.push(d[c])}return o}var a;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function n(o){const c=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(r=>{const[t,g]=r.split(":");t&&g&&c.set(t,g)});const i=o.path.substring(0,o.path.indexOf(";"));return i&&c.set(d.META_DATA_MIME,i),c}d.parseMetaData=n})(a||(e.DataUri=a={}));function S(d,n,o){if(n){let c=d.path;return c&&c[0]!==O.$fc.sep&&(c=O.$fc.sep+c),d.with({scheme:o,authority:n,path:c})}return d.with({scheme:o})}}),define(Oe[10],Ne([1,0,21,13,6,4,23,20,148,48]),function(be,e,v,I,P,O,R,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.Promises=e.$Zh=e.$Yh=e.$Xh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$oh=A,e.$ph=y,e.$qh=a,e.$rh=S,e.$sh=d,e.$th=n,e.$uh=o,e.$vh=c,e.$Dh=E,e.$Eh=D,e.$Fh=b,e.$Gh=k,e.$Hh=C,e.$Wh=ge,e.$5h=ce;function A(ue){return!!ue&&typeof ue.then=="function"}function y(ue){const X=new v.$ue,x=ue(X.token),me=new Promise((pe,Re)=>{const ze=X.token.onCancellationRequested(()=>{ze.dispose(),Re(new I.$4)});Promise.resolve(x).then(ke=>{ze.dispose(),X.dispose(),pe(ke)},ke=>{ze.dispose(),X.dispose(),Re(ke)})});return new class{cancel(){X.cancel(),X.dispose()}then(pe,Re){return me.then(pe,Re)}catch(pe){return this.then(void 0,pe)}finally(pe){return me.finally(pe)}}}function a(ue,X,x){return new Promise((me,pe)=>{const Re=X.onCancellationRequested(()=>{Re.dispose(),me(x)});ue.then(me,pe).finally(()=>Re.dispose())})}function S(ue,X){return new Promise((x,me)=>{const pe=X.onCancellationRequested(()=>{pe.dispose(),me(new I.$4)});ue.then(x,me).finally(()=>pe.dispose())})}async function d(ue){let X=-1;const x=ue.map((me,pe)=>me.then(Re=>(X=pe,Re)));try{return await Promise.race(x)}finally{ue.forEach((me,pe)=>{pe!==X&&me.cancel()})}}function n(ue,X,x){let me;const pe=setTimeout(()=>{me?.(void 0),x?.()},X);return Promise.race([ue.finally(()=>clearTimeout(pe)),new Promise(Re=>me=Re)])}function o(ue){return new Promise((X,x)=>{const me=ue();A(me)?me.then(X,x):X(me)})}function c(){let ue,X;return{promise:new Promise((me,pe)=>{ue=me,X=pe}),resolve:ue,reject:X}}class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const x=()=>{if(this.b=null,this.f)return;const me=this.queue(this.d);return this.d=null,me};this.b=new Promise(me=>{this.a.then(x,x).then(me)})}return new Promise((x,me)=>{this.b.then(x,me)})}return this.a=X(),new Promise((x,me)=>{this.a.then(pe=>{this.a=null,x(pe)},pe=>{this.a=null,me(pe)})})}dispose(){this.f=!0}}e.$wh=l;class i{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$xh=i;class r{constructor(){this.a=new Map}queue(X,x){const pe=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(X)===pe&&this.a.delete(X)});return this.a.set(X,pe),pe}}e.$yh=r;const t=(ue,X)=>{let x=!0;const me=setTimeout(()=>{x=!1,X()},ue);return{isTriggered:()=>x,dispose:()=>{clearTimeout(me),x=!1}}},g=ue=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,ue())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class u{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,x=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((pe,Re)=>{this.d=pe,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const pe=this.g;return this.g=null,pe()}}));const me=()=>{this.a=null,this.d?.(null)};return this.a=x===$.$ee?g(me):t(x,me),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new I.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$zh=u;class m{constructor(X){this.a=new u(X),this.b=new l}trigger(X,x){return this.a.trigger(()=>this.b.queue(X),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ah=m;class p{constructor(){this.a=!1,this.b=new Promise((X,x)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Bh=p;class h extends p{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Ch=h;function E(ue,X){return X?new Promise((x,me)=>{const pe=setTimeout(()=>{Re.dispose(),x()},ue),Re=X.onCancellationRequested(()=>{clearTimeout(pe),Re.dispose(),me(new I.$4)})}):y(x=>E(ue,x))}function D(ue,X=0,x){const me=setTimeout(()=>{ue(),x&&pe.dispose()},X),pe=(0,O.$Rc)(()=>{clearTimeout(me),x?.deleteAndLeak(pe)});return x?.add(pe),pe}function b(ue){const X=[];let x=0;const me=ue.length;function pe(){return x<me?ue[x++]():null}function Re(ze){ze!=null&&X.push(ze);const ke=pe();return ke?ke.then(Re):Promise.resolve(X)}return Promise.resolve(null).then(Re)}function k(ue,X=me=>!!me,x=null){let me=0;const pe=ue.length,Re=()=>{if(me>=pe)return Promise.resolve(x);const ze=ue[me++];return Promise.resolve(ze()).then(Pe=>X(Pe)?Promise.resolve(Pe):Re())};return Re()}function C(ue,X=me=>!!me,x=null){if(ue.length===0)return Promise.resolve(x);let me=ue.length;const pe=()=>{me=-1;for(const Re of ue)Re.cancel?.()};return new Promise((Re,ze)=>{for(const ke of ue)ke.then(Pe=>{--me>=0&&X(Pe)?(pe(),Re(Pe)):me===0&&Re(x)}).catch(Pe=>{--me>=0&&(pe(),ze(Pe))})})}class f{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new P.$je}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,me)=>{this.g.push({factory:X,c:x,e:me}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const x=X.factory();x.then(X.c,X.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ih=f;class w extends f{constructor(){super(1)}}e.$Jh=w;class M{constructor(){this.a=new se,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Kh=M;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new oe;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,x=R.$6g){const me=x.getComparisonKey(X);return this.a.get(me)?.size??0}queueFor(X,x,me=R.$6g){const pe=me.getComparisonKey(X);let Re=this.a.get(pe);if(!Re){Re=new w;const ze=this.f++,ke=P.Event.once(Re.onDrained)(()=>{Re?.dispose(),this.a.delete(pe),this.h(),this.d?.deleteAndDispose(ze),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$3c),this.d.set(ze,ke),this.a.set(pe,Re)}return Re.queue(x)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Lh=N;class L{constructor(X,x){this.b=!1,this.a=-1,typeof X=="function"&&typeof x=="number"&&this.setIfNotSet(X,x)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,x){if(this.b)throw new I.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},x)}setIfNotSet(X,x){if(this.b)throw new I.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},x))}}e.$Mh=L;class W{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,x,me=globalThis){if(this.f)throw new I.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const pe=me.setInterval(()=>{X()},x);this.d=(0,O.$Rc)(()=>{me.clearInterval(pe),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Nh=W;class G{constructor(X,x){this.b=-1,this.a=X,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Oh=G;class F{constructor(X,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=X,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ph=F;class K extends G{constructor(X,x){super(X,x),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Qh=K;class Y extends O.$Tc{constructor(X,x){super(),this.g=X,this.h=x,this.a=[],this.b=this.B(new O.$Uc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of X)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Rh=Y,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Th=(ue,X)=>{(0,T.$C)(()=>{if(x)return;const me=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$Th=(ue,X,x)=>{const me=ue.requestIdleCallback(X,typeof x=="number"?{timeout:x}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,ue.cancelIdleCallback(me))}}},e.$Sh=ue=>(0,e.$Th)(globalThis,ue)}();class le{constructor(X,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(me){this.l=me}finally{this.g=!0}},this.f=(0,e.$Th)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Uh=le;class _ extends le{constructor(X){super(globalThis,X)}}e.$Vh=_;async function ge(ue,X,x){let me;for(let pe=0;pe<x;pe++)try{return await ue()}catch(Re){me=Re,await E(X)}throw me}class se{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,x,me){return this.a={taskId:X,cancel:()=>me?.(),promise:x},x.then(()=>this.d(X),()=>this.d(X)),x}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:x,resolve:me,reject:pe}=c();this.b={run:X,promise:x,promiseResolve:me,promiseReject:pe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xh=se;class ae{constructor(X,x=()=>Date.now()){this.d=X,this.f=x,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$Yh=ae;var $e;(function(ue){ue[ue.Resolved=0]="Resolved",ue[ue.Rejected=1]="Rejected"})($e||($e={}));class oe{get isRejected(){return this.d?.outcome===$e.Rejected}get isResolved(){return this.d?.outcome===$e.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===$e.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,x)=>{this.a=X,this.b=x})}complete(X){return new Promise(x=>{this.a(X),this.d={outcome:$e.Resolved,value:X},x()})}error(X){return new Promise(x=>{this.b(X),this.d={outcome:$e.Rejected,value:X},x()})}cancel(){return this.error(new I.$4)}}e.$Zh=oe;var Ce;(function(ue){async function X(me){let pe;const Re=await Promise.all(me.map(ze=>ze.then(ke=>ke,ke=>{pe||(pe=ke)})));if(typeof pe<"u")throw pe;return Re}ue.settled=X;function x(me){return new Promise(async(pe,Re)=>{try{await me(pe,Re)}catch(ze){Re(ze)}})}ue.withAsyncBody=x})(Ce||(e.Promises=Ce={}));class Le{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new I.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$1h=Le;class Z{constructor(X){this.b=X,this.a=new s.$T(()=>new Le(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$2h=Z;var q;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(q||(q={}));class te{static fromArray(X){return new te(x=>{x.emitMany(X)})}static fromPromise(X){return new te(async x=>{x.emitMany(await X)})}static fromPromises(X){return new te(async x=>{await Promise.all(X.map(async me=>x.emitOne(await me)))})}static merge(X){return new te(async x=>{await Promise.all(X.map(async me=>{for await(const pe of me)x.emitOne(pe)}))})}static{this.EMPTY=te.fromArray([])}constructor(X,x){this.a=q.Initial,this.b=[],this.d=null,this.f=x,this.g=new P.$je,queueMicrotask(async()=>{const me={emitOne:pe=>this.h(pe),emitMany:pe=>this.j(pe),reject:pe=>this.l(pe)};try{await Promise.resolve(X(me)),this.k()}catch(pe){this.l(pe)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===q.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===q.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,x){return new te(async me=>{for await(const pe of X)me.emitOne(x(pe))})}map(X){return te.map(this,X)}static filter(X,x){return new te(async me=>{for await(const pe of X)x(pe)&&me.emitOne(pe)})}filter(X){return te.filter(this,X)}static coalesce(X){return te.filter(X,x=>!!x)}coalesce(){return te.coalesce(this)}static async toPromise(X){const x=[];for await(const me of X)x.push(me);return x}toPromise(){return te.toPromise(this)}h(X){this.a===q.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===q.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===q.Initial&&(this.a=q.DoneOK,this.g.fire())}l(X){this.a===q.Initial&&(this.a=q.DoneError,this.d=X,this.g.fire())}}e.$3h=te;class ve extends te{constructor(X,x){super(x),this.m=X}cancel(){this.m.cancel()}}e.$4h=ve;function ce(ue){const X=new v.$ue,x=ue(X.token);return new ve(X,async me=>{const pe=X.token.onCancellationRequested(()=>{pe.dispose(),X.dispose(),me.reject(new I.$4)});try{for await(const Re of x){if(X.token.isCancellationRequested)return;me.emitOne(Re)}pe.dispose(),X.dispose()}catch(Re){pe.dispose(),X.dispose(),me.reject(Re)}})}class we{constructor(X){this.a=new oe,this.b=new te(pe=>{if(x){pe.reject(x);return}return me&&pe.emitMany(me),this.d=Re=>pe.reject(Re),this.f=Re=>pe.emitOne(Re),this.a.p},X);let x,me;this.f=pe=>{me||(me=[]),me.push(pe)},this.d=pe=>{x||(x=pe)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$6h=we}),define(Oe[41],Ne([1,0,17,10,27,51,28,19,20,12]),function(be,e,v,I,P,O,R,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$sk=A,e.$vk=n,e.$wk=M,e.$xk=N,e.$yk=L,e.$zk=W,e.$Ak=G,e.$Bk=le;function A(){return Object.create(null)}e.$tk="**",e.$uk="/";const y="[/\\\\]",a="[^/\\\\]",S=/\//g;function d(_,ge){switch(_){case 0:return"";case 1:return`${a}*?`;default:return`(?:${y}|${a}+${y}${ge?`|${y}${a}+`:""})*?`}}function n(_,ge){if(!_)return[];const se=[];let ae=!1,$e=!1,oe="";for(const Ce of _){switch(Ce){case ge:if(!ae&&!$e){se.push(oe),oe="";continue}break;case"{":ae=!0;break;case"}":ae=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}oe+=Ce}return oe&&se.push(oe),se}function o(_){if(!_)return"";let ge="";const se=n(_,e.$uk);if(se.every(ae=>ae===e.$tk))ge=".*";else{let ae=!1;se.forEach(($e,oe)=>{if($e===e.$tk){if(ae)return;ge+=d(2,oe===se.length-1)}else{let Ce=!1,Le="",Z=!1,q="";for(const te of $e){if(te!=="}"&&Ce){Le+=te;continue}if(Z&&(te!=="]"||!q)){let ve;te==="-"?ve=te:(te==="^"||te==="!")&&!q?ve="^":te===e.$uk?ve="":ve=(0,s.$ff)(te),q+=ve;continue}switch(te){case"{":Ce=!0;continue;case"[":Z=!0;continue;case"}":{const ce=`(?:${n(Le,",").map(we=>o(we)).join("|")})`;ge+=ce,Ce=!1,Le="";break}case"]":{ge+="["+q+"]",Z=!1,q="";break}case"?":ge+=a;continue;case"*":ge+=d(1);continue;default:ge+=(0,s.$ff)(te)}}oe<se.length-1&&(se[oe+1]!==e.$tk||oe+2<se.length)&&(ge+=y)}ae=$e===e.$tk})}return ge}const c=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new R.$Cc(1e4),m=function(){return!1},p=function(){return null};function h(_,ge){if(!_)return p;let se;typeof _!="string"?se=_.pattern:se=_,se=se.trim();const ae=`${se}_${!!ge.trimForExclusions}`;let $e=u.get(ae);if($e)return E($e,_);let oe;return c.test(se)?$e=b(se.substr(4),se):(oe=l.exec(D(se,ge)))?$e=k(oe[1],se):(ge.trimForExclusions?r:i).test(se)?$e=C(se,ge):(oe=t.exec(D(se,ge)))?$e=f(oe[1].substr(1),se,!0):(oe=g.exec(D(se,ge)))?$e=f(oe[1],se,!1):$e=w(se),u.set(ae,$e),E($e,_)}function E(_,ge){if(typeof ge=="string")return _;const se=function(ae,$e){return(0,O.$Bg)(ae,ge.base,!$.$l)?_((0,s.$kf)(ae.substr(ge.base.length),T.sep),$e):null};return se.allBasenames=_.allBasenames,se.allPaths=_.allPaths,se.basenames=_.basenames,se.patterns=_.patterns,se}function D(_,ge){return ge.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function b(_,ge){return function(se,ae){return typeof se=="string"&&se.endsWith(_)?ge:null}}function k(_,ge){const se=`/${_}`,ae=`\\${_}`,$e=function(Ce,Le){return typeof Ce!="string"?null:Le?Le===_?ge:null:Ce===_||Ce.endsWith(se)||Ce.endsWith(ae)?ge:null},oe=[_];return $e.basenames=oe,$e.patterns=[ge],$e.allBasenames=oe,$e}function C(_,ge){const se=Y(_.slice(1,-1).split(",").map(Le=>h(Le,ge)).filter(Le=>Le!==p),_),ae=se.length;if(!ae)return p;if(ae===1)return se[0];const $e=function(Le,Z){for(let q=0,te=se.length;q<te;q++)if(se[q](Le,Z))return _;return null},oe=se.find(Le=>!!Le.allBasenames);oe&&($e.allBasenames=oe.allBasenames);const Ce=se.reduce((Le,Z)=>Z.allPaths?Le.concat(Z.allPaths):Le,[]);return Ce.length&&($e.allPaths=Ce),$e}function f(_,ge,se){const ae=T.sep===T.$fc.sep,$e=ae?_:_.replace(S,T.sep),oe=T.sep+$e,Ce=T.$fc.sep+_;let Le;return se?Le=function(Z,q){return typeof Z=="string"&&(Z===$e||Z.endsWith(oe)||!ae&&(Z===_||Z.endsWith(Ce)))?ge:null}:Le=function(Z,q){return typeof Z=="string"&&(Z===$e||!ae&&Z===_)?ge:null},Le.allPaths=[(se?"*/":"./")+_],Le}function w(_){try{const ge=new RegExp(`^${o(_)}$`);return function(se){return ge.lastIndex=0,typeof se=="string"&&ge.test(se)?_:null}}catch{return p}}function M(_,ge,se){return!_||typeof ge!="string"?!1:N(_)(ge,void 0,se)}function N(_,ge={}){if(!_)return m;if(typeof _=="string"||L(_)){const se=h(_,ge);if(se===p)return m;const ae=function($e,oe){return!!se($e,oe)};return se.allBasenames&&(ae.allBasenames=se.allBasenames),se.allPaths&&(ae.allPaths=se.allPaths),ae}return F(_,ge)}function L(_){const ge=_;return ge?typeof ge.base=="string"&&typeof ge.pattern=="string":!1}function W(_){return _.allBasenames||[]}function G(_){return _.allPaths||[]}function F(_,ge){const se=Y(Object.getOwnPropertyNames(_).map(Le=>K(Le,_[Le],ge)).filter(Le=>Le!==p)),ae=se.length;if(!ae)return p;if(!se.some(Le=>!!Le.requiresSiblings)){if(ae===1)return se[0];const Le=function(te,ve){let ce;for(let we=0,ue=se.length;we<ue;we++){const X=se[we](te,ve);if(typeof X=="string")return X;(0,I.$oh)(X)&&(ce||(ce=[]),ce.push(X))}return ce?(async()=>{for(const we of ce){const ue=await we;if(typeof ue=="string")return ue}return null})():null},Z=se.find(te=>!!te.allBasenames);Z&&(Le.allBasenames=Z.allBasenames);const q=se.reduce((te,ve)=>ve.allPaths?te.concat(ve.allPaths):te,[]);return q.length&&(Le.allPaths=q),Le}const $e=function(Le,Z,q){let te,ve;for(let ce=0,we=se.length;ce<we;ce++){const ue=se[ce];ue.requiresSiblings&&q&&(Z||(Z=(0,T.$mc)(Le)),te||(te=Z.substr(0,Z.length-(0,T.$nc)(Le).length)));const X=ue(Le,Z,te,q);if(typeof X=="string")return X;(0,I.$oh)(X)&&(ve||(ve=[]),ve.push(X))}return ve?(async()=>{for(const ce of ve){const we=await ce;if(typeof we=="string")return we}return null})():null},oe=se.find(Le=>!!Le.allBasenames);oe&&($e.allBasenames=oe.allBasenames);const Ce=se.reduce((Le,Z)=>Z.allPaths?Le.concat(Z.allPaths):Le,[]);return Ce.length&&($e.allPaths=Ce),$e}function K(_,ge,se){if(ge===!1)return p;const ae=h(_,se);if(ae===p)return p;if(typeof ge=="boolean")return ae;if(ge){const $e=ge.when;if(typeof $e=="string"){const oe=(Ce,Le,Z,q)=>{if(!q||!ae(Ce,Le))return null;const te=$e.replace("$(basename)",()=>Z),ve=q(te);return(0,I.$oh)(ve)?ve.then(ce=>ce?_:null):ve?_:null};return oe.requiresSiblings=!0,oe}}return ae}function Y(_,ge){const se=_.filter(Le=>!!Le.basenames);if(se.length<2)return _;const ae=se.reduce((Le,Z)=>{const q=Z.basenames;return q?Le.concat(q):Le},[]);let $e;if(ge){$e=[];for(let Le=0,Z=ae.length;Le<Z;Le++)$e.push(ge)}else $e=se.reduce((Le,Z)=>{const q=Z.patterns;return q?Le.concat(q):Le},[]);const oe=function(Le,Z){if(typeof Le!="string")return null;if(!Z){let te;for(te=Le.length;te>0;te--){const ve=Le.charCodeAt(te-1);if(ve===P.CharCode.Slash||ve===P.CharCode.Backslash)break}Z=Le.substr(te)}const q=ae.indexOf(Z);return q!==-1?$e[q]:null};oe.basenames=ae,oe.patterns=$e,oe.allBasenames=ae;const Ce=_.filter(Le=>!Le.basenames);return Ce.push(oe),Ce}function le(_,ge){return(0,v.$tb)(_,ge,(se,ae)=>typeof se=="string"&&typeof ae=="string"?se===ae:typeof se!="string"&&typeof ae!="string"?se.base===ae.base&&se.pattern===ae.pattern:!1)}}),define(Oe[59],Ne([1,0,13,98,23,12,2]),function(be,e,v,I,P,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.MarkdownStringTextNewlineStyle=void 0,e.$2k=s,e.$3k=A,e.$4k=y,e.$5k=a,e.$6k=S,e.$7k=d,e.$8k=n,e.$9k=o;var T;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class ${constructor(l="",i=!1){if(this.value=l,typeof this.value!="string")throw(0,v.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(l,i=T.Paragraph){return this.value+=a(this.supportThemeIcons?(0,I.$Uk)(l):l).replace(/([ \t]+)/g,(r,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===T.Break?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,i){return this.value+=`
${S(i,l)}
`,this}appendLink(l,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(l),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(l,i){const r=new RegExp((0,O.$ff)(i),"g");return l.replace(r,(t,g)=>l.charAt(g-1)!=="\\"?`\\${t}`:t)}}e.$1k=$;function s(c){return A(c)?!c.value:Array.isArray(c)?c.every(s):!0}function A(c){return c instanceof $?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function y(c,l){return c===l?!0:!c||!l?!1:c.value===l.value&&c.isTrusted===l.isTrusted&&c.supportThemeIcons===l.supportThemeIcons&&c.supportHtml===l.supportHtml&&(c.baseUri===l.baseUri||!!c.baseUri&&!!l.baseUri&&(0,P.$9g)(R.URI.from(c.baseUri),R.URI.from(l.baseUri)))}function a(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function S(c,l){const i=c.match(/^`+/gm)?.reduce((t,g)=>t.length>g.length?t:g).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${l}`,c,`${"`".repeat(r)}`].join(`
`)}function d(c){return c.replace(/"/g,"&quot;")}function n(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(c){const l=[],i=c.split("|").map(t=>t.trim());c=i[0];const r=i[1];if(r){const t=/height=(\d+)/.exec(r),g=/width=(\d+)/.exec(r),u=t?t[1]:"",m=g?g[1]:"",p=isFinite(parseInt(m)),h=isFinite(parseInt(u));p&&l.push(`width="${m}"`),h&&l.push(`height="${u}"`)}return{href:c,dimensions:l}}}),define(Oe[99],Ne([1,0,17,51,19,20,23,12]),function(be,e,v,I,P,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ww=$,e.$Xw=A,e.$Yw=a,e.$Zw=S,e.$1w=c,e.$2w=i,e.$3w=r,e.$4w=t,e.$5w=g,e.$6w=u;function $(p,h){const{os:E,tildify:D,relative:b}=h;if(b){const f=s(p,b,E);if(typeof f=="string")return f}let k=p.fsPath;if(E===O.OperatingSystem.Windows&&!O.$j?k=k.replace(/\//g,"\\"):E!==O.OperatingSystem.Windows&&O.$j&&(k=k.replace(/\\/g,"/")),E!==O.OperatingSystem.Windows&&D?.userHome){const f=D.userHome.fsPath;let w;p.scheme!==D.userHome.scheme&&p.path[0]===P.$fc.sep&&p.path[1]!==P.$fc.sep?w=D.userHome.with({path:p.path}).fsPath:w=k,k=a(w,f,E)}return(E===O.OperatingSystem.Windows?P.$ec:P.$fc).normalize(A(k,E===O.OperatingSystem.Windows))}function s(p,h,E){const D=E===O.OperatingSystem.Windows?P.$ec:P.$fc,b=E===O.OperatingSystem.Linux?R.$6g:R.$8g,k=h.getWorkspace(),C=(0,v.$Nb)(k.folders);if(!C)return;p.scheme!==C.uri.scheme&&p.path[0]===P.$fc.sep&&p.path[1]!==P.$fc.sep&&(p=C.uri.with({path:p.path}));const f=h.getWorkspaceFolder(p);if(!f)return;let w;if(b.isEqual(f.uri,p)?w="":w=b.relativePath(f.uri,p)??"",w&&(w=D.normalize(w)),k.folders.length>1&&!h.noPrefix){const M=f.name?f.name:b.basenameOrAuthority(f.uri);w=w?`${M} \u2022 ${w}`:M}return w}function A(p,h=O.$j){return(0,I.$Gg)(p,h)?p.charAt(0).toUpperCase()+p.slice(1):p}let y=Object.create(null);function a(p,h,E=O.OS){if(E===O.OperatingSystem.Windows||!p||!h)return p;let D=y.original===h?y.normalized:void 0;D||(D=h,O.$j&&(D=(0,I.$vg)(D)),D=`${(0,T.$lf)(D,P.$fc.sep)}${P.$fc.sep}`,y={original:h,normalized:D});let b=p;return O.$j&&(b=(0,I.$vg)(b)),(E===O.OperatingSystem.Linux?b.startsWith(D):(0,T.$Ef)(b,D))?`~/${b.substr(D.length)}`:p}function S(p,h){return p.replace(/^~($|\/|\\)/,`${h}$1`)}const d="\u2026",n="\\\\",o="~";function c(p,h=P.sep){const E=new Array(p.length);let D=!1;for(let b=0;b<p.length;b++){const k=p[b];if(k===""){E[b]=`.${h}`;continue}if(!k){E[b]=k;continue}D=!0;let C="",f=k;f.indexOf(n)===0?(C=f.substr(0,f.indexOf(n)+n.length),f=f.substr(f.indexOf(n)+n.length)):f.indexOf(h)===0?(C=f.substr(0,f.indexOf(h)+h.length),f=f.substr(f.indexOf(h)+h.length)):f.indexOf(o)===0&&(C=f.substr(0,f.indexOf(o)+o.length),f=f.substr(f.indexOf(o)+o.length));const w=f.split(h);for(let M=1;D&&M<=w.length;M++)for(let N=w.length-M;D&&N>=0;N--){D=!1;let L=w.slice(N,N+M).join(h);for(let W=0;!D&&W<p.length;W++)if(W!==b&&p[W]&&p[W].indexOf(L)>-1){const G=N+M===w.length,F=N>0&&p[W].indexOf(h)>-1?h+L:L,K=p[W].endsWith(F);D=!G||K}if(!D){let W="";(w[0].endsWith(":")||C!=="")&&(N===1&&(N=0,M++,L=w[0]+h+L),N>0&&(W=w[0]+h),W=C+W),N>0&&(W=W+d+h),W=W+L,N+M<w.length&&(W=W+h+d),E[b]=W}}D&&(E[b]=k)}return E}var l;(function(p){p[p.TEXT=0]="TEXT",p[p.VARIABLE=1]="VARIABLE",p[p.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function i(p,h=Object.create(null)){const E=[];let D=!1,b="";for(const k of p)if(k==="$"||D&&k==="{")b&&E.push({value:b,type:l.TEXT}),b="",D=!0;else if(k==="}"&&D){const C=h[b];if(typeof C=="string")C.length&&E.push({value:C,type:l.VARIABLE});else if(C){const f=E[E.length-1];(!f||f.type!==l.SEPARATOR)&&E.push({value:C.label,type:l.SEPARATOR})}b="",D=!1}else b+=k;return b&&!D&&E.push({value:b,type:l.TEXT}),E.filter((k,C)=>{if(k.type===l.SEPARATOR){const f=E[C-1],w=E[C+1];return[f,w].every(M=>M&&(M.type===l.VARIABLE||M.type===l.TEXT)&&M.value.length>0)}return!0}).map(k=>k.value).join("")}function r(p,h){return O.$k||h?p.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$k?"&":"&&"):p.replace(/&&|&/g,E=>E==="&"?"&&":"&")}function t(p,h){return O.$k||h?p.replace(/\(&&\w\)|&&/g,""):O.$j?p.replace(/&&|&/g,E=>E==="&"?"&&":"&"):p.replace(/&&/g,"_")}function g(p){return p.replace(/&/g,"&&")}function u(p){if(p.endsWith("]")){const h=p.lastIndexOf(" [",p.length-2);if(h!==-1){const E=m(p.substring(0,h)),D=p.substring(h);return{name:E.name+D,parentPath:E.parentPath}}}return m(p)}function m(p){const h=p.indexOf("/")!==-1?P.$fc:P.$ec,E=h.basename(p),D=h.dirname(p);return E.length?{name:E,parentPath:D}:{name:D,parentPath:""}}}),define(Oe[150],Ne([1,0,22,36,2]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=void 0,e.$Ln=$,e.$Mn=A,e.$Nn=y;function O(a){return a.toJSON()}class R{constructor(S){this.a=S}transformIncoming(S){const d=this.a.transformIncoming(S);return d===S?S:O(P.URI.from(d))}transformOutgoing(S){const d=this.a.transformOutgoing(S);return d===S?S:O(P.URI.from(d))}transformOutgoingURI(S){const d=this.a.transformOutgoing(S);return d===S?S:P.URI.from(d)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.$Jn=R,e.$Kn=new class{transformIncoming(a){return a}transformOutgoing(a){return a}transformOutgoingURI(a){return a}transformOutgoingScheme(a){return a}};function T(a,S,d){if(!a||d>200)return null;if(typeof a=="object"){if(a instanceof P.URI)return S.transformOutgoing(a);for(const n in a)if(Object.hasOwnProperty.call(a,n)){const o=T(a[n],S,d+1);o!==null&&(a[n]=o)}}return null}function $(a,S){const d=T(a,S,0);return d===null?a:d}function s(a,S,d,n){if(!a||n>200)return null;if(typeof a=="object"){if(a.$mid===I.MarshalledId.Uri)return d?P.URI.revive(S.transformIncoming(a)):S.transformIncoming(a);if(a instanceof v.$Le)return null;for(const o in a)if(Object.hasOwnProperty.call(a,o)){const c=s(a[o],S,d,n+1);c!==null&&(a[o]=c)}}return null}function A(a,S){const d=s(a,S,!1,0);return d===null?a:d}function y(a,S){const d=s(a,S,!0,0);return d===null?a:d}}),define(Oe[37],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=I;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(P){return v.test(P)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(T){for(let $=0;$<T.length;$++)T[$]=Math.floor(Math.random()*256);return T};const O=new Uint8Array(16),R=[];for(let T=0;T<256;T++)R.push(T.toString(16).padStart(2,"0"));return function(){P(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let $=0,s="";return s+=R[O[$++]],s+=R[O[$++]],s+=R[O[$++]],s+=R[O[$++]],s+="-",s+=R[O[$++]],s+=R[O[$++]],s+="-",s+=R[O[$++]],s+=R[O[$++]],s+="-",s+=R[O[$++]],s+=R[O[$++]],s+="-",s+=R[O[$++]],s+=R[O[$++]],s+=R[O[$++]],s+=R[O[$++]],s+=R[O[$++]],s+=R[O[$++]],s}}()}),define(Oe[151],Ne([1,0,17,39,37]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qu=e.$ou=void 0,e.$mu=O,e.$nu=R,e.$pu=s;function O(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function R(y,a,S){const d={id:(0,P.$Yg)(),name:y,uri:a,data:S};return{asString:async()=>"",asFile:()=>d,value:void 0}}class T{constructor(){this.a=new Map}get size(){let a=0;for(const S of this.a)a++;return a}has(a){return this.a.has(this.b(a))}matches(a){const S=[...this.a.keys()];return I.Iterable.some(this,([d,n])=>n.asFile())&&S.push("files"),A($(a),S)}get(a){return this.a.get(this.b(a))?.[0]}append(a,S){const d=this.a.get(a);d?d.push(S):this.a.set(this.b(a),[S])}replace(a,S){this.a.set(this.b(a),[S])}delete(a){this.a.delete(this.b(a))}*[Symbol.iterator](){for(const[a,S]of this.a)for(const d of S)yield[a,d]}b(a){return $(a)}}e.$ou=T;function $(y){return y.toLowerCase()}function s(y,a){return A($(y),a.map($))}function A(y,a){if(y==="*/*")return a.length>0;if(a.includes(y))return!0;const S=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[d,n,o]=S;return o==="*"?a.some(c=>c.startsWith(n+"/")):!1}e.$qu=Object.freeze({create:y=>(0,v.$Lb)(y.map(a=>a.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$qu.split(y).filter(a=>!a.startsWith("#"))})}),define(Oe[152],Ne([1,0,10,6,4,40,14]),function(be,e,v,I,P,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.StorageState=e.StorageHint=void 0,e.$aq=$;var T;(function(a){a[a.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",a[a.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function $(a){const S=a;return S?.changed instanceof Map||S?.deleted instanceof Set}var s;(function(a){a[a.None=0]="None",a[a.Initialized=1]="Initialized",a[a.Closed=2]="Closed"})(s||(e.StorageState=s={}));class A extends P.$Tc{static{this.a=100}constructor(S,d=Object.create(null)){super(),this.r=S,this.s=d,this.b=this.B(new I.$me),this.onDidChangeStorage=this.b.event,this.c=s.None,this.f=new Map,this.g=this.B(new v.$Ah(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((d,n)=>this.w(n,d)),S.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(S,d){if(this.c===s.Closed)return;let n=!1;(0,R.$lg)(d)?n=this.f.delete(S):this.f.get(S)!==d&&(this.f.set(S,d),n=!0),n&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===s.None&&(this.c=s.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,d){const n=this.f.get(S);return(0,R.$lg)(n)?d:n}getBoolean(S,d){const n=this.get(S);return(0,R.$lg)(n)?d:n==="true"}getNumber(S,d){const n=this.get(S);return(0,R.$lg)(n)?d:parseInt(n,10)}getObject(S,d){const n=this.get(S);return(0,R.$lg)(n)?d:(0,O.$$h)(n)}async set(S,d,n=!1){if(this.c===s.Closed)return;if((0,R.$lg)(d))return this.delete(S,n);const o=(0,R.$eg)(d)||Array.isArray(d)?(0,O.$0h)(d):String(d);if(this.f.get(S)!==o)return this.f.set(S,o),this.j.set(S,o),this.h.delete(S),this.b.fire({key:S,external:n}),this.D()}async delete(S,d=!1){if(!(this.c===s.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:d}),this.D()}async optimize(){if(this.c!==s.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=s.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(!(this.c===s.Closed||this.m))return this.D(S)}async D(S){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$bq=A;class y{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((d,n)=>this.a.set(n,d)),S.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$cq=y}),define(Oe[153],Ne([1,0,27]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$wu=P;var I;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function P(O){let R=0,T=0,$=0,s=I.Unknown;for(let A=0,y=O.length;A<y;A++){const a=O.charCodeAt(A);a===v.CharCode.CarriageReturn?(R===0&&(T=A),R++,A+1<y&&O.charCodeAt(A+1)===v.CharCode.LineFeed?(s|=I.CRLF,A++):s|=I.Invalid,$=A+1):a===v.CharCode.LineFeed&&(s|=I.LF,R===0&&(T=A),R++,$=A+1)}return R===0&&(T=O.length),[R,T,O.length-$,s]}}),define(Oe[154],Ne([1,0,12,20,22]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=void 0,e.$_t=A,e.$au=y,v=We(v),I=We(I),P=We(P);let O;function R(){return O||(O=new TextDecoder("UTF-16LE")),O}let T;function $(){return T||(T=new TextDecoder("UTF-16BE")),T}let s;function A(){return s||(s=I.$E()?R():$()),s}function y(d,n,o){const c=new Uint16Array(d.buffer,n,o);return o>0&&(c[0]===65279||c[0]===65534)?a(d,n,o):R().decode(c)}function a(d,n,o){const c=[];let l=0;for(let i=0;i<o;i++){const r=P.$Ne(d,n);n+=2,c[l++]=String.fromCharCode(r)}return c.join("")}class S{constructor(n){this.a=n|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const n=new Uint16Array(this.b.buffer,0,this.d);return A().decode(n)}f(){const n=this.e();this.d=0,this.c===null?this.c=[n]:this.c[this.c.length]=n}appendCharCode(n){const o=this.a-this.d;o<=1&&(o===0||v.$Hf(n))&&this.f(),this.b[this.d++]=n}appendASCIICharCode(n){this.d===this.a&&this.f(),this.b[this.d++]=n}appendString(n){const o=n.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=n;return}for(let c=0;c<o;c++)this.b[this.d++]=n.charCodeAt(c)}}e.$bu=S}),define(Oe[155],Ne([1,0,22,154]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cu=void 0,e.$du=R,v=We(v);function P($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(s,A,y,a){this.oldPosition=s,this.oldText=A,this.newPosition=y,this.newText=a}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(s){return 4+2*s.length}static c(s,A,y){const a=A.length;v.$Qe(s,a,y),y+=4;for(let S=0;S<a;S++)v.$Oe(s,A.charCodeAt(S),y),y+=2;return y}static d(s,A){const y=v.$Pe(s,A);return A+=4,(0,I.$au)(s,A,y)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(s,A){return v.$Qe(s,this.oldPosition,A),A+=4,v.$Qe(s,this.newPosition,A),A+=4,A=O.c(s,this.oldText,A),A=O.c(s,this.newText,A),A}static read(s,A,y){const a=v.$Pe(s,A);A+=4;const S=v.$Pe(s,A);A+=4;const d=O.d(s,A);A+=O.a(d);const n=O.d(s,A);return A+=O.a(n),y.push(new O(a,d,S,n)),A}}e.$cu=O;function R($,s){return $===null||$.length===0?s:new T($,s).compress()}class T{constructor(s,A){this.a=s,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let s=0,A=0,y=this.n(s),a=this.l(A);for(;s<this.f||A<this.h;){if(y===null){this.k(a),a=this.l(++A);continue}if(a===null){this.m(y),y=this.n(++s);continue}if(a.oldEnd<=y.newPosition){this.k(a),a=this.l(++A);continue}if(y.newEnd<=a.oldPosition){this.m(y),y=this.n(++s);continue}if(a.oldPosition<y.newPosition){const[c,l]=T.r(a,y.newPosition-a.oldPosition);this.k(c),a=l;continue}if(y.newPosition<a.oldPosition){const[c,l]=T.q(y,a.oldPosition-y.newPosition);this.m(c),y=l;continue}let n,o;if(a.oldEnd===y.newEnd)n=y,o=a,y=this.n(++s),a=this.l(++A);else if(a.oldEnd<y.newEnd){const[c,l]=T.q(y,a.oldLength);n=c,o=a,y=l,a=this.l(++A)}else{const[c,l]=T.r(a,y.newLength);n=y,o=c,y=this.n(++s),a=l}this.d[this.e++]=new O(n.oldPosition,n.oldText,o.newPosition,o.newText),this.g+=n.newLength-n.oldLength,this.j+=o.newLength-o.oldLength}const S=T.s(this.d);return T.t(S)}k(s){this.d[this.e++]=T.o(this.g,s),this.j+=s.newLength-s.oldLength}l(s){return s<this.h?this.c[s]:null}m(s){this.d[this.e++]=T.p(this.j,s),this.g+=s.newLength-s.oldLength}n(s){return s<this.f?this.a[s]:null}static o(s,A){return new O(A.oldPosition-s,A.oldText,A.newPosition,A.newText)}static p(s,A){return new O(A.oldPosition,A.oldText,A.newPosition+s,A.newText)}static q(s,A){const y=s.newText.substr(0,A),a=s.newText.substr(A);return[new O(s.oldPosition,s.oldText,s.newPosition,y),new O(s.oldEnd,"",s.newPosition+A,a)]}static r(s,A){const y=s.oldText.substr(0,A),a=s.oldText.substr(A);return[new O(s.oldPosition,y,s.newPosition,s.newText),new O(s.oldPosition+A,a,s.newEnd,"")]}static s(s){if(s.length===0)return s;const A=[];let y=0,a=s[0];for(let S=1;S<s.length;S++){const d=s[S];a.oldEnd===d.oldPosition?a=new O(a.oldPosition,a.oldText+d.oldText,a.newPosition,a.newText+d.newText):(A[y++]=a,a=d)}return A[y++]=a,A}static t(s){if(s.length===0)return s;const A=[];let y=0;for(let a=0;a<s.length;a++){const S=s[a];S.oldText!==S.newText&&(A[y++]=S)}return A}}}),define(Oe[156],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=void 0,e.$it={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Oe[157],Ne([1,0,41,19]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tu=P,e.$uu=O;function P(R,T,$,s,A,y){if(Array.isArray(R)){let a=0;for(const S of R){const d=P(S,T,$,s,A,y);if(d===10)return d;d>a&&(a=d)}return a}else{if(typeof R=="string")return s?R==="*"?5:R===$?10:0:0;if(R){const{language:a,pattern:S,scheme:d,hasAccessToAllModels:n,notebookType:o}=R;if(!s&&!n)return 0;o&&A&&(T=A);let c=0;if(d)if(d===T.scheme)c=10;else if(d==="*")c=5;else return 0;if(a)if(a===$)c=10;else if(a==="*")c=Math.max(c,5);else return 0;if(o)if(o===y)c=10;else if(o==="*"&&y!==void 0)c=Math.max(c,5);else return 0;if(S){let l;if(typeof S=="string"?l=S:l={...S,base:(0,I.$gc)(S.base)},l===T.fsPath||(0,v.$wk)(l,T.fsPath))c=10;else return 0}return c}else return 0}}function O(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(O):!!R.notebookType}}),define(Oe[158],Ne([1,0,27,159]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uu=e.$Tu=e.IndentAction=void 0;var P;(function($){$[$.None=0]="None",$[$.Indent=1]="Indent",$[$.IndentOutdent=2]="IndentOutdent",$[$.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class O{constructor(s){if(this.e=null,this.f=!1,this.open=s.open,this.close=s.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(s.notIn))for(let A=0,y=s.notIn.length;A<y;A++)switch(s.notIn[A]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(s){switch(s){case I.StandardTokenType.Other:return!0;case I.StandardTokenType.Comment:return this.c;case I.StandardTokenType.String:return this.b;case I.StandardTokenType.RegEx:return this.d}}shouldAutoClose(s,A){if(s.getTokenCount()===0)return!0;const y=s.findTokenIndexAtOffset(A-2),a=s.getStandardTokenType(y);return this.isOK(a)}g(s,A){for(let y=s;y<=A;y++){const a=String.fromCharCode(y);if(!this.open.includes(a)&&!this.close.includes(a))return a}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(v.CharCode.Digit0,v.CharCode.Digit9)),this.e||(this.e=this.g(v.CharCode.a,v.CharCode.z)),this.e||(this.e=this.g(v.CharCode.A,v.CharCode.Z))),this.e}}e.$Tu=O;class R{constructor(s){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const A of s)T(this.autoClosingPairsOpenByStart,A.open.charAt(0),A),T(this.autoClosingPairsOpenByEnd,A.open.charAt(A.open.length-1),A),T(this.autoClosingPairsCloseByStart,A.close.charAt(0),A),T(this.autoClosingPairsCloseByEnd,A.close.charAt(A.close.length-1),A),A.close.length===1&&A.open.length===1&&T(this.autoClosingPairsCloseSingleChar,A.close,A)}}e.$Uu=R;function T($,s,A){$.has(s)?$.get(s).push(A):$.set(s,[A])}}),define(Oe[160],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$C=e.NodeColor=e.$0C=void 0,e.$_C=P,e.$aD=O,e.$bD=s,e.$cD=A,e.$dD=y,e.$eD=a,e.$fD=S,e.$gD=d;class v{constructor(o,c){this.piece=o,this.color=c,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$$C)return P(this.right);let o=this;for(;o.parent!==e.$$C&&o.parent.left!==o;)o=o.parent;return o.parent===e.$$C?e.$$C:o.parent}prev(){if(this.left!==e.$$C)return O(this.left);let o=this;for(;o.parent!==e.$$C&&o.parent.right!==o;)o=o.parent;return o.parent===e.$$C?e.$$C:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$0C=v;var I;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(I||(e.NodeColor=I={})),e.$$C=new v(null,I.Black),e.$$C.parent=e.$$C,e.$$C.left=e.$$C,e.$$C.right=e.$$C,e.$$C.color=I.Black;function P(n){for(;n.left!==e.$$C;)n=n.left;return n}function O(n){for(;n.right!==e.$$C;)n=n.right;return n}function R(n){return n===e.$$C?0:n.size_left+n.piece.length+R(n.right)}function T(n){return n===e.$$C?0:n.lf_left+n.piece.lineFeedCnt+T(n.right)}function $(){e.$$C.parent=e.$$C}function s(n,o){const c=o.right;c.size_left+=o.size_left+(o.piece?o.piece.length:0),c.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=c.left,c.left!==e.$$C&&(c.left.parent=o),c.parent=o.parent,o.parent===e.$$C?n.root=c:o.parent.left===o?o.parent.left=c:o.parent.right=c,c.left=o,o.parent=c}function A(n,o){const c=o.left;o.left=c.right,c.right!==e.$$C&&(c.right.parent=o),c.parent=o.parent,o.size_left-=c.size_left+(c.piece?c.piece.length:0),o.lf_left-=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),o.parent===e.$$C?n.root=c:o===o.parent.right?o.parent.right=c:o.parent.left=c,c.right=o,o.parent=c}function y(n,o){let c,l;if(o.left===e.$$C?(l=o,c=l.right):o.right===e.$$C?(l=o,c=l.left):(l=P(o.right),c=l.right),l===n.root){n.root=c,c.color=I.Black,o.detach(),$(),n.root.parent=e.$$C;return}const i=l.color===I.Red;if(l===l.parent.left?l.parent.left=c:l.parent.right=c,l===o?(c.parent=l.parent,d(n,c)):(l.parent===o?c.parent=l:c.parent=l.parent,d(n,c),l.left=o.left,l.right=o.right,l.parent=o.parent,l.color=o.color,o===n.root?n.root=l:o===o.parent.left?o.parent.left=l:o.parent.right=l,l.left!==e.$$C&&(l.left.parent=l),l.right!==e.$$C&&(l.right.parent=l),l.size_left=o.size_left,l.lf_left=o.lf_left,d(n,l)),o.detach(),c.parent.left===c){const t=R(c),g=T(c);if(t!==c.parent.size_left||g!==c.parent.lf_left){const u=t-c.parent.size_left,m=g-c.parent.lf_left;c.parent.size_left=t,c.parent.lf_left=g,S(n,c.parent,u,m)}}if(d(n,c.parent),i){$();return}let r;for(;c!==n.root&&c.color===I.Black;)c===c.parent.left?(r=c.parent.right,r.color===I.Red&&(r.color=I.Black,c.parent.color=I.Red,s(n,c.parent),r=c.parent.right),r.left.color===I.Black&&r.right.color===I.Black?(r.color=I.Red,c=c.parent):(r.right.color===I.Black&&(r.left.color=I.Black,r.color=I.Red,A(n,r),r=c.parent.right),r.color=c.parent.color,c.parent.color=I.Black,r.right.color=I.Black,s(n,c.parent),c=n.root)):(r=c.parent.left,r.color===I.Red&&(r.color=I.Black,c.parent.color=I.Red,A(n,c.parent),r=c.parent.left),r.left.color===I.Black&&r.right.color===I.Black?(r.color=I.Red,c=c.parent):(r.left.color===I.Black&&(r.right.color=I.Black,r.color=I.Red,s(n,r),r=c.parent.left),r.color=c.parent.color,c.parent.color=I.Black,r.left.color=I.Black,A(n,c.parent),c=n.root));c.color=I.Black,$()}function a(n,o){for(d(n,o);o!==n.root&&o.parent.color===I.Red;)if(o.parent===o.parent.parent.left){const c=o.parent.parent.right;c.color===I.Red?(o.parent.color=I.Black,c.color=I.Black,o.parent.parent.color=I.Red,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,s(n,o)),o.parent.color=I.Black,o.parent.parent.color=I.Red,A(n,o.parent.parent))}else{const c=o.parent.parent.left;c.color===I.Red?(o.parent.color=I.Black,c.color=I.Black,o.parent.parent.color=I.Red,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,A(n,o)),o.parent.color=I.Black,o.parent.parent.color=I.Red,s(n,o.parent.parent))}n.root.color=I.Black}function S(n,o,c,l){for(;o!==n.root&&o!==e.$$C;)o.parent.left===o&&(o.parent.size_left+=c,o.parent.lf_left+=l),o=o.parent}function d(n,o){let c=0,l=0;if(o!==n.root){for(;o!==n.root&&o===o.parent.right;)o=o.parent;if(o!==n.root)for(o=o.parent,c=R(o.left)-o.size_left,l=T(o.left)-o.lf_left,o.size_left+=c,o.lf_left+=l;o!==n.root&&(c!==0||l!==0);)o.parent.left===o&&(o.parent.size_left+=c,o.parent.lf_left+=l),o=o.parent}}}),define(Oe[100],Ne([1,0,27,101,32,52,160,102]),function(be,e,v,I,P,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rD=e.$qD=e.$pD=void 0,e.$nD=y,e.$oD=a;const $=65535;function s(l){let i;return l[l.length-1]<65536?i=new Uint16Array(l.length):i=new Uint32Array(l.length),i.set(l,0),i}class A{constructor(i,r,t,g,u){this.lineStarts=i,this.cr=r,this.lf=t,this.crlf=g,this.isBasicASCII=u}}function y(l,i=!0){const r=[0];let t=1;for(let g=0,u=l.length;g<u;g++){const m=l.charCodeAt(g);m===v.CharCode.CarriageReturn?g+1<u&&l.charCodeAt(g+1)===v.CharCode.LineFeed?(r[t++]=g+2,g++):r[t++]=g+1:m===v.CharCode.LineFeed&&(r[t++]=g+1)}return i?s(r):r}function a(l,i){l.length=0,l[0]=0;let r=1,t=0,g=0,u=0,m=!0;for(let h=0,E=i.length;h<E;h++){const D=i.charCodeAt(h);D===v.CharCode.CarriageReturn?h+1<E&&i.charCodeAt(h+1)===v.CharCode.LineFeed?(u++,l[r++]=h+2,h++):(t++,l[r++]=h+1):D===v.CharCode.LineFeed?(g++,l[r++]=h+1):m&&D!==v.CharCode.Tab&&(D<32||D>126)&&(m=!1)}const p=new A(s(l),t,g,u,m);return l.length=0,p}class S{constructor(i,r,t,g,u){this.bufferIndex=i,this.start=r,this.end=t,this.lineFeedCnt=g,this.length=u}}e.$pD=S;class d{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.$qD=d;class n{constructor(i,r){this.a=[],this.c=i,this.d=r,this.b=0,i.root!==R.$$C&&i.iterate(i.root,t=>(t!==R.$$C&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class o{constructor(i){this.a=i,this.b=[]}get(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let r=!1;const t=this.b;for(let g=0;g<t.length;g++){const u=t[g];if(u.node.parent===null||u.nodeStartOffset>=i){t[g]=null,r=!0;continue}}if(r){const g=[];for(const u of t)u!==null&&g.push(u);this.b=g}}}class c{constructor(i,r,t){this.create(i,r,t)}create(i,r,t){this.a=[new d("",[0])],this.g={line:0,column:0},this.root=R.$$C,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=t;let g=null;for(let u=0,m=i.length;u<m;u++)if(i[u].buffer.length>0){i[u].lineStarts||(i[u].lineStarts=y(i[u].buffer));const p=new S(u+1,{line:0,column:0},{line:i[u].lineStarts.length-1,column:i[u].buffer.length-i[u].lineStarts[i[u].lineStarts.length-1]},i[u].lineStarts.length-1,i[u].buffer.length);this.a.push(i[u]),g=this.S(g,p)}this.h=new o(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const r=$,t=r-Math.floor(r/3),g=t*2;let u="",m=0;const p=[];if(this.iterate(this.root,h=>{const E=this.R(h),D=E.length;if(m<=t||m+D<g)return u+=E,m+=D,!0;const b=u.replace(/\r\n|\r|\n/g,i);return p.push(new d(b,y(b))),u=E,m=D,!0}),m>0){const h=u.replace(/\r\n|\r|\n/g,i);p.push(new d(h,y(h)))}this.create(p,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new n(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,g=>{if(g===R.$$C)return!0;const u=this.R(g),m=u.length,p=i.G(r),h=i.G(r+m),E=i.getValueInRange2(p,h);return r+=m,u===E})}getOffsetAt(i,r){let t=0,g=this.root;for(;g!==R.$$C;)if(g.left!==R.$$C&&g.lf_left+1>=i)g=g.left;else if(g.lf_left+g.piece.lineFeedCnt+1>=i){t+=g.size_left;const u=this.B(g,i-g.lf_left-2);return t+=u+r-1}else i-=g.lf_left+g.piece.lineFeedCnt,t+=g.size_left+g.piece.length,g=g.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,t=0;const g=i;for(;r!==R.$$C;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const u=this.A(r,i-r.size_left);if(t+=r.lf_left+u.index,u.index===0){const m=this.getOffsetAt(t+1,1),p=g-m;return new I.$Kt(t+1,p+1)}return new I.$Kt(t+1,u.remainder+1)}else if(i-=r.size_left+r.piece.length,t+=r.lf_left+r.piece.lineFeedCnt,r.right===R.$$C){const u=this.getOffsetAt(t+1,1),m=g-i-u;return new I.$Kt(t+1,m+1)}else r=r.right;return new I.$Kt(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),g=this.H(i.endLineNumber,i.endColumn),u=this.getValueInRange2(t,g);return r?r!==this.d||!this.f?u.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?u:u.replace(/\r\n|\r|\n/g,r):u}getValueInRange2(i,r){if(i.node===r.node){const p=i.node,h=this.a[p.piece.bufferIndex].buffer,E=this.u(p.piece.bufferIndex,p.piece.start);return h.substring(E+i.remainder,E+r.remainder)}let t=i.node;const g=this.a[t.piece.bufferIndex].buffer,u=this.u(t.piece.bufferIndex,t.piece.start);let m=g.substring(u+i.remainder,u+t.piece.length);for(t=t.next();t!==R.$$C;){const p=this.a[t.piece.bufferIndex].buffer,h=this.u(t.piece.bufferIndex,t.piece.start);if(t===r.node){m+=p.substring(h,h+r.remainder);break}else m+=p.substr(h,t.piece.length);t=t.next()}return m}getLinesContent(){const i=[];let r=0,t="",g=!1;return this.iterate(this.root,u=>{if(u===R.$$C)return!0;const m=u.piece;let p=m.length;if(p===0)return!0;const h=this.a[m.bufferIndex].buffer,E=this.a[m.bufferIndex].lineStarts,D=m.start.line,b=m.end.line;let k=E[D]+m.start.column;if(g&&(h.charCodeAt(k)===v.CharCode.LineFeed&&(k++,p--),i[r++]=t,t="",g=!1,p===0))return!0;if(D===b)return!this.f&&h.charCodeAt(k+p-1)===v.CharCode.CarriageReturn?(g=!0,t+=h.substr(k,p-1)):t+=h.substr(k,p),!0;t+=this.f?h.substring(k,Math.max(k,E[D+1]-this.e)):h.substring(k,E[D+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;for(let C=D+1;C<b;C++)t=this.f?h.substring(E[C],E[C+1]-this.e):h.substring(E[C],E[C+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;return!this.f&&h.charCodeAt(E[b]+m.end.column-1)===v.CharCode.CarriageReturn?(g=!0,m.end.column===0?r--:t=h.substr(E[b],m.end.column-1)):t=h.substr(E[b],m.end.column),!0}),g&&(i[r++]=t,t=""),i[r++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const t=this.a[r.piece.bufferIndex],g=this.u(r.piece.bufferIndex,r.piece.start);return t.buffer.charCodeAt(g)}else{const r=this.a[i.node.piece.bufferIndex],g=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(g)}}getLineCharCode(i,r){const t=this.H(i,r+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const r=this.G(i);return this.l(r)}getNearestChunk(i){const r=this.G(i);if(r.remainder===r.node.piece.length){const t=r.node.next();if(!t||t===R.$$C)return"";const g=this.a[t.piece.bufferIndex],u=this.u(t.piece.bufferIndex,t.piece.start);return g.buffer.substring(u,u+t.piece.length)}else{const t=this.a[r.node.piece.bufferIndex],g=this.u(r.node.piece.bufferIndex,r.node.piece.start),u=g+r.remainder,m=g+r.node.piece.length;return t.buffer.substring(u,m)}}findMatchesInNode(i,r,t,g,u,m,p,h,E,D,b){const k=this.a[i.piece.bufferIndex],C=this.u(i.piece.bufferIndex,i.piece.start),f=this.u(i.piece.bufferIndex,u),w=this.u(i.piece.bufferIndex,m);let M;const N={line:0,column:0};let L,W;r._wordSeparators?(L=k.buffer.substring(f,w),W=G=>G+f,r.reset(0)):(L=k.buffer,W=G=>G,r.reset(f));do if(M=r.next(L),M){if(W(M.index)>=w)return D;this.s(i,W(M.index)-C,N);const G=this.t(i.piece.bufferIndex,u,N),F=N.line===u.line?N.column-u.column+g:N.column+1,K=F+M[0].length;if(b[D++]=(0,T.$jD)(new P.$Lt(t+G,F,t+G,K),M,h),W(M.index)+M[0].length>=w||D>=E)return D}while(M);return D}findMatchesLineByLine(i,r,t,g){const u=[];let m=0;const p=new T.$mD(r.wordSeparators,r.regex);let h=this.H(i.startLineNumber,i.startColumn);if(h===null)return[];const E=this.H(i.endLineNumber,i.endColumn);if(E===null)return[];let D=this.s(h.node,h.remainder);const b=this.s(E.node,E.remainder);if(h.node===E.node)return this.findMatchesInNode(h.node,p,i.startLineNumber,i.startColumn,D,b,r,t,g,m,u),u;let k=i.startLineNumber,C=h.node;for(;C!==E.node;){const w=this.t(C.piece.bufferIndex,D,C.piece.end);if(w>=1){const N=this.a[C.piece.bufferIndex].lineStarts,L=this.u(C.piece.bufferIndex,C.piece.start),W=N[D.line+w],G=k===i.startLineNumber?i.startColumn:1;if(m=this.findMatchesInNode(C,p,k,G,D,this.s(C,W-L),r,t,g,m,u),m>=g)return u;k+=w}const M=k===i.startLineNumber?i.startColumn-1:0;if(k===i.endLineNumber){const N=this.getLineContent(k).substring(M,i.endColumn-1);return m=this.n(r,p,N,i.endLineNumber,M,m,u,t,g),u}if(m=this.n(r,p,this.getLineContent(k).substr(M),k,M,m,u,t,g),m>=g)return u;k++,h=this.H(k,1),C=h.node,D=this.s(h.node,h.remainder)}if(k===i.endLineNumber){const w=k===i.startLineNumber?i.startColumn-1:0,M=this.getLineContent(k).substring(w,i.endColumn-1);return m=this.n(r,p,M,i.endLineNumber,w,m,u,t,g),u}const f=k===i.startLineNumber?i.startColumn:1;return m=this.findMatchesInNode(E.node,p,k,f,D,b,r,t,g,m,u),u}n(i,r,t,g,u,m,p,h,E){const D=i.wordSeparators;if(!h&&i.simpleSearch){const k=i.simpleSearch,C=k.length,f=t.length;let w=-C;for(;(w=t.indexOf(k,w+C))!==-1;)if((!D||(0,T.$lD)(D,t,f,w,C))&&(p[m++]=new O.$bw(new P.$Lt(g,w+1+u,g,w+1+C+u),null),m>=E))return m;return m}let b;r.reset(0);do if(b=r.next(t),b&&(p[m++]=(0,T.$jD)(new P.$Lt(g,b.index+1+u,g,b.index+1+b[0].length+u),b,h),m>=E))return m;while(b);return m}insert(i,r,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==R.$$C){const{node:g,remainder:u,nodeStartOffset:m}=this.G(i),p=g.piece,h=p.bufferIndex,E=this.s(g,u);if(g.piece.bufferIndex===0&&p.end.line===this.g.line&&p.end.column===this.g.column&&m+p.length===i&&r.length<$){this.F(g,r),this.y();return}if(m===i)this.o(r,g),this.h.validate(i);else if(m+g.piece.length>i){const D=[];let b=new S(p.bufferIndex,E,p.end,this.t(p.bufferIndex,E,p.end),this.u(h,p.end)-this.u(h,E));if(this.K()&&this.M(r)&&this.I(g,u)===10){const w={line:b.start.line+1,column:0};b=new S(b.bufferIndex,w,b.end,this.t(b.bufferIndex,w,b.end),b.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(g,u-1)===13){const w=this.s(g,u-1);this.C(g,w),r="\r"+r,g.piece.length===0&&D.push(g)}else this.C(g,E);else this.C(g,E);const k=this.w(r);b.length>0&&this.S(g,b);let C=g;for(let f=0;f<k.length;f++)C=this.S(C,k[f]);this.v(D)}else this.q(r,g)}else{const g=this.w(r);let u=this.T(null,g[0]);for(let m=1;m<g.length;m++)u=this.S(u,g[m])}this.y()}delete(i,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===R.$$C)return;const t=this.G(i),g=this.G(i+r),u=t.node,m=g.node;if(u===m){const k=this.s(u,t.remainder),C=this.s(u,g.remainder);if(t.nodeStartOffset===i){if(r===u.piece.length){const f=u.next();(0,R.$dD)(this,u),this.N(f),this.y();return}this.D(u,C),this.h.validate(i),this.N(u),this.y();return}if(t.nodeStartOffset+u.piece.length===i+r){this.C(u,k),this.O(u),this.y();return}this.E(u,k,C),this.y();return}const p=[],h=this.s(u,t.remainder);this.C(u,h),this.h.validate(i),u.piece.length===0&&p.push(u);const E=this.s(m,g.remainder);this.D(m,E),m.piece.length===0&&p.push(m);const D=u.next();for(let k=D;k!==R.$$C&&k!==m;k=k.next())p.push(k);const b=u.piece.length===0?u.prev():u;this.v(p),this.O(b),this.y()}o(i,r){const t=[];if(this.K()&&this.M(i)&&this.L(r)){const m=r.piece,p={line:m.start.line+1,column:0},h=new S(m.bufferIndex,p,m.end,this.t(m.bufferIndex,p,m.end),m.length-1);r.piece=h,i+=`
`,(0,R.$fD)(this,r,-1,-1),r.piece.length===0&&t.push(r)}const g=this.w(i);let u=this.T(r,g[g.length-1]);for(let m=g.length-2;m>=0;m--)u=this.T(u,g[m]);this.N(u),this.v(t)}q(i,r){this.Q(i,r)&&(i+=`
`);const t=this.w(i),g=this.S(r,t[0]);let u=g;for(let m=1;m<t.length;m++)u=this.S(u,t[m]);this.N(g)}s(i,r,t){const g=i.piece,u=i.piece.bufferIndex,m=this.a[u].lineStarts,h=m[g.start.line]+g.start.column+r;let E=g.start.line,D=g.end.line,b=0,k=0,C=0;for(;E<=D&&(b=E+(D-E)/2|0,C=m[b],b!==D);)if(k=m[b+1],h<C)D=b-1;else if(h>=k)E=b+1;else break;return t?(t.line=b,t.column=h-C,null):{line:b,column:h-C}}t(i,r,t){if(t.column===0)return t.line-r.line;const g=this.a[i].lineStarts;if(t.line===g.length-1)return t.line-r.line;const u=g[t.line+1],m=g[t.line]+t.column;if(u>m+1)return t.line-r.line;const p=m-1;return this.a[i].buffer.charCodeAt(p)===13?t.line-r.line+1:t.line-r.line}u(i,r){return this.a[i].lineStarts[r.line]+r.column}v(i){for(let r=0;r<i.length;r++)(0,R.$dD)(this,i[r])}w(i){if(i.length>$){const D=[];for(;i.length>$;){const k=i.charCodeAt($-1);let C;k===v.CharCode.CarriageReturn||k>=55296&&k<=56319?(C=i.substring(0,$-1),i=i.substring($-1)):(C=i.substring(0,$),i=i.substring($));const f=y(C);D.push(new S(this.a.length,{line:0,column:0},{line:f.length-1,column:C.length-f[f.length-1]},f.length-1,C.length)),this.a.push(new d(C,f))}const b=y(i);return D.push(new S(this.a.length,{line:0,column:0},{line:b.length-1,column:i.length-b[b.length-1]},b.length-1,i.length)),this.a.push(new d(i,b)),D}let r=this.a[0].buffer.length;const t=y(i,!1);let g=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},g=this.g;for(let D=0;D<t.length;D++)t[D]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let D=0;D<t.length;D++)t[D]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const u=this.a[0].buffer.length,m=this.a[0].lineStarts.length-1,p=u-this.a[0].lineStarts[m],h={line:m,column:p},E=new S(0,g,h,this.t(0,g,h),u-r);return this.g=h,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,r=0){let t=this.root,g="";const u=this.h.get2(i);if(u){t=u.node;const m=this.B(t,i-u.nodeStartLineNumber-1),p=this.a[t.piece.bufferIndex].buffer,h=this.u(t.piece.bufferIndex,t.piece.start);if(u.nodeStartLineNumber+t.piece.lineFeedCnt===i)g=p.substring(h+m,h+t.piece.length);else{const E=this.B(t,i-u.nodeStartLineNumber);return p.substring(h+m,h+E-r)}}else{let m=0;const p=i;for(;t!==R.$$C;)if(t.left!==R.$$C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const h=this.B(t,i-t.lf_left-2),E=this.B(t,i-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,b=this.u(t.piece.bufferIndex,t.piece.start);return m+=t.size_left,this.h.set({node:t,nodeStartOffset:m,nodeStartLineNumber:p-(i-1-t.lf_left)}),D.substring(b+h,b+E-r)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const h=this.B(t,i-t.lf_left-2),E=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);g=E.substring(D+h,D+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,m+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==R.$$C;){const m=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const p=this.B(t,0),h=this.u(t.piece.bufferIndex,t.piece.start);return g+=m.substring(h,h+p-r),g}else{const p=this.u(t.piece.bufferIndex,t.piece.start);g+=m.substr(p,t.piece.length)}t=t.next()}return g}y(){let i=this.root,r=1,t=0;for(;i!==R.$$C;)r+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=r,this.c=t,this.h.validate(this.c)}A(i,r){const t=i.piece,g=this.s(i,r),u=g.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===r){const m=this.t(i.piece.bufferIndex,t.start,g);if(m!==u)return{index:m,remainder:0}}return{index:u,remainder:g.column}}B(i,r){if(r<0)return 0;const t=i.piece,g=this.a[t.bufferIndex].lineStarts,u=t.start.line+r+1;return u>t.end.line?g[t.end.line]+t.end.column-g[t.start.line]-t.start.column:g[u]-g[t.start.line]-t.start.column}C(i,r){const t=i.piece,g=t.lineFeedCnt,u=this.u(t.bufferIndex,t.end),m=r,p=this.u(t.bufferIndex,m),h=this.t(t.bufferIndex,t.start,m),E=h-g,D=p-u,b=t.length+D;i.piece=new S(t.bufferIndex,t.start,m,h,b),(0,R.$fD)(this,i,D,E)}D(i,r){const t=i.piece,g=t.lineFeedCnt,u=this.u(t.bufferIndex,t.start),m=r,p=this.t(t.bufferIndex,m,t.end),h=this.u(t.bufferIndex,m),E=p-g,D=u-h,b=t.length+D;i.piece=new S(t.bufferIndex,m,t.end,p,b),(0,R.$fD)(this,i,D,E)}E(i,r,t){const g=i.piece,u=g.start,m=g.end,p=g.length,h=g.lineFeedCnt,E=r,D=this.t(g.bufferIndex,g.start,E),b=this.u(g.bufferIndex,r)-this.u(g.bufferIndex,u);i.piece=new S(g.bufferIndex,g.start,E,D,b),(0,R.$fD)(this,i,b-p,D-h);const k=new S(g.bufferIndex,t,m,this.t(g.bufferIndex,t,m),this.u(g.bufferIndex,m)-this.u(g.bufferIndex,t)),C=this.S(i,k);this.N(C)}F(i,r){this.Q(r,i)&&(r+=`
`);const t=this.K()&&this.L(r)&&this.M(i),g=this.a[0].buffer.length;this.a[0].buffer+=r;const u=y(r,!1);for(let C=0;C<u.length;C++)u[C]+=g;if(t){const C=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:g-C}}this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1));const m=this.a[0].lineStarts.length-1,p=this.a[0].buffer.length-this.a[0].lineStarts[m],h={line:m,column:p},E=i.piece.length+r.length,D=i.piece.lineFeedCnt,b=this.t(0,i.piece.start,h),k=b-D;i.piece=new S(i.piece.bufferIndex,i.piece.start,h,b,E),this.g=h,(0,R.$fD)(this,i,r.length,k)}G(i){let r=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let g=0;for(;r!==R.$$C;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){g+=r.size_left;const u={node:r,remainder:i-r.size_left,nodeStartOffset:g};return this.h.set(u),u}else i-=r.size_left+r.piece.length,g+=r.size_left+r.piece.length,r=r.right;return null}H(i,r){let t=this.root,g=0;for(;t!==R.$$C;)if(t.left!==R.$$C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const u=this.B(t,i-t.lf_left-2),m=this.B(t,i-t.lf_left-1);return g+=t.size_left,{node:t,remainder:Math.min(u+r-1,m),nodeStartOffset:g}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const u=this.B(t,i-t.lf_left-2);if(u+r-1<=t.piece.length)return{node:t,remainder:u+r-1,nodeStartOffset:g};r-=t.piece.length-u;break}else i-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==R.$$C;){if(t.piece.lineFeedCnt>0){const u=this.B(t,0),m=this.J(t);return{node:t,remainder:Math.min(r-1,u),nodeStartOffset:m}}else if(t.piece.length>=r-1){const u=this.J(t);return{node:t,remainder:r-1,nodeStartOffset:u}}else r-=t.piece.length;t=t.next()}return null}I(i,r){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],g=this.u(i.piece.bufferIndex,i.piece.start)+r;return t.buffer.charCodeAt(g)}J(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===R.$$C||i.piece.lineFeedCnt===0)return!1;const r=i.piece,t=this.a[r.bufferIndex].lineStarts,g=r.start.line,u=t[g]+r.start.column;return g===t.length-1||t[g+1]>u+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(u)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===R.$$C||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const r=i.prev();this.M(r)&&this.P(r,i)}}O(i){if(this.K()&&this.M(i)){const r=i.next();this.L(r)&&this.P(i,r)}}P(i,r){const t=[],g=this.a[i.piece.bufferIndex].lineStarts;let u;i.piece.end.column===0?u={line:i.piece.end.line-1,column:g[i.piece.end.line]-g[i.piece.end.line-1]-1}:u={line:i.piece.end.line,column:i.piece.end.column-1};const m=i.piece.length-1,p=i.piece.lineFeedCnt-1;i.piece=new S(i.piece.bufferIndex,i.piece.start,u,p,m),(0,R.$fD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const h={line:r.piece.start.line+1,column:0},E=r.piece.length-1,D=this.t(r.piece.bufferIndex,h,r.piece.end);r.piece=new S(r.piece.bufferIndex,h,r.piece.end,D,E),(0,R.$fD)(this,r,-1,-1),r.piece.length===0&&t.push(r);const b=this.w(`\r
`);this.S(i,b[0]);for(let k=0;k<t.length;k++)(0,R.$dD)(this,t[k])}Q(i,r){if(this.K()&&this.M(i)){const t=r.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,R.$dD)(this,t);else{const g=t.piece,u={line:g.start.line+1,column:0},m=g.length-1,p=this.t(g.bufferIndex,u,g.end);t.piece=new S(g.bufferIndex,u,g.end,p,m),(0,R.$fD)(this,t,-1,-1)}return!0}}return!1}iterate(i,r){if(i===R.$$C)return r(R.$$C);const t=this.iterate(i.left,r);return t&&r(i)&&this.iterate(i.right,r)}R(i){if(i===R.$$C)return"";const r=this.a[i.piece.bufferIndex],t=i.piece,g=this.u(t.bufferIndex,t.start),u=this.u(t.bufferIndex,t.end);return r.buffer.substring(g,u)}getPieceContent(i){const r=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),g=this.u(i.bufferIndex,i.end);return r.buffer.substring(t,g)}S(i,r){const t=new R.$0C(r,R.NodeColor.Red);if(t.left=R.$$C,t.right=R.$$C,t.parent=R.$$C,t.size_left=0,t.lf_left=0,this.root===R.$$C)this.root=t,t.color=R.NodeColor.Black;else if(i.right===R.$$C)i.right=t,t.parent=i;else{const u=(0,R.$_C)(i.right);u.left=t,t.parent=u}return(0,R.$eD)(this,t),t}T(i,r){const t=new R.$0C(r,R.NodeColor.Red);if(t.left=R.$$C,t.right=R.$$C,t.parent=R.$$C,t.size_left=0,t.lf_left=0,this.root===R.$$C)this.root=t,t.color=R.NodeColor.Black;else if(i.left===R.$$C)i.left=t,t.parent=i;else{const g=(0,R.$aD)(i.left);g.right=t,t.parent=g}return(0,R.$eD)(this,t),t}U(i){let r="";return this.iterate(i,t=>(r+=this.R(t),!0)),r}}e.$rD=c}),define(Oe[161],Ne([1,0,6,12,32,52,100,153,155,4]),function(be,e,v,I,P,O,R,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sD=void 0,I=We(I);class A extends s.$Tc{constructor(a,S,d,n,o,c,l){super(),this.m=this.B(new v.$je),this.onDidChangeContent=this.m.event,this.f=S,this.j=!c,this.g=n,this.h=o,this.c=new R.$rD(a,d,l)}equals(a){return!(a instanceof A)||this.f!==a.f||this.getEOL()!==a.getEOL()?!1:this.c.equal(a.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(a){return this.c.createSnapshot(a?this.f:"")}getOffsetAt(a,S){return this.c.getOffsetAt(a,S)}getPositionAt(a){return this.c.getPositionAt(a)}getRangeAt(a,S){const d=a+S,n=this.getPositionAt(a),o=this.getPositionAt(d);return new P.$Lt(n.lineNumber,n.column,o.lineNumber,o.column)}getValueInRange(a,S=O.EndOfLinePreference.TextDefined){if(a.isEmpty())return"";const d=this.n(S);return this.c.getValueInRange(a,d)}getValueLengthInRange(a,S=O.EndOfLinePreference.TextDefined){if(a.isEmpty())return 0;if(a.startLineNumber===a.endLineNumber)return a.endColumn-a.startColumn;const d=this.getOffsetAt(a.startLineNumber,a.startColumn),n=this.getOffsetAt(a.endLineNumber,a.endColumn);let o=0;const c=this.n(S),l=this.getEOL();if(c.length!==l.length){const i=c.length-l.length,r=a.endLineNumber-a.startLineNumber;o=i*r}return n-d+o}getCharacterCountInRange(a,S=O.EndOfLinePreference.TextDefined){if(this.j){let d=0;const n=a.startLineNumber,o=a.endLineNumber;for(let c=n;c<=o;c++){const l=this.getLineContent(c),i=c===n?a.startColumn-1:0,r=c===o?a.endColumn-1:l.length;for(let t=i;t<r;t++)I.$Hf(l.charCodeAt(t))?(d=d+1,t=t+1):d=d+1}return d+=this.n(S).length*(o-n),d}return this.getValueLengthInRange(a,S)}getNearestChunk(a){return this.c.getNearestChunk(a)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(a){return this.c.getLineContent(a)}getLineCharCode(a,S){return this.c.getLineCharCode(a,S)}getCharCode(a){return this.c.getCharCode(a)}getLineLength(a){return this.c.getLineLength(a)}getLineMinColumn(a){return 1}getLineMaxColumn(a){return this.getLineLength(a)+1}getLineFirstNonWhitespaceColumn(a){const S=I.$sf(this.getLineContent(a));return S===-1?0:S+1}getLineLastNonWhitespaceColumn(a){const S=I.$uf(this.getLineContent(a));return S===-1?0:S+2}n(a){switch(a){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(a){this.c.setEOL(a)}applyEdits(a,S,d){let n=this.g,o=this.h,c=this.j,l=!0,i=[];for(let h=0;h<a.length;h++){const E=a[h];l&&E._isTracked&&(l=!1);const D=E.range;if(E.text){let w=!0;c||(w=!I.$Sf(E.text),c=w),!n&&w&&(n=I.$Rf(E.text)),!o&&w&&(o=I.$Uf(E.text))}let b="",k=0,C=0,f=0;if(E.text){let w;[k,C,f,w]=(0,T.$wu)(E.text);const M=this.getEOL(),N=M===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;w===T.StringEOL.Unknown||w===N?b=E.text:b=E.text.replace(/\r\n|\r|\n/g,M)}i[h]={sortIndex:h,identifier:E.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:b,eolCount:k,firstLineLength:C,lastLineLength:f,forceMoveMarkers:!!E.forceMoveMarkers,isAutoWhitespaceEdit:E.isAutoWhitespaceEdit||!1}}i.sort(A.u);let r=!1;for(let h=0,E=i.length-1;h<E;h++){const D=i[h].range.getEndPosition(),b=i[h+1].range.getStartPosition();if(b.isBeforeOrEqual(D)){if(b.isBefore(D))throw new Error("Overlapping ranges are not allowed!");r=!0}}l&&(i=this.s(i));const t=d||S?A._getInverseEditRanges(i):[],g=[];if(S)for(let h=0;h<i.length;h++){const E=i[h],D=t[h];if(E.isAutoWhitespaceEdit&&E.range.isEmpty())for(let b=D.startLineNumber;b<=D.endLineNumber;b++){let k="";b===D.startLineNumber&&(k=this.getLineContent(E.range.startLineNumber),I.$sf(k)!==-1)||g.push({lineNumber:b,oldContent:k})}}let u=null;if(d){let h=0;u=[];for(let E=0;E<i.length;E++){const D=i[E],b=t[E],k=this.getValueInRange(D.range),C=D.rangeOffset+h;h+=D.text.length-k.length,u[E]={sortIndex:D.sortIndex,identifier:D.identifier,range:b,text:k,textChange:new $.$cu(D.rangeOffset,k,C,D.text)}}r||u.sort((E,D)=>E.sortIndex-D.sortIndex)}this.g=n,this.h=o,this.j=c;const m=this.t(i);let p=null;if(S&&g.length>0){g.sort((h,E)=>E.lineNumber-h.lineNumber),p=[];for(let h=0,E=g.length;h<E;h++){const D=g[h].lineNumber;if(h>0&&g[h-1].lineNumber===D)continue;const b=g[h].oldContent,k=this.getLineContent(D);k.length===0||k===b||I.$sf(k)!==-1||p.push(D)}}return this.m.fire(),new O.$fw(u,m,p)}s(a){return a.length<1e3?a:[this._toSingleEditOperation(a)]}_toSingleEditOperation(a){let S=!1;const d=a[0].range,n=a[a.length-1].range,o=new P.$Lt(d.startLineNumber,d.startColumn,n.endLineNumber,n.endColumn);let c=d.startLineNumber,l=d.startColumn;const i=[];for(let m=0,p=a.length;m<p;m++){const h=a[m],E=h.range;S=S||h.forceMoveMarkers,i.push(this.getValueInRange(new P.$Lt(c,l,E.startLineNumber,E.startColumn))),h.text.length>0&&i.push(h.text),c=E.endLineNumber,l=E.endColumn}const r=i.join(""),[t,g,u]=(0,T.$wu)(r);return{sortIndex:0,identifier:a[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,O.EndOfLinePreference.TextDefined),text:r,eolCount:t,firstLineLength:g,lastLineLength:u,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}t(a){a.sort(A.w);const S=[];for(let d=0;d<a.length;d++){const n=a[d],o=n.range.startLineNumber,c=n.range.startColumn,l=n.range.endLineNumber,i=n.range.endColumn;if(o===l&&c===i&&n.text.length===0)continue;n.text?(this.c.delete(n.rangeOffset,n.rangeLength),this.c.insert(n.rangeOffset,n.text,!0)):this.c.delete(n.rangeOffset,n.rangeLength);const r=new P.$Lt(o,c,l,i);S.push({range:r,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return S}findMatchesLineByLine(a,S,d,n){return this.c.findMatchesLineByLine(a,S,d,n)}getPieceTree(){return this.c}static _getInverseEditRange(a,S){const d=a.startLineNumber,n=a.startColumn,[o,c,l]=(0,T.$wu)(S);let i;if(S.length>0){const r=o+1;r===1?i=new P.$Lt(d,n,d,n+c):i=new P.$Lt(d,n,d+r-1,l+1)}else i=new P.$Lt(d,n,d,n);return i}static _getInverseEditRanges(a){const S=[];let d=0,n=0,o=null;for(let c=0,l=a.length;c<l;c++){const i=a[c];let r,t;o?o.range.endLineNumber===i.range.startLineNumber?(r=d,t=n+(i.range.startColumn-o.range.endColumn)):(r=d+(i.range.startLineNumber-o.range.endLineNumber),t=i.range.startColumn):(r=i.range.startLineNumber,t=i.range.startColumn);let g;if(i.text.length>0){const u=i.eolCount+1;u===1?g=new P.$Lt(r,t,r,t+i.firstLineLength):g=new P.$Lt(r,t,r+u-1,i.lastLineLength+1)}else g=new P.$Lt(r,t,r,t);d=g.endLineNumber,n=g.endColumn,S.push(g),o=i}return S}static u(a,S){const d=P.$Lt.compareRangesUsingEnds(a.range,S.range);return d===0?a.sortIndex-S.sortIndex:d}static w(a,S){const d=P.$Lt.compareRangesUsingEnds(a.range,S.range);return d===0?S.sortIndex-a.sortIndex:-d}}e.$sD=A}),define(Oe[162],Ne([1,0,27,12,52,100,161]),function(be,e,v,I,P,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tD=void 0,I=We(I);class T{constructor(A,y,a,S,d,n,o,c,l){this.a=A,this.b=y,this.c=a,this.d=S,this.e=d,this.f=n,this.g=o,this.h=c,this.j=l}k(A){const y=this.c+this.d+this.e,a=this.c+this.e;return y===0?A===P.DefaultEndOfLine.LF?`
`:`\r
`:a>y/2?`\r
`:`
`}create(A){const y=this.k(A),a=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let d=0,n=a.length;d<n;d++){const o=a[d].buffer.replace(/\r\n|\r|\n/g,y),c=(0,O.$nD)(o);a[d]=new O.$qD(o,c)}const S=new R.$sD(a,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(A){return this.a[0].buffer.substr(0,A).split(/\r\n|\r|\n/)[0]}}class ${constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(A){if(A.length===0)return;this.a.length===0&&I.$3f(A)&&(this.b=I.$2f,A=A.substr(1));const y=A.charCodeAt(A.length-1);y===v.CharCode.CarriageReturn||y>=55296&&y<=56319?(this.m(A.substr(0,A.length-1),!1),this.c=!0,this.d=y):(this.m(A,!1),this.c=!1,this.d=y)}m(A,y){!y&&A.length===0||(this.c?this.n(String.fromCharCode(this.d)+A):this.n(A))}n(A){const y=(0,O.$oD)(this.e,A);this.a.push(new O.$qD(A,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=I.$Rf(A)),this.k||(this.k=I.$Uf(A)))}finish(A=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,A)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const A=this.a[this.a.length-1];A.buffer+=String.fromCharCode(this.d);const y=(0,O.$nD)(A.buffer);A.lineStarts=y,this.d===v.CharCode.CarriageReturn&&this.f++}}}e.$tD=$}),define(Oe[103],Ne([1,0,22,20]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndb=$,e.$Odb=A,I=We(I);var P;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(P||(P={}));function O(y){for(let a=0,S=y.length;a<S;a+=4){const d=y[a+0],n=y[a+1],o=y[a+2],c=y[a+3];y[a+0]=c,y[a+1]=o,y[a+2]=n,y[a+3]=d}}function R(y){const a=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return I.$E()||O(a),v.$Le.wrap(a)}function T(y){const a=y.buffer;if(I.$E()||O(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const S=new Uint8Array(a.byteLength);return S.set(a),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function $(y){const a=new Uint32Array(s(y));let S=0;if(a[S++]=y.id,y.type==="full")a[S++]=P.Full,a[S++]=y.data.length,a.set(y.data,S),S+=y.data.length;else{a[S++]=P.Delta,a[S++]=y.deltas.length;for(const d of y.deltas)a[S++]=d.start,a[S++]=d.deleteCount,d.data?(a[S++]=d.data.length,a.set(d.data,S),S+=d.data.length):a[S++]=0}return R(a)}function s(y){let a=0;if(a+=2,y.type==="full")a+=1+y.data.length;else{a+=1,a+=3*y.deltas.length;for(const S of y.deltas)S.data&&(a+=S.data.length)}return a}function A(y){const a=T(y);let S=0;const d=a[S++];if(a[S++]===P.Full){const l=a[S++],i=a.subarray(S,S+l);return S+=l,{id:d,type:"full",data:i}}const o=a[S++],c=[];for(let l=0;l<o;l++){const i=a[S++],r=a[S++],t=a[S++];let g;t>0&&(g=a.subarray(S,S+t),S+=t),c[l]={start:i,deleteCount:r,data:g}}return{id:d,type:"delta",deltas:c}}}),define(Oe[163],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F_=e.$E_=void 0;class v{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const R=this.a.get(O);return this.a.delete(O),R}}addDragOperationTransfer(O,R){this.a.set(O,R)}}e.$E_=v;class I{constructor(O){this.identifier=O}}e.$F_=I}),define(Oe[164],Ne([1,0,6,4,9]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=void 0,e.$mj=A,P=We(P);class O extends I.$Tc{constructor(a,S="",d="",n=!0,o){super(),this.j=this.B(new v.$je),this.onDidChange=this.j.event,this.z=!0,this.m=a,this.n=S,this.w=d,this.z=n,this.D=o}get id(){return this.m}get label(){return this.n}set label(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.j.fire({label:a}))}get tooltip(){return this.u||""}set tooltip(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.j.fire({tooltip:a}))}get class(){return this.w}set class(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.j.fire({class:a}))}get enabled(){return this.z}set enabled(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.j.fire({enabled:a}))}get checked(){return this.C}set checked(a){this.J(a)}J(a){this.C!==a&&(this.C=a,this.j.fire({checked:a}))}async run(a,S){this.D&&await this.D(a)}}e.$hj=O;class R extends I.$Tc{constructor(){super(...arguments),this.f=this.B(new v.$je),this.onWillRun=this.f.event,this.m=this.B(new v.$je),this.onDidRun=this.m.event}async run(a,S){if(!a.enabled)return;this.f.fire({action:a});let d;try{await this.u(a,S)}catch(n){d=n}this.m.fire({action:a,error:d})}async u(a,S){await a.run(S)}}e.$ij=R;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let S=[];for(const d of a)d.length&&(S.length?S=[...S,new T,...d]:S=d);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$jj=T;class ${get actions(){return this.a}constructor(a,S,d,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=S,this.class=n,this.a=d}async run(){}}e.$kj=$;class s extends O{static{this.ID="vs.actions.empty"}constructor(){super(s.ID,P.localize(12953,null),void 0,!1)}}e.$lj=s;function A(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...a)=>y.run(...a)}}}),define(Oe[165],Ne([1,0,9]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=s,e.$Zm=A,e.$1m=y;const I=60,P=I*60,O=P*24,R=O*7,T=O*30,$=O*365;function s(a,S,d,n){typeof a!="number"&&(a=a.getTime());const o=Math.round((new Date().getTime()-a)/1e3);if(o<-30)return(0,v.localize)(12890,null,s(new Date().getTime()+o*1e3,!1));if(!n&&o<30)return(0,v.localize)(12891,null);let c;return o<I?(c=o,S?c===1?d?(0,v.localize)(12892,null,c):(0,v.localize)(12893,null,c):d?(0,v.localize)(12894,null,c):(0,v.localize)(12895,null,c):c===1?d?(0,v.localize)(12896,null,c):(0,v.localize)(12897,null,c):d?(0,v.localize)(12898,null,c):(0,v.localize)(12899,null,c)):o<P?(c=Math.floor(o/I),S?c===1?d?(0,v.localize)(12900,null,c):(0,v.localize)(12901,null,c):d?(0,v.localize)(12902,null,c):(0,v.localize)(12903,null,c):c===1?d?(0,v.localize)(12904,null,c):(0,v.localize)(12905,null,c):d?(0,v.localize)(12906,null,c):(0,v.localize)(12907,null,c)):o<O?(c=Math.floor(o/P),S?c===1?d?(0,v.localize)(12908,null,c):(0,v.localize)(12909,null,c):d?(0,v.localize)(12910,null,c):(0,v.localize)(12911,null,c):c===1?d?(0,v.localize)(12912,null,c):(0,v.localize)(12913,null,c):d?(0,v.localize)(12914,null,c):(0,v.localize)(12915,null,c)):o<R?(c=Math.floor(o/O),S?c===1?(0,v.localize)(12916,null,c):(0,v.localize)(12917,null,c):c===1?(0,v.localize)(12918,null,c):(0,v.localize)(12919,null,c)):o<T?(c=Math.floor(o/R),S?c===1?d?(0,v.localize)(12920,null,c):(0,v.localize)(12921,null,c):d?(0,v.localize)(12922,null,c):(0,v.localize)(12923,null,c):c===1?d?(0,v.localize)(12924,null,c):(0,v.localize)(12925,null,c):d?(0,v.localize)(12926,null,c):(0,v.localize)(12927,null,c)):o<$?(c=Math.floor(o/T),S?c===1?d?(0,v.localize)(12928,null,c):(0,v.localize)(12929,null,c):d?(0,v.localize)(12930,null,c):(0,v.localize)(12931,null,c):c===1?d?(0,v.localize)(12932,null,c):(0,v.localize)(12933,null,c):d?(0,v.localize)(12934,null,c):(0,v.localize)(12935,null,c)):(c=Math.floor(o/$),S?c===1?d?(0,v.localize)(12936,null,c):(0,v.localize)(12937,null,c):d?(0,v.localize)(12938,null,c):(0,v.localize)(12939,null,c):c===1?d?(0,v.localize)(12940,null,c):(0,v.localize)(12941,null,c):d?(0,v.localize)(12942,null,c):(0,v.localize)(12943,null,c))}function A(a,S){const d=Math.abs(a/1e3);return d<1?S?(0,v.localize)(12944,null,a):(0,v.localize)(12945,null,a):d<I?S?(0,v.localize)(12946,null,Math.round(a)/1e3):(0,v.localize)(12947,null,Math.round(a)/1e3):d<P?S?(0,v.localize)(12948,null,Math.round(a/(1e3*I))):(0,v.localize)(12949,null,Math.round(a/(1e3*I))):d<O?S?(0,v.localize)(12950,null,Math.round(a/(1e3*P))):(0,v.localize)(12951,null,Math.round(a/(1e3*P))):(0,v.localize)(12952,null,Math.round(a/(1e3*O)))}function y(a){return a.getFullYear()+"-"+String(a.getMonth()+1).padStart(2,"0")+"-"+String(a.getDate()).padStart(2,"0")+"T"+String(a.getHours()).padStart(2,"0")+":"+String(a.getMinutes()).padStart(2,"0")+":"+String(a.getSeconds()).padStart(2,"0")+"."+(a.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Oe[42],Ne([1,0,17,14,9]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=$,e.$oj=s,e.$pj=A,v=We(v),I=We(I),P=We(P);function O(y,a){return a&&(y.stack||y.stacktrace)?P.localize(12884,null,T(y),R(y.stack)||R(y.stacktrace)):T(y)}function R(y){return Array.isArray(y)?y.join(`
`):y}function T(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?P.localize(12885,null,y.message):y.message||P.localize(12886,null)}function $(y=null,a=!1){if(!y)return P.localize(12887,null);if(Array.isArray(y)){const S=v.$Gb(y),d=$(S[0],a);return S.length>1?P.localize(12888,null,d,S.length):d}if(I.$cg(y))return y;if(y.detail){const S=y.detail;if(S.error)return O(S.error,a);if(S.exception)return O(S.exception,a)}return y.stack?O(y,a):y.message?y.message:P.localize(12889,null)}function s(y){const a=y;return a instanceof Error&&Array.isArray(a.actions)}function A(y,a){let S;return typeof y=="string"?S=new Error(y):S=y,S.actions=a,S}}),define(Oe[166],Ne([1,0,27,13,9]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var O;(function(A){A[A.LParen=0]="LParen",A[A.RParen=1]="RParen",A[A.Neg=2]="Neg",A[A.Eq=3]="Eq",A[A.NotEq=4]="NotEq",A[A.Lt=5]="Lt",A[A.LtEq=6]="LtEq",A[A.Gt=7]="Gt",A[A.GtEq=8]="GtEq",A[A.RegexOp=9]="RegexOp",A[A.RegexStr=10]="RegexStr",A[A.True=11]="True",A[A.False=12]="False",A[A.In=13]="In",A[A.Not=14]="Not",A[A.And=15]="And",A[A.Or=16]="Or",A[A.Str=17]="Str",A[A.QuotedStr=18]="QuotedStr",A[A.Error=19]="Error",A[A.EOF=20]="EOF"})(O||(e.TokenType=O={}));function R(...A){switch(A.length){case 1:return(0,P.localize)(11492,null,A[0]);case 2:return(0,P.localize)(11493,null,A[0],A[1]);case 3:return(0,P.localize)(11494,null,A[0],A[1],A[2]);default:return}}const T=(0,P.localize)(11495,null),$=(0,P.localize)(11496,null);class s{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return y.isTripleEq?"===":"==";case O.NotEq:return y.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return y.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return y.lexeme;case O.QuotedStr:return y.lexeme;case O.Error:return y.lexeme;case O.EOF:return"EOF";default:throw(0,I.$7)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case v.CharCode.OpenParen:this.k(O.LParen);break;case v.CharCode.CloseParen:this.k(O.RParen);break;case v.CharCode.ExclamationMark:if(this.h(v.CharCode.Equals)){const a=this.h(v.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:a})}else this.k(O.Neg);break;case v.CharCode.SingleQuote:this.o();break;case v.CharCode.Slash:this.q();break;case v.CharCode.Equals:if(this.h(v.CharCode.Equals)){const a=this.h(v.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:a})}else this.h(v.CharCode.Tilde)?this.k(O.RegexOp):this.l(R("==","=~"));break;case v.CharCode.LessThan:this.k(this.h(v.CharCode.Equals)?O.LtEq:O.Lt);break;case v.CharCode.GreaterThan:this.k(this.h(v.CharCode.Equals)?O.GtEq:O.Gt);break;case v.CharCode.Ampersand:this.h(v.CharCode.Ampersand)?this.k(O.And):this.l(R("&&"));break;case v.CharCode.Pipe:this.h(v.CharCode.Pipe)?this.k(O.Or):this.l(R("||"));break;case v.CharCode.Space:case v.CharCode.CarriageReturn:case v.CharCode.Tab:case v.CharCode.LineFeed:case v.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?v.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const a=this.d,S=this.c.substring(this.d,this.e),d={type:O.Error,offset:this.d,lexeme:S};this.g.push({offset:a,lexeme:S,additionalInfo:y}),this.f.push(d)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const a=this.c.substring(this.d,this.e),S=s.b.get(a);S?this.k(S):this.f.push({type:O.Str,lexeme:a,offset:this.d})}}o(){for(;this.j()!==v.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,a=!1,S=!1;for(;;){if(y>=this.c.length){this.e=y,this.l($);return}const n=this.c.charCodeAt(y);if(a)a=!1;else if(n===v.CharCode.Slash&&!S){y++;break}else n===v.CharCode.OpenSquareBracket?S=!0:n===v.CharCode.Backslash?a=!0:n===v.CharCode.CloseSquareBracket&&(S=!1);y++}for(;y<this.c.length&&s.a.has(this.c.charCodeAt(y));)y++;this.e=y;const d=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=s}),define(Oe[104],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const v={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(v)}),define(Oe[73],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class v{constructor(P,O=[],R=!1){this.ctor=P,this.staticArguments=O,this.supportsDelayedInstantiation=R}}e.$zi=v}),define(Oe[60],Ne([1,0,73]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Os=O,e.$Ps=R;const I=[];var P;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function O(T,$,s){$ instanceof v.$zi||($=new v.$zi($,[],!!s)),I.push([T,$])}function R(){return I}}),define(Oe[167],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=void 0;class v{constructor(O,R){this.key=O,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$rr=v;class I{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const R of this.a.values())R.outgoing.size===0&&O.push(R);return O}insertEdge(O,R){const T=this.lookupOrInsertNode(O),$=this.lookupOrInsertNode(R);T.outgoing.set($.key,$),$.incoming.set(T.key,T)}removeNode(O){const R=this.b(O);this.a.delete(R);for(const T of this.a.values())T.outgoing.delete(R),T.incoming.delete(R)}lookupOrInsertNode(O){const R=this.b(O);let T=this.a.get(R);return T||(T=new v(R,O),this.a.set(R,T)),T}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[R,T]of this.a)O.push(`${R}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,R]of this.a){const T=new Set([O]),$=this.c(R,T);if($)return $}}c(O,R){for(const[T,$]of O.outgoing){if(R.has(T))return[...R,T].join(" -> ");R.add(T);const s=this.c($,R);if(s)return s;R.delete(T)}}}e.$sr=I}),define(Oe[3],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e._util=void 0,e.$Ci=P,e.$Di=O;var v;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function T($){return $[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=T})(v||(e._util=v={})),e.$Bi=P("instantiationService");function I(R,T,$){T[v.DI_TARGET]===T?T[v.DI_DEPENDENCIES].push({id:R,index:$}):(T[v.DI_DEPENDENCIES]=[{id:R,index:$}],T[v.DI_TARGET]=T)}function P(R){if(v.serviceIds.has(R))return v.serviceIds.get(R);const T=function($,s,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(T,$,A)};return T.toString=()=>R,v.serviceIds.set(R,T),T}function O(R){return R}}),define(Oe[43],Ne([1,0,14,2,3]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=O,e.$$i=R,e.$_i=$,e.$aj=s,e.$bj=A,e.$cj=y,e.$dj=a,e.$ej=d,e.$fj=n,e.$gj=o,v=We(v),e.$9i=(0,P.$Ci)("configurationService");function O(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof I.URI)}function R(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof I.URI)}var T;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function $(c){switch(c){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function s(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function A(c,l){const i=Object.create(null);for(const r in c)y(i,r,c[r],l);return i}function y(c,l,i,r){const t=l.split("."),g=t.pop();let u=c;for(let m=0;m<t.length;m++){const p=t[m];let h=u[p];switch(typeof h){case"undefined":h=u[p]=Object.create(null);break;case"object":if(h===null){r(`Ignoring ${l} as ${t.slice(0,m+1).join(".")} is null`);return}break;default:r(`Ignoring ${l} as ${t.slice(0,m+1).join(".")} is ${JSON.stringify(h)}`);return}u=h}if(typeof u=="object"&&u!==null)try{u[g]=i}catch{r(`Ignoring ${l} as ${t.join(".")} is ${JSON.stringify(u)}`)}else r(`Ignoring ${l} as ${t.join(".")} is ${JSON.stringify(u)}`)}function a(c,l){const i=l.split(".");S(c,i)}function S(c,l){const i=l.shift();if(l.length===0){delete c[i];return}if(Object.keys(c).indexOf(i)!==-1){const r=c[i];typeof r=="object"&&!Array.isArray(r)&&(S(r,l),Object.keys(r).length===0&&delete c[i])}}function d(c,l,i){function r(u,m){let p=u;for(const h of m){if(typeof p!="object"||p===null)return;p=p[h]}return p}const t=l.split("."),g=r(c,t);return typeof g>"u"?i:g}function n(c,l,i){Object.keys(l).forEach(r=>{r!=="__proto__"&&(r in c?v.$eg(c[r])&&v.$eg(l[r])?n(c[r],l[r],i):i&&(c[r]=l[r]):c[r]=l[r])})}function o(c){return c.replace(/[\[\]]/g,"")}}),define(Oe[31],Ne([1,0,27,20,12,166,3,9,13]),function(be,e,v,I,P,O,R,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=A,e.$Bj=m,e.$Cj=p,e.$Vj=oe;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",I.$k),s.set("isLinux",I.$l),s.set("isWindows",I.$j),s.set("isWeb",I.$p),s.set("isMacNative",I.$k&&!I.$p),s.set("isEdge",I.$I),s.set("isFirefox",I.$G),s.set("isChrome",I.$F),s.set("isSafari",I.$H);function A(Z,q){if(s.get(Z)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");s.set(Z,q)}const y=Object.prototype.hasOwnProperty;var a;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})(a||(e.ContextKeyExprType=a={}));const S={regexParsingWithErrorRecovery:!0},d=(0,T.localize)(11506,null),n=(0,T.localize)(11507,null),o=(0,T.localize)(11508,null),c=(0,T.localize)(11509,null),l=(0,T.localize)(11510,null),i=(0,T.localize)(11511,null),r=(0,T.localize)(11512,null),t=(0,T.localize)(11513,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=S){this.k=q,this.d=new O.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:n});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const te=this.l();if(!this.E()){const ve=this.D(),ce=ve.type===O.TokenType.Str?i:void 0;throw this.h.push({message:l,offset:ve.offset,lexeme:O.$xj.getLexeme(ve),additionalInfo:ce}),g.c}return te}catch(te){if(te!==g.c)throw te;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(O.TokenType.Or);){const te=this.o();q.push(te)}return q.length===1?q[0]:u.or(...q)}o(){const q=[this.s()];for(;this.y(O.TokenType.And);){const te=this.s();q.push(te)}return q.length===1?q[0]:u.and(...q)}s(){if(this.y(O.TokenType.Neg)){const q=this.D();switch(q.type){case O.TokenType.True:return this.z(),E.INSTANCE;case O.TokenType.False:return this.z(),D.INSTANCE;case O.TokenType.LParen:{this.z();const te=this.l();return this.A(O.TokenType.RParen,c),te?.negate()}case O.TokenType.Str:return this.z(),M.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case O.TokenType.True:return this.z(),u.true();case O.TokenType.False:return this.z(),u.false();case O.TokenType.LParen:{this.z();const te=this.l();return this.A(O.TokenType.RParen,c),te}case O.TokenType.Str:{const te=q.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const ce=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ce.type!==O.TokenType.RegexStr)throw this.B("REGEX",ce);const we=ce.lexeme,ue=we.lastIndexOf("/"),X=ue===we.length-1?void 0:this.w(we.substring(ue+1));let x;try{x=new RegExp(we.substring(1,ue),X)}catch{throw this.B("REGEX",ce)}return K.create(te,x)}switch(ce.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const we=[ce.lexeme];this.z();let ue=this.D(),X=0;for(let ze=0;ze<ce.lexeme.length;ze++)ce.lexeme.charCodeAt(ze)===v.CharCode.OpenParen?X++:ce.lexeme.charCodeAt(ze)===v.CharCode.CloseParen&&X--;for(;!this.E()&&ue.type!==O.TokenType.And&&ue.type!==O.TokenType.Or;){switch(ue.type){case O.TokenType.LParen:X++;break;case O.TokenType.RParen:X--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let ze=0;ze<ue.lexeme.length;ze++)ue.lexeme.charCodeAt(ze)===v.CharCode.OpenParen?X++:ce.lexeme.charCodeAt(ze)===v.CharCode.CloseParen&&X--}if(X<0)break;we.push(O.$xj.getLexeme(ue)),this.z(),ue=this.D()}const x=we.join(""),me=x.lastIndexOf("/"),pe=me===x.length-1?void 0:this.w(x.substring(me+1));let Re;try{Re=new RegExp(x.substring(1,me),pe)}catch{throw this.B("REGEX",ce)}return u.regex(te,Re)}case O.TokenType.QuotedStr:{const we=ce.lexeme;this.z();let ue=null;if(!(0,P.$af)(we)){const X=we.indexOf("/"),x=we.lastIndexOf("/");if(X!==x&&X>=0){const me=we.slice(X+1,x),pe=we[x+1]==="i"?"i":"";try{ue=new RegExp(me,pe)}catch{throw this.B("REGEX",ce)}}}if(ue===null)throw this.B("REGEX",ce);return K.create(te,ue)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,o);const ce=this.u();return u.notIn(te,ce)}switch(this.D().type){case O.TokenType.Eq:{this.z();const ce=this.u();if(this.x().type===O.TokenType.QuotedStr)return u.equals(te,ce);switch(ce){case"true":return u.has(te);case"false":return u.not(te);default:return u.equals(te,ce)}}case O.TokenType.NotEq:{this.z();const ce=this.u();if(this.x().type===O.TokenType.QuotedStr)return u.notEquals(te,ce);switch(ce){case"true":return u.not(te);case"false":return u.has(te);default:return u.notEquals(te,ce)}}case O.TokenType.Lt:return this.z(),G.create(te,this.u());case O.TokenType.LtEq:return this.z(),F.create(te,this.u());case O.TokenType.Gt:return this.z(),L.create(te,this.u());case O.TokenType.GtEq:return this.z(),W.create(te,this.u());case O.TokenType.In:return this.z(),u.in(te,this.u());default:return u.has(te)}}case O.TokenType.EOF:throw this.h.push({message:r,offset:q.offset,lexeme:"",additionalInfo:t}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),q.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,te){if(this.C(q))return this.z();throw this.B(te,this.D())}B(q,te,ve){const ce=(0,T.localize)(11514,null,q,O.$xj.getLexeme(te)),we=te.offset,ue=O.$xj.getLexeme(te);return this.h.push({message:ce,offset:we,lexeme:ue,additionalInfo:ve}),g.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$zj=g;class u{static false(){return E.INSTANCE}static true(){return D.INSTANCE}static has(q){return b.create(q)}static equals(q,te){return k.create(q,te)}static notEquals(q,te){return w.create(q,te)}static regex(q,te){return K.create(q,te)}static in(q,te){return C.create(q,te)}static notIn(q,te){return f.create(q,te)}static not(q){return M.create(q)}static and(...q){return _.create(q,null,!0)}static or(...q){return ge.create(q,null,!0)}static greater(q,te){return L.create(q,te)}static greaterEquals(q,te){return W.create(q,te)}static smaller(q,te){return G.create(q,te)}static smallerEquals(q,te){return F.create(q,te)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$Aj=u;function m(Z){const q=new g({regexParsingWithErrorRecovery:!1});return Z.map(te=>(q.parse(te),q.lexingErrors.length>0?q.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,T.localize)(11515,null,ve.additionalInfo):(0,T.localize)(11516,null),offset:ve.offset,length:ve.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function p(Z,q){const te=Z?Z.substituteConstants():void 0,ve=q?q.substituteConstants():void 0;return!te&&!ve?!0:!te||!ve?!1:te.equals(ve)}function h(Z,q){return Z.cmp(q)}class E{static{this.INSTANCE=new E}constructor(){this.type=a.False}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return D.INSTANCE}}e.$Dj=E;class D{static{this.INSTANCE=new D}constructor(){this.type=a.True}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return E.INSTANCE}}e.$Ej=D;class b{static create(q,te=null){const ve=s.get(q);return typeof ve=="boolean"?ve?D.INSTANCE:E.INSTANCE:new b(q,te)}constructor(q,te){this.key=q,this.c=te,this.type=a.Defined}cmp(q){return q.type!==this.type?this.type-q.type:ae(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=s.get(this.key);return typeof q=="boolean"?q?D.INSTANCE:E.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Fj=b;class k{static create(q,te,ve=null){if(typeof te=="boolean")return te?b.create(q,ve):M.create(q,ve);const ce=s.get(q);return typeof ce=="boolean"?te===(ce?"true":"false")?D.INSTANCE:E.INSTANCE:new k(q,te,ve)}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=a.Equals}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=s.get(this.c);if(typeof q=="boolean"){const te=q?"true":"false";return this.d===te?D.INSTANCE:E.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Gj=k;class C{static create(q,te){return new C(q,te)}constructor(q,te){this.d=q,this.f=te,this.type=a.In,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const te=q.getValue(this.f),ve=q.getValue(this.d);return Array.isArray(te)?te.includes(ve):typeof ve=="string"&&typeof te=="object"&&te!==null?y.call(te,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Hj=C;class f{static create(q,te){return new f(q,te)}constructor(q,te){this.d=q,this.f=te,this.type=a.NotIn,this.c=C.create(q,te)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=f;class w{static create(q,te,ve=null){if(typeof te=="boolean")return te?M.create(q,ve):b.create(q,ve);const ce=s.get(q);return typeof ce=="boolean"?te===(ce?"true":"false")?E.INSTANCE:D.INSTANCE:new w(q,te,ve)}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=a.NotEquals}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=s.get(this.c);if(typeof q=="boolean"){const te=q?"true":"false";return this.d===te?E.INSTANCE:D.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Jj=w;class M{static create(q,te=null){const ve=s.get(q);return typeof ve=="boolean"?ve?E.INSTANCE:D.INSTANCE:new M(q,te)}constructor(q,te){this.c=q,this.d=te,this.type=a.Not}cmp(q){return q.type!==this.type?this.type-q.type:ae(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=s.get(this.c);return typeof q=="boolean"?q?E.INSTANCE:D.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$Kj=M;function N(Z,q){if(typeof Z=="string"){const te=parseFloat(Z);isNaN(te)||(Z=te)}return typeof Z=="string"||typeof Z=="number"?q(Z):E.INSTANCE}class L{static create(q,te,ve=null){return N(te,ce=>new L(q,ce,ve))}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=a.Greater}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Lj=L;class W{static create(q,te,ve=null){return N(te,ce=>new W(q,ce,ve))}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=a.GreaterEquals}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Mj=W;class G{static create(q,te,ve=null){return N(te,ce=>new G(q,ce,ve))}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=a.Smaller}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Nj=G;class F{static create(q,te,ve=null){return N(te,ce=>new F(q,ce,ve))}constructor(q,te,ve){this.c=q,this.d=te,this.f=ve,this.type=a.SmallerEquals}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Oj=F;class K{static create(q,te){return new K(q,te)}constructor(q,te){this.d=q,this.f=te,this.type=a.Regex,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const te=this.f?this.f.source:"",ve=q.f?q.f.source:"";return te<ve?-1:te>ve?1:0}equals(q){if(q.type===this.type){const te=this.f?this.f.source:"",ve=q.f?q.f.source:"";return this.d===q.d&&te===ve}return!1}substituteConstants(){return this}evaluate(q){const te=q.getValue(this.d);return this.f?this.f.test(te):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Y.create(this)),this.c}}e.$Pj=K;class Y{static create(q){return new Y(q)}constructor(q){this.c=q,this.type=a.NotRegex}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new Y(this.c.map(q))}negate(){return this.c}}e.$Qj=Y;function le(Z){let q=null;for(let te=0,ve=Z.length;te<ve;te++){const ce=Z[te].substituteConstants();if(Z[te]!==ce&&q===null){q=[];for(let we=0;we<te;we++)q[we]=Z[we]}q!==null&&(q[te]=ce)}return q===null?Z:q}class _{static create(q,te,ve){return _.d(q,te,ve)}constructor(q,te){this.expr=q,this.c=te,this.type=a.And}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let te=0,ve=this.expr.length;te<ve;te++){const ce=h(this.expr[te],q.expr[te]);if(ce!==0)return ce}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let te=0,ve=this.expr.length;te<ve;te++)if(!this.expr[te].equals(q.expr[te]))return!1;return!0}return!1}substituteConstants(){const q=le(this.expr);return q===this.expr?this:_.create(q,this.c,!1)}evaluate(q){for(let te=0,ve=this.expr.length;te<ve;te++)if(!this.expr[te].evaluate(q))return!1;return!0}static d(q,te,ve){const ce=[];let we=!1;for(const ue of q)if(ue){if(ue.type===a.True){we=!0;continue}if(ue.type===a.False)return E.INSTANCE;if(ue.type===a.And){ce.push(...ue.expr);continue}ce.push(ue)}if(ce.length===0&&we)return D.INSTANCE;if(ce.length!==0){if(ce.length===1)return ce[0];ce.sort(h);for(let ue=1;ue<ce.length;ue++)ce[ue-1].equals(ce[ue])&&(ce.splice(ue,1),ue--);if(ce.length===1)return ce[0];for(;ce.length>1;){const ue=ce[ce.length-1];if(ue.type!==a.Or)break;ce.pop();const X=ce.pop(),x=ce.length===0,me=ge.create(ue.expr.map(pe=>_.create([pe,X],null,ve)),null,x);me&&(ce.push(me),ce.sort(h))}if(ce.length===1)return ce[0];if(ve){for(let ue=0;ue<ce.length;ue++)for(let X=ue+1;X<ce.length;X++)if(ce[ue].negate().equals(ce[X]))return E.INSTANCE;if(ce.length===1)return ce[0]}return new _(ce,te)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const te of this.expr)q.push(...te.keys());return q}map(q){return new _(this.expr.map(te=>te.map(q)),null)}negate(){if(!this.c){const q=[];for(const te of this.expr)q.push(te.negate());this.c=ge.create(q,this,!0)}return this.c}}e.$Rj=_;class ge{static create(q,te,ve){return ge.d(q,te,ve)}constructor(q,te){this.expr=q,this.c=te,this.type=a.Or}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let te=0,ve=this.expr.length;te<ve;te++){const ce=h(this.expr[te],q.expr[te]);if(ce!==0)return ce}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let te=0,ve=this.expr.length;te<ve;te++)if(!this.expr[te].equals(q.expr[te]))return!1;return!0}return!1}substituteConstants(){const q=le(this.expr);return q===this.expr?this:ge.create(q,this.c,!1)}evaluate(q){for(let te=0,ve=this.expr.length;te<ve;te++)if(this.expr[te].evaluate(q))return!0;return!1}static d(q,te,ve){let ce=[],we=!1;if(q){for(let ue=0,X=q.length;ue<X;ue++){const x=q[ue];if(x){if(x.type===a.False){we=!0;continue}if(x.type===a.True)return D.INSTANCE;if(x.type===a.Or){ce=ce.concat(x.expr);continue}ce.push(x)}}if(ce.length===0&&we)return E.INSTANCE;ce.sort(h)}if(ce.length!==0){if(ce.length===1)return ce[0];for(let ue=1;ue<ce.length;ue++)ce[ue-1].equals(ce[ue])&&(ce.splice(ue,1),ue--);if(ce.length===1)return ce[0];if(ve){for(let ue=0;ue<ce.length;ue++)for(let X=ue+1;X<ce.length;X++)if(ce[ue].negate().equals(ce[X]))return D.INSTANCE;if(ce.length===1)return ce[0]}return new ge(ce,te)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const te of this.expr)q.push(...te.keys());return q}map(q){return new ge(this.expr.map(te=>te.map(q)),null)}negate(){if(!this.c){const q=[];for(const te of this.expr)q.push(te.negate());for(;q.length>1;){const te=q.shift(),ve=q.shift(),ce=[];for(const we of Le(te))for(const ue of Le(ve))ce.push(_.create([we,ue],null,!1));q.unshift(ge.create(ce,null,!1))}this.c=ge.create(q,this,!0)}return this.c}}e.$Sj=ge;class se extends b{static{this.d=[]}static all(){return se.d.values()}constructor(q,te,ve){super(q,null),this.f=te,typeof ve=="object"?se.d.push({...ve,key:q}):ve!==!0&&se.d.push({key:q,description:ve,type:te!=null?typeof te:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return k.create(this.key,q)}notEqualsTo(q){return w.create(this.key,q)}}e.$Tj=se,e.$Uj=(0,R.$Ci)("contextKeyService");function ae(Z,q){return Z<q?-1:Z>q?1:0}function $e(Z,q,te,ve){return Z<te?-1:Z>te?1:q<ve?-1:q>ve?1:0}function oe(Z,q){if(Z.type===a.False||q.type===a.True)return!0;if(Z.type===a.Or)return q.type===a.Or?Ce(Z.expr,q.expr):!1;if(q.type===a.Or){for(const te of q.expr)if(oe(Z,te))return!0;return!1}if(Z.type===a.And){if(q.type===a.And)return Ce(q.expr,Z.expr);for(const te of Z.expr)if(oe(te,q))return!0;return!1}return Z.equals(q)}function Ce(Z,q){let te=0,ve=0;for(;te<Z.length&&ve<q.length;){const ce=Z[te].cmp(q[ve]);if(ce<0)return!1;ce===0&&te++,ve++}return te===Z.length}function Le(Z){return Z.type===a.Or?Z.expr:[Z]}}),define(Oe[168],Ne([1,0,31,3]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$pt=e.AccessibilitySupport=e.$ot=void 0,e.$qt=O,e.$ot=(0,I.$Ci)("accessibilityService");var P;(function(R){R[R.Unknown=0]="Unknown",R[R.Disabled=1]="Disabled",R[R.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$pt=new v.$Tj("accessibilityModeEnabled",!1);function O(R){return R&&typeof R=="object"&&typeof R.label=="string"&&(typeof R.role>"u"||typeof R.role=="string")}e.$rt="ACCESSIBLE_VIEW_SHOWN_"}),define(Oe[105],Ne([1,0,17,25,20,146,280,156,169,9,168]),function(be,e,v,I,P,O,R,T,$,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=u,e.stringSet=h,e.cursorStyleToString=N,e.filterValidationDecorations=Pe,v=We(v),I=We(I),P=We(P),s=We(s);var y;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class a{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=a;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class d{constructor(Q,De,Je,xe){this.id=Q,this.name=De,this.defaultValue=Je,this.schema=xe}applyUpdate(Q,De){return o(Q,De)}compute(Q,De,Je){return Je}}class n{constructor(Q,De){this.newValue=Q,this.didChange=De}}e.ApplyUpdateResult=n;function o(ee,Q){if(typeof ee!="object"||typeof Q!="object"||!ee||!Q)return new n(Q,ee!==Q);if(Array.isArray(ee)||Array.isArray(Q)){const Je=Array.isArray(ee)&&Array.isArray(Q)&&v.$tb(ee,Q);return new n(Q,!Je)}let De=!1;for(const Je in Q)if(Q.hasOwnProperty(Je)){const xe=o(ee[Je],Q[Je]);xe.didChange&&(ee[Je]=xe.newValue,De=!0)}return new n(ee,De)}class c{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,De){return o(Q,De)}validate(Q){return this.defaultValue}}class l{constructor(Q,De,Je,xe){this.id=Q,this.name=De,this.defaultValue=Je,this.schema=xe}applyUpdate(Q,De){return o(Q,De)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,De,Je){return Je}}function i(ee,Q){return typeof ee>"u"?Q:ee==="false"?!1:!!ee}class r extends l{constructor(Q,De,Je,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Je),super(Q,De,Je,xe)}validate(Q){return i(Q,this.defaultValue)}}function t(ee,Q,De,Je){if(typeof ee>"u")return Q;let xe=parseInt(ee,10);return isNaN(xe)?Q:(xe=Math.max(De,xe),xe=Math.min(Je,xe),xe|0)}class g extends l{static clampedInt(Q,De,Je,xe){return t(Q,De,Je,xe)}constructor(Q,De,Je,xe,ht,$t=void 0){typeof $t<"u"&&($t.type="integer",$t.default=Je,$t.minimum=xe,$t.maximum=ht),super(Q,De,Je,$t),this.minimum=xe,this.maximum=ht}validate(Q){return g.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function u(ee,Q,De,Je){if(typeof ee>"u")return Q;const xe=m.float(ee,Q);return m.clamp(xe,De,Je)}class m extends l{static clamp(Q,De,Je){return Q<De?De:Q>Je?Je:Q}static float(Q,De){if(typeof Q=="number")return Q;if(typeof Q>"u")return De;const Je=parseFloat(Q);return isNaN(Je)?De:Je}constructor(Q,De,Je,xe,ht){typeof ht<"u"&&(ht.type="number",ht.default=Je),super(Q,De,Je,ht),this.validationFn=xe}validate(Q){return this.validationFn(m.float(Q,this.defaultValue))}}class p extends l{static string(Q,De){return typeof Q!="string"?De:Q}constructor(Q,De,Je,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Je),super(Q,De,Je,xe)}validate(Q){return p.string(Q,this.defaultValue)}}function h(ee,Q,De,Je){return typeof ee!="string"?Q:Je&&ee in Je?Je[ee]:De.indexOf(ee)===-1?Q:ee}class E extends l{constructor(Q,De,Je,xe,ht=void 0){typeof ht<"u"&&(ht.type="string",ht.enum=xe,ht.default=Je),super(Q,De,Je,ht),this.c=xe}validate(Q){return h(Q,this.defaultValue,this.c)}}class D extends d{constructor(Q,De,Je,xe,ht,$t,Nt=void 0){typeof Nt<"u"&&(Nt.type="string",Nt.enum=ht,Nt.default=xe),super(Q,De,Je,Nt),this.c=ht,this.d=$t}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function b(ee){switch(ee){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class k extends d{constructor(){super(Ue.accessibilitySupport,"accessibilitySupport",A.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(11682,null),s.localize(11683,null),s.localize(11684,null)],default:"auto",tags:["accessibility"],description:s.localize(11685,null)})}validate(Q){switch(Q){case"auto":return A.AccessibilitySupport.Unknown;case"off":return A.AccessibilitySupport.Disabled;case"on":return A.AccessibilitySupport.Enabled}return this.defaultValue}compute(Q,De,Je){return Je===A.AccessibilitySupport.Unknown?Q.accessibilitySupport:Je}}class C extends d{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(Ue.comments,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:s.localize(11686,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:s.localize(11687,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q;return{insertSpace:i(De.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(De.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var f;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(f||(e.TextEditorCursorBlinkingStyle=f={}));function w(ee){switch(ee){case"blink":return f.Blink;case"smooth":return f.Smooth;case"phase":return f.Phase;case"expand":return f.Expand;case"solid":return f.Solid}}var M;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function N(ee){switch(ee){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function L(ee){switch(ee){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class W extends c{constructor(){super(Ue.editorClassName)}compute(Q,De,Je){const xe=["monaco-editor"];return De.get(Ue.extraEditorClassName)&&xe.push(De.get(Ue.extraEditorClassName)),Q.extraEditorClassName&&xe.push(Q.extraEditorClassName),De.get(Ue.mouseStyle)==="default"?xe.push("mouse-default"):De.get(Ue.mouseStyle)==="copy"&&xe.push("mouse-copy"),De.get(Ue.showUnused)&&xe.push("showUnused"),De.get(Ue.showDeprecated)&&xe.push("showDeprecated"),xe.join(" ")}}class G extends r{constructor(){super(Ue.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:s.localize(11688,null)})}compute(Q,De,Je){return Je&&Q.emptySelectionClipboard}}class F extends d{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Ue.find,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:s.localize(11689,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[s.localize(11690,null),s.localize(11691,null),s.localize(11692,null)],description:s.localize(11693,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[s.localize(11694,null),s.localize(11695,null),s.localize(11696,null)],description:s.localize(11697,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:s.localize(11698,null),included:P.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:s.localize(11699,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:s.localize(11700,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q;return{cursorMoveOnType:i(De.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":h(De.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":h(De.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(De.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(De.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(De.loop,this.defaultValue.loop)}}}class K extends d{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Ue.fontLigatures,"fontLigatures",K.OFF,{anyOf:[{type:"boolean",description:s.localize(11701,null)},{type:"string",description:s.localize(11702,null)}],description:s.localize(11703,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"||Q.length===0?K.OFF:Q==="true"?K.ON:Q:Q?K.ON:K.OFF}}e.EditorFontLigatures=K;class Y extends d{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Ue.fontVariations,"fontVariations",Y.OFF,{anyOf:[{type:"boolean",description:s.localize(11704,null)},{type:"string",description:s.localize(11705,null)}],description:s.localize(11706,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?Y.OFF:Q==="true"?Y.TRANSLATE:Q:Q?Y.TRANSLATE:Y.OFF}compute(Q,De,Je){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=Y;class le extends c{constructor(){super(Ue.fontInfo)}compute(Q,De,Je){return Q.fontInfo}}class _ extends l{constructor(){super(Ue.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(11707,null)})}validate(Q){const De=m.float(Q,this.defaultValue);return De===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(De,6,100)}compute(Q,De,Je){return Q.fontInfo.fontSize}}class ge extends d{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(Ue.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ge.d,maximum:ge.e,errorMessage:s.localize(11708,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ge.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(11709,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(g.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,ge.d,ge.e))}}class se extends d{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},De={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[s.localize(11710,null),s.localize(11711,null),s.localize(11712,null)]},Je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Ue.gotoLocation,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(11713,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(11714,null),...De},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(11715,null),...De},"editor.gotoLocation.multipleDeclarations":{description:s.localize(11716,null),...De},"editor.gotoLocation.multipleImplementations":{description:s.localize(11717,null),...De},"editor.gotoLocation.multipleReferences":{description:s.localize(11718,null),...De},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Je,description:s.localize(11719,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Je,description:s.localize(11720,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Je,description:s.localize(11721,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Je,description:s.localize(11722,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Je,description:s.localize(11723,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q;return{multiple:h(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:De.multipleDefinitions??h(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:De.multipleTypeDefinitions??h(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:De.multipleDeclarations??h(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:De.multipleImplementations??h(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:De.multipleReferences??h(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ae extends d{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Ue.hover,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:s.localize(11724,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:s.localize(11725,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:s.localize(11726,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:s.localize(11727,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:s.localize(11728,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q;return{enabled:i(De.enabled,this.defaultValue.enabled),delay:g.clampedInt(De.delay,this.defaultValue.delay,0,1e4),sticky:i(De.sticky,this.defaultValue.sticky),hidingDelay:g.clampedInt(De.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(De.above,this.defaultValue.above)}}}var $e;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})($e||(e.RenderMinimap=$e={}));class oe extends c{constructor(){super(Ue.layoutInfo)}compute(Q,De,Je){return oe.computeLayout(De,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const De=Q.height/Q.lineHeight,Je=Math.floor(Q.paddingTop/Q.lineHeight);let xe=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(xe=Math.max(xe,De-1));const ht=(Je+Q.viewLineCount+xe)/(Q.pixelRatio*Q.height),$t=Math.floor(Q.viewLineCount/ht);return{typicalViewportLineCount:De,extraLinesBeforeFirstLine:Je,extraLinesBeyondLastLine:xe,desiredRatio:ht,minimapLineCount:$t}}static c(Q,De){const Je=Q.outerWidth,xe=Q.outerHeight,ht=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:$e.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ht*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const $t=De.stableMinimapLayoutInput,Nt=$t&&Q.outerHeight===$t.outerHeight&&Q.lineHeight===$t.lineHeight&&Q.typicalHalfwidthCharacterWidth===$t.typicalHalfwidthCharacterWidth&&Q.pixelRatio===$t.pixelRatio&&Q.scrollBeyondLastLine===$t.scrollBeyondLastLine&&Q.paddingTop===$t.paddingTop&&Q.paddingBottom===$t.paddingBottom&&Q.minimap.enabled===$t.minimap.enabled&&Q.minimap.side===$t.minimap.side&&Q.minimap.size===$t.minimap.size&&Q.minimap.showSlider===$t.minimap.showSlider&&Q.minimap.renderCharacters===$t.minimap.renderCharacters&&Q.minimap.maxColumn===$t.minimap.maxColumn&&Q.minimap.scale===$t.minimap.scale&&Q.verticalScrollbarWidth===$t.verticalScrollbarWidth&&Q.isViewportWrapping===$t.isViewportWrapping,Wt=Q.lineHeight,ri=Q.typicalHalfwidthCharacterWidth,Xt=Q.scrollBeyondLastLine,hi=Q.minimap.renderCharacters;let Ye=ht>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Vt=Q.minimap.maxColumn,Ht=Q.minimap.size,gt=Q.minimap.side,St=Q.verticalScrollbarWidth,Yt=Q.viewLineCount,Zt=Q.remainingWidth,Ut=Q.isViewportWrapping,wt=hi?2:3;let At=Math.floor(ht*xe);const ci=At/ht;let Qt=!1,Xe=!1,xt=wt*Ye,li=Ye/ht,di=1;if(Ht==="fill"||Ht==="fit"){const{typicalViewportLineCount:ei,extraLinesBeforeFirstLine:Bt,extraLinesBeyondLastLine:qt,desiredRatio:ui,minimapLineCount:Tt}=oe.computeContainedMinimapLineCount({viewLineCount:Yt,scrollBeyondLastLine:Xt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:xe,lineHeight:Wt,pixelRatio:ht});if(Yt/Tt>1)Qt=!0,Xe=!0,Ye=1,xt=1,li=Ye/ht;else{let bt=!1,Kt=Ye+1;if(Ht==="fit"){const yt=Math.ceil((Bt+Yt+qt)*xt);Ut&&Nt&&Zt<=De.stableFitRemainingWidth?(bt=!0,Kt=De.stableFitMaxMinimapScale):bt=yt>At}if(Ht==="fill"||bt){Qt=!0;const yt=Ye;xt=Math.min(Wt*ht,Math.max(1,Math.floor(1/ui))),Ut&&Nt&&Zt<=De.stableFitRemainingWidth&&(Kt=De.stableFitMaxMinimapScale),Ye=Math.min(Kt,Math.max(1,Math.floor(xt/wt))),Ye>yt&&(di=Math.min(2,Ye/yt)),li=Ye/ht/di,At=Math.ceil(Math.max(ei,Bt+Yt+qt)*xt),Ut?(De.stableMinimapLayoutInput=Q,De.stableFitRemainingWidth=Zt,De.stableFitMaxMinimapScale=Ye):(De.stableMinimapLayoutInput=null,De.stableFitRemainingWidth=0)}}}const kt=Math.floor(Vt*li),Ft=Math.min(kt,Math.max(0,Math.floor((Zt-St-2)*li/(ri+li)))+e.MINIMAP_GUTTER_WIDTH);let Rt=Math.floor(ht*Ft);const Mt=Rt/ht;Rt=Math.floor(Rt*di);const si=hi?$e.Text:$e.Blocks,_t=gt==="left"?0:Je-Ft-St;return{renderMinimap:si,minimapLeft:_t,minimapWidth:Ft,minimapHeightIsEditorHeight:Qt,minimapIsSampling:Xe,minimapScale:Ye,minimapLineHeight:xt,minimapCanvasInnerWidth:Rt,minimapCanvasInnerHeight:At,minimapCanvasOuterWidth:Mt,minimapCanvasOuterHeight:ci}}static computeLayout(Q,De){const Je=De.outerWidth|0,xe=De.outerHeight|0,ht=De.lineHeight|0,$t=De.lineNumbersDigitCount|0,Nt=De.typicalHalfwidthCharacterWidth,Wt=De.maxDigitWidth,ri=De.pixelRatio,Xt=De.viewLineCount,hi=Q.get(Ue.wordWrapOverride2),Ye=hi==="inherit"?Q.get(Ue.wordWrapOverride1):hi,Vt=Ye==="inherit"?Q.get(Ue.wordWrap):Ye,Ht=Q.get(Ue.wordWrapColumn),gt=De.isDominatedByLongLines,St=Q.get(Ue.glyphMargin),Yt=Q.get(Ue.lineNumbers).renderType!==ze.Off,Zt=Q.get(Ue.lineNumbersMinChars),Ut=Q.get(Ue.scrollBeyondLastLine),wt=Q.get(Ue.padding),At=Q.get(Ue.minimap),ci=Q.get(Ue.scrollbar),Qt=ci.verticalScrollbarSize,Xe=ci.verticalHasArrows,xt=ci.arrowSize,li=ci.horizontalScrollbarSize,di=Q.get(Ue.folding),kt=Q.get(Ue.showFoldingControls)!=="never";let Ft=Q.get(Ue.lineDecorationsWidth);di&&kt&&(Ft+=16);let Rt=0;if(Yt){const Gt=Math.max($t,Zt);Rt=Math.round(Gt*Wt)}let Mt=0;St&&(Mt=ht*De.glyphMarginDecorationLaneCount);let si=0,_t=si+Mt,ei=_t+Rt,Bt=ei+Ft;const qt=Je-Mt-Rt-Ft;let ui=!1,Tt=!1,Ct=-1;Ye==="inherit"&&gt?(ui=!0,Tt=!0):Vt==="on"||Vt==="bounded"?Tt=!0:Vt==="wordWrapColumn"&&(Ct=Ht);const bt=oe.c({outerWidth:Je,outerHeight:xe,lineHeight:ht,typicalHalfwidthCharacterWidth:Nt,pixelRatio:ri,scrollBeyondLastLine:Ut,paddingTop:wt.top,paddingBottom:wt.bottom,minimap:At,verticalScrollbarWidth:Qt,viewLineCount:Xt,remainingWidth:qt,isViewportWrapping:Tt},De.memory||new S);bt.renderMinimap!==$e.None&&bt.minimapLeft===0&&(si+=bt.minimapWidth,_t+=bt.minimapWidth,ei+=bt.minimapWidth,Bt+=bt.minimapWidth);const Kt=qt-bt.minimapWidth,yt=Math.max(1,Math.floor((Kt-Qt-2)/Nt)),oi=Xe?xt:0;return Tt&&(Ct=Math.max(1,yt),Vt==="bounded"&&(Ct=Math.min(Ct,Ht))),{width:Je,height:xe,glyphMarginLeft:si,glyphMarginWidth:Mt,glyphMarginDecorationLaneCount:De.glyphMarginDecorationLaneCount,lineNumbersLeft:_t,lineNumbersWidth:Rt,decorationsLeft:ei,decorationsWidth:Ft,contentLeft:Bt,contentWidth:Kt,minimap:bt,viewportColumn:yt,isWordWrapMinified:ui,isViewportWrapping:Tt,wrappingColumn:Ct,verticalScrollbarWidth:Qt,horizontalScrollbarHeight:li,overviewRuler:{top:oi,width:Qt,height:xe-2*oi,right:0}}}}e.EditorLayoutInfoComputer=oe;class Ce extends d{constructor(){super(Ue.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[s.localize(11729,null),s.localize(11730,null)],type:"string",enum:["simple","advanced"],default:"simple",description:s.localize(11731,null)}})}validate(Q){return h(Q,"simple",["simple","advanced"])}compute(Q,De,Je){return De.get(Ue.accessibilitySupport)===A.AccessibilitySupport.Enabled?"advanced":Je}}var Le;(function(ee){ee.Off="off",ee.OnCode="onCode",ee.On="on"})(Le||(e.ShowLightbulbIconMode=Le={}));class Z extends d{constructor(){const Q={enabled:Le.On};super(Ue.lightbulb,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Le.Off,Le.OnCode,Le.On],default:Q.enabled,enumDescriptions:[s.localize(11732,null),s.localize(11733,null),s.localize(11734,null)],description:s.localize(11735,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:h(Q.enabled,this.defaultValue.enabled,[Le.Off,Le.OnCode,Le.On])}}}class q extends d{constructor(){const Q={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Ue.stickyScroll,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:s.localize(11736,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:20,description:s.localize(11737,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:s.localize(11738,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:s.localize(11739,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q;return{enabled:i(De.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(De.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:h(De.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(De.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class te extends d{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Ue.inlayHints,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:s.localize(11740,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(11741,null),s.localize(11742,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),s.localize(11743,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),s.localize(11744,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:s.localize(11745,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:s.localize(11746,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:s.localize(11747,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q;return typeof De.enabled=="boolean"&&(De.enabled=De.enabled?"on":"off"),{enabled:h(De.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(De.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(De.fontFamily,this.defaultValue.fontFamily),padding:i(De.padding,this.defaultValue.padding)}}}class ve extends d{constructor(){super(Ue.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):g.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,De,Je){return Je<0?g.clampedInt(-Je*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Je}}class ce extends m{constructor(){super(Ue.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>m.clamp(Q,0,150),{markdownDescription:s.localize(11748,null)})}compute(Q,De,Je){return Q.fontInfo.lineHeight}}class we extends d{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Ue.minimap,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:s.localize(11749,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:s.localize(11750,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(11751,null),s.localize(11752,null),s.localize(11753,null)],default:Q.size,description:s.localize(11754,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:s.localize(11755,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:s.localize(11756,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(11757,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:s.localize(11758,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:s.localize(11759,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Q.showRegionSectionHeaders,description:s.localize(11760,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Q.showMarkSectionHeaders,description:s.localize(11761,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Q.sectionHeaderFontSize,description:s.localize(11762,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:Q.sectionHeaderLetterSpacing,description:s.localize(11763,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q;return{enabled:i(De.enabled,this.defaultValue.enabled),autohide:i(De.autohide,this.defaultValue.autohide),size:h(De.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(De.side,this.defaultValue.side,["right","left"]),showSlider:h(De.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(De.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(De.scale,1,1,3),maxColumn:g.clampedInt(De.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(De.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(De.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:m.clamp(De.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:m.clamp(De.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function ue(ee){return ee==="ctrlCmd"?P.$k?"metaKey":"ctrlKey":"altKey"}class X extends d{constructor(){super(Ue.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(11764,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(11765,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q;return{top:g.clampedInt(De.top,0,0,1e3),bottom:g.clampedInt(De.bottom,0,0,1e3)}}}class x extends d{constructor(){const Q={enabled:!0,cycle:!0};super(Ue.parameterHints,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:s.localize(11766,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:s.localize(11767,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q;return{enabled:i(De.enabled,this.defaultValue.enabled),cycle:i(De.cycle,this.defaultValue.cycle)}}}class me extends c{constructor(){super(Ue.pixelRatio)}compute(Q,De,Je){return Q.pixelRatio}}class pe extends d{constructor(){super(Ue.placeholder,"placeholder",void 0)}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q:this.defaultValue}}class Re extends d{constructor(){const Q={other:"on",comments:"off",strings:"off"},De=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(11768,null),s.localize(11769,null),s.localize(11770,null)]}];super(Ue.quickSuggestions,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:De,default:Q.strings,description:s.localize(11771,null)},comments:{anyOf:De,default:Q.comments,description:s.localize(11772,null)},other:{anyOf:De,default:Q.other,description:s.localize(11773,null)}},default:Q,markdownDescription:s.localize(11774,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const ri=Q?"on":"off";return{comments:ri,strings:ri,other:ri}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:De,comments:Je,strings:xe}=Q,ht=["on","inline","off"];let $t,Nt,Wt;return typeof De=="boolean"?$t=De?"on":"off":$t=h(De,this.defaultValue.other,ht),typeof Je=="boolean"?Nt=Je?"on":"off":Nt=h(Je,this.defaultValue.comments,ht),typeof xe=="boolean"?Wt=xe?"on":"off":Wt=h(xe,this.defaultValue.strings,ht),{other:$t,comments:Nt,strings:Wt}}}var ze;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(ze||(e.RenderLineNumbersType=ze={}));class ke extends d{constructor(){super(Ue.lineNumbers,"lineNumbers",{renderType:ze.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(11775,null),s.localize(11776,null),s.localize(11777,null),s.localize(11778,null)],default:"on",description:s.localize(11779,null)})}validate(Q){let De=this.defaultValue.renderType,Je=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(De=ze.Custom,Je=Q):Q==="interval"?De=ze.Interval:Q==="relative"?De=ze.Relative:Q==="on"?De=ze.On:De=ze.Off),{renderType:De,renderFn:Je}}}function Pe(ee){const Q=ee.get(Ue.renderValidationDecorations);return Q==="editable"?ee.get(Ue.readOnly):Q!=="on"}class Te extends d{constructor(){const Q=[],De={type:"number",description:s.localize(11780,null)};super(Ue.rulers,"rulers",Q,{type:"array",items:{anyOf:[De,{type:["object"],properties:{column:De,color:{type:"string",description:s.localize(11781,null),format:"color-hex"}}}]},default:Q,description:s.localize(11782,null)})}validate(Q){if(Array.isArray(Q)){const De=[];for(const Je of Q)if(typeof Je=="number")De.push({column:g.clampedInt(Je,0,0,1e4),color:null});else if(Je&&typeof Je=="object"){const xe=Je;De.push({column:g.clampedInt(xe.column,0,0,1e4),color:xe.color})}return De.sort((Je,xe)=>Je.column-xe.column),De}return this.defaultValue}}class U extends d{constructor(){super(Ue.readOnlyMessage,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function B(ee,Q){if(typeof ee!="string")return Q;switch(ee){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class H extends d{constructor(){const Q={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Ue.scrollbar,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(11783,null),s.localize(11784,null),s.localize(11785,null)],default:"auto",description:s.localize(11786,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(11787,null),s.localize(11788,null),s.localize(11789,null)],default:"auto",description:s.localize(11790,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:s.localize(11791,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:s.localize(11792,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:s.localize(11793,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Q.ignoreHorizontalScrollbarInContentHeight,description:s.localize(11794,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q,Je=g.clampedInt(De.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=g.clampedInt(De.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(De.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:B(De.vertical,this.defaultValue.vertical),horizontal:B(De.horizontal,this.defaultValue.horizontal),useShadows:i(De.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(De.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(De.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(De.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(De.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Je,horizontalSliderSize:g.clampedInt(De.horizontalSliderSize,Je,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:g.clampedInt(De.verticalSliderSize,xe,0,1e3),scrollByPage:i(De.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(De.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends d{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Ue.unicodeHighlighting,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:s.localize(11795,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:s.localize(11796,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:s.localize(11797,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:s.localize(11798,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:s.localize(11799,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:s.localize(11800,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:s.localize(11801,null)}})}applyUpdate(Q,De){let Je=!1;De.allowedCharacters&&Q&&(I.$fo(Q.allowedCharacters,De.allowedCharacters)||(Q={...Q,allowedCharacters:De.allowedCharacters},Je=!0)),De.allowedLocales&&Q&&(I.$fo(Q.allowedLocales,De.allowedLocales)||(Q={...Q,allowedLocales:De.allowedLocales},Je=!0));const xe=super.applyUpdate(Q,De);return Je?new n(xe.newValue,!0):xe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q;return{nonBasicASCII:Qe(De.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(De.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(De.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Qe(De.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Qe(De.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,De){if(typeof Q!="object"||!Q)return De;const Je={};for(const[xe,ht]of Object.entries(Q))ht===!0&&(Je[xe]=!0);return Je}}class ne extends d{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Ue.inlineSuggest,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:s.localize(11802,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(11803,null),s.localize(11804,null),s.localize(11805,null)],description:s.localize(11806,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:s.localize(11807,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Q.fontFamily,description:s.localize(11808,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q;return{enabled:i(De.enabled,this.defaultValue.enabled),mode:h(De.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(De.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(De.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:p.string(De.fontFamily,this.defaultValue.fontFamily)}}}class fe extends d{constructor(){const Q={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(Ue.inlineEdit,"experimentalInlineEdit",Q,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Q.enabled,description:s.localize(11809,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(11810,null),s.localize(11811,null),s.localize(11812,null)],description:s.localize(11813,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Q.fontFamily,description:s.localize(11814,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q;return{enabled:i(De.enabled,this.defaultValue.enabled),showToolbar:h(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:p.string(De.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(De.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Ie extends d{constructor(){const Q={enabled:T.$it.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$it.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Ue.bracketPairColorization,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:s.localize(11815,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:s.localize(11816,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q;return{enabled:i(De.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(De.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class je extends d{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Ue.guides,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(11817,null),s.localize(11818,null),s.localize(11819,null)],default:Q.bracketPairs,description:s.localize(11820,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(11821,null),s.localize(11822,null),s.localize(11823,null)],default:Q.bracketPairsHorizontal,description:s.localize(11824,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:s.localize(11825,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:s.localize(11826,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(11827,null),s.localize(11828,null),s.localize(11829,null)],default:Q.highlightActiveIndentation,description:s.localize(11830,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q;return{bracketPairs:Qe(De.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Qe(De.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(De.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(De.indentation,this.defaultValue.indentation),highlightActiveIndentation:Qe(De.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Qe(ee,Q,De){const Je=De.indexOf(ee);return Je===-1?Q:De[Je]}class _e extends d{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Ue.suggest,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(11831,null),s.localize(11832,null)],default:Q.insertMode,description:s.localize(11833,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:s.localize(11834,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:s.localize(11835,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:s.localize(11836,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[s.localize(11837,null),s.localize(11838,null),s.localize(11839,null),s.localize(11840,null)],default:Q.selectionMode,markdownDescription:s.localize(11841,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:s.localize(11842,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:s.localize(11843,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:s.localize(11844,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:s.localize(11845,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:s.localize(11846,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(11847,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(11848,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(11849,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(11850,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(11851,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(11852,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:s.localize(11853,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(11854,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(11855,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(11856,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(11857,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(11858,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(11859,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(11860,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(11861,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(11862,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(11863,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(11864,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(11865,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(11866,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(11867,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(11868,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(11869,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(11870,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(11871,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(11872,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(11873,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(11874,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(11875,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(11876,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(11877,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(11878,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q;return{insertMode:h(De.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(De.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(De.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(De.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(De.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(De.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(De.showIcons,this.defaultValue.showIcons),showStatusBar:i(De.showStatusBar,this.defaultValue.showStatusBar),preview:i(De.preview,this.defaultValue.preview),previewMode:h(De.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(De.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(De.showMethods,this.defaultValue.showMethods),showFunctions:i(De.showFunctions,this.defaultValue.showFunctions),showConstructors:i(De.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(De.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(De.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(De.showFields,this.defaultValue.showFields),showVariables:i(De.showVariables,this.defaultValue.showVariables),showClasses:i(De.showClasses,this.defaultValue.showClasses),showStructs:i(De.showStructs,this.defaultValue.showStructs),showInterfaces:i(De.showInterfaces,this.defaultValue.showInterfaces),showModules:i(De.showModules,this.defaultValue.showModules),showProperties:i(De.showProperties,this.defaultValue.showProperties),showEvents:i(De.showEvents,this.defaultValue.showEvents),showOperators:i(De.showOperators,this.defaultValue.showOperators),showUnits:i(De.showUnits,this.defaultValue.showUnits),showValues:i(De.showValues,this.defaultValue.showValues),showConstants:i(De.showConstants,this.defaultValue.showConstants),showEnums:i(De.showEnums,this.defaultValue.showEnums),showEnumMembers:i(De.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(De.showKeywords,this.defaultValue.showKeywords),showWords:i(De.showWords,this.defaultValue.showWords),showColors:i(De.showColors,this.defaultValue.showColors),showFiles:i(De.showFiles,this.defaultValue.showFiles),showReferences:i(De.showReferences,this.defaultValue.showReferences),showFolders:i(De.showFolders,this.defaultValue.showFolders),showTypeParameters:i(De.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(De.showSnippets,this.defaultValue.showSnippets),showUsers:i(De.showUsers,this.defaultValue.showUsers),showIssues:i(De.showIssues,this.defaultValue.showIssues)}}}class tt extends d{constructor(){super(Ue.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(11879,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:s.localize(11880,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(Q.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends d{constructor(){const Q=[];super(Ue.wordSegmenterLocales,"wordSegmenterLocales",Q,{anyOf:[{description:s.localize(11881,null),type:"string"},{description:s.localize(11882,null),type:"array",items:{type:"string"}}]})}validate(Q){if(typeof Q=="string"&&(Q=[Q]),Array.isArray(Q)){const De=[];for(const Je of Q)if(typeof Je=="string")try{Intl.Segmenter.supportedLocalesOf(Je).length>0&&De.push(Je)}catch{}return De}return this.defaultValue}}var et;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(et||(e.WrappingIndent=et={}));class rt extends d{constructor(){super(Ue.wrappingIndent,"wrappingIndent",et.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[s.localize(11883,null),s.localize(11884,null),s.localize(11885,null),s.localize(11886,null)],description:s.localize(11887,null),default:"same"}})}validate(Q){switch(Q){case"none":return et.None;case"same":return et.Same;case"indent":return et.Indent;case"deepIndent":return et.DeepIndent}return et.Same}compute(Q,De,Je){return De.get(Ue.accessibilitySupport)===A.AccessibilitySupport.Enabled?et.None:Je}}class mt extends c{constructor(){super(Ue.wrappingInfo)}compute(Q,De,Je){const xe=De.get(Ue.layoutInfo);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class lt extends d{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(Ue.dropIntoEditor,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:s.localize(11888,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:s.localize(11889,null),enum:["afterDrop","never"],enumDescriptions:[s.localize(11890,null),s.localize(11891,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q;return{enabled:i(De.enabled,this.defaultValue.enabled),showDropSelector:h(De.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends d{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(Ue.pasteAs,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:s.localize(11892,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:s.localize(11893,null),enum:["afterPaste","never"],enumDescriptions:[s.localize(11894,null),s.localize(11895,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const De=Q;return{enabled:i(De.enabled,this.defaultValue.enabled),showPasteSelector:h(De.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ct="Consolas, 'Courier New', monospace",ft="Menlo, Monaco, 'Courier New', monospace",pt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$k?ft:P.$l?pt:ct,fontWeight:"normal",fontSize:P.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function qe(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var Ue;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.ariaRequired=5]="ariaRequired",ee[ee.autoClosingBrackets=6]="autoClosingBrackets",ee[ee.autoClosingComments=7]="autoClosingComments",ee[ee.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ee[ee.autoClosingDelete=9]="autoClosingDelete",ee[ee.autoClosingOvertype=10]="autoClosingOvertype",ee[ee.autoClosingQuotes=11]="autoClosingQuotes",ee[ee.autoIndent=12]="autoIndent",ee[ee.automaticLayout=13]="automaticLayout",ee[ee.autoSurround=14]="autoSurround",ee[ee.bracketPairColorization=15]="bracketPairColorization",ee[ee.guides=16]="guides",ee[ee.codeLens=17]="codeLens",ee[ee.codeLensFontFamily=18]="codeLensFontFamily",ee[ee.codeLensFontSize=19]="codeLensFontSize",ee[ee.colorDecorators=20]="colorDecorators",ee[ee.colorDecoratorsLimit=21]="colorDecoratorsLimit",ee[ee.columnSelection=22]="columnSelection",ee[ee.comments=23]="comments",ee[ee.contextmenu=24]="contextmenu",ee[ee.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=26]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=28]="cursorStyle",ee[ee.cursorSurroundingLines=29]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=31]="cursorWidth",ee[ee.disableLayerHinting=32]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ee[ee.domReadOnly=34]="domReadOnly",ee[ee.dragAndDrop=35]="dragAndDrop",ee[ee.dropIntoEditor=36]="dropIntoEditor",ee[ee.emptySelectionClipboard=37]="emptySelectionClipboard",ee[ee.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ee[ee.extraEditorClassName=39]="extraEditorClassName",ee[ee.fastScrollSensitivity=40]="fastScrollSensitivity",ee[ee.find=41]="find",ee[ee.fixedOverflowWidgets=42]="fixedOverflowWidgets",ee[ee.folding=43]="folding",ee[ee.foldingStrategy=44]="foldingStrategy",ee[ee.foldingHighlight=45]="foldingHighlight",ee[ee.foldingImportsByDefault=46]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=47]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=49]="fontFamily",ee[ee.fontInfo=50]="fontInfo",ee[ee.fontLigatures=51]="fontLigatures",ee[ee.fontSize=52]="fontSize",ee[ee.fontWeight=53]="fontWeight",ee[ee.fontVariations=54]="fontVariations",ee[ee.formatOnPaste=55]="formatOnPaste",ee[ee.formatOnType=56]="formatOnType",ee[ee.glyphMargin=57]="glyphMargin",ee[ee.gotoLocation=58]="gotoLocation",ee[ee.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ee[ee.hover=60]="hover",ee[ee.inDiffEditor=61]="inDiffEditor",ee[ee.inlineSuggest=62]="inlineSuggest",ee[ee.inlineEdit=63]="inlineEdit",ee[ee.letterSpacing=64]="letterSpacing",ee[ee.lightbulb=65]="lightbulb",ee[ee.lineDecorationsWidth=66]="lineDecorationsWidth",ee[ee.lineHeight=67]="lineHeight",ee[ee.lineNumbers=68]="lineNumbers",ee[ee.lineNumbersMinChars=69]="lineNumbersMinChars",ee[ee.linkedEditing=70]="linkedEditing",ee[ee.links=71]="links",ee[ee.matchBrackets=72]="matchBrackets",ee[ee.minimap=73]="minimap",ee[ee.mouseStyle=74]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=76]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=78]="multiCursorModifier",ee[ee.multiCursorPaste=79]="multiCursorPaste",ee[ee.multiCursorLimit=80]="multiCursorLimit",ee[ee.occurrencesHighlight=81]="occurrencesHighlight",ee[ee.overviewRulerBorder=82]="overviewRulerBorder",ee[ee.overviewRulerLanes=83]="overviewRulerLanes",ee[ee.padding=84]="padding",ee[ee.pasteAs=85]="pasteAs",ee[ee.parameterHints=86]="parameterHints",ee[ee.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ee[ee.placeholder=88]="placeholder",ee[ee.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=90]="quickSuggestions",ee[ee.quickSuggestionsDelay=91]="quickSuggestionsDelay",ee[ee.readOnly=92]="readOnly",ee[ee.readOnlyMessage=93]="readOnlyMessage",ee[ee.renameOnType=94]="renameOnType",ee[ee.renderControlCharacters=95]="renderControlCharacters",ee[ee.renderFinalNewline=96]="renderFinalNewline",ee[ee.renderLineHighlight=97]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=99]="renderValidationDecorations",ee[ee.renderWhitespace=100]="renderWhitespace",ee[ee.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ee[ee.roundedSelection=102]="roundedSelection",ee[ee.rulers=103]="rulers",ee[ee.scrollbar=104]="scrollbar",ee[ee.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=106]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=107]="scrollPredominantAxis",ee[ee.selectionClipboard=108]="selectionClipboard",ee[ee.selectionHighlight=109]="selectionHighlight",ee[ee.selectOnLineNumbers=110]="selectOnLineNumbers",ee[ee.showFoldingControls=111]="showFoldingControls",ee[ee.showUnused=112]="showUnused",ee[ee.snippetSuggestions=113]="snippetSuggestions",ee[ee.smartSelect=114]="smartSelect",ee[ee.smoothScrolling=115]="smoothScrolling",ee[ee.stickyScroll=116]="stickyScroll",ee[ee.stickyTabStops=117]="stickyTabStops",ee[ee.stopRenderingLineAfter=118]="stopRenderingLineAfter",ee[ee.suggest=119]="suggest",ee[ee.suggestFontSize=120]="suggestFontSize",ee[ee.suggestLineHeight=121]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ee[ee.suggestSelection=123]="suggestSelection",ee[ee.tabCompletion=124]="tabCompletion",ee[ee.tabIndex=125]="tabIndex",ee[ee.unicodeHighlighting=126]="unicodeHighlighting",ee[ee.unusualLineTerminators=127]="unusualLineTerminators",ee[ee.useShadowDOM=128]="useShadowDOM",ee[ee.useTabStops=129]="useTabStops",ee[ee.wordBreak=130]="wordBreak",ee[ee.wordSegmenterLocales=131]="wordSegmenterLocales",ee[ee.wordSeparators=132]="wordSeparators",ee[ee.wordWrap=133]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=136]="wordWrapColumn",ee[ee.wordWrapOverride1=137]="wordWrapOverride1",ee[ee.wordWrapOverride2=138]="wordWrapOverride2",ee[ee.wrappingIndent=139]="wrappingIndent",ee[ee.wrappingStrategy=140]="wrappingStrategy",ee[ee.showDeprecated=141]="showDeprecated",ee[ee.inlayHints=142]="inlayHints",ee[ee.editorClassName=143]="editorClassName",ee[ee.pixelRatio=144]="pixelRatio",ee[ee.tabFocusMode=145]="tabFocusMode",ee[ee.layoutInfo=146]="layoutInfo",ee[ee.wrappingInfo=147]="wrappingInfo",ee[ee.defaultColorDecorators=148]="defaultColorDecorators",ee[ee.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ee[ee.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(Ue||(e.EditorOption=Ue={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:qe(new r(Ue.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(11896,null)})),acceptSuggestionOnEnter:qe(new E(Ue.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(11897,null),""],markdownDescription:s.localize(11898,null)})),accessibilitySupport:qe(new k),accessibilityPageSize:qe(new g(Ue.accessibilityPageSize,"accessibilityPageSize",10,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(11899,null),tags:["accessibility"]})),ariaLabel:qe(new p(Ue.ariaLabel,"ariaLabel",s.localize(11900,null))),ariaRequired:qe(new r(Ue.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:qe(new r(Ue.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:s.localize(11901,null),tags:["accessibility"]})),autoClosingBrackets:qe(new E(Ue.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(11902,null),s.localize(11903,null),""],description:s.localize(11904,null)})),autoClosingComments:qe(new E(Ue.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(11905,null),s.localize(11906,null),""],description:s.localize(11907,null)})),autoClosingDelete:qe(new E(Ue.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(11908,null),""],description:s.localize(11909,null)})),autoClosingOvertype:qe(new E(Ue.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(11910,null),""],description:s.localize(11911,null)})),autoClosingQuotes:qe(new E(Ue.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(11912,null),s.localize(11913,null),""],description:s.localize(11914,null)})),autoIndent:qe(new D(Ue.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[s.localize(11915,null),s.localize(11916,null),s.localize(11917,null),s.localize(11918,null),s.localize(11919,null)],description:s.localize(11920,null)})),automaticLayout:qe(new r(Ue.automaticLayout,"automaticLayout",!1)),autoSurround:qe(new E(Ue.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(11921,null),s.localize(11922,null),s.localize(11923,null),""],description:s.localize(11924,null)})),bracketPairColorization:qe(new Ie),bracketPairGuides:qe(new je),stickyTabStops:qe(new r(Ue.stickyTabStops,"stickyTabStops",!1,{description:s.localize(11925,null)})),codeLens:qe(new r(Ue.codeLens,"codeLens",!0,{description:s.localize(11926,null)})),codeLensFontFamily:qe(new p(Ue.codeLensFontFamily,"codeLensFontFamily","",{description:s.localize(11927,null)})),codeLensFontSize:qe(new g(Ue.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(11928,null)})),colorDecorators:qe(new r(Ue.colorDecorators,"colorDecorators",!0,{description:s.localize(11929,null)})),colorDecoratorActivatedOn:qe(new E(Ue.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[s.localize(11930,null),s.localize(11931,null),s.localize(11932,null)],description:s.localize(11933,null)})),colorDecoratorsLimit:qe(new g(Ue.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:s.localize(11934,null)})),columnSelection:qe(new r(Ue.columnSelection,"columnSelection",!1,{description:s.localize(11935,null)})),comments:qe(new C),contextmenu:qe(new r(Ue.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:qe(new r(Ue.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:s.localize(11936,null)})),cursorBlinking:qe(new D(Ue.cursorBlinking,"cursorBlinking",f.Blink,"blink",["blink","smooth","phase","expand","solid"],w,{description:s.localize(11937,null)})),cursorSmoothCaretAnimation:qe(new E(Ue.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[s.localize(11938,null),s.localize(11939,null),s.localize(11940,null)],description:s.localize(11941,null)})),cursorStyle:qe(new D(Ue.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:s.localize(11942,null)})),cursorSurroundingLines:qe(new g(Ue.cursorSurroundingLines,"cursorSurroundingLines",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(11943,null)})),cursorSurroundingLinesStyle:qe(new E(Ue.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(11944,null),s.localize(11945,null)],markdownDescription:s.localize(11946,null)})),cursorWidth:qe(new g(Ue.cursorWidth,"cursorWidth",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(11947,null)})),disableLayerHinting:qe(new r(Ue.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:qe(new r(Ue.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:qe(new r(Ue.domReadOnly,"domReadOnly",!1)),dragAndDrop:qe(new r(Ue.dragAndDrop,"dragAndDrop",!0,{description:s.localize(11948,null)})),emptySelectionClipboard:qe(new G),dropIntoEditor:qe(new lt),stickyScroll:qe(new q),experimentalWhitespaceRendering:qe(new E(Ue.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[s.localize(11949,null),s.localize(11950,null),s.localize(11951,null)],description:s.localize(11952,null)})),extraEditorClassName:qe(new p(Ue.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:qe(new m(Ue.fastScrollSensitivity,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:s.localize(11953,null)})),find:qe(new F),fixedOverflowWidgets:qe(new r(Ue.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:qe(new r(Ue.folding,"folding",!0,{description:s.localize(11954,null)})),foldingStrategy:qe(new E(Ue.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(11955,null),s.localize(11956,null)],description:s.localize(11957,null)})),foldingHighlight:qe(new r(Ue.foldingHighlight,"foldingHighlight",!0,{description:s.localize(11958,null)})),foldingImportsByDefault:qe(new r(Ue.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:s.localize(11959,null)})),foldingMaximumRegions:qe(new g(Ue.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(11960,null)})),unfoldOnClickAfterEndOfLine:qe(new r(Ue.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(11961,null)})),fontFamily:qe(new p(Ue.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(11962,null)})),fontInfo:qe(new le),fontLigatures2:qe(new K),fontSize:qe(new _),fontWeight:qe(new ge),fontVariations:qe(new Y),formatOnPaste:qe(new r(Ue.formatOnPaste,"formatOnPaste",!1,{description:s.localize(11963,null)})),formatOnType:qe(new r(Ue.formatOnType,"formatOnType",!1,{description:s.localize(11964,null)})),glyphMargin:qe(new r(Ue.glyphMargin,"glyphMargin",!0,{description:s.localize(11965,null)})),gotoLocation:qe(new se),hideCursorInOverviewRuler:qe(new r(Ue.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:s.localize(11966,null)})),hover:qe(new ae),inDiffEditor:qe(new r(Ue.inDiffEditor,"inDiffEditor",!1)),letterSpacing:qe(new m(Ue.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>m.clamp(ee,-5,20),{description:s.localize(11967,null)})),lightbulb:qe(new Z),lineDecorationsWidth:qe(new ve),lineHeight:qe(new ce),lineNumbers:qe(new ke),lineNumbersMinChars:qe(new g(Ue.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:qe(new r(Ue.linkedEditing,"linkedEditing",!1,{description:s.localize(11968,null)})),links:qe(new r(Ue.links,"links",!0,{description:s.localize(11969,null)})),matchBrackets:qe(new E(Ue.matchBrackets,"matchBrackets","always",["always","near","never"],{description:s.localize(11970,null)})),minimap:qe(new we),mouseStyle:qe(new E(Ue.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:qe(new m(Ue.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:s.localize(11971,null)})),mouseWheelZoom:qe(new r(Ue.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$k?s.localize(11972,null):s.localize(11973,null)})),multiCursorMergeOverlapping:qe(new r(Ue.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:s.localize(11974,null)})),multiCursorModifier:qe(new D(Ue.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[s.localize(11975,null),s.localize(11976,null)],markdownDescription:s.localize(11977,null)})),multiCursorPaste:qe(new E(Ue.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(11978,null),s.localize(11979,null)],markdownDescription:s.localize(11980,null)})),multiCursorLimit:qe(new g(Ue.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:s.localize(11981,null)})),occurrencesHighlight:qe(new E(Ue.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[s.localize(11982,null),s.localize(11983,null),s.localize(11984,null)],markdownDescription:s.localize(11985,null)})),overviewRulerBorder:qe(new r(Ue.overviewRulerBorder,"overviewRulerBorder",!0,{description:s.localize(11986,null)})),overviewRulerLanes:qe(new g(Ue.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:qe(new X),pasteAs:qe(new st),parameterHints:qe(new x),peekWidgetDefaultFocus:qe(new E(Ue.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(11987,null),s.localize(11988,null)],description:s.localize(11989,null)})),placeholder:qe(new pe),definitionLinkOpensInPeek:qe(new r(Ue.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:s.localize(11990,null)})),quickSuggestions:qe(new Re),quickSuggestionsDelay:qe(new g(Ue.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(11991,null)})),readOnly:qe(new r(Ue.readOnly,"readOnly",!1)),readOnlyMessage:qe(new U),renameOnType:qe(new r(Ue.renameOnType,"renameOnType",!1,{description:s.localize(11992,null),markdownDeprecationMessage:s.localize(11993,null)})),renderControlCharacters:qe(new r(Ue.renderControlCharacters,"renderControlCharacters",!0,{description:s.localize(11994,null),restricted:!0})),renderFinalNewline:qe(new E(Ue.renderFinalNewline,"renderFinalNewline",P.$l?"dimmed":"on",["off","on","dimmed"],{description:s.localize(11995,null)})),renderLineHighlight:qe(new E(Ue.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(11996,null)],description:s.localize(11997,null)})),renderLineHighlightOnlyWhenFocus:qe(new r(Ue.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(11998,null)})),renderValidationDecorations:qe(new E(Ue.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:qe(new E(Ue.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(11999,null),s.localize(12e3,null),s.localize(12001,null),""],description:s.localize(12002,null)})),revealHorizontalRightPadding:qe(new g(Ue.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:qe(new r(Ue.roundedSelection,"roundedSelection",!0,{description:s.localize(12003,null)})),rulers:qe(new Te),scrollbar:qe(new H),scrollBeyondLastColumn:qe(new g(Ue.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(12004,null)})),scrollBeyondLastLine:qe(new r(Ue.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:s.localize(12005,null)})),scrollPredominantAxis:qe(new r(Ue.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:s.localize(12006,null)})),selectionClipboard:qe(new r(Ue.selectionClipboard,"selectionClipboard",!0,{description:s.localize(12007,null),included:P.$l})),selectionHighlight:qe(new r(Ue.selectionHighlight,"selectionHighlight",!0,{description:s.localize(12008,null)})),selectOnLineNumbers:qe(new r(Ue.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:qe(new E(Ue.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[s.localize(12009,null),s.localize(12010,null),s.localize(12011,null)],description:s.localize(12012,null)})),showUnused:qe(new r(Ue.showUnused,"showUnused",!0,{description:s.localize(12013,null)})),showDeprecated:qe(new r(Ue.showDeprecated,"showDeprecated",!0,{description:s.localize(12014,null)})),inlayHints:qe(new te),snippetSuggestions:qe(new E(Ue.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(12015,null),s.localize(12016,null),s.localize(12017,null),s.localize(12018,null)],description:s.localize(12019,null)})),smartSelect:qe(new tt),smoothScrolling:qe(new r(Ue.smoothScrolling,"smoothScrolling",!1,{description:s.localize(12020,null)})),stopRenderingLineAfter:qe(new g(Ue.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:qe(new _e),inlineSuggest:qe(new ne),inlineEdit:qe(new fe),inlineCompletionsAccessibilityVerbose:qe(new r(Ue.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:s.localize(12021,null)})),suggestFontSize:qe(new g(Ue.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(12022,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:qe(new g(Ue.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(12023,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:qe(new r(Ue.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:s.localize(12024,null)})),suggestSelection:qe(new E(Ue.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(12025,null),s.localize(12026,null),s.localize(12027,null)],description:s.localize(12028,null)})),tabCompletion:qe(new E(Ue.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(12029,null),s.localize(12030,null),s.localize(12031,null)],description:s.localize(12032,null)})),tabIndex:qe(new g(Ue.tabIndex,"tabIndex",0,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:qe(new V),unusualLineTerminators:qe(new E(Ue.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(12033,null),s.localize(12034,null),s.localize(12035,null)],description:s.localize(12036,null)})),useShadowDOM:qe(new r(Ue.useShadowDOM,"useShadowDOM",!0)),useTabStops:qe(new r(Ue.useTabStops,"useTabStops",!0,{description:s.localize(12037,null)})),wordBreak:qe(new E(Ue.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[s.localize(12038,null),s.localize(12039,null)],description:s.localize(12040,null)})),wordSegmenterLocales:qe(new nt),wordSeparators:qe(new p(Ue.wordSeparators,"wordSeparators",$.$jt,{description:s.localize(12041,null)})),wordWrap:qe(new E(Ue.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(12042,null),s.localize(12043,null),s.localize(12044,null),s.localize(12045,null)],description:s.localize(12046,null)})),wordWrapBreakAfterCharacters:qe(new p(Ue.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:qe(new p(Ue.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:qe(new g(Ue.wordWrapColumn,"wordWrapColumn",80,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(12047,null)})),wordWrapOverride1:qe(new E(Ue.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:qe(new E(Ue.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:qe(new W),defaultColorDecorators:qe(new r(Ue.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:s.localize(12048,null)})),pixelRatio:qe(new me),tabFocusMode:qe(new r(Ue.tabFocusMode,"tabFocusMode",!1,{markdownDescription:s.localize(12049,null)})),layoutInfo:qe(new oe),wrappingInfo:qe(new mt),wrappingIndent:qe(new rt),wrappingStrategy:qe(new Ce)}}),define(Oe[106],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,v.$Ci)("environmentService"),e.$Ki=(0,v.$Di)(e.$Ji)}),define(Oe[29],Ne([1,0,58,19,12,14,2,9,3,20,15,48]),function(be,e,v,I,P,O,R,T,$,s,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$Cl=e.FileKind=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.FileOperationResult=e.$ul=e.$tl=e.$sl=e.$ql=e.FileChangeType=e.$pl=e.FileOperation=e.$jl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$0k=void 0,e.$$k=a,e.$_k=o,e.$al=l,e.$bl=i,e.$cl=r,e.$dl=t,e.$el=g,e.$fl=u,e.$gl=m,e.$hl=p,e.$il=h,e.$kl=b,e.$ll=k,e.$ml=C,e.$nl=f,e.$ol=w,e.$rl=G,e.$Dl=ge,e.$El=se,e.$Gl=$e,e.$0k=(0,$.$Ci)("fileService");function a(oe){return oe.create===!0}var S;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var d;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var n;(function(oe){oe[oe.UPDATED=2]="UPDATED",oe[oe.ADDED=4]="ADDED",oe[oe.DELETED=8]="DELETED"})(n||(e.FileChangeFilter=n={}));function o(oe){const Ce=oe;return!!Ce&&typeof Ce.onDidChange=="function"}var c;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function l(oe){return!!(oe.capabilities&c.FileReadWrite)}function i(oe){return!!(oe.capabilities&c.FileFolderCopy)}function r(oe){return!!(oe.capabilities&c.FileClone)}function t(oe){return!!(oe.capabilities&c.FileOpenReadWriteClose)}function g(oe){return!!(oe.capabilities&c.FileReadStream)}function u(oe){return l(oe)?!!(oe.capabilities&c.FileAtomicRead):!1}function m(oe){return l(oe)?!!(oe.capabilities&c.FileAtomicWrite):!1}function p(oe){return!!(oe.capabilities&c.FileAtomicDelete)}function h(oe){return!!(oe.capabilities&c.Readonly)}var E;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class D extends Error{static create(Ce,Le){const Z=new D(Ce.toString(),Le);return C(Z,Le),Z}constructor(Ce,Le){super(Ce),this.code=Le}}e.$jl=D;function b(oe,Ce){return D.create(oe,Ce)}function k(oe){return oe||b((0,T.localize)(11292,null),E.Unknown)}function C(oe,Ce){return oe.name=Ce?`${Ce} (FileSystemError)`:"FileSystemError",oe}function f(oe){if(!oe)return E.Unknown;if(oe instanceof D)return oe.code;const Ce=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!Ce)return E.Unknown;switch(Ce[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function w(oe){if(oe instanceof F)return oe.fileOperationResult;switch(f(oe)){case E.FileNotFound:return le.FILE_NOT_FOUND;case E.FileIsADirectory:return le.FILE_IS_DIRECTORY;case E.FileNotADirectory:return le.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return le.FILE_WRITE_LOCKED;case E.NoPermissions:return le.FILE_PERMISSION_DENIED;case E.FileExists:return le.FILE_MOVE_CONFLICT;case E.FileTooLarge:return le.FILE_TOO_LARGE;default:return le.FILE_OTHER_ERROR}}var M;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class N{constructor(Ce,Le,Z){this.resource=Ce,this.operation=Le,this.target=Z}isOperation(Ce){return this.operation===Ce}}e.$pl=N;var L;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class W{static{this.a=null}constructor(Ce,Le){this.c=Le,this.b=void 0,this.d=new y.$T(()=>{const Z=v.$Ii.forUris(()=>this.c);return Z.fill(this.rawAdded.map(q=>[q,!0])),Z}),this.f=new y.$T(()=>{const Z=v.$Ii.forUris(()=>this.c);return Z.fill(this.rawUpdated.map(q=>[q,!0])),Z}),this.g=new y.$T(()=>{const Z=v.$Ii.forUris(()=>this.c);return Z.fill(this.rawDeleted.map(q=>[q,!0])),Z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Z of Ce){switch(Z.type){case L.ADDED:this.rawAdded.push(Z.resource);break;case L.UPDATED:this.rawUpdated.push(Z.resource);break;case L.DELETED:this.rawDeleted.push(Z.resource);break}this.b!==W.a&&(typeof Z.cId=="number"?this.b===void 0?this.b=Z.cId:this.b!==Z.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains(Ce,...Le){return this.h(Ce,{includeChildren:!1},...Le)}affects(Ce,...Le){return this.h(Ce,{includeChildren:!0},...Le)}h(Ce,Le,...Z){if(!Ce)return!1;const q=Z.length>0;return!!((!q||Z.includes(L.ADDED))&&(this.d.value.get(Ce)||Le.includeChildren&&this.d.value.findSuperstr(Ce))||(!q||Z.includes(L.UPDATED))&&(this.f.value.get(Ce)||Le.includeChildren&&this.f.value.findSuperstr(Ce))||(!q||Z.includes(L.DELETED))&&(this.g.value.findSubstr(Ce)||Le.includeChildren&&this.g.value.findSuperstr(Ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ce){return this.b===Ce}hasCorrelation(){return typeof this.b=="number"}}e.$ql=W;function G(oe,Ce,Le){return!oe||!Ce||oe===Ce||Ce.length>oe.length?!1:(Ce.charAt(Ce.length-1)!==I.sep&&(Ce+=I.sep),Le?(0,P.$Ef)(oe,Ce):oe.indexOf(Ce)===0)}class F extends Error{constructor(Ce,Le,Z){super(Ce),this.fileOperationResult=Le,this.options=Z}}e.$sl=F;class K extends F{constructor(Ce,Le,Z,q){super(Ce,Le,q),this.fileOperationResult=Le,this.size=Z}}e.$tl=K;class Y extends F{constructor(Ce,Le,Z){super(Ce,le.FILE_NOT_MODIFIED_SINCE,Z),this.stat=Le}}e.$ul=Y;var le;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(le||(e.FileOperationResult=le={})),e.$vl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$wl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$xl="files.associations",e.$yl="files.exclude",e.$zl="files.readonlyInclude",e.$Al="files.readonlyExclude",e.$Bl="files.readonlyFromPermissions";var _;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(_||(e.FileKind=_={})),e.$Cl="";function ge(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}async function se(oe,Ce){if(!Ce.hasProvider(R.URI.from({scheme:oe.scheme})))return new Promise(Le=>{const Z=Ce.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===oe.scheme&&q.added&&(Z.dispose(),Le())})})}class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(Ce){return(0,O.$gg)(Ce)||(Ce=0),Ce<ae.KB?(0,T.localize)(11293,null,Ce.toFixed(0)):Ce<ae.MB?(0,T.localize)(11294,null,(Ce/ae.KB).toFixed(2)):Ce<ae.GB?(0,T.localize)(11295,null,(Ce/ae.MB).toFixed(2)):Ce<ae.TB?(0,T.localize)(11296,null,(Ce/ae.GB).toFixed(2)):(0,T.localize)(11297,null,(Ce/ae.TB).toFixed(2))}}e.$Fl=ae;function $e(oe){const Ce=typeof oe=="string"||oe?.scheme===A.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===A.Schemas.file?1024*ae.MB:Ce?10*ae.MB:s.$p?50*ae.MB:1024*ae.MB}}),define(Oe[74],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class v{constructor(...P){this.a=new Map;for(const[O,R]of P)this.set(O,R)}set(P,O){const R=this.a.get(P);return this.a.set(P,O),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Ai=v}),define(Oe[170],Ne([1,0,10,13,4,73,167,3,74,171]),function(be,e,v,I,P,O,R,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;const A=!1;class y extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class a{constructor(o=new $.$Ai,c=!1,l,i=A){this.i=o,this.j=c,this.k=l,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Bi,this),this._globalGraph=i?l?._globalGraph??new R.$sr(r=>r):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Oc)(this.h),this.h.clear();for(const o of this.g)(0,P.$Nc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o,c){this.m();const l=this,i=new class extends a{dispose(){l.h.delete(i),super.dispose()}}(o,this.j,this,this.l);return this.h.add(i),c?.add(i),i}invokeFunction(o,...c){this.m();const l=d.traceInvocation(this.l,o);let i=!1;try{return o({get:t=>{if(i)throw(0,I.$7)("service accessor is only valid during the invocation of its target method");const g=this.s(t,l);if(!g)throw new Error(`[invokeFunction] unknown service '${t}'`);return g}},...c)}finally{i=!0,l.stop()}}createInstance(o,...c){this.m();let l,i;return o instanceof O.$zi?(l=d.traceCreation(this.l,o.ctor),i=this.o(o.ctor,o.staticArguments.concat(c),l)):(l=d.traceCreation(this.l,o),i=this.o(o,c,l)),l.stop(),i}o(o,c=[],l){const i=T._util.getServiceDependencies(o).sort((g,u)=>g.index-u.index),r=[];for(const g of i){const u=this.s(g.id,l);u||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${g.id}.`,!1),r.push(u)}const t=i.length>0?i[0].index:c.length;if(c.length!==t){console.trace(`[createInstance] First service dependency of ${o.name} at position ${t+1} conflicts with ${c.length} static arguments`);const g=t-c.length;g>0?c=c.concat(new Array(g)):c=c.slice(0,t)}return Reflect.construct(o,c.concat(r))}q(o,c){if(this.i.get(o)instanceof O.$zi)this.i.set(o,c);else if(this.k)this.k.q(o,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const c=this.i.get(o);return!c&&this.k?this.k.r(o):c}s(o,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const l=this.r(o);return l instanceof O.$zi?this.u(o,l,c.branch(o,!0)):(c.branch(o,!1),l)}u(o,c,l){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,c,l)}finally{this.t.delete(o)}}v(o,c,l){const i=new R.$sr(u=>u.id.toString());let r=0;const t=[{id:o,desc:c,_trace:l}],g=new Set;for(;t.length;){const u=t.pop();if(!g.has(String(u.id))){if(g.add(String(u.id)),i.lookupOrInsertNode(u),r++>1e3)throw new y(i);for(const m of T._util.getServiceDependencies(u.desc.ctor)){const p=this.r(m.id);if(p||this.y(`[createInstance] ${o} depends on ${m.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(u.id),String(m.id)),p instanceof O.$zi){const h={id:m.id,desc:p,_trace:u._trace.branch(m.id,!0)};i.insertEdge(u,h),t.push(h)}}}}for(;;){const u=i.roots();if(u.length===0){if(!i.isEmpty())throw new y(i);break}for(const{data:m}of u){if(this.r(m.id)instanceof O.$zi){const h=this.w(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this.q(m.id,h)}i.removeNode(m)}}return this.r(o)}w(o,c,l=[],i,r){if(this.i.get(o)instanceof O.$zi)return this.x(o,c,l,i,r,this.g);if(this.k)return this.k.w(o,c,l,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(o,c,l=[],i,r,t){if(i){const g=new a(void 0,this.j,this,this.l);g.c=String(o);const u=new Map,m=new v.$Vh(()=>{const p=g.o(c,l,r);for(const[h,E]of u){const D=p[h];if(typeof D=="function")for(const b of E)b.disposable=D.apply(p,b.listener)}return u.clear(),t.add(p),p});return new Proxy(Object.create(null),{get(p,h){if(!m.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let b=u.get(h);return b||(b=new s.$4c,u.set(h,b)),(C,f,w)=>{if(m.isInitialized)return m.value[h](C,f,w);{const M={listener:[C,f,w],disposable:void 0},N=b.push(M);return(0,P.$Rc)(()=>{N(),M.disposable?.dispose()})}}}if(h in p)return p[h];const E=m.value;let D=E[h];return typeof D!="function"||(D=D.bind(E),p[h]=D),D},set(p,h,E){return m.value[h]=E,!0},getPrototypeOf(p){return c.prototype}})}else{const g=this.o(c,l,r);return t.add(g),g}}y(o,c){if(c&&console.warn(o),this.j)throw new Error(o)}}e.$tr=a;var S;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(S||(S={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(S.None,null)}stop(){}branch(){return this}}}static traceInvocation(o,c){return o?new d(S.Invocation,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(o,c){return o?new d(S.Creation,c.name):d.c}static{this.f=0}constructor(o,c){this.type=o,this.name=c,this.g=Date.now(),this.h=[]}branch(o,c){const l=new d(S.Branch,o.toString());return this.h.push([o,c,l]),l}stop(){const o=Date.now()-this.g;d.f+=o;let c=!1;function l(r,t){const g=[],u=new Array(r+1).join("	");for(const[m,p,h]of t.h)if(p&&h){c=!0,g.push(`${u}CREATES -> ${m}`);const E=l(r+1,h);E&&g.push(E)}else g.push(`${u}uses -> ${m}`);return g.join(`
`)}const i=[`${this.type===S.Creation?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(o>2||c)&&d.all.add(i.join(`
`))}}e.$ur=d}),define(Oe[11],Ne([1,0,9,42,6,75,4,28,20,23,14,2,31,3]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$ak=e.LogLevel=e.$$j=e.$0j=void 0,e.$_j=n,e.log=c,e.$lk=D,e.$mk=b,e.$nk=k,e.$ok=C,v=We(v),e.$0j=(0,S.$Ci)("logService"),e.$$j=(0,S.$Ci)("loggerService");function d(){return new Date().toISOString()}function n(f){return(0,A.$gg)(f)}var o;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$ak=o.Info;function c(f,w,M){switch(w){case o.Trace:f.trace(M);break;case o.Debug:f.debug(M);break;case o.Info:f.info(M);break;case o.Warning:f.warn(M);break;case o.Error:f.error(M);break;case o.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function l(f,w=!1){let M="";for(let N=0;N<f.length;N++){let L=f[N];if(L instanceof Error&&(L=(0,I.$nj)(L,w)),typeof L=="object")try{L=JSON.stringify(L)}catch{}M+=(N>0?" ":"")+L}return M}class i extends R.$Tc{constructor(){super(...arguments),this.b=e.$ak,this.c=this.B(new P.$je),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==o.Off&&this.b<=w}}e.$ck=i;class r extends i{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...M){this.f(o.Trace)&&this.g(o.Trace,l([w,...M],!0))}debug(w,...M){this.f(o.Debug)&&this.g(o.Debug,l([w,...M]))}info(w,...M){this.f(o.Info)&&this.g(o.Info,l([w,...M]))}warn(w,...M){this.f(o.Warning)&&this.g(o.Warning,l([w,...M]))}error(w,...M){if(this.f(o.Error))if(w instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=w.stack,this.g(o.Error,l(N))}else this.g(o.Error,l([w,...M]))}flush(){}}e.$dk=r;class t extends i{constructor(w=e.$ak){super(),this.setLevel(w),this.g=!$.$j}trace(w,...M){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...M):console.log(`[main ${d()}]`,w,...M))}debug(w,...M){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...M):console.log(`[main ${d()}]`,w,...M))}info(w,...M){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...M):console.log(`[main ${d()}]`,w,...M))}warn(w,...M){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,w,...M):console.warn(`[main ${d()}]`,w,...M))}error(w,...M){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,w,...M):console.error(`[main ${d()}]`,w,...M))}flush(){}}e.$ek=t;class g extends i{constructor(w=e.$ak,M=!0){super(),this.g=M,this.setLevel(w)}trace(w,...M){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...M):console.log(w,...M))}debug(w,...M){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...M):console.log(w,...M))}info(w,...M){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...M):console.log(w,...M))}warn(w,...M){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...M):console.log(w,...M))}error(w,...M){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...M):console.error(w,...M))}flush(){}}e.$fk=g;class u extends i{constructor(w,M=e.$ak){super(),this.g=w,this.setLevel(M)}trace(w,...M){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(w),...M])}debug(w,...M){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(w),...M])}info(w,...M){this.f(o.Info)&&this.g.log(o.Info,[this.h(w),...M])}warn(w,...M){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(w),...M])}error(w,...M){this.f(o.Error)&&this.g.log(o.Error,[this.h(w),...M])}h(w){return typeof w=="string"?w:(0,I.$nj)(w,this.f(o.Trace))}flush(){}}e.$gk=u;class m extends i{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const M of this.g)M.setLevel(w);super.setLevel(w)}trace(w,...M){for(const N of this.g)N.trace(w,...M)}debug(w,...M){for(const N of this.g)N.debug(w,...M)}info(w,...M){for(const N of this.g)N.info(w,...M)}warn(w,...M){for(const N of this.g)N.warn(w,...M)}error(w,...M){for(const N of this.g)N.error(w,...M)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$hk=m;class p extends R.$Tc{constructor(w,M,N){if(super(),this.h=w,this.j=M,this.b=new T.$zc,this.c=this.B(new P.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$je),this.onDidChangeVisibility=this.g.event,N)for(const L of N)this.b.set(L.resource,{logger:void 0,info:L})}m(w){return(0,A.$cg)(w)?[...this.b.values()].find(M=>M.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,M){const N=this.n(w),L=(0,A.$cg)(w)?w:M?.id??(0,O.$qj)(N.toString()).toString(16);let W=this.b.get(N)?.logger;const G=M?.logLevel==="always"?o.Trace:M?.logLevel;W||(W=this.s(N,G??this.getLogLevel(N)??this.h,{...M,id:L}));const F={logger:W,info:{resource:N,id:L,logLevel:G,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(F.info),this.b.set(N,F),W}n(w){return(0,A.$cg)(w)?(0,s.$dh)(this.j,`${w}.log`):w}setLogLevel(w,M){if(y.URI.isUri(w)){const N=w,L=M,W=this.b.get(N);W&&L!==W.info.logLevel&&(W.info.logLevel=L===this.h?void 0:L,W.logger?.setLevel(L),this.b.set(W.info.resource,W),this.f.fire([N,L]))}else{this.h=w;for(const[N,L]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&L.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,M){const N=this.m(w);N&&M!==!N.info.hidden&&(N.info.hidden=!M,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,M]))}getLogLevel(w){let M;return w&&(M=this.b.get(w)?.info.logLevel),M??this.h}registerLogger(w){const M=this.b.get(w.resource);M?M.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const M=this.b.get(w);M&&(M.logger&&M.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ik=p;class h{constructor(){this.onDidChangeLogLevel=new P.$je().event}setLevel(w){}getLevel(){return o.Info}trace(w,...M){}debug(w,...M){}info(w,...M){}warn(w,...M){}error(w,...M){}critical(w,...M){}dispose(){}flush(){}}e.$jk=h;class E extends h{}e.$kk=E;function D(f){if(f.verbose)return o.Trace;if(typeof f.logLevel=="string"){const w=C(f.logLevel.toLowerCase());if(w!==void 0)return w}return e.$ak}function b(f){switch(f){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function k(f){switch(f){case o.Trace:return{original:"Trace",value:v.localize(11225,null)};case o.Debug:return{original:"Debug",value:v.localize(11226,null)};case o.Info:return{original:"Info",value:v.localize(11227,null)};case o.Warning:return{original:"Warning",value:v.localize(11228,null)};case o.Error:return{original:"Error",value:v.localize(11229,null)};case o.Off:return{original:"Off",value:v.localize(11230,null)}}}function C(f){switch(f){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$pk=new a.$Tj("logLevel",b(o.Info))}),define(Oe[172],Ne([1,0,4,11]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CR=void 0;class P extends v.$Tc{constructor(R,T=[]){super(),this.a=new I.$hk([R,...T]),this.B(R.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...T){this.a.trace(R,...T)}debug(R,...T){this.a.debug(R,...T)}info(R,...T){this.a.info(R,...T)}warn(R,...T){this.a.warn(R,...T)}error(R,...T){this.a.error(R,...T)}flush(){this.a.flush()}}e.$CR=P});var ni=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[107],Ne([1,0,35,9,3]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Du=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,v=ni(v);var O;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var R;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function($){function s(d,n){return n-d}$.compare=s;const A=Object.create(null);A[$.Error]=(0,I.localize)(11222,null),A[$.Warning]=(0,I.localize)(11223,null),A[$.Info]=(0,I.localize)(11224,null);function y(d){return A[d]||""}$.toString=y;function a(d){switch(d){case v.default.Error:return $.Error;case v.default.Warning:return $.Warning;case v.default.Info:return $.Info;case v.default.Ignore:return $.Hint}}$.fromSeverity=a;function S(d){switch(d){case $.Error:return v.default.Error;case $.Warning:return v.default.Warning;case $.Info:return v.default.Info;case $.Hint:return v.default.Ignore}}$.toSeverity=S}(R||(e.MarkerSeverity=R={}));var T;(function($){const s="";function A(a){return y(a,!0)}$.makeKey=A;function y(a,S){const d=[s];return a.source?d.push(a.source.replace("\xA6","\\\xA6")):d.push(s),a.code?typeof a.code=="string"?d.push(a.code.replace("\xA6","\\\xA6")):d.push(a.code.value.replace("\xA6","\\\xA6")):d.push(s),a.severity!==void 0&&a.severity!==null?d.push(R.toString(a.severity)):d.push(s),a.message&&S?d.push(a.message.replace("\xA6","\\\xA6")):d.push(s),a.startLineNumber!==void 0&&a.startLineNumber!==null?d.push(a.startLineNumber.toString()):d.push(s),a.startColumn!==void 0&&a.startColumn!==null?d.push(a.startColumn.toString()):d.push(s),a.endLineNumber!==void 0&&a.endLineNumber!==null?d.push(a.endLineNumber.toString()):d.push(s),a.endColumn!==void 0&&a.endColumn!==null?d.push(a.endColumn.toString()):d.push(s),d.push(s),d.join("\xA6")}$.makeKeyOptionalMessage=y})(T||(e.IMarkerData=T={})),e.$Du=(0,P.$Ci)("markerService")});var ni=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[173],Ne([1,0,6,35,3]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$qw=e.Severity=void 0,e.$rw=T,I=ni(I),e.Severity=I.default,e.$qw=(0,P.$Ci)("notificationService");var O;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var R;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function T(y){if(y){const a=y;return typeof a.id=="string"&&typeof a.label=="string"}return!1}var $;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class s{constructor(){this.progress=new A,this.onDidClose=v.Event.None,this.onDidChangeVisibility=v.Event.None}updateSeverity(a){}updateMessage(a){}updateActions(a){}close(){}}e.$sw=s;class A{infinite(){}done(){}total(a){}worked(a){}}e.$tw=A}),define(Oe[108],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$qk=(0,v.$Ci)("productService"),e.$rk="vscode://schemas/vscode-product"});var Ge=this&&this.__decorate||function(be,e,v,I){var P=arguments.length,O=P<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,v):I,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(be,e,v,I);else for(var T=be.length-1;T>=0;T--)(R=be[T])&&(O=(P<3?R(O):P>3?R(e,v,O):R(e,v))||O);return P>3&&O&&Object.defineProperty(e,v,O),O},Ve=this&&this.__param||function(be,e){return function(v,I){e(v,I,be)}};define(Oe[76],Ne([1,0,10,21,4,3]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aw=e.$zw=e.$yw=e.$xw=e.$ww=e.$vw=e.ProgressLocation=e.$uw=void 0,e.$uw=(0,O.$Ci)("progressService");var R;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$vw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(a){this.b=a}report(a){this.a=a,this.b(this.a)}}e.$ww=T;class ${get value(){return this.a}constructor(a){this.e=a}report(a){this.b?this.b.push(a):this.b=[a],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const a=this.b.shift();this.a=a,await this.e(this.a)}}finally{this.c=!1;const a=this.d;this.d=void 0,a?.()}}drain(){return this.c?new Promise(a=>{const S=this.d;this.d=()=>{S?.(),a()}}):Promise.resolve()}}e.$xw=$;let s=class extends P.$Tc{constructor(a,S){super(),this.a=new v.$Zh,S.withProgress(a,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,P.$Rc)(()=>this.a.complete()))}report(a){this.b?this.b.report(a):this.c=a}};e.$yw=s,e.$yw=s=Ge([Ve(1,e.$uw)],s);class A extends P.$Tc{constructor(a){super(),this.g=a,this.a=0,this.b=this.B(new P.$Sc)}start(a){this.stop();const S=++this.a,d=new I.$ue;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},a),this.b.add((0,P.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Rc)(()=>d.cancel())),this.b.add((0,P.$Rc)(()=>this.c?this.c.done():void 0)),{id:S,token:d.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(a){this.a===a&&this.b.clear()}}e.$zw=A,e.$Aw=(0,O.$Ci)("editorProgressService")}),define(Oe[30],Ne([1,0,61,14]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,v=We(v),I=We(I);class P{constructor(){this.a=new Map}add(R,T){v.ok(I.$cg(R)),v.ok(I.$eg(T)),v.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,T)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$oo=new P}),define(Oe[77],Ne([1,0,6,137,30]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,P=We(P),e.$po={JSONContribution:"base.contributions.json"};function O($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class R{constructor(){this.b=new v.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(s,A){this.a[O(s)]=A,this.b.fire(s)}notifySchemaChanged(s){this.b.fire(s)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(s){const A=this.a[s];return A?(0,I.$5j)(A):void 0}hasSchemaContent(s){return!!this.a[s]}}const T=new R;P.$oo.add(e.$po.JSONContribution,T)}),define(Oe[53],Ne([1,0,17,6,14,9,43,77,30]),function(be,e,v,I,P,O,R,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.ConfigurationScope=e.$to=e.EditPresentationTypes=void 0,e.$Eo=n,e.$Fo=o,e.$Go=c,e.$Ho=i,e.$Io=r,e.$Jo=t,e.$Ko=g,P=We(P),O=We(O);var s;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(s||(e.EditPresentationTypes=s={})),e.$to={Configuration:"base.contributions.configuration"};var A;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao="vscode://schemas/settings/resourceLanguage",e.$Bo="vscode://schemas/settings/configurationDefaults";const y=$.$oo.as(T.$po.JSONContribution);class a{constructor(){this.a=[],this.i=new Set,this.j=new I.$je,this.onDidSchemaChange=this.j.event,this.k=new I.$je,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:O.localize(11518,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},y.registerSchema(e.$Ao,this.h),this.z()}registerConfiguration(m,p=!0){this.registerConfigurations([m],p)}registerConfigurations(m,p=!0){const h=new Set;this.r(m,p,h),y.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:h})}deregisterConfigurations(m){const p=new Set;this.s(m,p),y.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:p})}updateConfigurations({add:m,remove:p}){const h=new Set;this.s(p,h),this.r(m,!1,h),y.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:h})}registerDefaultConfigurations(m){const p=new Set;this.l(m,p),this.j.fire(),this.k.fire({properties:p,defaultsOverrides:!0})}l(m,p){this.a.push(...m);const h=[];for(const{overrides:E,source:D}of m)for(const b in E){p.add(b);const k=this.b.get(b)??this.b.set(b,{configurationDefaultOverrides:[]}).get(b),C=E[b];if(k.configurationDefaultOverrides.push({value:C,source:D}),e.$Do.test(b)){const f=this.o(b,C,D,k.configurationDefaultOverrideValue);if(!f)continue;k.configurationDefaultOverrideValue=f,this.n(b,f,D),h.push(...n(b))}else{const f=this.p(b,C,D,k.configurationDefaultOverrideValue);if(!f)continue;k.configurationDefaultOverrideValue=f;const w=this.e[b];w&&(this.A(b,w),this.w(b,w))}}this.q(h)}deregisterDefaultConfigurations(m){const p=new Set;this.m(m,p),this.j.fire(),this.k.fire({properties:p,defaultsOverrides:!0})}m(m,p){for(const h of m){const E=this.a.indexOf(h);E!==-1&&this.a.splice(E,1)}for(const{overrides:h,source:E}of m)for(const D in h){const b=this.b.get(D);if(!b)continue;const k=b.configurationDefaultOverrides.findIndex(C=>E?C.source?.id===E.id:C.value===h[D]);if(k!==-1){if(b.configurationDefaultOverrides.splice(k,1),b.configurationDefaultOverrides.length===0&&this.b.delete(D),e.$Do.test(D)){let C;for(const f of b.configurationDefaultOverrides)C=this.o(D,f.value,f.source,C);C&&!P.$pg(C.value)?(b.configurationDefaultOverrideValue=C,this.n(D,C,E)):(this.b.delete(D),delete this.e[D],delete this.c.properties[D])}else{let C;for(const w of b.configurationDefaultOverrides)C=this.p(D,w.value,w.source,C);b.configurationDefaultOverrideValue=C;const f=this.e[D];f&&(this.A(D,f),this.w(D,f))}p.add(D)}}this.y()}n(m,p,h){const E={type:"object",default:p.value,description:O.localize(11519,null,(0,R.$gj)(m)),$ref:e.$Ao,defaultDefaultValue:p.value,source:h,defaultValueSource:h};this.e[m]=E,this.c.properties[m]=E}o(m,p,h,E){const D=E?.value||{},b=E?.source??new Map;if(!(b instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const k of Object.keys(p)){const C=p[k];if(P.$eg(C)&&(P.$jg(D[k])||P.$eg(D[k]))){if(D[k]={...D[k]??{},...C},h)for(const w in C)b.set(`${k}.${w}`,h)}else D[k]=C,h?b.set(k,h):b.delete(k)}return{value:D,source:b}}p(m,p,h,E){const D=this.e[m],b=E?.value??D?.defaultDefaultValue;let k=h;if(P.$eg(p)&&(D!==void 0&&D.type==="object"||D===void 0&&(P.$jg(b)||P.$eg(b)))){if(k=E?.source??new Map,!(k instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const f in p)h&&k.set(`${m}.${f}`,h);p={...P.$eg(b)?b:{},...p}}return{value:p,source:k}}deltaConfiguration(m){let p=!1;const h=new Set;m.removedDefaults&&(this.m(m.removedDefaults,h),p=!0),m.addedDefaults&&(this.l(m.addedDefaults,h),p=!0),m.removedConfigurations&&this.s(m.removedConfigurations,h),m.addedConfigurations&&this.r(m.addedConfigurations,!1,h),this.j.fire(),this.k.fire({properties:h,defaultsOverrides:p})}notifyConfigurationSchemaUpdated(...m){this.j.fire()}registerOverrideIdentifiers(m){this.q(m),this.j.fire()}q(m){for(const p of m)this.i.add(p);this.y()}r(m,p,h){m.forEach(E=>{this.u(E,p,E.extensionInfo,E.restrictedProperties,void 0,h),this.d.push(E),this.v(E)})}s(m,p){const h=E=>{if(E.properties)for(const D in E.properties){p.add(D);const b=this.e[D];b?.policy?.name&&this.f.delete(b.policy.name),delete this.e[D],this.x(D,E.properties[D])}E.allOf?.forEach(D=>h(D))};for(const E of m){h(E);const D=this.d.indexOf(E);D!==-1&&this.d.splice(D,1)}}u(m,p=!0,h,E,D=A.WINDOW,b){D=P.$lg(m.scope)?D:m.scope;const k=m.properties;if(k)for(const f in k){const w=k[f];if(p&&i(f,w)){delete k[f];continue}if(w.source=h,w.defaultDefaultValue=k[f].default,this.A(f,w),e.$Do.test(f)?w.scope=void 0:(w.scope=P.$lg(w.scope)?D:w.scope,w.restricted=P.$lg(w.restricted)?!!E?.includes(f):w.restricted),k[f].hasOwnProperty("included")&&!k[f].included){this.g[f]=k[f],delete k[f];continue}else this.e[f]=k[f],k[f].policy?.name&&this.f.set(k[f].policy.name,f);!k[f].deprecationMessage&&k[f].markdownDeprecationMessage&&(k[f].deprecationMessage=k[f].markdownDeprecationMessage),b.add(f)}const C=m.allOf;if(C)for(const f of C)this.u(f,p,h,E,D,b)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const m=new Map;for(const[p,h]of this.b)h.configurationDefaultOverrideValue&&m.set(p,h.configurationDefaultOverrideValue);return m}v(m){const p=h=>{const E=h.properties;if(E)for(const b in E)this.w(b,E[b]);h.allOf?.forEach(p)};p(m)}w(m,p){switch(e.$uo.properties[m]=p,p.scope){case A.APPLICATION:e.$vo.properties[m]=p;break;case A.MACHINE:e.$wo.properties[m]=p;break;case A.MACHINE_OVERRIDABLE:e.$xo.properties[m]=p;break;case A.WINDOW:e.$yo.properties[m]=p;break;case A.RESOURCE:e.$zo.properties[m]=p;break;case A.LANGUAGE_OVERRIDABLE:e.$zo.properties[m]=p,this.h.properties[m]=p;break}}x(m,p){switch(delete e.$uo.properties[m],p.scope){case A.APPLICATION:delete e.$vo.properties[m];break;case A.MACHINE:delete e.$wo.properties[m];break;case A.MACHINE_OVERRIDABLE:delete e.$xo.properties[m];break;case A.WINDOW:delete e.$yo.properties[m];break;case A.RESOURCE:case A.LANGUAGE_OVERRIDABLE:delete e.$zo.properties[m],delete this.h.properties[m];break}}y(){for(const m of this.i.values()){const p=`[${m}]`,h={type:"object",description:O.localize(11520,null),errorMessage:O.localize(11521,null),$ref:e.$Ao};this.A(p,h),e.$uo.properties[p]=h,e.$vo.properties[p]=h,e.$wo.properties[p]=h,e.$xo.properties[p]=h,e.$yo.properties[p]=h,e.$zo.properties[p]=h}}z(){const m={type:"object",description:O.localize(11522,null),errorMessage:O.localize(11523,null),$ref:e.$Ao};e.$uo.patternProperties[e.$Co]=m,e.$vo.patternProperties[e.$Co]=m,e.$wo.patternProperties[e.$Co]=m,e.$xo.patternProperties[e.$Co]=m,e.$yo.patternProperties[e.$Co]=m,e.$zo.patternProperties[e.$Co]=m,this.j.fire()}A(m,p){const h=this.b.get(m)?.configurationDefaultOverrideValue;let E,D;h&&(!p.disallowConfigurationDefault||!h.source)&&(E=h.value,D=h.source),P.$jg(E)&&(E=p.defaultDefaultValue,D=void 0),P.$jg(E)&&(E=c(p.type)),p.default=E,p.defaultValueSource=D}}const S="\\[([^\\]]+)\\]",d=new RegExp(S,"g");e.$Co=`^(${S})+$`,e.$Do=new RegExp(e.$Co);function n(u){const m=[];if(e.$Do.test(u)){let p=d.exec(u);for(;p?.length;){const h=p[1].trim();h&&m.push(h),p=d.exec(u)}}return(0,v.$Lb)(m)}function o(u){return u.reduce((m,p)=>`${m}[${p}]`,"")}function c(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const l=new a;$.$oo.add(e.$to.Configuration,l);function i(u,m){return u.trim()?e.$Do.test(u)?O.localize(11525,null,u):l.getConfigurationProperties()[u]!==void 0?O.localize(11526,null,u):m.policy?.name&&l.getPolicyConfigurations().get(m.policy?.name)!==void 0?O.localize(11527,null,u,m.policy?.name,l.getPolicyConfigurations().get(m.policy?.name)):null:O.localize(11524,null)}function r(){const u=[],m=l.getConfigurationProperties();for(const p of Object.keys(m))u.push([p,m[p].scope]);return u.push(["launch",A.RESOURCE]),u.push(["task",A.RESOURCE]),u}function t(u){const m={};for(const p of u){const h=p.properties;if(P.$eg(h))for(const E in h)m[E]=h[E];p.allOf&&Object.assign(m,t(p.allOf))}return m}function g(u){switch(u){case"application":return A.APPLICATION;case"machine":return A.MACHINE;case"resource":return A.RESOURCE;case"machine-overridable":return A.MACHINE_OVERRIDABLE;case"language-overridable":return A.LANGUAGE_OVERRIDABLE;default:return A.WINDOW}}}),define(Oe[174],Ne([1,0,17,6,136,4,28,25,14,2,43,53,29,30]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0,e.$Po=r,v=We(v),P=We(P),T=We(T),$=We($);function d(m){return Object.isFrozen(m)?m:T.$co(m)}class n{static createEmptyModel(p){return new n({},[],[],void 0,p)}constructor(p,h,E,D,b){this.b=p,this.c=h,this.d=E,this.raw=D,this.f=b,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const p=this.raw.map(h=>{if(h instanceof n)return h;const E=new o("",this.f);return E.parseRaw(h),E.configurationModel});this.g=p.reduce((h,E)=>E===h?E:h.merge(E),p[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(p){return p?(0,A.$ej)(this.contents,p):this.contents}inspect(p,h){const E=this;return{get value(){return d(E.rawConfiguration.getValue(p))},get override(){return h?d(E.rawConfiguration.getOverrideValue(p,h)):void 0},get merged(){return d(h?E.rawConfiguration.override(h).getValue(p):E.rawConfiguration.getValue(p))},get overrides(){const D=[];for(const{contents:b,identifiers:k,keys:C}of E.rawConfiguration.overrides){const f=new n(b,C,[],void 0,E.f).getValue(p);f!==void 0&&D.push({identifiers:k,value:f})}return D.length?d(D):void 0}}}getOverrideValue(p,h){const E=this.j(h);return E?p?(0,A.$ej)(E,p):E:void 0}getKeysForOverrideIdentifier(p){const h=[];for(const E of this.overrides)E.identifiers.includes(p)&&h.push(...E.keys);return v.$Lb(h)}getAllOverrideIdentifiers(){const p=[];for(const h of this.overrides)p.push(...h.identifiers);return v.$Lb(p)}override(p){let h=this.a.get(p);return h||(h=this.h(p),this.a.set(p,h)),h}merge(...p){const h=T.$bo(this.contents),E=T.$bo(this.overrides),D=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const k of p)if(b.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.i(h,k.contents);for(const C of k.overrides){const[f]=E.filter(w=>v.$tb(w.identifiers,C.identifiers));f?(this.i(f.contents,C.contents),f.keys.push(...C.keys),f.keys=v.$Lb(f.keys)):E.push(T.$bo(C))}for(const C of k.keys)D.indexOf(C)===-1&&D.push(C)}return new n(h,D,E,b.every(k=>k instanceof n)?void 0:b,this.f)}h(p){const h=this.j(p);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const E={};for(const D of v.$Lb([...Object.keys(this.contents),...Object.keys(h)])){let b=this.contents[D];const k=h[D];k&&(typeof b=="object"&&typeof k=="object"?(b=T.$bo(b),this.i(b,k)):b=k),E[D]=b}return new n(E,this.keys,this.overrides,void 0,this.f)}i(p,h){for(const E of Object.keys(h)){if(E in p&&$.$eg(p[E])&&$.$eg(h[E])){this.i(p[E],h[E]);continue}p[E]=T.$bo(h[E])}}j(p){let h=null,E=null;const D=b=>{b&&(E?this.i(E,b):E=T.$bo(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===p?h=b.contents:b.identifiers.includes(p)&&D(b.contents);return D(h),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(p,h){this.k(p,h,!0)}setValue(p,h){this.k(p,h,!1)}removeValue(p){const h=this.keys.indexOf(p);h!==-1&&(this.keys.splice(h,1),(0,A.$dj)(this.contents,p),y.$Do.test(p)&&this.overrides.splice(this.overrides.findIndex(E=>v.$tb(E.identifiers,(0,y.$Eo)(p))),1))}k(p,h,E){if((0,A.$cj)(this.contents,p,h,D=>this.f.error(D)),E=E||this.keys.indexOf(p)===-1,E&&this.keys.push(p),y.$Do.test(p)){const D=(0,y.$Eo)(p),b={identifiers:D,keys:Object.keys(this.contents[p]),contents:(0,A.$bj)(this.contents[p],C=>this.f.error(C))},k=this.overrides.findIndex(C=>v.$tb(C.identifiers,D));k!==-1?this.overrides[k]=b:this.overrides.push(b)}}}e.$Lo=n;class o{constructor(p,h){this.f=p,this.g=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||n.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(p,h){if(!$.$lg(p)){const E=this.h(p);this.parseRaw(E,h)}}reparse(p){this.a&&this.parseRaw(this.a,p)}parseRaw(p,h){this.a=p;const{contents:E,keys:D,overrides:b,restricted:k,hasExcludedProperties:C}=this.i(p,h);this.b=new n(E,D,b,C?[p]:void 0,this.g),this.c=k||[]}h(p){let h={},E=null,D=[];const b=[],k=[];function C(w){Array.isArray(D)?D.push(w):E!==null&&(D[E]=w)}const f={onObjectBegin:()=>{const w={};C(w),b.push(D),D=w,E=null},onObjectProperty:w=>{E=w},onObjectEnd:()=>{D=b.pop()},onArrayBegin:()=>{const w=[];C(w),b.push(D),D=w,E=null},onArrayEnd:()=>{D=b.pop()},onLiteralValue:C,onError:(w,M,N)=>{k.push({error:w,offset:M,length:N})}};if(p)try{P.$3n(p,f),h=D[0]||{}}catch(w){this.g.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return h}i(p,h){const E=S.$oo.as(y.$to.Configuration).getConfigurationProperties(),D=this.j(p,E,!0,h);p=D.raw;const b=(0,A.$bj)(p,f=>this.g.error(`Conflict in settings file ${this.f}: ${f}`)),k=Object.keys(p),C=this.l(p,f=>this.g.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:b,keys:k,overrides:C,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(p,h,E,D){let b=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:p,restricted:[],hasExcludedProperties:b};const k={},C=[];for(const f in p)if(y.$Do.test(f)&&E){const w=this.j(p[f],h,!1,D);k[f]=w.raw,b=b||w.hasExcludedProperties,C.push(...w.restricted)}else{const w=h[f],M=w?typeof w.scope<"u"?w.scope:y.ConfigurationScope.WINDOW:void 0;w?.restricted&&C.push(f),!D.exclude?.includes(f)&&(D.include?.includes(f)||(M===void 0||D.scopes===void 0||D.scopes.includes(M))&&!(D.skipRestricted&&w?.restricted))?k[f]=p[f]:b=!0}return{raw:k,restricted:C,hasExcludedProperties:b}}l(p,h){const E=[];for(const D of Object.keys(p))if(y.$Do.test(D)){const b={};for(const k in p[D])b[k]=p[D][k];E.push({identifiers:(0,y.$Eo)(D),keys:Object.keys(b),contents:(0,A.$bj)(b,h)})}return E}}e.$Mo=o;class c extends O.$Tc{constructor(p,h,E,D,b){super(),this.c=p,this.f=h,this.g=D,this.h=b,this.b=this.B(new I.$je),this.onDidChange=this.b.event,this.a=new o(this.c.toString(),b),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(I.Event.any(I.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),I.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(a.FileOperation.CREATE)||k.isOperation(a.FileOperation.COPY)||k.isOperation(a.FileOperation.DELETE)||k.isOperation(a.FileOperation.WRITE))&&E.isEqual(k.resource,p)))(()=>this.b.fire()))}async loadConfiguration(){try{const p=await this.g.readFile(this.c);return this.a.parse(p.value.toString()||"{}",this.f),this.a.configurationModel}catch{return n.createEmptyModel(this.h)}}reparse(p){return p&&(this.f=p),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$No=c;class l{constructor(p,h,E,D,b,k,C,f,w,M,N,L,W){this.a=p,this.b=h,this.c=E,this.overrideIdentifiers=D,this.d=b,this.f=k,this.g=C,this.h=f,this.i=w,this.j=M,this.k=N,this.l=L,this.m=W}get value(){return d(this.c)}n(p){return p?.value!==void 0||p?.override!==void 0||p?.overrides!==void 0?p:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(p,h,E,D,b,k,C,f,w,M){this.j=p,this.l=h,this.m=E,this.n=D,this.p=b,this.q=k,this.r=C,this.s=f,this.t=w,this.u=M,this.h=null,this.i=new R.$zc,this.v=null}getValue(p,h,E){return this.w(p,h,E).getValue(p)}updateValue(p,h,E={}){let D;E.resource?(D=this.t.get(E.resource),D||(D=n.createEmptyModel(this.u),this.t.set(E.resource,D))):D=this.s,h===void 0?D.removeValue(p):D.setValue(p,h),E.resource||(this.h=null)}inspect(p,h,E){const D=this.w(p,h,E),b=this.A(h.resource,E),k=h.resource?this.t.get(h.resource)||this.s:this.s,C=new Set;for(const f of D.overrides)for(const w of f.identifiers)D.getOverrideValue(p,w)!==void 0&&C.add(w);return new l(p,h,D.getValue(p),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.q:void 0,b||void 0,k)}keys(p){const h=this.A(void 0,p);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(p){this.j=p,this.h=null,this.i.clear()}updatePolicyConfiguration(p){this.l=p}updateApplicationConfiguration(p){this.m=p,this.h=null,this.i.clear()}updateLocalUserConfiguration(p){this.n=p,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(p){this.p=p,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(p){this.q=p,this.h=null,this.i.clear()}updateFolderConfiguration(p,h){this.r.set(p,h),this.i.delete(p)}deleteFolderConfiguration(p){this.folderConfigurations.delete(p),this.i.delete(p)}compareAndUpdateDefaultConfiguration(p,h){const E=[];if(!h){const{added:D,updated:b,removed:k}=g(this.j,p);h=[...D,...b,...k]}for(const D of h)for(const b of(0,y.$Eo)(D)){const k=this.j.getKeysForOverrideIdentifier(b),C=p.getKeysForOverrideIdentifier(b),f=[...C.filter(w=>k.indexOf(w)===-1),...k.filter(w=>C.indexOf(w)===-1),...k.filter(w=>!T.$fo(this.j.override(b).getValue(w),p.override(b).getValue(w)))];E.push([b,f])}return this.updateDefaultConfiguration(p),{keys:h,overrides:E}}compareAndUpdatePolicyConfiguration(p){const{added:h,updated:E,removed:D}=g(this.l,p),b=[...h,...E,...D];return b.length&&this.updatePolicyConfiguration(p),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(p){const{added:h,updated:E,removed:D,overrides:b}=g(this.applicationConfiguration,p),k=[...h,...E,...D];return k.length&&this.updateApplicationConfiguration(p),{keys:k,overrides:b}}compareAndUpdateLocalUserConfiguration(p){const{added:h,updated:E,removed:D,overrides:b}=g(this.localUserConfiguration,p),k=[...h,...E,...D];return k.length&&this.updateLocalUserConfiguration(p),{keys:k,overrides:b}}compareAndUpdateRemoteUserConfiguration(p){const{added:h,updated:E,removed:D,overrides:b}=g(this.remoteUserConfiguration,p),k=[...h,...E,...D];return k.length&&this.updateRemoteUserConfiguration(p),{keys:k,overrides:b}}compareAndUpdateWorkspaceConfiguration(p){const{added:h,updated:E,removed:D,overrides:b}=g(this.workspaceConfiguration,p),k=[...h,...E,...D];return k.length&&this.updateWorkspaceConfiguration(p),{keys:k,overrides:b}}compareAndUpdateFolderConfiguration(p,h){const E=this.folderConfigurations.get(p),{added:D,updated:b,removed:k,overrides:C}=g(E,h),f=[...D,...b,...k];return(f.length||!E)&&this.updateFolderConfiguration(p,h),{keys:f,overrides:C}}compareAndDeleteFolderConfiguration(p){const h=this.folderConfigurations.get(p);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(p);const{added:E,updated:D,removed:b,overrides:k}=g(h,void 0);return{keys:[...E,...D,...b],overrides:k}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(p,h,E){let D=this.x(h,E);return h.overrideIdentifier&&(D=D.override(h.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(p)!==void 0&&(D=D.merge(this.l)),D}x({resource:p},h){let E=this.y();if(h&&p){const D=h.getFolder(p);D&&(E=this.z(D.uri)||E);const b=this.t.get(p);b&&(E=E.merge(b))}return E}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(p){let h=this.i.get(p);if(!h){const E=this.y(),D=this.r.get(p);D?(h=E.merge(D),this.i.set(p,h)):h=E}return h}A(p,h){if(h&&p){const E=h.getFolder(p);if(E)return this.r.get(E.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((p,h)=>{const{contents:E,overrides:D,keys:b}=this.r.get(h);return p.push([h,{contents:E,overrides:D,keys:b}]),p},[])}}allKeys(){const p=new Set;return this.j.keys.forEach(h=>p.add(h)),this.userConfiguration.keys.forEach(h=>p.add(h)),this.q.keys.forEach(h=>p.add(h)),this.r.forEach(h=>h.keys.forEach(E=>p.add(E))),[...p.values()]}B(){const p=new Set;return this.j.getAllOverrideIdentifiers().forEach(h=>p.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>p.add(h)),this.q.getAllOverrideIdentifiers().forEach(h=>p.add(h)),this.r.forEach(h=>h.getAllOverrideIdentifiers().forEach(E=>p.add(E))),[...p.values()]}D(p){const h=new Set;return this.j.getKeysForOverrideIdentifier(p).forEach(E=>h.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(p).forEach(E=>h.add(E)),this.q.getKeysForOverrideIdentifier(p).forEach(E=>h.add(E)),this.r.forEach(E=>E.getKeysForOverrideIdentifier(p).forEach(D=>h.add(D))),[...h.values()]}static parse(p,h){const E=this.E(p.defaults,h),D=this.E(p.policy,h),b=this.E(p.application,h),k=this.E(p.user,h),C=this.E(p.workspace,h),f=p.folders.reduce((w,M)=>(w.set(s.URI.revive(M[0]),this.E(M[1],h)),w),new R.$zc);return new i(E,D,b,k,n.createEmptyModel(h),C,f,n.createEmptyModel(h),new R.$zc,h)}static E(p,h){return new n(p.contents,p.keys,p.overrides,void 0,h)}}e.$Oo=i;function r(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const p=new Set,h=new Map;for(const D of m)D.keys.forEach(b=>p.add(b)),D.overrides.forEach(([b,k])=>{const C=(0,R.$wc)(h,b,new Set);k.forEach(f=>C.add(f))});const E=[];return h.forEach((D,b)=>E.push([b,[...D.values()]])),{keys:[...p.values()],overrides:E}}class t{constructor(p,h,E,D,b){this.change=p,this.f=h,this.g=E,this.h=D,this.i=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const k of p.keys)this.affectedKeys.add(k);for(const[,k]of p.overrides)for(const C of k)this.affectedKeys.add(C);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(p,h){const E=this.a+p,D=this.d.indexOf(E);if(D<0)return!1;const b=D+E.length;if(b>=this.d.length)return!1;const k=this.d.charCodeAt(b);if(k!==this.b&&k!==this.c)return!1;if(h){const C=this.previousConfiguration?this.previousConfiguration.getValue(p,h,this.f?.workspace):void 0,f=this.g.getValue(p,h,this.h);return!T.$fo(C,f)}return!0}}e.$Qo=t;function g(m,p){const{added:h,removed:E,updated:D}=u(p?.rawConfiguration,m?.rawConfiguration),b=[],k=m?.getAllOverrideIdentifiers()||[],C=p?.getAllOverrideIdentifiers()||[];if(p){const f=C.filter(w=>!k.includes(w));for(const w of f)b.push([w,p.getKeysForOverrideIdentifier(w)])}if(m){const f=k.filter(w=>!C.includes(w));for(const w of f)b.push([w,m.getKeysForOverrideIdentifier(w)])}if(p&&m){for(const f of k)if(C.includes(f)){const w=u({contents:m.getOverrideValue(void 0,f)||{},keys:m.getKeysForOverrideIdentifier(f)},{contents:p.getOverrideValue(void 0,f)||{},keys:p.getKeysForOverrideIdentifier(f)});b.push([f,[...w.added,...w.removed,...w.updated]])}}return{added:h,removed:E,updated:D,overrides:b}}function u(m,p){const h=m?p?m.keys.filter(b=>p.keys.indexOf(b)===-1):[...m.keys]:[],E=p?m?p.keys.filter(b=>m.keys.indexOf(b)===-1):[...p.keys]:[],D=[];if(m&&p){for(const b of p.keys)if(m.keys.indexOf(b)!==-1){const k=(0,A.$ej)(p.contents,b),C=(0,A.$ej)(m.contents,b);T.$fo(k,C)||D.push(b)}}return{added:h,removed:E,updated:D}}}),define(Oe[109],Ne([1,0,13,3]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.RemoteAuthorityResolverErrorCode=e.$Ql=e.$Pl=e.RemoteConnectionType=e.$Ol=void 0,e.$Sl=s,e.$Ol=(0,I.$Ci)("remoteAuthorityResolverService");var P;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class O{constructor(y){this.id=y,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Pl=O;class R{constructor(y,a){this.host=y,this.port=a,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ql=R;var T;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class $ extends v.$ab{static isNotAvailable(y){return y instanceof $&&y._code===T.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof $&&y._code===T.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof $&&y._code===T.NoResolverFound}static isInvalidAuthority(y){return y instanceof $&&y._code===T.InvalidAuthority}static isHandled(y){return y instanceof $&&y.isHandled}constructor(y,a=T.Unknown,S){super(y),this._message=y,this._code=a,this._detail=S,this.isHandled=a===T.NotAvailable&&S===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Rl=$;function s(A){const y=A.indexOf("+");return y===-1?A:A.substring(0,y)}}),define(Oe[62],Ne([1,0,15]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=I,e.$fn=P,e.$gn=O,e.$hn=R;function I($){return $.scheme===v.Schemas.vscodeRemote?$.authority:void 0}function P($){if(!$)return;const s=$.indexOf("+");return s<0?$:$.substr(0,s)}function O($){const{host:s,port:A}=T($);if(typeof A>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:s,port:A}}function R($,s){let{host:A,port:y}=T($);return typeof y>"u"&&(y=s),{host:A,port:y}}function T($){const s=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(s)return{host:s[1],port:parseInt(s[2],10)};const A=$.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const y=$.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:$,port:void 0}}}),define(Oe[18],Ne([1,0,12,3,62]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$qn=e.$pn=e.$on=e.TargetPlatform=e.ExtensionType=e.$nn=e.$ln=e.$kn=e.$jn=e.$in=void 0,e.$mn=O,e.$rn=y,e.$sn=a,e.$tn=S,e.$un=d,e.$vn=n,e.$wn=o,v=We(v),e.$in="extensions.user.cache",e.$jn="extensions.builtin.cache",e.$kn="undefined_publisher",e.$ln=["ui","workspace","web"];function O(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$nn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(R||(e.ExtensionType=R={}));var T;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class ${constructor(l){this.value=l,this._lower=l.toLowerCase()}static equals(l,i){if(typeof l>"u"||l===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof l=="string"||typeof i=="string"){const r=typeof l=="string"?l:l.value,t=typeof i=="string"?i:i.value;return v.$Df(r,t)}return l._lower===i._lower}static toKey(l){return typeof l=="string"?l.toLowerCase():l._lower}}e.$on=$;class s{get size(){return this.c.size}constructor(l){if(this.c=new Set,l)for(const i of l)this.add(i)}add(l){this.c.add($.toKey(l))}delete(l){return this.c.delete($.toKey(l))}has(l){return this.c.has($.toKey(l))}}e.$pn=s;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(l){this.c.delete($.toKey(l))}get(l){return this.c.get($.toKey(l))}has(l){return this.c.has($.toKey(l))}set(l,i){this.c.set($.toKey(l),i)}values(){return this.c.values()}forEach(l){this.c.forEach(l)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$qn=A;function y(c){return a(c)}function a(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function S(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function d(c,l){if(l){const i=`onResolveRemoteAuthority:${(0,P.$fn)(l)}`;return!!c.activationEvents?.includes(i)}return!1}function n(c){return c.map(l=>{const[i,r]=l.split("@");return{proposalName:i,version:r?parseInt(r):void 0}})}function o(c){return c.map(l=>l.split("@")[0])}e.$xn=(0,I.$Ci)("IBuiltinExtensionsScannerService")}),define(Oe[110],Ne([1,0,20,9,18,3]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.ExtensionManagementErrorCode=e.$jp=e.ExtensionGalleryErrorCode=e.$ip=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=void 0,e.$cp=T,e.$dp=$,e.$ep=s,e.$fp=A,e.$gp=y,e.$hp=a,e.$8o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9o=new RegExp(e.$8o),e.$0o="__web_extension",e.$$o="skipWalkthrough",e.$_o="extensionInstallSource",e.$ap="dependecyOrPackExtensionInstall",e.$bp="clientTargetPlatform";var R;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(R||(e.ExtensionInstallSource=R={}));function T(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function $(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function s(t,g){switch(t){case v.Platform.Windows:return g==="x64"?P.TargetPlatform.WIN32_X64:g==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Linux:return g==="x64"?P.TargetPlatform.LINUX_X64:g==="arm64"?P.TargetPlatform.LINUX_ARM64:g==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return g==="x64"?P.TargetPlatform.ALPINE_X64:g==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Mac:return g==="x64"?P.TargetPlatform.DARWIN_X64:g==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Web:return P.TargetPlatform.WEB}}function A(t,g){return g===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function y(t,g,u){return A(g,u)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===u}function a(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var S;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var d;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var n;(function(t){t.Install="install",t.Uninstall="uninstall"})(n||(e.StatisticType=n={}));var o;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(o||(e.InstallOperation=o={})),e.$ip=(0,O.$Ci)("extensionGalleryService");var c;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(c||(e.ExtensionGalleryErrorCode=c={}));class l extends Error{constructor(g,u){super(g),this.code=u,this.name=u}}e.$jp=l;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class r extends Error{constructor(g,u){super(g),this.code=u,this.name=u}}e.$kp=r,e.$lp=(0,O.$Ci)("extensionManagementService"),e.$mp="extensionsIdentifiers/disabled",e.$np="extensionsIdentifiers/enabled",e.$op=(0,O.$Ci)("IGlobalExtensionEnablementService"),e.$pp=(0,O.$Ci)("IExtensionTipsService"),e.$qp=(0,I.localize2)(11408,"Extensions"),e.$rp=(0,I.localize2)(11409,"Preferences")}),define(Oe[111],Ne([1,0,13,18]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VG=e.$UG=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(R,T){this.a.set(R,T)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const T=Object.create(null);for(const $ of R){const s=this.readActivationEvents($);s.length>0&&(T[I.$on.toKey($.identifier)]=s)}return T}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const T=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let $=0;$<T.length;$++)T[$]==="onUri"&&(T[$]=`onUri:${I.$on.toKey(R.identifier)}`);if(!R.contributes)return T;for(const $ in R.contributes){const s=this.a.get($);if(!s)continue;const A=R.contributes[$],y=Array.isArray(A)?A:[A];try{s(y,T)}catch(a){(0,v.$Y)(a)}}return T}}e.$UG=P,e.$VG=new P});var ni=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[175],Ne([1,0,23,35,9,281,18,104]),function(be,e,v,I,P,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=A,e.$Xp=y,e.$Yp=a,e.$Zp=S,e.$1p=d,e.$2p=n,e.$3p=o,e.$4p=c,I=ni(I),P=We(P),O=We(O);const $=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,s=/^-(\d{4})(\d{2})(\d{2})$/;function A(r){return r=r.trim(),r==="*"||$.test(r)}function y(r){if(!A(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=r.match($);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function a(r){if(!r)return null;const t=r.majorBase,g=r.majorMustEqual,u=r.minorBase;let m=r.minorMustEqual;const p=r.patchBase;let h=r.patchMustEqual;r.hasCaret&&(t===0||(m=!1),h=!1);let E=0;if(r.preRelease){const D=s.exec(r.preRelease);if(D){const[,b,k,C]=D;E=Date.UTC(Number(b),Number(k)-1,Number(C))}}return{majorBase:t,majorMustEqual:g,minorBase:u,minorMustEqual:m,patchBase:p,patchMustEqual:h,isMinimum:r.hasGreaterEquals,notBefore:E}}function S(r,t,g){let u;typeof r=="string"?u=a(y(r)):u=r;let m;t instanceof Date?m=t.getTime():typeof t=="string"&&(m=new Date(t).getTime());let p;if(typeof g=="string"?p=a(y(g)):p=g,!u||!p)return!1;const h=u.majorBase,E=u.minorBase,D=u.patchBase;let b=p.majorBase,k=p.minorBase,C=p.patchBase;const f=p.notBefore;let w=p.majorMustEqual,M=p.minorMustEqual,N=p.patchMustEqual;return p.isMinimum?h>b?!0:h<b?!1:E>k?!0:E<k||m&&m<f?!1:D>=C:(h===1&&b===0&&(!w||!M||!N)&&(b=1,k=0,C=0,w=!0,M=!1,N=!1),h<b?!1:h>b?!w:E<k?!1:E>k?!M:D<C?!1:D>C?!N:!(m&&m<f))}function d(r,t,g,u,m,p){const h=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return h.push([I.default.Error,P.localize(11339,null)]),h;if(typeof u.name!="string")return h.push([I.default.Error,P.localize(11340,null,"name")]),h;if(typeof u.version!="string")return h.push([I.default.Error,P.localize(11341,null,"version")]),h;if(!u.engines)return h.push([I.default.Error,P.localize(11342,null,"engines")]),h;if(typeof u.engines.vscode!="string")return h.push([I.default.Error,P.localize(11343,null,"engines.vscode")]),h;if(typeof u.extensionDependencies<"u"&&!i(u.extensionDependencies))return h.push([I.default.Error,P.localize(11344,null,"extensionDependencies")]),h;if(typeof u.activationEvents<"u"){if(!i(u.activationEvents))return h.push([I.default.Error,P.localize(11345,null,"activationEvents")]),h;if(typeof u.main>"u"&&typeof u.browser>"u")return h.push([I.default.Error,P.localize(11346,null,"activationEvents","main","browser")]),h}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&h.push([I.default.Warning,P.localize(11347,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return h.push([I.default.Error,P.localize(11348,null,"main")]),h;{const b=(0,v.$dh)(g,u.main);(0,v.$0g)(b,g)||h.push([I.default.Warning,P.localize(11349,null,b.path,g.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return h.push([I.default.Error,P.localize(11350,null,"browser")]),h;{const b=(0,v.$dh)(g,u.browser);(0,v.$0g)(b,g)||h.push([I.default.Warning,P.localize(11351,null,b.path,g.path)])}}if(!O.valid(u.version))return h.push([I.default.Error,P.localize(11352,null)]),h;const E=[];if(!n(r,t,u,m,E))for(const b of E)h.push([I.default.Error,b]);if(p&&u.enabledApiProposals?.length){const b=[];if(!c([...u.enabledApiProposals],b))for(const k of b)h.push([I.default.Error,k])}return h}function n(r,t,g,u,m){return u||typeof g.main>"u"&&typeof g.browser>"u"?!0:l(r,t,g.engines.vscode,m)}function o(r,t,g){return r==="*"||l(t,g,r)}function c(r,t){if(r.length===0)return!0;const g=Array.isArray(t)?t:void 0,u=(g?void 0:t)??T.allApiProposals,m=[],p=(0,R.$vn)(r);for(const{proposalName:h,version:E}of p){const D=u[h];D&&E&&D.version!==E&&m.push(P.localize(11353,null,h))}return g?.push(...m),m.length===0}function l(r,t,g,u=[]){const m=a(y(g));if(!m)return u.push(P.localize(11354,null,g)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return u.push(P.localize(11355,null,g)),!1}else if(!m.majorMustEqual)return u.push(P.localize(11356,null,g)),!1;return S(r,t,m)?!0:(u.push(P.localize(11357,null,r,g)),!1)}function i(r){if(!Array.isArray(r))return!1;for(let t=0,g=r.length;t<g;t++)if(typeof r[t]!="string")return!1;return!0}}),define(Oe[176],Ne([1,0,22,13,4,9,53,3,11,30]),function(be,e,v,I,P,O,R,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0,e.$7p=a,e.$8p=S,e.$9p=d,e.$0p=n,e.$$p=o,e.$_p=c,e.$5p=(0,T.$Ci)("requestService");class A{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const g in this.b)g.toLowerCase()==="authorization"||g.toLowerCase()==="proxy-authorization"?t[g]="*****":t[g]=this.b[g];this.a=t}return this.a}}class y extends P.$Tc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,O.localize)(11126,null),when:$.$pk.isEqualTo((0,$.$mk)($.LogLevel.Trace)).serialize()})}async c(t,g,u){const m=`${t} #${++this.b}: ${g.url}`;this.a.trace(`${m} - begin`,g.type,new A(g.headers??{}));try{const p=await u();return this.a.trace(`${m} - end`,g.type,p.res.statusCode,p.res.headers),p}catch(p){throw this.a.error(`${m} - error`,g.type,(0,I.$9)(p)),p}}}e.$6p=y;function a(r){return r.res.statusCode&&r.res.statusCode>=200&&r.res.statusCode<300||r.res.statusCode===1223}function S(r){return r.res.statusCode===204}async function d(r){return S(r)?null:(await(0,v.$Xe)(r.stream)).toString()}async function n(r){if(!a(r))throw new Error("Server returned "+r.res.statusCode);return d(r)}async function o(r){if(!a(r))throw new Error("Server returned "+r.res.statusCode);if(S(r))return null;const g=(await(0,v.$Xe)(r.stream)).toString();try{return JSON.parse(g)}catch(u){throw u.message+=`:
`+g,u}}function c(r){i(r)}let l;function i(r){const t=s.$oo.as(R.$to.Configuration),g=l;l={id:"http",order:15,title:(0,O.localize)(11127,null),type:"object",scope:r,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(11128,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(11129,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(11130,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,O.localize)(11131,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(11132,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(11133,null),(0,O.localize)(11134,null),(0,O.localize)(11135,null),(0,O.localize)(11136,null)],default:"override",description:(0,O.localize)(11137,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11138,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(11139,null),restricted:!0}}},t.updateConfigurations({add:[l],remove:g?[g]:[]})}i(R.ConfigurationScope.APPLICATION)}),define(Oe[177],Ne([1,0,20,78,37]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=R,e.$tp=T;function O($){if(v.$v===v.Platform.Linux&&/^penguin(\.|$)/i.test($))return"chromebook"}function R($,s,A,y,a,S,d,n,o,c){const l=Object.create(null);l["common.machineId"]=S,l["common.sqmId"]=d,l["common.devDeviceId"]=n,l.sessionID=(0,P.$Yg)()+Date.now(),l.commitHash=y,l.version=a,l["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,v.$i)(v.$v),l["common.nodePlatform"]=I.$cc,l["common.nodeArch"]=A,l["common.product"]=c||"desktop",o&&(l["common.msftInternal"]=o);let i=0;const r=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),v.$m&&(l["common.snap"]="true");const t=O(s);return t&&(l["common.platformDetail"]=t),l}function T($){const s=I.env.USERDNSDOMAIN;if(!s)return!1;const A=s.toLowerCase();return $.some(y=>A===y)}}),define(Oe[112],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=void 0,e.$9l=(0,v.$Ci)("telemetryService"),e.$0l=(0,v.$Ci)("customEndpointTelemetryService"),e.$$l="telemetry.currentSessionDate",e.$_l="telemetry.firstSessionDate",e.$am="telemetry.lastSessionDate",e.$bm="telemetry.machineId",e.$cm="telemetry.sqmId",e.$dm="telemetry.devDeviceId",e.$em="telemetry",e.$fm="telemetry.telemetryLevel",e.$gm="telemetry.enableCrashReporter",e.$hm="telemetry.enableTelemetry";var I;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(I||(e.TelemetryLevel=I={}));var P;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Oe[63],Ne([1,0,25,14,62,177,112]),function(be,e,v,I,P,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=void 0,e.$Bp=A,e.$Cp=y,e.$Dp=a,e.$Ep=S,e.$Fp=n,e.$Gp=c,e.$Hp=l,e.$Ip=t;class T{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.$up=T;class ${constructor(){this.telemetryLevel=R.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$vp=$,e.$wp=new $;class s{async publicLog(u,m,p){}async publicLogError(u,m,p){}}e.$xp=s,e.$yp="telemetry",e.$zp="extensionTelemetryLog",e.$Ap={log:()=>null,flush:()=>Promise.resolve(null)};function A(g,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!g.enableTelemetry)}function y(g,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||g.enableTelemetry&&g.aiConfig?.ariaKey)}function a(g){const u=g.getValue(R.$fm),m=g.getValue(R.$gm);if(g.getValue(R.$hm)===!1||m===!1)return R.TelemetryLevel.NONE;switch(u??R.TelemetryConfiguration.ON){case R.TelemetryConfiguration.ON:return R.TelemetryLevel.USAGE;case R.TelemetryConfiguration.ERROR:return R.TelemetryLevel.ERROR;case R.TelemetryConfiguration.CRASH:return R.TelemetryLevel.CRASH;case R.TelemetryConfiguration.OFF:return R.TelemetryLevel.NONE}}function S(g){const u={},m={},p={};o(g,p);for(let h in p){h=h.length>150?h.substr(h.length-149):h;const E=p[h];typeof E=="number"?m[h]=E:typeof E=="boolean"?m[h]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${E.length}`),u[h]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(u[h]=E)}return{properties:u,measurements:m}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(g){if(!g)return"none";const u=(0,P.$fn)(g);return d.has(u)?u:"other"}function o(g,u,m=0,p){if(g)for(const h of Object.getOwnPropertyNames(g)){const E=g[h],D=p?p+h:h;Array.isArray(E)?u[D]=(0,v.$go)(E):E instanceof Date?u[D]=E.toISOString():(0,I.$eg)(E)?m<2?o(E,u,m+1,D+"."):u[D]=(0,v.$go)(E):u[D]=E}}function c(g,u){const m=g.msftInternalDomains||[],p=u.getValue("telemetry.internalTesting");return(0,O.$tp)(m)||p}function l(g){return[g.appRoot,g.extensionsPath,g.userHome.fsPath,g.tmpDir.fsPath,g.userDataPath]}function i(g,u){if(!g||!g.includes("/")&&!g.includes("\\"))return g;let m=g;const p=[];for(const b of u)for(;;){const k=b.exec(g);if(!k)break;p.push([k.index,b.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(m="";;){const b=E.exec(g);if(!b)break;const k=p.some(([C,f])=>b.index<f&&C<E.lastIndex);!h.test(b[0])&&!k&&(m+=g.substring(D,b.index)+"<REDACTED: user-file-path>",D=E.lastIndex)}return D<g.length&&(m+=g.substr(D)),m}function r(g){if(!g)return g;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of u)if(m.regex.test(g))return`<REDACTED: ${m.label}>`;return g}function t(g,u){return(0,v.$do)(g,m=>{if(m instanceof T||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let p=m.replaceAll("%20"," ");p=i(p,u);for(const h of u)p=p.replace(h,"");return p=r(p),p}})}}),define(Oe[178],Ne([1,0,12,110,18,20,2,13,78,63]),function(be,e,v,I,P,O,R,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Kp=void 0,e.$Jp=A,e.$Lp=d,e.$Mp=n,e.$Np=o,e.$Op=c,e.$Pp=l,e.$Qp=i,e.$Rp=r,e.$Tp=t,e.$Up=u;function A(m,p){return m.uuid&&p.uuid?m.uuid===p.uuid:m.id===p.id?!0:(0,v.$yf)(m.id,p.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(p){const h=p.manifest?p.manifest.version:p.version,E=p.manifest?p.targetPlatform:p.properties.targetPlatform;return new a(p.identifier,h,E)}static parse(p){const h=y.exec(p);return h&&h[1]&&h[2]?new a({id:h[1]},h[2],h[4]||void 0):null}constructor(p,h,E=P.TargetPlatform.UNDEFINED){this.identifier=p,this.version=h,this.targetPlatform=E,this.id=p.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(p){return p instanceof a?A(this,p)&&this.version===p.version&&this.targetPlatform===p.targetPlatform:!1}}e.$Kp=a;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(m){const p=S.exec(m);return p&&p[1]?[o(p[1]),p[2]]:[o(m),void 0]}function n(m,p){return`${m}.${p}`}function o(m){return m.toLowerCase()}function c(m,p){return o(n(m??P.$kn,p))}function l(m,p){const h=[],E=D=>{for(const b of h)if(b.some(k=>A(p(k),p(D))))return b;return null};for(const D of m){const b=E(D);b?b.push(D):h.push([D])}return h}function i(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}function r(m){return{id:new s.$up(m.identifier.id),name:new s.$up(m.name),version:m.version,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,isPreReleaseVersion:m.properties.isPreReleaseVersion,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0),isSigned:m.isSigned,...m.telemetryData}}e.$Sp=new P.$on("pprice.better-merge");function t(m,p){const h=[],E=p.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const D=E.shift();if(D&&h.every(b=>!A(b.identifier,{id:D}))){const b=m.filter(k=>A(k.identifier,{id:D}));b.length===1&&(h.push(b[0]),E.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}async function g(m,p){if(!O.$l)return!1;let h;try{h=(await m.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{h=(await m.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){p.debug("Error while getting the os-release file.",(0,T.$9)(D))}}return!!h&&(h.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(m,p){const h=await g(m,p),E=(0,I.$ep)(h?"alpine":O.$v,$.$dc);return p.debug("ComputeTargetPlatform:",E),E}}),define(Oe[179],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=v,e.$Ds=I,e.$Es=P,e.$Fs=O,e.$Gs=R,e.$Hs=T;function v($){return[...$.entries()]}function I($){return $?[...$.entries()]:[]}function P($){return new Map($)}function O($){return new Map($??[])}function R($){return Array.from($.entries()).map(s=>[s[0],v(s[1].map),I(s[1].descriptionMap)])}function T($){return new Map($.map(s=>[s[0],{map:P(s[1]),descriptionMap:O(s[2])}]))}}),define(Oe[180],Ne([1,0,3,31,30]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=e.$os=e.$ns=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ms=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ls=void 0,e.$ls=new I.$Tj("terminalTabFocusMode",!1,!0);var O;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var R;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(R||(e.TerminalSettingId=R={}));var T;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(T||(e.PosixShellType=T={}));var $;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})($||(e.WindowsShellType=$={}));var s;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(s||(e.TitleEventSource=s={}));var A;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(A||(e.TerminalIpcChannels=A={}));var y;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$ms=(0,v.$Ci)("ptyService");var a;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(a||(e.HeartbeatConstants=a={}));var S;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(S||(e.TerminalLocation=S={}));var d;(function(t){t.TerminalView="view",t.Editor="editor"})(d||(e.TerminalLocationString=d={}));var n;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(n||(e.LocalReconnectConstants=n={}));var o;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var c;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(c||(e.ProfileSource=c={}));var l;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(l||(e.ShellIntegrationStatus=l={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$ns={Backend:"workbench.contributions.terminal.processBackend"};class r{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(g){const u=this.b(g.remoteAuthority);if(this.a.has(u))throw new Error(`A terminal backend with remote authority '${u}' was already registered.`);this.a.set(u,g)}getTerminalBackend(g){return this.a.get(this.b(g))}b(g){return g?.toLowerCase()??""}}P.$oo.add(e.$ns.Backend,new r),e.$os=(0,v.$Ci)("localPtyService"),e.$ps=(0,v.$Ci)("terminalLogService")}),define(Oe[181],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lxb=void 0;class v{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,O,R=5){const T=O($=>{const s=typeof $=="string"?$:$.data;let A=this.a.get(P);if(A){A.data.push(s);return}const y=setTimeout(()=>this.flushBuffer(P),R);A={data:[s],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(P),T.dispose()}},this.a.set(P,A)});return T}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const O=this.a.get(P);O&&(this.a.delete(P),this.b(P,O.data.join("")))}}e.$Lxb=v}),define(Oe[182],Ne([1,0,10,97,282,34,6,14,2,9,77,30]),function(be,e,v,I,P,O,R,T,$,s,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fx=e.$Ex=e.$Dx=e.$Cx=e.$Bx=e.$Ax=e.IconFontDefinition=e.IconContribution=e.$xx=void 0,e.$yx=o,e.$zx=c,y=We(y),e.$xx={IconContribution:"base.contributions.icons"};var a;(function(t){function g(u,m){let p=u.defaults;for(;O.ThemeIcon.isThemeIcon(p);){const h=n.getIcon(p.id);if(!h)return;p=h.defaults}return p}t.getDefinition=g})(a||(e.IconContribution=a={}));var S;(function(t){function g(m){return{weight:m.weight,style:m.style,src:m.src.map(p=>({format:p.format,location:p.location.toString()}))}}t.toJSONObject=g;function u(m){const p=h=>(0,T.$cg)(h)?h:void 0;if(m&&Array.isArray(m.src)&&m.src.every(h=>(0,T.$cg)(h.format)&&(0,T.$cg)(h.location)))return{weight:p(m.weight),style:p(m.style),src:m.src.map(h=>({format:h.format,location:$.URI.parse(h.location)}))}}t.fromJSONObject=u})(S||(e.IconFontDefinition=S={}));class d{constructor(){this.a=new R.$je,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,s.localize)(11058,null)},fontCharacter:{type:"string",description:(0,s.localize)(11059,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,u,m,p){const h=this.b[g];if(h){if(m&&!h.description){h.description=m,this.d.properties[g].markdownDescription=`${m} $(${g})`;const b=this.e.enum.indexOf(g);b!==-1&&(this.e.enumDescriptions[b]=m),this.a.fire()}return h}const E={id:g,description:m,defaults:u,deprecationMessage:p};this.b[g]=E;const D={$ref:"#/definitions/icons"};return p&&(D.deprecationMessage=p),m&&(D.markdownDescription=`${m}: $(${g})`),this.d.properties[g]=D,this.e.enum.push(g),this.e.enumDescriptions.push(m||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const u=this.e.enum.indexOf(g);u!==-1&&(this.e.enum.splice(u,1),this.e.enumDescriptions.splice(u,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,u){const m=this.f[g];return m||(this.f[g]=u,this.a.fire(),u)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(h,E)=>h.id.localeCompare(E.id),u=h=>{for(;O.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},m=[];m.push("| preview     | identifier                        | default codicon ID                | description"),m.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const p=Object.keys(this.b).map(h=>this.b[h]);for(const h of p.filter(E=>!!E.description).sort(g))m.push(`|<i class="${u(h)}"></i>|${h.id}|${O.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);m.push("| preview     | identifier                        "),m.push("| ----------- | --------------------------------- |");for(const h of p.filter(E=>!O.ThemeIcon.isThemeIcon(E.defaults)).sort(g))m.push(`|<i class="${u(h)}"></i>|${h.id}|`);return m.join(`
`)}}const n=new d;y.$oo.add(e.$xx.IconContribution,n);function o(t,g,u,m){return n.registerIcon(t,g,u,m)}function c(){return n}function l(){const t=(0,P.$Xj)();for(const g in t){const u="\\"+t[g].toString(16);n.registerIcon(g,{fontCharacter:u})}}l(),e.$Ax="vscode://schemas/icons";const i=y.$oo.as(A.$po.JSONContribution);i.registerSchema(e.$Ax,n.getIconSchema());const r=new v.$Oh(()=>i.notifySchemaChanged(e.$Ax),200);n.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Bx=o("widget-close",I.$2j.close,(0,s.localize)(11060,null)),e.$Cx=o("goto-previous-location",I.$2j.arrowUp,(0,s.localize)(11061,null)),e.$Dx=o("goto-next-location",I.$2j.arrowDown,(0,s.localize)(11062,null)),e.$Ex=O.ThemeIcon.modify(I.$2j.sync,"spin"),e.$Fx=O.ThemeIcon.modify(I.$2j.loading,"spin")}),define(Oe[183],Ne([1,0,6,4,20,2,43,3,11]),function(be,e,v,I,P,O,R,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=e.$Lw=e.$Iw=e.$Gw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Cw=e.$Bw=void 0,e.$Dw=y,e.$Ew=S,e.$Fw=d,e.$Hw=n,e.$Jw=o,e.$Kw=c,e.$Bw=(0,T.$Ci)("tunnelService"),e.$Cw=(0,T.$Ci)("sharedTunnelsService");var s;(function(r){r.Http="http",r.Https="https"})(s||(e.TunnelProtocol=s={}));var A;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(A||(e.TunnelPrivacyId=A={}));function y(r){return!!r.forwardPort}var a;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function S(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(t)return{address:t[1],port:+t[2]}}function d(r){if(r.scheme!=="http"&&r.scheme!=="https"||!r.query)return;const t=r.query.split("&");for(const g of t){const u=g.split("=")[1];if(/^https?:/.exec(u)){const m=S(O.URI.parse(u));if(m)return m}}}e.$Gw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(r){return e.$Gw.indexOf(r)>=0}e.$Iw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function o(r){return e.$Iw.indexOf(r)>=0}function c(r,t,g,u){if(g===P.OperatingSystem.Windows)return!1;if(g===P.OperatingSystem.Macintosh&&o(t)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(m?.length===4&&parseInt(m[1])>=18)return!1}return r<1024}class l{constructor(t,g,u){this.remoteAddress=t,this.localAddress=g,this.b=u,this.a=new v.$je,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lw=l;let i=class extends I.$Tc{constructor(t,g){super(),this.r=t,this.s=g,this.a=new v.$je,this.onTunnelOpened=this.a.event,this.b=new v.$je,this.onTunnelClosed=this.b.event,this.c=new v.$je,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],g=Array.from(this.f.values());for(const u of g){const m=Array.from(u.values());for(const p of m){const h=await p.value;h&&typeof h!="string"&&t.push(h)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:g}of t.values())await g.then(u=>typeof u!="string"?u?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,g,u,m,p){this.z(t,g,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:g,localAddress:u,privacy:m,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,g){(o(t)||n(t))&&(t=e.$Gw[0]);const u=this.D(t,g);if(u)return++u.refcount,u.value}openTunnel(t,g,u,m,p,h=!1,E,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${u} on local port ${p}.`);const b=this.g??t;if(!b)return;if(g||(g="localhost"),m||(m=this.t),this.g&&this.n.has(u)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const k=this.F(b,g,u,m,p,h,E,D);return k?k.then(C=>{if(C){if(typeof C=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(g,u),C}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(g,u);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.w(C);return(C.tunnelRemoteHost!==g||C.tunnelRemotePort!==u)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),E&&C.privacy!==E&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(f),f}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),k)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const g=this.f.get(t.tunnelRemoteHost);if(g){const u=g.get(t.tunnelRemotePort);u&&(u.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,u))}}}}async y(t,g,u){if(u.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${g}.`);const m=u.value.then(async p=>{p&&typeof p!="string"&&(await p.dispose(!0),this.b.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(g),m}}async closeTunnel(t,g){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${g} `);const u=this.f.get(t);if(u&&u.has(g)){const m=u.get(g);m.refcount=0,await this.y(t,g,m)}}z(t,g,u){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(g,{refcount:1,value:u})}async C(t,g){const u=this.f.get(t);if(u){const m=u.get(g),p=m?await m.value:void 0;(!p||typeof p=="string")&&u.delete(g),u.size===0&&this.f.delete(t)}}D(t,g){const u=[t];n(t)?(u.push(...e.$Gw),u.push(...e.$Iw)):o(t)&&u.push(...e.$Iw);const m=u.map(p=>this.f.get(p));for(const p of m){const h=p?.get(g);if(h)return h}}canTunnel(t){return!!S(t)}G(t,g,u,m,p,h,E){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${u} on local port ${m}.`);const D=u;this.n.add(D);const b=m===void 0?u:m,k={elevationRequired:p?this.isPortPrivileged(b):!1},C={remoteAddress:{host:g,port:u},localAddressPort:m,privacy:h,public:h?h!==A.Private:void 0,protocol:E},f=t.forwardPort(C,k);return f?(this.z(g,u,f),f.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),f}};e.$Mw=i,e.$Mw=i=Ge([Ve(0,$.$0j),Ve(1,R.$9i)],i)}),define(Oe[184],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=void 0,e.$Hl=(0,v.$Ci)("IUriIdentityService")}),define(Oe[185],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Nw=void 0,e.$Nw=(0,v.$Ci)("editSessionIdentityService");var I;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(I||(e.EditSessionIdentityMatch=I={}))}),define(Oe[186],Ne([1,0,15]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aN=I,e.$bN=P,e.$cN=O,e.$dN=R,e.$eN=T;function I($){return $.scheme!==v.Schemas.file&&$.scheme!==v.Schemas.vscodeRemote}function P($){if($.folders.length)return $.folders.every(s=>I(s.uri))?$.folders[0].uri:void 0;if($.configuration&&I($.configuration))return $.configuration}function O($){return P($)?.scheme}function R($){return P($)?.authority}function T($){return P($)!==void 0}}),define(Oe[49],Ne([1,0,9,19,58,23,2,3,15]),function(be,e,v,I,P,O,R,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=s,e.$Ni=A,e.$Qi=y,e.$Ri=a,e.$Si=S,e.$Ti=n,e.$Ui=o,e.$Xi=i,e.$3i=r,e.$4i=t,e.$6i=g,e.$7i=u,e.$8i=m,e.$Li=(0,T.$Ci)("contextService");function s(p){const h=p;return typeof h?.id=="string"&&R.URI.isUri(h.uri)}function A(p){return typeof p?.id=="string"&&!s(p)&&!a(p)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function y(p,h){if(typeof p=="string"||typeof p>"u")return typeof p=="string"?{id:(0,I.$mc)(p)}:h?e.$Oi:e.$Pi;const E=p;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}function a(p){const h=p;return typeof h?.id=="string"&&R.URI.isUri(h.configPath)}function S(p){const h=p;if(h?.uri)return{id:h.id,uri:R.URI.revive(h.uri)};const E=p;if(E?.configPath)return{id:E.id,configPath:R.URI.revive(E.configPath)};if(p?.id)return{id:p.id}}var d;(function(p){p[p.EMPTY=1]="EMPTY",p[p.FOLDER=2]="FOLDER",p[p.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function n(p){const h=p;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}function o(p){const h=p;return!!(h&&typeof h=="object"&&R.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}class c{constructor(h,E,D,b,k){this.h=h,this.j=D,this.k=b,this.l=k,this.c=P.$Ii.forUris(this.l,()=>!0),this.folders=E}update(h){this.h=h.id,this.k=h.configuration,this.j=h.transient,this.l=h.l,this.folders=h.folders}get folders(){return this.g}set folders(h){this.g=h,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(h){this.k=h}getFolder(h){return h&&this.c.findSubstr(h)||null}n(){this.c=P.$Ii.forUris(this.l,()=>!0);for(const h of this.folders)this.c.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=c;class l{constructor(h,E){this.raw=E,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,O.$dh)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=l;function i(p){return new l({uri:p,index:0,name:(0,O.$_g)(p)},{uri:p.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,v.localize)(10937,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function r(p,h){return O.$7g.isEqualOrParent(p,h.untitledWorkspacesHome)}function t(p){let h;return R.URI.isUri(p)?h=p:h=p.configuration,h?.scheme===$.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function g(p){return p.id===e.$5i}function u(p,h){return!r(p,h)&&!t(p)}function m(p){return(typeof p=="string"?(0,I.$nc)(p):(0,O.$bh)(p))===e.$Zi}}),define(Oe[113],Ne([1,0,75,6,4,23,2,9,106,29,3,11,49,28,184,10,37,12,14]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Jl=e.ProfileResourceType=void 0,e.$Il=r,e.$Kl=t,e.$Ll=g;var i;(function(p){p.Settings="settings",p.Keybindings="keybindings",p.Snippets="snippets",p.Tasks="tasks",p.Extensions="extensions",p.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(p){const h=p;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&typeof h.isDefault=="boolean"&&typeof h.name=="string"&&R.URI.isUri(h.location)&&R.URI.isUri(h.globalStorageHome)&&R.URI.isUri(h.settingsResource)&&R.URI.isUri(h.keybindingsResource)&&R.URI.isUri(h.tasksResource)&&R.URI.isUri(h.snippetsHome)&&R.URI.isUri(h.extensionsResource))}e.$Jl=(0,A.$Ci)("IUserDataProfilesService");function t(p,h){return{id:p.id,isDefault:p.isDefault,name:p.name,shortName:p.shortName,icon:p.icon,location:R.URI.revive(p.location).with({scheme:h}),globalStorageHome:R.URI.revive(p.globalStorageHome).with({scheme:h}),settingsResource:R.URI.revive(p.settingsResource).with({scheme:h}),keybindingsResource:R.URI.revive(p.keybindingsResource).with({scheme:h}),tasksResource:R.URI.revive(p.tasksResource).with({scheme:h}),snippetsHome:R.URI.revive(p.snippetsHome).with({scheme:h}),extensionsResource:R.URI.revive(p.extensionsResource).with({scheme:h}),cacheHome:R.URI.revive(p.cacheHome).with({scheme:h}),useDefaultFlags:p.useDefaultFlags,isTransient:p.isTransient}}function g(p,h,E,D,b,k){return{id:p,name:h,location:E,isDefault:!1,shortName:b?.shortName,icon:b?.icon,globalStorageHome:k&&b?.useDefaultFlags?.globalState?k.globalStorageHome:(0,O.$dh)(E,"globalStorage"),settingsResource:k&&b?.useDefaultFlags?.settings?k.settingsResource:(0,O.$dh)(E,"settings.json"),keybindingsResource:k&&b?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,O.$dh)(E,"keybindings.json"),tasksResource:k&&b?.useDefaultFlags?.tasks?k.tasksResource:(0,O.$dh)(E,"tasks.json"),snippetsHome:k&&b?.useDefaultFlags?.snippets?k.snippetsHome:(0,O.$dh)(E,"snippets"),extensionsResource:k&&b?.useDefaultFlags?.extensions?k.extensionsResource:(0,O.$dh)(E,"extensions.json"),cacheHome:(0,O.$dh)(D,p),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}let u=class extends P.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(h,E,D,b){super(),this.t=h,this.u=E,this.w=D,this.y=b,this.f=!0,this.h=this.B(new I.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new I.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new I.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new I.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new S.$zc,workspaces:new S.$zc,emptyWindows:new Map},this.profilesHome=(0,O.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(h){this.f!==h&&(this.z=void 0,this.f=h)}isEnabled(){return this.f}get C(){if(!this.z){const h=this.D(),E=[h];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,l.$cg)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}E.push(g((0,O.$ah)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},h))}}catch(k){this.y.error(k)}const D=new S.$zc,b=new Map;if(E.length)try{const k=this.Q();if(k.workspaces)for(const[C,f]of Object.entries(k.workspaces)){const w=R.URI.parse(C),M=E.find(N=>N.id===f);M&&D.set(w,M)}if(k.emptyWindows)for(const[C,f]of Object.entries(k.emptyWindows)){const w=E.find(M=>M.id===f);w&&b.set(C,w)}}catch(k){this.y.error(k)}this.z={profiles:E,workspaces:D,emptyWindows:b}}return this.z}D(){const h=g("__default__profile__",(0,T.localize)(10984,null),this.t.userRoamingDataHome,this.g);return{...h,extensionsResource:this.S()??h.extensionsResource,isDefault:!0}}async createTransientProfile(h){const E="Temp",D=new RegExp(`${(0,c.$ff)(E)}\\s(\\d+)`);let b=0;for(const C of this.profiles){const f=D.exec(C.name),w=f?parseInt(f[1]):0;b=w>b?w:b}const k=`${E} ${b+1}`;return this.createProfile((0,v.$qj)((0,o.$Yg)()).toString(16),k,{transient:!0},h)}async createNamedProfile(h,E,D){return this.createProfile((0,v.$qj)((0,o.$Yg)()).toString(16),h,E,D)}async createProfile(h,E,D,b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F(h,E,D);return b&&await this.setProfileForWorkspace(b,k),k}async F(h,E,D){if(!(0,l.$cg)(E)||!E)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.r.get(E);return b||(b=(async()=>{try{if(this.profiles.find(w=>w.name===E||w.id===h))throw new Error(`Profile with ${E} name already exists`);const C=g(h,E,(0,O.$dh)(this.profilesHome,h),this.g,D,this.defaultProfile);await this.u.createFolder(C.location);const f=[];return this.j.fire({profile:C,join(w){f.push(w)}}),await n.Promises.settled(f),this.I([C],[],[]),C}finally{this.r.delete(E)}})(),this.r.set(E,b)),b}async updateProfile(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(b=>b.id===h.id);if(!D)throw new Error(`Profile '${h.name}' does not exist`);return D=g(D.id,E.name??D.name,D.location,this.g,{shortName:E.shortName??D.shortName,icon:E.icon===null?void 0:E.icon??D.icon,transient:E.transient??D.isTransient,useDefaultFlags:E.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(h.isDefault)throw new Error("Cannot remove default profile");const E=this.profiles.find(b=>b.id===h.id);if(!E)throw new Error(`Profile '${h.name}' does not exist`);const D=[];this.m.fire({profile:E,join(b){D.push(b)}});try{await Promise.allSettled(D)}catch(b){this.y.error(b)}for(const b of[...this.C.emptyWindows.keys()])E.id===this.C.emptyWindows.get(b)?.id&&this.C.emptyWindows.delete(b);for(const b of[...this.C.workspaces.keys()])E.id===this.C.workspaces.get(b)?.id&&this.C.workspaces.delete(b);this.M(),this.I([],[E],[]);try{await this.u.del(E.cacheHome,{recursive:!0})}catch(b){(0,s.$ol)(b)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.error(b)}}async setProfileForWorkspace(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(b=>b.id===E.id);if(!D)throw new Error(`Profile '${E.name}' does not exist`);this.L(h,D)}unsetWorkspace(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(h,void 0,E)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const h=await this.u.resolve(this.profilesHome);await Promise.all((h.children||[]).filter(E=>E.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,E.resource))).map(E=>this.u.del(E.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const h=this.s.profiles.filter(E=>!this.H(E));await Promise.allSettled(h.map(E=>this.removeProfile(E)))}getProfileForWorkspace(h){const E=this.G(h),D=R.URI.isUri(E)?this.C.workspaces.get(E):this.C.emptyWindows.get(E);return D||((0,a.$Mi)(h)?this.s.folders.get(h.uri):(0,a.$Ri)(h)?this.s.workspaces.get(h.configPath):this.s.emptyWindows.get(h.id))}G(h){return(0,a.$Mi)(h)?h.uri:(0,a.$Ri)(h)?h.configPath:h.id}H(h){return!!([...this.C.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.C.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.folders.values()].some(E=>this.w.extUri.isEqual(E.location,h.location)))}I(h,E,D){const b=[...this.profiles,...h],k=[],C=this.s.profiles;this.s.profiles=[];for(let f of b){if(f.isDefault||E.some(M=>f.id===M.id))continue;f=D.find(M=>f.id===M.id)??f;const w=C.find(M=>f.id===M.id);if(f.isTransient)this.s.profiles.push(f);else{if(w){for(const[M,N]of this.s.emptyWindows.entries())if(f.id===N.id){this.L({id:M},f);break}for(const[M,N]of this.s.workspaces.entries())if(f.id===N.id){this.L({id:"",configPath:M},f);break}for(const[M,N]of this.s.folders.entries())if(f.id===N.id){this.L({id:"",uri:M},f);break}}k.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags})}}this.P(k),this.z=void 0,this.J(h,E,D)}J(h,E,D){this.h.fire({added:h,removed:E,updated:D,all:this.profiles})}L(h,E,D){if(D=E?.isTransient?!0:D,D)(0,a.$Mi)(h)?(this.s.folders.delete(h.uri),E&&this.s.folders.set(h.uri,E)):(0,a.$Ri)(h)?(this.s.workspaces.delete(h.configPath),E&&this.s.workspaces.set(h.configPath,E)):(this.s.emptyWindows.delete(h.id),E&&this.s.emptyWindows.set(h.id,E));else{this.L(h,void 0,!0);const b=this.G(h);R.URI.isUri(b)?(this.C.workspaces.delete(b),E&&this.C.workspaces.set(b,E)):(this.C.emptyWindows.delete(b),E&&this.C.emptyWindows.set(b,E)),this.M()}}M(){const h={};for(const[D,b]of this.C.workspaces.entries())h[D.toString()]=b.id;const E={};for(const[D,b]of this.C.emptyWindows.entries())E[D.toString()]=b.id;this.R({workspaces:h,emptyWindows:E}),this.z=void 0}N(h){const E={},D=this.D();if(h.workspaces)for(const[k,C]of Object.entries(h.workspaces)){const f=R.URI.parse(C);E[k]=this.w.extUri.isEqual(f,D.location)?D.id:this.w.extUri.basename(f)}const b={};if(h.emptyWindows)for(const[k,C]of Object.entries(h.emptyWindows)){const f=R.URI.parse(C);b[k]=this.w.extUri.isEqual(f,D.location)?D.id:this.w.extUri.basename(f)}return{workspaces:E,emptyWindows:b}}O(){return[]}P(h){throw new Error("not implemented")}Q(){return{}}R(h){throw new Error("not implemented")}S(){}};e.$Ml=u,e.$Ml=u=Ge([Ve(0,$.$Ji),Ve(1,s.$0k),Ve(2,d.$Hl),Ve(3,y.$0j)],u);class m extends u{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(h){this.a=h}Q(){return this.X}R(h){this.X=h}}e.$Nl=m}),define(Oe[187],Ne([1,0,10,6,4,64,14,152,3,113]),function(be,e,v,I,P,O,R,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$fq=e.$eq=e.$dq=void 0,e.$gq=S,e.$iq=n,e.$kq=c,e.$dq="__$__isNewStorageMarker",e.$eq="__$__targetStorageMarker",e.$fq=(0,$.$Ci)("storageService");var A;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var y;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var a;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(a||(e.StorageTarget=a={}));function S(l){const i=l.get(e.$eq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class d extends P.$Tc{static{this.a=60*1e3}constructor(i={flushInterval:d.a}){super(),this.m=i,this.b=this.B(new I.$me),this.c=this.B(new I.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new I.$je),this.onWillSaveState=this.f.event,this.h=this.B(new v.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,t){return I.Event.filter(this.b.event,g=>g.scope===i&&(r===void 0||g.key===r),t)}n(){this.j.value=(0,v.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:t,external:g}=r;if(t===e.$eq){switch(i){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:g})}w(i){this.f.fire({reason:i})}get(i,r,t){return this.P(r)?.get(i,t)}getBoolean(i,r,t){return this.P(r)?.getBoolean(i,t)}getNumber(i,r,t){return this.P(r)?.getNumber(i,t)}getObject(i,r,t){return this.P(r)?.getObject(i,t)}storeAll(i,r){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,r)})}store(i,r,t,g,u=!1){if((0,R.$lg)(r)){this.remove(i,t,u);return}this.y(()=>{this.z(i,t,g),this.P(t)?.set(i,r,u)})}remove(i,r,t=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const t=[],g=this.J(i);for(const u of Object.keys(g))g[u]===r&&t.push(u);return t}z(i,r,t,g=!1){const u=this.J(r);typeof t=="number"?u[i]!==t&&(u[i]=t,this.P(r)?.set(e.$eq,JSON.stringify(u),g)):typeof u[i]=="number"&&(delete u[i],this.P(r)?.set(e.$eq,JSON.stringify(u),g))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(i){switch(i){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?S(r):Object.create(null)}isNew(i){return this.getBoolean(e.$dq,i)===!0}async flush(i=A.NONE){this.f.fire({reason:i});const r=this.P(y.APPLICATION),t=this.P(y.PROFILE),g=this.P(y.WORKSPACE);switch(i){case A.NONE:await v.Promises.settled([r?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await v.Promises.settled([r?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(y.APPLICATION)?.items??new Map,r=this.P(y.PROFILE)?.items??new Map,t=this.P(y.WORKSPACE)?.items??new Map;return c(i,r,t,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(A.NONE),(0,s.$Il)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||n(r)&&n(i))}N(i,r,t){this.y(()=>{const g=new Set;for(const[u,m]of i)g.add(u),r.get(u)!==m&&this.u(t,{key:u,external:!0});for(const[u]of r.items)g.has(u)||this.u(t,{key:u,external:!0})})}}e.$hq=d;function n(l){return l.isDefault||!!l.useDefaultFlags?.globalState}class o extends d{constructor(){super(),this.U=this.B(new T.$bq(new T.$cq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$bq(new T.$cq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$bq(new T.$cq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(y.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(y.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(y.APPLICATION,i)))}P(i){switch(i){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$jq=o;async function c(l,i,r,t,g,u){const m=w=>{try{return JSON.parse(w)}catch{return w}},p=new Map,h=new Map;l.forEach((w,M)=>{p.set(M,w),h.set(M,m(w))});const E=new Map,D=new Map;i.forEach((w,M)=>{E.set(M,w),D.set(M,m(w))});const b=new Map,k=new Map;r.forEach((w,M)=>{b.set(M,w),k.set(M,m(w))}),console.group(t!==g?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const C=[];if(p.forEach((w,M)=>{C.push({key:M,value:w})}),console.table(C),console.groupEnd(),console.log(h),t!==g){console.group(`Storage: Profile (path: ${g}, profile specific)`);const w=[];E.forEach((M,N)=>{w.push({key:N,value:M})}),console.table(w),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${u})`);const f=[];b.forEach((w,M)=>{f.push({key:M,value:w})}),console.table(f),console.groupEnd(),console.log(k)}}),define(Oe[79],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=void 0;class v{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const O=this.c++;return this.b.set(O,P),this.e(),O}get(P,O){return this.b.has(P)?this.b.get(P)[O]:void 0}delete(P){this.b.delete(P),this.e()}e(){v.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Voc=v}),define(Oe[50],Ne([1,0,15,23,29,3]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2oc=e.$1oc=void 0;class R{constructor(){this.a=new Set(Object.keys(v.Schemas)),this.b=new Map,this.extUri=new I.$5g($=>{const s=this.b.get($.scheme);return!(s===void 0||s&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos($,s){s===null?this.b.delete($.scheme):this.b.set($.scheme,s)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$1oc=R,e.$2oc=(0,O.$Ci)("IExtHostFileSystemInfo")}),define(Oe[26],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=void 0,e.$sQ=(0,v.$Ci)("IExtHostInitDataService")}),define(Oe[188],Ne([1,0,9,11,172,26]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=void 0;let R=class extends P.$CR{constructor($,s,A){const y=A.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",a=A.remote.isRemote?(0,v.localize)(10737,null):$?(0,v.localize)(10738,null):(0,v.localize)(10739,null);super(s.createLogger(y,{name:a}))}};e.$0qc=R,e.$0qc=R=Ge([Ve(1,I.$$j),Ve(2,O.$sQ)],R)}),define(Oe[189],Ne([1,0,10]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hpc=e.$Gpc=void 0;class I{constructor(R,T,$){this.h=new Map,this.a=R,this.b=T,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(s=>(this.f=s,this)),this.g=this.c.onDidChangeStorage(s=>{s.shared===this.b&&s.key===this.a&&(this.f=s.value)}),this.i=new v.$Oh(()=>{const s=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of s.values())A.complete()}catch(A){for(const y of s.values())y.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,T){let $=this.f[R];return typeof $>"u"&&($=T),$}update(R,T){this.f[R]=T;const $=this.h.get(R);if($!==void 0)return $.p;const s=new v.$Zh;return this.h.set(R,s),this.i.isScheduled()||this.i.schedule(),s.p}dispose(){this.g.dispose()}}e.$Gpc=I;class P extends I{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,T){super(R.identifier.value,!0,T),this.j=R}}e.$Hpc=P}),define(Oe[190],Ne([1,0,6,2]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=void 0;class P{constructor(R){this.c=R,this.a=new v.$je,this.onDidSaveNotebookDocument=this.a.event,this.b=new v.$je,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,T,$,s){const y=this.c.getNotebookDocument(I.URI.revive(R)).acceptModelChanged(T.value,$,s);this.b.fire(y)}$acceptDirtyStateChanged(R,T){this.c.getNotebookDocument(I.URI.revive(R)).acceptDirty(T)}$acceptModelSaved(R){const T=this.c.getNotebookDocument(I.URI.revive(R));this.a.fire(T.apiNotebook)}}e.$Bqc=P}),define(Oe[16],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.$cQ=void 0,e.$cQ=(0,v.$Ci)("IExtHostRpcService");class I{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$dQ=I}),define(Oe[191],Ne([1,0,18,6,4]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=void 0;class O{#e;constructor(T,$){this.disposables=new P.$Sc,this.a=v.$on.toKey(T.identifier),this.#e=$,this.onDidChange=I.Event.map(I.Event.filter(this.#e.onDidChangePassword,s=>s.extensionId===this.a),s=>({key:s.key}),this.disposables)}dispose(){this.disposables.dispose()}get(T){return this.#e.get(this.a,T)}store(T,$){return this.#e.store(this.a,T,$)}delete(T){return this.#e.delete(this.a,T)}}e.$Qpc=O}),define(Oe[65],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=e.$epc=void 0,e.$epc=(0,v.$Ci)("IURITransformerService");class I{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$fpc=I});var ni=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[114],Ne([1,0,9,14,2,4,3,30,29,15,42,164,35]),function(be,e,v,I,P,O,R,T,$,s,A,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$nG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$dG=e.EditorInputCapabilities=e.$cG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=void 0,e.$6F=n,e.$7F=o,e.$8F=c,e.$9F=l,e.$0F=i,e.$$F=r,e.$_F=t,e.$aG=g,e.$bG=u,e.$eG=b,e.$fG=C,e.$gG=f,e.$hG=w,e.$iG=M,e.$jG=N,e.$kG=L,e.$lG=W,e.$mG=_,e.$oG=ae,e.$pG=oe,e.$qG=Ce,e.$rG=Le,a=ni(a),e.$1F={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$2F={id:"default",displayName:(0,v.localize)(12379,null),providerDisplayName:(0,v.localize)(12380,null)},e.$3F="workbench.editor.sidebysideEditor",e.$4F="workbench.editors.textDiffEditor",e.$5F="workbench.editors.binaryResourceDiffEditor";var S;(function(Z){Z[Z.PROGRAMMATIC=1]="PROGRAMMATIC",Z[Z.USER=2]="USER",Z[Z.EDIT=3]="EDIT",Z[Z.NAVIGATION=4]="NAVIGATION",Z[Z.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var d;(function(Z){Z[Z.IDENTICAL=1]="IDENTICAL",Z[Z.SIMILAR=2]="SIMILAR",Z[Z.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function n(Z){const q=Z;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}function o(Z){const q=Z;return!!q&&typeof q.getScrollPosition=="function"&&typeof q.setScrollPosition=="function"&&!!q.onDidChangeScroll}function c(Z,q,te){for(const ve of te.visibleEditorPanes)if(ve.group.id===q&&Z.matches(ve.input))return ve.getViewState()}function l(Z){if(b(Z))return!1;const q=Z;return P.URI.isUri(q?.resource)}function i(Z){if(b(Z))return!1;const q=Z;return q?.original!==void 0&&q.modified!==void 0}function r(Z){if(b(Z))return!1;const q=Z;return!q||q.resources&&!Array.isArray(q.resources)?!1:!!q.resources||!!q.multiDiffSource}function t(Z){if(b(Z)||i(Z))return!1;const q=Z;return q?.primary!==void 0&&q.secondary!==void 0}function g(Z){if(b(Z))return!1;const q=Z;return q?q.resource===void 0||q.resource.scheme===s.Schemas.untitled||q.forceUntitled===!0:!1}function u(Z){if(b(Z))return!1;const q=Z;return P.URI.isUri(q?.base?.resource)&&P.URI.isUri(q?.input1?.resource)&&P.URI.isUri(q?.input2?.resource)&&P.URI.isUri(q?.result?.resource)}var m;(function(Z){Z[Z.SHORT=0]="SHORT",Z[Z.MEDIUM=1]="MEDIUM",Z[Z.LONG=2]="LONG"})(m||(e.Verbosity=m={}));var p;(function(Z){Z[Z.EXPLICIT=1]="EXPLICIT",Z[Z.AUTO=2]="AUTO",Z[Z.FOCUS_CHANGE=3]="FOCUS_CHANGE",Z[Z.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(p||(e.SaveReason=p={}));class h{constructor(){this.a=new Map}registerSource(q,te){let ve=this.a.get(q);return ve||(ve={source:q,label:te},this.a.set(q,ve)),ve.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$cG=new h;var E;(function(Z){Z[Z.None=0]="None",Z[Z.Readonly=2]="Readonly",Z[Z.Untitled=4]="Untitled",Z[Z.Singleton=8]="Singleton",Z[Z.RequiresTrust=16]="RequiresTrust",Z[Z.CanSplitInGroup=32]="CanSplitInGroup",Z[Z.ForceDescription=64]="ForceDescription",Z[Z.CanDropIntoEditor=128]="CanDropIntoEditor",Z[Z.MultipleEditors=256]="MultipleEditors",Z[Z.Scratchpad=512]="Scratchpad"})(E||(e.EditorInputCapabilities=E={}));class D extends O.$Tc{}e.$dG=D;function b(Z){return Z instanceof D}function k(Z){const q=Z;return P.URI.isUri(q?.preferredResource)}function C(Z){const q=Z;return b(q?.primary)&&b(q?.secondary)}function f(Z){const q=Z;return b(q?.modified)&&b(q?.original)}function w(Z,q,te,ve,ce){return Le(ve,[(0,y.$mj)({id:"workbench.action.openLargeFile",label:(0,v.localize)(12381,null),run:()=>{const we={...te,limits:{size:Number.MAX_VALUE}};Z.openEditor(q,we)}}),(0,y.$mj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(12382,null),run:()=>ce.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}function M(Z){return b(Z?.editor)}function N(Z){const q=Z;return M(Z)&&q?.group!==void 0}function L(Z){const q=Z;return typeof q?.groupId=="number"&&b(q.editor)}function W(Z){return typeof Z?.groupId=="number"}var G;(function(Z){Z[Z.UNKNOWN=0]="UNKNOWN",Z[Z.REPLACE=1]="REPLACE",Z[Z.MOVE=2]="MOVE",Z[Z.UNPIN=3]="UNPIN"})(G||(e.EditorCloseContext=G={}));var F;(function(Z){Z[Z.GROUP_ACTIVE=0]="GROUP_ACTIVE",Z[Z.GROUP_INDEX=1]="GROUP_INDEX",Z[Z.GROUP_LABEL=2]="GROUP_LABEL",Z[Z.GROUP_LOCKED=3]="GROUP_LOCKED",Z[Z.EDITORS_SELECTION=4]="EDITORS_SELECTION",Z[Z.EDITOR_OPEN=5]="EDITOR_OPEN",Z[Z.EDITOR_CLOSE=6]="EDITOR_CLOSE",Z[Z.EDITOR_MOVE=7]="EDITOR_MOVE",Z[Z.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Z[Z.EDITOR_LABEL=9]="EDITOR_LABEL",Z[Z.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Z[Z.EDITOR_PIN=11]="EDITOR_PIN",Z[Z.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Z[Z.EDITOR_STICKY=13]="EDITOR_STICKY",Z[Z.EDITOR_DIRTY=14]="EDITOR_DIRTY",Z[Z.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var K;(function(Z){Z[Z.PRIMARY=1]="PRIMARY",Z[Z.SECONDARY=2]="SECONDARY",Z[Z.BOTH=3]="BOTH",Z[Z.ANY=4]="ANY"})(K||(e.SideBySideEditor=K={}));class Y{getOriginalUri(q,te){if(!q)return;if(u(q))return e.$nG.getOriginalUri(q.result,te);if(te?.supportSideBySide){const{primary:ce,secondary:we}=this.a(q);if(ce&&we){if(te?.supportSideBySide===K.BOTH)return{primary:this.getOriginalUri(ce,{filterByScheme:te.filterByScheme}),secondary:this.getOriginalUri(we,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===K.ANY)return this.getOriginalUri(ce,{filterByScheme:te.filterByScheme})??this.getOriginalUri(we,{filterByScheme:te.filterByScheme});q=te.supportSideBySide===K.PRIMARY?ce:we}}if(i(q)||r(q)||t(q)||u(q))return;const ve=k(q)?q.preferredResource:q.resource;return!ve||!te||!te.filterByScheme?ve:this.b(ve,te.filterByScheme)}a(q){return C(q)||t(q)?{primary:q.primary,secondary:q.secondary}:f(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,te){if(!q)return;if(u(q))return e.$nG.getCanonicalUri(q.result,te);if(te?.supportSideBySide){const{primary:ce,secondary:we}=this.a(q);if(ce&&we){if(te?.supportSideBySide===K.BOTH)return{primary:this.getCanonicalUri(ce,{filterByScheme:te.filterByScheme}),secondary:this.getCanonicalUri(we,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===K.ANY)return this.getCanonicalUri(ce,{filterByScheme:te.filterByScheme})??this.getCanonicalUri(we,{filterByScheme:te.filterByScheme});q=te.supportSideBySide===K.PRIMARY?ce:we}}if(i(q)||r(q)||t(q)||u(q))return;const ve=q.resource;return!ve||!te||!te.filterByScheme?ve:this.b(ve,te.filterByScheme)}b(q,te){if(Array.isArray(te)){if(te.some(ve=>q.scheme===ve))return q}else if(te===q.scheme)return q}}var le;(function(Z){Z[Z.UNKNOWN=0]="UNKNOWN",Z[Z.KEYBOARD=1]="KEYBOARD",Z[Z.MOUSE=2]="MOUSE"})(le||(e.EditorCloseMethod=le={}));function _(Z,q,te,ve){if(!Z.isSticky(q))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return te===le.MOUSE||te===le.KEYBOARD;case"mouse":return te===le.MOUSE;case"keyboard":return te===le.KEYBOARD}return!1}e.$nG=new Y;var ge;(function(Z){Z[Z.LEFT=0]="LEFT",Z[Z.RIGHT=1]="RIGHT"})(ge||(e.CloseDirection=ge={}));class se{constructor(){this.c=new Map,this.d=new Map}start(q){const te=this.a=q.get(R.$Bi);for(const[ve,ce]of this.c)this.e(ve,ce,te);this.c.clear()}e(q,te,ve){const ce=ve.createInstance(te);this.d.set(q,ce)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,I.$ng)(this.b)}registerEditorSerializer(q,te){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,te,this.a):this.c.set(q,te),(0,O.$Rc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}T.$oo.add(e.$1F.EditorFactory,new se);async function ae(Z,q,te){return!Z||!Z.length?[]:await Promise.all(Z.map(async ve=>{const ce=P.URI.revive(ve.fileUri);if(!ce){te.info("Cannot resolve the path because it is not valid.",ve);return}if(!await q.canHandleResource(ce)){te.info("Cannot resolve the path because it cannot be handled",ve);return}let ue=ve.exists,X=ve.type;if(typeof ue!="boolean"||typeof X!="number")try{X=(await q.stat(ce)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ue=!0}catch(me){te.error(me),ue=!1}if(!ue&&ve.openOnlyIfExists){te.info("Cannot resolve the path because it does not exist",ve);return}if(X===$.FileType.Directory){te.info("Cannot resolve the path because it is a directory",ve);return}const x={...ve.options,pinned:!0};return ue?{resource:ce,options:x}:{resource:ce,options:x,forceUntitled:!0}}))}var $e;(function(Z){Z[Z.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Z[Z.SEQUENTIAL=1]="SEQUENTIAL"})($e||(e.EditorsOrder=$e={}));function oe(Z){const q=Z;if(!q)return!1;const te=q;if(te.modified)return oe(te.modified);const ve=q;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function Ce(Z){return(0,A.$oj)(Z)}function Le(Z,q,te){const ve=(0,A.$pj)(Z,q);return ve.forceMessage=te?.forceMessage,ve.forceSeverity=te?.forceSeverity,ve.allowDialog=te?.allowDialog,ve}}),define(Oe[192],Ne([1,0,6,9,3,4,28,30,25,97,182]),function(be,e,v,I,P,O,R,T,$,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zG=e.$yG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$xG=e.ViewContentGroups=e.$vG=e.ViewContainerLocation=e.Extensions=e.$uG=e.$tG=e.$sG=void 0,e.$wG=S,e.$sG="views",e.$tG=(0,I.localize)(12219,null),e.$uG=(0,A.$yx)("default-view-icon",s.$2j.window,(0,I.localize)(12220,null));var y;(function(g){g.ViewContainersRegistry="workbench.registry.view.containers",g.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var a;(function(g){g[g.Sidebar=0]="Sidebar",g[g.Panel=1]="Panel",g[g.AuxiliaryBar=2]="AuxiliaryBar"})(a||(e.ViewContainerLocation=a={})),e.$vG=[a.Sidebar,a.Panel,a.AuxiliaryBar];function S(g){switch(g){case a.Sidebar:return"sidebar";case a.Panel:return"panel";case a.AuxiliaryBar:return"auxiliarybar"}}class d extends O.$Tc{constructor(){super(...arguments),this.c=this.B(new v.$je),this.onDidRegister=this.c.event,this.f=this.B(new v.$je),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(u,m,p){const h=this.get(u.id);if(h)return h;const E=u;return E.openCommandActionDescriptor=p?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,R.$wc)(this.g,m,[]).push(E),p?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:m}),E}deregisterViewContainer(u){for(const m of this.g.keys()){const p=this.g.get(m),h=p?.indexOf(u);if(h!==-1){p?.splice(h,1),p.length===0&&this.g.delete(m),this.f.fire({viewContainer:u,viewContainerLocation:m});return}}}get(u){return this.all.filter(m=>m.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(m=>this.getViewContainers(m).filter(p=>p?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(m=>this.getViewContainerLocation(m)===u)}}T.$oo.add(y.ViewContainersRegistry,new d);var n;(function(g){g.Open="2_open",g.Debug="4_debug",g.SCM="5_scm",g.More="9_more"})(n||(e.ViewContentGroups=n={}));function o(g,u){const m=g.group??n.More,p=u.group??n.More;return m!==p?m.localeCompare(p):(g.order??5)-(u.order??5)}class c extends O.$Tc{constructor(){super(...arguments),this.c=this.B(new v.$je),this.onViewsRegistered=this.c.event,this.f=this.B(new v.$je),this.onViewsDeregistered=this.f.event,this.g=this.B(new v.$je),this.onDidChangeContainer=this.g.event,this.h=this.B(new v.$je),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(u,m){this.registerViews2([{views:u,viewContainer:m}])}registerViews2(u){u.forEach(({views:m,viewContainer:p})=>this.r(m,p)),this.c.fire(u)}deregisterViews(u,m){const p=this.s(u,m);p.length&&this.f.fire({views:p,viewContainer:m})}moveViews(u,m){for(const p of this.m.keys())if(p!==m){const h=this.s(u,p);h.length&&(this.r(h,m),this.g.fire({views:h,from:p,to:m}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const m of this.j){const p=(this.m.get(m)||[]).filter(h=>h.id===u)[0];if(p)return p}return null}getViewContainer(u){for(const m of this.j)if((this.m.get(m)||[]).filter(h=>h.id===u)[0])return m;return null}registerViewWelcomeContent(u,m){return this.n.add(u,m),this.h.fire(u),(0,O.$Rc)(()=>{this.n.delete(u,m),this.h.fire(u)})}registerViewWelcomeContent2(u,m){const p=new Map;for(const[h,E]of m)this.n.add(u,E),p.set(h,(0,O.$Rc)(()=>{this.n.delete(u,E),this.h.fire(u)}));return this.h.fire(u),p}getViewWelcomeContent(u){const m=[];return this.n.forEach(u,p=>m.push(p)),m.sort(o)}r(u,m){let p=this.m.get(m);p||(p=[],this.m.set(m,p),this.j.push(m));for(const h of u){if(this.getView(h.id)!==null)throw new Error((0,I.localize)(12221,null,h.id));p.push(h)}}s(u,m){const p=this.m.get(m);if(!p)return[];const h=[],E=[];for(const D of p)u.includes(D)?h.push(D):E.push(D);return h.length&&(E.length?this.m.set(m,E):(this.m.delete(m),this.j.splice(this.j.indexOf(m),1))),h}}T.$oo.add(y.ViewsRegistry,new c),e.$xG=(0,P.$Ci)("viewDescriptorService");var l;(function(g){g[g.Default=0]="Default",g[g.Expand=1]="Expand"})(l||(e.ViewVisibilityState=l={}));var i;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class r{constructor(u,m){this.c=!1,this.d=!1,(0,$.$eo)(this,u),this.d=!!m,this.resolve=async p=>{if(m&&!this.c){const h=await m(p);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}p.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$yG=r;class t extends Error{constructor(u){super((0,I.localize)(12222,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$zG=t}),define(Oe[193],Ne([1,0,9,31]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=void 0,e.$DG=new I.$Tj("chatSessionResponseVote","",{type:"string",description:(0,v.localize)(8342,null)}),e.$EG=new I.$Tj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,v.localize)(8343,null)}),e.$FG=new I.$Tj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,v.localize)(8344,null)}),e.$GG=new I.$Tj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,v.localize)(8345,null)}),e.$HG=new I.$Tj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,v.localize)(8346,null)}),e.$IG=new I.$Tj("chatResponse",!1,{type:"boolean",description:(0,v.localize)(8347,null)}),e.$JG=new I.$Tj("chatRequest",!1,{type:"boolean",description:(0,v.localize)(8348,null)}),e.$KG=new I.$Tj("chatEditApplied",!1,{type:"boolean",description:(0,v.localize)(8349,null)}),e.$LG=new I.$Tj("chatInputHasText",!1,{type:"boolean",description:(0,v.localize)(8350,null)}),e.$MG=new I.$Tj("chatInputHasFocus",!1,{type:"boolean",description:(0,v.localize)(8351,null)}),e.$NG=new I.$Tj("inChatInput",!1,{type:"boolean",description:(0,v.localize)(8352,null)}),e.$OG=new I.$Tj("inChat",!1,{type:"boolean",description:(0,v.localize)(8353,null)}),e.$PG=new I.$Tj("chatIsEnabled",!1,{type:"boolean",description:(0,v.localize)(8354,null)}),e.$QG=new I.$Tj("chatCursorAtTop",!1),e.$RG=new I.$Tj("chatInputHasAgent",!1),e.$SG=new I.$Tj("chatLocation",void 0),e.$TG=new I.$Tj("quickChatHasFocus",!1,{type:"boolean",description:(0,v.localize)(8355,null)})}),define(Oe[115],Ne([1,0,283,10,21,6,39,4,40,143,12,31,18,3,11,108,176,187,193]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.ChatAgentLocation=void 0,e.$XH=m,e.$YH=p;var r;(function(h){h.Panel="panel",h.Terminal="terminal",h.Notebook="notebook",h.Editor="editor"})(r||(e.ChatAgentLocation=r={})),function(h){function E(D){switch(D){case"panel":return h.Panel;case"terminal":return h.Terminal;case"notebook":return h.Notebook;case"editor":return h.Editor}return h.Panel}h.fromRaw=E}(r||(e.ChatAgentLocation=r={})),e.$SH=(0,S.$Ci)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(E){this.f=E,this.b=new Map,this.d=new O.$je,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=l.$PG.bindTo(this.f)}registerAgent(E,D){if(this.getAgent(E))throw new Error(`Agent already registered: ${JSON.stringify(E)}`);const k=this,C=D.slashCommands;D={...D,get slashCommands(){return C.filter(w=>!w.when||k.f.contextMatchesRules(y.$Aj.deserialize(w.when)))}};const f={data:D};return this.b.set(E,f),(0,T.$Rc)(()=>{this.b.delete(E),this.d.fire(void 0)})}registerAgentImplementation(E,D){const b=this.b.get(E);if(!b)throw new Error(`Unknown agent: ${JSON.stringify(E)}`);if(b.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(E)}`);return b.data.isDefault&&this.e.set(!0),b.impl=D,this.d.fire(new g(b.data,D)),(0,T.$Rc)(()=>{b.impl=void 0,this.d.fire(void 0),b.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(E,D){E.isDynamic=!0;const b={data:E,impl:D};return this.b.set(E.id,b),this.d.fire(new g(E,D)),(0,T.$Rc)(()=>{this.b.delete(E.id),this.d.fire(void 0)})}registerAgentCompletionProvider(E,D){return this.g.set(E,D),{dispose:()=>{this.g.delete(E)}}}async getAgentCompletionItems(E,D,b){return await this.g.get(E)?.(D,b)??[]}updateAgent(E,D){const b=this.b.get(E);if(!b?.impl)throw new Error(`No activated agent with id ${JSON.stringify(E)} registered`);b.data.metadata={...b.data.metadata,...D},this.d.fire(new g(b.data,b.impl))}getDefaultAgent(E){return(0,v.$eb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(E))}getContributedDefaultAgent(E){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(E))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getAgent(E){if(this.h(E))return this.b.get(E)?.data}h(E){const D=this.b.get(E);return!D?.data.when||this.f.contextMatchesRules(y.$Aj.deserialize(D.data.when))}getAgentByFullyQualifiedId(E){const D=R.Iterable.find(this.b.values(),b=>m(b.data)===E)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(E=>E.data).filter(E=>this.h(E.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).filter(E=>this.h(E.data.id)).map(E=>new g(E.data,E.impl))}getAgentsByName(E){return this.getAgents().filter(D=>D.name===E)}agentHasDupeName(E){const D=this.getAgent(E);return D?this.getAgentsByName(D.name).filter(b=>b.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(E,D,b,k,C){const f=this.b.get(E);if(!f?.impl)throw new Error(`No activated agent with id "${E}"`);return await f.impl.invoke(D,b,k,C)}async getFollowups(E,D,b,k,C){const f=this.b.get(E);if(!f?.impl)throw new Error(`No activated agent with id "${E}"`);return f.impl?.provideFollowups?f.impl.provideFollowups(D,b,k,C):[]}};e.$TH=t,e.$TH=t=Ge([Ve(0,y.$Uj)],t);class g{constructor(E,D){this.b=E,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}async invoke(E,D,b,k){return this.d.invoke(E,D,b,k)}async provideFollowups(E,D,b,k){return this.d.provideFollowups?this.d.provideFollowups(E,D,b,k):[]}provideWelcomeMessage(E,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E,D)}provideSampleQuestions(E,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E,D)}}e.$UH=g,e.$VH=(0,S.$Ci)("chatAgentNameService");let u=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(E,D,b,k){if(this.g=D,this.h=b,this.i=k,this.e=(0,s.$4d)(this,Object.create(null)),this.f=!1,!E.chatParticipantRegistry)return;this.d=E.chatParticipantRegistry;const C=k.get(i.b,c.StorageScope.APPLICATION);try{this.e.set(JSON.parse(C??"{}"),void 0)}catch{k.remove(i.b,c.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(E=>this.h.warn("Failed to fetch chat participant registry",E)).then(()=>(0,I.$Dh)(5*60*1e3)).then(()=>this.j())}async k(){const E=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(E.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,o.$$p)(E);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const b=D.restrictedChatParticipants;this.e.set(b,void 0),this.i.store(i.b,JSON.stringify(b),c.StorageScope.APPLICATION,c.StorageTarget.MACHINE)}getAgentNameRestriction(E){const D=this.l(E.name,E).get(),b=!E.fullName||this.l(E.fullName.replace(/\s/g,""),E).get();return D&&b}l(E,D){return this.e.map(k=>k[E.toLowerCase()]).map(k=>k?k.some(C=>(0,A.$Df)(C,C.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$WH=u,e.$WH=u=i=Ge([Ve(0,n.$qk),Ve(1,o.$5p),Ve(2,d.$0j),Ve(3,c.$fq)],u);function m(h){return`${h.extensionId.value}.${h.id}`}function p(h){const E="name"in h?h:{...h,name:h.id};return"extensionPublisherId"in E||(E.extensionPublisherId=E.extensionPublisher??""),"extensionDisplayName"in E||(E.extensionDisplayName=""),"extensionId"in E||(E.extensionId=new a.$on("")),(0,$.$_h)(E)}}),define(Oe[194],Ne([1,0,2,32,3]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rH=e.$qH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$oH=O,e.$pH=R;function O(s){return!!s&&typeof s=="object"&&"uri"in s&&s.uri instanceof v.URI&&"version"in s&&typeof s.version=="number"&&"ranges"in s&&Array.isArray(s.ranges)&&s.ranges.every(I.$Lt.isIRange)}function R(s){return!!s&&typeof s=="object"&&"documents"in s&&Array.isArray(s.documents)&&s.documents.every(O)}var T;(function(s){s[s.Down=0]="Down",s[s.Up=1]="Up"})(T||(e.ChatAgentVoteDirection=T={}));var $;(function(s){s[s.Action=1]="Action",s[s.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$qH=(0,P.$Ci)("IChatService"),e.$rH="accessibility.voice.keywordActivation"}),define(Oe[195],Ne([1,0,6,10,9]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wtb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new v.$je,this.o=new v.$je,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,$,s,A){const y={command:T};if($&&Object.keys($).length>0&&(y.arguments=$),this.u("request",y),typeof A=="number"){const a=setTimeout(()=>{clearTimeout(a);const S=this.f.get(y.seq);if(S){this.f.delete(y.seq);const d={type:"response",seq:0,request_seq:y.seq,success:!1,command:T,message:(0,P.localize)(7458,null,A,T)};S(d)}},A)}return s&&this.f.set(y.seq,s),y.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,$){return T.type!=="event"||$.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,I.$Dh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const $=T,s=this.f.get($.request_seq);s&&(this.f.delete($.request_seq),s($));break}}}}u(T,$){$.type=T,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach(($,s)=>T.set(s,$)),await(0,I.$Dh)(500),T.forEach(($,s)=>{$({type:"response",seq:0,request_seq:s,success:!1,command:"canceled",message:"canceled"}),this.f.delete(s)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Wtb=O}),define(Oe[80],Ne([1,0,2,9,31,3]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$LK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$JK=e.MemoryRangeType=e.State=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=void 0,e.$IK=$,e.$KK=A,I=We(I),e.$wJ="workbench.view.debug",e.$xJ="workbench.debug.variablesView",e.$yJ="workbench.debug.watchExpressionsView",e.$zJ="workbench.debug.callStackView",e.$AJ="workbench.debug.loadedScriptsView",e.$BJ="workbench.debug.breakPointsView",e.$CJ="workbench.debug.disassemblyView",e.$DJ="workbench.panel.repl",e.$EJ="workbench.panel.repl.view",e.$FJ=new P.$Tj("debugType",void 0,{type:"string",description:I.localize(7395,null)}),e.$GJ=new P.$Tj("debugConfigurationType",void 0,{type:"string",description:I.localize(7396,null)}),e.$HJ=new P.$Tj("debugState","inactive",{type:"string",description:I.localize(7397,null)}),e.$IJ="debugUx",e.$JJ=new P.$Tj(e.$IJ,"default",{type:"string",description:I.localize(7398,null)}),e.$KJ=new P.$Tj("hasDebugged",!1,{type:"boolean",description:I.localize(7399,null)}),e.$LJ=new P.$Tj("inDebugMode",!1,{type:"boolean",description:I.localize(7400,null)}),e.$MJ=new P.$Tj("inDebugRepl",!1,{type:"boolean",description:I.localize(7401,null)}),e.$NJ=new P.$Tj("breakpointWidgetVisible",!1,{type:"boolean",description:I.localize(7402,null)}),e.$OJ=new P.$Tj("inBreakpointWidget",!1,{type:"boolean",description:I.localize(7403,null)}),e.$PJ=new P.$Tj("breakpointsFocused",!0,{type:"boolean",description:I.localize(7404,null)}),e.$QJ=new P.$Tj("watchExpressionsFocused",!0,{type:"boolean",description:I.localize(7405,null)}),e.$RJ=new P.$Tj("watchExpressionsExist",!1,{type:"boolean",description:I.localize(7406,null)}),e.$SJ=new P.$Tj("variablesFocused",!0,{type:"boolean",description:I.localize(7407,null)}),e.$TJ=new P.$Tj("expressionSelected",!1,{type:"boolean",description:I.localize(7408,null)}),e.$UJ=new P.$Tj("breakpointInputFocused",!1,{type:"boolean",description:I.localize(7409,null)}),e.$VJ=new P.$Tj("callStackItemType",void 0,{type:"string",description:I.localize(7410,null)}),e.$WJ=new P.$Tj("callStackSessionIsAttach",!1,{type:"boolean",description:I.localize(7411,null)}),e.$XJ=new P.$Tj("callStackItemStopped",!1,{type:"boolean",description:I.localize(7412,null)}),e.$YJ=new P.$Tj("callStackSessionHasOneThread",!1,{type:"boolean",description:I.localize(7413,null)}),e.$ZJ=new P.$Tj("watchItemType",void 0,{type:"string",description:I.localize(7414,null)}),e.$1J=new P.$Tj("canViewMemory",void 0,{type:"boolean",description:I.localize(7415,null)}),e.$2J=new P.$Tj("breakpointItemType",void 0,{type:"string",description:I.localize(7416,null)}),e.$3J=new P.$Tj("breakpointItemBytes",void 0,{type:"boolean",description:I.localize(7417,null)}),e.$4J=new P.$Tj("breakpointHasModes",!1,{type:"boolean",description:I.localize(7418,null)}),e.$5J=new P.$Tj("breakpointSupportsCondition",!1,{type:"boolean",description:I.localize(7419,null)}),e.$6J=new P.$Tj("loadedScriptsSupported",!1,{type:"boolean",description:I.localize(7420,null)}),e.$7J=new P.$Tj("loadedScriptsItemType",void 0,{type:"string",description:I.localize(7421,null)}),e.$8J=new P.$Tj("focusedSessionIsAttach",!1,{type:"boolean",description:I.localize(7422,null)}),e.$9J=new P.$Tj("focusedSessionIsNoDebug",!1,{type:"boolean",description:I.localize(7423,null)}),e.$0J=new P.$Tj("stepBackSupported",!1,{type:"boolean",description:I.localize(7424,null)}),e.$$J=new P.$Tj("restartFrameSupported",!1,{type:"boolean",description:I.localize(7425,null)}),e.$_J=new P.$Tj("stackFrameSupportsRestart",!1,{type:"boolean",description:I.localize(7426,null)}),e.$aK=new P.$Tj("jumpToCursorSupported",!1,{type:"boolean",description:I.localize(7427,null)}),e.$bK=new P.$Tj("stepIntoTargetsSupported",!1,{type:"boolean",description:I.localize(7428,null)}),e.$cK=new P.$Tj("breakpointsExist",!1,{type:"boolean",description:I.localize(7429,null)}),e.$dK=new P.$Tj("debuggersAvailable",!1,{type:"boolean",description:I.localize(7430,null)}),e.$eK=new P.$Tj("debugExtensionAvailable",!0,{type:"boolean",description:I.localize(7431,null)}),e.$fK=new P.$Tj("debugProtocolVariableMenuContext",void 0,{type:"string",description:I.localize(7432,null)}),e.$gK=new P.$Tj("debugSetVariableSupported",!1,{type:"boolean",description:I.localize(7433,null)}),e.$hK=new P.$Tj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:I.localize(7434,null)}),e.$iK=new P.$Tj("debugSetExpressionSupported",!1,{type:"boolean",description:I.localize(7435,null)}),e.$jK=new P.$Tj("breakWhenValueChangesSupported",!1,{type:"boolean",description:I.localize(7436,null)}),e.$kK=new P.$Tj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:I.localize(7437,null)}),e.$lK=new P.$Tj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:I.localize(7438,null)}),e.$mK=new P.$Tj("terminateDebuggeeSupported",!1,{type:"boolean",description:I.localize(7439,null)}),e.$nK=new P.$Tj("suspendDebuggeeSupported",!1,{type:"boolean",description:I.localize(7440,null)}),e.$oK=new P.$Tj("variableEvaluateNamePresent",!1,{type:"boolean",description:I.localize(7441,null)}),e.$pK=new P.$Tj("variableIsReadonly",!1,{type:"boolean",description:I.localize(7442,null)}),e.$qK=new P.$Tj("variableValue",!1,{type:"string",description:I.localize(7443,null)}),e.$rK=new P.$Tj("variableType",!1,{type:"string",description:I.localize(7444,null)}),e.$sK=new P.$Tj("variableInterfaces",!1,{type:"array",description:I.localize(7445,null)}),e.$tK=new P.$Tj("variableName",!1,{type:"string",description:I.localize(7446,null)}),e.$uK=new P.$Tj("variableLanguage",!1,{type:"string",description:I.localize(7447,null)}),e.$vK=new P.$Tj("variableExtensionId",!1,{type:"string",description:I.localize(7448,null)}),e.$wK=new P.$Tj("exceptionWidgetVisible",!1,{type:"boolean",description:I.localize(7449,null)}),e.$xK=new P.$Tj("multiSessionRepl",!1,{type:"boolean",description:I.localize(7450,null)}),e.$yK=new P.$Tj("multiSessionDebug",!1,{type:"boolean",description:I.localize(7451,null)}),e.$zK=new P.$Tj("disassembleRequestSupported",!1,{type:"boolean",description:I.localize(7452,null)}),e.$AK=new P.$Tj("disassemblyViewFocus",!1,{type:"boolean",description:I.localize(7453,null)}),e.$BK=new P.$Tj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:I.localize(7454,null)}),e.$CK=new P.$Tj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:I.localize(7455,null)});const R=i=>I.localize(7456,null,i);e.$DK=R,e.$EK="editor.contrib.debug",e.$FK="editor.contrib.breakpoint",e.$GK="debug",e.$HK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:I.localize(7457,null)};var T;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(T||(e.State=T={}));function $(i){switch(i){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var s;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(s||(e.MemoryRangeType=s={})),e.$JK="vscode-debug-memory";function A(i){const r=i.presentationHint??i.source.presentationHint;return r==="deemphasize"||r==="subtle"}var y;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var a;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(a||(e.DebugConfigurationProviderTriggerKind=a={}));var S;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(S||(e.DebuggerString=S={})),e.$LK=(0,O.$Ci)("debugService");var d;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var n;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(n||(e.DebugVisualizationType=n={}));var o;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var c;(function(i){i.deserialize=r=>r,i.serialize=r=>r})(c||(e.IDebugVisualizationTreeItem=c={}));var l;(function(i){i.deserialize=r=>({id:r.id,name:r.name,iconPath:r.iconPath&&{light:v.URI.revive(r.iconPath.light),dark:v.URI.revive(r.iconPath.dark)},iconClass:r.iconClass,visualization:r.visualization}),i.serialize=r=>r})(l||(e.IDebugVisualization=l={}))}),define(Oe[196],Ne([1,0,12,2,19,25,15,32,21,17]),function(be,e,v,I,P,O,R,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dI=void 0,e.$4H=y,e.$5H=a,e.$6H=S,e.$7H=d,e.$8H=n,e.$9H=o,e.$0H=c,e.$$H=i,e.$_H=g,e.$aI=u,e.$bI=p,e.$cI=E;const A=/{([^}]+)}/g;function y(b,k,C){return b.replace(A,function(f,w){return k&&w.length>0&&w[0]!=="_"?f:C&&C.hasOwnProperty(w)?C[w]:f})}function a(b){const k={};for(const C of Object.keys(b))C.startsWith("!")||(k[C]=b[C]);return k}function S(b){return b.configuration.request==="attach"&&!d(b)&&(!b.parentSession||S(b.parentSession))}function d(b){let k=b.configuration.type;if(k)return k==="vslsShare"&&(k=b.configuration.adapterProxy.configuration.type),(0,v.$Df)(k,"extensionhost")||(0,v.$Df)(k,"pwa-extensionhost")?b:b.parentSession?d(b.parentSession):void 0}function n(b){return b.type&&(b.label||b.program||b.runtime)}function o(b,k,C){let f,w=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=M.exec(b);){const L=N.index+1,W=L+N[0].length;if(L<=k&&W>=C){f=N[0],w=L;break}}if(f){const L=/(\w|\p{L})+/gu;let W=null;for(;(W=L.exec(f))&&!(W.index+1+w+W[0].length>=C););W&&(f=f.substring(0,L.lastIndex))}return f?{start:w,end:w+f.length-1}:{start:0,end:0}}async function c(b,k,C,f){if(b.evaluatableExpressionProvider.has(k)){const w=b.evaluatableExpressionProvider.ordered(k),M=(0,s.$Gb)(await Promise.all(w.map(async N=>{try{return await N.provideEvaluatableExpression(k,C,f??$.CancellationToken.None)}catch{return}})));if(M.length>0){let N=M[0].expression;const L=M[0].range;return N||(N=k.getLineContent(C.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:N}}}else{const w=k.getLineContent(C.lineNumber),{start:M,end:N}=o(w,C.column,C.column),L=w.substring(M-1,N);return{matchingExpression:L,range:new T.$Lt(C.lineNumber,M,C.lineNumber,M+L.length)}}return null}const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(b){return!!(b&&b.match(l))}function r(b){if(typeof b.path=="string"&&!(typeof b.sourceReference=="number"&&b.sourceReference>0)){if(i(b.path))return I.URI.parse(b.path);if((0,P.$hc)(b.path))return I.URI.file(b.path)}return b.path}function t(b){if(typeof b.path=="object"){const k=I.URI.revive(b.path);if(k)return k.scheme===R.Schemas.file?k.fsPath:k.toString()}return b.path}function g(b,k){const C=k?r:t,f=(0,O.$bo)(b);return m(f,(w,M)=>{w&&M&&(M.path=C(M))}),f}function u(b,k){const C=k?r:t,f=(0,O.$bo)(b);return m(f,(w,M)=>{!w&&M&&(M.path=C(M))}),f}function m(b,k){switch(b.type){case"event":{const C=b;switch(C.event){case"output":k(!1,C.body.source);break;case"loadedSource":k(!1,C.body.source);break;case"breakpoint":k(!1,C.body.breakpoint.source);break;default:break}break}case"request":{const C=b;switch(C.command){case"setBreakpoints":k(!0,C.arguments.source);break;case"breakpointLocations":k(!0,C.arguments.source);break;case"source":k(!0,C.arguments.source);break;case"gotoTargets":k(!0,C.arguments.source);break;case"launchVSCode":C.arguments.args.forEach(f=>k(!1,f));break;default:break}break}case"response":{const C=b;if(C.success&&C.body)switch(C.command){case"stackTrace":C.body.stackFrames.forEach(f=>k(!1,f.source));break;case"loadedSources":C.body.sources.forEach(f=>k(!1,f));break;case"scopes":C.body.scopes.forEach(f=>k(!1,f.source));break;case"setFunctionBreakpoints":C.body.breakpoints.forEach(f=>k(!1,f.source));break;case"setBreakpoints":C.body.breakpoints.forEach(f=>k(!1,f.source));break;case"disassemble":C.body?.instructions.forEach(w=>k(!1,w.location));break;default:break}break}}}function p(b){return b.filter(k=>!k.presentation?.hidden).sort((k,C)=>k.presentation?C.presentation?k.presentation.group?C.presentation.group?k.presentation.group!==C.presentation.group?k.presentation.group.localeCompare(C.presentation.group):h(k.presentation.order,C.presentation.order):-1:C.presentation.group?1:h(k.presentation.order,C.presentation.order):-1:C.presentation?1:0)}function h(b,k){return typeof b!="number"?typeof k!="number"?0:1:typeof k!="number"?-1:b-k}async function E(b,k){const C=b.getValue("debug.saveBeforeStart",{overrideIdentifier:k.activeTextEditorLanguageId});if(C!=="none"&&(await k.saveAll(),C==="allEditorsInActiveGroup")){const f=k.activeEditorPane;f&&f.input.resource?.scheme===R.Schemas.untitled&&await k.save({editor:f.input,groupId:f.group.id})}await b.reloadConfiguration()}const D=(b,k)=>!b||!k?b===k:b.name===k.name&&b.path===k.path&&b.sourceReference===k.sourceReference;e.$dI=D}),define(Oe[197],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TK=e.CellExecutionUpdateType=void 0;var I;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(I||(e.CellExecutionUpdateType=I={})),e.$TK=(0,v.$Ci)("INotebookExecutionService")}),define(Oe[198],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XK=e.$WK=e.ProxyKernelState=e.$VK=void 0,e.$VK=100;var I;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(I||(e.ProxyKernelState=I={})),e.$WK=(0,v.$Ci)("INotebookKernelService"),e.$XK=(0,v.$Ci)("INotebookKernelHistoryService")}),define(Oe[199],Ne([1,0,4,32,52,162,102]),function(be,e,v,I,P,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Zb=void 0;class T extends v.$Tc{constructor(s,A,y){super(),this._source=s,this.b=A,this.c=y,this.a=void 0}f(s){const A=s.getLineCount();return new I.$Lt(1,1,A,this.g(s,A))}g(s,A){if(A<1||A>s.getLineCount())throw new Error("Illegal value for lineNumber");return s.getLineLength(A)+1}get inputTextBuffer(){if(!this.b){const s=new O.$tD;s.acceptChunk(this._source);const A=s.finish(!0),{textBuffer:y,disposable:a}=A.create(P.DefaultEndOfLine.LF);this.b=y,this.B(a)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(s=>{const A=new O.$tD;A.acceptChunk(s);const y=A.finish(!0),{textBuffer:a,disposable:S}=y.create(P.DefaultEndOfLine.LF);return this.B(S),a})),this.a}findInInputs(s){const y=new R.$hD(s,!1,!1,null).parseSearchRequest();if(!y)return[];const a=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(a,y,!0,5e3)}findInOutputs(s){const y=new R.$hD(s,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(a=>{const S=a.findMatchesLineByLine(this.f(a),y,!0,5e3);if(S.length!==0)return{textBuffer:a,matches:S}}).filter(a=>!!a):[]}}e.$1Zb=T}),define(Oe[54],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3I=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(O){O.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var I;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(I||(e.TestPosition=I={}));class P{static fromExtHostTestItem(R,T,$=R.parent){if(R._isRoot)return new P([T]);const s=[R.id];for(let A=$;A&&A.id!==T;A=A.parent)s.push(A.id);return s.push(T),new P(s.reverse())}static isRoot(R){return!R.includes(v.Delimiter)}static root(R){const T=R.indexOf(v.Delimiter);return T===-1?R:R.slice(0,T)}static fromString(R){return new P(R.split(v.Delimiter))}static join(R,T){return new P([...R.path,T])}static joinToString(R,T){return R.toString()+v.Delimiter+T}static parentId(R){const T=R.lastIndexOf(v.Delimiter);return T===-1?void 0:R.slice(0,T)}static localId(R){const T=R.lastIndexOf(v.Delimiter);return T===-1?R:R.slice(T+v.Delimiter.length)}static isChild(R,T){return T[R.length]===v.Delimiter&&T.startsWith(R)}static compare(R,T){return R===T?I.IsSame:P.isChild(R,T)?I.IsChild:P.isChild(T,R)?I.IsParent:I.Disconnected}static getLengthOfCommonPrefix(R,T){if(R===0)return 0;let $=0;for(;$<R-1;){for(let s=1;s<R;s++){const A=T(s-1),y=T(s);if(A.path[$]!==y.path[$])return $}$++}return $}constructor(R,T=R.length){if(this.path=R,this.d=T,R.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new P(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new P(this.path,R)}compare(R){if(typeof R=="string")return P.compare(this.toString(),R);for(let T=0;T<R.d&&T<this.d;T++)if(R.path[T]!==this.path[T])return I.Disconnected;return R.d>this.d?I.IsChild:R.d<this.d?I.IsParent:I.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+=v.Delimiter,this.c+=this.path[R]}return this.c}}e.$3I=P}),define(Oe[55],Ne([1,0,2,101,32,54]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$$I=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$0I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$9I=e.$8I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$7I=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$6I=e.$5I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$4I=e.TestResultState=void 0;var R;(function(F){F[F.Unset=0]="Unset",F[F.Queued=1]="Queued",F[F.Running=2]="Running",F[F.Passed=3]="Passed",F[F.Failed=4]="Failed",F[F.Skipped=5]="Skipped",F[F.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$4I={[R.Unset]:"unset",[R.Queued]:"queued",[R.Running]:"running",[R.Passed]:"passed",[R.Failed]:"failed",[R.Skipped]:"skipped",[R.Errored]:"errored"};var T;(function(F){F[F.Run=1]="Run",F[F.Debug=2]="Debug",F[F.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var $;(function(F){F[F.Run=2]="Run",F[F.Debug=4]="Debug",F[F.Coverage=8]="Coverage",F[F.HasNonDefaultProfile=16]="HasNonDefaultProfile",F[F.HasConfigurable=32]="HasConfigurable",F[F.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$5I=[$.Run,$.Debug,$.Coverage,$.HasNonDefaultProfile,$.HasConfigurable,$.SupportsContinuousRun];const s=F=>"runId"in F;e.$6I=s;var A;(function(F){F.serialize=K=>({range:K.range.toJSON(),uri:K.uri.toJSON()}),F.deserialize=(K,Y)=>({range:P.$Lt.lift(Y.range),uri:K.asCanonicalUri(v.URI.revive(Y.uri))})})(A||(e.IRichLocation=A={}));var y;(function(F){F[F.Error=0]="Error",F[F.Output=1]="Output"})(y||(e.TestMessageType=y={}));var a;(function(F){F.serialize=K=>({label:K.label,uri:K.uri?.toJSON(),position:K.position?.toJSON()}),F.deserialize=(K,Y)=>({label:Y.label,uri:Y.uri?K.asCanonicalUri(v.URI.revive(Y.uri)):void 0,position:Y.position?I.$Kt.lift(Y.position):void 0})})(a||(e.ITestMessageStackFrame=a={}));var S;(function(F){F.serialize=K=>({message:K.message,type:y.Error,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&A.serialize(K.location),stackTrace:K.stackTrace?.map(a.serialize)}),F.deserialize=(K,Y)=>({message:Y.message,type:y.Error,expected:Y.expected,actual:Y.actual,contextValue:Y.contextValue,location:Y.location&&A.deserialize(K,Y.location),stackTrace:Y.stackTrace&&Y.stackTrace.map(le=>a.deserialize(K,le))})})(S||(e.ITestErrorMessage=S={}));const d=(F,K)=>`${K?"s":"e"}${F}`;e.$7I=d;var n;(function(F){F.serialize=K=>({message:K.message,type:y.Output,offset:K.offset,length:K.length,location:K.location&&A.serialize(K.location)}),F.deserialize=(K,Y)=>({message:Y.message,type:y.Output,offset:Y.offset,length:Y.length,location:Y.location&&A.deserialize(K,Y.location)})})(n||(e.ITestOutputMessage=n={}));var o;(function(F){F.serialize=K=>K.type===y.Error?S.serialize(K):n.serialize(K),F.deserialize=(K,Y)=>Y.type===y.Error?S.deserialize(K,Y):n.deserialize(K,Y),F.isDiffable=K=>K.type===y.Error&&K.actual!==void 0&&K.expected!==void 0})(o||(e.ITestMessage=o={}));var c;(function(F){F.serializeWithoutMessages=K=>({state:K.state,duration:K.duration,messages:[]}),F.serialize=K=>({state:K.state,duration:K.duration,messages:K.messages.map(o.serialize)}),F.deserialize=(K,Y)=>({state:Y.state,duration:Y.duration,messages:Y.messages.map(le=>o.deserialize(K,le))})})(c||(e.ITestTaskState=c={}));const l="\0",i=(F,K)=>F+l+K;e.$8I=i;const r=F=>{const K=F.indexOf(l);return{ctrlId:F.slice(0,K),tagId:F.slice(K+1)}};e.$9I=r;var t;(function(F){F.serialize=K=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?.toJSON(),range:K.range?.toJSON()||null,description:K.description,error:K.error,sortText:K.sortText}),F.deserialize=(K,Y)=>({extId:Y.extId,label:Y.label,tags:Y.tags,busy:Y.busy,children:void 0,uri:Y.uri?K.asCanonicalUri(v.URI.revive(Y.uri)):void 0,range:Y.range?P.$Lt.lift(Y.range):null,description:Y.description,error:Y.error,sortText:Y.sortText})})(t||(e.ITestItem=t={}));var g;(function(F){F[F.NotExpandable=0]="NotExpandable",F[F.Expandable=1]="Expandable",F[F.BusyExpanding=2]="BusyExpanding",F[F.Expanded=3]="Expanded"})(g||(e.TestItemExpandState=g={}));var u;(function(F){F.serialize=K=>({expand:K.expand,item:t.serialize(K.item)}),F.deserialize=(K,Y)=>({controllerId:O.$3I.root(Y.item.extId),expand:Y.expand,item:t.deserialize(K,Y.item)})})(u||(e.InternalTestItem=u={}));var m;(function(F){F.serialize=K=>{let Y;return K.item&&(Y={},K.item.label!==void 0&&(Y.label=K.item.label),K.item.tags!==void 0&&(Y.tags=K.item.tags),K.item.busy!==void 0&&(Y.busy=K.item.busy),K.item.uri!==void 0&&(Y.uri=K.item.uri?.toJSON()),K.item.range!==void 0&&(Y.range=K.item.range?.toJSON()),K.item.description!==void 0&&(Y.description=K.item.description),K.item.error!==void 0&&(Y.error=K.item.error),K.item.sortText!==void 0&&(Y.sortText=K.item.sortText)),{extId:K.extId,expand:K.expand,item:Y}},F.deserialize=K=>{let Y;return K.item&&(Y={},K.item.label!==void 0&&(Y.label=K.item.label),K.item.tags!==void 0&&(Y.tags=K.item.tags),K.item.busy!==void 0&&(Y.busy=K.item.busy),K.item.range!==void 0&&(Y.range=K.item.range?P.$Lt.lift(K.item.range):null),K.item.description!==void 0&&(Y.description=K.item.description),K.item.error!==void 0&&(Y.error=K.item.error),K.item.sortText!==void 0&&(Y.sortText=K.item.sortText)),{extId:K.extId,expand:K.expand,item:Y}}})(m||(e.ITestItemUpdate=m={}));const p=(F,K)=>{K.expand!==void 0&&(F.expand=K.expand),K.item!==void 0&&(F.item=F.item?Object.assign(F.item,K.item):K.item)};e.$0I=p;var h;(function(F){F.serializeWithoutMessages=K=>({...u.serialize(K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(c.serializeWithoutMessages)}),F.serialize=K=>({...u.serialize(K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(c.serialize)}),F.deserialize=(K,Y)=>({...u.deserialize(K,Y),ownComputedState:Y.ownComputedState,computedState:Y.computedState,tasks:Y.tasks.map(le=>c.deserialize(K,le)),retired:!0})})(h||(e.TestResultItem=h={}));var E;(function(F){F.empty=()=>({covered:0,total:0}),F.sum=(K,Y)=>{K.covered+=Y.covered,K.total+=Y.total}})(E||(e.ICoverageCount=E={}));var D;(function(F){F.serialize=K=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,testIds:K.testIds,uri:K.uri.toJSON()}),F.deserialize=(K,Y)=>({id:Y.id,statement:Y.statement,branch:Y.branch,declaration:Y.declaration,testIds:Y.testIds,uri:K.asCanonicalUri(v.URI.revive(Y.uri))}),F.empty=(K,Y)=>({id:K,uri:Y,statement:E.empty()})})(D||(e.IFileCoverage=D={}));function b(F){return{...F,location:F.location?.toJSON()}}function k(F){return F.location=F.location?I.$Kt.isIPosition(F.location)?I.$Kt.lift(F.location):P.$Lt.lift(F.location):void 0,F}e.$$I=3;var C;(function(F){F[F.Declaration=0]="Declaration",F[F.Statement=1]="Statement",F[F.Branch=2]="Branch"})(C||(e.DetailType=C={}));var f;(function(F){F.serialize=K=>K.type===C.Declaration?M.serialize(K):N.serialize(K),F.deserialize=K=>K.type===C.Declaration?M.deserialize(K):N.deserialize(K)})(f||(e.CoverageDetails=f={}));var w;(function(F){F.serialize=b,F.deserialize=k})(w||(e.IBranchCoverage=w={}));var M;(function(F){F.serialize=b,F.deserialize=k})(M||(e.IDeclarationCoverage=M={}));var N;(function(F){F.serialize=K=>({...b(K),branches:K.branches?.map(w.serialize)}),F.deserialize=K=>({...k(K),branches:K.branches?.map(w.deserialize)})})(N||(e.IStatementCoverage=N={}));var L;(function(F){F[F.Add=0]="Add",F[F.Update=1]="Update",F[F.DocumentSynced=2]="DocumentSynced",F[F.Remove=3]="Remove",F[F.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",F[F.Retire=5]="Retire",F[F.AddTag=6]="AddTag",F[F.RemoveTag=7]="RemoveTag"})(L||(e.TestDiffOpType=L={}));var W;(function(F){F.deserialize=(K,Y)=>Y.op===L.Add?{op:Y.op,item:u.deserialize(K,Y.item)}:Y.op===L.Update?{op:Y.op,item:m.deserialize(Y.item)}:Y.op===L.DocumentSynced?{op:Y.op,uri:K.asCanonicalUri(v.URI.revive(Y.uri)),docv:Y.docv}:Y,F.serialize=K=>K.op===L.Add?{op:K.op,item:u.serialize(K.item)}:K.op===L.Update?{op:K.op,item:m.serialize(K.item)}:K})(W||(e.TestsDiffOp=W={}));class G{constructor(K){this.k=K,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(K){const Y=this.w();for(const le of K)switch(le.op){case L.Add:this.l(u.deserialize(this.k,le.item),Y);break;case L.Update:this.p(m.deserialize(le.item),Y);break;case L.Remove:this.q(le.itemId,Y);break;case L.Retire:this.v(le.itemId);break;case L.IncrementPendingExtHosts:this.updatePendingRoots(le.amount);break;case L.AddTag:this.c.set(le.tag.id,le.tag);break;case L.RemoveTag:this.c.delete(le.id);break}Y.complete?.()}l(K,Y){const le=O.$3I.parentId(K.item.extId)?.toString();let _;if(!le)_=this.x(K),this.g.add(_),this.f.set(K.item.extId,_);else if(this.f.has(le)){const ge=this.f.get(le);ge.children.add(K.item.extId),_=this.x(K,ge),this.f.set(K.item.extId,_)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(K)}`);return}return Y.add?.(_),K.expand===g.BusyExpanding&&this.h++,_}p(K,Y){const le=this.f.get(K.extId);if(le)return K.expand!==void 0&&(le.expand===g.BusyExpanding&&this.h--,K.expand===g.BusyExpanding&&this.h++),(0,e.$0I)(le,K),Y.update?.(le),le}q(K,Y){const le=this.f.get(K);if(!le)return;const _=O.$3I.parentId(le.item.extId)?.toString();_?this.f.get(_).children.delete(le.item.extId):this.g.delete(le);const ge=[[K]];for(;ge.length;)for(const se of ge.pop()){const ae=this.f.get(se);ae&&(ge.push(ae.children),this.f.delete(se),Y.remove?.(ae,ae!==le),ae.expand===g.BusyExpanding&&this.h--)}}v(K){}updatePendingRoots(K){this.j+=K}w(){return{}}}e.$_I=G}),define(Oe[200],Ne([1,0,98,9,55]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$BGb=e.$AGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var R;(function(y){y.List="list",y.Tree="true"})(R||(e.TestExplorerViewMode=R={}));var T;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const $={[P.TestResultState.Errored]:(0,I.localize)(3158,null),[P.TestResultState.Failed]:(0,I.localize)(3159,null),[P.TestResultState.Passed]:(0,I.localize)(3160,null),[P.TestResultState.Queued]:(0,I.localize)(3161,null),[P.TestResultState.Running]:(0,I.localize)(3162,null),[P.TestResultState.Skipped]:(0,I.localize)(3163,null),[P.TestResultState.Unset]:(0,I.localize)(3164,null)},s=(y,a)=>(0,I.localize)(3165,null,(0,v.$Wk)(y),$[a]);e.$AGb=s,e.$BGb={[P.TestRunProfileBitset.Debug]:(0,I.localize)(3166,null),[P.TestRunProfileBitset.Run]:(0,I.localize)(3167,null),[P.TestRunProfileBitset.Coverage]:(0,I.localize)(3168,null)};var A;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(A||(e.TestCommandId=A={}))}),define(Oe[81],Ne([1,0,10,6,4,61,55,54]),function(be,e,v,I,P,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9P=e.$8P=e.$7P=e.$6P=e.$5P=e.TestItemEventOp=void 0;var $;(function(l){l[l.Upsert=0]="Upsert",l[l.SetTags=1]="SetTags",l[l.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",l[l.RemoveChild=3]="RemoveChild",l[l.SetProp=4]="SetProp",l[l.Bulk=5]="Bulk",l[l.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const s=(l,i)=>l===i,y=Object.entries({range:(l,i)=>l===i?!0:!l||!i?!1:l.equalsRange(i),busy:s,label:s,description:s,error:s,sortText:s,tags:(l,i)=>!(l.length!==i.length||l.some(r=>!i.includes(r)))}),a=(l,i)=>{let r;for(const[t,g]of y)g(l[t],i[t])||(r?r[t]=i[t]:r={[t]:i[t]});return r};class S extends P.$Tc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new v.$Oh(()=>this.flushDiff(),200)),this.g=this.B(new I.$je),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case R.TestDiffOpType.DocumentSynced:{for(const r of this.m)if(r.op===R.TestDiffOpType.DocumentSynced&&r.uri===i.uri){r.docv=i.docv;return}break}case R.TestDiffOpType.Update:{const r=this.m[this.m.length-1];if(r){if(r.op===R.TestDiffOpType.Update&&r.item.extId===i.item.extId){(0,R.$0I)(r.item,i.item);return}if(r.op===R.TestDiffOpType.Add&&r.item.item.extId===i.item.extId){(0,R.$0I)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||r>t.expandLevels)&&(t.expandLevels=r),t.expand===R.TestItemExpandState.Expandable){const g=this.M(t);return g.isOpen()?this.L(t,r-1):g.wait().then(()=>this.L(t,r-1))}else if(t.expand===R.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,r-1)):this.L(t,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case $.RemoveChild:this.O(T.$3I.joinToString(i.fullId,r.id));break;case $.Upsert:this.z(r.item,i);break;case $.Bulk:for(const t of r.ops)this.w(i,t);break;case $.SetTags:this.C(r.new,r.old,i.fullId.toString());break;case $.UpdateCanResolveChildren:this.J(i);break;case $.SetProp:this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:r.update}});break;case $.DocumentSynced:this.y(i.actual.uri);break;default:(0,O.$dd)(r)}}y(i){i&&this.pushDiff({op:R.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const t=T.$3I.fromExtHostTestItem(i,this.root.id,r?.actual),g=this.s.getApiFor(i);g.parent&&g.parent!==r?.actual&&this.s.getChildren(g.parent).delete(i.id);let u=this.tree.get(t.toString());if(!u){u={fullId:t,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:R.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(u.fullId.toString(),u),this.G(i,r),this.pushDiff({op:R.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:u.expand,item:this.s.toITestItem(i)}}),this.I(i,u,r);return}if(u.actual===i){this.H(i,u,r);return}if(u.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,r);const m=this.s.getChildren(u.actual),p=u.actual,h=a(this.s.toITestItem(p),this.s.toITestItem(i));this.s.getApiFor(p).listener=void 0,u.actual=i,u.resolveBarrier=void 0,u.expand=R.TestItemExpandState.NotExpandable,h&&(h.hasOwnProperty("tags")&&(this.C(i.tags,p.tags,t.toString()),delete h.tags),this.w(u,{op:$.SetProp,update:h})),this.I(i,u,r);for(const[D,b]of m)this.s.getChildren(i).get(b.id)||this.O(T.$3I.joinToString(t,b.id));const E=u.expandLevels;E!==void 0&&queueMicrotask(()=>{u.expand===R.TestItemExpandState.Expandable&&(u.expandLevels=void 0,this.expand(t.toString(),E))}),this.y(u.actual.uri)}C(i,r,t){const g=new Set(r.map(u=>u.id));for(const u of i)g.delete(u.id)||this.D(u);this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(u=>(0,R.$8I)(this.s.controllerId,u.id))}}}),g.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:R.TestDiffOpType.AddTag,tag:{id:(0,R.$8I)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:R.TestDiffOpType.RemoveTag,id:(0,R.$8I)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,t){this.G(i,t);const g=this.s.getApiFor(i);g.parent=t?.actual,g.listener=u=>this.w(r,u),this.J(r)}I(i,r,t){this.H(i,r,t);for(const[g,u]of this.s.getChildren(i))this.z(u,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?R.TestItemExpandState.Expanded:R.TestItemExpandState.BusyExpanding:r=i.actual.canResolveChildren?R.TestItemExpandState.Expandable:R.TestItemExpandState.NotExpandable:r=R.TestItemExpandState.NotExpandable,r!==i.expand&&(i.expand=r,this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:r}}),r===R.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const t=[];for(const[g,u]of this.s.getChildren(i.actual)){const m=this.expand(T.$3I.joinToString(i.fullId,u.id),r);(0,v.$oh)(m)&&t.push(m)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const u=new v.$Bh;return u.open(),u}i.expand=R.TestItemExpandState.BusyExpanding,this.N(i);const r=i.resolveBarrier=new v.$Bh,t=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,u)};let g;try{g=this.h(i.actual===this.root?void 0:i.actual)}catch(u){t(u)}return(0,v.$oh)(g)?g.catch(t).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:R.TestDiffOpType.Remove,itemId:i});const t=[r];for(;t.length;){const g=t.pop();if(g){this.s.getApiFor(g.actual).listener=void 0;for(const u of g.actual.tags)this.F(u.id);this.tree.delete(g.fullId.toString());for(const[u,m]of this.s.getChildren(g.actual))t.push(this.tree.get(T.$3I.joinToString(g.fullId,m.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$5P=S;class d extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$6P=d;class n extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$7P=n;class o extends Error{constructor(i,r,t){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${t}".`)}}e.$8P=o;const c=(l,i,r)=>{let t=new Map;return{get size(){return t.size},forEach(g,u){for(const m of t.values())g.call(u,m,this)},[Symbol.iterator](){return t.entries()},replace(g){const u=new Map,m=new Set(t.keys()),p={op:$.Bulk,ops:[]};for(const h of g){if(!(h instanceof r))throw new n(h.id);const E=i(h).controllerId;if(E!==l.controllerId)throw new o(h.id,E,l.controllerId);if(u.has(h.id))throw new d(h.id);u.set(h.id,h),m.delete(h.id),p.ops.push({op:$.Upsert,item:h})}for(const h of m.keys())p.ops.push({op:$.RemoveChild,id:h});l.listener?.(p),t=u},add(g){if(!(g instanceof r))throw new n(g.id);t.set(g.id,g),l.listener?.({op:$.Upsert,item:g})},delete(g){t.delete(g)&&l.listener?.({op:$.RemoveChild,id:g})},get(g){return t.get(g)},toJSON(){return Array.from(t.values())}}};e.$9P=c}),define(Oe[116],Ne([1,0,81]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$P=e.$0P=void 0;const I=new WeakMap,P=(R,T)=>{const $={controllerId:T};return I.set(R,$),$};e.$0P=P;const O=R=>{const T=I.get(R);if(!T)throw new v.$7P(R?.id||"<unknown>");return T};e.$$P=O}),define(Oe[82],Ne([1,0,27,15,2]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uDb=e.$tDb=e.$sDb=void 0,e.$vDb=O,e.$wDb=T,e.$sDb="vscode-cdn.net",e.$tDb=`vscode-resource.${e.$sDb}`,e.$uDb=`'self' https://*.${e.$sDb}`;function O($,s){return $.scheme===I.Schemas.http||$.scheme===I.Schemas.https?$:(s&&s.authority&&s.isRemote&&$.scheme===I.Schemas.file&&($=P.URI.from({scheme:I.Schemas.vscodeRemote,authority:s.authority,path:$.path})),P.URI.from({scheme:I.Schemas.https,authority:`${$.scheme}+${R($.authority)}.${e.$tDb}`,path:$.path,fragment:$.fragment,query:$.query}))}function R($){return $.replace(/./g,s=>{const A=s.charCodeAt(0);return A>=v.CharCode.a&&A<=v.CharCode.z||A>=v.CharCode.A&&A<=v.CharCode.Z||A>=v.CharCode.Digit0&&A<=v.CharCode.Digit9?s:"-"+A.toString(16).padStart(4,"0")})}function T($){return $.replace(/-([0-9a-f]{4})/g,(s,A)=>String.fromCharCode(parseInt(A,16)))}}),define(Oe[201],Ne([1,0,6,4,82]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cpc=void 0;class O{constructor(T,$,s){this.d=T,this.e=$,this.f=s,this.a=0,this.b=new I.$Sc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const A=$.getVisibleTextEditors();for(const y of this.c.values())A.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,$,s,A,y){let a;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===T){a=i;break}if(!a)throw new Error("not a visible editor");const S=this,d=this.a++,n=new v.$je,o=new v.$je,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,P.$vDb)(i,S.f)}get cspSource(){return P.$uDb}set options(i){this.b=i,S.d.$setOptions(d,i)}get options(){return this.b}set html(i){this.a=i,S.d.$setHtml(d,i)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(i){return S.d.$postMessage(d,i)}},l=new class{constructor(){this.editor=T,this.line=$,this.height=s,this.webview=c,this.onDidDispose=o.event}dispose(){S.c.has(d)&&(S.c.delete(d),S.d.$disposeEditorInset(d),o.fire(),o.dispose(),n.dispose())}};return this.d.$createEditorInset(d,a.id,a.value.document.uri,$+1,s,A||{},y.identifier,y.extensionLocation),this.c.set(d,{editor:T,inset:l,onDidReceiveMessage:n}),l}$onDidDispose(T){const $=this.c.get(T);$&&$.inset.dispose()}$onDidReceiveMessage(T,$){this.c.get(T)?.onDidReceiveMessage.fire($)}}e.$cpc=O}),define(Oe[117],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=e.$GM=e.$FM=void 0,e.$FM="__",e.$GM=(0,v.$Ci)("IAuthenticationService"),e.$HM=(0,v.$Ci)("IAuthenticationExtensionsService")}),define(Oe[202],Ne([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Q=e.VariableKind=e.$3Q=void 0,e.$3Q=(0,v.$Ci)("configurationResolverService");var I;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(I||(e.VariableKind=I={}));class P extends Error{constructor(R,T){super(T),this.variable=R}}e.$4Q=P}),define(Oe[203],Ne([1,0,19,78,14,25,20,99,9,202,12]),function(be,e,v,I,P,O,R,T,$,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gR=void 0,v=We(v),I=We(I),P=We(P),O=We(O);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,d,n,o){this.h=new Map,this.a=S,this.b=d,this.g=n,o&&(this.c=o.then(c=>this.i(c)))}i(S){if(R.$j){const d=Object.create(null);return Object.keys(S).forEach(n=>{d[n.toLowerCase()]=S[n]}),d}return S}resolveWithEnvironment(S,d,n){return this.l({env:this.i(S),userHome:void 0},d?d.uri:void 0,n)}async resolveAsync(S,d){const n={env:await this.c,userHome:await this.g};return this.l(n,S?S.uri:void 0,d)}async j(S,d,n,o){const c=O.$bo(d);R.$j&&c.windows?Object.keys(c.windows).forEach(i=>c[i]=c.windows[i]):R.$k&&c.osx?Object.keys(c.osx).forEach(i=>c[i]=c.osx[i]):R.$l&&c.linux&&Object.keys(c.linux).forEach(i=>c[i]=c.linux[i]),delete c.windows,delete c.osx,delete c.linux;const l={env:await this.c,userHome:await this.g};return this.l(l,S?S.uri:void 0,c,n,o)}async resolveAnyAsync(S,d,n){return this.j(S,d,n)}async resolveAnyMap(S,d,n){const o=new Map;return{newConfig:await this.j(S,d,n,o),resolvedVariables:o}}resolveWithInteractionReplace(S,d,n,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,d,n,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,d){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,d)}async l(S,d,n,o,c){if(P.$cg(n))return this.m(S,d,n,o,c);if(Array.isArray(n))return Promise.all(n.map(l=>this.l(S,d,l,o,c)));if(P.$eg(n)){const l=Object.create(null),i=await Promise.all(Object.keys(n).map(async r=>[await this.m(S,d,r,o,c),await this.l(S,d,n[r],o,c)]));for(const[r,t]of i)l[r]=t;return l}return n}m(S,d,n,o,c){return(0,A.$vf)(n,y.VARIABLE_REGEXP,async(l,i)=>{if(i.includes(y.VARIABLE_LHS))return l;let r=await this.o(S,l,i,d,o);return c?.set(i,r),r!==l&&P.$cg(r)&&r.match(y.VARIABLE_REGEXP)&&(r=await this.m(S,d,r,o,c)),r})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,d,n,o,c){let l;const i=n.split(":");i.length>1&&(n=i[0],l=i[1]);const r=u=>{const m=this.a.getFilePath();if(m)return(0,T.$Xw)(m);throw new s.$4Q(u,(0,$.localize)(2058,null,d))},t=u=>{const m=r(u);if(this.a.getWorkspaceFolderPathForFile){const p=this.a.getWorkspaceFolderPathForFile();if(p)return(0,T.$Xw)(p)}throw new s.$4Q(u,(0,$.localize)(2059,null,d,v.$mc(m)))},g=u=>{if(l){const m=this.a.getFolderUri(l);if(m)return m;throw new s.$4Q(u,(0,$.localize)(2060,null,d,l))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new s.$4Q(u,(0,$.localize)(2061,null,d)):new s.$4Q(u,(0,$.localize)(2062,null,d))};switch(n){case"env":if(l){if(S.env){const u=S.env[R.$j?l.toLowerCase():l];if(P.$cg(u))return u}return""}throw new s.$4Q(s.VariableKind.Env,(0,$.localize)(2063,null,d));case"config":if(l){const u=this.a.getConfigurationValue(o,l);if(P.$lg(u))throw new s.$4Q(s.VariableKind.Config,(0,$.localize)(2064,null,d,l));if(P.$eg(u))throw new s.$4Q(s.VariableKind.Config,(0,$.localize)(2065,null,d,l));return u}throw new s.$4Q(s.VariableKind.Config,(0,$.localize)(2066,null,d));case"command":return this.p(s.VariableKind.Command,d,l,c,"command");case"input":return this.p(s.VariableKind.Input,d,l,c,"input");case"extensionInstallFolder":if(l){const u=await this.a.getExtension(l);if(!u)throw new s.$4Q(s.VariableKind.ExtensionInstallFolder,(0,$.localize)(2067,null,d,l));return this.n(u.extensionLocation)}throw new s.$4Q(s.VariableKind.ExtensionInstallFolder,(0,$.localize)(2068,null,d));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,T.$Xw)(this.n(g(s.VariableKind.WorkspaceFolder)));case"cwd":return o||l?(0,T.$Xw)(this.n(g(s.VariableKind.Cwd))):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$Xw)(v.$mc(this.n(g(s.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new s.$4Q(s.VariableKind.UserHome,(0,$.localize)(2069,null,d))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new s.$4Q(s.VariableKind.LineNumber,(0,$.localize)(2070,null,d))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new s.$4Q(s.VariableKind.SelectedText,(0,$.localize)(2071,null,d))}case"file":return r(s.VariableKind.File);case"fileWorkspaceFolder":return t(s.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return v.$mc(t(s.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||l?v.$kc(this.n(g(s.VariableKind.RelativeFile)),r(s.VariableKind.RelativeFile)):r(s.VariableKind.RelativeFile);case"relativeFileDirname":{const u=v.$lc(r(s.VariableKind.RelativeFileDirname));if(o||l){const m=v.$kc(this.n(g(s.VariableKind.RelativeFileDirname)),u);return m.length===0?".":m}return u}case"fileDirname":return v.$lc(r(s.VariableKind.FileDirname));case"fileExtname":return v.$nc(r(s.VariableKind.FileExtname));case"fileBasename":return v.$mc(r(s.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=v.$mc(r(s.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-v.$nc(u).length)}case"fileDirnameBasename":return v.$mc(v.$lc(r(s.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||d}case"execInstallFolder":{const u=this.a.getAppRoot();return u||d}case"pathSeparator":case"/":return v.sep;default:try{const u=l?`${n}:${l}`:n;return this.p(s.VariableKind.Unknown,d,u,c,void 0)}catch{return d}}}}p(S,d,n,o,c){if(n&&o){const l=c===void 0?o[n]:o[c+":"+n];if(typeof l=="string")return l;throw new s.$4Q(S,(0,$.localize)(2072,null,d))}return d}}e.$gR=y}),define(Oe[118],Ne([1,0,3,114]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$qE=void 0,e.$rE=s,e.$sE=a,e.$tE=S,e.$qE=(0,v.$Ci)("editorGroupsService");var P;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var O;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var R;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var T;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var $;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function s(d){const n=d;return(0,I.$eG)(n?.editor)&&(0,I.$eG)(n?.replacement)}var A;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var y;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function a(d){const n=d;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}function S(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(Oe[204],Ne([1,0,3,118]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xE=e.$wE=e.$vE=e.$uE=void 0,e.$yE=P,e.$uE=(0,v.$Ci)("editorService"),e.$vE=-1,e.$wE=-2,e.$xE=-3;function P(O){const R=O;return typeof O=="number"||(0,I.$sE)(R)}}),define(Oe[205],Ne([1,0,3,106]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=void 0,e.$1M=(0,v.$Di)(I.$Ji)}),define(Oe[119],Ne([1,0,18,6,19,4,10]),function(be,e,v,I,P,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=e.$ldc=e.$kdc=e.$jdc=e.$idc=void 0,P=We(P);class T{constructor(l,i){this.versionId=l,this.removedDueToLooping=i}}e.$idc=T;class ${static isHostExtension(l,i,r){if(i.getExtensionDescription(l))return!1;const t=r.getExtensionDescription(l);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(l,i){this.j=l,this.c=new I.$je,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(n),this.f=new v.$qn,this.g=[],this.h=new Map;for(const l of this.e){if(this.f.has(l.identifier)){console.error("Extension `"+l.identifier.value+"` is already registered");continue}this.f.set(l.identifier,l),this.g.push(l);const i=this.j.readActivationEvents(l);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(l)}}set(l){return this.e=l,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(l,i){this.e=o(this.e,i),this.e=this.e.concat(l);const r=$.l(this.e);return this.e=o(this.e,r.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,r)}static l(l){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(m){this.d.has(m)||(this.d.add(m),this.e.push(m))}addArc(m,p){this.addNode(m),this.addNode(p),this.c.has(m)?this.c.get(m).push(p):this.c.set(m,[p])}getArcs(m){return this.c.has(m)?this.c.get(m):[]}hasOnlyGoodArcs(m,p){const h=i.getArcs(m);for(let E=0;E<h.length;E++)if(!p.has(h[E]))return!1;return!0}getNodes(){return this.e}},r=new v.$qn;for(const m of l)if(r.set(m.identifier,m),m.extensionDependencies)for(const p of m.extensionDependencies)i.addArc(v.$on.toKey(m.identifier),v.$on.toKey(p));const t=new Set;i.getNodes().filter(m=>i.getArcs(m).length===0).forEach(m=>t.add(m));const g=i.getNodes().filter(m=>!t.has(m));let u;do{u=!1;for(let m=0;m<g.length;m++){const p=g[m];i.hasOnlyGoodArcs(p,t)&&(g.splice(m,1),m--,t.add(p),u=!0)}}while(u);return g.map(m=>r.get(m))}containsActivationEvent(l){return this.h.has(l)}containsExtension(l){return this.f.has(l)}getExtensionDescriptionsForActivationEvent(l){const i=this.h.get(l);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new s(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(l){const i=this.f.get(l);return i||void 0}getExtensionDescriptionByUUID(l){for(const i of this.g)if(i.uuid===l)return i}getExtensionDescriptionByIdOrUUID(l,i){return this.getExtensionDescription(l)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$jdc=$;class s{constructor(l,i){this.versionId=l,this.extensions=i}}e.$kdc=s;class A{constructor(l){this.d=new S,this.c=new $(l,[])}async acquireLock(l){const i=await this.d.acquire(l);return new y(this,i)}deltaExtensions(l,i,r){if(!l.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(l){return this.c.containsActivationEvent(l)}containsExtension(l){return this.c.containsExtension(l)}getExtensionDescriptionsForActivationEvent(l){return this.c.getExtensionDescriptionsForActivationEvent(l)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(l){return this.c.getExtensionDescription(l)}getExtensionDescriptionByUUID(l){return this.c.getExtensionDescriptionByUUID(l)}getExtensionDescriptionByIdOrUUID(l,i){return this.c.getExtensionDescriptionByIdOrUUID(l,i)}}e.$ldc=A;class y extends O.$Tc{constructor(l,i){super(),this.f=l,this.c=!1,this.B(i)}isAcquiredFor(l){return!this.c&&this.f===l}}e.$mdc=y;class a{constructor(l){this.name=l;const i=(0,R.$vh)();this.promise=i.promise,this.c=i.resolve}resolve(l){this.c(l)}}class S{constructor(){this.c=[],this.d=!1}async acquire(l){const i=new a(l);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const l=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${l.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};l.resolve((0,O.$Rc)(t))}}var d;(function(c){c[c.Builtin=0]="Builtin",c[c.User=1]="User",c[c.Dev=2]="Dev"})(d||(d={}));function n(c,l){const i=c.isBuiltin?d.Builtin:c.isUnderDevelopment?d.Dev:d.User,r=l.isBuiltin?d.Builtin:l.isUnderDevelopment?d.Dev:d.User;if(i!==r)return i-r;const t=P.$fc.basename(c.extensionLocation.path),g=P.$fc.basename(l.extensionLocation.path);return t<g?-1:t>g?1:0}function o(c,l){const i=new v.$pn(l);return c.filter(r=>!i.has(r.identifier))}}),define(Oe[83],Ne([1,0,22]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$yn=R,e.$zn=T;var I;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(I||(e.UIKind=I={}));var P;(function(s){s[s.VersionMismatch=55]="VersionMismatch",s[s.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var O;(function(s){s[s.Initialized=0]="Initialized",s[s.Ready=1]="Ready",s[s.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function R(s){const A=v.$Le.alloc(1);switch(s){case O.Initialized:A.writeUInt8(1,0);break;case O.Ready:A.writeUInt8(2,0);break;case O.Terminate:A.writeUInt8(3,0);break}return A}function T(s,A){if(s.byteLength!==1)return!1;switch(s.readUInt8(0)){case 1:return A===O.Initialized;case 2:return A===O.Ready;case 3:return A===O.Terminate;default:return!1}}var $;(function(s){s.Start="START_NATIVE_LOG",s.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Oe[66],Ne([1,0,3,6,112,11,26,83,62,63,25,2,4,9]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wQ=e.$uQ=e.$tQ=void 0,e.$vQ=o;let d=class extends a.$Tc{constructor(l,i){super(),this.s=l,this.t=i,this.a=this.B(new I.$je),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new I.$je),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:s.$zp,name:(0,S.localize)(10732,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(r=>{(0,O.$_j)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(l,i,r){const t=this.getTelemetryDetails(),g=new n(i,r,l,this.n,this.j,this.getBuiltInCommonProperties(l),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),u=this.r.get(l.identifier.value)??[];return this.r.set(l.identifier.value,[...u,g]),g.apiTelemetryLogger}$initializeTelemetryLevel(l,i,r){this.f=l,this.g=i,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(l){const i=Object.create(null);switch(i["common.extname"]=`${l.publisher}.${l.name}`,i["common.extversion"]=l.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=o(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:i["common.uikind"]="web";break;case T.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,$.$fn)((0,s.$Fp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(l){this.h=this.getTelemetryConfiguration(),this.f=l;const i=this.getTelemetryDetails();this.r.forEach((r,t)=>{const g=r.filter(u=>!u.isDisposed);g.length===0?this.r.delete(t):this.r.set(t,g)}),this.r.forEach(r=>{for(const t of r)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(l,i){const t=this.r.get(l.value)?.filter(u=>!u.isDisposed);if(!t)return this.r.delete(l.value),!1;let g=!1;for(const u of t)u.ignoreUnhandledExtHostErrors||(u.logError(i),g=!0);return g}};e.$tQ=d,e.$tQ=d=Ge([Ve(0,R.$sQ),Ve(1,O.$$j)],d);class n{static validateSender(l){if(typeof l!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof l.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof l.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof l.flush<"u"&&typeof l.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(l,i,r,t,g,u,m){this.g=r,this.h=t,this.i=g,this.j=u,this.a=new I.$je,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=l,this.d={isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}}updateTelemetryEnablements(l,i){this.e&&(this.d={isUsageEnabled:l,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(l){let i="properties"in l?l.properties??{}:l;return i=(0,s.$Ip)(i,[]),this.c&&(i=(0,A.$eo)(i,this.c)),this.b||(i=(0,A.$eo)(i,this.j)),"properties"in l?l.properties=i:l=i,l}k(l,i){this.f&&(this.g.publisher==="vscode"?l=this.g.name+"/"+l:l=this.g.identifier.value+"/"+l,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(l,i),this.h.trace(l,i))}logUsage(l,i){this.d.isUsageEnabled&&this.k(l,i)}logError(l,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof l=="string")this.k(l,i);else{const r={name:l.name,message:l.message,stack:l.stack,cause:l.cause},t=(0,s.$Ip)(r,[]),g=new Error(t.message,{cause:t.cause});g.stack=t.stack,g.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(g,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const l=this,i={logUsage:l.logUsage.bind(l),get isUsageEnabled(){return l.d.isUsageEnabled},get isErrorsEnabled(){return l.d.isErrorsEnabled},logError:l.logError.bind(l),dispose:l.dispose.bind(l),onDidChangeEnableStates:l.a.event.bind(l)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let l=this.f;this.f=void 0,Promise.resolve(l.flush()).then(l=void 0),this.e=void 0}else this.f=void 0}}e.$uQ=n;function o(c){const l=Date.now()-new Date(c).getTime();return isNaN(l)?!1:l<1e3*60*60*24}e.$wQ=(0,v.$Ci)("IExtHostTelemetry")}),define(Oe[24],Ne([1,0,6,2,178,111,18,3]),function(be,e,v,I,P,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iH=e.ActivationKind=e.$fH=e.$eH=e.$bH=e.ExtensionHostStartup=e.$aH=e.$_G=e.$$G=e.$0G=void 0,e.$cH=a,e.$dH=S,e.$gH=c,e.$hH=l,e.$0G=Object.freeze({identifier:new R.$on("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1,targetPlatform:R.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$$G="extensions.webWorker",e.$_G=(0,T.$Ci)("extensionService");class ${constructor(t){this.dependency=t}}e.$aH=$;var s;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(s||(e.ExtensionHostStartup=s={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,g,u){this.c=t,this.d=g.slice(0),this.e=u.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$VG.createActivationEventsMap(this.d)}}set(t,g,u){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const m=[],p=[],h=[],E=[],D=y(this.d),b=y(g),k=(N,L)=>N.extensionLocation.toString()===L.extensionLocation.toString()||N.isBuiltin===L.isBuiltin||N.isUserBuiltin===L.isUserBuiltin||N.isUnderDevelopment===L.isUnderDevelopment;for(const N of this.d){const L=b.get(N.identifier);if(!L){m.push(N.identifier),D.delete(N.identifier);continue}if(!k(N,L)){m.push(N.identifier),D.delete(N.identifier);continue}}for(const N of g){const L=D.get(N.identifier);if(!L){p.push(N);continue}if(!k(L,N)){m.push(L.identifier),D.delete(L.identifier);continue}}const C=new R.$pn(this.e),f=new R.$pn(u);for(const N of this.e)f.has(N)||h.push(N);for(const N of u)C.has(N)||E.push(N);const w=O.$VG.createActivationEventsMap(p),M={versionId:t,toRemove:m,toAdd:p,addActivationEvents:w,myToRemove:h,myToAdd:E};return this.delta(M),M}delta(t){if(this.c>=t.versionId)return null;const{toRemove:g,toAdd:u,myToRemove:m,myToAdd:p}=t,h=new R.$pn(g),E=new R.$pn(m);for(let D=0;D<this.d.length;D++)h.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)E.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of u)this.d.push(D);for(const D of p)this.e.push(D);return this.f=null,t}containsExtension(t){for(const g of this.e)if(R.$on.equals(g,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const g of this.d){if(!this.containsExtension(g.identifier))continue;const u=O.$VG.readActivationEvents(g);for(const m of u)t.add(m)}return t}}e.$bH=A;function y(r){const t=new R.$qn;for(const g of r)t.set(g.identifier,g);return t}function a(r,t){return r.enabledApiProposals?r.enabledApiProposals.includes(t):!1}function S(r,t){if(!a(r,t))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class d{constructor(t,g,u,m){this.codeLoadingTime=t,this.activateCallTime=g,this.activateResolvedTime=u,this.activationReason=m}}e.$eH=d;class n{constructor(t,g){this.description=t,this.value=g}}e.$fH=n;var o;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function c(r){return{type:r.isBuiltin?R.ExtensionType.System:R.ExtensionType.User,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,P.$Op)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function l(r,t){const g=(0,P.$Mp)(r.manifest.publisher,r.manifest.name);return{id:g,identifier:new R.$on(g),isBuiltin:r.type===R.ExtensionType.System,isUserBuiltin:r.type===R.ExtensionType.User&&r.isBuiltin,isUnderDevelopment:!!t,extensionLocation:r.location,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,publisherDisplayName:r.publisherDisplayName,...r.manifest}}class i{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.onWillStop=v.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,g){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,g){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$iH=i}),define(Oe[206],Ne([1,0,13,4,119,18,24,11,10]),function(be,e,v,I,P,O,R,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=e.$Cpc=e.$Bpc=e.$Apc=e.$zpc=e.$ypc=void 0,v=We(v);class s{static{this.NONE=new s(!1,-1,-1,-1)}constructor(l,i,r,t){this.startup=l,this.codeLoadingTime=i,this.activateCallTime=r,this.activateResolvedTime=t}}e.$ypc=s;class A{constructor(l){this.a=l,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(l,i){return l===-1||i===-1?-1:i-l}build(){return new s(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$zpc=A;class y{constructor(l,i,r,t,g,u){this.activationFailed=l,this.activationFailedError=i,this.activationTimes=r,this.module=t,this.exports=g,this.disposable=u}}e.$Apc=y;class a extends y{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,I.$Tc.None)}}e.$Bpc=a;class S extends y{constructor(){super(!1,null,s.NONE,{activate:void 0,deactivate:void 0},void 0,I.$Tc.None)}}e.$Cpc=S;class d extends y{constructor(l){super(!0,l,s.NONE,{activate:void 0,deactivate:void 0},void 0,I.$Tc.None)}}let n=class{constructor(l,i,r,t){this.g=t,this.a=l,this.b=i,this.c=r,this.d=new O.$qn,this.f=Object.create(null)}dispose(){for(const[l,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const l=[];for(const[i,r]of this.d)l.push(r.wait());await Promise.all(l)}isActivated(l){const i=this.d.get(l);return!!(i&&i.value)}getActivatedExtension(l){const i=this.d.get(l);if(!i||!i.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return i.value}async activateByEvent(l,i){if(this.f[l])return;const r=this.a.getExtensionDescriptionsForActivationEvent(l);await this.h(r.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:l}}))),this.f[l]=!0}activateById(l,i){const r=this.a.getExtensionDescription(l);if(!r)throw new Error(`Extension '${l.value}' is not known`);return this.h([{id:r.identifier,reason:i}])}async h(l){const i=l.filter(r=>!this.isActivated(r.id)).map(r=>this.j(r));await Promise.all(i.map(r=>r.wait()))}j(l){if(this.d.has(l.id))return this.d.get(l.id);if(this.l(l.id))return this.k(l,null,[],null);const i=this.a.getExtensionDescription(l.id);if(!i){const g=new Error(`Cannot activate unknown extension '${l.id.value}'`),u=this.k(l,null,[],new d(g));return this.c.onExtensionActivationError(l.id,g,new R.$aH(l.id.value)),u}const r=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const g of t){if(this.m(g))continue;const u=this.d.get(g);if(u){r.push(u);continue}if(this.l(g)){r.push(this.j({id:this.b.getExtensionDescription(g).identifier,reason:l.reason}));continue}const m=this.a.getExtensionDescription(g);if(m){if(!m.main&&!m.browser)continue;r.push(this.j({id:m.identifier,reason:l.reason}));continue}const p=i.displayName||i.identifier.value,h=new Error(`Cannot activate the '${p}' extension because it depends on unknown extension '${g}'`),E=this.k(l,i.displayName,[],new d(h));return this.c.onExtensionActivationError(i.identifier,h,new R.$aH(g)),E}return this.k(l,i.displayName,r,null)}k(l,i,r,t){const g=new o(l.id,i,l.reason,r,t,this.c,this.g);return this.d.set(l.id,g),g}l(l){return P.$jdc.isHostExtension(l,this.a,this.b)}m(l){const i=this.b.getExtensionDescription(l);return i?!i.main&&!i.browser:!1}};e.$Dpc=n,e.$Dpc=n=Ge([Ve(3,T.$0j)],n);let o=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(l,i,r,t,g,u,m){this.c=l,this.d=i,this.f=r,this.g=t,this.h=g,this.j=u,this.k=m,this.a=new $.$Bh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let l=0;l<this.g.length;l++){const i=this.g[l];if(i.value&&!i.value.activationFailed){this.g.splice(l,1),l--;continue}if(i.value&&i.value.activationFailed){const r=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);r.detail=i.value.activationFailedError,this.h=new d(r),this.j.onExtensionActivationError(this.c,r,null);return}}this.g.length>0&&await Promise.race(this.g.map(l=>l.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(l){const i=new Error;if(l&&l.name&&(i.name=l.name),l&&l.message?i.message=`Activating extension '${this.c.value}' failed: ${l.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${l}.`,l&&l.stack&&(i.stack=l.stack),this.h=new d(i),this.b&&v.$3(l))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(l)}}};o=Ge([Ve(6,T.$0j)],o)});var ni=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[120],Ne([1,0,9,13,35,110,77,30,18,108,111,104]),function(be,e,v,I,P,O,R,T,$,s,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=void 0,v=We(v),P=ni(P);const a=T.$oo.as(R.$po.JSONContribution);class S{constructor(t,g,u){this.a=t,this.b=g,this.c=u}d(t,g){this.a({type:t,message:g,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(P.default.Error,t)}warn(t){this.d(P.default.Warning,t)}info(t){this.d(P.default.Info,t)}}e.$4G=S;class d{static a(t){const g=new $.$pn;for(let u=0,m=t.length;u<m;u++)g.add(t[u].description.identifier);return g}static compute(t,g){if(!t||!t.length)return new d(g,[]);if(!g||!g.length)return new d([],t);const u=this.a(t),m=this.a(g),p=g.filter(E=>!u.has(E.description.identifier)),h=t.filter(E=>!m.has(E.description.identifier));return new d(p,h)}constructor(t,g){this.added=t,this.removed=g}}e.$5G=d;class n{constructor(t,g){this.name=t,this.defaultExtensionKind=g,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=d.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,I.$Y)(t)}}}e.$6G=n;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[v.localize(1823,null),v.localize(1824,null)]},c="vscode://schemas/vscode-extensions";e.$7G={properties:{engines:{type:"object",description:v.localize(1825,null),properties:{vscode:{type:"string",description:v.localize(1826,null),default:"^1.22.0"}}},publisher:{description:v.localize(1827,null),type:"string"},displayName:{description:v.localize(1828,null),type:"string"},categories:{description:v.localize(1829,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$nn},{type:"string",const:"Languages",deprecationMessage:v.localize(1830,null)}]}},galleryBanner:{type:"object",description:v.localize(1831,null),properties:{color:{description:v.localize(1832,null),type:"string"},theme:{description:v.localize(1833,null),type:"string",enum:["dark","light"]}}},contributes:{description:v.localize(1834,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:v.localize(1835,null)},enableProposedApi:{type:"boolean",deprecationMessage:v.localize(1836,null)},enabledApiProposals:{markdownDescription:v.localize(1837,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals).map(r=>r),markdownEnumDescriptions:Object.values(y.allApiProposals).map(r=>r.proposal)}},api:{markdownDescription:v.localize(1838,null),type:"string",enum:["none"],enumDescriptions:[v.localize(1839,null)]},activationEvents:{description:v.localize(1840,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:v.localize(1841,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:v.localize(1842,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:v.localize(1843,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:v.localize(1844,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:v.localize(1845,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:v.localize(1846,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:v.localize(1847,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:v.localize(1848,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:v.localize(1849,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:v.localize(1850,null),body:"onStartupFinished"},{label:"onTaskType",description:v.localize(1851,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:v.localize(1852,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:v.localize(1853,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:v.localize(1854,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:v.localize(1855,null)},{label:"onUri",body:"onUri",description:v.localize(1856,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:v.localize(1857,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:v.localize(1858,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:v.localize(1859,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:v.localize(1860,null)},{label:"onRenderer",description:v.localize(1861,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:v.localize(1862,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:v.localize(1863,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:v.localize(1864,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:v.localize(1865,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:v.localize(1866,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:v.localize(1867,null)},{label:"*",description:v.localize(1868,null),body:"*"}]}},badges:{type:"array",description:v.localize(1869,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:v.localize(1870,null)},href:{type:"string",description:v.localize(1871,null)},description:{type:"string",description:v.localize(1872,null)}}}},markdown:{type:"string",description:v.localize(1873,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:v.localize(1874,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:v.localize(1875,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$8o}},extensionPack:{description:v.localize(1876,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$8o}},extensionKind:{description:v.localize(1877,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:v.localize(1878,null)},{body:["workspace"],description:v.localize(1879,null)},{body:["ui","workspace"],description:v.localize(1880,null)},{body:["workspace","ui"],description:v.localize(1881,null)},{body:[],description:v.localize(1882,null)}]},capabilities:{description:v.localize(1883,null),type:"object",properties:{virtualWorkspaces:{description:v.localize(1884,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:v.localize(1885,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(1886,null),v.localize(1887,null),v.localize(1888,null)]},description:{type:"string",markdownDescription:v.localize(1889,null)}}},untrustedWorkspaces:{description:v.localize(1890,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:v.localize(1891,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(1892,null),v.localize(1893,null),v.localize(1894,null)]},restrictedConfigurations:{description:v.localize(1895,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:v.localize(1896,null)}}}}},sponsor:{description:v.localize(1897,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:v.localize(1898,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:v.localize(1899,null),type:"string"},"vscode:uninstall":{description:v.localize(1900,null),type:"string"}}},icon:{type:"string",description:v.localize(1901,null)},l10n:{type:"string",description:v.localize(1902,null)},pricing:{type:"string",markdownDescription:v.localize(1903,null),enum:["Free","Trial"],default:"Free"}}};class l{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const g=new n(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,g),t.activationEventsGenerator&&A.$VG.register(t.extensionPoint,t.activationEventsGenerator),e.$7G.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,a.registerSchema(c,e.$7G),g}getExtensionPoints(){return Array.from(this.a.values())}}e.$8G=l;const i={ExtensionsRegistry:"ExtensionsRegistry"};T.$oo.add(i.ExtensionsRegistry,new l),e.$9G=T.$oo.as(i.ExtensionsRegistry),a.registerSchema(c,e.$7G),a.registerSchema(s.$rk,{properties:{extensionEnabledApiProposals:{description:v.localize(1904,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals).map(r=>r.proposal)}}]}}}})}),define(Oe[207],Ne([1,0,6,39,4,12,9,18,3,11,24,120]),function(be,e,v,I,P,O,R,T,$,s,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lH=e.$kH=e.$jH=e.ChatMessageRole=void 0;var a;(function(n){n[n.System=0]="System",n[n.User=1]="User",n[n.Assistant=2]="Assistant"})(a||(e.ChatMessageRole=a={})),e.$jH=(0,$.$Ci)("ILanguageModelsService");const S={type:"object",properties:{vendor:{type:"string",description:(0,R.localize)(8332,null)}}};e.$kH=y.$9G.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,R.localize)(8333,null),oneOf:[S,{type:"array",items:S}]},activationEventsGenerator:(n,o)=>{for(const c of n)o.push(`onLanguageModelChat:${c.vendor}`)}});let d=class{constructor(o,c){this.e=o,this.f=c,this.a=new P.$Sc,this.b=new Map,this.c=new Set,this.d=this.a.add(new v.$je),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$kH.setHandler(l=>{this.c.clear();for(const r of l){if(!(0,A.$cH)(r.description,"chatProvider")){r.collector.error((0,R.localize)(8334,null));continue}for(const t of I.Iterable.wrap(r.value)){if(this.c.has(t.vendor)){r.collector.error((0,R.localize)(8335,null,t.vendor));continue}if((0,O.$af)(t.vendor)){r.collector.error((0,R.localize)(8336,null));continue}if(t.vendor.trim()!==t.vendor){r.collector.error((0,R.localize)(8337,null));continue}this.c.add(t.vendor)}}const i=[];for(const[r,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(r),i.push(r));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(o){return this.b.get(o)?.metadata}async selectLanguageModels(o){if(o.vendor)await this.e.activateByEvent(`onLanguageModelChat:${o.vendor}}`);else{const l=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(l)}const c=[];for(const[l,i]of this.b)(o.vendor===void 0||i.metadata.vendor===o.vendor)&&(o.family===void 0||i.metadata.family===o.family)&&(o.version===void 0||i.metadata.version===o.version)&&(o.identifier===void 0||i.metadata.id===o.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(r=>T.$on.equals(r,o.extension)))&&c.push(l);return this.f.trace("[LM] selected language models",o,c),c}registerLanguageModelChat(o,c){if(this.f.trace("[LM] registering language model chat",o,c.metadata),!this.c.has(c.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${c.metadata.vendor}.`);if(this.b.has(o))throw new Error(`Chat response provider with identifier ${o} is already registered.`);return this.b.set(o,c),this.d.fire({added:[{identifier:o,metadata:c.metadata}]}),(0,P.$Rc)(()=>{this.b.delete(o)&&(this.d.fire({removed:[o]}),this.f.trace("[LM] UNregistered language model chat",o,c.metadata))})}async sendChatRequest(o,c,l,i,r){const t=this.b.get(o);if(!t)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return t.sendChatRequest(l,c,i,r)}computeTokenLength(o,c,l){const i=this.b.get(o);if(!i)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return i.provideTokenCount(c,l)}};e.$lH=d,e.$lH=d=Ge([Ve(0,A.$_G),Ve(1,s.$0j)],d)}),define(Oe[208],Ne([1,0,9,14,25,120,31,6]),function(be,e,v,I,P,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QI=void 0,v=We(v),I=We(I),P=We(P);const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:v.localize(3890,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:v.localize(3891,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:v.localize(3892,null),default:""}}};var s;(function(a){function S(d,n,o){if(!d)return;const c=I.$cg(d.type)?d.type:void 0;if(!c||c.length===0){o.error(v.localize(3893,null));return}const l=[];if(Array.isArray(d.required))for(const i of d.required)I.$cg(i)&&l.push(i);return{extensionId:n.value,taskType:c,required:l,properties:d.properties?P.$bo(d.properties):{},when:d.when?R.$Aj.deserialize(d.when):void 0}}a.from=S})(s||(s={}));const A=O.$9G.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,S)=>{for(const d of a)d.type&&S.push(`onTaskType:${d.type}`)},jsonSchema:{description:v.localize(3894,null),type:"array",items:$}});class y{constructor(){this.d=new T.$je,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,d)=>{A.setHandler((n,o)=>{this.c=void 0;try{for(const c of o.removed){const l=c.value;for(const i of l)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const c of o.added){const l=c.value;for(const i of l){const r=s.from(i,c.description.identifier,c.collector);r&&(this.a[r.taskType]=r)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const d of this.all()){const n={type:"object",additionalProperties:!1};d.required.length>0&&(n.required=d.required.slice(0)),d.properties!==void 0?n.properties=P.$bo(d.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[d.taskType]},S.push(n)}this.c={oneOf:S}}return this.c}}e.$QI=new y}),define(Oe[209],Ne([1,0,9,14,23,25,31,208,43]),function(be,e,v,I,P,O,R,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$1I=e.JsonSchemaVersion=e.ExecutionEngine=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$UI=e.ShellQuoting=e.$TI=e.$SI=e.$RI=void 0,v=We(v),I=We(I),P=We(P),O=We(O),e.$RI="settings",e.$SI=new R.$Tj("taskRunning",!1,v.localize(3878,null)),e.$TI=v.localize2(3880,"Tasks");var s;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(s||(e.ShellQuoting=s={})),e.$UI="$customized",function(F){function K(Y){if(!Y)return F.Strong;switch(Y.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=K}(s||(e.ShellQuoting=s={}));var A;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(A||(e.CommandOptions=A={}));var y;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(y||(e.RevealKind=y={})),function(F){function K(Y){switch(Y.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=K}(y||(e.RevealKind=y={}));var a;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(a||(e.RevealProblemKind=a={})),function(F){function K(Y){switch(Y.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=K}(a||(e.RevealProblemKind=a={}));var S;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(S||(e.PanelKind=S={})),function(F){function K(Y){switch(Y.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=K}(S||(e.PanelKind=S={}));var d;(function(F){F.defaults={echo:!0,reveal:y.Always,revealProblems:a.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(d||(e.PresentationOptions=d={}));var n;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(n||(e.RuntimeType=n={})),function(F){function K(le){switch(le.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=K;function Y(le){switch(le){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=Y}(n||(e.RuntimeType=n={}));var o;(function(F){function K(Y){return I.$cg(Y)?Y:Y.value}F.value=K})(o||(e.CommandString=o={}));var c;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function K(le){return le===F.Clean._id||le===F.Build._id||le===F.Rebuild._id||le===F.Test._id}F.is=K;function Y(le){if(le!==void 0)return I.$cg(le)?K(le)?{_id:le,isDefault:!1}:void 0:le}F.from=Y})(c||(e.TaskGroup=c={}));var l;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(l||(e.TaskScope=l={}));var i;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function K(Y){switch(Y){case F.User:return $.ConfigurationTarget.USER;case F.WorkspaceFile:return $.ConfigurationTarget.WORKSPACE;default:return $.ConfigurationTarget.WORKSPACE_FOLDER}}F.toConfigurationTarget=K})(i||(e.TaskSourceKind=i={}));var r;(function(F){F.parallel="parallel",F.sequence="sequence"})(r||(e.DependsOrder=r={}));var t;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var g;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(g||(e.RunOptions=g={}));class u{constructor(K,Y,le,_,ge,se){this._label="",this._id=K,Y&&(this._label=Y),le&&(this.type=le),this.runOptions=_,this.configurationProperties=ge,this._source=se}getDefinition(K){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const K={folder:this.d(),id:this._id};return JSON.stringify(K)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(K,Y=!1){if(K===void 0)return!1;if(I.$cg(K))return K===this._label||K===this.configurationProperties.identifier||Y&&K===this._id;const le=this.getDefinition(!0);return le!==void 0&&le._key===K._key}getQualifiedLabel(){const K=this.getWorkspaceFolder();return K?`${this._label} (${K.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(K){this.c===void 0&&(this.c=[]),K&&(this.c=this.c.concat(K))}get taskLoadMessages(){return this.c}}e.$VI=u;class m extends u{constructor(K,Y,le,_,ge,se,ae,$e){super(K,le,void 0,ae,$e,Y),this.command={},this._source=Y,this.hasDefinedMatchers=se,ge&&(this.command=ge)}clone(){return new m(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(K=!1){if(K&&this._source.customizes!==void 0)return this._source.customizes;{let Y;switch(this.command?this.command.runtime:void 0){case n.Shell:Y="shell";break;case n.Process:Y="process";break;case n.CustomExecution:Y="customExecution";break;case void 0:Y="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Y,_key:this._id,id:this._id}}}static is(K){return K instanceof m}getMapKey(){const K=this._source.config.workspaceFolder;return K?`${K.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$RI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const K=this.d();if(!K)return;let Y=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Y+=this._source.kind);const le={type:e.$UI,folder:K,id:Y};return JSON.stringify(le)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$ah(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(K){return new m(K._id,K._source,K._label,K.type,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.$WI=m;class p extends u{constructor(K,Y,le,_,ge,se,ae){super(K,le,_,se,ae,Y),this._source=Y,this.configures=ge}static is(K){return K instanceof p}f(K){return K}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$ah(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$RI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const K=this.d();if(!K)return;let Y=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Y+=this._source.kind);const le={type:e.$UI,folder:K,id:Y};return JSON.stringify(le)}}e.$XI=p;class h extends u{constructor(K,Y,le,_,ge,se,ae,$e,oe){super(K,le,_,$e,oe,Y),this.defines=ge,this.hasDefinedMatchers=ae,this.command=se,this.icon=oe.icon,this.hide=oe.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(K){return K instanceof h}getMapKey(){const K=this._source.workspaceFolder;return K?`${this._source.scope.toString()}|${K.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===l.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const K={type:"contributed",scope:this._source.scope,id:this._id};return K.folder=this.d(),JSON.stringify(K)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(K){return new h(K._id,K._source,K._label,K.type,K.defines,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.$YI=h;class E extends u{constructor(K,Y,le,_,ge,se){super(K,le,_,ge,se,Y),this._source=Y}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(K){return K instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(K){return new E(K._id,K._source,K._label,K.type,K.runOptions,K.configurationProperties)}}e.$ZI=E;var D;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(F){F._default=F.Terminal}(D||(e.ExecutionEngine=D={}));var b;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(b||(e.JsonSchemaVersion=b={}));class k{constructor(K){this.c=new Map;for(let Y=0;Y<K.length;Y++)this.c.set(K[Y].uri.toString(),Y)}compare(K,Y){const le=K.getWorkspaceFolder(),_=Y.getWorkspaceFolder();if(le&&_){let ge=this.c.get(le.uri.toString());ge=ge===void 0?0:ge+1;let se=this.c.get(_.uri.toString());return se=se===void 0?0:se+1,ge===se?K._label.localeCompare(Y._label):ge-se}else return!le&&_?-1:le&&!_?1:0}}e.$1I=k;var C;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(C||(e.TaskEventKind=C={}));var f;(function(F){F.SingleRun="singleRun",F.Background="background"})(f||(e.TaskRunType=f={}));var w;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var M;(function(F){function K($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?f.Background:f.SingleRun,group:$e.configurationProperties.group,__task:$e}}function Y($e,oe,Ce){return{...K($e),kind:C.Start,terminalId:oe,resolvedVariables:Ce}}F.start=Y;function le($e,oe,Ce){return{...K($e),kind:C.ProcessStarted,terminalId:oe,processId:Ce}}F.processStarted=le;function _($e,oe,Ce){return{...K($e),kind:C.ProcessEnded,terminalId:oe,exitCode:Ce}}F.processEnded=_;function ge($e,oe,Ce){return{...K($e),kind:C.Terminated,exitReason:Ce,terminalId:oe}}F.terminated=ge;function se($e,oe,Ce){return{...K(oe),kind:$e,terminalId:Ce}}F.general=se;function ae(){return{kind:C.Changed}}F.changed=ae})(M||(e.TaskEvent=M={}));var N;(function(F){function K(le){const _=Object.keys(le).sort();let ge="";for(const se of _){let ae=le[se];ae instanceof Object?ae=K(ae):typeof ae=="string"&&(ae=ae.replace(/,/g,",,")),ge+=se+","+ae+","}return ge}function Y(le){const ge={_key:K(le),type:le.taskType};return Object.assign(ge,le),ge}F.create=Y})(N||(e.KeyedTaskIdentifier=N={}));var L;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(L||(e.TaskSettingId=L={}));var W;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var G;(function(F){function K(Y,le){const _=T.$QI.get(Y.type);if(_===void 0){const $e=O.$bo(Y);return delete $e._key,N.create($e)}const ge=Object.create(null);ge.type=_.taskType;const se=new Set;_.required.forEach($e=>se.add($e));const ae=_.properties;for(const $e of Object.keys(ae)){const oe=Y[$e];if(oe!=null)ge[$e]=oe;else if(se.has($e)){const Ce=ae[$e];if(Ce.default!==void 0)ge[$e]=O.$bo(Ce.default);else switch(Ce.type){case"boolean":ge[$e]=!1;break;case"number":case"integer":ge[$e]=0;break;case"string":ge[$e]="";break;default:le.error(v.localize(3879,null,JSON.stringify(Y,void 0,0),$e));return}}}return N.create(ge)}F.createTaskIdentifier=K})(G||(e.TaskDefinition=G={}))}),define(Oe[210],Ne([1,0,13]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=e.$ndc=void 0;class I{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,T)=>{this.b=R,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,v.$Y)(R))}then(R,T){return this.j().then(R,T)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$ndc=I;class P extends I{constructor(){super(),this.h=!0,this.i=new v.$4}}e.$odc=P}),define(Oe[38],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uw=e.$Rw=void 0,e.$Sw=P,e.$Tw=O;class v{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++v.count}}e.$Rw=v;const I=[];function P(T){const $=new v(T);return I[$.nid]=$,$}function O(T){return I[T].sid}class R{constructor($){this.value=$}}e.$Uw=R}),define(Oe[5],Ne([1,0,38]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=e.$DN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$CN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var I;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(I||(e.TextEditorRevealType=I={}));var P;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput",n[n.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var O;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var R;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var T;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var $;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var s;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(s||(e.NotebookEditorRevealType=s={}));var A;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output",n[n.Hybrid=3]="Hybrid"})(A||(e.CandidatePortSource=A={}));class y{static{this.a=0}static mixin(o){return o._id=y.a++,o}}e.$CN=y;var a;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var S;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var d;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$DN={MainThreadAuthentication:(0,v.$Sw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.$Sw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,v.$Sw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,v.$Sw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,v.$Sw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,v.$Sw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,v.$Sw)("MainThreadChatSkills"),MainThreadClipboard:(0,v.$Sw)("MainThreadClipboard"),MainThreadCommands:(0,v.$Sw)("MainThreadCommands"),MainThreadComments:(0,v.$Sw)("MainThreadComments"),MainThreadConfiguration:(0,v.$Sw)("MainThreadConfiguration"),MainThreadConsole:(0,v.$Sw)("MainThreadConsole"),MainThreadDebugService:(0,v.$Sw)("MainThreadDebugService"),MainThreadDecorations:(0,v.$Sw)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.$Sw)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.$Sw)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.$Sw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.$Sw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.$Sw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.$Sw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.$Sw)("MainThreadEditorTabs"),MainThreadErrors:(0,v.$Sw)("MainThreadErrors"),MainThreadTreeViews:(0,v.$Sw)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.$Sw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,v.$Sw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.$Sw)("MainThreadLanguages"),MainThreadLogger:(0,v.$Sw)("MainThreadLogger"),MainThreadMessageService:(0,v.$Sw)("MainThreadMessageService"),MainThreadOutputService:(0,v.$Sw)("MainThreadOutputService"),MainThreadProgress:(0,v.$Sw)("MainThreadProgress"),MainThreadQuickDiff:(0,v.$Sw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.$Sw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.$Sw)("MainThreadStatusBar"),MainThreadSecretState:(0,v.$Sw)("MainThreadSecretState"),MainThreadStorage:(0,v.$Sw)("MainThreadStorage"),MainThreadSpeech:(0,v.$Sw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,v.$Sw)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.$Sw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,v.$Sw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,v.$Sw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.$Sw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.$Sw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.$Sw)("MainThreadCustomEditors"),MainThreadUrls:(0,v.$Sw)("MainThreadUrls"),MainThreadUriOpeners:(0,v.$Sw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.$Sw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.$Sw)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.$Sw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,v.$Sw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,v.$Sw)("MainThreadExtensionService"),MainThreadSCM:(0,v.$Sw)("MainThreadSCM"),MainThreadSearch:(0,v.$Sw)("MainThreadSearch"),MainThreadShare:(0,v.$Sw)("MainThreadShare"),MainThreadTask:(0,v.$Sw)("MainThreadTask"),MainThreadWindow:(0,v.$Sw)("MainThreadWindow"),MainThreadLabelService:(0,v.$Sw)("MainThreadLabelService"),MainThreadNotebook:(0,v.$Sw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.$Sw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.$Sw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.$Sw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.$Sw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.$Sw)("MainThreadInteractive"),MainThreadTheming:(0,v.$Sw)("MainThreadTheming"),MainThreadTunnelService:(0,v.$Sw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.$Sw)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.$Sw)("MainThreadTimeline"),MainThreadTesting:(0,v.$Sw)("MainThreadTesting"),MainThreadLocalization:(0,v.$Sw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,v.$Sw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,v.$Sw)("MainThreadAiEmbeddingVector")},e.$EN={ExtHostCommands:(0,v.$Sw)("ExtHostCommands"),ExtHostConfiguration:(0,v.$Sw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.$Sw)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.$Sw)("ExtHostDebugService"),ExtHostDecorations:(0,v.$Sw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.$Sw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.$Sw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.$Sw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.$Sw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.$Sw)("ExtHostEditors"),ExtHostTreeViews:(0,v.$Sw)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.$Sw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.$Sw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.$Sw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.$Sw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.$Sw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.$Sw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.$Sw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.$Sw)("ExtHostStatusBar"),ExtHostShare:(0,v.$Sw)("ExtHostShare"),ExtHostExtensionService:(0,v.$Sw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.$Sw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.$Sw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,v.$Sw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,v.$Sw)("ExtHostSCM"),ExtHostSearch:(0,v.$Sw)("ExtHostSearch"),ExtHostTask:(0,v.$Sw)("ExtHostTask"),ExtHostWorkspace:(0,v.$Sw)("ExtHostWorkspace"),ExtHostWindow:(0,v.$Sw)("ExtHostWindow"),ExtHostWebviews:(0,v.$Sw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.$Sw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.$Sw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.$Sw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.$Sw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.$Sw)("ExtHostEditorTabs"),ExtHostProgress:(0,v.$Sw)("ExtHostProgress"),ExtHostComments:(0,v.$Sw)("ExtHostComments"),ExtHostSecretState:(0,v.$Sw)("ExtHostSecretState"),ExtHostStorage:(0,v.$Sw)("ExtHostStorage"),ExtHostUrls:(0,v.$Sw)("ExtHostUrls"),ExtHostUriOpeners:(0,v.$Sw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.$Sw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.$Sw)("ExtHostOutputService"),ExtHostLabelService:(0,v.$Sw)("ExtHostLabelService"),ExtHostNotebook:(0,v.$Sw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.$Sw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.$Sw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.$Sw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.$Sw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.$Sw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.$Sw)("ExtHostInteractive"),ExtHostChatAgents2:(0,v.$Sw)("ExtHostChatAgents"),ExtHostChatVariables:(0,v.$Sw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,v.$Sw)("ExtHostChatSkills"),ExtHostChatProvider:(0,v.$Sw)("ExtHostChatProvider"),ExtHostSpeech:(0,v.$Sw)("ExtHostSpeech"),ExtHostEmbeddings:(0,v.$Sw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,v.$Sw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,v.$Sw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,v.$Sw)("ExtHostTheming"),ExtHostTunnelService:(0,v.$Sw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.$Sw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.$Sw)("ExtHostAuthentication"),ExtHostTimeline:(0,v.$Sw)("ExtHostTimeline"),ExtHostTesting:(0,v.$Sw)("ExtHostTesting"),ExtHostTelemetry:(0,v.$Sw)("ExtHostTelemetry"),ExtHostLocalization:(0,v.$Sw)("ExtHostLocalization")}}),define(Oe[84],Ne([1,0,3,11,5,16]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zoc=e.$Yoc=e.$Xoc=void 0,P=We(P),e.$Xoc=(0,v.$Ci)("IExtHostApiDeprecationService");let R=class{constructor($,s){this.c=s,this.a=new Set,this.b=$.getProxy(P.$DN.MainThreadTelemetry)}report($,s,A){const y=this.d($,s);this.a.has(y)||(this.a.add(y),s.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:s.identifier.value,apiId:$}))}d($,s){return`${$}-${s.identifier.value}`}};e.$Yoc=R,e.$Yoc=R=Ge([Ve(0,O.$cQ),Ve(1,I.$0j)],R),e.$Zoc=Object.freeze(new class{report(T,$,s){}})}),define(Oe[211],Ne([1,0,5]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$apc=void 0;class I{constructor(O){const R=O.getProxy(v.$DN.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(T){return R.$writeText(T)}})}}e.$apc=I}),define(Oe[212],Ne([1,0,25,5,26,16]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9qc=void 0;let R=class{constructor(A,y){this.a=A.getProxy(I.$DN.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,y){const a=this,S=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){a.e(A,y,S,arguments)}})}e(A,y,a,S){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:$(S,this.b)}),this.c&&this.f(A,a,S)}};e.$9qc=R,e.$9qc=R=Ge([Ve(0,O.$cQ),Ve(1,P.$sQ)],R);const T=1e5;function $(s,A){const y=[];if(s.length)for(let a=0;a<s.length;a++){let S=s[a];if(typeof S>"u")S="undefined";else if(S instanceof Error){const d=S;d.stack?S=d.stack:S=d.toString()}y.push(S)}if(A){const a=new Error().stack;a&&y.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,v.$go)(y);return a.length>T?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Oe[213],Ne([1,0,2,5,24]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cqc=void 0;class O{constructor(T){this.a=T.getProxy(I.$DN.MainThreadDialogs)}showOpenDialog(T,$){return $?.allowUIResources&&(0,P.$dH)(T,"showLocal"),this.a.$showOpenDialog($).then(s=>s?s.map(A=>v.URI.revive(A)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then($=>$?v.URI.revive($):void 0)}}e.$cqc=O}),define(Oe[214],Ne([1,0,21,6,4,5]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fqc=void 0;class R{constructor($){this.b=new Map,this.c=new I.$je,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(O.$DN.MainThreadEmbeddings)}registerEmbeddingsProvider($,s,A){if(this.d.has(s))throw new Error("An embeddings provider for this model is already registered");const y=this.e++;return this.a.$registerEmbeddingProvider(y,s),this.b.set(y,{id:s,provider:A}),(0,P.$Rc)(()=>{this.d.delete(s),this.a.$unregisterEmbeddingProvider(y),this.b.delete(y)})}async computeEmbeddings($,s,A){A??=v.CancellationToken.None;let y=!1;typeof s=="string"&&(s=[s],y=!0);const a=await this.a.$computeEmbeddings($,s,A);if(a.length!==s.length)throw new Error;if(y){if(a.length!==1)throw new Error;return a[0]}return a}async $provideEmbeddings($,s,A){const y=this.b.get($);if(!y)return[];const a=await y.provider.provideEmbeddings(s,A);return a||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$fqc=R}),define(Oe[215],Ne([1,0,4,5]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=void 0;class P{constructor(R){this.b=0,this.a=R.getProxy(I.$DN.MainThreadLabelService)}$registerResourceLabelFormatter(R){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,R),(0,v.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$wqc=P}),define(Oe[85],Ne([1,0,20,12,2,3,11,5,26,16]),function(be,e,v,I,P,O,R,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=e.$Rpc=void 0;let A=class{constructor(a,S,d){this.f=d,this.d=new Map,this.a=S.getProxy(T.$DN.MainThreadLocalization),this.b=a.environment.appLanguage,this.c=this.b===v.$h}getMessage(a,S){const{message:d,args:n,comment:o}=S;if(this.c)return(0,I.$cf)(d,n??{});let c=d;o&&o.length>0&&(c+=`/${Array.isArray(o)?o.join(""):o}`);const l=this.d.get(a)?.contents[c];return l||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,I.$cf)(l??d,n??{})}getBundle(a){return this.d.get(a)?.contents}getBundleUri(a){return this.d.get(a)?.uri}async initializeLocalizedMessages(a){if(this.c||!a.l10n&&!a.isBuiltin||this.d.has(a.identifier.value))return;let S;const d=await this.g(a);if(!d){this.f.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents(d),o=JSON.parse(n);S=a.isBuiltin?o.contents?.bundle:o}catch(n){this.f.error(`Failed to load translations for ${a.identifier.value} from ${d}: ${n.message}`);return}S&&this.d.set(a.identifier.value,{contents:S,uri:d})}async g(a){if(a.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(a.identifier.value,this.b);return P.URI.revive(S)}return a.l10n?P.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Rpc=A,e.$Rpc=A=Ge([Ve(0,$.$sQ),Ve(1,s.$cQ),Ve(2,R.$0j)],A),e.$Spc=(0,O.$Ci)("IExtHostLocalizationService")}),define(Oe[216],Ne([1,0,11,5,26,16,2,40]),function(be,e,v,I,P,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8qc=void 0;let $=class extends v.$ik{constructor(y,a){super(a.logLevel,a.logsLocation,a.loggers.map(S=>(0,T.$_h)(S))),this.r=y.getProxy(I.$DN.MainThreadLogger)}$setLogLevel(y,a){a?this.setLogLevel(R.URI.revive(a),y):this.setLogLevel(y)}setVisibility(y,a){super.setVisibility(y,a),this.r.$setVisibility(y,a)}s(y,a,S){return new s(this.r,y,a,S)}};e.$8qc=$,e.$8qc=$=Ge([Ve(0,O.$cQ),Ve(1,P.$sQ)],$);class s extends v.$dk{constructor(y,a,S,d){super(d?.logLevel==="always"),this.r=y,this.s=a,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(a,d).then(()=>{this.u(this.n),this.m=!0})}g(y,a){const S=[[y,a]];this.m?this.u(S):this.n.push(...S)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Oe[86],Ne([1,0,5,3,4,16,22]),function(be,e,v,I,P,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=e.$Tpc=void 0,e.$Tpc=(0,I.$Ci)("IExtHostManagedSockets");let T=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(v.$DN.MainThreadManagedSockets)}setFactory(y,a){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(y,a),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const a=++this.b,S=await this.c.makeConnection(),d=new P.$Sc;return this.d.set(a,new s(a,S,d)),d.add((0,P.$Rc)(()=>this.d.delete(a))),d.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(a),d.dispose()})),d.add(S.onDidClose(n=>{this.a.$onDidManagedSocketClose(a,n?.stack??n?.message),d.dispose()})),d.add(S.onDidReceiveMessage(n=>this.a.$onDidManagedSocketHaveData(a,R.$Le.wrap(n)))),a}$remoteSocketWrite(y,a){this.d.get(y)?.actual.send(a.buffer)}$remoteSocketEnd(y){const a=this.d.get(y);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$Upc=T,e.$Upc=T=Ge([Ve(0,O.$cQ)],T);class ${constructor(y,a){this.socketFactoryId=y,this.makeConnection=a}}class s extends P.$Tc{constructor(y,a,S){super(),this.socketId=y,this.actual=a,this.B(S)}}}),define(Oe[217],Ne([1,0,5,11,24]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zqc=void 0;function O(T){return T&&T.title}let R=class{constructor($,s){this.b=s,this.a=$.getProxy(v.$DN.MainThreadMessageService)}showMessage($,s,A,y,a){const S={source:{identifier:$.identifier,label:$.displayName||$.name}};let d;typeof y=="string"||O(y)?d=[y,...a]:(S.modal=y?.modal,S.useCustom=y?.useCustom,S.detail=y?.detail,d=a),S.useCustom&&(0,P.$dH)($,"resolvers");const n=[];let o=!1;for(let c=0;c<d.length;c++){const l=d[c];if(typeof l=="string")n.push({title:l,handle:c,isCloseAffordance:!1});else if(typeof l=="object"){const{title:i,isCloseAffordance:r}=l;n.push({title:i,isCloseAffordance:!!r,handle:c}),r&&(o?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,l):o=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,l)}return this.a.$showMessage(s,A,S,n).then(c=>{if(typeof c=="number")return d[c]})}};e.$zqc=R,e.$zqc=R=Ge([Ve(1,I.$0j)],R)}),define(Oe[218],Ne([1,0,4,14,2,24,5]),function(be,e,v,I,P,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iqc=void 0;class T{constructor(s){this.b=new Map,this.a=s.getProxy(R.$DN.MainThreadProfileContentHandlers)}registerProfileContentHandler(s,A,y){if((0,O.$dH)(s,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,y),this.a.$registerProfileContentHandler(A,y.name,y.description,s.identifier.value),(0,v.$Rc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(s,A,y,a){const S=this.b.get(s);if(!S)throw new Error(`Unknown handler with id: ${s}`);return S.saveProfile(A,y,a)}async $readProfile(s,A,y){const a=this.b.get(s);if(!a)throw new Error(`Unknown handler with id: ${s}`);return a.readProfile((0,I.$cg)(A)?A:P.URI.revive(A),y)}}e.$Iqc=T}),define(Oe[87],Ne([1,0,5,6,3]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=e.$Opc=void 0;class O{constructor(T){this.b=new I.$je,this.onDidChangePassword=this.b.event,this.a=T.getProxy(v.$DN.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,$){return this.a.$getPassword(T,$)}store(T,$,s){return this.a.$setPassword(T,$,s)}delete(T,$){return this.a.$deletePassword(T,$)}}e.$Opc=O,e.$Ppc=(0,P.$Ci)("IExtHostSecretState")}),define(Oe[219],Ne([1,0,21,4,5]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pqc=void 0;class O{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(P.$DN.MainThreadSpeech)}async $createSpeechToTextSession(T,$,s){const A=this.c.get(T);if(!A)return;const y=new I.$Sc,a=new v.$ue;this.d.set($,a);const S=await A.provideSpeechToTextSession(a.token,s?{language:s}:void 0);S&&(y.add(S.onDidChange(d=>{a.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,d)})),y.add(a.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,$,s){const A=this.c.get(T);if(!A)return;const y=new I.$Sc,a=new v.$ue;this.d.set($,a);const S=await A.provideTextToSpeechSession(a.token,s?{language:s}:void 0);S&&(this.f.set($,S),y.add(S.onDidChange(d=>{a.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,d)})),y.add(a.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(T,$){this.f.get(T)?.synthesize($)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,$){const s=this.c.get(T);if(!s)return;const A=new I.$Sc,y=new v.$ue;this.d.set($,y);const a=await s.provideKeywordRecognitionSession(y.token);a&&(A.add(a.onDidChange(S=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,S)})),A.add(y.token.onCancellationRequested(()=>A.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,$,s){const A=O.a++;return this.c.set(A,s),this.b.$registerProvider(A,$,{extension:T,displayName:T.value}),(0,I.$Rc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Pqc=O}),define(Oe[88],Ne([1,0,5,6,3]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=e.$Epc=void 0;class O{constructor(T,$){this.c=$,this.b=new I.$je,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(v.$DN.MainThreadStorage)}registerExtensionStorageKeysToSync(T,$){this.a.$registerExtensionStorageKeysToSync(T,$)}async initializeExtensionStorage(T,$,s){const A=await this.a.$initializeExtensionStorage(T,$);let y;return A&&(y=this.d(T,$,A)),y||s}setValue(T,$,s){return this.a.$setValue(T,$,s)}$acceptValue(T,$,s){const A=this.d(T,$,s);A&&this.b.fire({shared:T,key:$,value:A})}d(T,$,s){try{return JSON.parse(s)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${T}): ${A}`)}}}e.$Epc=O,e.$Fpc=(0,P.$Ci)("IExtHostStorage")}),define(Oe[220],Ne([1,0,4,15,2,5]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2qc=void 0;class R{static{this.a=new Set([I.Schemas.http,I.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(O.$DN.MainThreadUriOpeners)}registerExternalUriOpener($,s,A,y){if(this.c.has(s))throw new Error(`Opener with id '${s}' already registered`);const a=y.schemes.find(S=>!R.a.has(S));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this.c.set(s,A),this.b.$registerUriOpener(s,y.schemes,$,y.label),(0,v.$Rc)(()=>{this.c.delete(s),this.b.$unregisterUriOpener(s)})}async $canOpenUri($,s,A){const y=this.c.get($);if(!y)throw new Error(`Unknown opener with id: ${$}`);const a=P.URI.revive(s);return y.canOpenExternalUri(a,A)}async $openUri($,s,A){const y=this.c.get($);if(!y)throw new Error(`Unknown opener id: '${$}'`);return y.openExternalUri(P.URI.revive(s.resolvedUri),{sourceUri:P.URI.revive(s.sourceUri)},A)}}e.$2qc=R}),define(Oe[221],Ne([1,0,5,2,4,13,18]),function(be,e,v,I,P,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3qc=void 0;class T{static{this.a=0}constructor(s){this.c=new R.$pn,this.d=new Map,this.b=s.getProxy(v.$DN.MainThreadUrls)}registerUriHandler(s,A){const y=s.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const a=T.a++;return this.c.add(y),this.d.set(a,A),this.b.$registerUriHandler(a,y,s.displayName||s.name),(0,P.$Rc)(()=>{this.c.delete(y),this.d.delete(a),this.b.$unregisterUriHandler(a)})}$handleExternalUri(s,A){const y=this.d.get(s);if(!y)return Promise.resolve(void 0);try{y.handleUri(I.URI.revive(A))}catch(a){(0,O.$Y)(a)}return Promise.resolve(void 0)}async createAppUri(s){return I.URI.revive(await this.b.$createAppUri(s))}}e.$3qc=T}),define(Oe[222],Ne([1,0,22,5]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jtb=O,e.$Ktb=T,I=We(I);class P{constructor(){this.buffers=[]}add(s){let A=this.buffers.indexOf(s);return A<0&&(A=this.buffers.length,this.buffers.push(s)),A}}function O($,s){if(s.serializeBuffersForPostMessage){const A=new P,a=JSON.stringify($,(d,n)=>{if(n instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:A.add(n)};if(ArrayBuffer.isView(n)){const o=R(n);if(o)return{$$vscode_array_buffer_reference$$:!0,index:A.add(n.buffer),view:{type:o,byteLength:n.byteLength,byteOffset:n.byteOffset}}}return n}),S=A.buffers.map(d=>{const n=new Uint8Array(d);return v.$Le.wrap(n)});return{message:a,buffers:S}}else return{message:JSON.stringify($),buffers:[]}}function R($){switch($.constructor.name){case"Int8Array":return I.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return I.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return I.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return I.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return I.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return I.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return I.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return I.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return I.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return I.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return I.WebviewMessageArrayBufferViewType.BigUint64Array}}function T($,s){const A=s.map(S=>{const d=new ArrayBuffer(S.byteLength);return new Uint8Array(d).set(S.buffer),d}),y=s.length?(S,d)=>{if(d&&typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const n=d,{index:o}=n,c=A[o];if(n.view)switch(n.view.type){case I.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(c,n.view.byteOffset,n.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(c,n.view.byteOffset,n.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(c,n.view.byteOffset,n.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(c,n.view.byteOffset,n.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(c,n.view.byteOffset,n.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(c,n.view.byteOffset,n.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(c,n.view.byteOffset,n.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(c,n.view.byteOffset,n.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(c,n.view.byteOffset,n.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(c,n.view.byteOffset,n.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case I.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(c,n.view.byteOffset,n.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return d}:void 0;return{message:JSON.parse($,y),arrayBuffers:A}}}),define(Oe[67],Ne([1,0,6,4,15,25,2,175,222,82,5]),function(be,e,v,I,P,O,R,T,$,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=e.$ppc=void 0,e.$qpc=a,e.$spc=n,e.$tpc=o,O=We(O),A=We(A);class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(r,t,g,u,m,p,h){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new v.$je,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new v.$je,this._onDidDispose=this.#h.event,this.#e=r,this.#t=t,this.#o=g,this.#n=u,this.#s=m,this.#r=p,this.#u=a(p),this.#d=S(p),this.#i=h}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#l=!0,(0,s.$vDb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===P.Schemas.https||r.scheme===P.Schemas.http){let t=r.toString();return t.endsWith("/")||(t+="/"),t+" "+s.$uDb}return s.$uDb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),O.$fo(this.#o,r)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const t=(0,$.$Jtb)(r,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const t=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,g=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,m,p,h,E,D)=>{const b=R.URI.from({scheme:h||"file",path:decodeURIComponent(E)}),k=(0,s.$vDb)(b,{isRemote:t,authority:g}).toString();return`${m}${k}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,m,p,h,E,D)=>{const b=R.URI.from({scheme:h||"file",path:decodeURIComponent(E)}),k=(0,s.$vDb)(b,{isRemote:t,authority:g}).toString();return`${m}${k}${D}`})}}e.$ppc=y;function a(i){try{const r=(0,T.$Yp)((0,T.$Xp)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function S(i){try{const r=(0,T.$Yp)((0,T.$Xp)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class d extends I.$Tc{constructor(r,t,g,u,m){super(),this.c=t,this.f=g,this.g=u,this.h=m,this.b=new Map,this.a=r.getProxy(A.$DN.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,t,g){const u=this.j(r);if(u){const{message:m}=(0,$.$Ktb)(t,g.value);u._onMessageEmitter.fire(m)}}$onMissingCsp(r,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,t,g){const u=new y(r,this.a,c(t),this.c,this.f,g,this.h);this.b.set(r,u);const m=u._onDidDispose(()=>{m.dispose(),this.deleteWebview(r)});return u}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$rpc=d;function n(i){return{id:i.identifier,location:i.extensionLocation}}function o(i,r,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||l(i,r)}}function c(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>R.URI.from(r))}}function l(i,r){return[...(r?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Oe[121],Ne([1,0,6,15,12,2,3,16,5]),function(be,e,v,I,P,O,R,T,$){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=e.$5qc=void 0;let A=class{static{s=this}static{this.a={focused:!0,active:!0}}getState(){const a=this.d;return{get focused(){return a.focused},get active(){return a.active}}}constructor(a){this.c=new v.$je,this.onDidChangeWindowState=this.c.event,this.d=s.a,this.b=a.getProxy($.$DN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:d})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(a){this.onDidChangeWindowProperty("focused",a)}$onDidChangeWindowActive(a){this.onDidChangeWindowProperty("active",a)}onDidChangeWindowProperty(a,S){S!==this.d[a]&&(this.d={...this.d,[a]:S},this.c.fire(this.d))}openUri(a,S){let d;if(typeof a=="string"){d=a;try{a=O.URI.parse(a)}catch{return Promise.reject(`Invalid uri - '${a}'`)}}return(0,P.$af)(a.scheme)?Promise.reject("Invalid scheme - cannot be empty"):a.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${a.scheme}'`):this.b.$openUri(a,d,S)}async asExternalUri(a,S){if((0,P.$af)(a.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(a,S);return O.URI.from(d)}};e.$5qc=A,e.$5qc=A=s=Ge([Ve(0,T.$cQ)],A),e.$6qc=(0,R.$Ci)("IExtHostWindow")}),define(Oe[223],Ne([1,0,212,26,16]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gtc=void 0;let O=class extends v.$9qc{constructor(T,$){super(T,$)}f(T,$,s){$.apply(console,s)}};e.$gtc=O,e.$gtc=O=Ge([Ve(0,P.$cQ),Ve(1,I.$sQ)],O)}),define(Oe[224],Ne([1,0,10,22,21,27,13,6,4,36,150,210,38]),function(be,e,v,I,P,O,R,T,$,s,A,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=e.ResponsiveState=e.RequestInitiator=void 0,e.$pdc=l,e.$qdc=i,R=We(R);function d(M,N){try{return JSON.stringify(M,N)}catch{return"null"}}const n="$$ref$$",o={[n]:-1};class c{constructor(N,L){this.jsonString=N,this.referencedBuffers=L}}function l(M,N=null,L=!1){const W=[];return{jsonString:(L?d:JSON.stringify)(M,(F,K)=>{if(typeof K>"u")return o;if(typeof K=="object"){if(K instanceof I.$Le){const Y=W.push(K)-1;return{[n]:Y}}if(N)return N(F,K)}return K}),referencedBuffers:W}}function i(M,N,L){return JSON.parse(M,(W,G)=>{if(G){const F=G[n];if(typeof F=="number")return N[F];if(L&&G.$mid===s.MarshalledId.Uri)return L.transformIncoming(G)}return G})}function r(M,N){return JSON.stringify(M,N)}function t(M){return M?(N,L)=>L&&L.$mid===s.MarshalledId.Uri?M.transformOutgoing(L):L:null}var g;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));var u;(function(M){M[M.Responsive=0]="Responsive",M[M.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const m=()=>{},p=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class E extends $.$Tc{static{S=p}static{this.a=3*1e3}constructor(N,L=null,W=null){super(),this[S]=!0,this.b=this.B(new T.$je),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=L,this.g=W,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let G=0,F=a.$Rw.count;G<F;G++)this.m[G]=null,this.s[G]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=u.Responsive,this.z=0,this.C=0,this.D=this.B(new v.$Oh(()=>this.H(),1e3)),this.B(this.c.onMessage(G=>this.L(G)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const L=this.w[N];delete this.w[N],L.resolveErr(R.$5())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+E.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+E.a,this.z--,this.z===0&&this.D.cancel(),this.I(u.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(u.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,A.$Mn)(N,this.g):N}getProxy(N){const{nid:L,sid:W}=N;return this.s[L]||(this.s[L]=this.J(L,W)),this.s[L]}J(N,L){const W={get:(G,F)=>(typeof F=="string"&&!G[F]&&F.charCodeAt(0)===O.CharCode.DollarSign&&(G[F]=(...K)=>this.U(N,F,K)),F===h?L:G[F])};return new Proxy(Object.create(null),W)}set(N,L){return this.m[N.nid]=L,L}assertRegistered(N){for(let L=0,W=N.length;L<W;L++){const G=N[L];if(!this.m[G.nid])throw new Error(`Missing proxy instance ${G.sid}`)}}L(N){if(this.j)return;const L=N.byteLength,W=b.read(N,0),G=W.readUInt8(),F=W.readUInt32();switch(G){case f.RequestJSONArgs:case f.RequestJSONArgsWithCancellation:{let{rpcId:K,method:Y,args:le}=C.deserializeRequestJSONArgs(W);this.g&&(le=(0,A.$Mn)(le,this.g)),this.M(L,F,K,Y,le,G===f.RequestJSONArgsWithCancellation);break}case f.RequestMixedArgs:case f.RequestMixedArgsWithCancellation:{let{rpcId:K,method:Y,args:le}=C.deserializeRequestMixedArgs(W);this.g&&(le=(0,A.$Mn)(le,this.g)),this.M(L,F,K,Y,le,G===f.RequestMixedArgsWithCancellation);break}case f.Acknowledged:{this.f?.logIncoming(L,F,g.LocalSide,"ack"),this.G(F);break}case f.Cancel:{this.N(L,F);break}case f.ReplyOKEmpty:{this.O(L,F,void 0);break}case f.ReplyOKJSON:{let K=C.deserializeReplyOKJSON(W);this.g&&(K=(0,A.$Mn)(K,this.g)),this.O(L,F,K);break}case f.ReplyOKJSONWithBuffers:{const K=C.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(L,F,K);break}case f.ReplyOKVSBuffer:{const K=C.deserializeReplyOKVSBuffer(W);this.O(L,F,K);break}case f.ReplyErrError:{let K=C.deserializeReplyErrError(W);this.g&&(K=(0,A.$Mn)(K,this.g)),this.P(L,F,K);break}case f.ReplyErrEmpty:{this.P(L,F,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,L,W,G,F,K){this.f?.logIncoming(N,L,g.OtherSide,`receiveRequest ${(0,a.$Tw)(W)}.${G}(`,F);const Y=String(L);let le,_;if(K){const se=new P.$ue;F.push(se.token),le=this.Q(W,G,F),_=()=>se.cancel()}else le=this.Q(W,G,F),_=m;this.u[Y]=_;const ge=C.serializeAcknowledged(L);this.f?.logOutgoing(ge.byteLength,L,g.OtherSide,"ack"),this.c.send(ge),le.then(se=>{delete this.u[Y];const ae=C.serializeReplyOK(L,se,this.h);this.f?.logOutgoing(ae.byteLength,L,g.OtherSide,"reply:",se),this.c.send(ae)},se=>{delete this.u[Y];const ae=C.serializeReplyErr(L,se);this.f?.logOutgoing(ae.byteLength,L,g.OtherSide,"replyErr:",se),this.c.send(ae)})}N(N,L){this.f?.logIncoming(N,L,g.OtherSide,"receiveCancel");const W=String(L);this.u[W]?.()}O(N,L,W){this.f?.logIncoming(N,L,g.LocalSide,"receiveReply:",W);const G=String(L);if(!this.w.hasOwnProperty(G))return;const F=this.w[G];delete this.w[G],F.resolveOk(W)}P(N,L,W){this.f?.logIncoming(N,L,g.LocalSide,"receiveReplyErr:",W);const G=String(L);if(!this.w.hasOwnProperty(G))return;const F=this.w[G];delete this.w[G];let K;W&&(W.$isError?(K=new Error,K.name=W.name,K.message=W.message,K.stack=W.stack):K=W),F.resolveErr(K)}Q(N,L,W){try{return Promise.resolve(this.S(N,L,W))}catch(G){return Promise.reject(G)}}S(N,L,W){const G=this.m[N];if(!G)throw new Error("Unknown actor "+(0,a.$Tw)(N));const F=G[L];if(typeof F!="function")throw new Error("Unknown method "+L+" on actor "+(0,a.$Tw)(N));return F.apply(G,W)}U(N,L,W){if(this.j)return new y.$odc;let G=null;if(W.length>0&&P.CancellationToken.isCancellationToken(W[W.length-1])&&(G=W.pop()),G&&G.isCancellationRequested)return Promise.reject(R.$5());const F=C.serializeRequestArguments(W,this.h),K=++this.t,Y=String(K),le=new y.$ndc,_=new $.$Sc;G&&_.add(G.onCancellationRequested(()=>{const se=C.serializeCancel(K);this.f?.logOutgoing(se.byteLength,K,g.LocalSide,"cancel"),this.c.send(C.serializeCancel(K))})),this.w[Y]=new D(le,_),this.F(K);const ge=C.serializeRequest(K,N,L,F,!!G);return this.f?.logOutgoing(ge.byteLength,K,g.LocalSide,`request: ${(0,a.$Tw)(N)}.${L}(`,W),this.c.send(ge),le}}e.$rdc=E;class D{constructor(N,L){this.a=N,this.b=L}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class b{static alloc(N,L,W){const G=new b(I.$Le.alloc(W+1+4),0);return G.writeUInt8(N),G.writeUInt32(L),G}static read(N,L){return new b(N,L)}get buffer(){return this.a}constructor(N,L){this.a=N,this.b=L}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+N).toString();return this.b+=N,W}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+N).toString();return this.b+=N,W}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+N);return this.b+=N,L}static sizeMixedArray(N){let L=0;L+=1;for(let W=0,G=N.length;W<G;W++){const F=N[W];switch(L+=1,F.type){case w.String:L+=this.sizeLongString(F.value);break;case w.VSBuffer:L+=this.sizeVSBuffer(F.value);break;case w.SerializedObjectWithBuffers:L+=this.sizeUInt32,L+=this.sizeLongString(F.value);for(let K=0;K<F.buffers.length;++K)L+=this.sizeVSBuffer(F.buffers[K]);break;case w.Undefined:break}}return L}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let L=0,W=N.length;L<W;L++){const G=N[L];switch(G.type){case w.String:this.writeUInt8(w.String),this.writeLongString(G.value);break;case w.VSBuffer:this.writeUInt8(w.VSBuffer),this.writeVSBuffer(G.value);break;case w.SerializedObjectWithBuffers:this.writeUInt8(w.SerializedObjectWithBuffers),this.writeUInt32(G.buffers.length),this.writeLongString(G.value);for(let F=0;F<G.buffers.length;++F)this.writeBuffer(G.buffers[F]);break;case w.Undefined:this.writeUInt8(w.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const L=new Array(N);for(let W=0;W<N;W++)switch(this.readUInt8()){case w.String:L[W]=this.readLongString();break;case w.VSBuffer:L[W]=this.readVSBuffer();break;case w.SerializedObjectWithBuffers:{const F=this.readUInt32(),K=this.readLongString(),Y=[];for(let le=0;le<F;++le)Y.push(this.readVSBuffer());L[W]=new a.$Uw(i(K,Y,null));break}case w.Undefined:L[W]=void 0;break}return L}}var k;(function(M){M[M.Simple=0]="Simple",M[M.Mixed=1]="Mixed"})(k||(k={}));class C{static a(N){for(let L=0,W=N.length;L<W;L++)if(N[L]instanceof I.$Le||N[L]instanceof a.$Uw||typeof N[L]>"u")return!0;return!1}static serializeRequestArguments(N,L){if(this.a(N)){const W=[];for(let G=0,F=N.length;G<F;G++){const K=N[G];if(K instanceof I.$Le)W[G]={type:w.VSBuffer,value:K};else if(typeof K>"u")W[G]={type:w.Undefined};else if(K instanceof a.$Uw){const{jsonString:Y,referencedBuffers:le}=l(K.value,L);W[G]={type:w.SerializedObjectWithBuffers,value:I.$Le.fromString(Y),buffers:le}}else W[G]={type:w.String,value:I.$Le.fromString(r(K,L))}}return{type:k.Mixed,args:W}}return{type:k.Simple,args:r(N,L)}}static serializeRequest(N,L,W,G,F){switch(G.type){case k.Simple:return this.b(N,L,W,G.args,F);case k.Mixed:return this.c(N,L,W,G.args,F)}}static b(N,L,W,G,F){const K=I.$Le.fromString(W),Y=I.$Le.fromString(G);let le=0;le+=b.sizeUInt8(),le+=b.sizeShortString(K),le+=b.sizeLongString(Y);const _=b.alloc(F?f.RequestJSONArgsWithCancellation:f.RequestJSONArgs,N,le);return _.writeUInt8(L),_.writeShortString(K),_.writeLongString(Y),_.buffer}static deserializeRequestJSONArgs(N){const L=N.readUInt8(),W=N.readShortString(),G=N.readLongString();return{rpcId:L,method:W,args:JSON.parse(G)}}static c(N,L,W,G,F){const K=I.$Le.fromString(W);let Y=0;Y+=b.sizeUInt8(),Y+=b.sizeShortString(K),Y+=b.sizeMixedArray(G);const le=b.alloc(F?f.RequestMixedArgsWithCancellation:f.RequestMixedArgs,N,Y);return le.writeUInt8(L),le.writeShortString(K),le.writeMixedArray(G),le.buffer}static deserializeRequestMixedArgs(N){const L=N.readUInt8(),W=N.readShortString(),G=N.readMixedArray(),F=new Array(G.length);for(let K=0,Y=G.length;K<Y;K++){const le=G[K];typeof le=="string"?F[K]=JSON.parse(le):F[K]=le}return{rpcId:L,method:W,args:F}}static serializeAcknowledged(N){return b.alloc(f.Acknowledged,N,0).buffer}static serializeCancel(N){return b.alloc(f.Cancel,N,0).buffer}static serializeReplyOK(N,L,W){if(typeof L>"u")return this.d(N);if(L instanceof I.$Le)return this.e(N,L);if(L instanceof a.$Uw){const{jsonString:G,referencedBuffers:F}=l(L.value,W,!0);return this.g(N,G,F)}else return this.f(N,d(L,W))}static d(N){return b.alloc(f.ReplyOKEmpty,N,0).buffer}static e(N,L){let W=0;W+=b.sizeVSBuffer(L);const G=b.alloc(f.ReplyOKVSBuffer,N,W);return G.writeVSBuffer(L),G.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,L){const W=I.$Le.fromString(L);let G=0;G+=b.sizeLongString(W);const F=b.alloc(f.ReplyOKJSON,N,G);return F.writeLongString(W),F.buffer}static g(N,L,W){const G=I.$Le.fromString(L);let F=0;F+=b.sizeUInt32,F+=b.sizeLongString(G);for(const Y of W)F+=b.sizeVSBuffer(Y);const K=b.alloc(f.ReplyOKJSONWithBuffers,N,F);K.writeUInt32(W.length),K.writeLongString(G);for(const Y of W)K.writeBuffer(Y);return K.buffer}static deserializeReplyOKJSON(N){const L=N.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(N,L){const W=N.readUInt32(),G=N.readLongString(),F=[];for(let K=0;K<W;++K)F.push(N.readVSBuffer());return new a.$Uw(i(G,F,L))}static serializeReplyErr(N,L){const W=L?d(R.$1(L),null):void 0;if(typeof W!="string")return this.h(N);const G=I.$Le.fromString(W);let F=0;F+=b.sizeLongString(G);const K=b.alloc(f.ReplyErrError,N,F);return K.writeLongString(G),K.buffer}static deserializeReplyErrError(N){const L=N.readLongString();return JSON.parse(L)}static h(N){return b.alloc(f.ReplyErrEmpty,N,0).buffer}}var f;(function(M){M[M.RequestJSONArgs=1]="RequestJSONArgs",M[M.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",M[M.RequestMixedArgs=3]="RequestMixedArgs",M[M.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",M[M.Acknowledged=5]="Acknowledged",M[M.Cancel=6]="Cancel",M[M.ReplyOKEmpty=7]="ReplyOKEmpty",M[M.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",M[M.ReplyOKJSON=9]="ReplyOKJSON",M[M.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",M[M.ReplyErrError=11]="ReplyErrError",M[M.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var w;(function(M){M[M.String=1]="String",M[M.VSBuffer=2]="VSBuffer",M[M.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",M[M.Undefined=4]="Undefined"})(w||(w={}))}),define(Oe[225],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$itc=void 0;const v=function(O){const R=T=>{globalThis.removeEventListener("message",R);const $=T.data;Object.defineProperties(globalThis,{postMessage:{value(s,A){$.postMessage(s,A)}},onmessage:{get(){return $.onmessage},set(s){$.onmessage=s}}}),$.addEventListener("message",s=>{globalThis.dispatchEvent(new MessageEvent("message",{data:s.data,ports:s.ports?[...s.ports]:void 0}))}),$.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",R)}.toString();class I extends EventTarget{constructor(O,R,T){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const $=`((${v})('${R}'))`,s=new Blob([$],{type:"application/javascript"}),A=URL.createObjectURL(s),y=new MessageChannel,a=A,S={type:"_newWorker",id:a,port:y.port2,url:A,options:T};O(S,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{O({type:"_terminateWorker",id:a}),URL.revokeObjectURL(A),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(d){y.port1.onmessage=d}},onmessageerror:{get(){return y.port1.onmessageerror},set(d){y.port1.onmessageerror=d}}}),y.port1.addEventListener("messageerror",d=>{const n=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(n)}),y.port1.addEventListener("message",d=>{const n=new MessageEvent("message",{data:d.data});this.dispatchEvent(n)}),y.port1.start()}}e.$itc=I}),define(Oe[226],Ne([1,0,22,28,15,60,3]),function(be,e,v,I,P,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qL=e.$nL=void 0,e.$oL=A,e.$pL=y,e.$nL=(0,R.$Ci)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${T.join("")}]+`),s=7;function A(S){if(S.scheme!==P.Schemas.vscodeNotebookCell)return;const d=S.fragment.indexOf("s");if(d<0)return;const n=parseInt(S.fragment.substring(0,d).replace($,""),s),o=(0,v.$5e)(S.fragment.substring(d+1)).toString();if(!isNaN(n))return{handle:n,notebook:S.with({scheme:o,fragment:null})}}function y(S,d){const n=d.toString(s),c=`${n.length<T.length?T[n.length-1]:"z"}${n}s${(0,v.$6e)(v.$Le.fromString(S.scheme),!0,!0)}`;return S.with({scheme:P.Schemas.vscodeNotebookCell,fragment:c})}class a{constructor(){this.a=new I.$zc}getNotebook(d){if(d.scheme===P.Schemas.vscodeNotebookCell){const n=A(d);if(n){const o=this.a.get(n.notebook);if(o)return o}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$qL=a,(0,O.$Os)(e.$nL,a,O.InstantiationType.Delayed)}),define(Oe[89],Ne([1,0,22,41,39,72,15,19,20,31,226]),function(be,e,v,I,P,O,R,T,$,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=e.$HL=e.CellStatusbarAlignment=e.$GL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$DL=e.$CL=e.$AL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$zL=e.$yL=e.$xL=e.$wL=e.CellKind=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=void 0,e.$BL=u,e.$EL=h,e.$FL=E,e.$IL=k,e.$JL=f,I=We(I),e.$rL="workbench.editor.notebook",e.$sL="workbench.editor.notebookTextDiffEditor",e.$tL="workbench.editor.interactive",e.$uL="workbench.editor.repl",e.$vL="replNotebook.input.execute";var y;(function(Y){Y[Y.Markup=1]="Markup",Y[Y.Code=2]="Code"})(y||(e.CellKind=y={})),e.$wL=["application/json","application/javascript","text/html","image/svg+xml",O.$8s.latex,O.$8s.markdown,"image/png","image/jpeg",O.$8s.text],e.$xL=[O.$8s.latex,O.$8s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$8s.text],e.$yL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$zL="_notAvailable";var a;(function(Y){Y[Y.Running=1]="Running",Y[Y.Idle=2]="Idle"})(a||(e.NotebookRunState=a={}));var S;(function(Y){Y[Y.Unconfirmed=1]="Unconfirmed",Y[Y.Pending=2]="Pending",Y[Y.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var d;(function(Y){Y[Y.Unconfirmed=1]="Unconfirmed",Y[Y.Pending=2]="Pending",Y[Y.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var n;(function(Y){Y[Y.WithHardKernelDependency=0]="WithHardKernelDependency",Y[Y.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Y[Y.Pure=2]="Pure",Y[Y.Never=3]="Never"})(n||(e.NotebookRendererMatch=n={}));var o;(function(Y){Y.Always="always",Y.Never="never",Y.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var c;(function(Y){Y[Y.ModelChange=1]="ModelChange",Y[Y.Move=2]="Move",Y[Y.ChangeCellLanguage=5]="ChangeCellLanguage",Y[Y.Initialize=6]="Initialize",Y[Y.ChangeCellMetadata=7]="ChangeCellMetadata",Y[Y.Output=8]="Output",Y[Y.OutputItem=9]="OutputItem",Y[Y.ChangeCellContent=10]="ChangeCellContent",Y[Y.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Y[Y.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Y[Y.ChangeCellMime=13]="ChangeCellMime",Y[Y.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var l;(function(Y){Y[Y.Handle=0]="Handle",Y[Y.Index=1]="Index"})(l||(e.SelectionStateType=l={}));var i;(function(Y){Y[Y.Replace=1]="Replace",Y[Y.Output=2]="Output",Y[Y.Metadata=3]="Metadata",Y[Y.CellLanguage=4]="CellLanguage",Y[Y.DocumentMetadata=5]="DocumentMetadata",Y[Y.Move=6]="Move",Y[Y.OutputItems=7]="OutputItems",Y[Y.PartialMetadata=8]="PartialMetadata",Y[Y.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(Y){Y.scheme=R.Schemas.vscodeNotebookCell;function le(oe,Ce){return(0,A.$pL)(oe,Ce)}Y.generate=le;function _(oe){return(0,A.$oL)(oe)}Y.parse=_;function ge(oe,Ce){return oe.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${Ce??""},${oe.scheme!==R.Schemas.file?oe.scheme:""}`})}Y.generateCellOutputUri=ge;function se(oe){if(oe.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const Ce=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!Ce)return;const Le=Ce[1]&&Ce[1]!==""?Ce[1]:void 0,Z=Ce[2];return{outputId:Le,notebook:oe.with({scheme:Z||R.Schemas.file,fragment:null})}}Y.parseCellOutputUri=se;function ae(oe,Ce,Le){return Y.generate(oe,Ce).with({scheme:Le})}Y.generateCellPropertyUri=ae;function $e(oe,Ce){if(oe.scheme===Ce)return Y.parse(oe.with({scheme:Y.scheme}))}Y.parseCellPropertyUri=$e})(r||(e.CellUri=r={}));const t=Y=>$.$j?Y.replace(/\//g,"\\"):Y;class g{constructor(le=[],_=e.$wL){this.e=_,this.d=[...new Set(le)].map(ge=>({pattern:ge,matches:I.$xk(t(ge))}))}sort(le){const _=new Map(P.Iterable.map(le,se=>[se,t(se)]));let ge=[];for(const{matches:se}of this.d)for(const[ae,$e]of _)if(se($e)){ge.push(ae),_.delete(ae);break}return _.size&&(ge=ge.concat([..._.keys()].sort((se,ae)=>this.e.indexOf(se)-this.e.indexOf(ae)))),ge}prioritize(le,_){const ge=this.f(le);if(ge===-1){this.d.unshift({pattern:le,matches:I.$xk(t(le))});return}const se=new Set(_.map($e=>this.f($e,ge)));se.delete(-1);const ae=Array.from(se).sort();this.d.splice(ge+1,0,...ae.map($e=>this.d[$e]));for(let $e=ae.length-1;$e>=0;$e--)this.d.splice(ae[$e],1)}toArray(){return this.d.map(le=>le.pattern)}f(le,_=this.d.length){const ge=t(le);for(let se=0;se<_;se++)if(this.d[se].matches(ge))return se;return-1}}e.$AL=g;function u(Y,le,_,ge=(se,ae)=>se===ae){const se=[];function ae(Ce,Le,Z){if(Le===0&&Z.length===0)return;const q=se[se.length-1];q&&q.start+q.deleteCount===Ce?(q.deleteCount+=Le,q.toInsert.push(...Z)):se.push({start:Ce,deleteCount:Le,toInsert:Z})}let $e=0,oe=0;for(;;){if($e===Y.length){ae($e,0,le.slice(oe));break}if(oe===le.length){ae($e,Y.length-$e,[]);break}const Ce=Y[$e],Le=le[oe];if(ge(Ce,Le)){$e+=1,oe+=1;continue}_(Le)?(ae($e,1,[]),$e+=1):(ae($e,0,[Le]),oe+=1)}return se}e.$CL=new s.$Tj("notebookEditorCursorAtBoundary","none"),e.$DL=new s.$Tj("notebookEditorCursorAtLineBoundary","none");var m;(function(Y){Y.default="default",Y.option="option"})(m||(e.NotebookEditorPriority=m={}));var p;(function(Y){Y.Cells="cells",Y.Text="text",Y.None="none"})(p||(e.NotebookFindScopeType=p={}));function h(Y){const le=Y;return!!((typeof le.include=="string"||I.$yk(le.include))&&(typeof le.exclude=="string"||I.$yk(le.exclude)))}function E(Y,le,_){if(Array.isArray(Y.viewType)&&Y.viewType.indexOf(le)>=0||Y.viewType===le)return!0;if(Y.filenamePattern){const ge=h(Y.filenamePattern)?Y.filenamePattern.include:Y.filenamePattern,se=h(Y.filenamePattern)?Y.filenamePattern.exclude:void 0;if(I.$wk(ge,(0,T.$mc)(_.fsPath).toLowerCase()))return!(se&&I.$wk(se,(0,T.$mc)(_.fsPath).toLowerCase()))}return!1}e.$GL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(Y){Y[Y.Left=1]="Left",Y[Y.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class b{static{this.d="notebook/"}static create(le){return`${b.d}${le}`}static parse(le){if(le.startsWith(b.d))return le.substring(b.d.length)}}e.$HL=b;function k(Y){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Y)}const C=new TextDecoder;function f(Y){const le=[];let _=!1;for(const $e of Y)(le.length===0||_)&&(le.push($e),_=!0);let ge=N(le);const se=v.$Le.concat(le.map($e=>v.$Le.wrap($e))),ae=K(se);return ge=ge||ae.byteLength!==se.byteLength,{data:ae,didCompression:ge}}e.$KL="\x1B[A";const w=e.$KL.split("").map(Y=>Y.charCodeAt(0)),M=10;function N(Y){let le=!1;return Y.forEach((_,ge)=>{if(ge===0||_.length<e.$KL.length)return;const se=Y[ge-1],ae=_.subarray(0,e.$KL.length);if(ae[0]===w[0]&&ae[1]===w[1]&&ae[2]===w[2]){const $e=se.lastIndexOf(M);if($e===-1)return;le=!0,Y[ge-1]=se.subarray(0,$e),Y[ge]=_.subarray(e.$KL.length)}}),le}function L(Y){let le=Y;do Y=le,le=Y.replace(/[^\n]\x08/gm,"");while(le.length<Y.length);return Y}function W(Y){for(Y=Y.replace(/\r+\n/gm,`
`);Y.search(/\r[^$]/g)>-1;){const le=Y.match(/^(.*)\r+/m)[1];let _=Y.match(/\r+(.*)$/m)[1];_=_+le.slice(_.length,le.length),Y=Y.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,_)}return Y}const G=8,F=13;function K(Y){return!Y.buffer.includes(G)&&!Y.buffer.includes(F)?Y:v.$Le.fromString(W(L(C.decode(Y.buffer))))}}),define(Oe[7],Ne([1,0,17,13,59,28,72,12,14,2,37,18,29,109,89]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d){"use strict";var n,o,c,l,i,r,t,g,u,m,p,h,E,D,b,k,C;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$4P=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$3P=e.$2P=e.$1P=e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.LanguageModelChatMessageRole=e.$UP=e.$TP=e.ChatLocation=e.$SP=e.$RP=e.$QP=e.$PP=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.$GP=e.$FP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$EP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.$sP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$rP=e.$qP=e.$pP=e.$oP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.TestRunProfileKind=e.TestResultState=e.$hP=e.$gP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$fP=e.NotebookVariablesRequestKind=e.$eP=e.$dP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$cP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.ColorThemeKind=e.$9O=e.$8O=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$7O=e.QuickInputButtonLocation=e.$6O=e.DebugConsoleMode=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$ZO=e.$YO=e.FileChangeType=e.$XO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$WO=e.$VO=e.$UO=e.$TO=e.InlineCompletionTriggerKind=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.$LO=e.$KO=e.$JO=e.$IO=e.$GO=e.ConfigurationTarget=e.$FO=e.$EO=e.$DO=e.$CO=e.DocumentPasteTriggerKind=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$vO=e.ViewBadge=e.ProgressLocation=e.$uO=e.$tO=e.TaskScope=e.ShellQuoting=e.$sO=e.$rO=e.$qO=e.TaskPanelKind=e.TaskRevealKind=e.$pO=e.TerminalLocation=e.$oO=e.$nO=e.$mO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$lO=e.$kO=e.$jO=e.$iO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$gO=e.$fO=e.$eO=e.$dO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$cO=e.$bO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.LanguageStatusSeverity=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.CodeActionTriggerKind=e.$2N=e.$1N=e.SymbolTag=e.SymbolKind=e.$ZN=e.$YN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.DiagnosticSeverity=e.DiagnosticTag=e.$SN=e.$RN=e.FileEditType=e.$QN=e.$PN=e.$ON=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$NN=e.$MN=e.$LN=e.$IN=e.$HN=e.$GN=e.$FN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$JN=F,e.$KN=K,e.$hO=$t,e.$HO=Li,e.$nP=Pn;function f(j){return Object.assign(j,{apply:function(...re){if(re.length===0)return Reflect.construct(j,[]);{const Se=re.length===1?[]:re[1];return Reflect.construct(j,Se,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(j,[]);{const[Se,...Ke]=re;return Reflect.construct(j,Ke,Se.constructor)}}})}var w;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(w||(e.TerminalOutputAnchor=w={}));var M;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let N=n=class{static from(...z){let re=z;return new n(function(){if(re){for(const Se of re)Se&&typeof Se.dispose=="function"&&Se.dispose();re=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$FN=N,e.$FN=N=n=Ge([f],N);let L=o=class{static Min(...z){if(z.length===0)throw new TypeError;let re=z[0];for(let Se=1;Se<z.length;Se++){const Ke=z[Se];Ke.isBefore(re)&&(re=Ke)}return re}static Max(...z){if(z.length===0)throw new TypeError;let re=z[0];for(let Se=1;Se<z.length;Se++){const Ke=z[Se];Ke.isAfter(re)&&(re=Ke)}return re}static isPosition(z){if(!z)return!1;if(z instanceof o)return!0;const{line:re,character:Se}=z;return typeof re=="number"&&typeof Se=="number"}static of(z){if(z instanceof o)return z;if(this.isPosition(z))return new o(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,re){if(z<0)throw(0,I.$6)("line must be non-negative");if(re<0)throw(0,I.$6)("character must be non-negative");this.c=z,this.e=re}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,re=0){if(z===null||re===null)throw(0,I.$6)();let Se;return typeof z>"u"?Se=0:typeof z=="number"?Se=z:(Se=typeof z.lineDelta=="number"?z.lineDelta:0,re=typeof z.characterDelta=="number"?z.characterDelta:0),Se===0&&re===0?this:new o(this.line+Se,this.character+re)}with(z,re=this.character){if(z===null||re===null)throw(0,I.$6)();let Se;return typeof z>"u"?Se=this.line:typeof z=="number"?Se=z:(Se=typeof z.line=="number"?z.line:this.line,re=typeof z.character=="number"?z.character:this.character),Se===this.line&&re===this.character?this:new o(Se,re)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$GN=L,e.$GN=L=o=Ge([f],L);let W=c=class{static isRange(z){return z instanceof c?!0:z?L.isPosition(z.start)&&L.isPosition(z.end):!1}static of(z){if(z instanceof c)return z;if(this.isRange(z))return new c(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,re,Se,Ke){let it,dt;if(typeof z=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Ke=="number"?(it=new L(z,re),dt=new L(Se,Ke)):L.isPosition(z)&&L.isPosition(re)&&(it=L.of(z),dt=L.of(re)),!it||!dt)throw new Error("Invalid arguments");it.isBefore(dt)?(this.c=it,this.e=dt):(this.c=dt,this.e=it)}contains(z){return c.isRange(z)?this.contains(z.start)&&this.contains(z.end):L.isPosition(z)?!(L.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const re=L.Max(z.start,this.c),Se=L.Min(z.end,this.e);if(!re.isAfter(Se))return new c(re,Se)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const re=L.Min(z.start,this.c),Se=L.Max(z.end,this.end);return new c(re,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,re=this.end){if(z===null||re===null)throw(0,I.$6)();let Se;return z?L.isPosition(z)?Se=z:(Se=z.start||this.start,re=z.end||this.end):Se=this.start,Se.isEqual(this.c)&&re.isEqual(this.end)?this:new c(Se,re)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return F(this)}};e.$HN=W,e.$HN=W=c=Ge([f],W);let G=l=class extends W{static isSelection(z){return z instanceof l?!0:z?W.isRange(z)&&L.isPosition(z.anchor)&&L.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,re,Se,Ke){let it,dt;if(typeof z=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Ke=="number"?(it=new L(z,re),dt=new L(Se,Ke)):L.isPosition(z)&&L.isPosition(re)&&(it=L.of(z),dt=L.of(re)),!it||!dt)throw new Error("Invalid arguments");super(it,dt),this.f=it,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return K(this)}};e.$IN=G,e.$IN=G=l=Ge([f],G);function F(j){return j.isEmpty?`[${j.start.line}:${j.start.character})`:`[${j.start.line}:${j.start.character} -> ${j.end.line}:${j.end.character})`}function K(j){let z=F(j);return j.isEmpty||(j.active.isEqual(j.start)?z=`|${z}`:z=`${z}|`),z}const Y=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,I.$6)("connectionToken")};class le{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,re,Se){if(typeof z!="string"||z.length===0)throw(0,I.$6)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,I.$6)("port");typeof Se<"u"&&Y(Se),this.host=z,this.port=Math.round(re),this.connectionToken=Se}}e.$LN=le;class _{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,re){this.makeConnection=z,this.connectionToken=re,typeof re<"u"&&Y(re)}}e.$MN=_;class ge extends Error{static NotAvailable(z,re){return new ge(z,S.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(z){return new ge(z,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,re=S.RemoteAuthorityResolverErrorCode.Unknown,Se){super(z),this._message=z,this._code=re,this._detail=Se,Object.setPrototypeOf(this,ge.prototype)}}e.$NN=ge;var se;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(se||(e.EndOfLine=se={}));var ae;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(ae||(e.EnvironmentVariableMutatorType=ae={}));let $e=i=class{static isTextEdit(z){return z instanceof i?!0:z?W.isRange(z)&&typeof z.newText=="string":!1}static replace(z,re){return new i(z,re)}static insert(z,re){return i.replace(new W(z,z),re)}static delete(z){return i.replace(z,"")}static setEndOfLine(z){const re=new i(new W(new L(0,0),new L(0,0)),"");return re.newEol=z,re}get range(){return this.c}set range(z){if(z&&!W.isRange(z))throw(0,I.$6)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,I.$6)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,I.$6)("newEol");this.f=z}constructor(z,re){this.c=z,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$ON=$e,e.$ON=$e=i=Ge([f],$e);let oe=r=class{static isNotebookCellEdit(z){return z instanceof r?!0:z?yi.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,re){return new r(z,re)}static insertCells(z,re){return new r(new yi(z,z),re)}static deleteCells(z){return new r(z,[])}static updateCellMetadata(z,re){const Se=new r(new yi(z,z),[]);return Se.newCellMetadata=re,Se}static updateNotebookMetadata(z){const re=new r(new yi(0,0),[]);return re.newNotebookMetadata=z,re}constructor(z,re){this.range=z,this.newCells=re}};e.$PN=oe,e.$PN=oe=r=Ge([f],oe);class Ce{static isSnippetTextEdit(z){return z instanceof Ce?!0:z?W.isRange(z.range)&&q.isSnippetString(z.snippet):!1}static replace(z,re){return new Ce(z,re)}static insert(z,re){return Ce.replace(new W(z,z),re)}constructor(z,re){this.range=z,this.snippet=re}}e.$QN=Ce;var Le;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(Le||(e.FileEditType=Le={}));let Z=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,re,Se,Ke){this.c.push({_type:Le.File,from:z,to:re,options:Se,metadata:Ke})}createFile(z,re,Se){this.c.push({_type:Le.File,from:void 0,to:z,options:re,metadata:Se})}deleteFile(z,re,Se){this.c.push({_type:Le.File,from:z,to:void 0,options:re,metadata:Se})}e(z,re,Se){this.c.push({_type:Le.Cell,metadata:Se,uri:z,edit:{editType:d.CellEditType.DocumentMetadata,metadata:re},notebookMetadata:re})}f(z,re,Se,Ke){const it=re.start,dt=re.end;(it!==dt||Se.length>0)&&this.c.push({_type:Le.CellReplace,uri:z,index:it,count:dt-it,cells:Se,metadata:Ke})}g(z,re,Se,Ke){this.c.push({_type:Le.Cell,metadata:Ke,uri:z,edit:{editType:d.CellEditType.Metadata,index:re,metadata:Se}})}replace(z,re,Se,Ke){this.c.push({_type:Le.Text,uri:z,edit:new $e(re,Se),metadata:Ke})}insert(z,re,Se,Ke){this.replace(z,new W(re,re),Se,Ke)}delete(z,re,Se){this.replace(z,re,"",Se)}has(z){return this.c.some(re=>re._type===Le.Text&&re.uri.toString()===z.toString())}set(z,re){if(re)for(const Se of re){if(!Se)continue;let Ke,it;Array.isArray(Se)?(Ke=Se[0],it=Se[1]):Ke=Se,oe.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(z,Ke.range.start,Ke.newCellMetadata,it):Ke.newNotebookMetadata?this.e(z,Ke.newNotebookMetadata,it):this.f(z,Ke.range,Ke.newCells,it):Ce.isSnippetTextEdit(Ke)?this.c.push({_type:Le.Snippet,uri:z,range:Ke.range,edit:Ke.snippet,metadata:it}):this.c.push({_type:Le.Text,uri:z,edit:Ke,metadata:it})}else{for(let Se=0;Se<this.c.length;Se++){const Ke=this.c[Se];switch(Ke._type){case Le.Text:case Le.Snippet:case Le.Cell:case Le.CellReplace:Ke.uri.toString()===z.toString()&&(this.c[Se]=void 0);break}}(0,v.$Hb)(this.c)}}get(z){const re=[];for(const Se of this.c)Se._type===Le.Text&&Se.uri.toString()===z.toString()&&re.push(Se.edit);return re}entries(){const z=new O.$zc;for(const re of this.c)if(re._type===Le.Text){let Se=z.get(re.uri);Se||(Se=[re.uri,[]],z.set(re.uri,Se)),Se[1].push(re.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$RN=Z,e.$RN=Z=Ge([f],Z);let q=t=class{static isSnippetString(z){return z instanceof t?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=t.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,re=this.e++){if(typeof z=="function"){const Se=new t;Se.e=this.e,z(Se),this.e=Se.e,z=Se.value}else z=t.c(z);return this.value+="${",this.value+=re,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,re=this.e++){const Se=z.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(z,re){if(typeof re=="function"){const Se=new t;Se.e=this.e,re(Se),this.e=Se.e,re=Se.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$SN=q,e.$SN=q=t=Ge([f],q);var te;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(te||(e.DiagnosticTag=te={}));var ve;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(ve||(e.DiagnosticSeverity=ve={}));let ce=g=class{static isLocation(z){return z instanceof g?!0:z?W.isRange(z.range)&&s.URI.isUri(z.uri):!1}constructor(z,re){if(this.uri=z,re)if(W.isRange(re))this.range=W.of(re);else if(L.isPosition(re))this.range=new W(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$TN=ce,e.$TN=ce=g=Ge([f],ce);let we=class{static is(z){return z?typeof z.message=="string"&&z.location&&W.isRange(z.location.range)&&s.URI.isUri(z.location.uri):!1}constructor(z,re){this.location=z,this.message=re}static isEqual(z,re){return z===re?!0:!z||!re?!1:z.message===re.message&&z.location.range.isEqual(re.location.range)&&z.location.uri.toString()===re.location.uri.toString()}};e.$UN=we,e.$UN=we=Ge([f],we);let ue=class{constructor(z,re,Se=ve.Error){if(!W.isRange(z))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=z,this.message=re,this.severity=Se}toJSON(){return{severity:ve[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,re){return z===re?!0:!z||!re?!1:z.message===re.message&&z.severity===re.severity&&z.code===re.code&&z.severity===re.severity&&z.source===re.source&&z.range.isEqual(re.range)&&(0,v.$tb)(z.tags,re.tags)&&(0,v.$tb)(z.relatedInformation,re.relatedInformation,we.isEqual)}};e.$VN=ue,e.$VN=ue=Ge([f],ue);let X=class{constructor(z,re){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=re}};e.$WN=X,e.$WN=X=Ge([f],X);let x=class extends X{constructor(z,re,Se,Ke){super(z,re),this.canIncreaseVerbosity=Se,this.canDecreaseVerbosity=Ke}};e.$XN=x,e.$XN=x=Ge([f],x);var me;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(me||(e.HoverVerbosityAction=me={}));var pe;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(pe||(e.DocumentHighlightKind=pe={}));let Re=class{constructor(z,re=pe.Text){this.range=z,this.kind=re}toJSON(){return{range:this.range,kind:pe[this.kind]}}};e.$YN=Re,e.$YN=Re=Ge([f],Re);let ze=class{constructor(z,re){this.uri=z,this.highlights=re}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$ZN=ze,e.$ZN=ze=Ge([f],ze);var ke;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ke||(e.SymbolKind=ke={}));var Pe;(function(j){j[j.Deprecated=1]="Deprecated"})(Pe||(e.SymbolTag=Pe={}));let Te=u=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,re,Se,Ke,it){this.name=z,this.kind=re,this.containerName=it,typeof Se=="string"&&(this.containerName=Se),Ke instanceof ce?this.location=Ke:Se instanceof W&&(this.location=new ce(Ke,Se)),u.validate(this)}toJSON(){return{name:this.name,kind:ke[this.kind],location:this.location,containerName:this.containerName}}};e.$1N=Te,e.$1N=Te=u=Ge([f],Te);let U=m=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(m.validate)}constructor(z,re,Se,Ke,it){this.name=z,this.detail=re,this.kind=Se,this.range=Ke,this.selectionRange=it,this.children=[],m.validate(this)}};e.$2N=U,e.$2N=U=m=Ge([f],U);var B;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let H=class{constructor(z,re){this.title=z,this.kind=re}};e.$3N=H,e.$3N=H=Ge([f],H);let V=class{static{p=this}static{this.c="."}constructor(z){this.value=z}append(z){return new p(this.value?this.value+p.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+p.c)}};e.$4N=V,e.$4N=V=p=Ge([f],V),V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorMove=V.Refactor.append("move"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll"),V.Notebook=V.Empty.append("notebook");let ne=class{constructor(z,re){if(this.range=z,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$5N=ne,e.$5N=ne=Ge([f],ne);class fe{constructor(z,re,Se,Ke,it,dt){this.kind=z,this.name=re,this.detail=Se,this.uri=Ke,this.range=it,this.selectionRange=dt}}e.$6N=fe;class Ie{constructor(z,re){this.fromRanges=re,this.from=z}}e.$7N=Ie;class je{constructor(z,re){this.fromRanges=re,this.to=z}}e.$8N=je;var Qe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Qe||(e.LanguageStatusSeverity=Qe={}));let _e=class{constructor(z,re){this.range=z,this.command=re}get isResolved(){return!!this.command}};e.$9N=_e,e.$9N=_e=Ge([f],_e);let tt=h=class{#e;static isMarkdownString(z){return z instanceof h?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,re=!1){this.#e=new P.$1k(z,{supportThemeIcons:re})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,re){return this.#e.appendCodeblock(re??"",z),this}};e.$0N=tt,e.$0N=tt=h=Ge([f],tt);let nt=class{constructor(z,re){this.label=z,this.documentation=re}};e.$$N=nt,e.$$N=nt=Ge([f],nt);let et=class{constructor(z,re){this.label=z,this.documentation=re,this.parameters=[]}};e.$_N=et,e.$_N=et=Ge([f],et);let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$aO=rt,e.$aO=rt=Ge([f],rt);var mt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(mt||(e.SignatureHelpTriggerKind=mt={}));var lt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(lt||(e.InlayHintKind=lt={}));let st=class{constructor(z){this.value=z}};e.$bO=st,e.$bO=st=Ge([f],st);let ct=class{constructor(z,re,Se){this.position=z,this.label=re,this.kind=Se}};e.$cO=ct,e.$cO=ct=Ge([f],ct);var ft;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ft||(e.CompletionTriggerKind=ft={}));var pt;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(pt||(e.CompletionItemKind=pt={}));var qe;(function(j){j[j.Deprecated=1]="Deprecated"})(qe||(e.CompletionItemTag=qe={}));let Ue=class{constructor(z,re){this.label=z,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&pt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$dO=Ue,e.$dO=Ue=Ge([f],Ue);let ee=class{constructor(z=[],re=!1){this.items=z,this.isIncomplete=re}};e.$eO=ee,e.$eO=ee=Ge([f],ee);let Q=class{constructor(z,re,Se){this.insertText=z,this.range=re,this.command=Se}};e.$fO=Q,e.$fO=Q=Ge([f],Q);let De=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$gO=De,e.$gO=De=Ge([f],De);var Je;(function(j){j[j.Unknown=0]="Unknown",j[j.Word=1]="Word",j[j.Line=2]="Line",j[j.Suggest=3]="Suggest"})(Je||(e.PartialAcceptTriggerKind=Je={}));var xe;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(xe||(e.ViewColumn=xe={}));var ht;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(ht||(e.StatusBarAlignment=ht={}));function $t(j,z){return`${y.$on.toKey(j)}.${z}`}var Nt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(Nt||(e.TextEditorLineNumbersStyle=Nt={}));var Wt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Wt||(e.TextDocumentSaveReason=Wt={}));var ri;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ri||(e.TextEditorRevealType=ri={}));var Xt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Xt||(e.TextEditorSelectionChangeKind=Xt={}));var hi;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(hi||(e.TextDocumentChangeReason=hi={}));var Ye;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ye||(e.DecorationRangeBehavior=Ye={})),function(j){function z(re){switch(re){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=z}(Xt||(e.TextEditorSelectionChangeKind=Xt={}));var Vt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Vt||(e.SyntaxTokenType=Vt={})),function(j){function z(re){switch(re){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=z}(Vt||(e.SyntaxTokenType=Vt={}));let Ht=class{constructor(z,re){if(re&&!s.URI.isUri(re))throw(0,I.$6)("target");if(!W.isRange(z)||z.isEmpty)throw(0,I.$6)("range");this.range=z,this.target=re}};e.$iO=Ht,e.$iO=Ht=Ge([f],Ht);let gt=class{constructor(z,re,Se,Ke){this.red=z,this.green=re,this.blue=Se,this.alpha=Ke}};e.$jO=gt,e.$jO=gt=Ge([f],gt);let St=class{constructor(z,re){if(re&&!(re instanceof gt))throw(0,I.$6)("color");if(!W.isRange(z)||z.isEmpty)throw(0,I.$6)("range");this.range=z,this.color=re}};e.$kO=St,e.$kO=St=Ge([f],St);let Yt=class{constructor(z){if(!z||typeof z!="string")throw(0,I.$6)("label");this.label=z}};e.$lO=Yt,e.$lO=Yt=Ge([f],Yt);var Zt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Zt||(e.ColorFormat=Zt={}));var Ut;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Ut||(e.SourceControlInputBoxValidationType=Ut={}));var wt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(wt||(e.TerminalExitReason=wt={}));var At;(function(j){j[j.Low=0]="Low",j[j.Medium=1]="Medium",j[j.High=2]="High"})(At||(e.TerminalShellExecutionCommandLineConfidence=At={}));class ci{constructor(z,re,Se){if(this.startIndex=z,this.length=re,this.tooltip=Se,typeof z!="number"||z<0)throw(0,I.$6)("startIndex");if(typeof re!="number"||re<1)throw(0,I.$6)("length");if(Se!==void 0&&typeof Se!="string")throw(0,I.$6)("tooltip")}}e.$mO=ci;class Qt{constructor(z){this.uri=z}}e.$nO=Qt;class Xe{constructor(z){this.terminalCommand=z}}e.$oO=Xe;var xt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(xt||(e.TerminalLocation=xt={}));class li{constructor(z){if(this.options=z,typeof z!="object")throw(0,I.$6)("options")}}e.$pO=li;var di;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(di||(e.TaskRevealKind=di={}));var kt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(kt||(e.TaskPanelKind=kt={}));let Ft=class{static{E=this}static{this.Clean=new E("clean","Clean")}static{this.Build=new E("build","Build")}static{this.Rebuild=new E("rebuild","Rebuild")}static{this.Test=new E("test","Test")}static from(z){switch(z){case"clean":return E.Clean;case"build":return E.Build;case"rebuild":return E.Rebuild;case"test":return E.Test;default:return}}constructor(z,re){if(this.label=re,typeof z!="string"||typeof re!="string")throw(0,I.$6)("name");this.c=z}get id(){return this.c}};e.$qO=Ft,e.$qO=Ft=E=Ge([f],Ft);function Rt(j){let z="";for(let re=0;re<j.length;re++)z+=j[re].replace(/,/g,",,")+",";return z}let Mt=class{constructor(z,re,Se){if(typeof z!="string")throw(0,I.$6)("process");this.e=[],this.c=z,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=Se):this.f=re)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,I.$6)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const re of this.e)z.push(re);return Rt(z)}};e.$rO=Mt,e.$rO=Mt=Ge([f],Mt);let si=class{constructor(z,re,Se){if(this.f=[],Array.isArray(re)){if(!z)throw(0,I.$6)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,I.$6)("command");this.e=z,this.f=re,this.g=Se}else{if(typeof z!="string")throw(0,I.$6)("commandLine");this.c=z,this.g=re}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,I.$6)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,I.$6)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)z.push(typeof re=="string"?re:re.value);return Rt(z)}};e.$sO=si,e.$sO=si=Ge([f],si);var _t;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(_t||(e.ShellQuoting=_t={}));var ei;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(ei||(e.TaskScope=ei={}));class Bt{constructor(z){this.c=z}computeId(){return"customExecution"+(0,A.$Yg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$tO=Bt;let qt=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,re,Se,Ke,it,dt){this.k=!1,this.l=this.definition=z;let vt;typeof re=="string"?(this.o=this.name=re,this.w=this.source=Se,this.execution=Ke,vt=it,this.k=!0):re===ei.Global||re===ei.Workspace?(this.target=re,this.o=this.name=Se,this.w=this.source=Ke,this.execution=it,vt=dt):(this.target=re,this.o=this.name=Se,this.w=this.source=Ke,this.execution=it,vt=dt),typeof vt=="string"?(this.r=[vt],this.t=!0):Array.isArray(vt)?(this.r=vt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Mt?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof si?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof Bt?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,A.$Yg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,I.$6)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,I.$6)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const re=this.l.type;(D.g===re||D.e===re||D.f===re||D.c===re)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,I.$6)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$uO=qt,e.$uO=qt=D=Ge([f],qt);var ui;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(ui||(e.ProgressLocation=ui={}));var Tt;(function(j){function z(re){const Se=re;return(0,$.$gg)(Se.value)?Se.tooltip&&!(0,$.$cg)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}j.isViewBadge=z})(Tt||(e.ViewBadge=Tt={}));let Ct=b=class{static isTreeItem(z,re){const Se=z;if(Se.checkboxState!==void 0){const Ke=(0,$.$gg)(Se.checkboxState)?Se.checkboxState:(0,$.$eg)(Se.checkboxState)&&(0,$.$gg)(Se.checkboxState.state)?Se.checkboxState.state:void 0,it=!(0,$.$gg)(Se.checkboxState)&&(0,$.$eg)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Kt.Checked&&Ke!==Kt.Unchecked||it!==void 0&&!(0,$.$cg)(it))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(z instanceof b)return!0;if(Se.label!==void 0&&!(0,$.$cg)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,$.$cg)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,$.$cg)(Se.iconPath)&&!s.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,$.$cg)(Se.iconPath.id))){const Ke=Se.iconPath;if(!Ke||!(0,$.$cg)(Ke.light)&&!s.URI.isUri(Ke.light)&&!(0,$.$cg)(Ke.dark)&&!s.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,$.$cg)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!s.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,$.$cg)(Se.tooltip)&&!(Se.tooltip instanceof tt)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<bt.None&&Se.collapsibleState>bt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,$.$cg)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(z,re=bt.None){this.collapsibleState=re,s.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$vO=Ct,e.$vO=Ct=b=Ge([f],Ct);var bt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(bt||(e.TreeItemCollapsibleState=bt={}));var Kt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Kt||(e.TreeItemCheckboxState=Kt={}));let yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$wO=yt,e.$wO=yt=Ge([f],yt);class oi extends yt{}e.$xO=oi;class Gt extends oi{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$yO=Gt;class Ai{constructor(z,re,Se,Ke){this.name=z,this.uri=re,this._itemId=Se,this.c=Ke}data(){return this.c()}}e.$zO=Ai;let $i=class{#e=new Map;constructor(z){for(const[re,Se]of z??[]){const Ke=this.#e.get(this.#t(re));Ke?Ke.push(Se):this.#e.set(this.#t(re),[Se])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,re){this.#e.set(this.#t(z),[re])}forEach(z,re){for(const[Se,Ke]of this.#e)for(const it of Ke)z.call(re,it,Se,this)}*[Symbol.iterator](){for(const[z,re]of this.#e)for(const Se of re)yield[z,Se]}#t(z){return z.toLowerCase()}};e.$AO=$i,e.$AO=$i=Ge([f],$i);let Di=class{constructor(z,re,Se){this.insertText=z,this.title=re,this.kind=Se}};e.$BO=Di,e.$BO=Di=Ge([f],Di);var zt;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(zt||(e.DocumentPasteTriggerKind=zt={}));class fi{static{this.c="."}constructor(z){this.value=z}append(...z){return new fi((this.value?[this.value,...z]:z).join(fi.c))}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+fi.c)}}e.$CO=fi,fi.Empty=new fi("");class Ni{constructor(z,re,Se){this.title=re,this.insertText=z,this.kind=Se}}e.$DO=Ni;let It=class{constructor(z,re){this.id=z,this.color=re}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$EO=It,e.$EO=It=Ge([f],It),It.File=new It("file"),It.Folder=new It("folder");let Si=class{constructor(z){this.id=z}};e.$FO=Si,e.$FO=Si=Ge([f],Si);var Ri;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Ri||(e.ConfigurationTarget=Ri={}));let bi=class{get base(){return this.c}set base(z){this.c=z,this.e=s.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,re){if(typeof z!="string"&&(!z||!s.URI.isUri(z)&&!s.URI.isUri(z.uri)))throw(0,I.$6)("base");if(typeof re!="string")throw(0,I.$6)("pattern");typeof z=="string"?this.baseUri=s.URI.file(z):s.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$GO=bi,e.$GO=bi=Ge([f],bi);const Ti=new WeakMap;function Li(j,z){Ti.set(j,z)}let Lt=class{constructor(z,re,Se,Ke,it){this.enabled=typeof z=="boolean"?z:!0,typeof re=="string"&&(this.condition=re),typeof Se=="string"&&(this.hitCondition=Se),typeof Ke=="string"&&(this.logMessage=Ke),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=Ti.get(this)??(0,A.$Yg)()),this.c}};e.$IO=Lt,e.$IO=Lt=Ge([f],Lt);let Ee=class extends Lt{constructor(z,re,Se,Ke,it,dt){if(super(re,Se,Ke,it,dt),z===null)throw(0,I.$6)("location");this.location=z}};e.$JO=Ee,e.$JO=Ee=Ge([f],Ee);let Ae=class extends Lt{constructor(z,re,Se,Ke,it,dt){super(re,Se,Ke,it,dt),this.functionName=z}};e.$KO=Ae,e.$KO=Ae=Ge([f],Ae);let he=class extends Lt{constructor(z,re,Se,Ke,it,dt,vt,Jt){if(super(Ke,it,dt,vt,Jt),!re)throw(0,I.$6)("dataId");this.label=z,this.dataId=re,this.canPersist=Se}};e.$LO=he,e.$LO=he=Ge([f],he);let J=class{constructor(z,re,Se){this.command=z,this.args=re||[],this.options=Se}};e.$MO=J,e.$MO=J=Ge([f],J);let ye=class{constructor(z,re){this.port=z,this.host=re}};e.$NO=ye,e.$NO=ye=Ge([f],ye);let Be=class{constructor(z){this.path=z}};e.$OO=Be,e.$OO=Be=Ge([f],Be);let Ze=class{constructor(z){this.implementation=z}};e.$PO=Ze,e.$PO=Ze=Ge([f],Ze);class He{constructor(z,re,Se){this.session=z,this.threadId=re,this.frameId=Se}}e.$QO=He;class ut{constructor(z,re){this.session=z,this.threadId=re}}e.$RO=ut;let Pt=class{constructor(z,re){this.range=z,this.expression=re}};e.$SO=Pt,e.$SO=Pt=Ge([f],Pt);var ti;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(ti||(e.InlineCompletionTriggerKind=ti={}));let ai=class{constructor(z,re){this.range=z,this.text=re}};e.$TO=ai,e.$TO=ai=Ge([f],ai);let jt=class{constructor(z,re,Se=!0){this.range=z,this.variableName=re,this.caseSensitiveLookup=Se}};e.$UO=jt,e.$UO=jt=Ge([f],jt);let ii=class{constructor(z,re){this.range=z,this.expression=re}};e.$VO=ii,e.$VO=ii=Ge([f],ii);let Fi=class{constructor(z,re){this.frameId=z,this.stoppedLocation=re}};e.$WO=Fi,e.$WO=Fi=Ge([f],Fi);var _i;(function(j){j[j.AIGenerated=1]="AIGenerated"})(_i||(e.NewSymbolNameTag=_i={}));var Mi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Mi||(e.NewSymbolNameTriggerKind=Mi={}));class qi{constructor(z,re){this.newSymbolName=z,this.tags=re}}e.$XO=qi;var en;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(en||(e.FileChangeType=en={}));let Wi=k=class extends Error{static FileExists(z){return new k(z,a.FileSystemProviderErrorCode.FileExists,k.FileExists)}static FileNotFound(z){return new k(z,a.FileSystemProviderErrorCode.FileNotFound,k.FileNotFound)}static FileNotADirectory(z){return new k(z,a.FileSystemProviderErrorCode.FileNotADirectory,k.FileNotADirectory)}static FileIsADirectory(z){return new k(z,a.FileSystemProviderErrorCode.FileIsADirectory,k.FileIsADirectory)}static NoPermissions(z){return new k(z,a.FileSystemProviderErrorCode.NoPermissions,k.NoPermissions)}static Unavailable(z){return new k(z,a.FileSystemProviderErrorCode.Unavailable,k.Unavailable)}constructor(z,re=a.FileSystemProviderErrorCode.Unknown,Se){super(s.URI.isUri(z)?z.toString(!0):z),this.code=Se?.name??"Unknown",(0,a.$ml)(this,re),Object.setPrototypeOf(this,k.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$YO=Wi,e.$YO=Wi=k=Ge([f],Wi);let vi=class{constructor(z,re,Se){this.start=z,this.end=re,this.kind=Se}};e.$ZO=vi,e.$ZO=vi=Ge([f],vi);var tn;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(tn||(e.FoldingRangeKind=tn={}));var nn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(nn||(e.CommentThreadCollapsibleState=nn={}));var zi;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(zi||(e.CommentMode=zi={}));var rn;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(rn||(e.CommentState=rn={}));var ji;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(ji||(e.CommentThreadState=ji={}));var Vi;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})(Vi||(e.CommentThreadApplicability=Vi={}));var sn;(function(j){j[j.Reply=1]="Reply",j[j.Comment=2]="Comment"})(sn||(e.CommentThreadFocus=sn={}));class on{constructor(z,re=[]){this.tokenTypes=z,this.tokenModifiers=re}}e.$1O=on;function bn(j){return typeof j>"u"||(0,$.$dg)(j)}class ki{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let re=0,Se=z.tokenTypes.length;re<Se;re++)this.k.set(z.tokenTypes[re],re);for(let re=0,Se=z.tokenModifiers.length;re<Se;re++)this.l.set(z.tokenModifiers[re],re)}}push(z,re,Se,Ke,it){if(typeof z=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Ke=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(z,re,Se,Ke,it);if(W.isRange(z)&&typeof re=="string"&&bn(Se))return this.o(z,re,Se);throw(0,I.$6)()}o(z,re,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(re))throw new Error("`tokenType` is not in the provided legend");const Ke=z.start.line,it=z.start.character,dt=z.end.character-z.start.character,vt=this.k.get(re);let Jt=0;if(Se)for(const pi of Se){if(!this.l.has(pi))throw new Error("`tokenModifier` is not in the provided legend");const wi=this.l.get(pi);Jt|=1<<wi>>>0}this.q(Ke,it,dt,vt,Jt)}q(z,re,Se,Ke,it){if(this.f&&(z<this.c||z===this.c&&re<this.e)){this.f=!1;const Jt=this.g.length/5|0;let pi=0,wi=0;for(let Ei=0;Ei<Jt;Ei++){let Pi=this.g[5*Ei],Zi=this.g[5*Ei+1];Pi===0?(Pi=pi,Zi+=wi):Pi+=pi,this.g[5*Ei]=Pi,this.g[5*Ei+1]=Zi,pi=Pi,wi=Zi}}let dt=z,vt=re;this.f&&this.j>0&&(dt-=this.c,dt===0&&(vt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=vt,this.g[this.j++]=Se,this.g[this.j++]=Ke,this.g[this.j++]=it,this.c=z,this.e=re}static r(z){const re=[],Se=z.length/5|0;for(let vt=0;vt<Se;vt++)re[vt]=vt;re.sort((vt,Jt)=>{const pi=z[5*vt],wi=z[5*Jt];if(pi===wi){const Ei=z[5*vt+1],Pi=z[5*Jt+1];return Ei-Pi}return pi-wi});const Ke=new Uint32Array(z.length);let it=0,dt=0;for(let vt=0;vt<Se;vt++){const Jt=5*re[vt],pi=z[Jt+0],wi=z[Jt+1],Ei=z[Jt+2],Pi=z[Jt+3],Zi=z[Jt+4],Vn=pi-it,Or=Vn===0?wi-dt:wi,xi=5*vt;Ke[xi+0]=Vn,Ke[xi+1]=Or,Ke[xi+2]=Ei,Ke[xi+3]=Pi,Ke[xi+4]=Zi,it=pi,dt=wi}return Ke}build(z){return this.f?new Hi(new Uint32Array(this.g),z):new Hi(ki.r(this.g),z)}}e.$2O=ki;class Hi{constructor(z,re){this.resultId=re,this.data=z}}e.$3O=Hi;class wn{constructor(z,re,Se){this.start=z,this.deleteCount=re,this.data=Se}}e.$4O=wn;class vn{constructor(z,re){this.resultId=re,this.edits=z}}e.$5O=vn;var Ui;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Ui||(e.DebugConsoleMode=Ui={}));class an{constructor(z){this.name=z}}e.$6O=an;var Me;(function(j){j[j.Title=1]="Title",j[j.Inline=2]="Inline"})(Me||(e.QuickInputButtonLocation=Me={}));let gi=class{static{this.Back={iconPath:new It("arrow-left")}}constructor(){}};e.$7O=gi,e.$7O=gi=Ge([f],gi);var Qi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var ot;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(ot||(e.InputBoxValidationSeverity=ot={}));var Et;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Et||(e.ExtensionKind=Et={}));class yn{static validate(z){if(typeof z.badge=="string"){let re=(0,T.$Nf)(z.badge,0);if(re<z.badge.length&&(re+=(0,T.$Nf)(z.badge,re)),z.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!It.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,re,Se){this.badge=z,this.tooltip=re,this.color=Se}}e.$8O=yn;let Ki=class{constructor(z){this.kind=z}};e.$9O=Ki,e.$9O=Ki=Ge([f],Ki);var Gi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Gi||(e.ColorThemeKind=Gi={}));class yi{static isNotebookRange(z){return z instanceof yi?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,re){if(z<0)throw(0,I.$6)("start must be positive");if(re<0)throw(0,I.$6)("end must be positive");z<=re?(this.c=z,this.e=re):(this.c=re,this.e=z)}with(z){let re=this.c,Se=this.e;return z.start!==void 0&&(re=z.start),z.end!==void 0&&(Se=z.end),re===this.c&&Se===this.e?this:new yi(re,Se)}}e.$0O=yi;class Ci{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(re=>Ci.isNotebookCellData(re))}static isNotebookCellData(z){return!0}constructor(z,re,Se,Ke,it,dt,vt){this.kind=z,this.value=re,this.languageId=Se,this.mime=Ke,this.outputs=it??[],this.metadata=dt,this.executionSummary=vt,Ci.validate(this)}}e.$$O=Ci;class En{constructor(z){this.cells=z}}e.$_O=En;class mi{static isNotebookCellOutputItem(z){return z instanceof mi?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const re={name:z.name,message:z.message,stack:z.stack};return mi.json(re,"application/vnd.code.notebook.error")}static stdout(z){return mi.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return mi.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,re="application/octet-stream"){return new mi(z,re)}static#e=new TextEncoder;static text(z,re=R.$8s.text){const Se=mi.#e.encode(String(z));return new mi(Se,re)}static json(z,re="text/x-json"){const Se=JSON.stringify(z,void 0,"	");return mi.text(Se,re)}constructor(z,re){this.data=z,this.mime=re;const Se=(0,R.$_s)(re,!0);if(!Se)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$aP=mi;class Bi{static isNotebookCellOutput(z){return z instanceof Bi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,re=!1){const Se=new Set,Ke=new Set;for(let it=0;it<z.length;it++){const dt=z[it],vt=(0,R.$_s)(dt.mime);if(!Se.has(vt)||(0,d.$IL)(vt)){Se.add(vt);continue}Ke.add(it),re&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ke.size===0?z:z.filter((it,dt)=>!Ke.has(dt))}constructor(z,re,Se){this.items=Bi.ensureUniqueMimeTypes(z,!0),typeof re=="string"?(this.id=re,this.metadata=Se):(this.id=(0,A.$Yg)(),this.metadata=re??Se)}}e.$bP=Bi;var Ji;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Ji||(e.NotebookCellKind=Ji={}));var cn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(cn||(e.NotebookCellExecutionState=cn={}));var ln;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(ln||(e.NotebookCellStatusBarAlignment=ln={}));var un;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(un||(e.NotebookEditorRevealType=un={}));class Dn{constructor(z,re){this.text=z,this.alignment=re}}e.$cP=Dn;var hn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(hn||(e.NotebookControllerAffinity=hn={}));var dn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(dn||(e.NotebookControllerAffinity2=dn={}));class Sn{constructor(z,re=[]){this.uri=z,this.provides=(0,v.$1b)(re)}}e.$dP=Sn;class kn{constructor(z){this.label=z}}e.$eP=kn;var fn;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(fn||(e.NotebookVariablesRequestKind=fn={}));let Xi=class{constructor(z,re){this.label=z,this.timestamp=re}};e.$fP=Xi,e.$fP=Xi=Ge([f],Xi);var gn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(gn||(e.ExtensionMode=gn={}));var ie;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(ie||(e.ExtensionRuntime=ie={}));var de;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(de||(e.StandardTokenType=de={}));class Fe{constructor(z,re){this.ranges=z,this.wordPattern=re}}e.$gP=Fe;class at{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$hP=at;var Dt;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Dt||(e.TestResultState=Dt={}));var Ot;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(Ot||(e.TestRunProfileKind=Ot={}));let Ii=class{constructor(z=void 0,re=void 0,Se=void 0,Ke=!1,it=!0){this.include=z,this.exclude=re,this.profile=Se,this.continuous=Ke,this.preserveFocus=it}};e.$iP=Ii,e.$iP=Ii=Ge([f],Ii);let Yi=C=class{static diff(z,re,Se){const Ke=new C(z);return Ke.expectedOutput=re,Ke.actualOutput=Se,Ke}constructor(z){this.message=z}};e.$jP=Yi,e.$jP=Yi=C=Ge([f],Yi);let Cn=class{constructor(z){this.id=z}};e.$kP=Cn,e.$kP=Cn=Ge([f],Cn);class Kn{constructor(z,re,Se){this.label=z,this.file=re,this.position=Se}}e.$lP=Kn;class mn{constructor(z,re){this.covered=z,this.total=re,Pn(this)}}e.$mP=mn;function Pn(j){if(j){if(j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`);if(j.total<0)throw new Error(`The number of covered items (${j.total}) cannot be negative`)}}class In{static fromDetails(z,re){const Se=new mn(0,0),Ke=new mn(0,0),it=new mn(0,0);for(const vt of re)if("branches"in vt){Se.total+=1,Se.covered+=vt.executed?1:0;for(const Jt of vt.branches)Ke.total+=1,Ke.covered+=Jt.executed?1:0}else it.total+=1,it.covered+=vt.executed?1:0;const dt=new In(z,Se,Ke.total>0?Ke:void 0,it.total>0?it:void 0);return dt.detailedCoverage=re,dt}constructor(z,re,Se,Ke,it=[]){this.uri=z,this.statementCoverage=re,this.branchCoverage=Se,this.declarationCoverage=Ke,this.fromTests=it}}e.$oP=In;class Gn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,Se=[]){this.executed=z,this.location=re,this.branches=Se}}e.$pP=Gn;class Jn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,Se){this.executed=z,this.location=re,this.label=Se}}e.$qP=Jn;class Xn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,Se){this.name=z,this.executed=re,this.location=Se}}e.$rP=Xn;var An;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(An||(e.ExternalUriOpenerPriority=An={}));var Rn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Rn||(e.WorkspaceTrustState=Rn={}));var Tn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Tn||(e.PortAutoForwardAction=Tn={}));class Yn{constructor(z,re,Se,Ke,it,dt){this.kind=z,this.name=re,this.detail=Se,this.uri=Ke,this.range=it,this.selectionRange=dt}}e.$sP=Yn;class Zn{constructor(z){this.uri=z}}e.$tP=Zn;class xn{constructor(z,re){this.original=z,this.modified=re}}e.$uP=xn;class _n{constructor(z,re,Se,Ke){this.base=z,this.input1=re,this.input2=Se,this.result=Ke}}e.$vP=_n;class er{constructor(z,re){this.uri=z,this.viewType=re}}e.$wP=er;class tr{constructor(z){this.viewType=z}}e.$xP=tr;class ir{constructor(z,re){this.uri=z,this.notebookType=re}}e.$yP=ir;class nr{constructor(z,re,Se){this.original=z,this.modified=re,this.notebookType=Se}}e.$zP=nr;class rr{constructor(){}}e.$AP=rr;class sr{constructor(z,re){this.uri=z,this.inputBoxUri=re}}e.$BP=sr;class or{constructor(){}}e.$CP=or;class ar{constructor(z){this.textDiffs=z}}e.$DP=ar;var On;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(On||(e.InteractiveSessionVoteDirection=On={}));var Nn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(Nn||(e.ChatCopyKind=Nn={}));var Ln;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(Ln||(e.ChatVariableLevel=Ln={}));class cr{constructor(z,re,Se){this.id=z,this.label=re,this.values=Se}}e.$EP=cr;var Fn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(Fn||(e.InteractiveEditorResponseFeedbackKind=Fn={}));var Mn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(Mn||(e.ChatResultFeedbackKind=Mn={}));class lr{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new tt(z):z}}e.$FP=lr;class ur{constructor(z,re){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new tt(z):z,this.vulnerabilities=re}}e.$GP=ur;class hr{constructor(z,re){this.participant=z,this.command=re}}e.$HP=hr;class dr{constructor(z,re,Se,Ke){this.title=z,this.message=re,this.data=Se,this.buttons=Ke}}e.$IP=dr;class fr{constructor(z,re){this.value=z,this.baseUri=re}}e.$JP=fr;class gr{constructor(z,re){this.value=z,this.title=re}}e.$KP=gr;class mr{constructor(z){this.value=z}}e.$LP=mr;class pr{constructor(z,re){this.value=z,this.task=re}}e.$MP=pr;class $r{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new tt(z):z}}e.$NP=$r;class br{constructor(z){this.value=z}}e.$OP=br;class wr{constructor(z,re){this.value=z,this.iconPath=re}}e.$PP=wr;class vr{constructor(z,re){this.uri=z,this.edits=Array.isArray(re)?re:[re]}}e.$QP=vr;class yr{constructor(z,re,Se,Ke){this.prompt=z,this.command=re,this.references=Se,this.participant=Ke}}e.$RP=yr;class Er{constructor(z,re,Se,Ke){this.response=z,this.result=re,this.participant=Se,this.command=Ke}}e.$SP=Er;var zn;(function(j){j[j.Panel=1]="Panel",j[j.Terminal=2]="Terminal",j[j.Notebook=3]="Notebook",j[j.Editor=4]="Editor"})(zn||(e.ChatLocation=zn={}));class Dr{constructor(z,re,Se){this.document=z,this.selection=re,this.wholeRange=Se}}e.$TP=Dr;class Sr{constructor(z){this.cell=z}}e.$UP=Sr;var pn;(function(j){j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.System=3]="System"})(pn||(e.LanguageModelChatMessageRole=pn={}));class kr{constructor(z,re,Se){this.name=z,this.content=re,this.isError=Se??!1}}e.$VP=kr;class $n{static User(z,re){const Se=new $n(pn.User,typeof z=="string"?z:"",re);return Se.content2=z,Se}static Assistant(z,re){return new $n(pn.Assistant,z,re)}constructor(z,re,Se){this.role=z,this.content=re,this.content2=re,this.name=Se}}e.$WP=$n;class Cr{constructor(z,re){this.name=z,this.parameters=re}}e.$XP=Cr;class Ir{constructor(z){this.value=z}}e.$YP=Ir;class Pr{constructor(z){this.content=z}}e.$ZP=Pr;class Ar{constructor(z,re){this.content=z,this.name=re}}e.$1P=Ar;class Rr{constructor(z,re){this.content=z,this.name=re}}e.$2P=Rr;class Oi extends Error{static NotFound(z){return new Oi(z,Oi.NotFound.name)}static NoPermissions(z){return new Oi(z,Oi.NoPermissions.name)}static Blocked(z){return new Oi(z,Oi.Blocked.name)}constructor(z,re,Se){super(z,{cause:Se}),this.name="LanguageModelError",this.code=re??""}}e.$3P=Oi;var jn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(jn||(e.RelatedInformationType=jn={}));var Un;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped",j[j.Error=5]="Error"})(Un||(e.SpeechToTextStatus=Un={}));var Bn;(function(j){j[j.Started=1]="Started",j[j.Stopped=2]="Stopped",j[j.Error=3]="Error"})(Bn||(e.TextToSpeechStatus=Bn={}));var qn;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(qn||(e.KeywordRecognitionStatus=qn={}));class Tr{constructor(z,re){this.text=z,this.range=re}}e.$4P=Tr;var Wn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Wn||(e.InlineEditTriggerKind=Wn={}))}),define(Oe[227],Ne([1,0,5,7]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Woc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(v.$DN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,T,$){if(this.a.size===0)throw new Error("No related information providers registered");const s=this.a.get(R);if(!s)throw new Error("related information provider not found");return await s.provideRelatedInformation(T,$)??[]}getRelatedInformation(R,T,$){return this.c.$getAiRelatedInformation(T,$)}registerRelatedInformationProvider(R,T,$){const s=this.b;return this.b++,this.a.set(s,$),this.c.$registerAiRelatedInformationProvider(s,T),new I.$FN(()=>{this.c.$unregisterAiRelatedInformationProvider(s),this.a.delete(s)})}}e.$Woc=P}),define(Oe[90],Ne([1,0,6,5,7,18,117,3,16]),function(be,e,v,I,P,O,R,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9oc=e.$8oc=void 0,e.$8oc=(0,T.$Ci)("IExtHostAuthentication");let s=class{constructor(a){this.b=new Map,this.c=new v.$je,this.onDidChangeSessions=this.c.event,this.d=new A,this.a=a.getProxy(I.$DN.MainThreadAuthentication)}async getSession(a,S,d,n={}){const o=O.$on.toKey(a.identifier),c=[...d].sort().join(" ");return await this.d.getOrCreate(`${o} ${S} ${c}`,async()=>{await this.a.$ensureProvider(S);const l=a.displayName||a.name;return this.a.$getSession(S,d,o,l,n)})}async getAccounts(a){return await this.a.$ensureProvider(a),await this.a.$getAccounts(a)}async removeSession(a,S){const d=this.b.get(a);return d?d.provider.removeSession(S):this.a.$removeSession(a,S)}registerAuthenticationProvider(a,S,d,n){if(this.b.get(a))throw new Error(`An authentication provider with id '${a}' is already registered.`);this.b.set(a,{label:S,provider:d,options:n??{supportsMultipleAccounts:!1}});const o=d.onDidChangeSessions(c=>this.a.$sendDidChangeSessions(a,c));return this.a.$registerAuthenticationProvider(a,S,n?.supportsMultipleAccounts??!1),new P.$FN(()=>{o.dispose(),this.b.delete(a),this.a.$unregisterAuthenticationProvider(a)})}async $createSession(a,S,d){const n=this.b.get(a);if(n)return await n.provider.createSession(S,d);throw new Error(`Unable to find authentication provider with handle: ${a}`)}async $removeSession(a,S){const d=this.b.get(a);if(d)return await d.provider.removeSession(S);throw new Error(`Unable to find authentication provider with handle: ${a}`)}async $getSessions(a,S,d){const n=this.b.get(a);if(n)return await n.provider.getSessions(S,d);throw new Error(`Unable to find authentication provider with handle: ${a}`)}$onDidChangeAuthenticationSessions(a,S){return a.startsWith(R.$FM)||this.c.fire({provider:{id:a,label:S}}),Promise.resolve()}};e.$9oc=s,e.$9oc=s=Ge([Ve(0,$.$cQ)],s);class A{constructor(){this.a=new Map}getOrCreate(a,S){const d=this.a.get(a);if(d)return d;const n=S().finally(()=>this.a.delete(a));return this.a.set(a,n),n}}}),define(Oe[122],Ne([1,0,2,5,7,3,16,11,17,12,19,24]),function(be,e,v,I,P,O,R,T,$,s,A,y){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$bqc=e.$aqc=void 0;let S=class{static{a=this}static{this.c=0}static{this.d=250}constructor(n,o){this.h=o,this.f=new Map,this.g=n.getProxy(I.$DN.MainThreadDecorations)}registerFileDecorationProvider(n,o){const c=a.c++;this.f.set(c,{provider:n,extensionDescription:o}),this.g.$registerDecorationProvider(c,o.identifier.value);const l=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(c,null);return}const r=(0,$.$1b)(i);if(r.length<=a.d){this.g.$onDidChange(c,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,r.length);const t=r.map(m=>({uri:m,rank:(0,s.$gf)(m.path,"/")})),g=(0,$.$yb)(t,(m,p)=>m.rank-p.rank||(0,s.$wf)(m.uri.path,p.uri.path)),u=[];e:for(const m of g){let p;for(const h of m){const E=(0,A.$lc)(h.uri.path);if(p!==E&&(p=E,u.push(h.uri)>=a.d))break e}}this.g.$onDidChange(c,u)});return new P.$FN(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(n,o,c){if(!this.f.has(n))return Object.create(null);const l=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(n);return await Promise.all(o.map(async t=>{try{const{uri:g,id:u}=t,m=await Promise.resolve(i.provideFileDecoration(v.URI.revive(g),c));if(!m)return;try{P.$8O.validate(m),m.badge&&typeof m.badge!="string"&&(0,y.$dH)(r,"codiconDecoration"),l[u]=[m.propagate,m.tooltip,m.badge,m.color]}catch(p){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${p}`)}}catch(g){this.h.error(g)}})),l}};e.$aqc=S,e.$aqc=S=a=Ge([Ve(0,R.$cQ),Ve(1,T.$0j)],S),e.$bqc=(0,O.$Ci)("IExtHostDecorations")}),define(Oe[228],Ne([1,0,13,2,7,5,15,21,12]),function(be,e,v,I,P,O,R,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dqc=void 0;class s{static{this.a=0}constructor(y,a,S){this.d=a,this.e=S,this.b=new Map,this.c=y.getProxy(O.$DN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,a){if(Object.keys(R.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const S=s.a++;this.b.set(S,a),this.c.$registerTextContentProvider(S,y);let d;if(typeof a.onDidChange=="function"){let n;d=a.onDidChange(async o=>{if(o.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;n&&await n;const c=this.$provideTextDocumentContent(S,o).then(async l=>{if(!l&&typeof l!="string")return;const i=this.d.getDocument(o);if(!i)return;const r=(0,$.$qf)(l);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(o,l)}).catch(v.$Y).finally(()=>{n===c&&(n=void 0)});n=c})}return new P.$FN(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(y,a){const S=this.b.get(y);return S?Promise.resolve(S.provideTextDocumentContent(I.URI.revive(a),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.$dqc=s}),define(Oe[123],Ne([1,0,61,15,12,284,169,7,17]),function(be,e,v,I,P,O,R,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gQ=e.$fQ=void 0,e.$eQ=A;const s=new Map;function A(d,n){n?s.set(d,n):s.delete(d)}function y(d){return s.get(d)}class a extends O.$mw{constructor(n,o,c,l,i,r,t){super(o,c,l,i),this.c=n,this.m=r,this.q=t,this.b=!1}dispose(){(0,v.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,$.$tb)(this.f,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.d},get fileName(){return n.d.fsPath},get isUntitled(){return n.d.scheme===I.Schemas.untitled},get languageId(){return n.m},get version(){return n.h},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(o){return o?n.s(o):n.getText()},get eol(){return n.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return n.f.length},lineAt(o){return n.t(o)},offsetAt(o){return n.u(o)},positionAt(o){return n.v(o)},validateRange(o){return n.w(o)},validatePosition(o){return n.x(o)},getWordRangeAtPosition(o,c){return n.y(o,c)},[Symbol.for("debug.description")](){return`TextDocument(${n.d.toString()})`}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,v.ok)(!this.b),this.m=n}_acceptIsDirty(n){(0,v.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(n){const o=this.w(n);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const c=this.g,l=o.start.line,i=o.end.line,r=[];r.push(this.f[l].substring(o.start.character));for(let t=l+1;t<i;t++)r.push(this.f[t]);return r.push(this.f[i].substring(0,o.end.character)),r.join(c)}t(n){let o;if(n instanceof T.$GN?o=n.line:typeof n=="number"&&(o=n),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new S(o,this.f[o],o===this.f.length-1)}u(n){return n=this.x(n),this.l(),this.j.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.l();const o=this.j.getIndexOf(n),c=this.f[o.index].length;return new T.$GN(o.index,Math.min(o.remainder,c))}w(n){if(!(n instanceof T.$HN))throw new Error("Invalid argument");const o=this.x(n.start),c=this.x(n.end);return o===n.start&&c===n.end?n:new T.$HN(o.line,o.character,c.line,c.character)}x(n){if(!(n instanceof T.$GN))throw new Error("Invalid argument");if(this.f.length===0)return n.with(0,0);let{line:o,character:c}=n,l=!1;if(o<0)o=0,c=0,l=!0;else if(o>=this.f.length)o=this.f.length-1,c=this.f[o].length,l=!0;else{const i=this.f[o].length;c<0?(c=0,l=!0):c>i&&(c=i,l=!0)}return l?new T.$GN(o,c):n}y(n,o){const c=this.x(n);if(!o)o=y(this.m);else if((0,P.$pf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const l=(0,R.$nt)(c.character+1,(0,R.$lt)(o),this.f[c.line],0);if(l)return new T.$HN(c.line,l.startColumn-1,c.line,l.endColumn-1)}}e.$fQ=a;class S{constructor(n,o,c){this.a=n,this.b=o,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$HN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$HN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$gQ=S}),define(Oe[229],Ne([1,0,5,7]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gqc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(v.$DN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,T,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const s=this.a.get(R);if(!s)throw new Error("Embedding vector provider not found");const A=await s.provideEmbeddingVector(T,$);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,T,$){const s=this.b;return this.b++,this.a.set(s,$),this.c.$registerAiEmbeddingVectorProvider(T,s),new I.$FN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(s),this.a.delete(s)})}}e.$gqc=P}),define(Oe[68],Ne([1,0,5,29,7,22,3,16,50,4,10,23,15]),function(be,e,v,I,P,O,R,T,$,s,A,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$mpc=e.$lpc=void 0,I=We(I);let d=S=class{constructor(o,c){this.b=new Map,this.c=new A.$Lh,this.a=o.getProxy(v.$DN.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(i){try{let r;const t=l.b.get(i.scheme);return t?(await l.a.$ensureActivation(i.scheme),r=await t.impl.stat(i)):r=await l.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===I.FilePermission.Readonly?1:void 0}}catch(r){S.e(r)}},async readDirectory(i){try{const r=l.b.get(i.scheme);return r?(await l.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await l.a.$readdir(i)}catch(r){return S.e(r)}},async createDirectory(i){try{const r=l.b.get(i.scheme);return r&&!r.isReadonly?(await l.a.$ensureActivation(i.scheme),await l.d(r.impl,r.extUri,i)):await l.a.$mkdir(i)}catch(r){return S.e(r)}},async readFile(i){try{const r=l.b.get(i.scheme);return r?(await l.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await l.a.$readFile(i)).buffer}catch(r){return S.e(r)}},async writeFile(i,r){try{const t=l.b.get(i.scheme);return t&&!t.isReadonly?(await l.a.$ensureActivation(i.scheme),await l.d(t.impl,t.extUri,t.extUri.dirname(i)),await l.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await l.a.$writeFile(i,O.$Le.wrap(r))}catch(t){return S.e(t)}},async delete(i,r){try{const t=l.b.get(i.scheme);return t&&!t.isReadonly&&!r?.useTrash?(await l.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...r})):await l.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(t){return S.e(t)}},async rename(i,r,t){try{return await l.a.$rename(i,r,{overwrite:!1,...t})}catch(g){return S.e(g)}},async copy(i,r,t){try{return await l.a.$copy(i,r,{overwrite:!1,...t})}catch(g){return S.e(g)}},isWritableFileSystem(i){const r=c.getCapabilities(i);if(typeof r=="number")return!(r&I.FileSystemProviderCapabilities.Readonly)}})}async d(o,c,l){const i=[];for(;!c.isEqual(l,c.dirname(l));)try{if(!((await o.stat(l)).type&I.FileType.Directory))throw P.$YO.FileExists(`Unable to create folder '${l.scheme===a.Schemas.file?l.fsPath:l.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(I.$nl(r)!==I.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(c.basename(l)),l=c.dirname(l)}for(let r=i.length-1;r>=0;r--){l=c.joinPath(l,i[r]);try{await o.createDirectory(l)}catch(t){if(I.$nl(t)!==I.FileSystemProviderErrorCode.FileExists)throw t}}}static e(o){if(o instanceof P.$YO)throw o;if(o instanceof I.$jl)switch(o.code){case I.FileSystemProviderErrorCode.FileExists:throw P.$YO.FileExists(o.message);case I.FileSystemProviderErrorCode.FileNotFound:throw P.$YO.FileNotFound(o.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw P.$YO.FileNotADirectory(o.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw P.$YO.FileIsADirectory(o.message);case I.FileSystemProviderErrorCode.NoPermissions:throw P.$YO.NoPermissions(o.message);case I.FileSystemProviderErrorCode.Unavailable:throw P.$YO.Unavailable(o.message);default:throw new P.$YO(o.message,o.name)}if(!(o instanceof Error))throw new P.$YO(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw P.$YO.Unavailable(o.message);switch(o.name){case I.FileSystemProviderErrorCode.FileExists:throw P.$YO.FileExists(o.message);case I.FileSystemProviderErrorCode.FileNotFound:throw P.$YO.FileNotFound(o.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw P.$YO.FileNotADirectory(o.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw P.$YO.FileIsADirectory(o.message);case I.FileSystemProviderErrorCode.NoPermissions:throw P.$YO.NoPermissions(o.message);case I.FileSystemProviderErrorCode.Unavailable:throw P.$YO.Unavailable(o.message);default:throw new P.$YO(o.message,o.name)}}addFileSystemProvider(o,c,l){return this.b.set(o,{impl:c,extUri:l?.isCaseSensitive?y.$6g:y.$8g,isReadonly:!!l?.isReadonly}),(0,s.$Rc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??y.$6g}};e.$lpc=d,e.$lpc=d=S=Ge([Ve(0,T.$cQ),Ve(1,$.$2oc)],d),e.$mpc=(0,R.$Ci)("IExtHostConsumerFileSystem")}),define(Oe[91],Ne([1,0,3,26,11,68,2]),function(be,e,v,I,P,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$opc=e.$npc=void 0,e.$npc=(0,v.$Ci)("IExtensionStoragePaths");let T=class{constructor(s,A,y){this.d=A,this.f=y,this.a=s.workspace??void 0,this.b=s.environment,this.whenReady=this.h().then(a=>this.c=a)}async g(s){return R.URI.joinPath(this.b.workspaceStorageHome,s)}async h(){if(!this.a)return Promise.resolve(void 0);const s=this.a.id,A=await this.g(s);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(s){if(this.c)return R.URI.joinPath(this.c,s.identifier.value)}globalValue(s){return R.URI.joinPath(this.b.globalStorageHome,s.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$opc=T,e.$opc=T=Ge([Ve(0,I.$sQ),Ve(1,P.$0j),Ve(2,O.$mpc)],T)}),define(Oe[230],Ne([1,0,7,16,6]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xqc=void 0;let O=class{constructor(T){this.a=new v.$9O(v.ColorThemeKind.Dark),this.b=new P.$je}get activeColorTheme(){return this.a}$onColorThemeChange(T){let $;switch(T){case"light":$=v.ColorThemeKind.Light;break;case"hcDark":$=v.ColorThemeKind.HighContrast;break;case"hcLight":$=v.ColorThemeKind.HighContrastLight;break;default:$=v.ColorThemeKind.Dark}this.a=new v.$9O($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Xqc=O,e.$Xqc=O=Ge([Ve(0,I.$cQ)],O)}),define(Oe[92],Ne([1,0,21,6,4,9,3,11,183,5,26,16,7]),function(be,e,v,I,P,O,R,T,$,s,A,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Fb=e.$0Fb=e.TunnelDtoConverter=void 0,O=We(O),a=We(a);class S extends $.$Lw{}var d;(function(o){function c(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=c;function l(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=l})(d||(e.TunnelDtoConverter=d={})),e.$0Fb=(0,R.$Ci)("IExtHostTunnelService");let n=class extends P.$Tc{constructor(c,l,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new I.$je,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy(s.$DN.MainThreadTunnelService)}async openTunnel(c,l){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${l.remoteAddress.host}:${l.remoteAddress.port}.`);const i=await this.a.$openTunnel(l,c.displayName);if(i){const r=new S(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,l){c.portRange===void 0&&c.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:c,provider:l}),this.a.$registerPortsAttributesProvider(c,i),new a.$FN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(c,l,i,r,t){const g=[];for(const m of c){const p=this.r.get(m);if(!p)return[];g.push(...await Promise.all(l.map(async h=>{let E;try{E=await p.provider.providePortAttributes({port:h,pid:i,commandLine:r},t)}catch{E=await p.provider.providePortAttributes(h,i,r,t)}return{providedAttributes:E,port:h}})))}const u=g.filter(m=>!!m.providedAttributes);return u.length>0?u.map(m=>({autoForwardAction:m.providedAttributes.autoForwardAction,port:m.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,l){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,t)=>await c.provideTunnel(r,t,v.CancellationToken.None)??void 0;const i=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,privacyOptions:l.tunnelFeatures?.privacyOptions,protocol:l.tunnelFeatures.protocol===void 0?!0:l.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,P.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,l){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const i=c.tunnelFactory??(l?this.w(l):void 0);if(i){this.b=i;let r=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:O.localize(10728,null),themeIcon:"lock"},{id:"public",label:O.localize(10729,null),themeIcon:"eye"}]);const t=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,P.$Rc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,l){if(this.g.has(c.host)){const i=this.g.get(c.host);i.has(c.port)&&(l&&i.get(c.port).disposeListener.dispose(),await i.get(c.port).tunnel.dispose(),i.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,l){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(c,l);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const t=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:r,disposeListener:t}),d.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(c){const l=await Promise.all(c.map(r=>this.f(r.host,r.port,r.detail??""))),i=c.filter((r,t)=>l[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$$Fb=n,e.$$Fb=n=Ge([Ve(0,y.$cQ),Ve(1,A.$sQ),Ve(2,T.$0j)],n)}),define(Oe[8],Ne([1,0,17,22,151,231,59,28,138,40,72,25,144,23,34,14,2,105,32,159,93,52,107,76,116,114,115,207,80,89,54,55,204,7]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l,i,r,t,g,u,m,p,h,E,D,b,k,C,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$_P=ae,e.$aQ=oe,e.$bQ=Ce,R=We(R),l=We(l),i=We(i),r=We(r),E=We(E),b=We(b),w=We(w);var M;(function(Ee){function Ae(J){const{selectionStartLineNumber:ye,selectionStartColumn:Be,positionLineNumber:Ze,positionColumn:He}=J,ut=new w.$GN(ye-1,Be-1),Pt=new w.$GN(Ze-1,He-1);return new w.$IN(ut,Pt)}Ee.to=Ae;function he(J){const{anchor:ye,active:Be}=J;return{selectionStartLineNumber:ye.line+1,selectionStartColumn:ye.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ee.from=he})(M||(e.Selection=M={}));var N;(function(Ee){function Ae(J){if(!J)return;const{start:ye,end:Be}=J;return{startLineNumber:ye.line+1,startColumn:ye.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ee.from=Ae;function he(J){if(!J)return;const{startLineNumber:ye,startColumn:Be,endLineNumber:Ze,endColumn:He}=J;return new w.$HN(ye-1,Be-1,Ze-1,He-1)}Ee.to=he})(N||(e.Range=N={}));var L;(function(Ee){function Ae(J){return{uri:J.uri,range:N.from(J.range)}}Ee.from=Ae;function he(J){return new w.$TN(o.URI.revive(J.uri),N.to(J.range))}Ee.to=he})(L||(e.Location=L={}));var W;(function(Ee){function Ae(he){switch(he){case i.StandardTokenType.Comment:return w.StandardTokenType.Comment;case i.StandardTokenType.Other:return w.StandardTokenType.Other;case i.StandardTokenType.RegEx:return w.StandardTokenType.RegEx;case i.StandardTokenType.String:return w.StandardTokenType.String}}Ee.to=Ae})(W||(e.TokenType=W={}));var G;(function(Ee){function Ae(J){return new w.$GN(J.lineNumber-1,J.column-1)}Ee.to=Ae;function he(J){return{lineNumber:J.line+1,column:J.character+1}}Ee.from=he})(G||(e.Position=G={}));var F;(function(Ee){function Ae(ye,Be,Ze){return(0,v.$Gb)((0,v.$1b)(ye).map(He=>he(He,Be,Ze)))}Ee.from=Ae;function he(ye,Be,Ze){if(typeof ye=="string")return{$serialized:!0,language:ye,isBuiltin:Ze?.isBuiltin};if(ye)return{$serialized:!0,language:ye.language,scheme:J(ye.scheme,Be),pattern:xe.from(ye.pattern)??void 0,exclusive:ye.exclusive,notebookType:ye.notebookType,isBuiltin:Ze?.isBuiltin}}function J(ye,Be){return Be&&typeof ye=="string"?Be.transformOutgoingScheme(ye):ye}})(F||(e.DocumentSelector=F={}));var K;(function(Ee){function Ae(J){switch(J){case w.DiagnosticTag.Unnecessary:return g.MarkerTag.Unnecessary;case w.DiagnosticTag.Deprecated:return g.MarkerTag.Deprecated}}Ee.from=Ae;function he(J){switch(J){case g.MarkerTag.Unnecessary:return w.DiagnosticTag.Unnecessary;case g.MarkerTag.Deprecated:return w.DiagnosticTag.Deprecated;default:return}}Ee.to=he})(K||(e.DiagnosticTag=K={}));var Y;(function(Ee){function Ae(J){let ye;return J.code&&((0,n.$cg)(J.code)||(0,n.$gg)(J.code)?ye=String(J.code):ye={value:String(J.code.value),target:J.code.target}),{...N.from(J.range),message:J.message,source:J.source,code:ye,severity:_.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(le.from),tags:Array.isArray(J.tags)?(0,v.$Gb)(J.tags.map(K.from)):void 0}}Ee.from=Ae;function he(J){const ye=new w.$VN(N.to(J),J.message,_.to(J.severity));return ye.source=J.source,ye.code=(0,n.$cg)(J.code)?J.code:J.code?.value,ye.relatedInformation=J.relatedInformation&&J.relatedInformation.map(le.to),ye.tags=J.tags&&(0,v.$Gb)(J.tags.map(K.to)),ye}Ee.to=he})(Y||(e.Diagnostic=Y={}));var le;(function(Ee){function Ae(J){return{...N.from(J.location.range),message:J.message,resource:J.location.uri}}Ee.from=Ae;function he(J){return new w.$UN(new w.$TN(J.resource,N.to(J)),J.message)}Ee.to=he})(le||(e.DiagnosticRelatedInformation=le={}));var _;(function(Ee){function Ae(J){switch(J){case w.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}Ee.from=Ae;function he(J){switch(J){case g.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}Ee.to=he})(_||(e.DiagnosticSeverity=_={}));var ge;(function(Ee){function Ae(J){return typeof J=="number"&&J>=w.ViewColumn.One?J-1:J===w.ViewColumn.Beside?f.$wE:f.$vE}Ee.from=Ae;function he(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=he})(ge||(e.ViewColumn=ge={}));function se(Ee){return typeof Ee.range<"u"}function ae(Ee){return Ee.length===0?!0:!!se(Ee[0])}var $e;(function(Ee){function Ae(He){return He.map(Ee.from)}Ee.fromMany=Ae;function he(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function J(He){let ut;if(he(He)){const{language:jt,value:ii}=He;ut={value:"```"+jt+`
`+ii+"\n```\n"}}else w.$0N.isMarkdownString(He)?ut={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?ut={value:He}:ut={value:""};const Pt=Object.create(null);ut.uris=Pt;const ti=jt=>{try{let ii=o.URI.parse(jt,!0);ii=ii.with({query:ye(ii.query,Pt)}),Pt[jt]=ii}catch{}return""},ai=new $.marked.Renderer;return ai.link=ti,ai.image=jt=>typeof jt=="string"?ti(R.$9k(jt).href):"",(0,$.marked)(ut.value,{renderer:ai}),ut}Ee.from=J;function ye(He,ut){if(!He)return He;let Pt;try{Pt=(0,s.$$h)(He)}catch{}if(!Pt)return He;let ti=!1;return Pt=(0,y.$do)(Pt,ai=>{if(o.URI.isUri(ai)){const jt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[jt]=ai,ti=!0,jt}else return}),ti?JSON.stringify(Pt):He}function Be(He){const ut=new w.$0N(He.value,He.supportThemeIcons);return ut.isTrusted=He.isTrusted,ut.supportHtml=He.supportHtml,ut.baseUri=He.baseUri?o.URI.from(He.baseUri):void 0,ut}Ee.to=Be;function Ze(He){if(He)return typeof He=="string"?He:Ee.from(He)}Ee.fromStrict=Ze})($e||(e.MarkdownString=$e={}));function oe(Ee){return ae(Ee)?Ee.map(Ae=>({range:N.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?$e.fromMany(Ae.hoverMessage):Ae.hoverMessage?$e.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):Ee.map(Ae=>({range:N.from(Ae)}))}function Ce(Ee){return typeof Ee>"u"?Ee:typeof Ee=="string"?o.URI.file(Ee):Ee}var Le;(function(Ee){function Ae(he){return typeof he>"u"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?Ce(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}Ee.from=Ae})(Le||(e.ThemableDecorationAttachmentRenderOptions=Le={}));var Z;(function(Ee){function Ae(he){return typeof he>"u"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?Ce(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?Le.from(he.before):void 0,after:he.after?Le.from(he.after):void 0}}Ee.from=Ae})(Z||(e.ThemableDecorationRenderOptions=Z={}));var q;(function(Ee){function Ae(he){if(typeof he>"u")return he;switch(he){case w.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case w.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Ee.from=Ae})(q||(e.DecorationRangeBehavior=q={}));var te;(function(Ee){function Ae(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?q.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?Z.from(he.light):void 0,dark:he.dark?Z.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?Ce(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?Le.from(he.before):void 0,after:he.after?Le.from(he.after):void 0}}Ee.from=Ae})(te||(e.DecorationRenderOptions=te={}));var ve;(function(Ee){function Ae(J){return{text:J.newText,eol:J.newEol&&Ue.from(J.newEol),range:N.from(J.range)}}Ee.from=Ae;function he(J){const ye=new w.$ON(N.to(J.range),J.text);return ye.newEol=typeof J.eol>"u"?void 0:Ue.to(J.eol),ye}Ee.to=he})(ve||(e.TextEdit=ve={}));var ce;(function(Ee){function Ae(J,ye){const Be={edits:[]};if(J instanceof w.$RN){const Ze=new T.$Ac;for(const He of J._allEntries())He._type===w.FileEditType.File&&o.URI.isUri(He.to)&&He.from===void 0&&Ze.add(He.to);for(const He of J._allEntries())if(He._type===w.FileEditType.File){let ut;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?ut={type:"base64",value:(0,I.$6e)(I.$Le.wrap(He.options.contents))}:ut={type:"dataTransferItem",id:He.options.contents._itemId}),Be.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:ut},metadata:He.metadata})}else He._type===w.FileEditType.Text?Be.edits.push({resource:He.uri,textEdit:ve.from(He.edit),versionId:Ze.has(He.uri)?void 0:ye?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===w.FileEditType.Snippet?Be.edits.push({resource:He.uri,textEdit:{range:N.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Ze.has(He.uri)?void 0:ye?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===w.FileEditType.Cell?Be.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:ye?.getNotebookDocumentVersion(He.uri)}):He._type===w.FileEditType.CellReplace&&Be.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:ye?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:b.CellEditType.Replace,index:He.index,count:He.count,cells:He.cells.map(Ye.from)}})}return Be}Ee.from=Ae;function he(J){const ye=new w.$RN,Be=new T.$zc;for(const Ze of J.edits)if(Ze.textEdit){const He=Ze,ut=o.URI.revive(He.resource),Pt=N.to(He.textEdit.range),ti=He.textEdit.text,ai=He.textEdit.insertAsSnippet;let jt;ai?jt=w.$QN.replace(Pt,new w.$SN(ti)):jt=w.$ON.replace(Pt,ti);const ii=Be.get(ut);ii?ii.push(jt):Be.set(ut,[jt])}else ye.renameFile(o.URI.revive(Ze.oldResource),o.URI.revive(Ze.newResource),Ze.options);for(const[Ze,He]of Be)ye.set(Ze,He);return ye}Ee.to=he})(ce||(e.WorkspaceEdit=ce={}));var we;(function(Ee){const Ae=Object.create(null);Ae[w.SymbolKind.File]=r.SymbolKind.File,Ae[w.SymbolKind.Module]=r.SymbolKind.Module,Ae[w.SymbolKind.Namespace]=r.SymbolKind.Namespace,Ae[w.SymbolKind.Package]=r.SymbolKind.Package,Ae[w.SymbolKind.Class]=r.SymbolKind.Class,Ae[w.SymbolKind.Method]=r.SymbolKind.Method,Ae[w.SymbolKind.Property]=r.SymbolKind.Property,Ae[w.SymbolKind.Field]=r.SymbolKind.Field,Ae[w.SymbolKind.Constructor]=r.SymbolKind.Constructor,Ae[w.SymbolKind.Enum]=r.SymbolKind.Enum,Ae[w.SymbolKind.Interface]=r.SymbolKind.Interface,Ae[w.SymbolKind.Function]=r.SymbolKind.Function,Ae[w.SymbolKind.Variable]=r.SymbolKind.Variable,Ae[w.SymbolKind.Constant]=r.SymbolKind.Constant,Ae[w.SymbolKind.String]=r.SymbolKind.String,Ae[w.SymbolKind.Number]=r.SymbolKind.Number,Ae[w.SymbolKind.Boolean]=r.SymbolKind.Boolean,Ae[w.SymbolKind.Array]=r.SymbolKind.Array,Ae[w.SymbolKind.Object]=r.SymbolKind.Object,Ae[w.SymbolKind.Key]=r.SymbolKind.Key,Ae[w.SymbolKind.Null]=r.SymbolKind.Null,Ae[w.SymbolKind.EnumMember]=r.SymbolKind.EnumMember,Ae[w.SymbolKind.Struct]=r.SymbolKind.Struct,Ae[w.SymbolKind.Event]=r.SymbolKind.Event,Ae[w.SymbolKind.Operator]=r.SymbolKind.Operator,Ae[w.SymbolKind.TypeParameter]=r.SymbolKind.TypeParameter;function he(ye){return typeof Ae[ye]=="number"?Ae[ye]:r.SymbolKind.Property}Ee.from=he;function J(ye){for(const Be in Ae)if(Ae[Be]===ye)return Number(Be);return w.SymbolKind.Property}Ee.to=J})(we||(e.SymbolKind=we={}));var ue;(function(Ee){function Ae(J){switch(J){case w.SymbolTag.Deprecated:return r.SymbolTag.Deprecated}}Ee.from=Ae;function he(J){switch(J){case r.SymbolTag.Deprecated:return w.SymbolTag.Deprecated}}Ee.to=he})(ue||(e.SymbolTag=ue={}));var X;(function(Ee){function Ae(J){return{name:J.name,kind:we.from(J.kind),tags:J.tags&&J.tags.map(ue.from),containerName:J.containerName,location:ze.from(J.location)}}Ee.from=Ae;function he(J){const ye=new w.$1N(J.name,we.to(J.kind),J.containerName,ze.to(J.location));return ye.tags=J.tags&&J.tags.map(ue.to),ye}Ee.to=he})(X||(e.WorkspaceSymbol=X={}));var x;(function(Ee){function Ae(J){const ye={name:J.name||"!!MISSING: name!!",detail:J.detail,range:N.from(J.range),selectionRange:N.from(J.selectionRange),kind:we.from(J.kind),tags:J.tags?.map(ue.from)??[]};return J.children&&(ye.children=J.children.map(Ae)),ye}Ee.from=Ae;function he(J){const ye=new w.$2N(J.name,J.detail,we.to(J.kind),N.to(J.range),N.to(J.selectionRange));return(0,v.$Kb)(J.tags)&&(ye.tags=J.tags.map(ue.to)),J.children&&(ye.children=J.children.map(he)),ye}Ee.to=he})(x||(e.DocumentSymbol=x={}));var me;(function(Ee){function Ae(J){const ye=new w.$6N(we.to(J.kind),J.name,J.detail||"",o.URI.revive(J.uri),N.to(J.range),N.to(J.selectionRange));return ye._sessionId=J._sessionId,ye._itemId=J._itemId,ye}Ee.to=Ae;function he(J,ye,Be){if(ye=ye??J._sessionId,Be=Be??J._itemId,ye===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Be,name:J.name,detail:J.detail,kind:we.from(J.kind),uri:J.uri,range:N.from(J.range),selectionRange:N.from(J.selectionRange),tags:J.tags?.map(ue.from)}}Ee.from=he})(me||(e.CallHierarchyItem=me={}));var pe;(function(Ee){function Ae(he){return new w.$7N(me.to(he.from),he.fromRanges.map(J=>N.to(J)))}Ee.to=Ae})(pe||(e.CallHierarchyIncomingCall=pe={}));var Re;(function(Ee){function Ae(he){return new w.$8N(me.to(he.to),he.fromRanges.map(J=>N.to(J)))}Ee.to=Ae})(Re||(e.CallHierarchyOutgoingCall=Re={}));var ze;(function(Ee){function Ae(J){return{range:J.range&&N.from(J.range),uri:J.uri}}Ee.from=Ae;function he(J){return new w.$TN(o.URI.revive(J.uri),N.to(J.range))}Ee.to=he})(ze||(e.location=ze={}));var ke;(function(Ee){function Ae(J){const ye=J,Be=J;return{originSelectionRange:ye.originSelectionRange?N.from(ye.originSelectionRange):void 0,uri:ye.targetUri?ye.targetUri:Be.uri,range:N.from(ye.targetRange?ye.targetRange:Be.range),targetSelectionRange:ye.targetSelectionRange?N.from(ye.targetSelectionRange):void 0}}Ee.from=Ae;function he(J){return{targetUri:o.URI.revive(J.uri),targetRange:N.to(J.range),targetSelectionRange:J.targetSelectionRange?N.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?N.to(J.originSelectionRange):void 0}}Ee.to=he})(ke||(e.DefinitionLink=ke={}));var Pe;(function(Ee){function Ae(J){return{range:N.from(J.range),contents:$e.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}Ee.from=Ae;function he(J){const ye=J.contents.map($e.to),Be=N.to(J.range),Ze=J.canIncreaseVerbosity,He=J.canDecreaseVerbosity;return new w.$XN(ye,Be,Ze,He)}Ee.to=he})(Pe||(e.Hover=Pe={}));var Te;(function(Ee){function Ae(J){return{range:N.from(J.range),expression:J.expression}}Ee.from=Ae;function he(J){return new w.$SO(N.to(J.range),J.expression)}Ee.to=he})(Te||(e.EvaluatableExpression=Te={}));var U;(function(Ee){function Ae(J){if(J instanceof w.$TO)return{type:"text",range:N.from(J.range),text:J.text};if(J instanceof w.$UO)return{type:"variable",range:N.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof w.$VO)return{type:"expression",range:N.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Ae;function he(J){switch(J.type){case"text":return{range:N.to(J.range),text:J.text};case"variable":return{range:N.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:N.to(J.range),expression:J.expression}}}Ee.to=he})(U||(e.InlineValue=U={}));var B;(function(Ee){function Ae(J){return{frameId:J.frameId,stoppedLocation:N.from(J.stoppedLocation)}}Ee.from=Ae;function he(J){return new w.$WO(J.frameId,N.to(J.stoppedLocation))}Ee.to=he})(B||(e.InlineValueContext=B={}));var H;(function(Ee){function Ae(J){return{range:N.from(J.range),kind:J.kind}}Ee.from=Ae;function he(J){return new w.$YN(N.to(J.range),J.kind)}Ee.to=he})(H||(e.DocumentHighlight=H={}));var V;(function(Ee){function Ae(J){return{uri:J.uri,highlights:J.highlights.map(H.from)}}Ee.from=Ae;function he(J){return new w.$ZN(o.URI.revive(J.uri),J.highlights.map(H.to))}Ee.to=he})(V||(e.MultiDocumentHighlight=V={}));var ne;(function(Ee){function Ae(he){switch(he){case r.CompletionTriggerKind.TriggerCharacter:return w.CompletionTriggerKind.TriggerCharacter;case r.CompletionTriggerKind.TriggerForIncompleteCompletions:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case r.CompletionTriggerKind.Invoke:default:return w.CompletionTriggerKind.Invoke}}Ee.to=Ae})(ne||(e.CompletionTriggerKind=ne={}));var fe;(function(Ee){function Ae(he){return{triggerKind:ne.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}Ee.to=Ae})(fe||(e.CompletionContext=fe={}));var Ie;(function(Ee){function Ae(J){switch(J){case w.CompletionItemTag.Deprecated:return r.CompletionItemTag.Deprecated}}Ee.from=Ae;function he(J){switch(J){case r.CompletionItemTag.Deprecated:return w.CompletionItemTag.Deprecated}}Ee.to=he})(Ie||(e.CompletionItemTag=Ie={}));var je;(function(Ee){const Ae=new Map([[w.CompletionItemKind.Method,r.CompletionItemKind.Method],[w.CompletionItemKind.Function,r.CompletionItemKind.Function],[w.CompletionItemKind.Constructor,r.CompletionItemKind.Constructor],[w.CompletionItemKind.Field,r.CompletionItemKind.Field],[w.CompletionItemKind.Variable,r.CompletionItemKind.Variable],[w.CompletionItemKind.Class,r.CompletionItemKind.Class],[w.CompletionItemKind.Interface,r.CompletionItemKind.Interface],[w.CompletionItemKind.Struct,r.CompletionItemKind.Struct],[w.CompletionItemKind.Module,r.CompletionItemKind.Module],[w.CompletionItemKind.Property,r.CompletionItemKind.Property],[w.CompletionItemKind.Unit,r.CompletionItemKind.Unit],[w.CompletionItemKind.Value,r.CompletionItemKind.Value],[w.CompletionItemKind.Constant,r.CompletionItemKind.Constant],[w.CompletionItemKind.Enum,r.CompletionItemKind.Enum],[w.CompletionItemKind.EnumMember,r.CompletionItemKind.EnumMember],[w.CompletionItemKind.Keyword,r.CompletionItemKind.Keyword],[w.CompletionItemKind.Snippet,r.CompletionItemKind.Snippet],[w.CompletionItemKind.Text,r.CompletionItemKind.Text],[w.CompletionItemKind.Color,r.CompletionItemKind.Color],[w.CompletionItemKind.File,r.CompletionItemKind.File],[w.CompletionItemKind.Reference,r.CompletionItemKind.Reference],[w.CompletionItemKind.Folder,r.CompletionItemKind.Folder],[w.CompletionItemKind.Event,r.CompletionItemKind.Event],[w.CompletionItemKind.Operator,r.CompletionItemKind.Operator],[w.CompletionItemKind.TypeParameter,r.CompletionItemKind.TypeParameter],[w.CompletionItemKind.Issue,r.CompletionItemKind.Issue],[w.CompletionItemKind.User,r.CompletionItemKind.User]]);function he(Be){return Ae.get(Be)??r.CompletionItemKind.Property}Ee.from=he;const J=new Map([[r.CompletionItemKind.Method,w.CompletionItemKind.Method],[r.CompletionItemKind.Function,w.CompletionItemKind.Function],[r.CompletionItemKind.Constructor,w.CompletionItemKind.Constructor],[r.CompletionItemKind.Field,w.CompletionItemKind.Field],[r.CompletionItemKind.Variable,w.CompletionItemKind.Variable],[r.CompletionItemKind.Class,w.CompletionItemKind.Class],[r.CompletionItemKind.Interface,w.CompletionItemKind.Interface],[r.CompletionItemKind.Struct,w.CompletionItemKind.Struct],[r.CompletionItemKind.Module,w.CompletionItemKind.Module],[r.CompletionItemKind.Property,w.CompletionItemKind.Property],[r.CompletionItemKind.Unit,w.CompletionItemKind.Unit],[r.CompletionItemKind.Value,w.CompletionItemKind.Value],[r.CompletionItemKind.Constant,w.CompletionItemKind.Constant],[r.CompletionItemKind.Enum,w.CompletionItemKind.Enum],[r.CompletionItemKind.EnumMember,w.CompletionItemKind.EnumMember],[r.CompletionItemKind.Keyword,w.CompletionItemKind.Keyword],[r.CompletionItemKind.Snippet,w.CompletionItemKind.Snippet],[r.CompletionItemKind.Text,w.CompletionItemKind.Text],[r.CompletionItemKind.Color,w.CompletionItemKind.Color],[r.CompletionItemKind.File,w.CompletionItemKind.File],[r.CompletionItemKind.Reference,w.CompletionItemKind.Reference],[r.CompletionItemKind.Folder,w.CompletionItemKind.Folder],[r.CompletionItemKind.Event,w.CompletionItemKind.Event],[r.CompletionItemKind.Operator,w.CompletionItemKind.Operator],[r.CompletionItemKind.TypeParameter,w.CompletionItemKind.TypeParameter],[r.CompletionItemKind.User,w.CompletionItemKind.User],[r.CompletionItemKind.Issue,w.CompletionItemKind.Issue]]);function ye(Be){return J.get(Be)??w.CompletionItemKind.Property}Ee.to=ye})(je||(e.CompletionItemKind=je={}));var Qe;(function(Ee){function Ae(he,J){const ye=new w.$dO(he.label);return ye.insertText=he.insertText,ye.kind=je.to(he.kind),ye.tags=he.tags?.map(Ie.to),ye.detail=he.detail,ye.documentation=R.$3k(he.documentation)?$e.to(he.documentation):he.documentation,ye.sortText=he.sortText,ye.filterText=he.filterText,ye.preselect=he.preselect,ye.commitCharacters=he.commitCharacters,l.$Lt.isIRange(he.range)?ye.range=N.to(he.range):typeof he.range=="object"&&(ye.range={inserting:N.to(he.range.insert),replacing:N.to(he.range.replace)}),ye.keepWhitespace=typeof he.insertTextRules>"u"?!1:!!(he.insertTextRules&r.CompletionItemInsertTextRule.KeepWhitespace),typeof he.insertTextRules<"u"&&he.insertTextRules&r.CompletionItemInsertTextRule.InsertAsSnippet?ye.insertText=new w.$SN(he.insertText):(ye.insertText=he.insertText,ye.textEdit=ye.range instanceof w.$HN?new w.$ON(ye.range,ye.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(ye.additionalTextEdits=he.additionalTextEdits.map(Be=>ve.to(Be))),ye.command=J&&he.command?J.fromInternal(he.command):void 0,ye}Ee.to=Ae})(Qe||(e.CompletionItem=Qe={}));var _e;(function(Ee){function Ae(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:$e.fromStrict(J.documentation)}}Ee.from=Ae;function he(J){return{label:J.label,documentation:R.$3k(J.documentation)?$e.to(J.documentation):J.documentation}}Ee.to=he})(_e||(e.ParameterInformation=_e={}));var tt;(function(Ee){function Ae(J){return{label:J.label,documentation:$e.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(_e.from):[],activeParameter:J.activeParameter}}Ee.from=Ae;function he(J){return{label:J.label,documentation:R.$3k(J.documentation)?$e.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(_e.to):[],activeParameter:J.activeParameter}}Ee.to=he})(tt||(e.SignatureInformation=tt={}));var nt;(function(Ee){function Ae(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(tt.from):[]}}Ee.from=Ae;function he(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(tt.to):[]}}Ee.to=he})(nt||(e.SignatureHelp=nt={}));var et;(function(Ee){function Ae(he,J){const ye=new w.$cO(G.to(J.position),typeof J.label=="string"?J.label:J.label.map(rt.to.bind(void 0,he)),J.kind&&mt.to(J.kind));return ye.textEdits=J.textEdits&&J.textEdits.map(ve.to),ye.tooltip=R.$3k(J.tooltip)?$e.to(J.tooltip):J.tooltip,ye.paddingLeft=J.paddingLeft,ye.paddingRight=J.paddingRight,ye}Ee.to=Ae})(et||(e.InlayHint=et={}));var rt;(function(Ee){function Ae(he,J){const ye=new w.$bO(J.label);return ye.tooltip=R.$3k(J.tooltip)?$e.to(J.tooltip):J.tooltip,r.Command.is(J.command)&&(ye.command=he.fromInternal(J.command)),J.location&&(ye.location=ze.to(J.location)),ye}Ee.to=Ae})(rt||(e.InlayHintLabelPart=rt={}));var mt;(function(Ee){function Ae(J){return J}Ee.from=Ae;function he(J){return J}Ee.to=he})(mt||(e.InlayHintKind=mt={}));var lt;(function(Ee){function Ae(J){return{range:N.from(J.range),url:J.target,tooltip:J.tooltip}}Ee.from=Ae;function he(J){let ye;if(J.url)try{ye=typeof J.url=="string"?o.URI.parse(J.url,!0):o.URI.revive(J.url)}catch{}const Be=new w.$iO(N.to(J.range),ye);return Be.tooltip=J.tooltip,Be}Ee.to=he})(lt||(e.DocumentLink=lt={}));var st;(function(Ee){function Ae(J){const ye=new w.$lO(J.label);return J.textEdit&&(ye.textEdit=ve.to(J.textEdit)),J.additionalTextEdits&&(ye.additionalTextEdits=J.additionalTextEdits.map(Be=>ve.to(Be))),ye}Ee.to=Ae;function he(J){return{label:J.label,textEdit:J.textEdit?ve.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(ye=>ve.from(ye)):void 0}}Ee.from=he})(st||(e.ColorPresentation=st={}));var ct;(function(Ee){function Ae(J){return new w.$jO(J[0],J[1],J[2],J[3])}Ee.to=Ae;function he(J){return[J.red,J.green,J.blue,J.alpha]}Ee.from=he})(ct||(e.Color=ct={}));var ft;(function(Ee){function Ae(J){return{range:N.from(J.range)}}Ee.from=Ae;function he(J){return new w.$5N(N.to(J.range))}Ee.to=he})(ft||(e.SelectionRange=ft={}));var pt;(function(Ee){function Ae(he){switch(he){case p.SaveReason.AUTO:return w.TextDocumentSaveReason.AfterDelay;case p.SaveReason.EXPLICIT:return w.TextDocumentSaveReason.Manual;case p.SaveReason.FOCUS_CHANGE:case p.SaveReason.WINDOW_CHANGE:return w.TextDocumentSaveReason.FocusOut}}Ee.to=Ae})(pt||(e.TextDocumentSaveReason=pt={}));var qe;(function(Ee){function Ae(J){switch(J){case w.TextEditorLineNumbersStyle.Off:return c.RenderLineNumbersType.Off;case w.TextEditorLineNumbersStyle.Relative:return c.RenderLineNumbersType.Relative;case w.TextEditorLineNumbersStyle.Interval:return c.RenderLineNumbersType.Interval;case w.TextEditorLineNumbersStyle.On:default:return c.RenderLineNumbersType.On}}Ee.from=Ae;function he(J){switch(J){case c.RenderLineNumbersType.Off:return w.TextEditorLineNumbersStyle.Off;case c.RenderLineNumbersType.Relative:return w.TextEditorLineNumbersStyle.Relative;case c.RenderLineNumbersType.Interval:return w.TextEditorLineNumbersStyle.Interval;case c.RenderLineNumbersType.On:default:return w.TextEditorLineNumbersStyle.On}}Ee.to=he})(qe||(e.TextEditorLineNumbersStyle=qe={}));var Ue;(function(Ee){function Ae(J){if(J===w.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(J===w.EndOfLine.LF)return t.EndOfLineSequence.LF}Ee.from=Ae;function he(J){if(J===t.EndOfLineSequence.CRLF)return w.EndOfLine.CRLF;if(J===t.EndOfLineSequence.LF)return w.EndOfLine.LF}Ee.to=he})(Ue||(e.EndOfLine=Ue={}));var ee;(function(Ee){function Ae(he){if(typeof he=="object")return he.viewId;switch(he){case w.ProgressLocation.SourceControl:return u.ProgressLocation.Scm;case w.ProgressLocation.Window:return u.ProgressLocation.Window;case w.ProgressLocation.Notification:return u.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Ae})(ee||(e.ProgressLocation=ee={}));var Q;(function(Ee){function Ae(J){const ye={start:J.start+1,end:J.end+1};return J.kind&&(ye.kind=De.from(J.kind)),ye}Ee.from=Ae;function he(J){const ye={start:J.start-1,end:J.end-1};return J.kind&&(ye.kind=De.to(J.kind)),ye}Ee.to=he})(Q||(e.FoldingRange=Q={}));var De;(function(Ee){function Ae(J){if(J)switch(J){case w.FoldingRangeKind.Comment:return r.$Mu.Comment;case w.FoldingRangeKind.Imports:return r.$Mu.Imports;case w.FoldingRangeKind.Region:return r.$Mu.Region}}Ee.from=Ae;function he(J){if(J)switch(J.value){case r.$Mu.Comment.value:return w.FoldingRangeKind.Comment;case r.$Mu.Imports.value:return w.FoldingRangeKind.Imports;case r.$Mu.Region.value:return w.FoldingRangeKind.Region}}Ee.to=he})(De||(e.FoldingRangeKind=De={}));var Je;(function(Ee){function Ae(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?N.from(he.selection):void 0,override:typeof he.override=="boolean"?p.$2F.id:void 0}}Ee.from=Ae})(Je||(e.TextEditorOpenOptions=Je={}));var xe;(function(Ee){function Ae(Be){return Be instanceof w.$GO?Be.toJSON():typeof Be=="string"?Be:he(Be)||J(Be)?new w.$GO(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ee.from=Ae;function he(Be){const Ze=Be;return Ze?o.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function J(Be){const Ze=Be;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function ye(Be){return typeof Be=="string"?Be:new w.$GO(o.URI.revive(Be.baseUri),Be.pattern)}Ee.to=ye})(xe||(e.GlobPattern=xe={}));var ht;(function(Ee){function Ae(he){if(he){if(Array.isArray(he))return he.map(Ae);if(typeof he=="string")return he;{const J=he;return{language:J.language,scheme:J.scheme,pattern:xe.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}Ee.from=Ae})(ht||(e.LanguageSelector=ht={}));var $t;(function(Ee){function Ae(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(ye=>Array.isArray(ye)&&ye.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&o.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Ze=>Ze instanceof w.$HN)))}Ee.is=Ae;function he(J){return{documents:J.documents.map(ye=>ye.map(Be=>({uri:o.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Ze=>N.from(Ze))})))}}Ee.from=he})($t||(e.MappedEditsContext=$t={}));var Nt;(function(Ee){function Ae(J){return{start:J.start,end:J.end}}Ee.from=Ae;function he(J){return new w.$0O(J.start,J.end)}Ee.to=he})(Nt||(e.NotebookRange=Nt={}));var Wt;(function(Ee){function Ae(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}Ee.to=Ae;function he(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}Ee.from=he})(Wt||(e.NotebookCellExecutionSummary=Wt={}));var ri;(function(Ee){function Ae(he){if(he===b.NotebookCellExecutionState.Unconfirmed)return w.NotebookCellExecutionState.Pending;if(he===b.NotebookCellExecutionState.Pending)return;if(he===b.NotebookCellExecutionState.Executing)return w.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${he}`)}Ee.to=Ae})(ri||(e.NotebookCellExecutionState=ri={}));var Xt;(function(Ee){function Ae(J){switch(J){case w.NotebookCellKind.Markup:return b.CellKind.Markup;case w.NotebookCellKind.Code:default:return b.CellKind.Code}}Ee.from=Ae;function he(J){switch(J){case b.CellKind.Markup:return w.NotebookCellKind.Markup;case b.CellKind.Code:default:return w.NotebookCellKind.Code}}Ee.to=he})(Xt||(e.NotebookCellKind=Xt={}));var hi;(function(Ee){function Ae(J){const ye={metadata:J.metadata??Object.create(null),cells:[]};for(const Be of J.cells)w.$$O.validate(Be),ye.cells.push(Ye.from(Be));return ye}Ee.from=Ae;function he(J){const ye=new w.$_O(J.cells.map(Ye.to));return(0,n.$pg)(J.metadata)||(ye.metadata=J.metadata),ye}Ee.to=he})(hi||(e.NotebookData=hi={}));var Ye;(function(Ee){function Ae(J){return{cellKind:Xt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:Wt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Ht.from):[]}}Ee.from=Ae;function he(J){return new w.$$O(Xt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Ht.to):void 0,J.metadata,J.internalMetadata?Wt.to(J.internalMetadata):void 0)}Ee.to=he})(Ye||(e.NotebookCellData=Ye={}));var Vt;(function(Ee){function Ae(J){return{mime:J.mime,valueBytes:I.$Le.wrap(J.data)}}Ee.from=Ae;function he(J){return new w.$aP(J.valueBytes.buffer,J.mime)}Ee.to=he})(Vt||(e.NotebookCellOutputItem=Vt={}));var Ht;(function(Ee){function Ae(J){return{outputId:J.id,items:J.items.map(Vt.from),metadata:J.metadata}}Ee.from=Ae;function he(J){const ye=J.items.map(Vt.to);return new w.$bP(ye,J.outputId,J.metadata)}Ee.to=he})(Ht||(e.NotebookCellOutput=Ht={}));var gt;(function(Ee){function Ae(ye){return J(ye)?{include:xe.from(ye.include)??void 0,exclude:xe.from(ye.exclude)??void 0}:xe.from(ye)??void 0}Ee.from=Ae;function he(ye){return J(ye)?{include:xe.to(ye.include),exclude:xe.to(ye.exclude)}:xe.to(ye)}Ee.to=he;function J(ye){const Be=ye;return Be?!(0,n.$lg)(Be.include)&&!(0,n.$lg)(Be.exclude):!1}})(gt||(e.NotebookExclusiveDocumentPattern=gt={}));var St;(function(Ee){function Ae(he,J,ye){const Be=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===w.NotebookCellStatusBarAlignment.Left?b.CellStatusbarAlignment.Left:b.CellStatusbarAlignment.Right,command:J.toInternal(Be,ye),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}Ee.from=Ae})(St||(e.NotebookStatusBarItem=St={}));var Yt;(function(Ee){function Ae(he,J,ye){const Be=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{command:J.toInternal(Be,ye),label:he.label,description:he.description,detail:he.detail,documentation:he.documentation}}Ee.from=Ae})(Yt||(e.NotebookKernelSourceAction=Yt={}));var Zt;(function(Ee){function Ae(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{},cellContentMetadata:he?.cellContentMetadata??{}}}Ee.from=Ae})(Zt||(e.NotebookDocumentContentOptions=Zt={}));var Ut;(function(Ee){function Ae(J){return{uri:J.uri,provides:J.provides}}Ee.from=Ae;function he(J){return new w.$dP(o.URI.revive(J.uri),J.provides)}Ee.to=he})(Ut||(e.NotebookRendererScript=Ut={}));var wt;(function(Ee){function Ae(J){return{message:$e.fromStrict(J.message)||"",type:C.TestMessageType.Error,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:N.from(J.location.range),uri:J.location.uri},stackTrace:J.stackTrace?.map(ye=>({label:ye.label,position:ye.position&&G.from(ye.position),uri:ye.file&&o.URI.revive(ye.file).toJSON()}))}}Ee.from=Ae;function he(J){const ye=new w.$jP(typeof J.message=="string"?J.message:$e.to(J.message));return ye.actualOutput=J.actual,ye.expectedOutput=J.expected,ye.contextValue=J.contextValue,ye.location=J.location?ze.to(J.location):void 0,ye}Ee.to=he})(wt||(e.TestMessage=wt={}));var At;(function(Ee){Ee.namespace=C.$8I,Ee.denamespace=C.$9I})(At||(e.TestTag=At={}));var ci;(function(Ee){function Ae(J){const ye=(0,m.$$P)(J).controllerId;return{extId:k.$3I.fromExtHostTestItem(J,ye).toString(),label:J.label,uri:o.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Be=>At.namespace(ye,Be.id)),range:l.$Lt.lift(N.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&$e.fromStrict(J.error)||null}}Ee.from=Ae;function he(J){return{parent:void 0,error:void 0,id:k.$3I.fromString(J.extId).localId,label:J.label,uri:o.URI.revive(J.uri),tags:(J.tags||[]).map(ye=>{const{tagId:Be}=At.denamespace(ye);return new w.$kP(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}Ee.toPlain=he})(ci||(e.TestItem=ci={})),function(Ee){function Ae(J){return{id:J.id}}Ee.from=Ae;function he(J){return new w.$kP(J.id)}Ee.to=he}(At||(e.TestTag=At={}));var Qt;(function(Ee){const Ae=(J,ye)=>{const Be=J.value;if(!Be)return;const Ze={...ci.toPlain(Be.item),parent:ye,taskStates:Be.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(ut=>ut.type===C.TestMessageType.Error).map(wt.to)})),children:[]};if(J.children)for(const He of J.children.values()){const ut=Ae(He,Ze);ut&&Ze.children.push(ut)}return Ze};function he(J){const ye=new a.$2I;for(const He of J.items)ye.insert(k.$3I.fromString(He.item.extId).path,He);const Be=[ye.nodes],Ze=[];for(;Be.length;)for(const He of Be.pop())He.value?Ze.push(He):He.children&&Be.push(He.children.values());return{completedAt:J.completedAt,results:Ze.map(He=>Ae(He)).filter(n.$kg)}}Ee.to=he})(Qt||(e.TestResults=Qt={}));var Xe;(function(Ee){function Ae(Be){return{covered:Be.covered,total:Be.total}}function he(Be){return"line"in Be?G.from(Be):N.from(Be)}function J(Be){if(typeof Be.executed=="number"&&Be.executed<0)throw new Error(`Invalid coverage count ${Be.executed}`);return"branches"in Be?{count:Be.executed,location:he(Be.location),type:C.DetailType.Statement,branches:Be.branches.length?Be.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&he(Ze.location),label:Ze.label})):void 0}:{type:C.DetailType.Declaration,name:Be.name,count:Be.executed,location:he(Be.location)}}Ee.fromDetails=J;function ye(Be,Ze,He){return w.$nP(He.statementCoverage),w.$nP(He.branchCoverage),w.$nP(He.declarationCoverage),{id:Ze,uri:He.uri,statement:Ae(He.statementCoverage),branch:He.branchCoverage&&Ae(He.branchCoverage),declaration:He.declarationCoverage&&Ae(He.declarationCoverage),testIds:He instanceof w.$oP&&He.fromTests.length?He.fromTests.map(ut=>k.$3I.fromExtHostTestItem(ut,Be).toString()):void 0}}Ee.fromFile=ye})(Xe||(e.TestCoverage=Xe={}));var xt;(function(Ee){function Ae(he){switch(he){case r.CodeActionTriggerType.Invoke:return w.CodeActionTriggerKind.Invoke;case r.CodeActionTriggerType.Auto:return w.CodeActionTriggerKind.Automatic}}Ee.to=Ae})(xt||(e.CodeActionTriggerKind=xt={}));var li;(function(Ee){function Ae(J){const ye=new w.$sP(we.to(J.kind),J.name,J.detail||"",o.URI.revive(J.uri),N.to(J.range),N.to(J.selectionRange));return ye._sessionId=J._sessionId,ye._itemId=J._itemId,ye}Ee.to=Ae;function he(J,ye,Be){if(ye=ye??J._sessionId,Be=Be??J._itemId,ye===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Be,kind:we.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:N.from(J.range),selectionRange:N.from(J.selectionRange),tags:J.tags?.map(ue.from)}}Ee.from=he})(li||(e.TypeHierarchyItem=li={}));var di;(function(Ee){function Ae(he){if(he)return{value:he.value,tooltip:he.tooltip}}Ee.from=Ae})(di||(e.ViewBadge=di={}));var kt;(function(Ee){function Ae(Be,Ze,He){const ut=Ze.fileData;return ut?new w.$yO(new w.$zO(ut.name,o.URI.revive(ut.uri),ut.id,(0,O.$cb)(()=>He(ut.id)))):Be===A.$8s.uriList&&Ze.uriListData?new w.$xO(ye(Ze.uriListData)):new w.$xO(Ze.asString)}Ee.to=Ae;async function he(Be,Ze){const He=await Ze.asString();if(Be===A.$8s.uriList)return{asString:He,fileData:void 0,uriListData:J(He)};const ut=Ze.asFile();return{asString:He,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}Ee.from=he;function J(Be){return P.$qu.split(Be).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return o.URI.parse(Ze)}catch{}return Ze})}function ye(Be){return P.$qu.create(Be.map(Ze=>typeof Ze=="string"?Ze:o.URI.revive(Ze)))}})(kt||(e.DataTransferItem=kt={}));var Ft;(function(Ee){function Ae(J,ye){const Be=J.items.map(([Ze,He])=>[Ze,kt.to(Ze,He,ye)]);return new w.$AO(Be)}Ee.toDataTransfer=Ae;async function he(J){const ye={items:[]},Be=[];for(const[Ze,He]of J)Be.push((async()=>{ye.items.push([Ze,await kt.from(Ze,He)])})());return await Promise.all(Be),ye}Ee.from=he})(Ft||(e.DataTransfer=Ft={}));var Rt;(function(Ee){function Ae(J,ye){return{kind:"reply",agentId:J.participant??ye?.agentId??"",subCommand:J.command??ye?.command,message:J.prompt,title:J.label}}Ee.from=Ae;function he(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}Ee.to=he})(Rt||(e.ChatFollowup=Rt={}));var Mt;(function(Ee){function Ae(J){switch(J){case E.ChatMessageRole.System:return w.LanguageModelChatMessageRole.System;case E.ChatMessageRole.User:return w.LanguageModelChatMessageRole.User;case E.ChatMessageRole.Assistant:return w.LanguageModelChatMessageRole.Assistant}}Ee.to=Ae;function he(J){switch(J){case w.LanguageModelChatMessageRole.System:return E.ChatMessageRole.System;case w.LanguageModelChatMessageRole.User:return E.ChatMessageRole.User;case w.LanguageModelChatMessageRole.Assistant:return E.ChatMessageRole.Assistant}return E.ChatMessageRole.User}Ee.from=he})(Mt||(e.LanguageModelChatMessageRole=Mt={}));var si;(function(Ee){function Ae(J){let ye="",Be;J.content.type==="text"?ye=J.content.value:Be=new w.$VP(J.content.name,J.content.value,J.content.isError);const Ze=Mt.to(J.role),He=new w.$WP(Ze,ye,J.name);return Be!==void 0&&(He.content2=Be),He}Ee.to=Ae;function he(J){const ye=Mt.from(J.role),Be=J.name;let Ze;return J.content2 instanceof w.$VP?Ze={type:"function_result",name:J.content2.name,value:J.content2.content,isError:J.content2.isError}:Ze={type:"text",value:J.content},{role:ye,name:Be,content:Ze}}Ee.from=he})(si||(e.LanguageModelChatMessage=si={}));var _t;(function(Ee){function Ae(J){return{kind:"markdownContent",content:$e.from(J.value)}}Ee.from=Ae;function he(J){return new w.$FP($e.to(J.content))}Ee.to=he})(_t||(e.ChatResponseMarkdownPart=_t={}));var ei;(function(Ee){function Ae(J){return{kind:"markdownVuln",content:$e.from(J.value),vulnerabilities:J.vulnerabilities}}Ee.from=Ae;function he(J){return new w.$GP($e.to(J.content),J.vulnerabilities)}Ee.to=he})(ei||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ei={}));var Bt;(function(Ee){function Ae(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}Ee.from=Ae;function he(J){return new w.$HP(J.agentId,J.command)}Ee.to=he})(Bt||(e.ChatResponseDetectedParticipantPart=Bt={}));var qt;(function(Ee){function Ae(he){return{kind:"confirmation",title:he.title,message:he.message,data:he.data,buttons:he.buttons}}Ee.from=Ae})(qt||(e.ChatResponseConfirmationPart=qt={}));var ui;(function(Ee){function Ae(J){const{value:ye,baseUri:Be}=J;function Ze(He,ut){return He.map(Pt=>{const ti=o.URI.joinPath(ut,Pt.name);return{label:Pt.name,uri:ti,children:Pt.children&&Ze(Pt.children,ti)}})}return{kind:"treeData",treeData:{label:(0,S.$ah)(Be),uri:Be,children:Ze(ye,Be)}}}Ee.from=Ae;function he(J){const ye=(0,s.$_h)(J.treeData);function Be(ut){return ut.map(Pt=>({name:Pt.label,children:Pt.children&&Be(Pt.children)}))}const Ze=ye.uri,He=ye.children?Be(ye.children):[];return new w.$JP(He,Ze)}Ee.to=he})(ui||(e.ChatResponseFilesPart=ui={}));var Tt;(function(Ee){function Ae(J){const ye=Be=>o.URI.isUri(Be);return{kind:"inlineReference",name:J.title,inlineReference:ye(J.value)?J.value:L.from(J.value)}}Ee.from=Ae;function he(J){const ye=(0,s.$_h)(J);return new w.$KP(o.URI.isUri(ye.inlineReference)?ye.inlineReference:L.to(ye.inlineReference),J.name)}Ee.to=he})(Tt||(e.ChatResponseAnchorPart=Tt={}));var Ct;(function(Ee){function Ae(J){return{kind:"progressMessage",content:$e.from(J.value)}}Ee.from=Ae;function he(J){return new w.$LP(J.content.value)}Ee.to=he})(Ct||(e.ChatResponseProgressPart=Ct={}));var bt;(function(Ee){function Ae(J){return{kind:"warning",content:$e.from(J.value)}}Ee.from=Ae;function he(J){return new w.$NP(J.content.value)}Ee.to=he})(bt||(e.ChatResponseWarningPart=bt={}));var Kt;(function(Ee){function Ae(he){return{kind:"progressTask",content:$e.from(he.value)}}Ee.from=Ae})(Kt||(e.ChatTask=Kt={}));var yt;(function(Ee){function Ae(he){return{kind:"progressTaskResult",content:typeof he=="string"?$e.from(he):void 0}}Ee.from=Ae})(yt||(e.ChatTaskResult=yt={}));var oi;(function(Ee){function Ae(J,ye,Be){return{kind:"command",command:ye.toInternal(J.value,Be)??{command:J.value.command,title:J.value.title}}}Ee.from=Ae;function he(J,ye){return new w.$OP(ye.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}Ee.to=he})(oi||(e.ChatResponseCommandButtonPart=oi={}));var Gt;(function(Ee){function Ae(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(ye=>ve.from(ye))}}Ee.from=Ae;function he(J){return new w.$QP(o.URI.revive(J.uri),J.edits.map(ye=>ve.to(ye)))}Ee.to=he})(Gt||(e.ChatResponseTextEditPart=Gt={}));var Ai;(function(Ee){function Ae(J){const ye=d.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:o.URI.isUri(J.iconPath)?{light:o.URI.revive(J.iconPath)}:J.iconPath&&"light"in J.iconPath&&"dark"in J.iconPath&&o.URI.isUri(J.iconPath.light)&&o.URI.isUri(J.iconPath.dark)?{light:o.URI.revive(J.iconPath.light),dark:o.URI.revive(J.iconPath.dark)}:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:o.URI.isUri(J.value.value)||!J.value.value?J.value.value:L.from(J.value.value)},iconPath:ye}:{kind:"reference",reference:o.URI.isUri(J.value)?J.value:L.from(J.value),iconPath:ye}}Ee.from=Ae;function he(J){const ye=(0,s.$_h)(J),Be=Ze=>o.URI.isUri(Ze)?Ze:L.to(Ze);return new w.$PP("variableName"in ye.reference?{variableName:ye.reference.variableName,value:ye.reference.value&&Be(ye.reference.value)}:Be(ye.reference))}Ee.to=he})(Ai||(e.ChatResponseReferencePart=Ai={}));var $i;(function(Ee){function Ae(ye,Be,Ze){return ye instanceof w.$FP?_t.from(ye):ye instanceof w.$KP?Tt.from(ye):ye instanceof w.$PP?Ai.from(ye):ye instanceof w.$LP?Ct.from(ye):ye instanceof w.$JP?ui.from(ye):ye instanceof w.$OP?oi.from(ye,Be,Ze):ye instanceof w.$QP?Gt.from(ye):ye instanceof w.$GP?ei.from(ye):ye instanceof w.$HP?Bt.from(ye):ye instanceof w.$NP?bt.from(ye):ye instanceof w.$IP?qt.from(ye):{kind:"markdownContent",content:$e.from("")}}Ee.from=Ae;function he(ye,Be){switch(ye.kind){case"reference":return Ai.to(ye);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(ye,Be)}}Ee.to=he;function J(ye,Be){switch(ye.kind){case"markdownContent":return _t.to(ye);case"inlineReference":return Tt.to(ye);case"progressMessage":return;case"treeData":return ui.to(ye);case"command":return oi.to(ye,Be)}}Ee.toContent=J})($i||(e.ChatResponsePart=$i={}));var Di;(function(Ee){function Ae(he,J){return{prompt:he.message,command:he.command,attempt:he.attempt??0,enableCommandDetection:he.enableCommandDetection??!0,references:he.variables.variables.map(fi.to),location:zt.to(he.location),acceptedConfirmationData:he.acceptedConfirmationData,rejectedConfirmationData:he.rejectedConfirmationData,location2:J}}Ee.to=Ae})(Di||(e.ChatAgentRequest=Di={}));var zt;(function(Ee){function Ae(J){switch(J){case h.ChatAgentLocation.Notebook:return w.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return w.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return w.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return w.ChatLocation.Editor}}Ee.to=Ae;function he(J){switch(J){case w.ChatLocation.Notebook:return h.ChatAgentLocation.Notebook;case w.ChatLocation.Terminal:return h.ChatAgentLocation.Terminal;case w.ChatLocation.Panel:return h.ChatAgentLocation.Panel;case w.ChatLocation.Editor:return h.ChatAgentLocation.Editor}}Ee.from=he})(zt||(e.ChatLocation=zt={}));var fi;(function(Ee){function Ae(he){const J=he.value;if(!J)throw new Error("Invalid value reference");return{id:he.id,name:he.name,range:he.range&&[he.range.start,he.range.endExclusive],value:(0,o.$uc)(J)?o.URI.revive(J):J&&typeof J=="object"&&"uri"in J&&"range"in J&&(0,o.$uc)(J.uri)?L.to((0,s.$_h)(J)):J,modelDescription:he.modelDescription}}Ee.to=Ae})(fi||(e.ChatAgentValueReference=fi={}));var Ni;(function(Ee){function Ae(he,J,ye){return{id:he.id,label:he.label,fullName:he.fullName,icon:he.icon?.id,value:he.values[0].value,insertText:he.insertText,detail:he.detail,documentation:he.documentation,command:J.toInternal(he.command,ye)}}Ee.from=Ae})(Ni||(e.ChatAgentCompletionItem=Ni={}));var It;(function(Ee){function Ae(he){return{errorDetails:he.errorDetails,metadata:he.metadata}}Ee.to=Ae})(It||(e.ChatAgentResult=It={}));var Si;(function(Ee){function Ae(he,J,ye){if(J.action.kind==="vote")return;const Be=It.to(he);if(J.action.kind==="command"){const Ze=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:ye.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:Be}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:Rt.to(J.action.followup)},result:Be}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Be}:{action:J.action,result:Be}}Ee.to=Ae})(Si||(e.ChatAgentUserActionEvent=Si={}));var Ri;(function(Ee){function Ae(he,J,ye){return"terminalCommand"in he?{terminalCommand:he.terminalCommand,shouldExecute:he.shouldExecute}:"uri"in he?{uri:he.uri}:J.toInternal(he,ye)}Ee.from=Ae})(Ri||(e.TerminalQuickFix=Ri={}));var bi;(function(Ee){function Ae(he){return{kind:Ti.to(he.kind)}}Ee.to=Ae})(bi||(e.PartialAcceptInfo=bi={}));var Ti;(function(Ee){function Ae(he){switch(he){case r.PartialAcceptTriggerKind.Word:return w.PartialAcceptTriggerKind.Word;case r.PartialAcceptTriggerKind.Line:return w.PartialAcceptTriggerKind.Line;case r.PartialAcceptTriggerKind.Suggest:return w.PartialAcceptTriggerKind.Suggest;default:return w.PartialAcceptTriggerKind.Unknown}}Ee.to=Ae})(Ti||(e.PartialAcceptTriggerKind=Ti={}));var Li;(function(Ee){function Ae(he,J){return{id:J,label:he.label,description:he.description,canEdit:he.canEdit,collapsibleState:he.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:he.contextValue}}Ee.from=Ae})(Li||(e.DebugTreeItem=Li={}));var Lt;(function(Ee){function Ae(he){return{name:he.name,description:he.description,parametersSchema:he.parametersSchema}}Ee.to=Ae})(Lt||(e.LanguageModelToolDescription=Lt={}))}),define(Oe[232],Ne([1,0,5,16,8,38]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=void 0;let R=class{constructor($,s){this.a=$.getProxy(v.$DN.MainThreadBulkEdits),this.b={getTextDocumentVersion:A=>s.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,s,A){const y=new O.$Uw(P.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,A?.isRefactoring??!1)}};e.$0oc=R,e.$0oc=R=Ge([Ve(0,I.$cQ)],R)}),define(Oe[233],Ne([1,0,17,10,42,6,39,4,40,69,14,2,18,5,8,7,115,194,24]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$oc=void 0,d=We(d),n=We(n);class i{constructor(u,m,p,h,E){this.j=u,this.k=m,this.l=p,this.m=h,this.n=E,this.b=s.$de.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let m=function(h){if(u.c){const E=new Error("Response stream has been closed");throw Error.captureStackTrace(E,h),E}};const u=this;this.b.reset();const p=(h,E)=>{if(typeof this.d>"u"&&"content"in h&&(this.d=this.b.elapsed()),E){const D=this.l.$handleProgressChunk(this.k.requestId,h),b={report:k=>{D?.then(C=>{C&&(n.$0N.isMarkdownString(k.value)?this.l.$handleProgressChunk(this.k.requestId,d.ChatResponseWarningPart.from(k),C):this.l.$handleProgressChunk(this.k.requestId,d.ChatResponseReferencePart.from(k),C))})}};Promise.all([D,E?.(b)]).then(([k,C])=>{k!==void 0&&C!==void 0&&this.l.$handleProgressChunk(this.k.requestId,d.ChatTaskResult.from(C),k)})}else this.l.$handleProgressChunk(this.k.requestId,h)};this.g={markdown(h){m(this.markdown);const E=new n.$FP(h),D=d.ChatResponseMarkdownPart.from(E);return p(D),this},markdownWithVulnerabilities(h,E){m(this.markdown),E&&(0,l.$dH)(u.j,"chatParticipantAdditions");const D=new n.$GP(h,E),b=d.ChatResponseMarkdownWithVulnerabilitiesPart.from(D);return p(b),this},filetree(h,E){m(this.filetree);const D=new n.$JP(h,E),b=d.ChatResponseFilesPart.from(D);return p(b),this},anchor(h,E){m(this.anchor);const D=new n.$KP(h,E),b=d.ChatResponseAnchorPart.from(D);return p(b),this},button(h){m(this.anchor);const E=new n.$OP(h),D=d.ChatResponseCommandButtonPart.from(E,u.m,u.n);return p(D),this},progress(h,E){m(this.progress);const D=new n.$MP(h,E),b=E?d.ChatTask.from(D):d.ChatResponseProgressPart.from(D);return p(b,E),this},warning(h){m(this.progress),(0,l.$dH)(u.j,"chatParticipantAdditions");const E=new n.$NP(h),D=d.ChatResponseWarningPart.from(E);return p(D),this},reference(h,E){if(m(this.reference),"variableName"in h&&(0,l.$dH)(u.j,"chatParticipantAdditions"),"variableName"in h&&!h.value){const D=u.k.variables.variables.find(b=>b.name===h.variableName);if(D){let b;if(D.references?.length)b=D.references.map(k=>({kind:"reference",reference:{variableName:h.variableName,value:k.reference}}));else{const k=new n.$PP(h,E);b=[d.ChatResponseReferencePart.from(k)]}return b.forEach(k=>p(k)),this}}else{const D=new n.$PP(h,E),b=d.ChatResponseReferencePart.from(D);p(b)}return this},textEdit(h,E){m(this.textEdit),(0,l.$dH)(u.j,"chatParticipantAdditions");const D=new n.$QP(h,E),b=d.ChatResponseTextEditPart.from(D);return p(b),this},detectedParticipant(h,E){m(this.detectedParticipant),(0,l.$dH)(u.j,"chatParticipantAdditions");const D=new n.$HP(h,E),b=d.ChatResponseDetectedParticipantPart.from(D);return p(b),this},confirmation(h,E,D,b){m(this.confirmation),(0,l.$dH)(u.j,"chatParticipantAdditions");const k=new n.$IP(h,E,D,b),C=d.ChatResponseConfirmationPart.from(k);return p(C),this},push(h){if(m(this.push),(h instanceof n.$QP||h instanceof n.$GP||h instanceof n.$HP||h instanceof n.$NP||h instanceof n.$IP)&&(0,l.$dH)(u.j,"chatParticipantAdditions"),h instanceof n.$PP)this.reference(h.value,h.iconPath);else{const E=d.ChatResponsePart.from(h,u.m,u.n);p(E)}return this}}}return this.g}}class r extends T.$Tc{static{this.b=0}constructor(u,m,p,h){super(),this.n=m,this.s=p,this.t=h,this.c=new Map,this.j=this.B(new T.$3c),this.m=this.B(new T.$3c),this.g=u.getProxy(S.$DN.MainThreadChatAgents2)}transferActiveChat(u){this.g.$transferActiveChatSession(u)}createChatAgent(u,m,p){const h=r.b++,E=new t(u,m,this.g,h,p);return this.c.set(h,E),this.g.$registerAgent(h,u.identifier,m,{},void 0),E.apiAgent}createDynamicChatAgent(u,m,p,h){const E=r.b++,D=new t(u,m,this.g,E,h);return this.c.set(E,D),this.g.$registerAgent(E,u.identifier,m,{isSticky:!0},p),D.apiAgent}async $invokeAgent(u,m,p,h){const E=this.c.get(u);if(!E)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);const D=(0,$.$_h)(m);let b=this.j.get(D.sessionId);b||(b=new T.$Sc,this.j.set(D.sessionId,b));const k=new i(E.extension,D,this.g,this.s.converter,b);try{const C=await this.u(D.agentId,p);let f;if(D.locationData?.type===o.ChatAgentLocation.Editor){const M=this.t.getDocument(D.locationData.document);f=new n.$TP(M,d.Selection.to(D.locationData.selection),d.Range.to(D.locationData.wholeRange))}else if(D.locationData?.type===o.ChatAgentLocation.Notebook){const M=this.t.getDocument(D.locationData.sessionInputUri);f=new n.$UP(M)}else D.locationData?.type,o.ChatAgentLocation.Terminal;const w=E.invoke(d.ChatAgentRequest.to(D,f),{history:C},k.apiObject,h);return await(0,I.$qh)(Promise.resolve(w).then(M=>{if(M?.metadata)try{JSON.stringify(M.metadata)}catch(L){const W=`result.metadata MUST be JSON.stringify-able. Got error: ${L.message}`;return this.n.error(`[${E.extension.identifier.value}] [@${E.id}] ${W}`,E.extension),{errorDetails:{message:W},timings:k.timings}}let N;return M?.errorDetails&&(N={...M.errorDetails,responseIsIncomplete:!0}),N?.responseIsRedacted&&(0,l.$dH)(E.extension,"chatParticipantPrivate"),{errorDetails:N,timings:k.timings,metadata:M?.metadata}}),h)}catch(C){return this.n.error(C,E.extension),C instanceof n.$3P&&C.cause&&(C=C.cause),{errorDetails:{message:(0,P.$nj)(C),responseIsIncomplete:!0}}}finally{k.close()}}async u(u,m){const p=[];for(const h of m.history){const E=d.ChatAgentResult.to(h.result),D=u===h.request.agentId?E:{...E,metadata:void 0};p.push(new n.$RP(h.request.message,h.request.command,h.request.variables.variables.map(d.ChatAgentValueReference.to),h.request.agentId));const b=(0,v.$Gb)(h.response.map(k=>d.ChatResponsePart.toContent(k,this.s.converter)));p.push(new n.$SP(b,D,h.request.agentId,h.request.command))}return p}$releaseSession(u){this.j.deleteAndDispose(u)}async $provideFollowups(u,m,p,h,E){const D=this.c.get(m);if(!D)return Promise.resolve([]);const b=(0,$.$_h)(u),k=await this.u(D.id,h),C=d.ChatAgentResult.to(p);return(await D.provideFollowups(C,{history:k},E)).filter(f=>{const w=!f.participant||R.Iterable.some(this.c.values(),M=>M.id===f.participant&&a.$on.equals(M.extension.identifier,D.extension.identifier));return w||this.n.warn(`[@${D.id}] ChatFollowup refers to an unknown participant: ${f.participant}`),w}).map(f=>d.ChatFollowup.from(f,b))}$acceptFeedback(u,m,p,h){const E=this.c.get(u);if(!E)return;const D=d.ChatAgentResult.to(m);let b;switch(p){case c.ChatAgentVoteDirection.Down:b=n.ChatResultFeedbackKind.Unhelpful;break;case c.ChatAgentVoteDirection.Up:b=n.ChatResultFeedbackKind.Helpful;break}E.acceptFeedback(Object.freeze(h?{result:D,kind:b,reportIssue:h}:{result:D,kind:b}))}$acceptAction(u,m,p){const h=this.c.get(u);if(!h||p.action.kind==="vote")return;const E=d.ChatAgentUserActionEvent.to(m,p,this.s.converter);E&&h.acceptAction(Object.freeze(E))}async $invokeCompletionProvider(u,m,p){const h=this.c.get(u);if(!h)return[];let E=this.m.get(u);return E?E.clear():(E=new T.$Sc,this.m.set(u,E)),(await h.invokeCompletionProvider(m,p)).map(b=>d.ChatAgentCompletionItem.from(b,this.s.converter,E))}async $provideWelcomeMessage(u,m,p){const h=this.c.get(u);if(h)return await h.provideWelcomeMessage(d.ChatLocation.to(m),p)}async $provideSampleQuestions(u,m,p){const h=this.c.get(u);if(h)return(await h.provideSampleQuestions(d.ChatLocation.to(m),p)).map(E=>d.ChatFollowup.from(E,void 0))}}e.$$oc=r;class t{constructor(u,m,p,h,E){this.extension=u,this.id=m,this.w=p,this.x=h,this.y=E,this.m=new O.$je,this.n=new O.$je}acceptFeedback(u){this.m.fire(u)}acceptAction(u){this.n.fire(u)}async invokeCompletionProvider(u,m){return this.q?await this.q.provider.provideCompletionItems(u,m)??[]:[]}async provideFollowups(u,m,p){if(!this.b)return[];const h=await this.b.provideFollowups(u,m,p);return h?h.filter(E=>!(E&&"commandId"in E)).filter(E=>!(E&&"message"in E)):[]}async provideWelcomeMessage(u,m){if(!this.s)return[];const p=await this.s.provideWelcomeMessage(u,m);return p?p.map(h=>typeof h=="string"?h:d.MarkdownString.from(h)):[]}async provideSampleQuestions(u,m){if(!this.s||!this.s.provideSampleQuestions)return[];const p=await this.s.provideSampleQuestions(u,m);return p||[]}get apiAgent(){let u=!1,m=!1;const p=()=>{u||m||(m=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof y.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof n.$EO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:d.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:d.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:d.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),m=!1}))},h=this;return{get id(){return h.id},get iconPath(){return h.c},set iconPath(E){h.c=E,p()},get requestHandler(){return h.y},set requestHandler(E){(0,A.$mg)(typeof E=="function","Invalid request handler"),h.y=E},get followupProvider(){return h.b},set followupProvider(E){h.b=E,p()},get isDefault(){return(0,l.$dH)(h.extension,"defaultChatParticipant"),h.d},set isDefault(E){(0,l.$dH)(h.extension,"defaultChatParticipant"),h.d=E,p()},get helpTextPrefix(){return(0,l.$dH)(h.extension,"defaultChatParticipant"),h.g},set helpTextPrefix(E){(0,l.$dH)(h.extension,"defaultChatParticipant"),h.g=E,p()},get helpTextVariablesPrefix(){return(0,l.$dH)(h.extension,"defaultChatParticipant"),h.j},set helpTextVariablesPrefix(E){(0,l.$dH)(h.extension,"defaultChatParticipant"),h.j=E,p()},get helpTextPostfix(){return(0,l.$dH)(h.extension,"defaultChatParticipant"),h.k},set helpTextPostfix(E){(0,l.$dH)(h.extension,"defaultChatParticipant"),h.k=E,p()},get isSecondary(){return(0,l.$dH)(h.extension,"defaultChatParticipant"),h.l},set isSecondary(E){(0,l.$dH)(h.extension,"defaultChatParticipant"),h.l=E,p()},get supportIssueReporting(){return(0,l.$dH)(h.extension,"chatParticipantPrivate"),h.o},set supportIssueReporting(E){(0,l.$dH)(h.extension,"chatParticipantPrivate"),h.o=E,p()},get onDidReceiveFeedback(){return h.m.event},set participantVariableProvider(E){if((0,l.$dH)(h.extension,"chatParticipantAdditions"),h.q=E,E){if(!E.triggerCharacters.length)throw new Error("triggerCharacters are required");h.w.$registerAgentCompletionsProvider(h.x,h.id,E.triggerCharacters)}else h.w.$unregisterAgentCompletionsProvider(h.x,h.id)},get participantVariableProvider(){return(0,l.$dH)(h.extension,"chatParticipantAdditions"),h.q},set welcomeMessageProvider(E){(0,l.$dH)(h.extension,"defaultChatParticipant"),h.s=E,p()},get welcomeMessageProvider(){return(0,l.$dH)(h.extension,"defaultChatParticipant"),h.s},onDidPerformAction:(0,l.$cH)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(E){h.t=E,p()},get requester(){return h.t},set supportsSlowReferences(E){(0,l.$dH)(h.extension,"chatParticipantPrivate"),h.u=E,p()},get supportsSlowReferences(){return(0,l.$dH)(h.extension,"chatParticipantPrivate"),h.u},dispose(){u=!0,h.b=void 0,h.m.dispose(),h.w.$unregisterAgent(h.x)}}}invoke(u,m,p,h){return this.y(u,m,p,h)}}}),define(Oe[234],Ne([1,0,13,4,34,5,8,7,24]),function(be,e,v,I,P,O,R,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=void 0,R=We(R),T=We(T);class s{static{this.a=0}constructor(a){this.b=new Map,this.c=a.getProxy(O.$DN.MainThreadChatVariables)}async $resolveVariable(a,S,d,n){const o=this.b.get(a);if(o)try{if(o.resolver.resolve2){(0,$.$dH)(o.extension,"chatParticipantAdditions");const c=new A(S,this.c),l=await o.resolver.resolve2(o.data.name,{prompt:d},c.apiObject,n);if(l&&l[0])return l[0].value}else{const c=await o.resolver.resolve(o.data.name,{prompt:d},n);if(c&&c[0])return c[0].value}}catch(c){(0,v.$Z)(c)}}registerVariableResolver(a,S,d,n,o,c,l,i,r){const t=s.a++,g=r?P.ThemeIcon.fromId(r):void 0;return this.b.set(t,{extension:a,data:{id:S,name:d,description:n,modelDescription:o,icon:g},resolver:l}),this.c.$registerVariable(t,{id:S,name:d,description:n,modelDescription:o,isSlow:c,fullName:i,icon:g}),(0,I.$Rc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$_oc=s;class A{constructor(a,S){this.c=a,this.d=S,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let S=function(n){if(a.a){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,n),o}};const a=this,d=n=>{this.d.$handleProgressChunk(this.c,n)};this.b={progress(n){S(this.progress);const o=new T.$LP(n),c=R.ChatResponseProgressPart.from(o);return d(c),this},reference(n){S(this.reference);const o=new T.$PP(n),c=R.ChatResponseReferencePart.from(o);return d(c),this},push(n){return S(this.push),n instanceof T.$PP?d(R.ChatResponseReferencePart.from(n)):n instanceof T.$LP&&d(R.ChatResponseProgressPart.from(n)),this}}}return this.b}}}),define(Oe[235],Ne([1,0,10,71,6,4,36,2,93,18,8,7,5,24]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=d,$=We($),A=We(A),y=We(y);function d(n,o,c){const l=n.getProxy(a.$DN.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new s.$qn,o.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===R.MarshalledId.CommentController){const k=this.b.get(b.handle);return k?k.value:b}else if(b&&b.$mid===R.MarshalledId.CommentThread){const k=b,C=this.b.get(k.commentControlHandle);if(!C)return k;const f=C.getCommentThread(k.commentThreadHandle);return f?f.value:k}else if(b&&(b.$mid===R.MarshalledId.CommentThreadReply||b.$mid===R.MarshalledId.CommentThreadInstance)){const k=this.b.get(b.thread.commentControlHandle);if(!k)return b;const C=k.getCommentThread(b.thread.commentThreadHandle);return C?b.$mid===R.MarshalledId.CommentThreadInstance?C.value:{thread:C.value,text:b.text}:b}else if(b&&b.$mid===R.MarshalledId.CommentNode){const k=this.b.get(b.thread.commentControlHandle);if(!k)return b;const C=k.getCommentThread(b.thread.commentThreadHandle);if(!C)return b;const f=b.commentUniqueId,w=C.getCommentByUniqueId(f);return w||b}else if(b&&b.$mid===R.MarshalledId.CommentThreadNode){const k=this.b.get(b.thread.commentControlHandle);if(!k)return b;const C=k.getCommentThread(b.thread.commentThreadHandle);if(!C)return b;const f=b.text,w=b.commentUniqueId,M=C.getCommentByUniqueId(w);return M?(typeof M.body=="string"?M.body=f:M.body=new y.$0N(f),M):b}return b}})}createCommentController(b,k,C){const f=i.a++,w=new t(b,f,k,C);this.b.set(w.handle,w);const M=this.c.get(b.identifier)||[];return M.push(w),this.c.set(b.identifier,M),w.value}async $createCommentThreadTemplate(b,k,C,f){const w=this.b.get(b);w&&w.$createCommentThreadTemplate(k,C,f)}async $setActiveComment(b,k){const C=this.b.get(b);C&&C.$setActiveComment(k??void 0)}async $updateCommentThreadTemplate(b,k,C){const f=this.b.get(b);f&&f.$updateCommentThreadTemplate(k,C)}$deleteCommentThread(b,k){this.b.get(b)?.$deleteCommentThread(k)}async $provideCommentingRanges(b,k,C){const f=this.b.get(b);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const w=await c.ensureDocumentData(T.URI.revive(k));return(0,v.$uh)(async()=>{const M=await f.commentingRangeProvider.provideCommentingRanges(w.document,C);let N;return Array.isArray(M)?N={ranges:M,fileComments:!1}:M?N={ranges:M.ranges||[],fileComments:M.enableFileComments||!1}:N=M??void 0,N}).then(M=>{let N;return M&&(N={ranges:M.ranges.map(L=>A.Range.from(L)),fileComments:M.fileComments}),N})}$toggleReaction(b,k,C,f,w){const M=this.b.get(b);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,v.$uh)(()=>{const N=M.getCommentThread(k);if(N){const L=N.getCommentByUniqueId(f.uniqueIdInThread);if(M!==void 0&&L&&M.reactionHandler)return M.reactionHandler(L,m(w))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(b){this.n=b}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(b){(b===void 0!=(this.p===void 0)||!b||!this.p||!b.isEqual(this.p))&&(this.p=b,this.b.range=b,this.c.fire())}get range(){return this.p}set canReply(b){this.d!==b&&(this.d=b,this.b.canReply=b,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(b){this.e=b,this.b.label=b,this.c.fire()}get contextValue(){return this.f}set contextValue(b){this.f=b,this.b.contextValue=b,this.c.fire()}get comments(){return this.q}set comments(b){this.q=b,this.b.comments=b,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(b){this.g=b,this.b.collapsibleState=b,this.c.fire()}get state(){return this.h}set state(b){this.h=b,typeof b=="object"?((0,S.$dH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=b.resolved,this.b.applicability=b.applicability):this.b.state=b,this.c.fire()}get isDisposed(){return this.j}constructor(b,k,C,f,w,M,N,L,W){this.m=k,this.n=C,this.o=f,this.p=w,this.q=M,this.extensionDescription=N,this.r=L,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$je,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Uc,this.l.value=new O.$Sc,this.n===void 0&&(this.n=`${b}.${this.handle}`),l.$createCommentThread(k,this.handle,this.n,this.o,A.Range.from(this.p),this.q.map(F=>g(this,F,this.k,this.extensionDescription)),N.identifier,this.r,W),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{l.$deleteCommentThread(k,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(F){G.range=F},get comments(){return G.comments},set comments(F){G.comments=F},get collapsibleState(){return G.collapsibleState},set collapsibleState(F){G.collapsibleState=F},get canReply(){return G.canReply},set canReply(F){G.canReply=F},get contextValue(){return G.contextValue},set contextValue(F){G.contextValue=F},get label(){return G.label},set label(F){G.label=F},get state(){return G.state},set state(F){G.state=F},reveal:(F,K)=>G.reveal(F,K),hide:()=>G.hide(),dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Sc);const b=C=>Object.prototype.hasOwnProperty.call(this.b,C),k={};b("range")&&(k.range=A.Range.from(this.p)),b("label")&&(k.label=this.label),b("contextValue")&&(k.contextValue=this.contextValue??null),b("comments")&&(k.comments=this.q.map(C=>g(this,C,this.k,this.extensionDescription))),b("collapsibleState")&&(k.collapseState=p(this.g)),b("canReply")&&(k.canReply=this.canReply),b("state")&&(k.state=h(this.h)),b("applicability")&&(k.applicability=E(this.h)),b("isTemplate")&&(k.isTemplate=this.r),this.b={},l.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(b){for(const k of this.k){const C=k[0],f=k[1];if(b===f)return C}}async reveal(b,k){(0,S.$dH)(this.extensionDescription,"commentReveal");let C;b&&b.body!==void 0?C=b:k=k??b;let f=C?this.k.get(C):void 0;f??=this.k.get(this.q[0]);let w=!0,M=!1;return k?.focus===y.CommentThreadFocus.Reply?(M=!0,w=!1):k?.focus===y.CommentThreadFocus.Comment&&(w=!1),l.$revealCommentThread(this.m,this.handle,f,{preserveFocus:w,focusReply:M})}async hide(){return l.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(b=>b.dispose())}}Ge([(0,I.$8h)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(b){this.b=b,b?.resourceHints&&(0,S.$dH)(this.h,"commentingRangeHint"),l.$updateCommentingRanges(this.handle,b?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(b){this.c=b,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this.d}set options(b){this.d=b,l.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,S.$dH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,S.$dH)(this.h,"activeComment"),this.f}constructor(b,k,C,f){this.h=b,this.i=k,this.j=C,this.k=f,this.a=new Map,l.$registerCommentController(this.handle,C,f,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(M){w.options=M},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(M){w.commentingRangeProvider=M},get reactionHandler(){return w.reactionHandler},set reactionHandler(M){w.reactionHandler=M},get activeCommentThread(){return w.activeCommentThread},createCommentThread(M,N,L){return w.createCommentThread(M,N,L).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}createCommentThread(b,k,C){k===void 0&&(0,S.$dH)(this.h,"fileComments");const f=new r(this.id,this.handle,void 0,b,k,C,this.h,!1);return this.a.set(f.handle,f),f}$setActiveComment(b){if(!b){this.e=void 0,this.f=void 0;return}const k=this.a.get(b.commentThreadHandle);k&&(this.e=b.uniqueIdInThread?k.getCommentByUniqueId(b.uniqueIdInThread):void 0,this.f=k)}$createCommentThreadTemplate(b,k,C){const f=new r(this.id,this.handle,void 0,T.URI.revive(b),A.Range.to(k),[],this.h,!0,C);return f.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(f.handle,f),f}$updateCommentThreadTemplate(b,k){const C=this.a.get(b);C&&(C.range=A.Range.to(k))}$deleteCommentThread(b){this.a.get(b)?.dispose(),this.a.delete(b)}getCommentThread(b){return this.a.get(b)}dispose(){this.a.forEach(b=>{b.dispose()}),this.g.forEach(b=>b.dispose())}}function g(D,b,k,C){let f=k.get(b);return f||(f=++D.commentHandle,k.set(b,f)),b.state!==void 0&&(0,S.$dH)(C,"commentsDraftState"),b.reactions?.some(w=>w.reactors!==void 0)&&(0,S.$dH)(C,"commentReactor"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:f,body:typeof b.body=="string"?b.body:A.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(w=>u(w)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function u(D){return{label:D.label,iconPath:D.iconPath?A.$bQ(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(b=>b.name):D.reactors}}function m(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?T.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(b=>({name:b}))}}function p(D){if(D!==void 0)switch(D){case y.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function h(D){let b;if(typeof D=="object"?b=D.resolved:b=D,b!==void 0)switch(b){case y.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function E(D){let b;if(typeof D=="object"&&(b=D.applicability),b!==void 0)switch(b){case y.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new i}}),define(Oe[236],Ne([1,0,21,75,4,15,23,2,8,67,79,5,7]),function(be,e,v,I,P,O,R,T,$,s,A,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vpc=void 0,$=We($),y=We(y),a=We(a);class S{constructor(u,m){this.document=u,this.b=m,this.a=1,this.c=new A.$Voc("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,m){await this.f(u).undo(),m||this.disposeBackup()}async redo(u,m){await this.f(u).redo(),m||this.disposeBackup()}disposeEdits(u){for(const m of u)this.c.delete(m)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=t(this.document.uri)+this.a++;return(0,R.$dh)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const m=this.c.get(u,0);if(!m)throw new Error("No edit found");return m}}class d{constructor(){this.a=new Map}get(u,m){return this.a.get(this.b(u,m))}add(u,m,p){const h=this.b(u,m.uri);if(this.a.has(h))throw new Error(`Document already exists for viewType:${u} resource:${m.uri}`);const E=new S(m,p);return this.a.set(h,E),E}delete(u,m){const p=this.b(u,m.uri);this.a.delete(p)}b(u,m){return`${u}@@@${m}`}}var n;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(n||(n={}));class o{constructor(){this.a=new Map}addTextProvider(u,m,p){return this.b(u,{type:n.Text,extension:m,provider:p})}addCustomProvider(u,m,p){return this.b(u,{type:n.Custom,extension:m,provider:p})}get(u){return this.a.get(u)}b(u,m){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,m),new a.$FN(()=>this.a.delete(u))}}class c{constructor(u,m,p,h,E){this.d=m,this.f=p,this.g=h,this.h=E,this.b=new o,this.c=new d,this.a=u.getProxy(y.$DN.MainThreadCustomEditors)}registerCustomEditorProvider(u,m,p,h){const E=new P.$Sc;return i(p)?(E.add(this.b.addTextProvider(m,u,p)),this.a.$registerTextEditorProvider((0,s.$spc)(u),m,h.webviewOptions||{},{supportsMove:!!p.moveCustomTextEditor},(0,s.$qpc)(u))):(E.add(this.b.addCustomProvider(m,u,p)),l(p)&&E.add(p.onDidChangeCustomDocument(D=>{const b=this.i(m,D.document.uri);if(r(D)){const k=b.addEdit(D);this.a.$onDidEdit(D.document.uri,m,k,D.label)}else this.a.$onContentChange(D.document.uri,m)})),this.a.$registerCustomEditorProvider((0,s.$spc)(u),m,h.webviewOptions||{},!!h.supportsMultipleEditorsPerDocument,(0,s.$qpc)(u))),a.$FN.from(E,new a.$FN(()=>{this.a.$unregisterEditorProvider(m)}))}async $createCustomDocument(u,m,p,h,E){const D=this.b.get(m);if(!D)throw new Error(`No provider found for '${m}'`);if(D.type!==n.Custom)throw new Error(`Invalid provide type for '${m}'`);const b=T.URI.revive(u),k=await D.provider.openCustomDocument(b,{backupId:p,untitledDocumentData:h?.buffer},E);let C;return l(D.provider)&&this.f&&(C=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(m,k,C),{editable:l(D.provider)}}async $disposeCustomDocument(u,m){const p=this.b.get(m);if(!p)throw new Error(`No provider found for '${m}'`);if(p.type!==n.Custom)throw new Error(`Invalid provider type for '${m}'`);const h=T.URI.revive(u),{document:E}=this.i(m,h);this.c.delete(m,E),E.dispose()}async $resolveCustomEditor(u,m,p,h,E,D){const b=this.b.get(p);if(!b)throw new Error(`No provider found for '${p}'`);const k=$.ViewColumn.to(E),C=this.g.createNewWebview(m,h.contentOptions,b.extension),f=this.h.createNewWebviewPanel(m,p,h.title,k,h.options,C,h.active),w=T.URI.revive(u);switch(b.type){case n.Custom:{const{document:M}=this.i(p,w);return b.provider.resolveCustomEditor(M,f,D)}case n.Text:{const M=this.d.getDocument(w);return b.provider.resolveCustomTextEditor(M,f,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,m,p){this.i(m,u).disposeEdits(p)}async $onMoveCustomEditor(u,m,p){const h=this.b.get(p);if(!h)throw new Error(`No provider found for '${p}'`);if(!h.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${p}'`);const E=this.h.getWebviewPanel(u);if(!E)throw new Error("No webview found");const D=T.URI.revive(m),b=this.d.getDocument(D);await h.provider.moveCustomTextEditor(b,E,v.CancellationToken.None)}async $undo(u,m,p,h){return this.i(m,u).undo(p,h)}async $redo(u,m,p,h){return this.i(m,u).redo(p,h)}async $revert(u,m,p){const h=this.i(m,u);await this.j(m).revertCustomDocument(h.document,p),h.disposeBackup()}async $onSave(u,m,p){const h=this.i(m,u);await this.j(m).saveCustomDocument(h.document,p),h.disposeBackup()}async $onSaveAs(u,m,p,h){const E=this.i(m,u);return this.j(m).saveCustomDocumentAs(E.document,T.URI.revive(p),h)}async $backup(u,m,p){const h=this.i(m,u),D=await this.j(m).backupCustomDocument(h.document,{destination:h.getNewBackupUri()},p);return h.updateBackup(D),D.id}i(u,m){const p=this.c.get(u,T.URI.revive(m));if(!p)throw new Error("No custom document found");return p}j(u){const p=this.b.get(u)?.provider;if(!p||!l(p))throw new Error("Custom document is not editable");return p}}e.$vpc=c;function l(g){return!!g.onDidChangeCustomDocument}function i(g){return typeof g.resolveCustomTextEditor=="function"}function r(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function t(g){const u=g.scheme===O.Schemas.file||g.scheme===O.Schemas.untitled?g.fsPath:g.toString();return(0,I.$qj)(u)+""}}),define(Oe[237],Ne([1,0,9,107,2,5,7,8,6,11,28,50]),function(be,e,v,I,P,O,R,T,$,s,A,y){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$4oc=e.$3oc=void 0,T=We(T);class S{#e;#t;#i;constructor(o,c,l,i,r,t,g,u){this.d=o,this.e=c,this.f=l,this.g=i,this.h=r,this.c=!1,this.f=Math.max(i,l),this.#i=new A.$zc(m=>t.getComparisonKey(m)),this.#e=g,this.#t=u}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,c){if(!o){this.clear();return}this.j();let l=[];if(P.URI.isUri(o)){if(!c){this.delete(o);return}this.#i.set(o,c.slice()),l=[o]}else if(Array.isArray(o)){l=[];let t;o=[...o].sort(S.k);for(const g of o){const[u,m]=g;if((!t||u.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=u,l.push(u),this.#i.set(u,[])),m)this.#i.get(u)?.push(...m);else{const p=this.#i.get(u);p&&(p.length=0)}}}if(this.#t.fire(l),!this.#e)return;const i=[];let r=0;for(const t of l){let g=[];const u=this.#i.get(t);if(u)if(u.length>this.g){g=[];const m=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let p=0;p<4;p++)for(const h of u)if(h.severity===m[p]&&g.push({...T.Diagnostic.from(h),modelVersionId:this.h(t)})===this.g)break e;g.push({severity:I.MarkerSeverity.Info,message:(0,v.localize)(10745,null,u.length-this.g),startLineNumber:g[g.length-1].startLineNumber,startColumn:g[g.length-1].startColumn,endLineNumber:g[g.length-1].endLineNumber,endColumn:g[g.length-1].endColumn})}else g=u.map(m=>({...T.Diagnostic.from(m),modelVersionId:this.h(t)}));if(i.push([t,g]),r+=g.length,r>this.f)break}this.#e.$changeMany(this.e,i)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,c){this.j();for(const[l,i]of this)o.call(c,l,i,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const c=this.#i.get(o);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,c){return o[0].toString()<c[0].toString()?-1:o[0].toString()>c[0].toString()?1:0}}e.$3oc=S;let d=class{static{a=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(o){const c=new A.$zc;for(const l of o)c.set(l,l);return{uris:Object.freeze(Array.from(c.values()))}}constructor(o,c,l,i){this.j=c,this.k=l,this.l=i,this.g=new Map,this.h=new $.$ne({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,a._mapper),this.f=o.getProxy(O.$DN.MainThreadDiagnostics)}createDiagnosticCollection(o,c){const{g:l,f:i,h:r,j:t,k:g,l:u}=this,m=new class{$changeMany(E,D){i.$changeMany(E,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,E,D.length===0?"CLEARING":D)}$clear(E){i.$clear(E),t.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,E)}dispose(){i.dispose()}};let p;if(!c)c="_generated_diagnostic_collection_name_#"+a.c++,p=c;else if(!l.has(c))p=c;else{this.j.warn(`DiagnosticCollection with name '${c}' does already exist.`);do p=c+a.c++;while(l.has(p))}return new class extends S{constructor(){super(c,p,a.e,a.d,E=>u.getDocument(E)?.version,g.extUri,m,r),l.set(p,this)}dispose(){super.dispose(),l.delete(p)}}}getDiagnostics(o){if(o)return this.m(o);{const c=new Map,l=[];for(const i of this.g.values())i.forEach((r,t)=>{let g=c.get(r.toString());typeof g>"u"&&(g=l.length,c.set(r.toString(),g),l.push([r,[]])),l[g][1]=l[g][1].concat(...t)});return l}}m(o){let c=[];for(const l of this.g.values())l.has(o)&&(c=c.concat(l.get(o)));return c}$acceptMarkersChange(o){if(!this.n){const c="_generated_mirror",l=new S(c,c,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(c,l),this.n=l}for(const[c,l]of o)this.n.set(P.URI.revive(c),l.map(T.Diagnostic.to))}};e.$4oc=d,e.$4oc=d=a=Ge([Ve(1,s.$0j),Ve(2,y.$2oc)],d)}),define(Oe[238],Ne([1,0,2,13,7,8,171,38]),function(be,e,v,I,P,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eqc=void 0;class ${constructor(A,y,a,S={timeout:1500,errors:3}){this.c=A,this.d=y,this.f=a,this.g=S,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(A){return(y,a,S)=>{const n={dispose:this.a.push([y,a,A])};return Array.isArray(S)&&S.push(n),n}}async $participateInSave(A,y){const a=v.URI.revive(A);let S=!1;const d=setTimeout(()=>S=!0,this.g.timeout),n=[];try{for(const o of[...this.a]){if(S)break;const c=this.d.getDocument(a),l=await this.h(o,{document:c,reason:O.TextDocumentSaveReason.to(y)});n.push(l)}}finally{clearTimeout(d)}return n}h([A,y,a],S){const d=this.b.get(A);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(a,A,y,S).then(()=>!0,n=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${a.identifier.value}' threw ERROR`),this.c.error(n),!(n instanceof Error)||n.message!=="concurrent_edits"){const o=this.b.get(A);this.b.set(A,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${a.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(A,y,a,S){const d=[],n=Date.now(),{document:o,reason:c}=S,{version:l}=o,i=Object.freeze({document:o,reason:c,waitUntil(r){if(Object.isFrozen(d))throw(0,I.$7)("waitUntil can not be called async");d.push(Promise.resolve(r))}});try{y.apply(a,[i])}catch(r){return Promise.reject(r)}return Object.freeze(d),new Promise((r,t)=>{const g=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(d).then(u=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-n}ms`),clearTimeout(g),r(u)}).catch(u=>{clearTimeout(g),t(u)})}).then(r=>{const t={edits:[]};for(const g of r)if(Array.isArray(g)&&g.every(u=>u instanceof P.$ON))for(const{newText:u,newEol:m,range:p}of g)t.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:p&&O.Range.from(p),text:u,eol:m&&O.EndOfLine.from(m)}});if(t.edits.length!==0)return l===o.version?this.f.$tryApplyWorkspaceEdit(new T.$Uw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$eqc=$}),define(Oe[239],Ne([1,0,6,4,2,5,123,8,14,25,7]),function(be,e,v,I,P,O,R,T,$,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5oc=void 0,T=We(T);class y{constructor(S,d){this.a=new v.$je,this.b=new v.$je,this.c=new v.$je,this.d=new v.$je,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new I.$Sc,this.h=new Map,this.f=S.getProxy(O.$DN.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(n=>{for(const o of n)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(n=>{for(const o of n)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const d=this.g.getDocument(S);if(d)return d}getDocument(S){const d=this.getDocumentData(S);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return d.document}ensureDocumentData(S){const d=this.g.getDocument(S);if(d)return Promise.resolve(d);let n=this.h.get(S.toString());return n||(n=this.f.$tryOpenDocument(S).then(o=>{this.h.delete(S.toString());const c=P.URI.revive(o);return(0,$.$ng)(this.g.getDocument(c))},o=>(this.h.delete(S.toString()),Promise.reject(o))),this.h.set(S.toString(),n)),n}createDocumentData(S){return this.f.$tryCreateDocument(S).then(d=>P.URI.revive(d))}$acceptModelLanguageChanged(S,d){const n=P.URI.revive(S),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(d),this.a.fire(o.document)}$acceptModelSaved(S){const d=P.URI.revive(S),n=this.g.getDocument(d);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(n.document)}$acceptDirtyStateChanged(S,d){const n=P.URI.revive(S),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");o._acceptIsDirty(d),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,d,n){const o=P.URI.revive(S),c=this.g.getDocument(o);if(!c)throw new Error("unknown document");c._acceptIsDirty(n),c.onEvents(d);let l;d.isUndoing?l=A.TextDocumentChangeReason.Undo:d.isRedoing&&(l=A.TextDocumentChangeReason.Redo),this.c.fire((0,s.$co)({document:c.document,contentChanges:d.changes.map(i=>({range:T.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:l}))}setWordDefinitionFor(S,d){(0,R.$eQ)(S,d)}}e.$5oc=y}),define(Oe[70],Ne([1,0,240,6,14,2,3,5,16,8,7]),function(be,e,v,I,P,O,R,T,$,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xpc=e.$wpc=void 0,s=We(s),e.$wpc=(0,R.$Ci)("IExtHostEditorTabs");class y{constructor(o,c,l){this.e=l,this.d=c,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,c={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new A.$tP(O.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new A.$uP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new A.$vP(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new A.$wP(O.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new A.$xP(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new A.$yP(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new A.$zP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new A.$AP;case T.TabInputKind.InteractiveEditorInput:return new A.$BP(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new A.$CP;case T.TabInputKind.MultiDiffEditorInput:return new A.$DP(this.b.input.diffEditors.map(o=>new A.$uP(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class a{constructor(o,c){this.c=[],this.d="",this.b=o,this.e=c;for(const l of o.tabs)l.isActive&&(this.d=l.id),this.c.push(new y(l,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,c={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return s.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(l=>l.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(l=>l.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===T.TabModelOperationKind.TAB_OPEN){const l=new y(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,l),o.tabDto.isActive&&(this.d=l.tabId),l}else if(o.kind===T.TabModelOperationKind.TAB_CLOSE){const l=this.c.splice(o.index,1)[0];if(!l)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return l.tabId===this.d&&(this.d=""),l}else if(o.kind===T.TabModelOperationKind.TAB_MOVE){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const l=this.c.splice(o.oldIndex,1)[0];if(!l)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,l),l}const c=this.c.find(l=>l.tabId===o.tabDto.id);if(!c)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(o.tabDto),c}activeTabId(){return this.d}}let S=class{constructor(o){this.b=new I.$je,this.c=new I.$je,this.e=[],this.a=o.getProxy(T.$DN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,c={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(l=>l.apiObject))},get activeTabGroup(){const l=o.d;return(0,P.$ng)(o.e.find(r=>r.groupId===l)?.apiObject)},close:async(l,i)=>{const r=Array.isArray(l)?l:[l];return r.length?d(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(o){const c=new Set(this.e.map(m=>m.groupId)),l=new Set(o.map(m=>m.groupId)),i=(0,v.$d)(c,l),r=this.e.filter(m=>i.removed.includes(m.groupId)).map(m=>m.apiObject),t=[],g=[];this.e=o.map(m=>{const p=new a(m,()=>this.d);return i.added.includes(p.groupId)?t.push(p.apiObject):g.push(p.apiObject),p});const u=(0,P.$ng)(o.find(m=>m.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:t,closed:r,changed:g}))}$acceptTabGroupUpdate(o){const c=this.e.find(l=>l.groupId===o.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const c=this.e.find(i=>i.groupId===o.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const l=c.acceptTabOperation(o);switch(o.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[l.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[l.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[l.apiObject]}));return}}g(o){for(const c of this.e)for(const l of c.tabs)if(l.apiObject===o)return l}h(o){return this.e.find(c=>c.apiObject===o)}async i(o,c){const l=[];for(const i of o){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");l.push(r.tabId)}return this.a.$closeTab(l,c)}async j(o,c){const l=[];for(const i of o){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");l.push(r.groupId)}return this.a.$closeGroup(l,c)}};e.$xpc=S,e.$xpc=S=Ge([Ve(0,$.$cQ)],S);function d(n){return n.tabs!==void 0}}),define(Oe[241],Ne([1,0,2,5,29,4,7,8,285,12,27,22,24,59]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hqc=void 0,P=We(P),T=We(T);class d{constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const l=this.a.indexOf(c);l>=0&&(this.a.splice(l,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),l=[];let i,r,t=$.State.LastKnownState,g=$.State.LastKnownState;for(const u of c){let m=i?(0,s.$Ff)(i,u):0;for(m===0?r=$.State.Start:r=g;m<u.length;m++)m+1===u.length?(t=g,g=$.State.BeforeColon):g+=1,l.push([r,u.toUpperCase().charCodeAt(m),g]),l.push([r,u.toLowerCase().charCodeAt(m),g]),r=g;i=u,g=t}l.push([$.State.BeforeColon,A.CharCode.Colon,$.State.AfterColon]),l.push([$.State.AfterColon,A.CharCode.Slash,$.State.End]),this.b=new $.$w4(l)}}provideDocumentLinks(c){this.c();const l=[],i=$.$x4.computeLinks({getLineContent(r){return c.lineAt(r-1).text},getLineCount(){return c.lineCount}},this.b);for(const r of i){const t=T.DocumentLink.to(r);t.target&&l.push(t)}return l}}class n{constructor(c,l){this.i=l,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(I.$DN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,l,i,r={}){if(n.j(i),this.d.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const t=this.h++;this.b.add(l),this.d.add(l),this.c.set(t,i);let g=P.FileSystemProviderCapabilities.FileReadWrite;r.isCaseSensitive&&(g+=P.FileSystemProviderCapabilities.PathCaseSensitive),r.isReadonly&&(g+=P.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(g+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,a.$dH)(c,"fsChunks"),g+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let u;r.isReadonly&&(0,S.$3k)(r.isReadonly)&&r.isReadonly.value!==""&&(u={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(t,l,g,u).catch(p=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${l}`),console.error(p)});const m=i.onDidChangeFile(p=>{const h=[];for(const E of p){const{uri:D,type:b}=E;if(D.scheme!==l)continue;let k;switch(b){case R.FileChangeType.Changed:k=P.FileChangeType.UPDATED;break;case R.FileChangeType.Created:k=P.FileChangeType.ADDED;break;case R.FileChangeType.Deleted:k=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:D,type:k})}this.a.$onFileSystemChange(t,h)});return(0,O.$Rc)(()=>{m.dispose(),this.b.delete(l),this.d.delete(l),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:l,ctime:i,mtime:r,size:t,permissions:g}=c;return{type:l,ctime:i,mtime:r,size:t,permissions:g}}$stat(c,l){return Promise.resolve(this.l(c).stat(v.URI.revive(l))).then(i=>n.k(i))}$readdir(c,l){return Promise.resolve(this.l(c).readDirectory(v.URI.revive(l)))}$readFile(c,l){return Promise.resolve(this.l(c).readFile(v.URI.revive(l))).then(i=>y.$Le.wrap(i))}$writeFile(c,l,i,r){return Promise.resolve(this.l(c).writeFile(v.URI.revive(l),i.buffer,r))}$delete(c,l,i){return Promise.resolve(this.l(c).delete(v.URI.revive(l),i))}$rename(c,l,i,r){return Promise.resolve(this.l(c).rename(v.URI.revive(l),v.URI.revive(i),r))}$copy(c,l,i,r){const t=this.l(c);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(v.URI.revive(l),v.URI.revive(i),r))}$mkdir(c,l){return Promise.resolve(this.l(c).createDirectory(v.URI.revive(l)))}$watch(c,l,i,r){const t=this.l(c).watch(v.URI.revive(i),r);this.f.set(l,t)}$unwatch(c,l){const i=this.f.get(l);i&&(i.dispose(),this.f.delete(l))}$open(c,l,i){const r=this.l(c);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(v.URI.revive(l),i))}$close(c,l){const i=this.l(c);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(l))}$read(c,l,i,r){const t=this.l(c);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const g=y.$Le.alloc(r);return Promise.resolve(t.read(l,i,g.buffer,0,r)).then(u=>g.slice(0,u))}$write(c,l,i,r){const t=this.l(c);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(l,i,r.buffer,0,r.byteLength))}l(c){const l=this.c.get(c);if(!l){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return l}}e.$hqc=n}),define(Oe[242],Ne([1,0,6,41,2,5,8,7,29,48]),function(be,e,v,I,P,O,R,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iqc=void 0,R=We(R);class A{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(d,n,o,c,l,i){this.a=Math.random(),this.b=new v.$je,this.c=new v.$je,this.d=new v.$je,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const r=(0,I.$xk)(l),t=typeof l=="string",g=i?.correlate,u=c(m=>{if(!(typeof m.session=="number"&&m.session!==this.a)&&!(g&&typeof m.session>"u")){if(!i?.ignoreCreateEvents)for(const p of m.created){const h=P.URI.revive(p);r(h.fsPath)&&(!t||n.getWorkspaceFolder(h))&&this.b.fire(h)}if(!i?.ignoreChangeEvents)for(const p of m.changed){const h=P.URI.revive(p);r(h.fsPath)&&(!t||n.getWorkspaceFolder(h))&&this.c.fire(h)}if(!i?.ignoreDeleteEvents)for(const p of m.deleted){const h=P.URI.revive(p);r(h.fsPath)&&(!t||n.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=T.$FN.from(this.i(d,o,l,i,i?.correlate),this.b,this.c,this.d,u)}i(d,n,o,c,l){const i=T.$FN.from();if(typeof o=="string"||c?.ignoreChangeEvents&&c?.ignoreCreateEvents&&c?.ignoreDeleteEvents)return i;const r=d.getProxy(O.$DN.MainThreadFileSystemEventService);let t=!1;(o.pattern.includes(I.$tk)||o.pattern.includes(I.$uk))&&(t=!0);let g;return l&&(c?.ignoreChangeEvents||c?.ignoreCreateEvents||c?.ignoreDeleteEvents)&&(g=$.FileChangeFilter.UPDATED|$.FileChangeFilter.ADDED|$.FileChangeFilter.DELETED,c?.ignoreChangeEvents&&(g&=~$.FileChangeFilter.UPDATED),c?.ignoreCreateEvents&&(g&=~$.FileChangeFilter.ADDED),c?.ignoreDeleteEvents&&(g&=~$.FileChangeFilter.DELETED)),r.$watch(n.identifier.value,this.a,o.baseUri,{recursive:t,excludes:c?.excludes??[],filter:g},!!l),T.$FN.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class y{constructor(d){this.a=d,this.session=this.a.session,this.b=new s.$T(()=>this.a.created.map(P.URI.revive)),this.c=new s.$T(()=>this.a.changed.map(P.URI.revive)),this.d=new s.$T(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class a{constructor(d,n,o){this.j=d,this.k=n,this.l=o,this.a=new v.$je,this.b=new v.$je,this.c=new v.$je,this.d=new v.$je,this.g=new v.$le,this.h=new v.$le,this.i=new v.$le,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(d,n,o,c){return new A(this.j,d,n,this.a.event,R.GlobPattern.from(o),c)}$onFileEvent(d){this.a.fire(new y(d))}$onDidRunFileOperation(d,n){switch(d){case $.FileOperation.MOVE:this.b.fire(Object.freeze({files:n.map(o=>({oldUri:P.URI.revive(o.source),newUri:P.URI.revive(o.target)}))}));break;case $.FileOperation.DELETE:this.d.fire(Object.freeze({files:n.map(o=>P.URI.revive(o.target))}));break;case $.FileOperation.CREATE:case $.FileOperation.COPY:this.c.fire(Object.freeze({files:n.map(o=>P.URI.revive(o.target))}));break;default:}}getOnWillRenameFileEvent(d){return this.m(d,this.g)}getOnWillCreateFileEvent(d){return this.m(d,this.h)}getOnWillDeleteFileEvent(d){return this.m(d,this.i)}m(d,n){return(o,c,l)=>{const i=function(t){o.call(c,t)};return i.extension=d,n.event(i,void 0,l)}}async $onWillRunFileOperation(d,n,o,c){switch(d){case $.FileOperation.MOVE:return await this.n(this.g,{files:n.map(l=>({oldUri:P.URI.revive(l.source),newUri:P.URI.revive(l.target)}))},o,c);case $.FileOperation.DELETE:return await this.n(this.i,{files:n.map(l=>P.URI.revive(l.target))},o,c);case $.FileOperation.CREATE:case $.FileOperation.COPY:return await this.n(this.h,{files:n.map(l=>P.URI.revive(l.target))},o,c)}}async n(d,n,o,c){const l=new Set,i=[];if(await d.fireAsync(n,c,async(t,g)=>{const u=Date.now(),m=await Promise.resolve(t);m instanceof T.$RN&&(i.push([g.extension,m]),l.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-u>o&&this.k.warn("SLOW file-participant",g.extension.identifier)}),c.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,t]of i){const{edits:g}=R.WorkspaceEdit.from(t,{getTextDocumentVersion:u=>this.l.getDocument(u)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(g)}return{edit:r,extensionNames:Array.from(l)}}}e.$iqc=a}),define(Oe[243],Ne([1,0,17,10,21,13,96,4,25,69,12,14,2,32,286,93,103,9,18,8,7,24,79,5]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l,i,r,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6oc=void 0,n=We(n),i=We(i),u=We(u);class m{constructor(U,B){this.d=U,this.e=B}async provideDocumentSymbols(U,B){const H=this.d.getDocument(U),V=await this.e.provideDocumentSymbols(H,B);if(!(0,v.$Jb)(V))return V[0]instanceof r.$2N?V.map(i.DocumentSymbol.from):m.f(V)}static f(U){U=U.slice(0).sort((V,ne)=>{let fe=V.location.range.start.compareTo(ne.location.range.start);return fe===0&&(fe=ne.location.range.end.compareTo(V.location.range.end)),fe});const B=[],H=[];for(const V of U){const ne={name:V.name||"!!MISSING: name!!",kind:i.SymbolKind.from(V.kind),tags:V.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:i.Range.from(V.location.range),selectionRange:i.Range.from(V.location.range),children:[]};for(;;){if(H.length===0){H.push(ne),B.push(ne);break}const fe=H[H.length-1];if(S.$Lt.containsRange(fe.range,ne.range)&&!S.$Lt.equalsRange(fe.range,ne.range)){fe.children?.push(ne),H.push(ne);break}H.pop()}}return B}}class p{constructor(U,B,H,V,ne,fe){this.f=U,this.g=B,this.h=H,this.j=V,this.k=ne,this.l=fe,this.d=new g.$Voc("CodeLens"),this.e=new Map}async provideCodeLenses(U,B){const H=this.f.getDocument(U),V=await this.h.provideCodeLenses(H,B);if(!V||B.isCancellationRequested)return;const ne=this.d.add(V),fe=new T.$Sc;this.e.set(ne,fe);const Ie={cacheId:ne,lenses:[]};for(let je=0;je<V.length;je++)Ie.lenses.push({cacheId:[ne,je],range:i.Range.from(V[je].range),command:this.g.toInternal(V[je].command,fe)});return Ie}async resolveCodeLens(U,B){const H=U.cacheId&&this.d.get(...U.cacheId);if(!H)return;let V;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?V=H:V=await this.h.resolveCodeLens(H,B),V||(V=H),B.isCancellationRequested)return;const ne=U.cacheId&&this.e.get(U.cacheId[0]);if(ne){if(!V.command){const fe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,fe),this.l.error(fe);return}return U.command=this.g.toInternal(V.command,ne),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function h(Te){return Array.isArray(Te)?Te.map(i.DefinitionLink.from):Te?[i.DefinitionLink.from(Te)]:[]}class E{constructor(U,B){this.d=U,this.e=B}async provideDefinition(U,B,H){const V=this.d.getDocument(U),ne=i.Position.to(B),fe=await this.e.provideDefinition(V,ne,H);return h(fe)}}class D{constructor(U,B){this.d=U,this.e=B}async provideDeclaration(U,B,H){const V=this.d.getDocument(U),ne=i.Position.to(B),fe=await this.e.provideDeclaration(V,ne,H);return h(fe)}}class b{constructor(U,B){this.d=U,this.e=B}async provideImplementation(U,B,H){const V=this.d.getDocument(U),ne=i.Position.to(B),fe=await this.e.provideImplementation(V,ne,H);return h(fe)}}class k{constructor(U,B){this.d=U,this.e=B}async provideTypeDefinition(U,B,H){const V=this.d.getDocument(U),ne=i.Position.to(B),fe=await this.e.provideTypeDefinition(V,ne,H);return h(fe)}}class C{static{this.f=10}constructor(U,B){this.g=U,this.h=B,this.d=0,this.e=new Map}async provideHover(U,B,H,V){const ne=this.g.getDocument(U),fe=i.Position.to(B);let Ie;if(H&&H.verbosityRequest){const tt=H.verbosityRequest.previousHover.id,nt=this.e.get(tt);if(!nt)throw new Error(`Hover with id ${tt} not found`);const et={verbosityDelta:H.verbosityRequest.verbosityDelta,previousHover:nt};Ie=await this.h.provideHover(ne,fe,V,et)}else Ie=await this.h.provideHover(ne,fe,V);if(!Ie||(0,v.$Jb)(Ie.contents))return;Ie.range||(Ie.range=ne.getWordRangeAtPosition(fe)),Ie.range||(Ie.range=new r.$HN(fe,fe));const je=i.Hover.from(Ie),Qe=this.d;if(this.e.size===C.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Qe,Ie),this.d+=1,{...je,id:Qe}}releaseHover(U){this.e.delete(U)}}class f{constructor(U,B){this.d=U,this.e=B}async provideEvaluatableExpression(U,B,H){const V=this.d.getDocument(U),ne=i.Position.to(B),fe=await this.e.provideEvaluatableExpression(V,ne,H);if(fe)return i.EvaluatableExpression.from(fe)}}class w{constructor(U,B){this.d=U,this.e=B}async provideInlineValues(U,B,H,V){const ne=this.d.getDocument(U),fe=await this.e.provideInlineValues(ne,i.Range.to(B),i.InlineValueContext.to(H),V);if(Array.isArray(fe))return fe.map(Ie=>i.InlineValue.from(Ie))}}class M{constructor(U,B){this.d=U,this.e=B}async provideDocumentHighlights(U,B,H){const V=this.d.getDocument(U),ne=i.Position.to(B),fe=await this.e.provideDocumentHighlights(V,ne,H);if(Array.isArray(fe))return fe.map(i.DocumentHighlight.from)}}class N{constructor(U,B){this.d=U,this.e=B}async provideMultiDocumentHighlights(U,B,H,V){const ne=this.d.getDocument(U),fe=H.map(Qe=>this.d.getDocument(Qe)),Ie=i.Position.to(B),je=await this.e.provideMultiDocumentHighlights(ne,Ie,fe,V);if(Array.isArray(je))return je.map(i.MultiDocumentHighlight.from)}}class L{constructor(U,B){this.d=U,this.e=B}async provideLinkedEditingRanges(U,B,H){const V=this.d.getDocument(U),ne=i.Position.to(B),fe=await this.e.provideLinkedEditingRanges(V,ne,H);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,v.$Gb)(fe.ranges.map(i.Range.from)),wordPattern:fe.wordPattern}}}class W{constructor(U,B){this.d=U,this.e=B}async provideReferences(U,B,H,V){const ne=this.d.getDocument(U),fe=i.Position.to(B),Ie=await this.e.provideReferences(ne,fe,H,V);if(Array.isArray(Ie))return Ie.map(i.location.from)}}class G{static{this.d=1e3}constructor(U,B,H,V,ne,fe,Ie){this.g=U,this.h=B,this.j=H,this.k=V,this.l=ne,this.m=fe,this.n=Ie,this.e=new g.$Voc("CodeAction"),this.f=new Map}async provideCodeActions(U,B,H,V){const ne=this.g.getDocument(U),fe=d.$Nt.isISelection(B)?i.Selection.to(B):i.Range.to(B),Ie=[];for(const et of this.j.getDiagnostics(U))if(fe.intersection(et.range)&&Ie.push(et)>G.d)break;const je={diagnostics:Ie,only:H.only?new r.$4N(H.only):void 0,triggerKind:i.CodeActionTriggerKind.to(H.trigger)},Qe=await this.k.provideCodeActions(ne,fe,je,V);if(!(0,v.$Kb)(Qe)||V.isCancellationRequested)return;const _e=this.e.add(Qe),tt=new T.$Sc;this.f.set(_e,tt);const nt=[];for(let et=0;et<Qe.length;et++){const rt=Qe[et];if(rt)if(G.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,tt)});else{je.only&&(rt.kind?je.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value}' requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const mt=rt.ranges??[];nt.push({cacheId:[_e,et],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,tt),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$cH)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,t.$cH)(this.m,"codeActionRanges")?(0,v.$Gb)(mt.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:_e,actions:nt}}async resolveCodeAction(U,B){const[H,V]=U,ne=this.e.get(H,V);if(!ne||G.o(ne))return{};if(!this.k.resolveCodeAction)return{};const fe=await this.k.resolveCodeAction(ne,B)??ne;let Ie;fe.edit&&(Ie=i.WorkspaceEdit.from(fe.edit,void 0));let je;if(fe.command){const Qe=this.f.get(H);Qe&&(je=this.h.toInternal(fe.command,Qe))}return{edit:Ie,command:je}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class F{constructor(U,B,H,V,ne){this.e=U,this.f=B,this.g=H,this.h=V,this.j=ne,this.d=new g.$Voc("DocumentPasteEdit")}async prepareDocumentPaste(U,B,H,V){if(!this.g.prepareDocumentPaste)return;const ne=this.f.getDocument(U),fe=B.map(Qe=>i.Range.to(Qe)),Ie=i.DataTransfer.toDataTransfer(H,()=>{throw new O.$0});if(await this.g.prepareDocumentPaste(ne,fe,Ie,V),V.isCancellationRequested)return;const je=Array.from(Ie).filter(([,Qe])=>!(Qe instanceof r.$xO));return i.DataTransfer.from(je)}async providePasteEdits(U,B,H,V,ne,fe){if(!this.g.provideDocumentPasteEdits)return[];const Ie=this.f.getDocument(B),je=H.map(nt=>i.Range.to(nt)),Qe=i.DataTransfer.toDataTransfer(V,async nt=>(await this.e.$resolvePasteFileData(this.h,U,nt)).buffer),_e=await this.g.provideDocumentPasteEdits(Ie,je,Qe,{only:ne.only?new r.$CO(ne.only):void 0,triggerKind:ne.triggerKind},fe);if(!_e||fe.isCancellationRequested)return[];const tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,c.localize)(10741,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,B){const[H,V]=U,ne=this.d.get(H,V);if(!ne||!this.g.resolveDocumentPasteEdit)return{};const fe=await this.g.resolveDocumentPasteEdit(ne,B)??ne;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class K{constructor(U,B){this.d=U,this.e=B}async provideDocumentFormattingEdits(U,B,H){const V=this.d.getDocument(U),ne=await this.e.provideDocumentFormattingEdits(V,B,H);if(Array.isArray(ne))return ne.map(i.TextEdit.from)}}class Y{constructor(U,B){this.d=U,this.e=B}async provideDocumentRangeFormattingEdits(U,B,H,V){const ne=this.d.getDocument(U),fe=i.Range.to(B),Ie=await this.e.provideDocumentRangeFormattingEdits(ne,fe,H,V);if(Array.isArray(Ie))return Ie.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,B,H,V){(0,y.$mg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ne=this.d.getDocument(U),fe=B.map(i.Range.to),Ie=await this.e.provideDocumentRangesFormattingEdits(ne,fe,H,V);if(Array.isArray(Ie))return Ie.map(i.TextEdit.from)}}class le{constructor(U,B){this.d=U,this.e=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,B,H,V,ne){const fe=this.d.getDocument(U),Ie=i.Position.to(B),je=await this.e.provideOnTypeFormattingEdits(fe,Ie,H,V,ne);if(Array.isArray(je))return je.map(i.TextEdit.from)}}class _{constructor(U,B){this.e=U,this.f=B,this.d=new g.$Voc("WorkspaceSymbols")}async provideWorkspaceSymbols(U,B){const H=await this.e.provideWorkspaceSymbols(U,B);if(!(0,v.$Kb)(H))return{symbols:[]};const V=this.d.add(H),ne={cacheId:V,symbols:[]};for(let fe=0;fe<H.length;fe++){const Ie=H[fe];if(!Ie||!Ie.name){this.f.warn("INVALID SymbolInformation",Ie);continue}ne.symbols.push({...i.WorkspaceSymbol.from(Ie),cacheId:[V,fe]})}return ne}async resolveWorkspaceSymbol(U,B){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const H=this.d.get(...U.cacheId);if(H){const V=await this.e.resolveWorkspaceSymbol(H,B);return V&&(0,$.$eo)(U,i.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class ge{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,B,H){this.d=U,this.e=B,this.f=H}async provideRenameEdits(U,B,H,V){const ne=this.d.getDocument(U),fe=i.Position.to(B);try{const Ie=await this.e.provideRenameEdits(ne,fe,H,V);return Ie?i.WorkspaceEdit.from(Ie):void 0}catch(Ie){const je=ge.g(Ie);return je?{rejectReason:je,edits:void 0}:Promise.reject(Ie)}}async resolveRenameLocation(U,B,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const V=this.d.getDocument(U),ne=i.Position.to(B);try{const fe=await this.e.prepareRename(V,ne,H);let Ie,je;if(r.$HN.isRange(fe)?(Ie=fe,je=V.getText(fe)):(0,y.$eg)(fe)&&(Ie=fe.range,je=fe.placeholder),!Ie||!je)return;if(Ie.start.line>ne.line||Ie.end.line<ne.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ie),text:je}}catch(fe){const Ie=ge.g(fe);return Ie?{rejectReason:Ie,range:void 0,text:void 0}:Promise.reject(fe)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class se{static{this.d={[n.NewSymbolNameTriggerKind.Invoke]:r.NewSymbolNameTriggerKind.Invoke,[n.NewSymbolNameTriggerKind.Automatic]:r.NewSymbolNameTriggerKind.Automatic}}constructor(U,B,H){this.e=U,this.f=B,this.g=H}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(U,B,H,V){const ne=this.e.getDocument(U),fe=i.Range.to(B);try{const Ie=se.d[H],je=await this.f.provideNewSymbolNames(ne,fe,Ie,V);return je?je.map(Qe=>typeof Qe=="string"?{newSymbolName:Qe}:{newSymbolName:Qe.newSymbolName,tags:Qe.tags}):void 0}catch(Ie){this.g.error(se.h(Ie)??JSON.stringify(Ie,null,"	"));return}}static h(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class ae{constructor(U,B){this.resultId=U,this.tokens=B}}class $e{constructor(U,B){this.f=U,this.g=B,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,B,H){const V=this.f.getDocument(U),ne=B!==0?this.d.get(B):null;let fe=typeof ne?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(V,ne.resultId,H):await this.g.provideDocumentSemanticTokens(V,H);return ne&&this.d.delete(B),fe?(fe=$e.h(fe),this.o($e.n(ne,fe),fe)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return $e.j(U)?$e.k(U)?U:new r.$3O(new Uint32Array(U.data),U.resultId):$e.l(U)?$e.m(U)?U:new r.$5O(U.edits.map(B=>new r.$4O(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const B of U.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static n(U,B){if(!$e.j(B)||!U||!U.tokens)return B;const H=U.tokens,V=H.length,ne=B.data,fe=ne.length;let Ie=0;const je=Math.min(V,fe);for(;Ie<je&&H[Ie]===ne[Ie];)Ie++;if(Ie===V&&Ie===fe)return new r.$5O([],B.resultId);let Qe=0;const _e=je-Ie;for(;Qe<_e&&H[V-Qe-1]===ne[fe-Qe-1];)Qe++;return new r.$5O([{start:Ie,deleteCount:V-Ie-Qe,data:ne.subarray(Ie,fe-Qe)}],B.resultId)}o(U,B){if($e.j(U)){const H=this.e++;return this.d.set(H,new ae(U.resultId,U.data)),(0,o.$Ndb)({id:H,type:"full",data:U.data})}if($e.l(U)){const H=this.e++;return $e.j(B)?this.d.set(H,new ae(B.resultId,B.data)):this.d.set(H,new ae(U.resultId)),(0,o.$Ndb)({id:H,type:"delta",deltas:(U.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}class oe{constructor(U,B){this.d=U,this.e=B}async provideDocumentRangeSemanticTokens(U,B,H){const V=this.d.getDocument(U),ne=await this.e.provideDocumentRangeSemanticTokens(V,i.Range.to(B),H);return ne?this.f(ne):null}f(U){return(0,o.$Ndb)({id:0,type:"full",data:U.data})}}class Ce{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,B,H,V,ne){this.f=U,this.g=B,this.h=H,this.j=V,this.k=ne,this.d=new g.$Voc("CompletionItem"),this.e=new Map}async provideCompletionItems(U,B,H,V){const ne=this.f.getDocument(U),fe=i.Position.to(B),Ie=ne.getWordRangeAtPosition(fe)||new r.$HN(fe,fe),je=Ie.with({end:fe}),Qe=new s.$de,_e=await this.h.provideCompletionItems(ne,fe,V,i.CompletionContext.to(H));if(!_e||V.isCancellationRequested)return;const tt=Array.isArray(_e)?new r.$eO(_e):_e,nt=Ce.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),et=new T.$Sc;this.e.set(nt,et);const rt=[],mt={x:nt,[u.ISuggestResultDtoField.completions]:rt,[u.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ie),insert:i.Range.from(je)},[u.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[u.ISuggestResultDtoField.duration]:Qe.elapsed()};for(let lt=0;lt<tt.items.length;lt++){const st=tt.items[lt],ct=this.l(st,[nt,lt],je,Ie);rt.push(ct)}return mt}async resolveCompletionItem(U,B){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...U);if(!H)return;const V=this.l(H,U),ne=await this.h.resolveCompletionItem(H,B);if(!ne)return;const fe=this.l(ne,U);return(V[u.ISuggestDataDtoField.insertText]!==fe[u.ISuggestDataDtoField.insertText]||V[u.ISuggestDataDtoField.insertTextRules]!==fe[u.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(V[u.ISuggestDataDtoField.commandIdent]!==fe[u.ISuggestDataDtoField.commandIdent]||V[u.ISuggestDataDtoField.commandId]!==fe[u.ISuggestDataDtoField.commandId]||!(0,$.$fo)(V[u.ISuggestDataDtoField.commandArguments],fe[u.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...V,[u.ISuggestDataDtoField.documentation]:fe[u.ISuggestDataDtoField.documentation],[u.ISuggestDataDtoField.detail]:fe[u.ISuggestDataDtoField.detail],[u.ISuggestDataDtoField.additionalTextEdits]:fe[u.ISuggestDataDtoField.additionalTextEdits],[u.ISuggestDataDtoField.insertText]:fe[u.ISuggestDataDtoField.insertText],[u.ISuggestDataDtoField.insertTextRules]:fe[u.ISuggestDataDtoField.insertTextRules],[u.ISuggestDataDtoField.commandIdent]:fe[u.ISuggestDataDtoField.commandIdent],[u.ISuggestDataDtoField.commandId]:fe[u.ISuggestDataDtoField.commandId],[u.ISuggestDataDtoField.commandArguments]:fe[u.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,B,H,V){const ne=this.e.get(B[0]);if(!ne)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(U.command,ne),Ie={x:B,[u.ISuggestDataDtoField.label]:U.label,[u.ISuggestDataDtoField.kind]:U.kind!==void 0?i.CompletionItemKind.from(U.kind):void 0,[u.ISuggestDataDtoField.kindModifier]:U.tags&&U.tags.map(i.CompletionItemTag.from),[u.ISuggestDataDtoField.detail]:U.detail,[u.ISuggestDataDtoField.documentation]:typeof U.documentation>"u"?void 0:i.MarkdownString.fromStrict(U.documentation),[u.ISuggestDataDtoField.sortText]:U.sortText!==U.label?U.sortText:void 0,[u.ISuggestDataDtoField.filterText]:U.filterText!==U.label?U.filterText:void 0,[u.ISuggestDataDtoField.preselect]:U.preselect||void 0,[u.ISuggestDataDtoField.insertTextRules]:U.keepWhitespace?n.CompletionItemInsertTextRule.KeepWhitespace:n.CompletionItemInsertTextRule.None,[u.ISuggestDataDtoField.commitCharacters]:U.commitCharacters?.join(""),[u.ISuggestDataDtoField.additionalTextEdits]:U.additionalTextEdits&&U.additionalTextEdits.map(i.TextEdit.from),[u.ISuggestDataDtoField.commandIdent]:fe?.$ident,[u.ISuggestDataDtoField.commandId]:fe?.id,[u.ISuggestDataDtoField.commandArguments]:fe?.$ident?void 0:fe?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ie[u.ISuggestDataDtoField.insertText]=U.textEdit.newText):typeof U.insertText=="string"?Ie[u.ISuggestDataDtoField.insertText]=U.insertText:U.insertText instanceof r.$SN&&(Ie[u.ISuggestDataDtoField.insertText]=U.insertText.value,Ie[u.ISuggestDataDtoField.insertTextRules]|=n.CompletionItemInsertTextRule.InsertAsSnippet);let je;return U.textEdit?je=U.textEdit.range:U.range&&(je=U.range),r.$HN.isRange(je)?Ie[u.ISuggestDataDtoField.range]=i.Range.from(je):je&&(!H?.isEqual(je.inserting)||!V?.isEqual(je.replacing))&&(Ie[u.ISuggestDataDtoField.range]={insert:i.Range.from(je.inserting),replace:i.Range.from(je.replacing)}),Ie}}class Le{async provideInlineCompletions(U,B,H,V){}async provideInlineEdits(U,B,H,V){}disposeCompletions(U){}handleDidShowCompletionItem(U,B,H){}handlePartialAccept(U,B,H,V){}}class Z extends Le{constructor(U,B,H,V){super(),this.f=U,this.g=B,this.h=H,this.j=V,this.d=new te,this.e=(0,t.$cH)(this.f,"inlineCompletionsAdditions"),this.k={[n.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[n.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$cH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,B,H,V){const ne=this.g.getDocument(U),fe=i.Position.to(B),Ie=await this.h.provideInlineCompletionItems(ne,fe,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},V);if(!Ie||V.isCancellationRequested)return;const je=Array.isArray(Ie)?Ie:Ie.items,Qe=this.e?Array.isArray(Ie)?[]:Ie.commands||[]:[],_e=this.e&&!Array.isArray(Ie)?Ie.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:je}),items:je.map((et,rt)=>{let mt;et.command&&(tt||(tt=new T.$Sc),mt=this.j.toInternal(et.command,tt));const lt=et.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:mt,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Qe.map(et=>(tt||(tt=new T.$Sc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(U,B,H,V){if(!this.h.provideInlineEdits)return;(0,t.$dH)(this.f,"inlineCompletionsAdditions");const ne=this.g.getDocument(U),fe=i.Range.to(B),Ie=await this.h.provideInlineEdits(ne,fe,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind],userPrompt:H.userPrompt},V);if(!Ie||V.isCancellationRequested)return;const je=Array.isArray(Ie)?Ie:Ie.items,Qe=this.e?Array.isArray(Ie)?[]:Ie.commands||[]:[],_e=this.e&&!Array.isArray(Ie)?Ie.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:je}),items:je.map((et,rt)=>{let mt;et.command&&(tt||(tt=new T.$Sc),mt=this.j.toInternal(et.command,tt));const lt=et.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:mt,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Qe.map(et=>(tt||(tt=new T.$Sc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,B,H){const V=this.d.get(U)?.items[B];V&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(V,H)}handlePartialAccept(U,B,H,V){const ne=this.d.get(U)?.items[B];ne&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ne,H),this.h.handleDidPartiallyAcceptCompletionItem(ne,i.PartialAcceptInfo.to(V)))}}class q{async provideInlineEdits(U,B,H){const V=this.f.getDocument(U),ne=await this.g.provideInlineEdit(V,{triggerKind:this.e[B.triggerKind]},H);if(!ne||H.isCancellationRequested)return;let fe;const Ie=this.d.createReferenceId({dispose(){fe?.dispose()},item:ne});let je;ne.accepted&&(fe||(fe=new T.$Sc),je=this.h.toInternal(ne.accepted,fe));let Qe;return ne.rejected&&(fe||(fe=new T.$Sc),Qe=this.h.toInternal(ne.rejected,fe)),{pid:Ie,text:ne.text,range:i.Range.from(ne.range),accepted:je,rejected:Qe}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,B,H,V){this.f=B,this.g=H,this.h=V,this.d=new te,this.e={[n.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[n.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class te{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const B=this.e++;return this.d.set(B,U),B}disposeReferenceId(U){const B=this.d.get(U);return this.d.delete(U),B}get(U){return this.d.get(U)}}class ve{constructor(U,B){this.e=U,this.f=B,this.d=new g.$Voc("SignatureHelp")}async provideSignatureHelp(U,B,H,V){const ne=this.e.getDocument(U),fe=i.Position.to(B),Ie=this.g(H),je=await this.f.provideSignatureHelp(ne,fe,V,Ie);if(je){const Qe=this.d.add([je]);return{...i.SignatureHelp.from(je),id:Qe}}}g(U){let B;if(U.activeSignatureHelp){const H=i.SignatureHelp.to(U.activeSignatureHelp),V=this.d.get(U.activeSignatureHelp.id,0);V?(B=V,B.activeSignature=H.activeSignature,B.activeParameter=H.activeParameter):B=H}return{...U,activeSignatureHelp:B}}releaseSignatureHelp(U){this.d.delete(U)}}class ce{constructor(U,B,H,V,ne){this.f=U,this.g=B,this.h=H,this.j=V,this.k=ne,this.d=new g.$Voc("InlayHints"),this.e=new Map}async provideInlayHints(U,B,H){const V=this.f.getDocument(U),ne=i.Range.to(B),fe=await this.h.provideInlayHints(V,ne,H);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`);return}if(H.isCancellationRequested)return;const Ie=this.d.add(fe);this.e.set(Ie,new T.$Sc);const je={hints:[],cacheId:Ie};for(let Qe=0;Qe<fe.length;Qe++)this.l(fe[Qe],ne)&&je.hints.push(this.m(fe[Qe],[Ie,Qe]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`),je}async resolveInlayHint(U,B){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...U);if(!H)return;const V=await this.h.resolveInlayHint(H,B);if(V&&this.l(V))return this.m(V,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,B){return U.label.length===0||Array.isArray(U.label)&&U.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(B&&!B.contains(U.position))}m(U,B){const H=this.e.get(B[0]);if(!H)throw Error("DisposableStore is missing...");const V={label:"",cacheId:B,tooltip:i.MarkdownString.fromStrict(U.tooltip),position:i.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(i.TextEdit.from),kind:U.kind&&i.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")V.label=U.label;else{const ne=[];V.label=ne;for(const fe of U.label){if(!fe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ie={label:fe.value,tooltip:i.MarkdownString.fromStrict(fe.tooltip)};r.$TN.isLocation(fe.location)&&(Ie.location=i.location.from(fe.location)),fe.command&&(Ie.command=this.g.toInternal(fe.command,H)),ne.push(Ie)}}return V}}class we{constructor(U,B){this.e=U,this.f=B,this.d=new g.$Voc("DocumentLink")}async provideLinks(U,B){const H=this.e.getDocument(U),V=await this.f.provideDocumentLinks(H,B);if(!(!Array.isArray(V)||V.length===0)&&!B.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:V.filter(we.g).map(i.DocumentLink.from)};{const ne=this.d.add(V),fe={links:[],cacheId:ne};for(let Ie=0;Ie<V.length;Ie++){if(!we.g(V[Ie]))continue;const je=i.DocumentLink.from(V[Ie]);je.cacheId=[ne,Ie],fe.links.push(je)}return fe}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,B){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...U);if(!H)return;const V=await this.f.resolveDocumentLink(H,B);if(!(!V||!we.g(V)))return i.DocumentLink.from(V)}releaseLinks(U){this.d.delete(U)}}class ue{constructor(U,B){this.d=U,this.e=B}async provideColors(U,B){const H=this.d.getDocument(U),V=await this.e.provideDocumentColors(H,B);return Array.isArray(V)?V.map(fe=>({color:i.Color.from(fe.color),range:i.Range.from(fe.range)})):[]}async provideColorPresentations(U,B,H){const V=this.d.getDocument(U),ne=i.Range.to(B.range),fe=i.Color.to(B.color),Ie=await this.e.provideColorPresentations(fe,{document:V,range:ne},H);if(Array.isArray(Ie))return Ie.map(i.ColorPresentation.from)}}class X{constructor(U,B){this.d=U,this.e=B}async provideFoldingRanges(U,B,H){const V=this.d.getDocument(U),ne=await this.e.provideFoldingRanges(V,B,H);if(Array.isArray(ne))return ne.map(i.FoldingRange.from)}}class x{constructor(U,B,H){this.d=U,this.e=B,this.f=H}async provideSelectionRanges(U,B,H){const V=this.d.getDocument(U),ne=B.map(i.Position.to),fe=await this.e.provideSelectionRanges(V,ne,H);if(!(0,v.$Kb)(fe))return[];if(fe.length!==ne.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ie=[];for(let je=0;je<ne.length;je++){const Qe=[];Ie.push(Qe);let _e=ne[je],tt=fe[je];for(;;){if(!tt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(i.SelectionRange.from(tt)),!tt.parent)break;_e=tt.range,tt=tt.parent}}return Ie}}class me{constructor(U,B){this.f=U,this.g=B,this.d=new R.$hQ(""),this.e=new Map}async prepareSession(U,B,H){const V=this.f.getDocument(U),ne=i.Position.to(B),fe=await this.g.prepareCallHierarchy(V,ne,H);if(!fe)return;const Ie=this.d.nextId();return this.e.set(Ie,new Map),Array.isArray(fe)?fe.map(je=>this.h(Ie,je)):[this.h(Ie,fe)]}async provideCallsTo(U,B,H){const V=this.j(U,B);if(!V)throw new Error("missing call hierarchy item");const ne=await this.g.provideCallHierarchyIncomingCalls(V,H);if(ne)return ne.map(fe=>({from:this.h(U,fe.from),fromRanges:fe.fromRanges.map(Ie=>i.Range.from(Ie))}))}async provideCallsFrom(U,B,H){const V=this.j(U,B);if(!V)throw new Error("missing call hierarchy item");const ne=await this.g.provideCallHierarchyOutgoingCalls(V,H);if(ne)return ne.map(fe=>({to:this.h(U,fe.to),fromRanges:fe.fromRanges.map(Ie=>i.Range.from(Ie))}))}releaseSession(U){this.e.delete(U)}h(U,B){const H=this.e.get(U),V=i.CallHierarchyItem.from(B,U,H.size.toString(36));return H.set(V._itemId,B),V}j(U,B){return this.e.get(U)?.get(B)}}class pe{constructor(U,B){this.f=U,this.g=B,this.d=new R.$hQ(""),this.e=new Map}async prepareSession(U,B,H){const V=this.f.getDocument(U),ne=i.Position.to(B),fe=await this.g.prepareTypeHierarchy(V,ne,H);if(!fe)return;const Ie=this.d.nextId();return this.e.set(Ie,new Map),Array.isArray(fe)?fe.map(je=>this.h(Ie,je)):[this.h(Ie,fe)]}async provideSupertypes(U,B,H){const V=this.j(U,B);if(!V)throw new Error("missing type hierarchy item");const ne=await this.g.provideTypeHierarchySupertypes(V,H);if(ne)return ne.map(fe=>this.h(U,fe))}async provideSubtypes(U,B,H){const V=this.j(U,B);if(!V)throw new Error("missing type hierarchy item");const ne=await this.g.provideTypeHierarchySubtypes(V,H);if(ne)return ne.map(fe=>this.h(U,fe))}releaseSession(U){this.e.delete(U)}h(U,B){const H=this.e.get(U),V=i.TypeHierarchyItem.from(B,U,H.size.toString(36));return H.set(V._itemId,B),V}j(U,B){return this.e.get(U)?.get(B)}}class Re{constructor(U,B,H,V,ne){this.e=U,this.f=B,this.g=H,this.h=V,this.j=ne,this.d=new g.$Voc("DocumentDropEdit")}async provideDocumentOnDropEdits(U,B,H,V,ne){const fe=this.f.getDocument(B),Ie=i.Position.to(H),je=i.DataTransfer.toDataTransfer(V,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,U,nt)).buffer),Qe=await this.g.provideDocumentDropEdits(fe,Ie,je,ne);if(!Qe)return;const _e=(0,v.$1b)(Qe),tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,c.localize)(10742,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,B){const[H,V]=U,ne=this.d.get(H,V);if(!ne||!this.g.resolveDocumentDropEdit)return{};const fe=await this.g.resolveDocumentDropEdit(ne,B)??ne;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releaseDropEdits(U){this.d.delete(U)}}class ze{constructor(U,B){this.d=U,this.e=B}async provideMappedEdits(U,B,H,V){const ne=a.URI.revive(U),fe=this.d.getDocument(ne),Ie=H.documents.map(_e=>_e.map(tt=>({uri:a.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(nt=>i.Range.to(nt))}))),je={documents:Ie,selections:Ie[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(fe,B,je,V);return Qe?i.WorkspaceEdit.from(Qe):null}}class ke{constructor(U,B){this.adapter=U,this.extension=B}}class Pe{static{this.d=0}constructor(U,B,H,V,ne,fe,Ie,je){this.g=B,this.h=H,this.j=V,this.k=ne,this.l=fe,this.m=Ie,this.n=je,this.f=new Map,this.e=U.getProxy(u.$DN.MainThreadLanguageFeatures)}o(U,B){return i.DocumentSelector.from(U,this.g,B)}p(U){return new r.$FN(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Pe.d++}async s(U,B,H,V,ne,fe=!1){const Ie=this.f.get(U);if(!Ie||!(Ie.adapter instanceof B))return V;const je=Date.now();fe||this.l.trace(`[${Ie.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Qe=H(Ie.adapter,Ie.extension);return Promise.resolve(Qe).catch(_e=>{(0,O.$3)(_e)||(this.l.error(`[${Ie.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ie.extension.identifier,_e))}).finally(()=>{fe||this.l.trace(`[${Ie.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),P.CancellationToken.isCancellationToken(ne)?(0,I.$rh)(Qe,ne):Qe}t(U,B){const H=this.q();return this.f.set(H,new ke(U,B)),H}static u(U){return U.displayName||U.name}static w(U){return U.identifier.value}registerDocumentSymbolProvider(U,B,H,V){const ne=this.t(new m(this.h,H),U),fe=V&&V.label||Pe.u(U);return this.e.$registerDocumentSymbolProvider(ne,this.o(B,U),fe),this.p(ne)}$provideDocumentSymbols(U,B,H){return this.s(U,m,V=>V.provideDocumentSymbols(a.URI.revive(B),H),void 0,H)}registerCodeLensProvider(U,B,H){const V=this.q(),ne=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(V,new ke(new p(this.h,this.j.converter,H,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(V,this.o(B,U),ne);let fe=this.p(V);if(ne!==void 0){const Ie=H.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(ne));fe=r.$FN.from(fe,Ie)}return fe}$provideCodeLenses(U,B,H){return this.s(U,p,V=>V.provideCodeLenses(a.URI.revive(B),H),void 0,H)}$resolveCodeLens(U,B,H){return this.s(U,p,V=>V.resolveCodeLens(B,H),void 0,void 0)}$releaseCodeLenses(U,B){this.s(U,p,H=>Promise.resolve(H.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(U,B,H){const V=this.t(new E(this.h,H),U);return this.e.$registerDefinitionSupport(V,this.o(B,U)),this.p(V)}$provideDefinition(U,B,H,V){return this.s(U,E,ne=>ne.provideDefinition(a.URI.revive(B),H,V),[],V)}registerDeclarationProvider(U,B,H){const V=this.t(new D(this.h,H),U);return this.e.$registerDeclarationSupport(V,this.o(B,U)),this.p(V)}$provideDeclaration(U,B,H,V){return this.s(U,D,ne=>ne.provideDeclaration(a.URI.revive(B),H,V),[],V)}registerImplementationProvider(U,B,H){const V=this.t(new b(this.h,H),U);return this.e.$registerImplementationSupport(V,this.o(B,U)),this.p(V)}$provideImplementation(U,B,H,V){return this.s(U,b,ne=>ne.provideImplementation(a.URI.revive(B),H,V),[],V)}registerTypeDefinitionProvider(U,B,H){const V=this.t(new k(this.h,H),U);return this.e.$registerTypeDefinitionSupport(V,this.o(B,U)),this.p(V)}$provideTypeDefinition(U,B,H,V){return this.s(U,k,ne=>ne.provideTypeDefinition(a.URI.revive(B),H,V),[],V)}registerHoverProvider(U,B,H,V){const ne=this.t(new C(this.h,H),U);return this.e.$registerHoverProvider(ne,this.o(B,U)),this.p(ne)}$provideHover(U,B,H,V,ne){return this.s(U,C,fe=>fe.provideHover(a.URI.revive(B),H,V,ne),void 0,ne)}$releaseHover(U,B){this.s(U,C,H=>Promise.resolve(H.releaseHover(B)),void 0,void 0)}registerEvaluatableExpressionProvider(U,B,H,V){const ne=this.t(new f(this.h,H),U);return this.e.$registerEvaluatableExpressionProvider(ne,this.o(B,U)),this.p(ne)}$provideEvaluatableExpression(U,B,H,V){return this.s(U,f,ne=>ne.provideEvaluatableExpression(a.URI.revive(B),H,V),void 0,V)}registerInlineValuesProvider(U,B,H,V){const ne=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.t(new w(this.h,H),U);this.e.$registerInlineValuesProvider(fe,this.o(B,U),ne);let Ie=this.p(fe);if(ne!==void 0){const je=H.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(ne));Ie=r.$FN.from(Ie,je)}return Ie}$provideInlineValues(U,B,H,V,ne){return this.s(U,w,fe=>fe.provideInlineValues(a.URI.revive(B),H,V,ne),void 0,ne)}registerDocumentHighlightProvider(U,B,H){const V=this.t(new M(this.h,H),U);return this.e.$registerDocumentHighlightProvider(V,this.o(B,U)),this.p(V)}registerMultiDocumentHighlightProvider(U,B,H){const V=this.t(new N(this.h,H),U);return this.e.$registerMultiDocumentHighlightProvider(V,this.o(B,U)),this.p(V)}$provideDocumentHighlights(U,B,H,V){return this.s(U,M,ne=>ne.provideDocumentHighlights(a.URI.revive(B),H,V),void 0,V)}$provideMultiDocumentHighlights(U,B,H,V,ne){return this.s(U,N,fe=>fe.provideMultiDocumentHighlights(a.URI.revive(B),H,V.map(Ie=>a.URI.revive(Ie)),ne),void 0,ne)}registerLinkedEditingRangeProvider(U,B,H){const V=this.t(new L(this.h,H),U);return this.e.$registerLinkedEditingRangeProvider(V,this.o(B,U)),this.p(V)}$provideLinkedEditingRanges(U,B,H,V){return this.s(U,L,async ne=>{const fe=await ne.provideLinkedEditingRanges(a.URI.revive(B),H,V);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?Pe.y(fe.wordPattern):void 0}},void 0,V)}registerReferenceProvider(U,B,H){const V=this.t(new W(this.h,H),U);return this.e.$registerReferenceSupport(V,this.o(B,U)),this.p(V)}$provideReferences(U,B,H,V,ne){return this.s(U,W,fe=>fe.provideReferences(a.URI.revive(B),H,V,ne),void 0,ne)}registerCodeActionProvider(U,B,H,V){const ne=new T.$Sc,fe=this.t(new G(this.h,this.j.converter,this.k,H,this.l,U,this.m),U);return this.e.$registerCodeActionSupport(fe,this.o(B,U),{providedKinds:V?.providedCodeActionKinds?.map(Ie=>Ie.value),documentation:V?.documentation?.map(Ie=>({kind:Ie.kind.value,command:this.j.converter.toInternal(Ie.command,ne)}))},Pe.u(U),Pe.w(U),!!H.resolveCodeAction),ne.add(this.p(fe)),ne}$provideCodeActions(U,B,H,V,ne){return this.s(U,G,fe=>fe.provideCodeActions(a.URI.revive(B),H,V,ne),void 0,ne)}$resolveCodeAction(U,B,H){return this.s(U,G,V=>V.resolveCodeAction(B,H),{},void 0)}$releaseCodeActions(U,B){this.s(U,G,H=>Promise.resolve(H.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(U,B,H){const V=this.t(new K(this.h,H),U);return this.e.$registerDocumentFormattingSupport(V,this.o(B,U),U.identifier,U.displayName||U.name),this.p(V)}$provideDocumentFormattingEdits(U,B,H,V){return this.s(U,K,ne=>ne.provideDocumentFormattingEdits(a.URI.revive(B),H,V),void 0,V)}registerDocumentRangeFormattingEditProvider(U,B,H){const V=typeof H.provideDocumentRangesFormattingEdits=="function",ne=this.t(new Y(this.h,H),U);return this.e.$registerRangeFormattingSupport(ne,this.o(B,U),U.identifier,U.displayName||U.name,V),this.p(ne)}$provideDocumentRangeFormattingEdits(U,B,H,V,ne){return this.s(U,Y,fe=>fe.provideDocumentRangeFormattingEdits(a.URI.revive(B),H,V,ne),void 0,ne)}$provideDocumentRangesFormattingEdits(U,B,H,V,ne){return this.s(U,Y,fe=>fe.provideDocumentRangesFormattingEdits(a.URI.revive(B),H,V,ne),void 0,ne)}registerOnTypeFormattingEditProvider(U,B,H,V){const ne=this.t(new le(this.h,H),U);return this.e.$registerOnTypeFormattingSupport(ne,this.o(B,U),V,U.identifier),this.p(ne)}$provideOnTypeFormattingEdits(U,B,H,V,ne,fe){return this.s(U,le,Ie=>Ie.provideOnTypeFormattingEdits(a.URI.revive(B),H,V,ne,fe),void 0,fe)}registerWorkspaceSymbolProvider(U,B){const H=this.t(new _(B,this.l),U);return this.e.$registerNavigateTypeSupport(H,typeof B.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(U,B,H){return this.s(U,_,V=>V.provideWorkspaceSymbols(B,H),{symbols:[]},H)}$resolveWorkspaceSymbol(U,B,H){return this.s(U,_,V=>V.resolveWorkspaceSymbol(B,H),void 0,void 0)}$releaseWorkspaceSymbols(U,B){this.s(U,_,H=>H.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(U,B,H){const V=this.t(new ge(this.h,H,this.l),U);return this.e.$registerRenameSupport(V,this.o(B,U),ge.supportsResolving(H)),this.p(V)}$provideRenameEdits(U,B,H,V,ne){return this.s(U,ge,fe=>fe.provideRenameEdits(a.URI.revive(B),H,V,ne),void 0,ne)}$resolveRenameLocation(U,B,H,V){return this.s(U,ge,ne=>ne.resolveRenameLocation(a.URI.revive(B),H,V),void 0,V)}registerNewSymbolNamesProvider(U,B,H){const V=this.t(new se(this.h,H,this.l),U);return this.e.$registerNewSymbolNamesProvider(V,this.o(B,U)),this.p(V)}$supportsAutomaticNewSymbolNamesTriggerKind(U){return this.s(U,se,B=>B.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(U,B,H,V,ne){return this.s(U,se,fe=>fe.provideNewSymbolNames(a.URI.revive(B),H,V,ne),void 0,ne)}registerDocumentSemanticTokensProvider(U,B,H,V){const ne=this.t(new $e(this.h,H),U),fe=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ne,this.o(B,U),V,fe);let Ie=this.p(ne);if(fe){const je=H.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(fe));Ie=r.$FN.from(Ie,je)}return Ie}$provideDocumentSemanticTokens(U,B,H,V){return this.s(U,$e,ne=>ne.provideDocumentSemanticTokens(a.URI.revive(B),H,V),null,V)}$releaseDocumentSemanticTokens(U,B){this.s(U,$e,H=>H.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,B,H,V){const ne=this.t(new oe(this.h,H),U);return this.e.$registerDocumentRangeSemanticTokensProvider(ne,this.o(B,U),V),this.p(ne)}$provideDocumentRangeSemanticTokens(U,B,H,V){return this.s(U,oe,ne=>ne.provideDocumentRangeSemanticTokens(a.URI.revive(B),H,V),null,V)}registerCompletionItemProvider(U,B,H,V){const ne=this.t(new Ce(this.h,this.j.converter,H,this.m,U),U);return this.e.$registerCompletionsProvider(ne,this.o(B,U),V,Ce.supportsResolving(H),U.identifier),this.p(ne)}$provideCompletionItems(U,B,H,V,ne){return this.s(U,Ce,fe=>fe.provideCompletionItems(a.URI.revive(B),H,V,ne),void 0,ne)}$resolveCompletionItem(U,B,H){return this.s(U,Ce,V=>V.resolveCompletionItem(B,H),void 0,H)}$releaseCompletionItems(U,B){this.s(U,Ce,H=>H.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(U,B,H,V){const ne=new Z(U,this.h,H,this.j.converter),fe=this.t(ne,U);return this.e.$registerInlineCompletionsSupport(fe,this.o(B,U),ne.supportsHandleEvents,l.$on.toKey(U.identifier.value),V?.yieldTo?.map(Ie=>l.$on.toKey(Ie))||[]),this.p(fe)}$provideInlineCompletions(U,B,H,V,ne){return this.s(U,Le,fe=>fe.provideInlineCompletions(a.URI.revive(B),H,V,ne),void 0,ne)}$provideInlineEdits(U,B,H,V,ne){return this.s(U,Le,fe=>fe.provideInlineEdits(a.URI.revive(B),H,V,ne),void 0,ne)}$handleInlineCompletionDidShow(U,B,H,V){this.s(U,Le,async ne=>{ne.handleDidShowCompletionItem(B,H,V)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,B,H,V,ne){this.s(U,Le,async fe=>{fe.handlePartialAccept(B,H,V,ne)},void 0,void 0)}$freeInlineCompletionsList(U,B){this.s(U,Le,async H=>{H.disposeCompletions(B)},void 0,void 0)}registerInlineEditProvider(U,B,H){const V=new q(U,this.h,H,this.j.converter),ne=this.t(V,U);return this.e.$registerInlineEditProvider(ne,this.o(B,U),U.identifier),this.p(ne)}$provideInlineEdit(U,B,H,V){return this.s(U,q,ne=>ne.provideInlineEdits(a.URI.revive(B),H,V),void 0,V)}$freeInlineEdit(U,B){this.s(U,q,async H=>{H.disposeEdit(B)},void 0,void 0)}registerSignatureHelpProvider(U,B,H,V){const ne=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,fe=this.t(new ve(this.h,H),U);return this.e.$registerSignatureHelpProvider(fe,this.o(B,U),ne),this.p(fe)}$provideSignatureHelp(U,B,H,V,ne){return this.s(U,ve,fe=>fe.provideSignatureHelp(a.URI.revive(B),H,V,ne),void 0,ne)}$releaseSignatureHelp(U,B){this.s(U,ve,H=>H.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(U,B,H){const V=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,ne=this.t(new ce(this.h,this.j.converter,H,this.l,U),U);this.e.$registerInlayHintsProvider(ne,this.o(B,U),typeof H.resolveInlayHint=="function",V,Pe.u(U));let fe=this.p(ne);if(V!==void 0){const Ie=H.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(V));fe=r.$FN.from(fe,Ie)}return fe}$provideInlayHints(U,B,H,V){return this.s(U,ce,ne=>ne.provideInlayHints(a.URI.revive(B),H,V),void 0,V)}$resolveInlayHint(U,B,H){return this.s(U,ce,V=>V.resolveInlayHint(B,H),void 0,H)}$releaseInlayHints(U,B){this.s(U,ce,H=>H.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(U,B,H){const V=this.t(new we(this.h,H),U);return this.e.$registerDocumentLinkProvider(V,this.o(B,U),typeof H.resolveDocumentLink=="function"),this.p(V)}$provideDocumentLinks(U,B,H){return this.s(U,we,V=>V.provideLinks(a.URI.revive(B),H),void 0,H,B.scheme==="output")}$resolveDocumentLink(U,B,H){return this.s(U,we,V=>V.resolveLink(B,H),void 0,void 0,!0)}$releaseDocumentLinks(U,B){this.s(U,we,H=>H.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(U,B,H){const V=this.t(new ue(this.h,H),U);return this.e.$registerDocumentColorProvider(V,this.o(B,U)),this.p(V)}$provideDocumentColors(U,B,H){return this.s(U,ue,V=>V.provideColors(a.URI.revive(B),H),[],H)}$provideColorPresentations(U,B,H,V){return this.s(U,ue,ne=>ne.provideColorPresentations(a.URI.revive(B),H,V),void 0,V)}registerFoldingRangeProvider(U,B,H){const V=this.q(),ne=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(V,new ke(new X(this.h,H),U)),this.e.$registerFoldingRangeProvider(V,this.o(B,U),U.identifier,ne);let fe=this.p(V);if(ne!==void 0){const Ie=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ne));fe=r.$FN.from(fe,Ie)}return fe}$provideFoldingRanges(U,B,H,V){return this.s(U,X,ne=>ne.provideFoldingRanges(a.URI.revive(B),H,V),void 0,V)}registerSelectionRangeProvider(U,B,H){const V=this.t(new x(this.h,H,this.l),U);return this.e.$registerSelectionRangeProvider(V,this.o(B,U)),this.p(V)}$provideSelectionRanges(U,B,H,V){return this.s(U,x,ne=>ne.provideSelectionRanges(a.URI.revive(B),H,V),[],V)}registerCallHierarchyProvider(U,B,H){const V=this.t(new me(this.h,H),U);return this.e.$registerCallHierarchyProvider(V,this.o(B,U)),this.p(V)}$prepareCallHierarchy(U,B,H,V){return this.s(U,me,ne=>Promise.resolve(ne.prepareSession(a.URI.revive(B),H,V)),void 0,V)}$provideCallHierarchyIncomingCalls(U,B,H,V){return this.s(U,me,ne=>ne.provideCallsTo(B,H,V),void 0,V)}$provideCallHierarchyOutgoingCalls(U,B,H,V){return this.s(U,me,ne=>ne.provideCallsFrom(B,H,V),void 0,V)}$releaseCallHierarchy(U,B){this.s(U,me,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(U,B,H){const V=this.t(new pe(this.h,H),U);return this.e.$registerTypeHierarchyProvider(V,this.o(B,U)),this.p(V)}$prepareTypeHierarchy(U,B,H,V){return this.s(U,pe,ne=>Promise.resolve(ne.prepareSession(a.URI.revive(B),H,V)),void 0,V)}$provideTypeHierarchySupertypes(U,B,H,V){return this.s(U,pe,ne=>ne.provideSupertypes(B,H,V),void 0,V)}$provideTypeHierarchySubtypes(U,B,H,V){return this.s(U,pe,ne=>ne.provideSubtypes(B,H,V),void 0,V)}$releaseTypeHierarchy(U,B){this.s(U,pe,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(U,B,H,V){const ne=this.q();return this.f.set(ne,new ke(new Re(this.e,this.h,H,ne,U),U)),this.e.$registerDocumentOnDropEditProvider(ne,this.o(B,U),(0,t.$cH)(U,"documentPaste")&&V?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:V.dropMimeTypes}:void 0),this.p(ne)}$provideDocumentOnDropEdits(U,B,H,V,ne,fe){return this.s(U,Re,Ie=>Promise.resolve(Ie.provideDocumentOnDropEdits(B,a.URI.revive(H),V,ne,fe)),void 0,void 0)}$resolveDropEdit(U,B,H){return this.s(U,Re,V=>V.resolveDropEdit(B,H),{},void 0)}$releaseDocumentOnDropEdits(U,B){this.s(U,Re,H=>Promise.resolve(H.releaseDropEdits(B)),void 0,void 0)}registerMappedEditsProvider(U,B,H){const V=this.t(new ze(this.h,H),U);return this.e.$registerMappedEditsProvider(V,this.o(B,U),U.displayName??U.name),this.p(V)}$provideMappedEdits(U,B,H,V,ne){return this.s(U,ze,fe=>Promise.resolve(fe.provideMappedEdits(B,H,V,ne)),null,ne)}registerDocumentPasteEditProvider(U,B,H,V){const ne=this.q();return this.f.set(ne,new ke(new F(this.e,this.h,H,ne,U),U)),this.e.$registerPasteEditProvider(ne,this.o(B,U),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:V.providedPasteEditKinds?.map(fe=>fe.value),copyMimeTypes:V.copyMimeTypes,pasteMimeTypes:V.pasteMimeTypes}),this.p(ne)}$prepareDocumentPaste(U,B,H,V,ne){return this.s(U,F,fe=>fe.prepareDocumentPaste(a.URI.revive(B),H,V,ne),void 0,ne)}$providePasteEdits(U,B,H,V,ne,fe,Ie){return this.s(U,F,je=>je.providePasteEdits(B,a.URI.revive(H),V,ne,fe,Ie),void 0,Ie)}$resolvePasteEdit(U,B,H){return this.s(U,F,V=>V.resolvePasteEdit(B,H),{},void 0)}$releasePasteEdits(U,B){this.s(U,F,H=>Promise.resolve(H.releasePasteEdits(B)),void 0,void 0)}static y(U){return{pattern:U.source,flags:U.flags}}static z(U){return{decreaseIndentPattern:Pe.y(U.decreaseIndentPattern),increaseIndentPattern:Pe.y(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Pe.y(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Pe.y(U.unIndentedLinePattern):void 0}}static B(U){return{beforeText:Pe.y(U.beforeText),afterText:U.afterText?Pe.y(U.afterText):void 0,previousLineText:U.previousLineText?Pe.y(U.previousLineText):void 0,action:U.action}}static C(U){return U.map(Pe.B)}static D(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(B=>r.SyntaxTokenType.toString(B)):void 0}}static E(U){return U.map(Pe.D)}setLanguageConfiguration(U,B,H){const{wordPattern:V}=H;if(V&&(0,A.$pf)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this.h.setWordDefinitionFor(B,V):this.h.setWordDefinitionFor(B,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ne=this.q(),fe={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Pe.y(H.wordPattern):void 0,indentationRules:H.indentationRules?Pe.z(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Pe.C(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Pe.E(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ne,B,fe),this.p(ne)}$setWordDefinitions(U){for(const B of U)this.h.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.$6oc=Pe}),define(Oe[244],Ne([1,0,4,5,8]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=void 0,P=We(P);class O{constructor(T){this.a=new Map,this.c=new Map,this.b=T.getProxy(I.$DN.MainThreadLanguageModelTools),this.b.$getTools().then($=>{for(const s of $)this.c.set(s.name,s)})}async invokeTool(T,$,s){return await this.b.$invokeTool(T,$,s)}async $acceptToolDelta(T){T.added&&this.c.set(T.added.name,T.added),T.removed&&this.c.delete(T.removed)}get tools(){return Array.from(this.c.values()).map(T=>P.LanguageModelToolDescription.to(T))}async $invokeTool(T,$,s){const A=this.a.get(T);if(!A)throw new Error(`Unknown tool ${T}`);return await A.tool.invoke($,s)}registerTool(T,$,s){return this.a.set($,{extension:T,tool:s}),this.b.$registerTool($),(0,v.$Rc)(()=>{this.a.delete($),this.b.$unregisterTool($)})}}e.$xqc=O}),define(Oe[94],Ne([1,0,10,21,42,13,6,39,4,9,18,3,11,76,5,90,16,8,7,117,24]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l,i,r){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Npc=e.$Mpc=void 0,c=We(c),l=We(l),e.$Mpc=(0,y.$Ci)("IExtHostLanguageModels");class g{constructor(h,E){this.option=h,this.stream=new v.$6h,this.stream=E??new v.$6h}}class u{constructor(){this.a=new Map,this.b=new v.$6h,this.c=!1;const h=this;this.apiObject={get stream(){return h.b.asyncIterable},get text(){return v.$3h.map(h.b.asyncIterable,E=>{if(E instanceof l.$YP)return E.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,h]of this.a)yield h.stream;else yield this.b}handleFragment(h){if(this.c)return;let E=this.a.get(h.index);E||(this.a.size===0?E=new g(h.index,this.b):E=new g(h.index),this.a.set(h.index,E));let D;h.part.type==="text"?D=new l.$YP(h.part.value):D=new l.$XP(h.part.name,h.part.parameters),E.stream.emitOne(D)}reject(h){this.c=!0;for(const E of this.d())E.reject(h)}resolve(){this.c=!0;for(const h of this.d())h.resolve()}}let m=class{static{t=this}static{this.a=1}constructor(h,E,D){this.j=E,this.k=D,this.c=new R.$je,this.d=new R.$je,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new A.$qn,this.i=new Map,this.s=new Set,this.b=h.getProxy(d.$DN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(h,E,D,b){const k=t.a++;this.f.set(k,{extension:h.identifier,provider:D,languageModelId:E});let C;b.auth&&(C={providerLabel:h.displayName||h.name,accountLabel:typeof b.auth=="object"?b.auth.label:void 0}),this.b.$registerLanguageModelProvider(k,`${A.$on.toKey(h.identifier)}/${k}/${E}`,{extension:h.identifier,id:E,vendor:b.vendor??A.$on.toKey(h.identifier),name:b.name??"",family:b.family??"",version:b.version,maxInputTokens:b.maxInputTokens,maxOutputTokens:b.maxOutputTokens,auth:C,targetExtensions:b.extensions});const f=D.onDidReceiveLanguageModelResponse2?.(({extensionId:w,participant:M,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(E,new A.$on(w),M,N)});return(0,$.$Rc)(()=>{this.f.delete(k),this.b.$unregisterProvider(k),f?.dispose()})}async $startChatRequest(h,E,D,b,k,C){const f=this.f.get(h);if(!f)throw new Error("Provider not found");const w=new S.$ww(async N=>{if(C.isCancellationRequested){this.j.warn(`[CHAT](${f.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let L;if(N.part instanceof l.$XP?L={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof l.$YP&&(L={type:"text",value:N.part.value}),!L){this.j.warn(`[CHAT](${f.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this.b.$reportResponsePart(E,{index:N.index,part:L})});let M;if(f.provider.provideLanguageModelResponse2)M=Promise.resolve(f.provider.provideLanguageModelResponse2(b.map(c.LanguageModelChatMessage.to),k,A.$on.toKey(D),w,C));else{const N=new S.$ww(async L=>{w.report({index:L.index,part:new l.$YP(L.part)})});M=Promise.resolve(f.provider.provideLanguageModelResponse(b.map(c.LanguageModelChatMessage.to),k?.modelOptions??{},A.$on.toKey(D),N,C))}M.then(()=>{this.b.$reportResponseDone(E,void 0)},N=>{this.b.$reportResponseDone(E,(0,O.$1)(N))})}$provideTokenLength(h,E,D){const b=this.f.get(h);return b?Promise.resolve(b.provider.provideTokenCount(E,D)):Promise.resolve(0)}$acceptChatModelMetadata(h){if(h.added)for(const{identifier:E,metadata:D}of h.added)this.g.set(E,{metadata:D,apiObjects:new A.$qn});if(h.removed)for(const E of h.removed){this.g.delete(E);for(const[D,b]of this.i)b.languageModelId===E&&(b.res.reject(new O.$4),this.i.delete(D))}h.added?.forEach(E=>this.q(E.metadata)),this.d.fire(void 0)}async selectLanguageModels(h,E){const D=await this.b.$selectChatModels({...E,extension:h.identifier}),b=[],k=this;for(const C of D){const f=this.g.get(C);if(!f)continue;this.o(h.identifier,f.metadata)&&await this.q(f.metadata);let w=f.apiObjects.get(h.identifier);w||(w={id:C,vendor:f.metadata.vendor,family:f.metadata.family,version:f.metadata.version,name:f.metadata.name,maxInputTokens:f.metadata.maxInputTokens,countTokens(M,N){if(!k.g.has(C))throw l.$3P.NotFound(C);return k.r(C,M,N??I.CancellationToken.None)},sendRequest(M,N,L){if(!k.g.has(C))throw l.$3P.NotFound(C);return k.l(h,C,M,N??{},L??I.CancellationToken.None)}},Object.freeze(w),f.apiObjects.set(h.identifier,w)),b.push(w)}return b}async l(h,E,D,b,k){const C=this.m(h,D),f=h.identifier,w=this.g.get(E)?.metadata;if(!w||!this.g.has(E))throw l.$3P.NotFound(`Language model '${E}' is unknown.`);if(this.o(f,w)&&(!await this.n(h,{identifier:w.extension,displayName:w.auth.providerLabel},b.justification,!1)||!this.h.get(f)?.has(w.extension)))throw l.$3P.NoPermissions(`Language model '${E}' cannot be used by '${f.value}'.`);try{const M=Math.random()*1e6|0,N=new u;this.i.set(M,{languageModelId:E,res:N});try{await this.b.$tryStartChatRequest(f,E,M,C,b,k)}catch(L){throw this.i.delete(M),L}return N.apiObject}catch(M){throw M.name===l.$3P.name?M:new l.$3P(`Language model '${E}' errored: ${(0,P.$nj)(M)}`,"Unknown",M)}}m(h,E){const D=[];for(const b of E)b.role===l.LanguageModelChatMessageRole.System&&(0,r.$dH)(h,"languageModelSystem"),b.content2 instanceof l.$VP&&(0,r.$dH)(h,"lmTools"),D.push(c.LanguageModelChatMessage.from(b));return D}async $acceptResponsePart(h,E){const D=this.i.get(h);D&&D.res.handleFragment(E)}async $acceptResponseDone(h,E){const D=this.i.get(h);D&&(this.i.delete(h),E?D.res.reject((0,O.$2)(E)):D.res.resolve())}async n(h,E,D,b){const k=i.$FM+E.identifier.value;if(await this.k.getSession(h,k,[],{silent:!0}))return this.$updateModelAccesslist([{from:h.identifier,to:E.identifier,enabled:!0}]),!0;if(b)return!1;try{const f=D?(0,s.localize)(10740,null,E.displayName,D):void 0;return await this.k.getSession(h,k,[],{forceNewSession:{detail:f}}),this.$updateModelAccesslist([{from:h.identifier,to:E.identifier,enabled:!0}]),!0}catch{return!1}}o(h,E){return!!E.auth&&!A.$on.equals(E.extension,h)}async q(h){if(h.auth)for(const E of this.s)try{await this.n(E,{identifier:h.extension,displayName:""},void 0,!0)}catch(D){this.j.error("Fake Auth request failed"),this.j.error(D)}}async r(h,E,D){if(!this.g.get(h))throw l.$3P.NotFound(`Language model '${h}' is unknown.`);const k=T.Iterable.find(this.f.values(),C=>C.languageModelId===h);return k?k.provider.provideTokenCount(E,D):this.b.$countTokens(h,typeof E=="string"?E:c.LanguageModelChatMessage.from(E),D)}$updateModelAccesslist(h){const E=new Array;for(const{from:D,to:b,enabled:k}of h){const C=this.h.get(D)??new A.$pn;if(C.has(b)!==k){k?C.add(b):C.delete(b),this.h.set(D,C);const w={from:D,to:b};E.push(w),this.c.fire(w)}}}createLanguageModelAccessInformation(h){this.s.add(h);const E=this,D=R.Event.signal(R.Event.filter(this.c.event,k=>A.$on.equals(k.from,h.identifier))),b=R.Event.signal(this.d.event);return{get onDidChange(){return R.Event.any(D,b)},canSendRequest(k){let C;e:for(const[w,M]of E.g)for(const N of M.apiObjects.values())if(N===k){C=M.metadata;break e}if(!C)return;if(!E.o(h.identifier,C))return!0;const f=E.h.get(h.identifier);if(f)return f.has(C.extension)}}}};e.$Npc=m,e.$Npc=m=t=Ge([Ve(0,o.$cQ),Ve(1,a.$0j),Ve(2,n.$8oc)],m)});var ni=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[245],Ne([1,0,5,8,7,35,10,4,24]),function(be,e,v,I,P,O,R,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=void 0,I=We(I),O=ni(O);class s{constructor(y,a,S,d){this.c=a,this.d=S,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(v.$DN.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,a){await this.a.$changeLanguage(y,a);const S=this.c.getDocumentData(y);if(!S)throw new Error(`document '${y.toString()}' NOT found`);return S.document}async tokenAtPosition(y,a){const S=y.version,d=I.Position.from(a),n=await this.a.$tokensAtPosition(y.uri,d),o={type:P.StandardTokenType.Other,range:y.getWordRangeAtPosition(a)??new P.$HN(a.line,a.character,a.line,a.character)};if(!n)return o;const c={range:I.Range.to(n.range),type:I.TokenType.to(n.type)};return!c.range.contains(a)||S!==y.version?o:c}createLanguageStatusItem(y,a,S){const d=this.f++,n=this.a,o=this.g,c=`${y.identifier.value}/${a}`;if(o.has(c))throw new Error(`LanguageStatusItem with id '${a}' ALREADY exists`);o.add(c);const l={selector:S,id:a,name:y.displayName??y.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new T.$Sc,t=()=>{if(i?.dispose(),!o.has(c)){console.warn(`LanguageStatusItem (${a}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,R.$Eh)(()=>{r.clear(),this.a.$setLanguageStatus(d,{id:c,name:l.name??y.displayName??y.name,source:y.displayName??y.name,selector:I.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===P.LanguageStatusSeverity.Error?O.default.Error:l.severity===P.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:l.command&&this.d.toInternal(l.command,r),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},g={dispose(){r.dispose(),i?.dispose(),n.$removeLanguageStatus(d),o.delete(c)},get id(){return l.id},get name(){return l.name},set name(u){l.name=u,t()},get selector(){return l.selector},set selector(u){l.selector=u,t()},get text(){return l.text},set text(u){l.text=u,t()},set text2(u){(0,$.$dH)(y,"languageStatusText"),l.text=u,t()},get text2(){return(0,$.$dH)(y,"languageStatusText"),l.text},get detail(){return l.detail},set detail(u){l.detail=u,t()},get severity(){return l.severity},set severity(u){l.severity=u,t()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(u){l.accessibilityInformation=u,t()},get command(){return l.command},set command(u){l.command=u,t()},get busy(){return l.busy},set busy(u){l.busy=u,t()}};return t(),g}}e.$yqc=s}),define(Oe[246],Ne([1,0,15,2,8,7,89]),function(be,e,v,I,P,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=e.$jqc=void 0,P=We(P),R=We(R);class T{constructor(y,a,S,d){this.start=y,this.deletedCount=a,this.deletedItems=S,this.items=d}asApiEvent(){return{range:new O.$0O(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,a,S){this.notebook=y,this.h=a,this.j=S,this.handle=S.handle,this.uri=I.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(P.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,a=this.h.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:a.document,get mime(){return y.g},set mime(d){y.g=d},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(S)}return this.f}setOutputs(y){this.a=y.map(P.NotebookCellOutput.to)}setOutputItems(y,a,S){const d=S.map(P.NotebookCellOutputItem.to),n=this.a.find(o=>o.id===y);if(n&&(a||(n.items.length=0),n.items.push(...d),n.items.length>1&&n.items.every(o=>R.$IL(o.mime)))){const o=new Map,c=[];n.items.forEach(l=>{let i;o.has(l.mime)?i=o.get(l.mime):(i=[],o.set(l.mime,i),c.push(l.mime)),i.push(l.data)}),n.items.length=0,c.forEach(l=>{const i=R.$JL(o.get(l));n.items.push({mime:l,data:i.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$jqc=$;class s{static{this.a=0}constructor(y,a,S,d,n){this.k=y,this.l=a,this.m=S,this.uri=d,this.handle=s.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,a={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===v.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(S){return S=y.n(S),y.b[S].apiCell},getCells(S){return(S?y.p(S):y.b).map(n=>n.apiCell)},save(){return y.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(a)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,a,S){this.g=y.versionId,this.h=a,this.acceptDocumentPropertiesChanged({metadata:S});const d={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},n=[];for(const c of y.rawEvents)c.kind===R.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,d.contentChanges):c.kind===R.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,d.contentChanges):c.kind===R.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),n.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===R.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),n.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),n.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===R.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),n.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),n.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const o=new Map;for(let c=0;c<n.length;c++){const l=n[c],i=o.get(l.cell);if(i===void 0){const r=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...l});o.set(l.cell,r-1)}else d.cellChanges[i]={...d.cellChanges[i],...l}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let a=y.start|0,S=y.end|0;return a<0&&(a=0),S>this.b.length&&(S=this.b.length),y.with({start:a,end:S})}p(y){y=this.o(y);const a=[];for(let S=y.start;S<y.end;S++)a.push(this.b[S]);return a}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,a,S){if(this.j)return;const d=[],n=[],o=[];if(y.reverse().forEach(c=>{const i=c[2].map(g=>{const u=new $(this,this.l,g);return a||n.push($.asModelAddData(g)),u}),r=new T(c[0],c[1],[],i),t=this.b.splice(c[0],c[1],...i);for(const g of t)o.push(g.uri),r.deletedItems.push(g.apiCell);d.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:o}),S)for(const c of d)S.push(c.asApiEvent())}s(y,a,S,d){const n=this.b.splice(y,a);this.b.splice(S,0,...n);const o=[new T(y,a,n.map(c=>c.apiCell),[]),new T(S,0,[],n)];for(const c of o)d.push(c.asApiEvent())}t(y,a){this.b[y].setOutputs(a)}u(y,a,S,d){this.b[y].setOutputItems(a,S,d)}v(y,a){const S=this.b[y];S.apiCell.document.languageId!==a&&this.m.$acceptModelLanguageChanged(S.uri,a)}w(y,a){const S=this.b[y];S.apiCell.mime=a}x(y,a){this.b[y].setMetadata(a)}y(y,a){this.b[y].setInternalMetadata(a)}getCellFromApiCell(y){return this.b.find(a=>a.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(a=>a.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$kqc=s}),define(Oe[247],Ne([1,0,6,2,8,7,38]),function(be,e,v,I,P,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aqc=void 0;class T{constructor(s,A,y,a={timeout:1500,errors:3}){this.b=s,this.c=A,this.d=y,this.f=a,this.a=new v.$le}dispose(){}getOnWillSaveNotebookDocumentEvent(s){return(A,y,a)=>{const S=function(n){A.call(y,n)};return S.extension=s,this.a.event(S,void 0,a)}}async $participateInSave(s,A,y){const a=I.URI.revive(s),S=this.c.getNotebookDocument(a);if(!S)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:S.apiNotebook,reason:P.TextDocumentSaveReason.to(A)},y,async(o,c)=>{const l=Date.now(),i=await await Promise.resolve(o);Date.now()-l>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!y.isCancellationRequested&&i&&(i instanceof O.$RN?d.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(d.length===0)return!0;const n={edits:[]};for(const o of d){const{edits:c}=P.WorkspaceEdit.from(o);n.edits=n.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(new R.$Uw(n))}}e.$Aqc=T}),define(Oe[124],Ne([1,0,13,8,7]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lqc=void 0,I=We(I),P=We(P);class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,$,s,A,y,a){this.id=T,this.f=$,this.notebookData=s,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=A,this.c=a}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection($){this.selections=[$]},get selections(){return T.a},set selections($){if(!Array.isArray($)||!$.every(P.$0O.isNotebookRange))throw(0,v.$6)("selections");T.a=$,T.g($)},get visibleRanges(){return T.b},revealRange($,s){T.f.$tryRevealRange(T.id,I.NotebookRange.from($),s??P.NotebookEditorRevealType.Default)},get viewColumn(){return T.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(I.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$lqc=O}),define(Oe[248],Ne([1,0,6,11,8]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cqc=void 0,P=We(P);let O=class{constructor(T,$){this.c=T,this.d=$,this.a=new v.$je,this.b=new v.$je,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,$);const s=this.d.getEditorById(T);$.visibleRanges&&s._acceptVisibleRanges($.visibleRanges.ranges.map(P.NotebookRange.to)),$.selections&&s._acceptSelections($.selections.selections.map(P.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:s.apiEditor,visibleRanges:s.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:s.apiEditor,selections:s.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const $ in T)this.d.getEditorById($)._acceptViewColumn(P.ViewColumn.to(T[$]))}};e.$Cqc=O,e.$Cqc=O=Ge([Ve(0,I.$0j)],O)}),define(Oe[249],Ne([1,0,6,5,124]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fqc=void 0;class O{constructor(T,$){this.c=$,this.a=new Map,this.b=T.getProxy(I.$DN.MainThreadNotebookRenderers)}$postRendererMessage(T,$,s){const A=this.c.getEditorById(T);this.a.get($)?.fire({editor:A.apiEditor,message:s})}createRendererMessaging(T,$){if(!T.contributes?.notebookRenderer?.some(A=>A.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(A,y,a)=>this.d($).event(A,y,a),postMessage:(A,y)=>{P.$lqc.apiEditorsToExtHost.has(A)&&([A,y]=[y,A]);const a=y&&P.$lqc.apiEditorsToExtHost.get(y);return this.b.$postMessage(a?.id,$,A)}}}d(T){let $=this.a.get(T);return $||($=new v.$je({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(T)}}),this.a.set(T,$),$)}}e.$Fqc=O}),define(Oe[250],Ne([1,0,8,76,21,71,13]),function(be,e,v,I,P,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jqc=void 0;class T{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,a,S){const d=this.b++,{title:n,location:o,cancellable:c}=a,l={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(d,{location:v.ProgressLocation.from(o),title:n,source:l,cancellable:c},y.isUnderDevelopment?void 0:y.identifier.value).catch(R.$Z),this.d(d,S,!!c)}d(y,a,S){let d;S&&(d=new P.$ue,this.c.set(y,d));const n=c=>{this.a.$progressEnd(c),this.c.delete(c),d?.dispose()};let o;try{o=a(new s(this.a,y),S&&d?d.token:P.CancellationToken.None)}catch(c){throw n(y),c}return o.then(c=>n(y),c=>n(y)),o}$acceptProgressCanceled(y){const a=this.c.get(y);a&&(a.cancel(),this.c.delete(y))}}e.$Jqc=T;function $(A,y){return A.message=y.message,typeof y.increment=="number"&&(typeof A.increment=="number"?A.increment+=y.increment:A.increment=y.increment),A}class s extends I.$ww{constructor(y,a){super(S=>this.throttledReport(S)),this.c=y,this.d=a}throttledReport(y){this.c.$progressReport(this.d,y)}}Ge([(0,O.$9h)(100,(A,y)=>$(A,y),()=>Object.create(null))],s.prototype,"throttledReport",null)}),define(Oe[251],Ne([1,0,2,5,10,8]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kqc=void 0;class R{static{this.a=0}constructor($,s){this.d=s,this.c=new Map,this.b=$.getProxy(I.$DN.MainThreadQuickDiff)}$provideOriginalResource($,s,A){const y=v.URI.revive(s),a=this.c.get($);return a?(0,P.$uh)(()=>a.provideOriginalResource(y,A)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider($,s,A,y){const a=R.a++;return this.c.set(a,s),this.b.$registerQuickDiffProvider(a,O.DocumentSelector.from($,this.d),A,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(a),this.c.delete(a)}}}}e.$Kqc=R});var ni=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[252],Ne([1,0,21,6,4,5,2,7,13,17,35,34,24,8]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lqc=d,A=ni(A);function d(n,o,c){const l=n.getProxy(O.$DN.MainThreadQuickOpen);class i{constructor(D,b){this.e=new Map,this.f=0,this.a=D,this.b=b}showQuickPick(D,b,k,C=v.CancellationToken.None){this.c=void 0;const f=Promise.resolve(b),w=++this.f,M=l.$show(w,{title:k?.title,placeHolder:k?.placeHolder,matchOnDescription:k?.matchOnDescription,matchOnDetail:k?.matchOnDetail,ignoreFocusLost:k?.ignoreFocusOut,canPickMany:k?.canPickMany},C),N={},L=M.then(()=>N);return Promise.race([L,f]).then(W=>{if(W===N)return;const G=(0,a.$cH)(D,"quickPickItemTooltip");return f.then(F=>{const K=[];for(let Y=0;Y<F.length;Y++){const le=F[Y];if(typeof le=="string")K.push({label:le,handle:Y});else if(le.kind===T.QuickPickItemKind.Separator)K.push({type:"separator",label:le.label});else{le.tooltip&&!G&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const _=le.iconPath?m(le.iconPath):void 0;K.push({label:le.label,iconPath:_?.iconPath,iconClass:_?.iconClass,description:le.description,detail:le.detail,picked:le.picked,alwaysShow:le.alwaysShow,tooltip:G?S.MarkdownString.fromStrict(le.tooltip):void 0,handle:Y})}}return k&&typeof k.onDidSelectItem=="function"&&(this.c=Y=>{k.onDidSelectItem(F[Y])}),l.$setItems(w,K),M.then(Y=>{if(typeof Y=="number")return F[Y];if(Array.isArray(Y))return Y.map(le=>F[le])})})}).then(void 0,W=>{if(!(0,$.$3)(W))return l.$setError(w,W),Promise.reject(W)})}$onItemSelected(D){this.c?.(D)}showInput(D,b=v.CancellationToken.None){return this.d=D?.validateInput,l.$input(D,typeof this.d=="function",b).then(void 0,k=>{if(!(0,$.$3)(k))return Promise.reject(k)})}async $validateInput(D){if(!this.d)return;const b=await this.d(D);if(!b||typeof b=="string")return b;let k;switch(b.severity){case T.InputBoxValidationSeverity.Info:k=A.default.Info;break;case T.InputBoxValidationSeverity.Warning:k=A.default.Warning;break;case T.InputBoxValidationSeverity.Error:k=A.default.Error;break;default:k=b.message?A.default.Error:A.default.Ignore;break}return{content:b.message,severity:k}}async showWorkspaceFolderPick(D,b=v.CancellationToken.None){const k=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!k)return;const C=await this.a.getWorkspaceFolders2();if(C)return C.find(f=>f.uri.toString()===k.uri.toString())}createQuickPick(D){const b=new p(D,()=>this.e.delete(b._id));return this.e.set(b._id,b),b}createInputBox(D){const b=new h(D,()=>this.e.delete(b._id));return this.e.set(b._id,b),b}$onDidChangeValue(D,b){this.e.get(D)?._fireDidChangeValue(b)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,b){const k=this.e.get(D);k instanceof p&&k._fireDidChangeActive(b)}$onDidChangeSelection(D,b){const k=this.e.get(D);k instanceof p&&k._fireDidChangeSelection(b)}$onDidTriggerButton(D,b){this.e.get(D)?._fireDidTriggerButton(b)}$onDidTriggerItemButton(D,b,k){const C=this.e.get(D);C instanceof p&&C._fireDidTriggerItemButton(b,k)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class r{static{this.a=1}constructor(D,b){this.x=D,this.y=b,this._id=p.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new I.$je,this.q=new I.$je,this.r=new I.$je,this.s=new I.$je,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){const b=(0,a.$cH)(this.x,"quickInputButtonLocation");!b&&D.some(k=>k.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=D.slice(),this.o.clear(),D.forEach((k,C)=>{const f=k===T.$7O.Back?-1:C;this.o.set(f,k)}),this.z({buttons:D.map((k,C)=>({...m(k.iconPath),tooltip:k.tooltip,handle:k===T.$7O.Back?-1:C,location:b?k.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const b=this.o.get(D);b&&this.r.fire(b)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),l.$dispose(this._id))}z(D){if(!this.v){for(const b of Object.keys(D)){const k=D[b];this.u[b]=k===void 0?null:k}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){l.$createOrUpdate(this.u),this.u={id:this._id}}}function t(E){if(E instanceof T.$EO)return{id:E.id};const D=u(E),b=g(E);return{dark:typeof D=="string"?R.URI.file(D):D,light:typeof b=="string"?R.URI.file(b):b}}function g(E){return typeof E=="object"&&"light"in E?E.light:E}function u(E){return typeof E=="object"&&"dark"in E?E.dark:E}function m(E){const D=t(E);let b,k;return"id"in D?k=y.ThemeIcon.asClassName(D):b=D,{iconPath:b,iconClass:k}}class p extends r{constructor(D,b){super(D,b),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new I.$je,this.L=[],this.M=new I.$je,this.N=new I.$je,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((C,f)=>{this.C.set(f,C),this.D.set(C,f)});const b=(0,a.$cH)(this.x,"quickPickItemTooltip"),k=[];for(let C=0;C<D.length;C++){const f=D[C];if(f.kind===T.QuickPickItemKind.Separator)k.push({type:"separator",label:f.label});else{f.tooltip&&!b&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const w=f.iconPath?m(f.iconPath):void 0;k.push({handle:C,label:f.label,iconPath:w?.iconPath,iconClass:w?.iconClass,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:b?S.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((M,N)=>({...m(M.iconPath),tooltip:M.tooltip,handle:N}))})}}this.z({items:k})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(b=>this.D.has(b)),this.z({activeItems:this.J.map(b=>this.D.get(b))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(b=>this.D.has(b)),this.z({selectedItems:this.L.map(b=>this.D.get(b))})}_fireDidChangeActive(D){const b=(0,s.$Gb)(D.map(k=>this.C.get(k)));this.J=b,this.K.fire(b)}_fireDidChangeSelection(D){const b=(0,s.$Gb)(D.map(k=>this.C.get(k)));this.L=b,this.M.fire(b)}_fireDidTriggerItemButton(D,b){const k=this.C.get(D);if(!k||!k.buttons||!k.buttons.length)return;const C=k.buttons[b];C&&this.N.fire({button:C,item:k})}}class h extends r{constructor(D,b){super(D,b),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:A.default.Error}):this.z({validationMessage:D.message,severity:D.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new i(o,c)}}),define(Oe[253],Ne([1,0,2,6,71,4,10,5,17,145,11,18,36,34,8,24,15,20]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nqc=e.$Mqc=void 0;function i(N){return N instanceof v.URI}function r(N,L){return N.scheme===o.Schemas.file&&L.scheme===o.Schemas.file&&c.$l?N.toString()===L.toString():N.toString().toLowerCase()===L.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?v.URI.file(N.iconPath):v.URI.isUri(N.iconPath)||S.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function g(N){if(N){if(v.URI.isUri(N))return N;if(S.ThemeIcon.isThemeIcon(N))return N;{const L=N;return{light:L.light,dark:L.dark}}}else return}function u(N){const L=g(N.icon),W=N.labels?.map(G=>({title:G.title,icon:g(G.icon)}));return{...N,icon:L,labels:W}}function m(N,L){if(!N.iconPath&&!L.iconPath)return 0;if(N.iconPath){if(!L.iconPath)return 1}else return-1;const W=typeof N.iconPath=="string"?N.iconPath:v.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,G=typeof L.iconPath=="string"?L.iconPath:v.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,s.$Hr)(W,G)}function p(N,L){let W=0;if(N.strikeThrough!==L.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==L.faded)return N.faded?1:-1;if(N.tooltip!==L.tooltip)return(N.tooltip||"").localeCompare(L.tooltip||"");if(W=m(N,L),W!==0)return W;if(N.light&&L.light)W=m(N.light,L.light);else{if(N.light)return 1;if(L.light)return-1}if(W!==0)return W;if(N.dark&&L.dark)W=m(N.dark,L.dark);else{if(N.dark)return 1;if(L.dark)return-1}return W}function h(N,L){if(N.command!==L.command)return N.command<L.command?-1:1;if(N.title!==L.title)return N.title<L.title?-1:1;if(N.tooltip!==L.tooltip){if(N.tooltip!==void 0&&L.tooltip!==void 0)return N.tooltip<L.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(N.arguments===L.arguments)return 0;if(N.arguments)if(L.arguments){if(N.arguments.length!==L.arguments.length)return N.arguments.length-L.arguments.length}else return 1;else return-1;for(let W=0;W<N.arguments.length;W++){const G=N.arguments[W],F=L.arguments[W];if(G!==F&&!(i(G)&&i(F)&&r(G,F)))return G<F?-1:1}return 0}function E(N,L){let W=(0,s.$Hr)(N.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(W!==0)return W;if(N.command&&L.command)W=h(N.command,L.command);else{if(N.command)return 1;if(L.command)return-1}if(W!==0)return W;if(N.decorations&&L.decorations)W=p(N.decorations,L.decorations);else{if(N.decorations)return 1;if(L.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)W=(0,s.$Hr)(N.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)W=(0,s.$Hr)(N.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return W}function D(N,L){for(let W=0;W<N.length;W++)if(N[W]!==L[W])return!1;return!0}function b(N,L){return N.command===L.command&&N.title===L.title&&N.tooltip===L.tooltip&&(N.arguments&&L.arguments?D(N.arguments,L.arguments):N.arguments===L.arguments)}function k(N,L){return(0,$.$tb)(N,L,b)}class C{#e;#t;get value(){return this.d}set value(L){L=L??"",this.#e.$setInputBoxValue(this.m,L),this.o(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){this.#e.$setInputBoxPlaceholder(this.m,L),this.f=L}get validateInput(){return(0,n.$dH)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,n.$dH)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,this.#e.$setValidationProviderIsEnabled(this.m,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,this.#e.$setInputBoxEnablement(this.m,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,this.#e.$setInputBoxVisibility(this.m,L))}get document(){return(0,n.$dH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(L,W,G,F,K){this.k=L,this.m=F,this.n=K,this.d="",this.e=new I.$je,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=G}showValidationMessage(L,W){(0,n.$dH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,L,W)}$onInputBoxValueChange(L){this.o(L)}o(L){this.d=L,this.e.fire(L)}}e.$Mqc=C;class f{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(L){this.w=L,this.s.$updateGroupLabel(this.u,this.handle,L)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(L){this.q=L,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,W,G,F,K,Y,le){this.s=L,this.t=W,this.u=G,this.v=F,this.w=K,this.multiDiffEditorEnableViewChanges=Y,this.x=le,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new I.$je,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new I.$je,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=f.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,W){const G=this.h.get(L);return G?(0,R.$uh)(()=>this.t.executeCommand(G.command,...G.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(E),G=(0,$.$Cb)(this.p,L,E).map(Y=>{const le=Y.toInsert.map(_=>{const ge=this.e++;this.g.set(ge,_);const se=_.resourceUri;let ae;if(_.command)if(_.command.command==="vscode.open"||_.command.command==="vscode.diff"||_.command.command==="vscode.changes"){const x=new O.$Sc;ae=this.t.converter.toInternal(_.command,x),this.j.set(ge,x)}else this.h.set(ge,_.command);const $e=(0,n.$cH)(this.x,"scmMultiDiffEditor"),oe=$e?_.multiDiffEditorOriginalUri:void 0,Ce=$e?_.multiFileDiffEditorModifiedUri:void 0,Le=t(_.decorations),Z=_.decorations&&t(_.decorations.light)||Le,q=_.decorations&&t(_.decorations.dark)||Le,te=[Z,q],ve=_.decorations&&_.decorations.tooltip||"",ce=_.decorations&&!!_.decorations.strikeThrough,we=_.decorations&&!!_.decorations.faded,ue=_.contextValue||"";return{rawResource:[ge,se,te,ve,ce,we,ue,ae,oe,Ce],handle:ge}});return{start:Y.start,deleteCount:Y.deleteCount,toInsert:le}}),F=G.map(({start:Y,deleteCount:le,toInsert:_})=>[Y,le,_.map(ge=>ge.rawResource)]),K=G.reverse();for(const{start:Y,deleteCount:le,toInsert:_}of K){const ge=_.map(ae=>ae.handle),se=this.o.splice(Y,le,...ge);for(const ae of se)this.g.delete(ae),this.h.delete(ae),this.j.get(ae)?.dispose(),this.j.delete(ae)}return this.p=L,F}dispose(){this.m=!0,this.n.fire()}}class w{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,this.#e.$updateSourceControl(this.x,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let W;(0,n.$cH)(this.y,"quickDiffProvider")&&(W=L?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!L,quickDiffLabel:W})}get historyProvider(){return(0,n.$dH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(L){(0,n.$dH)(this.y,"scmHistoryProvider"),this.j=L,this.k.value=new O.$Sc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.m=L?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(L){L!==this.n&&(this.n=L,this.#e.$updateSourceControl(this.x,{commitTemplate:L}))}get acceptInputCommand(){return this.p}set acceptInputCommand(L){this.o.value=new O.$Sc,this.p=L;const W=this.z.converter.toInternal(L,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:W})}get actionButton(){return(0,n.$dH)(this.y,"scmActionButton"),this.s}set actionButton(L){(0,n.$dH)(this.y,"scmActionButton"),this.q.value=new O.$Sc,this.s=L;const W=L!==void 0?{command:this.z.converter.toInternal(L.command,this.q.value),secondaryCommands:L.secondaryCommands?.map(G=>G.map(F=>this.z.converter.toInternal(F,this.q.value))),description:L.description,enabled:L.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:W??null})}get statusBarCommands(){return this.u}set statusBarCommands(L){if(this.u&&L&&k(this.u,L))return;this.t.value=new O.$Sc,this.u=L;const W=(L||[]).map(G=>this.z.converter.toInternal(G,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:W})}get selected(){return this.v}constructor(L,W,G,F,K,Y,le){this.y=L,this.z=F,this.A=K,this.B=Y,this.C=le,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Uc,this.n=void 0,this.o=new O.$Uc,this.p=void 0,this.q=new O.$Uc,this.t=new O.$Uc,this.u=void 0,this.v=!1,this.w=new I.$je,this.onDidChangeSelection=this.w.event,this.x=w.d++,this.D=new Map,this.E=new Set,this.#e=G;const _=v.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${K}/scm${this.x}/input`,query:le?`rootUri=${encodeURIComponent(le.toString())}`:void 0});this.f=new C(L,W,this.#e,this.x,_),this.#e.$registerSourceControl(this.x,K,Y,le,_)}createResourceGroup(L,W,G){const F=(0,n.$cH)(this.y,"scmMultiDiffEditor")&&G?.multiDiffEditorEnableViewChanges===!0,K=new f(this.#e,this.z,this.x,L,W,F,this.y),Y=I.Event.once(K.onDidDispose)(()=>this.D.delete(K));return this.D.set(K,Y),this.eventuallyAddResourceGroups(),K}eventuallyAddResourceGroups(){const L=[],W=[];for(const[G,F]of this.D){F.dispose();const K=G.onDidUpdateResourceStates(()=>{this.E.add(G),this.eventuallyUpdateResourceStates()});I.Event.once(G.onDidDispose)(()=>{this.E.delete(G),K.dispose(),this.e.delete(G.handle),this.#e.$unregisterGroup(this.x,G.handle)}),L.push([G.handle,G.id,G.label,G.features,G.multiDiffEditorEnableViewChanges]);const Y=G._takeResourceStateSnapshot();Y.length>0&&W.push([G.handle,Y]),this.e.set(G.handle,G)}this.#e.$registerGroups(this.x,L,W),this.D.clear()}eventuallyUpdateResourceStates(){const L=[];this.E.forEach(W=>{const G=W._takeResourceStateSnapshot();G.length!==0&&L.push([W.handle,G])}),L.length>0&&this.#e.$spliceResourceStates(this.x,L),this.E.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.v=L,this.w.fire(L)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(L=>L.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ge([(0,P.$8h)(100)],w.prototype,"eventuallyAddResourceGroups",null),Ge([(0,P.$8h)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let M=class{static{l=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(L,W,G,F){this.m=W,this.n=G,this.o=F,this.g=new Map,this.h=new y.$qn,this.j=new I.$je,this.e=L.getProxy(T.$DN.MainThreadSCM),this.f=L.getProxy(T.$DN.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:K=>{if(K&&K.$mid===a.MarshalledId.ScmResource){const Y=this.g.get(K.sourceControlHandle);if(!Y)return K;const le=Y.getResourceGroup(K.groupHandle);return le?le.getResourceState(K.handle):K}else if(K&&K.$mid===a.MarshalledId.ScmResourceGroup){const Y=this.g.get(K.sourceControlHandle);return Y?Y.getResourceGroup(K.groupHandle):K}else if(K&&K.$mid===a.MarshalledId.ScmProvider){const Y=this.g.get(K.handle);return Y||K}return K}})}createSourceControl(L,W,G,F){this.o.trace("ExtHostSCM#createSourceControl",L.identifier.value,W,G,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const K=l.d++,Y=new w(L,this.n,this.e,this.m,W,G,F);this.g.set(K,Y);const le=this.h.get(L.identifier)||[];return le.push(Y),this.h.set(L.identifier,le),Y}getLastInputBox(L){this.o.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const W=this.h.get(L.identifier),G=W&&W[W.length-1];return G&&G.inputBox}$provideOriginalResource(L,W,G){const F=v.URI.revive(W);this.o.trace("ExtHostSCM#$provideOriginalResource",L,F.toString());const K=this.g.get(L);return!K||!K.quickDiffProvider||!K.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$uh)(()=>K.quickDiffProvider.provideOriginalResource(F,G)).then(Y=>Y||null)}$onInputBoxValueChange(L,W){this.o.trace("ExtHostSCM#$onInputBoxValueChange",L);const G=this.g.get(L);return G&&G.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(L,W,G,F){this.o.trace("ExtHostSCM#$executeResourceCommand",L,W,G);const K=this.g.get(L);if(!K)return Promise.resolve(void 0);const Y=K.getResourceGroup(W);return Y?Y.$executeResourceCommand(G,F):Promise.resolve(void 0)}$validateInput(L,W,G){this.o.trace("ExtHostSCM#$validateInput",L);const F=this.g.get(L);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,R.$uh)(()=>F.inputBox.validateInput(W,G)).then(K=>{if(!K)return Promise.resolve(void 0);const Y=d.MarkdownString.fromStrict(K.message);return Y?Promise.resolve([Y,K.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,W,G,F){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,G,F)??void 0}async $resolveHistoryItemGroupCommonAncestor2(L,W,G){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(W,G)??void 0}async $provideHistoryItems(L,W,G,F){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(W,G,F))?.map(le=>u(le))??void 0}async $provideHistoryItems2(L,W,G){return(await this.g.get(L)?.historyProvider?.provideHistoryItems2(W,G))?.map(Y=>u(Y))??void 0}async $provideHistoryItemSummary(L,W,G,F){const K=this.g.get(L)?.historyProvider;if(typeof K?.provideHistoryItemSummary!="function")return;const Y=await K.provideHistoryItemSummary(W,G,F);return Y?u(Y):void 0}async $provideHistoryItemChanges(L,W,G,F){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(W,G,F)??void 0}};e.$Nqc=M,e.$Nqc=M=l=Ge([Ve(3,A.$0j)],M)}),define(Oe[254],Ne([1,0,5,8,2]),function(be,e,v,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oqc=void 0;class O{static{this.a=0}constructor(T,$){this.d=$,this.c=new Map,this.b=T.getProxy(v.$DN.MainThreadShare)}async $provideShare(T,$,s){return await this.c.get(T)?.provideShare({selection:I.Range.to($.selection),resourceUri:P.URI.revive($.resourceUri)},s)??void 0}registerShareProvider(T,$){const s=O.a++;return this.c.set(s,$),this.b.$registerShareProvider(s,I.DocumentSelector.from(T,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(s),this.c.delete(s)}}}}e.$Oqc=O}),define(Oe[255],Ne([1,0,7,5,9,4,8,14]),function(be,e,v,I,P,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rqc=e.$Qqc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new v.$FO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new v.$FO("statusBarItem.warningForeground")]])}#e;#t;constructor(a,S,d,n,o,c=v.StatusBarAlignment.Left,l){if(this.i=!1,this.k="",this.q=new O.$Sc,this.#e=a,this.#t=S,o&&n){this.c=(0,v.$hO)(n.identifier,o);const i=d.get(this.c);i&&(c=i.alignLeft?v.StatusBarAlignment.Left:v.StatusBarAlignment.Right,l=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String($.a++);this.e=n,this.f=o,this.g=c,this.h=this.u(l)}u(a){if((0,T.$gg)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(a){this.k=a,this.v()}set name(a){this.m=a,this.v()}set tooltip(a){this.l=a,this.v()}set color(a){this.n=a,this.v()}set backgroundColor(a){a&&!$.b.has(a.id)&&(a=void 0),this.o=a,this.v()}set command(a){this.r?.fromApi!==a&&(this.p&&this.q.add(this.p),this.p=new O.$Sc,typeof a=="string"?this.r={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this.p)}:a?this.r={fromApi:a,internal:this.#t.toInternal(a,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(a){this.t=a,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let a;this.e?this.f?a=`${this.e.identifier.value}.${this.f}`:a=this.e.identifier.value:a=this.f;let S;this.m?S=this.m:S=(0,P.localize)(10733,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=$.b.get(this.o.id));const n=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,a,this.e?.identifier.value,S,this.k,n,this.r?.internal,d,this.o,this.g===v.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Qqc=$;class s{constructor(a){this.b=[],this.a=a.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(10734,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(a){const S={message:a};return this.b.unshift(S),this.c(),new v.$FN(()=>{const d=this.b.indexOf(S);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(a,S){this.e=new Map,this.a=a.getProxy(I.$DN.MainThreadStatusBar),this.b=S,this.c=new s(this)}$acceptStaticEntries(a){for(const S of a)this.e.set(S.entryId,S)}createStatusBarEntry(a,S,d,n){return new $(this.a,this.b,this.e,a,S,d,n)}setStatusBarMessage(a,S){const d=this.c.setMessage(a);let n;return typeof S=="number"?n=setTimeout(()=>d.dispose(),S):typeof S<"u"&&S.then(()=>d.dispose(),()=>d.dispose()),new v.$FN(()=>{d.dispose(),clearTimeout(n)})}}e.$Rqc=A}),define(Oe[125],Ne([1,0,32,116,54,81,55,8,2]),function(be,e,v,I,P,O,R,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rQ=e.$qQ=e.$pQ=e.$oQ=void 0,v=We(v),T=We(T);const s=(i,r,t,g)=>{let u=r;return{enumerable:!0,configurable:!1,get(){return u},set(m){if(!t(u,m)){const p=u;u=m,i.listener?.(g(m,p))}}}},A=(i,r)=>i===r,y={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(i,r)=>!(i.length!==r.length||i.some(t=>!r.find(g=>t.id===g.id)))},a=i=>r=>({op:O.TestItemEventOp.SetProp,update:i(r)}),S=(i,r)=>({range:(()=>{let t;const g=a(u=>({range:v.$Lt.lift(T.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return t},set(u){i.listener?.({op:O.TestItemEventOp.DocumentSynced}),y.range(t,u)||(t=u,i.listener?.(g(u)))}}})(),label:s(i,r,y.label,a(t=>({label:t}))),description:s(i,void 0,y.description,a(t=>({description:t}))),sortText:s(i,void 0,y.sortText,a(t=>({sortText:t}))),canResolveChildren:s(i,!1,y.canResolveChildren,t=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:s(i,!1,y.busy,a(t=>({busy:t}))),error:s(i,void 0,y.error,a(t=>({error:T.MarkdownString.fromStrict(t)||null}))),tags:s(i,[],y.tags,(t,g)=>({op:O.TestItemEventOp.SetTags,new:t.map(T.TestTag.from),old:g.map(T.TestTag.from)}))}),d=i=>{const r=P.$3I.fromString(i.extId),t=new o(r.controllerId,r.localId,i.label,$.URI.revive(i.uri)||void 0);return t.range=T.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(g=>T.TestTag.to({id:(0,R.$9I)(g).tagId})),t},n=i=>{let r;for(const t of i.tests){const g=d(t.item);(0,I.$$P)(g).parent=r,r=g}return r};e.$oQ=n;class o{constructor(r,t,g,u){if(t.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const m=(0,I.$0P)(this,r);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return m.parent instanceof c?void 0:m.parent}},children:{value:(0,O.$9P)(m,I.$$P,o),enumerable:!0,writable:!1},...S(m,g)})}}e.$pQ=o;class c extends o{constructor(r,t){super(r,r,t,void 0),this._isRoot=!0}}e.$qQ=c;class l extends O.$5P{constructor(r,t,g){super({controllerId:r,getDocumentVersion:u=>u&&g.getDocument(u)?.version,getApiFor:I.$$P,getChildren:u=>u.children,root:new c(r,t),toITestItem:T.TestItem.from})}}e.$rQ=l}),define(Oe[33],Ne([1,0,14,7,8,25,5,17,11,40,32,101,2,4,3,16,125,22,38,42,69,63,66,37]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l,i,r,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CQ=e.$BQ=e.$AQ=e.$zQ=e.$yQ=e.$xQ=void 0,I=We(I),P=We(P);let m=class{#e;#t;#i;constructor(k,C,f){this.b=new Map,this.c=new Map,this.#e=k.getProxy(R.$DN.MainThreadCommands),this.d=C,this.#i=f,this.#t=k.getProxy(R.$DN.MainThreadTelemetry),this.converter=new p(this,w=>{const M=this.c.get(w);return M?.result===E.Void?M:void 0},C),this.f=[{processArgument(w){return(0,s.$_h)(w)}},{processArgument(w){return(0,O.$do)(w,function(M){if(A.$Lt.isIRange(M))return P.Range.to(M);if(y.$Kt.isIPosition(M))return P.Position.to(M);if(A.$Lt.isIRange(M.range)&&a.URI.isUri(M.uri))return P.location.to(M);if(M instanceof c.$Le)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const C=this.registerCommand(!1,k.id,async(...f)=>{const w=k.args.map((N,L)=>{if(!N.validate(f[L]))throw new Error(`Invalid argument '${N.name}' when running '${k.id}', received: ${typeof f[L]=="object"?JSON.stringify(f[L],null,"	"):f[L]} `);return N.convert(f[L])}),M=await this.executeCommand(k.internalId,...w);return k.result.convert(M,f,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new I.$FN(()=>{C.dispose(),this.c.delete(k.id)})}registerCommand(k,C,f,w,M,N){if(this.d.trace("ExtHostCommands#registerCommand",C),!C.trim().length)throw new Error("invalid id");if(this.b.has(C))throw new Error(`command '${C}' already exists`);return this.b.set(C,{callback:f,thisArg:w,metadata:M,extension:N}),k&&this.#e.$registerCommand(C),new I.$FN(()=>{this.b.delete(C)&&k&&this.#e.$unregisterCommand(C)})}executeCommand(k,...C){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,C,!0)}async g(k,C,f){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,C,!1);{let w=!1;const M=(0,O.$do)(C,function(N){if(N instanceof I.$GN)return P.Position.from(N);if(N instanceof I.$HN)return P.Range.from(N);if(N instanceof I.$TN)return P.location.from(N);if(I.$0O.isNotebookRange(N))return P.NotebookRange.from(N);if(N instanceof ArrayBuffer)return w=!0,c.$Le.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return w=!0,c.$Le.wrap(N);if(N instanceof c.$Le)return w=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(k,w?new l.$Uw(M):M,f);return(0,s.$_h)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(k,C,!1);throw N}}}async h(k,C,f){const w=this.b.get(k);if(!w)throw new Error("Unknown command");const{callback:M,thisArg:N,metadata:L}=w;if(L?.args)for(let G=0;G<L.args.length;G++)try{(0,v.$tg)(C[G],L.args[G].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${L.args[G].name}' - ${L.args[G].description}`)}const W=r.$de.create();try{return await M.apply(N,C)}catch(G){if(k===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...C);F&&(k=F.command)}if(this.d.error(G,k,w.extension?.identifier),!f)throw G;if(w.extension?.identifier){const F=this.#i.onExtensionError(w.extension.identifier,G);this.d.trace("forwarded error to extension?",F,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$nj)(G)),this.id=k,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,k,W.elapsed())}}j(k,C,f){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new t.$up(C),duration:f})}$executeContributedCommand(k,...C){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const f=this.b.get(k);return f?(C=C.map(w=>this.f.reduce((M,N)=>N.processArgument(M,f.extension?.identifier),w)),this.h(k,C,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(C=>(k&&(C=C.filter(f=>f[0]!=="_")),C))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[C,f]of this.b){const{metadata:w}=f;w&&(k[C]=w)}return Promise.resolve(k)}};e.$xQ=m,e.$xQ=m=Ge([Ve(0,n.$cQ),Ve(1,$.$0j),Ve(2,g.$wQ)],m),e.$yQ=(0,d.$Ci)("IExtHostCommands");class p{constructor(k,C,f){this.d=k,this.f=C,this.g=f,this.delegatingCommandId=`__vsc${(0,u.$Yg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,C){if(!k)return;const f={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return f;const w=this.f(k.command);if(w)f.id=w.internalId,f.arguments=w.args.map((M,N)=>M.convert(k.arguments&&k.arguments[N]));else if((0,T.$Kb)(k.arguments)){const M=`${k.command} /${++this.c}`;this.b.set(M,k),C.add((0,S.$Rc)(()=>{this.b.delete(M),this.g.trace("CommandsConverter#DISPOSE",M)})),f.$ident=M,f.id=this.delegatingCommandId,f.arguments=[M],this.g.trace("CommandsConverter#CREATE",k.command,M)}return f}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const C=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],C?C.command:"MISSING"),C?this.d.executeCommand(C.command,...C.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$zQ=p;class h{static{this.Uri=new h("uri","Uri of a text document",k=>a.URI.isUri(k),k=>k)}static{this.Position=new h("position","A position in a text document",k=>I.$GN.isPosition(k),P.Position.from)}static{this.Range=new h("range","A range in a text document",k=>I.$HN.isRange(k),P.Range.from)}static{this.Selection=new h("selection","A selection in a text document",k=>I.$IN.isSelection(k),P.Selection.from)}static{this.Number=new h("number","",k=>typeof k=="number",k=>k)}static{this.String=new h("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=h.Arr(h.String)}static Arr(k){return new h(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,C=>Array.isArray(C)&&C.every(f=>k.validate(f)),C=>C.map(f=>k.convert(f)))}static{this.CallHierarchyItem=new h("item","A call hierarchy item",k=>k instanceof I.$6N,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new h("item","A type hierarchy item",k=>k instanceof I.$sP,P.TypeHierarchyItem.from)}static{this.TestItem=new h("testItem","A VS Code TestItem",k=>k instanceof o.$pQ,P.TestItem.from)}constructor(k,C,f,w){this.name=k,this.description=C,this.validate=f,this.convert=w}optional(){return new h(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,C){return new h(k??this.name,C??this.description,this.validate,this.convert)}}e.$AQ=h;class E{static{this.Void=new E("no result",k=>k)}constructor(k,C){this.description=k,this.convert=C}}e.$BQ=E;class D{constructor(k,C,f,w,M){this.id=k,this.internalId=C,this.description=f,this.args=w,this.result=M}}e.$CQ=D}),define(Oe[256],Ne([1,0,17,15,2,93,103,31,33,8,7]),function(be,e,v,I,P,O,R,T,$,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7oc=void 0,O=We(O),s=We(s),A=We(A);const y=[new $.$CQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$AQ.Uri,$.$AQ.Position],new $.$BQ("A promise that resolves to an array of DocumentHighlight-instances.",S(s.DocumentHighlight.to))),new $.$CQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$AQ.Uri],new $.$BQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,o)=>{if((0,v.$Jb)(n))return;class c extends A.$1N{static to(i){const r=new c(i.name,s.SymbolKind.to(i.kind),i.containerName||"",new A.$TN(o[0],s.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=s.Range.to(i.selectionRange),r.children=i.children?i.children.map(c.to):[],r}}return n.map(c.to)})),new $.$CQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$AQ.Uri,new $.$AQ("options","Formatting options",n=>!0,n=>n)],new $.$BQ("A promise that resolves to an array of TextEdits.",S(s.TextEdit.to))),new $.$CQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$AQ.Uri,$.$AQ.Range,new $.$AQ("options","Formatting options",n=>!0,n=>n)],new $.$BQ("A promise that resolves to an array of TextEdits.",S(s.TextEdit.to))),new $.$CQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$AQ.Uri,$.$AQ.Position,new $.$AQ("ch","Trigger character",n=>typeof n=="string",n=>n),new $.$AQ("options","Formatting options",n=>!0,n=>n)],new $.$BQ("A promise that resolves to an array of TextEdits.",S(s.TextEdit.to))),new $.$CQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$AQ.Uri,$.$AQ.Position],new $.$BQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$CQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$AQ.Uri,$.$AQ.Position],new $.$BQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$CQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$AQ.Uri,$.$AQ.Position],new $.$BQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$CQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$AQ.Uri,$.$AQ.Position],new $.$BQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new $.$CQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$AQ.Uri,$.$AQ.Position],new $.$BQ("A promise that resolves to an array of Location-instances.",S(s.location.to))),new $.$CQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$AQ.Uri,$.$AQ.Position],new $.$BQ("A promise that resolves to an array of Hover-instances.",S(s.Hover.to))),new $.$CQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$AQ.Uri,new $.$AQ("position","A position in a text document",n=>Array.isArray(n)&&n.every(o=>A.$GN.isPosition(o)),n=>n.map(s.Position.from))],new $.$BQ("A promise that resolves to an array of ranges.",n=>n.map(o=>{let c;for(const l of o.reverse())c=new A.$5N(s.Range.to(l),c);return c}))),new $.$CQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$AQ.String.with("query","Search string")],new $.$BQ("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(s.WorkspaceSymbol.to))),new $.$CQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$AQ.Uri,$.$AQ.Position],new $.$BQ("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(s.CallHierarchyItem.to))),new $.$CQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$AQ.CallHierarchyItem],new $.$BQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(s.CallHierarchyIncomingCall.to))),new $.$CQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$AQ.CallHierarchyItem],new $.$BQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(s.CallHierarchyOutgoingCall.to))),new $.$CQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$AQ.Uri,$.$AQ.Position],new $.$BQ("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:s.Range.to(n.range),placeholder:n.text}})),new $.$CQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$AQ.Uri,$.$AQ.Position,$.$AQ.String.with("newName","The new symbol name")],new $.$BQ("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return s.WorkspaceEdit.to(n)}})),new $.$CQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$AQ.Uri,$.$AQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$BQ("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(s.DocumentLink.to))),new $.$CQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$AQ.Uri],new $.$BQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new A.$1O(n.tokenTypes,n.tokenModifiers)})),new $.$CQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$AQ.Uri],new $.$BQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,R.$Odb)(n);if(o.type==="full")return new A.$3O(o.data,void 0)})),new $.$CQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$AQ.Uri,$.$AQ.Range.optional()],new $.$BQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new A.$1O(n.tokenTypes,n.tokenModifiers)})),new $.$CQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$AQ.Uri,$.$AQ.Range],new $.$BQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,R.$Odb)(n);if(o.type==="full")return new A.$3O(o.data,void 0)})),new $.$CQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$AQ.Uri,$.$AQ.Position,$.$AQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$AQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$BQ("A promise that resolves to a CompletionList-instance.",(n,o,c)=>{if(!n)return new A.$eO([]);const l=n.suggestions.map(i=>s.CompletionItem.to(i,c));return new A.$eO(l,n.incomplete)})),new $.$CQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$AQ.Uri,$.$AQ.Position,$.$AQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$BQ("A promise that resolves to SignatureHelp.",n=>{if(n)return s.SignatureHelp.to(n)})),new $.$CQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$AQ.Uri,$.$AQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$BQ("A promise that resolves to an array of CodeLens-instances.",(n,o,c)=>S(l=>new A.$9N(s.Range.to(l.range),l.command&&c.fromInternal(l.command)))(n))),new $.$CQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$AQ.Uri,new $.$AQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>A.$HN.isRange(n),n=>A.$IN.isSelection(n)?s.Selection.from(n):s.Range.from(n)),$.$AQ.String.with("kind","Code action kind to return code actions for").optional(),$.$AQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$BQ("A promise that resolves to an array of Command-instances.",(n,o,c)=>S(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(l.command)}else{const i=new A.$3N(l.title,l.kind?new A.$4N(l.kind):void 0);return l.edit&&(i.edit=s.WorkspaceEdit.to(l.edit)),l.command&&(i.command=c.fromInternal(l.command)),i.isPreferred=l.isPreferred,i}})(n))),new $.$CQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$AQ.Uri],new $.$BQ("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(o=>new A.$kO(s.Range.to(o.range),s.Color.to(o.color))):[])),new $.$CQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$AQ("color","The color to show and insert",n=>n instanceof A.$jO,s.Color.from),new $.$AQ("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:s.Range.from(n.range)}))],new $.$BQ("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(s.ColorPresentation.to):[])),new $.$CQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$AQ.Uri,$.$AQ.Range],new $.$BQ("A promise that resolves to an array of Inlay objects",(n,o,c)=>n.map(s.InlayHint.to.bind(void 0,c)))),new $.$CQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$AQ.Uri],new $.$BQ("A promise that resolves to an array of FoldingRange objects",(n,o)=>{if(n)return n.map(s.FoldingRange.to)})),new $.$CQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$BQ("A promise that resolves to an array of NotebookContentProvider static info objects.",S(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(o=>s.NotebookExclusiveDocumentPattern.to(o))})))),new $.$CQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$AQ.Uri,$.$AQ.Range,new $.$AQ("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof A.$HN,n=>s.InlineValueContext.from(n))],new $.$BQ("A promise that resolves to an array of InlineValue objects",n=>n.map(s.InlineValue.to))),new $.$CQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$AQ("uriOrString","Uri-instance or string (only http/https)",n=>P.URI.isUri(n)||typeof n=="string"&&(0,I.$Mg)(n,I.Schemas.http,I.Schemas.https),n=>n),new $.$AQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[s.ViewColumn.from(n),void 0]:[s.ViewColumn.from(n.viewColumn),s.TextEditorOpenOptions.from(n)])).optional(),$.$AQ.String.with("label","").optional()],$.$BQ.Void),new $.$CQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$AQ.Uri.with("resource","Resource to open"),$.$AQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$AQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[s.ViewColumn.from(n),void 0]:[s.ViewColumn.from(n.viewColumn),s.TextEditorOpenOptions.from(n)])).optional()],$.$BQ.Void),new $.$CQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$AQ.Uri.with("left","Left-hand side resource of the diff editor"),$.$AQ.Uri.with("right","Right-hand side resource of the diff editor"),$.$AQ.String.with("title","Human readable title for the diff editor").optional(),new $.$AQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[s.ViewColumn.from(n.viewColumn),s.TextEditorOpenOptions.from(n)]).optional()],$.$BQ.Void),new $.$CQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$AQ.String.with("title","Human readable title for the changes editor"),new $.$AQ("resourceList","List of resources to compare",n=>{for(const o of n){if(o.length!==3)return!1;const[c,l,i]=o;if(!P.URI.isUri(c)||!P.URI.isUri(l)&&l!==void 0&&l!==null||!P.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},n=>n)],$.$BQ.Void),new $.$CQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$AQ.Uri,$.$AQ.Position],new $.$BQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(s.TypeHierarchyItem.to))),new $.$CQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$AQ.TypeHierarchyItem],new $.$BQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(s.TypeHierarchyItem.to))),new $.$CQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$AQ.TypeHierarchyItem],new $.$BQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(s.TypeHierarchyItem.to))),new $.$CQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$AQ.TestItem],$.$BQ.Void),new $.$CQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$AQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$BQ.Void),new $.$CQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$AQ.String.with("name","The context key name"),new $.$AQ("value","The context key value",()=>!0,n=>n)],$.$BQ.Void),new $.$CQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$AQ.Uri,$.$AQ.StringArray,new $.$AQ("MappedEditsContext","Mapped Edits Context",n=>s.MappedEditsContext.is(n),n=>s.MappedEditsContext.from(n))],new $.$BQ("A promise that resolves to a workspace edit or null",n=>n?s.WorkspaceEdit.to(n):null)),new $.$CQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$AQ("Run arguments","",n=>!0,n=>{if(n)return{initialRange:n.initialRange?s.Range.from(n.initialRange):void 0,initialSelection:A.$IN.isSelection(n.initialSelection)?s.Selection.from(n.initialSelection):void 0,message:n.message,autoSend:n.autoSend,position:n.position?s.Position.from(n.position):void 0}})],$.$BQ.Void)];class a{static register(o){y.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",T.$Bj)}}e.$7oc=a;function S(n){return o=>{if(Array.isArray(o))return o.map(n)}}function d(n){if(!Array.isArray(n))return;const o=[];for(const c of n)O.$Iu(c)?o.push(s.DefinitionLink.to(c)):o.push(s.location.to(c));return o}}),define(Oe[257],Ne([1,0,2,33]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vqc=void 0;class P{constructor(R,T,$,s,A){this.a=T,this.b=$,this.c=s;const y=new I.$CQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new I.$AQ("showOptions","Show Options",a=>!0,a=>a),new I.$AQ("resource","Interactive resource Uri",a=>!0,a=>a),new I.$AQ("controllerId","Notebook controller Id",a=>!0,a=>a),new I.$AQ("title","Interactive editor title",a=>!0,a=>a)],new I.$BQ("Notebook and input URI",a=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const S=this.a.getEditorById(a.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:v.URI.revive(a.notebookUri),inputUri:v.URI.revive(a.inputUri),notebookEditor:S.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:v.URI.revive(a.notebookUri),inputUri:v.URI.revive(a.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(R,T,$,s){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:$,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$vqc=P}),define(Oe[258],Ne([1,0,17,10,21,6,4,28,2,18,11,5,33,8,7,82,197,24,38,198]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dqc=void 0,e.$Eqc=h,S=We(S);let r=class{constructor(D,b,k,C,f){this.m=b,this.n=k,this.o=C,this.q=f,this.b=new T.$zc,this.c=new T.$zc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$je,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(y.$DN.MainThreadNotebookKernels);const w=new a.$CQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.$AQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const L=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:L}}else if(N&&"notebookEditor"in N){const L=this.n.getIdByEditor(N.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return N})],a.$BQ.Void),M=new a.$CQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[a.$AQ.Uri],new a.$BQ("A promise that resolves to an array of variables",(N,L)=>N.map(W=>({variable:{name:W.name,value:W.value,expression:W.expression,type:W.type,language:W.language},hasNamedChildren:W.hasNamedChildren,indexedChildrenCount:W.indexedChildrenCount}))));this.o.registerApiCommand(w),this.o.registerApiCommand(M)}createNotebookController(D,b,k,C,f,w){for(const oe of this.j.values())if(oe.controller.id===b&&s.$on.equals(D.identifier,oe.extensionId))throw new Error(`notebook controller with id '${b}' ALREADY exist`);const M=this.k++,N=this;this.q.trace(`NotebookController[${M}], CREATED by ${D.identifier.value}, ${b}`);const L=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${D.identifier}'`);let W=!1;const G=new O.$je,F=new O.$je,K={id:h(D.identifier,b),notebookType:k,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:C||D.identifier.value,preloads:w?w.map(S.NotebookRendererScript.from):[]};let Y=f??L,le,_;this.a.$addKernel(M,K).catch(oe=>{console.log(oe),W=!0});let ge=0;const se=()=>{if(W)return;const oe=++ge;Promise.resolve().then(()=>{oe===ge&&this.a.$updateKernel(M,K)})},ae=new T.$zc,$e={get id(){return b},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:G.event,get label(){return K.label},set label(oe){K.label=oe??D.displayName??D.name,se()},get detail(){return K.detail??""},set detail(oe){K.detail=oe,se()},get description(){return K.description??""},set description(oe){K.description=oe,se()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(oe){K.supportedLanguages=oe,se()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){K.supportsExecutionOrder=oe,se()},get rendererScripts(){return K.preloads?K.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return Y},set executeHandler(oe){Y=oe??L},get interruptHandler(){return le},set interruptHandler(oe){le=oe,K.supportsInterrupt=!!oe,se()},set variableProvider(oe){(0,c.$dH)(D,"notebookVariableProvider"),_=oe,K.hasVariableProvider=!!oe,oe?.onDidChangeVariables(Ce=>N.a.$variablesUpdated(Ce.uri)),se()},get variableProvider(){return _},createNotebookCellExecution(oe){if(W)throw new Error("notebook controller is DISPOSED");if(!ae.has(oe.notebook.uri))throw N.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return N._createNotebookCellExecution(oe,h(D.identifier,this.id))},createNotebookExecution(oe){if((0,c.$dH)(D,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!ae.has(oe.uri))throw N.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.uri.toString()}`);return N._createNotebookExecution(oe,h(D.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${M}], DISPOSED`),W=!0,this.j.delete(M),G.dispose(),F.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(oe,Ce){Ce===d.NotebookControllerAffinity2.Hidden&&(0,c.$dH)(D,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(M,oe.uri,Ce)},onDidReceiveMessage:F.event,postMessage(oe,Ce){return(0,c.$dH)(D,"notebookMessaging"),N.a.$postMessage(M,Ce&&N.n.getIdByEditor(Ce),oe)},asWebviewUri(oe){return(0,c.$dH)(D,"notebookMessaging"),(0,n.$vDb)(oe,N.m.remote)}};return this.j.set(M,{extensionId:D.identifier,controller:$e,onDidReceiveMessage:F,onDidChangeSelection:G,associatedNotebooks:ae}),$e}getIdByController(D){for(const[b,k]of this.j)if(k.controller===D)return h(k.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,b){const k=this.g++,C=this;this.q.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(k,b);const f={dispose:()=>{this.f.delete(k),C.a.$removeKernelDetectionTask(k)}};return this.f.set(k,f),f}registerKernelSourceActionProvider(D,b,k){const C=this.i++,f=typeof k.onDidChangeNotebookKernelSourceActions=="function"?C:void 0,w=this;this.h.set(C,k),this.q.trace(`NotebookKernelSourceActionProvider[${C}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(C,C,b);let M;return f!==void 0&&(M=k.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.h.delete(C),w.a.$removeKernelSourceActionProvider(C,C),M?.dispose()}}}async $provideKernelSourceActions(D,b){const k=this.h.get(D);if(k){const C=new R.$Sc;return(await k.provideNotebookKernelSourceActions(b)??[]).map(w=>S.NotebookKernelSourceAction.from(w,this.o.converter,C))}return[]}$acceptNotebookAssociation(D,b,k){const C=this.j.get(D);if(C){const f=this.n.getNotebookDocument($.URI.revive(b));k?C.associatedNotebooks.set(f.uri,!0):C.associatedNotebooks.delete(f.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,f.uri.toString(),k),C.onDidChangeSelection.fire({selected:k,notebook:f.apiNotebook})}}async $executeCells(D,b,k){const C=this.j.get(D);if(!C)return;const f=this.n.getNotebookDocument($.URI.revive(b)),w=[];for(const M of k){const N=f.getCell(M);N&&w.push(N.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,f.uri.toString(),w.length),await C.controller.executeHandler.call(C.controller,w,f.apiNotebook,C.controller)}catch(M){this.q.error(`NotebookController[${D}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(D,b,k){const C=this.j.get(D);if(!C)return;const f=this.n.getNotebookDocument($.URI.revive(b));if(C.controller.interruptHandler)await C.controller.interruptHandler.call(C.controller,f.apiNotebook);else for(const w of k){const M=f.getCell(w);M&&this.b.get(M.uri)?.cancel()}if(C.controller.interruptHandler){const w=this.c.get(f.uri);this.c.delete(f.uri),k.length&&Array.isArray(w)&&w.length&&w.forEach(M=>M.dispose())}}async $provideVariables(D,b,k,C,f,w,M){const N=this.j.get(D);if(!N)return;const L=this.n.getNotebookDocument($.URI.revive(k)),W=N.controller.variableProvider;if(!W)return;let G;if(C!==void 0){if(G=this.s[C],!G)return}else this.s={};const F=f==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,K=W.provideVariables(L.apiNotebook,G,F,w,M);let Y=0;for await(const le of K){if(M.isCancellationRequested)return;const _={id:this.r++,name:le.variable.name,value:le.variable.value,type:le.variable.type,interfaces:le.variable.interfaces,language:le.variable.language,expression:le.variable.expression,hasNamedChildren:le.hasNamedChildren,indexedChildrenCount:le.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[_.id]=le.variable,this.a.$receiveVariable(b,_),Y++>=i.$VK)return}}$acceptKernelMessageFromRenderer(D,b,k){const C=this.j.get(D);if(!C)return;const f=this.n.getEditorById(b);C.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:k}))}$cellExecutionChanged(D,b,k){const f=this.n.getNotebookDocument($.URI.revive(D)).getCell(b);if(f){const w=k?S.NotebookCellExecutionState.to(k):d.NotebookCellExecutionState.Idle;w!==void 0&&this.l.fire({cell:f.apiCell,state:w})}}_createNotebookCellExecution(D,b){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const C=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!C)throw new Error("invalid cell");if(this.b.has(C.uri))throw new Error(`duplicate execution for ${C.uri}`);const f=new g(b,C,this.a);this.b.set(C.uri,f);const w=f.onDidChangeState(()=>{f.state===t.Resolved&&(f.dispose(),w.dispose(),this.b.delete(C.uri))});return f.asApiObject()}_createNotebookExecution(D,b){const k=this.n.getNotebookDocument(D.uri),C=D.getCells().find(M=>{const N=k.getCellFromApiCell(M);return N&&this.b.has(N.uri)});if(C)throw new Error(`duplicate cell execution for ${C.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const f=new m(b,k,this.a),w=f.onDidChangeState(()=>{f.state===u.Resolved&&(f.dispose(),w.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[f,w]),f.asApiObject()}};e.$Dqc=r,e.$Dqc=r=Ge([Ve(4,A.$0j)],r);var t;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(t||(t={}));class g extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(D,b,k){super(),this.m=b,this.n=k,this.b=g.a++,this.c=new O.$je,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new P.$ue),this.h=new p(10,C=>this.s(C)),this.j=b.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const b=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new l.$Uw(b))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let b=this.m;if(D&&(b=this.m.notebook.getCellFromApiCell(D)),!b)throw new Error("INVALID cell");return b.handle}y(D){return D.map(b=>{const k=d.$bP.ensureUniqueMimeTypes(b.items,!0);return k===b.items?S.NotebookCellOutput.from(b):S.NotebookCellOutput.from({items:k,id:b.id,metadata:b.metadata})})}async z(D,b,k){const C=this.w(b),f=this.y((0,v.$1b)(D));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:C,append:k,outputs:f})}async C(D,b,k){return D=d.$bP.ensureUniqueMimeTypes((0,v.$1b)(D),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:D.map(S.NotebookCellOutputItem.from),outputId:b.id,append:k})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(k){D.j=k,D.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(k){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,C,f){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const w=f?{message:f.message,stack:f.stack,location:f?.location?{startLineNumber:f.location.start.line,startColumn:f.location.start.character,endLineNumber:f.location.end.line,endColumn:f.location.end.character}:void 0,uri:f.uri}:void 0;D.n.$completeExecution(D.b,new l.$Uw({runEndTime:C,lastRunSuccess:k,error:w}))},clearOutput(k){return D.t(),D.z([],k,!1)},appendOutput(k,C){return D.t(),D.z(k,C,!0)},replaceOutput(k,C){return D.t(),D.z(k,C,!1)},appendOutputItems(k,C){return D.t(),D.C(k,C,!0)},replaceOutputItems(k,C){return D.t(),D.C(k,C,!1)}})}}var u;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(u||(u={}));class m extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(D,b,k){super(),this.h=b,this.j=k,this.b=m.a++,this.c=new O.$je,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new P.$ue),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===u.Resolved||this.f===u.Started)throw new Error("Cannot call start again");this.f=u.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===u.Resolved)throw new Error("Cannot call resolve twice");this.f=u.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class p{constructor(D,b){this.f=D,this.g=b,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new I.$Zh,this.b=Date.now(),(0,I.$Dh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const b=this.a;return this.a=[],this.g(b).finally(()=>D.complete())}}function h(E,D){return`${E.value}/${D}`}}),define(Oe[56],Ne([1,0,6,5,3,2,16,4,7,9,13,179,21,37,180,181,34,10,8,33,36]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lpc=e.$Kpc=e.$Jpc=e.$Ipc=void 0,e.$Ipc=(0,P.$Ci)("IExtHostTerminalService");class t extends T.$Tc{constructor(f,w,M,N){super(),this.u=f,this._id=w,this.w=M,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new v.$je),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const L=this;this.value={get name(){return L.y||""},get processId(){return L.b},get creationOptions(){return L.w},get exitStatus(){return L.j},get state(){return L.m},get selection(){return L.n},get shellIntegration(){return L.shellIntegration},sendText(W,G=!0){L.C(),L.u.$sendText(L._id,W,G)},show(W){L.C(),L.u.$show(L._id,W)},hide(){L.C(),L.u.$hide(L._id)},dispose(){L.a||(L.a=!0,L.u.$dispose(L._id))},get dimensions(){if(!(L.f===void 0||L.h===void 0))return{columns:L.f,rows:L.h}}}}dispose(){this.s.fire(),super.dispose()}async create(f,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??w?.cwd??void 0,env:f.env??void 0,icon:D(f.iconPath)??void 0,color:o.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:w?.forceShellIntegration??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.z(f.location,w?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,w,M,N,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:o.ThemeColor.isThemeColor(L)?L.id:void 0,location:w?.location||this.z(f,M),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(f,w){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in f?{viewColumn:l.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.y=f}setExitStatus(f,w){this.j=Object.freeze({code:f,reason:w})}setDimensions(f,w){return f===this.f&&w===this.h||f===0||w===0?!1:(this.f=f,this.h=w,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(f){this.n=f}_setProcessId(f){this.g?(this.g(f),this.g=void 0):this.b.then(w=>{w!==f&&(this.b=Promise.resolve(f))})}}e.$Jpc=t;class g{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new v.$je,this.onProcessData=this.a.event,this.b=new v.$je,this.d=new v.$je,this.onDidChangeProperty=this.d.event,this.f=new v.$je,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,w){this.g.setDimensions?.({columns:f,rows:w})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:d.ProcessPropertyType.OverrideDimensions,value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:d.ProcessPropertyType.Title,value:w})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,m=class extends T.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,w,M){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new v.$je,this.onDidCloseTerminal=this.H.event,this.I=new v.$je,this.onDidOpenTerminal=this.I.event,this.J=new v.$je,this.onDidChangeActiveTerminal=this.J.event,this.L=new v.$je,this.onDidChangeTerminalDimensions=this.L.event,this.M=new v.$je,this.onDidChangeTerminalState=this.M.event,this.N=new v.$je,this.onDidChangeShell=this.N.event,this.O=new v.$je({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new v.$je({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=M.getProxy(I.$DN.MainThreadTerminalService),this.y=new n.$Lxb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:N=>{const L=W=>{const G=W;return this.getTerminalById(G.instanceId)?.value};switch(N?.$mid){case r.MarshalledId.TerminalContext:return L(N);default:{if(Array.isArray(N))for(let W=0;W<N.length&&N[W].$mid===r.MarshalledId.TerminalContext;W++)N[W]=L(N[W]);return N}}}}),this.B({dispose:()=>{for(const[N,L]of this.g)L.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,w){const M=new t(this.a,(0,S.$Yg)(),f,f.name),N=new g(f.pty);return M.createExtensionTerminal(f.location,w,this.R(f,w).resolvedExtHostIdentifier,D(f.iconPath),b(f.color)).then(L=>{const W=this.S(L,N);this.h[L]=W}),this.f.push(M),M.value}R(f,w){if(w=w||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const M=f.location.parentTerminal;if(M){const N=this.f.find(L=>L.value===M);N&&(w.resolvedExtHostIdentifier=N._id)}}else f.location&&typeof f.location!="object"?w.location=f.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(f,w){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const N=new g(w),L=this.S(f,N);this.h[f]=L}async $acceptActiveTerminalChanged(f){const w=this.b;if(f===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const M=this.getTerminalById(f);M&&(this.b=M,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,w){const M=this.getTerminalById(f);M&&this.O.fire({terminal:M.value,data:w})}async $acceptTerminalDimensions(f,w,M){const N=this.getTerminalById(f);N&&N.setDimensions(w,M)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(f,w){const M=this.getTerminalById(f);M&&this.P.fire({terminal:M.value,...w})}async $acceptTerminalMaximumDimensions(f,w,M){this.g.get(f)?.resize(w,M)}async $acceptTerminalTitleChange(f,w){const M=this.getTerminalById(f);M&&(M.name=w)}async $acceptTerminalClosed(f,w,M){const N=this.X(this.f,f);if(N!==null){const L=this.f.splice(N,1)[0];L.setExitStatus(w,M),this.H.fire(L.value)}}$acceptTerminalOpened(f,w,M,N){if(w){const G=this.X(this.f,w);if(G!==null){this.f[G]._id=f,this.I.fire(this.terminals[G]),this.f[G].isOpen=!0;return}}const L={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:O.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},W=new t(this.a,f,L,M);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(f,w){this.getTerminalById(f)?._setProcessId(w)}async $startExtensionTerminal(f,w){const M=this.getTerminalById(f);if(!M)return{message:(0,s.localize)(10731,null,f)};M.isOpen||await new Promise(L=>{const W=this.onDidOpenTerminal(async G=>{G===M.value&&(W.dispose(),L())})});const N=this.g.get(f);N?N.startSendingEvents(w):this.j[f]={initialDimensions:w}}S(f,w){const M=new T.$Sc;M.add(w.onProcessReady(L=>this.a.$sendProcessReady(f,L.pid,L.cwd,L.windowsPty))),M.add(w.onDidChangeProperty(L=>this.a.$sendProcessProperty(f,L))),this.y.startBuffering(f,w.onProcessData),M.add(w.onProcessExit(L=>this.U(f,L))),this.g.set(f,w);const N=this.j[f];return N&&w instanceof g&&(w.startSendingEvents(N.initialDimensions),delete this.j[f]),M}$acceptProcessAckDataEvent(f,w){this.g.get(f)?.acknowledgeDataEvent(w)}$acceptProcessInput(f,w){this.g.get(f)?.input(w)}$acceptTerminalInteraction(f){const w=this.getTerminalById(f);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(f,w){this.getTerminalById(f)?.setSelection(w)}$acceptProcessResize(f,w,M){try{this.g.get(f)?.resize(w,M)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(f,w){this.g.get(f)?.shutdown(w)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(f,{type:d.ProcessPropertyType.InitialCwd,value:w}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(w=>this.a.$sendProcessProperty(f,{type:d.ProcessPropertyType.Cwd,value:w}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new $.$FN(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,w,M){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,M),this.a.$registerProfileProvider(w,f.identifier.value),new $.$FN(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(f,w,M){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,M),this.a.$registerQuickFixProvider(f,w),new $.$FN(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,w){const M=new a.$ue().token;if(M.isCancellationRequested)return;const N=this.D.get(f);if(!N)return;const L=await N.provideTerminalQuickFixes(w,M);if(L===null||Array.isArray(L)&&L.length===0)return;const W=new T.$Sc;if(this.w.value=W,!Array.isArray(L))return L?l.TerminalQuickFix.from(L,this.Q.converter,W):void 0;const G=[];for(const F of L){const K=l.TerminalQuickFix.from(F,this.Q.converter,W);K&&G.push(K)}return G}async $createContributedProfileTerminal(f,w){const M=new a.$ue().token;let N=await this.C.get(f)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,w);return}this.createTerminalFromOptions(N.options,w)}}async $provideLinks(f,w){const M=this.getTerminalById(f);if(!M)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const L=new a.$ue;this.G.set(f,L);const W=[],G={terminal:M.value,line:w},F=[];for(const le of this.z)F.push(c.Promises.withAsyncBody(async _=>{L.token.onCancellationRequested(()=>_({provider:le,links:[]}));const ge=await le.provideTerminalLinks(G,L.token)||[];L.token.isCancellationRequested||_({provider:le,links:ge})}));const K=await Promise.all(F);if(L.token.isCancellationRequested)return[];const Y=new Map;for(const le of K)le&&le.links.length>0&&W.push(...le.links.map(_=>{const ge={id:u++,startIndex:_.startIndex,length:_.length,label:_.tooltip};return Y.set(ge.id,{provider:le.provider,link:_}),ge}));return this.F.set(f,Y),W}$activateLink(f,w){const M=this.F.get(f)?.get(w);M&&M.provider.handleTerminalLink(M.link)}U(f,w){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const M=this.h[f];M&&(M.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,w)}getTerminalById(f){return this.W(this.f,f)}getTerminalIdByApiObject(f){const w=this.f.findIndex(M=>M.value===f);return w>=0?w:null}W(f,w){const M=this.X(f,w);return M!==null?f[M]:null}X(f,w){const M=f.findIndex(N=>N._id===w);return M>=0?M:null}getEnvironmentVariableCollection(f){let w=this.n.get(f.identifier.value);return w||(w=this.B(new p),this.Z(f.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Y(f,w){const M=(0,y.$Cs)(w.map),N=(0,y.$Ds)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(f,w.persistent,M.length===0?void 0:M,N)}$initEnvironmentVariableCollections(f){f.forEach(w=>{const M=w[0],N=this.B(new p(w[1]));this.Z(M,N)})}$acceptDefaultProfile(f,w){const M=this.s;this.s=f,this.u=w,M?.path!==f.path&&this.N.fire(f.path)}Z(f,w){this.n.set(f,w),this.B(w.onDidChangeCollection(()=>{this.Y(f,w)}))}};e.$Kpc=m,e.$Kpc=m=Ge([Ve(1,i.$yQ),Ve(2,R.$cQ)],m);class p extends T.$Tc{get persistent(){return this.b}set persistent(f){this.b=f,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(f){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new v.$je,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const w=this.j(f);let M=this.a.get(w);return M||(M=new h(this,f),this.a.set(w,M),this.B(M.onDidChangeCollection(()=>this.f.fire()))),M}replace(f,w,M,N){this.g(f,{value:w,type:$.EnvironmentVariableMutatorType.Replace,options:M??{applyAtProcessCreation:!0},scope:N})}append(f,w,M,N){this.g(f,{value:w,type:$.EnvironmentVariableMutatorType.Append,options:M??{applyAtProcessCreation:!0},scope:N})}prepend(f,w,M,N){this.g(f,{value:w,type:$.EnvironmentVariableMutatorType.Prepend,options:M??{applyAtProcessCreation:!0},scope:N})}g(f,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.h(f,w.scope),N=this.map.get(M),L=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==w.value||N.type!==w.type||N.options?.applyAtProcessCreation!==L.applyAtProcessCreation||N.options?.applyAtShellIntegration!==L.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const W=this.h(f,w.scope),G={variable:f,...w,options:L};this.map.set(W,G),this.f.fire()}}get(f,w){const M=this.h(f,w),N=this.map.get(M);return N?k(N):void 0}h(f,w){const M=this.j(w);return M.length?`${f}:::${M}`:f}j(f){return this.m(f?.workspaceFolder)??""}m(f){return f?f.uri.toString():void 0}getVariableMap(f){const w=new Map;for(const[M,N]of this.map)this.j(N.scope)===this.j(f)&&w.set(N.variable,k(N));return w}delete(f,w){const M=this.h(f,w);this.map.delete(M),this.f.fire()}clear(f){if(f?.workspaceFolder){for(const[w,M]of this.map)M.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(w);this.n(f)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(f,w){const M=this.j(w),N=this.descriptionMap.get(M);if(!N||N.description!==f){let L;typeof f=="string"?L=f:L=f?.value.split(`

`)[0];const W={description:L,scope:w};this.descriptionMap.set(M,W),this.f.fire()}}getDescription(f){const w=this.j(f);return this.descriptionMap.get(w)?.description}n(f){const w=this.j(f);this.descriptionMap.delete(w)}}class h{get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,w){this.b=f,this.d=w,this.a=new v.$je}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,w,M){this.b.replace(f,w,M,this.d)}append(f,w,M){this.b.append(f,w,M,this.d)}prepend(f,w,M){this.b.prepend(f,w,M,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,w){this.b.getVariableMap(this.d).forEach((M,N)=>f.call(w,N,M,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let E=class extends m{constructor(f,w){super(!1,f,w)}createTerminal(f,w,M){throw new A.$$}createTerminalFromOptions(f,w){throw new A.$$}};e.$Lpc=E,e.$Lpc=E=Ge([Ve(0,i.$yQ),Ve(1,R.$cQ)],E);function D(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function b(C){return o.ThemeColor.isThemeColor(C)?C:void 0}function k(C){const f={...C};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Oe[126],Ne([1,0,7,4,3,5,16,56,6,2,10]),function(be,e,v,I,P,O,R,T,$,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wqc=e.$Vqc=void 0,e.$Vqc=(0,P.$Ci)("IExtHostTerminalShellIntegration");let y=class extends I.$Tc{constructor(o,c){super(),this.h=c,this.b=new Map,this.c=new $.$je,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$je,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$je,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(O.$DN.MainThreadTerminalShellIntegration),this.B((0,I.$Rc)(()=>{for(const[l,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(o){const c=this.h.getTerminalById(o);if(!c)return;const l=c.value;let i=this.b.get(o);i||(i=new a(c.value,this.f),this.b.set(o,i),i.store.add(c.onWillDispose(()=>this.b.get(o)?.dispose())),i.store.add(i.onDidRequestShellExecution(r=>this.a.$executeCommand(o,r))),i.store.add(i.onDidRequestEndExecution(r=>this.g.fire(r))),i.store.add(i.onDidRequestChangeShellIntegration(r=>this.c.fire(r))),c.shellIntegration=i.value),this.c.fire({terminal:l,shellIntegration:i.value})}$shellExecutionStart(o,c,l,i,r){this.b.has(o)||this.$shellIntegrationChange(o);const t={value:c,confidence:l,isTrusted:i};this.b.get(o)?.startShellExecution(t,r)}$shellExecutionEnd(o,c,l,i,r){const t={value:c,confidence:l,isTrusted:i};this.b.get(o)?.endShellExecution(t,r)}$shellExecutionData(o,c){this.b.get(o)?.emitData(c)}$cwdChange(o,c){this.b.get(o)?.setCwd((0,s.$uc)(c)?s.URI.revive(c):c)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$Wqc=y,e.$Wqc=y=Ge([Ve(0,R.$cQ),Ve(1,T.$Ipc)],y);class a extends I.$Tc{get currentExecution(){return this.a}constructor(o,c){super(),this.j=o,this.m=c,this.b=!1,this.store=this.B(new I.$Sc),this.f=this.B(new $.$je),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$je),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$je),this.onDidRequestEndExecution=this.h.event;const l=this;this.value={get cwd(){return l.c},executeCommand(i,r){let t=i;r&&(t+=` "${r.map(m=>`${m.replaceAll('"','\\"')}`).join('" "')}"`),l.g.fire(t);const g={value:t,confidence:v.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},u=l.startShellExecution(g,l.c,!0).value;return l.b=!0,u}}}startShellExecution(o,c,l){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new S(o,c);l?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,c){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:c}),this.a=void 0)}setCwd(o){let c=!1;s.URI.isUri(this.c)?c=!s.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(c=!0),c&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class S{constructor(o,c){this.c=o,this.cwd=c,this.b=!1;const l=this;this.value={get commandLine(){return l.c},get cwd(){return l.cwd},read(){return l.d()}}}d(){if(!this.a){if(this.b)return A.$3h.EMPTY;this.a=new d}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class d extends I.$Tc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new A.$Bh);const o=this.a;return new A.$3h(async l=>{this.b.push(l),await o.wait()})}emitData(o){for(const c of this.b)c.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Oe[127],Ne([1,0,61,13,96,8,7]),function(be,e,v,I,P,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lQ=e.$kQ=e.$jQ=void 0,O=We(O);class T{static{this.c=new P.$hQ("TextEditorDecorationType")}constructor(a,S,d){const n=T.c.nextId();a.$registerTextEditorDecorationType(S.identifier,n,O.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:n,dispose(){a.$removeTextEditorDecorationType(n)}})}}e.$jQ=T;class ${constructor(a,S){this.g=[],this.h=void 0,this.j=!1,this.c=a,this.d=a.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(a,S){this.k();let d=null;if(a instanceof R.$GN)d=new R.$HN(a,a);else if(a instanceof R.$HN)d=a;else throw new Error("Unrecognized location");this.l(d,S,!1)}insert(a,S){this.k(),this.l(new R.$HN(a,a),S,!0)}delete(a){this.k();let S=null;if(a instanceof R.$HN)S=a;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(a,S,d){const n=this.c.validateRange(a);this.g.push({range:n,text:S,forceMoveMarkers:d})}setEndOfLine(a){if(this.k(),a!==R.EndOfLine.LF&&a!==R.EndOfLine.CRLF)throw(0,I.$6)("endOfLine");this.h=a}}class s{constructor(a,S,d,n){this.c=a,this.d=S,this._accept(d),this.e=n;const o=this;this.value={get tabSize(){return o.f},set tabSize(c){o.n(c)},get indentSize(){return o.g},set indentSize(c){o.p(c)},get insertSpaces(){return o.j},set insertSpaces(c){o.s(c)},get cursorStyle(){return o.k},set cursorStyle(c){o.t(c)},get lineNumbers(){return o.l},set lineNumbers(c){o.u(c)}}}_accept(a){this.f=a.tabSize,this.g=a.indentSize,this.h=a.originalIndentSize,this.j=a.insertSpaces,this.k=a.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(a.lineNumbers)}m(a){if(a==="auto")return"auto";if(typeof a=="number"){const S=Math.floor(a);return S>0?S:null}if(typeof a=="string"){const S=parseInt(a,10);return isNaN(S)?null:S>0?S:null}return null}n(a){const S=this.m(a);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}o(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const S=Math.floor(a);return S>0?S:null}if(typeof a=="string"){const S=parseInt(a,10);return isNaN(S)?null:S>0?S:null}return null}p(a){const S=this.o(a);if(S!==null){if(typeof S=="number"){if(this.h===S)return;this.g=S,this.h=S}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}q(a){return a==="auto"?"auto":a==="false"?!1:!!a}s(a){const S=this.q(a);if(typeof S=="boolean"){if(this.j===S)return;this.j=S}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}t(a){this.k!==a&&(this.k=a,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:a})))}u(a){this.l!==a&&(this.l=a,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(a)})))}assign(a){const S={};let d=!1;if(typeof a.tabSize<"u"){const n=this.m(a.tabSize);n==="auto"?(d=!0,S.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,d=!0,S.tabSize=n)}if(typeof a.indentSize<"u"){const n=this.o(a.indentSize);n==="tabSize"?(d=!0,S.indentSize=n):typeof n=="number"&&this.h!==n&&(this.g=n,this.h=n,d=!0,S.indentSize=n)}if(typeof a.insertSpaces<"u"){const n=this.q(a.insertSpaces);n==="auto"?(d=!0,S.insertSpaces=n):this.j!==n&&(this.j=n,d=!0,S.insertSpaces=n)}typeof a.cursorStyle<"u"&&this.k!==a.cursorStyle&&(this.k=a.cursorStyle,d=!0,S.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this.l!==a.lineNumbers&&(this.l=a.lineNumbers,d=!0,S.lineNumbers=O.TextEditorLineNumbersStyle.from(a.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,S))}v(a,S){S.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this.e.warn(d)})}}e.$kQ=s;class A{constructor(a,S,d,n,o,c,l,i){this.id=a,this.j=S,this.k=d,this.g=!1,this.h=new Set,this.c=o,this.d=new s(this.j,this.id,c,d),this.e=l,this.f=i;const r=this;this.value=Object.freeze({get document(){return n.value},set document(t){throw new I.$8("document")},get selection(){return r.c&&r.c[0]},set selection(t){if(!(t instanceof R.$IN))throw(0,I.$6)("selection");r.c=[t],r.l()},get selections(){return r.c},set selections(t){if(!Array.isArray(t)||t.some(g=>!(g instanceof R.$IN)))throw(0,I.$6)("selections");r.c=t,r.l()},get visibleRanges(){return r.e},set visibleRanges(t){throw new I.$8("visibleRanges")},get options(){return r.d.value},set options(t){r.g||r.d.assign(t)},get viewColumn(){return r.f},set viewColumn(t){throw new I.$8("viewColumn")},edit(t,g={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new $(n.value,g);return t(u),r.m(u)},insertSnippet(t,g,u={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let m;if(!g||Array.isArray(g)&&g.length===0)m=r.c.map(p=>O.Range.from(p));else if(g instanceof R.$GN){const{lineNumber:p,column:h}=O.Position.from(g);m=[{startLineNumber:p,startColumn:h,endLineNumber:p,endColumn:h}]}else if(g instanceof R.$HN)m=[O.Range.from(g)];else{m=[];for(const p of g)if(p instanceof R.$HN)m.push(O.Range.from(p));else{const{lineNumber:h,column:E}=O.Position.from(p);m.push({startLineNumber:h,startColumn:E,endLineNumber:h,endColumn:E})}}return S.$tryInsertSnippet(a,n.value.version,t.value,m,u)},setDecorations(t,g){const u=g.length===0;u&&!r.h.has(t.key)||(u?r.h.delete(t.key):r.h.add(t.key),r.n(()=>{if(O.$_P(g))return S.$trySetDecorations(a,t.key,O.$aQ(g));{const m=new Array(4*g.length);for(let p=0,h=g.length;p<h;p++){const E=g[p];m[4*p]=E.start.line+1,m[4*p+1]=E.start.character+1,m[4*p+2]=E.end.line+1,m[4*p+3]=E.end.character+1}return S.$trySetDecorationsFast(a,t.key,m)}}))},revealRange(t,g){r.n(()=>S.$tryRevealRange(a,O.Range.from(t),g||R.TextEditorRevealType.Default))},show(t){S.$tryShowEditor(a,O.ViewColumn.from(t))},hide(){S.$tryHideEditor(a)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,v.ok)(!this.g),this.g=!0}_acceptOptions(a){(0,v.ok)(!this.g),this.d._accept(a)}_acceptVisibleRanges(a){(0,v.ok)(!this.g),this.e=a}_acceptViewColumn(a){(0,v.ok)(!this.g),this.f=a}_acceptSelections(a){(0,v.ok)(!this.g),this.c=a}async l(){const a=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,a)),this.value}m(a){const S=a.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const d=S.edits.map(o=>o.range);d.sort((o,c)=>o.end.line===c.end.line?o.end.character===c.end.character?o.start.line===c.start.line?o.start.character-c.start.character:o.start.line-c.start.line:o.end.character-c.end.character:o.end.line-c.end.line);for(let o=0,c=d.length-1;o<c;o++){const l=d[o].end;if(d[o+1].start.isBefore(l))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=S.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,n,{setEndOfLine:typeof S.setEndOfLine=="number"?O.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(a){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$lQ=A}),define(Oe[57],Ne([1,0,61,6,4,2,3,5,123,16,127,8,11,28,15,39,48]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=e.$mQ=void 0,v=We(v),y=We(y);class c{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let l=class{constructor(r,t){this.h=r,this.i=t,this.a=null,this.b=new Map,this.c=new S.$zc,this.d=new I.$je,this.e=new I.$je,this.f=new I.$je,this.g=new I.$je,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const t=[],g=[],u=[];if(r.removedDocuments)for(const m of r.removedDocuments){const p=O.URI.revive(m),h=this.c.get(p);h?.unref()&&(this.c.delete(p),t.push(h.value))}if(r.addedDocuments)for(const m of r.addedDocuments){const p=O.URI.revive(m.uri);let h=this.c.get(p);if(h&&p.scheme!==d.Schemas.vscodeNotebookCell&&p.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${p} already exists!'`);h||(h=new c(new $.$fQ(this.h.getProxy(T.$DN.MainThreadDocuments),p,m.lines,m.EOL,m.versionId,m.languageId,m.isDirty)),this.c.set(p,h),g.push(h.value)),h.ref()}if(r.removedEditors)for(const m of r.removedEditors){const p=this.b.get(m);this.b.delete(m),p&&u.push(p)}if(r.addedEditors)for(const m of r.addedEditors){const p=O.URI.revive(m.documentUri);v.ok(this.c.has(p),`document '${p}' does not exist`),v.ok(!this.b.has(m.id),`editor '${m.id}' already exists!`);const h=this.c.get(p).value,E=new A.$lQ(m.id,this.h.getProxy(T.$DN.MainThreadTextEditors),this.i,new o.$T(()=>h.document),m.selections.map(y.Selection.to),m.options,m.visibleRanges.map(D=>y.Range.to(D)),typeof m.editorPosition=="number"?y.ViewColumn.to(m.editorPosition):void 0);this.b.set(m.id,E)}r.newActiveEditor!==void 0&&(v.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,P.$Oc)(t),(0,P.$Oc)(u),r.removedDocuments&&this.e.fire(t),r.addedDocuments&&this.d.fire(g),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(m=>m.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return n.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const t=this.b.get(this.a);return r?t:t?.value}allEditors(){return[...this.b.values()]}};e.$mQ=l,e.$mQ=l=Ge([Ve(0,s.$cQ),Ve(1,a.$0j)],l),e.$nQ=(0,R.$Ci)("IExtHostDocumentsAndEditors")}),define(Oe[95],Ne([1,0,10,22,21,6,231,75,4,36,14,37,3,11,5,33,57,16,125,8,7,200,54,81,55,24]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l,i,r,t,g,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=e.$6pc=e.$5pc=e.$4pc=e.$3pc=void 0,i=We(i);let h=0;const E=new WeakMap;e.$3pc=(0,a.$Ci)("IExtHostTesting");let D=class extends $.$Tc{constructor(_,ge,se,ae){super(),this.C=ge,this.D=se,this.F=ae,this.f=this.B(new O.$je),this.g=new Map,this.w=this.B(new O.$je),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=_.getProxy(d.$DN.MainThreadTesting),this.m=new W(this.h),this.j=new f(this.h,ge),se.registerArgumentProcessor({processArgument:$e=>{switch($e?.$mid){case s.MarshalledId.TestItemContext:{const oe=$e,Ce=oe.tests[oe.tests.length-1].item.extId;return this.g.get(g.$3I.root(Ce))?.collection.tree.get(Ce)?.actual??(0,l.$oQ)($e)}case s.MarshalledId.TestMessageMenuArgs:{const{test:oe,message:Ce}=$e,Le=oe.item.extId;return{test:this.g.get(g.$3I.root(Le))?.collection.tree.get(Le)?.actual??(0,l.$oQ)({$mid:s.MarshalledId.TestItemContext,tests:[oe]}),message:i.TestMessage.to(Ce)}}default:return $e}}}),se.registerCommand(!1,"testing.getExplorerSelection",async()=>{const $e=await se.executeCommand(t.TestCommandId.GetExplorerSelection),oe=Ce=>{const Le=this.g.get(g.$3I.root(Ce));if(Le)return g.$3I.isRoot(Ce)?Le.controller:Le.collection.tree.get(Ce)?.actual};return{include:$e?.include.map(oe).filter(A.$kg)||[],exclude:$e?.exclude.map(oe).filter(A.$kg)||[]}})}createTestController(_,ge,se,ae){if(this.g.has(ge))throw new Error(`Attempt to insert a duplicate controller with ID "${ge}"`);const $e=new $.$Sc,oe=$e.add(new l.$rQ(ge,se,this.F));oe.root.label=se;const Ce=new Map,Le=new Set,Z=this.h,q={items:oe.root.children,get label(){return se},set label(ve){se=ve,oe.root.label=ve,Z.$updateController(ge,{label:se})},get refreshHandler(){return ae},set refreshHandler(ve){ae=ve,Z.$updateController(ge,{canRefresh:!!ve})},get id(){return ge},createRunProfile:(ve,ce,we,ue,X,x)=>{let me=(0,T.$qj)(ve);for(;Ce.has(me);)me++;return new F(this.h,Ce,Le,this.w.event,ge,me,ve,ce,we,ue,X,x)},createTestItem(ve,ce,we){return new l.$pQ(ge,ve,ce,we)},createTestRun:(ve,ce,we=!0)=>this.j.createTestRun(_,ge,oe,ve,ce,we),invalidateTestResults:ve=>{if(ve===void 0)this.h.$markTestRetired(void 0);else{const ce=ve instanceof Array?ve:[ve];this.h.$markTestRetired(ce.map(we=>g.$3I.fromExtHostTestItem(we,ge).toString()))}},set resolveHandler(ve){oe.resolveHandler=ve},get resolveHandler(){return oe.resolveHandler},dispose:()=>{$e.dispose()}};Z.$registerTestController(ge,se,!!ae),$e.add((0,$.$Rc)(()=>Z.$unregisterTestController(ge)));const te={controller:q,collection:oe,profiles:Ce,extension:_,activeProfiles:Le};return this.g.set(ge,te),$e.add((0,$.$Rc)(()=>this.g.delete(ge))),$e.add(oe.onDidGenerateDiff(ve=>Z.$publishDiff(ge,ve.map(m.TestsDiffOp.serialize)))),q}createTestObserver(){return this.m.checkout()}async runTests(_,ge=P.CancellationToken.None){const se=w(_);if(!se)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ae=this.g.get(se.controllerId);if(!ae)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:_.preserveFocus??!0,group:K[se.kind],targets:[{testIds:_.include?.map($e=>g.$3I.fromExtHostTestItem($e,ae.collection.root.id).toString())??[ae.collection.root.id],profileId:se.profileId,controllerId:se.controllerId}],exclude:_.exclude?.map($e=>$e.id)},ge)}registerTestFollowupProvider(_){return this.y.add(_),{dispose:()=>{this.y.delete(_)}}}$syncTests(){for(const{collection:_}of this.g.values())_.flushDiff();return Promise.resolve()}async $getCoverageDetails(_,ge,se){return(await this.j.getCoverageDetails(_,ge,se))?.map(i.TestCoverage.fromDetails)}async $disposeRun(_){this.j.disposeTestRun(_)}$configureRunProfile(_,ge){this.g.get(_)?.profiles.get(ge)?.configureHandler?.()}$setDefaultRunProfiles(_){const ge=new Map;for(const[se,ae]of Object.entries(_)){const $e=this.g.get(se);if(!$e)continue;const oe=new Map,Ce=ae.filter(Z=>!$e.activeProfiles.has(Z)),Le=[...$e.activeProfiles].filter(Z=>!ae.includes(Z));for(const Z of Ce)oe.set(Z,!0),$e.activeProfiles.add(Z);for(const Z of Le)oe.set(Z,!1),$e.activeProfiles.delete(Z);oe.size&&ge.set(se,oe)}this.w.fire(ge)}async $refreshTests(_,ge){await this.g.get(_)?.controller.refreshHandler?.(ge)}$publishTestResults(_){this.results=Object.freeze(_.map(ge=>{const se=i.TestResults.to(ge);return E.set(se,ge.id),se}).concat(this.results).sort((ge,se)=>se.completedAt-ge.completedAt).slice(0,32)),this.f.fire()}async $expandTest(_,ge){const se=this.g.get(g.$3I.fromString(_).controllerId)?.collection;se&&(await se.expand(_,ge<0?1/0:ge),se.flushDiff())}$acceptDiff(_){this.m.applyDiff(_.map(ge=>m.TestsDiffOp.deserialize({asCanonicalUri:se=>se},ge)))}async $runControllerTests(_,ge){return Promise.all(_.map(se=>this.G(se,!1,ge)))}async $startContinuousRun(_,ge){const se=new P.$ue(ge),ae=await Promise.all(_.map($e=>this.G($e,!0,se.token)));return!ge.isCancellationRequested&&!ae.some($e=>$e.error)&&await new Promise($e=>ge.onCancellationRequested($e)),se.dispose(!0),ae}async $provideTestFollowups(_,ge){const se=this.results.find(oe=>E.get(oe)===_.resultId),ae=se&&Y(g.$3I.fromString(_.extId),se?.results);if(!ae)return[];let $e=[];return await Promise.all([...this.y].map(async oe=>{try{const Ce=await oe.provideFollowup(se,ae,_.taskIndex,_.messageIndex,ge);Ce&&($e=$e.concat(Ce))}catch(Ce){this.C.error("Error thrown while providing followup for test message",Ce)}})),ge.isCancellationRequested?[]:$e.map(oe=>{const Ce=h++;return this.z.set(Ce,oe),{title:oe.title,id:Ce}})}$disposeTestFollowups(_){for(const ge of _)this.z.delete(ge)}$executeTestFollowup(_){const ge=this.z.get(_);return ge?this.D.executeCommand(ge.command,...ge.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(_){_===void 0?this.j.cancelAllRuns():this.j.cancelRunById(_)}getMetadataForRun(_){for(const ge of this.j.trackers){const se=ge.getTaskIdForRun(_);if(se)return{taskId:se,runId:ge.id}}}async G(_,ge,se){const ae=this.g.get(_.controllerId);if(!ae)return{};const{collection:$e,profiles:oe,extension:Ce}=ae,Le=oe.get(_.profileId);if(!Le)return{};const Z=_.testIds.map(ce=>$e.tree.get(ce)).filter(A.$kg),q=_.excludeExtIds.map(ce=>ae.collection.tree.get(ce)).filter(A.$kg).filter(ce=>Z.some(we=>we.fullId.compare(ce.fullId)===g.TestPosition.IsChild));if(!Z.length)return{};const te=new r.$iP(Z.some(ce=>ce.actual instanceof l.$qQ)?void 0:Z.map(ce=>ce.actual),q.map(ce=>ce.actual),Le,ge),ve=(0,m.$6I)(_)&&this.j.prepareForMainThreadTestRun(Ce,te,M.fromInternal(_,ae.collection),Le,se);try{return await Le.runHandler(te,se),{}}catch(ce){return{error:String(ce)}}finally{ve&&ve.hasRunningTasks&&!se.isCancellationRequested&&await O.Event.toPromise(ve.onEnd)}}};e.$4pc=D,e.$4pc=D=Ge([Ve(0,c.$cQ),Ve(1,S.$0j),Ve(2,n.$yQ),Ve(3,o.$nQ)],D);const b=1e4;var k;(function(le){le[le.Running=0]="Running",le[le.Cancelling=1]="Cancelling",le[le.Ended=2]="Ended"})(k||(k={}));class C extends $.$Tc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(_,ge,se,ae,$e,oe){super(),this.z=_,this.C=ge,this.D=se,this.F=ae,this.G=$e,this.c=k.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$je),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new P.$ue(oe));const Ce=this.B(new v.$Oh(()=>this.H(),b));this.B(this.j.token.onCancellationRequested(()=>Ce.schedule()));const Le=new O.$je;this.w=Le.event,this.B((0,$.$Rc)(()=>{Le.fire(),Le.dispose()}))}getTaskIdForRun(_){for(const[ge,{run:se}]of this.g)if(se===_)return ge}cancel(){this.c===k.Running?(this.j.cancel(),this.c=k.Cancelling):this.c===k.Cancelling&&this.H()}async getCoverageDetails(_,ge,se){const[,ae]=g.$3I.fromString(_).path,$e=this.y.get(_);if(!$e)return[];const{report:oe,extIds:Ce}=$e,Le=this.g.get(ae);if(!Le)throw new Error("unreachable: run task was not found");let Z;if(ge&&oe instanceof r.$oP){const te=Ce.indexOf(ge);if(te===-1)return[];Z=oe.fromTests[te]}return await(Z?this.F?.loadDetailedCoverageForTest?.(Le.run,oe,Z,se):this.F?.loadDetailedCoverage?.(Le.run,oe,se))??[]}createRun(_){const ge=this.z.id,se=this.z.controllerId,ae=(0,y.$Yg)(),$e=Z=>(q,...te)=>{if(Ce){this.D.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}this.J(q),Z(q,...te)},oe=(Z,q)=>{const te=q instanceof Array?q.map(i.TestMessage.from):[i.TestMessage.from(q)];if(Z.uri&&Z.range){const ve={range:i.Range.from(Z.range),uri:Z.uri};for(const ce of te)ce.location=ce.location||ve}this.C.$appendTestMessagesInRun(ge,ae,g.$3I.fromExtHostTestItem(Z,se).toString(),te)};let Ce=!1;const Le={isPersisted:this.z.isPersisted,token:this.j.token,name:_,onDidDispose:this.w,addCoverage:Z=>{if(Ce)return;const q=Z instanceof r.$oP?Z.fromTests:[];if(q.length){(0,p.$dH)(this.G,"attributableCoverage");for(const ce of q)this.J(ce)}const te=Z.uri.toString(),ve=new g.$3I([ge,ae,te]).toString();this.y.set(ve,{report:Z,extIds:q.map(ce=>g.$3I.fromExtHostTestItem(ce,se).toString())}),this.C.$appendCoverage(ge,ae,i.TestCoverage.fromFile(se,ve,Z))},enqueued:$e(Z=>{this.C.$updateTestStateInRun(ge,ae,g.$3I.fromExtHostTestItem(Z,se).toString(),m.TestResultState.Queued)}),skipped:$e(Z=>{this.C.$updateTestStateInRun(ge,ae,g.$3I.fromExtHostTestItem(Z,se).toString(),m.TestResultState.Skipped)}),started:$e(Z=>{this.C.$updateTestStateInRun(ge,ae,g.$3I.fromExtHostTestItem(Z,se).toString(),m.TestResultState.Running)}),errored:$e((Z,q,te)=>{oe(Z,q),this.C.$updateTestStateInRun(ge,ae,g.$3I.fromExtHostTestItem(Z,se).toString(),m.TestResultState.Errored,te)}),failed:$e((Z,q,te)=>{oe(Z,q),this.C.$updateTestStateInRun(ge,ae,g.$3I.fromExtHostTestItem(Z,se).toString(),m.TestResultState.Failed,te)}),passed:$e((Z,q)=>{this.C.$updateTestStateInRun(ge,ae,g.$3I.fromExtHostTestItem(Z,this.z.controllerId).toString(),m.TestResultState.Passed,q)}),appendOutput:(Z,q,te)=>{Ce||(te&&this.J(te),this.C.$appendOutputToRun(ge,ae,I.$Le.fromString(Z),q&&i.location.from(q),te&&g.$3I.fromExtHostTestItem(te,se).toString()))},end:()=>{Ce||(Ce=!0,this.C.$finishedTestRunTask(ge,ae),--this.f||this.I())}};return this.f++,this.g.set(ae,{run:Le}),this.C.$startedTestRunTask(ge,{id:ae,name:_,running:!0}),Le}H(){for(const{run:_}of this.g.values())_.end()}I(){this.c!==k.Ended&&(this.c=k.Ended,this.m.fire())}J(_){if(!(_ instanceof l.$pQ))throw new u.$7P(_.id);if(this.h.has(g.$3I.fromExtHostTestItem(_,this.z.controllerId).toString()))return;const ge=[],se=this.z.colllection.root;for(;;){const ae=i.TestItem.from(_);if(ge.unshift(ae),this.h.has(ae.extId)||(this.h.add(ae.extId),_===se))break;_=_.parent||se}this.C.$addTestsToRun(this.z.controllerId,this.z.id,ge)}dispose(){this.I(),super.dispose()}}class f{get trackers(){return this.c.values()}constructor(_,ge){this.g=_,this.h=ge,this.c=new Map,this.f=new Map}getCoverageDetails(_,ge,se){const ae=g.$3I.root(_);return this.f.get(ae)?.getCoverageDetails(_,ge,se)||[]}disposeTestRun(_){this.f.get(_)?.dispose(),this.f.delete(_);for(const[ge,{id:se}]of this.c)se===_&&this.c.delete(ge)}prepareForMainThreadTestRun(_,ge,se,ae,$e){return this.j(ge,se,ae,_,$e)}cancelRunById(_){this.f.get(_)?.cancel()}cancelAllRuns(){for(const _ of this.c.values())_.cancel()}createTestRun(_,ge,se,ae,$e,oe){const Ce=this.c.get(ae);if(Ce)return Ce.createRun($e);const Le=M.fromPublic(ge,se,ae,oe),Z=w(ae);this.g.$startedExtensionTestRun({controllerId:ge,continuous:!!ae.continuous,profile:Z&&{group:K[Z.kind],id:Z.profileId},exclude:ae.exclude?.map(te=>g.$3I.fromExtHostTestItem(te,se.root.id).toString())??[],id:Le.id,include:ae.include?.map(te=>g.$3I.fromExtHostTestItem(te,se.root.id).toString())??[se.root.id],preserveFocus:ae.preserveFocus??!0,persist:oe});const q=this.j(ae,Le,ae.profile,_);return O.Event.once(q.onEnd)(()=>{this.g.$finishedExtensionTestRun(Le.id)}),q.createRun($e)}j(_,ge,se,ae,$e){const oe=new C(ge,this.g,this.h,se,ae,$e);return this.c.set(_,oe),this.f.set(oe.id,oe),oe}}e.$5pc=f;const w=le=>{if(le.profile){if(!(le.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return le.profile}};class M{static fromPublic(_,ge,se,ae){return new M(_,(0,y.$Yg)(),ae,ge)}static fromInternal(_,ge){return new M(_.controllerId,_.runId,!0,ge)}constructor(_,ge,se,ae){this.controllerId=_,this.id=ge,this.isPersisted=se,this.colllection=ae}}e.$6pc=M;class N{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(_){this.j=_,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(_){this.c.add(_)}update(_){Object.assign(_.revived,i.TestItem.toPlain(_.item)),this.c.has(_)||this.f.add(_)}remove(_){if(this.c.has(_)){this.c.delete(_);return}this.f.delete(_);const ge=g.$3I.parentId(_.item.extId);if(ge&&this.h.has(ge.toString())){this.h.add(_.item.extId);return}this.g.add(_)}getChangeEvent(){const{c:_,f:ge,g:se}=this;return{get added(){return[..._].map(ae=>ae.revived)},get updated(){return[...ge].map(ae=>ae.revived)},get removed(){return[...se].map(ae=>ae.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class L extends m.$_I{constructor(){super(...arguments),this.y=new O.$je,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(_){return this.f.get(_)}getMirroredTestDataByReference(_){return this.f.get(_.id)}x(_,ge){return{..._,revived:i.TestItem.toPlain(_.item),depth:ge?ge.depth+1:0,children:new Set}}w(){return new N(this.y)}}class W{constructor(_){this.f=_}checkout(){this.c||(this.c=this.g());const _=this.c;return _.observers++,{onDidChangeTest:_.tests.onDidChangeTests,get tests(){return[..._.tests.rootTests].map(ge=>ge.revived)},dispose:(0,R.$cb)(()=>{--_.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(_){return this.c?.tests.getMirroredTestDataByReference(_)}applyDiff(_){this.c?.tests.apply(_)}g(){const _=new L({asCanonicalUri:ge=>ge});return this.f.$subscribeToDiffs(),{observers:0,tests:_}}}const G=(le,_,ge,se)=>{ge?Object.assign(ge,se):_.$updateTestRunConfig(le.controllerId,le.profileId,se)};class F{#e;#t;#i;#n;#s;get label(){return this.f}set label(_){_!==this.f&&(this.f=_,G(this,this.#e,this.#n,{label:_}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(_){_!==this.g&&(this.g=_,G(this,this.#e,this.#n,{supportsContinuousRun:_}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(_){_!==this.isDefault&&(_?this.#t.add(this.profileId):this.#t.delete(this.profileId),G(this,this.#e,this.#n,{isDefault:_}))}get tag(){return this._tag}set tag(_){_?.id!==this._tag?.id&&(this._tag=_,G(this,this.#e,this.#n,{tag:_?i.TestTag.namespace(this.controllerId,_.id):null}))}get configureHandler(){return this.c}set configureHandler(_){_!==this.c&&(this.c=_,G(this,this.#e,this.#n,{hasConfigurationHandler:!!_}))}get onDidChangeDefault(){return O.Event.chain(this.#i,_=>_.map(ge=>ge.get(this.controllerId)?.get(this.profileId)).filter(A.$kg))}constructor(_,ge,se,ae,$e,oe,Ce,Le,Z,q=!1,te=void 0,ve=!1){this.controllerId=$e,this.profileId=oe,this.f=Ce,this.kind=Le,this.runHandler=Z,this._tag=te,this.g=ve,this.#e=_,this.#s=ge,this.#t=se,this.#i=ae,ge.set(oe,this);const ce=K[Le];if(typeof ce!="number")throw new Error(`Unknown TestRunProfile.group ${Le}`);q&&se.add(oe),this.#n={profileId:oe,controllerId:$e,tag:te?i.TestTag.namespace(this.controllerId,te.id):null,label:Ce,group:ce,isDefault:q,hasConfigurationHandler:!1,supportsContinuousRun:ve},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$7pc=F;const K={[r.TestRunProfileKind.Coverage]:m.TestRunProfileBitset.Coverage,[r.TestRunProfileKind.Debug]:m.TestRunProfileBitset.Debug,[r.TestRunProfileKind.Run]:m.TestRunProfileBitset.Run};function Y(le,_){for(let ge=0;ge<le.path.length;ge++){const se=_.find(ae=>ae.id===le.path[ge]);if(!se)return;if(ge===le.path.length-1)return se;_=se.children}}}),define(Oe[259],Ne([1,0,17,6,4,5,127,8,7]),function(be,e,v,I,P,O,R,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=void 0,v=We(v),T=We(T);class s extends P.$Tc{constructor(y,a){super(),this.m=a,this.a=new I.$je,this.b=new I.$je,this.c=new I.$je,this.f=new I.$je,this.g=new I.$je,this.h=new I.$je,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=y.getProxy(O.$DN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(S=>this.h.fire(S))),this.B(this.m.onDidChangeActiveTextEditor(S=>this.g.fire(S)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(y){const a=this.m.allEditors();return y?a:a.map(S=>S.value)}async showTextDocument(y,a,S){let d;typeof a=="number"?d={position:T.ViewColumn.from(a),preserveFocus:S}:typeof a=="object"?d={position:T.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?T.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:d={preserveFocus:!1};const n=await this.j.$tryShowTextDocument(y.uri,d),o=n&&this.m.getEditor(n);if(o)return o.value;throw n?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,a){return new R.$jQ(this.j,y,a).value}$acceptEditorPropertiesChanged(y,a){const S=this.m.getEditor(y);if(!S)throw new Error("unknown text editor");if(a.options&&S._acceptOptions(a.options),a.selections){const d=a.selections.selections.map(T.Selection.to);S._acceptSelections(d)}if(a.visibleRanges){const d=v.$Gb(a.visibleRanges.map(T.Range.to));S._acceptVisibleRanges(d)}if(a.options&&this.b.fire({textEditor:S.value,options:{...a.options,lineNumbers:T.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const d=$.TextEditorSelectionChangeKind.fromValue(a.selections.source),n=a.selections.selections.map(T.Selection.to);this.a.fire({textEditor:S.value,selections:n,kind:d})}if(a.visibleRanges){const d=v.$Gb(a.visibleRanges.map(T.Range.to));this.c.fire({textEditor:S.value,visibleRanges:d})}}$acceptEditorPositionData(y){for(const a in y){const S=this.m.getEditor(a);if(!S)throw new Error("Unknown text editor");const d=T.ViewColumn.to(y[a]);S.value.viewColumn!==d&&(S._acceptViewColumn(d),this.f.fire({textEditor:S.value,viewColumn:d}))}}getDiffInformation(y){return Promise.resolve(this.j.$getDiffInformation(y))}}e.$bpc=s}),define(Oe[260],Ne([1,0,2,3,5,4,7,8,18,36,14]),function(be,e,v,I,P,O,R,T,$,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zqc=e.$Yqc=void 0,e.$Yqc=(0,I.$Ci)("IExtHostTimeline");class y{constructor(d,n){this.b=new Map,this.c=new Map,this.a=d.getProxy(P.$DN.MainThreadTimeline),n.registerArgumentProcessor({processArgument:(o,c)=>{if(o&&o.$mid===s.MarshalledId.TimelineActionContext)if(this.b.get(o.source)&&$.$on.equals(c,this.b.get(o.source)?.extension)){const l=o.uri===void 0?void 0:v.URI.revive(o.uri);return this.c.get(o.source)?.get(a(l))?.get(o.handle)}else return;return o}})}async $getTimeline(d,n,o,c){return this.b.get(d)?.provider.provideTimeline(v.URI.revive(n),o,c)}registerTimelineProvider(d,n,o,c){const l=new O.$Sc,i=this.d(n.id,c,l).bind(this);let r;n.onDidChange&&(r=n.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:n.id}),this));const t=this.c;return this.f({...n,scheme:d,onDidChange:void 0,async provideTimeline(g,u,m){u?.resetCache&&(l.clear(),t.get(n.id)?.clear());const p=await n.provideTimeline(g,u,m);if(p==null)return;const h=i(g,u);return{...p,source:n.id,items:p.items.map(h)}},dispose(){for(const g of t.values())g.get(n.id)?.clear();r?.dispose(),l.dispose()}},o)}d(d,n,o){return(c,l)=>{let i;if(l?.cacheResults){let r=this.c.get(d);r===void 0&&(r=new Map,this.c.set(d,r));const t=a(c);i=r.get(t),i===void 0&&(i=new Map,r.set(t,i))}return r=>{const{iconPath:t,...g}=r,u=`${d}|${r.id??r.timestamp}`;i?.set(u,r);let m,p,h;r.iconPath&&(t instanceof R.$EO?h={id:t.id,color:t.color}:v.URI.isUri(t)?(m=t,p=t):{light:m,dark:p}=t);let E;return R.$0N.isMarkdownString(g.tooltip)?E=T.MarkdownString.from(g.tooltip):(0,A.$cg)(g.tooltip)?E=g.tooltip:R.$0N.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=T.MarkdownString.from(g.detail)):(0,A.$cg)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=g.detail),{...g,id:g.id??void 0,handle:u,source:d,command:r.command?n.toInternal(r.command,o):void 0,icon:m,iconDark:p,themeIcon:h,tooltip:E,accessibilityInformation:r.accessibilityInformation}}}}f(d,n){if(this.b.get(d.id))throw new Error(`Timeline Provider ${d.id} already exists.`);return this.a.$registerTimelineProvider({id:d.id,label:d.label,scheme:d.scheme}),this.b.set(d.id,{provider:d,extension:n}),(0,O.$Rc)(()=>{for(const c of this.c.values())c.get(d.id)?.clear();this.b.delete(d.id),this.a.$unregisterTimelineProvider(d.id),d.dispose()})}}e.$Zqc=y;function a(S){return S?.toString()}}),define(Oe[261],Ne([1,0,9,23,2,6,4,192,10,7,14,17,8,59,21,163,24]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1qc=void 0,s=We(s);function c(r,t){if((0,A.$cg)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let g;return Array.isArray(r.highlights)&&(g=r.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),g=g.length?g:void 0),{label:r.label,highlights:g}}}class l extends R.$Tc{constructor(t,g,u){super(),this.f=t,this.g=g,this.h=u,this.a=new Map,this.b=new n.$E_;function m(p){return p&&p.$treeViewId&&(p.$treeItemHandle||p.$selectedTreeItems||p.$focusedTreeItem)}g.registerArgumentProcessor({processArgument:p=>m(p)?this.r(p):Array.isArray(p)&&p.length>0?p.map(h=>m(h)?this.r(h):h):p})}registerTreeDataProvider(t,g,u){const m=this.createTreeView(t,{treeDataProvider:g},u);return{dispose:()=>m.dispose()}}createTreeView(t,g,u){if(!g||!g.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const m=g.dragAndDropController?.dropMimeTypes??[],p=g.dragAndDropController?.dragMimeTypes??[],h=!!g.dragAndDropController?.handleDrag,E=!!g.dragAndDropController?.handleDrop,D=this.m(t,g,u),b={showCollapseAll:!!g.showCollapseAll,canSelectMany:!!g.canSelectMany,dropMimeTypes:m,dragMimeTypes:p,hasHandleDrag:h,hasHandleDrop:E,manuallyManageCheckboxes:!!g.manageCheckboxStateManually},k=this.f.$registerTreeViewDataProvider(t,b),C={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,o.$dH)(u,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,o.$dH)(u,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(f){(0,S.$3k)(f)&&(0,o.$dH)(u,"treeViewMarkdownMessage"),D.message=f},get title(){return D.title},set title(f){D.title=f},get description(){return D.description},set description(f){D.description=f},get badge(){return D.badge},set badge(f){f!==void 0&&s.ViewBadge.isViewBadge(f)?D.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(D.badge=void 0)},reveal:(f,w)=>D.reveal(f,w),dispose:async()=>{await k,this.a.delete(t),D.dispose()}};return this.B(C),C}$getChildren(t,g){const u=this.a.get(t);return u?u.getChildren(g):Promise.reject(new T.$zG(t))}async $handleDrop(t,g,u,m,p,h,E,D){const b=this.a.get(t);if(!b)return Promise.reject(new T.$zG(t));const k=a.DataTransfer.toDataTransfer(u,async C=>(await this.f.$resolveDropFileData(t,g,C)).buffer);return E===t&&D&&await this.j(k,b,D,p,h),b.onDrop(k,m,p)}async j(t,g,u,m,p){const h=this.b.removeDragOperationTransfer(p);if(h)(await h)?.forEach((E,D)=>{E&&t.set(D,E)});else if(p&&g.handleDrag){const E=g.handleDrag(u,t,m);this.b.addDragOperationTransfer(p,E),await E}return t}async $handleDrag(t,g,u,m){const p=this.a.get(t);if(!p)return Promise.reject(new T.$zG(t));const h=await this.j(new s.$AO,p,g,m,u);if(!(!h||m.isCancellationRequested))return a.DataTransfer.from(h)}async $hasResolve(t){const g=this.a.get(t);if(!g)throw new T.$zG(t);return g.hasResolve}$resolve(t,g,u){const m=this.a.get(t);if(!m)throw new T.$zG(t);return m.resolveTreeItem(g,u)}$setExpanded(t,g,u){const m=this.a.get(t);if(!m)throw new T.$zG(t);m.setExpanded(g,u)}$setSelectionAndFocus(t,g,u){const m=this.a.get(t);if(!m)throw new T.$zG(t);m.setSelectionAndFocus(g,u)}$setVisible(t,g){const u=this.a.get(t);if(!u){if(!g)return;throw new T.$zG(t)}u.setVisible(g)}$changeCheckboxState(t,g){const u=this.a.get(t);if(!u)throw new T.$zG(t);u.setCheckboxState(g)}m(t,g,u){const m=this.B(new i(t,g,this.f,this.g.converter,this.h,u));return this.a.set(t,m),m}r(t){const g=this.a.get(t.$treeViewId);return g&&"$treeItemHandle"in t?g.getExtensionElement(t.$treeItemHandle):g&&"$focusedTreeItem"in t&&t.$focusedTreeItem?g.focusedElement:null}}e.$1qc=l;class i extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,A.$lg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,g,u,m,p,h){if(super(),this.I=t,this.J=u,this.L=m,this.M=p,this.N=h,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$je),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$je),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$je),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$je),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$je),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$je),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$je),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$ue,h.contributes&&h.contributes.views)for(const k in h.contributes.views)for(const C of h.contributes.views[k])C.id===t&&(this.P=C.name);this.f=g.treeDataProvider,this.g=g.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(k=>{Array.isArray(k)&&k.length===0||this.F.fire({message:!1,element:k})}));let E,D;const b=O.Event.debounce(this.F.event,(k,C)=>(k||(k={message:!1,elements:[]}),C.element!==!1&&(E||(E=new Promise(f=>D=f),this.G=this.G.then(()=>E)),Array.isArray(C.element)?k.elements.push(...C.element):k.elements.push(C.element)),C.message&&(k.message=!0),k),200,!0);this.B(b(({message:k,elements:C})=>{C.length&&(this.H=this.H.then(()=>{const f=D;return E=null,this.$(C).then(()=>f())})),k&&this.J.$setMessage(this.I,a.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const g=t?this.getExtensionElement(t):void 0;if(t&&!g)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let u=this.X(t);return u||(u=await this.Y(g)),u?u.map(m=>m.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,g){g=g||{select:!0,focus:!1};const u=(0,A.$lg)(g.select)?!0:g.select,m=(0,A.$lg)(g.focus)?!1:g.focus,p=(0,A.$lg)(g.expand)?!1:g.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(h=>this.W(t,h[h.length-1]).then(E=>this.J.$reveal(this.I,{item:E.item,parentChain:h.map(D=>D.item)},{select:u,focus:m,expand:p})),h=>this.M.error(h)):this.J.$reveal(this.I,void 0,{select:u,focus:m,expand:p})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=a.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,g){const u=this.getExtensionElement(t);u&&(g?this.u.fire(Object.freeze({element:u})):this.w.fire(Object.freeze({element:u})))}setSelectionAndFocus(t,g){const u=!(0,y.$tb)(this.s,t);this.s=t;const m=this.t!==g;this.t=g,u&&this.y.fire(Object.freeze({selection:this.selectedElements})),m&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const g=(await Promise.all(t.map(async u=>{const m=this.getExtensionElement(u.treeItemHandle);return m?{extensionItem:m,treeItem:await this.f.getTreeItem(m),newState:u.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);g.forEach(u=>{u.treeItem.checkboxState=u.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}),this.D.fire({items:g.map(u=>[u.extensionItem,u.newState])})}async handleDrag(t,g,u){const m=[];for(const p of t){const h=this.getExtensionElement(p);h&&m.push(h)}if(!(!this.g?.handleDrag||m.length===0))return await this.g.handleDrag(m,g,u),g}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,g,u){const m=g?this.getExtensionElement(g):void 0;if(!(!m&&g||!this.g?.handleDrop))return(0,$.$uh)(()=>this.g?.handleDrop?this.g.handleDrop(m,t,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,g){if(!this.f.resolveTreeItem)return;const u=this.j.get(t);if(u){const m=this.m.get(u);if(m){const p=await this.f.resolveTreeItem(m.extensionItem,u,g)??m.extensionItem;return this.hb(p),m.item.tooltip=this.eb(p.tooltip),m.item.command=this.fb(m.disposableStore,p.command),m.item}}}S(t){return this.U(t).then(g=>g?this.S(g).then(u=>this.W(g,u[u.length-1]).then(m=>(u.push(m),u))):Promise.resolve([]))}U(t){const g=this.m.get(t);return g?Promise.resolve(g.parent?this.j.get(g.parent.item.handle):void 0):(0,$.$uh)(()=>this.f.getParent(t))}W(t,g){const u=this.m.get(t);return u?Promise.resolve(u):(0,$.$uh)(()=>this.f.getTreeItem(t)).then(m=>this.kb(t,m,g,!0)).then(m=>this.getChildren(g?g.item.handle:void 0).then(()=>{const p=this.getExtensionElement(m);if(p){const h=this.m.get(p);if(h)return Promise.resolve(h)}throw new Error(`Cannot resolve tree item for element ${m} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let g;if(typeof t=="string"){const u=this.getExtensionElement(t);g=u?this.m.get(u):void 0}else g=t;return g&&g.children||void 0}return this.h}async Y(t){this.rb(t);const g=new d.$ue(this.Z.token);try{const u=t?this.m.get(t):void 0,m=await this.f.getChildren(t);if(g.token.isCancellationRequested)return;const p=(0,y.$Gb)(m||[]),h=await Promise.all((0,y.$Gb)(p).map(D=>this.f.getTreeItem(D)));if(g.token.isCancellationRequested)return;const E=h.map((D,b)=>D?this.db(p[b],D,u):null);return(0,y.$Gb)(E)}finally{g.dispose()}}$(t){if(t.some(u=>!u))return this.Z.dispose(!0),this.Z=new d.$ue,this.tb(),this.J.$refresh(this.I);{const u=this.ab(t);if(u.length)return this.bb(u)}return Promise.resolve(void 0)}ab(t){const g=new Set,u=t.map(p=>this.m.get(p));for(const p of u)if(p&&!g.has(p.item.handle)){let h=p;for(;h&&h.parent&&u.findIndex(E=>h&&h.parent&&E&&E.item.handle===h.parent.item.handle)===-1;){const E=this.j.get(h.parent.item.handle);h=E?this.m.get(E):void 0}h&&!h.parent&&g.add(p.item.handle)}const m=[];return g.forEach(p=>{const h=this.j.get(p);if(h){const E=this.m.get(h);E&&(!E.parent||!g.has(E.parent.item.handle))&&m.push(p)}}),m}bb(t){const g={};return Promise.all(t.map(u=>this.cb(u).then(m=>{m&&(g[u]=m.item)}))).then(()=>Object.keys(g).length?this.J.$refresh(this.I,g):void 0)}cb(t){const g=this.getExtensionElement(t);if(g){const u=this.m.get(g);if(u)return this.rb(g),(0,$.$uh)(()=>this.f.getTreeItem(g)).then(m=>{if(m){const p=this.ib(g,m,u.parent);return this.pb(g,p,u,u.parent),u.dispose(),p}return null})}return Promise.resolve(null)}db(t,g,u){const m=this.ib(t,g,u);if(g.id&&this.j.has(m.item.handle))throw new Error((0,v.localize)(10730,null,g.id));return this.ob(t,m),this.qb(m,u),m}eb(t){return s.$0N.isMarkdownString(t)?a.MarkdownString.from(t):t}fb(t,g){return g?{...this.L.toInternal(g,t),originalId:g.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let g,u,m;return typeof t.checkboxState=="number"?g=t.checkboxState:(g=t.checkboxState.state,u=t.checkboxState.tooltip,m=t.checkboxState.accessibilityInformation),{isChecked:g===s.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:m}}hb(t){if(!s.$vO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,g,u){this.hb(g);const m=this.B(new R.$Sc),p=this.kb(t,g,u),h=this.lb(g);return{item:{handle:p,parentHandle:u?u.item.handle:void 0,label:c(g.label,this.N),description:g.description,resourceUri:g.resourceUri,tooltip:this.eb(g.tooltip),command:this.fb(m,g.command),contextValue:g.contextValue,icon:h,iconDark:this.mb(g)||h,themeIcon:this.jb(g),collapsibleState:(0,A.$lg)(g.collapsibleState)?s.TreeItemCollapsibleState.None:g.collapsibleState,accessibilityInformation:g.accessibilityInformation,checkbox:this.gb(g)},extensionItem:g,parent:u,children:void 0,disposableStore:m,dispose(){m.dispose()}}}jb(t){return t.iconPath instanceof s.$EO?t.iconPath:void 0}kb(t,{id:g,label:u,resourceUri:m},p,h){if(g)return`${i.b}/${g}`;const E=c(u,this.N),D=p?p.item.handle:i.a;let b=E?E.label:m?(0,I.$ah)(m):"";b=b.indexOf("/")!==-1?b.replace("/","//"):b;const k=this.m.has(t)?this.m.get(t).item.handle:void 0,C=this.X(p)||[];let f,w=0;do{if(f=`${D}/${w}:${b}`,h||!this.j.has(f)||k===f)break;w++}while(w<=C.length);return f}lb(t){if(t.iconPath&&!(t.iconPath instanceof s.$EO))return typeof t.iconPath=="string"||P.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof s.$EO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return P.URI.isUri(t)?t:P.URI.file(t)}ob(t,g){this.j.set(g.item.handle,t),this.m.set(t,g)}pb(t,g,u,m){this.j.delete(g.item.handle),this.m.delete(t),g.item.handle!==u.item.handle&&this.j.delete(u.item.handle),this.ob(t,g);const p=this.X(m)||[],h=p.filter(E=>E.item.handle===u.item.handle)[0];h&&p.splice(p.indexOf(h),1,g)}qb(t,g){g?(g.children||(g.children=[]),g.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const g=this.m.get(t);if(g){if(g.children)for(const u of g.children){const m=this.j.get(u.item.handle);m&&this.sb(m)}g.children=void 0}}else this.tb()}sb(t){const g=this.m.get(t);if(g){if(g.children)for(const u of g.children){const m=this.j.get(u.item.handle);m&&this.sb(m)}this.m.delete(t),this.j.delete(g.item.handle),g.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Oe[262],Ne([1,0,6,4,2,37,8,67,5,7]),function(be,e,v,I,P,O,R,T,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$upc=void 0,R=We(R),$=We($),s=We(s);class A extends I.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(d,n,o,c){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new v.$je),this.onDidDispose=this.#d.event,this.#h=this.B(new v.$je),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=n,this.#n=o,this.#i=c.viewType,this.#s=c.panelOptions,this.#o=c.viewColumn,this.#r=c.title,this.#l=c.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,P.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(d){this.#u||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#l=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,n){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:R.ViewColumn.from(d),preserveFocus:!!n})}c(){if(this.#u)throw new Error("Webview is disposed")}}class y extends I.$Tc{static c(){return(0,O.$Yg)()}constructor(d,n,o){super(),this.j=n,this.m=o,this.g=new Map,this.h=new Map,this.f=d.getProxy($.$DN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,n,o,c,l={}){const i=typeof c=="object"?c.viewColumn:c,r={viewColumn:R.ViewColumn.from(i),preserveFocus:typeof c=="object"&&!!c.preserveFocus},t=(0,T.$qpc)(d),g=y.c();this.f.$createWebviewPanel((0,T.$spc)(d),g,n,{title:o,panelOptions:a(l),webviewOptions:(0,T.$tpc)(d,this.m,l),serializeBuffersForPostMessage:t},r);const u=this.j.createNewWebview(g,l,d);return this.createNewWebviewPanel(g,n,o,i,l,u,!0)}$onDidChangeWebviewPanelViewStates(d){const n=Object.keys(d);n.sort((o,c)=>{const l=d[o],i=d[c];return l.active?1:i.active?-1:+l.visible-+i.visible});for(const o of n){const c=this.getWebviewPanel(o);if(!c)continue;const l=d[o];c._updateViewState({active:l.active,visible:l.visible,viewColumn:R.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,n,o){if(this.h.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.h.set(n,{serializer:o,extension:d}),this.f.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.$qpc)(d)}),new s.$FN(()=>{this.h.delete(n),this.f.$unregisterSerializer(n)})}async $deserializeWebviewPanel(d,n,o,c){const l=this.h.get(n);if(!l)throw new Error(`No serializer found for '${n}'`);const{serializer:i,extension:r}=l,t=this.j.createNewWebview(d,o.webviewOptions,r),g=this.createNewWebviewPanel(d,n,o.title,c,o.panelOptions,t,o.active);await i.deserializeWebviewPanel(g,o.state)}createNewWebviewPanel(d,n,o,c,l,i,r){const t=new A(d,this.f,i,{viewType:n,title:o,viewColumn:c,panelOptions:l,active:r});return this.g.set(d,t),t}getWebviewPanel(d){return this.g.get(d)}}e.$upc=y;function a(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(Oe[263],Ne([1,0,6,4,67,8,5,7]),function(be,e,v,I,P,O,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4qc=void 0,R=We(R),T=We(T);class $ extends I.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,a,S,d,n,o){super(),this.#s=!1,this.#l=this.B(new v.$je),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new v.$je),this.onDidDispose=this.#u.event,this.#i=S,this.#a=d,this.#e=y,this.#t=a,this.#n=n,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class s{constructor(y,a){this.d=a,this.b=new Map,this.c=new Map,this.a=y.getProxy(R.$DN.MainThreadWebviewViews)}registerWebviewViewProvider(y,a,S,d){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:S,extension:y}),this.a.$registerWebviewViewProvider((0,P.$spc)(y),a,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$qpc)(y)}),new T.$FN(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(y,a,S,d,n){const o=this.b.get(a);if(!o)throw new Error(`No view provider found for '${a}'`);const{provider:c,extension:l}=o,i=this.d.createNewWebview(y,{},l),r=new $(y,this.a,a,S,i,!0);this.c.set(y,r),await c.resolveWebviewView(r,{state:d},n)}async $onDidChangeWebviewViewVisibility(y,a){this.e(y)._setVisible(a)}async $disposeWebviewView(y){const a=this.e(y);this.c.delete(y),a.dispose(),this.d.deleteWebview(y)}e(y){const a=this.c.get(y);if(!a)throw new Error("No webview found");return a}}e.$4qc=s}),define(Oe[264],Ne([1,0,6,30,31,3]),function(be,e,v,I,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=e.$YM=e.OutputChannelUpdateMode=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=void 0,e.$LM="text/x-code-output",e.$MM="output",e.$NM="Log",e.$OM="text/x-code-log-output",e.$PM="log",e.$QM="workbench.panel.output",e.$RM=new P.$Tj("inOutput",!1),e.$SM=new P.$Tj("activeLogOutput",!1),e.$TM=new P.$Tj("activeLogOutput.levelSettable",!1),e.$UM=new P.$Tj("activeLogOutput.level",""),e.$VM=new P.$Tj("activeLogOutput.levelIsDefault",!1),e.$WM=new P.$Tj("outputView.scrollLock",!1),e.$XM=(0,O.$Ci)("outputService");var R;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$YM={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new v.$je,this.onDidRegisterChannel=this.b.event,this.c=new v.$je,this.onDidRemoveChannel=this.c.event}registerChannel(s){this.a.has(s.id)||(this.a.set(s.id,s),this.b.fire(s.id))}getChannels(){const s=[];return this.a.forEach(A=>s.push(A)),s}getChannel(s){return this.a.get(s)}removeChannel(s){this.a.delete(s),this.c.fire(s)}}I.$oo.add(e.$YM.OutputChannels,new T),e.$ZM=new P.$Tj("activeOutputChannel","")}),define(Oe[128],Ne([1,0,5,3,16,18,11,264,68,26,50,165,22,14,29,6,4]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hqc=e.$Gqc=void 0;class c extends R.$dk{get disposed(){return this.n}constructor(t,g,u,m,p){super(),this.id=t,this.name=g,this.r=u,this.s=m,this.extension=p,this.m=0,this.n=!1,this.visible=!1,this.setLevel(u.getLevel()),this.B(u.onDidChangeLogLevel(h=>this.setLevel(h)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,t)}replace(t){const g=this.m;this.info(t),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,g),this.visible&&this.r.flush()}show(t,g){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:g))}hide(){this.s.$close(this.id)}g(t,g){this.m+=a.$Le.fromString(g).byteLength,(0,R.log)(this.r,t,g),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class l extends c{appendLine(t){this.append(t)}}let i=class{constructor(t,g,u,m,p,h){this.i=g,this.j=u,this.k=m,this.l=p,this.m=h,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(v.$DN.MainThreadOutputService),this.b=this.k.extUri.joinPath(g.logsLocation,`output_logging_${(0,y.$1m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[g,u]of this.g)u.visible=g===this.h}createOutputChannel(t,g,u){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const m=typeof g=="object"&&g.log,p=(0,S.$cg)(g)?g:void 0;if((0,S.$cg)(p)&&!p.trim())throw new Error("illegal argument `languageId`. must not be empty");let h;const E=this.i.environment.extensionLogLevel?.find(([b])=>O.$on.equals(u.identifier,b))?.[1];E&&(h=(0,R.$ok)(E));const D=m?this.o(t,h,u):this.n(t,p,u);return D.then(b=>{this.g.set(b.id,b),b.visible=b.id===this.h}),m?this.r(t,h??this.m.getLevel(),D):this.q(t,D)}async n(t,g,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const m=await this.c,p=this.k.extUri.joinPath(m,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),h=this.l.createLogger(p,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.a.$register(t,p,g,u.identifier.value);return new c(E,t,h,this.a,u)}async o(t,g,u){const m=await this.p(u),p=t.replace(/[\\/:\*\?"<>\|]/g,""),h=this.k.extUri.joinPath(m,`${p}.log`),E=`${u.identifier.value}.${p}`,D=this.l.createLogger(h,{id:E,name:t,logLevel:g,extensionId:u.identifier.value});return new l(E,t,D,this.a,u)}p(t){let g=this.d.get(t.identifier.value);if(!g){const u=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,g=(async()=>{try{await this.j.value.createDirectory(u)}catch(m){if((0,d.$nl)(m)!==d.FileSystemProviderErrorCode.FileExists)throw m}return u})())}return g}q(t,g){let u=!1;const m=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return t},append(p){m(),g.then(h=>h.append(p))},appendLine(p){m(),g.then(h=>h.appendLine(p))},clear(){m(),g.then(p=>p.clear())},replace(p){m(),g.then(h=>h.replace(p))},show(p,h){m(),g.then(E=>E.show(p,h))},hide(){m(),g.then(p=>p.hide())},dispose(){u=!0,g.then(p=>p.dispose())}}}r(t,g,u){const m=new o.$Sc,p=()=>{if(m.isDisposed)throw new Error("Channel has been closed")},h=m.add(new n.$je);function E(D){g=D,h.fire(D)}return u.then(D=>{m.add(D),D.logLevel!==g&&E(D.logLevel),m.add(D.onDidChangeLogLevel(b=>E(b)))}),{...this.q(t,u),get logLevel(){return g},onDidChangeLogLevel:h.event,trace(D,...b){p(),u.then(k=>k.trace(D,...b))},debug(D,...b){p(),u.then(k=>k.debug(D,...b))},info(D,...b){p(),u.then(k=>k.info(D,...b))},warn(D,...b){p(),u.then(k=>k.warn(D,...b))},error(D,...b){p(),u.then(k=>k.error(D,...b))},dispose(){m.dispose()}}}};e.$Gqc=i,e.$Gqc=i=Ge([Ve(0,P.$cQ),Ve(1,s.$sQ),Ve(2,$.$mpc),Ve(3,A.$2oc),Ve(4,R.$$j),Ve(5,R.$0j)],i),e.$Hqc=(0,I.$Ci)("IExtHostOutputService")}),define(Oe[129],Ne([1,0,3,10]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=void 0,e.$Tm=(0,v.$Ci)("remoteAgentService"),e.$Um=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let O=1/0;for(let T=0;T<this.maxSampleCount;T++){const $=await P.getRoundTripTime();if($===void 0)return;O=Math.min(O,$/2),await(0,I.$Dh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(O):R=this.initial.reduce((T,$)=>T+$,0)/this.initial.length,this.lastMeasurement={initial:R,current:O,average:this.average.reduce((T,$)=>T+$,0)/this.average.length,high:typeof R>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Oe[265],Ne([1,0,9,53,30,49,43,4,6,129,20,25,10,113]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=void 0,e.$_K=Object.freeze({id:"application",order:100,title:(0,v.localize)(12453,null),type:"object"}),e.$aL=Object.freeze({id:"workbench",order:7,title:(0,v.localize)(12454,null),type:"object"}),e.$bL=Object.freeze({id:"security",scope:I.ConfigurationScope.APPLICATION,title:(0,v.localize)(12455,null),type:"object",order:7}),e.$cL=Object.freeze({id:"problems",title:(0,v.localize)(12456,null),type:"object",order:101}),e.$dL=Object.freeze({id:"window",order:8,title:(0,v.localize)(12457,null),type:"object"}),e.$eL={ConfigurationMigration:"base.contributions.configuration.migration"};class d{constructor(){this.migrations=[],this.a=new $.$je,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const n=new d;P.$oo.add(e.$eL.ConfigurationMigration,n);let o=class extends T.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(r,t){super(),this.a=r,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async g=>{for(const u of g.added)await this.f(u,n.migrations)})),this.c(n.migrations),this.B(n.onDidRegisterConfigurationMigration(g=>this.c(g)))}async c(r){await this.f(void 0,r);for(const t of this.b.getWorkspace().folders)await this.f(t,r)}async f(r,t){await Promise.all([t.map(g=>this.g(g,r?.uri))])}async g(r,t){const g=this.a.inspect(r.key,{resource:t}),u=this.b.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",R.ConfigurationTarget.USER],["userLocal",R.ConfigurationTarget.USER_LOCAL],["userRemote",R.ConfigurationTarget.USER_REMOTE],["workspace",R.ConfigurationTarget.WORKSPACE],["workspaceFolder",R.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",R.ConfigurationTarget.USER],["userLocal",R.ConfigurationTarget.USER_LOCAL],["userRemote",R.ConfigurationTarget.USER_REMOTE],["workspace",R.ConfigurationTarget.WORKSPACE]];for(const[m,p]of u){const h=g[m];if(!h)continue;const E=[];if(h.value!==void 0){const D=await this.h(r,m,h.value,t,void 0);for(const b of D??[])E.push([b,[]])}for(const{identifiers:D,value:b}of h.overrides??[])if(b!==void 0){const k=await this.h(r,m,b,t,D);for(const C of k??[])E.push([C,D])}E.length&&await Promise.allSettled(E.map(async([[D,b],k])=>this.a.updateValue(D,b.value,{resource:t,overrideIdentifiers:k},p)))}}async h(r,t,g,u,m){const p=E=>{const b=this.a.inspect(E,{resource:u})[t];if(b)return m?b.overrides?.find(({identifiers:k})=>(0,y.$fo)(k,m))?.value:b.value},h=await r.migrateFn(g,p);return Array.isArray(h)?h:[[r.key,h]]}};e.$fL=o,e.$fL=o=Ge([Ve(0,R.$9i),Ve(1,O.$Li)],o);let c=class extends T.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(r){super(),this.b=r,this.a=new a.$Zh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$j&&(await this.b.getEnvironment())?.os!==A.OperatingSystem.Windows)return;P.$oo.as(I.$to.Configuration).registerConfiguration({...e.$bL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,v.localize)(12458,null)},default:[],markdownDescription:(0,v.localize)(12459,null),scope:I.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,v.localize)(12460,null),scope:I.ConfigurationScope.MACHINE}}})}};e.$gL=c,e.$gL=c=Ge([Ve(0,s.$Tm)],c),e.$hL="window.newWindowProfile";let l=class extends T.$Tc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(r,t){super(),this.c=r,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(g=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(g=>{g.source!==R.ConfigurationTarget.DEFAULT&&g.affectsConfiguration(e.$hL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const r=P.$oo.as(I.$to.Configuration),t={...e.$dL,properties:{[e.$hL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(g=>g.name),null],enumItemLabels:[...this.c.profiles.map(g=>""),(0,v.localize)(12461,null)],description:(0,v.localize)(12462,null),scope:I.ConfigurationScope.APPLICATION}}};this.a?r.updateConfigurations({add:[t],remove:[this.a]}):r.registerConfiguration(t),this.a=t}h(){const r=this.f.getValue(e.$hL);this.b=r?this.c.profiles.find(t=>t.name===r):void 0}j(){const r=this.f.getValue(e.$hL);if(!r)return;const t=this.b?this.c.profiles.find(g=>g.id===this.b.id):void 0;r!==t?.name&&this.f.updateValue(e.$hL,t?.name)}};e.$iL=l,e.$iL=l=Ge([Ve(0,S.$Jl),Ve(1,R.$9i)],l)}),define(Oe[266],Ne([1,0,41,15,19,23,9,265,53,3,30]),function(be,e,v,I,P,O,R,T,$,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$kL=e.$jL=void 0,e.$lL=n,e.$mL=o,v=We(v),e.$jL=(0,s.$Ci)("editorResolverService"),e.$kL="workbench.editorAssociations";const y=A.$oo.as($.$to.Configuration),a={...T.$aL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(2005,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(a);var S;(function(c){c.builtin="builtin",c.option="option",c.exclusive="exclusive",c.default="default"})(S||(e.RegisteredEditorPriority=S={}));var d;(function(c){c[c.ABORT=1]="ABORT",c[c.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function n(c){switch(c){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}function o(c,l){if(new Set([I.Schemas.extension,I.Schemas.webviewPanel,I.Schemas.vscodeWorkspaceTrust,I.Schemas.vscodeSettings]).has(l.scheme))return!1;const t=typeof c=="string"&&c.indexOf(P.$fc.sep)>=0?`${l.scheme}:${l.path}`:(0,O.$ah)(l);return v.$wk(typeof c=="string"?c.toLowerCase():c,t.toLowerCase())}}),define(Oe[267],Ne([1,0,51,15,19,20,23,2,3,186,49,205,129]),function(be,e,v,I,P,O,R,T,$,s,A,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=void 0,e.$fN=(0,$.$Ci)("pathService");let d=S=class{constructor(o,c,l,i){this.d=o,this.e=c,this.f=l,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??o})()}hasValidBasename(o,c,l){return typeof c=="string"||typeof c>"u"?this.a.then(i=>this.h(o,i,c)):this.h(o,c,l)}h(o,c,l){return o.scheme===I.Schemas.file||o.scheme===I.Schemas.vscodeRemote?(0,v.$zg)(l??(0,R.$ah)(o),c===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,c){if(o.remoteAuthority)return I.Schemas.vscodeRemote;const l=(0,s.$cN)(c.getWorkspace());if(l)return l;const i=c.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=c.getWorkspace().configuration;return r?r.scheme:I.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===O.OperatingSystem.Windows?P.$ec:P.$fc)}async fileURI(o){let c="";if(await this.a===O.OperatingSystem.Windows&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(c=o.substring(2),o="/"):(c=o.substring(2,i),o=o.substring(i)||"/")}return T.URI.from({scheme:I.Schemas.file,authority:c,path:o,query:"",fragment:""})}};e.$gN=d,e.$gN=d=S=Ge([Ve(1,a.$Tm),Ve(2,y.$1M),Ve(3,A.$Li)],d)}),define(Oe[130],Ne([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$TL=e.$SL=void 0;class v{constructor(R,T){this.line=R,this.character=T}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,T){return new v(0,0)}with(R){return new v(0,0)}}e.$SL=v;class I{constructor(R,T,$,s){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(R,T),this.end=new v($,s)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new I(0,0,0,0)}with(R){return new I(0,0,0,0)}}e.$TL=I;var P;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Oe[44],Ne([1,0,17,41,25,51,12,3,19,13,130,10]),function(be,e,v,I,P,O,R,T,$,s,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=e.$fM=e.$$L=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$8L=e.$7L=e.$6L=e.$5L=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.TextSearchCompleteMessageType=void 0,e.$2L=c,e.$3L=l,e.$4L=i,e.$9L=D,e.$0L=b,e.$_L=f,e.$aM=w,e.$bM=M,e.$cM=N,e.$dM=L,e.$eM=W,e.$gM=F,e.$iM=le,e.$jM=_,I=We(I),P=We(P),O=We(O),$=We($),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$UL="workbench.view.search",e.$VL="workbench.panel.search",e.$WL="workbench.view.search",e.$XL="search-result",e.$YL="search.exclude",e.$ZL=2e4;const a="\u27EA ",S=" characters skipped \u27EB",d=(a.length+S.length+5)*2;e.$1L=(0,T.$Ci)("searchService");var n;(function(se){se[se.file=0]="file",se[se.text=1]="text",se[se.aiText=2]="aiText"})(n||(e.SearchProviderType=n={}));var o;(function(se){se[se.File=1]="File",se[se.Text=2]="Text",se[se.aiText=3]="aiText"})(o||(e.QueryType=o={}));function c(se){return!!se.preview}function l(se){return!!se.resource}function i(se){return!!se.message}var r;(function(se){se[se.Normal=0]="Normal",se[se.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class t{constructor(ae){this.resource=ae,this.results=[]}}e.$5L=t;class g{constructor(ae,$e,oe,Ce){this.ranges=$e,this.webviewIndex=Ce;const Le=Array.isArray($e)?$e:[$e];if(oe&&oe.matchLines===1&&u(Le)){ae=(0,R.$8f)(ae,oe.matchLines);let Z="",q=0,te=0;const ve=Math.floor(oe.charsPerLine/5),ce=[];for(const we of Le){const ue=Math.max(we.startColumn-ve,0),X=we.startColumn+oe.charsPerLine;if(ue>te+ve+d){const x=a+(ue-te)+S;Z+=x+ae.slice(ue,X),q+=ue-(te+x.length)}else Z+=ae.slice(te,X);ce.push(new p(0,we.startColumn-q,we.endColumn-q)),te=X}this.preview={text:Z,matches:Array.isArray(this.ranges)?ce:ce[0]}}else{const Z=Array.isArray($e)?$e[0].startLineNumber:$e.startLineNumber;this.preview={text:ae,matches:(0,v.$Zb)($e,q=>new m(q.startLineNumber-Z,q.startColumn,q.endLineNumber-Z,q.endColumn))}}}}e.$6L=g;function u(se){const ae=se[0].startLineNumber;for(const $e of se)if($e.startLineNumber!==ae||$e.endLineNumber!==ae)return!1;return!0}class m{constructor(ae,$e,oe,Ce){this.startLineNumber=ae,this.startColumn=$e,this.endLineNumber=oe,this.endColumn=Ce}}e.$7L=m;class p extends m{constructor(ae,$e,oe){super(ae,$e,ae,oe)}}e.$8L=p;var h;(function(se){se.List="list",se.Tree="tree"})(h||(e.ViewMode=h={}));var E;(function(se){se.Default="default",se.FileNames="fileNames",se.Type="type",se.Modified="modified",se.CountDescending="countDescending",se.CountAscending="countAscending"})(E||(e.SearchSortOrder=E={}));function D(se,ae=!0){const $e=se&&se.files&&se.files.exclude,oe=ae&&se&&se.search&&se.search.exclude;if(!$e&&!oe)return;if(!$e||!oe)return $e||oe||void 0;let Ce=Object.create(null);return Ce=P.$eo(Ce,P.$bo($e)),Ce=P.$eo(Ce,P.$bo(oe),!0),Ce}function b(se,ae){return se.excludePattern&&I.$wk(se.excludePattern,ae)?!1:se.includePattern||se.usingSearchPaths?se.includePattern&&I.$wk(se.includePattern,ae)?!0:se.usingSearchPaths?!!se.folderQueries&&se.folderQueries.some($e=>{const oe=$e.folder.fsPath;if(O.$Bg(ae,oe)){const Ce=$.$kc(oe,ae);return!$e.includePattern||!!I.$wk($e.includePattern,Ce)}else return!1}):!1:!0}var k;(function(se){se[se.unknownEncoding=1]="unknownEncoding",se[se.regexParseError=2]="regexParseError",se[se.globParseError=3]="globParseError",se[se.invalidLiteral=4]="invalidLiteral",se[se.rgProcessError=5]="rgProcessError",se[se.other=6]="other",se[se.canceled=7]="canceled"})(k||(e.SearchErrorCode=k={}));class C extends Error{constructor(ae,$e){super(ae),this.code=$e}}e.$$L=C;function f(se){const ae=se.message;if((0,s.$3)(se))return new C(ae,k.canceled);try{const $e=JSON.parse(ae);return new C($e.message,$e.code)}catch{return new C(ae,k.other)}}function w(se){const ae={message:se.message,code:se.code};return new Error(JSON.stringify(ae))}function M(se){return se.type==="error"?!0:se.type==="success"}function N(se){return se.type==="success"}function L(se){return!!se.path}function W(se,ae,$e=!0){const oe=se.searchPath?se.searchPath:se.relativePath;return $e?(0,R.$5f)(oe,ae):I.$wk(ae,oe)}class G{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$fM=G;function F(se,ae){const $e={...se||{},...ae||{}};return Object.keys($e).filter(oe=>{const Ce=$e[oe];return typeof Ce=="boolean"&&Ce})}class K{constructor(ae,$e){this.c=null,this.a={...ae.excludePattern||{},...$e.excludePattern||{}},this.b=I.$xk(this.a);let oe=ae.includePattern;$e.includePattern&&(oe?oe={...oe,...$e.includePattern}:oe=$e.includePattern),oe&&(this.c=I.$xk(oe))}matchesExcludesSync(ae,$e,oe){return!!(this.b&&this.b(ae,$e,oe))}includedInQuerySync(ae,$e,oe){return!(this.b&&this.b(ae,$e,oe)||this.c&&!this.c(ae,$e,oe))}includedInQuery(ae,$e,oe){const Ce=this.b(ae,$e,oe),Le=()=>this.c?!!this.c(ae,$e,oe):!0;return(0,y.$oh)(Ce)?Ce.then(Z=>Z?!1:Le()):Le()}hasSiblingExcludeClauses(){return Y(this.a)}}e.$hM=K;function Y(se){for(const ae in se)if(typeof se[ae]!="boolean")return!0;return!1}function le(se){if(!se)return;let ae;return $e=>(ae||(ae=(se()||Promise.resolve([])).then(oe=>oe?ge(oe):{})),ae.then(oe=>!!oe[$e]))}function _(se){if(!se)return;let ae;return $e=>{if(!ae){const oe=se();ae=oe?ge(oe):{}}return!!ae[$e]}}function ge(se){const ae={};for(const $e of se)ae[$e]=!0;return ae}}),define(Oe[45],Ne([1,0,17,10,21,6,4,58,15,140,23,12,2,9,29,3,11,173,49,50,26,16,8,7,65,44,5,40]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l,i,r,t,g,u,m,p,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hpc=e.$gpc=void 0;function D(L,W,G){return new A.$5g(F=>f(F,G)).isEqual(L,W)}function b(L,W,G){return D(L.uri,W.uri,G)?0:(0,y.$wf)(L.uri.toString(),W.uri.toString())}function k(L,W,G){return L.index!==W.index?L.index<W.index?-1:1:D(L.uri,W.uri,G)?(0,y.$wf)(L.name,W.name):(0,y.$wf)(L.uri.toString(),W.uri.toString())}function C(L,W,G,F){const K=L.slice(0).sort((le,_)=>G(le,_,F)),Y=W.slice(0).sort((le,_)=>G(le,_,F));return(0,v.$Db)(K,Y,(le,_)=>G(le,_,F))}function f(L,W){const G=W.getCapabilities(L.scheme);return!(G&&G&d.FileSystemProviderCapabilities.PathCaseSensitive)}class w extends l.$Vi{static toExtHostWorkspace(W,G,F,K){if(!W)return{workspace:null,added:[],removed:[]};const{id:Y,name:le,folders:_,configuration:ge,transient:se,isUntitled:ae}=W,$e=[],oe=G;G?_.forEach((q,te)=>{const ve=a.URI.revive(q.uri),ce=w.o(F||G,ve,K);ce?(ce.name=q.name,ce.index=q.index,$e.push(ce)):$e.push({uri:ve,name:q.name,index:te})}):$e.push(..._.map(({uri:q,name:te,index:ve})=>({uri:a.URI.revive(q),name:te,index:ve}))),$e.sort((q,te)=>q.index<te.index?-1:1);const Ce=new w(Y,le,$e,!!se,ge?a.URI.revive(ge):null,!!ae,q=>f(q,K)),{added:Le,removed:Z}=C(oe?oe.workspaceFolders:[],Ce.workspaceFolders,b,K);return{workspace:Ce,added:Le,removed:Z}}static o(W,G,F){for(let K=0;K<W.folders.length;K++){const Y=W.workspaceFolders[K];if(D(Y.uri,G,F))return Y}}constructor(W,G,F,K,Y,le,_){super(W,F.map(ge=>new l.$Wi(ge)),K,Y,_),this.t=G,this.u=le,this.q=[],this.s=T.$Ii.forUris(_,()=>!0),F.forEach(ge=>{this.q.push(ge),this.s.set(ge.uri,ge)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,G){return G&&this.s.get(W)&&(W=(0,A.$ch)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let M=class{constructor(W,G,F,K,Y){this.c=new O.$je,this.onDidChangeWorkspace=this.c.event,this.g=new O.$je,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$le,this.C=new Map,this.h=K,this.s=F,this.t=Y,this.j=new s.$Km,this.k=new I.$Bh,this.o=W.getProxy(h.$DN.MainThreadWorkspace),this.q=W.getProxy(h.$DN.MainThreadMessageService);const le=G.workspace;this.l=le?new w(le.id,le.name,[],!!le.transient,le.configuration?a.URI.revive(le.configuration):null,!!le.isUntitled,_=>f(_,F)):void 0}$initializeWorkspace(W,G){this.v=G,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?a.URI.from({scheme:$.Schemas.untitled,path:(0,A.$ah)((0,A.$ch)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,G,F,...K){const Y=[];if(Array.isArray(K)&&K.forEach(ae=>{a.URI.isUri(ae.uri)&&!Y.some($e=>D($e.uri,ae.uri,this.s))&&Y.push({uri:ae.uri,name:ae.name||(0,A.$_g)(ae.uri)})}),this.n||[G,F].some(ae=>typeof ae!="number"||ae<0)||F===0&&Y.length===0)return!1;const le=this.x?this.x.workspaceFolders:[];if(G+F>le.length)return!1;const _=le.slice(0);_.splice(G,F,...Y.map(ae=>({uri:ae.uri,name:ae.name||(0,A.$_g)(ae.uri),index:void 0})));for(let ae=0;ae<_.length;ae++){const $e=_[ae];if(_.some((oe,Ce)=>Ce!==ae&&D($e.uri,oe.uri,this.s)))return!1}_.forEach((ae,$e)=>ae.index=$e);const{added:ge,removed:se}=C(le,_,k,this.s);if(ge.length===0&&se.length===0)return!1;if(this.o){const ae=W.displayName||W.name;this.o.$updateWorkspaceFolders(ae,G,F,Y).then(void 0,$e=>{this.n=void 0;const oe={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(c.Severity.Error,(0,S.localize)(10727,null,ae,$e.toString()),oe,[])})}return this.y(_),!0}getWorkspaceFolder(W,G){if(this.x)return this.x.getWorkspaceFolder(W,G)}async getWorkspaceFolder2(W,G){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,G)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,G){let F,K="";if(typeof W=="string"?(F=a.URI.file(W),K=W):typeof W<"u"&&(F=W,K=W.fsPath),!F)return K;const Y=this.getWorkspaceFolder(F,!0);if(!Y)return K;typeof G>"u"&&this.x&&(G=this.x.folders.length>1);let le=(0,A.$fh)(Y.uri,F);return G&&Y.name&&(le=`${Y.name}/${le}`),le}y(W){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:G,added:F,removed:K}=w.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=G||void 0,this.n=void 0,this.c.fire(Object.freeze({added:F,removed:K}))}findFiles(W,G,F,K,Y=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let le="",_=!0;return G===null?_=!1:G!==void 0&&(typeof G=="string"?le=G:le=G.pattern),this.z(W,void 0,{exclude:le,maxResults:F,useDefaultExcludes:_,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},Y)}findFiles2(W,G={},F,K=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${F.value}, entryPoint: findFiles2`),this.z(void 0,W,G,K)}async z(W,G,F,K=P.CancellationToken.None){if(K&&K.isCancellationRequested)return Promise.resolve([]);const Y=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,le={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof F.useDefaultSearchExcludes=="boolean"?!F.useDefaultSearchExcludes:!1,maxResults:F.maxResults,excludePattern:Y,shouldGlobSearch:typeof F.fuzzy=="boolean"?!F.fuzzy:!0,_reason:"startFileSearch"};let _;if(W){const{includePattern:ge,folder:se}=N(g.GlobPattern.from(W));_=se,le.includePattern=ge}else{const{includePattern:ge,folder:se}=N(g.GlobPattern.from(G));_=se,le.filePattern=ge}return this.o.$startFileSearch(_??null,le,K).then(ge=>Array.isArray(ge)?ge.map(se=>a.URI.revive(se)):[])}async findTextInFiles(W,G,F,K,Y=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const le=this.j.getNext(),_=typeof G.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:G.previewOptions,{includePattern:ge,folder:se}=N(g.GlobPattern.from(G.include)),ae=typeof G.exclude=="string"?G.exclude:G.exclude?G.exclude.pattern:void 0,$e={ignoreSymlinks:typeof G.followSymlinks=="boolean"?!G.followSymlinks:void 0,disregardIgnoreFiles:typeof G.useIgnoreFiles=="boolean"?!G.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof G.useGlobalIgnoreFiles=="boolean"?!G.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof G.useParentIgnoreFiles=="boolean"?!G.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof G.useDefaultExcludes=="boolean"?!G.useDefaultExcludes:!0,fileEncoding:G.encoding,maxResults:G.maxResults,previewOptions:_,afterContext:G.afterContext,beforeContext:G.beforeContext,includePattern:ge,excludePattern:ae},oe=!1;if(this.u[le]=Ce=>{if(oe)return;const Le=a.URI.revive(Ce.resource);Ce.results.forEach(Z=>{const q=(0,E.$_h)(Z);(0,p.$2L)(q)?F({uri:Le,preview:{text:q.preview.text,matches:(0,v.$Zb)(q.preview.matches,te=>new u.$HN(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))},ranges:(0,v.$Zb)(q.ranges,te=>new u.$HN(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))}):F({uri:Le,text:q.text,lineNumber:q.lineNumber})})},Y.isCancellationRequested)return{};try{const Ce=await this.o.$startTextSearch(W,se??null,$e,le,Y);return delete this.u[le],Ce||{}}catch(Ce){throw delete this.u[le],Ce}}$handleTextSearchResult(W,G){this.u[G]?.(W)}async save(W){const G=await this.o.$save(W,{saveAs:!1});return a.URI.revive(G)}async saveAs(W){const G=await this.o.$save(W,{saveAs:!0});return a.URI.revive(G)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}lookupAuthorization(W){return this.o.$lookupAuthorization(W)}lookupKerberosAuthorization(W){return this.o.$lookupKerberosAuthorization(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,G){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,G);const F=this.t.transformOutgoingScheme(W),K=this.A++;return this.o.$registerEditSessionIdentityProvider(K,F),(0,R.$Rc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(K)})}async $getEditSessionIdentifier(W,G){this.h.info("Getting edit session identifier for workspaceFolder",W);const F=await this.resolveWorkspaceFolder(a.URI.revive(W));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const K=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!K),!K)return;const Y=await K.provideEditSessionIdentity(F,G);if(this.h.info("Provider returned edit session identifier: ",Y),!!Y)return Y}async $provideEditSessionIdentityMatch(W,G,F,K){this.h.info("Getting edit session identifier for workspaceFolder",W);const Y=await this.resolveWorkspaceFolder(a.URI.revive(W));if(!Y){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Y);const le=this.w.get(Y.uri.scheme);if(this.h.info(`Provider for scheme ${Y.uri.scheme} is defined: `,!!le),!le)return;const _=await le.provideEditSessionIdentityMatch?.(G,F,K);if(this.h.info("Provider returned edit session identifier match result: ",_),!!_)return _}getOnWillCreateEditSessionIdentityEvent(W){return(G,F,K)=>{const Y=function(_){G.call(F,_)};return Y.extension=W,this.B.event(Y,void 0,K)}}async $onWillCreateEditSessionIdentity(W,G,F){const K=await this.resolveWorkspaceFolder(a.URI.revive(W));if(K===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:K},G,async(Y,le)=>{const _=Date.now();await Promise.resolve(Y),Date.now()-_>F&&this.h.warn("SLOW edit session create-participant",le.extension.identifier)}),G.isCancellationRequested}registerCanonicalUriProvider(W,G){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,G);const F=this.t.transformOutgoingScheme(W),K=this.A++;return this.o.$registerCanonicalUriProvider(K,F),(0,R.$Rc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(K)})}async provideCanonicalUri(W,G,F){const K=this.C.get(W.scheme);if(!K)return;const Y=await K.provideCanonicalUri?.(a.URI.revive(W),G,F);if(Y)return Y}async $provideCanonicalUri(W,G,F){return this.provideCanonicalUri(a.URI.revive(W),{targetScheme:G},F)}};e.$gpc=M,e.$gpc=M=Ge([Ve(0,t.$cQ),Ve(1,r.$sQ),Ve(2,i.$2oc),Ve(3,o.$0j),Ve(4,m.$epc)],M),e.$hpc=(0,n.$Ci)("IExtHostWorkspace");function N(L){let W,G;return L&&(typeof L=="string"?W=L:(W=L.pattern,G=a.URI.revive(L.baseUri))),{includePattern:W,folder:G}}}),define(Oe[46],Ne([1,0,25,6,45,5,7,43,174,53,14,10,3,16,11,2]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kpc=e.$jpc=e.$ipc=void 0;function o(m,p){if(p){const h=p.split(".");let E=m;for(let D=0;E&&D<h.length;D++)E=E[h[D]];return E}}function c(m){return m instanceof n.URI}function l(m){return m&&m.uri instanceof n.URI&&m.languageId&&typeof m.languageId=="string"}function i(m){return m&&!m.uri&&m.languageId&&typeof m.languageId=="string"}function r(m){return m&&m.uri instanceof n.URI&&(!m.name||typeof m.name=="string")&&(!m.index||typeof m.index=="number")}function t(m){if(c(m))return{resource:m};if(l(m))return{resource:m.uri,overrideIdentifier:m.languageId};if(i(m))return{overrideIdentifier:m.languageId};if(r(m))return{resource:m.uri};if(m===null)return{resource:null}}let g=class{constructor(p,h,E){this.a=p.getProxy(O.$DN.MainThreadConfiguration),this.c=h,this.b=E,this.d=new y.$Bh,this.e=null}getConfigProvider(){return this.d.wait().then(p=>this.e)}$initializeConfiguration(p){this.e=new u(this.a,this.c,p,this.b),this.d.open()}$acceptConfigurationChanged(p,h){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(p,h))}};e.$ipc=g,e.$ipc=g=Ge([Ve(0,S.$cQ),Ve(1,P.$hpc),Ve(2,d.$0j)],g);class u{constructor(p,h,E,D){this.a=new I.$je,this.b=p,this.f=D,this.c=h,this.e=$.$Oo.parse(E,D),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(p,h){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Oo.parse(p,this.f),this.d=this.k(p.configurationScopes),this.a.fire(this.j(h,E))}getConfiguration(p,h,E){const D=t(h)||{},b=this.g(p?o(this.e.getValue(void 0,D,this.c.workspace),p):this.e.getValue(void 0,D,this.c.workspace));p&&this.h(p,D,E?.identifier);function k(f){if(f==null)return null;if(typeof f=="boolean")return f?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(f){case R.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case R.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case R.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const C={has(f){return typeof o(b,f)<"u"},get:(f,w)=>{this.h(p?`${p}.${f}`:f,D,E?.identifier);let M=o(b,f);if(typeof M>"u")M=w;else{let N;const L=(W,G)=>{if((0,A.$eg)(W)){let F;const K=()=>{N=N||(0,v.$bo)(b),F=F||o(N,G)};return new Proxy(W,{get:(Y,le)=>{if(typeof le=="string"&&le.toLowerCase()==="tojson")return K(),()=>F;if(N)return F=F||o(N,G),F[le];const _=Y[le];return typeof le=="string"?L(_,`${G}.${le}`):_},set:(Y,le,_)=>(K(),F&&(F[le]=_),!0),deleteProperty:(Y,le)=>(K(),F&&delete F[le],!0),defineProperty:(Y,le,_)=>(K(),F&&Object.defineProperty(F,le,_),!0)})}return Array.isArray(W)?(0,v.$bo)(W):W};M=L(M,f)}return M},update:(f,w,M,N)=>{f=p?`${p}.${f}`:f;const L=k(M);return w!==void 0?this.b.$updateConfigurationOption(L,f,w,D,N):this.b.$removeConfigurationOption(L,f,D,N)},inspect:f=>{f=p?`${p}.${f}`:f;const w=this.e.inspect(f,D,this.c.workspace);if(w)return{key:f,defaultValue:(0,v.$bo)(w.policy?.value??w.default?.value),globalValue:(0,v.$bo)(w.user?.value??w.application?.value),workspaceValue:(0,v.$bo)(w.workspace?.value),workspaceFolderValue:(0,v.$bo)(w.workspaceFolder?.value),defaultLanguageValue:(0,v.$bo)(w.default?.override),globalLanguageValue:(0,v.$bo)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,v.$bo)(w.workspace?.override),workspaceFolderLanguageValue:(0,v.$bo)(w.workspaceFolder?.override),languageIds:(0,v.$bo)(w.overrideIdentifiers)}}};return typeof b=="object"&&(0,v.$eo)(C,b,!1),Object.freeze(C)}g(p){const h=E=>(0,A.$eg)(E)?new Proxy(E,{get:(D,b)=>h(D[b]),set:(D,b,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(D,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(D,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return h(p)}h(p,h,E){const D=s.$Do.test(p)?s.ConfigurationScope.RESOURCE:this.d.get(p),b=E?`[${E.value}] `:"";if(s.ConfigurationScope.RESOURCE===D){typeof h?.resource>"u"&&this.f.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${p}', provide the URI of a resource or 'null' for any resource.`);return}if(s.ConfigurationScope.WINDOW===D){h?.resource&&this.f.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${p}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(p,h){const E=new $.$Qo(p,h,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,b)=>E.affectsConfiguration(D,t(b))})}k(p){return p.reduce((h,E)=>(h.set(E[0],E[1]),h),new Map)}}e.$jpc=u,e.$kpc=(0,a.$Ci)("IExtHostConfiguration")}),define(Oe[131],Ne([1,0,2,10,6,5,7,45,57,46,21,56,16,26,3,15,20,11,84,209,13]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uqc=e.$Tqc=e.$Sqc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,R=We(R),o=We(o);var t;(function(N){function L(G){if(G!=null)return G}N.from=L;function W(G){if(G!=null)return G}N.to=W})(t||(t={}));var g;(function(N){function L(G){if(G!=null)return G}N.from=L;function W(G){if(G!=null)return G}N.to=W})(g||(g={}));var u;(function(N){function L(G){if(G!=null)return G}N.from=L;function W(G){if(G!=null)return G}N.to=W})(u||(u={}));var m;(function(N){function L(F){if(F){const K=F;return K&&!!K.process}else return!1}N.is=L;function W(F){if(F==null)return;const K={process:F.process,args:F.args};return F.options&&(K.options=u.from(F.options)),K}N.from=W;function G(F){if(F!=null)return new R.$rO(F.process,F.args,F.options)}N.to=G})(m||(m={}));var p;(function(N){function L(G){if(G!=null)return G}N.from=L;function W(G){if(G!=null)return G}N.to=W})(p||(p={}));var h;(function(N){function L(F){if(F){const K=F;return K&&(!!K.commandLine||!!K.command)}else return!1}N.is=L;function W(F){if(F==null)return;const K={};return F.commandLine!==void 0?K.commandLine=F.commandLine:(K.command=F.command,K.args=F.args),F.options&&(K.options=p.from(F.options)),K}N.from=W;function G(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new R.$sO(F.commandLine,F.options):new R.$sO(F.command,F.args?F.args:[],F.options)}N.to=G})(h||(h={}));var E;(function(N){function L(F){if(F){const K=F;return K&&K.customExecution==="customExecution"}else return!1}N.is=L;function W(F){return{customExecution:"customExecution"}}N.from=W;function G(F,K){return K.get(F)}N.to=G})(E||(e.CustomExecutionDTO=E={}));var D;(function(N){function L(W,G){let F;return W.scope!==void 0&&typeof W.scope!="number"?F=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===R.TaskScope.Workspace&&G&&G.workspaceFile?F=G.workspaceFile:F=i.$RI),{id:W._id,workspaceFolder:F}}N.from=L})(D||(e.TaskHandleDTO=D={}));var b;(function(N){function L(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}N.from=L})(b||(b={}));var k;(function(N){function L(F,K){if(F==null)return[];const Y=[];for(const le of F){const _=W(le,K);_&&Y.push(_)}return Y}N.fromMany=L;function W(F,K){if(F==null)return;let Y;F.execution instanceof R.$rO?Y=m.from(F.execution):F.execution instanceof R.$sO?Y=h.from(F.execution):F.execution&&F.execution instanceof R.$tO&&(Y=E.from(F.execution));const le=t.from(F.definition);let _;return F.scope?typeof F.scope=="number"?_=F.scope:_=F.scope.uri:_=R.TaskScope.Workspace,!le||!_?void 0:{_id:F._id,definition:le,name:F.name,source:{extensionId:K.identifier.value,label:F.source,scope:_},execution:Y,isBackground:F.isBackground,group:b.from(F.group),presentationOptions:g.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}N.from=W;async function G(F,K,Y){if(F==null)return;let le;m.is(F.execution)?le=m.to(F.execution):h.is(F.execution)?le=h.to(F.execution):E.is(F.execution)&&(le=E.to(F._id,Y));const _=t.to(F.definition);let ge;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?ge=F.source.scope:ge=await K.resolveWorkspaceFolder(v.URI.revive(F.source.scope)):ge=R.TaskScope.Workspace),!_||!ge)return;const se=new R.$uO(_,ge,F.name,F.source.label,le,F.problemMatchers);return F.isBackground!==void 0&&(se.isBackground=F.isBackground),F.group!==void 0&&(se.group=R.$qO.from(F.group._id),se.group&&F.group.isDefault&&(se.group=new R.$qO(se.group.id,se.group.label),F.group.isDefault===!0&&(se.group.isDefault=F.group.isDefault))),F.presentationOptions&&(se.presentationOptions=g.to(F.presentationOptions)),F._id&&(se._id=F._id),F.detail&&(se.detail=F.detail),se}N.to=G})(k||(e.TaskDTO=k={}));var C;(function(N){function L(G){return G}N.from=L;function W(G){if(G)return Object.assign(Object.create(null),G)}N.to=W})(C||(C={}));class f{#e;constructor(L,W,G){this._id=W,this.a=G,this.#e=L}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let w=class{constructor(L,W,G,F,K,Y,le,_){this.q=new P.$je,this.r=new P.$je,this.s=new P.$je,this.u=new P.$je,this.a=L.getProxy(O.$DN.MainThreadTask),this.b=G,this.c=F,this.d=K,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=le,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,W,G){if(!G)return new R.$FN(()=>{});const F=this.x();return this.j.set(F,{type:W,provider:G,extension:L}),this.a.$registerTaskProvider(F,W),new R.$FN(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(L,W){this.a.$registerTaskSystem(L,W)}fetchTasks(L){return this.a.$fetchTasks(C.from(L)).then(async W=>{const G=[];for(const F of W){const K=await k.to(F,this.b,this.m);K&&G.push(K)}return G})}get taskExecutions(){const L=[];return this.k.forEach(W=>L.push(W)),L}terminateTask(L){if(!(L instanceof f))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,W,G){const F=this.m.get(L.id);F&&(this.o.set(L.id,F),this.e.attachPtyToTerminal(W,await F.callback(G))),this.p=L.id,this.q.fire({execution:await this.z(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){if(!this.l.has(L.id))return;const W=await this.z(L);this.l.delete(L.id),this.k.delete(L.id),this.B(L),this.r.fire({execution:W})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const W=await this.z(L.id);this.s.fire({execution:W,processId:L.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(L){const W=await this.z(L.id);this.u.fire({execution:W,exitCode:L.exitCode})}$provideTasks(L,W){const G=this.j.get(L);if(!G)return Promise.reject(new Error("no handler found"));const F=[],K=(0,I.$uh)(()=>G.provider.provideTasks(A.CancellationToken.None)).then(Y=>this.v(W,F,G,Y));return new Promise(Y=>{K.then(le=>{Promise.all(F).then(()=>{Y(le)})})})}async $resolveTask(L,W){const G=this.j.get(L);if(!G)return Promise.reject(new Error("no handler found"));if(W.definition.type!==G.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${G.type}].`);const F=await k.to(W,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const K=await G.provider.resolveTask(F,A.CancellationToken.None);if(!K)return;this.A(K,G);const Y=k.from(K,G.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(Y.execution)&&await this.y(Y,K,!0),await this.w(Y)}x(){return this.h++}async y(L,W,G){const F=await this.a.$createTaskId(L);!G&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,W.execution)),this.m.set(F,W.execution)}async z(L,W){if(typeof L=="string"){const K=this.l.get(L);if(!K)throw new r.$ab("Unexpected: The specified task is missing an execution");return K}const G=this.l.get(L.id);if(G)return G;let F;return W?F=Promise.resolve(new f(this,L.id,W)):F=k.to(L.task,this.b,this.m).then(K=>{if(!K)throw new r.$ab("Unexpected: Task does not exist.");return new f(this,L.id,K)}),this.l.set(L.id,F),F.then(K=>(this.k.set(L.id,K),K))}A(L,W){L._deprecated&&this.g.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}B(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const G=this.n.values();let F=G.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=G.next()}};e.$Sqc=w,e.$Sqc=w=Ge([Ve(0,a.$cQ),Ve(1,S.$sQ),Ve(2,T.$hpc),Ve(3,$.$nQ),Ve(4,s.$kpc),Ve(5,y.$Ipc),Ve(6,c.$0j),Ve(7,l.$Xoc)],w);let M=class extends w{constructor(L,W,G,F,K,Y,le,_){super(L,W,G,F,K,Y,le,_),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:o.$i(o.Platform.Web)})}async executeTask(L,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const G=k.from(W,L);if(G===void 0)throw new Error("Task is not valid");if(E.is(G.execution))await this.y(G,W,!1);else throw new r.$$;const F=await this.z(await this.a.$getTaskExecution(G),W);return this.a.$executeTask(G).catch(K=>{throw new Error(K)}),F}v(L,W,G,F){const K=[];if(F)for(const Y of F){if(this.A(Y,G),!Y.definition||!L[Y.definition.type]){const _=Y.source?Y.source:"No task source";this.f.warn(`The task [${_}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`)}const le=k.from(Y,G.extension);le&&E.is(le.execution)?(K.push(le),W.push(this.y(le,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:G.extension}}async w(L){if(E.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,W,G){}};e.$Tqc=M,e.$Tqc=M=Ge([Ve(0,a.$cQ),Ve(1,S.$sQ),Ve(2,T.$hpc),Ve(3,$.$nQ),Ve(4,s.$kpc),Ve(5,y.$Ipc),Ve(6,c.$0j),Ve(7,l.$Xoc)],M),e.$Uqc=(0,d.$Ci)("IExtHostTask")}),define(Oe[268],Ne([1,0,44,32]),function(be,e,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=void 0,e.$pM=P,e.$rM=O;function P(R){return"cellResults"in R}e.$qM="rawCell#";function O(R,T){let $=-1;const s=[];let A=[];return R.forEach(a=>{a.range.startLineNumber!==$&&A.length>0&&(s.push([...A]),A=[]),A.push(a),$=a.range.endLineNumber}),A.length>0&&s.push([...A]),s.map(a=>{const S=[],d=a[0].range.startLineNumber,n=a[a.length-1].range.endLineNumber;for(let o=d;o<=n;o++)S.push(T.getLineContent(o));return new v.$6L(S.join(`
`)+`
`,a.map(o=>new I.$Lt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Oe[269],Ne([1,0,9,22,6,4,28,36,12,14,2,29,79,5,33,8,7,38,246,124,25,15,44,199,268,266]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l,i,r,t,g,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uqc=void 0,y=We(y),n=We(n),o=We(o);class h{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,b,k,C,f,w,M){this.q=k,this.r=C,this.s=f,this.t=w,this.u=M,this.f=new Map,this.g=new R.$zc,this.h=new Map,this.j=new P.$je,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$je,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$je,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$je,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new a.$Voc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(S.$DN.MainThreadNotebook),this.c=D.getProxy(S.$DN.MainThreadNotebookDocuments),this.d=D.getProxy(S.$DN.MainThreadNotebookEditors),this.i=b.converter,b.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===T.MarshalledId.NotebookCellActionContext){const L=N.notebookEditor?.notebookUri,W=N.cell.handle,F=this.g.get(L)?.getCell(W);if(F)return F.apiCell}if(N&&N.$mid===T.MarshalledId.NotebookActionContext){const L=N.uri,W=this.g.get(L);if(W)return W.apiNotebook}return N}}),h.C(b)}getEditorById(D){const b=this.h.get(D);if(!b)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return b}getIdByEditor(D){for(const[b,k]of this.h)if(k.apiEditor===D)return b}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,b){const k=this.g.get(D);if(!k&&!b)throw new Error(`NO notebook document for '${D}'`);return k}static w(D,b){if(!b)return;const k=b.filenamePattern.map(C=>n.NotebookExclusiveDocumentPattern.from(C)).filter(C=>C!==void 0);if(b.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${b.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:b.displayName,filenamePattern:k,priority:b.exclusive?p.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,b,k){const C=h.a++,f=typeof k.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(C,k),this.b.$registerNotebookCellStatusBarItemProvider(C,f,b);let w;return f!==void 0&&(w=k.onDidChangeCellStatusBarItems(M=>this.b.$emitCellStatusBarEvent(f))),new o.$FN(()=>{this.f.delete(C),this.b.$unregisterNotebookCellStatusBarItemProvider(C,f),w?.dispose()})}async createNotebookDocument(D){const b=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&n.NotebookData.from(D.content)});return A.URI.revive(b)}async openNotebookDocument(D){const b=this.g.get(D);if(b)return b.apiNotebook;const k=await this.c.$tryOpenNotebook(D),C=this.g.get(A.URI.revive(k));return(0,s.$ng)(C?.apiNotebook)}async showNotebookDocument(D,b){A.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let k;typeof b=="object"?k={position:n.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selections:b.selections&&b.selections.map(n.NotebookRange.from),pinned:typeof b.preview=="boolean"?!b.preview:void 0}:k={preserveFocus:!1};const C=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,k),f=C&&this.h.get(C)?.apiEditor;if(f)return f;throw C?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,b,k,C){const f=this.f.get(D),w=A.URI.revive(b),M=this.g.get(w);if(!M||!f)return;const N=M.getCellFromIndex(k);if(!N)return;const L=await f.provideCellStatusBarItems(N.apiCell,C);if(!L)return;const W=new O.$Sc,G=this.p.add([W]),K=(Array.isArray(L)?L:[L]).map(Y=>n.NotebookStatusBarItem.from(Y,this.i,W));return{cacheId:G,items:K}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,b,k,C,f){if((0,$.$af)(b))throw new Error("viewType cannot be empty or just whitespace");const w=this.x++;return this.y.set(w,{viewType:b,serializer:k,options:C}),this.b.$registerNotebookSerializer(w,{id:D.identifier,location:D.extensionLocation},b,n.NotebookDocumentContentOptions.from(C),h.w(D,f)),(0,O.$Rc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(D,b,k){const C=this.y.get(D);if(!C)throw new Error("NO serializer found");const f=await C.serializer.deserializeNotebook(b.buffer,k);return new c.$Uw(n.NotebookData.from(f))}async $notebookToData(D,b,k){const C=this.y.get(D);if(!C)throw new Error("NO serializer found");const f=await C.serializer.serializeNotebook(n.NotebookData.to(b.value),k);return I.$Le.wrap(f)}async $saveNotebook(D,b,k,C,f){const w=A.URI.revive(b),M=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${k}, ${w.toString()})`),!M)throw new Error("NO serializer found");const N=this.g.get(w);if(!N)throw new Error("Document NOT found");if(N.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new y.$sl((0,v.localize)(10735,null,this.A(w)),y.FileOperationResult.FILE_PERMISSION_DENIED);const L={metadata:(0,r.$jo)(N.apiNotebook.metadata,Y=>!(M.options?.transientDocumentMetadata??{})[Y]),cells:[]};for(const Y of N.apiNotebook.getCells()){const le=new o.$$O(Y.kind,Y.document.getText(),Y.document.languageId,Y.mime,M.options?.transientOutputs?[]:[...Y.outputs],Y.metadata,Y.executionSummary);le.metadata=(0,r.$jo)(Y.metadata,_=>!(M.options?.transientCellMetadata??{})[_]),L.cells.push(le)}if(await this.z(w,C),f.isCancellationRequested)throw new Error("canceled");const W=await M.serializer.serializeNotebook(L,f);if(f.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${k} ${w.toString()}`),await this.s.value.writeFile(w,W),this.D(`Finished write versionId: ${k} ${w.toString()}`);const G=this.s.getFileSystemProviderExtUri(w.scheme),F=await this.s.value.stat(w),K={name:G.basename(w),isFile:(F.type&y.FileType.File)!==0,isDirectory:(F.type&y.FileType.Directory)!==0,isSymbolicLink:(F.type&y.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&y.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((F.permissions??0)&y.FilePermission.Locked),etag:y.$Dl({mtime:F.mtime,size:F.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${k}, ${w.toString()})`),K}async $searchInNotebooks(D,b,k,C,f){const w=this.y.get(D)?.serializer;if(!w)return{limitHit:!1,results:[]};const M=new R.$Ac;await(async(F,K,Y)=>{await Promise.all(F.map(async le=>await Promise.all(le.filenamePatterns.map(_=>{const ge={_reason:Y._reason,folderQueries:Y.folderQueries,includePattern:Y.includePattern,excludePattern:Y.excludePattern,maxResults:Y.maxResults,type:g.QueryType.File,filePattern:_};return this.t.doInternalFileSearchWithCustomCallback(ge,K,se=>{se.forEach(ae=>{M.has(ae)||C.some(oe=>le.isFromSettings&&!oe.isFromSettings?!1:oe.filenamePatterns.some(Ce=>(0,p.$mL)(Ce,ae)))||M.add(ae)})}).catch(se=>{if(se.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw se})}))))})(k,f,b);const L=new R.$zc;let W=!1;const G=Array.from(M).map(async F=>{const K=[];try{if(f.isCancellationRequested)return;if(b.maxResults&&[...L.values()].reduce((ge,se)=>ge+se.cellResults.length,0)>b.maxResults){W=!0;return}const Y=[],le=this.g.get(F);if(le)le.apiNotebook.getCells().forEach(se=>Y.push({input:se.document.getText(),outputs:se.outputs.flatMap(ae=>ae.items.map($e=>$e.data.toString()))}));else{const ge=await this.s.value.readFile(F),se=I.$Le.fromString(ge.toString()),ae=await w.deserializeNotebook(se.buffer,f);if(f.isCancellationRequested)return;n.NotebookData.from(ae).cells.forEach(oe=>Y.push({input:oe.source,outputs:oe.outputs.flatMap(Ce=>Ce.items.map(Le=>Le.valueBytes.toString()))}))}if(f.isCancellationRequested)return;Y.forEach((ge,se)=>{const ae=b.contentPattern.pattern,$e=new u.$1Zb(ge.input,void 0,ge.outputs),oe=$e.findInInputs(ae),Ce=$e.findInOutputs(ae),Le=Ce.flatMap(Z=>(0,m.$rM)(Z.matches,Z.textBuffer)).map((Z,q)=>(Z.webviewIndex=q,Z));if(oe.length>0||Ce.length>0){const Z={index:se,contentResults:(0,m.$rM)(oe,$e.inputTextBuffer),webviewResults:Le};K.push(Z)}});const _={resource:F,cellResults:K};L.set(F,_);return}catch{return}});return await Promise.all(G),{limitHit:W,results:[...L.values()]}}async z(D,b){const k=await this.s.value.stat(D);if(typeof b?.mtime=="number"&&typeof b.etag=="string"&&b.etag!==y.$Cl&&typeof k.mtime=="number"&&typeof k.size=="number"&&b.mtime<k.mtime&&b.etag!==y.$Dl({mtime:b.mtime,size:k.size}))throw new y.$sl((0,v.localize)(10736,null),y.FileOperationResult.FILE_MODIFIED_SINCE,b)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,b,k){if(this.h.has(b))throw new Error(`editor with id ALREADY EXSIST: ${b}`);const C=new i.$lqc(b,this.d,D,k.visibleRanges.map(n.NotebookRange.to),k.selections.map(n.NotebookRange.to),typeof k.viewColumn=="number"?n.ViewColumn.to(k.viewColumn):void 0);this.h.set(b,C)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const k of D.value.removedDocuments){const C=A.URI.revive(k),f=this.g.get(C);f&&(f.dispose(),this.g.delete(C),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(f.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===C.toString()&&this.h.delete(w.id)}if(D.value.addedDocuments){const k=[];for(const C of D.value.addedDocuments){const f=A.URI.revive(C.uri);if(this.g.has(f))throw new Error(`adding EXISTING notebook ${f} `);const w=new l.$kqc(this.c,this.q,this.r,f,C);k.push(...C.cells.map(M=>l.$jqc.asModelAddData(M))),this.g.get(f)?.dispose(),this.g.set(f,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(w.apiNotebook)}}if(D.value.addedEditors)for(const k of D.value.addedEditors){if(this.h.has(k.id))return;const C=A.URI.revive(k.documentUri),f=this.g.get(C);f&&this.B(f,k.id,k)}const b=[];if(D.value.removedEditors)for(const k of D.value.removedEditors){const C=this.h.get(k);C&&(this.h.delete(k),this.k?.id===C.id&&(this.k=void 0),b.push(C))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(C=>this.h.get(C)).filter(C=>!!C);const k=new Set;this.l.forEach(C=>k.add(C.id));for(const C of this.h.values()){const f=k.has(C.id);C._acceptVisibility(f)}this.l=[...this.h.values()].map(C=>C).filter(C=>C.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const b=d.$AQ.String.with("notebookType","A notebook type"),k=new d.$CQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[b,new d.$AQ("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>I.$Le.wrap(f))],new d.$BQ("Notebook Data",f=>n.NotebookData.to(f.value))),C=new d.$CQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[b,new d.$AQ("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new c.$Uw(n.NotebookData.from(f)))],new d.$BQ("Bytes",f=>f.buffer));D.registerApiCommand(k),D.registerApiCommand(C)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$uqc=h}),define(Oe[270],Ne([1,0,19,21,42,41,23,69,44]),function(be,e,v,I,P,O,R,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mqc=void 0,v=We(v),O=We(O),R=We(R);class s{constructor(a,S,d){this.k=a,this.l=S,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=a.filePattern,this.b=a.includePattern&&O.$xk(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.h=new Set,this.j=a.excludePattern&&O.$xk(a.excludePattern)}cancel(){this.g=!0,this.h.forEach(a=>a.cancel()),this.h=new Set}search(a){const S=this.k.folderQueries||[];return new Promise((d,n)=>{const o=c=>{this.f++,a(c)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const l=c.toString(),i=v.$mc(l);this.j&&this.j(l,i)||this.v(o,{base:c,basename:i})}),Promise.all(S.map(c=>this.p(c,o))).then(c=>{d({limitHit:this.e,stats:c[0]||void 0})},c=>{n(new Error((0,P.$nj)(c)))})})}async p(a,S){const d=new I.$ue,n=this.q(a),o=this.r(),c=new $.$hM(this.k,a),l=!c.hasSiblingExcludeClauses();let i;try{this.h.add(d),i=T.$de.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,d.token),t=i.elapsed(),g=T.$de.create();return this.g&&!this.e||(r&&r.forEach(u=>{const m=v.$fc.relative(a.folder.path,u.path);if(l){const p=v.$mc(u.path);this.v(S,{base:a.folder,relativePath:m,basename:p});return}this.s(o,a.folder,m,S)}),this.g&&!this.e)?null:(this.u(o,c,S),{providerTime:t,postProcessTime:g.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(a){const S=(0,$.$gM)(this.k.includePattern,a.includePattern),d=(0,$.$gM)(this.k.excludePattern,a.excludePattern);return{folder:a.folder,excludes:d,includes:S,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}s({pathToEntries:a},S,d,n){if(d===this.a){const c=v.$mc(this.a);this.v(n,{base:S,relativePath:this.a,basename:c})}function o(c){const l=v.$mc(c),i=v.$lc(c);let r=a[i];r||(r=a[i]=[],o(i)),r.push({base:S,relativePath:c,basename:l})}o(d)}u({rootEntries:a,pathToEntries:S},d,n){const o=this,c=this.a;function l(i){const r=(0,$.$jM)(()=>i.map(t=>t.basename));for(let t=0,g=i.length;t<g;t++){const u=i[t],{relativePath:m,basename:p}=u;if(d.matchesExcludesSync(m,p,c!==p?r:void 0))continue;const h=S[m];if(h)l(h);else{if(m===c)continue;o.v(n,u)}if(o.e)break}}l(a)}v(a,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||a(S))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(a,S,d,n){const o=this.c(a.cacheKey),c=new s(a,S,o&&o.token);let l=0;const i=r=>{l+=r.length,d(r.map(t=>this.d(t)))};return this.e(c,A.a,i,n).then(r=>({limitHit:r.limitHit,stats:r.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:l,detailStats:r.stats}:void 0,messages:[]}))}clearCache(a){this.c(a)?.cancel()}c(a){if(a)return this.b.has(a)||this.b.set(a,new I.$ue),this.b.get(a)}d(a){return a.relativePath?{resource:R.$dh(a.base,a.relativePath)}:{resource:a.base}}e(a,S,d,n){const o=n.onCancellationRequested(()=>{a.cancel()}),c=i=>{i&&(l.push(i),S>0&&l.length>=S&&(d(l),l=[]))};let l=[];return a.search(c).then(i=>(l.length&&d(l),o.dispose(),i),i=>(l.length&&d(l),o.dispose(),Promise.reject(i)))}}e.$mqc=A}),define(Oe[271],Ne([1,0,17,240,41,99,28,15,19,23,12,14,2,102,9,43,11,49,118,267,44]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=void 0,e.$iN=b,v=We(v),I=We(I),P=We(P),$=We($),A=We(A),d=We(d);let t=class{constructor(C,f,w,M,N){this.a=C,this.b=f,this.c=w,this.d=M,this.e=N}text(C,f,w={}){C=this.f(C,w);const M=this.a.getValue(),N=f&&f.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(f?.map(c.$Xi),w),type:r.QueryType.Text,contentPattern:C,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:M.search.usePCRE2||N||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles}}f(C,f){const w=this.a.getValue();C.isRegExp&&(C.pattern=C.pattern.replace(/\r?\n/g,"\\n"));const M={...C,wordSeparators:w.editor.wordSeparators};return this.j(C,f)&&(M.isCaseSensitive=!0),this.k(C)&&(M.isMultiline=!0),f.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=f.notebookSearchConfig.includeMarkupInput),f.notebookSearchConfig?.includeMarkupPreview&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownPreview=f.notebookSearchConfig.includeMarkupPreview),f.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=f.notebookSearchConfig.includeCodeInput),f.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=f.notebookSearchConfig.includeOutput),M}file(C,f={}){return{...this.h(C,f),type:r.QueryType.File,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey,shouldGlobMatchFilePattern:f.shouldGlobSearch}}g(C,f){return C?(C=Array.isArray(C)?C.map(h):h(C),f?this.parseSearchPaths(C):{pattern:u(...Array.isArray(C)?C:[C])}):{}}h(C=[],f={}){const w=this.g(f.includePattern,f.expandPatterns),M=this.g(f.excludePattern,f.expandPatterns),N=C.length>1,L=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(F=>this.q(F,f,M)):C.map(F=>this.r(F,f,M,N))).filter(F=>!!F),W={_reason:f._reason,folderQueries:L,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:M.pattern,includePattern:w.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const F=v.$Gb(this.c.groups.flatMap(le=>le.editors.map(_=>_.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const K=F.filter(le=>(0,r.$0L)(W,le.fsPath)),Y=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...W,...Y}}const G=f.extraFileResources&&f.extraFileResources.filter(F=>(0,r.$0L)(W,F.fsPath));return W.extraFileResources=G&&G.length?G:void 0,W}i(C){const f=[],w=new R.$zc,M={};let N=!1;return C.forEach(L=>{if(L.scheme===T.Schemas.walkThrough)return;if((0,s.$hh)(L)){const G=this.b.getWorkspaceFolder(L)?.uri??L.with({path:$.$lc(L.fsPath)});let F=w.get(G);F||(N=!0,F={folder:G,includePattern:{}},f.push(F),w.set(G,F));const K=$.$kc(G.fsPath,L.fsPath);(0,y.$ng)(F.includePattern)[K.replace(/\\/g,"/")]=!0}else L.fsPath&&(N=!0,M[L.fsPath]=!0)}),{folderQueries:f,includePattern:M,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(C,f){if(f.isSmartCase){if(C.isRegExp){if(A.$6f(C.pattern,!0))return!0}else if(A.$6f(C.pattern))return!0}return!!C.isCaseSensitive}k(C){return C.isMultiline||C.isRegExp&&(0,S.$iD)(C.pattern)||C.pattern.indexOf(`
`)>=0?!0:!!C.isMultiline}parseSearchPaths(C){const f=Y=>$.$hc(Y)||/^\.\.?([\/\\]|$)/.test(Y),M=(Array.isArray(C)?C:m(C)).map(Y=>{const le=this.e.resolvedUserHome;return le?(0,O.$Zw)(Y,le.scheme===T.Schemas.file?le.fsPath:le.path):Y}),N=I.$c(M,Y=>f(Y)?"searchPaths":"exprSegments"),L=(N.exprSegments||[]).map(Y=>A.$lf(Y,"/")).map(Y=>A.$lf(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),p(Y))),W={},G=this.m(N.searchPaths||[]);G&&G.length&&(W.searchPaths=G);const F=L.flat(),K=u(...F);return K&&(W.pattern=K),W}l(C,f){return f.disregardExcludeSettings?void 0:(0,r.$9L)(C,!f.disregardSearchExcludeSettings)}m(C){if(!C||!C.length)return[];const f=C.flatMap(M=>{let{pathPortion:N,globPortion:L}=g(M);return L&&(L=E(L)),this.n(N).flatMap(G=>this.o(G,L))}),w=new Map;return f.forEach(M=>{const N=M.searchPath.toString(),L=w.get(N);L?M.pattern&&(L.pattern=L.pattern||{},L.pattern[M.pattern]=!0):w.set(N,{searchPath:M.searchPath,pattern:M.pattern?u(M.pattern):void 0})}),Array.from(w.values())}n(C){if($.$hc(C)){const f=this.b.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==T.Schemas.file?[{searchPath:f[0].uri.with({path:C})}]:[{searchPath:a.URI.file($.$gc(C))}]}if(this.b.getWorkbenchState()===c.WorkbenchState.FOLDER){const f=this.b.getWorkspace().folders[0].uri;if(C=h(C),C.startsWith("../")||C===".."){const M=$.$fc.resolve(f.path,C);return[{searchPath:f.with({path:M})}]}const w=E(C);return[{searchPath:f,pattern:w}]}else{if(C==="./"||C===".\\")return[];{const f=C.replace(/^\.[\/\\]/,""),M=this.b.getWorkspace().folders.map(N=>{const L=f.match(new RegExp(`^${A.$ff(N.name)}(?:/(.*)|$)`));return L?{match:L,folder:N}:null}).filter(y.$kg);if(M.length)return M.map(N=>{const L=N.match[1];return{searchPath:N.folder.uri,pattern:L&&E(L)}});{const N=C.match(/\.[\/\\](.+)[\/\\]?/),L=N?N[1]:C,W=d.localize(1613,null,L);throw new Error(W)}}}}o(C,f){const w=C.pattern&&f?`${C.pattern}/${f}`:C.pattern||f,M=[{searchPath:C.searchPath,pattern:w}];return w&&!w.endsWith("**")&&M.push({searchPath:C.searchPath,pattern:w+"/**"}),M}q(C,f,w){const M=this.r((0,c.$Xi)(C.searchPath),f,w,!1);return M?{...M,includePattern:C.pattern}:null}r(C,f,w,M){let N;const L=a.URI.isUri(C)?C:C.uri;if(w.searchPaths){const Y=w.searchPaths.filter(le=>(0,s.$9g)(le.searchPath,L))[0];if(Y&&!Y.pattern)return null;Y&&(N=Y.pattern)}const W=this.a.getValue({resource:L}),F={...this.l(W,f)||{},...N||{}},K=a.URI.isUri(C)?(0,s.$ah)(C):C.name;return{folder:L,folderName:M?K:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!W.search.followSymlinks}}};e.$hN=t,e.$hN=t=Ge([Ve(0,n.$9i),Ve(1,c.$Li),Ve(2,l.$qE),Ve(3,o.$0j),Ve(4,i.$fN)],t);function g(k){const C=k.match(/[\*\{\}\(\)\[\]\?]/);if(C){const f=C.index,w=k.substr(0,f).match(/[/|\\][^/\\]*$/);if(w){let M=k.substr(0,w.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:k.substr((w.index||0)+1)}}}return{pathPortion:k}}function u(...k){return k.length?k.reduce((C,f)=>(C[f]=!0,C),Object.create(null)):void 0}function m(k){return P.$vk(k,",").map(C=>C.trim()).filter(C=>!!C.length)}function p(k){return[`**/${k}/**`,`**/${k}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function h(k){return k.replace(/\\/g,"/")}function E(k){return h(k).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(k){return k.replace(/([?*[\]])/g,"[$1]")}function b(k,C){k=v.$Lb(k,M=>M.toString());const f=[],w=C.getWorkspace();return k&&k.forEach(M=>{let N;if(C.getWorkbenchState()===c.WorkbenchState.FOLDER)N=(0,s.$fh)(w.folders[0].uri,M),N&&N!=="."&&(N="./"+N);else{const L=C.getWorkspaceFolder(M);if(L){const W=L.name;if(w.folders.filter(F=>F.name===W).length===1){const F=(0,s.$fh)(L.uri,M);F===""?N=`./${L.name}`:N=`./${L.name}/${F}`}else N=M.fsPath}}N&&f.push(D(N))}),f}}),define(Oe[272],Ne([1,0,23,2,21,13,3,271,44,49,10]),function(be,e,v,I,P,O,R,T,$,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ryb=a,e.$syb=n,v=We(v),O=We(O);const y=7e3;function a(o,c){const l=c.activationEvents;if(!l)return Promise.resolve(void 0);const i=[],r=[];for(const h of l)if(/^workspaceContains:/.test(h)){const E=h.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||o.forceUsingSearch?r.push(E):i.push(E)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:t,resolve:g}=(0,A.$vh)(),u=h=>g({activationEvent:h}),m=Promise.all(i.map(h=>S(o,h,u))).then(()=>{}),p=d(o,c.identifier,r,u);return Promise.all([m,p]).then(()=>{g(void 0)}),t}async function S(o,c,l){for(const i of o.folders)if(await o.exists(v.$dh(I.URI.revive(i),c))){l(`workspaceContains:${c}`);return}}async function d(o,c,l,i){if(l.length===0)return Promise.resolve(void 0);const r=new P.$ue,t=o.checkExists(o.folders,l,r.token),g=setTimeout(async()=>{r.cancel(),o.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},y);let u=!1;try{u=await t}catch(m){O.$3(m)||O.$Y(m)}r.dispose(),clearTimeout(g),u&&i(`workspaceContains:${l.join(",")}`)}function n(o,c,l,i){const r=o.get(R.$Bi),t=o.get($.$1L),u=r.createInstance(T.$hN).file(c.map(m=>(0,s.$Xi)(I.URI.revive(m))),{_reason:"checkExists",includePattern:l,exists:!0});return t.fileSearch(u,i).then(m=>!!m.limitHit,m=>O.$3(m)?!1:Promise.reject(m))}}),define(Oe[47],Ne([1,0,9,19,64,23,10,4,58,2,11,5,46,206,88,45,24,119,13,18,22,189,7,109,3,26,91,16,74,92,56,94,6,272,87,191,15,85,69,20,86]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l,i,r,t,g,u,m,p,h,E,D,b,k,C,f,w,M,N,L,W,G,F,K){"use strict";var Y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zpc=e.$Ypc=e.$Xpc=e.$Wpc=e.$Vpc=void 0,v=We(v),I=We(I),P=We(P),l=We(l),e.$Vpc=(0,m.$Ci)("IHostUtils");let le=Y=class extends T.$Tc{constructor(Z,q,te,ve,ce,we,ue,X,x,me,pe,Re,ze){super(),this.Y=Re,this.Z=ze,this.a=this.B(new f.$je),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=q,this.g=te,this.f=ue,this.j=ve,this.m=ce,this.s=we,this.t=x,this.u=me,this.w=pe,this.y=this.g.getProxy(y.$DN.MainThreadWorkspace),this.z=this.g.getProxy(y.$DN.MainThreadTelemetry),this.C=this.g.getProxy(y.$DN.MainThreadExtensionService),this.D=new R.$Bh,this.F=new R.$Bh,this.G=new R.$Bh,this.H=new R.$Bh,this.I=new Ce(this.f.extensions.activationEvents),this.L=new c.$jdc(this.I,this.f.extensions.allExtensions);const ke=new i.$pn(this.f.extensions.myExtensions);this.J=new c.$jdc(this.I,$e(this.L,ke)),F.$u&&(this.s.info(`Creating extension host with the following global extensions: ${se(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${se(this.J)}`)),this.M=new d.$Epc(this.g,this.s),this.N=new M.$Opc(this.g),this.O=X,this.h=this.q.add(Z.createChild(new D.$Ai([d.$Fpc,this.M],[M.$Ppc,this.N]))),this.P=this.B(new S.$Dpc(this.J,this.L,{onExtensionActivationError:(Pe,Te,U)=>{this.C.$onExtensionActivationError(Pe,l.$1(Te),U)},actualActivateExtension:async(Pe,Te)=>{if(c.$jdc.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,Te),new S.$Cpc;const U=this.J.getExtensionDescription(Pe);return this.fb(U,Te)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Z){l.$Y(Z)}}async $(){this.O.onWillDeactivateAll();let Z=[];try{Z=this.J.getAllExtensionDescriptions().map(ce=>ce.identifier).filter(ce=>this.isActivated(ce)).map(ce=>this.eb(ce))}catch{}await Promise.all(Z)}terminate(Z,q=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Z}`),this.s.flush(),this.u.dispose(),this.P.dispose(),l.setUnexpectedErrorHandler(ve=>{this.s.error(ve)}),this.g.dispose();const te=this.$();Promise.race([(0,R.$Dh)(5e3),te]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${q}`):this.s.info(`Extension host exiting with code ${q}`),this.s.flush(),this.s.dispose(),this.c.exit(q)})}isActivated(Z){return this.G.isOpen()?this.P.isActivated(Z):!1}async getExtension(Z){const q=await this.C.$getExtension(Z);return q&&{...q,identifier:new i.$on(q.identifier.value),extensionLocation:s.URI.revive(q.extensionLocation)}}ab(Z,q){return this.P.activateByEvent(Z,q)}bb(Z,q){return this.P.activateById(Z,q)}activateByIdWithErrors(Z,q){return this.bb(Z,q).then(()=>{const te=this.P.getActivatedExtension(Z);if(te.activationFailed)return Promise.reject(te.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Z=>this.J)}getExtensionExports(Z){if(this.G.isOpen())return this.P.getActivatedExtension(Z).exports;try{return this.P.getActivatedExtension(Z).exports}catch{return null}}async cb(Z){if(Z.scheme===L.Schemas.file&&this.c.fsRealpath){const q=Z.fsPath;this.R.has(q)||this.R.set(q,this.c.fsRealpath(q));const te=await this.R.get(q);return s.URI.file(te)}return Z}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Z=>new oe(Z))),this.Q}async db(Z){const q=$.$Ii.forUris(te=>O.$7g.ignorePathCasing(te));return await Promise.all(Z.map(async te=>{if(this.wb(te)){const ve=await this.cb(te.extensionLocation);q.set(ve,te)}})),q}eb(Z){let q=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Z))return q;const te=this.P.getActivatedExtension(Z);if(!te)return q;try{typeof te.module.deactivate=="function"&&(q=Promise.resolve(te.module.deactivate()).then(void 0,ve=>(this.s.error(ve),Promise.resolve(void 0))))}catch(ve){this.s.error(`An error occurred when deactivating the extension '${Z.value}':`),this.s.error(ve)}try{te.disposable.dispose()}catch(ve){this.s.error(`An error occurred when disposing the subscriptions for extension '${Z.value}':`),this.s.error(ve)}return q}async fb(Z,q){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Z.identifier):await this.C.$onWillActivateExtension(Z.identifier),this.hb(Z,q).then(te=>{const ve=te.activationTimes;return this.C.$onDidActivateExtension(Z.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,q),this.gb(Z,q,"success",ve),te},te=>{throw this.gb(Z,q,"failure"),te})}gb(Z,q,te,ve){const ce=ge(Z,q);this.z.$publicLog2("extensionActivationTimes",{...ce,...ve||{},outcome:te})}hb(Z,q){const te=ge(Z,q);this.z.$publicLog2("activatePlugin",te);const ve=this.wb(Z);if(!ve)return Promise.resolve(new S.$Bpc(S.$ypc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Z.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${Z.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this.s.flush();const ce=new T.$Sc,we=new S.$zpc(q.startup);return Promise.all([this.xb(Z,(0,O.$dh)(Z.extensionLocation,ve),we),this.ib(Z,ce)]).then(ue=>(P.mark(`code/extHost/willActivateExtension/${Z.identifier.value}`),Y.jb(this.s,Z.identifier,ue[0],ue[1],ce,we))).then(ue=>(P.mark(`code/extHost/didActivateExtension/${Z.identifier.value}`),ue))}ib(Z,q){const te=this.Z.createLanguageModelAccessInformation(Z),ve=q.add(new t.$Hpc(Z,this.M)),ce=q.add(new t.$Gpc(Z.identifier.value,!1,this.M)),we=q.add(new N.$Qpc(Z,this.N)),ue=Z.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?g.ExtensionMode.Test:g.ExtensionMode.Development:g.ExtensionMode.Production,X=this.f.remote.isRemote?g.ExtensionKind.Workspace:g.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Z.identifier.value}`),Promise.all([ve.whenReady,ce.whenReady,this.O.whenReady]).then(()=>{const x=this;let me,pe;const Re=(0,o.$cH)(Z,"ipc")?this.f.messagePorts?.get(i.$on.toKey(Z.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:ce,secrets:we,subscriptions:[],get languageModelAccessInformation(){return te},get extensionUri(){return Z.extensionLocation},get extensionPath(){return Z.extensionLocation.fsPath},asAbsolutePath(ze){return I.$ic(Z.extensionLocation.fsPath,ze)},get storagePath(){return x.O.workspaceValue(Z)?.fsPath},get globalStoragePath(){return x.O.globalValue(Z).fsPath},get logPath(){return I.$ic(x.f.logsLocation.fsPath,Z.identifier.value)},get logUri(){return s.URI.joinPath(x.f.logsLocation,Z.identifier.value)},get storageUri(){return x.O.workspaceValue(Z)},get globalStorageUri(){return x.O.globalValue(Z)},get extensionMode(){return ue},get extension(){return me===void 0&&(me=new ae(x,Z.identifier,Z,X,!1)),me},get extensionRuntime(){return(0,o.$dH)(Z,"extensionRuntime"),x.extensionRuntime},get environmentVariableCollection(){return x.u.getEnvironmentVariableCollection(Z)},get messagePassingProtocol(){if(!pe){if(!Re)return;const ze=f.Event.buffer(f.Event.fromDOMEventEmitter(Re,"message",ke=>ke.data));Re.start(),pe={onDidReceiveMessage:ze,postMessage:Re.postMessage.bind(Re)}}return pe}})})}static jb(Z,q,te,ve,ce,we){return te=te||{activate:void 0,deactivate:void 0},this.kb(Z,q,te,ve,we).then(ue=>new S.$Apc(!1,null,we.build(),te,ue,(0,T.$Rc)(()=>{ce.dispose(),(0,T.$Oc)(ve.subscriptions)})))}static kb(Z,q,te,ve,ce){if(typeof te.activate=="function")try{ce.activateCallStart(),Z.trace(`ExtensionService#_callActivateOptional ${q.value}`);const we=typeof global=="object"?global:self,ue=te.activate.apply(we,[ve]);return ce.activateCallStop(),ce.activateResolveStart(),Promise.resolve(ue).then(X=>(ce.activateResolveStop(),X))}catch(we){return Promise.reject(we)}else return Promise.resolve(te)}lb(Z,q){this.bb(Z.identifier,{startup:!1,extensionId:Z.identifier,activationEvent:q}).then(void 0,te=>{this.s.error(te)})}mb(Z,q=0){const ve=Date.now();(0,F.$C)(()=>{for(let ce=q;ce<Z.length;ce+=1){const we=Z[ce];for(const ue of we.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-ve>50){this.mb(Z,ce);break}else this.lb(we,ue)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(Z=>{const q=Z.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),te=this.J.getAllExtensionDescriptions();if(q)this.mb(te);else for(const ve of te)if(ve.activationEvents)for(const ce of ve.activationEvents)ce==="onStartupFinished"&&this.lb(ve,ce)})}ob(){const Z=this.ab("*",!0).then(void 0,we=>{this.s.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.pb(we.added)));const q=this.j.workspace?this.j.workspace.folders:[],te=this.pb(q),ve=this.rb(),ce=Promise.all([ve,Z,te]).then(()=>{});return Promise.race([ce,(0,R.$Dh)(1e4)]).then(()=>{this.nb()}),ce}pb(Z){return Z.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(q=>this.qb(Z,q))).then(()=>{})}async qb(Z,q){if(this.isActivated(q.identifier))return;const te=!this.f.remote.isRemote&&!!this.f.remote.authority,ve={logService:this.s,folders:Z.map(we=>we.uri),forceUsingSearch:te||!this.c.fsExists,exists:we=>this.c.fsExists(we.fsPath),checkExists:(we,ue,X)=>this.y.$checkExists(we,ue,X)},ce=await(0,w.$ryb)(ve,q);if(ce)return this.bb(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:ce.activationEvent}).then(void 0,we=>this.s.error(we))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Z){throw console.error(Z),Z}}async sb(){const{extensionDevelopmentLocationURI:Z,extensionTestsLocationURI:q}=this.f.environment;if(!Z||!q)throw new Error(v.localize(10743,null));const te=await this.xb(null,q,new S.$zpc(!1));if(!te||typeof te.run!="function")throw new Error(v.localize(10744,null,q.toString()));return new Promise((ve,ce)=>{const we=(x,me)=>{x?(F.$u&&this.s.error("Test runner called back with error",x),ce(x)):(F.$u&&(me?this.s.info(`Test runner called back with ${me} failures.`):this.s.info("Test runner called back with successful outcome.")),ve(typeof me=="number"&&me>0?1:0))},ue=(0,O.$4g)(q),X=te.run(ue,we);X&&X.then&&X.then(()=>{F.$u&&this.s.info("Test runner finished successfully."),ve(0)}).catch(x=>{F.$u&&this.s.error("Test runner finished with error",x),ce(x instanceof Error&&x.stack?x.stack:String(x))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Dh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Z,q){return this.S[Z]=q,(0,T.$Rc)(()=>{delete this.S[Z]})}async getRemoteExecServer(Z){const{resolver:q}=await this.ub(Z);return q?.resolveExecServer?.(Z,{resolveAttempt:0})}async ub(Z){const q=Z.indexOf("+");if(q===-1)throw new g.$NN("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const te=Z.substr(0,q);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${te}`,!1),{authorityPrefix:te,resolver:this.S[te]}}async $resolveAuthority(Z,q){const te=G.$de.create(!1),ve=()=>`[resolveAuthority(${(0,u.$Sl)(Z)},${q})][${te.elapsed()}ms] `,ce=B=>this.s.info(`${ve()}${B}`),we=B=>this.s.warn(`${ve()}${B}`),ue=(B,H=void 0)=>this.s.error(`${ve()}${B}`,H),X=B=>{if(B instanceof g.$NN)return{type:"error",error:{code:B._code,message:B._message,detail:B._detail}};throw B},x=async B=>{ce(`activating resolver for ${B}...`);const{resolver:H,authorityPrefix:V}=await this.ub(B);if(!H)throw ue(`no resolver for ${V}`),new g.$NN(`No remote extension installed to resolve ${V}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:V,remoteAuthority:B}},me=Z.split(/@|%40/g).reverse();ce(`activating remote resolvers ${me.join(" -> ")}`);let pe;try{pe=await Promise.all(me.map(x)).catch(async B=>{if(!(B instanceof g.$NN)||B._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw B;return we(`resolving nested authorities failed: ${B.message}`),[await x(Z)]})}catch(B){return X(B)}const Re=new R.$Nh;Re.cancelAndSet(()=>ce("waiting..."),1e3);let ze,ke;for(const[B,{authorityPrefix:H,resolver:V,remoteAuthority:ne}]of pe.entries())try{if(B===pe.length-1)ce("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${H}`),ze=await V.resolve(ne,{resolveAttempt:q,execServer:ke}),P.mark(`code/extHost/didResolveAuthorityOK/${H}`),ce("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(V,g.$MN.isManagedResolvedAuthority(ze)?ze:void 0));else{if(ce(`invoking resolveExecServer() for ${ne}`),P.mark(`code/extHost/willResolveExecServer/${H}`),ke=await V.resolveExecServer?.(ne,{resolveAttempt:q,execServer:ke}),!ke)throw new g.$NN(`Exec server was not available for ${ne}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(fe){return P.mark(`code/extHost/didResolveAuthorityError/${H}`),ue("returned an error",fe),Re.dispose(),X(fe)}Re.dispose();const Pe={environmentTunnels:ze.environmentTunnels,features:ze.tunnelFeatures?{elevation:ze.tunnelFeatures.elevation,privacyOptions:ze.tunnelFeatures.privacyOptions,protocol:ze.tunnelFeatures.protocol===void 0?!0:ze.tunnelFeatures.protocol}:void 0},Te={extensionHostEnv:ze.extensionHostEnv,isTrusted:ze.isTrusted,authenticationSession:ze.authenticationSessionForInitializingExtensions?{id:ze.authenticationSessionForInitializingExtensions.id,providerId:ze.authenticationSessionForInitializingExtensions.providerId}:void 0};ce(`returned ${g.$MN.isManagedResolvedAuthority(ze)?"managed authority":`${ze.host}:${ze.port}`}`);let U;if(g.$MN.isManagedResolvedAuthority(ze)){const B=q;this.Y.setFactory(B,ze.makeConnection),U={authority:Z,connectTo:new u.$Pl(B),connectionToken:ze.connectionToken}}else U={authority:Z,connectTo:new u.$Ql(ze.host,ze.port),connectionToken:ze.connectionToken};return{type:"ok",value:{authority:U,options:Te,tunnelInformation:Pe}}}async $getCanonicalURI(Z,q){this.s.info(`$getCanonicalURI invoked for authority (${(0,u.$Sl)(Z)})`);const{resolver:te}=await this.ub(Z);if(!te)return null;const ve=s.URI.revive(q);if(typeof te.getCanonicalURI>"u")return ve;const ce=await(0,R.$uh)(()=>te.getCanonicalURI(ve));return ce||ve}async $startExtensionHost(Z){Z.toAdd.forEach(we=>we.extensionLocation=s.URI.revive(we.extensionLocation));const{globalRegistry:q,myExtensions:te}=_(this.I,this.L,this.J,Z),ve=await this.db(te);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(q.getAllExtensionDescriptions()),this.J.set(te),F.$u&&(this.s.info(`$startExtensionHost: global extensions: ${se(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${se(this.J)}`)),this.tb()}$activateByEvent(Z,q){return q===o.ActivationKind.Immediate?this.D.wait().then(te=>this.ab(Z,!1)):this.G.wait().then(te=>this.ab(Z,!1))}async $activate(Z,q){return await this.G.wait(),this.J.getExtensionDescription(Z)?(await this.bb(Z,q),!0):!1}async $deltaExtensions(Z){Z.toAdd.forEach(we=>we.extensionLocation=s.URI.revive(we.extensionLocation));const{globalRegistry:q,myExtensions:te}=_(this.I,this.L,this.J,Z),ve=await this.db(te);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(q.getAllExtensionDescriptions()),this.J.set(te),F.$u&&(this.s.info(`$deltaExtensions: global extensions: ${se(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${se(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Z){return Z}async $test_up(Z){return Z.byteLength}async $test_down(Z){const q=r.$Le.alloc(Z),te=Math.random()%256;for(let ve=0;ve<Z;ve++)q.writeUInt8(te,ve);return q}async $updateRemoteConnectionData(Z){this.X=Z,this.a.fire()}};e.$Wpc=le,e.$Wpc=le=Y=Ge([Ve(0,m.$Bi),Ve(1,e.$Vpc),Ve(2,E.$cQ),Ve(3,n.$hpc),Ve(4,a.$kpc),Ve(5,A.$0j),Ve(6,p.$sQ),Ve(7,h.$npc),Ve(8,b.$0Fb),Ve(9,k.$Ipc),Ve(10,W.$Spc),Ve(11,K.$Tpc),Ve(12,C.$Mpc)],le);function _(Le,Z,q,te){Le.addActivationEvents(te.addActivationEvents);const ve=new c.$jdc(Le,Z.getAllExtensionDescriptions());ve.deltaExtensions(te.toAdd,te.toRemove);const ce=new i.$pn(q.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of te.myToRemove)ce.delete(ue);for(const ue of te.myToAdd)ce.add(ue);const we=$e(ve,ce);return{globalRegistry:ve,myExtensions:we}}function ge(Le,Z){return{id:Le.identifier.value,name:Le.name,extensionVersion:Le.version,publisherDisplayName:Le.publisher,activationEvents:Le.activationEvents?Le.activationEvents.join(","):null,isBuiltin:Le.isBuiltin,reason:Z.activationEvent,reasonId:Z.extensionId.value}}function se(Le){return Le.getAllExtensionDescriptions().map(Z=>Z.identifier.value).join(",")}e.$Xpc=(0,m.$Ci)("IExtHostExtensionService");class ae{#e;#t;#i;constructor(Z,q,te,ve,ce){this.#e=Z,this.#t=q,this.#i=te.identifier,this.id=te.identifier.value,this.extensionUri=te.extensionLocation,this.extensionPath=I.$gc((0,O.$4g)(te.extensionLocation)),this.packageJSON=te,this.extensionKind=ve,this.isFromDifferentExtensionHost=ce}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Ypc=ae;function $e(Le,Z){return Le.getAllExtensionDescriptions().filter(q=>Z.has(q.identifier))}class oe{constructor(Z){this.a=Z}setSearchTree(Z){this.a=Z}findSubstr(Z){return this.a.findSubstr(Z)}forEach(Z){return this.a.forEach(Z)}}e.$Zpc=oe;class Ce{constructor(Z){this.a=new i.$qn,this.addActivationEvents(Z)}readActivationEvents(Z){return this.a.get(Z.identifier)??[]}addActivationEvents(Z){for(const q of Object.keys(Z))this.a.set(q,Z[q])}}}),define(Oe[273],Ne([1,0,64,2,5,46,24,18,16,26,3,47,11,12]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$$qc=void 0,v=We(v);let n=class{constructor(r,t,g,u,m,p,h){this.c=r,this.d=t,this.e=g,this.f=u,this.g=m,this.h=p,this.i=h,this.a=new Map,this.b=[]}async install(){this.j(),v.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new c(this.c,t,this.d,r,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(l,t,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const t of r.nodeModuleName)this.a.set(t,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(t=>r.alternativeModuleName(t))}};e.$$qc=n,e.$$qc=n=Ge([Ve(2,A.$Bi),Ve(3,O.$kpc),Ve(4,y.$Xpc),Ve(5,s.$sQ),Ve(6,a.$0j)],n);let o=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&d.a.size){const t=(0,S.$ff)(this.c(r.environment.appRoot.fsPath)),g="[a-z0-9_.-]",u=`@${g}+\\/${g}+|${g}+`,m="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${m}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const t=this.b.exec(this.c(r));if(!t)return;const[,g,u,m]=t,p=d.a.get(u);if(p!==void 0)return console.warn(`${u} as been renamed to ${p}, please update your imports`),g+p+m}c(r){return r.replace(/\\/g,"/")}};o=d=Ge([Ve(0,s.$sQ)],o);class c{constructor(r,t,g,u,m){this.c=r,this.d=t,this.e=g,this.f=u,this.g=m,this.nodeModuleName="vscode",this.a=new T.$qn}load(r,t){const g=this.d.findSubstr(t);if(g){let u=this.a.get(g.identifier);return u||(u=this.c(g,this.e,this.f),this.a.set(g.identifier,u)),u}if(!this.b){let u="";this.d.forEach((m,p)=>u+=`	${p} -> ${m.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${u}`),this.b=this.c(R.$0G,this.e,this.f)}return this.b}}let l=class{constructor(r,t,g){this.e=r,this.f=t,this.nodeModuleName=["open","opn"],this.d=g.getProxy(P.$DN.MainThreadTelemetry);const u=g.getProxy(P.$DN.MainThreadWindow);this.c=(m,p)=>{const h=I.URI.parse(m);return p?this.g(m,p):h.scheme==="http"||h.scheme==="https"?u.$openUri(h,m,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this.f?u.$openUri(h,m,{}):this.g(m,p)}}load(r,t,g){const u=this.e.findSubstr(t);return u&&(this.a=u.identifier.value,this.h()),this.b=g(r),this.c}g(r,t){return this.i(),this.b(r,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};l=Ge([Ve(2,$.$cQ)],l)}),define(Oe[132],Ne([1,0,48,4,19,78,3,57,70,47,7,45,203,46]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2pc=e.$1pc=void 0,P=We(P),O=We(O),e.$1pc=(0,R.$Ci)("IExtHostVariableResolverProvider");class d extends a.$gR{constructor(c,l,i,r,t,g,u){function m(){if(i){const p=i.activeEditor();if(p)return p.document.uri;const h=r.tabGroups.all.find(E=>E.isActive)?.activeTab;if(h!==void 0){if(h.input instanceof A.$uP||h.input instanceof A.$zP)return h.input.modified;if(h.input instanceof A.$tP||h.input instanceof A.$yP||h.input instanceof A.$wP)return h.input.uri}}}super({getFolderUri:p=>{const h=g.folders.filter(E=>E.name===p);if(h&&h.length>0)return h[0].uri},getWorkspaceFolderCount:()=>g.folders.length,getConfigurationValue:(p,h)=>t.getConfiguration(void 0,p).get(h),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const p=m();if(p)return P.$gc(p.fsPath)},getWorkspaceFolderPathForFile:()=>{if(l){const p=m();if(p){const h=l.getWorkspaceFolder(p);if(h)return P.$gc(h.uri.fsPath)}}},getSelectedText:()=>{if(i){const p=i.activeEditor();if(p&&!p.selection.isEmpty)return p.document.getText(p.selection)}},getLineNumber:()=>{if(i){const p=i.activeEditor();if(p)return String(p.selection.end.line+1)}},getExtension:p=>c.getExtension(p)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(O.env))}}let n=class extends I.$Tc{constructor(c,l,i,r,t){super(),this.b=c,this.c=l,this.g=i,this.h=r,this.j=t,this.a=new v.$T(async()=>{const g=await this.h.getConfigProvider(),m={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async p=>{m.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,g,m,this.m())})}getResolver(){return this.a.value}m(){}};e.$2pc=n,e.$2pc=n=Ge([Ve(0,s.$Xpc),Ve(1,y.$hpc),Ve(2,T.$nQ),Ve(3,S.$kpc),Ve(4,$.$wpc)],n)}),define(Oe[133],Ne([1,0,10,6,2,4,18,3,5,70,47,16,7,45,195,80,196,46,132,34,33,8,17,95]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l,i,r,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_pc=e.$$pc=e.$0pc=e.$9pc=e.$8pc=void 0,t=We(t),e.$8pc=(0,T.$Ci)("IExtHostDebugService");let m=class extends O.$Tc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(C,f,w,M,N,L,W,G){super(),this.Y=f,this.Z=w,this.$=M,this.ab=N,this.bb=L,this.cb=W,this.db=G,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new I.$je),this.z=this.B(new I.$je),this.C=this.B(new I.$je),this.F=this.B(new I.$je),this.u=C.getProxy($.$DN.MainThreadDebugService),this.I=this.B(new I.$je),this.L=this.B(new I.$je),this.G=new h(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(F=>{this.B(F.onDidChange(K=>{this.fb(F)})),this.fb(F)})}async $getVisualizerTreeItem(C,f){const w=this.gb(f);if(!w)return;const M=await this.Q.get(C)?.getTreeItem?.(w);return M?this.eb(C,M):void 0}registerDebugVisualizationTree(C,f,w){const M=R.$on.toKey(C.identifier),N=this.ub(M,f);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this.Q.set(N,w),this.u.$registerDebugVisualizerTree(N,!!w.editItem),(0,O.$Rc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete(f)})}async $getVisualizerTreeItemChildren(C,f){const w=this.S.get(f)?.item;return w?(await this.Q.get(C)?.getChildren?.(w))?.map(N=>this.eb(C,N))||[]:[]}async $editVisualizerTreeItem(C,f){const w=this.S.get(C);if(!w)return;const M=await this.Q.get(w.provider)?.editItem?.(w.item,f);return this.eb(w.provider,M||w.item)}$disposeVisualizedTree(C){const f=this.S.get(C);if(!f)return;const w=[f.children];for(const M of w)if(M)for(const N of M)w.push(this.S.get(N)?.children),this.S.delete(N)}eb(C,f){let w=this.R.get(f);return w||(w=this.O++,this.R.set(f,w),this.S.set(w,{provider:C,item:f})),t.DebugTreeItem.from(f,w)}asDebugSourceUri(C,f){const w=C;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let M=`debug:${encodeURIComponent(w.path||"")}`,N="?";return f&&(M+=`${N}session=${encodeURIComponent(f.id)}`,N="&"),M+=`${N}ref=${w.sourceReference}`,P.URI.parse(M)}else{if(w.path)return P.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(C){const f=[];for(const w of C.getAllExtensionDescriptions())if(w.contributes){const M=w.contributes.debuggers;if(M&&M.length>0)for(const N of M)(0,o.$8H)(N)&&f.push(N.type)}this.u.$registerDebugTypes(f)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const C=[];return this.H.forEach(f=>C.push(f)),C}async $resolveDebugVisualizer(C,f){const w=this.W.get(C);if(!w)throw new Error(`No debug visualizer found with id '${C}'`);let{v:M,provider:N,extensionId:L}=w;if(M.visualization||(M=await N.resolveDebugVisualization?.(M,f)||M,w.v=M),!M.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(L,M.visualization)}async $executeDebugVisualizerCommand(C){const f=this.W.get(C);if(!f)throw new Error(`No debug visualizer found with id '${C}'`);const w=f.v.visualization;w&&"command"in w&&this.cb.executeCommand(w.command,...w.arguments||[])}gb(C){const f=this.w.get(C.sessionId);return f&&{session:f.api,variable:C.variable,containerId:C.containerId,frameId:C.frameId,threadId:C.threadId}}async $provideDebugVisualizers(C,f,w,M){const N=this.gb(w),L=this.ub(C,f),W=this.P.get(L);if(!N||!W)return[];const G=await W.provideDebugVisualization(N,M);return G?G.map(F=>{const K=++this.X;this.W.set(K,{v:F,provider:W,extensionId:C});const Y=F.iconPath?this.wb(F.iconPath):void 0;return{id:K,name:F.name,iconClass:Y?.iconClass,iconPath:Y?.iconPath,visualization:this.vb(C,F.visualization)}}):[]}$disposeDebugVisualizers(C){for(const f of C)this.W.delete(f)}registerDebugVisualizationProvider(C,f,w){if(!C.contributes?.debugVisualizers?.some(L=>L.id===f))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${f})`);const M=R.$on.toKey(C.identifier),N=this.ub(M,f);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this.P.set(N,w),this.u.$registerDebugVisualizer(M,f),(0,O.$Rc)(()=>{this.u.$unregisterDebugVisualizer(M,f),this.P.delete(f)})}addBreakpoints(C){const f=C.filter(N=>{const L=N.id;return this.H.has(L)?!1:(this.H.set(L,N),!0)});this.rb(f,[],[]);const w=[],M=new Map;for(const N of f)if(N instanceof a.$JO){let L=M.get(N.location.uri.toString());L||(L={type:"sourceMulti",uri:N.location.uri,lines:[]},M.set(N.location.uri.toString(),L),w.push(L)),L.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof a.$KO&&w.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(w)}removeBreakpoints(C){const f=C.filter(L=>this.H.delete(L.id));this.rb([],f,[]);const w=f.filter(L=>L instanceof a.$JO).map(L=>L.id),M=f.filter(L=>L instanceof a.$KO).map(L=>L.id),N=f.filter(L=>L instanceof a.$LO).map(L=>L.id);return this.u.$unregisterBreakpoints(w,M,N)}startDebugging(C,f,w){const M=w.testRun&&this.db.getMetadataForRun(w.testRun);return this.u.$startDebugging(C?C.uri:void 0,f,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===a.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,testRun:M&&{runId:M.runId,taskId:M.taskId},suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(C){return this.u.$stopDebugging(C?C.id:void 0)}registerDebugConfigurationProvider(C,f,w){if(!f)return new a.$FN(()=>{});const M=this.f++;return this.g.push({type:C,handle:M,provider:f}),this.u.$registerDebugConfigurationProvider(C,w,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,M),new a.$FN(()=>{this.g=this.g.filter(N=>N.provider!==f),this.u.$unregisterDebugConfigurationProvider(M)})}registerDebugAdapterDescriptorFactory(C,f,w){if(!w)return new a.$FN(()=>{});if(!this.nb(C,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.kb(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const M=this.h++;return this.j.push({type:f,handle:M,factory:w}),this.u.$registerDebugAdapterDescriptorFactory(f,M),new a.$FN(()=>{this.j=this.j.filter(N=>N.factory!==w),this.u.$unregisterDebugAdapterDescriptorFactory(M)})}registerDebugAdapterTrackerFactory(C,f){if(!f)return new a.$FN(()=>{});const w=this.m++;return this.n.push({type:C,handle:w,factory:f}),new a.$FN(()=>{this.n=this.n.filter(M=>M.factory!==f)})}async $runInTerminal(C,f){return Promise.resolve(void 0)}async $substituteVariables(C,f){let w;const M=await this.tb(C);return M&&(w={uri:M.uri,name:M.name,index:M.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(w,f)}hb(C,f){if(C.type==="implementation")return new D(C.implementation)}ib(){}async $startDASession(C,f){const w=this,M=await this.sb(f);return this.pb(this.kb(M.type),M).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}' (extension might have failed to activate)`);const L=this.jb(N),W=this.hb(L,M);if(!W)throw new Error(`Couldn't create a debug adapter for type '${M.type}'.`);const G=W;return this.M.set(C,G),this.ob(M).then(F=>(F&&this.N.set(C,F),G.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const Y=K,le={type:"response",seq:0,command:Y.command,request_seq:Y.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const _=await this.U.sign(Y.arguments.value);le.body={signature:_},G.sendResponse(le)}else throw new Error("no signer")}catch(_){le.success=!1,le.message=_.message,G.sendResponse(le)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(K),K=(0,o.$aI)(K,!0),w.u.$acceptDAMessage(C,K)}),G.onError(K=>{F&&F.onError&&F.onError(K),this.u.$acceptDAError(C,K.name,K.message,K.stack)}),G.onExit(K=>{F&&F.onExit&&F.onExit(K??void 0,void 0),this.u.$acceptDAExit(C,K??void 0,void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),G.startSession()))})}$sendDAMessage(C,f){f=(0,o.$_H)(f,!1);const w=this.N.get(C);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(f),this.M.get(C)?.sendMessage(f)}$stopDASession(C){const f=this.N.get(C);this.N.delete(C),f&&f.onWillStopSession&&f.onWillStopSession();const w=this.M.get(C);return this.M.delete(C),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(C){const f=[],w=[],M=[];if(C.added)for(const N of C.added){const L=N.id;if(L&&!this.H.has(L)){let W;if(N.type==="function")W=new a.$KO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")W=new a.$LO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const G=P.URI.revive(N.uri);W=new a.$JO(new a.$TN(G,new a.$GN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,a.$HO)(W,L),this.H.set(L,W),f.push(W)}}if(C.removed)for(const N of C.removed){const L=this.H.get(N);L&&(this.H.delete(N),w.push(L))}if(C.changed){for(const N of C.changed)if(N.id){const L=this.H.get(N.id);if(L){if(L instanceof a.$KO&&N.type==="function"){const W=L;W.enabled=N.enabled,W.condition=N.condition,W.hitCondition=N.hitCondition,W.logMessage=N.logMessage,W.functionName=N.functionName}else if(L instanceof a.$JO&&N.type==="source"){const W=L;W.enabled=N.enabled,W.condition=N.condition,W.hitCondition=N.hitCondition,W.logMessage=N.logMessage,W.location=new a.$TN(P.URI.revive(N.uri),new a.$GN(N.line,N.character))}M.push(L)}}}this.rb(f,w,M)}async $acceptStackFrameFocus(C){let f;if(C){const w=await this.sb(C.sessionId);C.kind==="thread"?f=new a.$RO(w.api,C.threadId):f=new a.$QO(w.api,C.threadId,C.frameId)}this.J=f,this.L.fire(this.J)}$provideDebugConfigurations(C,f,w){return(0,v.$uh)(async()=>{const M=this.mb(C);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb(f);return M.provideDebugConfigurations(N,w)}).then(M=>{if(!M)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return M})}$resolveDebugConfiguration(C,f,w,M){return(0,v.$uh)(async()=>{const N=this.mb(C);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.tb(f);return N.resolveDebugConfiguration(L,w,M)})}$resolveDebugConfigurationWithSubstitutedVariables(C,f,w,M){return(0,v.$uh)(async()=>{const N=this.mb(C);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.tb(f);return N.resolveDebugConfigurationWithSubstitutedVariables(L,w,M)})}async $provideDebugAdapter(C,f){const w=this.lb(C);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const M=await this.sb(f);return this.pb(w,M).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(C){const f=await this.sb(C);this.y.fire(f.api)}async $acceptDebugSessionTerminated(C){const f=await this.sb(C);f&&(this.z.fire(f.api),this.w.delete(f.id))}async $acceptDebugSessionActiveChanged(C){this.D=C?await this.sb(C):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(C,f){(await this.sb(C))?._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(C,f){const M={session:(await this.sb(C)).api,event:f.event,body:f.body};this.F.fire(M)}jb(C){if(C instanceof a.$MO)return{type:"executable",command:C.command,args:C.args,options:C.options};if(C instanceof a.$NO)return{type:"server",port:C.port,host:C.host};if(C instanceof a.$OO)return{type:"pipeServer",path:C.path};if(C instanceof a.$PO)return{type:"implementation",implementation:C.implementation};throw new Error("convertToDto unexpected type")}kb(C){const f=this.j.filter(w=>w.type===C);if(f.length>0)return f[0].factory}lb(C){const f=this.j.filter(w=>w.handle===C);if(f.length>0)return f[0].factory}mb(C){const f=this.g.filter(w=>w.handle===C);if(f.length>0)return f[0].provider}nb(C,f){if(C.contributes){const w=C.contributes.debuggers;if(w&&w.length>0){for(const M of w)if(M.label&&M.type&&M.type===f)return!0}}return!1}ob(C){const w=C.configuration.type,M=this.n.filter(N=>N.type===w||N.type==="*").map(N=>(0,v.$uh)(()=>N.factory.createDebugAdapterTracker(C.api)).then(L=>L,L=>null));return Promise.race([Promise.all(M).then(N=>{const L=(0,g.$Gb)(N);if(L.length>0)return new E(L)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(C,f){const w=f.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new a.$NO(w));if(C){const N=await this.Z.getExtensionRegistry();return(0,v.$uh)(()=>C.createDebugAdapterDescriptor(f.api,this.qb(f,N))).then(L=>{if(L)return L})}const M=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(f,M))}qb(C,f){}rb(C,f,w){(C.length>0||f.length>0||w.length>0)&&this.I.fire(Object.freeze({added:C,removed:f,changed:w}))}async sb(C){if(C)if(typeof C=="string"){const f=this.w.get(C);if(f)return f}else{let f=this.w.get(C.id);if(!f){const w=await this.tb(C.folderUri),M=C.parent?this.w.get(C.parent):void 0;f=new p(this.u,C.id,C.type,C.name,w,C.configuration,M?.api),this.w.set(f.id,f),this.u.$sessionCached(f.id)}return f}throw new Error("cannot find session")}tb(C){if(C){const f=P.URI.revive(C);return this.Y.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}ub(C,f){return`${C}\0${f}`}vb(C,f){if(f){if("title"in f&&"command"in f)return{type:n.DebugVisualizationType.Command};if("treeId"in f)return{type:n.DebugVisualizationType.Tree,id:`${C}\0${f.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(C){const f=this.xb(C);let w,M;return"id"in f?M=i.ThemeIcon.asClassName(f):w=f,{iconPath:w,iconClass:M}}xb(C){if(C instanceof a.$EO)return{id:C.id};const f=typeof C=="object"&&"dark"in C?C.dark:C,w=typeof C=="object"&&"light"in C?C.light:C;return{dark:typeof f=="string"?P.URI.file(f):f,light:typeof w=="string"?P.URI.file(w):w}}};e.$9pc=m,e.$9pc=m=Ge([Ve(0,y.$cQ),Ve(1,S.$hpc),Ve(2,A.$Xpc),Ve(3,c.$kpc),Ve(4,s.$wpc),Ve(5,l.$1pc),Ve(6,r.$yQ),Ve(7,u.$3pc)],m);class p{constructor(C,f,w,M,N,L,W){this.f=C,this.g=f,this.h=w,this.j=M,this.k=N,this.l=L,this.m=W}get api(){const C=this;return this.d??=Object.freeze({id:C.g,type:C.h,get name(){return C.j},set name(f){C.j=f,C.f.$setDebugSessionName(C.g,f)},parentSession:C.m,workspaceFolder:C.k,configuration:C.l,customRequest(f,w){return C.f.$customDebugAdapterRequest(C.g,f,w)},getDebugProtocolBreakpoint(f){return C.f.$getDebugProtocolBreakpoint(C.g,f.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(C){this.j=C}get configuration(){return this.l}}e.$0pc=p;class h{constructor(C){this.value=Object.freeze({append(f){C.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.$$pc=h;class E{constructor(C){this.d=C}onWillStartSession(){this.d.forEach(C=>C.onWillStartSession?C.onWillStartSession():void 0)}onWillReceiveMessage(C){this.d.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(C):void 0)}onDidSendMessage(C){this.d.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(C):void 0)}onWillStopSession(){this.d.forEach(C=>C.onWillStopSession?C.onWillStopSession():void 0)}onError(C){this.d.forEach(f=>f.onError?f.onError(C):void 0)}onExit(C,f){this.d.forEach(w=>w.onExit?w.onExit(C,f):void 0)}}class D extends d.$Wtb{constructor(C){super(),this.h=C,C.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(C){this.h.handleMessage(C)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let b=class extends m{constructor(C,f,w,M,N,L,W,G){super(C,f,w,M,N,L,W,G)}};e.$_pc=b,e.$_pc=b=Ge([Ve(0,y.$cQ),Ve(1,S.$hpc),Ve(2,A.$Xpc),Ve(3,c.$kpc),Ve(4,s.$wpc),Ve(5,l.$1pc),Ve(6,r.$yQ),Ve(7,u.$3pc)],b)}),define(Oe[274],Ne([1,0,13,64,2,5,224,11,60,74,26,170,16,65,47,66]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$arc=e.$_qc=void 0,v=We(v),I=We(I);class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(T.$0j),g=i.get(a.$cQ).getProxy(O.$DN.MainThreadErrors);v.setUnexpectedErrorHandler(u=>{r.error(u);const m=v.$1(u);g.$onUnexpectedError(m)})}static async installFullHandler(i){const r=i.get(T.$0j),t=i.get(a.$cQ),g=i.get(d.$Xpc),u=i.get(n.$wQ),m=t.getProxy(O.$DN.MainThreadExtensionService),p=t.getProxy(O.$DN.MainThreadErrors),h=await g.getExtensionPathIndex(),E=new WeakMap;function D(C,f){if(E.has(C))return E.get(C).stack;let w="",M,N;for(const W of f)w+=`
	at ${W.toString()}`,N=W.getFileName(),!M&&N&&(M=h.findSubstr(P.URI.file(N)));const L=`${C.name||"Error"}: ${C.message||""}${w}`;return E.set(C,{extensionIdentifier:M?.identifier,stack:L}),L}const b=Symbol("prepareStackTrace wrapped");let k=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return k},set(C){if(C===D||!C||C[b]){k=C||D;return}k=function(f,w){return D(f,w),C.call(Error,f,w)},Object.assign(k,{[b]:!0})}}),v.setUnexpectedErrorHandler(C=>{r.error(C);const f=v.$1(C),w=E.get(C);if(!w?.extensionIdentifier){p.$onUnexpectedError(f);return}m.$onExtensionRuntimeError(w.extensionIdentifier,f);const M=u.onExtensionError(w.extensionIdentifier,C);r.trace("forwarded error to extension?",M,w)})}}e.$_qc=o;class c{constructor(i,r,t,g,u){this.a=t,this.b=new R.$rdc(i,null,g),r=c.e(r,this.b);const m=new s.$Ai(...(0,$.$Ps)());m.set(A.$sQ,{_serviceBrand:void 0,...r,messagePorts:u}),m.set(a.$cQ,new a.$dQ(this.b)),m.set(S.$epc,new S.$fpc(g)),m.set(d.$Vpc,t);const p=new y.$tr(m,!0);p.invokeFunction(o.installEarlyHandler),this.d=p.invokeFunction(h=>h.get(T.$0j)),I.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=p.invokeFunction(h=>h.get(d.$Xpc)),this.c.initialize(),p.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(O.$DN.MainThreadExtensionService);return P.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(g=>{g.extensionLocation=P.URI.revive(r.transformIncomingURIs(g.extensionLocation))}),i.environment.appRoot=P.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(g=>P.URI.revive(r.transformIncomingURIs(g)))),i.environment.extensionTestsLocationURI=P.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=P.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=P.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=P.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=P.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=P.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$arc=c}),define(Oe[275],Ne([1,0,17,10,21,42,15,19,23,2,44]),function(be,e,v,I,P,O,R,T,$,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qqc=e.$oqc=e.$nqc=void 0,e.$pqc=n,T=We(T),$=We($);class y{constructor(l,i,r){this.d=l,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(l,i){const r=this.g.folderQueries||[],t=new P.$ue(i);return new Promise((g,u)=>{this.a=new S(l);let m=!1;const p=(h,E)=>{if(!m&&!this.b){const D=this.h(h);n(h)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,m=!0,t.cancel(),h=this.j(h,this.g.maxResults-this.c));const b=this.h(h);this.c+=b,(b>0||!n(h))&&this.a.add(h,E)}};Promise.all(r.map((h,E)=>this.k(h,D=>p(D,E),t.token))).then(h=>{t.dispose(),this.a.flush();const E=h.some(D=>!!D&&!!D.limitHit);g({limitHit:this.b||E,messages:h.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},h=>{t.dispose();const E=(0,O.$nj)(h);u(new Error(E))})})}h(l){return n(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}j(l,i){const r=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:r.slice(0,i),preview:{matches:t.slice(0,i),text:l.preview.text},uri:l.uri}}async k(l,i,r){const t=new A.$hM(this.g,l),g=[],u={report:h=>{if(!this.l(h))return;const E=l.folder.scheme===R.Schemas.file?(0,A.$iM)(()=>this.e.readdir($.$ch(h.uri))):void 0,D=$.$fh(l.folder,h.uri);if(D){const b=t.includedInQuery(D,T.$mc(D),E);(0,I.$oh)(b)?g.push(b.then(k=>{k&&i(h)})):b&&i(h)}}},m=this.n(l);let p;return this.d.query.type===A.QueryType.aiText?p=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,m,u,r):p=await this.d.provider.provideTextSearchResults(a(this.d.query.contentPattern),m,u,r),g.length&&await Promise.all(g),p}l(l){if(n(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(l){const i=(0,A.$gM)(this.g.includePattern,l.includePattern),r=(0,A.$gM)(this.g.excludePattern,l.excludePattern),t={folder:s.URI.from(l.folder),excludes:r,includes:i,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.e.toCanonicalName(l.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??A.$ZL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$nqc=y;function a(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class S{constructor(l){this.e=l,this.b=-1,this.d=null,this.a=new o(512,i=>this.g(i))}add(l,i){this.d&&(this.b!==i||!$.$9g(this.c,l.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:l.uri,results:[]}),this.d.results.push(d(l))}f(){const l=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,l)}flush(){this.f(),this.a.flush()}g(l){this.e(l)}}e.$oqc=S;function d(c){return n(c)?{preview:{matches:(0,v.$Zb)(c.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:c.preview.text},ranges:(0,v.$Zb)(c.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function n(c){return!!c.preview}class o{static{this.a=4e3}static{this.b=50}constructor(l,i){this.g=l,this.h=i,this.c=0,this.d=[],this.e=0}addItem(l,i){l&&this.j(l,i)}addItems(l,i){l&&this.k(l,i)}j(l,i){this.d.push(l),this.e+=i,this.l()}k(l,i){this.d=this.d.concat(l),this.e+=i,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$qqc=o}),define(Oe[134],Ne([1,0,4,5,3,270,16,65,11,2,275]),function(be,e,v,I,P,O,R,T,$,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sqc=e.$rqc=void 0,e.$tqc=a,e.$rqc=(0,P.$Ci)("IExtHostSearch");let y=class{constructor(n,o,c){this.n=n,this.o=o,this.q=c,this.c=this.n.getProxy(I.$DN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$mqc}s(n){return this.o.transformOutgoingScheme(n)}registerTextSearchProvider(n,o){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const c=this.d++;return this.e.set(c,o),this.c.$registerTextSearchProvider(c,this.s(n)),(0,v.$Rc)(()=>{this.g.delete(n),this.e.delete(c),this.c.$unregisterProvider(c)})}registerAITextSearchProvider(n,o){if(this.i.has(n))throw new Error(`an AI text search provider for the scheme '${n}'is already registered`);this.i.add(n);const c=this.d++;return this.h.set(c,o),this.c.$registerAITextSearchProvider(c,this.s(n)),(0,v.$Rc)(()=>{this.i.delete(n),this.h.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(n,o){if(this.k.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.k.add(n);const c=this.d++;return this.j.set(c,o),this.c.$registerFileSearchProvider(c,this.s(n)),(0,v.$Rc)(()=>{this.k.delete(n),this.j.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(n,o,c,l){const i=a(c),r=this.j.get(n);if(r)return this.l.fileSearch(i,r,t=>{this.c.$handleFileMatch(n,o,t.map(g=>g.resource))},l);throw new Error("3 unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,o,c){return{messages:[]}}$clearCache(n){return this.l.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,o,c,l){const i=this.e.get(n);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${n}`);const r=a(c);return this.t(r,i).search(g=>this.c.$handleTextMatch(n,o,g),l)}$provideAITextSearchResults(n,o,c,l){const i=this.h.get(n);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${n}`);const r=a(c);return this.v(r,i).search(g=>this.c.$handleTextMatch(n,o,g),l)}$enableExtensionHostSearch(){}t(n,o){return new A.$nqc({query:n,provider:o},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}v(n,o){return new A.$nqc({query:n,provider:o},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"aiTextSearchProvider")}};e.$sqc=y,e.$sqc=y=Ge([Ve(0,R.$cQ),Ve(1,T.$epc),Ve(2,$.$0j)],y);function a(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(S),extraFileResources:d.extraFileResources&&d.extraFileResources.map(n=>s.URI.revive(n))}}function S(d){return{...d,folder:s.URI.revive(d.folder)}}});var ni=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Oe[276],Ne([1,0,21,13,6,4,15,35,2,105,157,158,52,18,29,11,62,63,185,5,227,256,84,90,232,233,234,211,201,33,235,46,236,133,122,237,213,228,238,239,57,70,214,229,47,241,68,242,50,26,257,215,243,244,94,245,85,86,217,269,247,190,248,258,249,128,218,250,251,252,16,253,134,87,254,219,255,88,91,131,66,56,126,95,259,230,260,261,92,8,7,220,65,221,67,262,263,121,45,80,83,24,130]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l,i,r,t,g,u,m,p,h,E,D,b,k,C,f,w,M,N,L,W,G,F,K,Y,le,_,ge,se,ae,$e,oe,Ce,Le,Z,q,te,ve,ce,we,ue,X,x,me,pe,Re,ze,ke,Pe,Te,U,B,H,V,ne,fe,Ie,je,Qe,_e,tt,nt,et,rt,mt,lt,st,ct,ft,pt,qe,Ue,ee,Q,De,Je,xe,ht,$t,Nt,Wt,ri,Xt,hi,Ye,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qc=Ht,I=We(I),T=ni(T),y=We(y),d=We(d),ee=We(ee),Q=We(Q);function Ht(gt){const St=gt.get(Ce.$sQ),Yt=gt.get(oe.$2oc),Zt=gt.get(ae.$mpc),Ut=gt.get(ge.$Xpc),wt=gt.get(ri.$hpc),At=gt.get(rt.$wQ),ci=gt.get(C.$kpc),Qt=gt.get(Je.$epc),Xe=gt.get(V.$cQ),xt=gt.get(tt.$Fpc),li=gt.get(nt.$npc),di=gt.get(n.$$j),kt=gt.get(n.$0j),Ft=gt.get(Ue.$0Fb),Rt=gt.get(g.$Xoc),Mt=gt.get(Wt.$6qc),si=gt.get(Ie.$Ppc),_t=gt.get(Y.$wpc),ei=gt.get(ue.$Tpc),Bt=gt.get(u.$8oc),qt=gt.get(ve.$Mpc);Xe.set(i.$EN.ExtHostFileSystemInfo,Yt),Xe.set(i.$EN.ExtHostLogLevelServiceShape,di),Xe.set(i.$EN.ExtHostWorkspace,wt),Xe.set(i.$EN.ExtHostConfiguration,ci),Xe.set(i.$EN.ExtHostExtensionService,Ut),Xe.set(i.$EN.ExtHostStorage,xt),Xe.set(i.$EN.ExtHostTunnelService,Ft),Xe.set(i.$EN.ExtHostWindow,Mt),Xe.set(i.$EN.ExtHostSecretState,si),Xe.set(i.$EN.ExtHostTelemetry,At),Xe.set(i.$EN.ExtHostEditorTabs,_t),Xe.set(i.$EN.ExtHostManagedSockets,ei),Xe.set(i.$EN.ExtHostAuthentication,Bt),Xe.set(i.$EN.ExtHostChatProvider,qt);const ui=Xe.set(i.$EN.ExtHostDecorations,gt.get(M.$bqc)),Tt=Xe.set(i.$EN.ExtHostDocumentsAndEditors,gt.get(K.$nQ)),Ct=Xe.set(i.$EN.ExtHostCommands,gt.get(b.$yQ)),bt=Xe.set(i.$EN.ExtHostTerminalService,gt.get(mt.$Ipc)),Kt=Xe.set(i.$EN.ExtHostTerminalShellIntegration,gt.get(lt.$Vqc)),yt=Xe.set(i.$EN.ExtHostDebugService,gt.get(w.$8pc)),oi=Xe.set(i.$EN.ExtHostSearch,gt.get(fe.$rqc)),Gt=Xe.set(i.$EN.ExtHostTask,gt.get(et.$Uqc)),Ai=Xe.set(i.$EN.ExtHostOutputService,gt.get(Pe.$Hqc)),$i=Xe.set(i.$EN.ExtHostLocalization,gt.get(we.$Spc)),Di=Xe.set(i.$EN.ExtHostUrls,new xe.$3qc(Xe)),zt=Xe.set(i.$EN.ExtHostDocuments,new F.$5oc(Xe,Tt)),fi=Xe.set(i.$EN.ExtHostDocumentContentProviders,new W.$dqc(Xe,Tt,kt)),Ni=Xe.set(i.$EN.ExtHostDocumentSaveParticipant,new G.$eqc(kt,zt,Xe.getProxy(i.$DN.MainThreadBulkEdits))),It=Xe.set(i.$EN.ExtHostNotebook,new x.$uqc(Xe,Ct,Tt,zt,Zt,oi,kt)),Si=Xe.set(i.$EN.ExtHostNotebookDocuments,new pe.$Bqc(It)),Ri=Xe.set(i.$EN.ExtHostNotebookEditors,new Re.$Cqc(kt,It)),bi=Xe.set(i.$EN.ExtHostNotebookKernels,new ze.$Dqc(Xe,St,It,Ct,kt)),Ti=Xe.set(i.$EN.ExtHostNotebookRenderers,new ke.$Fqc(Xe,It)),Li=Xe.set(i.$EN.ExtHostNotebookDocumentSaveParticipant,new me.$Aqc(kt,It,Xe.getProxy(i.$DN.MainThreadBulkEdits))),Lt=Xe.set(i.$EN.ExtHostEditors,new ct.$bpc(Xe,Tt)),Ee=Xe.set(i.$EN.ExtHostTreeViews,new qe.$1qc(Xe.getProxy(i.$DN.MainThreadTreeViews),Ct,kt)),Ae=Xe.set(i.$EN.ExtHostEditorInsets,new D.$cpc(Xe.getProxy(i.$DN.MainThreadEditorInsets),Lt,St.remote)),he=Xe.set(i.$EN.ExtHostDiagnostics,new N.$4oc(Xe,kt,Yt,Tt)),J=Xe.set(i.$EN.ExtHostLanguages,new ce.$yqc(Xe,zt,Ct.converter,Qt)),ye=Xe.set(i.$EN.ExtHostLanguageFeatures,new q.$6oc(Xe,Qt,zt,Ct,he,kt,Rt,At)),Be=Xe.set(i.$EN.ExtHostFileSystem,new se.$hqc(Xe,ye)),Ze=Xe.set(i.$EN.ExtHostFileSystemEventService,new $e.$iqc(Xe,kt,Tt)),He=Xe.set(i.$EN.ExtHostQuickOpen,(0,H.$Lqc)(Xe,wt,Ct)),ut=Xe.set(i.$EN.ExtHostSCM,new ne.$Nqc(Xe,Ct,zt,kt)),Pt=Xe.set(i.$EN.ExtHostQuickDiff,new B.$Kqc(Xe,Qt)),ti=Xe.set(i.$EN.ExtHostShare,new je.$Oqc(Xe,Qt)),ai=Xe.set(i.$EN.ExtHostComments,(0,k.$dpc)(Xe,Ct,zt)),jt=Xe.set(i.$EN.ExtHostProgress,new U.$Jqc(Xe.getProxy(i.$DN.MainThreadProgress))),ii=Xe.set(i.$EN.ExtHostLabelService,new Z.$wqc(Xe)),Fi=Xe.set(i.$EN.ExtHostTheming,new ft.$Xqc(Xe)),_i=Xe.set(i.$EN.ExtHostTimeline,new pt.$Zqc(Xe,Ct)),Mi=Xe.set(i.$EN.ExtHostWebviews,new ht.$rpc(Xe,St.remote,wt,kt,Rt)),qi=Xe.set(i.$EN.ExtHostWebviewPanels,new $t.$upc(Xe,Mi,wt)),en=Xe.set(i.$EN.ExtHostCustomEditors,new f.$vpc(Xe,zt,li,Mi,qi)),Wi=Xe.set(i.$EN.ExtHostWebviewViews,new Nt.$4qc(Xe,Mi)),vi=Xe.set(i.$EN.ExtHostTesting,gt.get(st.$3pc)),tn=Xe.set(i.$EN.ExtHostUriOpeners,new De.$2qc(Xe)),nn=Xe.set(i.$EN.ExtHostProfileContentHandlers,new Te.$Iqc(Xe));Xe.set(i.$EN.ExtHostInteractive,new Le.$vqc(Xe,It,Tt,Ct,kt));const zi=Xe.set(i.$EN.ExtHostChatAgents2,new p.$$oc(Xe,kt,Ct,zt)),rn=Xe.set(i.$EN.ExtHostChatVariables,new h.$_oc(Xe)),ji=Xe.set(i.$EN.ExtHostLanguageModelTools,new te.$xqc(Xe)),Vi=Xe.set(i.$EN.ExtHostAiRelatedInformation,new r.$Woc(Xe)),sn=Xe.set(i.$EN.ExtHostAiEmbeddingVector,new _.$gqc(Xe)),on=Xe.set(i.$EN.ExtHostStatusBar,new _e.$Rqc(Xe,Ct.converter)),bn=Xe.set(i.$EN.ExtHostSpeech,new Qe.$Pqc(Xe)),ki=Xe.set(i.$EN.ExtHostEmbeddings,new le.$fqc(Xe)),Hi=Object.values(i.$EN);Xe.assertRegistered(Hi);const wn=new m.$0oc(Xe,Tt),vn=new E.$apc(Xe),Ui=new X.$zqc(Xe,kt),an=new L.$cqc(Xe);return t.$7oc.register(Ct),function(Me,gi,Qi){function ot(ie){return(de,Fe,at)=>{const Dt=ie(Ot=>{try{de.call(Fe,Ot)}catch(Ii){I.$Z(new Error(`[ExtensionListenerError] Extension '${Me.identifier.value}' FAILED to handle event: ${Ii.toString()}`,{cause:Ii})),At.onExtensionError(Me.identifier,Ii)}});return at?.push(Dt),Dt}}const Et=function(){let ie=!Me.isUnderDevelopment;function de(){ie||(kt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Fe(at){if(Array.isArray(at))at.forEach(Fe);else if(typeof at=="string")de();else{const Dt=at;typeof Dt.scheme>"u"&&de(),typeof Dt.exclusive=="boolean"&&(0,Ye.$dH)(Me,"documentFiltersExclusive")}return at}}(),yn={getSession(ie,de,Fe){return typeof Fe?.forceNewSession=="object"&&Fe.forceNewSession.learnMore&&(0,Ye.$dH)(Me,"authLearnMore"),Fe?.account&&(0,Ye.$dH)(Me,"authGetSessions"),Bt.getSession(Me,ie,de,Fe)},getAccounts(ie){return(0,Ye.$dH)(Me,"authGetSessions"),Bt.getAccounts(ie)},async hasSession(ie,de){return(0,Ye.$dH)(Me,"authSession"),!!await Bt.getSession(Me,ie,de,{silent:!0})},get onDidChangeSessions(){return ot(Bt.onDidChangeSessions)},registerAuthenticationProvider(ie,de,Fe,at){return Bt.registerAuthenticationProvider(ie,de,Fe,at)}},Ki={registerCommand(ie,de,Fe){return Ct.registerCommand(!0,ie,de,Fe,void 0,Me)},registerTextEditorCommand(ie,de,Fe){return Ct.registerCommand(!0,ie,(...at)=>{const Dt=Lt.getActiveTextEditor();if(!Dt){kt.warn("Cannot execute "+ie+" because there is no active text editor.");return}return Dt.edit(Ot=>{de.apply(Fe,[Dt,Ot,...at])}).then(Ot=>{Ot||kt.warn("Edits from command "+ie+" were not applied.")},Ot=>{kt.warn("An error occurred while running command "+ie,Ot)})},void 0,void 0,Me)},registerDiffInformationCommand:(ie,de,Fe)=>((0,Ye.$dH)(Me,"diffCommand"),Ct.registerCommand(!0,ie,async(...at)=>{const Dt=Tt.activeEditor(!0);if(!Dt){kt.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Ot=await Lt.getDiffInformation(Dt.id);de.apply(Fe,[Ot,...at])},void 0,void 0,Me)),executeCommand(ie,...de){return Ct.executeCommand(ie,...de)},getCommands(ie=!1){return Ct.getCommands(ie)}},Gi={get machineId(){return St.telemetryInfo.machineId},get sessionId(){return St.telemetryInfo.sessionId},get language(){return St.environment.appLanguage},get appName(){return St.environment.appName},get appRoot(){return St.environment.appRoot?.fsPath??""},get appHost(){return St.environment.appHost},get uriScheme(){return St.environment.appUriScheme},get clipboard(){return vn.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return ot(bt.onDidChangeShell)},get isTelemetryEnabled(){return At.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(At.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$dH)(Me,"telemetry"),At.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$dH)(Me,"telemetry"),ot(At.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,rt.$vQ)(St.telemetryInfo.firstSessionDate)},createTelemetryLogger(ie,de){return rt.$uQ.validateSender(ie),At.instantiateLogger(Me,ie,de)},openExternal(ie,de){return Mt.openUri(ie,{allowTunneling:!!St.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===St.environment.appUriScheme)return Di.createAppUri(ie);try{return await Mt.asExternalUri(ie,{allowTunneling:!!St.remote.authority})}catch(de){if((0,R.$Lg)(ie,R.Schemas.http)||(0,R.$Lg)(ie,R.Schemas.https))return ie;throw de}},get remoteName(){return(0,o.$fn)(St.remote.authority)},get remoteAuthority(){return(0,Ye.$dH)(Me,"resolvers"),St.remote.authority},get uiKind(){return St.uiKind},get logLevel(){return kt.getLevel()},get onDidChangeLogLevel(){return ot(kt.onDidChangeLogLevel)},get appQuality(){return(0,Ye.$dH)(Me,"resolvers"),St.quality},get appCommit(){return(0,Ye.$dH)(Me,"resolvers"),St.commit}};St.environment.extensionTestsLocationURI||Object.freeze(Gi);const yi={createTestController(ie,de,Fe){return vi.createTestController(Me,ie,de,Fe)},createTestObserver(){return(0,Ye.$dH)(Me,"testObserver"),vi.createTestObserver()},runTests(ie){return(0,Ye.$dH)(Me,"testObserver"),vi.runTests(ie)},registerTestFollowupProvider(ie){return(0,Ye.$dH)(Me,"testObserver"),vi.registerTestFollowupProvider(ie)},get onDidChangeTestResults(){return(0,Ye.$dH)(Me,"testObserver"),ot(vi.onResultsChanged)},get testResults(){return(0,Ye.$dH)(Me,"testObserver"),vi.results}},Ci=St.remote.isRemote?Q.ExtensionKind.Workspace:Q.ExtensionKind.UI,En={getExtension(ie,de){(0,Ye.$cH)(Me,"extensionsAny")||(de=!1);const Fe=gi.mine.getExtensionDescription(ie);if(Fe)return new ge.$Ypc(Ut,Me.identifier,Fe,Ci,!1);if(de){const at=gi.all.getExtensionDescription(ie);if(at)return new ge.$Ypc(Ut,Me.identifier,at,Ci,!0)}},get all(){const ie=[];for(const de of gi.mine.getAllExtensionDescriptions())ie.push(new ge.$Ypc(Ut,Me.identifier,de,Ci,!1));return ie},get allAcrossExtensionHosts(){(0,Ye.$dH)(Me,"extensionsAny");const ie=new S.$pn(gi.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),de=[];for(const Fe of gi.all.getAllExtensionDescriptions()){const at=!ie.has(Fe.identifier);de.push(new ge.$Ypc(Ut,Me.identifier,Fe,Ci,at))}return de},get onDidChange(){return(0,Ye.$cH)(Me,"extensionsAny")?ot(P.Event.any(gi.mine.onDidChange,gi.all.onDidChange)):ot(gi.mine.onDidChange)}},mi={createDiagnosticCollection(ie){return he.createDiagnosticCollection(Me.identifier,ie)},get onDidChangeDiagnostics(){return ot(he.onDidChangeDiagnostics)},getDiagnostics:ie=>he.getDiagnostics(ie),getLanguages(){return J.getLanguages()},setTextDocumentLanguage(ie,de){return J.changeLanguage(ie.uri,de)},match(ie,de){const Fe=ee.LanguageSelector.from(ie);let at;return(0,A.$uu)(Fe)&&(at=It.notebookDocuments.find(Dt=>Dt.apiNotebook.getCells().find(Ot=>Ot.document===de))?.apiNotebook),(0,A.$tu)(Fe,de.uri,de.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(ie,de,Fe){return ye.registerCodeActionProvider(Me,Et(ie),de,Fe)},registerDocumentPasteEditProvider(ie,de,Fe){return(0,Ye.$dH)(Me,"documentPaste"),ye.registerDocumentPasteEditProvider(Me,Et(ie),de,Fe)},registerCodeLensProvider(ie,de){return ye.registerCodeLensProvider(Me,Et(ie),de)},registerDefinitionProvider(ie,de){return ye.registerDefinitionProvider(Me,Et(ie),de)},registerDeclarationProvider(ie,de){return ye.registerDeclarationProvider(Me,Et(ie),de)},registerImplementationProvider(ie,de){return ye.registerImplementationProvider(Me,Et(ie),de)},registerTypeDefinitionProvider(ie,de){return ye.registerTypeDefinitionProvider(Me,Et(ie),de)},registerHoverProvider(ie,de){return ye.registerHoverProvider(Me,Et(ie),de,Me.identifier)},registerEvaluatableExpressionProvider(ie,de){return ye.registerEvaluatableExpressionProvider(Me,Et(ie),de,Me.identifier)},registerInlineValuesProvider(ie,de){return ye.registerInlineValuesProvider(Me,Et(ie),de,Me.identifier)},registerDocumentHighlightProvider(ie,de){return ye.registerDocumentHighlightProvider(Me,Et(ie),de)},registerMultiDocumentHighlightProvider(ie,de){return ye.registerMultiDocumentHighlightProvider(Me,Et(ie),de)},registerLinkedEditingRangeProvider(ie,de){return ye.registerLinkedEditingRangeProvider(Me,Et(ie),de)},registerReferenceProvider(ie,de){return ye.registerReferenceProvider(Me,Et(ie),de)},registerRenameProvider(ie,de){return ye.registerRenameProvider(Me,Et(ie),de)},registerNewSymbolNamesProvider(ie,de){return(0,Ye.$dH)(Me,"newSymbolNamesProvider"),ye.registerNewSymbolNamesProvider(Me,Et(ie),de)},registerDocumentSymbolProvider(ie,de,Fe){return ye.registerDocumentSymbolProvider(Me,Et(ie),de,Fe)},registerWorkspaceSymbolProvider(ie){return ye.registerWorkspaceSymbolProvider(Me,ie)},registerDocumentFormattingEditProvider(ie,de){return ye.registerDocumentFormattingEditProvider(Me,Et(ie),de)},registerDocumentRangeFormattingEditProvider(ie,de){return ye.registerDocumentRangeFormattingEditProvider(Me,Et(ie),de)},registerOnTypeFormattingEditProvider(ie,de,Fe,...at){return ye.registerOnTypeFormattingEditProvider(Me,Et(ie),de,[Fe].concat(at))},registerDocumentSemanticTokensProvider(ie,de,Fe){return ye.registerDocumentSemanticTokensProvider(Me,Et(ie),de,Fe)},registerDocumentRangeSemanticTokensProvider(ie,de,Fe){return ye.registerDocumentRangeSemanticTokensProvider(Me,Et(ie),de,Fe)},registerSignatureHelpProvider(ie,de,Fe,...at){return typeof Fe=="object"?ye.registerSignatureHelpProvider(Me,Et(ie),de,Fe):ye.registerSignatureHelpProvider(Me,Et(ie),de,typeof Fe>"u"?[]:[Fe,...at])},registerCompletionItemProvider(ie,de,...Fe){return ye.registerCompletionItemProvider(Me,Et(ie),de,Fe)},registerInlineCompletionItemProvider(ie,de,Fe){return de.handleDidShowCompletionItem&&(0,Ye.$dH)(Me,"inlineCompletionsAdditions"),de.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$dH)(Me,"inlineCompletionsAdditions"),Fe&&(0,Ye.$dH)(Me,"inlineCompletionsAdditions"),ye.registerInlineCompletionsProvider(Me,Et(ie),de,Fe)},registerInlineEditProvider(ie,de){return(0,Ye.$dH)(Me,"inlineEdit"),ye.registerInlineEditProvider(Me,Et(ie),de)},registerDocumentLinkProvider(ie,de){return ye.registerDocumentLinkProvider(Me,Et(ie),de)},registerColorProvider(ie,de){return ye.registerColorProvider(Me,Et(ie),de)},registerFoldingRangeProvider(ie,de){return ye.registerFoldingRangeProvider(Me,Et(ie),de)},registerSelectionRangeProvider(ie,de){return ye.registerSelectionRangeProvider(Me,ie,de)},registerCallHierarchyProvider(ie,de){return ye.registerCallHierarchyProvider(Me,ie,de)},registerTypeHierarchyProvider(ie,de){return ye.registerTypeHierarchyProvider(Me,ie,de)},setLanguageConfiguration:(ie,de)=>ye.setLanguageConfiguration(Me,ie,de),getTokenInformationAtPosition(ie,de){return(0,Ye.$dH)(Me,"tokenInformation"),J.tokenAtPosition(ie,de)},registerInlayHintsProvider(ie,de){return ye.registerInlayHintsProvider(Me,ie,de)},createLanguageStatusItem(ie,de){return J.createLanguageStatusItem(Me,ie,de)},registerDocumentDropEditProvider(ie,de,Fe){return ye.registerDocumentOnDropEditProvider(Me,ie,de,(0,Ye.$cH)(Me,"documentPaste")?Fe:void 0)}},Bi={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(ie,de,Fe){$.URI.isUri(ie)&&ie.scheme===R.Schemas.vscodeRemote&&!ie.authority&&Rt.report("workspace.showTextDocument",Me,"A URI of 'vscode-remote' scheme requires an authority.");const at=await($.URI.isUri(ie)?Promise.resolve(Ji.openTextDocument(ie)):Promise.resolve(ie));return Lt.showTextDocument(at,de,Fe)},createTextEditorDecorationType(ie){return Lt.createTextEditorDecorationType(Me,ie)},onDidChangeActiveTextEditor(ie,de,Fe){return ot(Lt.onDidChangeActiveTextEditor)(ie,de,Fe)},onDidChangeVisibleTextEditors(ie,de,Fe){return ot(Lt.onDidChangeVisibleTextEditors)(ie,de,Fe)},onDidChangeTextEditorSelection(ie,de,Fe){return ot(Lt.onDidChangeTextEditorSelection)(ie,de,Fe)},onDidChangeTextEditorOptions(ie,de,Fe){return ot(Lt.onDidChangeTextEditorOptions)(ie,de,Fe)},onDidChangeTextEditorVisibleRanges(ie,de,Fe){return ot(Lt.onDidChangeTextEditorVisibleRanges)(ie,de,Fe)},onDidChangeTextEditorViewColumn(ie,de,Fe){return ot(Lt.onDidChangeTextEditorViewColumn)(ie,de,Fe)},onDidCloseTerminal(ie,de,Fe){return ot(bt.onDidCloseTerminal)(ie,de,Fe)},onDidOpenTerminal(ie,de,Fe){return ot(bt.onDidOpenTerminal)(ie,de,Fe)},onDidChangeActiveTerminal(ie,de,Fe){return ot(bt.onDidChangeActiveTerminal)(ie,de,Fe)},onDidChangeTerminalDimensions(ie,de,Fe){return(0,Ye.$dH)(Me,"terminalDimensions"),ot(bt.onDidChangeTerminalDimensions)(ie,de,Fe)},onDidChangeTerminalState(ie,de,Fe){return ot(bt.onDidChangeTerminalState)(ie,de,Fe)},onDidWriteTerminalData(ie,de,Fe){return(0,Ye.$dH)(Me,"terminalDataWriteEvent"),ot(bt.onDidWriteTerminalData)(ie,de,Fe)},onDidExecuteTerminalCommand(ie,de,Fe){return(0,Ye.$dH)(Me,"terminalExecuteCommandEvent"),ot(bt.onDidExecuteTerminalCommand)(ie,de,Fe)},onDidChangeTerminalShellIntegration(ie,de,Fe){return(0,Ye.$dH)(Me,"terminalShellIntegration"),ot(Kt.onDidChangeTerminalShellIntegration)(ie,de,Fe)},onDidStartTerminalShellExecution(ie,de,Fe){return(0,Ye.$dH)(Me,"terminalShellIntegration"),ot(Kt.onDidStartTerminalShellExecution)(ie,de,Fe)},onDidEndTerminalShellExecution(ie,de,Fe){return(0,Ye.$dH)(Me,"terminalShellIntegration"),ot(Kt.onDidEndTerminalShellExecution)(ie,de,Fe)},get state(){return Mt.getState()},onDidChangeWindowState(ie,de,Fe){return ot(Mt.onDidChangeWindowState)(ie,de,Fe)},showInformationMessage(ie,...de){return Ui.showMessage(Me,T.default.Info,ie,de[0],de.slice(1))},showWarningMessage(ie,...de){return Ui.showMessage(Me,T.default.Warning,ie,de[0],de.slice(1))},showErrorMessage(ie,...de){return Ui.showMessage(Me,T.default.Error,ie,de[0],de.slice(1))},showQuickPick(ie,de,Fe){return He.showQuickPick(Me,ie,de,Fe)},showWorkspaceFolderPick(ie){return He.showWorkspaceFolderPick(ie)},showInputBox(ie,de){return He.showInput(ie,de)},showOpenDialog(ie){return an.showOpenDialog(Me,ie)},showSaveDialog(ie){return an.showSaveDialog(ie)},createStatusBarItem(ie,de,Fe){let at,Dt,Ot;return typeof ie=="string"?(at=ie,Dt=de,Ot=Fe):(Dt=ie,Ot=de),on.createStatusBarEntry(Me,at,Dt,Ot)},setStatusBarMessage(ie,de){return on.setStatusBarMessage(ie,de)},withScmProgress(ie){return Rt.report("window.withScmProgress",Me,"Use 'withProgress' instead."),jt.withProgress(Me,{location:Q.ProgressLocation.SourceControl},(de,Fe)=>ie({report(at){}}))},withProgress(ie,de){return jt.withProgress(Me,ie,de)},createOutputChannel(ie,de){return Ai.createOutputChannel(ie,de,Me)},createWebviewPanel(ie,de,Fe,at){return qi.createWebviewPanel(Me,ie,de,Fe,at)},createWebviewTextEditorInset(ie,de,Fe,at){return(0,Ye.$dH)(Me,"editorInsets"),Ae.createWebviewEditorInset(ie,de,Fe,at,Me)},createTerminal(ie,de,Fe){return typeof ie=="object"?"pty"in ie?bt.createExtensionTerminal(ie):bt.createTerminalFromOptions(ie):bt.createTerminal(ie,de,Fe)},registerTerminalLinkProvider(ie){return bt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,de){return bt.registerProfileProvider(Me,ie,de)},registerTerminalQuickFixProvider(ie,de){return(0,Ye.$dH)(Me,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(ie,Me.identifier.value,de)},registerTreeDataProvider(ie,de){return Ee.registerTreeDataProvider(ie,de,Me)},createTreeView(ie,de){return Ee.createTreeView(ie,de,Me)},registerWebviewPanelSerializer:(ie,de)=>qi.registerWebviewPanelSerializer(Me,ie,de),registerCustomEditorProvider:(ie,de,Fe={})=>en.registerCustomEditorProvider(Me,ie,de,Fe),registerFileDecorationProvider(ie){return ui.registerFileDecorationProvider(ie,Me)},registerUriHandler(ie){return Di.registerUriHandler(Me,ie)},createQuickPick(){return He.createQuickPick(Me)},createInputBox(){return He.createInputBox(Me)},get activeColorTheme(){return Fi.activeColorTheme},onDidChangeActiveColorTheme(ie,de,Fe){return ot(Fi.onDidChangeActiveColorTheme)(ie,de,Fe)},registerWebviewViewProvider(ie,de,Fe){return Wi.registerWebviewViewProvider(Me,ie,de,Fe?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,de,Fe){return ot(It.onDidChangeActiveNotebookEditor)(ie,de,Fe)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(It.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ie,de,Fe){return ot(Ri.onDidChangeNotebookEditorSelection)(ie,de,Fe)},onDidChangeNotebookEditorVisibleRanges(ie,de,Fe){return ot(Ri.onDidChangeNotebookEditorVisibleRanges)(ie,de,Fe)},showNotebookDocument(ie,de){return It.showNotebookDocument(ie,de)},registerExternalUriOpener(ie,de,Fe){return(0,Ye.$dH)(Me,"externalUriOpener"),tn.registerExternalUriOpener(Me.identifier,ie,de,Fe)},registerProfileContentHandler(ie,de){return(0,Ye.$dH)(Me,"profileContentHandlers"),nn.registerProfileContentHandler(Me,ie,de)},registerQuickDiffProvider(ie,de,Fe,at){return(0,Ye.$dH)(Me,"quickDiffProvider"),Pt.registerQuickDiffProvider(Et(ie),de,Fe,at)},get tabGroups(){return _t.tabGroups},registerShareProvider(ie,de){return(0,Ye.$dH)(Me,"shareProvider"),ti.registerShareProvider(Et(ie),de)}},Ji={get rootPath(){return Rt.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(ie){throw new I.$8("rootPath")},getWorkspaceFolder(ie){return wt.getWorkspaceFolder(ie)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(ie){throw new I.$8("name")},get workspaceFile(){return wt.workspaceFile},set workspaceFile(ie){throw new I.$8("workspaceFile")},updateWorkspaceFolders:(ie,de,...Fe)=>wt.updateWorkspaceFolders(Me,ie,de||0,...Fe),onDidChangeWorkspaceFolders:function(ie,de,Fe){return ot(wt.onDidChangeWorkspace)(ie,de,Fe)},asRelativePath:(ie,de)=>wt.getRelativePath(ie,de),findFiles:(ie,de,Fe,at)=>wt.findFiles(ie,de,Fe,Me.identifier,at),findFiles2:(ie,de,Fe)=>((0,Ye.$dH)(Me,"findFiles2"),wt.findFiles2(ie,de,Me.identifier,Fe)),findTextInFiles:(ie,de,Fe,at)=>{(0,Ye.$dH)(Me,"findTextInFiles");let Dt,Ot;return typeof de=="object"?(Dt=de,Ot=Fe):(Dt={},Ot=de,at=Fe),wt.findTextInFiles(ie,Dt||{},Ot,Me.identifier,at)},save:ie=>wt.save(ie),saveAs:ie=>wt.saveAs(ie),saveAll:ie=>wt.saveAll(ie),applyEdit(ie,de){return wn.applyWorkspaceEdit(ie,Me,de)},createFileSystemWatcher:(ie,de,Fe,at)=>{let Dt;return typeof de=="boolean"?Dt={ignoreCreateEvents:!!de,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!at,correlate:!1}:de&&((0,Ye.$dH)(Me,"createFileSystemWatcher"),Dt={...de,correlate:!0}),Ze.createFileSystemWatcher(wt,Me,ie,Dt)},get textDocuments(){return zt.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw new I.$8("textDocuments")},openTextDocument(ie){let de;const Fe=ie;if(typeof ie=="string")de=Promise.resolve($.URI.file(ie));else if($.URI.isUri(ie))de=Promise.resolve(ie);else if(!Fe||typeof Fe=="object")de=zt.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(at=>(at.scheme===R.Schemas.vscodeRemote&&!at.authority&&Rt.report("workspace.openTextDocument",Me,"A URI of 'vscode-remote' scheme requires an authority."),zt.ensureDocumentData(at).then(Dt=>Dt.document)))},onDidOpenTextDocument:(ie,de,Fe)=>ot(zt.onDidAddDocument)(ie,de,Fe),onDidCloseTextDocument:(ie,de,Fe)=>ot(zt.onDidRemoveDocument)(ie,de,Fe),onDidChangeTextDocument:(ie,de,Fe)=>ot(zt.onDidChangeDocument)(ie,de,Fe),onDidSaveTextDocument:(ie,de,Fe)=>ot(zt.onDidSaveDocument)(ie,de,Fe),onWillSaveTextDocument:(ie,de,Fe)=>ot(Ni.getOnWillSaveTextDocumentEvent(Me))(ie,de,Fe),get notebookDocuments(){return It.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,de){let Fe;if($.URI.isUri(ie))Fe=ie,await It.openNotebookDocument(ie);else if(typeof ie=="string")Fe=$.URI.revive(await It.createNotebookDocument({viewType:ie,content:de}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(ie,de,Fe){return ot(Si.onDidSaveNotebookDocument)(ie,de,Fe)},onDidChangeNotebookDocument(ie,de,Fe){return ot(Si.onDidChangeNotebookDocument)(ie,de,Fe)},onWillSaveNotebookDocument(ie,de,Fe){return ot(Li.getOnWillSaveNotebookDocumentEvent(Me))(ie,de,Fe)},get onDidOpenNotebookDocument(){return ot(It.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(It.onDidCloseNotebookDocument)},registerNotebookSerializer(ie,de,Fe,at){return It.registerNotebookSerializer(Me,ie,de,Fe,(0,Ye.$cH)(Me,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ie,de,Fe)=>ot(Qi.onDidChangeConfiguration)(ie,de,Fe),getConfiguration(ie,de){return de=arguments.length===1?void 0:de,Qi.getConfiguration(ie,de,Me)},registerTextDocumentContentProvider(ie,de){return fi.registerTextDocumentContentProvider(ie,de)},registerTaskProvider:(ie,de)=>(Rt.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),Gt.registerTaskProvider(Me,ie,de)),registerFileSystemProvider(ie,de,Fe){return(0,O.$Qc)(Be.registerFileSystemProvider(Me,ie,de,Fe),Zt.addFileSystemProvider(ie,de,Fe))},get fs(){return Zt.value},registerFileSearchProvider:(ie,de)=>((0,Ye.$dH)(Me,"fileSearchProvider"),oi.registerFileSearchProvider(ie,de)),registerTextSearchProvider:(ie,de)=>((0,Ye.$dH)(Me,"textSearchProvider"),oi.registerTextSearchProvider(ie,de)),registerAITextSearchProvider:(ie,de)=>((0,Ye.$dH)(Me,"aiTextSearchProvider"),(0,Ye.$dH)(Me,"textSearchProvider"),oi.registerAITextSearchProvider(ie,de)),registerRemoteAuthorityResolver:(ie,de)=>((0,Ye.$dH)(Me,"resolvers"),Ut.registerRemoteAuthorityResolver(ie,de)),registerResourceLabelFormatter:ie=>((0,Ye.$dH)(Me,"resolvers"),ii.$registerResourceLabelFormatter(ie)),getRemoteExecServer:ie=>((0,Ye.$dH)(Me,"resolvers"),Ut.getRemoteExecServer(ie)),onDidCreateFiles:(ie,de,Fe)=>ot(Ze.onDidCreateFile)(ie,de,Fe),onDidDeleteFiles:(ie,de,Fe)=>ot(Ze.onDidDeleteFile)(ie,de,Fe),onDidRenameFiles:(ie,de,Fe)=>ot(Ze.onDidRenameFile)(ie,de,Fe),onWillCreateFiles:(ie,de,Fe)=>ot(Ze.getOnWillCreateFileEvent(Me))(ie,de,Fe),onWillDeleteFiles:(ie,de,Fe)=>ot(Ze.getOnWillDeleteFileEvent(Me))(ie,de,Fe),onWillRenameFiles:(ie,de,Fe)=>ot(Ze.getOnWillRenameFileEvent(Me))(ie,de,Fe),openTunnel:ie=>((0,Ye.$dH)(Me,"tunnels"),Ft.openTunnel(Me,ie).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Ye.$dH)(Me,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(ie,de,Fe)=>((0,Ye.$dH)(Me,"tunnels"),ot(Ft.onDidChangeTunnels)(ie,de,Fe)),registerPortAttributesProvider:(ie,de)=>((0,Ye.$dH)(Me,"portsAttributes"),Ft.registerPortsAttributesProvider(ie,de)),registerTunnelProvider:(ie,de)=>((0,Ye.$dH)(Me,"tunnelFactory"),Ft.registerTunnelProvider(ie,de)),registerTimelineProvider:(ie,de)=>((0,Ye.$dH)(Me,"timeline"),_i.registerTimelineProvider(ie,de,Me.identifier,Ct.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:ie=>((0,Ye.$dH)(Me,"workspaceTrust"),wt.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,de,Fe)=>ot(wt.onDidGrantWorkspaceTrust)(ie,de,Fe),registerEditSessionIdentityProvider:(ie,de)=>((0,Ye.$dH)(Me,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(ie,de)),onWillCreateEditSessionIdentity:(ie,de,Fe)=>((0,Ye.$dH)(Me,"editSessionIdentityProvider"),ot(wt.getOnWillCreateEditSessionIdentityEvent(Me))(ie,de,Fe)),registerCanonicalUriProvider:(ie,de)=>((0,Ye.$dH)(Me,"canonicalUriProvider"),wt.registerCanonicalUriProvider(ie,de)),getCanonicalUri:(ie,de,Fe)=>((0,Ye.$dH)(Me,"canonicalUriProvider"),wt.provideCanonicalUri(ie,de,Fe))},cn={get inputBox(){return Rt.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),ut.getLastInputBox(Me)},createSourceControl(ie,de,Fe){return ut.createSourceControl(Me,ie,de,Fe)}},ln={createCommentController(ie,de){return ai.createCommentController(Me,ie,de)}},un={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get activeStackItem(){return yt.activeStackItem},registerDebugVisualizationProvider(ie,de){return(0,Ye.$dH)(Me,"debugVisualization"),yt.registerDebugVisualizationProvider(Me,ie,de)},registerDebugVisualizationTreeProvider(ie,de){return(0,Ye.$dH)(Me,"debugVisualization"),yt.registerDebugVisualizationTree(Me,ie,de)},onDidStartDebugSession(ie,de,Fe){return ot(yt.onDidStartDebugSession)(ie,de,Fe)},onDidTerminateDebugSession(ie,de,Fe){return ot(yt.onDidTerminateDebugSession)(ie,de,Fe)},onDidChangeActiveDebugSession(ie,de,Fe){return ot(yt.onDidChangeActiveDebugSession)(ie,de,Fe)},onDidReceiveDebugSessionCustomEvent(ie,de,Fe){return ot(yt.onDidReceiveDebugSessionCustomEvent)(ie,de,Fe)},onDidChangeBreakpoints(ie,de,Fe){return ot(yt.onDidChangeBreakpoints)(ie,de,Fe)},onDidChangeActiveStackItem(ie,de,Fe){return ot(yt.onDidChangeActiveStackItem)(ie,de,Fe)},registerDebugConfigurationProvider(ie,de,Fe){return yt.registerDebugConfigurationProvider(ie,de,Fe||Xt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,de){return yt.registerDebugAdapterDescriptorFactory(Me,ie,de)},registerDebugAdapterTrackerFactory(ie,de){return yt.registerDebugAdapterTrackerFactory(ie,de)},startDebugging(ie,de,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?yt.startDebugging(ie,de,{parentSession:Fe}):yt.startDebugging(ie,de,Fe||{})},stopDebugging(ie){return yt.stopDebugging(ie)},addBreakpoints(ie){return yt.addBreakpoints(ie)},removeBreakpoints(ie){return yt.removeBreakpoints(ie)},asDebugSourceUri(ie,de){return yt.asDebugSourceUri(ie,de)}},Dn={registerTaskProvider:(ie,de)=>Gt.registerTaskProvider(Me,ie,de),fetchTasks:ie=>Gt.fetchTasks(ie),executeTask:ie=>Gt.executeTask(Me,ie),get taskExecutions(){return Gt.taskExecutions},onDidStartTask:(ie,de,Fe)=>ot(Gt.onDidStartTask)(ie,de,Fe),onDidEndTask:(ie,de,Fe)=>ot(Gt.onDidEndTask)(ie,de,Fe),onDidStartTaskProcess:(ie,de,Fe)=>ot(Gt.onDidStartTaskProcess)(ie,de,Fe),onDidEndTaskProcess:(ie,de,Fe)=>ot(Gt.onDidEndTaskProcess)(ie,de,Fe)},hn={createNotebookController(ie,de,Fe,at,Dt){return bi.createNotebookController(Me,ie,de,Fe,at,(0,Ye.$cH)(Me,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ie,de)=>It.registerNotebookCellStatusBarItemProvider(Me,ie,de),createRendererMessaging(ie){return Ti.createRendererMessaging(Me,ie)},createNotebookControllerDetectionTask(ie){return(0,Ye.$dH)(Me,"notebookKernelSource"),bi.createNotebookControllerDetectionTask(Me,ie)},registerKernelSourceActionProvider(ie,de){return(0,Ye.$dH)(Me,"notebookKernelSource"),bi.registerKernelSourceActionProvider(Me,ie,de)},onDidChangeNotebookCellExecutionState(ie,de,Fe){return(0,Ye.$dH)(Me,"notebookCellExecutionState"),ot(bi.onDidChangeNotebookCellExecutionState)(ie,de,Fe)}},dn={t(...ie){if(typeof ie[0]=="string"){const de=ie.shift(),Fe=!ie||typeof ie[0]!="object"?ie:ie[0];return $i.getMessage(Me.identifier.value,{message:de,args:Fe})}return $i.getMessage(Me.identifier.value,ie[0])},get bundle(){return $i.getBundle(Me.identifier.value)},get uri(){return $i.getBundleUri(Me.identifier.value)}},Sn={_version:1,transferActiveChat(ie){return(0,Ye.$dH)(Me,"interactive"),zi.transferActiveChat(ie)}},kn={getRelatedInformation(ie,de){return(0,Ye.$dH)(Me,"aiRelatedInformation"),Vi.getRelatedInformation(Me,ie,de)},registerRelatedInformationProvider(ie,de){return(0,Ye.$dH)(Me,"aiRelatedInformation"),Vi.registerRelatedInformationProvider(Me,ie,de)},registerEmbeddingVectorProvider(ie,de){return(0,Ye.$dH)(Me,"aiRelatedInformation"),sn.registerEmbeddingVectorProvider(Me,ie,de)}},fn={_version:1,registerChatResponseProvider(ie,de,Fe){return(0,Ye.$dH)(Me,"chatProvider"),qt.registerLanguageModel(Me,ie,de,Fe)},registerChatVariableResolver(ie,de,Fe,at,Dt,Ot,Ii,Yi){return(0,Ye.$dH)(Me,"chatVariableResolver"),rn.registerVariableResolver(Me,ie,de,Fe,at,Dt,Ot,Ii,Yi?.id)},registerMappedEditsProvider(ie,de){return(0,Ye.$dH)(Me,"mappedEditsProvider"),ye.registerMappedEditsProvider(Me,ie,de)},createChatParticipant(ie,de){return zi.createChatAgent(Me,ie,de)},createDynamicChatParticipant(ie,de,Fe){return(0,Ye.$dH)(Me,"chatParticipantPrivate"),zi.createDynamicChatAgent(Me,ie,de,Fe)}},Xi={selectChatModels:ie=>qt.selectLanguageModels(Me,ie??{}),onDidChangeChatModels:(ie,de,Fe)=>qt.onDidChangeProviders(ie,de,Fe),registerChatModelProvider:(ie,de,Fe)=>((0,Ye.$dH)(Me,"chatProvider"),qt.registerLanguageModel(Me,ie,de,Fe)),get embeddingModels(){return(0,Ye.$dH)(Me,"embeddings"),ki.embeddingsModels},onDidChangeEmbeddingModels:(ie,de,Fe)=>((0,Ye.$dH)(Me,"embeddings"),ki.onDidChange(ie,de,Fe)),registerEmbeddingsProvider(ie,de){return(0,Ye.$dH)(Me,"embeddings"),ki.registerEmbeddingsProvider(Me,ie,de)},async computeEmbeddings(ie,de,Fe){return(0,Ye.$dH)(Me,"embeddings"),ki.computeEmbeddings(ie,de,Fe)},registerTool(ie,de){return(0,Ye.$dH)(Me,"lmTools"),ji.registerTool(Me,ie,de)},invokeTool(ie,de,Fe){return(0,Ye.$dH)(Me,"lmTools"),ji.invokeTool(ie,de,Fe)},get tools(){return(0,Ye.$dH)(Me,"lmTools"),ji.tools}},gn={registerSpeechProvider(ie,de){return(0,Ye.$dH)(Me,"speech"),bn.registerProvider(Me.identifier,ie,de)}};return{version:St.version,ai:kn,authentication:yn,commands:Ki,comments:ln,chat:fn,debug:un,env:Gi,extensions:En,interactive:Sn,l10n:dn,languages:mi,lm:Xi,notebooks:hn,scm:cn,speech:gn,tasks:Dn,tests:yi,window:Bi,workspace:Ji,Breakpoint:Q.$IO,TerminalOutputAnchor:Q.TerminalOutputAnchor,ChatResultFeedbackKind:Q.ChatResultFeedbackKind,ChatVariableLevel:Q.ChatVariableLevel,ChatCompletionItem:Q.$EP,CallHierarchyIncomingCall:Q.$7N,CallHierarchyItem:Q.$6N,CallHierarchyOutgoingCall:Q.$8N,CancellationError:I.$4,CancellationTokenSource:v.$ue,CandidatePortSource:i.CandidatePortSource,CodeAction:Q.$3N,CodeActionKind:Q.$4N,CodeActionTriggerKind:Q.CodeActionTriggerKind,CodeLens:Q.$9N,Color:Q.$jO,ColorInformation:Q.$kO,ColorPresentation:Q.$lO,ColorThemeKind:Q.ColorThemeKind,CommentMode:Q.CommentMode,CommentState:Q.CommentState,CommentThreadCollapsibleState:Q.CommentThreadCollapsibleState,CommentThreadState:Q.CommentThreadState,CommentThreadApplicability:Q.CommentThreadApplicability,CommentThreadFocus:Q.CommentThreadFocus,CompletionItem:Q.$dO,CompletionItemKind:Q.CompletionItemKind,CompletionItemTag:Q.CompletionItemTag,CompletionList:Q.$eO,CompletionTriggerKind:Q.CompletionTriggerKind,ConfigurationTarget:Q.ConfigurationTarget,CustomExecution:Q.$tO,DebugAdapterExecutable:Q.$MO,DebugAdapterInlineImplementation:Q.$PO,DebugAdapterNamedPipeServer:Q.$OO,DebugAdapterServer:Q.$NO,DebugConfigurationProviderTriggerKind:Xt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Q.DebugConsoleMode,DebugVisualization:Q.$6O,DecorationRangeBehavior:Q.DecorationRangeBehavior,Diagnostic:Q.$VN,DiagnosticRelatedInformation:Q.$UN,DiagnosticSeverity:Q.DiagnosticSeverity,DiagnosticTag:Q.DiagnosticTag,Disposable:Q.$FN,DocumentHighlight:Q.$YN,DocumentHighlightKind:Q.DocumentHighlightKind,MultiDocumentHighlight:Q.$ZN,DocumentLink:Q.$iO,DocumentSymbol:Q.$2N,EndOfLine:Q.EndOfLine,EnvironmentVariableMutatorType:Q.EnvironmentVariableMutatorType,EvaluatableExpression:Q.$SO,InlineValueText:Q.$TO,InlineValueVariableLookup:Q.$UO,InlineValueEvaluatableExpression:Q.$VO,InlineCompletionTriggerKind:Q.InlineCompletionTriggerKind,EventEmitter:P.$je,ExtensionKind:Q.ExtensionKind,ExtensionMode:Q.ExtensionMode,ExternalUriOpenerPriority:Q.ExternalUriOpenerPriority,FileChangeType:Q.FileChangeType,FileDecoration:Q.$8O,FileDecoration2:Q.$8O,FileSystemError:Q.$YO,FileType:d.FileType,FilePermission:d.FilePermission,FoldingRange:Q.$ZO,FoldingRangeKind:Q.FoldingRangeKind,FunctionBreakpoint:Q.$KO,InlineCompletionItem:Q.$fO,InlineCompletionList:Q.$gO,Hover:Q.$WN,VerboseHover:Q.$XN,HoverVerbosityAction:Q.HoverVerbosityAction,IndentAction:y.IndentAction,Location:Q.$TN,MarkdownString:Q.$0N,OverviewRulerLane:a.OverviewRulerLane,ParameterInformation:Q.$$N,PortAutoForwardAction:Q.PortAutoForwardAction,Position:Q.$GN,ProcessExecution:Q.$rO,ProgressLocation:Q.ProgressLocation,QuickInputButtonLocation:Q.QuickInputButtonLocation,QuickInputButtons:Q.$7O,Range:Q.$HN,RelativePattern:Q.$GO,Selection:Q.$IN,SelectionRange:Q.$5N,SemanticTokens:Q.$3O,SemanticTokensBuilder:Q.$2O,SemanticTokensEdit:Q.$4O,SemanticTokensEdits:Q.$5O,SemanticTokensLegend:Q.$1O,ShellExecution:Q.$sO,ShellQuoting:Q.ShellQuoting,SignatureHelp:Q.$aO,SignatureHelpTriggerKind:Q.SignatureHelpTriggerKind,SignatureInformation:Q.$_N,SnippetString:Q.$SN,SourceBreakpoint:Q.$JO,StandardTokenType:Q.StandardTokenType,StatusBarAlignment:Q.StatusBarAlignment,SymbolInformation:Q.$1N,SymbolKind:Q.SymbolKind,SymbolTag:Q.SymbolTag,Task:Q.$uO,TaskGroup:Q.$qO,TaskPanelKind:Q.TaskPanelKind,TaskRevealKind:Q.TaskRevealKind,TaskScope:Q.TaskScope,TerminalLink:Q.$mO,TerminalQuickFixTerminalCommand:Q.$oO,TerminalQuickFixOpener:Q.$nO,TerminalLocation:Q.TerminalLocation,TerminalProfile:Q.$pO,TerminalExitReason:Q.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Q.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Q.TextDocumentSaveReason,TextEdit:Q.$ON,SnippetTextEdit:Q.$QN,TextEditorCursorStyle:s.TextEditorCursorStyle,TextEditorLineNumbersStyle:Q.TextEditorLineNumbersStyle,TextEditorRevealType:Q.TextEditorRevealType,TextEditorSelectionChangeKind:Q.TextEditorSelectionChangeKind,SyntaxTokenType:Q.SyntaxTokenType,TextDocumentChangeReason:Q.TextDocumentChangeReason,ThemeColor:Q.$FO,ThemeIcon:Q.$EO,TreeItem:Q.$vO,TreeItemCheckboxState:Q.TreeItemCheckboxState,TreeItemCollapsibleState:Q.TreeItemCollapsibleState,TypeHierarchyItem:Q.$sP,UIKind:hi.UIKind,Uri:$.URI,ViewColumn:Q.ViewColumn,WorkspaceEdit:Q.$RN,DocumentPasteTriggerKind:Q.DocumentPasteTriggerKind,DocumentDropEdit:Q.$BO,DocumentDropOrPasteEditKind:Q.$CO,DocumentPasteEdit:Q.$DO,InlayHint:Q.$cO,InlayHintLabelPart:Q.$bO,InlayHintKind:Q.InlayHintKind,RemoteAuthorityResolverError:Q.$NN,ResolvedAuthority:Q.$LN,ManagedResolvedAuthority:Q.$MN,SourceControlInputBoxValidationType:Q.SourceControlInputBoxValidationType,ExtensionRuntime:Q.ExtensionRuntime,TimelineItem:Q.$fP,NotebookRange:Q.$0O,NotebookCellKind:Q.NotebookCellKind,NotebookCellExecutionState:Q.NotebookCellExecutionState,NotebookCellData:Q.$$O,NotebookData:Q.$_O,NotebookRendererScript:Q.$dP,NotebookCellStatusBarAlignment:Q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Q.NotebookEditorRevealType,NotebookCellOutput:Q.$bP,NotebookCellOutputItem:Q.$aP,NotebookCellStatusBarItem:Q.$cP,NotebookControllerAffinity:Q.NotebookControllerAffinity,NotebookControllerAffinity2:Q.NotebookControllerAffinity2,NotebookEdit:Q.$PN,NotebookKernelSourceAction:Q.$eP,NotebookVariablesRequestKind:Q.NotebookVariablesRequestKind,PortAttributes:Q.$hP,LinkedEditingRanges:Q.$gP,TestResultState:Q.TestResultState,TestRunRequest:Q.$iP,TestMessage:Q.$jP,TestMessage2:Q.$jP,TestMessageStackFrame:Q.$lP,TestTag:Q.$kP,TestRunProfileKind:Q.TestRunProfileKind,TextSearchCompleteMessageType:Vt.TextSearchCompleteMessageType,DataTransfer:Q.$AO,DataTransferItem:Q.$wO,TestCoverageCount:Q.$mP,FileCoverage:Q.$oP,FileCoverage2:Q.$oP,StatementCoverage:Q.$pP,BranchCoverage:Q.$qP,DeclarationCoverage:Q.$rP,WorkspaceTrustState:Q.WorkspaceTrustState,LanguageStatusSeverity:Q.LanguageStatusSeverity,QuickPickItemKind:Q.QuickPickItemKind,InputBoxValidationSeverity:Q.InputBoxValidationSeverity,TabInputText:Q.$tP,TabInputTextDiff:Q.$uP,TabInputTextMerge:Q.$vP,TabInputCustom:Q.$wP,TabInputNotebook:Q.$yP,TabInputNotebookDiff:Q.$zP,TabInputWebview:Q.$xP,TabInputTerminal:Q.$AP,TabInputInteractiveWindow:Q.$BP,TabInputChat:Q.$CP,TabInputTextMultiDiff:Q.$DP,TelemetryTrustedValue:c.$up,LogLevel:n.LogLevel,EditSessionIdentityMatch:l.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Q.InteractiveSessionVoteDirection,ChatCopyKind:Q.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Q.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Q.$QO,DebugThread:Q.$RO,RelatedInformationType:Q.RelatedInformationType,SpeechToTextStatus:Q.SpeechToTextStatus,TextToSpeechStatus:Q.TextToSpeechStatus,PartialAcceptTriggerKind:Q.PartialAcceptTriggerKind,KeywordRecognitionStatus:Q.KeywordRecognitionStatus,ChatResponseMarkdownPart:Q.$FP,ChatResponseFileTreePart:Q.$JP,ChatResponseAnchorPart:Q.$KP,ChatResponseProgressPart:Q.$LP,ChatResponseProgressPart2:Q.$MP,ChatResponseReferencePart:Q.$PP,ChatResponseWarningPart:Q.$NP,ChatResponseTextEditPart:Q.$QP,ChatResponseMarkdownWithVulnerabilitiesPart:Q.$GP,ChatResponseCommandButtonPart:Q.$OP,ChatResponseDetectedParticipantPart:Q.$HP,ChatResponseConfirmationPart:Q.$IP,ChatRequestTurn:Q.$RP,ChatResponseTurn:Q.$SP,ChatLocation:Q.ChatLocation,ChatRequestEditorData:Q.$TP,ChatRequestNotebookData:Q.$UP,LanguageModelChatMessageRole:Q.LanguageModelChatMessageRole,LanguageModelChatMessage:Q.$WP,LanguageModelChatMessageFunctionResultPart:Q.$VP,LanguageModelChatResponseTextPart:Q.$YP,LanguageModelChatResponseFunctionUsePart:Q.$XP,LanguageModelError:Q.$3P,NewSymbolName:Q.$XO,NewSymbolNameTag:Q.NewSymbolNameTag,NewSymbolNameTriggerKind:Q.NewSymbolNameTriggerKind,InlineEdit:Q.$4P,InlineEditTriggerKind:Q.InlineEditTriggerKind}}}}),define(Oe[277],Ne([1,0,60,128,45,122,46,33,57,56,131,133,134,88,92,84,121,68,50,87,66,70,216,11,132,85,86,90,94,126,95]),function(be,e,v,I,P,O,R,T,$,s,A,y,a,S,d,n,o,c,l,i,r,t,g,u,m,p,h,E,D,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.$Os)(p.$Spc,p.$Rpc,v.InstantiationType.Delayed),(0,v.$Os)(u.$$j,g.$8qc,v.InstantiationType.Delayed),(0,v.$Os)(n.$Xoc,n.$Yoc,v.InstantiationType.Delayed),(0,v.$Os)(T.$yQ,T.$xQ,v.InstantiationType.Eager),(0,v.$Os)(E.$8oc,E.$9oc,v.InstantiationType.Eager),(0,v.$Os)(D.$Mpc,D.$Npc,v.InstantiationType.Eager),(0,v.$Os)(R.$kpc,R.$ipc,v.InstantiationType.Eager),(0,v.$Os)(c.$mpc,c.$lpc,v.InstantiationType.Eager),(0,v.$Os)(k.$3pc,k.$4pc,v.InstantiationType.Eager),(0,v.$Os)(y.$8pc,y.$_pc,v.InstantiationType.Eager),(0,v.$Os)(O.$bqc,O.$aqc,v.InstantiationType.Eager),(0,v.$Os)($.$nQ,$.$mQ,v.InstantiationType.Eager),(0,v.$Os)(h.$Tpc,h.$Upc,v.InstantiationType.Eager),(0,v.$Os)(l.$2oc,l.$1oc,v.InstantiationType.Eager),(0,v.$Os)(I.$Hqc,I.$Gqc,v.InstantiationType.Delayed),(0,v.$Os)(a.$rqc,a.$sqc,v.InstantiationType.Eager),(0,v.$Os)(S.$Fpc,S.$Epc,v.InstantiationType.Eager),(0,v.$Os)(A.$Uqc,A.$Tqc,v.InstantiationType.Eager),(0,v.$Os)(s.$Ipc,s.$Lpc,v.InstantiationType.Eager),(0,v.$Os)(b.$Vqc,b.$Wqc,v.InstantiationType.Eager),(0,v.$Os)(d.$0Fb,d.$$Fb,v.InstantiationType.Eager),(0,v.$Os)(o.$6qc,o.$5qc,v.InstantiationType.Eager),(0,v.$Os)(P.$hpc,P.$gpc,v.InstantiationType.Eager),(0,v.$Os)(i.$Ppc,i.$Opc,v.InstantiationType.Eager),(0,v.$Os)(r.$wQ,r.$tQ,v.InstantiationType.Eager),(0,v.$Os)(t.$wpc,t.$xpc,v.InstantiationType.Eager),(0,v.$Os)(m.$1pc,m.$2pc,v.InstantiationType.Eager)}),define(Oe[278],Ne([1,0,276,47,2,273,7,10,223]),function(be,e,v,I,P,O,R,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$htc=void 0;class s extends O.$$qc{j(){}getModule(S,d){for(const n of this.b){const o=n(S);if(o){S=o;break}}if(this.a.has(S))return this.a.get(S).load(S,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends I.$Wpc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async vb(){this.h.createInstance($.$gtc);const S=this.h.invokeFunction(v.$7qc);this.r=this.h.createInstance(s,S,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(S){return S.browser}async xb(S,d,n){d=d.with({path:y(d.path,".js")});const o=S?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const c=P.URI.revive(await this.C.$asBrowserUri(d)),l=await fetch(c.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),l.status!==200)throw new Error(l.statusText);const i=await l.text(),r=`${d.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${r}`;let g;try{g=new Function("module","exports","require",t)}catch(h){throw console.error(o?`Loading code for extension ${o} failed: ${h.message}`:`Loading code failed: ${h.message}`),console.error(`${d.toString(!0)}${typeof h.line=="number"?` line ${h.line}`:""}${typeof h.column=="number"?` column ${h.column}`:""}`),console.error(h),h}S&&await this.w.initializeLocalizedMessages(S);const u={},m={exports:u},p=h=>{const E=this.r.getModule(h,d);if(E===void 0)throw new Error(`Cannot load module '${h}'`);return E};try{return n.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),g(m,u,p),m.exports!==u?m.exports:u}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),n.codeLoadingStop()}}async $setRemoteEnvironment(S){}async Bb(S=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+S;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,T.$Dh)(10)}}e.$htc=A;function y(a,S){return a.endsWith(S)?a:a+S}}),define(Oe[279],Ne([1,0,73,60,11,47,188,91,278]),function(be,e,v,I,P,O,R,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$Os)(P.$0j,new v.$zi(R.$0qc,[!0],!0)),(0,I.$Os)(O.$Xpc,$.$htc,I.InstantiationType.Eager),(0,I.$Os)(T.$npc,T.$opc,I.InstantiationType.Eager)}),define(Oe[287],Ne([1,0,22,6,83,274,225,19,64,15,2,277,279]),function(be,e,v,I,P,O,R,T,$,s,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,T=We(T),$=We($);const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function S(g){return/^(file|vscode-remote):/i.test(g)}const d=fetch.bind(self);function n(g){self.fetch=async function(u,m){return u instanceof Request||S(String(u))&&(u=(await g(A.URI.parse(String(u)))).toString(!0)),d(u,m)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,m,p,h,E){(async()=>(S(m.toString())&&(m=(await g(A.URI.parse(m.toString()))).toString(!0)),super.open(u,m,p??!0,h,E)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const g=self.Worker;Worker=function(u,m){if(/^file:/i.test(u.toString()))u=s.$Wg.uriToBrowserUri(A.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const h=`(${function(k){function C(M){return typeof M=="string"||M instanceof URL?String(M).replace(/^file:\/\//i,"vscode-file://vscode-app"):M}const f=fetch.bind(self);self.fetch=function(M,N){return M instanceof Request?f(M,N):f(C(M),N)},self.XMLHttpRequest=class extends XMLHttpRequest{open(M,N,L,W,G){return super.open(M,C(N),L??!0,W,G)}};const w=importScripts.bind(self);self.importScripts=(...M)=>{w(...M.map(C))},w(k)}.toString()}('${u}'))`;m=m||{},m.name=`${name} -> ${m.name||T.$mc(u.toString())}`;const E=new Blob([h],{type:"application/javascript"}),D=URL.createObjectURL(E);return new g(D,m)}}else self.Worker=class extends R.$itc{constructor(g,u){super(a,g,{name:T.$mc(g.toString()),...u})}};const o=new class{constructor(){this.pid=void 0}exit(g){y()}};class c{constructor(){const u=new MessageChannel,m=new I.$je;let p=!1;a(u.port2,[u.port2]),u.port1.onmessage=h=>{const{data:E}=h;if(!(E instanceof ArrayBuffer)){console.warn("UNKNOWN data received",E);return}const D=v.$Le.wrap(new Uint8Array(E,0,E.byteLength));if((0,P.$zn)(D,P.MessageType.Terminate)){p=!0,i("received terminate message from renderer");return}m.fire(D)},this.protocol={onMessage:m.event,send:h=>{if(!p){const E=h.buffer.buffer.slice(h.buffer.byteOffset,h.buffer.byteOffset+h.buffer.byteLength);u.port1.postMessage(E,[E])}}}}}function l(g){return new Promise(u=>{const m=g.onMessage(p=>{m.dispose();const h=JSON.parse(p.toString());g.send((0,P.$yn)(P.MessageType.Initialized)),u({protocol:g,initData:h})});g.send((0,P.$yn)(P.MessageType.Ready))})}let i=g=>y();function r(g){return!!g&&typeof g=="object"&&g.type==="vscode.init"&&g.data instanceof Map}function t(){$.mark("code/extHost/willConnectToRenderer");const g=new c;return{onmessage(u){r(u)&&l(g.protocol).then(m=>{$.mark("code/extHost/didWaitForInitData");const p=new O.$arc(m.protocol,m.initData,o,null,u.data);n(h=>p.asBrowserUri(h)),i=h=>p.terminate(h)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/4a103b0eea7de96d12fc2cbada846ca7ef4f1298/core/vs/workbench/api/worker/extensionHostWorker.js.map
